REM
REM   $Id: MAKESDK.BAT 1.26 2003/08/11 15:30:02Z thomd Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@if "%DEBUGCMD%"=="" echo off
REM -----------------------------------------------------------------------
REM
REM  MAKESDK.BAT - Create SDK disks for RomDos -
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM
REM
REM	History:
REM
REM   07/29/2003 jmb I added Sockets SUV build capability
REM   04/17/2001 jmb I added a call to buildsck to build sockets
REM	04/12/2001 jmb fixed to use DL_ROOT for an alternate DEVTOOLS path
REM	------
REM		05/21/97 ms  Created to work with BUILDALL.BAT
REM   	09/05/87 rlm Modified to work with 2.5.11
REM		10/20/97 rlm Modified again for buggy fixes (including
REM                   the problem where CHECKOUT requires BCROOT
REM                   and TASM4 to be set already!!!)
REM      01/14/98 rlm Modified to look for TLIB tree; other bug fixes
REM      02/02/98 rlm Modified to add CONFIG.SDK and AUTOEXEC.SDK files
REM                   added BLDCWD variable, BUILDLOG variable
REM
REM     Description
REM         This set of batch commands creates SDK disks for ROMDOS
REM         by (1) checking out the latest tree; (2) building the
REM         executables; and (3) copying the files to the SDK tree
REM
REM -----------------------------------------------------------------------

REM --- Validate Command Line Parameters -------------- [ Stage 1 ] -------

REM - Verify that the user entered at least 1 argument

rem if "%1" == "" goto usage
%DEBUGCMD%

REM - If user specified "cleanup", then clean up!

if "%1"=="cleanup" goto cleanup
if "%1"=="CLEANUP" goto cleanup
if "%1"=="/?" goto usage
if "%1"=="HELP" goto usage
if "%1"=="help" goto usage
if "%1"=="" set BUILD=ALL
if not "%1"=="" set BUILD=%1
if NOT "%2"=="" goto usage
%DEBUGCMD%

REM - Check to see that BUILD is a valid selection
if "%BUILD%"=="CLEANUP" goto valid
if "%BUILD%"=="cleanup" goto valid
if "%BUILD%"=="71" goto valid
if "%BUILD%"=="622" goto valid
if "%BUILD%"=="EMJ" goto valid
if "%BUILD%"=="emj" goto valid
if "%BUILD%"=="SOCKETS" goto valid
if "%BUILD%"=="sockets" goto valid
if "%BUILD%"=="SUV" goto valid
if "%BUILD%"=="suv" goto valid
if "%BUILD%"=="REP" goto valid
if "%BUILD%"=="rep" goto valid
if "%BUILD%"=="186" goto valid
if "%BUILD%"=="ALL" goto valid
if "%BUILD%"=="all" goto valid
if "%BUILD%"=="NETADD" goto valid
if "%BUILD%"=="netadd" goto valid
goto ParmErr

:valid

REM - Modify the path to include TOOLS

set oldpath=%path%
bin\save drive rddrv
bin\save cwd rdinst
path = %rddrv%%rdinst%\bin;%path%
%DEBUGCMD%

REM - Save the current working directory

save cwd BLDCWD

REM - Determine if the SDK will be made on floppy drives
REM
REM Hard coded to only build a release tree of the project root
REM
%DEBUGCMD%

:welcome
rem cls

REM   set up the environment to build romdos

:Ccheck

REM - Determine if the C compiler is available

if not "%DL_ROOT%" == "" set bcroot=%DL_ROOT%\devtools
if not %bcroot%!==! goto Tcheck
if exist c:\dl\devtools\bin\bcc.exe set bcroot=c:\dl\devtools
if not %bcroot%!==! goto Tcheck
if exist t:\apps\dl\devtools\bin\bcc.exe set bcroot=t:\apps\dl\devtools
if not %bcroot%!==! goto Tcheck
%DEBUGCMD%
goto noc

:Tcheck
if not "%DL_ROOT%" == "" set tasm4=%DL_ROOT%\devtools\bin\tasm
if not %tasm4%!==! goto build
if exist c:\dl\devtools\bin\tasm.exe set tasm4=c:\dl\devtools\bin\tasm
if not %tasm4%!==! goto build
if exist %tasm4%\bin\tasm.exe set tasm4=%tasm4%\bin\tasm
if not %tasm4%!==! goto build
%DEBUGCMD%
goto notasm


:build

REM - Add BCROOT to the path

set path=%rddrv%%rdinst%\bin;%bcroot%\bin;%oldpath%
%DEBUGCMD%

REM
REM  Set up the BUILDLOG variable
REM
set buildlog=%bldcwd%\build.log
if exist %bldcwd%\build.log del %bldcwd%\build.log

REM  Make sure that no read-only attributes are set
REM
attrib -r *.* /s

REM  Clear the build error flag
REM
set builderr=


REM determine if we are doing standard build
REM
if "%BUILD%"=="ALL" goto normal_build
goto %BUILD%

REM  Build the romdos release tree for ROMDOS 6.22
REM
goto no622bld
:622
call build622
if not "%builderr%" == "" goto builderr


REM  Build the release\622\RXE release tree
REM
call buildrxe 622
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Make sure that all the files for ROMDOS 6.22 are
REM  in the release tree
REM
cd release\622
dir /ogned /s /b > ..\..\temp.lst
chppath2 ..\..\temp.lst ..\..\cmp.lst
cd ..\..
filecmpi sdk622.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
if not "%BUILD%"=="ALL" goto cleanup
:no622bld

:normal_build
:71
REM  Build the romdos release tree for ROMDOS 7.1
REM
rem goto no71bld
call build71
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Build the release\71\RXE release tree
REM
call buildrxe 71
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Make sure that all the files for ROMDOS 7.1 are
REM  in the release tree
REM
cd release\71
dir /ogned /s /b > ..\..\temp.lst
chppath2 ..\..\temp.lst ..\..\cmp.lst
cd ..\..
filecmpi sdk71.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
if not "%BUILD%"=="ALL" goto cleanup
:no71bld


:EMJ
REM  Build the EMJ tools tree
REM
rem goto NoEMJ
call emj.bat
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


rem  Build an tree that contains an updated tools disk for
rem  EMJ, a distributor.
rem
cd release\emj
dir /ogned /s /b > ..\..\temp.lst
chppath2 ..\..\temp.lst ..\..\cmp.lst
cd ..\..
filecmpi emj.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
if not "%BUILD%"=="ALL" goto cleanup
:NoEMJ


REM  End User Package Section
REM

:SUV
REM  Build the 6.22 Single User packages
REM
call b622suv.bat
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Make sure all the files are there
REM
cd release\suv\622
dir /ogned /s /b > ..\..\..\temp.lst
chppath2 ..\..\..\temp.lst ..\..\..\cmp.lst
cd ..\..\..
filecmpi suv622.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
:NoSuv622


REM  Build the 7.1 End User packages
REM
call b71suv.bat
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Make sure all the files are there
REM
cd release\suv\71
dir /ogned /s /b > ..\..\..\temp.lst
chppath2 ..\..\..\temp.lst ..\..\..\cmp.lst
cd ..\..\..
filecmpi suv71.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
if not "%BUILD%"=="ALL" goto cleanup
:NoSuv71

:netadd
REM Build Sockets End User packages
call bscksuv.bat
if not "%builderr%" == "" goto builderr
%DEBUGCMD%

REM Make sure all the files are there
REM
cd release\netaddon
dir /ogned /s /b > ..\..\temp.lst
chppath2 ..\..\temp.lst ..\..\cmp.lst
cd ..\..
filecmpi scksuv.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
if not "%BUILD%"=="ALL" goto cleanup
:NoSuvSock

:REP
REM  Build the 6.22 Replication packages
REM
call b622rep.bat
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Make sure all the files are there
REM
cd release\rep\622
dir /ogned /s /b > ..\..\..\temp.lst
chppath2 ..\..\..\temp.lst ..\..\..\cmp.lst
cd ..\..\..
filecmpi rep622.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
:NoRep622


REM  Build the 7.1 Replication packages
REM
call b71rep.bat
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Make sure all the files are there
REM
cd release\rep\71
dir /ogned /s /b > ..\..\..\temp.lst
chppath2 ..\..\..\temp.lst ..\..\..\cmp.lst
cd ..\..\..
filecmpi rep71.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
if not "%BUILD%"=="ALL" goto cleanup
:NoRep71


:SOCKETS
REM  Build the SOCKETS release tree
REM
rem goto NoSockets
call buildsck
if not "%builderr%" == "" goto builderr
%DEBUGCMD%


REM  Make sure that all the files for Sockets are
REM  in the release tree
REM
cd release\sockets
dir /ogned /s /b > ..\..\temp.lst
chppath2 ..\..\temp.lst ..\..\cmp.lst
cd ..\..
filecmpi sockets.lst cmp.lst
if errorlevel 1 goto missfiles
%DEBUGCMD%
if not "%BUILD%"=="ALL" goto cleanup
:NoSockets


:cleanup

if exist tmp.txt del tmp.txt
if exist cmp.lst del cmp.lst
if exist temp.lst del temp.lst
if exist at.blt del at.blt
if exist xt.blt del xt.blt
goto finish


REM --- Error Messages -------------------------------- [ Stage 8 ] -------

:usage

echo ROM-DOS SDK Release
echo.
echo This batch file will make the ROM-DOS SDK disks.
echo.
echo Syntax:  MAKESDK [CLEANUP]
echo.
echo Where:
echo         CLEANUP   resets to a clean environment
echo         71        builds ROMDOS 7.1
echo         622       builds ROMDOS 6.22
echo         EMJ       builds ROMDOS for EMJ
echo         SOCKETS   builds SOCKETS
echo         SUV       Builds ROMDOS Single User Version
echo         REP       Builds ROMDOS Replication Version
echo         186       Builds ROMDOS 186
echo.
echo NOTE:  If you set a local environment variable, NEWDATE, to a specific
echo        date (of the form MM-DD-YY), MAKESDK will set the dates
echo        of all the SDK files to that date.
echo.

set ERROR=ROMDOS release build error
goto notrun

:nonet
echo.
echo  No Network connection.  Can't check out ROM-DOS.
echo.
set ERROR=ROMDOS release build error
goto notrun

:noc
echo.
echo  No C compiler found! Set BCROOT to point to the root of the BC 5.2 tree!
echo.
set ERROR=ROMDOS release build error
goto notrun

:notasm
echo.
echo  No Turbo Assembler found! Set TASM4 to point to the root of the TASM4 tree!
echo.
set ERROR=ROMDOS release build error
goto notrun

:missfiles
echo.
echo Files were either missing or there are extra files in the release tree
echo  Please fix the problem and try again
echo.
set builderr=1
set ERROR=ROMDOS release build error
goto notrun

:direrr
echo.
echo Directory error...the build is lost in space!
echo.
set ERROR=ROMDOS release build error
goto end

:BuildErr
echo.
echo  ROM-DOS did not compile successfully!
echo.
echo  Please check BUILD.LOG and correct any errors before
echo  trying to build again.
echo.
rem deltree /y release > nul
set ERROR=ROMDOS release build error
goto NotRun

:ParmErr
echo.
echo  Invalid parameter %BUILD%
echo.
goto usage

REM - Finished -

:finish
set ERROR=
echo All Done!

REM - Jump out for usage screen -
:notrun

REM - Clean up variables and restore path -
set dest=
set disk=
set curdir=
set curdrv=
set instpath=
set echo=
set built=
set copied=
set shrunk=
set floppy=
set winsdk=
set bcroot=
set tasm4=
if %oldpath%!==! goto skippath
path=%oldpath%
:skippath
set oldpath=
set rd_sw=
set rd_sw_a=
set rd_lev=
set bldcwd=
set buildlog=
set rddrv=
set rdinst=

:end
