;
;   $Id: asmsupp.asm 1.3 2002/10/16 21:35:22Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:ASMSUPP.ASM
;
; Copyright (c) 2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
;
;  08-16-2002  jmb   made _term_table a public variable
;--------------------------------------------------------------------

include macros.inc
include profile.inc

cBegData

__errno dw 0;

	; International Support
		 DB	?		; B2EH	??
_uppercase_table DB	82H dup (?)	; B2FH	uchar uppercase_table[0x82];
public _term_table
_term_table	 DW	16H		; BB1H	uchar term_table[0x18];
	DB 01H,00H,0FFH,00H,00H,20H,02H,0EH
	DB '.','"','/','\','[',']',':','|'  ;	/* "/\[]:|<>+=;, */
	DB '<','>','+','=',';',',', 0	    ;	NULL terminated char list
		 DB	 17H dup (?)	; BCAH	??
_collating_table DB	102H dup (?)	; BE1H	uchar collating_table[0x102];
_lead_byte_start DW	?		; CE3H
_lead_byte_table DB	 10H dup (?)	; CE5H	uchar lead_byte_table[0x10];

_disk_stackbase	db	26CH dup (?)	; 656H
_disk_stack	label	word		; 8C2H
_char_stackbase	db	26CH dup (?)	;
_char_stack	label	word		; B2EH

cEndData

cBegCode

;
;   This function provides debugging during boot-up time.
;   Set BCHECK to TRUE
;
COMMENT ~ ;prototype;
void PASCAL bios_putc(uchar c)
{}
~
	public	BIOS_PUTC
BIOS_PUTC	PROC NEAR
IFDEF	BCHECK
	push	BP
	mov	BP, SP
	push	bx

	mov	AL, P[BP]

	mov	AH, BIOSVID_CTTY
	mov	BH, 0
	int	BIOSVID

	pop	bx
	pop	BP
ENDIF
	ret	2
BIOS_PUTC	ENDP

cEndCode

;/////////////////////////////////////////////////////////
;//							//
;//		UPPERCASE CONVERSIONS			//
;//							//
;/////////////////////////////////////////////////////////

cBegCode

COMMENT ; prototype
/*
   Assumes DS=DGROUP
*/
int PASCAL is_lead_byte(uchar c)
{}
;
	public	IS_LEAD_BYTE
IS_LEAD_BYTE proc near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	mov	AL, P[BP]
	mov	BX, GOFFSET _lead_byte_table

	; lead bytes are in RANGED pairs
	; Example: japan lead bytes are 81H 9FH E0H FCH 00H
	; which means a lead byte is any character in the
	; RANGE of 81-9F, or E0-FC
check_lead_byte_range:
	cmp	byte ptr [BX], 0
	jz	no_more_lead_bytes
	cmp	AL, byte ptr [BX]
	jb	next_lead
	cmp	AL, byte ptr [BX+1]
	jbe	its_a_lead_byte
next_lead:
	inc	BX
	inc	BX
	jmp	check_lead_byte_range

no_more_lead_bytes:
	xor	AX, AX
its_a_lead_byte:
	pop	BP

	EXIT_FUNCTION

	ret	2

IS_LEAD_BYTE endp


COMMENT ; prototype
/*
   This toupper is more than the "C" toupper in that it
   knows about the lead byte and uppercase tables.
   Assumes DS=DGROUP
*/
uchar PASCAL toupper(uchar c)
{}
;
	public	TOUPPER
TOUPPER	proc	near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	; if the character is a lead byte, leave it alone
	push	word ptr P[BP]
	call	IS_LEAD_BYTE	; PASCAL function POPs its args
	mov	BL, P[BP]
	or	AX, AX
	jnz	nochange

	; it may be from the uppercase table
	; c = (c >= 0x80 ? uppercase_table[c - 0x7E] : toupper(c));
	xor	BH, BH
	cmp	BL, 80H
	jb	ascii
	sub	BL, 7EH
	add	BX, GOFFSET _uppercase_table
	mov	BL, byte ptr [BX]
	jmp	short nochange

	; or it may be normal ascii
ascii:	cmp	BL, 'a'
	jb	nochange
	cmp	BL, 'z'
	ja	nochange
	sub	BL, 'a'-'A'

nochange:
	xchg	BX, AX		; character was in BL, now in AL
	xor	AH, AH		; return the character in AX
	pop	BP

	EXIT_FUNCTION

	ret	2

TOUPPER	endp


COMMENT ; prototype
/*
   Convert a string using the current uppercase table.
   A len of -1 says stop on a '\0' byte.
*/
uchar uppercase(uchar far * s, int len)
{}
;
c_func	uppercase

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI
	push	DI

   ;	{
   ;	char c;
   ;	int leadbyte = 0;
   	xor	SI, SI		; SI is leadbyte
	mov	CX, P+4[BP]	; CX = "len"
	les	DI, P[BP]	; ES:DI = far ptr to string

   ;
   ;	while(len)
   ;	{
   ;	   c = *s;
uc_0:	jcxz	uc_done
	mov	AL, byte ptr ES:[DI]

   ;	   if(leadbyte)
   ;	      --leadbyte;
   	or	SI, SI
   	jz	uc_1
   	dec	SI
   	jmp	uc_5
uc_1:

   ;	   else if(is_lead_byte(c))
   ;	      leadbyte = 1;
   	push	AX
   	call	IS_LEAD_BYTE
	or	AX, AX
	jz	uc_2
	mov	SI, 1
   	jmp	uc_5
uc_2:
   ;	   else
   ;	   {
   ;	      if(!c && len == -1)
   ;	         break;
   ;	      *s = toupper(c);
   ;	   }
	mov	AL, byte ptr ES:[DI]
	cmp	AL, 0
	jnz	uc_3
	cmp	CX, -1
	jnz	uc_3
	jmp	short uc_done	; break;
uc_3:	push	AX
	call	TOUPPER
	mov	ES:[DI], AL

   ;	   ++s;
   ;	   if(len != -1)
   ;	      --len;
   ;	}
uc_5:
	inc	DI	; ES:DI = far ptr to string
	cmp	CX, -1
	jz	uc_6
	dec	CX
uc_6:	jmp	short uc_0

   ;	return c;
uc_done:
	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	uppercase

cEndCode

cBegCode

comment ~ ; prototype ;
void far * dosmalloc(unsigned para)
{}
~
c_func	dosmalloc
	push	BP
	mov	BP, SP
	mov	word ptr __errno, 0
	mov	AX, 4800H
	mov	BX, P[BP]	; para
	int	21H
	jnc	alloc_worked
	mov	__errno, AX
	xor	AX, AX
alloc_worked:
	mov	DX, AX
	xor	AX, AX
	pop	BP
	ret
c_endp	dosmalloc

BIOSKEY		EQU 16H	; BIOS keyboard interrupt
BIOSKEY_SHSTAT	EQU 2	; check shift status

c_func	con_shstat

	ENTER_FUNCTION

	mov	AH, BIOSKEY_SHSTAT
	int	BIOSKEY

	EXIT_FUNCTION

	ret
c_endp	con_shstat


COMMENT ~ ; prototype
char far * PASCAL IntlFStrCpy(char far * lpDstStr, char far * lpSrcStr)
~
	public	INTLFSTRCPY
INTLFSTRCPY proc near

	ENTER_FUNCTION

	push	bp
	mov	bp, sp
	push	si
	push	di
	push	ds

	mov	ds, P+2[BP]	; lpSrcStr
	mov	si, P[BP]

	; determine length of string
	mov	ax, ds
	mov	es, ax
	mov	di, si
	cld
	xor	al, al
	mov	cx, -1
	repnz	scasb
	not	cx

	; now copy it
	mov	es, P+6[BP]	; lpDstStr
	mov	di, P+4[BP]
	rep	movsb

	mov	ax, P+4[BP]	; return lpDstStr
	mov	dx, es

	pop	ds
	pop	di
	pop	si
	pop	bp

	EXIT_FUNCTION

	ret	8

INTLFSTRCPY endp


cEndCode

   END