REM
REM   $Id: b71rep.bat 1.3 2003/01/14 22:33:10Z thomd Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo off
REM
REM  BUILD71.BAT
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM
REM  HISTORY
REM   05/03/2001 jmb fixed a problem with the NED_DIR if DL_ROOT is set.
REM   04-12/2001 jmb modified NED and PROTO copy paths if DL_ROOT is set
REM

set bldlog=
if NOT "%buildlog%"=="" goto start
set buildlog=..\build.log
set bldlog=1


:start


REM Create the release tree directory
REM
if exist release\rep\71\nul deltree /y release\rep\71
if not exist release\nul md release
if not exist release\rep\nul md release\rep
if not exist release\rep\71\nul md release\rep\71




REM Build TOOLS first
REM
call setdeb release 32 rep
echo Building Required Tools...
cd bin\source
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM
REM Build TOOLS used to make a ROMDOS release
REM

echo Building BIN...
cd bin
make -B >>%buildlog%
cd ..
%DEBUGCMD%


REM
REM  Build ROMDOS Libraries
REM

rem goto nolibbld
echo Building Library Code...
cd lib
if exist *.lib del *.lib
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..
%DEBUGCMD%
:nolibbld


REM
REM  Build romdos binaries
REM


call setdeb release 32 rep


echo Building ROMDOS kernel
cd kernel
if exist makefile make -B >>%buildlog%
cd ..


call setdeb release 32 rep


echo Building BUILD.EXE
cd build
set REP_BUILD=REP
if exist makefile make -B >>%buildlog%
call makelibs
set REP_BUILD=
cd ..


echo Building default 7.1  release kernel
cd build
@if exist build.bat del build.bat
build <..\71lfn.key
cd ..


call setdeb release 32 rep


echo Building LFN command
cd command
if exist makefile make -B command.com >>%buildlog%
cd ..

REM
REM  Copy the files to the release tree
REM


REM root directory
REM
copy build\rom-dos.sys release\rep\71
copy command\command.com                release\rep\71
copy command\command.hlp                release\rep\71

rem  Copy the user manuals and readme.txt into the release tree
rem
bin\verhdr >hdr.txt
copy hdr.txt+repdocs\readme.txt readme.tmp
copy readme.tmp release\rep\readme.txt
del readme.tmp

REM Update the file time to reflect the version
bin\sdkver 7.10 release\rep\71


:done
if "%bldlog%"=="1" set buildlog=
