//
//   $Id: CHPPATH2.C 1.4 2002/10/15 19:58:14Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  CHPPATH2.C
//
//  Copyright (c) 1999-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//

/*
	Helper program for building the SDK disk(s). Takes the output
	of a DIR /B/S and chops off the current working direcory.
*/
#include <dir.h>
#include <mem.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "..\include\datalght.h"
#include "..\include\dlpath.h"

char szCwd[MAXPATH];
char szLine[MAXPATH];

/*
	Goes through the whole file, turning  C:\TEMP\DEV\ROMDOS\DOSTRUCT.H
	into DOSTRUCT.H. Effectively chops the current working directory on
	each entry.

	Returns TRUE if worked, FALSE if failed.
*/
bool ChopRootPath(FILE *fpIn, FILE *fpOut)
{
	int	lenRoot;
	int	lineNum;

	// determine length of root string
	lenRoot = strlen(szCwd);

	lineNum = 1;
	fseek(fpIn, 0L, SEEK_SET);
	while(!feof(fpIn))
	{
		// get the line
		if(!fgets(szLine, MAXPATH, fpIn))
			break;

		// validate the line
		if(strncmpi(szCwd, szLine, lenRoot) != 0)
		{
			printf("Invalid line %d: %s\n",lineNum,szLine);
			return FALSE;
		}

		// chop the line
		memmove(szLine, szLine+lenRoot, strlen(szLine+lenRoot) + 1);

		// write it out
		fputs(szLine, fpOut);

		++lineNum;
	}

	return TRUE;
}


int main(int argc, char *argv[])
{
	FILE *fpIn, *fpOut;

	// verify cmdline arg
	if(argc != 3)
	{
		printf("Usage = CHOPPATH <inFile> <outFile>\n"
			"Where <inFile> is the result of DIR/S/B\n");
		return 1;
	}

	// get current directory
	if(!GetCurrentDir(szCwd, getdisk()))
	{
		printf("Error: getting current directory!\n");
		return 2;
	}
	// MUST end in backslash
	if(szCwd[strlen(szCwd)-1] != '\\')
		strcat(szCwd, "\\");

	// open the file we will chop
	fpIn = fopen(argv[1], "r");
	if(!fpIn)
	{
		printf("Error: couldn't open %s!\n",argv[1]);
		return 3;
	}

	fpOut = fopen(argv[2], "w");
	if(!fpOut)
	{
		printf("Error: couldn't create %s!\n",argv[2]);
		return 4;
	}

	// chop the path off
	if(!ChopRootPath(fpIn, fpOut))
	{
		printf("Error: Failed to chop path!\n");
		return 5;
	}

	fclose(fpIn);
	fclose(fpOut);

	return 0;
}
