//
//   $Id: FILECMP.C 1.4 2002/10/15 19:58:14Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  FILECMP.C
//
//  Copyright (c) 1997-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//

/*
	Line by Line File Comparison program

	History:
		6/18/97	MJS	Creation
*/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define LINELEN	128

void Usage(void)
{
	printf("Usage:  filecmp <filename1> <filename2>\n");
	exit(5);
}

int main(int argc, char *argv[])
{
	FILE *fpFile1 = NULL, *fpFile2 = NULL;
	char cpFile1Line[LINELEN], cpFile2Line[LINELEN];
	char *cpFile1Pos, *cpFile2Pos;
	int nErrorCode = 0;
	int bStillData = 1;

	if (argc < 3)  //  Verify correct number of arguments
	{
		Usage();
	}

	fpFile1 = fopen(argv[1], "r");	// Open the first file
	if (fpFile1 == 0)
	{
		printf("Unable to open file: %s\n", argv[1]);
		exit(5);
	}

	fpFile2 = fopen(argv[2], "r");	// Open the second file
	if (fpFile2 == 0)
	{
		fclose(fpFile1);
		printf("Unable to open file: %s\n", argv[2]);
		exit(5);
	}

	while(bStillData)		// While there is data in the file
	{
		// Read a line from each file
		cpFile1Pos = fgets(cpFile1Line, LINELEN, fpFile1);
		cpFile2Pos = fgets(cpFile2Line, LINELEN, fpFile2);
		// Check for EOF or error
		if (cpFile1Pos == NULL)
		{
			if (cpFile2Pos != NULL)
			{
				printf("File %s is longer than file %s\n", argv[2], argv[1]);
				nErrorCode = 2;
				break;
			}
			else
			{
				printf("No differences encountered\n");
				bStillData = 0;
				break;
			}
		}
		else
		{
			if (cpFile2Pos == NULL)
			{
				printf("File %s is longer than file %s\n", argv[2], argv[1]);
				nErrorCode = 2;
				break;
			}
		}

		// Compare the strings
		if (strcmp(cpFile1Line, cpFile2Line))
		{
			printf("*** ERROR *** Difference Encountered\n");
			printf("--- %s ---\n", argv[1]);
			printf("%s\n", cpFile1Line);
			printf("--- %s ---\n", argv[2]);
			printf("%s\n", cpFile2Line);
			nErrorCode = 1;
			break;
		}
	}

	// Close the files
	fclose(fpFile1);
	fclose(fpFile2);

	// Return the error code
	return (nErrorCode);
}
