//
//   $Id: BUILD.CPP 1.6 2002/10/15 20:06:44Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	BUILD.CPP  created 12/08/89  by Drew Gislason

   Copyright (c) 1989-2001 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This program simplifies the process of building a new
	ROM-DOS for disk or ROM.

***********************************************************/
#include <ctype.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <process.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "win.h"
#include "buildmsg.h"
#include "dosver.h"
#include "getkey.h"

//  Will this version of build allow you to build an LFN kernel?
//
#define LFN_SUPPORT	TRUE

//  This is the include path for assembling the devfdhd*.asm files
//
#define INCLUDE_PATH1	"devsrc" //  Release default
#define INCLUDE_PATH2	"..\\kernel" //  Development tree default

#define TRUE  1
#define FALSE 0
#define ERR -1

#define ESC 27
#define BS  8

// Borland assembler/linker
#define TLINK	"TLINK.EXE"
#define TASM	"TASM.EXE"
#define TLIB	"TLIB.EXE"
#define BOPTS	"/m/c"

// Microsoft assembler/linker
#define MLINK	"LINK.EXE"
#define MASM	"MASM.EXE"
#define MOPTS	"/MAP/NOD/NOE"

#define DATA_DEFAULT	0x70
#define CODE_DEFAULT	0xD000


// build command line options
int optBuild = TRUE;				// assemble/link/locate ROM-DOS, or just locate
int optNoColor;					// if true, only black and white colors
int optBorlandTools = TRUE;	// use Borland or Microsoft tools
int optPause;						// pause between executing each program
int optTTY;							// TTY mode for incompatible screens

// options for the locator
bool locExtendedAddress;			// put extended addresses in Intel HEX file?
unsigned locCodeStart = CODE_DEFAULT;
unsigned locDataStart = DATA_DEFAULT;

// quick build options
bool locIntelHex;				// output Intel HEX or binary image
bool locSplitRoms;				// 8 or 16 bit bus
bool locFloppy;					// boot from floppy or ROM

// custom build options
bool sysgenBCHECK;			// shall ROM-DOS display boot diagnostics?
bool sysgenBOOTMENU;		// include the boot menu?
int sysgenCOMPRESS;		// include compressed disk?
int sysgenBEXT;			// tell SYSGEN to include a BIOS extension?
int sysgenBOOTDEV;		// read CONFIG.SYS from device (ROM, Hard. Flop)
bool sysgenBOOTDRV;		// read CONFIG.SYS from specific drive letter
bool sysgenFLOPCHK;		// can floppy DOS supersede ROM-DOS in ROM?
bool sysgenNOFLOP;			// exclude floppy/hard disk driver
bool sysgenTRUSTME;		// Always believe FAT count in the BPB?
bool sysgenNOROM;			// exclude ROM-DISK driver
bool sysgenGENERIC;		// include the generic disk driver?
unsigned sysgenRAMBOOT;	// segment in RAM to boot from
unsigned sysgenRDISK;	// starting search segment for ROM-DISK
bool sysgenUSERTC;			// use the Real Time Clock?
int cfgLevel;				// config.sys processing level 0,3,5,6

bool fRomdos71Support  = FALSE;
bool fLFNSupport       = FALSE;
bool fFAT32Support     = FALSE;
bool fCreateSuperBoot   = FALSE;
bool fBootFromSuperBoot = TRUE;
char cSuperBootDriveOrder = 'L';
char szSuperBootID[3];

char recfile[] = "BUILD.CFG";			// record file
FILE *recfp;

char szCLSysgen[]   = "SYSGEN.CL";
char szCLDevfdhd[]  = "DEVFDHD.CL";
char szCLDevfdhdi[] = "DEVFDHDI.CL";
char szCLUserLib[]  = "USERLIB.CL";


unsigned rom_sizeK;				// size in K
unsigned long rom_sizeb;				// size in bytes


char LINK[40];
char ASM[40];
char LIB[40];
char szSysgenArgs[240];
char szDevfdhdiArgs[240];
char szDevfdhdArgs[240];
char szUserLibArgs[240];
char szDevfdhd[240];
char szDevfdhdi[240];
char link_line6[] = "dos6asm+sysgen,rom-dos,,%sromdos6.lib+%sdosinit6.lib+%sdoscfg6.lib%s; ";
char link_line7[] = "dos7asm+sysgen,rom-dos,,%sromdos7.lib+%sdosinit7.lib+%sdoscfg7.lib%s; ";
char USERLIB[] = "USER.LIB";
char cfg_libs1[80];
char cfg_libs2[80];
char cfg_libs3[80];
char szIncludePath[128];

// PROTO  Version 1.00

// File BUILD.C
int detect_tools(void);
void build_romdos(void);
void quick_build(void);
void custom_section(char *msg);
char * strof(char c);
char * strof(unsigned val);
void setoption(char *msg, char *ques, char *def, bool *opt, char ctrue);
void add_option(char *msg, char *result);
void romdisk_searchseg(void);
int options_do_over(void);
void custom_build(void);
void process_args(int argc,char *argv[]);
unsigned long find_segment_value(char *exe_name, char *seg_name);
void mk_loc_file(unsigned code_st, unsigned long size, unsigned data_st);
int strfnd(char *str1, char *str2);
void mk_ext(char *fname, char *ext);
char win_getkey(void);
unsigned char win_getpartid(char * msg, unsigned char defval);
unsigned win_getsegment(char * msg, unsigned defval);
void * win_question(char *string, char *choices, char *pick, int row=18);
char win_checkkey(void);
void win_getstring(char *str, int maxlen);
void win_exit(int n);
void win_checkexit(void);
void win_iderror(char *msg);
void * win_error(char *str);
void win_errorout(char *str);
void win_message(char *str);
void * win_showatrow(int row, char *str);
int use_blackandwhite(void);
void win_spawn(char *name, char *cmdline);
int win_ignorewarning(char * msg);
unsigned atoh(char *s);
void win_close(void * w);
void win_flush(void);
void win_pick(void * w);


char line[132];
char zz[1024];		// a very temporary string

// the 4 colors
int colorBackground = mkattr(BLACK,WHITE);
int colorWindow     = mkattr(LTWHITE,RED);
int colorError      = mkattr(YELLOW,BLUE);
int colorQuestion   = mkattr(YELLOW,RED);

/*
	Read the colors from the colors file (BUILD.COL).
	The 4 colors are numbers from 0-255, separated by
	commas:	background, window, err, question.
*/
void readcolors(void)
{
	FILE * fp;
	char s[40];
	char *p;
	fp = fopen("build.col","r");
	if(fp)
	{
		fgets(s,30,fp);
		p = s;
		colorBackground = atoi(p);
		p = strchr(p,',');
		++p;
		colorWindow = atoi(p);
		p = strchr(p,',');
		++p;
		colorError = atoi(p);
		p = strchr(p,',');
		++p;
		colorQuestion = atoi(p);
		fclose(fp);
	}
}

/*
	Should we use black and white by default?
*/
int use_blackandwhite(void)
{
	if(optTTY)
		return TRUE;

	int mode = w_getmode();
	if(mode==W_MODEMONO || mode==W_MODEBW80 || optNoColor)
		return TRUE;
	return FALSE;
}

/*
	BUILD /? for help
*/
int main(int argc, char *argv[])
{
	char c;
	void * w1, * w2;
	char * msg;

	// display sign-on message right away
	sprintf(zz,msgLogo, FULLVERSION, COPYRIGHT);
	printf("%s\n",zz);

	// read the colors from color file
	readcolors();

	// process the command line switches
	process_args(argc,argv);

	// create windowing structure
	if(!optTTY)
	{
		w_init();
		if(use_blackandwhite())
		{
			colorBackground = mkattr(WHITE,BLACK);
			colorWindow     = mkattr(BLACK,WHITE);
			colorError      = mkattr(BLACK,WHITE);
			colorQuestion   = mkattr(WHITE,BLACK);
		}
		w_pickbackdrop();
		w_setattr(colorBackground);
		w_clrall();
	}

	// create a Recording of current options
	if(*recfile && IsCharDevice( FD_STDIN ))
	{
		recfp = fopen(recfile,"w");
		if(!recfp)
		{
			sprintf(zz,msgRecError,recfile);
			win_errorout(zz);
		}
	}

	// display signon screen
	if(!optTTY)
		w1 = win_showatrow(2,zz);
	strcpy(zz,msgWelcome);
	strcat(zz,msgEscOrCR);
	w2 = win_showatrow(11,zz);
	win_checkkey();

	// Detect Assembler/Linker at this point
	if(!detect_tools())
	{
		if(!win_ignorewarning(msgNoAsm))
			win_exit(1);
	}

	// don't close opening screen until now because it looks cool
	win_close(w2);
	win_close(w1);

	// Quick or Custom Build?
	w1 = win_showatrow(3,msgQuickBuild);
	w2 = win_question(askQuickBuild,defQuickBuild, &c);
	win_close(w1);
	win_close(w2);
	if(c == 'Q')
		quick_build();
	else
		custom_build();

	build_romdos();

	if(locFloppy)
		sprintf(zz,msgBuiltDisk,rom_sizeK,rom_sizeb);
	else
	{
		if(locSplitRoms)
			msg = msgBuiltSplitFile;
		else if(locIntelHex)
			msg = msgBuiltHexFile;
		else
			msg = msgBuiltImgFile;
		sprintf(zz,msgBuiltROM,msg,rom_sizeK,rom_sizeb,locDataStart);
	}
	strcat(zz,msgExitCR);
	w1 = win_showatrow(2,zz);
	win_getkey();
	win_exit(0);
}

/*
	Redirect the following handle to the appropriate name.
	Used when finding ASM and LINK so their output doesn't
	muss the screen.
*/
void redirect(int handle, char *name)
{
	FILE * fp;

	fp = fopen(name,"w+");
	if(fp)
	{
		_close(handle);
		dup2(fp->fd,handle);
		fclose(fp);
	}
}

/*
	Redirect the handle back to what it was.
	Used when finding ASM and LINK.
*/
void redirect(int handle, int to)
{
	_close(handle);
	dup2(to,handle);
}

/*
	Returns TRUE if tools are found, FALSE if not.
*/
int detect_tools(void)
{
	int i;
	int found = FALSE;
	void * w;

	// let the user know what we are doing
	w = win_showatrow(10,msgSearchAsm);
	win_flush();

	// redirect output to null
	redirect(1,"NUL");

	for(i=0; i<1; ++i)
	{
		// choose Assembler and Linker Names
		if(optBorlandTools)
		{
			strcpy(ASM,  TASM);
			strcpy(LINK, TLINK);
			strcpy(LIB,  TLIB);
		}
		else
		{
			strcpy(ASM,  MASM);
			strcpy(LINK, MLINK);
			strcpy(LIB,  TLIB);
		}

		// detect if they are BOTH there
		if( (spawnlp(0, ASM, ASM,   "/?", 0) >= 0 ) &&
			 (spawnlp(0, LINK, LINK, "/?", 0) >= 0 ) &&
			 (spawnlp(0, LIB, LIB,   "/?", 0) >= 0 ) )
		{
			found = TRUE;
			break;
		}

//  Option no longer supported!
//
		// try the other ASSEMBLER/LINKER
//		optBorlandTools = !optBorlandTools;
	}

	// clean up
	redirect(1,2);			// redirect stdout back to stderr
	win_close(w);
	return found;
}

void build_romdos(void)
{
	FILE *fp, *fpbat;
	char szCLTemp[20];
	struct ffblk ffblk;


	fpbat = fopen("BUILD.BAT","w");
	fprintf(fpbat, msgBAT);

	if(optBuild)
	{
		//		<<<	ASSEMBLE SYSGEN	>>>

		// create command line for assembling SYSGEN.ASM
		*szSysgenArgs = 0;
		if(sysgenBCHECK)
			strcat(szSysgenArgs,"/DBCHECK=1 ");
		if(sysgenBEXT)
			strcat(szSysgenArgs,"/DBEXT=1 ");
		if(sysgenBOOTDEV)
		{
			sprintf(zz,"/DBOOTDEV=%02XH ",sysgenBOOTDEV&0xF0);
			strcat(szSysgenArgs, zz);
		}
		if(sysgenBOOTDRV)
		{
			sprintf(zz,"/DBOOTDRV=%d ",sysgenBOOTDRV-1);
			strcat(szSysgenArgs, zz);
		}
		if(sysgenBOOTMENU)
			strcat(szSysgenArgs,"/DBOOTMENU=1 ");
		if(sysgenFLOPCHK)
			strcat(szSysgenArgs,"/DFLOPCHK=1 ");
		if(sysgenNOFLOP)
			strcat(szSysgenArgs,"/DNOFLOP=1 ");
		if(sysgenTRUSTME)
			strcat(szSysgenArgs,"/DTRUST_ME=1 ");
		if(sysgenCOMPRESS)
			strcat(szSysgenArgs,"/DCOMPRESS=1 ");
		if(sysgenNOROM)
			strcat(szSysgenArgs,"/DNOROM=1 ");
		if(sysgenGENERIC)
			strcat(szSysgenArgs,"/DGENERIC=1 ");

#if USING_FAT32

		if(fFAT32Support)
			strcat(szSysgenArgs,"/DFAT32=1 ");

#endif //#if USING_FAT32

#if LFN_SUPPORT
		if(fLFNSupport)
			strcat(szSysgenArgs,"/DLFN=1 ");
#endif

		if(sysgenRAMBOOT)
		{
			sprintf(zz,"/DRAMBOOT=0%XH ",sysgenRAMBOOT);
			strcat(szSysgenArgs, zz);
		}
		if(sysgenRDISK)
		{
			sprintf(zz,"/DRDISK=0%XH ",sysgenRDISK);
			strcat(szSysgenArgs, zz);
		}
		if(sysgenUSERTC)
			strcat(szSysgenArgs,"/DUSERTC=1 ");

		//  Build the include path
		//
//		sprintf( zz, "%s\\*.*", INCLUDE_PATH1 );
//		if( 0 == findfirst( zz, &ffblk, 0 ) )
		if( 0 == findfirst( INCLUDE_PATH1, &ffblk, FA_DIREC ) )
		{
			//  Path for source in the release tree
			//
			sprintf( szIncludePath, "/I%s ", INCLUDE_PATH1 );
			strcpy( szDevfdhdi, INCLUDE_PATH1 );
			strcpy( szDevfdhd, INCLUDE_PATH1 );
			sprintf( zz, "/Mx /I%s %s\\SYSGEN.ASM;",
					INCLUDE_PATH1, INCLUDE_PATH1 );
		}
		else
		{
			//  Path for source in the development tree
			//
			sprintf( szIncludePath, "/I..\\include /I%s ", INCLUDE_PATH2 );
			strcpy( szDevfdhdi, INCLUDE_PATH2 );
			strcpy( szDevfdhd, INCLUDE_PATH2 );
			sprintf( zz, "/Mx /I..\\include /I%s %s\\SYSGEN.ASM;",
					INCLUDE_PATH2, INCLUDE_PATH2 );
		}
		strcat(szSysgenArgs, zz );


		// Assemble SYSGEN.ASM
		fprintf(fpbat, "%s @%s\n",ASM, szCLSysgen );
		fp = fopen(szCLSysgen,"w");
		fprintf(fp, szSysgenArgs);
		fclose(fp);
		sprintf( szCLTemp, "@%s", szCLSysgen );
		win_spawn(ASM, szCLTemp );


		strcat( szDevfdhdi, "\\devfdhdi.asm" );
		strcat( szDevfdhd,  "\\devfdhd.asm" );


		strcpy( szDevfdhdiArgs, "/Mx /m10" );
		strcpy( szDevfdhdArgs,  "/Mx /m10" );

		if( fCreateSuperBoot )
		{
			//  Enable super boot
			//
			sprintf( zz, " %s", "/DSUPERBOOT=1" );
			strcat( szDevfdhdiArgs, zz );
			strcat( szDevfdhdArgs,  zz );

			//  Super boot drive ordering
			//
			sprintf( zz, " %s", "/DSUPR_ORDER=" );
			if( cSuperBootDriveOrder == 'F' )
			{
				strcat( zz, "1" );
			}
			else if( cSuperBootDriveOrder == 'M' )
			{
				strcat( zz, "2" );
			}
			else
			{
				strcat( zz, "3" );
			}
			strcat( szDevfdhdiArgs, zz );
			strcat( szDevfdhdArgs,  zz );

			//  Boot from super boot drive
			//
			sprintf( zz, " %s", "/DBOOT_FROM_SUPER=" );
			if( fBootFromSuperBoot )
			{
				strcat( zz, "1" );
			}
			else
			{
				strcat( zz, "0" );
			}
			strcat( szDevfdhdiArgs, zz );
			strcat( szDevfdhdArgs,  zz );

			//  super boot ID
			//
			sprintf( zz, " %s0%sh", "/DSUPR_ID=", szSuperBootID );
			strcat( szDevfdhdiArgs, zz );
			strcat( szDevfdhdArgs,  zz );
		}

#if USING_FAT32
		if( fFAT32Support )
		{
			strcat( szDevfdhdiArgs, " /DFAT32=1 " );
			strcat( szDevfdhdArgs,  " /DFAT32=1 " );
		}
#endif

#if LFN_SUPPORT
		if( fLFNSupport )
		{
			strcat( szDevfdhdiArgs, " /DVDOS=7 " );
			strcat( szDevfdhdArgs,  " /DVDOS=7 " );
		}
		else
		{
			strcat( szDevfdhdiArgs, " /DVDOS=6 " );
			strcat( szDevfdhdArgs,  " /DVDOS=6 " );
		}
#else
		strcat( szDevfdhdiArgs, " /DVDOS=6 " );
		strcat( szDevfdhdArgs,  " /DVDOS=6 " );
#endif

		strcat( szDevfdhdiArgs, szIncludePath );
		strcat( szDevfdhdArgs,  szIncludePath );

		strcat( szDevfdhdiArgs, szDevfdhdi );
		strcat( szDevfdhdArgs,  szDevfdhd );


		//
		//  Build devfdhd* if we need to and put it in user.lib
		//

		// Assemble DEVFDHD.ASM
		//
		fprintf(fpbat, "%s @%s\n",ASM, szCLDevfdhd );
		fp = fopen(szCLDevfdhd,"w");
		fprintf(fp, szDevfdhdArgs);
		fclose(fp);
		sprintf( szCLTemp, "@%s", szCLDevfdhd );
		win_spawn(ASM, szCLTemp );


		// Assemble DEVFDHDI.ASM
		//
		fprintf(fpbat, "%s @%s\n",ASM, szCLDevfdhdi );
		fp = fopen(szCLDevfdhdi,"w");
		fprintf(fp, szDevfdhdiArgs);
		fclose(fp);
		sprintf( szCLTemp, "@%s", szCLDevfdhdi );
		win_spawn(ASM, szCLTemp );


		//  Add DEVFDHD and DEVFDHDI to USER.LIB
		//
		strcpy( szUserLibArgs, USERLIB );
		strcat( szUserLibArgs, " -+devfdhd.obj -+devfdhdi.obj\n" );
		fprintf(fpbat, "%s @%s\n",LIB, szCLUserLib );
		fp = fopen(szCLUserLib,"w");
		fprintf(fp, szUserLibArgs);
		fclose(fp);
		sprintf( szCLTemp, "@%s", szCLUserLib );
		win_spawn(LIB, szCLTemp );


		//		<<<	LINK ROM-DOS	>>>

		// create link line for linking ROM-DOS
		fp = fopen(USERLIB, "r");
		if(fp)
		{
			strcat(cfg_libs1,USERLIB);
			strcat(cfg_libs1,"+");
			fclose(fp);
		}
		fp = fopen("ROM-DOS.LNK", "w");
		if(fRomdos71Support)
		{
			fprintf(fp, link_line7, cfg_libs1, cfg_libs2, cfg_libs3,
				optBorlandTools ? BOPTS : MOPTS);
		}
		else
		{
			fprintf(fp, link_line6, cfg_libs1, cfg_libs2, cfg_libs3,
				optBorlandTools ? BOPTS : MOPTS);
		}
		fclose(fp);

		// link ROM-DOS
		fprintf(fpbat, "%s %s\n",LINK,"@ROM-DOS.LNK");
		win_spawn(LINK, "@ROM-DOS.LNK");

		// compress ROM-DOS DATA area
		fprintf(fpbat, "COMPRESS ROM-DOS\n");
		win_spawn("COMPRESS", "ROM-DOS");

		// display the size of ROM-DOS
		rom_sizeb = (find_segment_value("ROM-DOS.EXE", "BSS") + 1) * 16;
		rom_sizeK = (unsigned)((rom_sizeb-1)/1024 + 1);

		// make the location file
		mk_loc_file(locCodeStart, rom_sizeb, locDataStart);
	}

	//		<<<	LOCATE ROM-DOS		>>>
	fprintf(fpbat, "LOC @ROM-DOS.LOC\n");
	win_spawn("LOC", "@ROM-DOS.LOC");

	// Rename the image file to ROM-DOS.SYS for disk version
	if(locFloppy)
	{
		fprintf(fpbat, "DEL ROM-DOS.SYS\nREN ROM-DOS.IMG ROM-DOS.SYS\n");
		unlink("ROM-DOS.SYS");
		rename("ROM-DOS.IMG", "ROM-DOS.SYS");
	}

	fclose(fpbat);
}

void quick_build(void)
{

	// always have boot diagnostics on for Quick-Build
	sysgenBCHECK = TRUE;

#if USING_FAT32

	// Enable FAT32 support
	//
	strcpy(zz,msgQuick);
	strcat(zz,msgRomdos6or7);
	setoption(zz,askRomdos6or7,defRomdos6or7,&fRomdos71Support,
			defRomdos6or7[0]);
	if( fRomdos71Support )
	{
		fFAT32Support     = TRUE;
	}

#endif //#if USING_FAT32

#if LFN_SUPPORT
	// Enable LFN support
	//
	strcpy(zz,msgQuick);
	strcat(zz,msgLFNSupport);
	setoption(zz,askLFNSupport,defLFNSupport,&fLFNSupport,
			defLFNSupport[1]);
	if( fLFNSupport )
	{
		if( fRomdos71Support )
		{
			strcat(cfg_libs3,"dos7cfg7.obj+");
			strcat(cfg_libs2,"longnam7+");
		}
		else
		{
			strcat(cfg_libs3,"dos6cfg7.obj+");
			strcat(cfg_libs2,"longnam6+");
		}
	}
#endif // #if LFN_SUPPORT

	// disk bootable ROM-DOS?
	strcpy(zz,msgQuick);
	strcat(zz,msgDiskBoot);
	setoption(zz,askDiskBoot,defDiskBoot,&locFloppy,'Y');

	if(locFloppy)
	{
		sysgenBEXT = FALSE;
		sysgenNOROM = TRUE;
	}

	// ROM-DOS will be in ROM
	else
	{
		sysgenBEXT = TRUE;		// ROM-DOS gets control via BIOS extension
		sysgenFLOPCHK = TRUE;	// floppy DOS can superscede DOS in ROM

		// will this be a binary or Intel HEX file?
		strcpy(zz,msgQuick);
		strcat(zz,msgBinary);
		setoption(msgBinary,askBinary,defBinary,&locIntelHex,'H');

		// will this be a split ROM or not
		strcpy(zz,msgQuick);
		strcat(zz,msgSplit);
		setoption(msgSplit,askSplit,defSplit,&locSplitRoms,'Y');
	}
}

// describe a section and wait for a key
void custom_section(char *msg)
{
	void * w;
	strcpy(zz,msg);
	strcat(zz,msgEscOrCR);
	w = win_showatrow(8,zz);
	win_checkkey();
	win_close(w);
}

/*
	Standard question, get the results.
*/
void setoption(char *msg, char *ask, char *def, bool * opt, char ctrue)
{
	void * w1, * w2;
	char c;

	w1 = win_showatrow(3,msg);
	w2 = win_question(ask,def,&c);
	win_close(w1);
	win_close(w2);
	*opt = (c == ctrue);

	// record this option
	add_option(ask,strof(c));
}

/*
	Standard question, get the results.
*/
void getoption(char *msg, char *ask, char *def, char *opt)
{
	void * w1, * w2;
	char c;

	w1 = win_showatrow(3,msg);
	w2 = win_question(ask,def,&c);
	win_close(w1);
	win_close(w2);
	*opt = c;

	// record this option
	add_option(ask,strof(c));
}

char * strof(char c)
{
	static char s[2];
	*s = c;
	return s;
}

char * strof(unsigned val)
{
	static char s[5];
	sprintf(s,"%X",val);
	return s;
}

/*
	Add an option to the list of options.  This is only for
	display purposes.  The total list of options will be
	displayed at the end, and the user asked for confirmation.
*/
char * optbuff;
char * optptr;
void add_option(char *msg, char *result)
{
	#define SIZEOPTBUFF (4*1024)

	// allocate a buffer (if we haven't already)
	if(!optbuff)
		optptr = optbuff = new char[SIZEOPTBUFF];

	// add message and result to
	strcpy(optptr,msg);
	optptr += strlen(optptr) + 1;
	strcpy(optptr,result);
	optptr += strlen(optptr) + 1;
	*optptr = 0;

	if(optptr - optbuff > SIZEOPTBUFF)
	{
		sprintf(zz,msgInternal,__LINE__);
		win_errorout(zz);
	}
}

//  Returns TRUE if user wants to do options over
int options_do_over(void)
{
	FILE * fp;
	int height;
	int width;
	int len1;			// width of 2nd field
	int len2;			// width of 2nd field
	void * w;
	bool sure;
	char * orgoptptr;
	int firsttime = 1;

	// don't allow invalid buffer
	if(!optbuff)
		return 0;

	// count lines and determine width
do_over:
	height = 4;
	width = len1 = len2 = 0;
	optptr = optbuff;
	while(*optptr)
	{
		++height;

		// determine length of 1st field
		int len = strlen(optptr);
		if(len > len1)
			len1 = len;
		optptr += len + 1;

		// determine total width
		len = strlen(optptr);
		if(len > len2)
			len2 = len;
		optptr += len + 1;

		// check for errors
		if(optptr - optbuff > SIZEOPTBUFF)
		{
			sprintf(zz,msgInternal,__LINE__);
			win_errorout(zz);
		}
	}

	// allow for a gutter, both fields, and a margin of separation
	width = 2 + len1 + 3 + len2 + 2;
	len1 += 3;

	if(optTTY)
		printf("\n-- You've Chosen the following: --\n");
	// open the window
	else
	{
		w = w_open((w_screenrows()-height)/2, height,
			(w_screencols()-width) / 2, width, W_FIXED);
		w_setattr(colorWindow);
		w_setframe(W_DFRAME);
		w_setborderattr(w_getattr());
		w_setshadow(1);
		w_clrall();
	}

	// display everything (also write it to BUILD.TXT)
	if(firsttime)
		fp = fopen("BUILD.TXT","w");
	optptr = optbuff;
	int r;
	for(r = 1; *optptr; ++r)
	{
		// position cursor for display
		if(!optTTY)
		{
			win_flush();
			w_goto(r,2);
		}

		// display the field
		char * p = optptr + strlen(optptr) + 1;
		sprintf(zz,"%-*s%s",len1,optptr,p);
		if(optTTY)
			printf("%s\n",zz);
		else
			w_puts(zz);

		// write it to the file
		if(firsttime)
			fprintf(fp,"%s\n",zz);

		// next field
		optptr = p + strlen(p) + 1;
	}
	if(firsttime)
		fclose(fp);

	if(optTTY)
		printf("%s%c",msgChangeOpts,'Y');
	else
	{
		w_goto(r+1, (width-strlen(msgChangeOpts))/2);
		w_puts(msgChangeOpts);
		w_setattr(colorQuestion);
		w_putc('Y');
		w_goto(w_getrow(),w_getcol()-1);
		win_flush();
		w_updatecursor();
	}

	// does user want to do it again?
	int again = FALSE;
	char c = win_checkkey();
	c = toupper(c);
	if(optTTY)
		printf("\010%c\n",c);
	win_close(w);

	if(c == '\r' || c == '\n' || c == 'Y')
		again = TRUE;
	if(c == 'P')
		optPause = TRUE;

	if(again)
	{
		firsttime = 0;
		orgoptptr = optptr;
		setoption(warnSure,askSure,defSure,&sure,'Y');
		if(!sure)
		{
			*orgoptptr = 0;
			goto do_over;
		}
	}

	// start over in case user does it again, so add option works
	optptr = optbuff;
	return again;
}

#define ARRAY_ENTRIES(array) (sizeof(array) / sizeof(array[0]))

// ask the level of CONFIG.SYS processing
void ask_config_level(void)
{
	void * w1, * w2;
	char c;
	static char szTemp[ARRAY_ENTRIES(msgCfgLevel6) + ARRAY_ENTRIES(msgCfgLevel7) + 1];


	//  what cfglevel does user want?
	//
	if(fRomdos71Support)
	{
		strcpy( szTemp, msgCfgLevel6 );
		strcat( szTemp, msgCfgLevel7 );
		w1 = win_showatrow(2, szTemp);
		w2 = win_question(askCfgLevel7,defCfgLevel7,&c);
		add_option(askCfgLevel7, strof(c));
	}
	else
	{
		w1 = win_showatrow(2,msgCfgLevel6);
		w2 = win_question(askCfgLevel6,defCfgLevel6,&c);
		add_option(askCfgLevel6, strof(c));
	}
	win_close(w2);
	win_close(w1);


	//  Config 7 processing is LFN processing not DOS 7.1 processing.  DOS 7.1
	//  processing is the same as DOS 6.22
	//
	if(c=='7')
	{
		c='6';
	}
	else if(c=='N')
	{
		// None is config level 0
		c='0';
	}


	// set up the strings
	*cfg_libs3 = 0;
	if (c != '6')
	{
		if(fRomdos71Support)
		{
			sprintf(cfg_libs3,"dos7cfg%c.obj+",c);
		}
		else
		{
			sprintf(cfg_libs3,"dos6cfg%c.obj+",c);
		}
	}
}

#if 0
// We no longer need this question, as we don't include
// a compressed ROM-DISK anymore.
void ask_which_romdisk(void)
{
	void * w1, * w2;
	char c;
	char * p;
	int answer;

	// Does user want Standard, Compressed ROM-DISK driver or Both?
againdisk:
	w1 = win_showatrow(3,msg2ROMDISKs);
	w2 = win_question(askCompressed,defCompressed,&c);
	p = strchr(defCompressed, c);		// SCBN
	answer = (p - defCompressed);
	if(answer==1 || answer==3)	// compressed or none
		sysgenNOROM=TRUE;
	else
		sysgenNOROM=FALSE;
	if(answer==1 || answer==2)	// compressed or both
		sysgenCOMPRESS = TRUE;
	else
		sysgenCOMPRESS = FALSE;
	win_close(w2);
	win_close(w1);

	// don't allow user to exlude BOTH the ROM-DISK and the Floppy
	if(answer==3 && sysgenNOFLOP)
	{
		custom_section(warnNoDisks);
		goto againdisk;
	}
	add_option(askCompressed, strof(c));

	// if the ROM-DISK driver is still included, let user set search segment
	w1 = win_showatrow(3,msgSearchSeg);
	w2 = win_question(askSearchSeg,defSearchSeg,&c);
	add_option(askSearchSeg,strof(c));
	win_close(w2);
	win_pick(w1);
	sysgenRDISK = 0;
	if(c == 'Y')
	{
		sysgenRDISK = win_getsegment(getSearchSeg,0xC000);
		add_option(getSearchSeg, strof(sysgenRDISK));
	}
	win_close(w1);
}
#endif

void romdisk_searchseg(void)
{
	void * w1, * w2;
	char c;

	// Let user set search segment for ROM-DISK
	w1 = win_showatrow(3,msgSearchSeg);
	w2 = win_question(askSearchSeg,defSearchSeg,&c);
	add_option(askSearchSeg,strof(c));
	win_close(w2);
	win_pick(w1);
	sysgenRDISK = 0;
	if(c == 'Y')
	{
		sysgenRDISK = win_getsegment(getSearchSeg,0xC000);
		add_option(getSearchSeg, strof(sysgenRDISK));
	}
	win_close(w1);
}



/*
	Build with LOTS of options
*/
void custom_build(void)
{
	void * w1, * w2;
	char c;


again:

	*cfg_libs1 = *cfg_libs2 = *cfg_libs3 = 0;
	locDataStart = DATA_DEFAULT;
	locCodeStart = CODE_DEFAULT;

#if USING_FAT32

	// Enable FAT32 support
	//
	strcpy(zz,msgCustom);
	strcat(zz,msgRomdos6or7);
	setoption(zz,askRomdos6or7,defRomdos6or7,&fRomdos71Support,
			defRomdos6or7[0]);
	if( fRomdos71Support )
	{
		fFAT32Support     = TRUE;
	}

#endif // #if USING_FAT32

#if LFN_SUPPORT
	// Enable LFN support
	//
	strcpy(zz,msgCustom);
	strcat(zz,msgLFNSupport);
	setoption(zz,askLFNSupport,defLFNSupport,&fLFNSupport,
			defLFNSupport[1]);
	if( fLFNSupport )
	{
		if( fRomdos71Support )
		{
			strcat(cfg_libs3,"dos7cfg7.obj+");
			strcat(cfg_libs2,"longnam7+");
		}
		else
		{
			strcat(cfg_libs3,"dos6cfg7.obj+");
			strcat(cfg_libs2,"longnam6+");
		}
	}
#endif // #if LFN_SUPPORT

	// boot ROM-DOS off floppy?
	strcpy(zz,msgCustom);
	strcat(zz,msgDiskBoot);
	setoption(zz,askDiskBoot,defDiskBoot,&locFloppy,'Y');

	// ROM-DOS on disk only questions
	if(locFloppy)
	{
		// no BIOS extension for floppy bootable ROM-DOS
		sysgenBEXT = FALSE;

		// Create super boot kernel
		//
		strcpy(zz,msgCustom);
		strcat(zz,msgCreateSuperBoot);
		setoption(zz,askCreateSuperBoot,defCreateSuperBoot,&fCreateSuperBoot,
				defCreateSuperBoot[1]);
		if( fCreateSuperBoot )
		{
#if 0
			//
			//  SEE NOTES IN ELSE CLAUS
			//

			// Boot from super boot drive
			//
			strcpy(zz,msgCustom);
			strcat(zz,msgBootFromSuperBoot);
			setoption(zz,askBootFromSuperBoot,defBootFromSuperBoot,
					&fBootFromSuperBoot,	defBootFromSuperBoot[0]);
#else
			//  BT 12-17-1999
			//
			//  After discussing this question with Jamie, I decided to
			//  remove the question.  In the question (above), the user
			//  has the option of loading only the kernel from the
			//  SuperBoot drive.  After the kernel is loaded it continues
			//  to load the config.sys, autoexec.bat, and command.com from
			//  what would be the normal boot drive if SuperBoot were not
			//  there.  Unless of course you answered that you wanted the
			//  SuperBoot drive to appear as the first DOS drive letter
			//  in the next question in which case it would not matter.
			//
			//  This was removed because ROMDOS has a problem loading MSDOSs
			//  command.com.  So if a user setup a SuperBoot drive with
			//  a SuperBoot kernel to appear as the last drive letter in the
			//  DOS drive ordering and to not use the system files from the
			//  SuperBoot partition, and an WIN95 was installed on the normal
			//  boot drive, ROMDOS would probably hang when trying to load
			//  command.com if the user used the SuperBoot hotkey.
			//
			//  The only reason I could ever see this feature being useful
			//  is if a customer was using our latest ROMDOS release on
			//  the normal boot drive and had the previous customer tested
			//  release as a backup kernel on the SuperBoot drive.  This
			//  way if there customer had a problem they could go back to
			//  the previous version of ROMDOS.  No such case exists at
			//  this time and the build question would only seem to confuse
			//  a developer building a romdos SuperBoot kernel.
			//
			fBootFromSuperBoot = TRUE;
#endif
			// Super boot drive order
			//
			strcpy(zz,msgCustom);
			strcat(zz,msgSuperBootDriveOrder);
			getoption(zz,askSuperBootDriveOrder,defSuperBootDriveOrder,
					&cSuperBootDriveOrder );

			//  Get the super boot partition ID
			//
			strcpy(zz,msgCustom);
			strcat(zz,msgSuperBootID);
			w1 = win_showatrow(3,zz);
			sprintf( szSuperBootID, "%0X", win_getpartid( askSuperBootID,
					defSuperBootID ) );
			win_close(w1);
			sprintf( zz, "%sh", szSuperBootID );
			add_option(askSuperBootID, zz);
		}

		// always believe the FAT count in the BPB?
		//
		setoption(msgTrustMe,askTrustMe,defTrustMe,&sysgenTRUSTME,'Y');

		// include the ROM disk?
		setoption(msgExcludeROMDISK,askExcludeROMDISK,
			defExcludeROMDISK,&sysgenNOROM,'N');

		if(!sysgenNOROM)
			romdisk_searchseg();

		// include the Generic Disk?
		setoption(msgIncludeGeneric,askIncludeGeneric,
			defIncludeGeneric,&sysgenGENERIC,'Y');
	}

	// ROM-DOS in ROM only questions
	else
	{
		sysgenBEXT  = TRUE;		// ROM-DOS gets control via BIOS extension
		sysgenNOROM = sysgenGENERIC = FALSE;

		// Copy ROM-DOS to RAM?
		w1 = win_showatrow(3,msgRamCopy);
		w2 = win_question(askRamCopy,defRamCopy,&c);
		add_option(askRamCopy,strof(c));
		win_close(w2);
		win_pick(w1);
		sysgenRAMBOOT = 0;
		if(c == 'Y')
		{
			locDataStart = sysgenRAMBOOT =
				win_getsegment(msgRamCopySeg,locDataStart);
			add_option(msgRamCopySeg,strof(sysgenRAMBOOT));
		}
		win_close(w1);

		// where shall ROM-DOS code reside?
//		if(sysgenRAMBOOT)
//			w1 = win_showatrow(3,msgCopyCodeAddress);
//		else
//			w1 = win_showatrow(3,msgCodeAddress);
// 		locCodeStart = win_getsegment(askCodeAddress,locCodeStart);
//		add_option(askCodeAddress, strof(locCodeStart));
//		win_close(w1);

		// don't ask for data address if ROM-DOS is copied to RAM
		if(!sysgenRAMBOOT)
		{
			// where shall ROM-DOS data reside?
			w1 = win_showatrow(3,msgDataAddress);
			locDataStart = win_getsegment(askDataAddress,locDataStart);
			add_option(askDataAddress, strof(locDataStart));
			win_close(w1);
		}

		// Can floppy DOS superscede DOS in ROM?
		setoption(msgSuperscede,askSuperscede,defSuperscede,&sysgenFLOPCHK,'Y');

		// exclude floppy/hard disk driver
		setoption(msgNoFlop,askNoFlop,defNoFlop,&sysgenNOFLOP,'N');
		if(!sysgenNOFLOP)
		{
			// always believe the FAT count in the BPB?
			//
			setoption(msgTrustMe,askTrustMe,defTrustMe,&sysgenTRUSTME,'Y');
		}

		// include the Generic Disk?
		setoption(msgIncludeGeneric,askIncludeGeneric,
			defIncludeGeneric,&sysgenGENERIC,'Y');

		// if we have the floppy or Generic, it's OK to exclude the ROM-DISK
		if(!sysgenNOFLOP || sysgenGENERIC)
			setoption(msgExcludeROMDISK,askExcludeROMDISK,
				defExcludeROMDISK,&sysgenNOROM,'N');
		if(!sysgenNOROM)
			romdisk_searchseg();

		// Read CONFIG.SYS from Drive or Device?
		setoption(msgBootDrive,askBootDrive,defBootDrive,&sysgenBOOTDRV,'Y');

		// Boot from particular drive letter
		if(sysgenBOOTDRV)
		{
			w1 = win_showatrow(3,msgBootDrive);
			w2 = win_question(askBootDriveLetter,
				defBootDriveLetter,&c);
			win_close(w2);
			win_close(w1);
			sysgenBOOTDRV = c - 'A' + 1;
			add_option(askBootDriveLetter, strof(c));
		}

		// Read CONFIG.SYS from device (ROM, Floppy or Hard)
		else
		{
			w1 = win_showatrow(3,msgBootDrive);
			w2 = win_question(askBootDevice,defBootDevice,&c);
			if(sysgenNOFLOP && c!='R')
			{
				custom_section(warnBootDevice);
				c = 'R';
			}
			if(c == 'F')
				sysgenBOOTDEV = 1;		// Code for Floppy (in SYSGEN)
			else if(c == 'H')
				sysgenBOOTDEV = 0x80;	// Code for Hard Drive (in SYSGEN)
			else if(c == 'R')
				sysgenBOOTDEV = 0x10;	// Code for ROM-DISK (in SYSGEN)
			win_close(w2);
			win_close(w1);
			add_option(askBootDevice, strof(c));
		}

	}	// enclosed questions are only for ROM-DOS in ROM

#if LFN_SUPPORT
	if( !fLFNSupport )
	{
		// config.sys level (None, DOS 3, 5 or 6)
		ask_config_level();
	}
#else
	// config.sys level (None, DOS 3, 5 or 6)
	ask_config_level();
#endif

	// does user want boot diagnostics?
	setoption(msgBootDiag,askBootDiag,defBootDiag,&sysgenBCHECK,'Y');

	// does user want boot menu?
	setoption(msgBootMenu,askBootMenu,defBootMenu,&sysgenBOOTMENU,'Y');

	// does user want to use RTC instead of ticks?
	setoption(msgRealTime,askRealTime,defRealTime,&sysgenUSERTC,'Y');

	// What kind of file for PROM burner?  Ignored for disk bootable ROM-DOS
	if(!locFloppy)
	{
		// will this be a binary or Intel HEX file?
		setoption(msgBinary,askBinary,defBinary,&locIntelHex,'H');

		// use extended addresses?
		if(locIntelHex)
			setoption(msgExtended,askExtended,defExtended,&locExtendedAddress,'Y');

		// will this be a split ROM or not
		setoption(msgSplit,askSplit,defSplit,&locSplitRoms,'Y');
	}

	// display all the options chosen and give user a change to change 'em
	if(options_do_over())
		goto again;
}

void process_args(int argc,char *argv[])
{
	int i;

	for(i=1; i<argc; ++i)
	{
		char * arg = argv[i];

		while(*arg)
		{
			if(*arg == '?')
				goto show_help;

			if(*arg == '/' || *arg == '-')
			{
				switch(toupper(arg[1]))
				{
					case '?':
					case 'H':
						goto show_help;

					// Build location file only; don't build ROM-DOS.SYS
					case 'L':
						optBuild = FALSE;
						break;

					// Use Microsoft Tools (Default)
					case 'M':
						optBorlandTools = FALSE;
						break;

					// No color, in case of monochrome systems
					case 'N':
						optNoColor = TRUE;
						break;

					// Use Turbo Tools
					case 'B':
						optBorlandTools = TRUE;
						break;

					// Pause after running each program
					case 'P':
						optPause = TRUE;
						break;

					// tty mode, no "win" stuff
					case 'T':
						optTTY = TRUE;
						break;

					default:
						printf("Error: Bad option '/%c'\n", arg);
show_help:			printf(usage);
						exit(1);
				}
				arg += 2;
			}
			else
				++arg;
		}
	}
}


/*
	make the location file
*/
void mk_loc_file(unsigned code_st, unsigned long size, unsigned data_st)
{
	FILE *fp;
	time_t tt;

	fp = fopen("ROM-DOS.LOC", "w");
	if(fp == NULL)
		win_errorout(msgCreateLocFailed);

	// record data and time of this LOCation file
	tt = time(NULL);
	fprintf(fp, "#\n# ROM-DOS Location file created on %s#\n\n", ctime(&tt));

	if(!locIntelHex)
		fprintf(fp, "/INF\t\t# Binary Image file requested, no fill\n");
	else if(!locExtendedAddress)
		fprintf(fp, "/E\t\t# No Extended Addressing in the Intel HEX file\n");

	if(locSplitRoms)
		fprintf(fp, "/S\t\t# Split ROMs for 16 bit bus\n");

	if(sysgenBEXT)
		fprintf(fp, "/B\t\t# checksum the BIOS extension\n");

	fprintf(fp, "ROM-DOS,\nROM-DOS,\n,\n\n");
	fprintf(fp, "BIOSEXT  @ 0x%04X    +\n",code_st);
	fprintf(fp, "CODE     @ $         +\n");
	fprintf(fp, "DEVDATA  @ $(0x%04X) +\n", data_st);
	fprintf(fp, "FAR_DATA @ $($)      +\n");
	fprintf(fp, "DATA     @ $($)      +\n");
	fprintf(fp, "CONST    @ $($)      +\n");
	fprintf(fp, "MSG      @ $($)      +\n");
	fprintf(fp, "BSS      @  ($)      +\n");
	fprintf(fp, "HEAP     @  ($) ,\n\n");
	fprintf(fp, "%lu ROM   @ 0x%04X +\n", size, code_st);
	fprintf(fp, "64K RAM  @ 0x%04X\n", data_st);

	fclose(fp);
}

/*
	Find the byte offset of the named segment.  Assumes that
	offset is less than 64K.
*/
unsigned long find_segment_value(char *exe_name, char *seg_name)
{
	FILE *fp;
	char line[133];
	char map_name[65];
	int got_a_line= FALSE;
	unsigned long seg;

	// Open the MAP file
	strcpy(map_name, exe_name);
	mk_ext(map_name, "MAP");
	fp = fopen(map_name, "r");
	if(fp == NULL)
	{
		sprintf(zz,"Cannot open '%s'\n", map_name);
		win_errorout(zz);
	}

	// Make sure the name segment name is upper case
	strupr(seg_name);

	do
	{
		fgets(line, sizeof(line), fp);
		if(feof(fp))
		{
			fclose(fp);
			return -1;
		}
	} while(!strfnd(line, "Start"));

	got_a_line = FALSE;			// Don't have any seg lines

	do
	{
		fgets(line, sizeof(line), fp);
		if(!got_a_line && strlen(line) > 3)
			got_a_line = TRUE;
		if(feof(fp) || ((strlen(line) < 3) && got_a_line))
		{
			fclose(fp);
			return -1;
		}
	} while(!strfnd(line, seg_name));
	sscanf(line, "%lX", &seg);
	seg >>= 4;
	fclose(fp);
	return seg;
}


/*
 * strfnd Finds a sub string in a larger string.
 *
 * str1 = large string
 * Str2 = sub string
 * Return
 *	1 = Sub string found
 *	0 = Sub NOT string found
 */
int strfnd(char *str1, char *str2)
{
	int len = strlen(str2);
	while(*str1)
	{
		if(strncmp(str1, str2, len) == 0)
			return 1;
		 ++str1;
	}
	return 0;
}



/*
 * Build a file name from a path and a extension.
 * Watch out for "..\file.abc" and ".\..\..\prog.exe"
 * The user must make sure that fname is big enough
 * to handle the fname + ext.
 */
void mk_ext(char *fname, char *ext)
{
	char *p;
	*(fname + strlen(fname) + strlen(ext)) = '\0';
	p=fname+strlen(fname)-1;
	while(p >= fname)
	{
		if(*p == '.')			// already an extension
		{
			strcpy(p+1, ext);
			return;
		}
		else if(*p == '\\')
			goto add_ext;
		else
			;			// do nothing
		--p;
	}
add_ext:
	strcat(fname, ".");
	strcat(fname, ext);
}

int linelen(char *str)
{
	int len = 0;
	while(*str && *str!='\n')
		++str, ++len;
	return len;
}

void dimensions(char *str, int * pHeight, int * pWidth)
{
	int len;

	*pHeight = 1;
	*pWidth  = 0;
	while(*str)
	{
		len = linelen(str);
		if(len > *pWidth)
			*pWidth = len;
		str += len;
		if(*str == '\n')
			++str, ++(*pHeight);
	}
	*pWidth += 4;
}

unsigned atoh(char *s)
{
	char c;
	unsigned val = 0;
	while(isxdigit(*s))
	{
		c = toupper(*s);
		val = (val * 0x10) + ((c>='0' && c<='9') ? c-'0' : c-'A'+10);
		++s;
	}
	return val;
}


/*
	[]-------------------------------------------[]
	 |                                           |
	 |           Window Handling                 |
	 |                                           |
	[]-------------------------------------------[]
*/

/*
	Exit the program.
*/
void win_exit(int n)
{
	void * w;

	// just exit w/ TTY mode
	if(optTTY)
		exit(n);

	// make the screen look decent
	w = w_getpicked();
	w_pickbackdrop();
	w_setattr(mkattr(WHITE,BLACK));
	w_clrall();
	w_goto(0,0);
	if(!n)
	{
		w_pick(w);
		win_flush();
		w_getbackdrop();
		w_pickbackdrop();
		w_goto(22,0);
	}
	w_updatecursor();

//  BT 12-1-99
//
//  Conversion the BC 5.2 discovered this bug.  We were using memory
//  that had been freed.
//

//  ... and free the memory
//
	w_closeall();

// We just freed the memory.  We can't flush the video buffers!
//
//	win_flush();

	// close the recording file
	if( recfp )
		fclose(recfp);

	exit(n);
}

/*
  There has been an error.  Display it.
*/
void * win_error(char *str)
{
	int height, width;
	int row, col;
	void * w = 0;

	if(!optTTY)
	{
		// determine size of window
		dimensions(str,&height,&width);

		// center the window exactly on the screen
		row = (w_screenrows() - (height+2)) / 2;
		col = (w_screencols() - (width+2)) / 2;

		// prepare a window for the message
		w = w_open(row,height,col,width,W_FIXED);
		w_setattr(colorError);
	}

	// display the message
	win_message(str);

	return w;
}

/*
	Error out.  This will display the error message and wait
	for a keypress.
*/
void win_errorout(char *str)
{
	static char exitmsg[] = "\n\nPress any key to exit.\n";

	// tack on our error message
	if(str != zz)
	{
		strcpy(zz,str);
		str = zz;
	}
	strcat(str,exitmsg);

	// display the message
	win_error(str);

	// wait for a keypress
	win_getkey();
	win_exit(1);
}

/*
	Display the message in the current window.
*/
void win_message(char *str)
{
	int row = 0;
	int col;

	// TTY mode doesn't need to do anything so fancy
	if(optTTY)
	{
		printf("%s",str);
		return;
	}

	// all messages have frames and shadows
	w_setframe(W_DFRAME);
	w_setborderattr(w_getattr());
	w_setshadow(1);
	w_clrall();

	// display the message
	while(*str)
	{
		// determine position of this line
		int len = linelen(str);
		col = (w_getcols() - len) / 2;
		w_goto(row, col);

		// display the line
		char * p = str+len;
		int end = (*p == 0);
		if(!end)
			*p = 0;
		w_puts(str);
		if(!end)
			*p++ = '\n';

		// next line
		++row;
		str = p;

		// so cursor ends up on last piece of text
		if(*str == 0)
			w_updatecursor();
	}
}

/*
	Get a key, checking for esc to exit.
*/
char win_checkkey(void)
{
	char c;
	do
	{
		c = win_getkey();
		if(c == ESC)
			win_checkexit();
	} while(c == ESC);
	return c;
}

/*
	Does user really want to exit?
*/
void win_checkexit(void)
{
	void * oldw;
	int row, col;
	void * wtmp;
	char c;

	// remember the present window state
	if(!optTTY)
	{
		oldw = w_getpicked();
		row = w_getrow();
		col = w_getcol();
	}

	// display the exit message
	if(optTTY)
		printf(msgExit2);
	else
		wtmp = win_error(msgExit);

	// does user want to exit?
	c = win_getkey();
	if(optTTY)
		printf("%c",c);
	if(toupper(c) == 'Y')
		win_exit(1);
	win_close(wtmp);

	// set things back to how they were
	if(!optTTY)
	{
		w_pick(oldw);
		w_goto(row,col);
		w_updatecursor();
		win_flush();
	}
}

/*
	Create a question window.  Ask a 1 character question.
	Example:
		Quick or Custom Build? Q
*/
void * win_question(char *str, char *choices, char *pick,int startrow)
{
	int row;
	int col;
	int oldColor;
	void * w, * wtmp;
	char c;

	// ask the question
	w = win_showatrow(startrow, str);

	if(!optTTY)
	{
		row = w_getrow();
		col = w_getcol();
		oldColor = w_getattr();
	}

	// get the answer
	*pick = *choices;

	// display default response
	if(optTTY)
		printf("%c",*pick);

	while(1)
	{
		// display default response
		if(!optTTY)
		{
			w_pick(w);
			w_setattr(colorQuestion);
			w_goto(row,col);
			w_updatecursor();
			w_putc(*pick);
		}

		// get user response
		c = win_getkey();
		if(c == '\r' || c == '\n')
			c = *pick;
		c = toupper(c);

		// display user response
		if(optTTY)
			printf("\010%c\n",c);
		else
		{
			w_goto(row,col);
			w_putc(c);
			w_setattr(oldColor);
		}

		// does user want to exit the program?
		if(c == ESC)
			win_checkexit();

		// if not a valid choice, say so!
		else if(!strchr(choices,c))
		{
			sprintf(zz,msgNotValid, choices);
			wtmp = win_error(zz);
			if(!optTTY)
				win_getkey();
			win_close(wtmp);
		}

		else
		{
			*pick = c;
			break;
		}
	}

	return w;
}

/*
	Get a segment value (0-FFFFH) from the user.
*/
unsigned win_getsegment(char * msg, unsigned defval)
{
	void * w = 0;
	unsigned val;
	char s[20];

	// get user response
	while(1)
	{
		// build the message
		sprintf(s,"%X",defval);
		sprintf(zz,"%s [%s]: ",msg,s);

		// display the message
		if(optTTY)
			printf(zz);
		else
		{
			w = w_open(18,1,(w_screencols() - (strlen(zz)+7)) / 2,
				strlen(zz)+7,W_FIXED);
			w_setattr(colorWindow);
			w_setframe(W_DFRAME);
			w_setborderattr(w_getattr());
			w_setshadow(1);
			w_clrall();
			w_goto(0,1);
			w_puts(zz);
		}

		// display the current choice
		if(!optTTY)
		{
			w_pick(w);
			w_updatecursor();
			win_flush();
		}

		// get user's choice
		win_getstring(s,5);
		val = atoh(s);

		// don't allow user to accidentally locate ANYthing over the
		// interrupt vector table (0000:0 - 0040:0)
		if(val < 0x40 && !win_ignorewarning(msgVectorTable))
		{
			win_close(w);
			continue;
		}
		else
		{
			win_close(w);
			break;
		}
	}

	return val;
}

/*
	Get a partition id value (0-FFH) from the user.
*/
unsigned char win_getpartid(char * msg, unsigned char defval)
{
	void * w = 0;
	unsigned char val;
	char s[20];

	// get user response
	while(1)
	{
		// build the message
		sprintf(s,"%X",defval);
		sprintf(zz,"%s [%s]: ",msg,s);

		// display the message
		if(optTTY)
			printf(zz);
		else
		{
			w = w_open(18,1,(w_screencols() - (strlen(zz)+7)) / 2,
				strlen(zz)+7,W_FIXED);
			w_setattr(colorWindow);
			w_setframe(W_DFRAME);
			w_setborderattr(w_getattr());
			w_setshadow(1);
			w_clrall();
			w_goto(0,1);
			w_puts(zz);
		}

		// display the current choice
		if(!optTTY)
		{
			w_pick(w);
			w_updatecursor();
			win_flush();
		}

		// get user's choice
		win_getstring(s,3);
		val = atoh(s);

		//
		win_close(w);
		switch( val )
		{
			case 0x01:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x0b:
			case 0x0c:
			case 0x0e:
			case 0x0f:
				win_iderror( szReservedPartitionID );
				continue;

			default:
				break;
		}

		break;
	}

	return val;
}

/*
	Display a message at the given row.
*/
void * win_showatrow(int row, char *str)
{
	void * w;
	int height, width;
	int col;

	if(!optTTY)
	{
		// determine size of window
		dimensions(str,&height,&width);

		// center the window exactly on the screen
		col = (w_screencols() - (width+2)) / 2;

		// prepare a window for message
		w = w_open(row,height,col,width,W_FIXED);
		w_setattr(colorWindow);
	}

	// display the message
	win_message(str);

	return w;
}

/*
	Get a key.  This may be from the keyboard or a file.
*/
char win_getkey(void)
{
	char s[2];

	win_flush();
	char c = StdinGetKey();
	s[0] = c;
	s[1] = '\0';
	if(recfp)
		fputc(c, recfp);
	return c;
}

/*
	Get a string from the user.  Understands backspace only
	for editing.  Must be passed a 0 terminated string.
*/
void win_getstring(char *str, int maxlen)
{
	int row, col;
	int firsttime = TRUE;
	int len = strlen(str);
	int i;

	// remember original position
	if(!optTTY)
	{
		row = w_getrow();
		col = w_getcol();
	}

	while(1)
	{
		char c;

		// display the string field
		if(optTTY)
		{
			printf("%s",str);
			for(i=len; i<maxlen; ++i)
				printf(" ");
			for(i=len; i<maxlen; ++i)
				printf("\010");
		}
		else
		{
			w_goto(row,col);
			w_setattr(colorQuestion);
			w_puts(str);
			for(i=len; i<maxlen; ++i)
				w_putc(' ');
			w_goto(row,col+(firsttime ? 0 : len));
			w_updatecursor();
		}

		// get a character from the user
		c = win_checkkey();

		if(optTTY)
			for(i=0; i<len; ++i)
				printf("\010");

		// we are done, return the string
		if(c == '\n' || c== '\r')
			break;

		// backspace if we can
		if(c == BS && len)
			str[--len] = 0;

		// got a character, add it in if we can
		c = toupper(c);
		if(c >= ' ' && c <= '~')
		{
			if(firsttime)
				len = 0;
			if((len+1) < maxlen)
			{
				str[len++] = c;
				str[len] = 0;
			}
		}

		firsttime = FALSE;
	}
}

/*
	Spawn a sub-program (like TASM or TLINK).
*/
void win_spawn(char * name, char * cmdline)
{
	int ret;
	int row = 0;
	void * w;

	// prepare for the spawn
	if(!optTTY)
	{
		w_pickbackdrop();
		w_clrall();
	}

	// show what we are executing
	sprintf(zz,"Executing-> %s %s",name,cmdline);
	if(optTTY)
		printf("%s\n",zz);
	else
	{
		// string might be REALLY long
		while(strlen(zz) >= 78)
		{
			char c;
			w_goto(row++,0);
			c = zz[78];
			zz[78] = 0;
			w_puts(zz);
			zz[78] = c;
			strcpy(zz,zz+78);
		}
		w_goto(row++,0);
		w_puts(zz);

		// make sure use can see the info
		w_goto(row,0);
		w_updatecursor();
		win_flush();
	}

	ret = spawnlp(0, name, name,  cmdline, 0);
	if(ret)
	{
		if(!optTTY)
			w_getbackdrop();
		if(ret < 0)
			sprintf(zz,msgNoSpawn,name);
		else
			sprintf(zz,msgSpawnFailed,name);

		// program failed, explain why
		strcat(zz,msgRecord);
		if(optTTY)
			win_errorout(zz);
		else
		{
			w = win_error(zz);			// display the message
			win_getkey();				// wait for a keypress
			w_close(w);
			w_pickbackdrop();
			w_goto(22,0);
			w_flush();
			w_updatecursor();
			exit(1);					// exit build
		}
	}

	// clear the backdrop again
	if(!optTTY)
		w_getbackdrop();
	if(optPause)
		win_checkkey();
	if(!optTTY)
		w_clrall();
}

/*
	Ask user if s/he wants to ignore the warning.
*/
int win_ignorewarning(char *msg)
{
	void * w;
	int ignore;
	if(msg != zz)
	{
		strcpy(zz,msg);
		msg = zz;
	}
	strcat(msg,msgWarnContinue);
	w = win_error(msg);
	char c = win_checkkey();
	if(optTTY)
		printf("%c",c);
	ignore = (toupper(c) == 'Y');
	win_close(w);
	return ignore;
}

/*
	Ask user if s/he wants to ignore the warning.
*/
void win_iderror(char *msg)
{
	void * w;

	if(msg != zz)
	{
		strcpy(zz,msg);
		msg = zz;
	}
	strcat(msg,msgPressKey);
	w = win_error(msg);
	win_checkkey();
	win_close(w);
}

void win_close(void * w)
{
	if(!optTTY)
		w_close(w);
}

void win_flush(void)
{
	if(!optTTY)
		w_flush();
}

void win_pick(void * w)
{
	if(!optTTY)
		w_pick(w);
}
