//
//   $Id: DVKEY.H 1.4 2002/10/15 20:06:44Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	DVKEY.H  created  09/28/91

   Copyright (c) 1991-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

*********************************************************/

/* common control keys */
#define keyCtrl(cc) ((cc) - '@')

const int keyCtrlBS 	= 127;
const int keyCtrlCR		= 10;
const int keyEsc  		= 27;
const int keyCtrlC = ('C'-'@');
const int keyCtrlD = ('D'-'@');
const int keyCtrlE = ('E'-'@');
const int keyCtrlG = ('G'-'@');
const int keyCtrlK = ('K'-'@');
const int keyCtrlL = ('L'-'@');
const int keyCtrlN = ('N'-'@');
const int keyCtrlO = ('O'-'@');
const int keyCtrlS = ('S'-'@');
const int keyCtrlU = ('U'-'@');
const int keyCtrlW = ('W'-'@');
const int keyCtrlX = ('X'-'@');
const int keyCtrlZ = ('Z'-'@');

/* special keys */
const int keyIns   = 194;
const int keyDel   = 195;

/* function keys */
const int keyF1		= 171;
const int keyF2		= 172;
const int keyF3		= 173;
const int keyF4		= 174;
const int keyF5		= 175;
const int keyF6		= 176;
const int keyF7		= 177;
const int keyF8		= 178;
const int keyF9		= 179;
const int keyF10		= 180;
const int keyShiftF1	= 196;
const int keyCtrlF1		= 206;
const int keyAltF1		= 216;
const int keyAltF3		= (keyAltF1+2);
const int keyAltF4		= (keyAltF1+3);
const int keyAltF7		= (keyAltF1+6);
const int keyAltF8		= (keyAltF1+7);

const int keyAlt1		= 232;		/* Alt2 = Alt1+1, etc... */
const int keyAlt0		= 241;

const int keyAltA		= 142;		/* AltS = AltA+1, etc... */
const int keyAltQ		= 128;		/* AltW = AltQ+1, etc... */
const int keyAltZ		= 156;		/* AltX = AltZ+1, etc... */
const int keyAltB		= keyAltZ+4;
const int keyAltC		= keyAltZ+2;
const int keyAltD		= keyAltA+2;
const int keyAltE		= keyAltQ+2;
const int keyAltF		= keyAltA+3;
const int keyAltG		= keyAltA+4;
const int keyAltH		= keyAltA+5;
const int keyAltI		= keyAltQ+7;
const int keyAltJ		= keyAltA+6;
const int keyAltK		= keyAltA+7;
const int keyAltL		= keyAltA+8;
const int keyAltM		= keyAltZ+6;
const int keyAltN		= keyAltZ+5;
const int keyAltO		= keyAltQ+8;
const int keyAltP		= keyAltQ+9;
const int keyAltR		= keyAltQ+3;
const int keyAltS		= keyAltA+1;
const int keyAltT		= keyAltQ+4;
const int keyAltU		= keyAltQ+6;
const int keyAltV		= keyAltZ+3;
const int keyAltW		= keyAltQ+1;
const int keyAltX		= keyAltZ+1;
const int keyAltY		= keyAltQ+5;

/* cursor keys */
const int keyHome  = 183;
const int keyUp    = 184;
const int keyPgUp  = 185;
const int keyLeft  = 187;
const int keyRight = 189;
const int keyEnd   = 191;
const int keyDown  = 192;
const int keyPgDn  = 193;
const int keyCtrlLeft  = 227;
const int keyCtrlRight = 228;
const int keyCtrlEnd   = 229;
const int keyCtrlPgDn  = 230;
const int keyCtrlHome  = 231;
const int keyCtrlPgUp  = 244;

const int keyAltMinus = 242;
const int keyAltEquals = 243;

// the following are only available through "morekeys.com"
// note: these should be moved - Alt F8-Alt F10 use these values
const int keyCtrlUp				= 253;
const int keyCtrlCenter			= 255;
const int keyCtrlDown			= 257;
const int keyCenter				= 188;
const int keyCtrlIns				= 258;
const int keyCtrlDel				= 259;

const int keyShiftIns			= 260;
const int keyShiftDel 			= 261;
const int keyShiftLeft			= 262;
const int keyShiftRight			= 263;
const int keyShiftEnd			= 264;
const int keyShiftHome			= 265;
const int keyShiftDown			= 266;
const int keyShiftUp				= 267;
const int keyShiftPgDn			= 268;
const int keyShiftPgUp			= 269;
const int keyShiftCtrlLeft		= 270;
const int keyShiftCtrlRight	= 271;
const int keyShiftCtrlEnd		= 272;
const int keyShiftCtrlHome		= 273;
const int keyShiftCtrlDown		= 274;
const int keyShiftCtrlUp		= 275;
const int keyShiftCtrlPgDn		= 276;
const int keyShiftCtrlPgUp 	= 277;
const int keyShiftCenter		= 278;

const int keyBS	= 280;
const int keyTab	= 281;
const int keyCR	= 282;
const int keyBackTab = 283;
const int keyAlt   = 284;
const int keyBreak = 286;
