//
//   $Id: GETKEY.CPP 1.3 2002/10/15 20:06:44Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1991-2001 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <assert.h>

#if defined(__BORLANDC__)
	#if(__BORLANDC__ < 0x500)
#include "datalght.h"
	#endif
#endif

#include "getkey.h"

#define ZF			0x40

typedef unsigned char uchar;
//typedef int	bool;

bool IsCharDevice( int fd )
{
	union REGS regs;

	regs.x.ax = 0x4400;
	regs.x.bx = fd;
	intdos( &regs, &regs );

	assert( !regs.x.cflag );

	return (regs.x.dx & 0x80) == 0x80;
}

uchar StdinGetKey( void )
{
	union REGS regs;
	uchar c;

	if( IsCharDevice( FD_STDIN ) )
	{
		c = bdos( 7,0,0 );		  // Wait-for-key input
	} else
	{
		regs.h.ah = 6;
		regs.h.dl = 0xff;
		intdos(&regs, &regs);
		if( regs.x.flags & ZF )
		{
			clrscr();
//			printf( "Unexpected end of input file!\n" );
			exit( 5 );
		} else
		{
			c = regs.h.al;
		}
	}
	return c;
}

#if UNIT_TEST
void main( void )
{
	printf( "Press any key to continue..." );
	putch( StdinGetKey());
}
#endif