//
//   $Id: WIN.H 1.4 2002/10/15 20:06:44Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	Window library for Borland C/C++
   Copyright (c) 1995-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/

/* public definitions */

#if !defined(WIN_H)
#define WIN_H 1
enum colors
{
	BLACK,	BLUE,		GREEN,	CYAN,		RED,		MAGENTA,		BROWN,	WHITE,
	GRAY,		LTBLUE,	LTGREEN,	LTCYAN,	LTRED,	LTMAGENTA,	YELLOW,	LTWHITE
};
typedef enum {W_VARIABLE,W_FIXED} wtype;
typedef enum {W_NOFRAME,W_SFRAME,W_DFRAME} wframe;
typedef enum {W_BORDER,W_WRAP,W_SCROLL,W_VISIBLE} style;
typedef enum {W_MODEMONO=7,W_MODECO80=3,W_MODEBW80=2} wmode;
typedef unsigned word;

#if defined(__BORLANDC__)
	#if(__BORLANDC__ < 0x500)
typedef int bool;
	#endif
#endif

enum {FALSE,TRUE};

#define mkword(c,attr)	(((attr)<<8) | (unsigned char)(c))
#define mkattr(fg,bg)	(((bg)  <<4) | (fg))

bool	w_init(void);
void	*w_open(int top,int rows,int left,int cols,wtype type);
void	w_closeall(void);
void	w_close(void *win);
void	w_pick(void *win);
void	w_pickbackdrop(void);
void  w_getbackdrop(void);
void	*w_getpicked(void);

void	w_setsize(int rows,int cols);
void	w_move(int top,int left);
void	w_front(void);
void	w_flush(void);

void	w_goto(int row,int col);
void	w_getcursor(int *row, int *col);
void	w_setcursor(int row, int col);
int	w_getrow(void);
int	w_getcol(void);
void	w_updatecursor(void);
void	w_puts(char *s);
void	w_puti(int i);
void	w_putc(char c);

void	w_clrall(void);
void	w_clrpart(int top,int rows,int left,int cols);
void	w_clreol(void);

int	w_screenrows(void);
int	w_screencols(void);

int	w_getmode(void);
int	w_morelines(void);
int	w_25lines(void);

int	w_getrows(void);
int	w_getcols(void);

int	w_getattr(void);
int	w_setattr(int newattr);

int	w_getborderattr(void);
int	w_setborderattr(int newattr);
void	w_setshadow(bool set);
int	w_setframe(wframe frame);

int	w_getkey(void);
int	w_pollkey(void);

void	w_putblock(void *win,void *buffer,int top,int rows,int left,int cols);

void	w_fillall(char c);
void	w_fillpart(int top,int rows,int left,int cols,char c);

void	w_attrall(int newattr);
void	w_attrpart(int top,int rows,int left,int cols,int newattr);

void	w_scrollall(bool down);
void	w_scrollpart(int top,int rows,int left,int cols,bool down);

void	*w_malloc(int size);
void	w_free(void *p);

#endif
