REM
REM   $Id: build71.bat 1.64 2003/03/20 20:18:10Z thomd Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo off
REM
REM  BUILD71.BAT
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM
REM  HISTORY
REM   05/03/2001 jmb fixed a problem with the NED_DIR if DL_ROOT is set.
REM   04-12/2001 jmb modified NED and PROTO copy paths if DL_ROOT is set
REM

set bldlog=
if NOT "%buildlog%"=="" goto start
set buildlog=..\build.log
set bldlog=1


:start


REM Create the release tree directory
REM
if exist testing\71\nul deltree /y testing\71
if exist release\71\nul deltree /y release\71
if not exist release\nul md release
if not exist testing\nul md testing
md release\71
md release\71\devsrc
md release\71\docs
md release\71\examples
md release\71\include
md release\71\lib
md release\71\memdisk
md release\71\minicmd
md release\71\options
md release\71\options\386max
md testing\71


REM Build TOOLS first
REM
call setdeb release 32
echo Building Required Tools...
cd bin\source
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM
REM Build TOOLS used to make a ROMDOS release
REM

echo Building BIN...
cd bin
make -B >>%buildlog%
cd ..
%DEBUGCMD%


REM
REM  Build ROMDOS Libraries
REM

rem goto nolibbld
echo Building Library Code...
cd lib
if exist *.lib del *.lib
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..
%DEBUGCMD%
:nolibbld


REM
REM  Build romdos binaries
REM


call setdeb release 32


echo Building ROMDOS kernel
cd kernel
if exist makefile make -B >>%buildlog%
cd ..


call setdeb release 32


echo Building BUILD.EXE
cd build
if exist makefile make -B >>%buildlog%
call makelibs
cd ..


echo Building default 7.1  release kernel
cd build
echo.>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
@if exist build.bat del build.bat
build <build.key
cd ..


call setdeb release 32


echo Building LFN command
cd command
if exist makefile make -B command.com >>%buildlog%
cd ..


echo Building LFN utilities...
cd utils
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


echo Building non-LFN utilities...
cd nonlfn
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


call setdeb release 32


echo Building drivers
cd drivers
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


echo Building memdisk
cd memdisk
if exist makefile make -B >>%buildlog%
cd ..


echo Building minibios
cd minibios
if exist makefile make -B >>%buildlog%
cd ..


echo Building minicmd
cd minicmd
if exist makefile make -B >>%buildlog%
cd ..


REM
REM  Copy the files to the release tree
REM


REM root directory
REM
copy build\rom-dos.sys release\71
copy bin\compress.exe release\71
copy bin\loc.exe release\71
copy build\build.exe release\71
if exist build\user.lib del build\user.lib
copy build\*.lib release\71
if exist build\devfdhd*.obj del build\devfdhd*.obj
if exist build\sysgen.obj del build\sysgen.obj
copy build\*.obj release\71










REM devsrc directory
REM
copy kernel\devfdhd.inc release\71\devsrc
copy kernel\dev*.asm release\71\devsrc
copy include\dostruct.inc release\71\devsrc
copy include\profile.inc release\71\devsrc
copy include\profile.h release\71\devsrc
copy build\devsrc.mak release\71\devsrc\makefile
copy kernel\dosignon.c release\71\devsrc
copy kernel\sysgen.asm release\71\devsrc
copy include\macros.inc release\71\devsrc
copy include\devhdr.inc release\71\devsrc
copy include\dosver.inc release\71\devsrc
copy include\dosver.h release\71\devsrc
copy include\bldver.h release\71\devsrc
copy include\bldver.inc release\71\devsrc
copy include\use186.inc release\71\devsrc


REM include directory
REM
copy include\datalght.h release\71\include
copy include\dostruct.h release\71\include
copy include\dosdef.h   release\71\include
copy include\dlint13.h  release\71\include
copy include\dl64.h     release\71\include
copy include\dllfn.h    release\71\include
copy include\fatworld.h release\71\include
copy include\windows.h  release\71\include

REM LIB directory
REM
copy lib\dlc.lib release\71\lib
copy lib\dll.lib release\71\lib
copy lib\dlm.lib release\71\lib
copy lib\dls.lib release\71\lib

REM EXAMPLES directory
REM
copy examples\example1.c   release\71\examples
copy examples\example1.mak release\71\examples
copy examples\example2.c   release\71\examples
copy examples\example2.mak release\71\examples


REM memdisk directory
REM
copy memdisk\membc.mak release\71\memdisk\makefile
copy memdisk\memdisk.asm release\71\memdisk
copy memdisk\ldrbext.asm release\71\memdisk
copy memdisk\vdisk.c release\71\memdisk
copy memdisk\raminit.c release\71\memdisk
copy memdisk\pagedldr.c release\71\memdisk
copy memdisk\pagedldr.loc release\71\memdisk
copy memdisk\memfixed.c release\71\memdisk
copy memdisk\int15pag.c release\71\memdisk
copy memdisk\dyndrvr.c release\71\memdisk
copy memdisk\memrom.c release\71\memdisk
copy memdisk\memext.c release\71\memdisk
copy memdisk\sc400pag.c release\71\memdisk
copy memdisk\mempaged.c release\71\memdisk
copy memdisk\memdisk.inc release\71\memdisk
copy memdisk\compiler.h release\71\memdisk
copy memdisk\memdisk.h release\71\memdisk
copy memdisk\vdisk.h release\71\memdisk
copy memdisk\dyndrvr.h release\71\memdisk
copy memdisk\memutil.lib release\71\memdisk


REM  minicmd
REM
copy minicmd\*.* release\71\minicmd


REM  utils
REM
copy drivers\ansi\ansi.sys release\71\ansi.sys
copy drivers\ata\ata.sys release\71\ata.sys
copy utils\attrib\attrib.exe release\71
copy nonlfn\backup\backup.exe release\71
copy drivers\cdex\mscdex.exe release\71
copy utils\chkdsk\chkdsk.exe release\71
copy utils\choice\choice.com release\71
copy command\command.com release\71
copy command\command.hlp release\71
copy drivers\country\country.sys release\71
copy utils\comm\comm.exe release\71
rem copy utils\defrag\defrag.exe release\71
copy utils\deltree\deltree.exe release\71
copy utils\disk2img\disk2img.exe release\71
copy utils\diskcomp\diskcomp.com release\71
copy utils\diskcopy\diskcopy.com release\71
copy drivers\display\display.sys release\71
copy utils\dump\dump.exe release\71
copy drivers\display\ega.cpi release\71
copy drivers\display\ega3.cpi release\71
copy drivers\emm386\emm386.exe release\71
copy utils\exe2bin\exe2bin.com release\71
copy utils\fdisk\fdisk.exe release\71
copy utils\find\find.exe release\71
copy utils\format\format.com release\71
copy drivers\himem\himem.sys release\71
copy drivers\keyb\keyb.com release\71
copy drivers\keyb\keyboard.sys release\71
copy drivers\keyb\keybrd2.sys release\71
copy utils\label\label.exe release\71
rem copy kernel\longname.txt release\71
copy utils\mem\mem.exe release\71
copy utils\mode\mode.com release\71
copy utils\more\more.com release\71
copy utils\move\move.exe release\71
copy utils\power\power.exe release\71
copy nonlfn\print\print.exe release\71
copy utils\remdisk\remdisk.exe release\71
copy utils\remdisk\remserv.exe release\71
copy utils\remdisk\remquit.com release\71
copy nonlfn\backup\restore.exe release\71
copy nonlfn\romdisk\romdisk.exe release\71
copy nonlfn\rsz\rsz.exe release\71\rsz.exe
copy nonlfn\rsz\rz.bat release\71\rz.bat
copy utils\client\serlink.exe release\71
copy utils\server\serserv.exe release\71
copy nonlfn\share\share.exe release\71
copy utils\cache\smartdrv.exe release\71
copy utils\sort\sort.exe release\71
copy drivers\stackdev\stackdev.sys release\71\stackdev.sys
copy utils\subst\subst.exe release\71
copy utils\sys\sys.com release\71
copy nonlfn\rsz\sz.bat release\71\sz.bat
copy utils\transfer\transfer.exe release\71
copy utils\tree\tree.com release\71
copy kernel\umblink.exe release\71
copy memdisk\vdisk.sys release\71
copy drivers\version\version.sys release\71
copy drivers\wx2swap\wx2swap.sys release\71
copy utils\xcopy\xcopy.exe release\71


REM  Copy in the items from devtools which are in the ROMDOS release
REM
cd release\71
set ned_dir=c:\dl\devtools\bin
if not "%dl_root%" == "" set ned_dir=%dl_root%\devtools\bin
copy %ned_dir%\ned*.*
copy %ned_dir%\proto.exe
if exist ned.cfg del ned.cfg
set ned_dir=
rem copy t:\products\devtools\testing\isfiles\common\bin\ned.exe
rem copy t:\products\devtools\testing\isfiles\common\bin\nedman.txt
rem copy t:\products\devtools\testing\isfiles\common\bin\nedremot.cfg
rem copy t:\products\devtools\testing\isfiles\common\bin\nedremot.com
rem copy t:\products\devtools\testing\isfiles\common\bin\proto.exe
cd ..\..


rem  Copy the user manuals and readme.txt into the release tree
rem
copy "rxe\RXE Theory of Operation.PDF"     release\71\docs
copy "docs\ROM-DOS Developer's Guide.pdf"  release\71\docs
copy "docs\ROM-DOS User's Guide.pdf"       release\71\docs
bin\verhdr >hdr.txt
copy hdr.txt+docs\read.me readme.tmp
copy readme.tmp release\71\docs\readme.txt
copy readme.tmp release\71\readme.txt
del readme.tmp

rem  Copy 386max into the release tree
rem
xcopy 3rdparty\386max\*.* release\71\options\386max\*.* /s


rem  Copy readme.txt into the options directory
rem
copy 3rdparty\readme.txt release\71\options


REM
REM build the files needed for the romdos test suite
REM

call setdeb release 32

echo Building DDTDISK
cd memdisk
if exist makefile make -B ddtdisk.exe >>%buildlog%
cd ..

echo Building IMAVIRUS
cd drivers\emm386
if exist makefile make -B -fmaketest.mak >>%buildlog%
cd ..\..

echo Building RDBLDNUM
cd utils\rdbldnum
if exist makefile make -B >>%buildlog%
cd ..\..

echo Building CFGTEST
cd testutil\cfgtest
if exist makefile make -B >>%buildlog%
cd ..\..

copy memdisk\ddtdisk.exe testing\71
copy drivers\emm386\imavirus.exe testing\71
copy utils\rdbldnum\rdbldnum.exe testing\71
copy utils\cache\misery.exe testing\71
copy utils\cache\commout1.dat testing\71
copy testutil\cfgtest\cfgtest.exe testing\71


REM Update the file time to reflect the version
bin\sdkver 7.10 release\71
bin\sdkver 7.10 release\71\devsrc
bin\sdkver 7.10 release\71\docs
bin\sdkver 7.10 release\71\include
bin\sdkver 7.10 release\71\lib
bin\sdkver 7.10 release\71\memdisk
bin\sdkver 7.10 release\71\minicmd
bin\sdkver 7.10 testing\71


:done
if "%bldlog%"=="1" set buildlog=
