//
//   $Id: COMDEB.C 1.6 2002/10/15 20:08:46Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:COMDEB.C

	Copyright (c) 1989-2002 Datalight, Inc.
	Datalight Confidential and Proprietary.
   All Rights Reserved.

	This module contains routines used in the DEBUG build of COMMAND.
	They are not included in the RELEASE build of COMMAND.

	$DOCHISTORY
	07/16/1998 dg  Updated to support datalght.h
	06/25/1991 dg  Created by Drew Gislason
*********************************************************************/
#define __FILENUM__ 7

// ansi includes
#include <stdio.h>

// datalight includes
#include "datalght.h"
#include "command.h"

/*
	$DOCPROC:assert

	Standard assert. This is included in both DEBUG and RELEASE
	builds, although there are very few asserts in the RELEASE build.
*/
void _assert(unsigned line)
{
	printf("Datalight Command Processor INTERNAL ERROR: %u",line);
	while(1) {}
}

#if DEBUG // {

#include <dos.h>
#include <dir.h>

#define DEBUG_FUNC 0xDB

#if !defined(ENODEB)
#define	ENODEB	0xFF
#endif

#define D_CATCH	0x08		/* mask for catch before call */
#define D_AFTER	0x10		/* mask for catch after call */
#define D_NOIO		0x80		/* no i/o trapping (ignore them) */

void PASCAL do_debug(char *args)
{
	union REGS r;
	char cmd[12];
	extern char *xdeb[];
	int i,j;

	intl_strupr(args);
	if(*args)
	{
		r.x.ax= (DEBUG_FUNC<<8) | 1;		/* set a debug option */
		r.x.dx= 0;

		while(*args)
		{
			/* get a copy of the argument */
			LFNArgCopy(cmd,args,10);
			args = nextarg(args);

			if(!isdigit(*cmd))
				for(i=0; xdeb[i]; ++i)
				{
					if(strcmp(xdeb[i],cmd) == 0)
					{
						if(i < 3)
						{
							r.x.dx &= 0xFFF8;				/* mask off lower 3 bits */
							r.x.dx |= (i | D_CATCH);	/* set output location */
						}
						else if(i == 3)
							r.x.dx |= D_NOIO;
						else if(i == 4)
							r.x.dx |= D_AFTER;
						else if(i <= 9)
							r.x.dx |= (1 << (i+6));
						else if(i == 10)
						{
							for(j=0; xdeb[j]; ++j)
								printf("%-10s",xdeb[j]);
							printf("\n");
						}
					}
				}
			else
				r.x.dx= atoh(cmd);
		}
	}
	else
		r.x.ax= DEBUG_FUNC<<8;				/* get the debug flags */

	/* do the call */
	intdos(&r,&r);
	if(r.x.cflag)
		PrintError(ENODEB);						/* no debugging available */

	printf("Debug flag = %04X\n",r.x.ax);
}


int PASCAL atoh(char *s)
{
	unsigned h=0;

	while(isxdigit(*s))
	{
		h*= 16;
		h+= (*s>='0' && *s<='9' ? *s-'0' : toupper(*s) - 'A' + 10);
		++s;
	}
	return h;
}

char local_string[130];

void PASCAL do_show(char *args)
{
	extern unsigned resseg;

	int fd, psp;

#if ANYBODY_KNOWS_WHAT_THIS_IS_SUPPOSED_TO_DO
	if(*args)
		sscanf(args, "%d", &xcountry.co_date);
	printf("date format = %d args = '%s'\n", &xcountry.co_date,args);
#endif

	printf("in_batch = %d echo = %d\n",	c_in_batch, c_echo);
	farstrcpy((char far *)(local_string),pCurBCB->batName);
	printf("\tbat_name = %s\n",local_string);
	farstrcpy((char far *)(local_string),pCurBCB->batArgs);
	printf("\tbat_args = %s\n",local_string);
	fd = dos_creat("junk.abc");
	printf("Next file = %d\n", fd);
	psp = get_psp();
	printf("Psp = %04x\n", psp);
	printf("Res Segment = %04x\n", resseg);
	close(fd);
}


/*
	Dump a far area of memory
*/
void PASCAL fardump(char far *p,int len)
{
	char s[16];
	int i,n;
	while(len>0)
	{
		n=min(len,16);
		for(i=0;i<n;++i)
			s[i]=*p++;
		dump(s,n);
		len-=16;
	}
	printf("\n");
}


/*
	return the word checksum
*/
unsigned PASCAL do_chksum(char far *c1, unsigned len)
{
	unsigned chksum=0;

	while(len--)
		chksum+= *(c1+len);

	return chksum;
}


/*
	Checksum the code and compare it with the last checksum.
	If it is not identical, we've got problems.
*/
void PASCAL chk_code(int first)
{
	static unsigned orig;
	static unsigned cs,len;
	unsigned chk;

	if(first)
	{
		cs  = getCS();
		len = (getDS() - cs) * 0x10;
	}
	chk = do_chksum(MK_FP(cs,0),len);

	if(first)
	{
		orig= chk;
#if DEBUG > 2
		code_save(cs,len);		/* save the bytes out to disk */
#endif
	}

	else if(chk != orig)
	{
		printf("FATAL ERROR: code corrupted!\n");
#if DEBUG > 2
		code_diff(cs,len);		/* compares the bytes with disk */
#endif

		PerformExit();
	}
}


/*
	Save our code segment out to disk
*/
void PASCAL code_save(unsigned cs,unsigned len)
{
	extern void res_openhole();
	extern void res_closehole();

	int fd,i;
	unsigned segment;
	unsigned char far *farbuff;
	unsigned char far *fp = MK_FP(cs,0);

	farcall(res_openhole);
	segment = dos_malloc(len/16);
	farbuff = MK_FP(segment,0);

	for(i=0; i<len; ++i)
		farbuff[i]= fp[i];

	fd = dos_creat("CODE");
	dos_write(fd,farbuff,len);
	dos_close(fd);

	dos_free(segment);
	farcall(res_closehole);
}


/*
	Display the differences in the code
*/
void PASCAL code_diff(unsigned cs,unsigned len)
{
	extern void res_openhole();
	extern void res_closehole();

	int fd,i;
	unsigned segment;
	unsigned char far *farbuff;
	unsigned char far *fp = MK_FP(cs,0);


	farcall(res_openhole);

	segment= dos_malloc(len/16);
	farbuff = MK_FP(segment,0);

	fd = dos_open("CODE",RD);
	dos_read(fd,farbuff,len);
	dos_close(fd);

	for(i=0; i<len; ++i)
		if(farbuff[i] != fp[i])
			printf("%p %02X %02X\n",i,farbuff[i],fp[i]);

	dos_free(segment);
	farcall(res_closehole);
}


/*
	Display a far string
*/
void PASCAL putfs(char far *s)
{
	while(*s)
		printf("%c",*s++);
}


/*
	List our handle table
*/
void PASCAL io_list(void)
{
	unsigned char far *fp;
	int i, total = 0;

	fp = MK_FP(_psp,0x18);
	for(i= 0; i<20; ++i)
	{
		printf("%02X ",*fp);
		if(*fp != 0xFF)
			++total;
		++fp;
	}
	printf("\n");

	/* figure out IOCTL of all these handles */
	for(i=0; i<total; ++i)
		printf("%d: ioctl %p\n",i,dos_ioctl(i,0,0));
}


/*
	Display our PSP
*/
void PASCAL show_psp(void)
{
	unsigned i;
	char far *fp;
	i = get_psp();

	fp = MK_FP(i, 0x18);

	printf("Psp @ %04x ", i);
	for(i=0; i<20; ++i)
		printf("%02x ", fp[i]);
	printf("\n");
}
/*
	Dump a near area of memory
*/
void PASCAL dump(char *buff, int length)
{
	int start=0, len, i;
	unsigned char *dumpbuf = (unsigned char *)buff;

	while(length>0)
	{
		len=min(length,16);
		for(i=0;i<16;++i)
		{
			printf(i<len ? "%02X " : "   ",dumpbuf[start+i]);
			if(i==7)
				printf(i<len ? "| " : "  ");
		}
		printf(" ");
		for(i=0;i<16;++i)
		{
			if(i<len)
				printf(isprint(dumpbuf[start+i]) ? "%c" : ".",dumpbuf[start+i]);
			else
				printf(" ");
		}
		printf("\n");
		length -= len;
		start  += len;
	}
}

#endif // }
