//
//   $Id: COMFIELD.C 1.4 2002/10/15 20:08:46Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:COMFIELD.C

	Copyright (c) 1989-2002 Datalight, Inc.
	Datalight Confidential and Proprietary.
   All Rights Reserved.

	Used to get date fields.

	$DOCHISTORY
	02/21/1999 dg  Created by Drew Gislason
***************************************************************************/

#define isdigit(c) ((c)>='0' && (c)<='9')

/*
	Get a generic field string (ie date and/or time string)

int get_field(char *str, unsigned count, unsigned sep, ...)
*/
 int get_field(char *str, unsigned count, unsigned sep, unsigned * arg1)
{
	unsigned i, **array = &arg1;
	unsigned val;
	int hitdigit;

	hitdigit = val = i = 0;
	while(*str && i<count)
	{
		// digits, lets use 'em
		if(isdigit(*str))
		{
			hitdigit = 1;
			val = val * 10 + *str - '0';
		}

		// hit separator, on to next field
		else if(*str == sep || *str == '.')
		{
			*array[i] = val;
			val = 0;
			++i;
		}

		// tabs and spaces OK, all other characters bad!
		else if(*str!=' ' && *str!='\t')
			return 0;

		++str;
	}

	/* no digits? error! */
	if(!hitdigit)
		return 0;

	/* fill out the rest of the fields */
	while(i<count)
	{
		*array[i++] = val;
		val = 0;
	}

	/* all fields looked OK */
	return 1;
}

