//
//   $Id: RAW.H 1.2 2002/10/15 20:30:20Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*--------------------------------------------------------------------------
 Include file for users of raw.c.
 For details, see raw.c.
 $Log: RAW.H $
 Revision 1.2  2002/10/15 20:30:20Z  peterb
 = 10-16-02 ======================== 4.11.1367 (4) ==================
 - IR ? *.* Updated all source files with the new copyright header
 * Revision 1.2  90/07/14  09:00:55  dan_kegel
 * Added raw_set_stdio(), which should make it easy to use RAW mode.
 *
 * Revision 1.1  90/07/09  23:11:39  dan_kegel
 * Initial revision
 *
--------------------------------------------------------------------------*/

/* Call this routine with raw=1 at the start of your program;
 * call it with raw=0 when your program terminates.
 * If raw=1, sets stdin and stdout to RAW mode, disables break checking,
 * and turns off line buffering on stdin.
 * If raw=0, sets stdin and stdout back to non-RAW mode, and restores break
 * checking to its previous state.
 */
void raw_set_stdio(int raw);

/* A replacement for kbhit().
 * Check for char on stdin.  Returns nonzero if one is waiting, 0 if not.
 * If stdin is RAW, and break checking is off, then this won't kill
 * your program when the user types ^C (unlike the kbhit() that comes
 * with MSC).
 */
int raw_kbhit(void);

/* Building-block routines.  See raw.c for documentation. */
int raw_get(int fileno);
void raw_set(int fileno, int raw);
int break_get(void);
void break_set(int check);
