//
//   $Id: CDASM.C 1.5 2002/10/15 20:34:18Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************
 *
 *  Copyright (c) 1996-2002 Datalight, Inc.
 *  All Rights Reserved.
 *  Datalight Confidential and Proprietary
 *
 *********************************************************/
#include <dos.h>

#include "datalght.h"


#include "cdrom.h"
#include "cddos.h"
#include "cdstruct.h"

#define __FILENUM__ 2

//
// prototype include files
//
#include "cdasm.pt"
#include "cdboot.pt"



//
// Get the DOS List of Lists - Call DOS and get a far pointer
// to the ListOfLists
//
void GetListOfListsPtr(void)
{
	unsigned listOfListSeg, listOfListOff;

	asm 	mov	ah, 0x52
	asm	int 	0x21
	asm	mov	listOfListSeg, es
	asm	mov	listOfListOff, bx
	lpListOfLists = MK_FP(listOfListSeg, listOfListOff);
}



//
// getSDA calls DOS for the address of the Swappable Data Area (SDA).
// getSDA also initializes the "static" values of the SDA.
//
void GetSDA(void)
{
	unsigned sdaSeg, sdaOff;

	asm 	mov	ax, 0x5D06
	asm	push	ds
	asm	int 	0x21
	asm 	mov	sdaSeg, ds
	asm	pop	ds
	asm	mov	sdaOff, si

	lpSDA = MK_FP(sdaSeg, sdaOff);

	lpSDAFileName1 = lpSDA->fn1;
	lpSDAFileName2 = lpSDA->fn2;
	lpSDASDB = &lpSDA->sdb;
}


