;
;   $Id: FNMATCH.ASM 1.4 2002/10/15 20:34:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;*
;* Copyright (C) 1996-2002 Datalight, Inc.
;* All Rights Reserved
;* Datalight Confidential and Proprietary
;*
;* This file contains a name match generator that will check to see if two
;* filenames/directories match.  There are special cases:
;*
;*		filename\ filename<null>		** match
;*		filename<null> filename.		** match
;* and of course:
;*		filename filename			** match
;*
;* Revision history
;*	02/13/97 jmb	Initial revision
;*
;*****************************************************************************
include macros.inc


FALSE equ 0
TRUE  equ 1

PERIOD_NULL equ 002Eh

cBegData
;
; external data
;


;
; local data
;

;
; public procedures
;

	public	NameMatch

;
; external procedures
;


cEndData

cBegCode

;---------------------------------------------------------------------------------------
;
;	bool NameMatch(char far *lpDOSName, char far *lpCDName, int iMaxSrchLen)
;
; NameMatch will compare two names, lpDOSName and lpCDName.  If they match
; this routine will return true.  If they don't, it will return false.  It will
; do one additional thing:  If the dos name ends with a null and no extension
; but the cdrom name ends in a "." and a null then TRUE will be returned to say
; that the names matched.  The cases of matching are:
;
;	   DOS NAME    CD NAME           Result
;	------------ ------------       --------
;	FILENAME.EXT FILENAME.EXT	 match
;	FILENAME.EXT FILENAME     	 no match
;	FILENAME     FILENAME.EXT        no match
;       FILENAME     FILENAME            match
;       FILENAME     FILENAME.           match
;       FILENAME.    FILENAME.           this case will never happen as DOS
;					 will not pass the "." to CDEX.
;
;
;	Register usage:
;		es:di will point to the CDROM filename
;		ds:si will point to the DOS filename
;
;	Returns
;		ax = FALSE for failure
;		ax = TRUE  for success
;----------------------------------------------------------------------
NameMatch	proc
	push	bp
	mov	bp, sp

	push	es
	push	ds
	push	si
	push	di
	push	cx


	; get the length of the item to compare (not incl NULL terminator)
	mov	cx, [bp+4]

	; get pointer to cdrom filename
	les	di, [bp+6]

	; get pointer to dos filename
	lds	si, [bp+10]

CompareNames:

	; get a character from the dos filename
	mov	al, byte ptr [si]

	; see if it matches the cdrom filename
	cmp	byte ptr es:[di], al
	jne	NoMatch

	; did we find a null character?
	or	al, al
	jz	TheyMatch

	inc	si
	inc	di
	loop	CompareNames

	; all of the characters match to this point.  But we ran out of length
	; on the DOS filename - whose length we are using.  The DOS filename
	; is either a null terminated filespec or a directory name which should
	; be terminated by a backslash ("\")

	; check to see if the DOS filename is NULL terminated
	cmp	byte ptr [si], 0
	je	CheckCDROMName

	; check to see if the DOS filename is BACKSLASH terminated
	cmp	byte ptr [si], '\'
	jne	NoMatch


CheckCDROMName:

	; check for null terminator on the cdrom filename
	cmp	byte ptr es:[di], 0
	je	TheyMatch

	; the cdrom name could be terminated by a period followed by a null
	cmp	word ptr es:[di], PERIOD_NULL
	jne	NoMatch

TheyMatch:
	mov	ax, TRUE
	jmp	short LeaveNameMatch

NoMatch:
	mov	ax, FALSE


LeaveNameMatch:
	pop	cx
	pop	di
	pop	si
	pop	ds
	pop	es
	pop	bp
	ret	10

NameMatch endp

cEndCode
	end

