//
//   $Id: SFT.H 1.4 2002/10/15 20:34:18Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************
 *
 *  SFT.H            created mm/dd/yy  by Roy Sherrill
 *                   updated 06/14/96  by John Burnham
 *
 *  Copyright (c) 1989-2002 Datalight, Inc.
 *  All Rights Reserved.
 *  Datalight Confidential and Proprietary
 *
 *   The System File Table (SFT) for DOS
 *
 * 10/07/96 Added new fields to save even more information
 *
 *********************************************************/

struct CDEX_SFT
{
   unsigned handles;                  // 00 Number of handles refering to entry
   unsigned openMode;                 // 02 0=read, 1 = write 2 = read/write
   uchar    attr;                     // 04 file attribute
   unsigned devInfo;                  // 05 bit map for ioctl (device)
   unsigned cdexSignature;            // 07 0xFEED
   int      VSSN;                     // 09 volume set sequence number of file
   unsigned cdexHandle;               // 0B internal handle number
   unsigned fTime;                    // 0D time of file entry
   unsigned fDate;                    // 0F date of file entry
   ulong    fSize;                    // 11 the file size
   ulong    fPos;                     // 15 offset for next read/write
   uchar    extendedAttrRecordLength; // 19 length of XAR in LBNs
   ulong    lbnOfFileStart;           // 1A LBN of file start
   uchar    interleaveSize;           // 1E interleave size in LBNs
   uchar    interleaveSkip;           // 1F interleave gab in LBNs
   uchar    fName[11];                // 20 filename
   int      fileVersion;              // 2B version of CDROM file
   int      numLogicalSectors;        // 2D number of logical sector read ahead
   unsigned shareid;                  // 2F ??? network id of process
   unsigned owner;                    // 31 psp of owner of this SFT
   unsigned shareoff;                 // 33 ??? sharing record offset
   unsigned absclus;                  // 35 as above, 0000 = invalid
   ulong    cdFilePosition;           // 37 file position pointer
};




