;
;   $Id: STDOS.ASM 1.4 2002/10/15 20:34:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   STDOS.ASM  created 08/23/93  by Drew Gislason

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This startup code works for any utility where size is
   critical.  It is standard "DOS" startup code without
   all the normal trappings of the full blown C library.

   The STACKSIZE can be set to any size up to 64K.  The
   stack is not allocated, but is actually part of the
   uninitialized data.

   If main() returns bit 4000H set, then the program will
   remain resident as a TSR.

   The only allocation routine is:
   void * AllocateBytes(unsigned bytes)

   There is no routine to free the memory.

	Revision History
	07/13/98	jmb	added a check for resize failure
	??/??/93	dg 	original revision


---------------------------------------------------------- ~
include macros.inc
include defines.inc

;-----------------------------------------
;	Define SEGMENT ORDERING
;-----------------------------------------
cBegCode
cEndCode

cBegData
cEndData

cBegUdata
begbss	label	word
cEndUdata

	dgroup group _DATA, _BSS, endingseg
ENDINGSEG	segment para public 'ENDSEG'
bssend	label	word
ENDINGSEG	ends


;-----------------------------------------
;	Define DATA AREA
;-----------------------------------------
cBegData
	extrn	wReEntryFlag:word

	tsrseg	dw	seg ENDINGSEG

	; required by BC 2.0
	public	___brklvl
___brklvl	DW	0
		DW	seg ENDINGSEG	; start of heap

cEndData

cBegUdata
	public	__psp, __envseg, _errno
	__psp		dw	?
	__envseg	dw	?
	_errno		dw	?

	public	stackbottom, stacktop, _stackcheck
	; +3 words for stack overflow checking
	_stackcheck	dw 0ffffh, 5555h, 0aaaah
	stackbottom	db STACKSIZE dup (?)
	stacktop	dw ?

	argc	dw	?
	argv	dw	MAXARGV dup (?)	; argv[0]=progname
					; argv[1]=args (if any)
					; argv[2]=NULL

	; near copy of cmdline
	cmdline	db	80H dup (?)
cEndUdata

cBegCode
	extrn	_main:near
	ASSUME DS:DGROUP, ES:DGROUP

	public	_astart
_astart:

	; set up a stack
	cli
	mov	DX, DGROUP
	mov	SS, DX
	mov	SP, GOFFSET stacktop
	sti

	; zero BSS
	xor	AL, AL
	mov	ES, DX			; DGROUP from above
	mov	DI, GOFFSET begbss
	mov	CX, GOFFSET bssend
	sub	CX, DI
	cld
	rep	stosb

	; DS=ES=SS=DGROUP
	mov	ES:[__psp], DS		; save PSP
	mov	DS, DX			; DGROUP from above

	; determine location of environment
	mov	ES, [__psp]
	mov	ES, ES:[2CH]
	mov	[__envseg], ES

	; push filename on stack. filename is found at the
	; end of the environment.
	xor	DI, DI
again:	cmp	word ptr ES:[DI],0	; find end of environment
	jz	end_of_strings
	inc	DI
	jmp	again
end_of_strings:
	add	DI, 4		; skip to filename
	call	push_name	; ES:DI pts to filename, push on stack

	; the filename is argv[0]
	mov	[argc], 1		; argc = 1 argument so far
	mov	[argv], BP	; argv[0]

	; copy the cmdline from the PSP to the near cmdline
	; the cmdline from DOS is 80H bytes in size at PSP:80H
	push	SS
	pop	ES		; get DGROUP into ES
	mov	DS, [__psp]
	mov	SI, 80H
	mov	DI, GOFFSET cmdline
	mov	CX, 40H		; 40H words = 80H bytes
	rep	movsw

	; convert cmdline into argv[] array
	push	SS
	pop	DS		; get DGROUP into DS
	mov	SI, GOFFSET cmdline
	xor	CX, CX
	mov	CL, [SI]		; CX = length of cmdline
	inc	SI			; [SI] = start of cmdline
	mov	BX, GOFFSET argv+2	; [BX] = argv[] array

again_cmdline:
	; we can only have so many cmdline args
	cmp	[argc], MAXARGV
	jae	done_cmdline

	; for each argument, skip all preceding white space
	call	skipwhite_ds_si
	jcxz	done_cmdline

	; record this argument in the argv[] array
	inc	[argc]			; 1 more arg
	mov	[BX], SI		; argv[n]
	inc	BX
	inc	BX
	call	skiptext_ds_si

	; null terminate each argv[] entry
	mov	byte ptr [SI], 0

	; skip past NULL character
	; (but not if at very end of cmdline)
	jcxz	done_cmdline
	dec	CX
	inc	SI
	jmp	again_cmdline
done_cmdline:
	; doubly null terminate the command line
	mov	byte ptr [si+1], 0

	; resize memory down to as small as possible
	mov	BX, [tsrseg]
	sub	BX, [__psp]	; BX = new size
	mov	AH, 4AH		; resize memory
	mov	ES, [__psp]	; ES = mem segment
	int	21H		; tell DOS to resize
	jc		terminate

clear_reentry_flag:
	mov	wReEntryFlag, 0

	; call main(int argc, char *argv[])
noargs:	mov	AX, GOFFSET argv
	push	AX
	push	[argc]
	call	_main

	; do we install a TSR?
	test	AH, (TSR/256)
	jz	terminate

	; don't install TSR if there was an error
	or	AL, AL
	jnz	terminate

	; Terminate and Stay Resident
	mov	DX, [tsrseg]
	sub	DX, [__psp]	; DX contains # of paras
	mov	AX, 3100H
	int	21H
tsr1:	jmp	tsr1

terminate:
	mov	AH, 4CH
	int	21H

	; Borland C 2.0 requires this if main has argv
	public	__setargv__
__setargv__:

t1:	jmp	t1

	public	__exitclean, _exit
__exitclean:
_exit:	push	BP
	mov	BP, SP
	mov	AL, P[BP]
	jmp	short terminate

;----------------------------------
; On Entry
;   ES:DI = string
; On Exit
;   SS:BP = offset on stack of string
	public	push_name
push_name	proc	near
	; remember return address
	pop	BX

	; determine length of string
	mov	SI, DI
	xor	CX, CX
strlen:	cmp	byte ptr ES:[SI], 0
	jz	gotlen
	inc	SI
	inc	CX
	jmp	strlen
gotlen:	inc	CX	; account for 0 terminator

	; get the space on the stack
	mov	BP, CX
	test	BP, 1
	jz	noinc
	inc	BP		; always allocate words on stack
noinc:	sub	SP, BP
	mov	BP, SP		; point SS:BP to memory

	; copy the bytes
	mov	SI, BP		; assume DS=SS
copyb:	mov	AL, ES:[DI]
	mov	DS:[SI], AL
	inc	SI
	inc	DI
	cmp	AL, 0
	jnz	copyb

	; return to caller
	push	BX
	ret
push_name	endp

;----------------------------------
; On Entry
;   CX    = length left
;   DS:SI = string
; On Exit
;   CX    = length left
;   DS:SI = string, stopping on first whitespace
	public	skiptext_ds_si
skiptext_ds_si	proc near

skiptxt_again:
	; are we done skipping text?
	jcxz	done_skiptxt
	cmp	byte ptr [SI], ' '
	jz	done_skiptxt
	cmp	byte ptr [SI], TAB	; 9
	jz	done_skiptxt

	; not done yet, on to next byte
	inc	SI
	dec	CX
	jmp	short skiptxt_again

done_skiptxt:
	ret
skiptext_ds_si	endp

;----------------------------------
; On Entry
;   CX    = length left
;   DS:SI = string
; On Exit
;   CX    = length left
;   DS:SI = string, skipping all spaces and tabs
	public	skipwhite_ds_si
skipwhite_ds_si	proc near

skip_again:
	jcxz	done_skip
	cmp	byte ptr [SI], ' '
	jz	skip_char
	cmp	byte ptr [SI], TAB	; 9
	jnz	done_skip
skip_char:
	inc	SI	; on to next byte
	dec	CX	; 1 less byte in cmdline
	jmp	short skip_again

done_skip:
	ret
skipwhite_ds_si	endp


; void * AllocateBytes(unsigned bytes)
c_func	AllocateBytes
	push	BP
	mov	BP, SP

	; convert bytes requested to paras
	mov	AX, P[BP]
	add	AX, 0FH
	mov	CL, 4
	shr	AX, CL

	; determine start of "current" allocation block
	mov	DX, [tsrseg]
	mov	CX, DS
	sub	DX, CX	; DX = paras from start of DGROUP

	; can we allocate the memory?
	mov	BX, DX
	add	BX, AX
	cmp	BX, 1000H
	jae	nomem		; small model, can't alloc >64K

	; update allocated memory
	mov	CX, DS
	add	BX, CX
	mov	[tsrseg], BX

	; resize memory to include user requested memory
	push	DX
	mov	BX, [tsrseg]
	sub	BX, [__psp]	; BX = new size
	mov	AH, 4AH		; resize memory
	mov	ES, [__psp]	; ES = mem segment
	int	21H		; tell DOS to resize
	jc		nomem		;#071398) did the resize fail?
	pop	DX		; original value of TSRSEG

	; make a pointer out of paras
	mov	AX, DX
	mov	CL, 4
	shl	AX, CL
	jmp	short donemem

	; no memory left? return 0
nomem:	xor	AX, AX

donemem:
	pop	BP
	ret
c_endp	AllocateBytes

; void far * AllocateFarMemory(unsigned paragraphs)
;
; this routine will attempt to allocate at the end of the executable, the
; specified number of paragraphs.
;
; returns either a valid far pointer to the allocated buffer
; or NULL on any error.
c_func	AllocateFarMemory
	push	bp
	mov	bp, sp

	; get segment where the block starts
	mov	dx, [tsrseg]

	; get number of paras
	mov	ax, P[bp]

	cmp	ax, 0		; valid size requested?
	je	faralloc_failed ; no, jump

	; determine new ending segment
	mov	bx, dx
	add	bx, ax

	; update allocated memory
	mov	[tsrseg], BX

	; resize memory to include user requested memory
	push	dx
	sub	bx, [__psp]	; BX = new size
	mov	es, [__psp]	; ES = mem segment
	mov	ah, 4Ah		; resize memory
	int	21h		; tell DOS to resize
	pop	dx		; original value of TSRSEG

	jc	faralloc_failed	; jump if error

	; make a pointer out of segment and offset (dx:ax)
	mov	AX, 0
	jmp	short faralloc_done

faralloc_failed:
	mov	[tsrseg], dx	; restore previous TSRSEG
	xor	ax, ax
	xor	dx, dx		; return null pointer


faralloc_done:
	pop	bp
	ret
c_endp	AllocateFarMemory

cEndCode

	END	_astart

