;
;   $Id: COUNTRY.ASM 1.4 2002/10/15 20:35:36Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~ ------------------------------------------------

   COUNTRY.SYS   created 02/15/89  by Drew Gislason

   Copyright (c) 1989-2002 by Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This installable device allows the user to set the
   country at boot time (only).  The device simply sets
   the country.  It claims that the device failed to
   install so that no memory is used.

   This COUNTRY info is to be installed in CONFIG.SYS, thus:

   DEVICE = COUNTRY.SYS 61,850

      or

   COUNTRY 33

---------------------------------------------------------- ~

include macros.inc

; define segment ordering
cBegCode
cEndCode

cBegData
cEndData

cBegUdata
	orgstack	dd ?
	stackbase	dw 200 dup (?)
	stacktop	dw ?
cEndUdata

cBegCode

	PUBLIC country_hdr,country_strat,country_serve,country_init

	EXTRN	_set_country_data:near


;----------------------------------------------------------------------
;
;	DEVICE HEADER
;
country_hdr:
	dw	-1,-1
	dw	0		; IBM format-compatible block
	dw	country_strat	; strategy routine
	dw	country_serve	; service routine


;----------------------------------------------------------------------
;
;	STRATEGY
;
ptrsav	dd	?

strat	proc	far
country_strat:
	mov	word ptr cs:[ptrsav],bx
	mov	word ptr cs:[ptrsav+2],es
	ret
strat	endp


;----------------------------------------------------------------------
;
;	SERVICE ROUTINE (MAIN ENTRY)
;

; Request Header Macros
cmdlen	=	0	; length of this command
unit	=	1	; sub unit specifier
cmdc	=	2	; command code
status	=	3	; status
media	=	13	; media descriptor
trans	=	14	; transfer address
count	=	18	; count of blocks
start	=	20	; first block to transfer


country_serve:
	pushf
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es

	lds	bx,cs:[ptrsav]		; get pointer to i/o packet

	; make sure this is the INIT command (the only one we can handle)
	mov	al,byte ptr [bx].cmdc	; command code
	or	al,al
	jz	country_init


;----------------------------------------------------------------------
;
;		EXIT - ALL ROUTINE RETURN THROUGH HERE
;
cmderr:
	mov	al,3		; unknown cmd error
err_exit:
	mov	ah,81H		; mark error return
	jmp	short err1

exitp	PROC	FAR
exit:	mov	ah,01H
err1:	lds	bx,cs:[ptrsav]
	mov	word ptr [bx].status,ax		; mark as complete

	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	popf
	ret
exitp	ENDP


;----------------------------------------------------------------------
;
;	INIT
;
;	DS:BX	= i/o packet
;
;	Returns:
;	+-------------------------+
;	| 13-Byte header          |
;	+-------------------------+
; 0D	| BYTE   Number of units  |
;	+-------------------------+
; 0E	| DWORD  End Address      |
;	+-------------------------+
; 12	| DWORD  Ptr to BPB array |
;	+-------------------------+
; 16	| BYTE   Block Device #   |
;	+-------------------------+
;

country_init:
	; get pointer to commandline
	les	di, dword ptr [bx].count	; ES:DI = cmdline
	cld

	; get our dgroup
	mov	ax,seg _DATA
	mov	ds,ax

	; set up a stack
	mov	word ptr [orgstack+2], SS
	mov	word ptr [orgstack], SP
	cli
	mov	SS, AX
	mov	SP, GOFFSET stacktop
	sti

	push	es
	push	di
	call	_set_country_data
	add	sp, 4

	; restore original stack
	cli
	mov	SS, word ptr [orgstack+2]
	mov	SP, word ptr [orgstack]
	sti

	lds	bx,cs:[ptrsav]
	mov	byte ptr [bx].media,0	; ZERO disks (this is faked)
	mov	word ptr [bx].trans,0
	mov	word ptr [bx].trans+2,0	; no end address
	jmp	exit

cEndCode

	end country_hdr
