;
;   $Id: DISPLAY2.ASM 1.4 2002/10/15 20:36:54Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   MEMCHAR.ASM  created 08/12/91  by Drew Gislason

   Copyright (c) 1991-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   THE GENERIC CHARACTER DRIVER
   -----------------------
   This device driver shell simplifies the process of
   creating a memory disk driver.  This includes ROM disks,
   RAM disks, Flash memory disks, Paged ROM/RAM disks,
   etc...

   It provides all the surrounding routines that interact
   with DOS, leaving only a few routines to code for any
   given disk device.

   The only routines that interact with the disk itself
   (memory or otherwise) are defined as follows:

   GENERIC DISK DRIVER I/O
   -----------------------
   bool meminit(struct BPB * bpb, char far *cmdline, unsigned *endseg, int drv);

   Extended Interface (depending on options)
   -----------------------------------------
   bool memioctl(unsigned category, char far * buffer);
   void memshowhelp(void);


   OPTIONS
   -------
   BUILTIN=1	This option allows you to choose whether
   		this device driver will be built-in to
   		ROM-DOS or stand alone (installable from
   		CONFIG.SYS).

   STACKSIZE=n	A stand-alone driver needs a stack.  This
   		defines the size of it in bytes.

---------------------------------------------------------- ~

include macros.inc
include devhdr.inc

; relevant to both built-in and stand-alone drivers
; BUILTIN=1		; built-in or stand-alone(CONFIG.SYS)
GENIOCTL=1		; support generic IOCTL functions 440CH?

; relevant only to stand-alone drivers
IFNDEF BUILTIN
STACKSIZE = 1024	; stack space for stack hogs
; MATHFUNCS=1		; for long math functions
; MEMHELP=1		; display help when run from cmdline?
; TSRDEV=1		; optionally install device via TSR methods
ENDIF

;  If you wish to build this driver into ROM-DOS (as opposed to
;  loading it through CONFIG.SYS), you must modify SYSGEN.ASM
;  to include the external "_memx" in its list of internal disk
;  devices.
public _memcharx

;---------------------------------------------------------
;
;	STANDALONE SEGMENT ORDERING
;
;	The segment ordering must be defined correctly
;	for a standalone device driver.  Built-in drivers
;	are taken care of by the ROM-DOS segment ordering.
;
;---------------------------------------------------------

IFNDEF BUILTIN ; {

;
;  Define SEGMENT ORDERING for standalone device driver
;
cBegCode
cEndCode

BEGDATA	SEGMENT PARA PUBLIC '_BEGDATA'
	DGROUP GROUP BEGDATA
datastart label word
BEGDATA	ENDS

cBegData
cEndData

cBegUdata
begbss	label word
cEndUdata

DISK	SEGMENT PARA PUBLIC '_DISK'
diskstart label word
DISK	ENDS

;---------------------------------------------------------
;
;	STANDALONE DEVICE HEADER
;
;	This device header handles a stand alone
;	RAM or ROM disk.
;
;---------------------------------------------------------

cBegCode

_memcharx:
	dw	-1, -1
IFDEF GENIOCTL
	dw	8040H		; char device, generic ioctl
ELSE
	dw	8000H		; character device
ENDIF
	dw	strategy	; strategy routine
	dw	service		; service routine
	db	"DISPLAY$"	; name


cmdtbl:
	dw	memdev_init	; 00 - init
	dw	dev_cmd_err	; 01 - media check
	dw	dev_cmd_err	; 02 - build a bpb
	dw	dev_cmd_err	; 03 - ioctl input
	dw	dev_cmd_err	; 04 - device read
	dw	dev_cmd_err	; 05 - non-destructive read
	dw	dev_cmd_err	; 06 - input status
	dw	dev_cmd_err	; 07 - input flush
	dw	dev_cmd_err	; 08 - write
	dw	dev_cmd_err	; 09 - write w/ verify
IFDEF GENIOCTL
	dw	dev_cmd_err	; 0A - output status
	dw	dev_cmd_err	; 0B - flush output
	dw	dev_cmd_err	; 0C - ioctl write
	dw	dev_cmd_err	; 0D - device open
	dw	dev_cmd_err	; 0E - device close
	dw	dev_cmd_err	; 0F - removable media check
	dw	dev_cmd_err	; 10 -
	dw	dev_cmd_err	; 11 -
	dw	dev_cmd_err	; 12 -
	dw	memdev_gen_ioctl; 13 - generic ioctl (440CH)
ENDIF
cmdend:

cEndCode

ELSE ; we are BUILT-IN

;---------------------------------------------------------
;
;	BUILT-IN DEVICE HEADER
;
;	This device header handles a disk device that is
;	built-in to the ROM-DOS Kernel.
;
;---------------------------------------------------------
cBegCode
	EXTRN	dev_strat:near, dev_serv:near
	EXTRN	dev_cmd_err:near, dev_err_exit:near
	EXTRN	dev_busy_exit:near, dev_err_cnt:near
	EXTRN	dev_exit:near

cmdtbl:
	dw	memdev_init	; 00 - init
	dw	memdev_media	; 01 - media check
	dw	memdev_bpb	; 02 - build a bpb
	dw	dev_cmd_err	; 03 - ioctl input
	dw	memdev_read	; 04 - device read
	dw	dev_cmd_err	; 05 - non-destructive read
	dw	dev_cmd_err	; 06 - input status
	dw	dev_cmd_err	; 07 - input flush
	dw	memdev_write	; 08 - write
	dw	memdev_write	; 09 - write w/ verify
IFDEF GENIOCTL
	dw	dev_cmd_err	; 0A - output status
	dw	dev_cmd_err	; 0B - flush output
	dw	dev_cmd_err	; 0C - ioctl write
	dw	dev_cmd_err	; 0D - device open
	dw	dev_cmd_err	; 0E - device close
	dw	dev_cmd_err	; 0F - removable media check
	dw	dev_cmd_err	; 10 -
	dw	dev_cmd_err	; 11 -
	dw	dev_cmd_err	; 12 -
	dw	memdev_gen_ioctl; 13 - generic ioctl (440DH)
ENDIF
cmdend:

cEndCode

_DEVDATA segment word public 'DEVDATA'

	ASSUME CS:_DEVDATA, DS:_DEVDATA
	EXTRN	dev_fstrat:NEAR, cmd_ptr:DWORD

;---------------------------------------------------------
;
;	BUILT-IN DEVICE HEADER
;
;---------------------------------------------------------
_memcharx:
	dw	-1, -1
IFDEF GENIOCTL
	dw	8040H		; char device, generic ioctl
ELSE
	dw	8000H		; character device
ENDIF
	dw	dev_fstrat	; strategy routine
	dw	service		; service routine
	db	"MEMCHAR$"	; name

service:
	push	AX
	push	SI

	; calc # of commands and where to find cmdtbl
	mov	AH, (OFFSET cmdend - OFFSET cmdtbl)/2
	mov	SI, OFFSET _TEXT:cmdtbl

	; Jump to the REAL service routine in ROM (CODE SEG)
	mov	WORD PTR cmd_ptr,OFFSET  dev_serv
	jmp	DWORD PTR CS:cmd_ptr

_DEVDATA ENDS

; defined so we have proper ASSUMEs
cBegData
	EXTRN	_ptrsav:DWORD
cEndData

ENDIF ; } from "ELSE BUILTIN"


;---------------------------------------------------------
;
;	STANDALONE ONLY CODE AND DATA
;
;	Some code and data is needed by a standalone
;	driver.  This entry/exit code is handled by
;	ROM-DOS in the built-in version.
;
;---------------------------------------------------------

IFNDEF BUILTIN ; {

cBegData
	zerobss	db	1	; only do it the 1st time

	public	_ptrsav		; MUST be in DATA, not BSS
	_ptrsav	dd	0	; far pointer to device request header

cEndData

cBegUdata

IFDEF STACKSIZE
	public	oldstack, stacktop
	oldstack dd	?
	stackbottom	db STACKSIZE dup (?)
	stacktop	dw ?
	stackCount	dw 0
ENDIF

IFDEF TSRDEV
	public	_psp, _dosseg, dev_req_hdr
	_psp		dw ?
	_dosseg		dw ?
	start_drive	db ?
	dev_req_hdr	db 1EH dup (?)

	public	tsrstack
			db 384 dup (?)
	tsrstack	dw ?
ENDIF
cEndUdata

cBegCode

	public strategy
strategy:
	push	DS
	call	_getDGROUP
	mov	word ptr [_ptrsav], BX
	mov	word ptr [_ptrsav+2], ES
	pop	DS
	retf

	public service
service:
	pushf
	push	AX
	push	BX
	push	CX
	push	DX
	push	SI
	push	DI
	push	DS
	push	ES

	call	_getDGROUP

	; Zero BSS (1st time only)
	cmp	byte ptr [zerobss], 0
	jz	no_zero
	mov	BX, offset CS:no_zero
	jmp	zero_bss
no_zero:

IFDEF STACKSIZE
	call	UseOurStack
ENDIF

	; determine the command
	les	BX, [_ptrsav]			; get pointer to i/o packet
	mov	AL, byte ptr ES:[BX+CMD]	; command code
	cmp	AL, (OFFSET cmdend - OFFSET cmdtbl) / 2
	jae	dev_cmd_err			; bad command
	cbw
	shl	AX, 1				; get index into cmd table
	mov	SI, offset _TEXT:cmdtbl
	add	SI, AX

	; load up the registers with common value
	mov	AL, byte ptr ES:[BX+UNIT]	; AL	= unit #
	mov	AH, byte ptr ES:[BX+MEDIA]	; AH	= media
	mov	CX, word ptr ES:[BX+COUNT]	; CX    = count
	mov	DX, word ptr ES:[BX+START]	; DX    = start sector
	les	DI, dword ptr ES:[BX+TRANS]	; ES:DI = transfer buffer

;	we've set up the following:
;	--------------------------
;	DS	= DGROUP
;	ES:DI	= transfer buffer
;	CX	= count
;	DX	= start
;	AL	= unit
;	AH	= media

	jmp	word ptr CS:[SI]	; do the command


; return address MUST be in BX because it may be the
; STACK that is ZEROED!!
zero_bss:
	xor	AL, AL
	mov	byte ptr [zerobss], AL
	push	DS
	pop	ES
	mov	DI, GOFFSET begbss
	mov	CX, offset DGROUP:diskstart
	sub	CX, DI
	cld
	rep	stosb
	push	BX
	ret

	public	dev_cmd_err, dev_err_exit, dev_exit, dev_busy_exit
dev_busy_exit:
	mov	AH, 03H		; busy and done bits set
	jmp	short err1
dev_cmd_err:
	mov	AL, 3		; unknown cmd error
dev_err_exit:
	mov	AH, 81H		; mark error return
	jmp	SHORT err1

dev_exit:
	mov	AH, 01H		; done bit set

err1:	les	BX, [_ptrsav]
	mov	WORD PTR ES:[BX+STATUS], AX	; mark as complete

IFDEF STACKSIZE
	call	UseOldStack
ENDIF
	pop	ES
	pop	DS
	pop	DI
	pop	SI
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	popf
	retf

; STANDALONE ONLY!!
; put DGROUP into DS
c_func	getDGROUP
	push	AX
IF 1
	; easy method
	mov	AX, DGROUP
	mov	DS, AX
ELSE
	; no fixups method
	push	CX
	mov	CX, CS
	mov	AX, offset _TEXT:datastart
	shr	AX, 1
	shr	AX, 1
	shr	AX, 1
	shr	AX, 1
	add	AX, CX
	mov	DS, AX
	pop	CX
ENDIF
	pop	AX
	ret
c_endp	getDGROUP

; STANDALONE ONLY!!
; return DISK segment in AX
c_func	getDISK
	mov	CX, CS
	add	AX, offset _TEXT:diskstart
	shr	AX, 1
	shr	AX, 1
	shr	AX, 1
	shr	AX, 1
	add	AX, CX
	ret
c_endp	getDISK


COMMENT ~
/*
   Assumes that "dosstr" ends in a "$".
*/
; STANDALONE ONLY!!
void print_str(char *dosstr)
~
c_func	print_str
	push	BP
	mov	BP, SP
	push	SI
	push	DI

	mov	DX, P[BP]
	mov	AH, 9
	int	21H

	pop	DI
	pop	SI
	pop	BP
	ret
c_endp	print_str

cEndCode


ENDIF ; } from "IF NOT BUILTIN"


;---------------------------------------------------------
;
;	STANDALONE and BUILT-IN DATA
;
;	Things like the BPB are universal to both
;	built-in and standalone device drivers.
;
;---------------------------------------------------------

cBegUdata
	public _memerr, end_seg, cmdline
	_memerr  dw	?	; set if read/write or init error
	end_seg  dw	?	; end of device in DOS memory
	cmdline  dd	?	; cmdline to "\SUBDIR\DEVNAME..."
cEndUdata


;---------------------------------------------------------
;
;	STANDALONE and BUILT-IN DEVICE FUNCTIONS
;
;	These are the function that DOS calls in order to
;	initialize, read and write the memory disk.  Uses
;	the standard device interface.
;
;---------------------------------------------------------

cBegCode

	extrn _meminit:near
IFDEF GENIOCTL
	extrn _memioctl:near
ENDIF

;---------------------------------------------------------
;
;	FUNCTION 0 - INIT THE DISK
;
; On Entry:
;
;	DS	= DGROUP
;	DX:CX	= "DEVICE = \dev\name.sys /1"
;	                    ^
;
; On Exit:
;	+-------------------------+
; 00H	| 13-Byte header          | (ignored)
;	+-------------------------+
; 0DH	| BYTE   Number of units  | (we set this)
;	+-------------------------+
; 0EH	| DWORD  End Address      | (we set this)
;	+-------------------------+
; 12H	| DWORD  Ptr to BPB array | (we set this)
;	+-------------------------+
;
;---------------------------------------------------------

	public	memdev_init
memdev_init:

IFNDEF BUILTIN ; {

	; save the ptr to the command line "C:\DEVNAME args..."
	mov	word ptr cmdline, CX
	mov	word ptr cmdline+2, DX

	; get the default ending segment "end_seg"
	call	getDISK
	mov	end_seg, AX

ENDIF ; } from "IF NOT BUILTIN"

	; set up error code in case they don't
	mov	byte ptr _memerr, ERR_GENERALFAIL

	; call the init function
	mov	AX, GOFFSET end_seg
	push	AX
	les	BX, [cmdline]
	push	ES
	push	BX
	call	_meminit
	add	SP, 6
	or	AX, AX
	jnz	initok

	; if there is an error, tell DOS about it
	mov	AL, byte ptr _memerr
IFNDEF BUILTIN
	les	BX, DS:[_ptrsav]
	mov	word ptr ES:[BX+TRANS], 0
	mov	word ptr ES:[BX+TRANS+2], 0
ENDIF
	jmp	dev_err_exit

	; no error, set up the i/o packet
initok:	les	BX, DS:[_ptrsav]

	; only the standalone device needs end address
IFNDEF BUILTIN
	mov	word ptr ES:[BX+TRANS], 0
	mov	AX, end_seg
	mov	word ptr ES:[BX+TRANS+2], AX
ENDIF
	mov	AL, 0
	jmp	dev_exit


return_chk:
	or	AX, AX
	jz	return_failed
	mov	AL, 0
	jmp	dev_exit

return_failed:
	mov	AL, byte ptr _memerr
	jmp	dev_err_exit


IFDEF GENIOCTL
;---------------------------------------------------------
;  FUNCTION 13H - Generic IOCTL
;---------------------------------------------------------
	public memdev_gen_ioctl
memdev_gen_ioctl:
	les	BX, _ptrsav
	mov	CX, ES:[BX+MEDIA]	; get category (CX)
	xchg	CH, CL			; DOS rearranged CL/CH, put 'em back
	les	BX, ES:[BX+IOCTL]	; get user buffer ES:BX
	push	ES
	push	BX
	push	CX
	; bool memioctl(unsigned category, char far * buffer);
	call	_memioctl
	add	SP, 6
	jmp	return_chk
ENDIF

	tempAX	dw	?
	tempBX	dw	?
	tempCX	dw	?

COMMENT ; prototype
void	UseOurStack(void)
{}
;
public UseOurStack
UseOurStack:
	cmp	[stackCount], 0
	jnz	UsingOurStack

	; save AX BX and CX
	mov	CS:[tempAX], AX
	mov	CS:[tempBX], BX
	mov	CS:[tempCX], CX

	; remember where to return to
	pop	BX

	; save old stack
	mov	word ptr oldstack+2, SS
	mov	word ptr oldstack, SP

	; set up our stack
	mov	AX, DS
	mov	CX, GOFFSET stacktop
	cli
	mov	SS, AX
	mov	SP, CX
	sti

	; return to the proper place
	push	BX

	; restore AX BX and CX
	mov	AX, CS:[tempAX]
	mov	BX, CS:[tempBX]
	mov	CX, CS:[tempCX]

UsingOurStack:
	inc	[stackCount]
	ret


COMMENT ; prototype
void	UseOldStack(void)
{}
;
public UseOldStack
UseOldStack:
	dec	[stackCount]
	jnz	UsingOldStack

	; save BX
	mov	CS:[tempBX], BX

	; remember where to return to
	pop	BX

	; switch back to their stack
	cli
	mov	SS, word ptr oldstack+2
	mov	SP, word ptr oldstack
	sti

	; return to the correct place
	push	BX

	; restore BX
	mov	BX, CS:[tempBX]

UsingOldStack:
	ret


;---------------------------------------------------------
;
;	MATH FUNCTIONS
;
;	All these math functions are avaible by ROM-DOS
;	to built-in device drivers.  Similar functions are
;	available in the standard compiler's (Borland's or
;	Microsoft's) library.
;
;	These are included here to allow the code that may
;	be built-in or stand-alone use the same long math
;	functions.
;
;---------------------------------------------------------

IFNDEF BUILTIN ; {
IFDEF MATHFUNCS ; {

COMMENT ; prototype
ulong _ldiv(ulong l1, ulong l2)
{}
;
c_func	_ldiv
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI

	MOV	AX,P+2[BP]	; high 16 bits of l1
	MOV	BX,P+0[BP]	; low  16 bits of l1
	MOV	CX,P+6[BP]	; high 16 bits of l2
	MOV	DX,P+4[BP]	; low  16 bits of l2

	CALL	LXXX

	MOV	DX,AX		; high order bits of divide
	MOV	AX,BX		; low order bits of divide

	POP	DI
	POP	SI
	POP	BP
	RET
c_endp	_ldiv ;


COMMENT ; prototype
ulong _lmod(ulong l1, ulong l2)
{}
;
c_func _lmod
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI

	MOV	AX,P+2[BP]	; high 16 bits of l1
	MOV	BX,P+0[BP]	; low  16 bits of l1
	MOV	CX,P+6[BP]	; high 16 bits of l2
	MOV	DX,P+4[BP]	; low  16 bits of l2

	CALL	LXXX

	MOV	AX,DX		; low order bits of remainder
	MOV	DX,CX		; high order bits of remainder

	POP	DI
	POP	SI
	POP	BP
	RET
c_endp _lmod


;-------------------------------------------
; Unsigned Long Divide
;
; Input:
;	[AX,BX],[CX,DX]
; Output:
;	[AX,BX] = [AX,BX] / [CX,DX]
;	[CX,DX] = [AX,BX] % [CX,DX]
;	SI,DI	destroyed

LXXX	PROC	NEAR
	MOV	SI,CX
	MOV	DI,DX			;[SI,DI] = divisor
	OR	CX,DX			;test for divide by 0
	JZ	div0			;yes

	;left justify [SI,DI] and leave count of shifts + 1 in BP

	PUSH	BP			;need a temporary
	MOV	BP,1			;at least 1 shift
L6:	TEST	SI,SI			;left justified?
	JS	L1			;yes
	JNZ	L2			;if non-zero
	XCHG	SI,DI			;SI = DI, DI = 0
	MOV	BP,17			;at least 17 shifts
	JMP	L6

L2:	INC	BP			;another shift
	SHL	DI,1
	RCL	SI,1			;[SI,DI] <<= 1
	TEST	SI,SI			;affect sign flag
	JNS	L2			;not left justified yet

L1:	MOV	CX,AX
	MOV	DX,BX			;[CX,DX] = [AX,BX]
	XOR	AX,AX
	XOR	BX,BX			;[AX,BX] = 0
L4:	CMP	SI,CX			;is [CX,DX] > [SI,DI]?
	JA	L3
	JB	L5			;definitely less than
	CMP	DI,DX			;check low order word
	JA	L3
L5:	SUB	DX,DI
	SBB	CX,SI			;[CX,DX] -= [SI,DI]
	STC				;rotate in a 1
L3:	RCL	BX,1
	RCL	AX,1			;[AX,BX] = ([AX,BX] << 1) + C
	SHR	SI,1
	RCR	DI,1			;[SI,DI] >>= 1
	DEC	BP			;control count
	JNE	L4
	POP	BP
	RET

div0:	MOV	AX,-1
	MOV	BX,AX			;quotient is -1
	XOR	CX,CX
	XOR	DX,DX			;remainder is 0
	RET

LXXX	ENDP

ENDIF ; } MATHFUNCS
ENDIF ; } NDEF BUILTIN

;---------------------------------------------------------
;
;	DEVICE START
;
;	This section of code is what gets executed when
;	the device driver .EXE is called from the DOS
;	command-line.  Depending on options, this may
;	display a help screen, or install the device via
;	the Terminate-and-Stay-Resident method.
;
;---------------------------------------------------------

_devstart:

IFNDEF BUILTIN ; {

IFDEF MEMHELP
	extrn	_memshowhelp:near
	call	_getDGROUP	; get DGROUP into DS

	; void memshowhelp(void);
	call	_memshowhelp
ENDIF

IFDEF TSRDEV ; {

	FIRST_DPB	EQU	26H
	CDS_ARRAY	EQU	3CH
	FIRSTDEV	EQU	48H
	DPBSIZE		EQU	21H	; 33 decimal
	CDSSIZE		EQU	58H	; 88 decimal
	LOL_NUMDRIVES	EQU	46H	; # of drives

; Checks left to do:
; 1) DOS 5.0
; 2) lastdrive

	; standard C environment: DGROUP, stack, zero BSS
	mov	SI, DS		; save PSP segment
	call	_getDGROUP	; get DGROUP into DS
	mov	DX, DS
	mov	AX, GOFFSET tsrstack
	cli
	mov	SS, DX		; create stack for TSR use
	mov	SP, AX
	sti
	mov	BX, offset CS:no_zero2
	jmp	zero_bss	; BSS must contain all 0s
no_zero2:

	; determine starting drive & top of mem
	mov	ES, SI			; restore PSP segment from SI
	mov	[_psp], ES
	push	ES			; save PSP segment
	mov	AH, 52H
	int	21H
	mov	[_dosseg], ES		; save DOS segment
	mov	AL, ES:[LOL_NUMDRIVES]	; from LOL, start drive
	pop	ES
	mov	DX, word ptr ES:[2]	; from PSP, top of mem
	mov	start_drive, AL		; save starting drive

	; set up device header call (note: dev_req_hdr already 0ed)
	; mov	byte ptr [dev_req_hdr+UNIT], 0		; unit = 0
	; mov	byte ptr [dev_req_hdr+CMD], 0		; cmd = 0 (init)
	mov	BX, 80H
	mov	byte ptr ES:[BX], 'X'			; "name" of device
	mov	word ptr [dev_req_hdr+COUNT], BX
	mov	word ptr [dev_req_hdr+START], ES	; cmdline ptr
	mov	byte ptr [dev_req_hdr+START+2], AL	; start drive
	mov	word ptr [dev_req_hdr+TRANS+2], DX	; top of memory

	; call device driver strategy and service routines
	push	DS
	pop	ES
	mov	BX, GOFFSET dev_req_hdr
	push	CS
	call	strategy
	push	CS
	call	service

	; worked?  how much mem?
	test	byte ptr [dev_req_hdr+STATUS], 80H	; error
	jz	install_worked
	jmp	failed
install_worked:

	; set up DPB for drive (tell DOS to rebuild)
	mov	AL, start_drive
	mov	byte ptr [drive_parm_blk+0], AL		; drive
	mov	word ptr [drive_parm_blk+13H], offset CS:_memx
	mov	word ptr [drive_parm_blk+13H+2], CS	; device

	; link DPB into list
	mov	ES, [_dosseg]
	les	BX, ES:[FIRST_DPB]
nextdpb:
	cmp	word ptr ES:[BX+19H], -1		; find last DPB
	jz	gotlastdpb
	les	BX, ES:[BX+19H]
	jmp	short nextdpb
gotlastdpb:
	mov	word ptr ES:[BX+19H], GOFFSET drive_parm_blk
	mov	word ptr ES:[BX+19H+2], DS

	; set up the CDS for the drive
	mov	ES, [_dosseg]
	les	BX, ES:[CDS_ARRAY]
	mov	AL, [start_drive]
	mov	AH, CDSSIZE		; size of CDS entry
	mul	AH			; AX = start of CDS for this drv
	add	BX, AX			; ES:BX pts to CDS
	mov	word ptr ES:[BX+43H], 4000H
	mov	word ptr ES:[BX+45H], GOFFSET drive_parm_blk
	mov	word ptr ES:[BX+45H+2], DS

	; link device into list
	mov	ES, [_dosseg]			; get DOS segment back
	mov	AX, word ptr ES:[FIRSTDEV]
	mov	DX, word ptr ES:[FIRSTDEV+2]	; point our next to
	mov	word ptr CS:_memx, AX		; the next of 1st device
	mov	word ptr CS:_memx+2, DX
	cli
	mov	word ptr ES:[FIRSTDEV], offset CS:_memx
	mov	word ptr ES:[FIRSTDEV+2], CS
	sti

	; update # of drives
	mov	AL, start_drive
	inc	AL
	mov	ES:[LOL_NUMDRIVES], AL	; set # drives to new value

	; Terminate and Stay Resident
	mov	DX, word ptr [dev_req_hdr+TRANS+2]
	sub	DX, _psp
	mov	AX, 3100H
	int	21H

failed:
ENDIF ; } TSRDEV
	mov	AX, 4C00H
	int	21H

ENDIF ; } NDEF BUILTIN

cEndCode


;---------------------------------------------------------
;
;	ASSEMBLE-TIME MESSAGES
;
;	These message serve as reminders, displaying the
;	current options during assembly.
;
;---------------------------------------------------------

; <<<<< Print a Message on Pass 1 >>>>>
outstr MACRO msg
    IFDEF ??version
	%out msg
    ELSE
	IF1
	    %out msg
	ENDIF
    ENDIF
ENDM

IFDEF BUILTIN
	outstr	<* Built-in>
ELSE
	outstr	<* Stand-alone>
ENDIF

	outstr	<* Character Device>

	END	_devstart
