;
;   $Id: EMM386.INC 1.4 2002/10/15 20:39:22Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  EMM386.INC
;
;  Copyright (c) 1994-2002 by Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;


; MAX count of numbered AMRS save areas to be allocated (AMRSs
; that can be (de)allocated).  This count is in addition to
; AMRS(0) which is always defined, so the actual number of distinct
; context save areas is 1+MAX_AMRS
;
MAX_AMRS		=	7

; The default range, within the "384K adapter space" from
; A0000h-FFFFFh, that will be considered for use as UMBs. The LIM
; 3.2 page frame, Included/eXcluded regions and ROM regions may
; all disrupt this range.
;
DEFAULT_UMB_START 	=	0C800h
DEFAULT_UMB_END 	=	0F000h


; This variable length structure is passed in to the Get Partial
; Page Map function (4F00h). The mappablePageCount is followed
; by an array of words. The array values specify the list of
; segments for which mapping context information is to be
; returned. There may be from 0 up to MAX_MAPPABLE_PAGES array
; entries.
;
LIM32_MAPPABLE_PAGES  	equ	4
MAX_MAPPABLE_PAGES    	equ	64			; 1M / 16K = 64
EMS_MAPPABLE_SEG_LIST	struc
	mappablePageCount		dw	?	;
	firstMappableSegmemtArrayEntry  dw	?
EMS_MAPPABLE_SEG_LIST	ends


; These structures define the internal representation of our
; page mapping context. The variable length DL_PAGE_MAP_STRUC is
; used to save both full and partial mapping contexts as well as
; to record the mapping context associated with an AMRS. The
; pageMapEntries count is followed by an array of
; DL_PAGE_MAP_ARRAY_ENTRY_STRUCs which define the mapping
; context for a specific mappable page. The array dimension may
; be from 0 to MAX_MAPPABLE_PAGES with a limit of
; MAX_CONTEXT_SIZE on the total size of the variable length
; struc. With the current structure definitions our maximum
; DL_PAGE_MAP_STRUC length is:
;
;   SIZE DL_PAGE_MAP_LIST
; + (MAX_MAPPABLE_REGIONS-1) * SIZE DL_PAGE_MAP_ARRAY_ENTRY_STRUC
;
; = 4 + 63*3 = 193 bytes
;
; A page map of the LIM 3.2 page frame would require 4+3*3=13
; bytes: In such a case the corresponding EMS_MAPPABLE_SEG_LIST
; would have the 4 mappable segment values of that page frame.
;
; NOTE:	Each physicalPageNumber entry in the list is part of a
;	physical (linear protected mode) address indicating the
;	start of the first of four consecutive 4K raw CPU pages
;	which make up a logical EMS page. Each of these logical
;	pages is currently mapped into a mappable page specified
;	by a corresponding entry in an EMS_MAPPABLE_SEG_LIST.
;
;	Both the mapping granularity and minimal alignment of
;	the 386+ CPU mapping machinary is 4K. Consequently, we
;	know that the 12 LSBs of any 4K page will always be zero
;	and so we can just throw them away. The choice of a word
;	size structure member leaves us with 16 of the remaining
;	20 address bits to describe the location of the page in
;	memory, this allows us to uniquely identify no more than:
;
;           2^(16+12) = 2^28 = 2^8 * 2^20 = 256M of memory
;
MAX_CONTEXT_SIZE        equ	255

DL_PAGE_MAP_ARRAY_ENTRY_STRUC	struc
	mappablePageNumber	db	0
	physicalPageNumber	dw	0
DL_PAGE_MAP_ARRAY_ENTRY_STRUC	ends

DL_PAGE_MAP_LIST 	struc
	pageMapEntries		db	0
	firstPageMapArrayEntry	DL_PAGE_MAP_ARRAY_ENTRY_STRUC <?>
DL_PAGE_MAP_LIST 	ends

; We currently only support the four mappable pages of the LIM 3.2
; page frame. Since both the number of mappable pages and the number
; of contexts is fixed by design, we statically allocate our context
; save areas. This is what they look like.
;
DL_EMS_CONTEXT struc
	hdr DL_PAGE_MAP_LIST		<>
	cdr DL_PAGE_MAP_ARRAY_ENTRY_STRUC   (LIM32_MAPPABLE_PAGES-1) dup(<>)
DL_EMS_CONTEXT ends


; The description of the structure passed by the user to fn 57xxh
;
EMS_MOVEX_STRUCT	struc
	regionSize       	dd	?	; 00h
	sourceMemType		db	?       ; 04h
	sourceHandle		dw	?       ; 05h
	sourceOffset		dw	?       ; 07h
	sourcePageOrSegment     dw      ?       ; 09h
	destMemType             db      ?       ; 0Bh
	destHandle              dw      ?       ; 0Ch
	destOffset              dw      ?       ; 0Eh
	destPageOrSegment       dw      ?       ; 10h
EMS_MOVEX_STRUCT	ends

; This subset of the EMS_MOVEX_STRUCT is a local invention
; describing either the source or destination memory blocks.
; The F57DescripToPhysAddr routine will convert this block
; into an (absolute) phsysical address
;
F57DESCRIP	struc
	memType			db	?	; 00h
	memHandle		dw	?	; 01h
	memOffset		dw	?	; 03h
	memPageOrSegment   	dw      ?	; 05h
F57DESCRIP	ends


; This array defines the correspondence between a mappable segment
; address and a mappable page number. It is used by EMS funtion
; 5800h to define the elements of the Mappable Page Array (MPA).
;
EMS_MAPPABLE_PAGE_STRUCT 	struc
	mappableMPASegment	dw	?
	mappableMPAPageNumber	dw	?
EMS_MAPPABLE_PAGE_STRUCT 	ends


; The bits below define the accessibility of the "get EMM
; hardware info" (59h), AMRS and DMARS functions (5Bxxh) and the
; "enable/disable Operating System/Environment (OS/E) functions"
; (5Dxxh) functions. Access to these functions is intended to be
; under control of the OS/E. The access state is maintained in
; the fnAccessState variable and controlled by the fn i67f5D
; interface code. (EMM386.ASM), The fnAccessState variable may
; contain any combination of the following values:
;
FULL_ACCESS_ALLOWED 	=	000b
ACCESS_KEY_ISSUED	=	010b
ACCESS_DENIED_BY_OSE	=	001b


; Error codes returned by V86Init() (MAPPER.ASM)
;
ERR_NOT_386     equ     1
ERR_CANT_REMAP  equ     2
ERR_NOT_REAL    equ     3
ERR_A20         equ     4


; GEOS specific switch, enables different header block
; and a few differences in the exception handling.
; see DrewG for additional information
;
USING_GEOS      equ     0
INT_06h         equ     (06h*4)


; Special code has been added to handle an INSB instruction
; and the conflict exception it can cause with port 60.
;
ENABLE_INSB_SUPPORT	EQU	1

