#
#   $Id: MAKETEST.MAK 1.5 2002/10/15 20:39:22Z peterb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#  Makefile for EMM386.EXE and test programs.
#
#  Copyright (c) 1994-2002 by Datalight, Inc.
#  All Rights Reserved.
#  Datalight Confidential and Proprietary
#
#  Like ALL ROM-DOS makefiles, MAKE -B RELEASE will create
#  the release executables

!if !$d(DEBUG)
DEBUG=/DDEBUG=0 /DSUPPORT_FN51=1
!endif


release : IMAVIRUS.exe
	echo made IMAVIRUS.EXE

#debug info !!!
IMAVIRUS.exe : emm386.obj mapper.obj write_p.obj vds.obj #printf.obj
	tlink /m/c/l/3 $(RD_SW_L) emm386+mapper+write_p+vds.obj,imavirus,imavirus #+printf

IMAVIRUS.sym : IMAVIRUS.exe
	msym IMAVIRUS

emm386.obj : emm386.asm

# protected and real mode debugging printf() module for use in combination
# with the LOG.EXE file from the WinLight project
#
vmmerr.obj: .\vmmdebug\vmmerr.asm
	$(TASM4) $(RD_SW_A) /dMMOD=s /DDEBUG=1 /i.\vmmdebug .\vmmdebug\vmmerr.asm

# This module can be linked w/ EMM386 to test the debug capabilities
# supplied by VMMERR.ASM and friends, that's its only purpose
#
vmmdebug.obj: .\vmmdebug\vmmdebug.asm
	$(TASM4) $(RD_SW_A) /dMMOD=s /DDEBUG=1 /i.\vmmdebug .\vmmdebug\vmmdebug.asm

mon_emm : mon_emm.exe

mon_emm.obj : mon_emm.c monitor.h 8250.pt
	$(CC) $(CFLAGS) -D$(EMMFLAGS) -c $*.c

hook_emm.obj : hook_emm.asm macros.inc
	$(TASM4) $(AFLAGS) /d$(EMMFLAGS) $*.asm

mon_emm.exe : stdos.obj mon_emm.obj hook_emm.obj 8250.obj
	$(LINK) $(LFLAGS) stdos+mon_emm+hook_emm+8250,mon_emm,,cs

test.exe : test.c mapper.asm
	bcc -v test.c mapper.asm

t1.exe : t1.obj mapper.obj
	bcc -v T1.obj mapper.obj

u.exe : u.obj mapper.obj
	BCC -v u.obj mapper.obj

backup:
	del *.obj
	del *.exe
	del *.map
	pkzip a:umb *.*

clean :
	del *.obj
	del *.exe
	del *.map


# generic rules
.c.obj:
	bcc -c $(RD_SW) $*.c
.asm.obj:
	$(TASM4) $(RD_SW_A) $(DEBUG) /i..\..\include /i.\vmmdebug $*.asm
