//
//   $Id: CMDLINE.C 1.4 2002/10/15 20:41:02Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  CMDLINE.C
//
//  Copyright (c) 1994-2002 by Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//
// declarations for code/data in CMDLINEA.ASM and EMM386.ASM
//
void parse_cmdline(char far * s);

extern unsigned frame_seg, frame_memK, frame_pages, frame_avail, frame_maxK;
extern char donot_load_high;

unsigned get_vds_buff_memK(void);
unsigned get_num_rom_ranges(void);
unsigned get_rom_range_start(void);
unsigned get_rom_range_stop(void);
void reset_variables(void);

extern unsigned num_ranges, ranges[], range_memK;



#define cbCMDLINE	0x81
typedef char far s[cbCMDLINE], CMDLINE;
CMDLINE *szCmdLines[] = {"",
								 "max=2 frame=D000,128 d=63"
								 "I=A000-AFFF I=b000-b800 I=c800-cfff frame=d000,384 I=e000-f000 max=384",
								 "max=512 A000-AFFF b000-b800 frame=e000,384 low",
								 "ROM=c000-c800 ROM=f000-ffff"
								};



// prints the variable values that can be assigned by command line arguments
//
void PrintConfigResults(void)
{ unsigned i,j,k;

	printf("\n ---- EMS DATA ---- \n");
	printf("EMM386 loaded %s.\n",donot_load_high ? "low" : "in UMB");
	printf("Page frame seg = %x\n", frame_seg);
	printf("Min = %dK (%d pages),    Max = %dK (%dK available)\n",
			frame_memK, frame_pages, frame_maxK, frame_avail);

	printf("\n ---- VDS DATA ---- \n");
	printf("VDS buffer size = %dK\n", get_vds_buff_memK());

	printf("\n ---- Include/RAM Data ---- \n");
	printf("%d ranges... ",num_ranges);
	for(i=0,j=0; i < num_ranges; i++, j+=2)
	{
		printf("  %x - %x ",ranges[j],ranges[j]+ranges[j+1]-1);
	}
	printf("\n");

	printf("\n ---- Shadow Rom Data ---- \n");
	k = get_num_rom_ranges();
	printf("%d ranges... ",k);
	for(i=0,j=0; i < k; i++, j+=2)
	{
		printf("  %x - %x ",get_rom_range_start(), get_rom_range_stop());
	}
	printf("\n");


}




// would you believe...
//
void main(int argc, char *argv[])
{ int i,cCmdLns;
  char szPspCmdLn[0x81];

	if(argc > 1)
	{
		for(i=1,szPspCmdLn[0]=0; i < argc; i++)
			strcat(szPspCmdLn,argv[i]);
		printf("\nCommand line = %c%s%c ",34,szPspCmdLn,34);
	}

	cCmdLns = (sizeof(szCmdLines) / sizeof(szCmdLines[0]));
	for(i=0; i < cCmdLns; i++)
	{
		reset_variables();
		strupr(szCmdLines[i]);
		printf("\nCommand line = """"%s""",szCmdLines[i]);
		parse_cmdline(szCmdLines[i]);
		PrintConfigResults();
	}
}
