;
;   $Id: CMDLINEA.ASM 1.4 2002/10/15 20:41:02Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  CMDLINEA.ASM
;
;  Copyright (c) 1994-2002 by Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;
; Unit Test module for EMM386 command line parser.
; The parse_cmdline proc at the bottom of this file is the command line
; parsing routine and, after being modified and tested can the be used
; as a drop in replacement for the original proc in EMM386.ASM...
;
; Note: 	This module contains a dummy xms_handler routine that always
;		returns 07FFFh in AX as the largest free XMS block size.
;
;
;

DEFAULT_UMB_START	= 0C800h
DEFAULT_UMB_END 	= 0F000h
MAXRANGES		= 4

.Model small
.Data

public  i_range, x_range
public	_frame_seg,_frame_memK,_frame_pages,_frame_avail,_frame_maxK
public  _get_vds_buff_memK
public	_get_num_rom_ranges, _get_rom_range_start, _get_rom_range_stop
public	_num_ranges, _ranges, _range_memK
public 	_reset_variables
public  _donot_load_high



; These variables are declared in the data segment of EMM386.ASM
;

i_range		db 32 dup(0)
x_range 	db 32 dup(0)

framestr        db "FRAME="
_frame_seg	dw 0,0400h,0800h,0C00h
_frame_memK	dw 256
_frame_pages	dw 16
_frame_avail	dw 0
_frame_maxK	dw 0

vds_buff_memK	dw 16

num_rom		dw 0
rom_start	dw MAXRANGES dup(0)
rom_stop	dw MAXRANGES dup(0)
rom_memK	dw 0

_num_ranges	dw 0
_ranges		dw 2*MAXRANGES dup(0)
_range_memK	dw 0

win_page_table_ptr dw 0
incremental_XMS	dw 0

_donot_load_high db 0


; These variables are only used by the unit test code
;
num_rom_read	dw	0


.Code

.386

; This is called by parse_cmdline to get the available XMS. We just return
; the defined upper limit for  both the largest free block and total free.
;
	public 	xms_handler
xms_handler	proc
	mov	ax, 07FFFh	; return values are in K-bytes
	mov	dx, 07FFFh
	ret
xms_handler	endp

comment ~ ; prototype ;
void reset_variables(void)
~
_reset_variables	proc
	push	si
	push	di
	push	es

	mov	word ptr _frame_seg, 0
	mov	word ptr _frame_seg+2, 0400h
	mov	word ptr _frame_seg+4, 0800h
	mov	word ptr _frame_seg+6, 0C00h
	mov	word ptr _frame_memK,  256
	mov	word ptr _frame_pages, 16
	mov	word ptr _frame_avail, 0
	mov	word ptr _frame_maxK,  0
	mov	word ptr vds_buff_memK,16
	xor	cx, cx
	mov	word ptr _num_ranges, cx
	mov	word ptr _range_memK, cx
	mov	word ptr num_rom_read,cx
	mov	word ptr num_rom, cx
	mov	byte ptr _donot_load_high, cl
	xor	bx, bx
	mov	cx, MAXRANGES

    rv_rom_range_loop:
	mov	word ptr rom_start[bx], 0
	mov	word ptr rom_stop[bx], 0
	add	bx, 2
    	loop	rv_rom_range_loop

	push	ds
	pop	es
	lea	di, _ranges
	xor	ax, ax
	mov	cx, MAXRANGES * 2
	cld
	rep	stosw

	lea	di, i_range
	mov	cx, 32
	rep	stosb

	lea	di, x_range
	mov	cx, 32
	rep	stosb

	pop	es
	pop	di
	pop	si
	ret
_reset_variables endp

comment ~ ; prototype ;
int _get_vds_buff_memK(void)
~
_get_vds_buff_memK proc
	mov	ax, vds_buff_memK
	ret
_get_vds_buff_memK endp

comment ~ ; prototype ;
int _get_num_rom_ranges(void)
~
_get_num_rom_ranges	proc
	mov	ax, num_rom
	ret
_get_num_rom_ranges     endp

; NOTE: the _get_rom_range_start and _get_rom_range_end routines are meant
;	to be called in pairs, _get_rom_range_start first.
;
comment ~ ; prototype ;
int _get_rom_range_start(void)
~
_get_rom_range_start    proc

	xor	ax, ax
	mov	bx, num_rom_read
	cmp	bx, num_rom
	jae	start_done

	shl	bx, 1
	mov	ax, rom_start[bx]
	inc	num_rom_read

    start_done:
	ret
_get_rom_range_start    endp

comment ~ ; prototype ;
int _get_rom_range_stop(void)
~
_get_rom_range_stop     proc

	xor	ax, ax
	mov	bx, num_rom_read
	cmp	bx, num_rom
	jae	stop_done

	shl	bx, 1
	mov	ax, rom_stop[bx]
	dec	ax

    stop_done:
	ret
_get_rom_range_stop     endp


comment ~ ; prototype ;
int toupper(char c)
~
	public _toupper
_toupper	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		if(c>='a' && c<='z')
   ;
	cmp	dl,97
	jl	short @2@98
	cmp	dl,122
	jg	short @2@98
   ;
   ;			c = c-'a'+'A';
   ;
	mov	al,dl
	add	al,224
	mov	dl,al
@2@98:
   ;
   ;		return c;
   ;
	mov	al,dl
	cbw
	jmp	short @2@122
@2@122:
   ;
   ;	}
   ;
	pop	bp
	ret
_toupper	endp


comment ~ ; prototype ;
int isterminator(char c)
~
	public _isterminator
_isterminator	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
	xor	ax,ax
   ;
   ;	{
   ;		return (c<' ' && c!='\t');
   ;
	cmp	dl, ' '
	jge	short @3@98
	cmp	dl, 9
	je	short @3@98
	inc	ax
@3@98:
   ;
   ;	}
   ;
	pop	bp
	ret
_isterminator	endp

comment ~ ; prototype ;
int isseparator(char c)
~
	public _isseparator
_isseparator	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
	xor	ax, ax
   ;
   ; {
   ;	return (c==' ' || c=='\t' || c==',' || c=='/' || c=='-' || c=='=');
   ;
	cmp	dl, ' '
	je	short @4@98
	cmp	dl, 9
	je	short @4@98
	cmp	dl, ','
	je	short @4@98
	cmp	dl, '/'
	je	short @4@98
	cmp	dl, '-'
	je	short @4@98
	cmp	dl, '='
	jne	short @4@122
@4@98:
	inc	ax
@4@122:
   ;
   ; }
   ;
	pop	bp
	ret
_isseparator	endp

comment ~ ; prototype ;
int isdigit(char c)
~
	public _isdigit
_isdigit	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		return (c>='0' && c<='9');
   ;
	cmp	dl,48
	jl	short @5@98
	cmp	dl,57
	jg	short @5@98
	mov	ax,1
	jmp	short @5@122
@5@98:
	xor	ax,ax
@5@122:
	jmp	short @5@146
@5@146:
   ;
   ;	}
   ;
	pop	bp
	ret
_isdigit	endp

comment ~ ; prototype ;
int isxdigit(char c)
~
	public _isxdigit
_isxdigit	proc	near
	push	bp
	mov	bp,sp
   ;
   ;	{
   ;		c = toupper(c);
   ;
	mov	al,byte ptr [bp+4]
	push	ax
	call	near ptr _toupper
	pop	cx
	mov	byte ptr [bp+4],al
   ;
   ;		return (isdigit(c) || (c>='A' && c<='F'));
   ;
	mov	al,byte ptr [bp+4]
	push	ax
	call	near ptr _isdigit
	pop	cx
	or	ax,ax
	jne	short @6@98
	cmp	byte ptr [bp+4],65
	jl	short @6@122
	cmp	byte ptr [bp+4],70
	jg	short @6@122
@6@98:
	mov	ax,1
	jmp	short @6@146
@6@122:
	xor	ax,ax
@6@146:
	jmp	short @6@170
@6@170:
   ;
   ;	}
   ;
	pop	bp
	ret
_isxdigit	endp

comment ~ ; prototype ;
unsigned far_atoi(char far *s)
~
	public _far_atoi
_far_atoi	proc	near
	push	bp
	mov	bp,sp
	push	si
   ;
   ;	{
   ;		unsigned val=0;
   ;
	xor	si,si
	jmp	short @7@74
@7@50:
   ;
   ;		while(isdigit(*s))
   ;		{
   ;			val*= 10;
   ;
	mov	dx,10
	mov	ax,si
	imul	dx
	mov	si,ax
   ;
   ;			val+= *s-'0';
   ;
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	cbw
	add	ax,65488
	add	si,ax
   ;
   ;			++s;
   ;
	inc	word ptr [bp+4]
@7@74:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isdigit
	pop	cx
	or	ax,ax
	jne	short @7@50
   ;
   ;		}
   ;		return val;
   ;
	mov	ax,si
	jmp	short @7@122
@7@122:
   ;
   ;	}
   ;
	pop	si
	pop	bp
	ret
_far_atoi	endp

comment ~ ; prototype ;
unsigned far_atoh(char far *s)
~
	public _far_atoh
_far_atoh	proc	near
	push	bp
	mov	bp,sp
	push	si
   ;
   ;	{
   ;		unsigned h=0;
   ;
	xor	si,si
	jmp	short @8@170
@8@50:
   ;
   ;		char c;
   ;
   ;		while(isxdigit(*s))
   ;		{
   ;			h*= 16;
   ;
	mov	dx,16
	mov	ax,si
	imul	dx
	mov	si,ax
   ;
   ;			h+= (*s>='0' && *s<='9' ? *s-'0' : toupper(*s) - 'A' + 10);
   ;
	les	bx,dword ptr [bp+4]
	cmp	byte ptr es:[bx],48
	jl	short @8@122
	les	bx,dword ptr [bp+4]
	cmp	byte ptr es:[bx],57
	jg	short @8@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	cbw
	add	ax,65488
	jmp	short @8@146
@8@122:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _toupper
	pop	cx
	add	ax,65481
@8@146:
	add	si,ax
   ;
   ;			++s;
   ;
	inc	word ptr [bp+4]
@8@170:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	jne	short @8@50
   ;
   ;		}
   ;		return h;
   ;
	mov	ax,si
	jmp	short @8@218
@8@218:
   ;
   ;	}
   ;
	pop	si
	pop	bp
	ret
_far_atoh	endp


comment ~ ; prototype ;
char far *nextparm(char far *s)
~
	public _nextparm
_nextparm	proc	near
	push	bp
	mov	bp,sp
	jmp	short @9@74
@9@50:
   ;
   ;	{
   ;		while(!isterminator(*s) && !isseparator(*s))
   ;			++s;
   ;
	inc	word ptr [bp+4]
@9@74:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @9@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isseparator
	pop	cx
	or	ax,ax
	je	short @9@50
@9@122:
	jmp	short @9@170
@9@146:
   ;
   ;		while(!isterminator(*s) && isseparator(*s))
   ;			++s;
   ;
	inc	word ptr [bp+4]
@9@170:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @9@218
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isseparator
	pop	cx
	or	ax,ax
	jne	short @9@146
@9@218:
   ;
   ;		return s;
   ;
	mov	dx,word ptr [bp+6]
	mov	ax,word ptr [bp+4]
	jmp	short @9@242
@9@242:
   ;
   ;	}
   ;
	pop	bp
	ret
_nextparm	endp

comment ~ ; prototype ;
int fmemcmpi(char far *s1, char far * s2, int n)
~
	public _fmemcmpi
_fmemcmpi	proc	near
	push	bp
	mov	bp,sp
	dec	sp
	dec	sp
	push	si
	mov	si,word ptr [bp+12]
	jmp	short @10@74
@10@50:
   ;
   ;	{
   ;		char c1,c2;
   ;		while(--n>0 && (c1=toupper(*s1))==(c2=toupper(*s2)))
   ;			++s1, ++s2;
   ;
	inc	word ptr [bp+4]
	inc	word ptr [bp+8]
@10@74:
	dec	si
	jle	short @10@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _toupper
	pop	cx
	mov	byte ptr [bp-1],al
	push	ax
	les	bx,dword ptr [bp+8]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _toupper
	pop	cx
	mov	byte ptr [bp-2],al
	pop	dx
	cmp	dl,al
	je	short @10@50
@10@122:
   ;
   ;		if(c1 == c2)
   ;
	mov	al,byte ptr [bp-1]
	cmp	al,byte ptr [bp-2]
	jne	short @10@194
   ;
   ;			return 0;
   ;
	xor	ax,ax
	jmp	short @10@266
@10@194:
   ;
   ;		else if(c1 < c2)
   ;
	mov	al,byte ptr [bp-1]
	cmp	al,byte ptr [bp-2]
	jge	short @10@242
   ;
   ;			return -1;
   ;
	mov	ax,65535
	jmp	short @10@266
@10@242:
   ;
   ;		return 1;
   ;
	mov	ax,1
@10@266:
   ;
   ;	}
   ;
	pop	si
	mov	sp,bp
	pop	bp
	ret
_fmemcmpi	endp

comment ~ ; prototype ;
unsigned getnum(char far **sptr, int base)
~
	public _getnum
_getnum	proc	near
	push	bp
	mov	bp,sp
	push	si
	push	di
	mov	si,word ptr [bp+4]
   ;
   ;	{
   ;		unsigned val;
   ;		if(base == 16)
   ;
	cmp	word ptr [bp+6],16
	jne	short @11@74
   ;
   ;			val = far_atoh(*sptr);
   ;
	push	word ptr [si+2]
	push	word ptr [si]
	call	near ptr _far_atoh
	pop	cx
	pop	cx
	mov	di,ax
	jmp	short @11@98
@11@74:
   ;
   ;		else
   ;			val = far_atoi(*sptr);
   ;
	push	word ptr [si+2]
	push	word ptr [si]
	call	near ptr _far_atoi
	pop	cx
	pop	cx
	mov	di,ax
@11@98:
	jmp	short @11@146
@11@122:
   ;
   ;		while(isxdigit(**sptr))
   ;			++(*sptr);
   ;
	inc	word ptr [si]
@11@146:
	les	bx,dword ptr [si]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	jne	short @11@122
   ;
   ;		return val;
   ;
	mov	ax,di
	jmp	short @11@194
@11@194:
   ;
   ;	}
   ;
	pop	di
	pop	si
	pop	bp
	ret
_getnum	endp


comment &
   HISTORY:
   --------

   11/12/97: <PPP> e-mail: paulpp@jvl-ent.com
   1. Command line parameters now have precedence over autodetect.

   06/21/97: (DKH)
   1.  Fixed a problem with PIC # 2 interrupts during hlt instructions.  Also
       fixed a problem in which the machine crashes if there are no UMBs.
&


comment ~ ; prototype ;
void parse_cmdline(char far * s)
~
	public	_parse_cmdline
_parse_cmdline	proc	near
	push	bp
	mov	bp,sp
	push	si
	push	di

	sub	sp,64	; make space for i_cmd, x_cmd
	; [bp-4]
i_cmd	equ	word ptr [bp-4-32]
x_cmd	equ	word ptr i_cmd-32
	; clear i_cmd, x_cmd
	mov	ax,0
	mov	cx,32
	push	ss
	pop	es
	lea	di,x_cmd
	cld
	rep	stosw

comment &
autodetection code moved here to give cmdline parameters precedence
over autodetection results. If user knows what he doing - make so.

        We have an assumed i_range of C800-F000,
	set those bits in i_range before proceeding.
&
        cld
        mov     di,offset DGROUP:i_range[25]
        mov     cx,5
        mov     al,-1
        push    ds
        pop     es
        rep     stosb           ;assumed range of C800-F000 is now in place

;We must search for BIOS extentions in the C000-FFFF range.

        mov     dx,0C000h               ; scan start segment
xtd_scan:
        mov     es,dx                   ; get target seg
        mov     ax,es:[0]               ; get id field
        cmp     ax,0AA55h               ; is it 55AAh
        jnz     next_page               ; else try next 2K
;Now do a checksum
        xor     cx,cx
        mov     ch,es:[2]                       ;get length byte
;length byte is number of 512 byte pages in extention, we have it in ch which
;means cx has the number of words in the extention.
        xor     ax,ax
ext_loop1:
        xor     si,si
ext_loop:
        add     al,es:[si]
        inc     si
        add     al,es:[si]
        inc     si
        loopnz  ext_loop        ;loop until cx = 0 or until si wraps
        jcxz    check_sum_done
;si has wrapped, add 64K to es
        mov     si,es
        add     si,4096         ;64K in segment arithmetic
        mov     es,si
        jmp     ext_loop1

check_sum_done:
;check sum is now in al, it should = zero.
        or      al,al
        mov     es,dx                   ;es may have been trashed
        jnz short next_page             ;jmp if not a valid BIOS extention
;This is a valid BIOS extention, mark it in the x_range
        movzx   cx,byte ptr es:[2]      ; get length in 512 byte pages
        add     cx,7
        shr     cx,3                    ;round up to nearest 4K
;cx contains the number of 4K pages in the extention
        movzx   bx,dh                   ;round start down to 4K
ext_loop2:
        bts word ptr x_range,bx
        inc     bx
        loop    ext_loop2

next_page:
        add     dx,0080h
        jnc     xtd_scan

;check ranges to see if they are all 1s or all 0s
        mov     bx,0c8h         ;start of range to check
det_loop1:
        bt word ptr x_range,bx
        jc short det_a
;check the 4K page specified by bx
        mov     ax,bx
        shl     ax,8
        mov     es,ax
        xor     di,di
        mov     ax,es:[di]      ;get first byte in the range
        mov     cx,2048
        repe    scasb
        jne short det_b         ;jmp if block is not all the same
;now check if block is all 1s or all 0s
        mov     cx,ax
        or      ax,ax
        jz short det_c          ;jmp if all 0s
        inc     ax
        jnz short det_b         ;jmp if not all 1s
det_c:
;check if we can write to the block
        not     cx              ;invert value stored in block
        mov     ax,cx
        pushf
        cli
        xchg    ax,es:[0]       ;try to invert all bits in the first word
        xchg    ax,es:[0]       ;restore the word in case it is RAM
        popf
comment &
        We were checking to insure that AX was equal to the value of the
        block, some machines do not have positive enough pull ups to allow
        this test to work.  The test below should detect genuine RAM.
&
        cmp     ax,cx           ;ax should NOT equal cx unless the block is RAM
        jne short det_a         ;jmp if okay

;Block is not perfect empty space, don't risk it.
det_b:  ;the range specified in bx must be marked as an X range
        bts word ptr x_range,bx
det_a:
        inc     bl
        jnz short det_loop1     ;loop through 1 meg
	jmp short @12@98

   ;
   ;	{
   ;		static char framestr[] = "FRAME=";
   ;		unsigned end;
   ;
   ;		// skip device name
   ;		s = nextparm(s);
   ;
   ;	push	word ptr [bp+6]
   ;	push	word ptr [bp+4]
   ;	call	near ptr _nextparm
   ;	pop	cx
   ;	pop	cx
   ;	mov	word ptr [bp+6],dx
   ;	mov	word ptr [bp+4],ax
   ;	jmp	@12@434
   ;
@12@98:
   ;
   ;
   ;		// parse the whole string
   ;		while(!isterminator(*s))
   ;		{
   ;			// is it the FRAME designation?
   ;			if(fmemcmpi(framestr,s,sizeof(framestr)-1) == 0)
   ;
	push	6
	push	word ptr [bp+6]
	push	word ptr [bp+4]
	push	ds
	push	offset DGROUP:framestr
	call	near ptr _fmemcmpi
	add	sp,10
	or	ax,ax
	jne	short check_vds
   ;
   ;			{
   ;				s += sizeof(framestr)-1;	// skip the "frame=" part
   ;
	add	word ptr [bp+4],6
   ;
   ;				frame_seg = getnum(&s,16);
   ;
	mov	ax,16
	push	ax
	lea	ax,word ptr [bp+4]
	push	ax
	call	near ptr _getnum
	pop	cx
	pop	cx
        mov     _frame_seg,ax
        add     _frame_seg[2],ax
        add     _frame_seg[4],ax
        add     _frame_seg[6],ax                ;for function 4eh
   ;
   ;
   ;				// determine how much memory to devote to EMS
	mov	word ptr DGROUP:_frame_memK,0        ;assume no memory reserved for EMS
   ;
   ;				if(*s == ',')
   ;
	les	bx,dword ptr [bp+4]
	cmp	byte ptr es:[bx],','
	jne	short @12@170
   ;
   ;				{
   ;					++s;
   ;
	inc	word ptr [bp+4]
   ;
   ;					frame_memK = getnum(&s,10);
   ;
        push    10              ;use base 10 numbers
	lea	ax,word ptr [bp+4]
	push	ax
	call	near ptr _getnum
	pop	cx
	pop	cx
	mov	word ptr DGROUP:_frame_memK,ax
@12@170:
   ;
   ;				}
   ;				frame_memK &= ~0xF;		// truncate memory to nearest 16K chunk
   ;
	and	word ptr DGROUP:_frame_memK,65520
   ;
   ;			}
   ;
	jmp	@12@410

check_vds:      ;see if the string is "D="
        les     bx,[bp+4]               ;pointer to string
        cmp word ptr es:[bx],'=D'       ;cmp to D=
	jne	check_max		;jmp if not "D="

        add word ptr [bp+4],2   ;point to end of string, start of number
        push    10              ;use base 10 numbers
        lea     ax,word ptr [bp+4]
        push    ax              ;pointer to the pointer
        call near ptr _getnum
        add     sp,4            ;pop garbage
;ax is the number of K bytes to use for DMA buffering
        add     ax,3
        and     al,0fch         ;round up to nearest 4K
        cmp     ax,256
        jb short vds_okay
        mov     ax,256          ;allow no larger than 256K buffer
vds_okay:
        mov     vds_buff_memk,ax
        jmp     @12@410

check_max:
        les     bx,[bp+4]       	;pointer to string
        cmp dword ptr es:[bx],'=XAM'    ;cmp to MAX=
        jne	check_low         	;jmp if not "MAX="

        add 	word ptr [bp+4],4   	;point to end of string, start of maxK
        push    10   		        ;use base 10 numbers
	lea	ax,word ptr [bp+4]
	push	ax
	call	near ptr _getnum
	pop	cx
	pop	cx
	mov	word ptr DGROUP:_frame_maxK, ax
        jmp     @12@410


check_low:
	les	bx,[bp+4]
	cmp	word ptr es:[bx],'OL'
	jne	check_ram
	cmp	byte ptr es:[bx+2], 'W'
	jne	check_ram

	add	word ptr [bp+4], 3
	mov	byte ptr DGROUP:_donot_load_high, 1
	jmp	@12@410

	; see if the string is "RAM"
	; The "RAM" substring may or may not be followed by an
	; '=' char and a range description
	;
	; NOTE:	Right now, we do nothing here except parse the
	;	command line. Any (assumed) arguments are just
	;	thrown away.
	;
check_ram:
        les     bx,[bp+4]       		; get pointer to substring
        cmp 	word ptr es:[bx],'AR'    	; cmp to "RA"
        jne 	check_rom       		; jmp if not "RAM"
	cmp	byte ptr es:[bx+2], 'M'
        jne 	check_rom       		; jmp if not "RAM"

	add 	word ptr [bp+4],3		; skip past token
	cmp	byte ptr es:[bx+3], '=' 	; is a range being specified?
	je	check_ram_find_start_of_range   ; process it if so

	; If no range value is specified for the RAM option,
	; then MS EMM386 uses all of the "adapter space" for UMBs
	; and the LIM 3.2 page frame.
	;
    check_ram_no_range_spec:
	mov	ax, DEFAULT_UMB_START
	mov	bx, DEFAULT_UMB_END
	jmp	short check_ram_have_range_values

    check_ram_find_start_of_range:
        inc 	word ptr [bp+4]     	; skip separator char
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]	; al = current cmd line cahr
	push	ax
	call	near ptr _isseparator	; is cur char a separator?
	pop	cx
	or	ax,ax
	jnz	short check_ram_find_start_of_range ; skip cur separator char

	les	bx,dword ptr [bp+4]	; cur char not separator char
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit 	; error if cur char isn't a hex digit
	pop	cx
	or	ax,ax
	je	short check_ram_syntax_error	; handle ill formed range spec

    check_ram_get_start_of_range:
        lea     ax,[bp+4]       	; pointer to the start spec substring
        push    16              	; use base 16 numbers
        lea     ax,word ptr [bp+4]
        push    ax              	; pass pointer to the pointer
        call 	near ptr _getnum
        pop     cx
	pop	cx

	; AX = starting segment of RAM range
	; The pointer argument on the stack now points to just past
	; the "start of range" spec substring.
	;
    check_ram_have_start_of_range:
    	push	ax			; save the start of range value

	; there must be at least one separator char between the start
	; and the stop range specs...
	;
    check_ram_find_end_of_range:
        inc 	word ptr [bp+4]     	; skip separator char
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]	; al = current cmd line cahr
	push	ax
	call	near ptr _isseparator	; is cur char a separator?
	pop	cx
	or	ax,ax
	jne	short check_ram_find_end_of_range ; skip cur separator char

	les	bx,dword ptr [bp+4]	; cur char not separator char
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit 	; error if cur char isn't a hex digit
	pop	cx
	or	ax,ax
	pop	ax				; AX = start seg value
	je	short check_ram_syntax_error	; handle ill formed range spec

	push	ax			; save start of range value again

    check_ram_get_end_of_range:
        lea     ax,[bp+4]       	; pointer to the end spec substring
	push	16
        push    ax
        call 	near ptr _getnum
        pop     cx
        pop     cx

	; AX = ending segment value of the RAM range, the
	; starting segment value of the range is on the top of
	; the stack. The command tail pointer argument on the
	; stack now points to just past the "end of range" spec
	; substring.
	;
    check_ram_have_end_of_range:
	mov	bx, ax
	pop	ax

	; The 'RAM=' option was found on the command line
	; AX = the (assumed) "start of range" segment value
	; BX = the (assumed) "end of range" segment value
	;
	; If the range is assumed (because RAM appeared by itself on
	; the command line) then the RAM range will overlap the LIM 3.2
	; page frame, ROM regions and Included/eXcluded regions.
	;
    check_ram_have_range_values:
	;
	; We do nothing with these values yet.
	;
	nop

    check_ram_done:
        jmp     @12@410

	; The 'RAM=' option was found on the command line but the
	; the argument was ill formed. The pointer at [bp+4] points
	; to the offending portion of the command line.
	;
    check_ram_syntax_error:
	;
	; whatawedonow?
	;
	nop

	; The code at the top of the argument processing loop
	; checks to see if we are on a non-separator char and, if so,
	; assumes we are on part of an argument skips over the
	; remainder of that "argument" to find some separators.
	; Back up to some white space.
	;
    check_ram_backup_to_a_sep:
        dec 	word ptr [bp+4]     	; skip separator char
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]	; al = current cmd line cahr
	push	ax
	call	near ptr _isseparator	; is cur char a separator?
	pop	cx
	or	ax,ax
	jz	short check_ram_backup_to_a_sep ; find a separator char
	jmp	@12@410


check_rom:      ;see if the string is "ROM="
        les     bx,[bp+4]       ;pointer to string
        cmp dword ptr es:[bx],'=MOR'    ;cmp to ROM=
        jne short @12@194       ;jmp if not "ROM="
        add word ptr [bp+4],4   ;point to end of string, start of range
        push    16              ;use base 16 numbers
        lea     ax,word ptr [bp+4]
        push    ax              ;pointer to the pointer
        call near ptr _getnum
        pop     cx              ;pop pointer only
        xor     al,al           ;round segment down to nearest 4K
        mov     bx,DGROUP:num_rom
;if we have already done 4 ROM ranges, dec num_rom before continuing
        cmp     bx,4
        jb short num_rom_okay
        dec     bx
        mov     num_rom,bx      ;set num_rom back to 3
num_rom_okay:
        shl     bx,1
        mov     DGROUP:rom_start[bx],ax
        inc word ptr [bp+4]     ;point to rom_stop
        lea     ax,[bp+4]       ;pointer to the string
        push    ax
        call near ptr _getnum
        pop     cx
        pop     cx
        mov     bx,DGROUP:num_rom
        shl     bx,1
        inc     ax              ;bump it up if ending in FFF
        xor     al,al           ;round segment address down to 4k
        mov     DGROUP:rom_stop[bx],ax
        sub     ax,DGROUP:rom_start[bx] ;calculate number of paragraphs
;If the top end was 1 meg, we just subtracted the start address from zero.
;This actually works for calculating the size.
        shr     ax,6            ;convert paragraphs to K
        add     DGROUP:rom_memK,ax
        inc     DGROUP:num_rom
        jmp     @12@410

@12@194:
   ;			// is it a memory range?
	les	bx,dword ptr [bp+4]
	mov	bx,es:[bx]
	push	bx
	call	near ptr _isxdigit
	pop	cx
        lea     si,i_cmd	;<PPP>
	or	ax,ax
	jnz	@@0
;check for I=
        and     bl,not 20h              ;convert to upper case
        cmp     bx,'=I'
        je short @@0_a
;check for X=
        lea     si,x_cmd	;<PPP>
        cmp     bx,'=X'
        jne     @12@410
@@0_a:
;It was I= or X=, dump the identifiers, find the number.  Si = either offset
;of i_range or offset x_range.
        add word ptr [bp+4],2           ;dump the 'I=' or 'X='
@@0:
   ;				// get start of range (must be on a 4K boundary)
        push    16
        lea     ax,[bp+4]
        push    ax
        call    _getnum         ;returns ax = number
        pop     cx
        pop     cx
        xor     al,al                   ;round down to nearest 4K
        push    ax              ;save for now
        jmp short @12@290
@12@266:
   ;
   ;
   ;				// get end of range (must be on a 4K boundary)
   ;				// allow both D000-DFFF and D000-E000 to work
   ;				while(!isterminator(*s) && !isxdigit(*s))
   ;					++s;
   ;
	inc	word ptr [bp+4]
@12@290:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @12@338
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	je	short @12@266
@12@338:
   ;
   ;				end = getnum(&s,16);
   ;
	mov	ax,16
	push	ax
	lea	ax,word ptr [bp+4]
	push	ax
	call	near ptr _getnum
        pop     ecx
;ax has the end segment address, round up to nearest 4K
        add     ax,255
        jnc short rl_1
;We have wrapped over the top, ah is now zero, set it back down
        dec     ah
rl_1:
        mov     al,0
        pop     bx              ;start of block
;check if start and stop addresses are appropriate
        sub     ax,bx           ;is top below or equal to start?
        jbe short @12@410       ;jmp if not appropriate
        or      bx,bx           ;is the start zero?
        jz short @12@410        ;jmp if not appropriate
        movzx   cx,ah           ;number of 4K pages in range
        movzx   bx,bh           ;4K index for start
r_loop:
        bts	ss:[si],bx      ;<PPP> set the proper bit in the range array
        inc     bx
        loop    r_loop

@12@410:
   ;
   ;				}
   ;			}
   ;
   ;			// on to the next parameter
   ;			s = nextparm(s);
   ;
	push	word ptr [bp+6]
	push	word ptr [bp+4]
	call	near ptr _nextparm
	pop	cx
	pop	cx
	mov	word ptr [bp+6],dx
	mov	word ptr [bp+4],ax
@12@434:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
        je      @12@98                  ;loop until we find the termination

; The command line has been parsed. Now apply I= and X= parameters.

	xor	si,si	; index/offset
apply_ix_cmd:
	mov	ax,i_cmd[si]
	or	word ptr i_range[si],ax	; apply I=
	not	ax
	and	word ptr x_range[si],ax	; I= takes over autodetect
	mov	ax,x_cmd[si]
	or	word ptr x_range[si],ax	; apply X= over I=
	add	si,2
	cmp	si,32
	jb	apply_ix_cmd


comment &
        There are a number of things which can over ride the i_range bits.
        First, we must take care of the FRAME segment and the ROM= ranges.
&
        movzx   bx,byte ptr _frame_seg[1]
        mov     cx,16
det_h:  bts word ptr x_range,bx
        inc     bx
        loop    det_h
;set the bits corresponding to the ROM=ranges
        mov     cx,num_rom
        jcxz short det_k
        xor     si,si           ;si is 2 * index
det_loop4:
        movzx   bx,byte ptr rom_start[si+1]
        movzx   dx,byte ptr rom_stop[si+1]
        or      dx,dx
        jnz short det_loop5     ;is dx zero?
;dx is zero, rom_stop is 1 meg, adjust dx accordingly
        inc     dh
det_loop5:
        bts word ptr x_range,bx
        inc     bx
        cmp     bx,dx
        jb      det_loop5
        add     si,2
        loop    det_loop4

det_k:


;The x_range and i_range arrays have been initialized, any bit in the x_range
;that has been set must be cleared in the i_range.
        mov     si,offset DGROUP:x_range
        mov     di,offset DGROUP:i_range
        mov     cx,16
det_loop2:
        lodsw                   ;get a word from the x_range
        not     ax
        and     ds:[di],ax      ;clear the required bits
        add     di,2
        loop    det_loop2
;i_range now accurately specifies the ranges, fill in the _range array
        xor     dx,dx           ;_range_memK
        xor     bx,bx           ;bit index for i_range
        xor     si,si           ;_num_ranges*4
det_loop3:
        bt word ptr i_range,bx
        jc short det_d          ;jmp if UMB
det_i:
        inc     bl              ;point to next 4K page
        jnz short det_loop3     ;loop through 1 meg
;done, exit the loop
        jmp short det_l

det_d:
;bx points to a block to be used for UMB, will it fit in the current range?
        or      dx,dx
        jz short det_e         ;jmp if the first time through
        mov     ax,word ptr _ranges[si]         ;get the start segment
        add     ax,word ptr _ranges[si+2]       ;add the size
;ax contains the segment address of the top of the current range.
        cmp     ah,bl
        jne short det_g                 ;jmp if not contiguous
;things are contiguous, increase the size of the range by 4K or 256 paragraphs
det_j:
        inc byte ptr _ranges[si+3]      ;increment the high byte
;increase size of _range_memK by 4K
        add     dx,4
        jmp     det_i

det_g:  ;start a new range
        add     si,4            ;point to next range
        cmp     si,MAXRANGES*4
        jae short det_f         ;jmp if no more ranges allowed
det_e:  ;si is a pointer to a new range, initialize the start address
        mov byte ptr _ranges[si+1],bl   ;start address in segment form
        jmp     det_j

det_l:
        or      dx,dx
        jz short det_f          ;don't increment si if no UMBs
        add     si,4            ;change from index to num_ranges*4

det_f:  ;finished initializing the _range array, save _range_memK
        mov     _range_memK,dx
        shr     si,2            ;divide by 4
        mov     _num_ranges,si
comment &
        Examine the results and see if we have enough memory to do everything
        requested.  Prioritize as follows:
                1.  UMBs
                2.  ROM=
                3.  VDS
                4.  EMS
&


        mov     AH,8
        call    xms_handler             ;sizeK returned in AX
        and     al,0fch                 ;round down to nearest 4K
	and	dl,0fch

	push	bx
	push	cx

	mov	bx, _frame_maxK		; if no max= on the command line
	or	bx, bx
	jz	short pcmdln_limit_max

    pcmdln_have_max:
	cmp	bx, dx
	jbe	short pcmdln_limit_min

    pcmdln_limit_max:
	mov	bx, dx			; use all the EMS we can get

    pcmdln_limit_min:
	cmp	bx, _frame_memK		; if max < min
	jae	short pcmdln_set_max

	mov	_frame_memK, bx		; then set min to max

    pcmdln_set_max:
	mov	_frame_maxK, bx		; update EMS maxK variable
	pop	cx
	pop	bx

        mov     si,ax                   ;save largest XMS block in si
        sub     si,_range_memK
        ja short @12@506                ;jmp if enough for UMBs

;we don't have enough memory for UMBs, use what we have.
        mov     _range_memK,ax
;all others must now be set to zero.
        xor     ax,ax
        mov     rom_memK,ax             ;no ROM=
        mov     rom_start,ax
no_vds:
        xor     ax,ax
        mov     vds_buff_memk,ax
no_ems:
        xor     ax,ax
        mov     _frame_memK,ax          ;zero EMS
	mov	_frame_maxK,ax
        mov     _frame_seg,ax           ;no page frame
        jmp     short cmd_ret

@12@506:
        mov     ax,si                   ;save in case of error
        sub     si,rom_memK             ;allow for rom_memK
        ja short l1                     ;jmp if enough for ROM=
;not enough for ROM=, use what we have.
        mov     rom_memK,ax
        mov     rom_start,ax            ;disable ROM=
        jmp     no_vds
l1:
        mov     ax,si                   ;save in case of error
        sub     si,vds_buff_memk        ;allow for vds buffer
        ja short l2                     ;jmp if enough for VDS buffer
;not enough memory for DMA buffer, use what we have
        mov     vds_buff_memk,ax
        jmp     no_ems
l2:
   ;		// adjust size of EMS memory (in case there's not enough)
   ;		if(frame_memK > totalxms)
   ;
        mov     ax,si                   ;save in case of error
;calculate the memory needed for this size _frame_memK
;we need extra memory for the EMS page tables if windows starts
        xor     edx,edx
        cmp     dx,_frame_seg
        mov     dx,ax                   ;total available XMS memory in kbytes
        jz      cmd_ret                 ;jmp if no EMS
;allow 64 bytes for system handle and round up to nearest 4K
        add     edx,64+4096
        shr     edx,10                  ;convert to k bytes
        and     dl,0fch                 ;4K align
        mov word ptr win_page_table_ptr,dx      ;save for now
        mov     cx,ax                   ;total XMS memory
        sub     cx,dx
        jc      no_ems                  ;jmp if no EMS memory available
;dx contains the memory needed for page tables, cx contains the max possible
;EMS memory.

	cmp	cx,_frame_maxK
	jbe	@12@5539

	mov	cx,_frame_maxK

@12@5539:
        cmp     cx,_frame_memK          ;do we have enough for command line?
        ja 	short @12@554           ;jmp if enough memory
;not enough for requested EMS, use what we have.
        mov     _frame_memK,cx
	mov	_frame_maxK,cx
@12@554:
;frame_pages = max possible EMS memory in pages
        shr     cx,4                    ;convert kbytes to EMS pages.
        mov     _frame_pages,cx
;frame_avail = _frame_memK expressed in 16K pages
        mov     ax,_frame_memK
        shr     ax,4                    ;divide by 16
        mov     _frame_avail,ax
;calculate incremental_XMS.
        sub     si,_frame_memK          ;si is max EMS - reserved for EMS
;si is the number of kbytes which can be swapped from XMS to EMS.
;we want to divide that amount by about 8.
        shr     si,7                    ;divide by 8 and convert to 16K pages
        mov     incremental_XMS,si
cmd_ret:

	add	sp,64	; remove locals

	pop	di
	pop	si
	pop	bp
	ret
_parse_cmdline	endp


@curseg	ends
	end
