;
;   $Id: INTELX86.INC 1.4 2002/10/15 20:42:12Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~ /*-------------------------------------------------------------
        $DOCFILE:INTELX86.INC

        Copyright (C) Datalight, Inc. 1996-2002
        All Rights Reserved.
        Datalight Confidential and Proprietary.

	This file Intel x86 defines.

        $DOCHISTORY
	12/05/96 gp	Created
	12/19/96 gp	Added a bunch of stuff from WINLIGHT.INC
	02/18/97 gp	Updated the header
	06/13/97 gp	Updated some comments.
	06/18/97 gp	Updated the DESCRIPTOR structure to be compatible
			with the C version.
----------------------------------------------------------------------*/ ~

; CPU flags
CPUFLAG_CARRY		equ <0001h>
CPUFLAG_RESERVED1	equ <0002h>
CPUFLAG_PARITY		equ <0004h>
CPUFLAG_RESERVED2	equ <0008h>
CPUFLAG_AUX		equ <0010h>
CPUFLAG_RESERVED3	equ <0020h>
CPUFLAG_ZERO 		equ <0040h>
CPUFLAG_SIGN		equ <0080h>
CPUFLAG_TRAP		equ <0100h>
CPUFLAG_INTERRUPT	equ <0200h>
CPUFLAG_DIRECTION	equ <0400h>
CPUFLAG_OVERFLOW	equ <0800h>
CPUFLAG_IOPLMASK	equ <3000h>
CPUFLAG_NESTED		equ <4000h>
CPUFLAG_RESERVED4	equ <8000h>
CPUFLAG_RESUME   	equ <10000h>	; 386 and later
CPUFLAG_VIRTUAL86	equ <20000h>	; 386 and later
CPUFLAG_ALIGNMENT	equ <40000h>	; 386 and later


;--------------------------------------------
; Selector/Descriptor stuff

DESCRIPTOR	struc
descLimitLo	dw  0	; low 16 bits of limit
descBaseLo	dw  0	; low 16 bits of base address
descBaseMid	db  0	; middle 8 bits of base address
descAccess	db  0	; access rights byte (LAR)
descStatus	db  0	; 0-3 is high 4 bytes of limit, remainder is status
descBaseHi	db  0	; high 8 bits of base address
DESCRIPTOR	ends

; Access Rights byte layout
AR_ACCESSED	equ <00000001b>
AR_EXECREAD     equ <00000010b>         ; if a CODE segment (else EXECONLY)
AR_READWRITE    equ <00000010b>         ; if a DATA segment (else READONLY)
AR_CONFORMING   equ <00000100b>         ; if a CODE segment
AR_EXPANDDOWN	equ <00000100b>		; if a DATA segment
AR_CODE      	equ <00001000b>
AR_SEGMENT   	equ <00010000b>		; must always be set
AR_DPL0     	equ <00000000b>
AR_DPL1     	equ <00100000b>
AR_DPL2     	equ <01000000b>
AR_DPL3     	equ <01100000b>
AR_DPLMASK  	equ <01100000b>
AR_PRESENT 	equ <10000000b>

; Status byte layout
STAT_LIMITMASK	equ <00001111b>		; high 4 bits of limit
STAT_AVAILABLE	equ <00010000b>		; unused, available as needed
STAT_RESERVED	equ <00100000b>		; must always be 0
STAT_32BIT  	equ <01000000b>		; CODE segments only??
STAT_4KGRAN     equ <10000000b>		;



;-------------------------------------------
; 8259 PIC ThingyMaBobs
PIC_MASTER		equ <020h>	; master PIC base port
PIC_SLAVE		equ <0A0h>	; slave PIC base port
PIC_MASKREGISTER	equ <001h>

PIC_EOI			equ <20h>	; non-specific EOI command

IRQ8_PICFLAG		equ <01h>
