//
//   $Id: GETSORT.CPP 1.2 2002/10/15 20:43:38Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-1997 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
#include <dos.h>
#include <stdio.h>

union REGS r;
struct SREGS sr;

typedef unsigned char SortTable[256];

SortTable tables[12];

typedef struct
{
	unsigned country;
	unsigned codepage;
} CCP;

CCP list[] =
{
	{1,	437},
	{1,	850},
	{44,	437},
	{44,	850},
	{45,	850},
	{45,	865},
	{46,	437},
	{46,	850},
	{47,	850},
	{47,	865},
	{49,	850},
	{49,	437},
	{358,	850},
	{358,	437},
	{0}
};

void	SetCountry(unsigned country)
{
	r.h.ah = 0x38;
	if (country < 255)
		r.h.al = country;
	else
		r.h.al = 0xFF;

	r.x.bx = country;
	r.x.dx = 0xFFFF;
	intdos(&r,&r);
	if (r.x.cflag)
		printf("FAILED 0x38 Country %u (%u)\n", country, r.x.ax);
}

unsigned systemCodePage = 437;

void	SetCodePage(unsigned codepage)
{
	r.x.ax = 0x6602;
	r.x.bx = codepage;
	r.x.dx = systemCodePage;
	intdos(&r, &r);
	if (r.x.cflag)
		printf("FAILED 0x6602 Codepage %u (%u)\n", codepage, r.x.ax);
}

void	GetCodePage()
{
	r.x.ax = 0x6601;
	intdos(&r, &r);
	if (r.x.cflag)
		printf("FAILED 0x6601 (%u)\n", r.x.ax);
	else
	{
		printf("Code Page = %u\nSystem Code Page = %u\n", r.x.bx, r.x.dx);
		systemCodePage = r.x.dx;
	}
}

typedef struct
{
	char	infoID;
	unsigned char far * table;
} TableReturn;

void	DumpSortTable(unsigned country, unsigned codepage)
{
	TableReturn buffer;

	r.x.di = FP_OFF(&buffer);
	sr.es = FP_SEG(&buffer);
	r.x.ax = 0x6506;
	r.x.bx = codepage;
	r.x.cx = 5;
	r.x.dx = country;
	intdosx(&r, &r, &sr);
	if (r.x.cflag)
	{
		printf("FAILED Country %u Codepage %u %u\n", country, codepage, r.x.ax);
		return;
	}

	char fileName[20];
	sprintf(fileName, "%u.%u", country, codepage);

	FILE * fp = stdout;		// fopen(fileName, "w");
	if (fp)
	{
		unsigned char far * p = buffer.table + 2;
		fprintf(fp, "// Country %u CodePage %u ()\n", country, codepage);
		for (int i=0; i < 256; ++i)
		{
			if (i%8 == 0)
				fprintf(fp, "\n");
			fprintf(fp, "0x%02X, ", *p++);
		}
		fprintf(fp, "\n\n");
//		fclose(fp);
	}
}

void	DumpUpperTable(unsigned country, unsigned codepage)
{
	TableReturn buffer;

	r.x.di = FP_OFF(&buffer);
	sr.es = FP_SEG(&buffer);
	r.x.ax = 0x6502;
	r.x.bx = codepage;
	r.x.cx = 5;
	r.x.dx = country;
	intdosx(&r, &r, &sr);
	if (r.x.cflag)
	{
		printf("FAILED Country %u Codepage %u %u\n", country, codepage, r.x.ax);
		return;
	}

//	char fileName[20];
//	sprintf(fileName, "%u.%u", country, codepage);

	FILE * fp = stdout;		// fopen(fileName, "w");
	if (fp)
	{
		unsigned char far * p = buffer.table + 2;
		fprintf(fp, "// Country %u CodePage %u ()\n", country, codepage);
		for (int i=0; i < 128; ++i)
		{
			if (i%8 == 0)
				fprintf(fp, "\n");
			fprintf(fp, "0x%02X, ", *p++);
		}
		fprintf(fp, "\n\n");
//		fclose(fp);
	}
}

void main(void)
{
	for (unsigned i=0; list[i].country; ++i)
	{
		SetCountry(list[i].country);
		SetCodePage(list[i].codepage);
		GetCodePage();
//		DumpUpperTable(list[i].country, list[i].codepage);
		DumpSortTable(list[i].country, list[i].codepage);
	}
}
