;
;   $Id: I10FILT.ASM 1.2 2002/10/15 20:43:38Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;   Copyright (c) 1992-1997 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary

comment ~

This is a small interrupt handler for BIOS vidoe interrupt 10h.
It will watch for a call to load any soft font and move the upper
128 chars into the buffer pointed to _FILEFontInfo


end_comment ~

.Model small
.Data

	extrn _FILEFontPtr:dword
	extrn _FontBytesMoved:word


.Code
	assume cs:@code

		assume  ds:nothing

data_seg	dw	@data

		public 	_oldInt10h
_oldInt10h	label	dword
		dw	offset  _int_10h_filter
		dw	@code

		public	_int_10h_filter
_int_10h_filter	proc
		cmp	ax, 1100h		; if not loading a user font
		jne	done

		cmp	cx, 100h		; with 256 chars
		jne	done

		or	dx, dx			; starting at char 0
		jne	done			; then we don't char

		push	ax
		push	bx
		push	cs
		push	dx
		push	si
		push	di
		push	ds
		push	es

		; get the next destination address of our file buffer
		;
		mov	ax, es
		mov	ds, cs:data_seg

		assume	ds:@data

		les	di, _FILEFontPtr

		assume	ds:nothing

		; get the source address for the font info, we will want to
		; move exactly the upper half of the the font table into our
		; buffer
		;
		mov	ds, ax
		mov	si, bp			; start of font in es:bx on entry
		mov	al, 128d		; we want chars 128...255
		mul	bh			; bytes per char in bh
		mov	cx, ax			; will move same number of bytes
		add	si, ax			; as we want to skip over

		; move it
		;
		cld
		rep	movsb


		; We have the font data.
		; Tell the main program the number of bytes that we moved
		;
		mov	ds, cs:data_seg

		assume	ds:@data

		mov	_FontBytesMoved, ax

		pop	es
		pop	ds
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	ax

	done:
		jmp	dword ptr cs:_oldInt10h

_int_10h_filter	endp


; Swaps the pointer in the current vector table with the pointer in
; the _oldInt10h variable
;
		public	_SwapVidFilter
_SwapVidFilter	proc

		xor	ax, ax
		mov	es, ax
		mov	bx, 10h
		shl	bx, 1
		shl	bx, 1

		cli
		mov	ax, word ptr cs:_oldInt10h
		xchg	ax, es:[bx]
		mov	word ptr cs:_oldInt10h, ax
		inc	bx
		inc	bx
		mov	ax, word ptr cs:_oldInt10h[2]
		xchg	ax, es:[bx]
		mov	word ptr cs:_oldInt10h[2], ax
		sti

		ret

_SwapVidFilter  endp

@curseg ends
end
