;
;   $Id: GROWCONV.ASM 1.4 2002/10/15 20:44:24Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------
   GROWCONV.ASM  created 12/15/95  by Drew Gislason

   Copyright (c) 1995-2002 by Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   GROWCONV v1.0

   This device driver grows conventional memory by linking
   in new address range(s).  For use on embedded system where
   RAM already exists at the specified address range(s).
   Examples (in CONFIG.SYS):

   DEVICE=GROWCONV.EXE D000-E000
   DEVICE=GROWCONV.EXE C000-D000 E800-F000

   The ranges must be real mode segment values.
----------------------------------------------------------- ~
.MODEL SMALL
.CODE
	assume DS:_TEXT

CR = 13
LF = 10
P	equ	4		; the 1st parameter to a C function

MCB	struc
   mcb_id	db	?	; /* 00 'M' for normal, 'Z' for last MCB */
   mcb_owner	dw	?	; /* 01 psp segment of owner        */
   mcb_para_cnt	dw	?	; /* 03 # of paragraphs in this MCB */
   mcb_reserved	db 11 dup (?)	; /* 05-0FH */
MCB	ends


SYSTEM_ID = 8

;------------------------------------------------
;  Device Request Header Fields
;
;  When DOS calls the device driver, the request
;  header (pointed to by ES:BX) may contain some
;  or all of the following fields:
;
CMDLEN	equ	00H	; length of command
UNIT	equ	01H	; unit # for disks
CMD	equ	02H	; the command itself
STATUS	equ	03H	; status word (0 on start)
CMDLINE equ	12H	; cmdline on init


device_header:
	dd	-1			; ptr to next device
	dw	0			; disk device
	dw	offset strategy
	dw	offset service
	dw	0			;

reqptr	dd	?

; just record the address of the request header
strategy:
	mov	word ptr cs:[reqptr], bx
	mov	word ptr cs:[reqptr+2], es	; ES:BX = packet
	retf

service:
	push	ds
	push	es

	; display sign-on message
	push	cs
	pop	ds
	mov	dx, offset signon_msg
	mov	ah, 9		; display sign-on
	int	21h

	; get pointer to request header
	lds	bx, cs:[reqptr]

	; is this INIT?
	cmp	byte ptr ds:[bx+CMD], 0		; init
	jnz	done_service

	; initialize the device driver (grow memory)
	; User typed in a command line such as
	; DEVICE=GROWCONV.EXE C000-D000
	les	bx, ds:[bx+CMDLINE]	; get command line
	push	es
	push	bx
	call	_parse_ranges
	add	sp, 4

done_service:
	; return error always
	mov	ax, 8103H
	lds	bx, cs:[reqptr]
	mov	word ptr [bx.status], ax

	pop	es
	pop	ds
	retf


comment ~ ; prototype ;
int toupper(char c)
~
	public _toupper
_toupper	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		if(c>='a' && c<='z')
   ;
	cmp	dl,97
	jl	short @2@98
	cmp	dl,122
	jg	short @2@98
   ;
   ;			c = c-'a'+'A';
   ;
	mov	al,dl
	add	al,224
	mov	dl,al
@2@98:
   ;
   ;		return c;
   ;
	mov	al,dl
	cbw
	jmp	short @2@122
@2@122:
   ;
   ;	}
   ;
	pop	bp
	ret
_toupper	endp

comment ~ ; prototype ;
int isseparator(char c)
~
	public _isseparator
_isseparator	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		return (c==' ' || c=='\t' || c==',');
   ;
	cmp	dl,32
	je	short @4@98
	cmp	dl,9
	je	short @4@98
	cmp	dl,44
	jne	short @4@122
@4@98:
	mov	ax,1
	jmp	short @4@146
@4@122:
	xor	ax,ax
@4@146:
	jmp	short @4@170
@4@170:
   ;
   ;	}
   ;
	pop	bp
	ret
_isseparator	endp

comment ~ ; prototype ;
int isterminator(char c)
~
	public _isterminator
_isterminator	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		return (c<' ' && c!='\t');
   ;
	cmp	dl,32
	jge	short @3@98
	cmp	dl,9
	je	short @3@98
	mov	ax,1
	jmp	short @3@122
@3@98:
	xor	ax,ax
@3@122:
	jmp	short @3@146
@3@146:
   ;
   ;	}
   ;
	pop	bp
	ret
_isterminator	endp

comment ~ ; prototype ;
int isdigit(char c)
~
	public _isdigit
_isdigit	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		return (c>='0' && c<='9');
   ;
	cmp	dl,48
	jl	short @5@98
	cmp	dl,57
	jg	short @5@98
	mov	ax,1
	jmp	short @5@122
@5@98:
	xor	ax,ax
@5@122:
	jmp	short @5@146
@5@146:
   ;
   ;	}
   ;
	pop	bp
	ret
_isdigit	endp

comment ~ ; prototype ;
int isxdigit(char c)
~
	public _isxdigit
_isxdigit	proc	near
	push	bp
	mov	bp,sp
   ;
   ;	{
   ;		c = toupper(c);
   ;
	mov	al,byte ptr [bp+4]
	push	ax
	call	near ptr _toupper
	pop	cx
	mov	byte ptr [bp+4],al
   ;
   ;		return (isdigit(c) || (c>='A' && c<='F'));
   ;
	mov	al,byte ptr [bp+4]
	push	ax
	call	near ptr _isdigit
	pop	cx
	or	ax,ax
	jne	short @6@98
	cmp	byte ptr [bp+4],65
	jl	short @6@122
	cmp	byte ptr [bp+4],70
	jg	short @6@122
@6@98:
	mov	ax,1
	jmp	short @6@146
@6@122:
	xor	ax,ax
@6@146:
	jmp	short @6@170
@6@170:
   ;
   ;	}
   ;
	pop	bp
	ret
_isxdigit	endp

comment ~ ; prototype ;
unsigned far_atoi(char far *s)
~
	public _far_atoi
_far_atoi	proc	near
	push	bp
	mov	bp,sp
	push	si
   ;
   ;	{
   ;		unsigned val=0;
   ;
	xor	si,si
	jmp	short @7@74
@7@50:
   ;
   ;		while(isdigit(*s))
   ;		{
   ;			val*= 10;
   ;
	mov	dx,10
	mov	ax,si
	imul	dx
	mov	si,ax
   ;
   ;			val+= *s-'0';
   ;
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	cbw
	add	ax,65488
	add	si,ax
   ;
   ;			++s;
   ;
	inc	word ptr [bp+4]
@7@74:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isdigit
	pop	cx
	or	ax,ax
	jne	short @7@50
   ;
   ;		}
   ;		return val;
   ;
	mov	ax,si
	jmp	short @7@122
@7@122:
   ;
   ;	}
   ;
	pop	si
	pop	bp
	ret
_far_atoi	endp

comment ~ ; prototype ;
unsigned far_atoh(char far *s)
~
	public _far_atoh
_far_atoh	proc	near
	push	bp
	mov	bp,sp
	push	si
   ;
   ;	{
   ;		unsigned h=0;
   ;
	xor	si,si
	jmp	short @8@170
@8@50:
   ;
   ;		char c;
   ;
   ;		while(isxdigit(*s))
   ;		{
   ;			h*= 16;
   ;
	mov	dx,16
	mov	ax,si
	imul	dx
	mov	si,ax
   ;
   ;			h+= (*s>='0' && *s<='9' ? *s-'0' : toupper(*s) - 'A' + 10);
   ;
	les	bx,dword ptr [bp+4]
	cmp	byte ptr es:[bx],48
	jl	short @8@122
	les	bx,dword ptr [bp+4]
	cmp	byte ptr es:[bx],57
	jg	short @8@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	cbw
	add	ax,65488
	jmp	short @8@146
@8@122:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _toupper
	pop	cx
	add	ax,65481
@8@146:
	add	si,ax
   ;
   ;			++s;
   ;
	inc	word ptr [bp+4]
@8@170:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	jne	short @8@50
   ;
   ;		}
   ;		return h;
   ;
	mov	ax,si
	jmp	short @8@218
@8@218:
   ;
   ;	}
   ;
	pop	si
	pop	bp
	ret
_far_atoh	endp

comment ~ ; prototype ;
unsigned getnum(char far **sptr, int base)
~
	public _getnum
_getnum	proc	near
	push	bp
	mov	bp,sp
	push	si
	push	di
	mov	si,word ptr [bp+4]
   ;
   ;	{
   ;		unsigned val;
   ;		if(base == 16)
   ;
	cmp	word ptr [bp+6],16
	jne	short @11@74
   ;
   ;			val = far_atoh(*sptr);
   ;
	push	word ptr [si+2]
	push	word ptr [si]
	call	near ptr _far_atoh
	pop	cx
	pop	cx
	mov	di,ax
	jmp	short @11@98
@11@74:
   ;
   ;		else
   ;			val = far_atoi(*sptr);
   ;
	push	word ptr [si+2]
	push	word ptr [si]
	call	near ptr _far_atoi
	pop	cx
	pop	cx
	mov	di,ax
@11@98:
	jmp	short @11@146
@11@122:
   ;
   ;		while(isxdigit(**sptr))
   ;			++(*sptr);
   ;
	inc	word ptr [si]
@11@146:
	les	bx,dword ptr [si]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	jne	short @11@122
   ;
   ;		return val;
   ;
	mov	ax,di
	jmp	short @11@194
@11@194:
   ;
   ;	}
   ;
	pop	di
	pop	si
	pop	bp
	ret
_getnum	endp

comment ~ ; prototype ;
/*
   Look for the next parameter.  Will stop on any terminator
   via isterminator().  Will skip all following separators via
   isseparator().

   Examples: DEVICE=XYZ
*/
char far *nextparm(char far *s)
~
	public _nextparm
_nextparm	proc	near
	push	bp
	mov	bp,sp
	jmp	short @9@74
@9@50:
   ;
   ;	{
   ;            /* skip the current parameter */
   ;		while(!isterminator(*s) && !isseparator(*s))
   ;			++s;
   ;
	inc	word ptr [bp+4]
@9@74:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @9@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isseparator
	pop	cx
	or	ax,ax
	je	short @9@50
@9@122:
	jmp	short @9@170
@9@146:
   ;
   ;		while(!isterminator(*s) && isseparator(*s))
   ;			++s;
   ;
	inc	word ptr [bp+4]
@9@170:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @9@218
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isseparator
	pop	cx
	or	ax,ax
	jne	short @9@146
@9@218:
   ;
   ;		return s;
   ;
	mov	dx,word ptr [bp+6]
	mov	ax,word ptr [bp+4]
	jmp	short @9@242
@9@242:
   ;
   ;	}
   ;
	pop	bp
	ret
_nextparm	endp

comment ~ ; prototype ;
struct MCB far * last_mcb(void)
~
_last_mcb	proc	near

	; Get first MCB, returns LOL, ES:[BX-2] = 1st MCB
	mov	ah, 52H
	int	21H
	mov	ES, ES:[BX-2]

	; are we at the last MCB?
try_again:
	cmp	ES:[mcb_id], 'Z'	; ID must be 'Z' for last one
	jz	found_last

	; is the MCB valid?
	cmp	ES:[mcb_id], 'M'	; ID must be 'M' for other MCBs
	jnz	bogus_mcb

	; move on to next MCB
	mov	AX, ES
	add	AX, ES:[mcb_para_cnt]
	inc	AX
	mov	ES, AX
	jmp	short try_again

bogus_mcb:
	xor	DX, DX
	jmp	short done_mcb

found_last:
	mov	DX, ES
done_mcb:
	xor	AX, AX
	ret
_last_mcb	endp

comment ~ ; prototype ;
int _is_RAM(unsigned seg)
~
	public _is_RAM
_is_RAM		proc	near
	push	bp
	mov	bp, sp

	; change the byte to at least 2 values
	mov	ES, P[BP]
	mov	byte ptr ES:[0], 5AH
	cmp	byte ptr ES:[0], 5AH
	jnz	no_ram
	mov	byte ptr ES:[0], 0A5H
	cmp	byte ptr ES:[0], 0A5H
	jnz	no_ram

	; worked! RAM is there.
	mov	AX, 1
	jmp	short done_ram
no_ram:
	xor	AX, AX
done_ram:
	pop	bp
	ret
_is_RAM		endp

comment ~ ; prototype ;
/*
   Given a segment and length in paragraphs, add this range
   to the current MCB chain.

   Returns TRUE if worked, FALSE if failed.  The only reason
   why it would fail is if the range did not really have RAM
   there.
*/
int add_range(unsigned seg, unsigned paras)
~
	public _add_range
_add_range	proc	near
	push	bp
	mov	bp, sp

	; check parameters. seg and paras must be non-zero
	cmp	word ptr P[BP], 0
	jnz	ar_ok1
	jmp	ar_failed
ar_ok1:	cmp	word ptr P[BP+2], 0
	jz	ar_failed

	; does the range start with RAM?
	push	P[BP]
	call	_is_RAM
	pop	CX
	or	AX, AX
	jz	ar_failed

	; does the range end with RAM?
	mov	AX, P[BP]
	add	AX, P+2[BP]	; add (size - 1)
	dec	AX		; example: D000, len 800H, should be D7FFH
	push	AX
	call	_is_RAM
	pop	CX
	or	AX, AX
	jz	ar_failed

	; create the MCB in the new range
	mov	ES, P[BP]
	mov	ES:[mcb_id], 'Z'		; mark as last MCB
	mov	ES:[mcb_owner], 0		; mark as free
	mov	AX, P+2[BP]
	dec	AX				; paras-1 to allow room
	mov	ES:[mcb_para_cnt], AX		; for this MCB

	; find the last MCB
	call	_last_mcb	; should return in DX:AX
	cmp	DX, 0		; seg of 0 means bogus MCB chain
	jz	ar_failed
	cmp	AX, 0		; low word MUST be 0, should be seg:0
	jnz	ar_failed
	mov	ES, DX		; put seg in ES

	; shrink last MCB by 1 para for a link to the new MCB
	cmp	word ptr ES:[mcb_para_cnt], 0
	jz	ar_failed			; must be at least 1 para
	dec	word ptr ES:[mcb_para_cnt]

	; create the link
	push	DS
	mov	AX, ES
	inc	AX
	add	AX, word ptr ES:[mcb_para_cnt]	; get link segment
	mov	DS, AX
	mov	byte ptr DS:[mcb_id], 'M'
	mov	word ptr DS:[mcb_owner], SYSTEM_ID
	mov	AX, P[BP]		; size of link.  for example, if
	mov	DX, DS			; link is at 9FFF:0, and new MCB
	sub	AX, DX			; will be at C000:0, size should be
	dec	AX			; (C000-9FFF)-1
	mov	word ptr DS:[mcb_para_cnt], AX
	pop	DS

	; now, extend the MCB chain
	mov	ES:[mcb_id], 'M'

	; it worked!
	mov	AX, 1
	jmp	short ar_done

	; failed, return 0
ar_failed:
	xor	AX, AX
ar_done:
	pop	bp
	ret
_add_range	endp

comment ~ ; prototype ;
/*
   Parse the command line looking for ranges.  When each one is
   found, allocate it using add_range.  Example of ranges:
   C000-D000, D800-E000.

   Returns # of ranges defined.
*/
int parse_ranges(char far *cmdline)
~
	public _parse_ranges
_parse_ranges	proc	near
	push	bp
	mov	bp, sp
	push	si
	push	di
	push	ds

	; for this function, DS MUST equal SS.  getnum() takes a
	; near ptr to a far ptr (cmdline)
	push	ss
	pop	ds

	; DI = 0, # of ranges defined
	xor	di, di

	; drops into loop, skipping the first argument which is
	; the "DEVICE=GROWCONV.EXE" part of the cmdline

again_range:
	; skip to next argument
	; cmdline = nextparm(cmdline);
	push	P+2[BP]
	push	P[BP]		; cmdline
	call	_nextparm
	add	sp, 4
	mov	P[BP], ax	; only low word changes

	; are we done?
	les	bx, P[BP]
	mov	AL, es:[bx]
	push	AX
	call	_isterminator	; are we at the last character?
	pop	CX
	cmp	AX, 0
	jnz	done_range

	; does this argument begin with a number?
	les	bx, P[BP]
	mov	AL, es:[bx]
	push	AX
	call	_isxdigit	; does argument begin with a hex digit?
	pop	CX
	cmp	AX, 0
	jz	again_range	; invalid argument, skip to next one

	; should be in the form of "C000-C800".  The numbers MUST be
	; separated by a dash (no spaces), and the 2nd number must be
	; at least 1 paragraph bigger than the 1st number

	; unsigned getnum(char far **sptr, int base)
	mov	AX, 16
	push	AX
	lea	AX, P[BP]
	push	AX		; address of cmdline
	call	_getnum
	add	SP, 4
	or	AX, AX
	jz	bad_range	; bogus #, cannot be 0
	mov	SI, AX		; save 1st # in SI

	; next character MUST be a '-'
	les	bx, P[BP]
	cmp	byte ptr es:[bx], '-'
	jnz	bad_range	; bogus range, s/b form of C000-D000

	; skip the dash
	inc	word ptr P[BP]

	; get 2nd # of range
	mov	AX, 16
	push	AX
	lea	AX, P[BP]
	push	AX		; address of cmdline
	call	_getnum
	add	SP, 4

	; 2nd # MUST be greater than 1st #
	cmp	AX, SI
	jbe	bad_range

	; link in the range
	; add_range(unsigned seg, unsigned paras)
	sub	AX, SI
	push	AX		; AX = # of paras
	push	SI		; SI = start seg
	call	_add_range
	add	SP, 4
	or	AX, AX
	jz	bad_range	; failed to add the range!

	; worked, range added, record # of ranges
	inc	DI

	; are there more ranges in cmdline?
	jmp	short again_range

bad_range:
	push	ds		; save DS

	push	cs
	pop	ds
	mov	dx, offset badrange_msg
	mov	ah, 9
	int	21h

	pop	ds		; restore DS

	; just because THIS range was bad, there may be more
	jmp	short again_range

done_range:
	; display error message if no ranges
	cmp	di, 0
	jnz	have_ranges
	push	cs
	pop	ds
	mov	dx, offset norange_msg
	mov	ah, 9
	int	21h
have_ranges:

	; return # of ranges
	mov	ax, di

	pop	ds
	pop	di
	pop	si
	pop	bp
	ret
_parse_ranges	endp

norange_msg	label	byte
	db "Error! No valid ranges defined!",CR,LF,"$"
badrange_msg	label	byte
	db "Warning! Invalid range!",CR,LF,"$"

	;-----------------------------------------
	; entry point when run from the DOS prompt
help_screen:

	; display signon
	push	ds
	push	cs
	pop	ds
	mov	dx, offset signon_msg
	mov	ah, 9		; display sign-on
	int	21h
	pop	ds

IF 0
	; DEBUGGING!
	push	ds
	mov	ax, 81H
	push	ax
	call	_parse_ranges
	add	sp, 4
ENDIF

	; display help screen
	push	cs
	pop	ds
	mov	dx, offset help_msg
	mov	ah, 9		; display help message via DOS
	int	21h
	mov	ax, 4C01H	; terminate
	int	21H

signon_msg	label byte
	db "GROWCONV v1.0",CR,LF,"$"

help_msg	label byte
	db CR,LF
	db "This device driver grows conventional memory by linking",CR,LF
	db "in new address range(s).  RAM must already exist at the",CR,LF
	db "specified address range(s).  Examples (in CONFIG.SYS):",CR,LF
   	db CR,LF
	db "DEVICE=GROWCONV.EXE D000-E000",CR,LF
	db "DEVICE=GROWCONV.EXE C000-D000 E800-F000",CR,LF
   	db CR,LF
   	db "The ranges must be real mode segment values.",CR,LF,"$"

	END	help_screen
