//
//   $Id: KEYBDATA.C 1.4 2002/10/15 20:48:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mem.h>

#include "dosver.h"
#include "keyb.h"

// first data file
//
#include "po850.h"
#include "be850.h"
#include "be437.h"
#include "it850.h"
#include "it437.h"
#include "us437.h"
#include "us850.h"
#include "uk437.h"
#include "uk850.h"
#include "dk850.h"
#include "dk865.h"
#include "gr850.h"
#include "gr437.h"
#include "sv850.h"
#include "sv437.h"
#include "no850.h"
#include "no865.h"
#include "la437.h"
#include "la850.h"
#include "nl850.h"
#include "nl437.h"
#include "pl850.h"
#include "pl852.h"
#include "cf850.h"
#include "cf863.h"
#include "fr850.h"
#include "fr437.h"
#include "sf850.h"
#include "sf437.h"
#include "sg850.h"
#include "sg437.h"
#include "sp850.h"
#include "sp437.h"
#include "dv437.h"

// second data file
//
#include "ru437.h"
#include "ru866.h"
#include "cz850.h"
#include "cz852.h"
#include "yu850.h"
#include "yu852.h"

KeyMapping mappingList[] =
{
	{"US", 437, 0, us437canPrefixList, us437prefixes, us437normalKeys, us437letters, us437numbers},
	{"US", 850, 0, us850canPrefixList, us850prefixes, us850normalKeys, us850letters, us850numbers},
	{"UK", 437, 0, uk437canPrefixList, uk437prefixes, uk437normalKeys, uk437letters, uk437numbers},
	{"UK", 850, 0, uk850canPrefixList, uk850prefixes, uk850normalKeys, uk850letters, uk850numbers},
	{"CF", 850, 0, cf850canPrefixList, cf850prefixes, cf850normalKeys, cf850letters, cf850numbers},
	{"CF", 863, 0, cf863canPrefixList, cf863prefixes, cf863normalKeys, cf863letters, cf863numbers},
	{"CZ", 850, 0, cz850canPrefixList, cz850prefixes, cz850normalKeys, cz850letters, cz850numbers},
	{"CZ", 852, 0, cz852canPrefixList, cz852prefixes, cz852normalKeys, cz852letters, cz852numbers},
	{"UK", 850, 0, uk850canPrefixList, uk850prefixes, uk850normalKeys, uk850letters, uk850numbers},
	{"DK", 850, 1, dk850canPrefixList, dk850prefixes, dk850normalKeys, dk850letters, dk850numbers},
	{"DK", 865, 1, dk865canPrefixList, dk865prefixes, dk865normalKeys, dk865letters, dk865numbers},
	{"GR", 850, 1, gr850canPrefixList, gr850prefixes, gr850normalKeys, gr850letters, gr850numbers},
	{"GR", 437, 1, gr437canPrefixList, gr437prefixes, gr437normalKeys, gr437letters, gr437numbers},
	{"FR", 850, 1, fr850canPrefixList, fr850prefixes, fr850normalKeys, fr850letters, fr850numbers},
	{"FR", 437, 1, fr437canPrefixList, fr437prefixes, fr437normalKeys, fr437letters, fr437numbers},
	{"BE", 850, 1, be850canPrefixList, be850prefixes, be850normalKeys, be850letters, be850numbers},
	{"BE", 437, 1, be437canPrefixList, be437prefixes, be437normalKeys, be437letters, be437numbers},
	{"SV", 437, 1, sv437canPrefixList, sv437prefixes, sv437normalKeys, sv437letters, sv437numbers},
	{"SV", 850, 1, sv850canPrefixList, sv850prefixes, sv850normalKeys, sv850letters, sv850numbers},
	{"NO", 850, 1, no850canPrefixList, no850prefixes, no850normalKeys, no850letters, no850numbers},
	{"NO", 865, 1, no865canPrefixList, no865prefixes, no865normalKeys, no865letters, no865numbers},

	// NOTE: SU (Finland) is exactly the same as SV (Sweden)
	{"SU", 850, 1, sv850canPrefixList, sv850prefixes, sv850normalKeys, sv850letters, sv850numbers},
	{"SU", 437, 1, sv437canPrefixList, sv437prefixes, sv437normalKeys, sv437letters, sv437numbers},
	{"SP", 850, 0, sp850canPrefixList, sp850prefixes, sp850normalKeys, sp850letters, sp850numbers},
	{"SP", 437, 0, sp437canPrefixList, sp437prefixes, sp437normalKeys, sp437letters, sp437numbers},
	{"LA", 850, 1, la850canPrefixList, la850prefixes, la850normalKeys, la850letters, la850numbers},
	{"LA", 437, 1, la437canPrefixList, la437prefixes, la437normalKeys, la437letters, la437numbers},
	{"NL", 850, 1, nl850canPrefixList, nl850prefixes, nl850normalKeys, nl850letters, nl850numbers},
	{"NL", 437, 1, nl437canPrefixList, nl437prefixes, nl437normalKeys, nl437letters, nl437numbers},
	{"IT", 850, 0, it850canPrefixList, it850prefixes, it850normalKeys, it850letters, it850numbers},
	{"IT", 437, 0, it437canPrefixList, it437prefixes, it437normalKeys, it437letters, it437numbers},
	{"PL", 852, 1, pl852canPrefixList, pl852prefixes, pl852normalKeys, pl852letters, pl852numbers},
	{"PL", 850, 1, pl850canPrefixList, pl850prefixes, pl850normalKeys, pl850letters, pl850numbers},
	{"PO", 850, 1, po850canPrefixList, po850prefixes, po850normalKeys, po850letters, po850numbers},
	{"SF", 850, 1, sf850canPrefixList, sf850prefixes, sf850normalKeys, sf850letters, sf850numbers},
	{"SF", 437, 1, sf437canPrefixList, sf437prefixes, sf437normalKeys, sf437letters, sf437numbers},
	{"SG", 850, 1, sg850canPrefixList, sg850prefixes, sg850normalKeys, sg850letters, sg850numbers},
	{"SG", 437, 1, sg437canPrefixList, sg437prefixes, sg437normalKeys, sg437letters, sg437numbers},
	{"DV", 437, 0, dv437canPrefixList, dv437prefixes, dv437normalKeys, dv437letters, dv437numbers},

	{"YU", 850, 0, yu850canPrefixList, yu850prefixes, yu850normalKeys, yu850letters, yu850numbers},
	{"YU", 852, 0, yu852canPrefixList, yu852prefixes, yu852normalKeys, yu852letters, yu852numbers},
	{0}
};


KeyMapping mappingList2[] =
{
	{"RU", 437, 0, ru437canPrefixList, ru437prefixes, ru437normalKeys, ru437letters, ru437numbers},
	{"RU", 866, 0, ru866canPrefixList, ru866prefixes, ru866normalKeys, ru866letters, ru866numbers},
	{"CZ", 850, 0, cz850canPrefixList, cz850prefixes, cz850normalKeys, cz850letters, cz850numbers},
	{"CZ", 852, 0, cz852canPrefixList, cz852prefixes, cz852normalKeys, cz852letters, cz852numbers},

	{"YU", 850, 0, yu850canPrefixList, yu850prefixes, yu850normalKeys, yu850letters, yu850numbers},
	{"YU", 852, 0, yu852canPrefixList, yu852prefixes, yu852normalKeys, yu852letters, yu852numbers},
	{0}
};


GlobalHeader globalHeader;

void	GetSizeInfo(Header * hdr, KeyMapping * m)
{
	int i;

	for (i = 0; m->prefixes[i].scanCode; ++i)
		;
	hdr->numPrefixes = i + 1;	   // include terminator

	for (i = 0; m->normalKeys[i].scanCode; ++i)
		;
	hdr->numNormalKeys = i + 1; // include terminator

	for (i = 0; m->letters[i].scanCode; ++i)
		;
	hdr->numLetters = i + 1;		// include terminator

	for (i = 0; m->numbers[i].scanCode; ++i)
		;
	hdr->numNumbers = i + 1;		// include terminator

	hdr->totalLen =
			MAX_CAN_PREFIX +
			hdr->numPrefixes * sizeof(Prefix) +
			hdr->numNormalKeys * sizeof(NormalKey) +
			hdr->numLetters * sizeof(NormalKey) +
			hdr->numNumbers * sizeof(NormalKey);
}

void	WriteData(int fd, KeyMapping * m)
{
	Header hdr;

	strcpy(hdr.country, m->country);
	hdr.codePage = m->codePage;
	hdr.euroCapsLock = m->euroCapsLock;
	GetSizeInfo(&hdr, m);

	// now write the data
	write(fd, &hdr, sizeof(hdr));
	write(fd, m->canPrefixList, MAX_CAN_PREFIX);
	write(fd, m->prefixes, hdr.numPrefixes * sizeof(Prefix));
	write(fd, m->normalKeys, hdr.numNormalKeys * sizeof(NormalKey));
	write(fd, m->letters, hdr.numLetters * sizeof(NormalKey));
	write(fd, m->numbers, hdr.numNumbers * sizeof(NormalKey));

	++globalHeader.numMappings;
	if (hdr.numPrefixes > globalHeader.maxPrefixes)
		globalHeader.maxPrefixes = hdr.numPrefixes;
	if (hdr.numNormalKeys > globalHeader.maxNormalKeys)
		globalHeader.maxNormalKeys = hdr.numNormalKeys;
	if (hdr.numLetters > globalHeader.maxLetters)
		globalHeader.maxLetters = hdr.numLetters;
	if (hdr.numNumbers > globalHeader.maxNumbers)
		globalHeader.maxNumbers = hdr.numNumbers;
}

void main()
{
	int i;
	int fd;
	static char * fileName = KEYBDATAFILE;


	// Create the first data file
	// This has a hotkeytype of 0 meaning that <Ctrl><Alt><F1> is the
	// normal keyboard and <Ctrl><Alt><F2> is the alternate keyboard
	// that is active on bootup
	//
	memset(globalHeader.copyright, 0, sizeof(globalHeader.copyright));
	strcpy(globalHeader.copyright, COPYRIGHT);
	globalHeader.numMappings = 0;
	globalHeader.maxPrefixes = 0;
	globalHeader.maxNormalKeys = 0;
	globalHeader.maxLetters = 0;
	globalHeader.maxNumbers = 0;
	globalHeader.hotkeytype = 0;

	fd = _creat(fileName, 0);
	if (fd == -1)
	{
		printf("Can't create %s", fileName);
		exit(1);
	}
	write(fd, &globalHeader, sizeof(globalHeader));

	for (i = 0; mappingList[i].canPrefixList; ++i)
		WriteData(fd, &mappingList[i]);

	lseek(fd, 0L, SEEK_SET);
	write(fd, &globalHeader, sizeof(globalHeader));

	close(fd);

	printf("%s created successfully:\n", fileName);
	printf("  %3u keyboard layouts\n", globalHeader.numMappings);
	printf("  %3u maximum prefixes	(%4u bytes)\n",
			globalHeader.maxPrefixes, globalHeader.maxPrefixes*sizeof(Prefix));
	printf("  %3u maximum normal keys (%4u bytes)\n",
			globalHeader.maxNormalKeys, globalHeader.maxNormalKeys*sizeof(NormalKey));
	printf("  %3u maximum letter keys (%4u bytes)\n",
			globalHeader.maxLetters, globalHeader.maxLetters*sizeof(NormalKey));
	printf("  %3u maximum number keys (%4u bytes)\n",
			globalHeader.maxNumbers, globalHeader.maxNumbers*sizeof(NormalKey));


	// Create the second data file
	// This has a hot key type of 1 meaning that <Alt><LShift> is the
	// normal keyboard while <Alt><RShift> is the alternate keyboard
	// that is active on bootup
	//
	fileName = KEYBDATAFILE2;

	globalHeader.numMappings = 0;
	globalHeader.maxPrefixes = 0;
	globalHeader.maxNormalKeys = 0;
	globalHeader.maxLetters = 0;
	globalHeader.maxNumbers = 0;
	globalHeader.hotkeytype = 1;

	fd = _creat(fileName, 0);
	if (fd == -1)
	{
		printf("Can't create %s", fileName);
		exit(1);
	}
	write(fd, &globalHeader, sizeof(globalHeader));

	for (i = 0; mappingList2[i].canPrefixList; ++i)
		WriteData(fd, &mappingList2[i]);

	lseek(fd, 0L, SEEK_SET);
	write(fd, &globalHeader, sizeof(globalHeader));

	close(fd);

	printf("%s created successfully:\n", fileName);
	printf("  %3u keyboard layouts\n", globalHeader.numMappings);
	printf("  %3u maximum prefixes	(%4u bytes)\n",
			globalHeader.maxPrefixes, globalHeader.maxPrefixes*sizeof(Prefix));
	printf("  %3u maximum normal keys (%4u bytes)\n",
			globalHeader.maxNormalKeys, globalHeader.maxNormalKeys*sizeof(NormalKey));
	printf("  %3u maximum letter keys (%4u bytes)\n",
			globalHeader.maxLetters, globalHeader.maxLetters*sizeof(NormalKey));
	printf("  %3u maximum number keys (%4u bytes)\n",
			globalHeader.maxNumbers, globalHeader.maxNumbers*sizeof(NormalKey));


	exit(0);
}
