//
//   $Id: NL850.H 1.5 2002/10/15 20:48:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
unsigned char nl850canPrefixList[MAX_CAN_PREFIX] = " aAeEiIoOuUyYnN";

Prefix nl850prefixes[] =
{
    //  key,    shift,
    //      <space>
    //      a       A       e       E       i       I       o       O
    //      u       U       y       Y       n       N
    //
    {0x28,  ALTGR,          // apostrophe
        {
            239,
            160,    181,    130,    144,    161,    214,    162,    224,    // aAeEiIoO
            163,    233,    236,    237,    0,      0                       // uUyYnN
        }
    },
    {0x28,  SHIFT,  // back apostrophe
        {
            '`',
            133,    183,    138,    212,    141,    222,    149,    227,    // aAeEiIoO
            151,    235,    0,      0,      0,      0                       // uUyYnN
        }
    },
    {0x1A,  NORMAL, // umlaut (sp?)
        {
            249,
            132,    142,    137,    211,    139,    216,    148,    153,    // aAeEiIoO
            129,    154,    0,      0,      0,      0                       // uUyYnN
        }
    },
    {0x1A,  SHIFT,  // caret
        {
            '^',
            131,    182,    0,      210,    140,    215,    147,    226,    // aAeEiIoO
            150,    234,    0,      0,      0,      0                       // uUyYnN
        }
    },
    {0x0D,  ALTGR,  // tilde
        {
            '~',
            198,    199,    0,      0,      0,      0,      0,      0,      // aAeEiIoO
            0,      0,      0,      0,      164,    165                 // uUyYnN
        }
    },
    {0}
};

NormalKey nl850normalKeys[] =
{
    {0x78, ALTGR,   251},       // Alt-1        subscript 1
    {0x79, ALTGR,   253},       // Alt-2        subscript 2
    {0x7A, ALTGR,   252},       // Alt-3        subscript 3
    {0x7B, ALTGR,   172},       // Alt-4        1/4
    {0x7C, ALTGR,   171},       // Alt-5        1/2
    {0x7D, ALTGR,   243},       // Alt-6    3/4
    {0x7E, ALTGR,   159},       // Alt-7        English Monetary Pound sign
    {0x7F, ALTGR,   '{'},       // Alt-8
    {0x80, ALTGR,   '}'},       // Alt-9
    {0x82, ALTGR,   '\\'},   // Alt--
    {0x83, ALTGR,   247},   // Alt-=
    {0x29, NORMAL,  '@'},
    {0x29, SHIFT,   21},
    {0x29, ALTGR,   170},
    {0x03, SHIFT,   '"'},
    {0x05, SHIFT,   207},
    {0x07, SHIFT,   '&'},
    {0x08, SHIFT,   '/'},
    {0x09, SHIFT,   '('},
    {0x0A, SHIFT,   ')'},
    {0x0B, SHIFT,   '='},
    {0x0C, NORMAL,  '/'},
    {0x0C, SHIFT,   '?'},
    {0x0D, NORMAL,  248},   // tiny degree sign
    {0x0D, SHIFT,   '~'},
    {0x13, ALTGR,   244},
    {0x1B, NORMAL,  '*'},
    {0x1B, SHIFT,   '|'},
    {0x2B, NORMAL,  '`'},
    {0x2B, SHIFT,   '*'},
    {0x33, SHIFT,   ';'},
    {0x34, SHIFT,   ':'},
    {0x35, NORMAL,  '-'},
    {0x35, SHIFT,   '_'},
    {0x56, NORMAL,  '<'},
    {0x56, SHIFT,   '>'},
    {0x12, ALTGR,  213},    // euro (0xD5)
    {0}
};

NormalKey nl850letters[] =
{
    {0x1A, NORMAL,  134},
    {0x1A, SHIFT,   143},
    {0x27, NORMAL,  155},       // 0
    {0x27, SHIFT,   157},       // 0
    {0x28, NORMAL,  145},       // ae
    {0x28, SHIFT,   146},       // AE
    {0}
};

NormalKey nl850numbers[] =
{
    {0x53, SHIFT, ','},
    {0}
};
