;
;   $Id: OEMMOVEA.ASM 1.4 2002/10/15 20:48:06Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   OEMMOVEA.ASM  created 04/14/93  by Drew Gislason

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Real-mode move/cmp operations coded in assembly for
   speed purposes.

---------------------------------------------------------- ~
include macros.inc

cBegCode

;---------------------------------------------------------
;
;		STRING OPERATIONS
;
;---------------------------------------------------------


COMMENT ~ ; prototype ;
/*
   This move is "smart" in that it can work with overlapping
   data, either forward or backward.  That is, it does both
   these moves correctly:
	memmove(p, p+1, 5);
	memmove(p+1, p, 5);
*/
//void memmove(void *to,void *from,unsigned len)
//{}
~
	public	_memmove
_memmove:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI
	PUSH	DS

	; near move, ES must equal DS
	PUSH	DS
	POP	ES
	MOV	AX,P+2[BP]	; move forward if "from" is greater
	CMP	AX,P[BP]	; move backward if "to" is greater
	JNB	M1
	STD
	MOV	AX,1
	JMP	M2
M1:	CLD
	XOR	AX,AX
M2:	MOV	SI,P+2[BP]
	MOV	DI,P[BP]
	MOV	CX,P+4[BP]

do_move:
	OR	AX,AX
	JE	M3
	ADD	SI,CX
	DEC	SI
	ADD	DI,CX
	DEC	DI
M3:	TEST	DI,1
	JE	M4
	JCXZ	M5
	MOVSB
	DEC	CX
M4:	SUB	SI,AX
	SUB	DI,AX
	SHR	CX,1
	REP	MOVSW
	JNB	M5
	ADD	SI,AX
	ADD	DI,AX
	MOVSB
M5:	CLD
	POP	DS
	POP	DI
	POP	SI
	POP	BP
	RET

;
;   NOTE:   unlike memmove(), this routine does no
;   overlap checking at all.
;
COMMENT ; prototype
void fmemmove(void far *dst,void far *src,unsigned len)
{}
;
	public	_fmemmove, __fmemmove
__fmemmove:
_fmemmove:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI
	PUSH	DS

	CLD			; far move is always forward
	XOR	AX,AX
	MOV	DI,P[BP]	; dst
	MOV	ES,P+2[BP]
	MOV	SI,P+4[BP]	; src
	MOV	DS,P+6[BP]
	MOV	CX,P+8[BP]	; len

	JMP	do_move



COMMENT ; prototype
//void memset(void *dst,int val,unsigned len)
//{}
;
	public	_memset
_memset:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI

	; get the parameters
	PUSH	DS
	POP	ES
	MOV	DI,P[BP]
	MOV	AL,P+2[BP]
	MOV	CX,P+4[BP]

	; do the move
memset1:CLD
	REP	STOSB

	POP	DI
	POP	SI
	POP	BP
	RET


COMMENT ; prototype
void fmemset(void far *dst,int val,unsigned len)
{}
;
	public	_fmemset
_fmemset:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI

	; get the parameters
	MOV	DI,P[BP]
	MOV	ES,P+2[BP]
	MOV	AL,P+4[BP]
	MOV	CX,P+6[BP]

	; go do the move
	JMP	memset1


COMMENT ; prototype
//int memcmp(void *m1, void *m2, unsigned len)
//{}
;
	public	_memcmp
_memcmp:
	push	BP
	mov	BP,SP
	push	SI
	push	DI
	push	DS

	; get the parameters
	push	DS
	pop	ES
	mov	SI, P[BP]
	mov	DI, P+2[BP]
	mov	CX, P+4[BP]	; length of compare

	; do the compare
memcmp1:xor	AX, AX
	cld
	repz	cmpsb		; repeat while DS:SI == ES:DI
	jz	memcmp5		; m1 == m2
	dec	DI
	dec	SI
memcmp2:mov	DL, byte ptr ES:[DI]
	cmp	[SI], DL
	jb	memcmp3
	mov	AL, 1		; m1 > m2
	jmp	short memcmp5
memcmp3:mov	AX, -1		; m1 < m2

memcmp5:pop	DS
	pop	DI
	pop	SI
	pop	BP
	ret


COMMENT ; prototype
int fmemcmp(void far *m1, void far * m2, unsigned len)
{}
;
	public	_fmemcmp
_fmemcmp:
	push	BP
	mov	BP,SP
	push	SI
	push	DI
	push	DS

	; get the parameters
	mov	SI, P[BP]
	mov	DS, P+2[BP]
	mov	DI, P+4[BP]
	mov	ES, P+6[BP]
	mov	CX, P+8[BP]

	; go do the compare
	jmp	memcmp1

cEndCode
	END
