//
//   $Id: SF850.H 1.5 2002/10/15 20:48:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
unsigned char sf850canPrefixList[MAX_CAN_PREFIX] = " aAeEiIoOuUyYnN";

Prefix sf850prefixes[] =
{
    //  key,    shift,
    //      <space>
    //      a       A       e       E       i       I       o       O
    //      u       U       y       Y       n       N
    //
    {0x82, ALTGR,  // accent aigue
        {
            239,
            160,    181,    130,    144,    161,    214,    162,    224,
            163,    233,    236,    237,    0,      0
        }
    },
    {0x0D, NORMAL,  // caret
        {
            '^',
            131,    182,    136,    210,    140,    215,    147,    226,
            150,    234,      0,      0,      0,      0
        }
    },
    {0x0D, SHIFT,   // accent grave
        {
            '`',
            133,    183,    138,    212,    141,    222,    149,    227,
            151,    235,    0,      0,      0,      0
        }
    },
    {0x83, ALTGR,   // tilda
        {
            '~',
            198,    199,    0,      0,      0,      0,      228,    229,
            0,      0,      0,      0,      164,    165
        }
    },
	 {0x1B, NORMAL,
        {
            0xF9,
				132,	  142,	 137,	   211,    139,    216,    148,    153,
				129,    154,    152,      0,      0,      0
        }
	 },
    {0}
};

NormalKey sf850normalKeys[] =
{
    {0x02, SHIFT,  '+'},
    {0x78, ALTGR,  '|'},
    {0x03, SHIFT,  34},
    {0x79, ALTGR,  '@'},
    {0x04, SHIFT,  '*'},
    {0x7A, ALTGR,  '#'},
    {0x05, SHIFT,  135},
    {0x07, SHIFT,  '&'},
    {0x7D, ALTGR,  170},
    {0x7E, ALTGR,  221},
    {0x7F, ALTGR,  189},
    {0x08, SHIFT,  '/'},
    {0x09, SHIFT,  '('},
    {0x0A, SHIFT,  ')'},
    {0x0B, SHIFT,  '='},
    {0x0C, NORMAL, 39},
    {0x0C, SHIFT,  '?'},
    {0x15, CTRL,   0x1a},  // Control Z
    {0x1A, NORMAL, 138},
    {0x1A, SHIFT,  129},
    {0x1A, ALTGR,  '['},
    {0x1B, NORMAL, 34},
    {0x1B, SHIFT,  '!'},
    {0x1B, ALTGR,  ']'},
    {0x27, NORMAL, 130},
    {0x27, SHIFT,  148},
    {0x28, NORMAL, 133},
    {0x28, SHIFT,  132},
    {0x28, ALTGR,  '{'},
    {0x29, NORMAL, 245},
    {0x29, SHIFT,  248},
    {0x2B, NORMAL, '$'},
    {0x2B, SHIFT,  156},
    {0x2B, ALTGR,  '}'},
    {0x2C, CTRL,   0x19},	// Control Y
    {0x33, NORMAL, ','},
    {0x33, SHIFT,  ';'},
    {0x34, NORMAL, '.'},
    {0x34, SHIFT,  ':'},
    {0x35, NORMAL, '-'},
    {0x35, SHIFT,  '_'},
    {0x56, NORMAL, '<'},
    {0x56, SHIFT,  '>'},
    {0x56, ALTGR,  '\\'},
    {0x12, ALTGR,  213},    // euro (0xD5)
    {0}
};

NormalKey sf850letters[] =
{
    {0x15, NORMAL,  'z'},
    {0x15, SHIFT,   'Z'},
    {0x2C, NORMAL,  'y'},
    {0x2C, SHIFT,   'Y'},
    {0}
};

NormalKey sf850numbers[] =
{
    {0}
};


