//
//   $Id: yu850.h 1.4 2002/10/15 20:48:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
unsigned char yu850canPrefixList[MAX_CAN_PREFIX] = " aAeEiIoOuUyYcCdDlLnNrRsStTzZ";

Prefix yu850prefixes[] =
{
    //  key,    shift,
    //      <space>
    //      a       A       e       E       i       I       o       O
    //      u       U       y       Y       c       C       d       D
    //      l       L       n       N       r       R       s       S
    //      t       T       z       Z
    //
    {0x29, NORMAL,  // cedilla
        {
            0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      135,    128,    0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x29, SHIFT,  // dot above letter
        {
            250,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x7A, ALTGR,  // caret above letter
        {
            94,
            131,    182,    0,      0,      140,    215,    147,    226,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x7C, ALTGR,  // o above letter
        {
            248,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x7D, ALTGR,  // cedilla
        {
            0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      135,    128,    0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x7E, ALTGR,  // right apostrophe
        {
            96,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x7F, ALTGR,  // dot above letter
        {
            250,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x80, ALTGR,  // accent aigue
        {
            239,
            160,    181,    130,    144,    161,    214,    162,    224,
            163,    233,    0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0x82, ALTGR,  // umlaut
        {
            249,
            132,    142,    137,    211,    0,      0,      148,    153,
            129,    154,    0,      0,      0,      0,      0,      0,
            0,      0,      0,      0,      0,      0,      0,      0,
            0,      0,      0,      0
        }
    },
    {0}
};

NormalKey yu850normalKeys[] =
{
    {0x02, NORMAL,  '~'},
    {0x03, SHIFT,   '"'},
    {0x05, SHIFT,   207},
    {0x07, SHIFT,   '&'},
    {0x08, SHIFT,   '/'},
    {0x09, SHIFT,   '('},
    {0x0A, SHIFT,   ')'},
    {0x0B, SHIFT,   '='},
    {0x0C, NORMAL,  '+'},
    {0x0C, SHIFT,   '?'},
    {0x0D, NORMAL,  39},
    {0x0D, SHIFT,   '*'},
    {0x10, ALTGR,   92},
    {0x1A, ALTGR,   246},
    {0x1B, ALTGR,   158},
    {0x21, ALTGR,   91},
    {0x22, ALTGR,   93},
    {0x27, ALTGR,   '$'},
    {0x28, ALTGR,   225},
    {0x29, SHIFT,   250},
    {0x2B, NORMAL,  162},
    {0x2C, CTRL,    25},
    {0x2F, ALTGR,   '@'},
    {0x30, ALTGR,   '{'},
    {0x31, ALTGR,   '}'},
    {0x32, ALTGR,   21},
    {0x33, NORMAL,  ','},
    {0x33, SHIFT,   ';'},
    {0x34, NORMAL,  '.'},
    {0x34, SHIFT,   ':'},
    {0x35, NORMAL,  '-'},
    {0x35, SHIFT,   '_'},
    {0x56, NORMAL,  '<'},
    {0x56, SHIFT,   '>'},
    {0}
};

NormalKey yu850letters[] =
{
    {0x15, NORMAL,  'z'},
    {0x15, SHIFT,   'Z'},
    {0x2C, NORMAL,  'y'},
    {0x2C, SHIFT,   'Y'},
    {0}
};

NormalKey yu850numbers[] =
{
    {0x53, NORMAL, ','},
    {0}
};
