//  $Id: EXAMPLE1.C 1.1 2003/03/20 20:22:26Z thomd Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//  Copyright (c) 2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
//
//  HISTORY:
//
//  03-20-2003  pb  Created
//


//  Borland Includes
//
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <io.h>


//  Datalight Includes
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dllfn.h"


void main( void )
{
   bool fSuccessful;
   int iModeFlags;
   int iAttr;
   int iAction;
   char szFileName[LFN_MAXNAME];
   int iHandle;
   int iActionTaken;
   char szWriteBuffer[80];
   unsigned uLength;


   //  Set up our variables to create our file.
   //
   iModeFlags = OPEN_ACCESS_READWRITE;    //  Set the Mode to Read/Write
   iAttr = A_NORMAL;                      //  Set the attributes for the file
   iAction = (FILE_CREATE | FILE_OPEN);   //  Set the action to take
   strcpy( szFileName, "New Long File.txt" );

   fSuccessful = SmartCreateOpenFile( iModeFlags, iAttr, iAction,
               szFileName, &iHandle, &iActionTaken);
   if( !fSuccessful )
   {
      //  We failed to create the file
      //
      printf( "File creation error!\n" );
      exit(255);
   }


   //  Set up the write.
   //
   strcpy( szWriteBuffer, "Hello World!" );
   uLength = strlen( szWriteBuffer );
   write( iHandle, szWriteBuffer, uLength );


   //  Close the file
   //
   close( iHandle );


   return;
}
