;  $Id: DLERRCOD.INC 1.5 2003/03/20 17:11:42Z thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1997-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
;----------------------------------------------------------
;
;   ERRCODES.INC
;   Standard Datalight error code values
;   Created 04-28-97 Dennis Edwards
;
;   Copyright (c) 1997-2002 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary
;

ERR_NONE                        = 0     ; all OK
ERR_INVALID_FUNCTION            = 01h   ; invalid function
ERR_FILE_NOT_FOUND              = 02h   ; file not found
ERR_PATH_NOT_FOUND              = 03h   ; path not found
ERR_TOO_MANY_FILES              = 04h   ; too many open files
ERR_ACCESS_DENIED               = 05h   ; access denied
ERR_INVALID_HANDLE              = 06h   ; invalid handle
ERR_ARENA_TRASHED               = 07h   ; memory arena trashed
ERR_NOT_ENOUGH_MEMORY           = 08h   ; not enough memory
ERR_INVALID_BLOCK               = 09h   ; invalid block
ERR_BAD_ENVIRONMENT             = 0Ah   ; bad environment
ERR_BAD_FORMAT                  = 0Bh   ; bad format error
ERR_INVALID_ACCESS              = 0Ch   ; invalid access
ERR_INVALID_DATA                = 0Dh   ; invalid data

; reserved                      = 0Eh   ;

ERR_INVALID_DRIVE               = 0Fh   ; invalid drive
ERR_CURRENT_DIRECTORY           = 10h   ; current directory error
ERR_NOT_SAM_DEVICE              = 11h   ; not same device
ERR_NO_MORE_FILES               = 12h   ; no more files
ERR_WRITE_PROTECT               = 13h   ; attempted write to protected media
ERR_BAD_UNIT                    = 14h   ; unknown unit
ERR_DRIVE_NOT_READY             = 15h   ; drive not ready
ERR_UNKNOWN_COMMAND             = 16h   ; unknown command
ERR_CRC                         = 17h   ; data error (bad CRC)
ERR_BAD_LENGTH                  = 18h   ; bad request structure length
ERR_SEEK                        = 19h   ; disk seek error
ERR_UNKNOWN_MEDIA_TYPE          = 1Ah   ; unknown media type
ERR_SECTOR_NOT_FOUND            = 1Bh   ; specified sector not found
ERR_OUT_OF_PAPER                = 1Ch   ; printer is out of paper
ERR_WRITE_FAULT                 = 1Dh   ; write fault
ERR_READ_FAULT                  = 1Eh   ; read fault
ERR_GENERAL_FAILURE             = 1Fh   ; general failure
ERR_SHARING_VIOLATION           = 20h   ; sharing violation
ERR_LOCK_VIOLATION              = 21h   ; locking violation
ERR_INVALID_DISK_CHANGE         = 22h   ; invalid disk change
ERR_FCB_UNAVAILABLE             = 23h   ; File Control Block unavailable
ERR_SHARING_BUFFER_EXCEEDED     = 24h   ; sharing buffer overflow
ERR_CODE_PAGE_MISMATCH          = 25h   ;
ERR_HANDLE_EOF                  = 26h   ;
ERR_HANDLE_DISK_FULL            = 27h   ;

; reserved                      = 28h   ;
; reserved                      = 29h   ;
; reserved                      = 2Ah   ;
; reserved                      = 2Bh   ;
; reserved                      = 2Ch   ;
; reserved                      = 2Dh   ;
; reserved                      = 2Eh   ;
; reserved                      = 2Fh   ;
; reserved                      = 30h   ;
; reserved                      = 31h   ;

ERR_NOT_SUPPORTED               = 32h   ; network request not supported
ERR_REMOTE_NOT_LISTENING        = 33h   ; remote computer not listening
ERR_DUP_NET_NAME                = 34h   ; duplicate name on network
ERR_NET_NAME_NOT_FOUND          = 35h   ; network name not fond
ERR_NET_BUSY                    = 36h   ; network busy
ERR_NET_DEVICE_GONE             = 37h   ; network device no longer exists
ERR_NET_CMD_LIMIT               = 38h   ; net BIOS command limit exceeded
ERR_BAD_NET_HARDWARE            = 39h   ; network adapter hardware error
ERR_BAD_NET_RESPONSE            = 3Ah   ; incorrect response from network
ERR_UNEXPECTED_NET              = 3Bh   ; unexpected network error
ERR_BAD_REMOTE_HARDWARE         = 3Ch   ; incompatible remote adapter
ERR_PRINT_Q_FULL                = 3Dh   ; print queue full
ERR_NO_PRINT_FILE_SPACE         = 3Eh   ; not enough space for print file
ERR_PRINT_FILE_DELETED          = 3Fh   ; print file was deleted
ERR_NET_NAME_DELETED            = 40h   ; network name was deleted
ERR_NET_ACCESS_DENIED           = 41h   ; access denied
ERR_NET_DEV_TYPE_BAD            = 42h   ; network device type incorrect
ERR_NET_NAME_NOT_FOUND1         = 43h   ; (??? - dup of error 35h?)
ERR_NET_NAME_LIMIT              = 44h   ; network name limit exceeded
ERR_NET_SESSION_LIMIT           = 45h   ; net BIOS session limit exceeded
ERR_TEMP_PAUSE                  = 46h   ; temporarily paused
ERR_NET_REQUEST_REJECTED        = 47h   ; network request not accepted
ERR_REDIR_PAUSED                = 48h   ; print or disk redirection is paused

; reserved                      = 49h   ;
; reserved                      = 4Ah   ;
; reserved                      = 4Bh   ;
; reserved                      = 4Ch   ;
; reserved                      = 4Dh   ;
; reserved                      = 4Eh   ;
; reserved                      = 4Fh   ;

ERR_FILE_EXISTS                 = 50h   ; file already exists
ERR_DUP_FCB                     = 51h   ; FCB already exists
ERR_CANNOT_MAKE                 = 52h   ; cannot make item (directory)
ERR_INT_24_FAILURE              = 53h   ; fail returned on intr. 24h
ERR_OUT_OF_STRUCS               = 54h   ; too many redirections
ERR_ALREADY_ASSIGNED            = 55h   ; duplicate redirection
ERR_INVALID_PASSWORD            = 56h   ; invalid password
ERR_INVALID_PARAMETER           = 57h   ; invalid parameter
ERR_NET_DATA_FAULT              = 58h   ; network data fault

ERR_SYS_COMPONENT_NOT_LOADED    = 5Ah   ; missing system component

; from European DOS 4.x (multi-tasking variant not sold in USA)
;
ERR_NO_PROC_SLOTS               = 59h   ; no process slots available
ERR_NOT_FROZEN                  = 5Ah   ; not frozen error
ERR_TIMER_OVERFLOW              = 5Bh   ; timer service table overflow
ERR_TIMER_DUP                   = 5Ch   ; timer service table duplicate
ERR_NO_ITEMS                    = 5Dh   ; no items found to work on
ERR_SYSTEM_INTERRUPTED          = 5Eh   ; system call interrupted
ERR_TOO_MANY_SEMAPHORES         = 5Fh   ; too many semaphores
ERR_EXCLUSIVE_SEMAPHORE         = 60h   ; exclusive semaphore already owned
ERR_SEMAPHORE_SET               = 61h   ; semaphore was already set

; OMNIVIEW error definitions
;
ERR_NOT_FIRST_IN_CHAIN          = 62h   ; access blocked by later chained item(s)
ERR_CHAINING_FAULT              = 63h   ; item(s) unexpectedly deleted from chain
ERR_TABLE_OVERFLOW              = 64h   ; table was already full
ERR_TABLE_UNDERFLOW             = 65h   ; table was already empty
ERR_TABLE_DUPLICATE             = 66h   ; unique item already in table

; reserved                      = 67h   ;
; reserved                      = 68h   ;
; reserved                      = 69h   ;
; reserved                      = 6Ah   ;
; reserved                      = 6Bh   ;
; reserved                      = 6Ch   ;
; reserved                      = 6Dh   ;
; reserved                      = 6Eh   ;
; reserved                      = 6Fh   ;
; reserved                      = 70h   ;
; reserved                      = 71h   ;
; reserved                      = 72h   ;
; reserved                      = 73h   ;
; reserved                      = 74h   ;
; reserved                      = 75h   ;
; reserved                      = 76h   ;
; reserved                      = 77h   ;
; reserved                      = 78h   ;
; reserved                      = 79h   ;
; reserved                      = 7Ah   ;
; reserved                      = 7Bh   ;
; reserved                      = 7Ch   ;
; reserved                      = 7Dh   ;
; reserved                      = 7Eh   ;
; reserved                      = 7Fh   ;

; Datalight application error codes
;
ERR_INTERNAL                    = 80h   ; use with ASSERT()
ERR_USER_ABORT                  = 81h   ; ^C, ^Brk, Abort on int 24h, etc.
ERR_PARAMETER_MISSING           = 82h   ; required input missing










