//
//   $Id: DLMEM.H 1.6 2002/10/15 21:41:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:DLMEM.H  created 04/25/97 by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This .H file includes memory interaction routines, including XMS
	and EMS.

	$DOCHISTORY
	07-28-98   de	Added an already included guard
	06/25/1998 dg  Added Int15h routines
*********************************************************************/

#if !defined( DLMEM_H )
#define		  DLMEM_H 1

//
//		XMS Routines
//
int IsHimemInstalled(void);
unsigned TotalXMS(void);
unsigned AllocateXMS(unsigned sizeK);
void FreeXMS(unsigned handle);
void CopyToXMS(unsigned hXMS, long offset, void far *lpMem, long numBytes);
void CopyFromXMS(void far *lpMem, unsigned hXMS, long offset, long numBytes);

//
//		Int15h Memory Routines
//
unsigned Int15MemSize(void);
bool CopyToInt15(ulong lDstAddr, void far *lpSrc, unsigned nWords);
bool CopyFromInt15(void far *lpDst, ulong lSrcAddr, unsigned nWords);
bool IsFirstVDisk(void);

//
//		Int15h wrapper routines (VDISK interface aware)
//
unsigned AvailInt15Memory(void);
bool AllocateInt15Memory(unsigned sizeK, ulong *pStartAddr);
void RestoreInt15Used(void);

//
//		Memory Store Routines
//
bool InitMemStore(void);
void KillMemStore(void);
ulong MemStoreSize(void);
ulong MemStoreTell(void);
ulong MemStoreLeft(void);
void MemStoreSeek(ulong ulPosition, unsigned uWhence);
unsigned MemStoreRead(void far * lpBytes, unsigned size);
unsigned MemStoreWrite(void far * lpBytes, unsigned size);
void far * GetCurrentStoreAddress( void );

//
//  a simple Dump program
//
void Dump(void *pBuffer, unsigned nLen);


// macro to normalize a far pointer
#define Normalize(ptr, offset) (char far *)((char huge *)(ptr)+(offset))

// amount of memory needed in Memory Store
#define MIN_STORE_SIZE		(32*1024L)

#endif // #if !defined( DLMEM_H )
