//
//   $Id: DLXMS.H 1.4 2002/10/15 21:41:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*

	DLXMSLIB.H -- Low level XMS 2.0 function library header file.
	Created 10-25-97 by Dennis Edwards

   Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	All XMS 2.0 functions are provided by this library.

*/
#if !defined(_DLXMSLIB_H_)
#define _DLXMSLIB_H_

/*
 	XMS error codes returned by the functions below. Never rely
	on any values returned by these functions unless the returned
	error code is XMS_SUCCESS. Note that these values are simply
	sign extensions of the 8-bit error codes defined by the XMS
	2.0 spec. This allows for efficient return code testing.

	The GetXMSErrorCodeString() function can be used to translate
	any of these error codes for the user.

*/

#define XMS_SUCCESS									0
#define XMS_ERR_FUNCTION_NOT_IMPLEMENTED  	((int)0xFF80) // the function is not implemented
#define XMS_ERR_VDISK_DETECTED       	  		((int)0xFF81) // a VDISK device is detected
#define XMS_ERR_A20_ERROR 			      		((int)0xFF82) // an A20 error occurs
#define XMS_ERR_GENERAL_DRIVER_ERROR	 		((int)0xFF8E) // a general driver error occurs
#define XMS_ERR_UNRECOVERABLE_DRIVER_ERROR	((int)0xFF8F) // an unrecoverable driver error occurs
#define XMS_ERR_NO_HMA       		  				((int)0xFF90) // the HMA does not exist
#define XMS_ERR_HMA_IN_USE       	  			((int)0xFF91) // the HMA is already in use
#define XMS_ERR_HMAMIN_BIGGER      	  			((int)0xFF92) // DX is less than the /HMAMIN= parameter
#define XMS_ERR_HMA_NOT_ALLOCATED         	((int)0xFF93) // the HMA is not allocated
#define XMS_ERR_A20_LINE_ENABLED       	  	((int)0xFF94) // the A20 line is still enabled
#define XMS_ERR_NO_MORE_XMS       	  			((int)0xFFA0) // all extended memory is allocated
#define XMS_ERR_NO_MORE_XMS_HANDLES       	((int)0xFFA1) // all available extended memory handles are in use
#define XMS_ERR_HANDLE_INVALID		  			((int)0xFFA2) // the handle is invalid
#define XMS_ERR_SOURCE_HANDLE_INVALID	  		((int)0xFFA3) // the SourceHandle is invalid
#define XMS_ERR_SOURCE_OFFSET_INVALID	  		((int)0xFFA4) // the SourceOffset is invalid
#define XMS_ERR_DEST_HANDLE_INVALID  	     	((int)0xFFA5) // the DestHandle is invalid
#define XMS_ERR_DEST_OFFSET_INVALID    	   ((int)0xFFA6) // the DestOffset is invalid
#define XMS_ERR_LENGTH_INVALID       	 	 	((int)0xFFA7) // the Length is invalid
#define XMS_ERR_INVALID_OVERLAP       	  		((int)0xFFA8) // the move has an invalid overlap
#define XMS_ERR_PARITY_ERROR       	  			((int)0xFFA9) // a parity error occurs
#define XMS_ERR_BLOCK_NOT_LOCKED       	  	((int)0xFFAA) // the block is not locked
#define XMS_ERR_BLOCK_IS_LOCKED       	  		((int)0xFFAB) // the block is locked
#define XMS_ERR_BLOCK_LOCK_COUNT_OVERFLOW 	((int)0xFFAC) // the block's lock count overflows
#define XMS_ERR_LOCK_FAILED       	  			((int)0xFFAD) // the lock fails
#define XMS_ERR_HAVE_SMALLER_UMB       	  	((int)0xFFB0) // a smaller UMB is available
#define XMS_ERR_NO_MORE_UMBS       	  			((int)0xFFB1) // no UMBs are available
#define XMS_ERR_UMB_SEGMENT_INVALID       	((int)0xFFB2) // the UMB segment number is invalid

// xmsermsg.asm -- returns a ptr to an ASCIIZ string describing an XMM error.
//
char * PASCAL GetXMSErrorCodeString(int XMSErrorCode);

// xmsthere.asm
//
int PASCAL CheckXMMInstalled(void);

// xmsver.asm
//
int PASCAL GetXMMVersion(unsigned *pXMMVersion, unsigned *pXMMRevision,
					   bool *pHMAExists);

// xmshma.asm
//
int PASCAL RequestHMA(unsigned size);
int PASCAL ReleaseHMA(void);

// xmsa20.asm
//
int PASCAL GlobalEnableA20(void);
int PASCAL GlobalDisableA20(void);
int PASCAL LocalEnableA20(void);
int PASCAL LocalDisableA20(void);
int PASCAL QueryA20State(bool *pIsA20Enabled);

// xmsavail.asm
//
int PASCAL GetXMSFree(unsigned *pXMSLargestFreeK, unsigned *pXMSTotalFreeK);

// xmsalloc.asm
//
int PASCAL AllocateXMSBlock(unsigned blockSizeK, unsigned *pHandle);
int PASCAL FreeXMSBlock(unsigned handle);


typedef struct
{
	unsigned lpOff;
	unsigned lpSeg;
} FAR_PTR_STRUC;

typedef union
{
	unsigned long  offset32;
	FAR_PTR_STRUC	p;
} ADDRESS32;

typedef struct
{
	unsigned long 	length;  		// 32-bit number of bytes to transfer
	unsigned 		sourceHandle;  // Handle of source block
	ADDRESS32		sourceOffset;  // 32-bit offset into source
	unsigned 		destHandle;    // Handle of destination block
	ADDRESS32		destOffset;    // 32-bit offset into destination block
} XMS_MOVE_STRUCT;

// xmsmove.asm
//
int PASCAL MoveXMSBlock(XMS_MOVE_STRUCT far *lpXMSMoveStruct);

// xmslock.asm
//
int PASCAL LockXMSBlock(unsigned handle, unsigned long *pXMSBlockPhysicalAddress);
int PASCAL UnlockXMSBlock(unsigned handle);

// xmsinfo.asm
//
int PASCAL GetXMSHandleInfo(unsigned handle, unsigned *pXMSBlockLockCount,
           		     unsigned *pXMSHandlesFree, unsigned *pXMSBlockSizeK);

// xmsrealo.asm
//
int PASCAL ReallocateXMSBlock(unsigned handle, unsigned newSizeK);

// xmsumb.asm
//
int PASCAL RequestUMB(unsigned *pSizeParas, unsigned *pUMBSegment);
int PASCAL ReleaseUMB(unsigned UMBSegment);


#endif	// #if !defined(_DLXMSLIB_H_)
