//  $Id: DOSDEF.H 1.27 2003/08/15 15:15:56Z thomd Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//  Copyright (c) 1989-2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
/*********************************************************

	DOSDEF.H  created  08/16/88  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This file contains defines, bit maps, in-line code
	error codes and other useful stuff for ROM-DOS.

**********************************************************/

#ifndef PASCAL
#define PASCAL		pascal
#endif


/************************************

	Hardcoded defaults

*************************************/
#define MINSFT		8			/* default # of SFTs for handle use */
#define MINBUF		2			/* default # of FAT file buffers    */
#define MAXFCB		20
#define MAXSFT		255		/* who needs 255 open files?        */
#define MAXBUF		40			/* DOS slows down w/ more than 40   */
#define SMART_FILES 20		/* from min to this at 640K memory */
#define SMART_BUFS 15		/* from min to this at 640K memory */
#define LASTDRIVE	5			/* the minimum # of CDSs to create  */
#define BUFSIZE	512		/* default buffer size              */
#define RETRY		5			/* default retries before crit err  */
#define STACKWORD 0x5678	/* guard word placed at bottom of stacks */

// long filename searches
#define MIN_SEARCHES    2		// minimum number of searches
#define DEF_SEARCHES	  10		// default maximum searches
#define MAX_SEARCHES	  64

/************************************

	Defines everybody should have

*************************************/
#ifndef NULL
#define	NULL		0
#endif
#define	NULLF		((void *)0xFFFF)

#define	BELL	 7
#define	BS		 8
#define	TAB	 9
#define	LF		10
#define	CR		13
#define	ESC	27
#define	F1		0x3B
#define	F3		0x3D
#define	F6		0x40
#define	LEFT	0x4B
#define	RIGHT	0x4D
#define	INS	0x52
#define	DEL	0x53

/************************************

		ROM-DOS Specific Defines

*************************************/

#define MAXNAMELEN	127
#define PATHLEN		66
#define ENAMESIZE		11
#define LFN_MAX_PATH	260		// allow room for lfn plus "C:\"
#define LFNMAXLNAME	256		// up to 256 characters in a long filename
#define DEFAULTSTACK 0x26C

/* CONFIG.SYS processing */
#define CFGLINELEN	120
#define BLKNAMESIZE	70		// make no larger than 128; we use SDA vars

#define MAXCALL	0x6C		/* 00H - 6CH */
#define DOS1CALL	0x37		/* 01H - 37H */

#define SYSTEM_OWNER		8	/* value for initial ownership of MCBs */

/* file/directory attributes (in a DIR) */
#define A_NORMAL		0x00
#define A_READONLY	0x01
#define A_HIDDEN		0x02
#define A_SYSTEM		0x04
#define A_VOLUME		0x08
#define A_SUBDIR		0x10
#define A_ARCHIVE		0x20
#define A_DEVICE		0x40
#define A_ALL			0x1E	/* DIR | VOL | SYS | HID */
#define A_DIRCHK		0x17	/* DIR | SYS | HID | RDO */
#define A_FILECHK		0x06	/* SYS | HID */
#define A_NOCHG		0x09	/* VOL | RDO */
#define A_NODEL		0x11	/* DIR | RDO */
#define A_NOMAKE		0x18	/* DIR | VOL */
#define A_MASK			0x1F	// mask off all upper bits
#define A_LONGNAME 	0x0F  // long filename attribute

/* Open Modes */
#define O_RDONLY		0x00
#define O_WRONLY		0x01
#define O_RDWR			0x02
#define O_RESERVED	0x08	/* must not be used - reserved */
#define O_DENYOPEN	0x10
#define O_DENYWRITE	0x20
#define O_DENYREAD	0x30
#define O_DENYNONE	0x40
#define O_SHARE		0x70	/* share bits */
#define O_SHARESHFT	4

/* Extended Open Modes */
#define O_NOCHILD		0x0080  // see also sft.ioctl bit IO_NOCHILD below
#define O_NO24			0x2000
#define O_WRITENOW	0x4000

/* Extended Open Actions User Requested */
#define ACT_EXIST_OPEN		0x0001
#define ACT_EXIST_REPLACE	0x0002
#define ACT_NEXIST_CREATE	0x0010
#define ACT_BADFUNC	~(0x13)
#define ACT_INCOMPAT	  0x3		// can't use open/replace together

/* Extended Open Actions User Requested */
#define ACTION_OPENED		1
#define ACTION_CREATED		2
#define ACTION_TRUNCATED	3

/* time functions */
#define TM_READ		0
#define TM_WRITE		1

/* seek attrubutes */
#define SK_BEG			0
#define SK_REL			1
#define SK_END			2

/* disk changed status */
#define CHG_NO			1
#define CHG_MAYBE		0
#define CHG_YES		0xFF
#define FIXED			0xF8

/* memory allocation schemes */
#define MEM_FIRST 0
#define MEM_BEST  1
#define MEM_LAST  2
#define MEM_UMB1ST	0x80
#define MEM_UMBONLY	0x40

/* if a dir entry is deleted, its name starts with this */
#define DELETED		0xE5
#define DELETED2		0x05

/* status bits of the CDS */
#define C_NETWORK	0x8000
#define C_VALID	0x4000
#define C_JOIN		0x2000
#define C_SUBST	0x1000

/* SDB status bits */
#define SDB_NETDRIVE 0x80

/* device driver commands */
#define DEV_INIT		0x00	/* initialize the device */
#define DEV_MEDIA		0x01	/* has disk changed?     */
#define DEV_BPB		0x02	/* get the BPB           */
#define DEV_IOREAD	0x03	/* ioctl read            */
#define DEV_READ		0x04	/* read from the device  */
#define DEV_NDREAD	0x05	/* non destructive read  */
#define DEV_INSTAT	0x06	/* input status          */
#define DEV_FLUSH		0x07	/* flush input buffers   */
#define DEV_WRITE		0x08	/* write to device       */
#define DEV_VWRITE	0x09	/* write with verify     */
#define DEV_OUTSTAT	0x0A	/* output status         */
#define DEV_FLUSHO	0x0B	/* flush output buffers  */
#define DEV_IOWRITE	0x0C	/* ioctl write           */
#define DEV_OPEN		0x0D	/* ioctl open            */
#define DEV_CLOSE		0x0E	/* ioctl close           */
#define DEV_REMOVE	0x0F	/* is device removeable? */
#define DEV_OUTBUSY	0x10	/* output until busy     */
#define DEV_GENIO		0x13	/* generic ioctl         */
#define DEV_GETDEV	0x17	/* get logical device    */
#define DEV_SETDEV	0x18	/* set logical device    */
#define DEV_QUERY		0x19	/* query generic ioctl   */

/* device header attributes */
#define DEVA_CHAR		0x8000	/* 1=char, 0=disk device */
#define DEVA_IOCTL	0x4000	/* device supports ioctl calls */
#define DEVA_IBMBLK	0x2000	/* 0=fat, 1=scratch */
#define DEVA_REMOVE	0x0800	/* Removeable media call supported */
#define DEVA_OPNCLS	0x0800	/* Open/Close device call supported */
#define DEVA_QUERY	0x0080	/* query generic IOCTL */
#define DEVA_GENIO	0x0040	/* generic IOCTL */
#define DEVA_RAWMODE 0x0020   /* Raw mode */
#define DEVA_FAST		0x0010	/* INT 29H is supported */
#define DEVA_CLOCK	0x0008	/* this is the CLOCK driver */
#define DEVA_NUL		0x0004	/* this is the NUL driver */
#define DEVA_CON		0x0003	/* this is the CONsole driver */
#define DEVA_32BIT	0x0002	/* device supports 32 bit sectors */

/* ioctl bits for SFTs */
#define IO_NETWORK		0x8000
#define IO_SETDATE		0x4000
#define IO_NOCHILD		0x1000 // don't bequeath file (open mode & O_NOCHILD)
#define IO_DEVICE			0x0080
#define IO_NOTEOF			0x0040 // device
#define IO_NOTWRITTEN	0x0040 // file
#define IO_RAW				0x0020
#define IO_FAST			0x0010
#define IO_NUL				0x0008
#define IO_CLK				0x0004
#define IO_CON				0x0003
#define IoctlDrive(ioctl) ((ioctl) & 0x1F)

/* device error conditions */
#define DEVE_ERROR		0x8000
#define DEVE_WRITEPROT  0x0000
#define DEVE_UNKNOWN		0x0003
#define DEVE_BUSY			0x0200

/* critical error bit map */
#define CRIT_CHARDEV 0x80
#define CRIT_IGNORE	0x20
#define CRIT_RETRY	0x10
#define CRIT_FAIL		0x08
#define CRIT_BOOT		0x00
#define CRIT_FAT     0x02
#define CRIT_ROOTDIR 0x04
#define CRIT_DATA		0x06
#define CRIT_WRITE	0x01

/* DOS errors */
#define ERR_BADFUNC		0x01
#define ERR_NOTFOUND		0x02
#define ERR_NOTPATH		0x03
#define ERR_NOHANDLE		0x04
#define ERR_DENIED		0x05
#define ERR_BADHANDLE	0x06
#define ERR_BADMEMBLK	0x07
#define ERR_NOMEM			0x08
#define ERR_BADMEMSEG	0x09
#define ERR_INVALID_ENV	0x0a
#define ERR_INVALID_FMT	0x0b
#define ERR_BADCODE		0x0c
#define ERR_BADDATA		0x0d
#define ERR_NOTDRIVE		0x0f
#define ERR_CURDIR		0x10
#define ERR_NOT_SAME_DV	0x11
#define ERR_LASTFILE		0x12
#define ERR_WPROTECT		0x13
#define ERR_UNKNOWNUNIT	0x14
#define ERR_NOTREADY		0x15
#define ERR_BUFFSIZE		0x18		// invalid buffer size
#define ERR_SHARE			0x20		/* sharing violation */
#define ERR_LOCKED		0x21		/* portion of file is locked */
#define ERR_WRONGDISK   0x22     // Illegal (floppy) disk change
#define ERR_NOLOCKS		0x24		/* all locks used */
#define ERR_NETWORK_TIMEOUT	0x33
#define ERR_NOTNEW		0x50		/* file already exists call 5BH */
#define ERR_BADLEVEL		0x57		// invalid level for
#define ERR_W95BADFUNC	0x7100	// prog. look for this for unsupported calls
#define ERR_RXENOTHERE	0xF0		/* RXE is not in memory */
#define ERR_RXESUM		0xF1		/* RXE checksum is wrong */

// error defines for absrdwr
#define ERR_ABSRDWR		0x0207	// error for abs rdwr
#define ABS_NOERR			0x0100	// no error

/* names for the user registers */
#define R_AX		(userregs->x.ax)
#define R_BX		(userregs->x.bx)
#define R_CX		(userregs->x.cx)
#define R_DX		(userregs->x.dx)
#define R_SI		(userregs->x.si)
#define R_DI		(userregs->x.di)
#define R_BP		(userregs->x.bp)
#define R_DS		(userregs->x.ds)
#define R_ES		(userregs->x.es)
#define R_IP		(userregs->x.ip)
#define R_CS		(userregs->x.cs)
#define R_FLAGS	(userregs->x.flags)
#define R_AH		(userregs->h.ah)
#define R_AL		(userregs->h.al)
#define R_BH		(userregs->h.bh)
#define R_BL		(userregs->h.bl)
#define R_CH		(userregs->h.ch)
#define R_CL		(userregs->h.cl)
#define R_DH		(userregs->h.dh)
#define R_DL		(userregs->h.dl)
extern union dos_regs far * userregs;
extern int error_no;

/* 8086 flags */
#define F_OVERFLOW	(1<<11)
#define F_DIR		 	(1<<10)
#define F_INT			(1<<9)
#define F_TRAP			(1<<8)
#define F_SIGN			(1<<7)
#define F_ZERO			(1<<6)
#define F_AUXCARRY	(1<<4)
#define F_PARITY     (1<<2)
#define F_CARRY		(1)

/* DOS 5 flags */
#define DOS5_ROM	0x0800
#define DOS5_HMA	0x1000

/* the standard handles */
#define STDIN		0
#define STDOUT		1
#define STDERR		2
#define STDAUX		3
#define STDPRN		4


#define FREEMEM	0

#define EXESIG  (('Z' << 8) | 'M') /* Mark Zimbowski was a modest man... */

/* call flags, placed in sda_callflags */
#define CALLF_PATH	0x01
#define CALLF_DEV		0x02
#define CALLF_NAME	0x04
#define CALLF_FCB		0x08
#define CALLF_HANDLE	0x10
#define CALLF_CHARIO	0x20
#define CALLF_RDWR	0x40
#define CALLF_NOWILD	0x80


/************************************

			In-Line Functions

*************************************/

/*
	ASSERT() and ABORT().

	There are 2 versions of the ROM-DOS Kernel: a Debug Kernel,
	and a shipping version.  The Debug Kernel has LOTS of asserts
	in it, the non-debugging one is built for size and speed.

	PERMASSERT() and PERMABORT() never get compiled out, even in
	the shipping version.
*/
void	PASCAL krn_assert(unsigned filenum, unsigned linenum);
#define PERMASSERT(e) if(!(e)) krn_assert(__FILENUM__, __LINE__)
#define PERMABORT() krn_assert(__FILENUM__, __LINE__)
#ifndef ASSERTS_DEFINED
#if DEBUG
#define ASSERTS_DEFINED		1
#define ASSERTLP(lp) if(!FP_SEG(lp)) krn_assert(__FILENUM__, __LINE__)
#define ASSERT(e) if(!(e)) krn_assert(__FILENUM__, __LINE__)
#define ABORT() krn_assert(__FILENUM__, __LINE__)
#else
#define ASSERTLP(lp)	// compiled out
#define ASSERT(e)		// compiled out
#define ABORT()		// compiled out
#endif
#endif

/* common ones */
#define ctrl(cc)    ((cc) - '@')
#define isslash(cc) ((cc) == '\\' || (cc) == '/')
#define min(a,b)    (((a) < (b)) ? (a) : (b))
#define DL_IS_SPACE(c) (((c)==' ') || ((c)=='\t') || ((c)=='\x0d') || ((c)=='\x0a') )

/* call flags set up by regs_to_sda() */
#define callf_path()				(sda_callflags & CALLF_PATH)
#define callf_dev()				(sda_callflags & CALLF_DEV)
#define callf_name()				(sda_callflags & CALLF_NAME)
#define callf_nowild()			(sda_callflags & (CALLF_NAME | CALLF_NOWILD))
#define callf_fcb()				(sda_callflags & CALLF_FCB)
#define callf_handle()			(sda_callflags & CALLF_HANDLE)
#define callf_chario()			(sda_callflags & CALLF_CHARIO)
#define callf_rdwr()				(sda_callflags & CALLF_RDWR)
#define callf_ifs()				(sda_callflags & 0xFF00)
#define callf_xlatifs()			(sda_callflags >> 8)

/* SFT ioctl bit tests */
#define iscondev(ioctl)		(ioctl & IO_CON)

/* the open mode has share bits, tests them */
#define share_mode(mode) (((mode)&O_SHARE)>>O_SHARESHFT)

/* 12-bit FAT entry decode functions */
#define fat0(u) ((unsigned)(u) & 0xFFF)
#define fat1(u) ((unsigned)(u) >> 4)

/* make a far pointer from a segment:offset pair */
#ifndef MK_FP
#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))
#endif
#ifndef FP_SEG
#define FP_SEG( fp )( (unsigned )( void _seg * )( void far * )( fp ))
#endif
#ifndef FP_OFF
#define FP_OFF( fp )( (unsigned )( fp ))
#endif

#define LOWORD( dw ) FP_OFF( dw )
#define HIWORD( dw ) FP_SEG( dw )
#define MK_ULONG( hi, lo ) ((ulong)(MK_FP( (hi), (lo) )))

//In an effort to clean up the code, an additional #define was added
//   and a great effort was made to eliminate explicit assignments!
//   These are the values from:
//      Disecting DOS, by Podanoffsky, p. 193
//      Ralf Brown's "DOS interrupts", Table 01656
//
/* "documented" buffer list flags */
#define B_REMOTE   0x80
#define B_DIRTY    0x40
#define B_VALID    0x20
#define B_SRCHREM  0x10
#define B_DATA     0x08   /* data area */
#define B_DIR      0x04   /* dir area */
#define B_FAT      0x02   /* fat area */
#define B_UNUSED   0x00

/* additional buffer list flags */
#define B_NEWDIRTY 0x80                /* RD specific */
#define B_BOOT     0x01                /* boot area */
#define B_SUBDIR   (B_DATA | B_DIR)    /* subdirectory */
#define B_VD       (B_VALID | B_DIRTY)
#define B_NVD      (B_NEWDIRTY | B_VALID | B_DIRTY)

#define B_INVDRV   0xFF  // used to mark drive in an unused buffer

/* buffer control in-line functions */
typedef void (*buffunc)(LPBUFLIST buf);
#define buf_dataptr(buf)         ((uchar far *)(buf->buffer))
#define buf_set_new_dirty(buf)   (buf->flags |= B_NVD)
#define buf_set_invalid(buf)     (buf->flags &= ~B_VALID)
#define buf_set_valid(buf)       (buf->flags |=  B_VALID)
#define buf_is_dirty(buf)        ((buf->flags&(uchar)B_VD) == (uchar)B_VD)
#define buf_not_dirty(buf)       (buf->flags &= ~(B_DIRTY | B_NEWDIRTY))
#define buf_is_new_dirty(buf)    ((buf->flags&(uchar)B_NVD) == (uchar)B_NVD)
#define buf_is_valid(buf)        (buf->flags&(uchar)B_VALID)
#define buf_mark_as_dir(buf)     (buf->flags |= B_DIR)
#define buf_is_in_data_area(buf) ((buf->flags & (uchar)B_DATA) == (uchar)B_DATA)
#define buf_holds_a_dir(buf)     ((buf->flags & (uchar)B_DIR)  == (uchar)B_DIR)

/* memory (MCB) functions */
#define MEMSIG			'M'
#define MEMSIGZ		'Z'
#define next_mcb(mcb) MK_FP(FP_SEG(mcb) + mcb->para_cnt + 1, 0)
#define last_mcb(mcb) ((mcb)->id == MEMSIGZ)

#define SKIPVAL 2			/* skip value on a "normal" drive (eg "C:") */

/* other inline functions */
#define internal_seek(pos, mode) file_seek(pos,mode)

/* used to determine if a directory entry is deleted */
//
// DELETED2 is *not* used to mark a deleted file on the disk,
// but instead to mark a translation of the 0xE5 character to 0x05.
//
#define IsDeleted(c) ((c)==DELETED)    // || (c)==DELETED2

/* end of list macro */
#define EndOfSFTList(lpSFT) ((void *)lpSFT == NULLF)

/* isdigit macro */
#ifndef isdigit(c)
#define isdigit(c) ((c)>='0' && (c)<='9')
#endif

/* prototype for long filenames */
void SearchesCreate(void);
bool LongnameFunctions(void);

/* highest legal cluster number in the 3 FAT systems (0-n) */
#define HICLUS12	0xFF6
#define HICLUS16	0xFFF6
#define HICLUS32	0x0FFFFFF6L
#define MAXSPC		0x40			// maximum sectors per cluster

/* file system types recognized by ROM-DOS */
#define FS_FAT12	1
#define FS_FAT16	2
#define FS_FAT32	3

#define Negative1  (unsigned)0xFFFF

// Fat32 treats clusters as unsigned longs (32-bits)
#define AVAILABLE_CLUSTER	0
#if USING_FAT32
#define BAD_CLUSTER ((ulong)0x0FFFFFF7L)
#define END_OF_FAT ((ulong)0x0FFFFFFFL)
#define END_OF_FAT_CHECK ((ulong)0x0FFFFFF8L)
#else
#define BAD_CLUSTER (0xFFF7)
#define END_OF_FAT (0xFFFF)
#define END_OF_FAT_CHECK (0xFFF8)
#endif

#if USING_FAT32
// signature in the FS Info sector
#define FSINFO_SIG1			0x61415252L		// at start of sector
#define FSINFO_SIG2			0x61417272L		// at sig_offset
#define FSINFO_SIG_OFFSET	0x1E4
#define SECTOR_SIG			0xAA55			// at end of sector
#define SECTOR_SIG_OFFSET	0x1FE				// just below end of sector

#define IsFat32Drive(lpDPB) ((lpDPB)->fat_len == 0)
#define Fat32Start(dir) ((ulong)MK_FP((dir).uStartingClusterHi,(dir).uStartingClusterLo))
#define Fat32StartLP(lpdir) ((ulong)MK_FP((lpdir)->uStartingClusterHi,(lpdir)->uStartingClusterLo))
#define Fat32FreeClusters() MK_ULONG(sda_dpbptr->uFreeClustersHigh, sda_dpbptr->freeclus)

#endif

// Check if this is a SUBSTituted drive
//
// NOTE: Only the _IsValidDrive macro will work in a window dos box.
//       This is because windows doesn't update all the information
//       in the device attribute word.
//
#define IsSubstDrive(cdsptr)   (((cdsptr)->status & C_SUBST)   != 0)
#define IsJoinedDrive(cdsptr)  (((cdsptr)->status & C_JOIN)    != 0)
#define _IsValidDrive(cdsptr)   (((cdsptr)->status & C_VALID)   != 0)
#define IsNetworkDrive(cdsptr) (((cdsptr)->status & C_NETWORK) != 0)


// SDA variables
extern LPDPB sda_dpbptr;
extern LPCDS sda_cdsptr;
extern uchar CritErr;
extern uchar bios_err;
extern struct dev_req_hdr sda_reqhdr;
extern LPBUFLIST sda_cur_buf;
extern struct LOL lol;


#ifndef CLUSTER_ASSERTS_DEFINED
#if DEBUG
#define CLUSTER_ASSERTS_DEFINED		1

#if USING_FAT32
#define ASSERT_ValidCluster(clusnum)                      \
   ASSERT( clusnum >= 2 );                               \
   if( IsFat32Drive(sda_dpbptr) )                        \
   {  ASSERT( clusnum <= sda_dpbptr->ulMaxCluster );  }  \
   else                                                  \
   {  ASSERT( clusnum <= sda_dpbptr->hiclus );  }
#else
   ASSERT( clusnum >= 2 );                               \
   ASSERT( clusnum <= sda_dpbptr->hiclus );
#endif

#else
#define ASSERT_ValidCluster(clusnum)
#endif
#endif
