//
//   $Id: DOSMSG.C 1.69 2003/08/28 14:42:44Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   DOSMSG.C  created 08/17/92  by Drew Gislason

   Copyright (c) 1992-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains all the language specific messages
   displayed in ROM-DOS and all utilities.  Each section
   is surrounded by an #if/#endif pair.  This file  also
   contains default country information.  If a developer
   wants to port ROM-DOS to another language, this  file
   is the only one that need be changed.

**********************************************************/

/*
   []-----------------------------------------[]
    |                                         |
    |    ROM-DOS KERNEL INTERNAL MESSAGES     |
    |                                         |
   []-----------------------------------------[]
*/
#if ROMDOS

/*
   These strings are for ROM-DOS fatal errors.

   Examples:
   Memory Corrupted (1FD2)!  System Halted...
   No Disk Devices!  System Halted...
   Internal Error (5540)!  System Halted...
*/
char fatal_mem[]      = "Memory Corrupted (%p)";
char fatal_disk[]     = "No Disk Devices";
char fatal_interr[]   = "Internal Error! (%d.%d)";
char fatal_zero[]     = "Divide by Zero (%x:%x)\n";
char fatal_overflow[] = "Stack Overflow (%x:%x)";
char fatal_notfound[] = "%s Not Found";
char fatal_romdos[]   = "ROM-DOS Fatal Error!  ";
char fatal_halt[]     = "!  System Halted...";
char fatal_unsupp[]   = "Unsupported DOS function INT %x, %p";


/*
   These strings are for non-fatal errors.
*/
char warn_bad[]    = "Bad or Missing %s (%ls)\n";
char warn_device[] = "Device";
char warn_shell[]  = "Shell";
char warn_newfile[]= "NewFile";
char warn_again[]  = "A>";
char warn_cmd[]    = "Bad cmd (%ls) in %s, line %d\n";


/*
	Critical Error Messages
*/
char crit_bad_msg[] = "???";

// KLUDGE!  MS Lan Manager needs DOS DGROUP at address 128DH.
// char lan_kludge[30] = "";

char *crit_msgs[] =
{
	"Write protect",                 /* 0x00 */
	"Unknown unit",                  /* 0x01 */
	"Not ready",                     /* 0x02 */
	"Unknown command",               /* 0x03 */
	"CRC",                           /* 0x04 */
	"Bad struct",                    /* 0x05 */
	"Seek",                          /* 0x06 */
	"Invalid media type",            /* 0x07 */
	"Sector not found",              /* 0x08 */
	"No paper",                      /* 0x09 */
	"Write fault",                   /* 0x0A */
	"Read fault",                    /* 0x0B */
	"General failure",               /* 0x0C */
	"Sharing violation",             /* 0x0D */
	"Lock violation",  	            /* 0x0E */
	"Invalid disk change",           /* 0x0F */
	"FCB unavailable",               /* 0x10 */
	"Sharing buffer overflow",       /* 0x11 */
	"Code page mismatch",            /* 0x12 */
	"Out of input",                  /* 0x13 */
	"Insufficient disk space"        /* 0x14 */
};

char crit_error[]		=	" error ";
char crit_read[]		=	"reading ";
char crit_write[]		=	"writing ";
char crit_drv_msg[]	=	"drive ";
char crit_dev_msg[]	= 	"device ";
char crit_quest_mark[]	= 	"? ";
char crit_cr_lf[]		= 	"\r\n";
char crit_abort[]		=	"Abort";
char crit_retry[]		=	", Retry";
char crit_ignore[]	=	", Ignore";
char crit_fail[]		=	", Fail";
char crit_volume[]   =  "Please insert volume ";
char crit_serial[]   =  " serial ";

/* Country information as returned by DOS call INT 21H, func 6501H */
#define DATE_TIME_FMT    0   /* 0=USA, 1= Europe, 2=Japan */
#define COUNTRY_ID       1   /* 1=USA */
#define CODE_PAGE      437   /* 437 for USA */
#define CURRENCY       "$"   /* currency symbol,     "$" in USA */
#define THOUSANDS      ","   /* thousands separator, "," in USA */
#define DECIMAL        "."   /* decimal separator,   "." in USA */
#define DATE_SEPARATOR "-"   /* date separator,      "-" in USA */
#define TIME_SEPARATOR ":"   /* time separator,      ":" in USA */
#define CURRENCY_FORMAT  0   /* currency format, 0=leading */
#define DEC_DIGITS       2   /* digits after decimal,  2 in USA */
#define TIME_FORMAT      0   /* 0=12hr, 1=24hr */
#define DATA_LIST      ","   /* data list separator  "," in USA */

/* offset into flop_chg_msg for drive letter (A:) */
int flop_chg_off = 24;

/* the message the floppy driver displays for disk change */
char flop_chg_msg[] =
	"\r\nInsert disk for drive A: and strike a key when ready\r\n";

#endif   /* ROMDOS */

/*
   []-----------------------------------------[]
    |                                         |
    |    ROM-DOS KERNEL CONFIG.SYS MESSAGES   |
    |                                         |
   []-----------------------------------------[]
*/

#if CONFIG

#if VDOS >= 5
char warn_tsr[]    = "TSR";
char warn_nohigh[] = "\nHMA not available; DOS low\n";
#endif

#if VDOS >= 6
char warn_bypass[] = "Bypassing CONFIG.SYS and AUTOEXEC.BAT\n";
char ask_string[]  = "%ls [Y/N]?";
char autoexec_msg[]= "Process AUTOEXEC.BAT";
char common_str[]  = "COMMON";
char menu_str[]    = "MENU";
// moved title_msg to SYSGEN.ASM
// char title_msg[]   = "ROM-DOS Startup Menu\n";
char choice_msg[]  = "Enter Choice: ";
char confirm_msg[] = "F5=Bypass Startup Files    F8=Confirm each CONFIG line [N]";
char wait_msg[]    = "Press any key...";
char time_msg[]    = "Time remaining: ";
#endif

#endif	/* ROMDOS CONFIG.SYS */


/*
   []-----------------------------------------[]
    |                                         |
    |              SMARTDRV.EXE               |
    |                                         |
   []-----------------------------------------[]
*/
#if DISK_CACHE

char szUsage[] = ""
"\n"
"Installs and configures the SMARTDRV disk-caching utility.\n"
"\n"
"SMARTDRV [/X] [[drive[+|-]]...] [/U] [/C | /R] [/F | /N] [/V | /Q | /S]\n"
"      [InitCacheSize] [/E:ElementSize] [/B:BufferSize]\n"
"\n"
"/X              Disables write-behind caching for all drives.\n"
"drive           Sets caching options on specific drive(s). The specified\n"
"                drive(s) will have write-caching disabled unless you add +.\n"
"+               Enables write-behind caching for the specified drive.\n"
"-               Disables all caching for the specified drive.\n"
"/U              Do not load CD-ROM caching module.\n"
"/C              Writes all information currently in write-cache to hard disk.\n"
"/R              Clears the cache and restarts the SMARTDRV program.\n"
"/F              Writes cached data before command prompt returns (default).\n"
"/N              Doesn't write cached data before command prompt returns.\n"
//"/L              Prevents SMARTDRV from loading itself into upper memory.\n"
"/V              Displays SMARTDRV status messages when loading.\n"
"/Q              Does not display status information.\n"
"/S              Displays additional information about SMARTDRV's status.\n"
"InitCacheSize   Specifies XMS memory (KB) for the cache.\n"
//"WinCacheSize    Specifies XMS memory (KB) for the cache with Windows.\n"
"/E:ElementSize  Specifies how many bytes of information to move at one time.\n"
"/B:BufferSize   Specifies the size of the read-ahead buffer.\n"
"";


char szSignOnMessage[] = "Datalight SMARTDRV %s %s\n%s\n\n";
char szShortVersion[] = SHORTVERSION;
char szShortVersion622[] = SHORTVERSION622;
char szBuildVersion[] = BUILDVERSION;
char szCopyright[] = COPYRIGHT;


char szExtraStatus[] = ""
"Room for %6u elements of %,7u bytes each\n"
"There have been %6lu cache hits\n"
"    and %5lu cache misses\n\n";

char szCachSize[] = "Cache size:  %,lu bytes\n";
char szStatusHeader[] = ""
"            Disk Caching Status\n"
"drive   read cache   write cache   buffering\n"
"--------------------------------------------\n";
char szStatusEntry[] = ""
"  %c:       %-14s%-13s%s\n";

char szCommitBeforeCommand[] = ""
"Write behind data will %sbe committed before command prompt returns.\n";
char szForHelp[] = "For help, type \"SMARTDRV /?\".\n";
char szLoaded[] = "\nThe memory-resident portion of SMARTDRV is loaded.\n";


char szYes[] = "yes";
char szNo[]  = "no";
char szUncertain[] = "-";
char szNot[] = "not ";


char szInvalidSwitch[] = "Invalid Switch - %s\n";
char szWindowsIsRunning[] = ""
		"SMARTDRV cannot be loaded while Windows is running.\n";
char szNoXMS[] = ""
	"SMARTDRV cannot be loaded because the XMS driver, HIMEM.SYS,\n"
	"is not loaded.  Check the CONFIG.SYS file for a device=himem.sys\n"
	"command line.\n";
char szNotEnoughXMS[] = "There is insufficient XMS memory to load SMARTDRV.\n";
char szBadDrive[] = ""
	"\nWarning: Unable to use a disk cache on the specified drive\n";
char szConflictingSwitches[] = "Error: Conflicting switches\n";


#endif //  #if DISK_CACHE


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR COMMAND.COM          |
    |                                         |
   []-----------------------------------------[]
*/
#if COMMAND
char * messages[] =
{
	"Required parameter missing",				/*  0 */
	"Unable to create directory",
	"Invalid path, not directory,\r\nor directory not empty",
	"Invalid drive specification",
	"Path not found",
	"File not found",					/*  5 */
	"\nInvalid date",
	"\nInvalid time",
	"Syntax error",
	"Bad command or file name",
	"Not enough memory",					/* 10 */
	"Error in EXE file",
	"File creation error",
	"Invalid drive in search path",
	"Duplicate file name or File not found",
	"Invalid device",					/* 15 */
	"Insufficient disk space",
	"\nBatch file missing",
	"Out of environment space",
	"Label not found",
	"\nTerminate batch job (Y/N)?",				/* 20 */
	"Current drive no longer valid>",
	"Cannot use wildcards in destination",
	"File cannot be copied onto itself",
	"Access denied",
	"Invalid parameter",				/* 25 */
	"Incorrect ROM-DOS version",
	"Must specify ON or OFF",
	"Path not found",
	"All files in directory will be deleted!\n\rAre you sure (Y/N)?",
	"Attempt to remove current directory",		/* 30 */
	"Intermediate file error during pipe",
	"\nUsage:\tCOMMAND {Option(s)} {CommandString}\n\n"
	"See the ROM-DOS users guide for more information\n",
	"Help not available for this command.",
	"Function available with ROM-DOS kernel only",
	"Directory already exists", /* 35 */
	"Invalid directory",
	"Invalid switch",
	"Too many parameters",
	"",
};

char date_id[] = "date";
char time_id[] = "time";

char cmdstr_askprompt[] = "%s (Yes/No/All)?";
char cmdstr_copyprompt[] = "Overwrite %s (Yes/No/All)?";
char cmdstr_copied[] = "%,9u file(s) copied\n";
char cmdstr_curdatetime[] = "Current %s is ";
char cmdstr_newdatetime[] = "Enter new %s%s: ";
char cmdstr_promptdel[] = "%s,    Delete (Y/N)?";

// volume label strings
char cmdstr_dirvol[]     = " Volume in drive %c %s";
char cmdstr_dirvolyes[]  = "is %s";
char cmdstr_dirvolno[]   = "has no label";
char cmdstr_dirserial[]  = " Volume Serial Number is %s";

// strings used for the DIR command
char cmdstr_dirof[]      = "Directory of %s";
char cmdstr_dirspace[]   = "%-*s";	// for "<DIR>   " in file size column
char cmdstr_dirpause[]   = "(%s continued...)";
char cmdstr_dirfiles[]   = " file(s) ";
char cmdstr_dirdirs[]    = " dir(s)  ";
char cmdstr_dirbytes[]   = " bytes";
char cmdstr_dirfreestr[] = " bytes free";
char cmdstr_dirfreestr2[] = " free";
char cmdstr_dirallocated[] = " bytes allocated";
char cmdstr_dirallocated2[] = " allocated";
char cmdstr_dirtotal[]   = " bytes total disk space, %3u%% in use";
char cmdstr_dirlisted[]  = "Total files listed:";
#if TWO_DIGIT_YEAR
char cmdstr_verbose[]    = "File Name         Size        Allocated      Modified      Accessed  Attrib";
#else
char cmdstr_verbose[]    = "File Name         Size        Allocated      Modified         Accessed   Attrib";
#endif
char cmdstr_nopath[]     = "No Path\n";
char cmdstr_pause[]      = "Strike a key when ready . . . ";

char cmdstr_nohelp[]     = "Cannot open %s\n";
char cmdstr_badhelp[]    = "Incorrect help file version %s\n";

/* strings for version */
char cmdstr_rdver[]     = "Datalight ROM-DOS Version ";
char cmdstr_kernelver[] = "Kernel Reports Version";
char cmdstr_kernelrev[] = "Kernel Revision";
char cmdstr_dosmem[]    = "Kernel Resides in";
char cmdstr_hmamem[] = "HMA";
char cmdstr_rommem[] = "ROM";
char cmdstr_rammem[] = "RAM";
char cmdstr_superboot[] = "Super-Boot Kernel";
char cmdstr_cmdrev[]    = "Command Revision";
char cmdstr_biosrev[]   = "Datalight BIOS Revision";
char cmdstr_revcol2[]   = "%-30s%s %s\n";
char cmdstr_revcol[]    = "%-30s%s\n";
char notrd[] = "(not ROM-DOS)";
char notrep[]= "(unknown)";
char *day_of_week[] =
	{ "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };

char szEnvComSpec[] = "COMSPEC=";
char szEnvPath[] = "PATH=";
char szStatusErrorLevel[] = "Return code (ERRORLEVEL): %3u\n";
char szStatusReloaded[] = "WARNING: Reloaded COMMAND.COM transient\n";

#endif /* COMMAND.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR COMMAND.HLP          |
    |                                         |
   []-----------------------------------------[]
*/

#if COM_HELP

char *help[] =
{
	/* BREAK */
		"Displays or modifies Control C checking.\n"
		"\n"
		"Usage:\n"
			"\tBREAK [ON | OFF]\n"
		"Examples:\n"
			"\tBREAK ON\t\tTurn on the DOS break flag\n"
			"\tBREAK OFF\t\tTurn off the DOS break flag\n"
			"\tBREAK\t\t\tDisplay the break status\n",

	/* CALL */
		"Execute another batch file, returning to the calling batch file\n"
		"upon completion.\n"
		"\n"
		"Usage:\n"
			"\tCALL <Batch File Name> [Batch File Arguments]\n"
		"Example:\n"
			"\tCALL DO_LASER COM1:\n"
				"\t\tCalls batch file DO_LASER with COM1 as an argument\n",

	/* CD */
		"Displays or changes the current working directory for a drive.\n"
		"\n"
		"Usage:\n"
			"\tCD [Drive:][New Directory]\n"
		"Examples:\n"
			"\tCD \\ROMDOS\\UTILS\n"
				"\t\tChange into the specified directory on the current disk\n"
			"\tCD ..\n"
				"\t\tChange into the parent directory\n"
			"\tCD A:\n"
				"\t\tDisplay the current directory on drive A:\n",

	/* CHDIR */
		"Displays or changes the current working directory for a drive.\n"
		"\n"
		"Usage:\n"
			"\tCHDIR [Drive:][New Directory]\n"
		"Examples:\n"
			"\tCHDIR \\ROMDOS\\UTILS\n"
				"\t\tChange into the specified directory on the current disk\n"
			"\tCHDIR ..\n"
				"\t\tChange into the parent directory\n"
			"\tCHDIR\n"
				"\t\tDisplay the current directory\n",

	/* CLS */
		"Clear the console screen\n"
		"\n"
		"Usage:\n"
			"\tCLS\n"
		"Example:\n"
			"\tCLS\t\tClear the screen\n",

	/* COPY */
		"Copy one or more files.\n"
		"\n"
		"Usage:\n"
			"\tCOPY <Source[+]...> [Destination] {Options}\n"
		"Options:\n"
			"\t/A\tCopy the file(s) in ASCII format, stopping on Ctrl-Z\n"
			"\t/B\tCopy the file(s) in Binary format\n"
			"\t/H\tCopy hidden file(s) as well\n"
			"\t/V\tCopy the file(s) with Verify\n"
			"\t/Y\tAuto answer \"Yes\" to overwrite prompt\n"
			"\t/-Y\tDisplay overwrite prompt\n"
		"Examples:\n"
			"\tCOPY *.DAT \\BIN\n"
				"\t\tCopy all files with a .DAT extension to the \\BIN directory\n"
			"\tCOPY 1.BIN + 2.BIN + X*.BIN ALL.BIN /b\n"
				"\t\tConcatenate binary files 1.BIN, 2.BIN and X*.BIN into ALL.BIN\n"
		"Notes:\n"
			"\tYou may preset any of these options using the COPYCMD environment\n"
			"\tvariable (e.g. SET COPYCMD=/Y).\n",

	/* CTTY */
		"Specifies the console device, usually COMx or CON.\n"
		"\n"
		"Usage:\n"
			"\tCTTY <Device>\n"
		"Examples:\n"
			"\tCTTY COM1:\n"
				"\t\tChange console to the COM1 device\n"
			"\tCTTY CON:\n"
				"\t\tChange back to standard console\n",

	/* DATE */
		"Display or modify the system date.\n"
		"\n"
		"Usage:\n"
			"\tDATE [mm-dd-yyyy]\n"
		"Examples:\n"
			"\tDATE\t\t\tDisplay the current date\n"
			"\tDATE 1-27-93\t\tChange the date to January 27, 1993\n"
			"\tDATE 10-12-2002\t\tChange the date to October 12, 2002\n"
		"Notes:\n"
			"\tThe order of month-day-year, and the date separator may change\n"
			"\tdepending on country.\n",

	/* DEL */
		"Delete one or more files.\n"
		"\n"
		"Usage:\n"
			"\tDEL <FileSpec> [/P]\n"
		"Options:\n"
			"\t/P\tPrompt the user before deleting each file\n"
		"Examples:\n"
			"\tDEL *.BAK\n"
				"\t\tDelete all files with the extension of .BAK\n"
			"\tDEL *.* /P\n"
				"\t\tDelete all files but ask user before each delete\n",

	 /* DIR */
		"\nDisplays the names, dates, times and sizes of files and directories.\n"
		"\n"
		"Usage:\n"
			"\tDIR <FileSpec> {Options}\n"
		"Options:\n"
			"\t/A?\tDisplay only files with a matching attribute as show below\n"
				"\t\tA Archive\tD Directory\tH Hidden\tR Read Only\n"
				"\t\tS System\tX Show Attrs\t- Prefix for not\n"
			"\t/B\tDisplay in bare format\n"
			"\t/L\tDisplay in lowercase\n"
			"\t/O?\tSort directory listing by item as shown below\n"
				"\t\tN Name\t\tE Extension\t\tD Date and time\n"
				"\t\tS Size\t\tG Group directories\t- Prefix for reverse\n"
				"\t\tA Last access date\n"
			"\t/P\tPause after each screenful\n"
			"\t/S\tDisplay files in subdirectories as well\n"
			"\t/V\tVerbose directory information\n"
			"\t/W\tDisplay in wide format without date, time, or size\n"
			"\t/4\tDisplays year with 4 digits (default)\n"
		"Example:\n"
			"\tDIR \ogen *.HPP\n"
				"\t\tDisplay all files with the extension of .HPP sorted\n"
			"\tDIR /on\n"
				"\t\tDisplay files sorted by name\n",

	// removed so it fits on one screen
#if 0
		"Notes:\n"
			"\tYou may preset any of these switches with the environment\n"
			"\tvariable DIRCMD (SET DIRCMD=/B).  You may also specify an\n"
			"\tan odd screen size using DIRSIZE (SET DIRSIZE=rows cols).\n",
#endif

	 /* ECHO */
		"Display a message, or inform a batch file to display/not display\n"
		"each command as the batch file runs.\n"
		"\n"
		"Usage:\n"
			"\tECHO [ON | OFF | <Message>]\n"
		"Examples:\n"
			"\tEcho This is a test!\n"
				"\t\tDisplays the message \"This is a test!\"\n"
			"\tEcho OFF\n"
				"\t\tTurn batch file command echoing off\n"
			"\tEcho ON\n"
				"\t\tTurn batch file command echoing on\n",

	 /* ERASE */
		"Erase one or more files.\n"
		"\n"
		"Usage:\n"
			"\tERASE <FileSpec> [/P]\n"
		"Options:\n"
			"\t/P\tPrompt the user before erasing each file\n"
		"Examples:\n"
			"\tERASE *.BAK\n"
				"\t\tErase all files with the extension of .BAK\n"
			"\tERASE *.* /P\n"
				"\t\tErase all files, but ask user before erasing each file\n",

	/* EXIT */
		"Exit the COMMAND processor and return to the previous program.\n"
		"\n"
		"Usage:\n"
			"\tEXIT\n"
		"Example:\n"
			"\tEXIT\t\tReturn to previous program\n",

	/* FOR */
		"A simple list processing command for batch files.\n"
		"\n"
		"Usage:\n"
			"\tFOR %%%%n IN (List) DO <Statement>\n"
		"Examples:\n"
			"\tFOR %%%%n IN (a b c) DO echo %%%%n\n"
				"\t\tThe FOR statement will display 'a', 'b' and 'c'\n"
			"\tFOR %%%%f IF (*.ASM) DO tasm %%%%f\n"
				"\t\tAssemble each file with the .ASM extension\n",

	/* GOTO */
		"Continue processing at the given label in a batch file.\n"
		"Usage:\n"
			"\tGOTO <Label>\n"
		"Example:\n"
			"\tGOTO LABEL1\n"
				"\t\tContinue processing on the line that begins with \":LABEL1\"\n",

	/* HELP */
		"Display HELP for a given command. Requires COMMAND.HLP to be in the\n"
		"same directory as COMMAND.COM (see the COMSPEC environment variable).\n"
		"\n"
		"Usage:\n"
			"\tHELP <Command> -or- <Command> /?\n"
		"Options:\n"
			"\tHelp is available for the following commands:\n"
			"\tBREAK\t\tCALL\t\tCD\t\tCHDIR\n"
			"\tCLS\t\tCOPY\t\tCTTY\t\tDATE\n"
			"\tDEL\t\tDIR\t\tECHO\t\tERASE\n"
			"\tEXIT\t\tFOR\t\tGOTO\t\tHELP\n"
			"\tIF\t\tLFNFOR\t\tLH\t\tLOADHIGH\n"
			"\tMD\t\tMKDIR\t\tPATH\t\tPAUSE\n"
			"\tPROMPT\t\tRD\t\tREM\t\tREN\n"
			"\tRENAME\t\tRMDIR\t\tSET\t\tSHIFT\n"
			"\tTIME\t\tTYPE\t\tVER\t\tVERIFY\n"
			"\tVOL\n"
		"Examples:\n"
			"\tDIR /?\t\tDisplay help for the DIR command\n"
			"\tHELP RENAME\tDisplay help for the RENAME command\n",

	/* IF */
		"A conditional command for batch files.  The statement following the\n"
		"condition is only executed if the condition is true.\n"
		"\n"
		"Usage:\n"
			"\tIF [NOT] <Condition> <Statement>\n"
		"Examples:\n"
			"\tIF EXIST C:\\COMMAND.COM GOTO CMD_IN_ROOT\n"
				"\t\tCan the file COMMAND.COM be found in the root directory?\n"
			"\tIF NOT %%1ABC == ABC ECHO '%%1' is not an empty string\n"
				"\t\tDisplay the 1st argument passed to this batch file\n",

	/* LFNFOR */
		"Modifies FOR statement to allow long filename searches.\n"
		"\n"
		"Usage:\n"
			"\tLFNFOR [ON | OFF]\n"
		"Examples:\n"
			"\tLFNFOR ON\t\tEnable long filenames in FOR statements\n"
			"\tLFNFOR\t\t\tDisplay the current LFNFOR setting\n",

	/* LH */
		"Load a program into Upper Memory Blocks (load high). If no\n"
		"UMBs are available, it will load (run) the program low.\n"
		"\n"
		"Usage:\n"
			"\tLH <Program Name> [Program Arguments]\n"
		"Example:\n"
			"\tLH SIDEKICK\n"
				"\t\tLoads the TSR Sidekick into high memory\n",

	/* LOADHIGH */
		"Load a program into Upper Memory Blocks (load high). If no\n"
		"UMBs are available, it will load (run) the program low.\n"
		"\n"
		"Usage:\n"
			"\tLOADHIGH <Program Name> [Program Arguments]\n"
		"Example:\n"
			"\tLOADHIGH SIDEKICK\n"
				"\t\tLoads the TSR Sidekick into high memory\n",

	/* MD */
		"Make a new subdirectory.\n"
		"\n"
		"Usage:\n"
			"\tMD <Subdirectory>\n"
		"Examples:\n"
			"\tMD DATA\n"
				"\t\tMake a new subdirectory named \"DATA\"\n"
			"\tMD C:\\DATALIGHT\\PROGS\n"
				"\t\tMake a new subdirectory named \"PROGS\" on drive C:\n",

	/* MKDIR */
		"Make a new subdirectory.\n"
		"\n"
		"Usage:\n"
			"\tMKDIR <Subdirectory>\n"
		"Examples:\n"
			"\tMKDIR DATA\n"
				"\t\tMake a new subdirectory named \"DATA\"\n"
			"\tMD C:\\DATALIGHT\\PROGS\n"
				"\t\tMake a new subdirectory named \"PROGS\" on drive C:\n",

	/* PATH */
		"Display or modify the search path for programs.\n"
		"\n"
		"Usage:\n"
			"\tPATH [New Path]\n"
		"Examples:\n"
			"\tPATH\n"
				"\t\tDisplay the current path\n"
			"\tPATH C:\\BIN;D:\\DOS;E:\n"
				"\t\tCOMMAND will search C:\\BIN, D:\\DOS and drive E: when told to\n"
				"\t\trun a program if it can't be found in the current directory\n",

	/* PAUSE */
		"Wait for a keypress.  For use in batch files.\n"
		"\n"
		"Usage:\n"
			"\tPAUSE [Message]\n"
		"Example:\n"
			"\tPAUSE Press <Enter> to continue!\n"
				"\t\tWait for user to press a key\n",

	/* PROMPT */
		"Modify the system prompt.\n"
		"\n"
		"Usage:\n"
			"\tPROMPT <New Prompt>\n"
		"Options:\n"
			"\tPossible prompts can include one or more of the following:\n"
			"\t$B\tVertical bar '|'\t$D\tCurrent date\n"
			"\t$E\tEscape character\t$G\tGreater than sign '>'\n"
			"\t$H\tBack space      \t$L\tLess than sign '<'\n"
			"\t$N\tCurrent drive   \t$P\tCurrent drive and path\n"
			"\t$Q\tEqual sign '='  \t$T\tCurrent time\n"
			"\t$V\tDOS version     \t$$\tDollar sign '$'\n"
			"\t$_\tCarriage return\n"
		"Examples:\n"
			"\tPROMPT $d $t$_:"
				"\t\tDisplay date and time in the system prompt\n"
			"\tPROMPT $p$g\n"
				"\t\tThe most common system prompt\n",

	/* RD */
		"Remove an empty subdirectory.\n"
		"\n"
		"Usage:\n"
			"\tRD <Subdirectory>\n"
		"Example:\n"
			"\tRD C:\\ROMDOS\\BUGS\n"
				"\t\tRemoves the empty subdirectory \"BUGS\" from the subdirectory\n"
				"\t\t\"ROMDOS\" on drive C:\n",

	/* REM */
		"A remark or comment, for use in batch files.\n"
		"\n"
		"Usage:\n"
			"REM <Text>\n"
		"Example:\n"
			"\tREM This is a comment\n"
				"\t\tA comment in a batch file\n",

	/* REN */
	 	"Change the name of one or more files.\n"
		"\n"
		"Usage:\n"
			"\tREN <Old Name> <New Name>\n"
		"Examples:\n"
			"\tREN FILE1 FILE2\n"
				"\t\tChange the name of FILE1 to FILE2\n"
			"\tREN *.C *.CPP\n"
				"\t\tChange all file extensions of .C to .CPP\n",

	/* RENAME */
	 	"Change the name of one or more files.\n"
		"\n"
		"Usage:\n"
			"\tRENAME <Old Name> <New Name>\n"
		"Examples:\n"
			"\tRENAME FILE1 FILE2\n"
				"\t\tChange the name of FILE1 to FILE2\n"
			"\tRENAME *.C *.CPP\n"
				"\t\tChange all file extensions of .C to .CPP\n",

	/* RMDIR */
		"Remove an empty subdirectory.\n"
		"\n"
		"Usage:\n"
			"\tRMDIR <Subdirectory>\n"
		"Example:\n"
			"\tRD C:\\ROMDOS\\BUGS\n"
				"\t\tRemoves the empty subdirectory \"BUGS\" from the subdirectory\n"
				"\t\t\"ROMDOS\" on drive C:\n",

	/* SET */
		"Display or modify environment variables.\n"
		"\n"
		"Usage:\n"
			"\tSET [<VarName>=<EnvString>]\n"
		"Examples:\n"
			"\tSET\n"
				"\t\tDisplay the current environment\n"
			"\tSET LIB=C:\\BC3\\LIB\n"
				"\t\tSet environment variable \"LIB\" to \"C:\\BC3\\LIB\"\n"
			"\tSET LIB=\n"
				"\t\tRemove environment variable \"LIB\"\n",

	 /* SHIFT */
		"Shift batch file arguments, %%1, %%2, %%3, etc, to the previous number.\n"
		"\n"
		"Usage:\n"
			"\tSHIFT\n"
		"Example:\n"
			"\tSHIFT\n"
				"\t\tMove all Batch file arguments to the next lower number\n",

	/* TIME */
		"Display or modify the system time.\n"
		"\n"
		"Usage:\n"
			"\tTIME [HH:MM:SS][AM|PM]\n"
		"Examples:\n"
			"\tTIME 10:45pm\n"
				"\t\tSet the system time to 10:45pm\n"
			"\tTIME 8:00:30\n"
				"\t\tSet the system time to 8:00am and 30 seconds\n"
		"Notes:\n"
			"\tThe time separator may change depending on country.\n",

	 /* TRUENAME */
		"Display the actual path of virtual drives created with\n"
		"SUBST, network drives, normal drives, and the contents\n"
		"of envrionment variables that are created using the SET\n"
		"command.\n"
		"\n"
		"Usage:\n"
			"\tTRUENAME [path | %environmentvariable%]\n"
		"Examples:\n"
			"\tTRUENAME C:\n"
			"\t\tDisplays the full true path of C:\n"
			"\t\tup to the current directory.\n"
		"Notes:\n"
			"\tLFN file names will be truncated to 8.3\n"
			"\tformat. But will not be in short name form.\n"
			"\tLFN directory names will be truncated to\n"
			"\t8 characters in length.\n",

	 /* TYPE */
		"Display a text file.\n"
		"\n"
		"Usage:\n"
			"\tTYPE <FileSpec> [/P]\n"
		"Options:\n"
			"\t/P\tPause after every screenful of text\n"
		"Example:\n"
			"\tTYPE A:AUTOEXEC.BAT\n"
				"\t\tDisplay the AUTOEXEC.BAT file from the A: drive\n",

	 /* VER */
		"Display/Set the version number of ROM-DOS\n"
		"\n"
		"Usage:\n"
			"\tVER [ver#] {Options}\n"
		"Options:\n"
			"\t/R\tDisplay the ROM-DOS revision number and code location\n"
		"Examples:\n"
			"\tVER /r\n"
				"\t\tDisplay the ROM-DOS version number, and note whether\n"
				"\t\tROM-DOS is running from ROM, RAM or the HMA\n"
			"\tVER 5.0\n"
				"\t\tSet reported DOS version to 5.0 for some utility\n",

	 /* VERIFY */
		"Displays or modifies DOS disk writing verification.\n"
		"\n"
		"Usage:\n"
			"\tVERIFY [ON | OFF]\n"
		"Examples:\n"
			"\tVERIFY ON\t\tTurn on the DOS Verify flag\n"
			"\tVERIFY\t\t\tDisplay the Verify status\n"
			"\tVERIFY OFF\t\tTurn off the DOS Verify flag\n",


	 /* VOL */
		"Display the volume label for the default or given drive.\n"
		"\n"
		"Usage:\n"
			"\tVOL [Drive:]\n"
		"Examples:\n"
			"\tVOL B:\n\t\tDisplay the volume label on drive B:\n"
			"\tVOL\n\t\tDisplay the volume label on the current drive\n",

	/* NULL terminator */
		0
};

/* error messages for standard DOS errors, INT 2FH 122EH, dx=0,4 */
char * DOSmsgs[] =
{
	"\xC6\x46",										// 00
	"Invalid function",							// 01
	"File not found",								// 02
	"Path not found",								// 03
	"Too many open files",						// 04
	"Access denied ",								// 05
	"Invalid handle",								// 06
	"Memory control blocks destroyed",		// 07
	"Insufficient memory",						// 08
	"Invalid memory block address",			// 09
	"Invalid Environment",						// 0A
	"Invalid format",								// 0B
	"Invalid function parameter",				// 0C
	"Invalid data",								// 0D
	(char *)0xFFFF,								// 0E
	"Invalid drive specification",			// 0F
	"Attempt to remove current directory",	// 10
	"Not same device",							// 11
	"No more files",								// 12
	"Write protect error",						// 13
	"Invalid unit",								// 14
	"Not ready",									// 15
	"Invalid device request",					// 16
	"Data error",									// 17
	"Invalid device request parameters",	// 18
	"Seek error",									// 19
	"Invalid media type",						// 1A
	"Sector not found",							// 1B
	"Printer out of paper error",				// 1C
	"Write fault error",							// 1D
	"Read fault error",							// 1E
	"General failure",							// 1F
	"Sharing violation",							// 20
	"Lock violation",								// 21
	"Invalid disk change",						// 22
	"FCB unavailable",							// 23
	"System resource exhausted",				// 24
	"Code page mismatch",						// 25
	"Out of input",								// 26
	"Insufficient disk space",					// 27
	(char *)0xFFFF,								// 28
	(char *)0xFFFF,								// 29
	(char *)0xFFFF,								// 2A
	(char *)0xFFFF,								// 2B
	(char *)0xFFFF,								// 2C
	(char *)0xFFFF,								// 2D
	(char *)0xFFFF,								// 2E
	(char *)0xFFFF,								// 2F
	(char *)0xFFFF,								// 30
	(char *)0xFFFF,								// 31
	(char *)0xFFFF,								// 32
	(char *)0xFFFF,								// 33
	(char *)0xFFFF,								// 34
	(char *)0xFFFF,								// 35
	(char *)0xFFFF,								// 36
	(char *)0xFFFF,								// 37
	(char *)0xFFFF,								// 38
	(char *)0xFFFF,								// 39
	(char *)0xFFFF,								// 3A
	(char *)0xFFFF,								// 3B
	(char *)0xFFFF,								// 3C
	(char *)0xFFFF,								// 3D
	(char *)0xFFFF,								// 3E
	(char *)0xFFFF,								// 3F
	(char *)0xFFFF,								// 40
	(char *)0xFFFF,								// 41
	(char *)0xFFFF,								// 42
	(char *)0xFFFF,								// 43
	(char *)0xFFFF,								// 44
	(char *)0xFFFF,								// 45
	(char *)0xFFFF,								// 46
	(char *)0xFFFF,								// 47
	(char *)0xFFFF,								// 48
	(char *)0xFFFF,								// 49
	(char *)0xFFFF,								// 4A
	(char *)0xFFFF,								// 4B
	(char *)0xFFFF,								// 4C
	(char *)0xFFFF,								// 4D
	(char *)0xFFFF,								// 4E
	(char *)0xFFFF,								// 4F
	"File exists",									// 50
	(char *)0xFFFF,								// 51
	"Cannot make directory entry",			// 52
	"Fail on INT 24",								// 53
	"Too many redirections",					// 54
	"Duplicate redirection",					// 55
	"Invalid password",							// 56
	"Invalid parameter",							// 57
	"Network data fault",						// 58
	"Function not supported by network",	// 59
	"Required system component not installed",	// 5A

	/* Terminator */
	0
};

/* paramter error messages, INT 2FH 122EH, dx=2 */
char * PARMmsgs[] =
{
	(char *)0xFFFF,									// 00
	"Too many parameters",							// 01
	"Required parameter missing",					// 02
	"Invalid switch",									// 03
	"Invalid keyword",								// 04
	" ",													// 05
	"Parameter value not in allowed range",	// 06
	"Parameter value not allowed",				// 07
	"Parameter value not allowed",				// 08
	"Parameter format not correct",				// 09
	"Invalid parameter",								// 0A
	"Invalid parameter combination",				// 0B

	/* NULL Terminator */
	0
};


#endif


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR ATTRIB.EXE           |
    |                                         |
   []-----------------------------------------[]
*/
#if ATTRIB
char *USAGE =
	"Displays or changes file attributes.\n"
	"\n"
	"ATTRIB [+R | -R] [+A | -A] [+S | -S] [+H | -H] [[drive:][path]filename]\n"
	"       [/S] [/C]\n"
	"\n"
	"  +   Sets an attribute.\n"
	"  -   Clears an attribute.\n"
	"  R   Read-only file attribute.\n"
	"  A   Archive file attribute.\n"
	"  S   System file attribute.\n"
	"  H   Hidden file attribute.\n"
	"  /S  Processes files in all directories in the specified path.\n"
	"  /C  Clear all attributes\n"
	"";

char *msgs[] =
{
	"Name expand error",							// 0
	"Cannot open '%s'",                    // 1
	"Invalid switch - %s",                 // 2
	"Path not found - %s",						// 3
   "Parameter format not correct - %s",   // 4
   "Not resetting system file %s\\%s",    // 5
   "Not resetting hidden file %s\\%s",    // 6
	"File not found - %s",						// 7
	"Invalid drive specification - %s",    // 8
	"Invalid keyword - %s",                // 9
   "Parameter value not allowed - %s",    // 10
};

#endif /* ATTRIB.EXE */


/*
   []--------------------------------------------[]
    |                                            |
    |          MESSAGES FOR CHKDSK.EXE           |
    |                                            |
   []--------------------------------------------[]
*/

#if CHKDSK

char szUsage[] =
   "Usage = CHKDSK [d:][path][filespec] [/C] [/F] [/V]\n\n"
   "Options\n"
	"\t/C\tDo not confirm before fixing errors\n"
   "\t/F\tFix any errors encountered\n"
   "\t/V\tVerbose, display files and directories\n"
	"\t/[\tHide program signon message\n"
   "\t/?\tShow this help screen\n";

char *szSignon = "CHKDSK %s %s\n%s\n\n";

char szErrSubstDrive[] = "Cannot CHKDSK a SUBSTed or ASSIGNed drive\n";
char szErrInvalidDrive[] = "Invalid drive specification\n";
char szErrRemoteDrive[] = "Cannot CHKDSK a network drive\n";

char vol_str1[] = "\nVolume %s%s created %02u-%02u-%04u %u:%02u%c";
char vol_str2[] = "Volume Serial Number is %04X-%04X\n";

char * stat_str[] =
{
	"bytes total disk space",						// 0
   "bytes in %,u hidden files",					// 1
   "bytes in %,u directories",					// 2
   "bytes in %,u user files",						// 3
   "bytes in %,u recovered files",				// 4
   "bytes in bad sectors",							// 5
   "bytes available on disk",						// 6
	"bytes in each allocation unit",				// 7
	"total allocation units on disk",			// 8
	"available allocation units on disk",		// 9
	"total bytes memory",							// 10
   "bytes free",										// 11
};

char szKiloStr[] = "kilo";

//char szScaledTotalSpace[] = "kilobytes total disk space";
//char szScaledFreeSpace[] = "kilobytes free";

char szCHKName[] = "FILE%04uCHK";

char showdir_str[] = "Directory %s\n";

char chk_nofix[]     =	"Errors found, F parameter not specified\n"
								"Corrections will not be written to disk\n\n";

char szLostMsg[]  = "   %,lu lost allocation units found in %,u chains.\n";
char szLostMsg2[] = "%,13lu bytes disk space would be freed\n\n";
char szLostMsg3[] = "%,13lu bytes disk space freed\n\n";

char szConvLostClusMsg[]   = "Convert lost chains to files  (Y/N)?";

char szFixCrossLinkedMsg[] = "   %s cross linked on allocation unit %lu\n";
char szIs[]  = "Is";
char szWas[] = "Was";

char szInvalidAllocationMsg[] =
	"   Has invalid allocation unit, file truncated\n";

char szInvalidRootMsg[] =
	"   Has invalid allocation unit, root truncated\n";

char szFirstInvalidAllocationMsg[] =
	"   First allocation unit is invalid, entry truncated\n";

char szFileSizeErrorMsg[] =
	"   Allocation error, size adjusted\n";

char szNoExist[] = "   Does not exist\n";
char szNoRecover1[] = "   Cannot recover %s entry%s";
char szNoRecover2[] = ", processing continued\n";
char szNoRecover3[] = "\n   tree past this point not processed\n";
char szUnrecoverableMsg[] = "Unrecoverable error in directory\n";
char szDirEmptyMsg[] =
	"   Directory is totally empty, no . or ..\n"
	"   tree past this point not processed\n";

char szInvalidDirMsg[]  = "   Invalid sub-directory entry\n";

char szInvalidNameMsg[] = "entry with invalid name";
char szFixed[] = "   Fixed %s\n";

char szRenamedAndRelocated[] = "   Renamed and relocated %s to the root\n";

char szConvertDirToFileMsg[] = "Convert directory to file (Y/N)?";

char szInsufRoot[] = "\n"
		"   Insufficient room in root directory\n"
		"   Move files from root directory and repeat CHKDSK\n";

char szTooManyCHKFiles[] = "\n"
		"   There are too many files named FILE*.CHK in the root.\n"
		"   Move files from root directory and repeat CHKDSK\n";

char szInsufficientSpace[] = "\n"
		"   There is not enough disk space available to fix the\n"
		"   cross-linked files.  Remove files from the disk to\n"
		"   free some disk space and repeat CHKDSK.\n\n";

char szOrphanedLFNEntry[] = "   Orphaned LFN entry deleted\n";

char szInvalidEntries[] = "  Directory contains invalid entries.  All invalid\n"
								  "  entries will be deleted but will show up as .CHK\n"
								  "  files in the root.\n";

char szCmpFATCopies[] = "  Comparing FAT copies...\n";

char szSyncFATCopies[] =
		"   The FAT copies did not match.  FAT copies are being syncronized."
		"\n\n";

char szInsufficientMemory[] = "\n"
		"   There is not enough conventional memory and/or XMS memory available\n"
		"   to run CHKDSK.  Free some memory then run CHKDSK.\n";

char szFileNotFound[] = "File not found\n";

char szNonContigious[] = "%s Contains %lu non-contiguous blocks\n";

char szContigious[] = "All specified file(s) are contiguous\n";

char szChkFreeSpace[] = "  Checking FAT32 drive freespace...\n";

char szIncorrectFreeSpace[] =
		"   The drive freespace was incorrect and has been fixed\n";

char szUserAbort[] =
		"\nCHKDSK did not complete because it was aborted by the user.\n";

char szNotReady[] = "Drive not ready\n";

//  For file compare purposes only
//
#if SHOW_SCANDISK_MSG

char szUseScandiskMsg[] = "\n"
"Instead of using CHKDSK, try using SCANDISK.  SCANDISK can reliably detect\n"
"and fix a much wider range of disk problems.\n\n";

#endif

#endif // #if CHKDSK


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR DISKCOMP.COM         |
    |                                         |
   []-----------------------------------------[]
*/
#if DISKCOMP

char * szUsage =
	"Compares the contents of two floppy disks.\n"
	"\n"
	"DISKCOMP [drive1: [drive2:]] [/1] [/8]\n"
	"\n"
	"   /1   Compares the first side of the disks.\n"
	"   /8   Compares only the first eight sectors of each track.\n"
	"";

char * szInsertSource =
	"\nInsert FIRST diskette in drive %c:\n";

char * szInsertTarget =
	"\nInsert SECOND diskette in drive %c:\n";

char * szAnyKey =
	"\nPress any key to continue . . .\n";

char * szReadError =
	"\nUnrecoverable read error on drive %c: Side %u, track %u\n";

char * szCmpError =
	"\nCompare error on\n"
	"side %u, track %u\n";

char * szCmpOk =
	"\nCompare OK\n";

char * szDisplayStats =
	"\nComparing %u tracks\n"
	"%u sectors per track, %u side(s)\n";

char * szCompPrompt =
	"\nCompare another diskette (Y/N)? ";

char * szBadOpt =
	"Bad command line option '%s'\n";

char * szUnkErrorCode =
	"Unknown error code %u";

char * szNotReady =
	"Not ready - %c:"
	"\n"
	"Make sure a diskette is inserted into"
	"\n"
	"the drive and the door is closed"
	"\n"
	"\n"
	"Press CTRL+C to abort,"
	"\n"
	"or correct this problem and press any other key to continue . . ."
	"\n"
	"";

char * szErrorMessages[] =
{
	"",																		// 0
	"Specified drive does not exist or is non-removable.",	// 1
	"Invalid drive specification.",									// 2
	"Cannot DISKCOMP to or from a network drive.",				// 3
	"Cannot DISKCOMP to or from a SUBST drive.",					// 4
	"Drive types or diskette types\nnot compatible",       	// 5
	"Compare process ended",  											// 6
	"Error reading disk.",		  										// 7
	"Error allocating memory.",                              // 8
	"Error freeing memory.",                                 // 9
	"Dos 5.0 or later not detected.",	                     // 10
};

#endif /* DISKCOMP.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR DISKCOPY.COM         |
    |                                         |
   []-----------------------------------------[]
*/
#if DISKCOPY

char * szUsage =
	"Copies the contents of one floppy disk to another.\n"
	"\n"
	"DISKCOPY [drive1: [drive2:]] [/1] [/V] [/M]\n"
	"\n"
  	"\t/1\tCopies only the first side of the disk.\n"
  	"\t/V\tVerifies that the information is copied correctly.\n"
	"\t/M\tForce multi-pass copy using memory only.\n"
	"\n"
	"The two floppy disks must be the same type.\n"
	"You may specify the same drive for drive1 and drive2.\n"
	"";

char * szMemOnly =
	"Error creating image file.  "
	"Diskcopy will revert to a multiple-pass copy.\n";

char * szInsertSource =
	"\nInsert SOURCE diskette in drive %c:\n";

char * szInsertTarget =
	"\nInsert TARGET diskette in drive %c:\n";

char * szFormatting =
	"\nFormatting while copying\n";

char * szAnyKey =
	"\nPress any key to continue . . .\n";

char * szAnotherDupe =
	"\nDo you wish to write another duplicate of this disk (Y/N)? ";

char * szReadError =
	"\nUnrecoverable read error on drive %c: Side %u, track %u\n";

char * szWriteError =
	"\nUnrecoverable write error on drive %c: Side %u, track %u\n";

char * szCmpError =
	"\nVerify compare error on drive %c: Side %u, track %u\n";

char * szReadSrc =
	"\nReading from source diskette . . .\n";

char * szWriteTarg =
	"\nWriting to target diskette . . .\n";

char * szDisplayStats =
	"\nCopying %u tracks, %u sectors per track, %u side(s).\n";

char * szDisplaySerial =
	"\nVolume Serial Number is %04X-%04X\n";

char * szCopyPrompt =
	"\nCopy another diskette (Y/N)? ";

char * szBadOpt =
	"Bad command line option '%s'\n";

char * szUnkErrorCode =
	"Unknown error code %u";

char * szNotReady =
	"Not ready - %c:"
	"\n"
	"Make sure a diskette is inserted into"
	"\n"
	"the drive and the door is closed"
	"\n"
	"\n"
	"Press CTRL+C to abort,"
	"\n"
	"or correct this problem and press any other key to continue . . ."
	"\n"
	"";

char * szErrorMessages[] =
{
	"",																		// 0
	"Specified drive does not exist or is non-removable.",	// 1
	"Invalid drive specification.",									// 2
	"Cannot DISKCOPY to or from a network drive.",				// 3
	"Cannot DISKCOPY to or from a SUBST drive.",					// 4
	"Drive types or diskette types not compatible",       	// 5
	"Copy process ended",												// 6
	"Error reading disk.",		  										// 7
	"Error writing disk.",                                   // 8
	"Error allocating memory.",                              // 9
	"Error freeing memory.",                                 // 10
	"Error formatting disk.", 											// 11
	"Dos 5.0 or later not detected.",	                     // 12
	"Error deleting swapfile.",										// 13
	"Error closing swapfile.",											// 14
};

#endif /* DISKCOPY.COM */

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR DUMP.EXE             |
    |                                         |
   []-----------------------------------------[]
*/
#if DUMP
char USAGE[] =
	"DUMP %s\n"
	"%s\n"
	"\n"
	"Usage = Dump  <filename> [<offset>] [<length>]\n"
	" -or-   Dump /<address>  [<length>]\n"
	"\n"
	"Note: <offset>, <address>, and <length> represent hexidecimal numbers.\n"
	"      The <address> should be a two word value.  ie 03F8:0010\n";


char errMsgFileNotFound[] = "Can't open file '%s'\n";

#endif /* DUMP.EXE */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR FDISK.EXE            |
    |                                         |
   []-----------------------------------------[]
*/
#if FDISK

char USAGE_P1[] =
	"Usage = FDISK [drive] [/3] [/C] [/I# [/N]] [/B|/R|/V] [/S#] [/?]\n"
	"Options\n";
char USAGE_P2[] =
	"   /3   Enable large disk support\n";
char USAGE_P3[] =
	"   /B   Make partition. Force update of Master Boot Record code\n"
	"   /C   Don't confirm (no operator input)\n"
	"   /I#  Make non-DOS or Super-Boot partition with this ID (default 98h)\n"
	"   /N   Don't write MBR code for non-DOS or Super-Boot partitions\n"
	"   /R   Refresh Master Boot Record code only\n"
	"   /S#  Partition size in megabytes (default: large as possible)\n"
	"   /V   View partitions and exit\n"
	"   /?   This help screen\n"
	"\n"
	"Examples:\n"
	"\n"
	"FDISK 81 /R /C\t\tRefresh MBR code on drive 81h\n"
	"FDISK 80 /I98 /S5 /C\tCreate a 5 Megabyte SuperBoot partition\n";
char USAGE_P4[] =
	"FDISK 80 /3 /S0 /C\tCreate a FAT 32 partition, as large as possible\n";

char szEnableFat32[] = "Do you wish to enable large disk support? ";

/* fatal errors */
char szErrNoFixedDisks[] = "No fixed disks!\n";
char szErrInternal[]     = "FDISK Internal error (%u.%u)!\n";
char szErrBadValue[]     = "Please enter a value between %Xh and %Xh.\n";
char szErrInvalidDrive[] = "Invalid drive!\n";
char szErrIncompatibleOptions[] =
	"Incompatible options! Use only one of /B, /R or /V.\n";
char szErrNoMem[]        = "Not enough memory!\n";
char szErrInvalidPartition[] = "Invalid partition record %u!\n\n";
char szDeleteInvalidPartition[] = "Delete invalid partition and continue?";
char szErrNotFAT32World[] = "FAT32 features require the FAT32 kernel.\n";
char szErrDriveParms[] = "Error retrieving the drive parameters.\n";
char szErrWriting[] = "Error writing to disk.\n";
char szErrReading[] = "Error reading from disk.\n";

/* partition display */
char szFixedInfo[]  = "Fixed Disk %u of %u:  Cylinders %lu, Heads %lu, Sectors %lu, Size %s\n";
char szPartHeader[] = "Drive  Bootable  Type      StartCyl    EndCyl   Size    Bytes\n";
char szPartInfo[]   = "  %s%7c      %-12s%4lu%11lu%8lu %14s\n";
char szPartSect[]   = "Partition sector at %lX\n";
char szId12[]    = "DOS 12 ";			// 01h
char szId16[]    = "DOS 16 ";			// 04h
char szIdExt[]   = "EXT DOS";			// 05h
char szIdBig[]   = "DOS BIG ";		// 06h
char szId32[]    = "FAT 32";			// 0Bh
char szId32Lba[] = "F32 LBA";			// 0Ch
char szIdBigLba[]= "BIG LBA";			// 0Eh
char szIdExtLba[]= "EXT LBA";			// 0Fh
char szIdSuper[] = "SUPER(%Xh)";		// usually 98h (assumed super-boot)
char szIdDLRel[] = "RELIANCE";      // CCh
char szIdNonDos[]= "non-DOS(%Xh)";	// unknown id
char szNoPartitions[]  = "\tNo partitions\n";
char szViewWhichDrive[]="View partition(s) for which drive (1-%u)";

char szWriteMBRForDrive[]= "Force Master Boot Record code write for which drive (1-%u)";
char szWriteMBR[]= "Master Boot Record code will be written when you Save Changes\n\n";
char szNoChange[] = "No changes made\n";

/* delete strings */
char szDelPartOnDrive[]= "Delete a partition for which drive (1-%u)";
char szDeleteAll[]  = "Delete all partitions for which drive (1-%u)";
char szDelSuper[]="Delete a non-DOS or Super-Boot partition? ";
char szDiskEmpty[]= "No partitions on fixed disk %u!\n\n";
char szWarnDisk[]= "Warning! All data on fixed disk %u will be lost!\n";
char szWarnDrive[]= "Warning! All data for drive %c will be lost!\n";
char szWarnSuper[]= "Warning! All data in non-dos or Super-Boot partition %X will be lost\n";
char szAreYouSure[]=  "Are you sure you want to delete? ";
char szDeleted[]=  "Partition(s) deleted.\n\n";
char szDelByLetter[]="Enter one of the above drive letters";
char szDelSuperID[]="Enter non-DOS or Super-Boot partition id";

/* create strings */
char szCreateWhich[]  = "Create a partition for which drive (1-%u)";
char szCreateAnother[]= "Create another partition? ";
char szSuperID[]      = "Enter non-DOS or Super-Boot partition ID ";
char szDiskFilled[]   = "All space used on fixed disk!\n\n";
char szNoDrivesLeft[] = "All DOS drive letters are in use!\n\n";
char szNoPartsLeft[]  = "All partition entries used!\n\n";
char szToggleNoDos[]  = "No Primary DOS partition!";
char szToggleDos[] = "Primary partition on fixed disk %u is now %sbootable\n";
char szUn[]           = "un";
char szSaved[]        = "Changes saved. Press any key to reboot...";
char szSavedNoBoot[]  = "Changed saved. Reboot system for changes to take effect...";
char szQuit[]         = "Abandon changes. Are you sure?";
char szOverwrite[] = "It appears a valid DOS partition resides on drive %02Xh at cylinder %u.\n";
char szEraseAnyway[]  = "Erase system areas anyway? ";
char szMaxPart[]   = "Maximum partition size is %lu cylinders (%s bytes).\n";
char szGetPartSize[] = "\nEnter partition size in cylinders (#) or megs (#M) [%lu]: ";
char szInvalidSize[] = "Invalid partition size!\n";
char szInvalidID[]   = "Invalid partition ID! Use 10h - FFh. Default 98h recommended.\n";
char szWarningID[]   = "Warning! This partition ID may conflict with another OS.\n";

/* enter a command */
char szSignOn[]  =  "FDISK %s %s\n%s\n\n";
char szGetCmd[]  =  "Enter command ";
char szEsc[]     =  "esc\n";

/* menu choices */
#define VIEW_CHAR		'V'
#define RAW_CHAR		'R'
#define CREATE_CHAR	'C'
#define SUPER_CHAR	'P'
#define DELETE_CHAR	'D'
#define DELALL_CHAR	'A'
#define BOOT_CHAR		'T'
#define CODE_CHAR		'M'
#define QUIT_CHAR		'Q'
#define SAVE_CHAR		'S'

char szViewPartitions[]       = "View partition(s)";
char szDisplayRawPartitions[] = "View partitions(s), raw format";
char szCreatePartition[]      = "Create DOS partition(s)";
char szCreateSuperPart[]      = "Create non-DOS or Super-Boot partition";
char szDeletePartition[]      = "Delete a partition";
char szDeleteAllPartitions[]  = "Delete all partitions";
char szToggleBoot[]           = "Toggle boot status";
char szRewriteMBRCode[]       = "Write Master Boot Record code";
char szQuitButDontSave[]      = "Quit without saving";
char szSaveAndExit[]          = "Save changes (and reboot)";

char szToggleDrive[]= "Toggle boot status on which drive (1-%u)";

/* yes/no questions */
char szAskYesNo[] = "%s [%c]: ";
#define YES_CHAR 'Y'
#define NO_CHAR 'N'

char szPressEsc[] = "Press Esc to return to menu: ";
#define ESC      27

char szStrikeKey[] = "Strike a key when ready . . . ";

#endif /* FDISK.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR FIND.EXE             |
    |                                         |
   []-----------------------------------------[]
*/
// Used to be FIND, but FIND conflicts with new type in DOSTRUCT.H
#if FIND_COM

char USAGE[] =
	"Searches for a text string in a file or files.\n"
	"\n"
	"FIND [/V] [/C] [/N] [/I] \"string\" [[drive:][path]filename[ ...]]\n"
	"\n"
	"  /V        Displays all lines NOT containing the specified string.\n"
	"  /C        Displays only the count of lines containing the string.\n"
	"  /N        Displays line numbers with the displayed lines.\n"
	"  /I        Ignores the case of characters when searching for the string.\n"
	"  \"string\"  Specifies the text string to find.\n"
	"  [drive:][path]filename\n"
	"            Specifies a file or files to search.\n"
	"\n"
	"If a pathname is not specified, FIND searches the text typed at the prompt\n"
	"or piped from another command.\n";

char bad_opt[] = "FIND: Invalid switch\n";
char cant_open_str[] = "File not found - %s";
char match_str[] = ": %u\n";
char szBadFormat[] = "FIND: Parameter format not correct\n";
char szMissingParm[] = "FIND: Required parameter missing\n";

#endif /* FIND.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR FORMAT.COM           |
    |                                         |
   []-----------------------------------------[]
*/
#if FORMAT

char szUsage[] =
	"Formats a disk for use with DOS.\n"
	"\n"
	"FORMAT drive: [/V[:label]] [/Q] [/F:size] [/S] [/C]\n"
	"FORMAT drive: [/V[:label]] [/Q] [/4 | /7] [/S] [/C]\n"
	"FORMAT drive: [/Q] [/4 | /7] [/S] [/C]\n"
	"\n"
	"  /V[:label]  Specifies the volume label.\n"
	"  /Q          Performs a quick format.\n"
	"  /F:size     Specifies the size of the floppy disk to format (such\n"
	"              as 360, 720, 1.2, 1.44, 2.88).\n"
	"  /S          Copies system files to the formatted disk.\n"
	"  /H          Don't Hide (or write protect) system files\n"
	"  /4          Format 360K disk on 1.2M, 1.44M or 2.88M drive\n"
	"  /7          Format 720K disk on 1.44M or 2.88M drive\n"
	"  /C          Don't confirm before formatting\n"
	"  /[          Do not show program signon message\n"
	"";


char *err_msg[] =
{
	"Cannot format system track - disk unusable\n",				// 0
	"Write protect error\n",											// 1
	"No command line parameters\n",									// 2
	"User aborted\n",														// 3
	"Insufficient conventional memory\n",							// 4
	"Error resizing memory\n",											// 5
	"Error releasing memory\n",										// 6
	"No drive letter specified\n",									// 7
	"Unable to open the file '%s'\n",								// 8
	"Read error drive %c\n",											// 9
	"Write error drive '%c'\n",										// 10
	"Error closing file\n",												// 11
	"Error getting files date and time\n",							// 12
	"Invalid drive letter '%c'\n",									// 13
	"Error creating file '%s'\n",										// 14
	"Drive not ready\n",													// 15
	"Format not supported on drive %c:\n",							// 16
	"Error executing the LOCK command\n",							// 17
	"Error executing the UNLOCK command\n",						// 18
	"Can not specify hard drive sizes\n",							// 19
	"Can not quick format drive %c:\n",								// 20
	"Error! Too many bad clusters\n",								// 21
	"Can not specify quick format sizes\n",						// 22
   "Invalid switch - /A%s\n",                               // 23
};

char szErrorNotFat32Kernel[] =
		"FAT32 drives require a DOS 7.xx kernel.\n";

char szWritingFat[] = "Writing out file allocation table\n";

char szComplete[] = "Complete.\n";

char szCalcFreeSpace[] =
	"Calculating free space (this may take several minutes)...\n";

char szCannotQuickFormat[] = "This disk cannot be QuickFormatted.\n"
	"Proceed with Unconditional Format (Y/N)?";

char warn_olddos[] = "";

char sysboot_getsys[] =
	"Failed to find system file '%s'\n"
	"Enter path where it resides: ";

char newdisk_str[] =
	"Insert new diskette for drive %c:\n"
	"and press ENTER when ready...";

char szWarnLostData[] =
	"WARNING, ALL DATA ON NON-REMOVABLE DISK\n"
	"DRIVE %c: WILL BE LOST!\n"
	"Proceed with Format (Y/N)?";

char quick_str[] = "Quick";
char format_type_str[] = "Formatting %s\n";
char szFormatComplete[] = "Format complete.\n";
char szFormatTerminated[] = "Format terminated.\n";
char getvol_str[] = "\nVolume label (11 characters, ENTER for none)? ";
char volume_str[20]={12,0}, illegalVolChars[] = "\\/<>+?*";
char another_str[] = "Format another (Y/N)?";
char format_percent[] = "\x0d%3u% percent complete.\x0d";

char stat_str1[] = "%,13lu bytes ";
char stat_str2[] = "%,10lu.%02u MB ";
char stat_str3[] = "%,13lu %s\n";
char *stat_msg[] =
{
	"total disk space\n",
	"in bad sectors\n",
	"used by system\n",
	"available on disk\n",
	"bytes in each allocation unit.",
	"allocation units available on disk.\n",
};

char volume_serial[] = "Volume Serial Number is %04x-%04x\n\n";

char szSystemTransfered[] = "System transferred\n";

#endif /* FORMAT.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR HEXCAT.COM           |
    |                                         |
   []-----------------------------------------[]
*/
#if HEXCAT

#define DEF_OUTNAME "ROM.HEX"
char USAGE[] =
	"HEXCAT concatenates multiple HEX files into a single file\n\n"
	"Usage = HEXCAT {options} {filespecs}\n\n"
	"Options\n"
	"\t/N<HexFileName>\tName the output HEX file (Defaults to "
	DEF_OUTNAME
	")\n";

char success_str[] = "HEX file '%s' written successfully\n";
char bad_opt[] = "Invalid option '%s'\n";
char cant_create_str[] = "Cannot creat HEX file '%s'\n";
char cant_open_str[] = "Cannot open '%s'\n";
char warn_noseg[] =
	"Warning: Hex file '%s' does not have segment information\n";
char corrupt_str[] = "Input HEX file '%s' is corrupted at line %u\n";
char fatal_str[] = "Fatal Error: ";
char place_str[] = "Placing File '%s' at segment %s\n";
char next_seg_str[] = "\tNext Segment at %s\n";

#endif /* HEXCAT.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR LABEL.EXE            |
    |                                         |
   []-----------------------------------------[]
*/
#if LABEL

/* note: volume string may be in quotes or not */
char USAGE[] = "Usage = LABEL [d:][VolumeString] \n";

char *errmsg[] =
{
	"Invalid drive specification",
	"Invalid characters in volume label",
	"Failed to write label"
};

char *msg[] =
{
	"Volume in drive ",
	" is ",
	" has no label",
	"Volume label (11 characters, ENTER for none)? ",
	"Delete current volume label (Y/N)? ",
	"Volume Serial Number is "
};

#endif /* LABEL.EXE */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR MODE.COM             |
    |                                         |
   []-----------------------------------------[]
*/
#if MODE

char USAGE[] =
	"Usage = MODE COMn: baud [,parity [,databits [,stop bits [,p]]]]\n"
   "\tMODE LPTn:=COMn:\n"
	"\tMODE <DisplayLines> where DisplayLines is either L25, L43 or L50\n"
   "\tMODE <VideoMode> where VideoMode is any of:\n"
	"\t\t40, 80, BW40, BW80, CO40, CO80, or MONO\n";

char bad_opt[]     = "Invalid Option: '%s'\n";
char bad_printer[] = "Invalid Printer '%s'\n";
char bad_port[]    = "Port COM%d does not exist\n";
char bad_redir[]   = "Must redirect to a COM port, not '%s'\n";
char bad_dev[]     = "Can't find device!\n";
char reroute_str[] = "LPT%u: rerouted to COM%u\n";

char err_invalid[] = "Invalid %s %s\n";
char *error_msg[] =
{
   "parameter ",         /* 0 */
   "port ",
   "baud ",
   "parity ",
   "data bits ",
   "stop bits ",         /* 5 */
   "- no COM ports!"
};

char res_installed[] = "\nResident portion of MODE installed\n";

#endif /* MODE.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR MORE.COM             |
    |                                         |
   []-----------------------------------------[]
*/
#if MORE

char USAGE[] =
"Displays output one screen at a time.\n"
"\n"
"MORE [drive:][path]filename\n"
"MORE < [drive:][path]filename\n"
"command-name | MORE [drive:][path][filename]\n"
"\n"
"  [drive:][path]filename  Specifies file(s) to display one screen at a time\n"
"  command-name            Specifies a command whose output will be displayed.\n"
"";

char cant_open_str[] = "Cannot open '%s'\n";
char bad_opt[] = "Invalid option '%s'\n";
char more_str[] = "--More-- %u%%";
char clear_more[] = "\r                \r";	/* clear the above line */

#endif /* MORE.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR PRINT.COM            |
    |                                         |
   []-----------------------------------------[]
*/
#if PRINT

char USAGE[] =
	"\nPRINT - A Printer Spooler Utility\n\n"
	"Usage = PRINT {options} {filespecs}\n\n"
	"Options\n"
	"*\t/B:num\tSet PRINT buffer size (default is 512)\n"
	"\t/C\tCancel files listed after this option\n"
	"*\t/F:num\tSet maximum # of files PRINT can queue (default is 10)\n"
	"\t/H\tDisplay this screen\n"
	"\t/P\tSubmit files listed after this option for printing\n"
	"\t/T\tCancel all files in the PRINT queue\n\n"
	"* The /B and /F options can only be used on the first time PRINT is run\n";

char installed_str[] = "Resident part of PRINT installed\n";
char first_time_str[] = "/%c only allowed the first time PRINT is run\n";
char fatal_str[] = "\nError: %s\n";
char bad_opt[] = "Invalid option '%s'\n";
char offline_str[] =
	"\nErrors on list device indicate that it\n"
	"may be off-line.  Please check it.\n\n";
char queue_empty_str[] = "\nPrint queue is empty\n";
char printed_str[] = "is currently being printed";
char in_queue_str[] = "is in queue";
char cant_open_str[] = "\nCannot open '%s'\n";
char szNoFilesFound[] = "No files found matching '%s'\n";
char get_devname_str[] = "Name of list device [%s]: ";
char not_device_str[] = "List output is not assigned to a device\n";

#endif /* PRINT.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR SORT.EXE             |
    |                                         |
   []-----------------------------------------[]
*/
#if SORT

char USAGE[] =
"Sorts input and writes results to the screen, a file, or another device\n"
"\n"
"SORT [/R] [/+n] [[drive1:][path1]filename1] [> [drive2:][path2]filename2]\n"
"[command | ] SORT [/R] [/+n] [> [drive2:][path2]filename2]\n"
"\n"
"  /R                         Reverses the sort order; that is, sorts Z to A,\n"
"                             then 9 to 0.\n"
"  /+n                        Sorts the file according to characters in\n"
"                             column n.\n"
"  [drive1:][path1]filename1  Specifies file(s) to be sorted\n"
"  [drive2:][path2]filename2  Specifies a file where the sorted input is to be\n"
"                             stored.\n"
"  command                    Specifies a command whose output is to be sorted.\n"
"";

char bad_opt[] = "Invalid Option '%s'\n";
char cant_open_str[] = "Cannot open '%s'\n";
char nothing_to_sort_str[] = "Input file is empty\n";
char out_of_mem[] = "Out of memory\n";

#endif /* SORT.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR SYS.COM              |
    |                                         |
   []-----------------------------------------[]
*/
#if SYS

char sysboot_getsys[] =
	"Failed to find system file '%s'\n"
	"Enter path where it resides: ";

char USAGE[] =
	"Usage = SYS <drive:> {options}\n\n"
	"Options\n"
	"\t/C\tDo not confirm before transfering system\n"
	"\t/H\tDo not hide system files\n"
	"\t/[\tDo not show program signon message\n";

char *err_msg[] =
{
	"System transferred\n",												/* 0  */
	"Write protect error\n",											/* 1  */
	"No command line parameters\n",									/* 2  */
	"User aborted\n",														/* 3  */
	"Insufficient conventional memory\n",							/* 4  */
	"Error resizing memory\n",											/* 5  */
	"Error releasing memory\n",										/* 6  */
	"No drive letter specified\n",									/* 7  */
	"Unable to open the file '%s'\n",								/* 8  */
	"Read error drive %c\n",											/* 9  */
	"Write error drive '%c'\n",										/* 10 */
	"Error closing file\n",												/* 11 */
	"Error getting files date and time\n",							/* 12 */
	"Invalid drive letter '%c'\n",									/* 13 */
	"Error creating file '%s'\n",										/* 14 */
	"Drive not ready\n",												   /* 15 */
	"Error deleting previous system files\n",						/* 16 */
	"Error executing the LOCK command\n",							/* 17 */
	"Error executing the UNLOCK command\n",						/* 18 */
	"Insufficient disk space\n",										/* 19 */
	"Invalid Bios Parameter Block on drive '%c'\n",				/* 20 */
	"Need 3 root directory entries\n",								/* 21 */
	"Cannot sys the network drive '%c'\n",							/* 22 */
	"Cannot create boot sector\n",									/* 23 */
	"Could not retrieve the drive specifications\n",			/* 24 */
	"Command.com not found in current directory\n",				/* 25 */
	"Invalid change of disk\n",										/* 26 */
	"Multiple drive letters on command line\n",					/* 27 */
	"This program only supports FAT 12 or FAT 16 drives\n",	/* 28 */
	"This program does not support 128 byte sector sizes\n", /* 29 */
	"Cannot SYS the Windows boot drive while running Windows\n", /* 30 */
};


char szErrorNotFat32Kernel[] =
		"FAT32 drives require a DOS 7.xx kernel.\n";

char bad_opt[] = "Invalid Option '%c'\n";

char warn_olddos[] =
	"Warning!! System files already reside on this disk!\n"
	"Do you want to replace them ? [N] ";
char warn_switch[] =
	"Insert new disk for System and press return.";
char yes_char = 'Y';		/* anything else means no */

char internal_error[] = "SYS Internal Error %u";

#endif /* SYS.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR TRANSFER.EXE         |
    |                                         |
   []-----------------------------------------[]
*/
#if TRANSFER
char usage[] =
	"Usage = TRANSFER {options} filename\n"
	"\n"
	"Options\n"
	"\t/S\tSend a file\n"
	"\t/R\tReceive a file\n"
	"\t/B#\tSet baud rate (default 9600 if COM#)\n"
	"\t/BC\tUse BIOS Console to transfer files (instead of CTTY) \n"
	"\t/COM#\tUse COM port 1..4 for transfer (default is CONsole)\n"
	"\t/IRQ#\tUse IRQ number 3..15 (defaults IRQ4=COM1,COM3 IRQ3=COM2,COM4)\n"
	"\t/Q\tDisplay no output to the screen (quiet)\n"
	"\n"
	"Example\n"
	"\tC>TRANSFER /r /com1 B:\TEST.EXE\n"
	"\tC>TRANSFER /r /com4 /irq11 TEST.EXE\n"
	"\n"
	"Transfer uses the XMODEM protocol to send/receive files.\n";

char bad_opt_str[] = "\nBad option %s!\n";
char filename_msg[] = "\nYou must specify the filename!\n";
char sendrec_msg[] = "\nYou must specify either /R or /S!\n";
char irq_msg[] = "\nIRQ numbers must be between 3 and 15!\n";
char sending_msg[] = "Sending %s...\n";
char open_fail_msg[] = "Failed to open %s!\n";
char send_fail_msg[] = "Failed to send %s!\n";
char user_can_msg[] = "User cancelled %s!\n";
char receiving_msg[] = "Receiving %s...\n";
char create_fail_msg[] = "Failed to create %s!\n";
char receive_fail_msg[] = "Failed to receive %s!\n";
char deleting_msg[] = "Deleting %s\n";
char trans_block_char[] = "T";
char receive_block_char[] = "R";

#endif /* TRANSFER.EXE */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR TREE.COM             |
    |                                         |
   []-----------------------------------------[]
*/
#if NEWTREE
char szUsage[] =

"Graphically displays the directory structure of a drive or path.\n"
"\n"
"TREE [drive:][path] [/F] [/A]\n"
"\n"
"  /F   Displays the names of the files in each directory.\n"
"  /A   Uses ASCII instead of extended characters.\n"
"  /[   Hide the program signon message\n"
"";

char szVolumeStr[] = "Directory PATH listing for Volume %-11s\n";
char szSerialStr[] = "Volume Serial Number is %04X-%04X\n";
char szPathStr[] = "%s\n";

char szNoSubdirMsg[] = "No sub-directories exist\n\n";
char szInvalidPath[] = "Invalid path - %s\n";
char szInvalidSwitch[] = "Invalid switch -  %s\n";

#endif

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR XCOPY.EXE            |
    |                                         |
   []-----------------------------------------[]
*/
#if XCOPY

char usageMsg[] =
	"Copies files and directory trees.\n"
	"\n"
	"XCOPY source [destination] [/A | /M] [/D[:date]] [/P] [/S [/E]] [/W]\n"
	"                           [/Y | /-Y]\n"
	"\n"
	" source       Specifies the file(s) to copy.\n"
	" destination  Specifies the location and/or name of new files.\n"
	" /A           Copies files with the archive attribute set,\n"
	"              doesn't change the attribute.\n"
	" /M           Copies files with the archive attribute set,\n"
	"              turns off the archive attribute.\n"
	" /D:date      Copies files changed on or after the specified date.\n"
	"              If no date is given, copies only those files whose\n"
	"              source time is newer than the destination time.\n"
	" /P           Prompts you before creating each destination file.\n"
	" /S           Copies directories and subdirectories except empty ones.\n"
	" /E           Copies directories and subdirectories, including empty ones.\n"
	"              Same as /S /E.\n"
	" /W           Prompts you to press a key before copying.\n"
	" /Q           Does not display file names while copying.\n"
	" /F           Displays full source and destination file names while copying.\n"
	" /H           Copies hidden and system files also.\n"
	" /K           Copies attributes. Normal Xcopy will reset read-only attributes.\n"
	" /Y           Overwrites existing files without prompting.\n"
	" /-Y          Prompts you before overwriting existing files.\n";

char *msgs[] =
{                                               // from XCOPY.H
   "Msg 0",
   "File not found - %s",                       // ERR_FILENOTFOUND
   "Cannot create '%s'",                        // ERR_CANNOTCREATE
   "IO error",                                  // ERR_IOERROR
   "Invalid source path",                       // ERR_INVALIDSOURCE
   "Invalid destination path",                  // ERR_INVALIDDESTINATION
   "Cannot perform a cyclic copy",              // ERR_CYCLICCOPY
   "Insufficient disk space",                   // ERR_DISKSPACE
   "Access denied",	                         	// ERR_ACCESSDENIED
   "Access is denied",	                        // ERR_LFNACCESSDENIED
   "Error reading file '%s'",                   // ERR_ERRORREADINGFILE
   "Insufficient memory",                       // ERR_INSUFFICENTMEMORY
   "Cannot XCOPY to a reserved device",         // ERR_TORESERVEDDEVICE
   "Cannot XCOPY from a reserved device",       // ERR_FROMRESERVEDDEVICE
   "Invalid number of parameters",              // ERR_INVALIDPARAMETERS
   "Path too deep!",                            // ERR_PATHTOODEEP
   "Invalid switch - %s",                       // ERR_INVALIDSWITCH
   "Invalid parameter - %s",                    // ERR_LFNINVALIDSWITCH
   "XCOPY Internal Error: %u %u",               // ERR_INTERNALERROR
	"File cannot be copied onto itself",			// ERR_COPIEDTOITSELF
	"Invalid date",										// ERR_INVALIDDATE
	"Invalid drive specification",					// ERR_INVALIDDRIVE
};

#define YES_CHAR 'Y'
#define NO_CHAR  'N'
#define ALL_CHAR 'A'

char press_a_key[]     = "\nPress any key to begin copying file(s)\n";
char file_count_str[]  = "\t%u File(s) copied\n";
char ask_create[]      = "Create %s %s? ";
char createOptStr[]    = {'(',YES_CHAR,'/',NO_CHAR,')',0};
char createOptions[]   = {YES_CHAR,NO_CHAR,0};
char askOverwrite[]    = "Overwrite %s %s? ";
char overwriteOptStr[] = "(Yes/No/All)";
char overwriteOptions[]= {YES_CHAR,NO_CHAR,ALL_CHAR,0};
char reading_str[]     = "Reading source file(s)...\n";
char specify_file[]    = "Does %s specify a file name\nor directory name on the target\n(F = File, D = Directory)? ";
char FileDirOptions[] = {'F', 'D', 0 };

#endif /* XCOPY.EXE */

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR XDEL.COM             |
    |                                         |
   []-----------------------------------------[]
*/

#if XDEL
char *Usage = "Usage = XDEL <filespec> {options}\n\n"
	"Options\n"
	"\t/D\tRemove Subdirectories\n"
	"\t/P\tPrompt before deleting each file\n"
	"\t/R\tDelete read-only files\n"
	"\t/S\tDelete files in subdirectories\n";

char *msgs[] =
{
		"Msg 0",
		"Invalid Option '%s'",
		"Invalid path",
		"Path does not exist",
};

char press_a_key[] = "\nPress any Key to begin copying file(s)\n";
char file_count_str[] = "\t%u file(s) deleted.\n";
char ask_copy[] = "Delete file %s\\%s (Y/N)? :";
char reading_str[] = "\nReading source file(s)...\n";
char internal_err[] = "XDEL Internal Error: %u\n";

#define YES_CHAR 'Y'
#define NO_CHAR  'N'

#endif	/* XDEL.COM */


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR DISPLAY.SYS          |
    |                                         |
   []-----------------------------------------[]
*/
#if DISPLAYSYS
unsigned char * string[] =
{
	"ERROR: DISPLAY already installed\r\n$",					// 0
	"ERROR: DISPLAY requires EGA or better\r\n$",
	"ERROR: Can't open $",
	"ERROR: invalid file $",
	"ERROR: code page not available\r\n$",
	"Code page ",														// 5
	"DISPLAY.SYS ",
	0
};

#endif DISPLAYSYS

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR KEYB.SYS             |
    |                                         |
   []-----------------------------------------[]
*/
#if KEYB
unsigned char * string[] =
{
	"Current keyboard code: %c%c\nCurrent code page: %u\n",		// 0
	"KEYB has not been installed\n",
	"Incompatible KEYB is already resident\n",
	"Error: Unable to load Country %s",
	", Code page %u\n",
	"Error: Can't open keyboard definition file",					// 5
	0
};
#endif

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR POWER.EXE            |
    |                                         |
   []-----------------------------------------[]
*/
#if POWER

char *SIGNON = "ROM-DOS Power Manager %s %s\n%s\n\n";

char *USAGE  = "Usage = POWER {options}\n\n"
"Options\n"
"\t/C#\tSet the COM Ports time\n"
"\t/D#\tSet the Disk time\n"
"\t/H \tDisplay the help <this information>\n"
"\t/K#\tSet the Keyboard time\n"
"\t/P#\tSet the Printer time\n"
"\t/S#\tSet the Screen time\n"
"\t/ADV:MIN\tProvide minimum power reduction (most responsive)\n"
"\t/ADV:REG\tProvide standard power reduction\n"
"\t/ADV:MAX\tProvide maximum power reduction (least responsive)\n"
"\t/STD\tProvide standard power reduction\n"
"\t/OFF\tTurn off power management\n"
"Note: The '#' defines the number of seconds the device can be inactive\n"
"      before it will be powered down.\n"
;

char *messages[] = {
	"Msg0",
	"BIOS Does not support Power Management!",
	"Invalid Option '%c'",
	"POWER - Installed!",
	"POWER - Now unInstalled!",
	"Power Management already installed!",
	"Msg 6",
};

#endif	/* POWER.EXE */

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR SHARE.EXE            |
    |                                         |
   []-----------------------------------------[]
*/
#if SHARE

char SIGNON[] = "SHARE ";
char USAGE[]  = "Usage = SHARE [/L:nn] [/U]\n\n"
"Options\n"
"\t/L:#\tSet the number of Locks\n"
"\t/U\tUnload SHARE\n";

char msg_uninstalled[] = "uninstalled.\n";
char *msg_installed = msg_uninstalled+2;
char msg_already_installed[] = "...is already installed!\n";
char msg_cant_uninstall[] = "...can't uninstall!\n";

#endif	/* SHARE.EXE */

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR DISK2IMG.EXE         |
    |                                         |
   []-----------------------------------------[]
*/
#if DISK2IMG

char szUsage[] =
	"Usage = DISK2IMG <d:> <filespec>\n"
	"Examples\n"
	"\tC>DISK2IMG a: flop.img\n"
	"\tC>DISK2IMG e: C:\\TEMP\\compress.bin\n";

char create_msg[]  = "Creating '%s' (%lu bytes) from drive %c...\n";

char read_fail_msg[] = "  Failed to read drive %c!\n";
char write_fail_msg[] = "  Failed to write to '%s'!\n";
char bpb_err_msg[] = "BPB error on drive %c!\n";
char not_enough_space_msg[] = "  Not enough space to save image on drive %c!\n";
char cannot_create_msg[] = "  Cannot create '%s'!\n";

#endif	// DISK2IMG


#if SUBST

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR SUBST.EXE            |
    |                                         |
   []-----------------------------------------[]
*/
char szUSAGE[] =
	"Associates a path with a drive letter.\n"
	"\n"
	"SUBST [drive1: [drive2:]path]\n"
	"SUBST drive1: /D\n"
	"\n"
	"  drive1:        Specifies a virtual drive to which you want to assign a path.\n"
	"  [drive2:]path  Specifies a physical drive and path you want to assign to\n"
	"                 a virtual drive.\n"
	"  /D             Deletes a substituted (virtual) drive.\n"
	"\n"
	"Type SUBST with no parameters to display a list of current virtual drives.\n"
	"";

char signon[] = "ROM-DOS SUBST %s %s\n%s\n\n";

//char err_not_subst[] = "Cannot delete a drive unless it is SUBSTed!\n";
char err_not_subst[] = "Invalid parameter\n";
char err_invalid_drive[] = "Invalid drive\n";
char err_bad_path[] = "Path not found - %s\n";

char szErrInvalidParm[] = "Invalid parameter -  %s\n";
char szAlreadySubsted[] = "Drive already SUBSTed\n";

#endif  // SUBST


#if CDEX // {

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR MSCDEX.EXE           |
    |                                         |
   []-----------------------------------------[]
*/
/*
 * CD-ROM Strings file contains the portable strings
 * used by the CD-ROM Driver!
 */

/*
 * CD-ROM Strings file contains the portable strings
 * used by the CD-ROM Driver!
 */

char * Signon = "Datalight CDEX CD-ROM Driver Version %s %s\n%s\n";

char *Usage =
	"\nUsage:\n"
	"\tCDEX {Options}\n"
	"Option:\n"
	"\t/D:<Name>\tCD-ROM Device name (Default \"MSC002\"\n"
	"\t/E\t\tUse Extended memory for CD-ROM buffers\n"
	"\t/K\t\tAllow Kanji with the CD-ROM Volumes\n"
	"\t/H\t\tHelp Display this screen\n"
	"\t/L:<Letter>\tSpecifies the drive letter to start CD-ROM Drives on\n"
	"\t/M:<Number>\tSpecifies the number of sector buffers\n"
#if DEBUG
	"\t/U\t\tUninstall CDEX!\n"
#endif
	"\t/V\t\tDirects CDEX to display memory statics when it starts\n"
	"Examples:\n"
	"\tCDEX\n"
	"\t\tInstall the CD-ROM Driver using default name\n"
	"\tCDEX /D:MSC003 \n"
	"\t\tInstall the CD-ROM Driver using \"MSCD003\" as Device name\n";


char *messages[] = {
	"CD-ROM Device not found (Name = %s)",
	"No room for CD-ROM!\n\tMake LASTDRIVE higher in CONFIG.SYS\n",
	"CD-ROM installed as drive(s) %c:",
	"Invalid option '%c'",
	"\nCD-ROM Internal error %u.%u\n",  //  old string = "\nCD-ROM Internal error '%s' %u\n",
	"No room for drive %c: LASTDRIVE is %c:\n",		/* 5 */
	"CEDX Already Installed",
	"CD-ROM requires DOS 5.x or greater;\n\tPlease reboot with DOS 5.x or higher\n",
	"CD-ROM Drive '%s' has more than 1 drive available, Only 1 supported",
	"",
	"CD-ROM already installed!",			/* 10 */
	"\nCEDX Unloaded",
	"CDEX Not Loaded!",
	"Invalid number in /M option",
};

#endif  // } CDEX

#if COMM // {
/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR COMM.EXE             |
    |                                         |
   []-----------------------------------------[]
*/

char statusMsg[81];
char *szProgramName = "COMM";
char *szHelpPrompt  = "<Press F1 for Help>";

char *helpstr[] = {
	"                           COMM HELP SCREEN",
	"    Hotkeys  Description               Hotkeys  Description",
	"    -------  -----------------         -------  ---------------",
	"    F1       This Screen               Alt-P    Toggle N81/E71",
	"    Alt-B    Toggle Baud Rate          Alt-K    Send breaK signal",
	"    Alt-C    Clear Screen              Alt-T    Toggle CR/LF Translation",
	"    Alt-D    Dial Modem                Alt-X    Exit COMM",
	"    Alt-E    Toggle Echo (Duplex)      PgUp     Upload (Ascii/Xmodem/Zmodem)",
	"    Alt-H    Hangup Modem              PgDn     Download (Ascii/Xmodem/Zmodem)",
	"",
	"    Environment: (processed first)     C>SET COMM = {Command Line Option(s)}",
	"    Command Line Options:  /B#         Initial Baud (300,1200..9600..115200)",
	"                           /Com#       COM port (1..4)",
	"                           /Irq#       IRQ number (3-15)",
	"                           /N81, /E71  Initial port parameters",
	"                           /H#         handshaking 0=none, 1=XON, 2=RTS",
	"",
	"    Ansi Terminal Emulation with Codes",
	"    ----------------------------------",
	"    Esc[#A    Up      Esc[#B  Down      Esc[#C  Right      Esc[#D  Left",
	"    Esc[#;#H  Position cursor to (row);(col) (1,1 == upper left)",
	"    Esc[2J    Erase to EndOfPage        Esc[#K    Erase to EndOfLine",
	"    Esc[#;#m  Set fore color (30-37), background color (40-47), or",
	"              intensity (0 or 1)"
	};

#endif  // } COMM

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR MEM.EXE             |
    |                                         |
   []-----------------------------------------[]
*/
#if MEM // { MEM
char Usage[] =
	"MEM [/BiosExtensions] [/Classify] [/Raw]\n"
	"Displays the memory used and free in your system\n"
	"\t/B\t    Display each BIOS Extension and it's size\n"
	"\t/C\t    Classify the memory usage\n"
	"\t/R\t    Raw dump of the MCB Chain\n"
	"\t/?\t    Display Help Screen\n";

char *BasicStrings[] = {
	"Memory Type        Total  =   Used  +   Free\n",		/* 0 */
	"----------------  -------   -------   -------\n",
	"Conventional      %,6luK   %,6luK   %,6luK\n",
	"Upper             %,6luK   %,6luK   %,6luK\n",
	"Adapter RAM/ROM   %,6luK   %,6luK   %,6luK\n",
	"Extended (XMS)    %,6luK   %,6luK   %,6luK\n",				/* 5 */
	"----------------  -------   -------   -------\n",
	"Total memory      %,6luK   %,6luK   %,6luK\n\n",
	"Total under 1 MB  %,6luK   %,6luK   %,6luK\n\n",
	"Largest executable program size    %,6luK %15s\n",
	"Largest free upper memory block    %,6luK %15s\n",		/* 10 */
	"%s is resident in the %s.\n",
	"Total Expanded (EMS)               %,6luK %15s\n",
	"Free Expanded (EMS)                %,6luK %15s\n\n",
};
char msgBytes[] = "(%,lu bytes)";


// Messages to define the DOS Position.
char msgInConventional[] = "conventional memory";
char msgInROM[] = "ROM";
char msgInHMA[] = "high memory area";

// other messages
char msgBiosExt[]   = "Bios Extension at %04X:%04X  %2uK  (%,u Bytes)\n";
char msgNoBiosExt[] = "No Bios Extensions found!\n";
char msgRawHeader[] = "Address    Sig  Owner   Size     Name\n";
char msgByProgramHeader[] =
		"Module    Address         Size\n"
		"--------------------------------------\n";

// error messages
char errMsgBadOpt[] = "Invalid Option '%s'\n";	// ERR_BADOPT
char errMsgMcbChain[] = "Invalid MCB Chain!\n";

#endif  // } MEM

/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR DELTREE.EXE          |
    |                                         |
   []-----------------------------------------[]
*/
#if DELTREE	// {

char signOnMsg[]= "DELTREE %s %s\n%s\n\n";
char usageMsg[] =
"USAGE = DELTREE [/Y] [drive:]path [[drive:]path[...]]\n\n"
"Options\n"
"   /Y             Don't prompt before deleting.\n"
"   /[             Hide the program signon message.\n"
"   [drive:]path   The name(s) of the file(s) or directory\n"
"                  tree(s) to delete. Wild-cards allowed.\n\n"
"Be careful using wild cards with DELTREE. DELTREE deletes\n"
"all specified files and subdirectories regardless of their\n"
"attributes. Multiple files and/or subdirectories may be\n"
"specified.\n";

char deletingMsg[] = "Deleting %s...\n";
char fileDeletion[]= "Delete file \"%s\"? [%s] ";
char dirDeletion[]	= "Delete directory \"%s\" and all its subdirectories? [%s] ";
char ynString[]    = "yn";

char cannotRmDirMsg[]   = "Could not remove directory: %s\n";
char cannotDelFileMsg[] = "Could not delete file: %s\n";

char szMissingParms[] = "Required parameter missing\n";

#endif	// } DELTREE



/*
   []-----------------------------------------[]
    |                                         |
    | MESSAGES FOR BACKUP.EXE AND RESTORE.EXE |
    |                                         |
   []-----------------------------------------[]
*/
// messages common to both backup and restore
#if (BACKUP || RESTORE)  // {

// ascii signature at beginning of each volume
char	szVolumeSignature[32] = "Datalight Backup File v1.0\032";

// statistic messages
char msgLogLine[]   = "%-30s %,9lu %s  %s";
char msgContinued[] = " (begins volume %u)";
char msgStatistics[] = "%,17lu file(s) %,14lu bytes\n%17u volume(s)\n";

// cmdline errors
char errMsgBadOpt[]		= "Invalid Option '%c'!\n\n";
char errMsgWrongNumber[]= "Invalid Number of Arguments!\n\n";

char errMsgNoMem[]		= "Not enough memory!\n";
char errMsgPleaseCall[]	= "Please contact Datalight\n";

#endif  // } (BACKUP || RESTORE)

#if BACKUP  // {
char msgUsage[] =
	"\n"
	"Usage = BACKUP <srcpath> <dstdrive> [/A] [/H] [/L[:<logname>]] [/M]\n"
	"               [/S] [/Y] [/?]\n"
	"Options\n"
	"  /A  Append to existing backup\n"
	"  /H  Backup Hidden files as well\n"
	"  /L  Keep a Log file (default name same as backup)\n"
	"  /M  Only backup files Marked as changed\n"
	"  /S  backup from Subdirectories as well\n"
#if DEBUG
	"  /V  set volume size, in K bytes (for debugging only)\n"
	"  /X  memory size, in K bytes (for debugging only)\n"
#endif
	"  /Y  Answer \"Yes\" to all prompts\n"
	"  /?  This help screen\n"
	"\n"
	"Example:\n"
	"  BACKUP C:\\DEV\\ROMDOS\\*.* B: /S\n";

char msgComplete[] = "\nBackup Set %s Complete.\n";
char msgDirectoryOf[] = "\nDirectory of %s\n\n";

// for asserts
char errMsgInternal[]	= "Backup Internal Error: ";

// other error messages
char errMsg[]				= "Backup Error: ";
char errMsgBadSource[]	= "Invalid source path!\n";
char errMsgBadDest[]		= "Invalid destination drive!\n";
char errMsgPathTooDeep[]= "Path too deep!\n";
char errMsgCreateLog[]  = "Couldn't create .LOG file!\n";

// general messages
char msgInsertDisk[]    = "\nInsert a blank disk for backup volume %s\n";
char msgInsertLastVol[] = "\nInsert the last volume of the backup set\n";
char msgReturn[]        = "and press return...";
char msgOtherReturn[]   = "or press return to overwrite disk...";

// more error messages
char errMsgFromThisSet[] = "\nYou've inserted volume %s from this backup set!";
char errMsgWriteProtect[]= "Volume in drive %c: is write protected!\n";
char errMsgNoFormat[]    = "\nVolume in drive %c: is missing or write protected!\n";
char errMsgNotLastVol[]  = "\nThis disk does not contain the last volume!\n";

#endif  // } BACKUP

#if RESTORE  // {

char msgUsage[] =
	"\n"
	"Usage = RESTORE <srcdrive> [dstpath] [/D] [/P] [/S] [/Y] [/?]\n"
	"Options\n"
	"  /D  Display files in backup volume(s)\n"
	"  /P  Prompt only when overwriting read-only or newer files\n"
#if DEBUG
	"  /R  Show Raw dump of file records (debugging only!)\n"
#endif
	"  /S  restore all subdirectories\n"
	"  /Y  Answer \"Yes\" to all prompts\n"
	"  /?  This help screen\n"
	"\n"
	"Examples:\n"
	"  RESTORE A: /D          Display files in the backup\n"
	"  RESTORE A: D:\\TEMP /S  Complete restore, with subdirecories\n"
	"  RESTORE B: *.c /S      Restore only files with a .C extension\n";

// for asserts
char errMsgInternal[]	= "Restore Internal Error: ";

// error messages
char errMsg[]				= "\nRestore Error: ";
char errMsgBadSource[]	= "Invalid source drive %c:!\n";
char errMsgBadDest[]		= "Invalid destination path %s!\n";
char errMsgCorrupted[]  = "Backup Volume %s corrupted!\n";
char errMsgCantOpen[]   = "Can't open Volume %s!\n";
char errMsgCantCreate[] = "Can't create file %s!\n";
char errMsgDestFull[]   = "Drive %c: full!\n";

// messages for inserting volumes
char msgInsertVolume[] =
	"Insert Volume %u of Backup Set %sin drive %c:";
char msgNotFound[]    = "\nBackup Volume not found!\n";
char msgOtherVolume[] = "\nYou've Inserted Volume %s!\n";
char msgReturn[]      = " and press Return...";
char msgOtherReturn[] = "\nor press Return to continue from this point...";
char msgOverWrite[]   = "  Overwrite? [yna] ";
char overChars[] = "YNA";

// for doing a directory of backup set
char msgDir[]       = "Directory of %s (%s)\n\n";
char msgRestoring[] = "Restoring %s from %s to %s\n\n";
char msgBytesFree[] = "%,40lu bytes free\n";

#endif  // } RESTORE

#if PBEXDISK  // {

char msgUsage[] =
   "Usage = PBEXDISK <biosDrive> [/C] [/N|/R] [/S#] [/?]\n"
   "Options\n"
   "  /C    Don't confirm. Simply make the partition and reboot.\n"
   "  /N    No Master Boot Record, make PBEX partition only.\n"
   "  /R    Refresh the Master Boot Record only.\n"
   "  /S#   Partition size, in Megabytes (default 4, max 2047).\n"
   "  /?    This help screen.\n"
   "\n"
   "Examples:\n"
   "  PBEXDISK 80H           Make drive 80H a PBEX partitioned disk\n"
   "  PBEXDISK 81H /r        Refresh the Master Boot Record on drive 81H\n"
   "  PBEXDISK 80H /N /S12   Make a 12 Meg parition, don't write MBR\n";

char szSignOn[]    =  "PBEXDISK %s\n%s\n\n";

/* error messages */
char szUserAbort[]      = "Aborted.\n";
char szErrNoDisks[]     = "No fixed disks!\a\n";
char szErrInvalidOpt[]  = "Invalid option! %s\n";
char szErrBadDrive[]    = "Invalid drive %X!\n";
char szErrNoMem[]       = "Not enough memory!\n";
char szErrInternal[]    = "Internal Error %u.%u!\n";
char szErrPartSize[]		= "Invalid partition size!\n";
char szErrMutual[]		= "/N and /R are mutually exclusive options!\n";

char szWarning[] =
	"Warning! About to erase all partitions! All data on drive %02XH\n"
	"will be lost! Type 'Y' then enter to continue. Press Esc to abort: ";
char szWarnBootDisk[] =
	"\n"
	"The system will reboot. Please insert the ROM-DOS(WfM Version) disk\n"
	"in drive A:. If the ROM-DOS disk is not prepared, press Esc now: ";
char szEscape[] =  "Esc\n";

#endif  // } PBEXDISK


/*
   []-----------------------------------------[]
    |                                         |
    |       MESSAGES FOR RXEVERFY.EXE         |
    |                                         |
   []-----------------------------------------[]
*/
#if RXEVERFY

char * szSignOnMessage = "RXEVERFY %s %s\n%s\n\n";

char szUsage[] =
   "RXEVERFY [/O] [/?] [/[] [[drive]path]EXENAME [[drive]path]RXENAME\n"
   "\n"
	"DRIVE is the letter of the drive to create the file\n"
	"PATH is the directory to create the file\n"
	"EXENAME is the name of the executable\n"
	"RXENAME is the name of the RXE converted executable\n"
	"/O  Force the interpretation of the RXE file as an optimized RXE file\n"
	"/[  Hide program signon message\n"
   "/?  Show this help screen\n"
	"";

#endif	// #if RXEVERFY
