//
//   $Id: LOGFILE.H 1.5 2002/10/15 21:41:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	$DOCMODULE:LOGFILE.H

	Copyright (c) 1989-2002 by Datalight, Inc.
	All Rights Reserved.
	Datalight Confidential and Proprietary

	This file provides the prototypes and defines for the
	ROM-DOS test results logging module.

	Usage:

	#include "logfile.h"

	int main(void)
	{
		log_title("Sample Test");

		if(!Test1())
			log_error(ERR_TEST1);

		log_passed();
		return 0;
	}

	Revision History

		09-29-98 de Corrected usage example to have a single parameter.
		07-28-98 de	Added an already included guard
		07-07-98 bt added a log skipped macro
		05-22-98 de consolodated ROM-DOS and RDTEST headers.
		04/04/97 jb revised comments for clarity
		03/21/97 dg original


**********************************************************/

#if !defined( LOGFILE_H )
#define		  LOGFILE_H 1

/*
	Prototypes
*/
void log_time( void );
void log_printf(char *format,...);
void log_error(int val);
void log_error_line(int val, int line);
void log_na( void );
int  IsNet( void );

/*
	Defines
*/
#define MAXBUFSIZE 255

/*
	The following DEFINES create two alternate logging functions
*/
#define log_title(str) log_printf("%-12s %-55s ", __FILE__, str)
#define log_passed()   log_printf("  Passed\n");  exit(0)
#define log_passed2()   log_printf("  Passed\n");
#define log_skipped()  log_printf("  SKIPPED\n");  exit(0)
#define log_fail(test, line) {log_printf("Failed! %d, line: %d\n", test, line); return test;}
#define log_failure(test, line) {log_printf("Failed! %d, line: %d\n", test, line); exit(test);}
#define log_notimplemented()  log_printf("  NO TEST\n");  exit(0)
#define log_notimplemented2()  log_printf("  NO TEST\n");

/*
	included for CDEX tests
*/
#define log_failed()   log_printf("Failed\n")
#define log_not_installed() log_printf("NO CD-ROM H/W\n")

#endif // #if !defined( LOGFILE_H )
