;  $Id: DL64ADD.ASM 1.8 2003/03/20 17:06:36Z thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1998-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DL64ADD.ASM
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module contains 64-bit math add functions.
;
; bool AddQuadLong(uquad *pQuad, ulong ulValue);
; bool AddQuad(uquad *pDstQuad, uquad * pSrcQuad);
;
; $DOCHISTORY
; 07/21/1998 dg  Created by Drew Gislason
;--------------------------------------------------------------------

include macros.inc
include datalght.inc
include profile.inc

InitModel SMALL, pascal, use16


cBegCode

;--------------------------------------------------------------------
; $DOCPROC:AddQuad
;
; On Entry
;	pDstQuad	ptr to 64 bit for destination
;	pSrcQuad	ptr to 64 bit # to be added to dst
; On Exit
;	ax = TRUE if worked, FALSE if overflow
;--------------------------------------------------------------------
ProcBegin	AddQuad, public
ProcArgs	pDstQuad:ptr, pSrcQuad:ptr
ProcUses	ds, si
ProcSetup

	ENTER_FUNCTION

	; get pointers to structures
	lptr_es	bx, pDstQuad
	lptr_ds	si, pSrcQuad

	; add quad words with 16-bit math
	mov	ax, [si]
	add	es:[bx], ax
	mov	ax, [si+2]
	adc	es:[bx+2], ax
	mov	ax, [si+4]
	adc	es:[bx+4], ax
	mov	ax, [si+6]
	adc	es:[bx+6], ax

	; overflow?
	jc	@@OverFlow
	mov	ax, 1
	jmp	short @@Done

    @@OverFlow:
	xor	ax, ax
    @@Done:

	EXIT_FUNCTION

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:AddQuadLong
;
; On Entry
;	pQuad		ptr to 64 bit value for destination
;	ulValue		long to add to the quad
; On Exit
;	ax = TRUE if worked, FALSE if overflow
;--------------------------------------------------------------------
ProcBegin	AddQuadLong, public
ProcArgs	pQuad:ptr, ulValue:dword
ProcUses	ds
ProcSetup

	ENTER_FUNCTION

	; get pointers to structures
	lptr_ds	bx, pQuad

	; add quad words with 16-bit math
	mov	ax, word ptr ulValue
	add	[bx], ax
	mov	ax, word ptr ulValue+2
	adc	[bx+2], ax
	xor	ax, ax
	adc	[bx+4], ax
	adc	[bx+6], ax

	; overflow?
	jc	@@OverFlow
	mov	ax, 1
	jmp	short @@Done

    @@OverFlow:
	xor	ax, ax
    @@Done:

	EXIT_FUNCTION

ProcEnd

cEndCode

	end
