;
;   $Id: DOSCALL.ASM 1.9 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
---------------------------------------------------------------

   DOSCALL.ASM  created 05/10/89  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   All calls to devices are made though here.  This file
   also contains generic code usable for ROM-DOS built-in
   devices.

   Before call to the device driver Strategy or Service
   routines, DOS must set up the following:

   1) ES:BX = req hdr (during call to Strat and Service)
   2) DS = CS = seg of device (during call to Strat and Service)
   3) AX = offset Strategy or Service during call

   History:
   01-25-1999 bt  SPR 1882
--------------------------------------------------------------- ~
include macros.inc
include devhdr.inc
include profile.inc

cBegData
	extrn	_userregs:DWORD
	extrn	_ptrsav:dword	; pointer to dev req hdr, set each call
	extrn	_ROM_DS:word		; segment of DGROUP
	extrn	_ROM_DEVSEG:word	; segment of _DEVDATA

	; Initial length of request header commands for
	; block devices
	;
	; (BT 01-25-1999 SPR 1882)
	; Some of these initial request header lengths were wrong.
	; Audited the entire lot and made corrections as necessary.
	;
	DEVICE_REQLEN:
		db 19H,13H,16H,16H,14H,0EH,0dH,0dH    ; 00-07H
		db 14H,14H,0DH,0DH,14H,0DH,0DH,0DH    ; 08-0FH
		db 14H,17H,0DH,17H,0DH,0DH,0DH,0DH    ; 10-18H
		db 0DH

cEndData

_DEVDATA segment word public 'DEVDATA'

	assume	CS:_DEVDATA, DS:_DEVDATA

	PUBLIC	cmd_ptr, dev_dgroup
	cmd_ptr	DD	?	; pointer to common service routine
	dev_dgroup DW	?	; DGROUP accessable from _DEVDATA seg

	PUBLIC	dev_fstrat
dev_fstrat	proc	far

	; get DGROUP into DS
	push	DS
	mov	DS, CS:dev_dgroup

	; save ptr to request header
	assume	DS:DGROUP
	mov	word ptr [_ptrsav], BX
	mov	word ptr [_ptrsav+2], ES

	pop	DS
	retf
dev_fstrat	endp

_DEVDATA ENDS

cBegCode

	extrn getDGROUP:near
	extrn _set_crit_section:near
	extrn _clear_crit_section:near
	c_extrn getDEVDATA,near

;
;---------------------------------------------------------
;
;  This routine makes the actual call to devices.  It can
;  call both internal (built-in) and external (user
;  installed) devices.  It assumes small code model.
;
;---------------------------------------------------------
;
COMMENT ; prototype
void dev_call(struct dev_req_hdr *hdr,LPDEV_HDR device)
{}
;
c_func	dev_call

	ENTER_FUNCTION

	push	BP
	mov	BP, SP		; get stack frame
	push	SI		; device driver may trash these!
	push	DI		; device driver may trash these!
	push	DS		; device driver may trash these!

; BT 1-19-00 ETR 2457
;
; Because of the ramifications of being reentered, we now enter
; a critical section after entering dos (_int_21).  Further more,
; we end the critical section when exiting DOS (dos_return).  This
; was because MS Networking would copy the SDA and interrupt DOS
; at any given time.  The obvious thing to protect was the device
; drivers from being reentered.  Because our DOS design is different
; than MSDOS, be could not enter critical sections when modifying
; CDSs, BUFFERs, and SFTs.  For instance: if we had a pointer to
; a buffer and DOS was interrupted by MS networking, we could not
; be sure that the buffers had not been changed therefore leaving
; us with a bad pointer.
;
;	; Inform network multitasking interfaces that we are about
;	; to enter a non-reentrant part of DOS (ie: device drivers!)
;	; and that we are busy!
;	;
;	call	_set_crit_section

	; get user CX and DX into those regs (IOCTL calls use 'em)
	les	BX, [_userregs]
	mov	CX, ES:[BX+04H]		; get CX from user stack
	mov	DX, ES:[BX+06H]		; get DX from user stack

	; Get the attibutes for the device.  This is so we
	; can determine if this is a block device or a
	; character device and if we are using 32bit structure
	; fields.
	;
	les	bx, P+2[bp]
	mov	si, word ptr es:[bx+4]

	; Point ES:BX to request header
	;
	push	SS
	pop	ES
	mov	BX, P[BP]		; ES:BX = req header

	; always set request hdr status to 0.
	;
	mov	WORD PTR ES:[BX+STATUS], 0

	; Set a pointer to a table which contains the
	; request structure size for each of the functions
	;
	mov	di, GOFFSET DEVICE_REQLEN

	; (BT 01-25-1999 SPR 1882)
	; Made sure we were setting the request header length
	; field based on whether or not the device was a character
	; or block device.
	;

	; Set the initial request hdr length field in al
	;
	xor	ax, ax
	mov	al, byte ptr es:[bx+CMD]
	add	di, ax
	mov	al, [di]

	; Determine if the device is a character device	test
	;
	test	si, 8000h
	jnz	IS_A_CHARACTER_DEVICE

	; Check if this is one of the functions which have
	; extra fields for a block device
	;
	cmp	ah, 4		; read cmd
	jz	req_len_adjust
	cmp	ah, 8		; write cmd
	jz	req_len_adjust
	cmp	ah, 9		; write w/ verify cmd
	jnz	req_len_ok

	; Adjust the length of the request header if this
	; is a function which has extra field for block
	; devices
	;
req_len_adjust:
	jnz	req_len_ok	; length on read/write goes from
	add	AL, 0ah		; 14H to 1EH on BIG (32M+) disks

	; Save the size of the request header in the request header
	; (hdr->length = DEVICE_REQLEN[hdr->command])
	;
IS_A_CHARACTER_DEVICE:
req_len_ok:
	mov	BYTE PTR ES:[BX+CMDLEN], AL

	; call the strategy routine (Novell demands AX pts to it)
	; note: device driver may destroy ALL registers but stack
	lds	SI, P+2[BP]		; DS:SI = device header
	push	SI			; save header offset
	push	BP
	mov	AX, DS:[SI+6]		; strategy
	mov	P+2[BP], AX
	call	DWORD PTR P+2[BP]	; call strategy
	pop	BP
	pop	SI			; restore header offset

	; call the service routine (Novell demands AX pts to it)
	; note: device driver may destroy ALL registers but stack
	push	SS
	pop	ES
	mov	BX, P[BP]		; ES:BX = req header
	mov	DS, P+4[BP]		; DS:SI = device header
	mov	AX, DS:[SI+8]		; service
	mov	P+2[BP], AX
	call	DWORD PTR P+2[BP]	; call service

; BT 1-19-00 ETR 2457
;
; Because of the ramifications of being reentered, we now enter
; a critical section after entering dos (_int_21).  Further more,
; we end the critical section when exiting DOS (dos_return).  This
; was because MS Networking would copy the SDA and interrupt DOS
; at any given time.  The obvious thing to protect was the device
; drivers from being reentered.  Because our DOS design is different
; than MSDOS, be could not enter critical sections when modifying
; CDSs, BUFFERs, and SFTs.  For instance: if we had a pointer to
; a buffer and DOS was interrupted by MS networking, we could not
; be sure that the buffers had not been changed therefore leaving
; us with a bad pointer.
;
;	; Inform network multitasking interfaces that we are finished
;	; entering a non-reentrant part of DOS (ie: device drivers!)
;	; and that we are no longer busy!
;	;
;	call	_clear_crit_section

	pop	DS
	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	dev_call


;
;---------------------------------------------------------
;
;   This routine is a generic service routine for use by
;   all internal (built-in) devices.  It is only called by
;   the device drivers, never by DOS.
;
;   On Entry
;	SI = cmd_table in device
;	AH = # of entries in device
;
;   Before JMP to device code
;	DS	= DGROUP
;	ES:DI	= transfer buffer
;	CX	= count
;	DX	= start
;	AL	= unit
;	AH	= media
;
;---------------------------------------------------------
;
COMMENT ; prototype
void dev_serv()
{}
;
	public	dev_serv
dev_serv:
	; AX and SI are already saved
	pushf
	sti
	push	BX
	push	CX
	push	DX
	push	DI
	push	DS
	push	ES

	; SET DS = DGROUP
	call	getDGROUP
	push	DS

	; CHECK FOR VALID COMMAND
	lds	BX, [_ptrsav]
	mov	AL, BYTE PTR [BX+CMD]	; GET THE COMMAND #
	cmp	AL, AH
	jb	dvserv1
	pop	DS
	jmp	short dev_cmd_err

	; GET OFFSET OF COMMAND IN COMMAND TABLE
dvserv1:
	cbw
	shl	AL,1
	add	SI,AX			; SI = COMMAND

	mov	AL,BYTE  PTR [BX+UNIT]	; AL	= unit #
	mov	AH,BYTE  PTR [BX+MEDIA]	; AH	= media
	mov	CX,WORD  PTR [BX+COUNT]	; CX    = count
	mov	DX,WORD  PTR [BX+START]	; DX	= start
	les	DI,DWORD PTR [BX+TRANS]	; ES:DI = transfer area

	pop	DS
	jmp	WORD PTR CS:[SI]	; do the command



;---------------------------------------------------------
;
;   GENERIC EXIT ROUTINES
;
;   These routines make no assumptions about DS.  DGROUP
;   is always loaded first.  Place return codes (status)
;   into AL.  The high-byte is determined by the exit
;   routine used.
;
;---------------------------------------------------------
;
COMMENT ; prototype
void dev_exit()
{}
;
	public dev_exit
dev_exit:
	mov	AH,1H		; no error, not busy
err1:
	CALL	getDGROUP	; DS = DGROUP, preserves AX
	lds	BX, [_ptrsav]
	mov	[BX+STATUS], AX	; return the status

	pop	ES
	pop	DS
	pop	DI
	pop	DX
	pop	CX
	pop	BX
	popf
	pop	SI
	pop	AX
	retf		; far return (RETF)

	public dev_err_cnt
dev_err_cnt:

	; place # of blks transferred into request header
	call	getDGROUP
	lds	BX, [_ptrsav]
	mov	WORD PTR [BX+COUNT], 0
	jmp	SHORT dev_err_exit

	; unknown command error
	public dev_cmd_err
dev_cmd_err:
	mov	AL, 3

	; generic device error
	public dev_err_exit
dev_err_exit:
	mov	AH, 81H
	jmp	SHORT err1

	; device is busy error
	public dev_busy_exit
dev_busy_exit:
	mov	AH, 03H		; busy and done bits set
	jmp	SHORT err1


IF 0
;
;---------------------------------------------------------
;
;	Write a String to Console (BIOS INT 10H)
;
;	Assumes string is in CS:[SI]
;	note: preserves all registers
;---------------------------------------------------------
;
COMMENT ; prototype
void bios_puts()
{}
;
bios_puts	proc near

	ENTER_FUNCTION

	push	AX		; save the registers used
	push	BX
	push	SI

wrstr:
	mov	AL, CS:[SI]	; get byte
	cmp	AL, 0
	jz	done
	mov	AH, 14
	mov	BH, 0
	int	10H		; write it out
	inc	SI
	jmp	wrstr

done:	pop	SI		; restore registers
	pop	BX
	pop	AX

	EXIT_FUNCTION

	ret
bios_puts	endp

ENDIF


cEndCode


	END
