//
//   $Id: DOSCFG.C 1.12 2002/10/15 21:44:46Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
#if 0

 /*********************************************************

    DOSCFG.C  created 01/11/91  by Drew Gislason

    Copyright (c) 1991-2002 Datalight, Inc.
    All Rights Reserved.
    Datalight Confidential and Proprietary

 	This file contains the CONFIG.SYS processing.

 	History:

 	02-02-1999 de  SPR#1893

 **********************************************************/
 #include "dostruct.h"
 #include "dosdef.h"
 #include "dosproto.h"

 #define __FILENUM__ 1

 // default to version 6
 #ifndef VDOS
 #define VDOS 6
 #endif

 #define CONFIG 1
 #include "dosmsg.c"

 extern char shell[128];		// the 1st program run by ROM-DOS, ie COMMAND

 /*
 	[]----------------------------------------[]
     |                                        |
     |         ALL CONFIGSYS LEVELS           |
     |                                        |
 	[]----------------------------------------[]
 */

 /*
 	Run Only On Bootup:

 	Install a different boot program, called a "shell" in
 	the DOS world.  The parms string points to the path and
 	name of the shell.

 	Example: "SHELL = C:\BIN\NEWSHELL.EXE /arg1 /arg2"
 */
 void	do_shell(char *parms)
 {
 	// validate pointer
 	ASSERT(parms);

 	shell[0] = sizeof(shell)-4;
 	shell[1] = strlen(parms);
 	memmove(shell+2, parms, shell[1]+1);
 }


 /*
 	[]----------------------------------------[]
     |                                        |
     |             DOS 3.31 only              |
     |                                        |
 	[]----------------------------------------[]
 */

 /*	cfg_name must be defined the same so nothing
 	breaks, but adds a backslash to the output file.  For
 	Fillon Systems, whose redirector expects the string
 	"\CONFIG.SYS",0 to be in every DOS boot file.
  */
 char cfg_name_kludge = '\\';
 char cfg_name[] = "CONFIG.SYS";

 #if (VDOS < 5)		// DOS 3.31 only

 // Dummied out for DOS 3.31
 void enable_hma(void)
 {
 }

 // Dummied out for DOS 3.31
 #pragma argsused
 int alloc_hma(unsigned bytes)
 {
 	return 0;
 }

 // Dummied out for DOS 3.31
 void warning_nohigh(void)
 {
 }

 // Dummied out for DOS 3.31
 void SetupStacks(void)
 {
 }

 #endif	// DOS 3.31 only


 /*
 	[]----------------------------------------[]
     |                                        |
     |         ONLY FOR NO CONFIG.SYS         |
     |                                        |
 	[]----------------------------------------[]
 */

 #if (VDOS == 0)		//	NO CONFIG.SYS processing

 // for space savings have NO CONFIG.SYS processing
 #pragma argsused
  void configsys(int pass)
 {}

 #endif


 /*
 	[]----------------------------------------[]
     |                                        |
     |             DOS 5+ VERSIONS            |
     |                                        |
 	[]----------------------------------------[]
 */

 #if VDOS	// { the whole file may be commented out

 #if (VDOS >= 6)	// DOS 6+ only

 // variables for include
 #define MAX_INCLUDE_DEPTH 3		// see DOSASM.ASM as well
 extern unsigned cfg_inc_pos[MAX_INCLUDE_DEPTH];
 extern int cfg_inc_line[MAX_INCLUDE_DEPTH];
 extern int cfg_inc_level;

 extern int cfg_ask;
 extern int cfg_ask_line;

 char skippingTheRest = 0;			// ask() sets this TRUE if F5 is pressed;
 char numlockstr[] = "NUMLOCK";
 char switchstr[]  = "SWITCHES";
 char blockname[BLKNAMESIZE];
 #endif

 extern unsigned cfg_size;			// size of CONFIG.SYS
 extern unsigned cfg_position;		// current position, 0xFFFF = eof
 extern unsigned cfg_seg;			// memory buffer
 extern int cfg_linenum;				// current line #


 // SPR 1893 (DE) allow DOS and STACKS to be the only First pass commands so
 // FILES, FCBS and BUFFERS can be reset in NEWFILEs while still allocating
 // STACKS before any device drivers and allocating the HMA just after HIMEM
 // has been run.
 //
 #define  CFG_NEWFILE	7			// are we into a new CONFIG file?
 struct config config[] =
 {
 	// fundamental CONFIG commands (ala 3.31)
 	{ "BREAK",		do_break,		PASS2_FLAGS | CFG_UPPERCASE },
 	{ "BUFFERS",	do_buffers,		PASS2_FLAGS },
 	{ "COUNTRY",	do_country,		PASS2_FLAGS | CFG_UPPERCASE },
 	{ "DEVICE",		do_device,		PASS2_FLAGS | CFG_UPPERCASE },
 	{ "FCBS",		do_fcbs,			PASS2_FLAGS },
 	{ "FILES",		do_files,		PASS2_FLAGS },
 	{ "LASTDRIVE",	do_lastdrive,	PASS2_FLAGS | CFG_UPPERCASE },
 	{ "NEWFILE",	do_newfile,		PASS2_FLAGS },	// rd specific
 	{ "REM",       do_rem,			PASS2_FLAGS },
 	{ "SHELL",		do_shell,		PASS2_FLAGS },

 	// DOS 5+ CONFIG commands
 #if VDOS >= 5
 	{ "DOS",			do_dos,			PASS1_FLAGS | CFG_UPPERCASE },
 	{ "INSTALL",   do_install,		PASS3_FLAGS },
 	{ "INSTALLHIGH", do_installhigh,		PASS3_FLAGS },
 	{ "STACKS",		do_stacks,		PASS1_FLAGS },
 #endif

 	// DOS 6+ CONFIG commands
 #if VDOS >= 6
 	{ "INCLUDE",	do_include,		PASS2_FLAGS | CFG_UPPERCASE },
 	{ numlockstr,	do_numlock,		PASS2_FLAGS | CFG_UPPERCASE },
 	{ "SET",			do_set,			PASS2_FLAGS },
 	{ switchstr,	do_rem,			PASS2_FLAGS },
 	{ "DEVICEHIGH",do_devicehigh,	PASS2_FLAGS | CFG_UPPERCASE },
 #endif

 #if VDOS >= 7
 	{ "SEARCHES",	do_searches,	PASS2_FLAGS | CFG_UPPERCASE },
 #endif

 	{ 0 }
 };


 #if VDOS >= 5
 extern int stacksNum;
 extern int stacksSize;
 #endif


 /*
 	Run Only On Bootup:

 	Process the CONFIG.SYS file.  Can add devices and modify
 	various internal structure lists. An example could be:
 	"DEVICE = C:\BIN\WHATEVER.SYS  3=5=7".  The device would
 	see "C:\...5=7\r" upon init.

 	Bypassing CONFIG.SYS:
 	- Press & release F5, or hold down Shift key to skip
 	- Press & release F8 to Ask on each line
 */
 void	configsys(int pass)
 {
 	/*
 		[ externals ]
 	*/
 	extern char warn_bad[];
 	extern char warn_cmd[];
 	extern struct config config[];	/* the list of CONFIG.SYS commands */
 	extern char config_str[];			/* a buffer to read lines */
 	extern int error_no;

 #if VDOS >= 6
 	extern char warn_bypass[];
 	extern char autoexec_msg[];
 	extern char common_str[];

 	int in_ok_block;
 #endif


 	/*
 		[ locals ]
 	*/
 	char *line = config_str;
 	char *parms;
 	int  cmdnum;
 	int  newfile = FALSE;

 	/*
 		[ code ]
 	*/

 	/*
 		Each NEWFILE must act just like CONFIG.SYS.  The only
 		difference is that the user doesn't see the "starting
 		ROM-DOS" message more than once.
 	*/
 newfile:

 #if VDOS >= 6
 	if(pass == PASS1)
 	{
 		/* check if user wants to bypass CONFIG.SYS */
 		if(!newfile && bypass_config())
 		{
 bypass:
 			printf(warn_bypass);
 			goto config_done;
 		}
 	}
 #endif

 	// don't process CONFIG.SYS if we couldn't read it
 	if(!cfg_seg)
 	{
 		if(newfile)
 			printf(warn_bad, "", cfg_name);
 #if VDOS >= 6
 		if(cfg_ask)
 			goto ask_autoexec;
 #endif
 		return;
 	}

 #if VDOS >= 6
 	if(pass == PASS1)
 	{
 		/* present the menus */
 		if(!process_menus(blockname))
 			goto bypass;
 	}

 	in_ok_block = 1;
 #endif

 	/* process the lines */
 	cfg_position = cfg_linenum = 0;
 	while(1)
 	{
 		if(!getline(line))
 		{
 #if VDOS >= 6
 			// we may be including something
 			if(cfg_inc_level)
 				goto doing_include;
 			else
 #endif
 				break;
 		}
 		++cfg_linenum;

 		/* skip TABs and SPACES */
 		parms = skipwhite(line);

 #if VDOS >= 6
 		/* we are now in a new block */
 		if(*parms == '[')
 		{
 			if(cfg_inc_level)
 			{
 doing_include:
 				cfg_position = cfg_inc_pos[--cfg_inc_level];
 				cfg_linenum  = cfg_inc_line[cfg_inc_level];
 			}
 			else if(is_block(parms+1,common_str) || is_block(parms+1,blockname))
 				in_ok_block = TRUE;
 			else
 				in_ok_block = FALSE;
 			continue;
 		}

 		/* ignore Blocks that aren't for us */
 		if(!in_ok_block)
 			continue;

 		/* comment lines can begin with a ';', ignore them */
 		if(*parms == ';')
 			continue;
 #endif

 		/* ignore blank lines */
 		if(*parms == 0)
 			continue;

 		/* find the command */
 		cmdnum = is_command(&parms, config);

 		/* ignore lines that are for another pass through CONFIG */
 		if(cmdnum >= 0)
 		{
 			if((config[cmdnum].flags >> 4) != pass)
 				continue;
 		}

 		/* didn't find a command, display offending line */
 		else
 		{
 bad_cmd:
 			printf(warn_cmd, line, cfg_name, cfg_linenum);
 			continue;
 		}

 		/* execute the command */
 #if VDOS >= 6
 		// maybe ask [Y/N] and quit if no
 		if((cfg_ask_line || cfg_ask) && (ask(line) <= 0))
 			cmdnum = 0;
 		else
 #endif
 			(*config[cmdnum].func)(parms);

 		// if the user pressed F5 when asked a Y/N question,
 		// we just walk away and leave the rest undone
 		//
 #if VDOS >= 6
 		if( cmdnum == 0 && skippingTheRest )
 		{
 			cfg_ask = FALSE;
 			goto bypass;
 		}
 #endif
 		// if the last (attempted) command had an error that left error_no set
 		//
 		if(error_no)
 		{
 			error_no = 0;					// reset error_no

 			if(cmdnum == CFG_NEWFILE) 	// fail on newfile open?
 				continue;					// then process next line

 			goto bad_cmd;					// else bad command msg
 		}

 		// did we just successfully load a new file?
 		// if so, start over config sys processing (except msg).
 		//
 		if(cmdnum == CFG_NEWFILE)
 		{
 			newfile = TRUE;
 			goto newfile;
 		}
 	}

 #if VDOS >= 6
 ask_autoexec:
 #endif

 	if(pass == PASS3)
 	{
 #if VDOS >= 6
 		if(cfg_ask)
 		{
 			if(ask(autoexec_msg))
 				strcat(shell+2," /Y");	// ask during autoexec
 			else
 			{
 config_done:
 			strcat(shell+2," /D");		// disable autoexec
 			}
 		}
 #endif

 		// free the memory used by CONFIG.SYS
 		if(cfg_seg)
 			mem_free(cfg_seg);
 		cfg_seg = 0;
 	}
 }

 /*
 	[]----------------------------------[]
 	 |                                  |
 	 |     CONFIG HELPING ROUTINES      |
 	 |                                  |
 	[]----------------------------------[]
 */

 /*
 	Run Only On Bootup:

 	make a 0-terminated filename out of a string with
 	filename and parameters.  Returns the character it
 	replaced with the 0.  Will turn "X.SYS arg" into
 	"X.SYS\0arg".
 */
 char make_fname(char *parms)
 {
 	char *p;
 	char oldc;

 	// validate pointer
 	ASSERT(parms);

 	for(p = parms; *p>' ' && *p!=','; ++p)
 		/* we are finding a place */;
 	oldc = *p;
 	*p = 0;
 	return oldc;
 }

 /*
 	Run Only On Bootup:

 	This routine gets a number and ensures that it is
 	between the minimum and maximum values.
 */
 int PASCAL minmax(char *parms, int min, int max)
 {
 	int num;

 	// validate pointer
 	ASSERT(parms);
 	ASSERT(min <= max);

 	// get the number
 	num = atoi(parms);

 	// keep it in bounds
 	if(num < min)
 		num = min;
 	if(num > max)
 		num = max;

 	// return the number
 	return num;
 }

 /*
 	Run Only On Bootup:

 	Get a line for CONFIG.SYS processing.
 */
 bool	PASCAL getline(char *line)
 {
 	/*
 		[ locals ]
 	*/
 	char far * p;
 	unsigned len;
 	unsigned maxlen;

 	/*
 		[ code ]
 	*/

 	// validate pointer
 	ASSERT(line);

 	// at end of file
 	if(!cfg_seg || cfg_position == 0xFFFF)
 		return FALSE;

 	// determine start for line
 	p = MK_FP(cfg_seg, cfg_position);

 	// scan for end of this line (CR/LF pair)
 	for(len=0; ; ++len, ++p)
 	{
 		if(*p == 0)		/* convert all 0s to spaces */
 			*p = ' ';
 		if(*p == ctrl('Z') || *p == '\r')
 			break;
 	}

    // maxlen represents the most line we can process,
    // while len represents the actual length of line.
    //
 	maxlen = min(CFGLINELEN, len);

 	// retrieve the line
 	fmemcpy(line, MK_FP(cfg_seg, cfg_position), maxlen);
 	*(int *)(line+maxlen) = 0;       // end in a double 0 for parms

 	// update position, maybe at end of file
 	if(*p == ctrl('Z'))
    {
 		cfg_position = 0xFFFF;
    }
 	else
    {
 		cfg_position += len + 2;			// assume CR/LF pair at end-of-line
    }

 	return TRUE;
 }

 /*
 	Returns the item in the "config" array (0-n) or -1 if the
 	command is not found.  Skips past the cmd string and all
 	the equals if found.
 	Example:

 	DEVICE  = == HELLO.EXE

 	would skip past everything until the "HELLO"
 */
 int is_command(char **cmd, struct config *cp)
 {
 	char c;
 	char cmdstr[12];					// for the longest command
 	int i;
 	int cmdnum;
 	char * parms;

 	ASSERT(cp);
 	ASSERT(cmd && *cmd);

 #if VDOS >= 6
 	// each line might have an "ask me" request [Y/N]?
 	cfg_ask_line = FALSE;
 #endif

 	/* copy the command into cmdstr, and ASCIIZ the cmdstr */
 	for(i=0; i<(sizeof(cmdstr)-1); ++i)
 	{
 		c = **cmd;
 		if(c <= ' ' || c == '=')
 			break;
 #if VDOS >= 6
 		if(c == '?')
 			break;
 #endif
 		cmdstr[i]= c;

 		// on to next character
 		++(*cmd);
 	}
 	cmdstr[i] = 0;
 	strupr(cmdstr);

 	// find the command
 	cmdnum = -1;
 	for(i=0; cp[i].command; ++i)
 		if(memcmp(cmdstr,cp[i].command,strlen(cp[i].command)+1) == 0)
 		{
 			cmdnum = i;
 			break;
 		}

 	// find the beginning of the args (skip all ='s and whitespace's)
 	parms = *cmd;
 	while(1)
 	{
 		parms = skipwhite(parms);

 #if VDOS >= 6
 		// does user want to get asked for this line?
 		if(!cfg_ask_line && *parms == '?')
 		{
 			cfg_ask_line = TRUE;
 			memmove(parms,parms+1,strlen(parms));	// extract the '?'
 		}
 		else
 #endif
 		if(*parms == '=')
 			++parms;		// skip past the equals sign

 		else
 			break;		// all done
 	}

 	// some commands need UPPERCASE args
 	if(cmdnum>=0 && (cp[cmdnum].flags & 1))
 		strupr(parms);

 	*cmd = parms;
 	return cmdnum;
 }

 /*
 	[]----------------------------------[]
 	 |                                  |
 	 |     CONFIG HELPING ROUTINES      |
 	 |                                  |
 	[]----------------------------------[]
 */

 #if VDOS >= 7
 void	do_searches(char *parms)
 {
 	extern int lfnMaxSearches;
 	lfnMaxSearches = minmax(parms, MIN_SEARCHES, MAX_SEARCHES);
 }
 #endif

 /*
 	Run Only On Bootup:

 	Set BREAK to ON or OFF.  This allows a user to break out
 	of any DOS call, not just character i/o calls.
 */
 void	do_break(char *parms)
 {
 	extern uchar BREAK_FLAG;

 	ASSERT(parms);

 	BREAK_FLAG = FALSE;
 	if(memcmp(parms,"ON",2) == 0)
 		BREAK_FLAG = TRUE;
 }

 /*
 	Run Only On Bootup:

 	Allocate a certain # of buffers for use by the file
 	system.  There is a hardcoded minimum set in DOSDEF.H
 */
 void	do_buffers(char *parms)
 {
 	extern struct LOL lol;
 	extern int	init_buffers;

 	// validate pointer
 	ASSERT(parms);

 	init_buffers = lol.numbufs = minmax(parms, lol.numbufs, MAXBUF);
 }


 /*
 	Run Only On Bootup:

 	Install new country information.  This routine cheats by
 	simply installing a device that will do the necessary
 	DOS calls.
 */
 void	do_country(char *parms)
 {
 	/*
 		[ locals ]
 	*/
 	extern char country_buff[66];
 	static char defname[] = "COUNTRY.SYS ";


 	/*
 		[ code ]
 	*/
 	// validate pointer
 	ASSERT(parms);

 	memmove(country_buff,defname,sizeof(defname));
 	memmove(country_buff+sizeof(defname)-1,parms,strlen(parms)+1);
 	do_device(country_buff);
 }

 /*
 	Run Only On Bootup:

 	Install a disk or character device from CONFIG.SYS.  The
 	parms string starts on the device name.  For example:
 		"DEVICE = FNAME.SYS /b0=1"
 		          ^
 	The ending of the string must be exact, as some devices
 	don't parse very intelligently.
 */
 void	do_device(char *parms)
 {
 	/*
 		[ externals ]
 	*/
 	extern unsigned sda_handle;
 	extern char warn_bad[];
 	extern char warn_device[];
 #ifndef CONFIG_UNIT_TEST
 	extern char sda_ename1[];
 #endif
 	extern int error_no;
 	extern uchar mem_fit;

 	extern unsigned dos5_flags;
 	extern char trydoshi;
 	extern unsigned hma_used;
 	extern unsigned codeparas;
 	extern unsigned bufparas;

 	/*
 		[ locals ]
 	*/
 	char oldc;
 	unsigned seg;
 	int len1, len2;


 	/*
 		[ code ]
 	*/

 	// validate pointer
 	ASSERT(parms);

 	/* make line palatable to device drivers */
 	strcat(parms, " \n");

 	/* get the "drive:\path\name" of the device */
 	oldc = make_fname(parms);

 	/* load the device into memory */
 	seg = load_device(parms);
 	if(seg == 0xFFFF && mem_fit)
 	{
 		mem_fit = MEM_FIRST;
 		seg = load_device(parms);
 	}

 	/* if we couldn't load it, tell user so */
 	if(seg == 0xFFFF)
 	{
 		printf(warn_bad,warn_device,parms);
 		return;
 	}

 #ifndef CONFIG_UNIT_TEST
 	/* set initial ID and name fields for system MCB */
 	((struct MCB far *)MK_FP(seg-1,0))->init_id = 'D';
 	fmemcpy(MK_FP(seg-1,8), (void far *)sda_ename1, 8);
 #endif

 	/* put cr/lf on dev with "args", put ' '/lf on dev w/o args */
 	len1 = strlen(parms);
 	parms[len1] = oldc;			/* tack on the args back onto filename */
 	len2 = strlen(parms);
 	if(len2 > len1+2)
 		parms[len2-2] = '\r';

 	/* initialize the device driver */
 	dev_init(MK_FP(seg,0), parms);

 	if(trydoshi && !(dos5_flags&DOS5_ROM) && (hma_used == 0))
 	 	alloc_hma((codeparas+bufparas)*0x10+0x20);

 	/* in case driver init made DOS calls */
 	error_no = 0;
 }


 /*
 	Run Only On Bootup:

 	Create some more SFTs for the use of the DOS1 file
 	(FCB) system.  There is a hardcoded minimum set in
 	DOSDEF.H
 */
 void	do_fcbs(char *parms)
 {
 	extern uchar sda_numfcbs;

 	// validate pointer
 	ASSERT(parms);

 	sda_numfcbs = minmax(parms, sda_numfcbs, MAXFCB);
 }


 /*
 	Run Only On Bootup:

 	Create some more SFTs for the use of the file system.
 	There is a hardcoded minimum set in DOSDEF.H
 */
 void	do_files(char *parms)
 {
 	extern uchar sda_numsfts;
 	extern int	init_files;

 	// validate pointer
 	ASSERT(parms);

 	init_files = sda_numsfts = minmax(parms, sda_numsfts, MAXSFT);
 }

 /*
 	Run Only On Bootup:

 	Force DOS to allocate more drive structures.
 */
 void	do_lastdrive(char *parms)
 {
 	extern struct LOL lol;

 	// validate pointer
 	ASSERT(parms);

 	lol.lastdrive = toupper(*parms)-'A'+1;
 }

 /*
 	Run Only On Bootup:	ROM-DOS specific feature

 	Continue processing a new CONFIG.SYS file.  The new
 	file may have menus and all the other stuff of any
 	CONFIG.SYS.
 */
 void	do_newfile(char *parms)
 {
 	extern char warn_bad[];
 	extern char warn_newfile[];
 	extern int error_no;
 	int found_file = 0;

 	// validate pointer
 	ASSERT(parms);

 	// need to make sure that the specified file exists first.
 	//
 	asm	mov	ax, 0x6C00
 	asm	mov	bx, O_NO24		// no critical error
 	asm	mov	cx, 0
 	asm	mov	dx, ACT_EXIST_OPEN
 	asm	mov	si, parms		// try to open it
 	asm	int	0x21
 	asm	jc		tried_open		// if not found, print msg
 	asm	inc	found_file		// else set flag
 	asm	mov	bx, ax			// and close file
 	asm	mov	ax, 0x3E00
 	asm	int	0x21

 tried_open:
 	if(!found_file)
 	{
 		printf(warn_bad,warn_newfile,parms);	// bad or missing newfile
 		error_no=1;										// disclose err to configsys loop
 		return;
 	}

 	mem_free(cfg_seg);			// free the current config.sys block
 	load_config(parms);			// go get the new file
 }

 /*
 	Run Only On Bootup:

 	Just a remark, do nothing.
 */
 #pragma argsused
 void	do_rem(char *parms)
 {
 	// validate pointer
 	ASSERT(parms);
 }

 #if VDOS >= 5

 /*
 	Run Only On Bootup:

 	No HMA available, inform user.
 */
 void warning_nohigh(void)
 {
 	printf(warn_nohigh);
 }

 /*
 	Run Only On Bootup:

 	DOS=HIGH

 	Note: UMBs are ALWAYS linked in, if EMM has set up upper
 	memory blocks (no need to say DOS=HIGH,UMBS).
 */
 void	do_dos(char *parms)
 {
 	extern char trydoshi;

 	// validate pointer
 	ASSERT(parms);

 	if(memcmp(parms,"HIGH",4) == 0)
 		trydoshi = TRUE;			// tell DOS to attempt loading high
 }

 /*
 	Run Only On Bootup:

 	STACKS=num,size

 	There may be more than one STACKS entry in a set of CONFIG files, if
 	so the last one takes affect.

 */
 void	do_stacks(char *parms)
 {
 	extern int stacksNum;
 	extern int stacksSize;

 	/* determine number of stacks */
 	stacksNum = minmax(parms, 0, 64);
 	if(stacksNum > 0 && stacksNum < 8)
 		stacksNum = 8;

 	/* skip to second number */
 	while(isdigit(*parms))
 		++parms;
 	while(*parms && !isdigit(*parms))
 		++parms;

 	/* determine size of stacks */
 	stacksSize = minmax(parms, 32, 512);

 }

 /*
 	This routine is called by UseSTACKSStacks() to do the math for the
 	last STACKS= entry in CONFIG; the SDA variables stacksNum and
 	stacksSize will have been set to the last STACKS= values by the
 	do_stacks() routine above. Once we have figured out the size
 	and number of the stacks we allocate any additional memory from
 	DGROUP that we may need. When this is done, the STACKS stacks
 	will have been set up in the SDA and UseSTACKSStacks() need only
 	copy the contents of the two stacks and then switch onto the new
 	char stack.
 */
 void SetupStacks(void)
 {
 	/* By default...
 	   stacksNum = 9, stacksSize = 128,	static stack depth = 0x26C,
 		pDiskStack = &disk_stack, pCharStack = &char_stack
 	*/
 	extern int stacksNum;
 	extern int stacksSize;
 	extern char *pDiskStack;
 	extern char *pCharStack;
 	extern char *pDiskStackTop;
 	extern char *pCharStackTop;
 	extern char char_stack[];

 	unsigned totalSize;
 	unsigned allocSize;

 	/* determine memory needed for the stacks */
 	totalSize = (unsigned)stacksNum * stacksSize;
 	allocSize = totalSize >> 1;

 	/* We have two statically allocated stacks in the SDA (one
 		char stack and one disk stack) That are each 0x26Ch bytes
 		long. If the totalSize of the STACKS (n*s) is less than or
 		equal to the sum of the statically allocated stacks we
 		will just use the static stacks.
 	*/
 	if(totalSize <= (0x26C * 2))
 		return;

 	/* If 0x26C < (totalSize/2) <= 0x26C*2 (if half of it will fit
 		in the statically allocated stack space) then use the statically
 		allocated space for the disk stack and dynamically allocate a new
 		char stack (size = n*s/2, size <=0x26C*2).
 	*/
 	else if((totalSize >> 1) <= (0x26C * 2))
 	{
 		/* move top of stack up leave ptr to bottom of stack where it is now */
 		pDiskStackTop  = char_stack;

 		pCharStack     = mem_alloc_ptr(allocSize, 'S');
 		pCharStackTop  = pCharStack + allocSize;
 		*(int *)pCharStack = STACKWORD;
 	}
 	/* If (totalSize/2) > 0x26C*2 then we can't fit either stack in
 		the statically allocated stack region (it can't be expanded because
 		it's upper limit is bound by the SDA COUNTRY info location). We
 		have to dynamically allocate both the char and the disk stack.
 	*/
 	else
 	{
 		pDiskStack    = mem_alloc_ptr(totalSize, 'S');
 		pDiskStackTop = pDiskStack + allocSize;
 		*(int *)pDiskStack = STACKWORD;

 		pCharStack    = pDiskStackTop + 2;
 		pCharStackTop = pDiskStackTop + allocSize;
 		*(int *)pCharStack = STACKWORD;
 	}
 }

 /*
 	Run Only On Bootup:

 	Install a TSR in high memory if possible.  No environment is made for
    this TSR.
 */
 void	do_installhigh(char *parms)
 {
 	extern uchar mem_fit;


 	mem_fit = MEM_UMB1ST | MEM_BEST;
 	set_umb_link(1);
 	do_install(parms);
 	mem_fit = MEM_FIRST;
 	set_umb_link(0);
 }

 /*
 	Run Only On Bootup:

 	Install a TSR.  No environment is made for this TSR.
 */
 void	do_install(char *parms)
 {
 	extern union EXEPARM boot_parms;
 	extern char warn_bad[];
 	extern char warn_tsr[];

 	int len;
 	char * p;

 	// validate pointer
 	ASSERT(parms);

 	/* separate TSR name from parameters */
 	make_fname(parms);

 	/* set up the EXE parameters for spawn */
 	boot_parms.e.envseg = getDS();	/* empty environment (always 0's) */
 	p = parms + strlen(parms) + 1;
 	len = strlen(p);
 	if(len)
 	{
 		++len;
 		memmove(p+2, p, len);
 		p[1] = ' ';
 	}
 	*p = len;
 	memmove(p+len+1,"\r\n",3);
 	boot_parms.e.command_line = (char far *)p;

 	/* spawn the program */
 	if(!spawn_tsr(parms, &boot_parms))
 		printf(warn_bad,warn_tsr,parms);
 }
 #endif

 #if VDOS >= 6

 /*
 	Run Only On Bootup:

 	Install a disk or character device into UMBs.  See
 	"do_device".  If device cannot be loaded high, then
 	load it low.
 */
 void	do_devicehigh(char *parms)
 {
 	extern uchar mem_fit;
 	extern int error_no;

 	// validate pointer
 	ASSERT(parms);

 	/* we want to load into UMBs. If that fails, do_device will try again */
 	mem_fit = MEM_UMBONLY;
 	set_umb_link(1);
 	do_device(parms);
 	mem_fit = MEM_FIRST;
 	set_umb_link(0);

 	/* if set_umb_link failed, clear error condition so no CONFIG err msg */
 	error_no = 0;
 }

 /*
 	Run Only On Bootup:

 	Include a block in the present block.
 */
 #pragma argsused
 void	do_include(char *parms)
 {
 	extern int error_no;

 	unsigned oldpos;
 	int oldline;
 	int line;

 	// validate pointer
 	ASSERT(parms);

 	// beyond depth?
 	if(cfg_inc_level >= MAX_INCLUDE_DEPTH)
 		return;

 	// make sure that the Block is valid
 	oldpos = cfg_position;
 	oldline= cfg_linenum;
 	if((line = find_block(parms)) != 0)
 	{
 		cfg_inc_pos[cfg_inc_level] = oldpos;
 		cfg_inc_line[cfg_inc_level++] = oldline;
 		cfg_linenum = line;
 	}
 	else
 	{
 		error_no = 1;
 		cfg_position = oldpos;
 	}
 }

 /*
 	Run Only On Bootup:

 	Set the Numlock (for numeric pad) ON or OFF.
 */
 void	do_numlock(char *parms)
 {
 	char far * numlockptr = MK_FP(0x40,0x17);

 	// validate pointer
 	ASSERT(parms);

 	// need only set it off; BIOS sets it on by default
 	if(memcmp(parms,"OFF",3) == 0)
 		*numlockptr = 0;
 	if(memcmp(parms,"ON",2) == 0)
 		*numlockptr |= 0x20;
 }

 /*
 	Run Only On Bootup:

 	Auxiliary routine to "SET=xxx" in CONFIG.SYS.
 	Returns a pointer to the final NULL in the boot
 	environment.
 */
 char far * env_end(void)
 {
 	extern unsigned boot_env;
 	char far * ep = MK_FP(boot_env,0);

 	while(*ep)
 	{
 		++ep;
 		if(*ep == 0)	// skip NULL at end of each string
 			++ep;
 	}

 	return ep;
 }

 /*
 	Run Only On Bootup:

 	Auxiliary routine to "SET=xxx" in CONFIG.SYS.
 	Adds an item to the boot environment.
 */
 void env_add(char * item)
 {
 	char far * ep = env_end();
 	int len = strlen(item)+1;

 	// validate pointer
 	ASSERT(item);

 	// add in the string
 	fmemcpy(ep, (void far *)item, len);

 	// null terminate the whole kit and kaboodle
 	*(ep+len) = 0;
 }

 /*
 	Run Only On Bootup:

 	Auxiliary routine to "SET=xxx" in CONFIG.SYS.
 	Removes an item from the boot environment.
 */
 void env_remove(char far * ep)
 {
 	char far * next_ep = ep;
 	int env_len;

 	// validate pointer
 	ASSERT(ep);

 	// find the next environment variable
 	while(*next_ep)
 		++next_ep;
 	++next_ep;

 	// determine length of stuff to move
 	env_len = (int)(env_end() - next_ep) + 1;

 	fmemcpy(ep, next_ep, env_len);
 }

 void	do_set(char *parms)
 {
 	extern unsigned boot_env;

 	char *p;
 	char far * ep;
 	int len;

 	// validate pointer
 	ASSERT(parms);

 	// determine "name" part of environment string
 	for(p=parms, len=0; *p && *p!='='; ++p, ++len)
 		*p = toupper(*p);

 	// if it already exists, remove the old copy
 	ep = MK_FP(boot_env,0);
 	while(*ep)
 	{
 		// found it!, remove it
 		if((fmemcmp((char far *)parms,ep,len) == 0) && (*(ep+len) == '='))
 			env_remove(ep);

 		// on to next env variable
 		else
 		{
 			while(*ep)
 				++ep;
 			++ep;
 		}
 	}

 	// add in the new one
 	if(*p == '=' && *(p+1))
 		env_add(parms);
 }

 #endif



 #if VDOS >= 6	// {

 #define MENUITEM	0
 #define SUBMENU	1

 #define TITLEROW	1
 #define TITLECOL	2
 #define MENUROW	(TITLEROW+2)
 #define MENUCOL	TITLECOL
 #define CONFIRM_ROW	24
 #define CONFIRM_COL	0
 #define CHOICE_ROW	1
 #define TIMEROW	TITLEROW
 #define TIMECOL	40

 #define F5 0x3F00
 #define F8 0x4200
 #define UPARROW 0x4800
 #define DNARROW 0x5000

 struct menu
 {
 	unsigned pos;			// position in CONFIG.SYS
 	unsigned pos2;			// position of menu itself
 	char type;				// MENUITEM or SUBMENU
 };

 // used for both "Starting ROM-DOS..." message, and to wait for a key
 // in a MENU, definable by MENUDEFAULT.  (0=wait forever in menu)
 extern int cfg_seconds;

 char cfg_color = 7;						// MENUCOLOR, what color? (0 = tty)
 extern unsigned cfg_default;			// MENUDEFAULT, points to menu name
 extern int cfg_num_menus;				// # of menus (up to 9)
 extern struct menu * cfg_menuptr;	// ptr to up to 9 menuitems
 extern unsigned cfg_menupos;			// set by caller
 extern int cfg_nobypass;				// don't allow bypass at all

 #define CFG_SWITCH 5
 struct config menus[] =
 {
 	{ "MENUITEM",		do_menuitem,		1 },	// 0
 	{ "MENUCOLOR",		do_menucolor,		1 },
 	{ "MENUDEFAULT",	do_menudefault,	1 },
 	{ numlockstr,		do_numlock,			1 },
 	{ "SUBMENU",		do_submenu,			1 },
 	{ switchstr,		do_rem,				1 },	// 5
 	{ 0 }
 };

 /*
 	Run Only On Bootup:

 	Check CONFIG.SYS for menus.  If menus are found, then
 	present them to the user and decide which one is it.

 	There are effectively 2 kinds of Blocks: Menu Blocks
 	and Configuration Blocks.  The Menu Blocks contain
 	commands like "menuitem", "submenu" and so on.  The
 	Configuration Blocks contain all the normal CONFIG.SYS
 	stuff.

 	The user eventually picks one of the Configuration (not
 	Menu) Blocks, or says to bypass CONFIG.SYS.

 	Returns false if we should NOT process CONFIG.SYS.
 */
 int process_menus(char *picked_block)
 {
 	extern char menu_str[];
 	extern char config_str[];			// used as a buffer to read lines
 	extern char warn_cmd[];
 	extern char cfg_name[];
 	extern int cfg_ask;
 	extern unsigned cfg_position;
 	extern char title_msg[];
 	extern char choice_msg[];
 	extern char confirm_msg[];
 	extern int error_no;

 	static char number[] = "1\010";	// # + backspace
 	char * line = config_str;
 	struct menu menuitems[9];			// 1 - 9 possible items
 	int item;
 	int c;
 	char * cmd;
 	int linenum;
 	int len;
 	int worked = TRUE;
 	int choicerow;					// the row for waiting

 	// validate pointer
 	ASSERT(picked_block);

 	// are there any menus at all?
 	*picked_block = 0;
 	if((linenum = find_block(menu_str)) == 0)		// sets cfg_position
 		return worked;

 	// get a menu from the user
 	while(1)
 	{
 		// find all MENUITEMs and SUBMENUs
 		cfg_menuptr = menuitems;
 		cfg_num_menus = 0;
 		while(1)
 		{
 			cfg_menupos = cfg_position;
 			if(!getline(line))
 				break;

 			++linenum;

 			// if we hit a '[', we are done with this Menu Block
 			cmd = skipwhite(line);
 			if(*cmd == '[')
 				break;

 			// comments
 			if(*cmd == ';' || *cmd == 0)
 				continue;

 			/* didn't find a command, display offending line */
 			item = is_command(&cmd, menus);
 			if(item < 0)
 			{
 error:
 				printf(warn_cmd, line, cfg_name, linenum);
 				waitforkey();
 			}
 			else
 			{
 				cfg_menupos += cmd-line;
 				error_no = 0;
 				(*menus[item].func)(cmd);
 				if(error_no)
 				{
 					error_no = 0;
 					goto error;
 				}
 			}
 		}

 		// NO Block was chosen
 		if(!cfg_num_menus)
 		{
 			*picked_block = 0;
 			return worked;
 		}

 		// "ROM-DOS Startup Menu"
 		if(cfg_color)
 		{
 			clear_screen(0);
 			set_cursor(TITLEROW, TITLECOL);
 		}
 		printf(title_msg);

 		// print each menu item
 		for(item=0; item<cfg_num_menus; ++item)
 		{
 			if(cfg_color)
 				set_cursor(MENUROW+item, MENUCOL);
 			memmove(line,"1.  ",4);
 			*line = item+'1';
 			get_title(line+4, menuitems[item].pos);
 			strcat(line,"\n");	// in case of tty
 			printf(line);
 		}
 		choicerow = MENUROW+cfg_num_menus+CHOICE_ROW;

 		// F5=Bypass Startup Files    F8=Confirm each CONFIG line [N]
 		if(cfg_color && !cfg_nobypass)
 		{
 			set_cursor(CONFIRM_ROW, CONFIRM_COL);
 			printf(confirm_msg);
 			set_cursor(choicerow, MENUCOL);
 		}
 		printf(choice_msg);

 		// determine default item
 		for(item=0; item<cfg_num_menus; ++item)
 			if(cfg_default == menuitems[item].pos2)
 				break;
 		if(item >= cfg_num_menus)
 			item = 0;

 		// get keys until the user chooses something
 		while(1)
 		{
 			// display current "ask" value, F8 [N]
 			if(cfg_color && !cfg_nobypass)
 			{
 				set_cursor(CONFIRM_ROW,CONFIRM_COL+strlen(confirm_msg)-2);
 				printf("%c", cfg_ask ? 'Y' : 'N');
 				set_cursor(choicerow,MENUCOL+strlen(choice_msg));
 			}

 			// display the current number
 			*number = item + '1';
 			printf(number);

 			// do what the user says to do
 			c = menu_getkey();
 			switch(c)
 			{
 				case F5:	if(!cfg_nobypass) worked = FALSE; goto done;
 				case F8: if(!cfg_nobypass) cfg_ask = !cfg_ask; break;
 				case UPARROW: if(item > 0) --item; break;
 				case DNARROW: if(item+1 < cfg_num_menus) ++item; break;
 				default:
 					c &= 0xFF;
 					if(c >= '1' && c <= '0'+cfg_num_menus)
 						item = c-'1';
 					break;
 			}
 			if(c == CR)
 				break;
 		}

 		// extract the new menu name
 		cfg_position = menuitems[item].pos;
 		getline(line);
 		c = make_fname(line);
 		len = strlen(line);
 		strupr(line);
 		memmove(picked_block,line,len+1);

 		// found a menu!  use it
 		if(menuitems[item].type == MENUITEM)
 			break;

 		// go to the submenu
 		linenum = find_block(picked_block);
 	}

 	// set the "CONFIG=" in the environment
 	cfg_position = menuitems[item].pos;
 	getline(line);
 	make_fname(line);						// Menu_Name
 	cmd = strchr(cfg_name, '.');
 	len = (cmd ? cmd-cfg_name : strlen(cfg_name));
 	memmove(line+len+1,line,strlen(line)+1);	// make room for cfgname
 	memmove(line, cfg_name, len);
 	line[len] = '=';						// CONFIG=Menu_Name
 	do_set(line);

 done:

 	// got our menu, clear the rest of the screen
 	if(cfg_color)
 		clear_screen(choicerow+1);

 	// menus processed OK
 	return worked;
 }

 /*
 	Wait for a key from the menu.  May have a timer on it.
 */
 int menu_getkey(void)
 {
 	extern uchar seconds;
 	extern char time_msg[];

 	int c;
 	int i;
 	uchar oldsecs;

 	// at menu prompt. just wait for a key.
 	if(cfg_seconds <= 0)
 		c = con_getkey();

 	// do the count-down thing
 	else
 	{
 		// display the "Time remaining..." message
 		if(cfg_color)
 		{
 			set_cursor(TIMEROW, TIMECOL);
 			printf(time_msg);
 		}

 		// get current time into SDA
 		touch_time(TM_READ);
 		oldsecs = 70;		// set to any illegal # of seconds (not 0-59)

 		// we'll be decrementing cfg_seconds, so inflate it here
 		++cfg_seconds;

 		// look for keys
 		do
 		{
 			c = con_chkkey();
 			if(c == -1)
 			{
 				touch_time(TM_READ);			// Read the time into globals
 				if(oldsecs != seconds)
 				{
 					--cfg_seconds;
 					if(cfg_color)
 					{
 						set_cursor(TIMEROW, TIMECOL + strlen(time_msg));
 						printf("%d ",cfg_seconds);
 					}
 					if(cfg_seconds == 0)
 						c = CR;				// inaction means do default
 				}
 				oldsecs = seconds;
 			}

 			// user pressed a key, delete time message
 			else
 			{
 				cfg_seconds = 0;
 				if(cfg_color)
 				{
 					set_cursor(TIMEROW, TIMECOL);
 					for(i=strlen(time_msg)+4; i>=0; --i)
 						printf(" ");
 				}
 			}
 		} while(c == -1);
 	}

 	return c;
 }

 void waitforkey(void)
 {
 	extern char wait_msg[];
 	printf(wait_msg);
 	con_getkey();
 	printf("\n");
 }

 /*
 	Extract the title from CONFIG.SYS file given the
 	position of the "parms" of a menuitem line.

 	MENUITEM=ABC			will extract "ABC"
 	MENUITEM=XYZ, Text	will extract "Text"
 */
 void get_title(char * line, unsigned pos)
 {
 	extern unsigned cfg_position;
 	char * p;

 	// validate pointer
 	ASSERT(line);

 	cfg_position = pos;
 	getline(line);
 	p = strchr(line, ',');
 	if(p)
 		memmove(line,p+1,strlen(p));
 }

 /*
 	Run Only On Bootup:

 	Look through CONFIG.SYS for the given block name.

 	Returns the line # and set cfg_position if found.
 	Returns 0 (with cfg_position unchanged) if not.
 */
 int find_block(char *name)
 {
 	extern unsigned cfg_position;
 	extern char sda_fname1[];			// used as a buffer to read lines

 	unsigned oldpos = cfg_position;
 	char * line = sda_fname1;
 	int linenum = 0;
 	char * cmd;
 	char c;
 	int found;

 	// validate pointer
 	ASSERT(name);

 	// save the name string
 	c = make_fname(name);

 	// look for the block [name]
 	found = cfg_position = 0;
 	while(getline(line))
 	{
 		++linenum;
 		cmd = skipwhite(line);
 		if(*cmd == '[' && is_block(cmd+1, name))
 		{
 			found = 1;
 			break;
 		}
 	}

 	// reset the name
 	name[strlen(name)] = c;

 	// we found it!
 	if(found)
 		return linenum;

 	// not found, go back to where we were
 	cfg_position = oldpos;
 	return 0;
 }

 /*
 	Run Only On Bootup:

 	Does the name match the Block name in the CONFIG.SYS
 	line?  Returns TRUE if match, FALSE if not.
 */
 int is_block(char *line, char *name)
 {
 	extern char * terminators;
 	unsigned len;
 	char tmpname[BLKNAMESIZE];

 	// validate pointers
 	ASSERT(line);
 	ASSERT(name);

 	// no block name, give up
 	len = strlen(name);
 	if(!len)
 		return FALSE;

 	// match the name (must end in a terminator)
 	line = skipwhite(line);
 	memmove(tmpname,line,len);
 	strupr(tmpname);
 	return ((memcmp(tmpname,name,len)==0) && strchr(terminators,line[len]));
 }

 /*
 	Run Only On Bootup:

 	Ask a yes/no/"get hosed" question.
 	Returns TRUE if yes, FALSE if no, -1 if F5 was pressed.

 */
 int ask(char *prompt)
 {
 	extern char ask_string[];
 	int c, result;

 	// validate pointer
 	ASSERT(prompt);

 	printf(ask_string,prompt);
 	c = getyesno();

 #if (VDOS >= 6)	// DOS 6+ only
 	if(c == F5)
 	{
 		c               = '\r';
 		result          = -1;
 		skippingTheRest = TRUE;
 	}
 	else
 #endif

 	{
 		c      &= 0xFF;
 		result  = (c == 'Y');
 	}

 	printf("%c\n",c);
 	return result;
 }

 /*
 	Run Only On Bootup:

 	Add this menu item to the current list.
 */
 void do_menuitem(char *parms)
 {
 	// validate pointer
 	ASSERT(parms);

 	if(cfg_num_menus >= 9)
 		return;

 	if(founditem(parms))
 	{
 		cfg_menuptr->type = MENUITEM;
 		++cfg_menuptr;
 	}
 }

 /*
 	Run Only On Bootup:

 	Set the menu color.  Makes it look pretty.

 	Syntax: menucolor = fg[,bg]
 	fg = foreground color (0-15)
 	bg = background color (0-7)
 */
 void do_menucolor(char *parms)
 {
 	char c;

 	// validate pointer
 	ASSERT(parms);

 	// check for foreground color
 	c = minmax(parms, 0, 15);
 	cfg_color = (cfg_color & 0xF0) + c;

 	// check for background color
 	parms = strchr(parms,',');
 	if(parms)
 	{
 		c = minmax(skipwhite(parms+1), 0, 7);
 		cfg_color = (cfg_color & 0x0F) + (c<<4);
 	}
 }

 /*
 	Run Only On Bootup:

 	Menuitem 1. is the normal default.  Allow user to
 	change this.  Default menu is specified by name.
 	Example:
 			MENUDEFAULT=Windows,10
 */
 void do_menudefault(char *parms)
 {
 	extern unsigned cfg_position;
 	unsigned oldpos;

 	// validate pointer
 	ASSERT(parms);

 	// remember the way things were
 	oldpos = cfg_position;
 	if(find_block(parms))
 		cfg_default = cfg_position;
 	cfg_position = oldpos;

 	// cfg_seconds should already be -1, from the assembly routine
 	// bypass_config(). -1 means wait for a key.

 	// check for timeout
 	parms = strchr(parms,',');
 	if(parms)
 	{
 		// only set timeout if user actually put a number there.
 		// user MAY have said MENUDEFAULT x,  with no number.
 		parms = skipwhite(parms+1);
 		if(*parms)
 			cfg_seconds = minmax(parms, 0, 90);		// up to 90 secs
 	}
 }

 /*
 	Run Only On Bootup:

 	Menus can be nested any number of levels deep.  This
 	command says that the given menuitem is really a
 	submenu.
 	Example:
 		SUBMENU=SubMenuName,Text for Menu
 */
 void do_submenu(char *parms)
 {
 	// validate pointer
 	ASSERT(parms);

 	if(cfg_num_menus >= 9)
 		return;

 	if(founditem(parms))
 	{
 		cfg_menuptr->type = SUBMENU;
 		++cfg_menuptr;
 	}
 }

 /*
 	Look for a MENUITEM or SUBMENU.
 	Returns TRUE if found, FALSE if not.
 */
 int founditem(char *parms)
 {
 	extern unsigned cfg_position;
 	extern int error_no;

 	unsigned oldpos;
 	int found = FALSE;

 	// validate pointer
 	ASSERT(parms);

 	// remember the way things were
 	oldpos = cfg_position;

 	// does the block exist?
 	if(find_block(parms))
 	{
 		cfg_menuptr->pos  = cfg_menupos;
 		cfg_menuptr->pos2 = cfg_position;
 		++cfg_num_menus;

 		++found;		// found=TRUE
 	}
 	else
 		error_no = 1;

 	// don't lose our place
 	cfg_position = oldpos;
 	return found;
 }

 /*
 	Run Only On Bootup:

 	Set a number of DOS options
 	/F		Fast startup - don't wait for user key
 	/K		Use standard keyboard calls, not extended
 	/N		Don't allow F5 or F8 to bypass CONFIG.SYS
 */
 void process_switches(void)
 {
 	extern char config_str[];			/* a buffer to read lines */

 	char * line = config_str;
 	char * cmd;
 	int item;

 	while(getline(line))
 	{
 		// comments
 		cmd = skipwhite(line);

 		// is this the switches command?
 		item = is_command(&cmd, menus+CFG_SWITCH);
 		if(item == 0)
 			set_switches(cmd);
 	}
 }

 void set_switches(char *parms)
 {
 	extern uchar switch_char;

 	// validate pointer
 	ASSERT(parms);

 	cfg_seconds = 3;
 	while(*parms)
 	{
 		parms = skipwhite(parms);

 		if(*parms == switch_char)
 		{
 			switch(*(parms+1))
 			{
 				// Don't allow F5 or F8 to bypass CONFIG.SYS
 				case 'N':
 					cfg_nobypass = TRUE; // fall thru...

 				// Fast startup - don't wait for user key
 				case 'F':
 					cfg_seconds = 0;
 					break;

 				// Use standard keyboard calls, not extended
 				case 'K':
 					disable_extended();
 					break;

 				//
 				default :
 					;
 			}

 			// on to next parameter
 			parms += 2;
 		}
 	}
 }

 #endif	// }  DOS 6+ only

 #endif	// }  the whole file may be commented out


#endif  // #if 0