;
;   $Id: DOSCFG3A.ASM 1.10 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
IF 0
;
; This file was replaced by the "load_and_process_config()"
; which is located in DOSCONFI.C
;
COMMENT ~
----------------------------------------------------------

   DOSCFG3A.ASM  created 12/16/93  by Drew Gislason

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This code is used in DOS 3.31 (and up) CONFIG.SYS
   processing.  It is in its own separate file so that
   when ROM-DOS is linked via library, it is not pulled
   in if NO CONFIG.SYS processing is required by the
   OEM.

   The code is thrown away (in RAM) after initialization.

---------------------------------------------------------- ~
include macros.inc
include profile.inc

cBegData
	extrn	_cfg_size:word
	extrn	_cfg_seg:word
	extrn	_mem_fit:byte
cEndData

cBegCode

	extrn	MEM_Z_ALLOC:near
	extrn	MEM_FREE:near

;-------------------------------------------------------
;   Read in all of CONFIG.
;
;   Returns size of CONFIG.SYS if found, or 0 on failure.
;   A failure might occur if the file is not found, or
;   read encounters problems.
;
;   Sets "cfg_size" and "cfg_seg".
;
comment ~ ; prototype ;
int load_config(char *name)
{}
~
c_func	load_config

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI

	; open the file
	mov	AX, 6C00H	; DOS special open function
	mov	BX, 2000H	; open for read only, no INT 24H
	mov	CX, 0		; attribute, just in case
	mov	DX, 1		; open if exist, fail if not
	mov	SI, P[BP]	; pointer to filename
	int	21H
	jc	lc_failed	; couldn't open file
	mov	BX, AX		; save handle

	; determine size
	mov	AX, 4202H	; DOS seek from end
	xor	CX, CX
	xor	DX, DX
	int	21H		; size returned in DX:AX

	; max size of 16K
	or	DX, DX
	jnz	size16
	cmp	AX, 4000H	; 16K
	jbe	sizeok
size16:	mov	AX, 4000H
sizeok:
	inc	AX       ; make room for ^Z (EOF)
	mov	[_cfg_size], AX

	; allocate memory for this CONFIG.SYS
	push	BX
	mov	[_mem_fit], 2	; last fit
	push	AX		; id byte
	push	AX		; byte to alloc
	call	MEM_Z_ALLOC
	mov	[_cfg_seg], AX
	mov	[_mem_fit], 0
	pop	BX

	; read it in
	mov	AX, 4200H	; seek to beginning
	xor	CX, CX
	xor	DX, DX
	int	21H
	mov	AH, 3FH
	mov	CX, [_cfg_size]
	push	DS
	mov	DS, [_cfg_seg]
	xor	DX, DX
	; we are setup for the read, take a moment to stuff a ^Z (EOF)
	; into the buffer at the appropriate spot
	;
	push	BX
	mov	BX, CX
	dec	BX                     ; get the new size-1
	mov	BYTE PTR [BX],1Ah      ; tack on a ^Z (EOF)
	pop	BX
	; now go ahead and read it in
	;
	int	21H
	pop	DS
	jc	lc_failed2

	; close file
	mov	AH, 3EH		; DOS seek function
	int	21H		; no one cares if it fails
	mov	AX, [_cfg_size]
	jmp	short lc_done

lc_failed2:
	; release memory
	mov	AX, [_cfg_seg]
	call	MEM_FREE
lc_failed:
	xor	AX, AX
	mov	[_cfg_seg], AX
lc_done:
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret
c_endp	load_config


cEndCode

ENDIF    ; IF 0

	END