//
//   $Id: DOSCONFI.C 1.20 2003/06/13 17:02:54Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   DOSCONFI.C, originally based on
      DOSCFG.C created 01/11/91  by Drew Gislason

   Copyright (c) 1991-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains the CONFIG.SYS processing.

   History:

   04-30-2003 jmb made DOS a pass1 and pass2 command
   08-25-2002 td  near-complete rewrite

**********************************************************/
#include "dostruct.h"
#include "dosdef.h"
#include "dosproto.h"
#include "dlerrcod.h"

#define __FILENUM__ 1

// default to version 6
#ifndef VDOS
#define VDOS 6
#endif

#define CONFIG 1
#include "dosmsg.c"

// Regardless of config_level, at least until DOSMAIN.C is fixed,
// do_shell must be available.
//
#define CFG_SHELL=1

#if VDOS
#define CFG_PROCESSING=1

#define CFG_BREAK=1
#define CFG_BUFFERS=1
#define CFG_COUNTRY=1
#define CFG_DEVICE=1
#define CFG_FCBS=1
#define CFG_FILES=1
#define CFG_LASTDRIVE=1
#define CFG_NEWFILE=1
#define CFG_REM=1
#define CFG_SHELL=1
#endif

#if VDOS >= 5
#define CFG_DOS=1
#define CFG_INSTALL=1
#define CFG_INSTALLHIGH=1
#define CFG_STACKS=1
#endif

#if VDOS >= 6
#define CFG_INCLUDE=1
#define CFG_MENUS=1
#define CFG_ASKS=1
#define CFG_BLOCKS=1

#define CFG_NUMLOCK=1
#define CFG_SET=1
#define CFG_SWITCHES=1
#define CFG_DEVICEHIGH=1
#endif

#if VDOS >= 7
#define CFG_SEARCHES=1
#endif

/*
	[]----------------------------------------[]
    |                                        |
    |         ALL CONFIGSYS LEVELS           |
    |                                        |
	[]----------------------------------------[]
*/

#ifdef CFG_SHELL
/*
   Run Only On Bootup:

   Install a different boot program, called a "shell" in
   the DOS world.  The parms string points to the path and
   name of the shell.

   Example: "SHELL = C:\BIN\NEWSHELL.EXE /arg1 /arg2"
*/
void   do_shell(char far *parms)
{
   extern char shell[128];      // the 1st program run by ROM-DOS, ie COMMAND

   // validate pointer
   ASSERT(parms);

   shell[0] = sizeof(shell)-4;
   shell[1] = fstrlen(parms);
   fmemcpy((char far *)shell+2, parms, shell[1]+1);
   shell[shell[1]+3]= 0;
}
#endif  // #ifdef CFG_SHELL

/*
	[]----------------------------------------[]
    |                                        |
    |             DOS 3.31 only              |
    |                                        |
	[]----------------------------------------[]
*/

/*	cfg_name must be defined the same so nothing
	breaks, but adds a backslash to the output file.  For
	Fillon Systems, whose redirector expects the string
	"\CONFIG.SYS",0 to be in every DOS boot file.
 */
char cfg_name_kludge = '\\';
char cfg_name[] = "CONFIG.SYS";

#if (VDOS < 5)		// DOS 3.31 only

// Dummied out for DOS 3.31
void enable_hma(void)
{
}

// Dummied out for DOS 3.31
#pragma argsused                 // disable a warning message
int alloc_hma(unsigned bytes)
{
	return 0;
}

#endif	// DOS 3.31 only

#if (VDOS == 0)		//	NO CONFIG.SYS processing

// for space savings have NO CONFIG.SYS processing
#pragma argsused                 // disable a warning message
 void configsys(int pass)
{}

#pragma argsused                 // disable a warning message
#pragma warn -rvl                // disable a warning message
 int load_and_process_config(char far *fpszConfigName, unsigned uCfgPos)
{}

#endif  // #if (VDOS == 0)


#ifdef CFG_PROCESSING
char skippingTheRest = 0;         // ask() sets this TRUE if F5 is pressed;

unsigned uMenuSeg;            // new memory buffer
unsigned uMenuPosition;       // new current position, 0xFFFF = EOF

char numlockstr[] = "NUMLOCK";
char switchstr[]  = "SWITCHES";

// moved to SYSGEN  #define F5 0x3F00
// moved to SYSGEN  #define F8 0x4200

#ifdef CFG_NEWFILE
unsigned char ucSpecialNewFile = 0;
unsigned char ucNewFileError;
#endif // #ifdef CFG_NEWFILE

struct config normal_items[] =
{
#ifdef CFG_DOS
   { "DOS",         do_dos,         PASS1_FLAGS | PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_DOS
#ifdef CFG_STACKS
   { "STACKS",      do_stacks,      PASS1_FLAGS },
#endif  // #ifdef CFG_STACKS

#ifdef CFG_BREAK
   { "BREAK",       do_break,       PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_BREAK
#ifdef CFG_BUFFERS
   { "BUFFERS",     do_buffers,     PASS2_FLAGS },
#endif  // #ifdef CFG_BUFFERS
#ifdef CFG_COUNTRY
   { "COUNTRY",     do_country,     PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_COUNTRY
#ifdef CFG_DEVICE
   { "DEVICE",      do_device,      PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_DEVICE
#ifdef CFG_FCBS
   { "FCBS",        do_fcbs,        PASS2_FLAGS },
#endif  // #ifdef CFG_FCBS
#ifdef CFG_FILES
   { "FILES",       do_files,       PASS2_FLAGS },
#endif  // #ifdef CFG_FILES
#ifdef CFG_LASTDRIVE
   { "LASTDRIVE",   do_lastdrive,   PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_LASTDRIVE
#ifdef CFG_NEWFILE
   { "NEWFILE",     do_newfile,     PASS2_FLAGS },
#endif  // #ifdef CFG_NEWFILE
#ifdef CFG_REM
   { "REM",         do_rem,         PASS2_FLAGS },
#endif  // #ifdef CFG_REM
#ifdef CFG_SHELL
   { "SHELL",       do_shell,       PASS2_FLAGS },
#endif  // #ifdef CFG_SHELL
#ifdef CFG_NUMLOCK
   { numlockstr,    do_numlock,     PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_NUMLOCK
#ifdef CFG_SET
   { "SET",         do_set,         PASS2_FLAGS },
#endif  // #ifdef CFG_SET
#ifdef CFG_DEVICEHIGH
   { "DEVICEHIGH",  do_devicehigh,  PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_DEVICEHIGH
#ifdef CFG_SEARCHES
   { "SEARCHES",    do_searches,    PASS2_FLAGS | CFG_UPPERCASE },
#endif  // #ifdef CFG_SEARCHES

#ifdef CFG_INSTALL
   { "INSTALL",     do_install,     PASS3_FLAGS },
#endif  // #ifdef CFG_INSTALL
#ifdef CFG_INSTALLHIGH
   { "INSTALLHIGH", do_installhigh, PASS3_FLAGS },
#endif  // #ifdef CFG_INSTALLHIGH

   { 0 }
};


struct config menu_items[] =
{
   { switchstr, 0, 0 },
#define CMD_SWITCHES 0
   { "INCLUDE", 0, 0 },
#define CMD_INCLUDE 1
   { "NEWFILE", 0, 0 }, // rd specific
#define  CMD_NEWFILE  2
   { "SUBMENU",      do_submenu,       1 },
   { "MENUITEM",     do_menuitem,      1 },
   { "MENUCOLOR",    do_menucolor,     1 },
   { "MENUDEFAULT",  do_menudefault,   1 },
#ifdef CFG_NUMLOCK
   { numlockstr,     do_numlock,       1 },
#define CMD_NUMLOCK 7
#endif  // #ifdef CFG_NUMLOCK
   { 0 }
};

#endif  // #ifdef CFG_PROCESSING
/*********************************************************

   Configuration load, unload, and special processing

**********************************************************/
#ifdef CFG_PROCESSING

/*
   Run Only On Bootup:

   Process the CONFIG.SYS file.
   Can add devices and modify various internal structure lists.

   Bypassing CONFIG.SYS:
   - Press & release F5 (configurable in sysgen),
      or hold down Shift key to skip
   - Press & release F8 (configurable in sysgen) to Ask on each line
*/
void configsys(int pass)
{
   extern char shell[128];       // 1st program run by ROM-DOS, ie COMMAND.COM
   extern unsigned cfg_seg;      // memory buffer
   extern unsigned cfg_position; // current position, 0xFFFF = eof
   extern int cfg_linenum;       // current line #

	extern char warn_bypass[];
   extern char warn_cmd[];
   extern int cfg_ask;
   extern int cfg_ask_line;

#ifdef CFG_BLOCKS
   char blockname[BLKNAMESIZE];
#endif // #ifdef CFG_BLOCKS
   char far * fpszLine;
   char far * fpszCommand;
   int iCmdNum;


#ifdef CFG_ASKS
   if(pass == PASS1)
   {
      /* check if user wants to bypass CONFIG.SYS */
      if( bypass_config() )
      {
bypass:
         printf(warn_bypass);
         goto config_done;
      }
   }
#endif  // #ifdef CFG_ASKS

   // don't process CONFIG.SYS if we couldn't read it
   if(!cfg_seg)
   {
#ifdef CFG_ASKS
      if(cfg_ask)
         goto ask_autoexec;
#endif  // #ifdef CFG_ASKS

      return;
   }

#ifdef CFG_BLOCKS
   if(pass == PASS1)
   {
      cfg_position = cfg_linenum = 0;

      /* present the menus */
      if(!process_menus(blockname))
         goto bypass;

      // Whether or not we have menus, we must
      // process the chosen blocks
      //
      process_blocks( blockname );
   }
#endif  // #ifdef CFG_BLOCKS

   cfg_position = cfg_linenum = 0;


   // This is the guts of the configsys file processing
   // Walk the whole file and do anything that matches this pass
   //
   while(1)
   {
      if( !getline( &fpszLine ) )
      {
         break;
      }
      ++cfg_linenum;

      /* skip TABs and SPACES */
      fpszCommand = fskipwhite( fpszLine );

      /* comment lines can begin with a ';', ignore them */
      if(*fpszCommand == ';')
         continue;

      /* ignore blank lines */
      if(*fpszCommand == 0)
         continue;

      // if at end of file, terminate processing
      if(*fpszCommand == 0x1A)
         break;

      /* find the command */
      iCmdNum = is_command( &fpszCommand, normal_items, FALSE );

      /* ignore lines that are for another pass through CONFIG */
      if(iCmdNum >= 0)
      {
         if(!((normal_items[iCmdNum].flags >> 4) & pass))
            continue;
      }
      else
      {
         /* didn't find a command, display offending line */
bad_cmd:
         printf( warn_cmd, fpszCommand, cfg_name, cfg_linenum );
         continue;
      }

      /* execute the command */
#ifdef CFG_ASKS
      // maybe ask [Y/N] and quit if no
      if( (cfg_ask_line || cfg_ask) && (ask( fpszLine ) <= 0) )
      {
         iCmdNum = 0;
      }
      else
#endif  // #ifdef CFG_ASKS
      {
         (*normal_items[iCmdNum].func)( fpszCommand );
      }

      // if the user pressed F5 when asked a Y/N question,
      // we just walk away and leave the rest undone
      //
#ifdef CFG_ASKS
      if( iCmdNum == 0 && skippingTheRest )
      {
         cfg_ask = FALSE;
         goto bypass;
      }
#endif  // #ifdef CFG_ASKS
      // if the last (attempted) command had an error that left error_no set
      //
      if(error_no)
      {
         error_no = 0;               // reset error_no
         goto bad_cmd;               // else bad command msg
      }
   }

#ifdef CFG_ASKS
ask_autoexec:
#endif  // #ifdef CFG_ASKS

   if(pass == PASS3)
   {
#ifdef CFG_ASKS
      if(cfg_ask)
      {
         if(ask((char far *)autoexec_msg))
            strcat(shell+2," /Y");   // ask during autoexec
         else
         {
config_done:
         strcat(shell+2," /D");      // disable autoexec
         }
      }
#endif  // #ifdef CFG_ASKS

      // free the memory used by CONFIG.SYS
      if(cfg_seg)
      {
         mem_free(cfg_seg);
      }
      cfg_seg = 0;
   }
}

int load_and_process_config(char far *fpszConfigName, unsigned uCfgPos)
{
   extern uchar mem_fit;
   extern unsigned cfg_seg;
   extern unsigned cfg_size;
   extern int error_no;
   extern char trydoshi;

   int nHandle;
   int iReturnValue;
   long lFileSize = 0l;
   char far *fpConfigBuf;
   bool bNewCfgSeg = cfg_seg == 0;
   bool bErrorCondition = FALSE;

   // only open the file if it exists
   //
   _asm  push  DS
   _asm  mov   AX, 6c00h      // DOS special open function
   _asm  mov   BX, 2000h      // open for read only
   _asm  mov   CX, 0000h      // attribute normal
   _asm  mov   DX, 1          // open if exist, fail if not
   _asm  lds   SI, dword ptr [fpszConfigName]
   _asm  int   21h
   _asm  pop   DS
   _asm  jc    open_failed    // nope, doesn't exist, don't do anything

   // save handle
   //
   _asm  mov   [nHandle], AX

   // see how big the file is
   //
   _asm  mov   AX, 4202h      // dos seek from end
   _asm  mov   BX, [nHandle]
   _asm  xor   CX, CX
   _asm  xor   DX, DX
   _asm  int   21h            // size returned in dx:ax
   _asm  mov   word ptr [lFileSize], AX
   _asm  mov   word ptr [lFileSize+2], DX

   // file is zero bytes in length, don't do anything
   if (lFileSize == 0l)
   {
 open_failed:
      bErrorCondition = TRUE;
   }

   if( !bErrorCondition)
   {
      // allocate memory if reading into the beginning of a segment
      //
      if( bNewCfgSeg )
      {
         // set allocation scheme to last fit
         //
         mem_fit = 2;

         // allocate a 16k + 2 block for config files
         //
         cfg_seg = mem_z_alloc( (unsigned)lFileSize+3, 0 );

         mem_fit = 0;

         if( error_no != ERR_NONE )
         {
            bErrorCondition = TRUE;
         }
      }
   }

   /*
    * The amount of data to read is based upon the amount of space
    * left in the buffer.  In the case of a buffer being read from
    * position 0, the entire buffer is available.  If being read
    * from position > 0, subtract that position from the maximum
    * size to get the maximum amount of remaining data.
    */

   if( !bErrorCondition)
   {
      if (lFileSize > (0x4000 - uCfgPos))
      {
         lFileSize = 0x4000 - uCfgPos;
      }

      // set the new size of the config, including the two ending bytes
      //
      cfg_size = (unsigned)lFileSize + uCfgPos + 2;

      // move back to the beginning of the config file
      //
      _asm  mov   AX, 4200h      // dos seek from beginning
      _asm  mov   BX, [nHandle]
      _asm  xor   CX, CX
      _asm  xor   DX, DX
      _asm  int   21h            // size returned in dx:ax

      // setup a pointer to the buffer and put a 0x001a (null & <eof>)
      // signature at the end of the buffer
      //
      fpConfigBuf = MK_FP(cfg_seg, 0);
      fpConfigBuf += cfg_size-2;
      *fpConfigBuf++ = 0x00;
      *fpConfigBuf++ = 0x00;
      *fpConfigBuf   = 0x1A;

      // read the file
      //
      _asm  push  DS
      _asm  mov   AH, 3FH
      _asm  mov   BX, [nHandle]
      _asm  mov   CX, [cfg_size]
      _asm  mov   DS, [cfg_seg]
      _asm  mov   DX, [uCfgPos]
      _asm  int   21h
      _asm  pop   DS
      _asm  jnc   read_success

 // read_failed

   bErrorCondition = TRUE;

 read_success:

      // close the file
      //
      _asm  mov   ah, 3eh
      _asm  int   21h

   }

   if( bErrorCondition )
   {
      if( bNewCfgSeg )
      {
         if( cfg_seg != 0 )
         {
            // The error was with the file read, free our segment
            mem_free(cfg_seg);
         }
         cfg_seg = 0;
         cfg_size = 0;
      }
      iReturnValue = 0;
   }
   else
   {
      // now process the file and convert /r/n (0x0d,0x0a) to (0x20,0x00)
      // we will stop when we find the 0x1a

      fpConfigBuf = MK_FP(cfg_seg, 0);

      while (*fpConfigBuf != 0x1a)
      {
         if (*fpConfigBuf == '\r')
         {
            *(int far *)fpConfigBuf = 0x0000;   // (0x00, 0x00)
            fpConfigBuf++;
         }
         fpConfigBuf++;
      }

      iReturnValue = cfg_size;
   }

   return iReturnValue;
}


// Menus are only valid in the root CONFIG.SYS, so this function
//   will only be called from there
//
void process_blocks( char far *fpPickedBlock )
{
   extern unsigned cfg_seg;         // memory buffer
   extern unsigned cfg_position;    // current position, 0xFFFF = eof
   extern uchar mem_fit;
   extern int error_no;
   char far * fpszLine;

   // set allocation scheme to last fit
   //
   mem_fit = 2;

   // allocate a new 16k + 2 block for the results of processing
   //
   uMenuSeg = mem_z_alloc(0x4002, 0);
   mem_fit = 0;

   if( error_no != ERR_NONE )
   {
      // We didn't change cfg_seg, so quickly exit
      //
      return;
   }

   // Start at the beginning of the new segment
   //
   uMenuPosition = 0;

   // reprocess the config.sys, removing menus and includes
   //
   reprocess_blocks( fpPickedBlock, TRUE, uMenuPosition );

   // tack on a new 0x001A
   fpszLine = MK_FP( uMenuSeg, uMenuPosition++ );
   *fpszLine = 0x1A;

   // free the old segment
   //
   mem_free(cfg_seg);

   // Now point the old variables at the new locations
   //
   cfg_seg = uMenuSeg;
   cfg_position = uMenuPosition;
}


void reprocess_blocks( char far *fpPickedBlock, bool bStartOK, unsigned uStart )
{
   extern unsigned cfg_seg;         // memory buffer
   extern unsigned cfg_position;    // current position, 0xFFFF = eof
   extern int cfg_linenum;          // current line #

   extern char warn_bad[];
   extern char warn_newfile[];
   extern char warn_cmd[];
	extern char common_str[];

   // set local to top_of_segment
   //
   unsigned uSavedCfgSeg = cfg_seg;
   unsigned uSavedPosition = cfg_position;
   unsigned uSavedLineNum = cfg_linenum;
   int iLineLen, iNewCfgSize;
   bool bInOKBlock = FALSE;
   char far * fpszLine;
   char far * fpszTargetLine;
   char far * fpszCommand;
   char far * fpszCommandMenu;
   int iCmdNum;

   // At the root level, we start in an OK block
   // Within an INCLUDE= reprocessing, only the include block is OK
   //
   if( bStartOK )
   {
      bInOKBlock = TRUE;
   }

   cfg_position = uStart;
   cfg_linenum = 0;

   while( cfg_position != 0xFFFF )
   {
      // read each line of the config
      //
      if( !getline( &fpszLine ) )
         break;
      cfg_linenum++;

      fpszCommand = fskipwhite( fpszLine );

      /* comment lines can begin with a ';', ignore them */
      if(*fpszCommand == ';')
         continue;

      /* ignore blank lines */
      if(*fpszCommand == 0)
         continue;

      // if at end of file, terminate processing
      if(*fpszCommand == 0x1A)
         break;

      // if we are within a menu-style block
      //
      if( *fpszCommand == '[' )
      {
         if( is_block( fpszCommand+1, fpPickedBlock ) )
         {
            bInOKBlock = TRUE;
         }
         else if(    bStartOK
                  && is_block( fpszCommand+1, (char far *)common_str ) )
         {
            bInOKBlock = TRUE;
         }
         else
         {
            bInOKBlock = FALSE;
         }
      }
      else if( (*fpszCommand) && (bInOKBlock) )
      {
         fpszCommandMenu = fpszCommand;
         // Get the "command" from the line
         //
         iCmdNum = is_command( &fpszCommandMenu, menu_items, FALSE );

#ifdef CFG_INCLUDE
         if( iCmdNum == CMD_INCLUDE )
         {
            // We have an INCLUDE=; fpszCommand points at the parameter
            //
            fpszCommand = fskipwhite( fpszCommandMenu );

            // We Process each INCLUDE= line one time only
            // to prevent a loop -- change them into comments
            //
            *fpszLine = ';';

            reprocess_blocks( fpszCommand, FALSE, 0 );
         }
         else
#endif  // #ifdef CFG_INCLUDE

#ifdef CFG_NEWFILE
         if( iCmdNum == CMD_NEWFILE )
         {
            // If it's a NEWFILE= command, this is the appropriate time
            //
            fpszCommand = fskipwhite( fpszCommandMenu );
            fpszTargetLine = fpszCommand;

            while( fpszTargetLine && *fpszTargetLine )
            {
               if( *fpszTargetLine == ',' )
               {
                  fpszTargetLine = 0;
                  ucSpecialNewFile = 1;
               }
               else
               {
                  fpszTargetLine++;
               }
            }
            if( fpszTargetLine )
            {
               // load_and_process_config() will read into cfg_seg,
               // so give set it up to use our new segment, uMenuSeg
               //
               uSavedCfgSeg = cfg_seg;
               cfg_seg = uMenuSeg;

               iNewCfgSize = load_and_process_config( fpszCommand, uMenuPosition );

               if( iNewCfgSize )
               {
                  // no error? Verify the contents and then exit this function
                  //
                  // CFG_NAME = fpszCommand
                  //
                  reprocess_blocks( fpPickedBlock, FALSE, uMenuPosition );
                  uMenuPosition = iNewCfgSize - 1;

                  // CFG_NAME = old cfg_name
                  //
                  cfg_seg = uSavedCfgSeg;

                  // jump out of here
                  return;
               }
               else
               {
                  // otherwise we couldn't read the file, so report an error
                  // and continue processing within this function
                  //
                  printf( warn_bad, warn_newfile, fpszCommand );

                  cfg_seg = uSavedCfgSeg;

                  // by definition, NEWFILE ends this config.sys
                  //
                  cfg_position = 0xFFFF;

               }
               // any error reading newfile has been reported, so reset flag
               //
               error_no = 0;               // reset error_no
            }
            else
            {
               // this NEWFILE has a comma, so copy for later processing
               // however, any NEWFILE ends this config.sys
               //
               iLineLen = fstrlen( fpszLine )+2;

               fpszTargetLine = MK_FP( uMenuSeg, uMenuPosition );

               if (iLineLen > (0x4000 - uMenuPosition))
               {
                  iLineLen = 0x4000 - uMenuPosition;
               }

               fmemcpy( fpszTargetLine, fpszLine, iLineLen );
               uMenuPosition += (unsigned)iLineLen;

               cfg_position = 0xFFFF;
            }
         }
         else
#endif  // #ifdef CFG_NEWFILE

         if( iCmdNum == -1)
         {
            // it's not a menu command, check for a normal command
            //
            iLineLen = fstrlen( fpszLine )+2;

            iCmdNum = is_command( &fpszCommand, normal_items, FALSE );

            if( iCmdNum >= 0 )
            {
               fpszTargetLine = MK_FP( uMenuSeg, uMenuPosition );

               if (iLineLen > (0x4000 - uMenuPosition))
               {
                  iLineLen = 0x4000 - uMenuPosition;
               }

               fmemcpy( fpszTargetLine, fpszLine, iLineLen );
               uMenuPosition += (unsigned)iLineLen;
            }
            else
            {
               // Report erroneous command + line number
               //
               // WARNING: appears cfg_name is always "config.sys"
               //
               printf( warn_cmd, fpszLine, cfg_name, cfg_linenum );
            }
         }
      }
   }

   cfg_position = uSavedPosition;
   cfg_linenum = uSavedLineNum;
}


#endif  // #ifdef CFG_PROCESSING
/*********************************************************

   Configuration helper routines

**********************************************************/
#ifdef CFG_PROCESSING

#ifdef CFG_ASKS
/*
   Run Only On Bootup:

   Ask a yes/no/"get hosed" question.
   Returns TRUE if yes, FALSE if no, -1 if F5 was pressed.

*/
int ask(char far *prompt)
{
   extern char ask_string[];
   int c, result;

   extern int F5_bypass;               // this is stored in SYSGEN

   // validate pointer
   ASSERT(prompt);

   printf(ask_string,prompt);
   c = getyesno();

#ifdef CFG_BLOCKS
   if( c == F5_bypass )
   {
      c               = '\r';
      result          = -1;
      skippingTheRest = TRUE;
   }
   else
#endif  // #ifdef CFG_BLOCKS
   {
      c      &= 0xFF;
      result  = (c == 'Y');
   }

   printf("%c\n",c);
   return result;
}
#endif  // #ifdef CFG_ASKS

/*
   Run Only On Bootup:

   This routine gets a number and ensures that it is
   between the minimum and maximum values.
*/
int PASCAL minmax(char far *parms, int min, int max)
{
   int num;

   // validate pointer
   ASSERT(parms);
   ASSERT(min <= max);

   // get the number
   num = fatoi( fskipwhite( parms ) );

   // keep it in bounds
   if(num < min)
      num = min;
   if(num > max)
      num = max;

   // return the number
   return num;
}


/*
   Run Only On Bootup:

   Get a line for CONFIG.SYS processing.
*/
bool PASCAL getline(char far **line)
{
   extern unsigned cfg_seg;         // memory buffer
   extern unsigned cfg_position;    // current position, 0xFFFF = eof
   extern int cfg_linenum;          // current line #

   char far * p;

   // validate pointer
   ASSERT(line);

   // at end of file
   if(!cfg_seg || cfg_position == 0xFFFF)
      return FALSE;

   // determine start for line
   p = MK_FP(cfg_seg, cfg_position);

   // line is returned regardless
   //
   *line = MK_FP( cfg_seg, cfg_position );

   // walk the line until we get to the null,null or Ctrl-Z
   //
   while(1)
   {
      if( *p == ctrl('Z') ) break;
      if( *p == 0 ) break;

      cfg_position++;
      p++;
   }

   if(*p == ctrl('Z'))
   {
      // update pointer flag for next time EOF
      //
      cfg_position = 0xFFFF;
   }
   else
   {
      // step past the terminating null
      //
      cfg_position+=2;
   }

   return TRUE;
}

/*
   Returns the item in the "config" array (0-n) or -1 if the
   command is not found.  Skips past the cmd string and all
   the equals if found.
   Example:

   DEVICE  = == HELLO.EXE

   would skip past everything until the "HELLO"
*/
int is_command(char far **cmd, struct config *cp, bool bUpperMenuOption)
{
   extern int cfg_ask_line;

   char c, oldc;
   char cmdstr[12];               // for the longest command
   int i;
   int cmdnum;
   char far * parms;
   unsigned len;

   ASSERT(cp);
   ASSERT(cmd && *cmd);

#ifdef CFG_ASKS
   // each line might have an "ask me" request [Y/N]?
   cfg_ask_line = FALSE;
#endif  // #ifdef CFG_ASKS

   /* copy the command into cmdstr, and ASCIIZ the cmdstr */
   for(i=0; i<(sizeof(cmdstr)-1); ++i)
   {
      c = **cmd;
      if(c <= ' ' || c == '=')
         break;
#ifdef CFG_ASKS
      if(c == '?')
         break;
#endif  // #ifdef CFG_ASKS
      cmdstr[i]= c;

      // on to next character
      ++(*cmd);
   }
   cmdstr[i] = 0;
   strupr(cmdstr);

   // find the command
   cmdnum = -1;
   for(i=0; cp[i].command; ++i)
      if(memcmp(cmdstr,cp[i].command,strlen(cp[i].command)+1) == 0)
      {
         cmdnum = i;
         break;
      }

   // find the beginning of the args (skip all ='s and whitespace's)
   parms = *cmd;
   while(1)
   {
      parms = fskipwhite(parms);

#ifdef CFG_ASKS
      // does user want to get asked for this line?
      if(!cfg_ask_line && *parms == '?')
      {
         cfg_ask_line = TRUE;

         // We used to remove the '?', but in the rewrite
         // we don't want to mess up the memory data
         //
         // fmemmove(parms,parms+1,fstrlen(parms));   // extract the '?'
         ++parms;
      }
      else
#endif  // #ifdef CFG_ASKS
      if(*parms == '=')
         ++parms;      // skip past the equals sign

      else
         break;      // all done
   }

   if( bUpperMenuOption )
   {
      oldc = make_fname( parms );  // just looking for block, remove description

      len = fstrlen( parms );
      uppercase( parms, (int)len );

      parms[len] = oldc;
   }
   else
   {
      // some commands need UPPERCASE args
      if(cmdnum>=0 && (cp[cmdnum].flags & 1))
      {
         uppercase( parms, -1 );
      }
   }

   *cmd = parms;
   return cmdnum;
}

/*
   Run Only On Bootup:

   make a 0-terminated filename out of a string with
   filename and parameters.  Returns the character it
   replaced with the 0.  Will turn "X.SYS arg" into
   "X.SYS\0arg".
*/
char make_fname(char far *parms)
{
   char far *p;
   char oldc;

   // validate pointer
   ASSERT(parms);

   for(p = parms; *p>' ' && *p!=','; ++p)
      /* we are finding a place */;
   oldc = *p;
   *p = 0;
   return oldc;
}

/*
   Run Only On Bootup:

   Does the name match the Block name in the CONFIG.SYS
   line?  Returns TRUE if match, FALSE if not.
*/
int  is_block(char far *line, char far *name)
{
   extern char * terminators;
   unsigned len;
   char tmpname[BLKNAMESIZE];
   char oldc;

   // validate pointers
   ASSERT(line);

   if( !name )
   {
      return FALSE;
   }

   oldc = make_fname(name);   // just looking for block, remove args

   // no block name, give up
   len = fstrlen(name);
   name[len]=oldc;            // reattach args

   if(!len)
      return FALSE;

   // match the name (must end in a terminator)
   line = fskipwhite(line);

   fmemcpy( (char far *)tmpname, line, len );
   tmpname[len] = 0;                      // and null terminate
   strupr( tmpname );
   return (   (fmemcmp((char far *)tmpname,name,len)==0)
           && strchr(terminators,line[len]));
}

#endif  // #ifdef CFG_PROCESSING

/*********************************************************

   Configuration routines for handling menus

**********************************************************/
#ifdef CFG_PROCESSING
#ifdef CFG_MENUS

#define MENUITEM   0
#define SUBMENU   1

#define TITLEROW   1
#define TITLECOL   2
#define MENUROW   (TITLEROW+2)
#define MENUCOL   TITLECOL
// moved to SYSGEN  #define CONFIRM_ROW   24
#define CONFIRM_COL   0
#define CHOICE_ROW   1
// moved to SYSGEN  #define TIMEROW   TITLEROW
// moved to SYSGEN  #define TIMECOL   40

#define UPARROW   0x4800
#define UPCURSOR  0x48E0
#define DNARROW   0x5000
#define DNCURSOR  0x50E0

struct menu
{
   unsigned pos;        // position in CONFIG.SYS
   unsigned pos2;       // position of menu itself
   char type;           // MENUITEM or SUBMENU
};

// used for both "Starting ROM-DOS..." message, and to wait for a key
// in a MENU, definable by MENUDEFAULT.  (0=wait forever in menu)
extern int cfg_seconds;

char cfg_color = 7;                 // MENUCOLOR, what color? (0 = tty)
extern unsigned cfg_default;        // MENUDEFAULT, points to menu name
extern int cfg_num_menus;           // # of menus (up to 9)
extern struct menu * cfg_menuptr;   // ptr to up to 9 menuitems
extern int cfg_nobypass;            // don't allow bypass at all

/*
   Run Only On Bootup:

   Check CONFIG.SYS for menus.  If menus are found, then
   present them to the user and decide which one is it.

   There are effectively 2 kinds of Blocks: Menu Blocks
   and Configuration Blocks.  The Menu Blocks contain
   commands like "menuitem", "submenu" and so on.  The
   Configuration Blocks contain all the normal CONFIG.SYS
   stuff.

   The user eventually picks one of the Configuration (not
   Menu) Blocks, or says to bypass CONFIG.SYS.

   Returns false if we should NOT process CONFIG.SYS.
*/
int process_menus(char *picked_block)
{
   extern char menu_str[];
   extern char config_str[];           // used as a buffer to read lines
   extern char warn_cmd[];
   extern char cfg_name[];
   extern int cfg_ask;
   extern unsigned cfg_position;
   extern char title_msg[];
   extern char choice_msg[];
   extern char confirm_msg[];
   extern int error_no;
   extern unsigned cfg_menupos;        // set by caller

   extern char confirm_row;            // these are stored in SYSGEN
   extern char time_row;
   extern char time_col;
   extern int F5_bypass;
   extern int F8_confirm;

   char menuline[80];
   static char number[] = "1\010";   // # + backspace
   char far * line;
   struct menu menuitems[9];         // 1 - 9 possible items
   int item;
   int c;
   char far * cmd;
   int linenum;
   int len;
   int worked = TRUE;
   int choicerow;               // the row for waiting

   // validate pointer
   ASSERT(picked_block);

   // are there any menus at all?
   *picked_block = 0;
   if((linenum = find_block(menu_str,TRUE)) == 0)     // sets cfg_position
      return worked;

   // get a menu from the user
   while(1)
   {
      // find all MENUITEMs and SUBMENUs
      cfg_menuptr = menuitems;
      cfg_num_menus = 0;
      while(1)
      {
         cfg_menupos = cfg_position;
         if(!getline(&line))
            break;

         ++linenum;

         // if we hit a '[', we are done with this Menu Block
         cmd = fskipwhite(line);
         if(*cmd == '[')
            break;

         // comments
         if(*cmd == ';' || *cmd == 0)
            continue;

         /* didn't find a command, display offending line */
         item = is_command( &cmd, menu_items, TRUE );
         if( item < 0 )
         {
error:
            printf(warn_cmd, line, cfg_name, linenum);
            waitforkey();
         }
         else
         {
            cfg_menupos += (int)(cmd - line);
            error_no = 0;
            (*menu_items[item].func)(cmd);
            if(error_no)
            {
               error_no = 0;
               goto error;
            }
         }
      }

      // NO Block was chosen
      if(!cfg_num_menus)
      {
         *picked_block = 0;
         return worked;
      }

      // "ROM-DOS Startup Menu" or equivalent message
      if(cfg_color)
      {
         clear_screen(0);
         set_cursor(TITLEROW, TITLECOL);
      }
      printf(title_msg);
      printf("\n");

      // print each menu item
      for(item=0; item<cfg_num_menus; ++item)
      {
         //   menuline;
         //
         // "line" at this point is just a workspace
         // menu items are stored in the "menuitems" array
         //
         if(cfg_color)
            set_cursor(MENUROW+item, MENUCOL);
         memmove(menuline,"1.  ",4);
         *menuline = item+'1';
         get_title(menuline+4, menuitems[item].pos);
         strcat(menuline,"\n");   // in case of tty
         printf(menuline);
      }
      choicerow = MENUROW+cfg_num_menus+CHOICE_ROW;

      // F5=Bypass Startup Files    F8=Confirm each CONFIG line [N]
      if(cfg_color && !cfg_nobypass && (confirm_row != (char)0xFF))
      {
         set_cursor((int)confirm_row, CONFIRM_COL);
         printf(confirm_msg);
      }
      set_cursor(choicerow, MENUCOL);
      printf(choice_msg);

      // determine default item
      for(item=0; item<cfg_num_menus; ++item)
         if(cfg_default == menuitems[item].pos2)
            break;
      if(item >= cfg_num_menus)
         item = 0;

      // get keys until the user chooses something
      while(1)
      {
         // display current "ask" value, F8 [N]
         if(cfg_color && !cfg_nobypass && (confirm_row != (char)0xFF))
         {
            set_cursor((int)confirm_row,CONFIRM_COL+strlen(confirm_msg)-2);
            printf("%c", cfg_ask ? 'Y' : 'N');
         }
         set_cursor(choicerow,MENUCOL+strlen(choice_msg));

         // display the current number
         *number = item + '1';
         printf(number);

         // do what the user says to do
         c = menu_getkey();

         if( c == F5_bypass )
         {
            if(!cfg_nobypass)
            {
               worked = FALSE;
            }
            goto done;
         }
         else if( c == F8_confirm )
         {
            if(!cfg_nobypass)
            {
               cfg_ask = !cfg_ask;
            }
         }
         else
         {
            switch(c)
            {
               case UPARROW:
               case UPCURSOR:
                  if(item > 0) --item; break;
               case DNARROW:
               case DNCURSOR:
                  if(item+1 < cfg_num_menus) ++item; break;
               default:
                  c &= 0xFF;
                  if(c >= '1' && c <= '0'+cfg_num_menus)
                     item = c-'1';
                  break;
            }
         }
         if(c == CR)
            break;
      }

      // extract the new menu name
      cfg_position = menuitems[item].pos;
      getline(&line);
      c = make_fname(line);

      len = fstrlen(line);
      uppercase( line, (int)len );

      fmemcpy( (char far *)picked_block, line, len+1 );

      // found a menu!  use it
      if(menuitems[item].type == MENUITEM)
         break;

      // go to the submenu
      linenum = find_block((char far *)picked_block, FALSE);
   }

#ifdef CFG_SET
   // set the "CONFIG=" in the environment
   cfg_position = menuitems[item].pos;
   getline(&line);
   make_fname(line);                   // Menu_Name

   cmd = strchr(cfg_name, '.');
   len = (cmd ? (int)(cmd - cfg_name) : strlen(cfg_name));

   // make room for cfgname
   //
   fmemcpy( (char far *)menuline+len+1, line, fstrlen(line)+1 );

   memmove(menuline, cfg_name, len);
   menuline[len] = '=';                // CONFIG=Menu_Name

   do_set((char far *)menuline);
#endif  // #ifdef CFG_SET

done:

   // got our menu, clear the rest of the screen
   if(cfg_color)
      clear_screen(choicerow+1);

   // menus processed OK
   return worked;
}

/*
   Wait for a key from the menu.  May have a timer on it.
*/
int menu_getkey(void)
{
   extern uchar seconds;
   extern char time_msg[];

   extern int user_F5;                // these are stored in SYSGEN
   extern int user_F8;
   extern char time_row;
   extern char time_col;

   int c;
   int i;
   uchar oldsecs;

   // at menu prompt. just wait for a key.
   if(cfg_seconds <= 0)
      c = con_getkey();

   // do the count-down thing
   else
   {
      // display the "Time remaining..." message
      if(cfg_color)
      {
         set_cursor((int)time_row, (int)time_col);
         printf(time_msg);
      }

      // get current time into SDA
      touch_time(TM_READ);
      oldsecs = 70;      // set to any illegal # of seconds (not 0-59)

      // we'll be decrementing cfg_seconds, so inflate it here
      ++cfg_seconds;

      // look for keys
      do
      {
         c = con_chkkey();
         if(c == -1)
         {
            touch_time(TM_READ);         // Read the time into globals
            if(oldsecs != seconds)
            {
               --cfg_seconds;
               if(cfg_color)
               {
                  set_cursor((int)time_row, (int)time_col + strlen(time_msg));
                  printf("%d ",cfg_seconds);
               }
               if(cfg_seconds == 0)
                  c = CR;            // inaction means do default
            }
            oldsecs = seconds;
         }

         // user pressed a key, delete time message
         else
         {
            cfg_seconds = 0;
            if(cfg_color)
            {
               set_cursor((int)time_row, (int)time_col);
               for(i=strlen(time_msg)+4; i>=0; --i)
                  printf(" ");
            }
         }
      } while(c == -1);
   }
   return c;
}

void waitforkey(void)
{
   extern char wait_msg[];
   printf(wait_msg);
   con_getkey();
   printf("\n");
}

/*
   Extract the title from CONFIG.SYS file given the
   position of the "parms" of a menuitem line.

   MENUITEM=ABC         will extract "ABC"
   MENUITEM=XYZ, Text   will extract "Text"
*/
void get_title( char * menuline, unsigned pos )
{
   extern unsigned cfg_position;

   char far * line;
   char * szMenuTitle;

   // validate pointer
   ASSERT(menuline);

   cfg_position = pos;

   // this "line" is where we get the values
   //
   getline( &line );
   fmemcpy( (char far *)menuline, line, fstrlen( line )+1 );

   // and here is where we store them - returned in "line"
   //
   szMenuTitle = skipwhite( strchr( menuline, ',' )+1 );
   if( szMenuTitle )
   {
      memmove( menuline, szMenuTitle, strlen(szMenuTitle)+1 );
   }
}

/*
   Run Only On Bootup:

   Look through CONFIG.SYS for the given block name.

   Returns the line # and set cfg_position if found.
   Returns 0 (with cfg_position unchanged) if not.
*/
int find_block(char far *name, bool fProcessNumLock)
{
   extern unsigned cfg_position;

   unsigned oldpos = cfg_position;
   char far * line;
   int linenum = 0;
   char far * cmd;
   char c;
   int found;
   int item;

   // validate pointer
   ASSERT(name);

   // save the name string
   c = make_fname(name);

   // look for the block [name]
   found = cfg_position = 0;
   while(getline(&line))
   {
      ++linenum;

      cmd = fskipwhite(line);

      if(*cmd == '[')
      {
         // once we see "menu" blocks, process no more numlocks
         //
         fProcessNumLock = FALSE;

         if( is_block(cmd+1, name) )
         {
            found = 1;
            break;
         }
      }
      else if( fProcessNumLock )
      {
         // is this a numlock command?
         item = is_command( &cmd, menu_items, TRUE );
         if( item == CMD_NUMLOCK )
         {
            do_numlock( cmd );
         }
      }
   }

   // reset the name
   name[fstrlen(name)] = c;

   // we found it!
   if(found)
      return linenum;

   // not found, go back to where we were
   cfg_position = oldpos;
   return 0;
}

/*
   Run Only On Bootup:

   Add this menu item to the current list.
*/
void do_menuitem(char far *parms)
{
   // validate pointer
   ASSERT(parms);

   if(cfg_num_menus >= 9)
      return;

   if(founditem(parms))
   {
      cfg_menuptr->type = MENUITEM;
      ++cfg_menuptr;
   }
}

/*
   Run Only On Bootup:

   Set the menu color.  Makes it look pretty.

   Syntax: menucolor = fg[,bg]
   fg = foreground color (0-15)
   bg = background color (0-7)
*/
void do_menucolor(char far *parms)
{
   char c;
   char menuline[80];
   char *szBackground = NULL;

   // validate pointer
   ASSERT(parms);

   // check for foreground color
   //
   c = minmax(parms, 0, 15);
   cfg_color = (cfg_color & 0xF0) + c;

   // get a local copy for strchr
   //
   fmemcpy( (char far *)menuline, parms, fstrlen( parms )+1 );
   szBackground = skipwhite( strchr( menuline, ',' ) );

   if(szBackground)
   {
      c = minmax( (char far *)szBackground+1, 0, 7 );
      cfg_color = (cfg_color & 0x0F) + (c<<4);
   }
}

/*
   Run Only On Bootup:

   Menuitem 1. is the normal default.  Allow user to
   change this.  Default menu is specified by name.
   Example:
         MENUDEFAULT=Windows,10
*/
void do_menudefault(char far *parms)
{
   extern unsigned cfg_position;
   unsigned oldpos;
   char menuline[80];
   char *szMenuTimeout = NULL;

   // validate pointer
   ASSERT(parms);

   // remember the way things were
   oldpos = cfg_position;
   if(find_block(parms, FALSE))
      cfg_default = cfg_position;
   cfg_position = oldpos;

   // cfg_seconds should already be -1, from the assembly routine
   // bypass_config(). -1 means wait for a key.

   // get a local copy for strchr
   //
   fmemcpy( (char far *)menuline, parms, fstrlen(parms)+1 );

   // only set timeout if user actually put a number there.
   // user MAY have said MENUDEFAULT x,  with no number.
   //
   szMenuTimeout = skipwhite( strchr( menuline, ',' ) );

   if(szMenuTimeout)
   {
      // up to 90 secs
      //
      cfg_seconds = minmax( (char far *)szMenuTimeout+1, 0, 90 );
   }
}

/*
   Run Only On Bootup:

   Menus can be nested any number of levels deep.  This
   command says that the given menuitem is really a
   submenu.
   Example:
      SUBMENU=SubMenuName,Text for Menu
*/
void do_submenu(char far *parms)
{
   // validate pointer
   ASSERT(parms);

   if(cfg_num_menus >= 9)
      return;

   if(founditem(parms))
   {
      cfg_menuptr->type = SUBMENU;
      ++cfg_menuptr;
   }
}

/*
   Look for a MENUITEM or SUBMENU.
   Returns TRUE if found, FALSE if not.
*/
int founditem(char far *parms)
{
   extern unsigned cfg_position;
   extern unsigned cfg_menupos;        // set by caller
   extern int error_no;

   unsigned oldpos;
   int found = FALSE;

   // validate pointer
   ASSERT(parms);

   // remember the way things were
   oldpos = cfg_position;

   // does the block exist?
   if(find_block(parms, FALSE))
   {
      cfg_menuptr->pos  = cfg_menupos;
      cfg_menuptr->pos2 = cfg_position;
      ++cfg_num_menus;

      ++found;      // found=TRUE
   }
   else
      error_no = 1;

   // don't lose our place
   cfg_position = oldpos;
   return found;
}

#endif  // #ifdef CFG_MENUS
#endif  // #ifdef CFG_PROCESSING
/*********************************************************

   Configuration routines for any and all circumstances

**********************************************************/
#ifdef CFG_PROCESSING


#ifdef CFG_REM
/*
   Run Only On Bootup:

   Just a remark, do nothing.
*/
#pragma argsused                 // disable a warning message
void   do_rem(char far *parms)
{
   // validate pointer
   ASSERT(parms);
}
#endif  // #ifdef CFG_REM


/*
   Run Only On Bootup:

   Set a number of DOS options
   /F      Fast startup - don't wait for user key
   /K      Use standard keyboard calls, not extended
   /N      Don't allow F5 or F8 to bypass CONFIG.SYS
*/
void process_switches( void )
{
#ifdef CFG_SWITCHES

   char far * line;
   char far * cmd;
   int item;

   while( getline( &line ) )
   {
      // comments
      cmd = fskipwhite( line );

      // is this the switches command?
      item = is_command( &cmd, menu_items, TRUE );
      if( item == CMD_SWITCHES )
         set_switches( cmd );
   }
#endif  // #ifdef CFG_SWITCHES
}

#ifdef CFG_SWITCHES

// Helper routine for do_switches
//
void set_switches(char far *parms)
{
   extern uchar switch_char;

   // validate pointer
   ASSERT(parms);

   cfg_seconds = 3;
   while(*parms)
   {
      parms = fskipwhite(parms);

      if(*parms == switch_char)
      {
         switch(*parms)
         {
            // Don't allow F5 or F8 to bypass CONFIG.SYS
            //
            case 'N':
               cfg_nobypass = TRUE; // fall thru...

            // Fast startup - don't wait for user key
            //
            case 'F':
               cfg_seconds = 0;

               parms++;
               break;

            // Use standard keyboard calls, not extended
            //
            case 'K':
               disable_extended();

               parms++;
               break;

            // We didn't get a recognizable value -- don't increment either.
            //
            default :
               ;
         }
      }
      // whether or not it was a switch char, move on
      //
      parms++;
   }
}
#endif  // #ifdef CFG_SWITCHES

#ifdef CFG_BREAK
/*
   Run Only On Bootup:

   Set BREAK to ON or OFF.  This allows a user to break out
   of any DOS call, not just character i/o calls.
*/
void   do_break(char far *parms)
{
   extern uchar BREAK_FLAG;

   ASSERT(parms);

   BREAK_FLAG = FALSE;
   if(fmemcmp(parms,"ON",2) == 0)
      BREAK_FLAG = TRUE;
}
#endif  // #ifdef CFG_BREAK

#ifdef CFG_BUFFERS
/*
   Run Only On Bootup:

   Allocate a certain # of buffers for use by the file
   system.  There is a hardcoded minimum set in DOSDEF.H
*/
void   do_buffers(char far *parms)
{
   extern struct LOL lol;
   extern int   init_buffers;

   // validate pointer
   ASSERT(parms);

   init_buffers = lol.numbufs = minmax(parms, lol.numbufs, MAXBUF);
}
#endif  // #ifdef CFG_BUFFERS

#ifdef CFG_COUNTRY
/*
   Run Only On Bootup:

   Install new country information.  This routine cheats by
   simply installing a device that will do the necessary
   DOS calls.
*/
void   do_country(char far *parms)
{
   /*
      [ locals ]
   */
   extern char country_buff[66];
   static char defname[] = "COUNTRY.SYS ";

   /*
      [ code ]
   */
   // validate pointer
   ASSERT(parms);

   memmove(country_buff,defname,sizeof(defname));
   fmemcpy( (char far *)country_buff+sizeof(defname)-1, parms, fstrlen(parms)+1 );

   do_device( (char far *)country_buff );
}
#endif  // #ifdef CFG_COUNTRY

#ifdef CFG_DEVICE OR CFG_COUNTRY
/*
   Run Only On Bootup:

   Install a disk or character device from CONFIG.SYS.  The
   parms string starts on the device name.  For example:
      "DEVICE = FNAME.SYS /b0=1"
                ^
   The ending of the string must be exact, as some devices
   don't parse very intelligently.
*/
void  do_device(char far *parms)
{
   /*
      [ externals ]
   */
   extern char warn_bad[];
   extern char warn_device[];
#ifndef CONFIG_UNIT_TEST
   extern char sda_ename1[];
#endif
   extern int error_no;
   extern uchar mem_fit;

   extern unsigned dos5_flags;
   extern char trydoshi;
   extern unsigned hma_used;
   extern unsigned codeparas;
   extern unsigned bufparas;

   /*
      [ locals ]
   */
   char oldc;
   unsigned uSegment;
   int iParmLength;
   int iProgLength;

   /*
      [ code ]
   */

   // validate pointer
   ASSERT(parms);

   // Check the length so we have a space to put the 0x0D0A or 0x200A
   //
   iParmLength = fstrlen(parms)+2;

   // Now separate the "device" from it's parameters
   //
   oldc = make_fname(parms);
   iProgLength = fstrlen(parms);

   /* load the device into memory */
   uSegment = load_device(parms);
   if(uSegment == 0xFFFF && mem_fit)
   {
      mem_fit = MEM_FIRST;
      uSegment = load_device(parms);
   }

   iProgLength = fstrlen(parms);
   parms[iProgLength] = oldc;

   /* if we couldn't load it, tell user so */
   if(uSegment == 0xFFFF)
   {
      printf(warn_bad,warn_device,parms);
#ifdef CFG_NEWFILE
      ucNewFileError = 1;
#endif // #ifdef CFG_NEWFILE
   }
   else
   {
      // If the device had no parameters, the length of just the device
      // string will be a fixed size smaller than the original string
      //
      //   A device with no parameters is terminated by ' '\n
      //   The parameter string of a device with parms ends in \r\n
      //
      parms[iParmLength-1]='\n';
      if( iParmLength > iProgLength + 2 )
      {
         parms[iParmLength-2]='\r';
      }
      else
      {
         parms[iParmLength-2]=' ';
      }

#ifndef CONFIG_UNIT_TEST
      /* set initial ID and name fields for system MCB */
      ((struct MCB far *)MK_FP(uSegment-1,0))->init_id = 'D';
      fmemcpy(MK_FP(uSegment-1,8), (void far *)sda_ename1, 8);
#endif

      /* initialize the device driver */
      dev_init(MK_FP(uSegment,0), parms );

      if(trydoshi && !(dos5_flags&DOS5_ROM) && (hma_used == 0))
          alloc_hma((codeparas+bufparas)*0x10+0x20);

      /* in case driver init made DOS calls */
      error_no = 0;

      parms[iParmLength-1] = 0x00;
      parms[iParmLength-2] = 0x00;
   }
}
#endif  // #ifdef CFG_DEVICE OR CFG_COUNTRY

#ifdef CFG_DEVICEHIGH
/*
   Run Only On Bootup:

   Install a disk or character device into UMBs.  See
   "do_device".  If device cannot be loaded high, then
   load it low.
*/
void   do_devicehigh(char far *parms)
{
   extern uchar mem_fit;
   extern int error_no;

   // validate pointer
   ASSERT(parms);

   /* we want to load into UMBs. If that fails, do_device will try again */
   mem_fit = MEM_UMBONLY;
   set_umb_link(1);
   do_device(parms);
   mem_fit = MEM_FIRST;
   set_umb_link(0);

   /* if set_umb_link failed, clear error condition so no CONFIG err msg */
   error_no = 0;
}
#endif  // #ifdef CFG_DEVICEHIGH

#ifdef CFG_FCBS
/*
   Run Only On Bootup:

   Create some more SFTs for the use of the DOS1 file
   (FCB) system.  There is a hardcoded minimum set in
   DOSDEF.H
*/
void   do_fcbs(char far *parms)
{
   extern uchar sda_numfcbs;

   // validate pointer
   ASSERT(parms);

   sda_numfcbs = minmax(parms, sda_numfcbs, MAXFCB);
}
#endif  // #ifdef CFG_FCBS

#ifdef CFG_FILES
/*
   Run Only On Bootup:

   Create some more SFTs for the use of the file system.
   There is a hardcoded minimum set in DOSDEF.H
*/
void   do_files(char far *parms)
{
   extern uchar sda_numsfts;
   extern int   init_files;

   // validate pointer
   ASSERT(parms);

   init_files = sda_numsfts = minmax(parms, sda_numsfts, MAXSFT);
}
#endif  // #ifdef CFG_FILES

#ifdef CFG_LASTDRIVE
/*
   Run Only On Bootup:

   Force DOS to allocate more drive structures.
*/
void   do_lastdrive(char far *parms)
{
   extern struct LOL lol;

   // validate pointer
   ASSERT(parms);

   lol.lastdrive = toupper(*parms)-'A'+1;
}
#endif  // #ifdef CFG_LASTDRIVE

#ifdef CFG_DOS
/*
   Run Only On Bootup:

   DOS=HIGH

   Note: UMBs are ALWAYS linked in, if EMM has set up upper
   memory blocks (no need to say DOS=HIGH,UMBS).
*/
void   do_dos(char far *parms)
{
   extern unsigned dos5_flags;
   extern char trydoshi;
   extern unsigned hma_used;
   extern unsigned codeparas;
   extern unsigned bufparas;

   // validate pointer
   ASSERT(parms);

   if(fmemcmp(parms,"HIGH",4) == 0)
   {
      trydoshi = TRUE;         // tell DOS to attempt loading high

      //  PB - 4/15/2003 - IR 4187
      //  Do an alloc of some hma
      //  (This was put in to fix an issue with DOS not loading
      //  high from a newfile)
      //
      if(!(dos5_flags&DOS5_ROM) && (hma_used == 0))
      {
         alloc_hma((codeparas+bufparas)*0x10+0x20);

         // In PASS1, hma_used will remain zero, so enable_hma()
         // should only be called once.
         //
         if(hma_used != 0)
         {
            dos5_flags |= DOS5_HMA;
            enable_hma();
         }
      }
   }
}
#endif  // #ifdef CFG_DOS

#ifdef CFG_INSTALL
/*
   Run Only On Bootup:

   Install a TSR.  No environment is made for this TSR.
*/
void  do_install(char far *parms)
{
   extern union EXEPARM boot_parms;
   extern char warn_bad[];
   extern char warn_tsr[];
   extern uchar mem_fit;

   char szInstallProg[CFGLINELEN];
   int iParmLength;
   int iProgLength;
   int iReturnValue;
   char far * fpszInstallParms;
   char oldc;
   char cSave1, cSave2;

   // validate pointer
   ASSERT(parms);

   // Check the length so we have a space to put extra characters
   //
   iParmLength = fstrlen(parms)+2;

   // Now separate the TSR from it's parameters
   //
   oldc = make_fname(parms);
   iProgLength = fstrlen(parms);
   parms[iProgLength] = oldc;

   // Copy and zero terminate the TSR program
   //
   fmemcpy( (char far *)szInstallProg, parms, iProgLength );
   szInstallProg[iProgLength] = 0x00;

   // The "parameters" block is kind of special.
   //   block[0] = length, or zero for "no parameters"
   //   block[1] = ' '
   //   block+2  = the parameters, terminated with a \r\n
   //

   fpszInstallParms = parms + iProgLength - 2;

   cSave2 = *fpszInstallParms;
   cSave1 = *(fpszInstallParms+1);

   *fpszInstallParms = iParmLength - iProgLength;
   if(*fpszInstallParms == 2)
   {
      *fpszInstallParms = 0;
   }
   *(fpszInstallParms+1) = ' ';
   parms[iParmLength-2]='\r';
   parms[iParmLength-1]='\n';

   /* set up the EXE parameters for spawn */
   boot_parms.e.envseg = getDS();   /* empty environment (always 0's) */
   boot_parms.e.command_line = fpszInstallParms;

   /* spawn the program */
   iReturnValue = spawn_tsr( szInstallProg, &boot_parms );

   *fpszInstallParms = cSave2;
   *(fpszInstallParms+1) = cSave1;
   parms[iParmLength-1]=0x00;
   parms[iParmLength-2]=0x00;

   if( !iReturnValue )
   {
      printf(warn_bad,warn_tsr,parms);
   }
}


#endif  // #ifdef CFG_INSTALL

#ifdef CFG_INSTALLHIGH
/*
   Run Only On Bootup:

   Install a TSR in high memory if possible.  No environment is made for
   this TSR.
*/
void   do_installhigh(char far *parms)
{
   extern uchar mem_fit;

   mem_fit = MEM_UMB1ST | MEM_BEST;
   set_umb_link(1);
   do_install(parms);
   mem_fit = MEM_FIRST;
   set_umb_link(0);
}
#endif  // #ifdef CFG_INSTALLHIGH


#ifdef CFG_NEWFILE
void   do_newfile(char far *parms)
{
   char far * fpszRestoreWhitespace = 0;
   char far * fpszNewfileDevice;
   int iNewCfgSize;

   extern unsigned cfg_seg;      // memory buffer
   extern unsigned cfg_position; // current position, 0xFFFF = eof
   extern char warn_bad[];
   extern char warn_newfile[];

   // This processing is only for NEWFILE statements with a comma
   //
   if( ucSpecialNewFile )
   {
      fpszNewfileDevice = parms;

      while( *fpszNewfileDevice != ',')
      {
         // if we find whitespace, drop a null...
         if (DL_IS_SPACE(*fpszNewfileDevice) && !fpszRestoreWhitespace)
         {
            fpszRestoreWhitespace = fpszNewfileDevice;
            *fpszNewfileDevice = (char) 0;
         }

         fpszNewfileDevice++;
      }

      if (!fpszRestoreWhitespace)
      {
         *fpszNewfileDevice = (char) 0;
         fpszRestoreWhitespace = fpszNewfileDevice;
      }

      // move past null/comma
      fpszNewfileDevice++;

      ucNewFileError = 0;
      
      do_device( fskipwhite(fpszNewfileDevice) );

      if( !ucNewFileError )
      {
         iNewCfgSize = load_and_process_config( parms, cfg_position );

         if( !iNewCfgSize )
         {
            printf( warn_bad, warn_newfile, parms );
            error_no = 0;               // reset error_no
         }
      }

      // For future passes, make this back into one command line.
      // We may end up with two commas in the memory image, but this
      // should pose no issues as this line will not be processed again.
      //
      *fpszRestoreWhitespace = ',';
      ucNewFileError = 0;
   }
}
#endif  // #ifdef CFG_NEWFILE


#ifdef CFG_STACKS
/*
   Run Only On Bootup:

   STACKS=num,size

   There may be more than one STACKS entry in a set of CONFIG files, if
   so the last one takes affect.

*/
void   do_stacks(char far *parms)
{
   extern int stacksNum;
   extern int stacksSize;

   /* determine number of stacks */
   stacksNum = minmax(parms, 0, 64);
   if(stacksNum > 0 && stacksNum < 8)
      stacksNum = 8;

   /* skip to second number */
   while(isdigit(*parms))
      ++parms;
   while(*parms && !isdigit(*parms))
      ++parms;

   /* determine size of stacks */
   stacksSize = minmax(parms, 32, 512);

}
#endif  // #ifdef CFG_STACKS

#ifdef CFG_NUMLOCK
/*
   Run Only On Bootup:

   Set the Numlock (for numeric pad) ON or OFF.
*/
void   do_numlock(char far *parms)
{
   char far * numlockptr = MK_FP(0x40,0x17);

   // validate pointer
   ASSERT(parms);

   // need only set it off; BIOS sets it on by default
   if(fmemcmp(parms,"OFF",3) == 0)
      *numlockptr = 0;
   if(fmemcmp(parms,"ON",2) == 0)
      *numlockptr |= 0x20;
}
#endif  // #ifdef CFG_NUMLOCK


#ifdef CFG_SEARCHES
void   do_searches(char far *parms)
{
   extern int lfnMaxSearches;
   lfnMaxSearches = minmax(parms, MIN_SEARCHES, MAX_SEARCHES);
}
#endif  // #ifdef CFG_SEARCHES


#ifdef CFG_SET
/*
   Run Only On Bootup:

   Auxiliary routine to "SET=xxx" in CONFIG.SYS.
   Returns a pointer to the final NULL in the boot
   environment.
*/
char far * env_end(void)
{
   extern unsigned boot_env;
   char far * ep = MK_FP(boot_env,0);

   while(*ep)
   {
      ++ep;
      if(*ep == 0)   // skip NULL at end of each string
         ++ep;
   }

   return ep;
}

/*
   Run Only On Bootup:

   Auxiliary routine to "SET=xxx" in CONFIG.SYS.
   Adds an item to the boot environment.
*/
void env_add(char far * item)
{
   char far * ep = env_end();
   int len = fstrlen(item)+1;

   // validate pointer
   ASSERT(item);

   // add in the string
   fmemcpy(ep, item, len);

   // null terminate the whole kit and kaboodle
   *(ep+len) = 0;
}

/*
   Run Only On Bootup:

   Auxiliary routine to "SET=xxx" in CONFIG.SYS.
   Removes an item from the boot environment.
*/
void env_remove(char far * ep)
{
   char far * next_ep = ep;
   int env_len;

   // validate pointer
   ASSERT(ep);

   // find the next environment variable
   while(*next_ep)
      ++next_ep;
   ++next_ep;

   // determine length of stuff to move
   env_len = (int)(env_end() - next_ep) + 1;

   fmemcpy(ep, next_ep, env_len);
}

void   do_set(char far *parms)
{
   extern unsigned boot_env;

   char far *p;
   char far *ep;
   int len;

   // validate pointer
   ASSERT(parms);

   // determine "name" part of environment string
   for(p=parms, len=0; *p && *p!='='; ++p, ++len)
      *p = toupper(*p);

   // if it already exists, remove the old copy
   ep = MK_FP(boot_env,0);
   while(*ep)
   {
      // found it!, remove it
      if((fmemcmp(parms,ep,len) == 0) && (*(ep+len) == '='))
         env_remove(ep);

      // on to next env variable
      else
      {
         while(*ep)
            ++ep;
         ++ep;
      }
   }

   // add in the new one
   if(*p == '=' && *(p+1))
      env_add(parms);
}
#endif  // #ifdef CFG_SET


#endif  // #ifdef CFG_PROCESSING


// Compiler's note -- these functions probably *no longer* belong
// in this file, the stand-alone CONFIG.SYS processing engine.
//


#if (VDOS < 5)

// Dummied out for DOS 3.31
//
void SetupStacks(void)
{
}

void warning_nohigh(void)
{
}

#else

/*
   This routine is called by UseSTACKSStacks() to do the math for the
   last STACKS= entry in CONFIG; the SDA variables stacksNum and
   stacksSize will have been set to the last STACKS= values by the
   do_stacks() routine above. Once we have figured out the size
   and number of the stacks we allocate any additional memory from
   DGROUP that we may need. When this is done, the STACKS stacks
   will have been set up in the SDA and UseSTACKSStacks() need only
   copy the contents of the two stacks and then switch onto the new
   char stack.
*/
void SetupStacks(void)
{
   /* By default...
      stacksNum = 9, stacksSize = 128,   static stack depth = 0x26C,
      pDiskStack = &disk_stack, pCharStack = &char_stack
   */
   extern int stacksNum;
   extern int stacksSize;
   extern char *pDiskStack;
   extern char *pCharStack;
   extern char *pDiskStackTop;
   extern char *pCharStackTop;
   extern char char_stack[];

   unsigned totalSize;
   unsigned allocSize;

   /* determine memory needed for the stacks */
   totalSize = (unsigned)stacksNum * stacksSize;
   allocSize = totalSize >> 1;

   /* We have two statically allocated stacks in the SDA (one
      char stack and one disk stack) That are each 0x26Ch bytes
      long. If the totalSize of the STACKS (n*s) is less than or
      equal to the sum of the statically allocated stacks we
      will just use the static stacks.
   */
#if 0
// This code will be replaced in a future major release.
// Until then, we must always switch to a new char stack.
//
   if(totalSize <= (DEFAULTSTACK * 2))
      return;

   /* If 0x26C < (totalSize/2) <= 0x26C*2 (if half of it will fit
      in the statically allocated stack space) then use the statically
      allocated space for the disk stack and dynamically allocate a new
      char stack (size = n*s/2, size <=0x26C*2).
   */
   else
#endif
   if((totalSize >> 1) <= (DEFAULTSTACK * 2))
   {
      /* move top of stack up leave ptr to bottom of stack where it is now */
      pDiskStackTop  = char_stack;

      pCharStack     = mem_alloc_ptr(allocSize, 'S');
      pCharStackTop  = pCharStack + allocSize;
      *(int *)pCharStack = STACKWORD;
   }
   /* If (totalSize/2) > 0x26C*2 then we can't fit either stack in
      the statically allocated stack region (it can't be expanded because
      it's upper limit is bound by the SDA COUNTRY info location). We
      have to dynamically allocate both the char and the disk stack.
   */
   else
   {
      pDiskStack    = mem_alloc_ptr(totalSize, 'S');
      pDiskStackTop = pDiskStack + allocSize;
      *(int *)pDiskStack = STACKWORD;

      pCharStack    = pDiskStackTop + 2;
      pCharStackTop = pDiskStackTop + allocSize;
      *(int *)pCharStack = STACKWORD;
   }
}

/*
   Run Only On Bootup:

   No HMA available, inform user.
*/
void warning_nohigh(void)
{
   printf(warn_nohigh);
}

#endif  // #if (VDOS < 5)
