;
;   $Id: DOSIFS.ASM 1.9 2003/03/10 16:17:10Z thomd Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
---------------------------------------------------------------

   DOSIFS.ASM  created 06/17/91  by Drew Gislason

   Copyright (c) 1991-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains all INT 2FH handling - that is, all
   the interaction between DOS and an IFS (ie network, CD-ROM
   drive, FLASH disk, etc).

--------------------------------------------------------------- ~
include macros.inc
include dostruct.inc
include profile.inc

cBegUdata
	public	old13, reboot13
	old13		DD	?	; also used for disk I/O
	reboot13	DD	?	; value to place in INT 13H at reboot

cEndUdata

cBegData
	extrn	_current_psp:word
	extrn	_sda_sftptr:dword
	extrn	_pDiskStackTop:word
	extrn	_fatal_unsupp:byte
	extrn	_error_no:word
	extrn	_userregs:dword
	extrn	_sda_ename1:byte
	extrn	_sda_devptr:dword
	extrn	_uppercase_table:byte
	extrn	_lead_byte_table:byte
	extrn	_lol:ListOfLists
	extrn	_nulx:dword
	extrn	_err_locus:byte
	extrn	_err_extended:byte
	extrn	_err_action:byte
	extrn	_err_class:byte
	extrn	_sda_callflags:word
	extrn	windows_data:byte
	extrn	_in_windows:byte
	extrn	_sda_cdsptr:dword
	extrn	_CUR_DRIVE:byte
	extrn	_share_delay:word
	extrn       _days_per_month:byte

	public	drive_table_ptr
	drive_table_ptr DW	-1	; will be set by Floppy driver
cEndData

;/////////////////////////////////////////////////////////
;//							//
;//		UPPERCASE CONVERSIONS			//
;//							//
;/////////////////////////////////////////////////////////

cBegCode

COMMENT ; prototype
/*
   Assumes DS=DGROUP
*/
int PASCAL is_lead_byte(uchar c)
{}
;
	public	IS_LEAD_BYTE
IS_LEAD_BYTE proc near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	mov	AL, P[BP]
	mov	BX, GOFFSET _lead_byte_table

	; lead bytes are in RANGED pairs
	; Example: japan lead bytes are 81H 9FH E0H FCH 00H
	; which means a lead byte is any character in the
	; RANGE of 81-9F, or E0-FC
check_lead_byte_range:
	cmp	byte ptr [BX], 0
	jz	no_more_lead_bytes
	cmp	AL, byte ptr [BX]
	jb	next_lead
	cmp	AL, byte ptr [BX+1]
	jbe	its_a_lead_byte
next_lead:
	inc	BX
	inc	BX
	jmp	check_lead_byte_range

no_more_lead_bytes:
	xor	AX, AX
its_a_lead_byte:
	pop	BP

	EXIT_FUNCTION

	ret	2

IS_LEAD_BYTE endp


COMMENT ; prototype
/*
   This toupper is more than the "C" toupper in that it
   knows about the lead byte and uppercase tables.
   Assumes DS=DGROUP
*/
uchar PASCAL toupper(uchar c)
{}
;
	public	TOUPPER
TOUPPER	proc	near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	; if the character is a lead byte, leave it alone
	push	word ptr P[BP]
	call	IS_LEAD_BYTE	; PASCAL function POPs its args
	mov	BL, P[BP]
	or	AX, AX
	jnz	nochange

	; it may be from the uppercase table
	; c = (c >= 0x80 ? uppercase_table[c - 0x7E] : toupper(c));
	xor	BH, BH
	cmp	BL, 80H
	jb	ascii
	sub	BL, 7EH
	add	BX, GOFFSET _uppercase_table
	mov	BL, byte ptr [BX]
	jmp	short nochange

	; or it may be normal ascii
ascii:	cmp	BL, 'a'
	jb	nochange
	cmp	BL, 'z'
	ja	nochange
	sub	BL, 'a'-'A'

nochange:
	xchg	BX, AX		; character was in BL, now in AL
	xor	AH, AH		; return the character in AX
	pop	BP

	EXIT_FUNCTION

	ret	2

TOUPPER	endp


COMMENT ; prototype
/*
   Convert a string using the current uppercase table.
   A len of -1 says stop on a '\0' byte.
*/
uchar uppercase(char far * s, int len)
{}
;
c_func	uppercase

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI
	push	DI

   ;	{
   ;	char c;
   ;	int leadbyte = 0;
   	xor	SI, SI		; SI is leadbyte
	mov	CX, P+4[BP]	; CX = "len"
	les	DI, P[BP]	; ES:DI = far ptr to string

   ;
   ;	while(len)
   ;	{
   ;	   c = *s;
uc_0:	jcxz	uc_done
	mov	AL, byte ptr ES:[DI]

   ;	   if(leadbyte)
   ;	      --leadbyte;
   	or	SI, SI
   	jz	uc_1
   	dec	SI
   	jmp	uc_5
uc_1:

   ;	   else if(is_lead_byte(c))
   ;	      leadbyte = 1;
   	push	AX
   	call	IS_LEAD_BYTE
	or	AX, AX
	jz	uc_2
	mov	SI, 1
   	jmp	uc_5
uc_2:
   ;	   else
   ;	   {
   ;	      if(!c && len == -1)
   ;	         break;
   ;	      *s = toupper(c);
   ;	   }
	mov	AL, byte ptr ES:[DI]
	cmp	AL, 0
	jnz	uc_3
	cmp	CX, -1
	jnz	uc_3
	jmp	short uc_done	; break;
uc_3:	push	AX
	call	TOUPPER
	mov	ES:[DI], AL

   ;	   ++s;
   ;	   if(len != -1)
   ;	      --len;
   ;	}
uc_5:
	inc	DI	; ES:DI = far ptr to string
	cmp	CX, -1
	jz	uc_6
	dec	CX
uc_6:	jmp	short uc_0

   ;	return c;
uc_done:
	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	uppercase

cEndCode


cBegCode
	extrn	_ifs_crit_err:near
	extrn	_get_filedate:near
	extrn	_panic:near
	extrn	getDGROUP:near
	c_extrn getDS,near
	extrn	_decr_handle_count:near
	extrn	_hma_alloc_handler:near
	extrn	H_TO_SFT:near			; PASCAL function
	extrn	FIND_DEVICE:near		; PASCAL function
	extrn	_abspath:near
	extrn	FSTRLEN:near			; PASCAL function
	extrn	_drv_to_cds_no_check:near
	extrn	SETUP_CDS:near

COMMENT ; prototype
void lock_file(bool lock, void far * sft, struct LOCK *lockbuff)
{}
;
c_func	lock_file

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI
	push	DI

	; get all parameters
	mov	AX, 110AH
	mov	BX, P+0[BP]	; BX = lock(0)/unlock(1)
	les	DI, P+2[BP]	; ES:DI = ptr to sft
	mov	DX, P+6[BP]	; DS:DX = lock record w/ start/len
	mov	bp, dx		; NETWARE LITE wants ds:bp-> lock record

	; actually do the INT 2FH
	int	2FH

	; record error (if any) and clean up stack
	jc	bad_lock
	xor	AX, AX
bad_lock:
	mov	[_error_no], AX

	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	lock_file



COMMENT ~
----------------------------------------------------------------

	Here it is, the INT 2FH handler.

	We support functions 11H and 12H, 16H and all their
	subfunctions (well, some of them anyway).

	int 2FH, 11xx:	DOS calls IFS via these calls
	int 2FH, 12xx:	IFS access to DOS functions
	int 2FH, 1607:	Windows instance data
	int 2FH, 4Axx:	Get HMA memory

	ROM-DOS 6 supports the following (those lead by .......)
	int 2FH, 12xx:
.......	00 - DOS installed?
	01 - Flush file
	02 - Get Interrupt Vector
.......	03 - Get DOS Data Segment
	04 - Normalize Path Separator
	05 - Output Character
.......	06 - Invoke Critical Error
	07 - Move Disk Buffer
.......	08 - Decrement User Count
.......	0C - Call Device Open
.......	0D - Get Date/Time
	0E - Search Disk Buffer Chain
	10 - Time Delay
.......	11 - Normalize Asciiz File
.......	12 - Strlen
.......	13 - Toupper (Supports Country Info)
.......	14 - Compare Far Pointers
.......	16 - Get SFT from handle #
.......	17 - Get CDS Ptr
.......	18 - Get User Stack Address
.......	19 - Set CDS Ptr for Drive n
.......	1A - Get Drive Code From Path
.......	1B - Adjust for Leap Year
.......	1C - Calculate Days Since Start-of-Month
.......	1D - Add until # exceeded
	1E - Compare Strings
.......	1F - Build CDS
.......	20 - Get handle # (PSP) from handle
.......	21 - Expand Asciiz Pathname
.......	22 - Set Extended Error Info
.......	23 - Is This A Character Device?
.......	24 - Delay
	25 - Strlen
	26 - Open File
	27 - Close File
	28 - Position File Pointer
	29 - Read File
.......	2A - Set Fast Open Entry Point
	2B - Call Device IOCTL
....... 2C - Get Device Chain
	2D - Get Extended Error Code
.......	2E - Get Error Table
	2F - Store DX?

---------------------------------------------------------------- ~

	; note: right now, the DEVFDHD driver does not chain
	; properly, so if you want to add other drivers with DDTs,
	; we must figure out some scheme.
int_2F_0803:

	ENTER_FUNCTION

	; return DS:DI pointing to drive table
	call	getDGROUP
	mov	DI, [drive_table_ptr]

	EXIT_FUNCTION

	iret

c_func	int_2F
	cmp	AH, 4AH		; get HMA memory
	jnz	not4A

	;  BT 12-19-01
	;
	;  Function 4a00h is not an HMA function.  In fact we
	;  don't support it.  So just IRET here instead of passing
	;  it on to the hma_alloc_handler.
	;
	cmp	al, 0
	je	iretx

	cmp	AL, 2H		; get HMA is function 1,2
	ja	not4A
	jmp	_hma_alloc_handler
not4a:	cmp	AX, 1607H	; Windows instance interface
	jz	int_2F_1607
	cmp	AX, 0803H	; Get Floppy/Hard Drive Tables
	jz	int_2F_0803
	cmp	AH, 13H
	jz	int_2F_13
	cmp	AH, 12H		; lot's o' DOS functions
	jnz	not12
	jmp	int_2F_12xx
not12:	cmp	AH, 11H		; redirector
	jnz	iretx
	jmp	int_2F_11xx
iretx:	iret


;/////////////////////////////////////////////////////////
;//							//
;//		INT 2FH, function 1607H			//
;//		Windows/DOSMGR Support			//
;//							//
;//               BX = 15, CX = fn			//
;//							//
;//		CX = 0 - Establish DOSMGR support       //
;//		CX = 1 - Enable Windows support         //
;//		CX = 2 - Disable Windows support        //
;//		CX = 3 - Size of CDS                    //
;//		CX = 4 - Get instancing exceptions      //
;//		CX = 5 - Get Size of device driver      //
;//							//
;/////////////////////////////////////////////////////////
int_2F_1607:
	cmp	BX, 15H		; broadcast for DOS
	jnz	iretx

	ENTER_FUNCTION

	; CX = 0 - Establish DOSMGR support
	cmp	CX, 0
	jnz	not_1607_00
	inc	CX		; mov CX, 1
	mov	BX, GOFFSET windows_data
	push	AX
	call	getDS
	mov	ES, AX
	pop	AX

	EXIT_FUNCTION

	jmp	short iretx

not_1607_00:

	; CX = 1 - Enable Windows support
	cmp	CX, 1
	jnz	not_1607_01
	push	DS
	call	getDGROUP
	mov	[_in_windows], 1
done_1607_01:
	pop	DS
	mov	BX, DX
        xor	CX, CX		; compliments of undocumented DOS
cookie:	mov	DX, 0A2ABH	; magic numbers Windows expects
        mov	AX, 0B97CH
	jmp	short iretx
not_1607_01:

	; CX = 2 - Disable Windows support
	cmp	CX, 2
	jnz	not_1607_02
	push	DS
	call	getDGROUP
	mov	[_in_windows], 0
	jmp	short done_1607_01
not_1607_02:

	; Get CDS Structure Size
	cmp	CX, 3
	jnz	not_1607_03
	mov	CX, SIZE CurrentDirectoryStructure
	jmp	short cookie
not_1607_03:

	; Get Instancing Exemptions
	cmp	CX, 4
	jnz	not_1607_04

zcxdx:	xor	CX, CX
	xor	DX, DX
	jmp	short iretx
not_1607_04:

	; Get Size of Device Driver
	cmp	CX, 5
	jnz	not_1607_05
	xor	AX, AX
	jmp	short zcxdx
not_1607_05:

	jmp	short iretx

;/////////////////////////////////////////////////////////
;//							//
;//		INT 2FH, function 13H			//
;//		Set Disk Interrupt Handler		//
;//							//
;/////////////////////////////////////////////////////////
int_2F_13:

	ENTER_FUNCTION

	push	AX
	push	CX
	mov	AX, DS
	mov	CX, ES
	call	getDGROUP
	xchg	DX, word ptr [old13]
	xchg	AX, word ptr [old13+2]
	xchg	BX, word ptr [reboot13]
	xchg	CX, word ptr [reboot13+2]
	mov	ES, CX
	mov	DS, AX
	pop	CX
	pop	AX

	EXIT_FUNCTION

	iret

;/////////////////////////////////////////////////////////
;//							//
;//		INT 2FH, function 12xxH			//
;//							//
;/////////////////////////////////////////////////////////

	; INT 2FH function 12xxH calls are made from within
	; an IFS.  Most will not work from outside of DOS.
	public	int_2F_12xx
int_2F_12xx:

	;--------------------------------------------------
	;
	;  ALL THESE CALLS DO NOT REQUIRE ROM-DOS DGROUP in DS
	;
	;--------------------------------------------------

	;///////////////////////
	; INT 2FH, 1200H - Install Check
	cmp	AL, 0
	jnz	not_1200
	mov	AX, 0FFH
	iret
not_1200:

	;///////////////////////
	; INT 2FH, 121AH - Get Drive Code From Path
	cmp	AL, 1AH
	jnz	not_121A

	ENTER_FUNCTION

	cmp	byte ptr DS:[SI+1], ':'
	jnz	defdrive
	mov	AL, byte ptr DS:[SI]
	push	DS
	push	BX
	call	getDGROUP
	push	AX
	call	TOUPPER
	pop	BX
	pop	DS
	cmp	AL, 'A'
	jb	defdrive
	cmp	AL, 'Z'
	ja	defdrive
	sub	AL, 'A'-1	; so 0=A, 1=B, and so on
	inc	SI
	inc	SI		; skip "A:" part of path
	jmp 	short done_121A
defdrive:
	xor	AX, AX		; drive not there!
done_121A:

	EXIT_FUNCTION

	iret
not_121A:

	;///////////////////////
	; INT 2FH, 1211H - Convert a string w/ slash to uppercase
	;
	cmp	AL, 11H
	jnz	not_1211

	ENTER_FUNCTION

	; copy string into new buffer
	push	SI
	push	DI
	cld
next_char_1211:
	movsb
	cmp	byte ptr DS:[SI-1], 0
	jnz	next_char_1211
	pop	DI
	pop	SI

	; convert string to uppercase
	; uchar uppercase(uchar far * s, int len)
	push	DS
	push	ES
	push	BX
	push	CX
	push	DX
	call	getDGROUP

	; convert string to uppercase
	mov	CX, -1
	push	CX
	push	ES
	push	DI
	call	uppercase
	add	SP, 6

	; change all '/' into '\'
	push	DI
again_1211:
	cmp	byte ptr ES:[DI], 0
	jz	done_1211
	cmp	byte ptr ES:[DI], '/'
	jnz	not_slash_1211
	mov	byte ptr ES:[DI], '\'
not_slash_1211:
	inc	DI
	jmp	short again_1211
done_1211:
	pop	DI

	; pop all saved registers
	pop	DX
	pop	CX
	pop	BX
	pop	ES

	EXIT_FUNCTION

	jmp	clear_2F_carry
not_1211:

	;///////////////////////
	; INT 2FH, 1212H - Get Asciz String Size (fstrlen+1)
	cmp	AL, 12H
	jnz	not_1212

	ENTER_FUNCTION

	push	ES
	push	DI
	call	FSTRLEN
	inc	AX
	xchg	CX, AX		; return length in CX
	xor	AX, AX		; return AX=0

	EXIT_FUNCTION

	iret
not_1212:

	;///////////////////////
	; INT 2FH, 121BH - Return length of February
	; note: MS-DOS sets some internals, we don't
	public i2f_121b
i2f_121b:
	cmp	AL, 1BH
	jnz	not_121B

	ENTER_FUNCTION

	mov	AX, 28		; days in February
	test	CL, 3
	jnz	done_121B
	inc	AX		; 29 days in leap years
done_121B:
	mov	[_days_per_month][1], al  ; update days in Feb in days/mon table

	EXIT_FUNCTION

	iret
not_121B:

	;///////////////////////
	; INT 2FH, 121CH - Checksum Memory
	cmp	AL, 1CH
	jnz	not_121C

	ENTER_FUNCTION

	jcxz	done_121C
	xor	AH, AH
again_121C:
	lodsb
	add	DX, AX		; simple add-byte-to-word checksum
	loop	again_121C
done_121C:

	EXIT_FUNCTION

	iret
not_121C:

	;///////////////////////
	; INT 2FH, 121DH - Calculate limit, used for date calcs?
	cmp	AL, 1DH
	jnz	not_121D

	ENTER_FUNCTION

	xor	AH, AH
again_121D:
	lodsb			; load AL with DS:[SI]
	cmp	DX, AX
	jb	done_121D
	sub	DX, AX
	inc	CX
	jmp	again_121D
done_121D:

	EXIT_FUNCTION

	iret
not_121D:

	;///////////////////////
	; INT 2FH, 122AH - Set Fast Open Entry Point
	cmp	AL, 2AH
	jnz	not_122A

	ENTER_FUNCTION
	EXIT_FUNCTION

	iret
not_122A:

	;///////////////////////
	; INT 2FH, 1203H - Get DOS Data Area
	cmp	AL, 03H
	jnz	not_1203

	ENTER_FUNCTION

	call	getDGROUP

	EXIT_FUNCTION

	iret
not_1203:

	;///////////////////////
	; INT 2FH, 122EH - Get Error Table
	; The REAL support for the "DOS error Table" is in
	; COMMAND.COM.  We have a stub here in case COMMAND
	; isn't being run at all!  Debug uses this call to
	; get its error messages.
	cmp	AL, 2EH
	jnz	not_122E

	ENTER_FUNCTION

	xor	DI, DI
	mov	ES, DI

	EXIT_FUNCTION

	iret
not_122E:

	;///////////////////////
	; INT 2FH, 1218H - Get Error Table
	cmp	AL, 18H
	jnz	not_1218

	ENTER_FUNCTION

	call	getDGROUP
	lds	SI, _userregs

	EXIT_FUNCTION

	iret
not_1218:

	;///////////////////////
	; INT 2FH, 1214H - Compare pointers
	cmp	AL, 14H
	jnz	not_1214

	ENTER_FUNCTION

	cmp	SI, DI
	jnz	fail_1214
	push	SI
	push	DI
	mov	DI, ES
	mov	SI, DS
	cmp	SI, DI
	pop	DI
	pop	SI
fail_1214:
	push	BP
	mov	BP, SP
	pushf			; remember ZF state
	pop	AX		; in AX
	and	AX, 40H
	and	byte ptr [BP+6], NOT 41H	; clear ZF and CY
	or	byte ptr [BP+6], AL
	pop	BP

	EXIT_FUNCTION

	iret

not_1214:
	cmp	al, 25h
	jnz	not_1225

	; /////////////////////
	; int 2Fh, 1225h -- get length of ASCIIZ string @ds:si
	; needed for spr1399
	;
int2F_fn1225:

	ENTER_FUNCTION

	push	ax
	push	si
	xor	cx, cx
	cld

loop_1225:
	lodsb
	or al, al
	loopnz	loop_1225

	inc	cx
	neg	cx
	pop	si
	pop	ax

	EXIT_FUNCTION

	iret

not_1225:
	;--------------------------------------------------
	;
	;  ALL THESE CALLS REQUIRE ROM-DOS DGROUP in DS
	;
	;--------------------------------------------------
	push	DS
	call	getDGROUP

	;///////////////////////
	; INT 2FH, 121FH - Create CDS
	cmp	AL, 1FH
	jnz	not_121F

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	; get drive letter in toupper form
	push	word ptr [BP+10]
	call	TOUPPER		; returned in AL

	les	DI, [_sda_cdsptr]
	mov	word ptr ES:[DI+43H], 0		; invalidate CDS
	sub	AL, 'A'
	cmp	AL, DS:[lol_LAST_DRIVE]		; only proceed if drv #
	jae	done_121F			; is in range of lastdrive

	; set up CDS for current drive #
	push	ES
	push	DI
	push	AX
	call	SETUP_CDS	; set the current CDS to given drive #

	; return pointer in ES:DI to current CDS
	les	DI, [_sda_cdsptr]
done_121F:
	pop	BP

	EXIT_FUNCTION

	jmp	clear_2F_carry
not_121F:

	;///////////////////////
	; INT 2FH, 1224H - Share Delay
	cmp	AL, 24H
	jnz	not_1224

	ENTER_FUNCTION

	mov	CX, [_share_delay]
wait0_1224:
	push	CX
	xor	CX, CX
wait1_1224:
	loop	wait1_1224
	pop	CX
	loop	wait0_1224

	EXIT_FUNCTION

	jmp	clear_2F_carry

not_1224:
	;///////////////////////
	; INT 2FH, 1217H - Get CDS ptr for drive
	cmp	AL, 17H
	jnz	not_1217

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	DX
	mov	AX, word ptr [BP+10]	; word from stack specifies drive
					; 0=A, 1=B, etc...
	call	GetCdsPtr
	jz	fail_1217
	mov	SI, AX			; DS:SI pts to CDS
	mov	[BP+2], DX		; put segment in user DS
	mov	AX, word ptr [BP+10]	; drive # should be in AX on ret
	pop	DX
	pop	BP

	EXIT_FUNCTION

	jmp	clear_2F_carry
fail_1217:
	pop	DX
	pop	BP

	EXIT_FUNCTION

	jmp	set_2F_carry

;  Returns Z=1 if failed, Z=0 if worked
;  Returns CDS Ptr in DX:AX if worked
GetCdsPtr:

	ENTER_FUNCTION

	; preserve all registers
	push	ES
	push	BX
	push	CX

	push	AX		; drive #
	call	_drv_to_cds_no_check
	pop	CX

	pop	CX
	pop	BX
	pop	ES

	cmp	AX, -1
	jz	FailedGet
	mov	word ptr [_sda_cdsptr], AX
	mov	word ptr [_sda_cdsptr+2], DX
FailedGet:

	EXIT_FUNCTION

	ret
not_1217:

	;///////////////////////
	; INT 2FH, 1219H - Set CDS Ptr for Drive n
	cmp	AL, 19H
	jnz	not_1219

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	mov	AX, word ptr [BP+10]	; word from stack specifies drive
					; 0=default, 1=A, 2=B, etc...
	dec	AL			; (decrement so 0=A, etc..)
	cmp	AL, 0FFH		; default?
	jnz	not_default
	mov	AL, [_CUR_DRIVE]
not_default:
	call	GetCdsPtr
	jz	fail_1217
	pop	BP

	EXIT_FUNCTION

	jmp	clear_2F_carry
not_1219:

	;///////////////////////
	; INT 2FH, 1213H - Convert a character to uppercase
	cmp	AL, 13H
	jnz	not_1213

	ENTER_FUNCTION

	; get the character from the stack
	push	BP
	mov	BP, SP
	mov	AX, [BP+10]
	pop	BP

	; convert it
	push	BX
	push	AX
	call	TOUPPER
	pop	BX
	pop	DS

	EXIT_FUNCTION

	iret
not_1213:

	;///////////////////////
	; INT 2FH, 1221H - Abspath a String
	; DS already pushed (abspath guaranteed not to change it)
	cmp	AL, 21H
	jnz	not_1221

	ENTER_FUNCTION

	push	SI
	push	ES
	push	DI
	call	_abspath
	pop	DI
	pop	ES
	pop	SI
	or	AX, AX
	jnz	fail_1221

	EXIT_FUNCTION

	jmp	clear_2F_carry

fail_1221:
	EXIT_FUNCTION

	jmp	set_2F_carry
not_1221:

	;///////////////////////
	; INT 2FH, 1222H - Set Extended Error Codes
	cmp	AL, 22H
	jnz	not_1222

	ENTER_FUNCTION

	push	AX
	push	BX
	push	CX
	mov	CX, 4
do_1222:
	mov	BX, CX
	mov	AL, byte ptr SS:[SI+BX-1]
	cmp	AL, 0FFH
	jz	loop_1222
	mov	BL, byte ptr CS:[index_1222+bx-1]
	mov	byte ptr [_err_locus+BX], AL
loop_1222:
	loop	do_1222
	pop	CX
	pop	BX
	pop	AX

	EXIT_FUNCTION

	jmp	clear_2F_carry

index_1222	db	1,4,3,0

not_1222:

	;///////////////////////
	; INT 2FH, 1206H - Generate Critical Error
	cmp	AL, 06H
	jnz	not_1206

	ENTER_FUNCTION

	; Store passed error number
	mov	[_error_no], DI

	; Get user stack, get crit locus into AX, restore stack
	push	BP
	mov	BP, SP
	mov	AX, 10[BP]
	pop	BP

	; AH=locus, AL=drive, BP:SI = devhdr
	call	_ifs_crit_err
	pop	DS

	EXIT_FUNCTION

	iret
not_1206:

	;///////////////////////
	; INT 2FH, 1208H - Decrement Handle Count
	cmp	AL, 08H
	jnz	not_1208

	public	i2f_1208
i2f_1208:

	ENTER_FUNCTION

	; save registers, we'll be changing them
	push	BX
	push	CX
	push	DX

	; save original handle count
	push	word ptr ES:[DI]

	; decrement the handle count using our standard function
	; (checks ownership)
	call	_decr_handle_count

	; set to -1 if dropped to 0 (DOS will set to 0 just before
	; returning to caller.  We don't want anyone using this meanwhile).
	cmp	word ptr ES:[DI], 0
	jnz	nodec
	dec	word ptr ES:[DI]	; change to FFFFH
nodec:

	; restore original handle count to AX
	pop	AX

	; restore registers
	pop	DX
	pop	CX
	pop	BX

	EXIT_FUNCTION

	jmp	clear_2F_carry
not_1208:

	;///////////////////////
	; INT 2FH, 120CH - Set File Owner
	cmp	AL, 0CH
	jnz	not_120C

	ENTER_FUNCTION

	; set the file ownership to current PSP
	les	DI, _sda_sftptr
	mov	AX, _current_psp
	mov	ES:[DI+31H], AX

	EXIT_FUNCTION

	jmp	clear_2F_carry
not_120C:

	;///////////////////////
	; INT 2FH, 120DH - Get File Date
	cmp	AL, 0DH
	jnz	not_120D

	ENTER_FUNCTION

	; return file date/time in DX:AX
	push	ES
	push	BX
	push	CX
	call	_get_filedate
	pop	CX
	pop	BX
	pop	ES

	EXIT_FUNCTION

	jmp	clear_2F_carry
not_120D:

	;///////////////////////
	; INT 2FH, 1216H - Get SFT from handle #
	cmp	AL, 16H
	jnz	not_1216

	ENTER_FUNCTION

	; save registers
	push	AX
	push	BX
	push	CX
	push	DX

	; struct SFT far * PASCAL h_to_sft(int h)
	push	word ptr [_sda_callflags]
	mov	word ptr [_sda_callflags], 0
	push	BX
	call	H_TO_SFT
	pop	word ptr [_sda_callflags]
	mov	ES, DX
	mov	DI, AX
	pop	DX
	pop	CX
	pop	BX
	pop	AX

	EXIT_FUNCTION

	; check for failure
	cmp	DI, -1
	jz	set_2F_carry

	; it worked!
	jmp	short clear_2F_carry
not_1216:

	;///////////////////////
	; INT 2FH, 1220H - Get handle # (PSP) from handle
	cmp	AL, 20H
	jnz	not_1220

	ENTER_FUNCTION

	; handle in BX
	mov	ES, _current_psp
	cmp	BX, word ptr ES:[32H]	; hcount
	jae	set_2F_carry
	les	DI, dword ptr ES:[34H]	; hptr
	add	DI, BX

	EXIT_FUNCTION

	jmp	short clear_2F_carry

	; the call worked, clear carry
clear_2F_carry:
	push	BP
	mov	BP, SP
	and	byte ptr [BP+8], 0FEH	; clear carry
	pop	BP
	pop	DS
	iret

	; the call failed, set carry and exit
set_2F_carry:
	push	BP
	mov	BP, SP
	or	byte ptr [BP+8], 1	; set carry
	pop	BP
	pop	DS
	iret
not_1220:

	;///////////////////////
	; INT 2FH, 1223H - Is Character Device
	cmp	AL, 23H
	jnz	not_1223

	ENTER_FUNCTION

	; find_device(sda_ename1)
	mov	AX, GOFFSET _sda_ename1
	push	AX
	call	FIND_DEVICE

	EXIT_FUNCTION

	or	AX, AX
	jz	set_2F_carry
	les	BX, dword ptr [_sda_devptr]
	mov	BX, ES:[BX+4]
	jmp	clear_2F_carry

not_1223:

	;///////////////////////
	; INT 2FH, 122CH - Get first device ptr after NUL
	cmp	AL, 2CH
	jnz	not_122C

	ENTER_FUNCTION

	; The NUL device is a public DGROUP location
	; and the first two words are the pointer we want
	push	ES
	les	BX, dword ptr [_nulx]
	mov	AX, BX
	mov	BX, ES
	pop	ES

	EXIT_FUNCTION

	jmp	clear_2F_carry

not_122C:
	; ignore calls that MS-DOS doesn't support
	; but assert on calls that we don't, but should
	cmp	AL, 30H
	jb	unsupported_2F
	mov	AX, 1			; invalid function
	jmp	set_2F_carry

	; ROM-DOS does not support this 2FH call.
	; Inquiring minds like mine want to know!
	public	unsupported_2F
unsupported_2F:

	; get our DOS stack back
	mov	DX, DS
	mov	CX, _pDiskStackTop
	mov	SS, DX
	mov	SP, CX

	; halt system with message about 2FH call
	push	AX
	mov	AX, 2FH
	push	AX
	mov	AX, GOFFSET _fatal_unsupp
	push	AX
	call	_panic


COMMENT ~
----------------------------------------------------------------

	INT 2FH, function 11xxH

---------------------------------------------------------------- ~

	; INT 2FH, function 11H.  Set carry and return.
int_2F_11xx:
	cmp	AL, 0
	jnz	_11xx
	iret

	; remove the flags, set carry and AX to 1
_11xx:
	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	or	byte ptr [BP+6], 1	; set carry; indicate error
	pop	BP
	mov	AX, 1	; return "Bad Function"

	EXIT_FUNCTION

	iret
c_endp	int_2F

cEndCode
	END
