;
;   $Id: DOSINT.ASM 1.11 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DOSINT.ASM  created 11/30/90  by Drew Gislason

   Copyright (c) 1990-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains the interrupt handlers for all DOS
   interrupts (0,1,3,4,1BH,20H-3FH), with the exception
   of the INT 2FH multiplex calls.  INT 2FH is handled
   in DOSIFS.ASM.  DOSHMA.ASM contains the entry points
   to these interrupts.

   DOS Traps These Interrupts
   --------------------------
   00H	Divide by Zero
   01H	Single Step (IRET)
   03H	Breakpoint (IRET)
   04H	Divide Overflow (IRET)
   1BH	Ctrl-break address
   20H	Terminate the current process
   21H	Generic DOS call
   22H	Terminate address
   23H	Control-C handler address
   24H	Critical Error handler address
   25H	Absolute disk read
   26H	Absolute disk write
   27H	Terminate but stay resident
   28H	DOS idle (for TSRs)
   29H	Fast putchar
   2AH	Lock/Unlock Resources
   2BH - 2DH IRET
   2EH	IRET (COMMAND.COM may trap this)
   2FH	Multiplex and Network calls
   30H - 3FH IRET

---------------------------------------------------------- ~
include macros.inc
include dostruct.inc
include profile.inc

CRIT_SECTION	equ 1

BEGIN1_CRIT_SECTION	equ	8001H
BEGIN2_CRIT_SECTION	equ	8002H
END1_CRIT_SECTION	equ	8101H
END2_CRIT_SECTION	equ	8102H
END_ALL_CRIT_SECTIONS	equ	82H
PROCESS_EXT_REQUESTS	equ	84h

; Bit values for CDS.CDS_STATUS field
;
C_NETWORK	= 8000h
C_VALID		= 4000h
C_JOIN		= 2000h
C_SUBST		= 1000h

; DOS error code returned when a CDS is invalid
;
ERR_NOTDRIVE	= 000Fh

; values for DPB fields
;
HARDMEDIA	=	0F8h		; DBP_media for a hard drive

cBegCode
	extrn	BIOS_PUTC:near

	; external code
	extrn	_divide_by_zero:near
	extrn	getDGROUP:near
	extrn	_getDS:near
	extrn	_dos_entry:near
	extrn	_abs_rdwr:near
	extrn	_dos_exit:near
	extrn	_regs_to_sda:near
	extrn	_buf_invalidate:near
	extrn	HANDLE_TO_SDA:near
	extrn	H_TO_SDA:near
	extrn	GET_CALL_FLAGS:near
	extrn   DRV_TO_CDS:near
cEndCode


cBegData
	extrn	_BREAK_FLAG:byte
	extrn	_dos_ver:word
	extrn	_dos5_flags:word
	extrn	bootdrive:byte
	extrn	_current_psp:word
	extrn	_userregs:dword
	extrn	_pDiskStackTop:word
	extrn	_pCharStackTop:word
	extrn	_InDOS:byte
	extrn	_special_ret:word
	extrn	_int21_ax:word
	extrn	_int21_ah:byte
	extrn	_err_psp:word
	extrn   _machine_id:word
	extrn	_olduserregs:dword
	extrn	_oldhandle:word
	extrn	_old_sfth:byte
	extrn	_sda_reqhdr:byte
	extrn	_old_reqhdr:byte
	extrn	_sda_callflags:word
	extrn	_sda_handle:word
	extrn	_sda_sft_h:byte
	extrn	_error_no:word
	extrn	_err_extended:word
	extrn	_err_action:word
	extrn	_err_esdi:dword
	extrn	_err_locus:byte
	extrn	_pCharStack:word
	extrn	_pDiskStack:word
	extrn	_sda_sftptr:dword
	extrn	_sda_cdsptr:dword
	extrn	_sda_rdwrlen:word
	extrn	_int28_OK:byte
	extrn	_sda_devptr:dword
	extrn	_CritErr:byte
 	extrn	_crit_drive:byte
	extrn	_crit_locus:byte
	extrn	_crit_stack:dword
	extrn	_int28_sp:word
	extrn	_int23_sp:word
	extrn	_user_ds:word
	extrn	_hitbrk:byte		; break handler
	extrn	sda_dispatch:word	; func pointer for quick 21H calls
	extrn	_booting:byte		; are we booting?
	extrn	_using_boot_stack:byte  ; 1= we are on the boot stack now
	extrn	_int2f_ax:word, _int2f_bx:word
	extrn	_int2f_cx:word, _int2f_dx:word, _int2f_di:word
	extrn	xms_addr:dword
	extrn	_dos5_flags:word
	extrn	_sda_in_5D:byte
	extrn   _DTA:dword
	extrn	_in_ifs_crit_err:byte	; >0 if inside int 2Fh, 1206h
	extrn	drive_table_ptr:word ; -1 if none else DGROUP offset of 1st DDT
	extrn	_CUR_DRIVE:byte		; default drive number (0=A:)
	extrn	_return_code:word	; last i21f4C return code
	extrn	_verify_flag:byte	; the verify state value
	extrn	_ROM_DS:word		; our current DGROUP value
	extrn	_dos_vars:byte		; DRGOUP offset of list of lists

DOS_IN_HMA	equ	10H

		public	_no_ctrl_c
	_no_ctrl_c	db 1
cEndData


cBegCode


; ->:	CX	DOS drive number to look for (0=A:)
; <-:	CF	set on error (not found) and DS:SI trashed else
;	DS:SI	ptr to DDT for specified drive
;
	public	FindDDTFromDrive
FindDDTFromDrive	proc near

	ENTER_FUNCTION

	push	cx
	call	getDGROUP
	mov	si, drive_table_ptr

	cmp	si, -1
    	je	short FDDTFD_error

	inc	cx    		; make 1=A: so loop exit w/ CX==0 is success
	jmp	FDDTFD_check_on_count

    FDDTFD_loop_top:
	lds	si, [si].DDT_nextptr

    FDDTFD_check_on_count:
	cmp	word ptr [si].DDT_nextptr, 0FFFFh
    	loopne	FDDTFD_loop_top
	clc
	jcxz	FDDTFD_exit

    FDDTFD_error:
	stc

    FDDTFD_exit:
	pop	cx

	EXIT_FUNCTION

	retn

FindDDTFromDrive	endp


COMMENT ~
/*
   -------------------------------------------------------

		The INT 21H Handler

	Some functions are so simple that they are
	processed in assembly before the real int 21
	handler is called.  These are called quick_funcs.

   -------------------------------------------------------
*/
~

	public QuickFuncsList, cQuickFuncs, oQuickFuncs, QuickFuncHandlersList
QuickFuncsList label byte
	db 19h			; Get Current Drive
	db 1Ah	                ; Set DTA
	db 25H	                ; Set Interrupt Vector
	db 2Eh	                ; Set verify state
	db 2Fh	                ; Get DTA
	db 30H	                ; Get DOS Version
	db 33H	                ; Get/Set Break Flag
	db 34H	                ; Get InDos Flag address
	db 35H	                ; Get Interrupt Vector
	db 42H	                ; File Seek
	db 47h	                ; Get CWD (may only do part of the work here)
	db 4BH	                ; Set Exec State
	db 4Dh	                ; Get return code
	db 50H	                ; Set PSP
	db 51H	                ; Get PSP
	db 52h	                ; Get ptr to list of lists
	db 54h	                ; Get verify flag
	db 59H	                ; Get Extended Error
	db 5DH                  ; Set Extended Error
	db 5EH	                ; Network Printer Setup
	db 62H	                ; Get PSP

       cQuickFuncs	=	($-offset QuickFuncsList)
       oQuickFuncs	=	(cQuickFuncs - 1)

QuickFuncHandlersList label word
	dw offset int_21_19	; Get Current Drive
	dw offset int_21_1A	; Set DTA
	dw offset int_21_25	; Set Interrupt Vector
	dw offset int_21_2E	; Set verify state
	dw offset int_21_2F	; Get DTA
	dw offset int_21_30	; Get DOS Version
	dw offset int_21_33	; Get/Set Break Flag
	dw offset int_21_34	; Get InDos Flag address
	dw offset int_21_35	; Get Interrupt Vector
	dw offset int_21_42	; File Seek
	dw offset int_21_47	; Get CWD (may only do part of the work here)
	dw offset int_21_4B	; Set Exec State
	dw offset int_21_4D	; Get return code
	dw offset int_21_50	; Set PSP
	dw offset int_21_51	; Get PSP
	dw offset int_21_52	; Get ptr to list of lists
	dw offset int_21_54	; Get verify flag
	dw offset int_21_59	; Get Extended Error
	dw offset int_21_5D	; Set Extended Error
	dw offset int_21_5E	; Network Printer Setup
	dw offset int_21_62	; Get PSP


comment ~
	public quick_funcs
quick_funcs label byte
	db 19h
	dw offset int_21_19	; Get Current Drive
	db 1Ah
	dw offset int_21_1A	; Set DTA
	db 25H
	dw offset int_21_25	; Set Interrupt Vector
	db 2Eh
	dw offset int_21_2E	; Set verify state
	db 2Fh
	dw offset int_21_2F	; Get DTA
	db 30H
	dw offset int_21_30	; Get DOS Version
	db 33H
	dw offset int_21_33	; Get/Set Break Flag
	db 34H
	dw offset int_21_34	; Get InDos Flag address
	db 35H
	dw offset int_21_35	; Get Interrupt Vector
	db 42H
	dw offset int_21_42	; File Seek
	db 47h
	dw offset int_21_47	; Get CWD (may only do part of the work here)
	db 4BH
	dw offset int_21_4B	; Set Exec State
	db 4Dh
	dw offset int_21_4D	; Get return code
	db 50H
	dw offset int_21_50	; Set PSP
	db 51H
	dw offset int_21_51	; Get PSP
	db 52h
	dw offset int_21_52	; Get ptr to list of lists
	db 54h
	dw offset int_21_54	; Get verify flag
	db 59H
	dw offset int_21_59	; Get Extended Error
	db 5DH
	dw offset int_21_5D	; Set Extended Error
	db 5EH
	dw offset int_21_5E	; Network Printer Setup
	db 62H
	dw offset int_21_62	; Get PSP
	db 0			; end-of-list

end_comment ~



int_21_5E:
	cmp	AL, 02H
	jae	i5E02
	jmp	int21_normal
i5E02:
	ENTER_FUNCTION

	pop	DS		; we want the USER regs for this call
	pop	ES
	push	AX
	mov	AX, 111FH
	int	2FH
	pushf				; save the carry status
	push	BP
	mov	BP, SP
	push	BX
	mov	BL, byte ptr [BP+2]
	and	BL, 1			; preserve carry state
	and	byte ptr [BP+10], 0FEH	; prepare USER carry
	or	byte ptr [BP+10], BL	; propigate carry returned from 2FH
	pop	BX
	pop	BP
	add	SP, 4			; "pop" temp flags and 5ExxH AX

	EXIT_FUNCTION

	iret

int_21_5D:
	; we handle some here, some in C
	cmp	AL, 0AH
	jz	int_21_5D0A
	cmp	AL, 0
	jz	int_21_5D00
	cmp	al, 0Bh
	jne	int_21_5Dxx_in_C

	; We need this handled for PC-ANYWHERE for Windows.
	; MS-DOS v6.22 just returns unsupported function error.
	;
	mov	ax, 1
	jmp	int21_errout

    int_21_5Dxx_in_C:
	jmp	int21_normal

	public	int_21_5D00
	; /* Alternate (Server?) Call to int 21H (5D00H) */
int_21_5D00:

	ENTER_FUNCTION

	inc	[_sda_in_5D]
	pop	DS
	pop	ES
	xchg	DI, DX	; DS:DI now points to user data
	mov	AX, word ptr DS:[DI]
	mov	BX, word ptr DS:[DI+2]
	mov	CX, word ptr DS:[DI+4]
	mov	DX, word ptr DS:[DI+6]
	mov	SI, word ptr DS:[DI+8]
	mov	ES, word ptr DS:[DI+0EH]
	lds	DI, dword ptr DS:[DI+0AH]

	EXIT_FUNCTION

	jmp	_int_21

	; Set Extended Error Data Values (5D0AH).
	; This call allows for the following sequence of events:
	;
	;  1) a program calls DOS and the DOS call fails
	;  2) before the program can call DOS again to get the
	;     extended error information on the failed call...
	;  3) another program pops up, preempting the "current"
	;     program. The pop-up program gets the "current"
	;     program's extended error information using int 21h
	;     fn 59h
	;  4) the pop-up program makes DOS calls, some of which
	;     may fail and generate new extended error
	;     information.
	;  5) the pop-up program goes back to sleep, restoring the
	;     extended error of the preempted program using int
	;     21h fn 5D0Ah.
	;  6) the preempted program starts running again and,
	;     finally calling int 21 fn 59h, gets the correct
	;     extended error information regarding its last DOS
	;     call.
	;
int_21_5D0A:

	ENTER_FUNCTION

	; get pointer to user buffer (user DS:DX)
	pop	ES	; user DS
	push	AX	; save AX & BX because we'll be using them
	push	BX
	mov	BX, DX	; ES:BX now points to user buffer

	; copy user buffer error values into SDA
	;
	mov	AL, ES:[BX+5]
	mov	_err_locus, AL
	mov	AX, ES:[BX]
	mov	_err_extended, AX
	mov	AX, ES:[BX+2]
	mov	_err_action, AX
	mov	AX, ES:[BX+0AH]
	mov	word ptr _err_esdi, AX
	mov	AX, ES:[BX+0EH]
	mov	word ptr _err_esdi+2, AX
	mov	ax, es:[bx+12h]
	mov	_machine_ID, ax
	mov	ax, es:[bx+14h]
	mov	_err_psp, ax

	; restore user registers
	pop	BX
	pop	AX
	push	ES

	EXIT_FUNCTION

	jmp	short int21_quickout

	; Get current drive
	;
int_21_19:

	ENTER_FUNCTION

	mov	al, _CUR_DRIVE

	EXIT_FUNCTION

	jmp	short int21_quickout

	; SET DTA to address passed in DS:DX, caller's DS is on top of stack
	; followed by ES, CS:IP and flags (CF cleared in saved flags).
	;
int_21_1A:

	ENTER_FUNCTION

	mov	word ptr _DTA, dx	; record caller's DTA offset
	pop	dx			; callers DS into DX
	push	dx			; save it again
	mov	word ptr _DTA[2], dx	; record caller's DTA segment

	EXIT_FUNCTION

	jmp	short int21_quickout

	; Set verify state
	;
int_21_2E:

	ENTER_FUNCTION

	mov	_verify_flag, al

	EXIT_FUNCTION

	jmp	short int21_quickout

	; get DTA
	;
int_21_2F:

	ENTER_FUNCTION

	les	bx, _DTA

	EXIT_FUNCTION

	jmp	short drop_es_and_leave

	; /* 30H Get DOS Version */
int_21_30:
	cmp	SI, 0B2D2H	; magic cookie meaning "debug_call"
	jnz	is30
	cmp	AL, 0DBH	; only DB calls allowed
	jnz	is30
	mov	AX, DI		; "debug_call" function #
	mov	AH, 0DBH
	jmp	int21_normal	; let ROM-DOS handle it
is30:
	ENTER_FUNCTION

	xor	BX, BX
	xor	CX, CX
	cmp	AL, 1
	jz	no_oem
	mov	BH, 0FFH
no_oem:	mov	AX, [_current_psp]	; the version is actually
	mov	DS, AX			; taken from the PSP
	mov	AX, DS:[40H]

	EXIT_FUNCTION

	jmp	short int21_quickout

	; for simple DOS calls, get out with minimum of fuss
	; CF is cleared in caller's flags prior to calling any of the
	; "quick" fns
	;
	public int21_quickout
int21_quickout:

;	; clear the carry
;	push	BP
;	mov	BP, SP
;	and	byte ptr [BP+10], 0FEH	; clear carry
;	pop	BP

	; pop registers and return
	;
	pop	DS
	pop	ES
	iret



	; /* 3305H Get Boot Drive Code */
int_21_3305:
	cmp	AL, 5
	jnz	int_21_3306

	ENTER_FUNCTION

	mov	DL, [bootdrive]

	EXIT_FUNCTION

	jmp	short int21_quickout

	; /* 3306H Get Real DOS Version */
int_21_3306:
	cmp	AL, 6
	jnz	int_21_33XX

	ENTER_FUNCTION

	mov	BX, [_dos_ver]
	mov	DX, [_dos5_flags]

	EXIT_FUNCTION

	jmp	short int21_quickout

int_21_33XX:

	ENTER_FUNCTION

	mov	AL, 0FFH

	EXIT_FUNCTION

	jmp	short int21_quickout

	; 3300H, 3301H, 3302h  Get, Set and Get&Set Break Flag
	;
int_21_3302:
	cmp	al, 2
	ja	int_21_3305

	ENTER_FUNCTION

	xchg	[_BREAK_FLAG], dl

	EXIT_FUNCTION

	jmp	short int21_quickout

int_21_33:
	cmp	al, 1
	ja	int_21_3302

	ENTER_FUNCTION

	jb	ixx2
	mov	[_BREAK_FLAG], DL

ixx2:	mov	DL, [_BREAK_FLAG]

	EXIT_FUNCTION

	jmp	short int21_quickout


	; 34h -- Get address of InDos flag (located in DGROUP) into es:bx
	;
int_21_34:

	ENTER_FUNCTION

	mov	bx, ds                  ; DS = DGROUP on entry
	mov	es, bx
	mov	bx, offset DGROUP:_InDos ; get _InDos flag address in es:bx

	EXIT_FUNCTION

drop_es_and_leave:
	pop	ds			; restore caller's DS
	add	sp, 2			; drop callers saved ES
	iret				; iret to caller

int_21_47:

	ENTER_FUNCTION

	pop	es			; get caller's DS into ES
	push	es			; save caller's DS again

	push	ax			; save regs we will trash soon
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds			; save our DGROUP
	mov	di, si			; es:di-> user buffer for CWD

	mov	dh, 0
	or	dl, dl			; asking about default drive?
	jnz    	i21f47_have_drive_number ; jump if not

	mov	dl, _CUR_DRIVE		; get default drive number (0=A:)
	inc	dl			; user arg is 1=A:

    i21f47_have_drive_number:
	dec	dl			; make 0=A:
	push	es			; save destination seg
    	push	dx			; save drive number
    	push	dx			; pass in drive drive number
	call	DRV_TO_CDS              ; PASCAL, DX:AX=0:FFFF if CDS invalid
	pop	cx			; get drive number back into CX
	pop	es			; restore destination seg

	inc	ax
	jz	i21f47_drive_invalid	; jump if CDS bad
	dec	ax

	mov	ds, dx
	mov	si, ax
	test	[si].CDS_status, (C_NETWORK OR C_JOIN)
	jnz	i21f47_cant_handle_it_here	; jump if network or joined

	push	si
	push	ds
	lds	si, [si].CDS_lpDPB
	mov	ax, word ptr [si].DPB_media
	cmp	ax, HARDMEDIA		   ; has this hard drive been accessed?
	jne	i21f47_cant_do_it_popdssi  ; jump if floppy or if hdsk needs rebuilt

	mov	al, [si].DPB_unit
	call	FindDDTFromDrive
	jc	i21f47_cant_do_it_popdssi  ; give up if drive has no DDT

	cmp	al, [si].DDT_dos_drive     ; sanity check: same device unit?
	jne	i21f47_cant_do_it_popdssi  ; give up if not

	test	[si].DDT_dattr, 1	   ; B0 set if NOT removable
	jz	i21f47_cant_do_it_popdssi  ; give up if drive is removable

	pop	ds			; ok! we should be safe!
	pop	si			; get back ptr to CDS for this drive
	add	si, [si].CDS_skip	; skip over root dir, description
	inc	si                      ; and the initial '\'
	cld

    i21f47_copy_loop:
	lodsb
	stosb
	or	al, al
	jnz    	i21f47_copy_loop

    i21f47_success:
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	xor	ax, ax

	EXIT_FUNCTION

	jmp	int21_quickout		; we're done!

    i21f47_drive_invalid:
	pop	ds			; restore our DGROUP
	pop	di
	pop	si			; restore user's regs
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	mov	ax, ERR_NOTDRIVE
	pop	ds
	pop	es
	stc

	EXIT_FUNCTION

	retf	2

    i21f47_cant_do_it_popdssi:
	pop	si			; throw away ds:si saved on stack
	pop	si

    i21f47_cant_handle_it_here:
	pop	ds			; restore our DGROUP
	pop	di
	pop	si			; restore user's regs
	pop	dx
	pop	cx
	pop	bx
	pop	ax

	EXIT_FUNCTION

	jmp	int21_normal		; handle this func the hard way...

int_21_4D:

	ENTER_FUNCTION

	xor	ax, ax
	xchg	ax, _return_code

	EXIT_FUNCTION

	jmp	int21_quickout

	; /* Set PSP (UNDOC) */
int_21_50:
	ENTER_FUNCTION

	mov	[_current_psp], BX

	EXIT_FUNCTION

	; /* Get PSP (UNDOC) */
int_21_51:
int_21_62:
	ENTER_FUNCTION

	mov	BX, [_current_psp]

	EXIT_FUNCTION

	jmp	int21_quickout

	; Get ptr to list of lists
	;
int_21_52:
	ENTER_FUNCTION

	mov	es, _ROM_DS
	mov	bx, offset DGROUP:_dos_vars

	EXIT_FUNCTION

	jmp	drop_es_and_leave

	; Get verify flag
int_21_54:
	ENTER_FUNCTION

	mov	al, _verify_flag

	EXIT_FUNCTION

	jmp	int21_quickout


	; /* Get/Set Interrupt Vector */
int_21_25:
int_21_35:
	ENTER_FUNCTION

	pop	DS		; now only ES is on the stack
	push	BX		; save BX since we'll change ES & BX

	xor	BX,BX
	mov	ES,BX		; ES points to page 0
	mov	BL,AL		; BX will contain
	shl	BX,1
	shl	BX,1		; ES:BX = ptr to interrupt vector

	cli
	cmp	AH,35H		; 25 is Set Interrupt Vector
	jz	do_35
	mov	WORD PTR ES:[BX],DX
	mov	WORD PTR ES:[BX+2],DS

	pop	BX
	pop	ES		; restore all registers

	EXIT_FUNCTION

	iret

do_35:
	les	BX,ES:[BX]	; get the interrupt vector
	add	SP, 4		; POP off BX,ES

	EXIT_FUNCTION

	iret

	; /* Set Exec State */
	; /* DS:DX -> user buffer */
int_21_4B:
	cmp	AL, 5
	je	int_21_4B05
	jmp	int21_normal	; let ROM-DOS handle it

int_21_4B05:

	ENTER_FUNCTION

	pop	AX		; Get user's DS
	push	AX		; Without changing the stack
	push	BX
	push	DI

	mov	DI, DX		; PSP segment in the Exec State structure
	mov	ES, AX
	mov	AX, word ptr ES:[DI+7]
	mov	ES, AX
	mov	BX, 40H		; Put DOS version at PSP:40H
	mov	AX, [_dos_ver]
	mov	word ptr ES:[BX], AX

	pop	DI
	pop	BX
	xor	AX, AX		; No errors :-)

	EXIT_FUNCTION

	jmp	int21_quickout

	; /* File Seek */
	public	int_21_42
int_21_42:

; some equates required by File Seek
SFT_HANDLES	equ 0		; position within SFT for handle field
ERR_BADFUNC	equ 1
ERR_BADHANDLE	equ 6

	; functions required
	extrn GET_HANDLE_VAL:near
	extrn CALLF_FLAGSOF:near
	extrn H_TO_SFT:near
	extrn FILE_SEEK:near
	extrn _default_error_codes:near

	ENTER_FUNCTION

	; We must preserve ALL registers not used as outputs.
	; In this case, BX, CX and DX.  DS and ES are already
	; saved, and DX:AX are return registers. DX must be
	; preserved in case of error.  "C" functions preserve
	; all other registers, so we don't have to.
	push	DX
	push	CX
	push	BX

	; store "whence" and "position" on stack
	; note: MUST be saved in this order, used as parameters
	; to pascal function "FILE_SEEK"
	push	CX
	push	DX		; position in CX:DX
	push	AX		; whence in AL (SEEK_SET, SEEK_END..)

	; store "handle" on stack
	; note: used as parameter to pascal function "get_handle_val"
	push	BX		; handle #

	; start with no error (error_no = 0)
	mov	word ptr [_error_no], 0

	; set call flags, required by "h_to_sft"
	; unsigned PASCAL callf_flagsof(uchar call)
	mov	AL, 42H
	push	AX		; DOS call 42H (seek)
	call	CALLF_FLAGSOF
	mov	[_sda_callflags], AX	; set callflags

	; convert "handle" (in BX, already on stack) to an
	; "h" handle value.
	; unsigned PASCAL get_handle_val(uchar handle)
	call	GET_HANDLE_VAL
	cmp	AL, 0FFH	; bad handle?
	jz	short bad_seek_handle

	; does this point to an SFT?
	; struct SFT far * PASCAL h_to_sft(int h)
	push	AX
	call	H_TO_SFT
	cmp	AX, 0FFFFH	; failed? (NULLF)
	jz	short bad_seek_handle

	; /* make sure the SFT is valid */
	;if(sda_sftptr->handles == 0)
	;	return FALSE;
	mov	ES, DX
	mov	BX, AX
	cmp	word ptr ES:[BX+SFT_HANDLES], 0
	jz	short bad_seek_handle

	; store SFT ptr in sda for use by file_seek
	; ulong	PASCAL file_seek(ulong pos, uchar mode)
	; note: "pos" and "whence" already pushed on the stack
	; at the beginning of this seek call!
	mov	word ptr [_sda_sftptr], AX
	mov	word ptr [_sda_sftptr+2], DX
	call	FILE_SEEK

	; restore caller registers (BX, CX and DX)
	pop	BX
	pop	CX

	; was there an error during FILE_SEEK?
	cmp	word ptr [_error_no], 0
	jnz	bad_seek_func

	; remove DX from stack.  used as return value, so throw
	; out "old" value for DX.
	add	SP, 2

	EXIT_FUNCTION

	; everything worked!  we're done!
	jmp	int21_quickout

	; return error code 1, invalid function
bad_seek_func:
	; restore old DX from stack
	pop	DX

	mov	AX, [_error_no]

	EXIT_FUNCTION

	jmp	short int21_errout		; report the error

	; bad handle, give up with error!
bad_seek_handle:
	; remove "position" and "whence" from stack
	add	SP, 6

	; restore caller registers (BX, CX and DX)
	pop	BX
	pop	CX
	pop	DX

	; handle or SFT not valid
	mov	AX, ERR_BADHANDLE

	EXIT_FUNCTION

	jmp	short int21_errout

;------------------------------------------------------------
;  This "routine", callable from the "quick" functions, sets
;  the "error_no" and extended error information based on AX,
;  then sets carry flag and returns to caller program.
	public	int21_errout
int21_errout:

	; save error # from AX
	mov	[_error_no], AX

	; convert error # to extended error
	; remember to preserve all "X" registers.  ES is already
	; saved, and so does NOT need to be preserved.
	push	AX			; preserve error #
	push	BX			; preserve handle #
	push	CX
	push	DX
	call	_default_error_codes
	pop	DX
	pop	CX
	pop	BX
	pop	AX

	; set the carry on stack
	push	BP
	mov	BP, SP
	or	byte ptr [BP+10], 1H	; set carry
	pop	BP

	; pop segment registers and return
	pop	DS
	pop	ES
	iret


	; /* Get Extended Error */
int_21_59:

	ENTER_FUNCTION

	mov	AX, _err_extended
	mov	BX, _err_action
	mov	CH, _err_locus
	mov	DI, word ptr _err_esdi
	mov	ES, word ptr _err_esdi+2
	pop	DS
	add	SP, 2

	EXIT_FUNCTION

	iret

;
;   Terminate Process
;
COMMENT ; prototype
void int_20(void)
{}
;
c_func	int_20

	ENTER_FUNCTION

	; set current PSP to user CS
	pop	BX
	pop	AX	; get user "CS" into AX
	push	AX
	push	BX
	call	getDGROUP
	mov	[_current_psp], AX

	EXIT_FUNCTION

	; terminate
	mov	AX,4C00H
	jmp	SHORT _int_21
c_endp	int_20


;
;   Terminate But Stay Resident
;
COMMENT ; prototype
void int_27(void)
{}
;
c_func	int_27

	ENTER_FUNCTION

	; make this do a normal terminate (INT 21) call
	mov	AX,3100H

	; convert # of bytes in DX to # of paras
	mov	CL,4
	add	DX, 000FH
	shr	DX,CL

	;  ETR 3626  BT 12-14-2000
	;
	;  The minimum amount of paragraphs you can release
	;  is 6.  Verified with MS-DOS 6.22.  This was
	;  discovered while debugging ETR 3622.
	;
	cmp	dx, 6
	jae     INT_27_VAL_OK
	mov	dx, 6

INT_27_VAL_OK:

	EXIT_FUNCTION

	jmp	SHORT _int_21
c_endp	int_27


;
;   The Big DOS Function Handler
;
COMMENT ; prototype
void int_21(void)
{}
;

	public _int_21
_int_21:

	ENTER_FUNCTION

	; enable interrupts
	sti

	;  BT 1-19-00 ETR 2457
	;
	;  Because of the ramifications of being reentered, we now enter
	;  a critical section after entering dos (_int_21).  Further more,
	;  we end the critical section when exiting DOS (dos_return).  This
	;  was because MS Networking would copy the SDA and interrupt DOS
	;  at any given time.  The obvious thing to protect was the device
	;  drivers from being reentered.  Because our DOS design is different
	;  than MSDOS, be could not enter critical sections when modifying
	;  CDSs, BUFFERs, and SFTs.  For instance: if we had a pointer to
	;  a buffer and DOS was interrupted by MS networking, we could not
	;  be sure that the buffers had not been changed therefore leaving
	;  us with a bad pointer.
	;
	push	ax
	mov	ah, 82h
	push	ax
	call	_call_int_2a	; Now is the time for redirecters to interrupt DOS
	pop	ax

	; save user segment registers on stack (we change em)
	push	ES
	push	DS
	call	getDGROUP

	push	di
	push	cx

	mov	cx, cQuickFuncs
	mov	di, cs
	mov	es, di
	mov	di, offset QuickFuncsList

	cld
	xchg	ah, al
	repne	scasb
	xchg	ah, al
	jnz     not_a_quick_func

	mov	di, oQuickFuncs
	sub	di, cx
	shl	di, 1
	mov	di, QuickFuncHandlersList[di]
	pop	cx

	push	BP
	mov	BP, SP
	xchg	di, [BP+2]              ; swap callers DI and handler addr
	and	byte ptr [BP+12], 0FEH	; clear carry flag
	pop	BP

	EXIT_FUNCTION

	retn				; "jump" to quick function handler

    not_a_quick_func:
	call	_set_crit_section
	pop	cx
	pop	di

	EXIT_FUNCTION

comment ~
	; these calls use the USER stack and are FULLY reentrant
	push	BX
	mov	BX, offset CS:quick_funcs
again:	cmp	AH, CS:[BX]
	jz	quick_found
	add	BX, 3			; size of byte and near ptr
	cmp	byte ptr CS:[BX], 0	; check for end of list
	jnz	again
	pop	BX
	jmp	short int21_normal

	; this DOS call is handled by the "quick functions" code.
	; this following code restores the caller's BX, and uses
	; a "return" to effectively jump into the quick code.
	;
	; We also clear the CF here while we already have a stack frame
	; built and so that it is set up for successful return
	; by default.
	;
quick_found:
	push	BP
	mov	BP, SP
	mov	BX, word ptr CS:[BX+1]
	xchg	BX, [BP+2]
	and	byte ptr [BP+12], 0FEH	; clear carry
	pop	BP
	ret		; "jump"
end_comment ~


int21_normal:

	ENTER_FUNCTION

	; push all the user registers
	push	BP
	push	DI
	push	SI
	push	DX
	push	CX
	push	BX
	push	AX

	; save stack in current PSP
	mov	ES, [_current_psp]
	mov	word ptr ES:[PSP_USER_STACK+2], SS
	mov	word ptr ES:[PSP_USER_STACK], SP

	; choose a stack for DOS to use
retry_24:
	call	_getstack

	EXIT_FUNCTION

	; do the dos call
	jmp	_dos_entry

COMMENT ; prototype
void PASCAL call_int_2a( unsigned uFunction )
{}
;
public _call_int_2a
_call_int_2a proc pascal near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP		; Windows trashes SP, save it
	mov	AX, [bp+4]
	int	2ah
	mov	SP, BP		; Windows trashes SP, save it
	pop	BP

	EXIT_FUNCTION

	ret	2

_call_int_2a endp


COMMENT ; prototype
void set_crit_section(void)
{}
;
c_func	set_crit_section

	ENTER_FUNCTION

	push	AX
	mov	AX, BEGIN1_CRIT_SECTION
	push	ax
	call	_call_int_2a
	mov	AX, BEGIN2_CRIT_SECTION
	push	ax
	call	_call_int_2a
	pop	ax

	EXIT_FUNCTION

	ret
c_endp	set_crit_section

COMMENT ; prototype
void clear_crit_section(void)
{}
;
c_func	clear_crit_section

	ENTER_FUNCTION

	push	AX
	mov	AX, END2_CRIT_SECTION
	push	ax
	call	_call_int_2a
	mov	AX, END1_CRIT_SECTION
	push	ax
	call	_call_int_2a
	pop	ax

	EXIT_FUNCTION

	ret
c_endp	clear_crit_section


COMMENT ; prototype
void dos_return(void)
{}
;
c_func	dos_return

	ENTER_FUNCTION

	; we are no longer in an Int 21H, 5D00H call
	; this kills the flag that is set when 5D00H is called
	; initially
	mov	[_sda_in_5D], 0

	call	pop_userregs

	;  BT 1-19-00 ETR 2457
	;
	;  Because of the ramifications of being reentered, we now enter
	;  a critical section after entering dos (_int_21).  Further more,
	;  we end the critical section when exiting DOS (dos_return).  This
	;  was because MS Networking would copy the SDA and interrupt DOS
	;  at any given time.  The obvious thing to protect was the device
	;  drivers from being reentered.  Because our DOS design is different
	;  than MSDOS, be could not enter critical sections when modifying
	;  CDSs, BUFFERs, and SFTs.  For instance: if we had a pointer to
	;  a buffer and DOS was interrupted by MS networking, we could not
	;  be sure that the buffers had not been changed therefore leaving
	;  us with a bad pointer.
	;
	call	_clear_crit_section

	EXIT_FUNCTION

	iret
c_endp	dos_return


;
;   Choose a stack for ROM-DOS to use.  This "knows"
;   about both the InDOS and CritErr flags.
;
COMMENT ; prototype
void getstack(void)
{}
;
c_func	getstack

		ENTER_FUNCTION

		; get return address (we'll push it on a different stack later)
		;
		pop	DI

		; Save pointer to user registers, SS:SP in PSP already filled in
		; this will allow us to nest one fn 1..0Ch call within any other
		; calls and vice versa. It will not allow us to reenter either
		; of these two catagories of function calls with a like call,
		; even inside an int 24.
		;
		push	ax
		call	getDGROUP

		; MSDOS stores the previous stack ptr with the words reversed
		;
		mov	AX, word ptr [_userregs]
		mov	word ptr [_olduserregs+2], AX
		mov	AX, word ptr [_userregs+2]
		mov	word ptr [_olduserregs], AX
		pop	ax

		inc	[_InDOS]		; in DOS now

		mov	WORD PTR [_userregs+2], SS ; record user's ss:sp
		mov	WORD PTR [_userregs], SP

		mov	BP, _pDiskStackTop ; assume disk stack
		cmp 	byte ptr [_using_boot_stack], 0	; if haven't exec'ed shell
		jne	havestack		; then use disk stack regardless

		cmp	[_CritErr], 0		; if not inside an int 24
		je	choose_stack		; select stack based on fn #

		; disk stack is immediately below char stack if error occured
		; on the char stack then we want to use the disk stack for
		; the crit error handler, otherwise we want to use the char stack
		;
		push	ax
		mov	ax, _pDiskStackTop
		mov	byte ptr [_int28_OK], 0 ; no int 28s during crit err
		cmp	word ptr [_crit_stack], ax
		pop	ax
		ja	choose_stack		; use assumed disk stack
		mov	BP, _pCharStackTop ; use char stack

		; now we have a stack but we need to know if the call is
		; not 1..0Ch and, if so, reset the crit error flag
		; the "least duplicated code" option is to test _CritErr again
		;
	choose_stack:
		or	ah, ah
		jz	not_char_stack_call
		cmp	ah, 0Ch
		ja	not_char_stack_call
		cmp	[_CritErr], 0		; if inside an int 24
		jne	havestack		; keep prviously selected stack

		mov	byte ptr [_int28_OK], 1 ; OK to call int 28h during this fn

	use_char_stack:
		mov	BP, _pCharStackTop ; point to char stack
		jmp	short havestack

	not_char_stack_call:
		mov	byte ptr [_int28_OK], 0 ; no int 28s
		mov	[_CritErr], 0		; reset crit error

	noreset:
	havestack:
		; we are only in DOS once, don't bother saving this stuff...
		cmp	[_InDOS], 1
		jz	anystack

		; save sda_reqhdr in case device calls another device
		push	SI
		push	DI
		push	DS
		pop	ES
		mov	CX, 30
		mov	SI, GOFFSET _sda_reqhdr
		mov	DI, GOFFSET _old_reqhdr
		cld
		rep	movsb
		pop	DI
		pop	SI

		; save old handle
		mov	AX, word ptr [_sda_handle]
		mov	word ptr [_oldhandle], AX
		mov	AL, byte ptr [_sda_sft_h]
		mov	byte ptr [_old_sfth], AL

	anystack:
		; make a DOS stack, BP will be our SP
		mov	AX, DS
		cli
		mov	SS, AX
		mov	SP, BP
		sti

		; set direction forward
		cld

		; go back to whoever called us.
		push	DI

		EXIT_FUNCTION

		ret

		; DOS has been reentered too many times!!
	stackfail:
IFDEF DEBUG
 IF (DEBUG GT 1)	; only if debug > 1
		mov	AX, DS
		cli
		mov	SS, AX
		mov	SP, BP
		sti

		; fatal error, "bad_reenter" never returns
		extrn	_bad_reenter:near
		call	_bad_reenter
ELSE
		mov	[_InDOS], 0
		jmp	noreset
ENDIF
ELSE
		mov	[_InDOS], 0
		jmp	noreset
ENDIF
c_endp	getstack


COMMENT ; prototype
void pop_userregs(void)
{}
;
c_func	pop_userregs

	ENTER_FUNCTION

	; make sure we haven't overflowed the stack
	call	_chkstack

	; get the return address of the function call
	pop	DX

	; get back the user stack
	cli
	mov	SS, word ptr [_userregs+2]
	mov	SP, word ptr [_userregs]

	; restore pointer to nested user's registers. MSDOS swaps the
	; word order of the copy.
	;
	mov	AX, word ptr [_olduserregs+2]
	mov	word ptr [_userregs], AX
	mov	AX, word ptr [_olduserregs]
	mov	word ptr [_userregs+2], AX

	; finagel registers around to have our return address
	; on stack
	mov	BP, SP
	mov	AX, [BP+16]	; get user ES into AX
	mov	[BP+16], DX	; save near return in user ES slot
	push	AX		; push user ES on stack

	; we're getting out of DOS, say so
	dec	[_InDOS]
	mov	byte ptr [_int28_OK], 0 ; no int 28s now

	; we are "reentering" DOS if this is a critical error
	cmp	[_CritErr], 0
	jnz	reentered

	; restore ptr to "USER regs" from temp place if needed
	cmp	[_InDOS], 0
	jz	not_reentered

reentered:
	; restore old sda_req_hdr in case someone used it
	push	DS
	pop	ES
	mov	CX, 30
	mov	SI, GOFFSET _old_reqhdr
	mov	DI, GOFFSET _sda_reqhdr
	cld
	rep	movsb

	; restore handle if needed
	les	BX, dword ptr [_userregs]
	mov	AX, ES:[BX]
	mov	[_int21_ax], AX		; user AX
	cmp	AH, 0CH
	ja	no_handle
	call	GET_CALL_FLAGS
	push	word ptr [_oldhandle]
	call	HANDLE_TO_SDA
	or	AX, AX			; did it work?
	jnz	no_handle
	push	word ptr [_old_sfth]	; no, convert sfth into sda
	call	H_TO_SDA
no_handle:

not_reentered:
	sti

	; get the USER registers back
	pop	ES
	pop	AX
	pop	BX
	pop	CX
	pop	DX
	pop	SI
	pop	DI
	pop	BP
	pop	DS

	EXIT_FUNCTION

	ret
c_endp	pop_userregs


COMMENT ; prototype
void chkstack(void)
{}
;
	extrn	_stk_overflow:near
	STACKWORD	EQU	5678H

c_func	chkstack

	ENTER_FUNCTION

	push	bx
	mov	bx,_pCharStack
	CMP	[bx],STACKWORD
	JNZ	give_up_and_die
	mov	bx, _pDiskStack
	cmp	[bx], STACKWORD
	JNZ	give_up_and_die
	pop	bx

	EXIT_FUNCTION

	RET

give_up_and_die:
	pop	bx
	CALL	_stk_overflow
c_endp	chkstack

cEndCode

cBegData
	assume CS:DGROUP
	extrn	is_hma_enabled:near

; For historical reasons we need to turn of the HMA when load programs.
; For Scientel we need to leave the A20 line on all the time and added
; an /CONTROLA20 switch to himem to tell HIMEM to not try and turn it
; off (the hardware won't anyway...). So we loop up the max of HIMEM's
; locala20count (or 255 times) +1 before giving up on trying to disable
; the HMA.
;
	public	disable_hma
disable_hma:

	ENTER_FUNCTION

IF 1
	test	byte ptr [_dos5_flags+1], DOS_IN_HMA
	jz	no_disable
	mov	cx, 256d

disable_again:
	push	cx
	mov	AH, 6		; local disable HMA
	call	dword ptr [xms_addr]
	call	is_hma_enabled
	pop	cx
	loopne	disable_again

no_disable:
ENDIF

	EXIT_FUNCTION

	ret

;-------------------------
;  This routine passes control from DOS to the user
;  program that was spawned with i21 4Bh.
;
;  On Entry
;	CX:SI = user CS:IP
;	BX:DI = user SS:SP
;	DX    = user DS, ES
;
	public	__make_it_so
__make_it_so:

	ENTER_FUNCTION

	; disable the HMA in case user program uses "wrap around"
	; feature of 8086.  Remember, when HMA is disabled, ROM-DOS
	; CODE segment is no longer available.
	push	CX
	push	BX
	push	DX
	call	disable_hma
	pop	DX
	pop	BX
	pop	CX

	; We are completely out of DOS, reset InDOS and CritErr and stack
	cli
	mov	AL, [_booting]	; 0 or 1
	mov	[_InDOS], AL
	mov	[_CritErr],0

	; create user DS and ES
	mov	DS, DX
	mov	ES, DX

	; create use stack
	mov	SS, BX
	mov	SP, DI
	sti

	; push user "start" address on stack
	; we will RETF to effectively JMP to it
	push	CX
	push	SI

	; zero all "unused" registers
	xor	AX, AX
	xor	BX, BX
	xor	CX, CX
	xor	DX, DX
	xor	SI, SI
	xor	DI, DI
	xor	BP, BP

	EXIT_FUNCTION

	; jump to user program
	retf
cEndData

cBegCode

;
;   special routine!!  never goes back into C, but JMPs
;   to user program.
;
COMMENT ; prototype
void go_asm(unsigned ip, unsigned cs, unsigned sp, unsigned ss, unsigned ds)
{}
;
c_func	go_asm

	ENTER_FUNCTION

	; throw away C return address
	pop	AX

	; get the user CS:IP into CX:SI
	pop	SI	; IP
	pop	CX	; CS

	; get the user SS:SP into BX:DI
	pop	DI	; SP
	pop	BX	; SS

	; get the user DS and ES into SI register
	pop	DX	; user ES,DS

	; jmp to the routine that runs the user program
	mov	AX, GOFFSET __make_it_so
	push	DS
	push	AX

	EXIT_FUNCTION

	retf
c_endp	go_asm

cEndCode

cBegCode


COMMENT ~
/*
   -------------------------------------------------------


		INTERRUPT HANDLERS


   -------------------------------------------------------
*/
~


;
;   This is the default divide-by-zero (INT 00H) handler
;
COMMENT ; prototype
void int_00(void)
{}
;
c_func	int_00

	ENTER_FUNCTION

	; get back our DS
	call	getDGROUP

	; get the offender's address off the stack
	mov	BP, SP
	mov	DX, [BP]	; IP
	mov	CX, [BP+2]	; CS

	; display the message
	push	DX		; IP
	push	CX		; CS
	call	_divide_by_zero
	add	SP, 4

	EXIT_FUNCTION

	; terminate the current process
	mov	AX,4C05H
	int	21H
c_endp	int_00


;
;   The default BIOS break (INT 1BH) handler.  Lets
;   ROM-DOS know a break has happened (better even
;   than ^C).
;
COMMENT ; prototype
void int_1B(void)
{}
;
c_func	int_1B

	ENTER_FUNCTION

	push	ds
	call	getDGROUP
	mov	_hitbrk, 1
	pop	ds

	EXIT_FUNCTION

	iret
c_endp	int_1B


;
;   The default ctrl-break handler.  Tells DOS to
;   abort the current process.
;
COMMENT ; prototype
void int_23(void)
{}
;
c_func	int_23

	ENTER_FUNCTION

	stc

	EXIT_FUNCTION

	retf
c_endp	int_23


;
;   Absolute Disk Read
;
COMMENT ; prototype
void int_25(void)
{}
;
	public	_int_25
_int_25:
	mov	ah, 1		; TRUE for read

absrdwr:
	ENTER_FUNCTION

	; enable interrupts
	sti

	; save all the user registers
	push	ES
	push	DS
	push	BP
	push	DI
	push	SI
	push	DX
	push	CX
	push	BX
	push	AX

	; get a DOS stack to use
	call	_getstack
	call	_abs_rdwr

	; we're done with the DOS stack
	call	pop_userregs

	; set carry if error
	cmp	AX, 0100H
	jz	dnoerr
	stc

	EXIT_FUNCTION

	retf		; leave flags word on the stack

dnoerr:	clc
	mov	CX, 0

	EXIT_FUNCTION

	retf		; leave flags word on the stack


;
;   Absolute Disk Write
;
COMMENT ; prototype
void int_26(void)
{}
;
	public	_int_26
_int_26:
	mov	AH, 0		; FALSE for write
	jmp	short absrdwr



COMMENT ~
/*
   -------------------------------------------------------


		INTERRUPT GENERATORS


   -------------------------------------------------------
*/
~

;
;   A ^C (or Break) has been detected, so see if the
;   user want to abort the process (default) or do the
;   DOS call all over again.
;
COMMENT ; prototype
void generate_int23(void)
{}
;
c_func	generate_int23

	ENTER_FUNCTION

	; get onto user stack (and out of DOS)
	call	pop_userregs

	; save stack pointer (in case user messes it up)
	push	DS
	call	getDGROUP
	mov	word ptr [_int23_sp], SP
	add	word ptr [_int23_sp], 2
	pop	DS

	clc
	int	23H

	; abort the DOS call
	jnc	i23_retry
	push	DS
	call	getDGROUP
	mov	[_special_ret], 100H
	mov	AX, 4C00H
	pop	DS
	jmp	short i23_redo

	; restore stack pointer (in case user messed it up)
	; user most NOT mess up stack segment
i23_retry:
	push	DS
	call	getDGROUP
	pop	word ptr [_user_ds]
	mov	SP, word ptr [_int23_sp]
	mov	DS, word ptr [_user_ds]

	; redo the DOS call
i23_redo:

	EXIT_FUNCTION

	jmp	_int_21

c_endp	generate_int23



;
;   Used with an IFS, generate a critical error.
;   Can only happen inside an Int 2FH, 1206H call.
;
COMMENT ;
void ifs_crit_err(void)
{}
;
c_func	ifs_crit_err


	ENTER_FUNCTION

	; fill in the SDA with the IFS info
	mov	[_crit_locus], AH
	mov	[_crit_drive], AL
	mov	word ptr [_sda_devptr], SI
	mov	word ptr [_sda_devptr+2], BP

	; call the real critical error handler
	push	DI
	inc	byte ptr [_in_ifs_crit_err]	; in crit err now

	call	_generate_int24

	dec	byte ptr [_in_ifs_crit_err]	; back from crit err
	pop	DI

	EXIT_FUNCTION

	ret

c_endp	ifs_crit_err



;------------------------------------------------------
;   Used to generate a critical error on FAT system.
;
;   Returns TRUE if caller should Retry the operation.
;
COMMENT ;
int fat_crit_err(unsigned error)
{}
;
c_func	fat_crit_err

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	push	P[BP]			; error #
	call	_generate_int24
	pop	CX

	; On return from generate_in24 AL will either be SAID_IGNORE (0) or
	; SAID_RETRY (1) since both fail and abort will have been handled
	; by generate_int24. All we have to do is to convert these codes
	; to a boolean that is TRUE if the device call should be retried
	; or FALSE if it should be ignored.
	;
	cbw

	; return with AX indicating whether to retry or ignore the device call
	;
IF 1
	pop	BP

	EXIT_FUNCTION

	ret
ELSE
	; DOS 6 release way, redo the whole DOS call
	cli
	mov	SS, word ptr [_userregs+2]
	mov	SP, word ptr [_userregs]
	dec	[_InDOS]
	sti
	jmp	retry_24
ENDIF
c_endp	fat_crit_err


; "action is allowed" bits in the critical error locus
; (in AH register on entry to int 24h)
;
IGNORE_OK	equ	20h
RETRY_OK	equ	10h
FAIL_OK		equ	08h

; Disk area bits in which the critical error occured if(WAS_DISK_ERROR & AH)
; The disk area is identified by the value in B1,B0. To determine if the
; error occured in a specific disk area, and AH (or a copy of it) with the
; DISK_AREA_MASK and then compare the result to the appropriate ???_AREA
; equate listed below.
;
WAS_DISK_ERROR	equ	80h	; this bit set in AH if crit err on a disk
DISK_AREA_MASK	equ	03h	; and AH with DISK_AREA_MASK then compare of the disk identified in B1,B0
BOOT_AREA	equ	0	; values of B1,B0 that identify disk area
FAT_AREA	equ	1
ROOT_DIR_AREA	equ	2
DATA_AREA	equ	3

; action codes returned from int 24h in the AL register
;
SAID_IGNORE	equ	0
SAID_RETRY	equ	1
SAID_ABORT	equ	2
SAID_FAIL	equ	3


; validates that an int 24h return code (action code) is valid
; according to the the error locus. If the action code is SAID_IGNORE
; and the IGNORE_OK is not part of the error locus then the the action
; code is promoted to SAID_FAIL. Likewise, SAID_RETRY may be promoted to
; SAID_FAIL and SAID_FAIL may be promoted to SAID_ABORT (which is always
; an acceptable action code). See DOS Prog. Ref. pgs 737-740
;
; on entry:
;	ah	= error locus
;	al 	= action code
; on exit:
;	ah	= original error locus
;	al	= (possibly promoted) error locus;
; regs used:
;	al, flags
;
validate_action_code proc near

	ENTER_FUNCTION

	cmp	al, SAID_IGNORE		; "user" said ignore?
	jne	VAC_check_retry		; no
	test	ah, IGNORE_OK		; yes, ignore valid?
	jnz	VAC_exit		; yes
	jmp	short VAC_say_fail	; no, promote ignore to fail

VAC_check_retry:
	cmp	al, SAID_RETRY		; retry?
	jne	VAC_check_fail		; no
	test	ah, RETRY_OK		; yes, retries OK?
	jnz	VAC_exit		; yes

VAC_say_fail:
	mov	al, SAID_FAIL		; no, promote retry to fail

VAC_check_fail:
	cmp	al, SAID_FAIL		; fail?
	jne	VAC_abort		; no
	test	ah, FAIL_OK		; yes, OK to fail?
	jnz	VAC_exit		; yes

VAC_abort:
	mov	al, SAID_ABORT		; can only be abort now

VAC_exit:

	EXIT_FUNCTION

	retn
validate_action_code endp


;	A critical error happened.  That means a device
;	has reported an error and we want the user to know
;	about it.  This generates a call to the INT 24H
;	handler which will ask for Abort,Retry,Fail or Ignore.
;
COMMENT ;
void generate_int24(unsigned di)
{}
;
c_func	generate_int24

	ENTER_FUNCTION

	; save all these on the DOS stack
	;
	push	BP
	mov	BP, SP
	push	SI
	push	DI

	; save DOS stack since we will switch to USER stack
	;
	push	[_error_no]
	mov	word ptr [_crit_stack+2], SS
	mov	word ptr [_crit_stack], SP

	; set up registers for INT 24H call
	;
	mov	AH, [_crit_locus]
	mov	AL, [_crit_drive]
	mov	DI, P[BP]
	mov	SI, word ptr [_sda_devptr]
	mov	BP, word ptr [_sda_devptr+2]

	; save the current error code on our critical stack
	; change to the user stack, but do NOT pop off register set
	;
	cli
	mov	SS, word ptr [_userregs+2]
	mov	SP, word ptr [_userregs]

	; we are in a critical error
	;
	dec	[_InDOS]		; no longer in DOS
	mov	[_CritErr], 1		; now in critical error
	sti

	; Call the Critical Error Handler (might be in user space).
	; Be sure and save our error code since DOS may be re-entered
	; to display the critical error message.
	;
	int	24H

	; save the user stack once again
	;
	call	getDGROUP
	cli
	mov	word ptr [_userregs+2], SS
	mov	word ptr [_userregs], SP

	; we are no longer in a critical condition
	;
	inc	[_InDOS]		; we're back in DOS
	mov	[_CritErr], 0		; and no longer in a critical err
	sti

	; make sure the return code from int 24h suggests a valid action
	; IAW the error locus and, if it doesn't, convert the returned
	; code into one that's allowed.
	;
	mov	AH, [_crit_locus]
	call	validate_action_code

	; MSDOS 6.22 does NOT return to IFS (or any other caller) on abort
	;
	cmp	al, SAID_ABORT
	je	@do_abort

	; Action code is one of Retry, Ignore or Fail: get back on DOS' stack
	; restore the current error code
	;
	cli
	mov	SS, word ptr [_crit_stack+2]
	mov	SP, word ptr [_crit_stack]
	sti
	pop	[_error_no]

	; if inside of an IFS call, just return the validated action code
	; for the IFS to act on. (flag inc/dec by ifs_crit_err() above).
	;
	cmp	byte ptr [_in_ifs_crit_err], 0
	ja	gen_int24_exit

; ? leave error_no alone for IFS calls

	cmp	al, SAID_FAIL		; if failing call, branch
	je	@do_fail

	mov	[_error_no], 0		; Clear error number on retry/ignore
	cmp	al, SAID_IGNORE		; if ignoring error, branch
	je	@do_ignore
	jmp	@do_retry		; else retry the call

@do_fail:
	cmp	[_int21_ah], 47H	; get current directory?
	jnz	have_error_code
	mov	[_error_no], 0FH	; "drive not valid"

have_error_code:

	EXIT_FUNCTION

	jmp	_dos_exit	; fail the DOS call: exit w/ error_no!=0


@do_abort:
	cmp	byte ptr [_in_ifs_crit_err], 0	; won't return to IFS
	je	IFS_flag_reset			; so if inside an IFS now
	dec	byte ptr [_in_ifs_crit_err]	; dec the in crit err flag

	; on disk critical errors, forget the buffers
	;
IFS_flag_reset:
	test	AH, WAS_DISK_ERROR
	jnz	dont_trash_buffers

	; get back onto ROM-DOS stack to invalidate buffers
	;
	cli
	mov	SS, word ptr [_crit_stack+2]
	mov	SP, word ptr [_crit_stack]
	sti
	call	_regs_to_sda		; which drive is it?
	call	_buf_invalidate		; invalidate all buffers on this drive
	cli
	mov	SS, word ptr [_userregs+2]
	mov	SP, word ptr [_userregs]
	sti

dont_trash_buffers:
	mov	[_special_ret], 200H	; return type 2 (Abort from Crit)

	EXIT_FUNCTION

	mov	AX, 4C00H
	int	21H			; Abort the program

	; Note:	In the case of an int 21h fn 4Bxxh call, the sda_sft ptr
	; is restored by the critical_error() function (DOSDEV.C), not
	; by regs_to_sda (4Bh calls do not "have handles")
	;
	; SPR 1638 (de) on a file close, calling regs_to_sda() can set
	; error_no to 6 (bad handle) since the handle count is decremented
	; before the device is called. Make sure error_no == 0 on ignore
	; and retry.
	;
@do_ignore:
@do_retry:
	push	AX			; save user response
	call	_regs_to_sda		; get back "normal" state
	pop	AX			; restore user response
	mov	_error_no, 0

gen_int24_exit:
	pop	DI			; restore error code
	pop	SI			; and ptr to device driver header
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	generate_int24


;
;	ROM-DOS is waiting for user input (and is only
;	InDOS once).  Interrupt 28H (DOS Idle) gives a
;	TSR a chance to do it's magic while "inside"
;	of this non-reentrant DOS.
;
COMMENT ;
void generate_int28(void)
{}
;
c_func	generate_int28

	ENTER_FUNCTION

	; save current stack location
	push	BP
	push	SI
	push	DI

	; BT 1-19-00 ETR 2457
	;
	; Because of the ramifications of being reentered, we now enter
	; a critical section after entering dos (_int_21).  Further more,
	; we end the critical section when exiting DOS (dos_return).  This
	; was because MS Networking would copy the SDA and interrupt DOS
	; at any given time.  The obvious thing to protect was the device
	; drivers from being reentered.  Because our DOS design is different
	; than MSDOS, be could not enter critical sections when modifying
	; CDSs, BUFFERs, and SFTs.  For instance: if we had a pointer to
	; a buffer and DOS was interrupted by MS networking, we could not
	; be sure that the buffers had not been changed therefore leaving
	; us with a bad pointer.
	;
	; The exception is when DOS is idle, as when DOS is waiting for
	; user input and thus is IDLE.  We should not be using any buffers,
	; CDSs, or SFTs when DOS is idle.
	;
	call	_clear_crit_section

	mov	al, [_int28_ok]	; save enable state of int 28s
	push	ax	; can be modified by pop-ups inside int 28

	mov	[_int28_sp], SP

	int	28H

	; get back current stack location
	call	_getDS
	mov	DS, AX
	cli
	mov	SS, AX
	mov	SP, [_int28_sp]
	sti
	cld

	pop	ax		; back in original call
	mov	[_int28_ok], al	; restore enable state of int 28s

	; BT 1-19-00 ETR 2457
	;
	; Because of the ramifications of being reentered, we now enter
	; a critical section after entering dos (_int_21).  Further more,
	; we end the critical section when exiting DOS (dos_return).  This
	; was because MS Networking would copy the SDA and interrupt DOS
	; at any given time.  The obvious thing to protect was the device
	; drivers from being reentered.  Because our DOS design is different
	; than MSDOS, be could not enter critical sections when modifying
	; CDSs, BUFFERs, and SFTs.  For instance: if we had a pointer to
	; a buffer and DOS was interrupted by MS networking, we could not
	; be sure that the buffers had not been changed therefore leaving
	; us with a bad pointer.
	;
	; The exception is when DOS is idle, as when DOS is waiting for
	; user input and thus is IDLE.  We should not be using any buffers,
	; CDSs, or SFTs when DOS is idle.
	;
	call	_set_crit_section

	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	generate_int28


;
;	This function is used by to speed up the console
;	display.  All output to the console goes through
;	here.  INT 29H itself is implemented in the CON
;	device.
;
COMMENT ;
void PASCAL generate_int29(uchar c)
{}
;
	public	GENERATE_INT29
GENERATE_INT29	PROC NEAR

	ENTER_FUNCTION

	push	BP
	mov	BP,SP
	mov	AL,P[BP]

	; save DS from Lucent's SHAD_TSR which considers
	; saving DS "duplicatous and redundant". MS-DOS saves
	; DS for other reasons.
	;
	push	ds
	int	29H
	pop	ds

	pop	BP

	EXIT_FUNCTION

	ret	2

GENERATE_INT29	ENDP


;
;	All INT 21H, 5FxxH calls are passed through to
;	INT 2FH, func 111EH.  The call is on the stack.
;
COMMENT ;
void generate_int2F5F(void)
{}
;
	public	_generate_int2F5F
_generate_int2F5F:

	ENTER_FUNCTION

	push	BP
	push	SI
	push	DI
	push	DS

	; save 5FxxH call on stack
	lds	BX, [_userregs]
	push	word ptr DS:[BX]

	; get all the user registers
	mov	AX, word ptr DS:[BX+2]	; actually user BX
	mov	CX, word ptr DS:[BX+4]
	mov	DX, word ptr DS:[BX+6]
	mov	SI, word ptr DS:[BX+8]
	mov	DI, word ptr DS:[BX+10]
	mov	BP, word ptr DS:[BX+12]
	mov	ES, word ptr DS:[BX+16]
	mov	DS, word ptr DS:[BX+14]
	xchg	BX, AX			; get the real BX
	mov	AX, 111EH

	EXIT_FUNCTION

	jmp	SHORT L2F2

;
;	Generate an INT 2FH.  Unlike its partner, this function
;	requires only 1 parameter: the 11xxH call number.  This
;	is part of the IFS interface for ROM-DOS.
;
COMMENT ;
void generate_int2Fx(uchar call)
{}
;
	public	_generate_int2Fx
_generate_int2Fx:

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI
	push	DI
	push	DS

	; reuse code from below (it need only set AX)
	push	CX

	EXIT_FUNCTION

	jmp	SHORT L2F1

;
;	Generate an INT 2FH.  This is the IFS interface
;	for ROM-DOS.
;
COMMENT ;
void generate_int2F(uchar call, unsigned stk, unsigned call_cx, void far *esdi, void far *dssi)
{}
;
	public	_generate_int2F
_generate_int2F:

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI
	push	DI
	push	DS

	; put the word on the stack, and value into CX
	mov	CX, P+2[BP]
	push	CX
	mov	CX, P+4[BP]

	; point ES:DI, DS to the right place
	les	DI, P+6[BP]
	lds	SI, P+10[BP]

L2F1:	; get the proper call into AL
	mov	AL, P[BP]
	mov	AH, 11H

	; set the other parameters and do the 2FH interrupt
L2F2:	int	2FH
	pop	DS	; toss out word on stack
	pop	DS

	jnc	L2F3
	mov	[_error_no], AX

	; store the return registers (for possible return to user)
L2F3:	mov	[_int2f_ax], AX
	mov	[_int2f_bx], BX
	mov	[_int2f_cx], CX
	mov	[_int2f_dx], DX
	mov	[_int2f_di], DI

	; pop stack and return
	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret


;
; Generate an INT 2FH fn 1121h: Seek from end of remote file.
; IFS should return new file position in dx:ax.
;
COMMENT ;
ulong remote_seek(ulong relPos)
{}
;
SFT_file_size	equ	11h
SFT_file_offset	equ	15h
	public	_remote_seek
_remote_seek	proc

	ENTER_FUNCTION

	push	bp
	mov	bp, sp
	push	di

	les	di, [_sda_sftptr] ; es:di points to SFT for file
	mov	dx, P[BP]
	mov	cx, P+2[BP]	; cx:dx is offset from remote EOF
	push	cx
	push	dx		; save offset from EOF
	mov	ax, 1121h
	int	2Fh		; returns new file position in dx:ax

	; LANTASTIC does not handle this function but does return the
	; value passed in CX:DX in DX:AX with the CF clear! Have to
	; assume that if we get back what we passed then we treat
	; this like a normal seek and just adjust SFT.file_offset
	;
	pop	bx		; get passed value in CX:BX
	pop	cx
	cmp	ax, bx
	jne	RS_went_OK
	cmp	cx, dx
	jne	RS_went_OK

	mov	ax, es:[di].SFT_file_size	; get file size
	mov	dx, es:[di].SFT_file_size[2]
	add	ax, bx				; seek
	adc	dx, cx

    RS_went_OK:
	pop	di		; return new file position in DX:AX
	pop	bp

	EXIT_FUNCTION

	ret

_remote_seek	endp

COMMENT ~
/*
   -------------------------------------------------------


		SUPPORT FUNCTIONS


   -------------------------------------------------------
*/
~

COMMENT ;
void far * get_vector(uchar vector)
{}
;
c_func	get_vector

	ENTER_FUNCTION

	push	BP
	mov	BP,SP

	; get the vector address
	xor	BX, BX
	mov	ES, BX
	mov	BL, P[BP]
	shl	BX, 1
	shl	BX, 1

	; return the vector in DX:AX
	cli
	les	AX, ES:[BX]
	mov	DX, ES
	sti

	pop	BP

	EXIT_FUNCTION

	ret

c_endp	get_vector


COMMENT ;
void set_vector(uchar vector, void far *addr)
{}
;
c_func	set_vector

	ENTER_FUNCTION

	push	BP
	mov	BP,SP

	; get the vector address
	xor	BX, BX
	mov	ES, BX
	mov	BL, P[BP]
	shl	BX, 1
	shl	BX, 1

	; get the new address into registers
	mov	AX, P+2[BP]
	mov	DX, P+4[BP]

	; place the new address in the vector
	cli
	mov	ES:[BX], AX
	mov	ES:[BX+2], DX
	sti

	pop	BP

	EXIT_FUNCTION

	ret

c_endp	set_vector

comment ~ ; prototype ;
void set_process_ints(void far *term_adr)
{}
~
c_func set_process_ints

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	DS
	push	SI
	push	DI
	lds	SI, P[BP]
	xor	DI, DI
	mov	ES, DI
	add	DI, 22H*4
	mov	CX, 6		; move 6 words (3 int vectors)
	cld
	rep	movsw
	pop	DI
	pop	SI
	pop	DS
	pop	BP

	EXIT_FUNCTION

	ret
c_endp set_process_ints

cEndCode


	END
