;
;   $Id: FARDOS.ASM 1.5 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
---------------------------------------------------------------

   FARDOS.ASM  created 07/28/99  by Brandon Thomas

   Copyright (c) 1999-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

--------------------------------------------------------------- ~
include macros.inc
include dostruct.inc



cBegData
		public	_fpFarDOSCall
		public	_uFarDOSCallSegment
	_fpFarDOSCall	label dword
IF (VDOS GE 7)	; DOS 7+ only
				dw	offset FarDOSCall
ELSE
				dw	?
ENDIF
	_uFarDOSCallSegment	dw	?

	_fpReturnAddress label dword
	_uReturnOffset		dw	?
	_uReturnSegment		dw	?

cEndData

IF (VDOS GE 7)	; DOS 7+ only

cBegCode

	extrn STRCHR:near
	extrn TOUPPER:near
	extrn STRLEN:near
	c_extrn xitoa,near
	extrn MEMMOVE:near
	extrn ATOI:near
	extrn STRCAT:near
	extrn GET_FAT_ENTRY:near
	extrn GET_NEW_CLUSTERS:near
	extrn ZERO_CLUSTER:near
	extrn LCLUS_TO_PCLUS:near
	extrn CLUS_TO_SEC:near
	extrn BUF_GETSECTOR:near
	extrn FMEMCPY:near
	extrn ENAME_TO_DOT:near
	extrn DOT_TO_ENAME:near
	extrn DRIVE_TO_SDA:near
	extrn DEFDRIVE_TO_SDA:near
	extrn FSTRLEN:near
	c_extrn lastchar,near
	extrn IS_LEAD_BYTE:near
	c_extrn change_of_disk,near
	extrn BUF_SET_MODIFIED:near
	extrn MEMSET:near
	c_extrn get_filedate,near
	c_extrn change_to_root,near
	extrn FREE_THE_FAT:near
	extrn BUF_FLUSH_ALL:near
	C_extrn alloc_next_free,near
	extrn SET_FAT_ENTRY:near
	c_extrn get_new_sft,near
	c_extrn get_new_handle,near
	extrn SET_HANDLE_VAL:near
	extrn H_TO_SFT:near
	extrn NAME_CHANGE:near
	extrn STRUPR:near
	extrn HANDLE_TO_SDA:near
	c_extrn dev_call,near
	extrn MEM_Z_ALLOC:near
	extrn GET_CALL_FLAGS:near
	c_extrn fcb_to_sda,near
	extrn KRN_ASSERT:near
	extrn NAME_MATCH:near
	extrn ATTR_MATCH:near
	extrn _LMULU:near
	extrn _LDIVU:near
	c_extrn leapyear,near
	extrn FIND_DEVICE:near
	extrn FMEMSET:near
	c_extrn dev_to_sft,near
	c_extrn dev_openclose,near

COMMENT ; prototype
void PASCAL FarDOSCall( unsigned uFunctionIndex )
{}
;
	public	FarDOSCall
FarDOSCall proc far

	;
	;  ASSUMES : DS = cBegData
	;

	; Get the return address off the stack and save it
	; in our own variable which is not on the stack
	;
	pop	bx			; offset
	mov	_uReturnOffset, bx
	pop	bx			; segment
	mov	_uReturnSegment, bx

	; Get the function number index into the jump table
	; and go to the code which handles pascal and c functions
	;
	pop	bx ; function index
	cmp	bx, ((offset StartOfPascalFunctions) - (offset StartOfCFunctions))
	jb	IsACCall

	; If this is a pascal function we won't need to put the
	; function index back on the stack because pascal functions
	; remove there own parameters from the stack
	;

IsAPascalCall:

	call	word ptr cs:[(offset DOSFuncLookup)+bx]
	jmp	dword ptr _fpReturnAddress

	; If this is a C function we will need to put the function
	; index back on the stack because the caller will remove
	; the parameters from the stack
	;

IsACCall:

	call	word ptr cs:[(offset DOSFuncLookup)+bx]
	push	bx ; doesn't really have to be the function index
	jmp	dword ptr _fpReturnAddress



	; This is a table of offsets for functions which are called
	; from romdos to a far DOS module.  C functions must appear
	; in the list before the pascal functions
	;

DOSFuncLookup:

	; Start of the c functions
	;

StartOfCFunctions:

	dw offset xitoa                	; 0
	dw offset get_filedate         	; 2
	dw offset change_to_root       	; 4
	dw offset get_new_sft          	; 6
	dw offset get_new_handle       	; 8
	dw offset dev_call             	; 10
	dw offset fcb_to_sda           	; 12
	dw offset lastchar             	; 14
	dw offset change_of_disk       	; 16
	dw offset alloc_next_free      	; 18
	dw offset leapyear		; 20
	dw offset dev_to_sft		; 22
	dw offset dev_openclose		; 24

	; Start of the pascal functions
	;

StartOfPascalFunctions:

	dw offset strchr		; 26
	dw offset toupper		; 28
	dw offset strlen               	; 30
	dw offset memmove              	; 32
	dw offset atoi                 	; 34
	dw offset strcat               	; 36
	dw offset get_fat_entry        	; 38
	dw offset get_new_clusters     	; 40
	dw offset zero_cluster         	; 42
	dw offset lclus_to_pclus       	; 44
	dw offset clus_to_sec          	; 46
	dw offset buf_getsector        	; 48
	dw offset fmemcpy              	; 50
	dw offset ename_to_dot         	; 52
	dw offset dot_to_ename         	; 54
	dw offset drive_to_sda         	; 56
	dw offset defdrive_to_sda      	; 58
	dw offset fstrlen              	; 60
	dw offset is_lead_byte         	; 62
	dw offset buf_set_modified     	; 64
	dw offset memset               	; 66
	dw offset free_the_fat         	; 68
	dw offset buf_flush_all        	; 70
	dw offset set_fat_entry        	; 72
	dw offset set_handle_val       	; 74
	dw offset h_to_sft             	; 76
	dw offset name_change          	; 78
	dw offset strupr               	; 80
	dw offset handle_to_sda        	; 82
	dw offset mem_z_alloc          	; 84
	dw offset get_call_flags       	; 86
	dw offset krn_assert           	; 88
	dw offset name_match		; 90
	dw offset attr_match		; 92
	dw offset _lmulu		; 94
	dw offset _ldivu		; 96
	dw offset find_device		; 98
	dw offset fmemset		; 100

FarDOSCall endp

cEndCode

ENDIF	;; IF (VDOS GE 7)	; DOS 7+ only

	END
