;
;   $Id: LONGASM.ASM 1.7 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~ *********************************************************

   LONGASM.ASM  created 12/18/96  by Drew Gislason
   Copyright (c) 1996-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Assembly stuff needed for long filenames, mostly for speed,
   size purposes.

******************************************************************* ~

IF VDOS GE 7	; {  commented out unless DOS 7 or greater

include macros.inc
include profile.inc

cBegData
cEndData

cBegCode

	; code this stuff relies on
	extrn	IS_LEAD_BYTE_PASS_THROUGH:near

COMMENT ~ ; prototype
uchar DetermineChecksum(char *pEname)
~
c_func	DetermineChecksum

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	mov	BX, P[BP]
	xor	AX, AX		; also clears carry
	mov	CX, 11
chkmore:
	ror	AL, 1
	add	AL, [BX]
	inc	BX
	loop	chkmore

	pop	BP

	EXIT_FUNCTION

	ret

c_endp	DetermineChecksum


COMMENT ~ ; prototype
char * PASCAL IntlStrCpy(char * pDstStr, char * pSrcStr)
~
	public	INTLSTRCPY
INTLSTRCPY proc near

	ENTER_FUNCTION

	push	bp
	mov	bp, sp
	push	si
	push	di

	;  using same segment for src and dst, that it ds
	mov	ax, ds
	mov	es, ax

	mov	si, P[BP]	; pSrcStr

	; determine length
	mov	di, si
	cld
	xor	al, al
	mov	cx, -1
	repnz	scasb
	not	cx

	; now copy it
	mov	di, P+2[BP]
	rep	movsb

	; return pDstStr
	mov	ax, [bp+04]

	pop	di
	pop	si
	pop	bp

	EXIT_FUNCTION

	ret	4

INTLSTRCPY endp

COMMENT ~ ; prototype
char far * PASCAL IntlFStrCpy(char far * lpDstStr, char far * lpSrcStr)
~
	public	INTLFSTRCPY
INTLFSTRCPY proc near

	ENTER_FUNCTION

	push	bp
	mov	bp, sp
	push	si
	push	di
	push	ds

	mov	ds, P+2[BP]	; lpSrcStr
	mov	si, P[BP]

	; determine length of string
	mov	ax, ds
	mov	es, ax
	mov	di, si
	cld
	xor	al, al
	mov	cx, -1
	repnz	scasb
	not	cx

	; now copy it
	mov	es, P+6[BP]	; lpDstStr
	mov	di, P+4[BP]
	rep	movsb

	mov	ax, P+4[BP]	; return lpDstStr
	mov	dx, es

	pop	ds
	pop	di
	pop	si
	pop	bp

	EXIT_FUNCTION

	ret	8

INTLFSTRCPY endp


COMMENT ~ ; prototype
char * PASCAL IntlStrRChr(char * pStr, char c)
~
	public	INTLSTRRCHR
INTLSTRRCHR:

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	DS
	pop	ES	; ES = segment of pStr

	; call the real work-horse (it will get args)
	call	FindRev

	pop	BP

	EXIT_FUNCTION

	ret	4

COMMENT ~ ; prototype
char far * PASCAL IntlFStrRChr(char far * pStr, char c)
~
	public	INTLFSTRRCHR
INTLFSTRRCHR:

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	mov	ES, P+4[BP]	; ES = segment of pStr

	; call the real work-horse (it will get args)
	call	FindRev

	pop	BP

	EXIT_FUNCTION

	ret	6

;-------------------------------------
;  internal use by near and far versions
FindRev proc near

	ENTER_FUNCTION

	; get arguments
	push	SI	; offset of last occurence of "c"
	push	DI	; ES:DI = pStr
	xor	SI, SI
	mov	DI, P+2[BP]	; offset of pStr

	; // at end of string? we're done
	; while(*pStr)
	; {
while_loop:
	mov	AL, byte ptr ES:[DI]
	or	AL, AL
	jz	loop_done

	; // found our char "c"? record WHERE it is
	; if(*pStr == c)
	;    pLastChar = pStr;
	cmp	AL, byte ptr P[BP]
	jnz	not_ours
	mov	SI, DI
not_ours:

	; // dealing with double byte (asian) characters?
	; if(is_lead_byte(*pStr))
	;    ++pStr;
	;
	; IS_LEAD_BYTE is located in far dos code.  All other
	; far DOS functions have been called from C.  All the
	; macros to handle this are in C.  For simplicity a
	; pass through function in the LONGNAME.C file was
	; created.
	;
	push	AX
	call	IS_LEAD_BYTE_PASS_THROUGH
	or	AX, AX
	jz	not_lead_byte
	inc	DI
not_lead_byte:

	;    ++pStr;
	; }
	inc	DI
	jmp	while_loop

loop_done:

	; if(!pLastChar)
	;    pLastChar = pStr;
	or	SI, SI
	jnz	got_last_char
	mov	SI, DI
got_last_char:

	; return (pLastChar);
	mov	DX, ES
	mov	AX, SI

	pop	DI
	pop	SI

	EXIT_FUNCTION

	ret

FindRev endp

COMMENT ~ ; prototype
int strcpy(char *pDst, char *pSrc)
~
c_func	strcpy

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI
	push	DI

	; es:si pts to dst
	mov	AX, DS
	mov	ES, AX
	mov	DI, P[BP]

	; ds:si pts to src
	mov	SI, P+2[BP]

	cld
cpyagain:
	lodsb
	stosb
	cmp	AL, 0
	jz	cpydone
	jmp	short cpyagain

cpydone:
	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	strcpy

COMMENT ~ ; prototype
int strcmp(char *pStr1, char *pStr2)
~
c_func	strcmp

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	SI

	mov	SI, P[BP]
	mov	BX, P+2[BP]

	cld
cmpagain:
	lodsb
	cmp	AL, [BX]
	jb	less_than
	ja	greater_than
	cmp	AL, 0
	jz	same
	inc	BX
	jmp	cmpagain

greater_than:
	mov	AX, 1
	jmp	short donecmp
less_than:
	mov	AX, -1
	jmp	short donecmp

same:	xor	AX, AX
donecmp:
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	strcmp

cEndCode

ENDIF ; } VDOS >= 7

	END
