;
;   $Id: USE186.ASM 1.5 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:USE186.ASM
;
; Copyright (c) 1994-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; Division routine for compiling ROMDOS kernel for 186
; disk driver.
;
; $DOCHISTORY
; 01/08/2002 jb original revision
;--------------------------------------------------------------------

include use186.inc
include macros.inc
include profile.inc

.8086

;****************************************************
;
; Div_QL
;
; Divide an unsigned qword by an unsigned dword
;
; 	Entry	DI,SI - The divisor
; 	  DX,CX,BX,AX - The dividend
;
; 	Exit	DI,SI - The remainder
; 	  DX,CX,BX,AX - The quotient
;
;****************************************************

cBegCode

IF USE_186 NE 0

PUBLIC  DIV_QL
DIV_QL   proc  near
local md_val4:word, md_val3:word, md_val2:word, md_val1:word, md_divh:word=LSIZE

	ENTER_FUNCTION

        push    bp
        mov     bp, sp
        sub     sp, LSIZE

        push    es

        push    ss
        pop     es

        mov     es:md_val1, ax
        mov     es:md_val2, bx
        mov     es:md_val3, cx
        mov     es:md_val4, dx

        mov     cx, di
        mov     bx, si

        lea     di, md_val1

        mov     es:md_divh, cx    ; DIVH:BX has divisor
        xor     dx, dx            ; DX:AX holds remainder of prior divide
        xor     ax, ax            ; (init remainder to zero)
        mov     si, 64            ; cx = bits remaining (use SI for now)
        mov     cx, es:[di]       ; [DI+4]:[DI+2]:[DI]:SI (CX for now)
        add     di, 2             ; hold dividend in high bits) and quotient (in low bits)

md_10:
        test    dh, dh            ; is there room to shift left 8 bits?
        jnz     md_30             ; divide rest by bites ofnot
        mov     dh, dl            ; try shifting 8 bits at once
        mov     dl, ah            ; instead of one at a time
        mov     ah, al            ; (this can be done until the partial
        mov     al, es:[di+5]     ;  remainder > divisor)
        cmp     dx, es:md_divh    ; would this shift go too far?
        jb      md_20             ; (maybe)
        ja      md_25             ; don't shift these 8 bits if so
        cmp     ax, bx            ; (maybe)
        jae     md_25             ; don't shift these 8 bits if so
md_20:
        xchg    ch, cl            ; can shift 8 bits at once
        xchg    es:[di+0], cl     ; shift rest of remainder dividend
        xchg    es:[di+1], cl     ;  to the left 8 bits
        xchg    es:[di+2], cl
        xchg    es:[di+3], cl
        xchg    es:[di+4], cl
        xchg    es:[di+5], cl
        xor     cl, cl
        sub     si, 8             ; now there 8 fewer bits to divide
        jnz     md_10             ;  more remain, try to skip 8 more
        jmp     md_90             ;  done, return quot=0, rem=0
md_25:
        mov     al, ah
        mov     ah, dl            ; can't skip the last 8 bits
        mov     dl, dh            ; undo the echange done at md_10
        xor     dh, dh            ;   when seeing if its could be skipped
md_30:
        xchg    cx, si            ; fix CX=loop count, SI=low dividend word

md_40:
        shl     si, 1             ; shift dividend left one bit
        rcl     word ptr es:[di], 1     ; make room for new quotient bit
        rcl     word ptr es:[di+2], 1   ;  at bottom, shifts high bit out
        rcl     word ptr es:[di+4], 1   ;  the top for append to remainder
        rcl     ax, 1             ; append high divident bit onto
        rcl     dx, 1             ;  low end of remainder
        jc      md_50             ; if CF set, rem is > divisor
        cmp     dx, es:md_divh    ; is remainder bigger than divisor?
        jb      md_60             ; rem smaller, shift and try again if not
        ja      md_50             ; sub divisor once and set quotient if so
        cmp     ax, bx            ; high words same, is rem same/bigger?
        jb      md_60             ; rem smaller, shift and try again if not
md_50:
        sub     ax, bx            ; rem >= divisor, can divid one time.
        sbb     dx, es:md_divh    ; subtract divisor from remainder
        inc     si                ; set bit in quotient indicating divide
md_60:
        loop    md_40             ; continue until all bits are done

md_90:
        mov     es:[di-2], si     ; return low word of quotient

        mov     di, dx
        mov     si, ax
        mov     ax, es:md_val1
        mov     bx, es:md_val2
        mov     cx, es:md_val3
        mov     dx, es:md_val4

        pop     es
        add     sp, LSIZE
        pop     bp

	EXIT_FUNCTION

        ret
DIV_QL  endp


;****************************************************
;
; MUL_UU
;
; Multiply an unsigned long with another unsigned long
;
; 	Entry
;         DX:AX         first number
; 	  BX:CX         second number
;
; 	Exit
; 	  DX,CX,BX,AX   the result
;
;****************************************************
;
public MUL_UU
MUL_UU	proc	near
local	target1:word, target2:word, target3:word, target4:word=LSIZE

	ENTER_FUNCTION

	push	bp
	mov	bp, sp

	sub	sp, LSIZE       ; create space on local stack for result

	push	si              ; save registers
	push	di

	mov	si, ax          ; save ax and dx in si and di
	mov	di, dx

	mov	target1, 0      ; clear result
	mov	target2, 0
	mov	target3, 0
	mov	target4, 0


	mul	cx              ; multiply with lower word of second value
	mov	target1, ax     ; store result
	mov	target2, dx

	mov	ax, si          ; get lower word of first value back
	mul	bx              ; multiply with upper word of second value
	add	target2, ax     ; add to result
	adc	target3, dx
	adc	target4, 0

	mov	ax, di          ; get upper word of first value
	mul	cx              ; multiply with lower word of second value
	add	target2, ax     ; add to result
	adc	target3, dx
	adc	target4, 0

	mov	ax, di          ; get upper word of first value
	mul	bx              ; multiply with upper word of second value
	add	target3, ax     ; add to result
	adc	target4, dx

	mov	ax, target1     ; get 64-bit result into dx:cx:bx:ax
	mov	bx, target2
	mov	cx, target3
	mov	dx, target4

	pop	di              ; restore registers
	pop	si

	add	sp, LSIZE       ; clean up local stack
	pop	bp

	EXIT_FUNCTION

	ret

MUL_UU	endp



ENDIF   ;; USE_186
cEndCode
        END
