;
;   $Id: DLBKBD.ASM 1.4 2002/10/15 22:43:50Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~

   DLBKBD.ASM
   Created 08-21-97 by Dennis Edwards

   Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This module is part of the DLx library, it contains:

   	BIOSKeyboard -- invokes the specified BIOS keyboard function
	                and functions similar to the Borland library
			function: int bioskey(int fn)

end_comment ~

; use the /i switch on the assembler command line to specify
; the include path if these files are not in the current dir
;
include datalght.inc


; MEMMODEL is assumed to be defined using a /D argument on the
; assembler command line.
;
; Establish segment model, calling conventions, etc.
;
InitModel %MEMMODEL, pascal, use16


.Code
if @DataSize
	assume	cs:@curseg, ds:nothing, es:nothing, ss:nothing
else
	assume	cs:@curseg, ds:@data, es:nothing, ss:nothing
endif


comment ~
unsigned PASCAL BIOSKeyboard(unsigned function)
end_comment ~
ProcBegin	BIOSKeyboard,public
ProcArgs	@@function:byte
ProcLocals	@@value:word
ProcSetup

	mov	ah, @@function
	push	ax
	int	16h
	mov	@@value, ax	; store whatever was returned
	pop	ax		; get back function number in ah

	mov	al, ah		; function number in al
	lahf			; low byte of returned flags in AX
	test	al, 1           ; if not testing for pending keystroke
	jz	BKBD_done	; then we're done, recover returned AX and exit

	test	ah, 40h		; else test to see if ZF was set by int 16h
	jz	BKBD_done	; if not, returned AX is preview of next key

	xor	ax, ax
	jmp	short BKBD_exit	; return 0 if no key pending

    BKBD_done:
	mov	ax, @@value
	or	ax, ax          ; Borland's design can't tell data from nothing
	jnz	BKBD_exit

	mov	ax, 2E03h	; return ^C extended scan code for ^Brk or Alt-Num0

    BKBD_exit:
ProcEnd
	end
