//
//   $Id: DLS13F4X.C 1.3 2002/10/15 22:43:50Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/***************************************************************************
   $DOCMODULE:DLS13F42.C

	Copyright (c) 1999-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

	DLS13F42:Datalight Library Smart Int 13 Function 42 Smart Lba Read
	Sectors.

	bool PASCAL DlSmartLbaReadSectors(PLSIP plsipInfo , PLSTP plstpTransfer);

	$DOCHISTORY
	03/31/1999 dg  Created by Drew Gislason
****************************************************************************/
#include <string.h>

#include "datalght.h"
#include "dlint13.h"
#include "_dlint13.h"

/*
	Convert from linear LBA sector to CHS.
*/
bool PASCAL LbaToCHS(PLSIP plsipInfo, ulong ulSector, int *piTrack,
					uchar *pucHead, uchar *pucSector)
{
	// no dividing by 0
	if(!plsipInfo->ebdpt.ulPhysicalSPT || !plsipInfo->ebdpt.ulPhysicalHeads)
		return FALSE;

	// sector is 1 based, head is 0 based
	*pucSector = (uchar)(ulSector % plsipInfo->ebdpt.ulPhysicalSPT) + 1;
	ulSector  /= plsipInfo->ebdpt.ulPhysicalSPT;
	*pucHead   = (uchar)(ulSector % plsipInfo->ebdpt.ulPhysicalHeads);
	ulSector  /= plsipInfo->ebdpt.ulPhysicalHeads;

	// track (cylinder) should be 0-1023 to be CHS compliant
	if(ulSector >= 1024)
		return FALSE;
	*piTrack   = (int)ulSector;

	return TRUE;
}
