//
//   $Id: DLS13F4Y.C 1.5 2002/10/15 22:43:50Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/***************************************************************************
   $DOCMODULE:DLS13F4y.C

	Copyright (c) 1999-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

	$DOCHISTORY
	03/31/1999 dg  Created by Drew Gislason
****************************************************************************/
#include <string.h>

#include "datalght.h"
#include "dlint13.h"
#include "_dlint13.h"

/*
	$DOCPROC:LbaSmartTransfer

	Used by SmartLbaRead, Write and Verify. Sets up the proper structures,
	then calls the appropriate BIOS disk function.
*/
bool PASCAL SmartLbaTransfer(int iFunction, PLSIP plsipInfo, PLSTP plstpTransfer)
{
	BDTP	bdtpPacket;
	DAP 	dapAddressPacket;
	bool PASCAL (*fnOldTransfer)(int iDrive, PBDTP pbdtpPacket);
	bool PASCAL (*fnLbaTransfer)(int iDrive, PDAP pdapAddressPacket);

	// determine function to use
	switch(iFunction)
	{
		case	SMT_WRITE:
			fnOldTransfer = DlBiosWriteSectors;
			fnLbaTransfer = DlLbaWriteSectors;
			break;
		case	SMT_VERIFY:
			fnOldTransfer = DlBiosVerifySectors;
			fnLbaTransfer = DlLbaVerifySectors;
			break;
		default:
			fnOldTransfer = DlBiosReadSectors;
			fnLbaTransfer = DlLbaReadSectors;
			break;
	}


	// old-style transfer, figure out track/head/sector
	// invalid CHS?
	if(LbaToCHS(plsipInfo, plstpTransfer->ulStartSector,
			&bdtpPacket.iTrack, &bdtpPacket.ucHead, &bdtpPacket.ucSector))
	{
		// set up transfer packet
		bdtpPacket.iNumSectors = plstpTransfer->iNumSectors;
		bdtpPacket.lpBuffer    = plstpTransfer->lpBuffer;

		// do the transfer (read, write, verify)
		return (*fnOldTransfer)(plsipInfo->iDrive, &bdtpPacket);
	}
	else
	{
		// use LBA transfer if possible
		if(plsipInfo->uEFlags & EBIOS_HAS_LBA_DISK_SUPPORT)
		{
			dapAddressPacket.ucBlockCount     = plstpTransfer->iNumSectors;
			dapAddressPacket.ulStartingLBALow = plstpTransfer->ulStartSector;
			dapAddressPacket.lpBuffer         = plstpTransfer->lpBuffer;

			// do the transfer (read, write, verify)
			return (*fnLbaTransfer)(plsipInfo->iDrive, &dapAddressPacket);
		}
	}
}
