;
;   $Id: dli13f4x.asm 1.4 2002/10/15 22:43:50Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCMODULE:DLI13F4x.ASM
;
;  Copyright (c) 1999-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary.
;
; This module contains the BIOS disk function Int 13h fn 42h, LBA Read
; Sectors.
;
; bool PASCAL DlLbaReadSectors(int iDrive, PDAP pdapAddressPacket);
;
; $DOCHISTORY
; 03/31/1999 dg  Created by Drew Gislason
;---------------------------------------------------------------------------
include datalght.inc
BIGDISKS	equ 1
include dostruct.inc

; initialize memory model from cmdline
InitModel %MEMMODEL, pascal, use16

_I13F42 equ 1
include _dlint13.inc

.Code

;---------------------------------------------------------------------------
; Helper function to DlLbaReadSectors (and Write and Verify). Does the
; transfer, and reports the results.
;---------------------------------------------------------------------------
ProcBegin	_I13DoLbaTransfer, public
ProcSetup

	; set up basic packet info so user doesn't have to
	push	ax
	xor	ax, ax
	mov	[si.DAP_ucReserved1], al
	mov	[si.DAP_ucReserved2], al
	mov	[si.DAP_ucPacketSize], size DeviceAddressPacket
	mov	word ptr [si.DAP_ulStartingLBAHigh], ax
	mov	word ptr [si.DAP_ulStartingLBAHigh+2], ax
	pop	ax

	; call Int 13h to do the LBA function
	stc
	int	13h
	jc	@@Failed

	; worked, return TRUE
	mov	ax, 1
	jmp	@@Done

	; failed, record error and return FALSE
    @@Failed:
	mov	_BiosError, ah
	xor	ax, ax
    @@Done:

ProcEnd

	End
