;
;   $Id: dli13fxx.asm 1.3 2002/10/15 22:43:50Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCMODULE:DLI13Fxx.ASM
;
;  Copyright (c) 1999-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary.
;
; This module contains the BIOS disk function Int 13h fn 02h, Read Sectors.
;
; bool PASCAL DlBiosReadSectors(int iDrive, PBDTP pbdtpPacket);
;
; $DOCHISTORY
; 03/31/1999 dg  Created by Drew Gislason
;---------------------------------------------------------------------------
.186
include datalght.inc

; initialize memory model from cmdline
InitModel %MEMMODEL, pascal, use16

_I13F02 equ 1

include _dlint13.inc

.data?
		public	_BiosError
	_BiosError	db	?

.code

;---------------------------------------------------------------------------
; Helper function to all the disk transfer functions.
; On Entry
;	ah	Bios Int 13h fn #
;	dl	Bios Int 13h drive #
;	ds:bx	ptr to BiosDiskTransferPacket
; On Exit
;	ax	worked (TRUE or FALSE)
;		transfer complete if no error
;---------------------------------------------------------------------------
ProcBegin	_I13DoDiskTransfer, public
ProcSetup

	; get all the registers from the packet
	mov	al, byte ptr [bx.BDTP_iNumSectors]
	mov	cl, byte ptr [bx.BDTP_iTrack+1]	; top 2 bits of track
	shl	cl, 6				; go into top 2 bits of cl
	or	cl, [bx.BDTP_ucSector]
	mov	ch, byte ptr [bx.BDTP_iTrack]
	mov	dh, [bx.BDTP_ucHead]
	les	bx, [bx.BDTP_lpBuffer]

	; call Int 13h
	int	13h
	mov	al, 1		; set to TRUE without affecting flags
	jnc	@@Done

	; failed! record error #
	mov	_BiosError, ah
	xor	ax, ax		; set return to FALSE
    @@Done:
ProcEnd

	End
