;
;   $Id: fatcomn.asm 1.7 2002/10/15 22:48:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCFILE:FATCOMN.ASM
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is used by the PUTFAT and GETFAT library functions
;
; 01/17/2002 jmb Added conditional code which will perform
;                the 386 operations using 16-bit operands
; 07-21-2000 bt  Split up FATLIB.ASM into UNIFY.ASM,PUTFAT.ASM,
;                and GETFAT.ASM
; 03/31/1999 bt  Created (modeled from dosfat.asm by dg)
;
;---------------------------------------------------------------------------

include use186.inc
include datalght.inc
include dostruct.inc
include dosdef.inc

InitModel %MEMMODEL, Pascal, Use16

;
;  [ CONSTANTS ]
;


include fatlib.inc


.code
	extrn	READSECTORBUFFER:proc
	extrn	GETBUFFERDATAADDRESS:proc
	extrn	MARKBUFFERDIRTY:proc
	extrn	SETBUFFERCOPIESANDDISTANCE:proc

IF USE_186 EQ 1
        extrn   DIV_QL:near
        extrn   MUL_UU:near
ENDIF ;; USE_186

IF USING_FAT32 ; {

IF USE_186 EQ 0
.386
ENDIF ;; USE_186

;---------------------------------------------------------------------------
; $DOCPROC:_GetFat32EntryPtr
;
; Helper routine to get/Put fat32entry routines. Gets the fat sector into
; memory, and returns a pointer to the fat entry inside that sector
;
; On Entry	eax	ulClusterNumber (386 mode)
;               di:ax   ulFatEntry (186 mode)
;		bx	uBytesPerSector
;		ecx	ulStartingFATSector (386 mode)
;		si:cx	ulStartingFATSector (186 mode)
;		dx	ucDOSDriveNumber
;
; On Exit	es:bx	pointer to fat entry
;		si:di	buffer handle
;
;---------------------------------------------------------------------------
ProcBegin	_GetFat32EntryPtr, public
ProcLocals	@@ppBufferHandle:word,@@lpBufferAddress:dword,@@uIndexIntoSector:word
ProcSetup

	; set the drive number for the call to ReadSectorBuffer
	;
	push	dx

IF USE_186 EQ 0
	; determine 64-bit fat entry offset (in edx:eax)
	;
	xor	edx, edx
	mov	dx, FAT32_ENTRY_NUMBER_OF_BYTES
	mul	edx		; 64-bit in edx:eax

	; convert to sector # and offset
	;
	movzx	ebx, bx
	div	ebx		; sector now in eax, remainder in edx

	; save the remainder (always 0-1FFh in dx only)
	;
	mov	@@uIndexIntoSector, dx

	; set the absolute sector number for the call to ReadSectorBuffer
	;
	add	eax, ecx	; add in start of FAT
	push	eax

ELSE    ;; USE_186
	; determine 64-bit fat entry offset (in dx::cx:bx:ax)

	; save values
        push    si
        push    cx
        push    bx

	;
	; multiply dx:ax by bx:cx
	;
        mov     dx, di          ; setup dx portion of dx:ax
        xor     bx, bx
        mov     cx, FAT32_ENTRY_NUMBER_OF_BYTES
        call    MUL_UU          ; 64-bit in dx:cx:bx:ax


	;
	; divide dx:cx:bx:ax              by    di:si
	;        ^^^^^^^^^^^                    ^^^^^
	;        64-bit fat entry offset        bytes per sector
	;

	;
	; setup di:si -- get uBytesPerSector into si
	;
        pop     si
        xor     di, di
	; convert to sector # and offset
        call    DIV_QL
        ; 64-bit sector number in dx:cx:bx:ax
        ; 32-bit remainder in di:si

	; save the remainder (always 0-1FFh in si only)
	;
	mov	@@uIndexIntoSector, si

        ; read the sector (from saved SI:CX on stack)
        pop     di
        pop     si
        add     ax, di
        adc     bx, si

        push    bx
        push    ax
ENDIF   ;; USE_186
	; set the variable which will contain the buffer handle for the
	; call to ReadSectorBuffer
	;
if @DataSize
	push	ss
endif
	lea	di, @@ppBufferHandle
	push	di

	; bool PASCAL ReadSectorBuffer( uchar ucDOSDriveNumber,
	;	ulong ulAbsSector, void ** ppBufferHandle );
	;
	call	ReadSectorBuffer
	or	ax, ax		; check for an error
	jz	@@Error

	; Get the buffer handle
	;
if @DataSize
	mov	si, @@ppBufferHandle[2]
endif
	mov	di, @@ppBufferHandle

	; Get the address of the buffer
	;
	; bool GetBufferDataAddress( void * pBufferHandle,
	;	void far * * plpBufferAddress )
	;
if @DataSize
	push	si
endif
	push	di
if @DataSize
	push	ss
endif
	lea	bx, @@lpBufferAddress
	push	bx
	call	GetBufferDataAddress
	or	ax, ax			; check for an error
	jz	@@Error

	; set the address of the buffer
	;
	les	bx, @@lpBufferAddress

	; add in the offset (remainder) to return a pointer to
	; the 16-bit fat entry in es:bx
	;
	add	bx, @@uIndexIntoSector

	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE
	jmp	short @@Done

 	; Set the boolean return value of the function to FALSE (failed)
	;
    @@Error:
	xor	ax, ax

    @@Done:

ProcEnd

.186

ENDIF ; } USING_FAT32

;---------------------------------------------------------------------------
; $DOCPROC:_GetFat16EntryPtr
;
; Helper routine to get/set fat16 routines. Gets the fat sector into
; memory, and returns a pointer to the fat entry inside that sector
;
; On Entry	ax	uClusterNumber
;		bx	uBytesPerSector
;		cx	uStartingFATSector
;		dx	ucDOSDriveNumber
;
; On Exit	es:bx	pointer to fat entry
;		si:di	buffer handle
;
;---------------------------------------------------------------------------
ProcBegin	_GetFat16EntryPtr, public
ProcLocals	@@ppBufferHandle:word,@@lpBufferAddress:dword,@@uIndexIntoSector:word
ProcSetup

	; set the drive number for the call to ReadSectorBuffer
	;
	push	dx

	; determine 16-bit fat entry offset (in dx:ax).  Convert this
	; into a byte index.
	;
	xor	dx, dx
	shl	ax, 1
	rcl	dx, 1		; 32-bit offset in dx:ax

	; convert byte offset to logical sector # and remainder
	;
	div	bx		; sector now in ax, remainder in dx

	; save the remainder (always 0-1FFh in dx only)
	;
	mov	@@uIndexIntoSector, dx

	; set the absolute sector number for the call to ReadSectorBuffer
	;
	xor	dx, dx
	add	ax, cx		; add in FAT start to logical sector #
	adc	dx, ADD_NOTHING
	push	dx
	push	ax

	; set the variable which will contain the buffer handle for the
	; call to ReadSectorBuffer
	;
if @DataSize
	push	ss
endif
	lea	di, @@ppBufferHandle
	push	di

	; bool PASCAL ReadSectorBuffer( uchar ucDOSDriveNumber,
	;	ulong ulAbsSector, void ** ppBufferHandle );
	;
	call	ReadSectorBuffer
	or	ax, ax			; Check for an error
	jz	@@Error

	; Get the buffer handle
	;
if @DataSize
	mov	si, @@ppBufferHandle[2]
endif
	mov	di, @@ppBufferHandle

	; Get the address of the buffer
	;
	; bool GetBufferDataAddress( void * pBufferHandle,
	;	void far * * plpBufferAddress )
	;
if @DataSize
	push	si
endif
	push	di
if @DataSize
	push	ss
endif
	lea	bx, @@lpBufferAddress
	push	bx
	call	GetBufferDataAddress
	or	ax, ax			;Check for an error
	jz	@@Error

	; set the address of the buffer
	;
	les	bx, @@lpBufferAddress

	; add in the offset (remainder) to return a pointer to
	; the 16-bit fat entry in es:bx
	;
	add	bx, @@uIndexIntoSector

	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE
	jmp	short @@Done

 	; Set the boolean return value of the function to FALSE (failed)
	;
    @@Error:
	xor	ax, ax	; return FALSE

    @@Done:

ProcEnd

;---------------------------------------------------------------------------
; $DOCPROC:_GetFat12EntryPtr
;
; Helper routine to get/set fat12 routines. Gets the fat sector into
; memory, and returns a pointer to the fat entry inside that sector.
;
; On Entry	ax	uClusterNumber
;		bx	uBytesPerSector
;		cx	uStartingFATSector
;		dx	ucDOSDriveNumber
;
; On Exit	es:bx	pointer to fat entry
;		si:di	buffer handle
;		dx	offset (remainder/index) into sector
;
; Warning! This function trashes si! not callable from C!
;
;---------------------------------------------------------------------------
ProcBegin	_GetFat12EntryPtr, public
ProcLocals	@@ppBufferHandle:word,@@lpBufferAddress:dword,@@uIndexIntoSector:word
ProcSetup

	; set the drive number for the call to ReadSectorBuffer
	;
	push	dx

	; make sure ax is in range
	;
	and	ax, FAT12_MAXIMUM_NUMBER

	; determine 12-bit fat entry offset.  Convert this into a
	; byte index.
	;
	mov	dx, ax
	shr	dx, 1
	add	ax, dx		; 12-bit offset into FAT now in ax

	; convert byte offset to logical sector # and remainder
	;
	xor	dx, dx
	div	bx		; logical sector in ax, remainder in dx

	; save the remainder into si (always 0-1FFh in dx only)
	;
	mov	@@uIndexIntoSector, dx

	; set the absolute sector number for the call to ReadSectorBuffer
	;
	xor	dx, dx
	add	ax, cx		; add in FAT start to logical sector
	adc	dx, ADD_NOTHING
	push	dx
	push	ax

	; set the variable which will contain the buffer handle for the
	; call to ReadSectorBuffer
	;
if @DataSize
	push	ss
endif
	lea	di, @@ppBufferHandle
	push	di

	; bool PASCAL ReadSectorBuffer( uchar ucDOSDriveNumber,
	;	ulong ulAbsSector, void ** ppBufferHandle );
	;
	call	ReadSectorBuffer
	or	ax, ax			; Check for an error
	jz	@@Error

	; Get the buffer handle
	;
if @DataSize
	mov	si, @@ppBufferHandle[2]
endif
	mov	di, @@ppBufferHandle

	; Get the address of the buffer
	;
	; bool GetBufferDataAddress( void * pBufferHandle,
	;	void far * * plpBufferAddress )
	;
if @DataSize
	push	si
endif
	push	di
if @DataSize
	push	ss
endif
	lea	bx, @@lpBufferAddress
	push	bx
	call	GetBufferDataAddress
	or	ax, ax			;Check for an error
	jz	@@Error

	; set the address of the buffer
	;
	les	bx, @@lpBufferAddress

	; add in the offset (remainder) to return a pointer to
	; the 16-bit fat entry in es:bx
	;
	mov	dx, @@uIndexIntoSector
	add	bx, dx

	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE
	jmp	short @@Done

 	; Set the boolean return value of the function to FALSE (failed)
	;
    @@Error:
	xor	ax, ax

    @@Done:

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:_UnifyClusterValue
;
; void PASCAL _UnifyClusterValue( ulong * pulClusterValue,
;	unsigned uMaxHiclus );
;
; Modify a cluster value so that values for bad cluster (0ff7h/0fff7h)
; through end of FAT chain values (0fffh/0ffffh) get modified to the
; FAT32 equivilent.  Values less than 0ff7/0fff7h have the high word
; set to zero.
;
; Parameters	pulClusterValue
;		uMaxHiclus
;
; Returns	pulClusterValue (Gets modified)
;
;--------------------------------------------------------------------
ProcBegin	_UnifyClusterValue, public
ProcArgs	@@pulClusterValue:PTR, @@uMaxHiclus:word
ProcSetup

	; Load the value into ax
	;
	LPTR_ES	bx, @@pulClusterValue
	mov	ax, word ptr es:[bx]
	cmp	ax, @@uMaxHiclus
	jna	@@PadWithZeros

	; Modify the value so that it is the same as
	; what would be returned from a FAT32 drive
	; for the same condition.
	;
	or	ax, 0f000h
	mov	dx, 0FFFh
	mov	word ptr es:[bx], ax
	mov	word ptr es:[bx][2], dx
	jmp	short @@Done

	; Zero the high word
	;
    @@PadWithZeros:
	xor	dx, dx
	mov	word ptr es:[bx][2], dx

    @@Done:
ProcEnd

	end
