;
;   $Id: DLALLOC.ASM 1.5 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DLALLOC.ASM
; Created 1-4-1999 by Brandon Thomas
;
; Copyright (c) 1997-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21 function 48h allocate
; conventional memory block
;
; bool PASCAL dlAllocMem( unsigned uNumberOfParagraphs,
;		unsigned * puSegment );
;
; $DOCHISTORY
; 01/04/1998 bt  Created
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosio.inc


.code

;--------------------------------------------------------------------
; $DOCPROC: dlAllocMem
;
; bool PASCAL dlAllocMem( unsigned uNumberOfParagraphs,
;		unsigned * puSegment );
;
; Interrupt 21 function 48h allocate conventional memory block
; interface.  Returns TRUE if successful, FALSE if it failed.
;
; On Entry
;
;	bx (@@uNumberOfParagraphs) Number of paragraphs to allocate
;
; On Exit
;
;	ax (function)	TRUE if the function was successful, FALSE otherwise
;	ax (puSegment)	Segment of allocated block
;
;--------------------------------------------------------------------
ProcBegin	dlAllocMem,public
if @DataSize
ProcUses	ds
endif
ProcArgs	@@uNumberOfParagraphs:word, @@puSegment:PTR
ProcSetup

	; Allocate conventional memory
	;
	mov	ah, 48h

	; Set the number of paragraphs to allocate
	;
	mov	bx, @@uNumberOfParagraphs

	; Perform the interrupt
	;
	int	21h

	; Check for an error
	;
	jc      FUNCTION_ERROR

	; Save the segment address in the return variable
	;
	LPTR_DS	bx, @@puSegment
	mov	[bx], ax

	; Set the boolean return value to successful and exit
	;
	xor	ax, ax
	jmp	short DONE

    FUNCTION_ERROR:

	; In case of an insufficient memory error, return the
	; size of the largest allocatable block in the segment
	; variable
	;
	mov	dx, bx
	LPTR_DS	bx, @@puSegment
	mov	[bx], dx
	stc

    DONE:

	; Set the error code and the boolean return value for
	; an error
	;
	SET_DOS_ERROR

ProcEnd
	end
