;
;   $Id: DLBIGDRV.ASM 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:BIGDRIVE.ASM
; Created 12-22-1997 by Dennis Edwards
;
; Copyright (c) 1997-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is for determining if the drive has 65536 sectors or
; less and is part of the Datalight Library.
;
; bool PASCAL dlIsBigDrive(int drive);
;
; $DOCHISTORY
; 07/22/1998 bt  copied it from defrag and made it into library
;		 function.
; 12/22/1997 de  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16

.code

;--------------------------------------------------------------------
; $DOCPROC: dlIsBigDrive
;
; bool PASCAL dlIsBigDrive(int iDrive)
;
; This function determines if the drive has 65536 sectors or
; more.
;
; On Entry
;	dl iDrive	Drive number (A=0,B=1,C=2,...)
; On Exit
;	ax		TRUE if drive has more than 65535 sectors,
;			FALSE otherwise
;
;--------------------------------------------------------------------
ProcBegin	dlIsBigDrive,public
ProcUses  	ds
ProcArgs	@@drive:word
ProcSetup

	; determine # of sectors on disk
	;
	mov	ah, 1CH
	mov	dl, byte ptr @@drive	; drive passed (A=0, B=1)
	inc	dl			; DOS wants 1=A, 2=B, etc
	int	21h

	; DX = clusters, AL = sectors per cluster
	; if more than 64K sectors, it's big
	;
	xor	ah, ah
	mul	dx
	mov	ax, dx
ProcEnd

	END
