//
//   $Id: DLDFREE.C 1.4 2002/10/15 22:49:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*****************************************************************************

   DLDFREE.C
   Created 08-09-97 by Dennis Edwards

   Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This module is part of the DLDOSIO library, it contains:

		bool PASCAL dlGetFreeSpaceOnDrive(int drive, unsigned long *freeSpace);

	HISTORY:
	02-27-1999 de  Moved "smart" function to DLDFRE32.C. Cleaned it up.
	02-24-1999 dm  Added IsFat32Drive macro check to verify FAT32 drives
	02-20-1999 dm	Fixed FAT16 setup of the allocation units to get the
						same numbers as clusters.
	02-17-1999 dm	Added Smart function for Get Free Disk Space
	01-30-1999 bt  Added include for dostruct.h

*****************************************************************************/
#include "dostruct.h"
#include "dosdef.h"
#include "datalght.h"
#include "dldosio.h"


bool PASCAL dlGetFreeSpaceOnDrive(int drive, unsigned long *freeSpace)
{ unsigned SectorsPerCluster;
  unsigned FreeClusters;
  unsigned BytesPerSector;
  unsigned TotalClusters;

	*freeSpace = 0L;
	if(__dlGetFreeSpaceOnDrive(drive, &SectorsPerCluster, &FreeClusters,
										     &BytesPerSector,    &TotalClusters))
	{
		*freeSpace = (unsigned long)BytesPerSector * SectorsPerCluster
		    				* FreeClusters;
		return TRUE;
	}
	else
		return FALSE;
}
