;
;   $Id: DLGETDDT.ASM 1.5 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DLGETDDT.ASM
; Created 06-22-1999 by Brandon Thomas
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 2fh function 0803h get address
; of the first DDT
;
; bool PASCAL dlGetFirstDDT(LPDDT * plpDDT );
;
; $DOCHISTORY
; 06/22/1999 bt  Created
;--------------------------------------------------------------------
include datalght.inc
include dostruct.inc
include _dldosio.inc

InitModel %MEMMODEL, pascal, use16

.code
;--------------------------------------------------------------------
; $DOCPROC: dlGetFirstDDT
;
; bool PASCAL dlGetFirstDDT(LPLOL *plpLOL );
;
; Interrupt 2fh function 0803h get the address of the first DDT.
; Returns TRUE if successful, FALSE if it failed.
;
; On Entry
;
;	none
;
; On Exit
;
;	ax    (function)  TRUE if the function was successful, FALSE
;                         otherwise
;	ds:di (plpDDT)    Address of the first DDT
;
;--------------------------------------------------------------------
ProcBegin	dlGetFirstDDT,public
ProcUses	ds,es,di,si
ProcArgs	@@plpDDT:PTR
ProcSetup

	; Set the function number for the call to retrieve the first
	; DDT address.
	;
	push	ds
	mov	ax, 0803h

	; So that we can detect a function failure we will set DS to
	; and DI to something that can't happen
	;
	mov	di, 0ffffh
	mov	ds, di

	; Perform the interrupt
	;
	int	2fh

	; initialize the return value to FALSE
	;
	xor	ax, ax

	; Check that the address has changed
	;
	mov	si, ds
	pop	ds
	cmp	di, 0ffffh
	jz	NotChanged
	cmp	si, 0ffffh
	jz	NotChanged

    Changed:

	; Store the pointer to the LOL in the return variable
	;
	LPTR_ES	bx, @@plpDDT
	mov	es:[bx+0], di
	mov    	es:[bx+2], si
	inc	ax

    NotChanged:
ProcEnd
	end
