;
;   $Id: DLGETLOL.ASM 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:GETLOL.ASM
; Created 2-23-1999 by Brandon Thomas
;
; Copyright (c) 1997-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21 function 52h get the list
; of lists pointer
;
; bool PASCAL dlGetLOLPointer(LPLOL * plpLOL );
;
; $DOCHISTORY
; 02/27/1999 de  Cleaned it up and added it to the libs.
; 02/23/1999 bt  Created
;--------------------------------------------------------------------
include datalght.inc
include dostruct.inc
include _dldosio.inc

InitModel %MEMMODEL, pascal, use16

.code
;--------------------------------------------------------------------
; $DOCPROC: dlGetLOLPointer
;
; bool PASCAL dlGetLOLPointer(LPLOL *plpLOL );
;
; Interrupt 21 function 52h get list of list pointer.  Returns TRUE if
; successful, FALSE if it failed.
;
; On Entry
;
;	none
;
; On Exit
;
;	ax    (function)  TRUE if the function was successful, FALSE
;                         otherwise
;	es:bx (plpLOL)    Segment of allocated block
;
;--------------------------------------------------------------------
ProcBegin	dlGetLOLPointer,public
if @DataSize
ProcUses	ds,es
else
ProcUses	es
endif
ProcArgs	@@plpLOL:PTR
ProcSetup

	; Get List of Lists (LOL) pointer
	;
	mov	ah, 52h

	; Perform the interrupt
	;
	int	21h

	; Move the offset of the LOL pointer into another variable
	;
	mov	ax, bx

	; This function does not return a pointer to the beginning
	; of the list of lists.  So, we are adjusting the pointer so
	; that it points to the start of the list of lists structure.
	;
	sub	ax, LOL_dpb_ptr

	; Store the pointer to the LOL in the return variable
	;
	LPTR_DS	bx, @@plpLOL
	mov	[bx+0], ax
	mov	[bx+2], es

	; Set the boolean return value to successful and exit
	;
 xor	ax, ax			; zero ax, clear CF
	SET_DOS_ERROR

ProcEnd
	end
