;
;   $Id: DRVFRE32.ASM 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DRVFREE32.ASM
; Created 1-4-1999 by Brandon Thomas
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21h function 7303h get
; drive free space.  This is part of the Datalight Library.
;
; bool PASCAL dlGetDriveFreeSpace32( char * pszDriveString,
;		PGDF32 sFreeSpace );
;
; $DOCHISTORY
; 02/27/1999 de	 Cleaned it up.
; 01/04/1999 bt  Created.
;--------------------------------------------------------------------

include datalght.inc
include dostruct.inc
include _dldosio.inc

InitModel %MEMMODEL, pascal, use16


.code

;--------------------------------------------------------------------
; $DOCPROC: dlGetDriveFreeSpace32
;
; bool PASCAL dlGetDriveFreeSpace32( char * pszDriveString,
;		PGDF32 sFreeSpace );
;
; Int 21h function 7303h interface to get drive free space. This
; function returns TRUE if successful, FALSE if it failed.
;
; On Entry
;
;	es:di (sFreeSpace)    Free space structure
;	ds:dx (szDriveString) Name and path
;
; On Exit
;
;	ax (function) TRUE if the function was successful, FALSE otherwise
;
;--------------------------------------------------------------------
ProcBegin	dlGetDriveFreeSpace32,public
if @DataSize
ProcUses	ds,es,di
else
ProcUses	di
endif
ProcArgs	@@szDriveString:PTR, @@sFreeSpace:PTR
ProcSetup

	;
	; Set the function number for a Get Extended Free Space call
	;

	mov	ax, 7303h

	;
	; Set the pointer to the structure
	;

	LPTR_ES	di, @@sFreeSpace

	;
	; The level field must be initialized to zero
	; in the return structure
	;

	mov	word ptr es:[di].GDF_uLevel, 0

	;
	; Set the size of the buffer
	;

	mov	cx, SIZE GetDiskFreeSpace32

	;
	; Set the drive
	;

	LPTR_DS	dx, @@szDriveString

	;
	; Perform the get free space call
	;
	stc                     ;; set carry in case not supported by kernel
	int	21h
    	jnc	GDFS_done

	or	al, al		;; if error in function, AX will <> 0
	stc
	jnz	GDFS_done	;; return the appropriate error code

	mov	ax, 1		;; unsupported function error code

	;
	; Set the error code and return variable
	;

    GDFS_done:
	SET_DOS_ERROR

ProcEnd
	end
