;
;   $Id: EXPAND.ASM 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:EXPAND.ASM
; Created 7-1-1999 by Brandon Thomas
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21h function 60h which
; expands a path name string.  This is part of the Datalight
; Library.
;
; bool PASCAL dlExpandPath( char * szRelativePath, char * szAbsolutePath );
;
; $DOCHISTORY
; 07/01/1999 bt  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosio.inc

.code

;--------------------------------------------------------------------
; $DOCPROC: dlKernelSupportVersion
;
; bool PASCAL dlExpandPath( char * szRelativePath, char * szAbsolutePath );
;
; This function calls INT-21h function 60h which is used to determine
; the absolute path for a relative path.  This function returns TRUE
; if successful.
;
; On Entry
;
;	szRelativePath = relative path name
;	szAbsolutePath = 67 byte work buffer
;
; On Exit
;	if the function is successful, the szAbsolutePath will contain
;	the absolute path with respect to the relative path.
;
;	ax  TRUE if romdos is running, FALSE otherwise
;
;--------------------------------------------------------------------
ProcBegin 	dlExpandPath, public
ProcArgs	@@szRelativePath:PTR,@@szAbsolutePath:PTR
ProcUses	ds,es,si,di
ProcSetup

	; Set the function number
	;
	mov	ah, 60h
	LPTR_DS si, @@szRelativePath
	LPTR_ES di, @@szAbsolutePath

	; Perform the Expand Path Name function
	;
	int	21h
	jc	short Error

	xor	ax, ax			; zero ax, clear CF

    Error:
	SET_DOS_ERROR
ProcEnd

@curseg	ends
	end
