;
;   $Id: FCBPARSE.ASM 1.2 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:FCBPARSE.ASM
;
; Copyright (c) 2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 01/16/02  bt  Created
;
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosio.inc

.code

;--------------------------------------------------------------------
; $DOCPROC: dlFCBParse
;
; bool PASCAL dlFCBParse( uchar ucParseControlFlag, char * szName,
;	PFCB pFCB );
;
; This module is a wrapper for interrupt 21h function 29h which
; parses a file name into an FCB.  Returns TRUE if successful
;
;
; On Entry
;
;	al    (ucParseControlFlag) Parse control flag
;	ds:si (szName)             File name
;	es:di (pFCB)               Unopened FCB
;
; On Exit
;
;	ax 	TRUE if the function was successful, FALSE otherwise
;
;--------------------------------------------------------------------
ProcBegin	dlFCBParse,public
ProcArgs	@@ucParseControlFlag:byte,@@szName:PTR,@@pFCB:PTR
ProcUses	ds,si,di
ProcSetup

	;  Set the address of the file name
	;
	LPTR_DS si, @@szName

	;  Set the address of the FCB
	;
	LPTR_ES	di, @@pFCB

	;  Set the parse control flag
	;
	mov	al, @@ucParseControlFlag

	; Set the function number
	;
	mov	ah, 29h

	; Perform the interrupt
	;
	int	21h

	; Set return variable
	;
	not	al
	cbw

ProcEnd
	end
