;
;   $Id: LFNFIND.ASM 1.5 2002/10/15 22:55:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:LFNDIR.ASM
; Created 07-07-1998 by Drew Gislason
;
; Copyright (c) 1998-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 07/07/1998 dg  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16

include _dllfn.inc

.code

;--------------------------------------------------------------------
; $DOCPROC:LFNFindFirstFile
;
; bool PASCAL LFNFindFirstFile(int nAttrs, char szLongMask[], int nDateFmt,
;	struct WIN32_FIND_DATA *pFindData, int *pHandle, int *pConvertCode);
;
; Find a file matching the longname file match. Note that szLongMatch
; uses different search criteria than the older DOS style search.
; Multiple wildcards are allowed. Example:
;
; *start*mid*end*  Will find anything containing the strings "start",
; "mid" and "end" in that order.
;
; Remember also to close the search, or the handle will be lost.
;
; On Entry
;	ch (hi byte nAttrs)	MustMatchAttrs
;	cl (lo byte nAttrs)	SearchAttrs
;	ds:dx (szLongMask)	search string
;	si (nDateFmt)		date/time format
;	es:di (pFindData)	buffer for data
; On Exit
;	ax (pHandle)		handle for findnext
;	cx (pConvertCode)	UniCode conversion code
;	es:di (pFindData)	filled in find data.
;
; Returns TRUE if worked, FALSE if failed.
;--------------------------------------------------------------------
ProcBegin	LFNFindFirstFile, PUBLIC
ProcArgs	@@nAttrs:word, @@szLongMask:PTR, @@nDateFmt:word, @@pFindData:PTR, @@pHandle:PTR, @@pConvertCode:PTR
ProcUses	ds, si, di
ProcSetup
	; call LFN to make directory
	mov	cx, @@nAttrs
	lptr_ds	dx, @@szLongMask
	lptr_es	di, @@pFindData
	mov	si, @@nDateFmt
	mov	ax, 714Eh
	stc
	int	21h
	jc	@@SetPassFail

	; save handle and conversion code
	lptr_ds	bx, @@pHandle
	mov	[bx], ax
	lptr_ds	bx, @@pConvertCode
	mov	[bx], cx

	; set pass/failed here (ax=TRUE if worked, FALSE if failed)
    @@SetPassFail:
	LFN_SET_DOS_ERROR
ProcEnd

	END
