;
;   $Id: LFNMISC.ASM 1.5 2002/10/15 22:55:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:LFNMISC.ASM
; Created 07-07-1998 by Drew Gislason
;
; Copyright (c) 1998-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 07/07/1998 dg  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16

include _dllfn.inc

.code

;--------------------------------------------------------------------
; $DOCPROC:LFNConvertFileTime
;
; bool PASCAL LFNConvertFileTime(int iAction, int *pMilli,
;					union FILETIME *pFileTime);
;
; Convert file time/date between DOS and 64-bit Nanosecond form.
;
; On Entry
;	bl (iAction)		action (0=Nano to DOS, 1=DOS to Nano)
;	bh (pMilli)		0-199 milliseconds, action 1 only
;	ds:si (pFileTime)	union for file time
; On Exit
;	bh (pMilli)		0-199 milliseconds, action 1 only
;	cx			DOS time
;	dx			DOS date
;	es:di (pFileTime)	returned time
;
; Returns TRUE if worked. Returns FALSE if failed.
;--------------------------------------------------------------------
ProcBegin	LFNConvertFileTime, PUBLIC
ProcArgs	@@iAction:word, @@pMilli:PTR, @@pFileTime:PTR
ProcUses	ds, si, di
ProcSetup

	; setup to convert from Nano (64-bit) to DOS date/time
	cmp	@@iAction, 0	; Nano to DOS
	jnz	SetupDOSToNano
	lptr_ds	si, @@pFileTime
	jmp	short ConvertTime

	; set to convert from DOS date/time to Nano (64-bit) time
    SetupDOSToNano:
	lptr_ds	si, @@pMilli
	mov	bh, [si]
	lptr_es	di, @@pFileTime
	mov	cx, es:[di]	; DOS time
	mov	dx, es:[di+2]	; DOS date

	; convert file time
    ConvertTime:
	mov	bl, byte ptr @@iAction
	mov	ax, 71A7h
	stc
	int	21h
	jc	@@SetPassFail

	; Nano (64-bit) file time to DOS file time/date
	cmp	@@iAction, 0	; Nano to DOS
	jnz	@@Done
	lptr_ds	si, @@pMilli
	mov	[si], bh
	lptr_ds	si, @@pFileTime
	mov	[si], cx
	mov	[si+2], dx
	xor	ax, ax
	mov	[si+4], ax	; zero hi dword
	mov	[si+6], ax

	; passed and done. clear carry
    @@Done:
	clc

	; set pass/failed here (ax=TRUE if worked, FALSE if failed)
    @@SetPassFail:
	LFN_SET_DOS_ERROR
ProcEnd

	END
