;
;   $Id: LFNSUBST.ASM 1.5 2002/10/15 22:55:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:LFNSUBST.ASM
; Created 04-03-2001 by Thom Denholm
;
; Copyright (c) 2001-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is part of the Long Filename Support for the Datalight
; Library. It contains the support functions for the Windows SUBST calls.
;
; bool PASCAL LFNSubstFunction(int iFunction, int iDrive, char szLongName[]);
;
; $DOCHISTORY
; 04/03/2001 td  Created
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16

include _dllfn.inc

.code

;--------------------------------------------------------------------
; $DOCPROC:LFNSubstFunction
;
; bool PASCAL LFNSubstFunction(int iFunction, int iDrive, char szLongName[]);
;
; Perform one of the three valid subst functions
;
; On Entry
;  bh (iFunction)      Function Number
;  bl (iDriveNum)      Drive Number (01=A:, etc.)
;  ds:dx (szLongFName) Long filename directory string (function 0)
;                      Long filename buffer (function 2)
; On Exit
;  function performed, or error
;
; Notes
;  Drive number may only be "00" or "default drive" for function 0.
;  A check for this in functions 1 or 2 has not been implemented.
;
; Returns TRUE if worked. Returns FALSE if failed.
;--------------------------------------------------------------------
ProcBegin   LFNSubstFunction, PUBLIC
ProcArgs	@@iFunction:byte, @@iDriveNum:byte, @@szLongFname:PTR

ProcUses	ds,dx,bx
ProcSetup
	mov	bh, @@iFunction
	mov	bl, @@iDriveNum
	lptr_ds	dx, @@szLongFname
	mov	ax, 71AAh
	stc
	int	21h

	; set pass/failed here (ax=TRUE if worked, FALSE if failed)
	LFN_SET_DOS_ERROR
ProcEnd

	END
