;
;   $Id: _DLLFN.INC 1.5 2002/10/15 22:55:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:_DLLFN.INC
; Created 06-29-1998 by Drew Gislason
;
; Copyright (c) 1998-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; Helper macros for Long Filename routines.
;
; $DOCHISTORY
; 07-28-98   de	 Commented and slightly improved the error handling macro.
;		 Also renamed it to LFN_SET_DOS_ERROR to be distinct from the
;		 8.3 names macro that functions similarly. Also added
;		 the MEMMODEL.INC include comment.
; 07/14/1998 dg  Set ERR_BADFUNC on int 21 71h on DOS 6.22.
; 06/29/1998 dg  Created.
;--------------------------------------------------------------------

; Declare our error variable for the lib modules to see
;
extrn	LAST_DOS_ERROR:word


; if your assembler does not suport @DataSize and @CodeSize then
; you will have to provide these definitions, possibly based on the
; command line definition of the MEMMODEL string equate.
;
; include MEMMODEL.inc


ERR_BADFUNC	equ	1


;--------------------------------------------------------------------
; $DOCMACRO:LFN_SET_DOS_ERROR
;
; If there was an error, updates the internal error code variable and
; then sets up a boolean return value in AX (TRUE (1) means the function
; succeeded, FALSE (0) means failure). It assumes that the state of the
; CF and the value of AX are those returned by DOS.
;
; NOTE: Any function that uses this macro MUST have the carry flag set
; 	at the time that it calls int 21h fn 71xx. Without this precaution
;	we will not be able to determine whether or not LFN functions are
;	supported by a particular ROM-DOS configuration.
;
LFN_SET_DOS_ERROR macro
local @@error_recorded, @@sde_got_err

	jnc	@@error_recorded	;; don't erase errors, return TRUE (1)

	;; int 21h, 71h calls won't set error code on DOS 6.22. Instead
	;; they will just set AL to 0 without changing the state of the
	;; carry flag. Change it to "invalid function" and make sure that
	;; CF = 1 when we get to @@error_recorded.
	;;
	cmp	al, 0
	jnz	@@sde_got_err
	mov	ax, ERR_BADFUNC

    @@sde_got_err:
	stc				;; return FALSE (0) on errors

    if @DataSize
	push	ax
	mov	ax, SEG LAST_DOS_ERROR	;; record the latest error code
	mov	ds, ax
	pop	LAST_DOS_ERROR
    else
	mov	LAST_DOS_ERROR, ax
    endif

    @@error_recorded:
	mov	ax, 0
	cmc
	adc	ax, ax
ENDM
