//
//   $Id: DLCMDLN3.C 1.6 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*******************************************************************

   DLCMDLN3.C  created 04/24/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Datalight ROM-DOS Tools Library

********************************************************************/


#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"

char far * GetEnvEntry( char * szString );


void GetLFNCommandLine(char * szLFNCmdLine, unsigned uMaxLen)
{
	char far * lpCmdLine;
	struct PSP far *fpPSP;
	char far * lpStart;
	bool inQuote;


	lpCmdLine = GetEnvEntry("CMDLINE");


	// validate parameters
	ASSERT(szLFNCmdLine);
	ASSERT(uMaxLen > 0);


	// do we use the CMDLINE variable
	if(lpCmdLine)
	{
		// remove leading whitespace
		while (DL_IS_SPACE(*lpCmdLine))
			lpCmdLine++;

		// move past program
		lpStart = lpCmdLine;
		inQuote = FALSE;
		while (*lpStart)
		{
			if (*lpStart == '"')
			{
				if (!inQuote)
					inQuote = TRUE;
				else
					inQuote = FALSE;
			}

            if (*lpStart == 0x0d)
                break;

			if( (!inQuote) && (*lpStart == ' ') )
			{
				++lpStart;
				break;
			}

			if( (!inQuote) && (*lpStart == '/') )
			{
				break;
			}

			++lpStart;
		}


		if (!*lpStart || *lpStart == 0x0d)
		{
			*szLFNCmdLine = '\0';
			return;
		}
		else
		{
			lpCmdLine = lpStart;
			if (_fstrlen(lpCmdLine)-1 < uMaxLen)
				uMaxLen = _fstrlen(lpCmdLine);
		}

	}
	else
	{
		unsigned psp;

		asm {
			mov ah, 62h
			int 21h
			mov psp, bx
		}
		fpPSP = MK_FP(psp, 0);

		if (fpPSP->count < uMaxLen)
			uMaxLen = fpPSP->count;

		lpCmdLine = (char far *)fpPSP->command_line;
		lpCmdLine[fpPSP->count] = 0;

		// remove leading whitespace
		while (DL_IS_SPACE(*lpCmdLine))
		{
			lpCmdLine++;
			uMaxLen--;		// don't need to copy as many characters...
		}
	}

	_fstrncpy( szLFNCmdLine, lpCmdLine, uMaxLen );


	// make sure it is null terminated...
	szLFNCmdLine[uMaxLen] = '\0';
}
