;
;   $Id: DLEXITA.ASM 1.4 2002/10/15 22:57:48Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~

    DLEXITA.ASM  Created 04-28-97 Dennis Edwards

    Copyright (c) 1989-2002 Datalight, Inc.
    All Rights Reserved.
    Datalight Confidential and Proprietary

    Interrupt handler module for Datalight Exit Handler Package.
    Filters interrupts 23h and 24h.

end_comment ~


include ..\include\datalght.inc
include ..\include\dlerrcod.inc


; Values that can be returned by the (DOS or user) int24h handler
;
INT24_IGNORE	=	0
INT24_RETRY	=	1
INT24_ABORT	=	2
INT24_FAIL	=	3

INT24_FAIL_OK   =	08h
INT24_RETRY_OK  =	10h
INT24_IGNORE_OK =	20h


InitModel %MEMMODEL, pascal, use16

	extrn	_userInt23hHandler:dword
	extrn   _oldInt23hHandler:dword

	extrn	_userInt24hHandler:dword
	extrn	_oldInt24hHandler:dword
	extrn   _int24ax:word
	extrn   _int24ip:word
	extrn   _int24cs:word
	extrn   _int24flags:word

	extrn	_exit:proc


.Code

ProcBegin	Int23Handler, public
ProcSetup

	push	ax
	push	bx
	push	cx
	push	dx
	push	ds
	push	es

	; If the user did not call SetInt23hHandler to establish
	; a consultive routine, we take the default action of
	; ignoring ^C, ^Break and <Alt><Num3>
	;
	mov	ax, SEG _userInt23hHandler
	mov	ds, ax
	mov	bx, word ptr _userInt23hHandler
	mov	ax, word ptr _userInt23hHandler[2]
	mov	cx, ax
	or	cx, bx
	jz	@@int23h_continue

	push	cs				; save return CS:IP
	mov	cx, offset @@int23h_watawedo
	push	cx
	push	ax	; push destination CS:IP
	push	bx
	mov	ax, DGROUP
	mov	ds, ax
	retf		; "call" destination handler

	; If the user handler returns ax < 0 we will ignore the ^C.
	; If the user handler returns ax >= 0 we will call exit()
	; (passing it the value in AL) to process any atexit()
	; handlers and abort the program.
	;
    @@int23h_watawedo:
	or	ax, ax
	js	@@int23h_continue

    @@int23h_die:
	and	ax, 0FFh	; only use value in AL
	push	ax
	mov	ax, DGROUP
	mov	ds, ax
	call	_exit
	pop	ax
	stc
	jmp	short @@int23h_exit

    @@int23h_continue:
	clc

    @@int23h_exit:
	pop	es
	pop	ds
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	retf	2

ProcEnd

; This is a CONSTANT! and should not cause a problem with RXE...
; We need this reference to the label in a variable so we
; can push the value in 8086 mode.
;
ReturnOffset	dw offset ReturnedFromResidentInt24hHandler


; This is our int 24h handler.
ProcBegin	Int24Handler, public
ProcSetup

	push	ds
	push	bx	; save regs we use to see if user installed a handler
	push	cx
	push	dx

	mov	dx, SEG _userInt24hHandler
	mov	ds, dx
	mov	bx, word ptr _userInt24hHandler
	mov	dx, word ptr _userInt24hHandler[2]
	mov	cx, dx
	or	cx, bx
	jz	@@no_user_int24_handler

	push	es	; save DOS' ES

	push	ax	; flags and drive
	push	di	; device error value
	push	bp	; SEG device header
	push	si	; OFFSET device header
	push	cs                         	; save return CS:IP
	mov	cx, offset @@back_from_user
	push	cx
	push	dx	; push destination CS:IP
	push	bx
	mov	ax, DGROUP
	mov	ds, ax
	retf		; "call" destination handler

    @@back_from_user:
	add	sp, 6	; pop C args from stack
	pop	bx	; get back ax value passed in by DOS
	mov	ah, bh	; get the passed flags back into AH

	pop	es
	pop	dx
	pop	cx	; restore all of DOS' regs except DS
	pop	bx
	jmp	short @@evaluate_user_response

    @@no_user_int24_handler:
	pop	dx
	pop	cx		; restore all of DOS' regs except DS
	pop	bx

	mov	_int24ax, ax	; save AX passed in by DOS
	pop	ax		; AX = DOS' DS

	; Nothing of ours is left on the stack right now.
	; Get DOS CS:IP+flags off stack in case the resident
	; int 24h handler might access the registers saved
	; on the stack. The contents of the stack is published info.
	;
	pop	_int24ip
	pop	_int24cs
	pop	_int24flags

	pushf
	push	cs
	push	cs:[ReturnOffset]

	push	word ptr _oldInt24hHandler[2]
	push	word ptr _oldInt24hHandler

	push	ax		; put DOS' DS back on the stack
	mov	ax, _int24ax	; restore AX passed in by DOS
	pop	ds		; restore DOS' DS

	; call the resident handler
	;
	cli
	retf

	public	ReturnedFromResidentInt24hHandler
ReturnedFromResidentInt24hHandler  label byte

	; Make room on the stack to restore DOS' CS:IP+flags
	; We will want DOS' DS on the top of the stack after
	; the IRET address and flags are restored
	;
	sub	sp, 6
	push	ds

	; Set up a stack frame:
	; flags = bp+8
	; cs 	= bp+6
	; ip 	= bp+4
	; ds 	= bp+2
	;
	push	bp
	mov	bp, sp
	push	bx
	push	ax

	; Get our DATA segment into DS
	;
	mov	ax, SEG _userInt24hHandler
	mov	ds, ax

	; Restore DOS' CS:IP and flags for our IRET
	;
	mov	ax, _int24flags
	mov	[bp+8], ax
	mov	ax, _int24cs
	mov	[bp+6], ax
	mov	ax, _int24ip
	mov	[bp+4], ax

	; Get the flags DOS passed in into AH, the action code
	; that the resident int 24h handler passed back will be
	; in AL
	;
	pop	ax
	mov	bx, _int24ax
	mov	ah, bh

	; Restore BX and destroy our temporary stack frame
	;
	pop	bx
	pop	bp

	; However we get here...
	;
	; AH = The flags DOS passed us when it generated the int 24h
	; AL = The action code that the int 24h handler passed back
	; DOS' DS is on the top of the stack followed DOS' CS:IP+flags
	;
	; We need to evaluate the return code from the int 24h
	; handler.  If the returned action is not allowed then we
	; must promote the value using DOS' rules. If the action
	; code is (ultimately promoted to) Abort, then we need to
	; dispatch our atexit() functions by calling exit()
	; (vs _exit() or abort()) before "returning"
	;
    @@evaluate_user_response:
	cmp	al, INT24_ABORT
	je	@@int24_terminate
	ja	@@int24_check_fail_OK

	or	al, al
	jnz	@@int24_check_retry_OK

	; If Fail specified and allowed, return else promote
	; Ignore to Fail
	;
    @@int24_check_ignore_OK:
	test	ah, INT24_IGNORE_OK
	jnz	@@int24_exit

	jmp	short @@int24_promote_to_fail

	; If Retry specified and allowed, return else promte
	; Retry to Fail
	;
    @@int24_check_retry_OK:
	test	ah, INT24_RETRY_OK
	jnz	@@int24_exit

    @@int24_promote_to_fail:
	mov	al, INT24_FAIL

	; if Fail specified and Fail allowed, just return
	; otherwise promote Fail to Abort
	;
    @@int24_check_fail_OK:
	test	ah, INT24_FAIL_OK
	jnz     @@int24_exit

	; We are going to be terminated. Make sure our atexit()
	; functions get executed.
	;
    @@int24_terminate:
	push	ax
	push	bx
	push	cx
	push	dx
	push	es

	mov	ax, DGROUP
	mov	ds, ax
	mov	ax, ERR_USER_ABORT
	push	ax
	call	_exit	; vs. __exit which is _exit() in C
	pop	ax

	pop	es
	pop	dx
	pop	cx
	pop	bx
	pop	ax

    @@int24_exit:
	pop	ds
	iret
ProcEnd


comment ~
void PASCAL InstallDOSErrorHandlers(void)
end_comment ~
ProcBegin	InstallDOSErrorHandlers, public
ProcUses	ds, es
ProcSetup

	xor	ax, ax
	mov	bx, 23h*4
	mov	es, ax
	mov	ax, offset Int23Handler
	mov	dx, cs
	cli
	xchg	es:[bx], ax
	xchg	es:[bx][2], dx
	mov	word ptr _oldInt23hHandler, ax
	mov	word ptr _oldInt23hHandler[2], dx
	sti

	mov	bx, 24h*4
	mov	ax, offset Int24Handler
	mov	dx, cs
	cli
	xchg	es:[bx], ax
	xchg	es:[bx][2], dx
	mov	word ptr _oldInt24hHandler, ax
	mov	word ptr _oldInt24hHandler[2], dx
	sti
ProcEnd


comment ~
void RemoveDOSErrorHandlers(void)
end_comment ~
ProcBegin	RemoveDOSErrorHandlers, C, public
ProcUses	ds, es
ProcSetup

	xor	ax, ax
	mov	bx, 23h*4
	mov	es, ax
	mov	ax, SEG _oldInt23hHandler
	mov	ds, ax
	cli
	mov	ax, word ptr _oldInt23hHandler
	mov	dx, word ptr _oldInt23hHandler[2]
	mov	es:[bx], ax
	mov	es:[bx][2], dx
	sti

	mov	bx, 24h*4
	cli
	mov	ax, word ptr _oldInt24hHandler
	mov	dx, word ptr _oldInt24hHandler[2]
	mov	es:[bx], ax
	mov	es:[bx][2], dx
	sti
ProcEnd


end
