//
//   $Id: DLPATH4.C 1.5 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   DLPATH4.C  created 03/07/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Contains the routines needed to get a generic path.

	void SetFileExt(char szFileName[], const char szExt[]);

	Todo:
	Make this internationally aware.

	Revision History
	03/16/99	jmb	Added ExandPath
	03-06-01  bt  Broke up dlpath.c for library granularity
	03-06-01  bt  Changed calls to borland libraries to DL libs

**********************************************************/
#define __FILENUM__	507

// includes
//#include <dir.h>
//#include <dos.h>
//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>

#include "datalght.h"
#include "dlpath.h"
//#include "dlcntry.h"

/*
	Set the file extension to the given extenstion.
	"szExt" can be either in ".ext" form or just "ext".
	Cannot fail.  Does no checking for string sizes.

	Examples:

		Name        Ext      Combined
		X.Y         .Z       X.Z
		A:\HELLO    XYZ      A:\HELLO.XYZ
		FILE.EXT             FILE             (empty extension)
*/
void SetFileExt(char szFileName[], const char szExt[])
{
	char *pNamePart;
	char *pExt;

	// validate parameters
	ASSERT(szFileName);
	ASSERT(szExt);

	// look for just the name part (just after any path parts)
	pNamePart = strrchr(szFileName, '\\');
	if(!pNamePart)
		pNamePart = szFileName;

	// look for extension, if any
	pExt = strchr(pNamePart, '.');
	if(!pExt)
		pExt = pNamePart + strlen(pNamePart);

	// is there an extension?
	if(*szExt)
	{
		// add on the new extension
		if(*pExt != '.')
			*pExt = '.';

		// if szExt already has a dot, we don't need 2
		if(*szExt != '.')
			++pExt;
	}

	// copy in the new extension
	strcpy(pExt, szExt);
}
