//
//   $Id: DLPATH6.C 1.4 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   DLPATH6.C  created 03/07/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Contains the routines needed to get a generic path.

	Datalight ROM-DOS Tools Library:
	bool SetName(char szFullPath[], const char szName[]);
	bool PartialToFullPath(char *pFullPath, char *pPartialPath);
	bool IsWild(const char *pStr);
	int PASCAL IntlFileNameSplit(char *pStr, char *pDrive, char *pDir,
													char *pName, char *pExt);
	bool ExpandPath(char *pFullPath, char *pPartialPath);

	Todo:
	Make this internationally aware.

	Revision History
	03/16/99	jmb	Added ExandPath
	03-06-01  bt  Broke up dlpath.c for library granularity
	03-06-01  bt  Changed calls to borland libraries to DL libs

**********************************************************/
#define __FILENUM__	507

// includes
#include <dir.h>
//#include <dos.h>
//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>

#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dlpath.h"
#include "dllfn.h"
//#include "dlcntry.h"

/*
	Set the name in the full path to the given name.

	Returns FALSE if string is too long.
*/
bool SetName(char szFullPath[], const char szName[])
{
	char *pNamePart;

	// validate parameters
	ASSERT(szFullPath);
	ASSERT(szName);

	// find the last slash (example C:\TEMP\NAME.EXT)
	pNamePart = strrchr(szFullPath, '\\');

	// no slash found, what about just a drive (example C:)
	if(!pNamePart)
		pNamePart = strchr(szFullPath, ':');

	// found the name part? skip slash or colon
	if(pNamePart)
		++pNamePart;

	// did NOT find the name part? then just use start of string
	if(!pNamePart)
		pNamePart = szFullPath;

	// check for string too long
	if(pNamePart - szFullPath + strlen(szName) >= DL_MAXPATH)
		return FALSE;

	// copy the name to the right place
	strcpy(pNamePart, szName);
	return TRUE;
}
