//
//   $Id: DLSCALE.C 1.8 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  DLSCALE.C
//
//  Copyright (c) 1999-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//


#include <stdio.h>
#include <string.h>

#include "datalght.h"
#include "dl64.h"

/*
	11,876.73 MB
	1,234,567,890

	Always scale the bytes to Megabytes
	Returns total length of string.
*/
int PASCAL DlScaleQuadToMegabytes(char szStr[], uquad uqValue, bool fCommas)
{
	static char szPercent[]    = ".%02u";
	static char szWithCommas[] = "%,lu";
	static char szNoCommas[]   = "%lu";
	static char szMegabytes[]  = " MB";

	ulong ulValue;
	int	iPercent = 0;
	unsigned	uRemainder;
	char * psz = szStr;

	// convert to megabytes
	DivideQuadByUnsigned(&uqValue, 1024, &uRemainder, &uqValue );
	DivideQuadByUnsigned(&uqValue, 1024, &uRemainder, &uqValue );

	// determine percentage
	ulValue = 1000L * uRemainder;
	ulValue /= 1024;
	iPercent = (int)ulValue;
	if((iPercent % 10) >= 5)		// round up/down
		iPercent += 10;
	iPercent /= 10;

	// expressed in megabytes
	ulValue = GetQuadLoDword(&uqValue);

	// put the main part of the number into the string
	psz += sprintf(psz, (fCommas ? szWithCommas : szNoCommas), ulValue);

	// put the percentage point into the string
	if(iPercent)
		psz += sprintf(psz, szPercent, iPercent);

	// put megabyte onto end of the string
	psz += sprintf(psz, szMegabytes);

	// return length of string
	return (int)(psz - szStr);
}

#if UNIT_TEST

#define MAX_ULONG	4294967295L		// (0xFFFFFFFFL)

int main(void)
{
	char	szStr[32];
	uquad	uqValue;

	// test low numbers
	SetQuadZX(&uqValue, 0);
	dlScaleQuadToMegabytes(szStr, uqValue, TRUE);
	printf("%s\n",szStr);

	SetQuadZX(&uqValue, 4294967295L);
	dlScaleQuadToMegabytes(szStr, uqValue, TRUE);
	printf("%s\n",szStr);

	// test no commas
	dlScaleQuadToMegabytes(szStr, uqValue, FALSE);
	printf("%s\n",szStr);

	// test quad numbers
	uqValue = QuadMultiply(1111111111L, 9L);
	dlScaleQuadToMegabytes(szStr, uqValue, TRUE);
	printf("%s\n",szStr);

	// test no commas
	dlScaleQuadToMegabytes(szStr, uqValue, FALSE);
	printf("%s\n",szStr);

	return 0;
}
#endif
