;
;   $Id: DLWLDDEL.ASM 1.4 2002/10/15 22:57:48Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  DLWLDDEL.ASM created 05-01-97 Dennis Edwards
;
;  Copyright (c) 1997-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  This function uses the DOS function 5D00h (server back door)
;  to do a wild card delete. To delete all files in a directory
;  use the attr. The lpPath argument must be a fully canonical
;  path and file mask for the files to delete (eg c:\temp\*.bak).
;  Use the WILDDEL_ATTR attribute value to delete all files
;  (including Hidden, System and Read-Only directory entries).
;
;  Returns the DOS error code from the 5D00h call which is
;  ERR_FILE_NOT_FOUND (2) on success.
;
;  See Undocumented DOS 2nd Edition, pg 723-724 for more information.
;
include datalght.inc

InitModel %MEMMODEL, pascal, use16


	extrn	__psp:word

.Code

comment ~
int PASCAL WildUnlink(char far* lpPath,uchar attr)
end_comment ~
ProcBegin	WildUnlink, public
ProcArgs	lpPath:dword, attr:byte
ProcUses	ds
ProcSetup

	mov	bx, sp                 	; remember current SP
	mov	ax, __psp
	push	ax			; set PSP
	xor	ax, ax
	push	ax			; set machine ID (0 is current)
	push	ax                      ; set reserved word = 0

	mov	ax, 4100h		; set up for "Delete Files" function
	lds	dx, lpPath		; with specified path and mask
	mov	cl, attr		; and search attributes

	push	es			; fill in the rest of the struct.
	push	ds
	push	di
	push	si
	push	dx
	push	cx
	push	bx
	push	ax

	mov	dx, sp			; save ptr to start of struct
	push	bx

	mov	ax, ss
	mov	ds, ax
	mov	ax, 5D00h		; server back door call
	int	21h			; to DOS

	pop	sp			; restore SP
ProcEnd

end
