;
;   $Id: STDOS.ASM 1.7 2002/10/15 22:45:24Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  STDOS.ASM
;
;  Copyright (c) 1993-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;


;
;
include stdos.inc
include stdos.def


;-----------------------------------------
;  Macros and equates
;-----------------------------------------

IFDEF __COMPACT__ OR __LARGE__
	GOFFSET equ <offset _BSS:>
ELSE
IFDEF __TINY__
	GOFFSET equ <offset _TEXT:>
ELSE ; IFDEF __TINY__
	GOFFSET equ <offset DGROUP:>
ENDIF ; IFDEF __TINY__
ENDIF

;----------------------------------------------------------------------------
;  Segment declarations
;----------------------------------------------------------------------------

_TEXT           SEGMENT BYTE PUBLIC 'CODE'
label	begCODE
                ENDS
_DATA           SEGMENT PARA PUBLIC 'DATA'
label	endCODE
label	begDATA
                ENDS
_CONST		SEGMENT PARA PUBLIC 'CONST'
label	endDATA
label	begCONST
                ENDS
_BSS            SEGMENT PARA PUBLIC 'BSS'
label	endCONST
label	begBSS
                ENDS
_BSSEND         SEGMENT PARA PUBLIC 'BSSEND'
public endbss
label	endBSS
                ENDS
IFNDEF __TINY__
_STACK          SEGMENT STACK 'STACK'
public begstack
label	begSTACK
		db	80h dup(?)
                ENDS
ENDIF


;----------------------------------------------------------------------------
;  DGROUP definition
;----------------------------------------------------------------------------

IFDEF __TINY__
	DGROUP GROUP _TEXT, _DATA, _BSS
ELSE ; IFDEF __TINY__

IFDEF __COMPACT__ OR __LARGE__
	DGROUP GROUP _BSS
ELSE ; IFDEF __COMPACT__ OR __LARGE__
	DGROUP GROUP _DATA, _BSS
ENDIF ; IFDEF __COMPACT__ OR __LARGE__

ENDIF ; IFDEF __TINY__

IFDEF __COMPACT__ OR __LARGE__ OR __TINY__
        ASSUME  CS:_TEXT, DS:_BSS
ELSE
        ASSUME  CS:_TEXT, DS:DGROUP
ENDIF

;----------------------------------------------------------------------------
;  External References
;----------------------------------------------------------------------------

IFDEF __MEDIUM__ OR __LARGE__
	extrn _main:far
ELSE
	extrn _main:near
ENDIF

IF STDOS_RESIZE
	extrn __stklen:word
ENDIF ; IF STDOS_RESIZE

;-----------------------------------------
;	Initialized data segment
;-----------------------------------------
_DATA	SEGMENT


	;  This must be the first entry in the data segment.  It is
	;  used to check for a null pointer assignement
	;
		public lpNullPtr
	lpNullPtr	dd	0


_DATA	ENDS


;-----------------------------------------
;	Uninitialized data segment
;-----------------------------------------
_BSS	SEGMENT


	;  Global _psp variable for C
	;
		public __psp
	__psp		dw	?


	;  Global _envseg variable for C
	;
		public __envseg
	__envseg	dw	?


	;  Global errno variable for C
	;
		public _errno
	_errno		dw	?


	;  Global errno variable for C
	;
		public DGROUP@
	DGROUP@		dw	?


	;  argv and argc
	;
		public	argc
	argc	dw	?

	; argv[0]=progname name
	; argv[1]=args (if any)
	; argv[n]=NULL
		public	argv
IF BUILD_ARGS

IFDEF __COMPACT__ OR __LARGE__
	argv	dd	(MAXARGV + 1) dup (?)
ELSE ; IFDEF __COMPACT__ OR __LARGE__
	argv	dw	(MAXARGV + 1) dup (?)
ENDIF ; IFDEF __COMPACT__ OR __LARGE__

ELSE  ; IF BUILD_ARGS

IFDEF __COMPACT__ OR __LARGE__
	argv	dd	?		 ; argv[0]= NULL
ELSE ; IFDEF __COMPACT__ OR __LARGE__
	argv	dw	?		 ; argv[0]= NULL
ENDIF ; IFDEF __COMPACT__ OR __LARGE__

ENDIF ; IF BUILD_ARGS


IF BUILD_ARGS
	;  Temp variables for building the command line args
	;
	NextArgv	dw	?
	ArgStart	dw	?
	ArgEnd		dw	?
	CmdCount	dw	?
ENDIF

_BSS	ENDS


;----------------------------------------------------------------------------
;  Entry point
;----------------------------------------------------------------------------

_TEXT           SEGMENT
IFDEF __TINY__
                ORG     100h
ENDIF

StartUp:
;	int 3

	;  Zero BSS
	;
	;  NOTE: Running on init stack
	;
IFDEF __COMPACT__ OR __LARGE__
	mov	si, SEG _BSS
ELSE ; IFDEF __COMPACT__ OR __LARGE__
IFDEF __TINY__
	mov	si, cs
ELSE ; IFDEF __TINY__
	mov	si, DGROUP
ENDIF ; IFDEF __TINY__
ENDIF ; IFDEF __COMPACT__ OR __LARGE__
	mov	es, si
IFDEF __COMPACT__ OR __LARGE__
	mov	di, seg _BSS
	mov	cx, seg _BSSEND
	sub	cx, di
	shl	cx, 4
	xor	di, di
ELSE ; IFDEF __COMPACT__ OR __LARGE__
	mov	di, GOFFSET begBSS
	mov	cx, GOFFSET endBSS
	sub	cx, di
ENDIF ; IFDEF __COMPACT__ OR __LARGE__
	xor	al, al
	cld
	rep	stosb


	;  Save the PSP segment
	;
	;  NOTE: ES set above to BSS.  When data is near, ES
	;        is set to DGROUP which contains BSS.
	;
	;  NOTE: __psp resides in BSS which means it can not be
	;        saved before BSS is initialized
	;
IFDEF __COMPACT__ OR __LARGE__
        ASSUME  ES:_BSS
ELSE ; IFDEF __COMPACT__ OR __LARGE__
        ASSUME  ES:DGROUP
ENDIF ; IFDEF __COMPACT__ OR __LARGE__

	mov	word ptr es:[GOFFSET __psp], ds


	;
	;
	mov	ds, si
IFDEF __COMPACT__ OR __LARGE__
        ASSUME  DS:_BSS
ELSE ; IFDEF __COMPACT__ OR __LARGE__
        ASSUME  DS:DGROUP
ENDIF ; IFDEF __COMPACT__ OR __LARGE__


	;  Save the location of environment
	;
IFNDEF __TINY__
	mov	ES, [__psp]
ENDIF
	mov	ES, ES:[2CH]
	mov	word ptr [GOFFSET __envseg], ES


IFDEF __COMPACT__ OR __LARGE__

	;  Determine the amount of memory used by the program
	;
	mov	bx, seg _STACK
	mov	ax, seg _TEXT
	sub	bx, ax
	mov	ax, SEG __stklen
	mov	es, ax
	ASSUME	ES:SEG __stklen
	mov	ax, es:__stklen
	add	ax, 0fh
	shr	ax, 4
	add	bx, ax
	add	bx, 10h		; Add in the size off the PSP (in para)

ELSE ; IFDEF __COMPACT__ OR __LARGE__

IFNDEF __TINY__

	;  Determine the amount of memory used by the program
	;
	mov	ax, GOFFSET endBSS
	add	ax, 0fh
	shr	ax, 4
	mov	bx, ax
	mov	ax, [__stklen]
	add	ax, 0fh
	shr	ax, 4
	add	bx, ax
	mov	ax, OFFSET _TEXT:begDATA
	add	ax, 0fh
	shr	ax, 4
	add	bx, ax
	add	bx, 10h		; Add in the size off the PSP (in para)

ELSE ; IFNDEF __TINY__

IF STDOS_RESIZE

	;  Determine the amount of memory used by the program
	;
	mov	ax, GOFFSET endBSS
	add	ax, 0fh
	shr	ax, 4
	mov	bx, ax
	mov	ax, [__stklen]
	add	ax, 0fh
	shr	ax, 4
	add	bx, ax

ENDIF ; IF STDOS_RESIZE

ENDIF ; IFNDEF __TINY__

ENDIF ; IFDEF __COMPACT__ OR __LARGE__


IFDEF __TINY__

IF STDOS_RESIZE

	;  Save the resize value until after the stack has
	;  been relocated when making a COM file
	;
	;  NOTE: The reallocation above makes sure that there
	;        is enough space for the stack with the user
	;        overridable size (stklen).  When making a COM
	;        file, the stack will be inside memory already
	;        allocated to the program so it is OK to do
	;        it later.
	;
	mov	di, bx

ENDIF ; IF STDOS_RESIZE

ELSE ; IFDEF __TINY__

	;  Resize the memory allocated to the program to only what
	;  is needed
	;
	;  NOTE: The reallocation above makes sure that there
	;        is enough space for the stack with the user
	;        overridable size (stklen).  The could reside
	;        outside of memory already allocated
	;
	mov	ah, 4ah		; resize memory function
	mov	es, [__psp]	; es = mem segment to resize
	int	21h		; tell DOS to resize

	mov	dx, offset NotEnoughMemory
	jc	ErrorOut

ENDIF ; IFDEF __TINY__


IFDEF __COMPACT__ OR __LARGE__

	;  Determine the address of the real stack
	;
	mov	ax, SEG __stklen
	mov	es, ax
	mov	ax, es:__stklen
	mov	dx, seg _STACK

ELSE ; IFDEF __COMPACT__ OR __LARGE__

	;  Determine the address of the real stack
	;
IFNDEF __TINY__
	mov	ax, GOFFSET begSTACK
ELSE ; IFNDEF __TINY__

IF STDOS_RESIZE

	mov	ax, GOFFSET endBSS
	add	ax, 0fh
	and	ax, 0fff0h

ENDIF ; IF STDOS_RESIZE

ENDIF ; IFNDEF __TINY__

IF STDOS_RESIZE

	add	ax, [__stklen]
	mov	dx, si

ENDIF ; IF STDOS_RESIZE

ENDIF ; IFDEF __COMPACT__ OR __LARGE__


IF STDOS_RESIZE

	;  Switch to the real stack
	;
	;  NOTE: DX:AX set to the stack above.
	;
	mov	ss, dx
	mov	sp, ax

ENDIF ; IF STDOS_RESIZE


IFDEF __TINY__

IF STDOS_RESIZE

	;  Resize the memory allocated to the program to only what
	;  is needed
	;
	;  NOTE: When making a COM file, the stack will be inside
	;        memory already allocated to the program.
	;
	mov	bx, di
	mov	ah, 4ah		; resize memory function
	mov	es, word ptr [GOFFSET __psp]	; es = mem segment to resize
	int	21h		; tell DOS to resize

	mov	dx, offset NotEnoughMemory
	jc	ErrorOut

ENDIF ;IF STDOS_RESIZE

ENDIF ; IFDEF __TINY__


	;  Build command line arguments
	;
IF BUILD_ARGS
	jmp	ParseCommandLine
ENDIF


	;  Execute main()
	;
DoMain:
	mov	ax, ds
	mov	DGROUP@, ax
IFDEF __COMPACT__ OR __LARGE__
	push	ds
ENDIF
	mov	AX, GOFFSET argv
	push	AX
	push	word ptr [GOFFSET argc]
IFDEF __TINY__
	mov	bx, cs
ELSE
	mov	bx, seg _DATA
ENDIF
	mov	ds, bx
	call	_main


	;  Terminate the program after checking for a null
	;  pointer assignment
	;
	;  NOTE: AL contains the exit code returned to DOS
	;
terminate:
;	int 3
	Assume ES:_DATA

IFDEF __TINY__
	mov	dx, cs
ELSE ; IFDEF __TINY__
	mov	dx, DGROUP
ENDIF ; IFDEF __TINY__
	mov	es, dx
IFDEF __TINY__
        ASSUME  ES:DGROUP
ENDIF

IFDEF __TINY__
	cmp	word ptr es:[GOFFSET lpNullPtr], 0
ELSE
	cmp	word ptr es:[offset _DATA:lpNullPtr], 0
ENDIF
	mov	dx, offset NullPointerAssignment
	jnz	ErrorOut

_terminate:
	mov	ah, 4ch
	int	21h


	;  _exit
	;
	;  This is the built in exit function
	;
	;  void exit(uchar ucExitCode);
	;
	public	_exit
_exit:

	;  Put the exit code in AL and terminate
	;
	pop	ax
	pop	ax
IFDEF __MEDIUM__ OR __LARGE__
	pop	ax
ENDIF
	jmp	short terminate


	;  Display an error message and terminate
	;
ErrorOut:
	push	cs
	pop	ds
	mov	ax, 09ffh
	int	21h
	jmp	short _terminate

;-----------------------------------------
;	Command line parsing
;-----------------------------------------
IFDEF __COMPACT__ OR __LARGE__
	ASSUME DS:_BSS
ELSE ; IFDEF __COMPACT__ OR __LARGE__
	ASSUME DS:DGROUP
ENDIF ; IFDEF __COMPACT__ OR __LARGE__

IF BUILD_ARGS

ParseCommandLine:


	; push filename on stack. filename is found at the
	; end of the environment.
	;
;	int 3
	mov	ax, word ptr GOFFSET __envseg
	mov	es, ax
	xor	DI, DI
again:	cmp	word ptr ES:[DI],0	; find end of environment
	jz	end_of_strings
	inc	DI
	jmp	again
end_of_strings:
	add	DI, 4		; skip to filename

	;
	;  ES:DI now points to filename in the environment
	;


	;  Push filename (argv[0]) on stack
	;
	call	near ptr PushStringOnStack


	;  The filename is argv[0]
	;
;	int 3
	inc	word ptr [GOFFSET argc]
	mov	di, GOFFSET argv
IFDEF __COMPACT__ OR __LARGE__
	mov	[di + 2], ss
ENDIF
	mov	[di], bp	; argv[0]


	;  Copy the cmdline from the PSP to the near cmdline
	;  the cmdline from DOS is 80H bytes in size at PSP:80H
	;
	mov	es, word ptr [GOFFSET __psp]
	mov	di, 80h


	;  Convert the command line in the PSP into argv[] array
	;
	xor	cx, cx
	mov	cl, es:[di]		; CX   = length of cmdline
	inc	di			; [DI] = start of cmdline
	mov	bx, GOFFSET argv	; [BX] = argv[] array


	;  Point to the next argv
	;
IFDEF __COMPACT__ OR __LARGE__
	add	bx, 4
ELSE
	inc	bx
	inc	bx			; [BX] = argv[1]
ENDIF
	mov	word ptr [GOFFSET NextArgv], bx



	mov	dx, ds
;	int 3
again_cmdline:


	;  For each argument, skip all preceding white space
	;
	call	SkipWhite_ES_DI
	jcxz	done_cmdline


	;  Determine if this is the last command line argument
	;
	cmp	word ptr [GOFFSET argc], MAXARGV
	je	last_cmd_arg


	;  Put this argument on the stack
	;
	mov	word ptr GOFFSET ArgStart, di
	call	SkipText_ES_DI
	mov	word ptr GOFFSET CmdCount, cx
	mov	cx, ax
	mov	word ptr GOFFSET ArgEnd, di
	mov	di, word ptr GOFFSET ArgStart
	call	near ptr PushArgOnStack
	mov	cx, word ptr GOFFSET CmdCount
	mov	di, word ptr GOFFSET ArgEnd

	; record this argument in the argv[] array
	;
	mov	ds, dx
	inc	word ptr [GOFFSET argc] ; 1 more arg
	mov	bx, word ptr [GOFFSET NextArgv]
IFDEF __COMPACT__ OR __LARGE__
	mov	[bx + 2], ss
ENDIF
	mov	[bx], SP		; argv[n]


	;  Point to the next argv
	;
IFDEF __COMPACT__ OR __LARGE__
	add	bx, 4
ELSE
	inc	bx
	inc	bx			; [BX] = argv[1]
ENDIF
	mov	word ptr [GOFFSET NextArgv], bx


	;  Process the next argument
	;
	jmp	again_cmdline


last_cmd_arg:


	;  Push the remaining arguments on the stack as one argument
	;
	inc	cx
	call	near ptr PushArgOnStack


	; record this argument in the argv[] array
	;
	mov	ds, dx
	inc	word ptr [GOFFSET argc] ; 1 more arg
	mov	bx, word ptr [GOFFSET NextArgv]
IFDEF __COMPACT__ OR __LARGE__
	mov	[bx + 2], ss
ENDIF
	mov	[bx], SP		; argv[n]


done_cmdline:


	; null terminate the argv[] array
	;
	mov	ds, dx
	mov	bx, word ptr [GOFFSET NextArgv]
IFDEF __COMPACT__ OR __LARGE__
	mov	word ptr [bx + 2], 0
ENDIF
	mov	word ptr [bx], 0


	;
	;
	jmp	DoMain


ENDIF ; IF BUILD_ARGS


IF BUILD_ARGS
;----------------------------------
; On Entry
;   ES:DI = string
; On Exit
;   SS:BP = offset on stack of string
	public	PushStringOnStack
PushStringOnStack	proc	near


	; determine length of string
	;
	push	di
	mov	cx, 0ffffh
	mov	al, 0
	repnz	scasb
	not	cx
	pop	di


	;  Save the source offset
	;
PushArgOnStack:
	mov	si, di


	;  Allocate the space on the stack for the string
	;
	mov	ax, cx
	inc	cx
	and	cx, 0fffeh
	pop	bx	; remember return address
	sub	sp, cx
	mov	di, sp	; point SS:DI to memory for string on stack
	push	bx  	; Put the return address back on the stack
	mov	cx, ax


	; Save the stack offset of the string
	;
	push	di


	; Copy the string to the space allocated on the stack
	;
	dec	cx
CopyNextByte:
	mov	al, es:[si]
	mov	ss:[di], al
	inc	si
	inc	di
	loop	CopyNextByte
	xor	ax, ax
	mov	ss:[di], al


	;  Put the the address of the string on the stack in BP
	;
	pop	bp


	; return to caller
	;
	ret

PushStringOnStack	endp
ENDIF ; IF BUILD_ARGS


IF BUILD_ARGS
;----------------------------------
; On Entry
;   CX    = length left
;   ES:DI = string
; On Exit
;   AX    = length of argument
;   CX    = length left
;   ES:DI = string, stopping on first whitespace

	public	SkipText_ES_DI
SkipText_ES_DI	proc near

	push	bx
	xor	ax, ax
	xor	bx, bx

skiptxt_again:
	; are we done skipping text?
	jcxz	done_skiptxt
	cmp	byte ptr es:[DI], '"'
	jnz	not_a_quote
	not	bx

not_a_quote:
	or	bx, bx
	jnz	do_next_character

	cmp	byte ptr es:[DI], ' '
	jz	done_skiptxt
	cmp	byte ptr es:[DI], 9 	; TAB
	jz	done_skiptxt

do_next_character:
	; not done yet, on to next byte
	inc	di
	dec	cx
	inc	ax
	jmp	short skiptxt_again

done_skiptxt:
	pop	bx
	inc	ax

	ret

SkipText_ES_DI	endp
ENDIF ; IF BUILD_ARGS


IF BUILD_ARGS
;----------------------------------
; On Entry
;   CX    = length left
;   ES:DI = string
; On Exit
;   CX    = length left
;   ES:DI = string, skipping all spaces and tabs
;
	public	SkipWhite_ES_DI
SkipWhite_ES_DI	proc near

skip_again:
	jcxz	done_skip
	cmp	byte ptr es:[di], ' '
	jz	skip_char
	cmp	byte ptr es:[di], 9	; TAB
	jnz	done_skip

skip_char:
	inc	di	; on to next byte
	dec	cx	; 1 less byte in cmdline
	jmp	short skip_again

done_skip:
	ret

SkipWhite_ES_DI	endp
ENDIF ; IF BUILD_ARGS


;-----------------------------------------
;	Special startup code strings
;-----------------------------------------

	NotEnoughMemory		db "Insufficient memory$"
	NullPointerAssignment	db "Null pointer assignment$"


_TEXT		ENDS

        	END     StartUp
