;
;   $Id: strncat.asm 1.6 2002/10/15 23:04:54Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:STRNCAT.ASM
; Created 2-25-2001 by Brandon Thomas
;
; Copyright (c) 2001-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 02/25/2001 bt  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, C, use16

IF FARSEG
.code
ELSE
.code _TEXT
ENDIF

;--------------------------------------------------------------------
; $DOCPROC: strncat
;
; char * strncat( char * szDest, char * szSrc, unsigned uSize );
;
;--------------------------------------------------------------------
ProcBegin_f 	strncat, public
IF @DataSize
ProcUses  	es,ds,di,si
ELSE
ProcUses  	di,si
ENDIF
ProcArgs	@@szDest:PTR,@@szSrc:PTR,@@uSize:word
ProcSetup

	;  Find the end of the destination string
	;
	xor	ax, ax
	mov	cx, 0ffffh
	LPTR_ES	di, @@szDest
	push	di		; save destination offset
IF @DataSize
	push	es		; save destination segment
ENDIF
	cld
	repne	scasb
	dec	di


	;  Append the source string to the destination string
	;
	LPTR_DS	si, @@szSrc
	mov	cx, @@uSize
	jcxz	@@Done

    @@Next:
	lodsb
	stosb
	or	al, al
	jz	@@Done
	loop	@@Next

	xor	al, al
	stosb

    @@Done:

	; Set the return address to the destination (saved above)
	;
IF @DataSize
	pop	dx
ENDIF
	pop	ax

ProcEnd

@curseg	ends
	end
