;
;   $Id: MEM19.ASM 1.4 2002/10/15 23:47:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:MEM19.ASM
;
; Copyright (c) 1998-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; This module contains the functions necessary to wipe out the
; VDISK image.
;--------------------------------------------------------------------
include macros.inc

cBegData
	old19	dd	?

	; copy in ANY other data to wipe out VDisk signature
	; from F000:0 is fine.
	GDT	db 16 dup (0)
	srcDesc	db 0, 0FEh, 0, 0, 10h, 93h, 0, 0	; 1 Meg
	dstDec	db 0, 0FEh, 0, 0F0h, 0, 93h, 0, 0	; F000h
		db 20 dup (0)
cEndData


cBegCode

;--------------------------------------------------------------------
; Wipe out the VDisk signature on an Int 19h reboot.
; No need to preserve registers: this is an Int 19h.
Int19Handler:

	; wipe out signature
	mov	ah, 87h
	mov	ax, DGROUP
	mov	es, ax
	mov	si, offset DGROUP:GDT
	mov	cx, 10h
	int	15h

	; jump to old int 19h handler
	jmp	dword ptr es:[old19]

;--------------------------------------------------------------------
; $DOCPROC:OnInt19WipeVDisk
;
; Trpa Int 19h so that the VDisk signature is cleared upon reboot.
;--------------------------------------------------------------------
c_func	OnInt19WipeVDisk
	push	bp
	mov	bp, sp

	; point Int 19h to the wipe handler
	xor	ax, ax
	mov	es, ax
	mov	bx, 19h*4
	cli
	mov	ax, es:[bx]
	mov	dx, es:[bx+2]
	mov	word ptr old19, ax
	mov	word ptr old19+2, dx
	mov	word ptr es:[bx], offset _TEXT:Int19Handler
	mov	word ptr es:[bx+2], cs
	sti

	pop	bp
	ret
c_endp	OnInt19WipeVDisk

cEndCode
	END
