//
//   $Id: MEMCTYPE.C 1.5 2002/10/17 14:57:40Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:MEMCTYPE.C

	Copyright (c) 1998-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

	Ctype like functions.

	$DOCHISTORY
	07/23/1998 dg  Created by Drew Gislason
**********************************************************/
#define __FILENUM__	221
#include "compiler.h"
#include "memdisk.h"

/*
	$DOCPROC:MemToUpper
	Convert to upper case.
*/
char PASCAL MemToUpper(char c)
{
	if(c >= 'a' && c <= 'z')
		return c-'a'+'A';
	return c;
}


/*
	$DOCPROC:MemIsDigit
	Is this a digit?
*/
bool PASCAL MemIsDigit(char c)
{
	return (c >= '0' && c <= '9');
}

/*
	$DOCPROC:MemIsXDigit
	Is this a hexidecimal digit?
*/
bool PASCAL MemIsXDigit(char c)
{
	if(MemIsDigit(c))
		return TRUE;
	else
	{
		c = MemToUpper(c);
		if(c >= 'A' && c <= 'F')
			return TRUE;
	}
	return FALSE;
}

/*
	$DOCPROC:MemXDigitVal
	Return the hex digit value for a character. Ignores case.
*/
int PASCAL MemXDigitVal(char c)
{
	if(c>='0' && c<='9')
		return c-'0';
	else if(MemIsXDigit(c))
		return MemToUpper(c)-'A'+10;
	return 0;
}

/*
	$DOCPROC:MemSkipWhite
	Skip the whitespace in this far string.
*/
char far * PASCAL MemSkipWhite(char far *lpStr)
{
	while(*lpStr==' ' || *lpStr=='\t')
		++lpStr;
	return lpStr;
}

/*
	$DOCPROC:MemSkipArg
	Skip cmdline argument.
*/
char far * PASCAL MemSkipArg(char far *lpStr)
{
	while(*lpStr > ' ')
		++lpStr;
	return lpStr;
}

