;  $Id: MEMDISK.INC 1.5 2003/03/20 17:19:48Z thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1999-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   MEMDISK.INC  created 03/02/95  by Drew Gislason

   This is compatible with VDISK and DDTDISK.

   Copyright (c) 1995-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   History
   01/20/1999  bt  Merged ddtdisk.inc and memdisk.inc.  These
		   files are now identicle.
   01/20/1999  bt  Added an internal(internal to this memdisk)
		   type of structure which holds the BPB, serial
		   number, volume label, and a fat type string
		   in a specific order so that when a pointer
		   to the volume label is returned in a request
		   header, the volume label, serial number, BPB,
		   and fat type string will all be in the correct
		   places around the BPB and Volume label.
   01/20/1999  bt  Replace all the define byte(s) as whatever (?)
		   fields with zero's.  This allows for a reproducable
		   case when recompiling as well as being able
		   to know when a structure was never initialized
		   or that the saved stack variables had no saved
		   value type conditions to name but a few.
---------------------------------------------------------- ~

; The BIOS Parameter Block
; BIOS Parameter Block
;
bpbdef	STRUC
	BPB_sec_size 	DW	0 ; 00H (512	bytes per sector)
	BPB_sec_per_clus DB	0 ; 02H (2	sectors/cluster)
	BPB_res_sec	DW	0 ; 03H (1	reserved sectors)
	BPB_num_fats	DB	0 ; 05H (2	number of fats)
	BPB_dir_ent	DW	0 ; 06H (112	number of directory entries)
	BPB_num_sec	DW	0 ; 08H (720	total number of sectors)
	BPB_media	DB	0 ; 0AH (0FDH	media descriptor)
	BPB_fat_size	DW	0 ; 0BH (2	sectors per fat)
	BPB_sec_per_trak DW	0 ; 0DH (9	sectors/track)
	BPB_sides	DW	0 ; 0FH (2	number of heads)
	BPB_hidden	DD	0 ; 11H (0	reserved for disk partitioning)
	BPB_lnumsec	DD	0 ; 15H (0	set if "num_sec" == 0)
bpbdef	ENDS


; This is the structure for the internal copies of the needed
; boot sector data.
;

internal_bsdef STRUC
	bpb 	bpbdef	{}
	volume	db	12 dup (0)
	serial	dd	0
	fatstr	db	9 dup (0)
internal_bsdef ENDS

TRUE 		equ	1
FALSE 		equ	0

; has the disk changed? for mem_changed
;
CHANGED_YES	equ -1
CHANGED_MAYBE	equ  0
CHANGED_NO	equ  1

DEF_SEC_SIZE	equ 512		; /* default sector size */
FAT_ID		equ 0F0H	; /* default FAT id byte */

; /* categories for IOCTL calls */
BLOCK_IOCTL_READ  equ 0FF03H
BLOCK_IOCTL_WRITE equ 0FF0CH

; /*
;	Device Error Codes
;
;	If the device must return an error, the following
;	defines the possible error conditions:
; */
DEVERR_WRITEPROT	        equ 00H    ; /* write protected */
DEVERR_BADUNIT		        equ 01H    ; /* invalid unit # */
DEVERR_NOTREADY		        equ 02H    ; /* disk not ready (drive door open) */
DEVERR_BADCMD		        equ 03H
DEVERR_CRC		        equ 04H
DEVERR_BADSTRUCT	        equ 05H
DEVERR_SEEK		        equ 06H
DEVERR_BADMEDIA		        equ 07H
DEVERR_SECNOTFOUND	        equ 08H    ; /* sector not found */
DEVERR_NOPAPER		        equ 09H
DEVERR_WRITEFAULT	        equ 0AH
DEVERR_READFAULT		equ 0BH
DEVERR_GENERALFAIL 		equ 0CH
DEVERR_SHARINGVIOLATION	   	equ 0DH
DEVERR_LOCKVIOLATION	     	equ 0EH
DEVERR_INVALIDDISKCHANGE     	equ 0FH
DEVERR_FCBUNAVAILABLE        	equ 10H
DEVERR_SHARINGBUFFEROVERFLOW 	equ 11H
DEVERR_CODEPAGEMISMATCH      	equ 12H
DEVERR_OUTOFINPUT            	equ 13H
DEVERR_INSUFFICIENTDISKSPACE 	equ 14H

VOLUME_LABEL_SIZE	equ	11
FAT_TYPE_SIZE		equ	9
