;
;   $Id: MEMIO.ASM 1.4 2002/10/15 23:47:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:MEMIO.ASM
;
; Copyright (c) 1998-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; This module contains the basic In and Out instructions, usable by
; C functions.
;--------------------------------------------------------------------
include macros.inc

cBegData
cEndData

cBegCode

;--------------------------------------------------------------------
; $DOCPROC:OutpByte
;
; void OutpByte(unsigned port, int val)
;
; Output a byte to an I/O port (only low byte of val is used).
;--------------------------------------------------------------------
c_func	OutpByte
	push	bp
	mov	bp, sp
	mov	dx, P[bp]
	mov	al, P+2[bp]
	out	dx, al
	pop	bp
	ret
c_endp	OutpByte

;--------------------------------------------------------------------
; $DOCPROC:OutpWord
;
; void OutpWord(unsigned port, int val)
;
; Output a word to an I/O port.
;--------------------------------------------------------------------
c_func	OutpWord
	push	bp
	mov	bp, sp
	mov	dx, P[bp]
	mov	ax, P+2[bp]
	out	dx, ax
	pop	bp
	ret
c_endp	OutpWord

;--------------------------------------------------------------------
; $DOCPROC:InpByte
;
; uchar InpByte(unsigned port)
;
; Input a byte from an I/O port (hi byte of return int is always 0).
;--------------------------------------------------------------------
c_func	InpByte
	push	bp
	mov	bp, sp
	mov	dx, P[bp]
	in	al, dx
	mov	ah, 0
	pop	bp
	ret
c_endp	InpByte

;--------------------------------------------------------------------
; $DOCPROC:InpWord
;
; int InpWord(unsigned port)
;
; Input a word from an I/O port.
;--------------------------------------------------------------------
c_func	InpWord
	push	bp
	mov	bp, sp
	mov	dx, P[bp]
	in	ax, dx
	pop	bp
	ret
c_endp	InpWord

cEndCode

	END
