;
;   $Id: INT10.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT10.ASM
;
;  Copyright (c) 1994-2002 Datalight, Inc.
;  All Rights Reserved
;  Datalight Confidential and Proprietary
;


_TEXT Segment byte public 'CODE'

extrn _console_init:near, _console_putchar:near

	assume cs:_TEXT, ds:_DATA

BIOS_VIDEO	equ	10H
CARRY_FLAG	equ	1
ZERO_FLAG	equ	4H
INT10_BADCMD	equ	86H
INT10_ERROR	equ	87H

;
; Interrupt Service Routine
;
public _INT10_isr
_INT10_isr:
	cmp	ah, 0EH
	jnz	Done

	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	es
	push	ds

	mov	bx, Seg _DATA
	mov	ds, bx
	push	ax
	call	_console_putchar
	pop	ax

	pop	ds
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax

Done:	iret


; -------------------------------------------------
; Console Put C is an internal BIOS Put Char routine that requires AL = Char.
; It requires that _Int10_init has been called.
;
	public _Int10PutChar,_console_putc
_Int10PutChar:
_console_putc:
	mov	ah, 0EH
	int	BIOS_VIDEO
	ret


; -------------------------------------------------
; Console Put String (AX = OFFSET _TEXT:string)
;
; ** message string output-to-console subroutine **
; call "msg_puts" with string offset in AX
; for displaying MSG_LIST strings only (original proc)
;
; Caution!! calls in minibios.asm assume this preserves cx!
	public _console_puts
_console_puts:
	push	bx
	mov	bx, ax
Con1:	mov	al, Byte Ptr CS:[bx]
	cmp	al, 0
	jz	Con2
	push	bx
	call	_console_putc
	pop	bx
	inc	bx
	jmp	Con1
Con2:	pop	bx
	ret




; -------------------------------------------------
; Far Console Put String (far Ptr)
;
; ** message string output-to-console subroutine **
; call "msg_puts" with string address on the stack
;

	public _far_console_puts
_far_console_puts:
	push	bp
	mov	bp, sp
	push	si
	push	es
	push	ax
	mov	si, [bp+4]
	mov	ax, [bp+6]
	mov	es, ax
_far_con1:
	mov	al, es:[si]
	cmp	al, 0
	jz	_far_con2
	mov	ah, 0EH
	call	_console_putc
	inc	si
	jmp	_far_con1
_far_con2:
	pop	ax
	pop	es
	pop	si
	pop	bp
	ret




_TEXT Ends


_DATA Segment public byte 'DATA'
	dw 0
_DATA Ends

	End

