;
;   $Id: INT15.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT15.ASM
;
;  Copyright (c) 1994-2002 Datalight, Inc.
;  All Rights Reserved
;  Datalight Confidential and Proprietary
;
;  INT 15 - Various Service BIOS Interrupt
;

include minibios.inc


_TEXT Segment byte public 'CODE'
	assume CS:_TEXT

	assume CS:_TEXT, DS:Nothing

public _INT15_isr
_INT15_isr:

if APM_SUPPORTED
	extrn 	_APM_ISR_Handler:near

	cmp	ah, 53H
	jnz	_I15_1
	jmp	_APM_ISR_Handler
_I15_1:
endif


if Target_CPU GE 386
extrn Int15_87:near

	cmp	ah, 87H
	jnz	not_87
	jmp	Int15_87
not_87:	cmp	ah, 88H
	jz 	Int15_88
endif

	cmp	ah, 0C0H
	jz 	Int15_C0

	mov	ah, 86h
	push	bp
	mov	bp, sp
	or	word ptr [bp+6], 1	; Error return
	pop	bp
	iret


if Target_CPU GE 386

;Get Extended Memory Size
Int15_88:
        push    ds
        mov     ax,_DATA
        mov     ds,ax
        mov     ax,ds:ex_mem_size
        pop     ds
        iret

endif

; Get Int 15 System Model Table
Int15_C0:
        push    cs
        pop     es
        mov     bx,offset Int15_C0_Table
        xor     ah,ah                   ;clear CF and ah to indicate success
        sti
        retf    2                       ;pop flags and return

Int15_C0_Table:
	dw 8		; Length
	db SystemModel
	db SystemSubModel
	db 02		; BIOS revision level (00 = first release)
	db Features
	db 0		; Byte 7
	db 0		; Byte 8
	db 0		; Byte 9
	db 0		; Byte 10

_TEXT Ends

if Target_CPU GE 386

_DATA	segment byte public 'DATA'
public ex_mem_size
ex_mem_size     dw      0
_DATA	ends

endif

End
