;
;   $Id: INT15_EX.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT15.ASM
;
;  Copyright (c) 1994-2002 Datalight, Inc.
;  All Rights Reserved
;  Datalight Confidential and Proprietary
;
;  INT 15 - Various Service BIOS Interrupt
;

include minibios.inc

if Target_CPU GE 386

.386p
_TEXT   segment dword use16 public 'CODE'
assume cs:_TEXT, ds:nothing

IF HWD_INTS
comment &
        Below is a portion of an interrupt descriptor table.  It is very
        important to notice that this is only a partial table and contains
        interrupt gates for ints 8 - fh at this point to support PIC #1.
        Following the gate for 0fh is the bulk of the code in this file,
        followed by the gates for 70h - 77h after the code.  We must be very
        careful not to disturb the offset between the two portions of table.
        This means that the total code between the two portions of table must
        not exceed 768 bytes.  The "org" instruction at the beginning of the
        next portion of the table will control the offset between portions of
        the table so long as the size of code is less than 768 bytes.  We must
        not allow interrupts outside of 8 - 0fh and 70h -  77h to occur, we
        must also remember that the Interrupt descriptor table pointer must
        point to 64 bytes below the label idt_8.
&

idt_8   dw      offset int8
        dw      8
        dd      0ee00h
        dw      offset int9
        dw      8
        dd      0ee00h
        dw      offset inta
        dw      8
        dd      0ee00h
        dw      offset intb
        dw      8
        dd      0ee00h
        dw      offset intc
        dw      8
        dd      0ee00h
idt_d   dw      offset intd
        dw      8
        dd      0ee00h
        dw      offset inte
        dw      8
        dd      0ee00h
        dw      offset intf
        dw      8
        dd      0ee00h

else

; if not HWD, we only need int D handling
idt_d   dw      offset param_error
        dw      8
        dd      0ee00h

endif   ;HWD_INTS

comment &
        This code provides functions for switching from real to protected
        mode and back again.  It assumes the processor is in real mode.  If
        HWD_INTS is zero, interrupts MUST remain disabled while the processor
        is in protected mode.  If HWD_INTS is non zero, interrupts will be
        enabled in protected mode but only interrupts 8 - f and 70h - 77h are
        allowed.

        Once in protected mode, the code segment will be 8, it will be a read
        only segment, you can read from the _text segment but you cannot write
        with this selector.  SS will be left as a real mode value.  This is
        fine so long as we don't try to reload it.  Reloading a real mode
        selector value in protected mode will cause a GP fault.  If the gdt
        passed to the function is set up for a move extended memory block, the
        destination selector will be 18h, the source selector will be 10h.  If
        a pointer to a garbage filled buffer is passed, selectors 10h and 18h
        will probably be invalid, just the act of loading them can cause a GP
        fault.  Everything will be fine as long as 10h or 18h is not loaded in
        a segment register.

        Selector 20h will be a selector with a base address of 0 and a limit
        of 4 gbytes.  It is useful for writing directly to any physical
        address you want to access.  It can be loaded in any segment register
        except CS.

        Selector 28h will be a 16 bit data selector, it will be equivalent to
        the real mode SS.

        This function switches the processor from Real To Protected mode.  It
        is passed a pointer in es:si which points to a buffer space to be
        used as a GDT.  This buffer will be used as the PC BIOS uses it for
        int 15h function 87h, preserving selectors 10h and 18h while using
        selectors 8,20h and 28h.  It preserves all registers except segment
        registers which are loaded with zero and ax which returns the state of
        the a20 line, (0 for disabled, nonzero for enabled).  Paging is
        disabled, nothing is remapped so everything will be at its correct
        physical address.  A word of caution!, when doing a rep movs with 32
        bit values in esi and edi, you will need a db 67h ahead of the
        instruction.  You are operating in a 16 bit code segment and the
        processor assumes 16 bit registers unless it is told otherwise.  Use
        32 bit registers in a movs as follows:

        db      67h
        rep     movs            ;uses edi,esi and ecx

        Remember it uses ecx, not cx.  It will move an embarrassing amount of
        memory if the high word of ecx is not zero.

        This code assumes the processor is in REAL mode, not V86 mode, it
        makes no checks to see if the A20 line was successfully enabled.
&

public _rtop
_rtop:
        push    edx
        push    ecx
        push    eax
        pop     ax                      ;save high word of eax only
        call    a20_get_state           ;returns CF = 1 if a20 is enabled
        sbb     ax,ax                   ;make -1 if enabled, 0 if not enabled
        push    ax                      ;low word of return value for eax
        jc short a20_okay
;We need to enable the a20 line, this can be a slow process.  If the embedded
;system will tolerate it being enabled permanently, this can save some time.

        call    A20_enable

a20_okay:
        xor     eax,eax
        mov     ax,es
        movzx   ecx,si                  ;pointer to gdt in ax:cx
        shl     eax,4                   ;convert paragraphs to 32 bit offset
        add     eax,ecx                 ;32 bit address of gdt
        push    eax                     ;absolute address of gdt
        push word ptr 30h               ;limit for gdt
;now convert selector 8 to a code selector
        mov     cx,cs                   ;caution!, high word of ecx must be 0
        mov     eax,9bh                 ;DPL = 0, executable, readable
        shl     ecx,12
        shld    eax,ecx,8              ;move part of base address into eax
        shl     ecx,8
        mov     cx,-1                   ;set limit to real mode compatible
        mov     es:[si+8],ecx           ;low dword of selector 8
        mov     es:[si+12],eax          ;high dword of selector 8
;convert selector 20h to 4 Gbyte data selector
        mov dword ptr es:[si+20h],0ffffh        ;set big limit
        mov dword ptr es:[si+24h],0cf9300h      ;32 bit, page granular dpl = 0
;convert selector 28h to 16 bit Stack selector
        xor     ecx,ecx
        mov     cx,ss
        mov     eax,93h                 ;DPL = 0, read/write
        shl     ecx,12
        shld    eax,ecx,8              ;move part of base address into eax
        shl     ecx,8
        mov     cx,-1                   ;set limit to real mode compatible
        mov     es:[si+28h],ecx         ;low dword of selector 28h
        mov     es:[si+2ch],eax         ;high dword of selector 28h
;gdt is now ready to use.
        pushf
        pop     cx
        and     ch,0bfh                 ;clear the NT flag
        push    cx
        popf
        cli                             ;interrupts must be off below
        lgdt fword ptr ss:[esp]         ;load pointer to gdt
        add     sp,6                    ;pop garbage off stack
        xor     eax,eax
        mov     es,ax
        mov     ds,ax                   ;zero so they can be pushed and popped
        mov     ax,cs
        shl     eax,4                   ;convert to 32 bit address

        db      66h                     ;make it a 32 bit add
        add     ax,offset idt_d[-8*0dh]
        dw      0                       ;high word of immediate value

        push    eax                     ;base address
        push    959                     ;limit

        mov     eax,cr0
        or      al,1                    ;set prot enable bit
        mov     cr0,eax                 ;now in protected mode

        db      0eah            ;far jump
        dw      offset rtop_jmp
        dw      8               ;code selector
rtop_jmp:
;Now in protected mode with a protected mode CS.
        lidt fword ptr ss:[esp]
if HWD_INTS
        sti
endif   ;HWD_INTS
        add     sp,6            ;pop garbage off stack
        pop     eax
        pop     ecx
        pop     edx
        ret

comment &
        Function to switch to real mode.  Passed the desired state of a20 in
        di (0 for disabled, nonzero for enabled, preserves all registers
        except es and ds which are trashed.  IMPORTANT!!!  assumes fs and gs
        were not used in protected mode, if they are used, they must be set to
        28h prior to switching to real mode, see code for ds and es below.
&

public _ptor
_ptor:
        push    edx
        push    ecx
        push    eax
        mov     ax,28h          ;real mode compatible selector
        mov     ds,ax
        mov     es,ax           ;set up ds and es with real mode limits
        mov     eax,cr0
        and     al,0feh         ;clear the PE bit
        cli
        mov     cr0,eax         ;switch to real mode
        db      0eah                            ;far jump
        dw      offset ptor_jmp                 ;offset for ip
        dw      _TEXT                           ;real mode segment

ptor_jmp:
;ds and es are garbage, they have non functioning protected mode selectors
        xor     ax,ax
        push    ax
        push    ax              ;base address of zero for real IDT
        push    3ffh            ;real limit of 256 vectors
        lidt fword ptr ss:[esp] ;real mode interrupts can now be executed
        add     sp,6
        or      di,di
        jnz short a20_okay1             ;jmp if a20 was enabled in real mode
;disable the a20 line to restore it to its original condition.

        call A20_disable

a20_okay1:
        pop     eax
        pop     ecx
        pop     edx
        ret

public A20_enable,A20_disable

if  PS_2_Port92         ; Three Functions: A20_enable, A20_disable, A20_get_state
                        ;  Choose either the PS_2_Port92 style interface or
                        ; the AT_Style interface for these function calls
A20_enable   proc    near
        ;We need to enable the a20 line, this is fast with the Port 92.
        in      AL, 92H
enable_ps2_a20:
        or      AL, 02H                 ; set bit 1, A20 on
set_ps2_a20:
        out     92H, AL                 ; set the A20 line (on or off)
        ret
A20_enable   endp

A20_disable   proc    near
        ;We need to disable the a20 line, this is fast with the Port 92.
        in      AL, 92H
disable_ps2_a20:
        and     AL, 0FDH                ; clear bit 1, A20 off
clr_ps2_a20:
        out     92H, AL                 ; set the A20 line (on or off)

        ret
A20_disable   endp

A20_get_state   proc    near  ; return Carry Flag Set if A20 Enabled
        ; this function used if PS/2 style A20 line enable/disable
        push    ds
        push    es
        push    ax

        in      AL, 92H   ;read port 92h bit 1 to determine state of A20 line
        test    al,02h          ;
        jnz     PS_2_a20_on
        clc                     ; return a20 is disabled, Clear Carry Flag
        jmp     PS_2_a20_off
PS_2_a20_on:
        stc                     ; return a20 is enabled, Set Carry Flag
PS_2_a20_off:
        pop     ax
        pop     es
        pop     ds
        ret

A20_get_state   endp

else    ; Use AT style 8402 Keyboard communication, Don't use the PS2_Port92 Style interface

sync_keyboard   proc    near

                                ; AT style 8402 Keyboard communication
        mov     cx,-1           ;give plenty of time for sync to occur
sync_loop:
        in      al,64h
        test    al,2
        loopnz  sync_loop
        ret

sync_keyboard   endp

A20_enable   proc    near
        ; AT style 8402 Keyboard communication
        mov     dx,60h
        mov     eax,0ffdfd100h          ;data to enable A20 line
a20_loop:
        call    sync_keyboard
        shr     eax,8           ;shift in next data to send
        xor     dl,4            ;toggle between 64h and 60h
        out     dx,al
        or      ah,ah           ;test for zero in ah, done if zero
        jnz short a20_loop
        call    sync_keyboard
        ret
A20_enable   endp

A20_disable   proc    near
        ; AT style 8402 Keyboard communication
        mov     dx,60h
        mov     eax,0ffddd100h          ;data to disable A20 line
a20_loop1:
        call    sync_keyboard
        shr     eax,8           ;shift in next data to send
        xor     dl,4            ;toggle between 64h and 60h
        out     dx,al
        or      ah,ah           ;test for zero in ah, done if zero
        jnz short a20_loop1
        call    sync_keyboard
        ret
A20_disable   endp

A20_get_state   proc    near
;  Return value is passed in the carry flag, carry set on a20 enable,
;  cleared on a20 disabled.
        push    ds
        push    es
        push    ax
        xor     ax,ax
        mov     ds,ax
        dec     ax                      ;ffffh now in ax
        mov     es,ax
        mov     ah,ds:[0]               ;address at 0000:0000
        dec     ah
        mov     al,ah
        xchg    es:[10h],al             ;address at 10000:0000
        sub     ah,ds:[0]      ;ah will be zero if disabled, 255 if enabled
        xchg    es:[10h],al    ;restore es[10h]
        sahf
        pop     ax
        pop     es
        pop     ds
        ret
A20_get_state   endp

endif                   ; "if  PS_2_Port92 "

param_error:    ;if error in GDT access rights or limits
if HWD_INTS
        add     sp,18           ;dump exception struc and int number
else
        add     sp,16           ;dump exception struc
endif
        pop     di              ;a20 state
        call    _ptor           ;switch to real mode
        pop     ax              ;restore al
        mov     ah,2            ;indicate parameter error
        pop     ecx
        pop     es
        pop     ds
        or byte ptr ss:[esp+16],1       ;set the carry flag in the iret struc
        pop     esp
        pop     esi
        pop     edi
        iret                            ;return to original caller.

;
; Interrupt 15 Code for 386 and above.  This code will not work on a
; 286 machine or below!

;Extended Memory Move
        public Int15_87
Int15_87:
        push    edi
        push    esi
        push    esp
        push    ds
        push    es
        push    ecx
        push    ax
        movzx   esp,sp
        call    _rtop           ;switch to protected mode
        push    ax              ;save state of a20 line
        mov     ax,18h
        mov     es,ax           ;destination
        mov     al,10h          ;caution, ah must = 0!
        mov     ds,ax           ;source
        movzx   ecx,cx          ;number of words to move in ecx
        xor     edi,edi         ;es:edi is destination
        xor     esi,esi         ;ds:esi is source
;CF must = 0 at this point
        rcr     cx,1            ;convert number of words to number of dwords
        db      67h     ;use 32 bit addresses (this also uses ecx for counter)
        rep     movsd           ;move the dwords
        rcl     cx,1            ;get the number of words to move
        db      67h     ;use 32 bit addresses (this also uses ecx for counter)
        rep     movsw           ;move the word if there is one
        pop     di              ;a20 state
        call    _ptor           ;switch to real mode
        pop     ax              ;restore al
        xor     ah,ah           ;indicate success
        pop     ecx
        pop     es
        pop     ds
        and byte ptr ss:[esp+16],0feh   ;clear the carry flag in the iret struc
        pop     esp
        pop     esi
        pop     edi
        iret                            ;return to original caller.

if HWD_INTS
int8:   push    8h
        jmp short common_handler
int9:   push    9h
        jmp short common_handler
inta:   push    0ah
        jmp short common_handler
intb:   push    0bh
        jmp short common_handler
intc:   push    0ch
        jmp short common_handler
intd:   push    0dh
        jmp short common_handler
inte:   push    0eh
        jmp short common_handler
intf:   push    0fh
        jmp short common_handler
int70:  push    70h
        jmp short common_handler
int71:  push    71h
        jmp short common_handler
int72:  push    72h
        jmp short common_handler
int73:  push    73h
        jmp short common_handler
int74:  push    74h
        jmp short common_handler
int75:  push    75h
        jmp short common_handler
int76:  push    76h
        jmp short common_handler
int77:  push    77h

comment &
        Execution arrives here with int number on stack, we must check to see
        if it is an interrupt or exception.  If ss:[esp+10] = CS it is an
        exception, if not, it is an interrupt.  If exception, we must report
        the error, if interrupt, switch to real mode, execute the interrupt in
        real mode and then return to protected mode.

        Since _ptor and _rtop are rather specialized functions which
        initialize the IDT and other such things, we won't use those
        functions, we will use abbreviated, in-line equivalents.  The code
        below assumes fs and gs are not being used, if they are being used,
        they must be saved and set to 28h just as es and ds are.  Notice that
        interrupts MUST be disabled at this point!!!!!  Portions of the code
        below must not be interrupted.  The real mode interrupt handler may
        re-enable interrupts if it chooses.
&
common_handler:
;We assume the SS value is still a real mode SS
        cmp byte ptr ss:[esp+10],8      ;check if CS
        je      param_error             ;jmp if exception
        push    es
        push    ds
        push    eax
        sub     sp,12           ;make  room for gdt ptr and idt ptr
        sidt fword ptr ss:[esp+6]
        sgdt fword ptr ss:[esp]
        mov     ax,28h                  ;real mode compatible selector
        mov     ds,ax
        mov     es,ax
        mov     eax,cr0
        and     al,0feh         ;clear the PE bit
        mov     cr0,eax         ;switch to real mode
        db      0eah                            ;far jump
        dw      offset int_r_jmp                ;offset for ip
        dw      _TEXT                           ;real mode segment

int_r_jmp:
;ds and es are garbage, they have non functioning protected mode selectors
;we will NOT worry about the a20 line for this handler, if we come across
;a system which depends on the a20 being disabled within hardware interrupt
;handlers, then we will have to check and disable it at this point.
        xor     ax,ax
        push    ax
        push    ax              ;base address of zero for real IDT
        mov     ax,3ffh
        push    ax              ;real limit of 256 vectors
        lidt fword ptr ss:[esp] ;real mode interrupts can now be executed
        add     sp,4
        pop     ds              ;load zero in ds
        movzx   eax,word ptr ss:[esp+20]        ;interrupt number
        pushf
        call    dword ptr ds:[eax*4]    ;call real mode interrupt handler
;real mode handler has been called, return to protected mode code
;We will NOT worry about the a20 line but assume the hardware interrupt
;handler has restored anything it has altered.
        lgdt fword ptr ss:[esp]
        mov     eax,cr0
        or      al,1                    ;set prot enable bit
        mov     cr0,eax                 ;now in protected mode

        db      0eah            ;far jump
        dw      offset int_p_jmp
        dw      8               ;code selector
int_p_jmp:
;Now in protected mode with a protected mode CS.
        add     sp,6            ;pop gdt pointer off stack
        lidt fword ptr ss:[esp] ;restore protected mode idt pointer
        add     sp,6            ;pop idt pointer off stack
        pop     eax
        pop     ds
        pop     es
        add     sp,2            ;pop interrupt number
        iretd

comment &
        Below is the balance of the IDT containing interrupt gates 70h - 77h.
        This is in place to support PIC #2.  THIS ABSOLUTELY HAS TO BE LOCATED
        AT idt_8[832].  The instruction below should insure that.
&
org idt_8[8 * (70h - 8h)]
        dw      offset int70
        dw      8
        dd      0ee00h
        dw      offset int71
        dw      8
        dd      0ee00h
        dw      offset int72
        dw      8
        dd      0ee00h
        dw      offset int73
        dw      8
        dd      0ee00h
        dw      offset int74
        dw      8
        dd      0ee00h
        dw      offset int75
        dw      8
        dd      0ee00h
        dw      offset int76
        dw      8
        dd      0ee00h
        dw      offset int77
        dw      8
        dd      0ee00h

endif   ;HWD_INTS

.286p

_TEXT Ends

endif           ; "if Target_CPU GE 386"


End

