;
;   $Id: INT1A.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT1A.ASM
;
;  Copyright (c) 1994-2002 Datalight, Inc.
;  All Rights Reserved
;  Datalight Confidential and Proprietary
;
;  INT 1A - Clock Services BIOS Interrupt
;	Functions Supported
;		0 - Get Tick Count
;		1 - Set Tick Count


_TEXT Segment byte public 'CODE'

	assume cs:_TEXT, ds:_DATA

;
; Interrupt Service Routine
;
public _INT1A_isr
_INT1A_isr:
; *** TIME OF DAY COUNTER / INT 1Ah.SUB 0 & 1 ***
; -----------------------------------------------
        assume  ds:_DATA
;isr_entry:
        ; ISR'S WILL NEED TO PUSH CX, DX, or INDEX REG'S IF USED
        ; IF the num of regs pushed changes, then in isr for INT16.x must
        ; also change offset added to access flags on stack
        push    bx
        push    bp
        push    ds
        push    es

        ; *** ENTER ISR'S WITH DS POINTING TO BIOS-DATA AREA ***
        ; (use bx since ax used to pass params)
        mov     bx, Seg _DATA            ; point ds to bios data
        mov     ds,bx
        cld

; ------------- END OF ORIG ENTRY CODE -------------------

	cmp	ah, 00
	jne	func1
	call	get_TICK
        jmp     end1A_functs
func1:	cmp	ah, 01
	jne	func2
	call	set_TICK
        jmp     end1A_functs
func2:  cmp     ah, 01
        ja      RTC_functs
;        EXECUTE INDX_TIME_ISR, MULTIindx
RTC_functs:     ; place calls to system Real Time Clock chip
		; here, if there is one
end1A_functs:
        pop     es
        pop     ds
        pop     bp
        pop     bx
        iret

; -------------------------------------------
; *** TIME and DATE FUNCTIONS / INT 1Ah ***
; -------------------------------------------

; *** Get Tick Count / INT 1Ah, 00h ***
; -------------------------------------------
        public  get_TICK
get_TICK:
        mov     dx,TICK_low
        mov     cx,TICK_hi
        mov     al,TICK_ovflow
        mov     Word Ptr TICK_ovflow, 0   ; clr 24hr wrap flag
	ret

; *** Set Tick Count / INT 1Ah, 01h ***
; -------------------------------------------
        public  set_TICK
set_TICK:
        mov     TICK_low,dx
        mov     TICK_hi,cx
	ret

	IRET



_TEXT Ends

_DATA Segment word  public 'DATA'
	extrn TICK_low:word, TICK_hi:word, TICK_ovflow:byte
_DATA Ends

	End
