;
;   $Id: MINIBIOS.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ^
*===========================================================================*

        MINIBIOS.ASM  revision 3.1

        Copyright (c) 1994-2002 by Datalight, Inc.
        All rights reserved.
	Datalight Proprietary and Confidential.

        This file is the common assembly file for Datalight's miniBIOS.
        The user should not need to modify this file when targeting the
        miniBIOS to a new system unless there is a need to add a new BIOS
        function or modify an existing one.  Please read BIOSREAD.ME for
        instruction on adding a new BIOS Function.


*===========================================================================*

Purpose :       minimal BIOS functions and system housekeeping
                designed to support ROM-DOS(tm).  The BIOS functions
                implemented here follow standard protocol for invo-
                cation using software interrupts.

BIOS FUNCTIONS SUPPORTED:
        FUNCTION        SUBFUNCTION     TASK
        --------        -----------     -----------
        07H                             186 or greater co-processor esc instruction
        10H             0Eh             TTY Char Output
        11H                             Get Equipment
        12H                             Get Memory Size
        14H                             Serial I/O
        15H             87              Extended memory read, 286 and above
        15H             88              Extended memory size, 286 and above
        15H             C0              PS/2 or AT style A20 Gate table
        16H             0               Read TTY char
        16H             1               Get TTY Status
        16H             2               GET TTY Flags
        19H                             Reboot System
        1AH             0               Get Tick Count
        1AH             1               Set Tick Count
        1CH                             Timer Tick


============================================================================ ^

BIOSVERSION     equ     " (Revision 3.1)"

; > Standard Include files <
; --------------------------
include macros.inc      ;macro definitions for segment ordering

include dosver.inc      ; ** specify user-version for BIOS boot banner **

include miniBIOS.inc    ; user modifiable system defines

;****************************************************************************
;                        DEFINE SEGMENT ORDERING
;****************************************************************************
; (see include file "mmacros.inc")
; DO NOT move these segment ordering directives!

_TEXT   segment byte public 'CODE'
        DW      DGROUP
_TEXT   ENDS

RELOC_DATA      segment para public 'RDATA'
        db      "Alicia Johnston",0
RELOC_DATA ends

; ** locate this at segment 0x40 in your loc file for standard bios **
_DATA   segment byte public 'DATA'
if TARGET_CPU GE 386
extrn ex_mem_size:word
endif
_DATA   ends

;the following two class definitions are for microsoft compatibility
;so that the C_thru_Rom loc file will be the same for both MASM and TASM
_CONST SEGMENT WORD PUBLIC 'CONST'
_CONST ENDS

MSG SEGMENT WORD PUBLIC 'MSG'
MSG ENDS

_BSS    segment byte public 'BSS'
_BSS    ends

_STACK           segment STACK para 'STACK'
_STACK ends

DGROUP GROUP    _DATA, _CONST, MSG, _BSS, _STACK

PUBLIC  __acrtused              ; trick used to force link of C startup code
        __acrtused = 9876h      ; this declaration MUST remain in order to
                                ; defeat include of un-needed C startup code

; --------------------------------------------------------------------
; >>>           internal equates                                   <<<
; --------------------------------------------------------------------
; THESE EQUATES MOST LIKELY DO NOT NEED TO BE MODIFIED BY THE USER


;---------------------------------------------
; DATE Specification
;       Must be in format of "MM/DD/YY"
;       If using TASM version 2.00 or later, it will put in the
;       build date automatically, if not, the date will be as
;       specified in the second equate for BIOS_DATE.

ifdef ??VERSION                 ;if ??VERSION is defined
    if ??VERSION GE 200         ;If TASM version 2.0 or greater
; Date string below does NOT work for MASM 5.1 and below
BIOS_DATE       equ     ' ',??DATE,' '
    endif
endif

ifndef  BIOS_DATE
        BIOS_DATE       equ     " 04/11/96 "
endif

;       special purpose flags & values
BIOS_EXT_ID     equ     0AA55h  ; BIOS extention ID-flag value

;       scalars
inc_sec         equ     18
inc_min         equ     1092
msw_24hr        equ     0018h
lsw_24hr        equ     00B0h


;---------------------------------------------
; BIOS CONFIGURATION SWITCHES

;------------- RAM TEST OPTIONS --------------
RAM_TBS         equ     32*1024 ;RAM Test Block Size in bytes
;Parameter above must be larger than the size of the vector table, BIOS data
;area and BIOS stack which is about 1600 bytes.  It must be smaller than 64K
;and it also must be 2^n Kbytes which means it can be: 2, 4, 8, 16 or 32
;Kbytes. Larger block sizes result in a faster RAM test.  If any part of the
;block fails the RAM test, the miniBIOS will stop the test and the block will
;not be used.  This means the block size must evenly divide into the total
;conventional memory for all of memory to be used.

; ------------------------------------------------
; DEBUGGING SWITCHES FOR BIOS TESTING ONLY

DEBUG           equ     0      ; set both switches to 0 for normal compile-

TARGETRUN       equ     0      ; -set both to 1 for remote deb'ing with kernel
                               ; -set 'debug'=0 & 'targetrun'=1 for "loadgo"

REMOTE_WAIT     equ     1     ; 1= wait for a 'g' (char) from the target's
                              ; remote-console before issuing any messages.
                              ; Used for testing with "loadgo" when the
                              ; serial port used to download the code is the
                              ; same used for the remote-console.

LOAD_ADDR       equ    0200h   ; set to BIOS's 1st segment specified in your-
                               ; loc file when remote debugging (on 8K bounds)

USER_TEST       equ     0       ; set to enable special user defined test functions
                                ; defined in biosinit.inc

; ------------- >>>>>>> END OF USER SELECTED OPTIONS <<<<<<< ---------------


; ----------------------------- BIOS DATA AREA --------------------------------
;              declaration & structure of standard bios-data area
; -----------------------------------------------------------------------------
;
; DO NOT alter the "structure" of these data elements-
; This is an image of standard bios-data-locations
; when BIOS_DATA is located at segment 0x40 in the loc-file.

cBegData

bios_area       label   word
base_addr       label   word

comment &
        The com port base addresses below will be set to zero if there does
        not seem to be a UART present.  If a com port is being used as a
        console, the corresponding address must be set to zero in the list
        below so the BIOS will not attempt to use it as a normal com port.
&
public _com_bases
_com_bases label word   ; RS-232C port base addresses
if Console_Port EQ      1
        dw      0       ; 40:00
else
        dw      3f8h    ; 40:00
endif
if Console_Port EQ      2
        dw      0       ; 40:02
else
        dw      2f8h    ; 40:02
endif
if Console_Port EQ      3
        dw      0       ; 40:04
else
        dw      3e8h    ; 40:04
endif
if Console_Port EQ      4
        dw      0       ; 40:06
else
        dw      2e8h    ; 40:06
endif

public _PRN_BASES, PRN1_BASE, PRN2_BASE, PRN3_BASE, PRN4_BASE
_PRN_BASES      label   word    ; printer port base addresses
PRN1_BASE       dw      ?       ; 40:08
PRN2_BASE       dw      ?       ; 40:0A
PRN3_BASE       dw      ?       ; 40:0C
PRN4_BASE       dw      ?       ; 40:0E

public _EQUIPMENT, equip_list,mem_size,kb_stat,kb_stat1
_EQUIPMENT      label   dword
equip_list      dw      OriginalEquipmentList   ; 40:10  equipment list offset addr
                db      ?       ; 40:12  unused
mem_size        dw      ?       ; 40:13  memory in K bytes
un_int_num      dw      ?       ; 40:15  unsupported bios interrupt number
kb_stat         db      ?       ; 40:17  keybd status bits
kb_stat1        db      ?       ; 40:18  keybd extended status bits
                db      ?       ; 40:19

        public _Int16BufHead,_Int16BufTail, _Int16Buffer
_Int16BufHead   dw      offset _Int16Buffer     ;head pointer for kbd buffer
_Int16BufTail   dw      offset _Int16Buffer     ;tail pointer for kbd buffer
_Int16Buffer    dw      16 dup (?)              ; Int 16 Keyboard Buffer

        org     (base_addr + 6Ch)
public  _bios_ticks, TICK_low, TICK_hi, TICK_ovflow, reset_flag
_bios_ticks     label   dword    ; 40:6C
TICK_low         dw      ?       ; lsw for real-time clock
TICK_hi          dw      ?       ; msw
TICK_ovflow      db      ?       ; status timer-wrap since last read
brk_key_state    db      ?       ; unused
reset_flag       dw      ?       ; value set to 1234h at cold boot time only

        org     (base_addr + 7Ch)
public com_time_out
com_time_out    db      1       ;com1 timeout in seconds
                db      1       ;com2 timeout in seconds
                db      1       ;com3 timeout in seconds
                db      1       ;com4 timeout in seconds

        org     (base_addr + 101h)
public _reset_addr, xtd_bios_ofs, xtd_bios_seg, int_flag
_reset_addr     label   dword
xtd_bios_ofs    dw      ?       ; holds temp bios-extention vector
xtd_bios_seg    dw      ?
int_flag        db      ?       ; indicates an interrupt has occurred
                                ; (currently not supported)

cEndData

;----------------------- UNINTIALIZED DATA AREA -------------------------
CBegUdata
public  _data_end
_data_end       label word
strbuf  db      12 dup(?)       ;space for creating strings
public bios_timer
bios_timer      dw      0       ;general purpose timer, incremented by int 8

CEndUdata

; -------------------------- END BIOS DATA AREA --------------------------

;*************************************************************************
; STACK SEGMENT
;*************************************************************************
; remember, the BIOS stack is part of DGROUP
;
_STACK segment
        public _bss_end, _stack_end
_bss_end        label word
        db      100h dup (?)    ; default stack size is 100h bytes
_stack_end      label word
_STACK ends

;*************************************************************************
;                                 BIOS CODE
;*************************************************************************

;CBegCode
; >> ------ DECLARE EXTERNAL PROCESSES AND VARIABLES HERE <<

; *** EXAMPLES OF 'C' EXTERNAL VARIABLE DECLARATION ***
;c_extrn  your_C_variable,word

; *** EXAMPLE OF 'C' EXTERNAL PROCESS DECLARATION ***
;c_extrn  a_cfunc,proc

; *** declare external C procedures and functions***

; >> DO NOT change the following declarations <<
;
c_extrn  console_putc,proc
c_extrn  console_puts,proc  far_console_puts,proc
;
; *** End of externals ***

; ----------------------------------------------------
; >>>      Begin BIOS System Initializations      <<<
; ----------------------------------------------------

include BIOSINIT.INC    ;Bring in hardware specific code.

ENTRY:   ;Reference point for BiosInit.Inc
; ---------------------------------------------------------
; >>>             SET UP BIOS STACK                     <<<
; ---------------------------------------------------------
; Initialize BIOS stack, stack RAM has not been tested yet.
        mov     ax,DGROUP
        mov     ss,ax
        mov     ds,ax
        mov     sp,GOFFSET _stack_end

        assume  ds:DGROUP

Post_Print I

        cld

; --------------------------------------------
; >>>         Power On Ram Test            <<<
; --------------------------------------------
; Test RAM used by vector table, bios-data and stack.  We do this
; test only if SupportPostCodes = 1.  If the STACK RAM is dead, we
; can't get a message out without PostCodes anyway, so testing is
; irrelevant without PostCodes.

IF (SupportPostCodes) AND (RAM_TEST NE 0)
        xor     ax,ax                   ;specify block to test at 0
        mov     bp,offset brt1          ;return address (we have no stack yet)
        jmp     mem_test1
brt1:
        jnc short brt2                  ;jmp if RAM is okay
        mov     si,offset mem_fail_msg
        jmp     term_dump_msg           ;terminate and dump error message
brt2:
ENDIF   ; (SupportPostCodes) AND (RAM_TEST NE 0)

Post_Print J

; --------------------------------------------
; >>>     SETUP LOCAL ENVIRONMENT FOR C    <<<
; --------------------------------------------
; initialize data
        ; relocate compiler-initialized data
        cld
        push    ss              ; dgroup
        pop     es
        xor     di,di           ; relocate to DGROUP:0
        mov     ax,seg reloc_data
        inc     ax              ; skip reloc_data
        mov     ds, ax          ; ds now points to DATA in ROM
        xor     si,si           ; relocate from ds:[si]
        mov     cx,offset DGROUP: _data_end    ; length
        rep     movsb           ; move it to RAM
        assume  es:DGROUP
        ; zero un-initialized data areas (_BSS and c_common)
        mov     di,offset DGROUP: _data_end   ; beginning of bss area
        mov     cx,offset DGROUP: _bss_end    ; end of bss area
        sub     cx,di
        xor     al,al
        rep     stosb                   ; zero bss (mov es:[di],al)

        ; set up the C environment
        mov     ax,ss           ; dgroup
        mov     ds,ax
        mov     es,ax

; --------------------------------------------
; >>>         Vector Table Setup           <<<
; --------------------------------------------
; setup the vector table for hardware and software interrupts
; first fill the entire vector table with a vector pointing to
; the non-supported bios call handling routine

Post_Print K

load_vects:
        push    ds              ; save bios-data seg
        push    es

        ; set DS = 0
        xor     ax,ax
        mov     ds,ax

IF DEBUG EQ 0 ; don't stomp vectors if using Turbo Debug/RDEB

IF ReportNonSupportedCalls

        ; point all int vectors to our handlers
        push    cs
        pop     es
        mov     cx,0100h        ;256 vectors
        mov     dx,OFFSET CS:isr_00
        xor     bx,bx

load_vects1:
        mov     [bx],dx         ; load vector offset
        mov     [bx+2],cs       ; and segment
        add     dx,3            ; add the size of a near CALL instruction
                                ; each ISR is a call to "unsupported int"
        add     bx,4            ; add size of an interrupt vector
        loop    load_vects1
ELSE

        ; point all int vectors IRET
        push    cs
        pop     es
        mov     cx,0100h
        mov     dx,OFFSET CS:dummy_isr
        xor     bx,bx

load_vects1:
        mov     [bx],dx         ; load vector offset
        mov     [bx+2],cs       ; and segment
        add     bx,4            ; add size of an interrupt vector
        loop    load_vects1
ENDIF ; from "IF REPORT_NSCALLS"

ENDIF ; from "IF DEBUG EQ 0"

        ; we have just pointed all interrupts to an IRET
        ; or dummy handler...

Post_Print L

comment &
             ----------------------------------------------------
             >>>           Initialize the supported BIOS Interrupts  <<<
             ----------------------------------------------------

        The bios_vec table and bios_init_funcs table are found in the file
        biosinit.inc.  The interrupt vectors specified in the bios_vec table
        will be initialized first, then the functions specified in the
        bios_init_funcs table will be called.
&
        push    cs
        pop     ds
        mov     si,offset bios_vec_table        ;ds:si points to bios_vec table
        xor     ax,ax
        mov     es,ax                           ;es points to vector table
bios_vec_loop:
        cmp     si,offset bios_vec_table_end[-2]
        jae short bios_vec_done                 ;jmp if at end of table
        lodsb                                   ;load interrupt number
        shl     ax,1
        shl     ax,1                            ;make index into vector table
        mov     di,ax
        xor     ax,ax                           ;zero high word of ax again
        movsw                                   ;initialize offset in vec table
        jmp     bios_vec_loop

bios_vec_done:  ;Now call the functions in the bios_init_funcs table.

Post_Print M

if SupportPostCodes
;allow time for last Post_Print before console_Init below
        mov     cx,1000
l1:     loop    l1
endif

        mov     si,offset bios_init_funcs
bios_init_funcs_loop:
        cmp     si,offset bios_init_funcs_end
        jae short bios_init_funcs_done
        lodsw
        push    si              ;initialization functions can trash all regs
        call    ax
        pop     si
        jmp     bios_init_funcs_loop

bios_init_funcs_done:
        pop     es
        pop     ds                              ; restore bios-data seg
        assume  ds:DGROUP

IF      TARGETRUN and REMOTE_WAIT
        ;Test options to wait here until a key is pressed

        public targwait
targwait:
        sti                     ; allow serial Rx int (_commint)
cwt:    c_callm console_getc       ; wait for char from host (for remote
        cmp     al,'g'          ; debugging at target)
        jnz     cwt
        cli                     ; not ready for free running ints yet
ELSE
        ; free running init sequence
        mov     cx,0fffh
comdly: loop    comdly          ; wait for serial device to settle
ENDIF

;---------------------------------------------------------
; >>>   Send copyright & ram status messages to host   <<<
;---------------------------------------------------------
        mov     ax,offset _TEXT:copyrt
        call    _console_puts
        mov     ax,offset _TEXT:target_name_msg
        call    _console_puts

if TARGET_CPU GE 386
.386
;zero high word of certain registers before calling print_accumulator
        movzx   esp,sp
        xor     eax,eax
.8086
endif

; --------------------------------------------------------
; >>>                   RAM TEST                       <<<
; --------------------------------------------------------
; RAM test to determine memsize
; Normally tests 8 Kbytes per iteration
; ** "TEST_LIMIT" **
; set this to the TOP limit of memory where you wish
; the ram test to quit testing
;
; RAM_TBS controls size of block being tested
; We are on a confirmed good stack at this point.

        mov     ax,offset _TEXT:rptram
        call    _console_puts
        xor     ax,ax
        mov     es,ax                   ;es holds pointer to last block checked

ram_test_loop:
        mov     ax,offset _TEXT:rrBacksp
        call    _console_puts
        mov     ax,es
        add     ax,RAM_TBS/16   ;segment start of next block
        push    ax              ;next segment to test
        mov     cl,6            ;convert segment address to K bytes
        shr     ax,cl           ;ax is now size in K bytes
if TARGET_CPU GE 386
.386
        mov     ebx,100000      ;parameter for print_accumulator
.8086
else
        mov     bx,100          ;parameter for print_accumulator
endif
        call    print_accumulator
        mov     al,'K'
        call    _console_putc           ;attach a 'K' on the end of digits
        pop     ax                      ;get next segment to test
        xor     bx,bx                   ;segment for accessing zero
        cmp     ax,TEST_LIMIT           ;reached limit yet?
        jae short ram_end
        push    ax
        call    mem_test2
        pop     ax
        jnc     ram_test_loop           ;jmp if no RAM errors

ram_end:        ;ax = last segment of usable RAM
        push    ss
        pop     ds
        mov     cl,6
        shr     ax,cl                   ;calculate mem size in K bytes
        mov     mem_size,ax

if TARGET_CPU GE 386
;conventional memory has been tested.  We must now check extended memory.
;Make a GDT for protected mode operation.
.386p
extrn _ptor:near,_rtop:near
        xor     ax,ax
        mov     cx,30h/2
e_ram_loop1:
        push    ax
        loop    e_ram_loop1     ;allocate space for GDT and zero it
        movzx   esp,sp          ;must zero high word of esp before calling rtop
        mov     bp,sp
        mov byte ptr ss:[bp+16h],0cfh   ;page granularity, limit = 4080 meg
        mov     eax,dword ptr 100000h   ;starting pointer to blocks
        jmp short e_ram_test1

e_ram_loop2:
;print RAM tested so far
        mov     ax,offset _TEXT:rrBacksp
        call    _console_puts
        pop     eax                     ;last successful block test
        pop     bp                      ;pointer to GDT
        add     eax,RAM_TBS             ;point to start of next block
        mov     ebx,100000              ;digit divisor
        push    eax                     ;top of next block to test
        shr     eax,10                  ;calculate K bytes
        call    print_accumulator       ;print memory tested so far.
        mov     al,'K'
        call    _console_putc           ;attach a 'K' on the end of digits
        pop     eax
e_ram_test1:
        push    bp                      ;save both pointers for next pass
        push    eax
        cmp     eax,EXT_TEST_LIMIT
        jae short e_ram_done
        rol     eax,8                   ;get high byte of block address in al
        mov     ss:[bp+17h],al          ;place high byte in GDT
        mov     al,93h                  ;access rights byte
        ror     eax,8
        mov     ss:[bp+12h],eax         ;set access rights and remainder of addr
;All uninitialized portions of the selector should be zero.
;The GDT is now ready to test the next block of memory.
        push    ss
        pop     es
        mov     si,bp           ;es:si points to GDT
        call    _rtop           ;switch to protected mode
        mov     ax,10h          ;selector for block to test
        mov     bx,20h          ;selector pointing to zero
        call    mem_test2       ;returns CF = 0 if block okay, CF = 1 if failure
        pushf
        mov     di,1            ;leave A20 enabled.
        call    _ptor           ;switch to real mode
        popf
        jnc     e_ram_loop2
e_ram_done:
;done testing memory
        pop     eax
        shr     eax,10          ;convert bytes to Kbytes
        push    ss
        pop     ds
;ax indicates total memory size in kbytes
        sub     ax,1024         ;calculate extended memory size
        mov     ex_mem_size,ax

;The A20 line is currently enabled
IF DEFAULT_A20_ENABLE EQ 0
extrn A20_disable:near
        call    A20_disable     ;disable according to configuration
endif

.8086
endif   ;TARGET_CPU GE 386

        mov     ax,offset _TEXT:cr
        call    _console_puts

Post_Print N

; --------------------------------------------
; >>>        Init System Environment       <<<
; --------------------------------------------

sys_init:
        ; ** initialize dedicated bios-data locations **
        mov     reset_flag,1234h        ; cold boot flag

Post_Print O
; --------------------------------------------
; >>>      SCAN FOR BIOS EXTENTIONS        <<<
; --------------------------------------------
;search memory from the segment address START_EXT_SRCH
; until address STOP_EXT_SRCH both defined in minibios.inc

xbios_chk:
        push    ds                      ; save bios data seg
        push    ds                      ; and get it in es
        pop     es

        ; do bios-extention search & invoke all that are present
        mov     dx,ROM_SCAN_START       ; scan start segment
xtd_scan:
        mov     ds,dx                   ; get target seg
        mov     ax,ds:[0]                       ; get id field
        cmp     ax,BIOS_EXT_ID          ; is it 55AAh
        jnz     next_page               ; else try next 2K
;Now do a checksum
        xor     cx,cx
        mov     ch,ds:[2]                       ;get length byte
;length byte is number of 512 byte pages in extention, we have it in ch which
;means cx has the number of words in the extention.
        xor     ax,ax
        xor     si,si
ext_loop:
        add     al,ds:[si]
        add     al,ds:[si+1]
        add     si,2
        loopnz  ext_loop        ;loop until cx = 0 or until si wraps
        jcxz    check_sum_done
;si has wrapped, add 64K to ds
        mov     si,ds
        add     si,4096         ;64K in segment arithmetic
        mov     ds,si
        xor     si,si
        jmp     ext_loop

check_sum_done:
;check sum is now in al, it should = zero.
        or      al,al
        mov     ds,dx                   ;ds may have been trashed
        jnz short next_page             ;jmp if not a valid BIOS extention

        ; body of control-passing scheme
;Caution!!!, ah must = 0 at this point!
        mov     al,ds:[2]               ; get length byte
        mov     cl,5                    ; and convert to seg para val
        shl     ax,cl
        add     dx,ax                   ; point to next area to scan
        mov     es:word ptr xtd_bios_seg,ds     ; build pointer
        mov     es:word ptr xtd_bios_ofs,3      ; offset of extention code
        push    dx                              ; save 'next seg to chk'
        push    es                              ; save bios data seg
        call    dword ptr es:xtd_bios_ofs       ; !! execute it !!
        pop     es
        pop     dx

        dec     dx
        and     dl,80h                  ;round down to nearest 2k boundary
next_page:
        add     dx,0080h
xs_done?:
        cmp     dx,ROM_SCAN_END         ; top of where extention can live
        jng     xtd_scan

xbs_done:
        pop     ds                      ; restore bios-data seg
        ; xtd bios scan done
        ; pass control to warm-boot code

; *******************************************************
; ** For testing user implemented features without CTR **
;    (enter test loop instead of booting ROM-DOS)
; *******************************************************
IFDEF NOT_ROMDOS
        JMP     go_test
ENDIF

Post_Print P

; *** ROM-DOS(tm) entry point ***
; rom dos should have installed its own int 19 handler
; by BIOS extension  INT 19 starts ROM-DOS
        sti

        INT 19H         ; Actual System Boot
;no return from ROM-DOS


; ----------------------------------------------------------------------
; >>>           miscellaneous subroutines and utilities              <<<
; ----------------------------------------------------------------------

comment &
        Below are some of the interrupt handlers which are required when
        using ROM-DOS.
&
_INT11_isr:     ;return equipment configuration in ax
        push    bx
        mov     bx,offset _DATA:equip_list
get_isr:
        push    ds
        mov     ax,_DATA
        mov     ds,ax
        mov     ax,ds:[bx]      ;get the desired word
        pop     ds
        pop     bx
_INT1c_isr label near
_INT09_isr:
        iret

_INT12_isr:     ;return conventional memory size
        push    bx
        mov     bx,offset _DATA:mem_size
        jmp short get_isr

comment &
        Procedure below dumps the number in ax or eax, to the console in
        decimal form.  Pass 10^(n-1) in bx or ebx, where n is the number of
        digits to display.  To dump a number <= 999, send bx = 100.  In this
        case, if ax = 59, it will dump out 059.  This is used for the memory
        test but can be used for other purposes also.  If running on a 386 or
        above and trying to print ax, be certain high word of eax and high
        word of ebx are zero.
&
print_accumulator:
IF TARGET_CPU GE 386
.386
;This is the 32 bit version of print_accumulator
        push    eax
        push    ebx
        push    ecx
        push    edx
        mov     ecx,10          ;dump numbers in base 10
        xor     edx,edx         ;zero the high dword of the dividend
print_loop:
        div     ebx
;edx now has the remainder, al has digit to print
        push    edx             ;save remainder
        add     al,'0'          ;convert to ASCII
        call    _console_putc
        xor     edx,edx         ;zero the high word of the dividend
        mov     eax,ebx         ;digit divisor, 100,10....
        div     ecx             ;prepare for next digit
        mov     ebx,eax         ;new digit divisor
        pop     eax             ;remaining digits to print
;edx should be zero now, ebx is new digit divisor
;eax = remainder of number to dump
        or      bx,bx
        jnz     print_loop      ;loop until digit divisor = 0.
        pop     edx
        pop     ecx
        pop     ebx
        pop     eax
        ret
.8086
else    ;IF TARGET_CPU LT 386 do the code below
        push    ax
        push    bx
        push    cx
        push    dx
        mov     cx,10           ;dump numbers in base 10
        xor     dx,dx           ;zero the high word of the dividend
print_loop:
        div     bx
;dx now has the remainder, al has digit to print
        push    dx              ;save remainder
        add     al,'0'          ;convert to ASCII
        call    _console_putc
        xor     dx,dx           ;zero the high word of the dividend
        mov     ax,bx           ;digit divisor, 100,10....
        div     cx              ;prepare for next digit
        mov     bx,ax           ;new digit divisor
        pop     ax              ;remaining digits to print
;dx should be zero now, bx is new digit divisor
;ax = remainder of number to dump
        or      bx,bx
        jnz     print_loop      ;loop until digit divisor = 0.
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret
endif   ;TARGET_CPU GE 386

mem_error:
        stc
        jmp     bp                      ;return to caller

comment &
        This function works in both real mode and protected mode.  If no
        confirmed stack, jmp to mem_test1 with bp = return address, ax =
        segment to test,  bx = segment with base address of zero.  Size of
        block to test is RAM_TBS, it must be 2^n and is typically 8 Kilobytes.
        The STACK is not trusted or used in any way by this procedure.  If
        RAM_TEST != 0, this procedure checks the memory block to insure no
        bits are stuck either high or low, it tests to insure no address lines
        are stuck high or low, it tests to insure odd byte addressing is
        working correctly.  It checks refresh by waiting as specified by
        dlytime.  If RAM_TEST == 0, all tests are eliminated except checking
        for stuck bits and wrap at the highest byte in each block.  This is
        primarily just for determining the memory size.

        All registers are trashed.  Returns with CF = 0 if okay, CF = 1 if
        failure.
&
mem_test2:      pop     bp              ;put ret address in bp

mem_test1:      ;jmp to mem_test1 with bp = ret address
        or      ax,ax                   ;check if real mode and first block
        mov     es,ax
        jz short skip_wrap              ;skip wrap test if segment = 0
comment &
        A stuck address line shows up by causing a memory wrap.  If each of
        the blocks we test is 8K and starts on an 8K boundary, we can catch
        all stuck address lines by checking each memory block to insure the
        start of the block doesn't wrap back to zero and by checking to insure
        there are no wraps internal to the 8K block.  The test below checks to
        see if we are wrapping back to zero.  We skip this test if the block
        starts at zero.
&
        mov     ds,bx                   ;segment with base address = 0
        mov     bx,es:[0]               ;get word at start of block
        cmp     bx,ds:[0]               ;check if = word at absolute zero
        jne short skip_wrap             ;jmp if no wrap
;The word at the start of the block = the word at start of memory
;We may have a wrap problem, change the data and test again.
        not word ptr es:[0]             ;invert the first word of the block
        cmp     bx,ds:[0]               ;check if we altered absolute zero
;bx was = prior to the NOT instruction above, it should still = ds:[0]
        mov     es:[0],bx               ;restore the first word
        jne short mem_error             ;jmp if we have a confirmed wrap

skip_wrap:

IF RAM_TEST EQ 0
        mov     al,es:[RAM_TBS-1]
        mov     ah,al
        not byte ptr es:[RAM_TBS-1]     ;change the byte
        xchg    al,es:[RAM_TBS-1]       ;restore the byte
        not     al                      ;should restore byte to = ah
        cmp     ah,al
        jne short mem_error
;if we make it this far, the block is assumed to be good.

ELSE    ;IF RAM_TEST != 0 do the code below
        mov     ds,ax                   ;selector pointing to block to test
;check for odd addressing problems, symptoms are a byte read from an odd
;address does not match the high byte of a word at the next lower address,
        mov     ax,1234h
        mov     bx,5678h
        mov     cx,9abch
        xchg    ax,ds:[0]
        xchg    bx,ds:[2]
        xchg    cx,ds:[4]
        mov     dl,al
        mov     al,ah
        mov     ah,bl
        mov     bl,bh
        mov     bh,cl
        xchg    ax,ds:[1]
        xchg    bx,ds:[3]
        xchg    ch,ds:[5]
        xchg    dl,ds:[0]               ;restore memory using odd addresses
        mov     cl,dl
        cmp     ax,7812h
        jne     mem_error
        cmp     bx,0bc56h
        jne     mem_error
        cmp     cx,9a34h
        jne     mem_error
;Check for stuck bits
        xor     di,di
        xor     si,si                   ;es:di and ds:si point to block
        mov     cx,RAM_TBS/2            ;number of words to check
        mov     dx,cx                   ;dx has number of words to test

if RAM_TEST EQ 2                        ;do the fast "write over" test
        mov     ax,5555h                ;alternating 1s and 0s
        rep     stosw                   ;fill the block with 5555h
        mov     cx,dx
        xor     di,di
        repe    scasw                   ;check if all words = ax
        jne     mem_error1
        mov     cx,dx                   ;number of words in block
        xor     di,di
        mov     ax,0aaaah               ;alternating 1s and 0s
        rep     stosw                   ;fill the block with 0aaaah
; We will check the second half of the stuck bit test after a delay to test
; refresh

else    ;RAM_TEST NE 2          do the slower non destructive test

mem_l1:
        mov     ax,5555h                ;alternating 1s and 0s
        xchg    ds:[si],ax              ;place 5555h in memory
        mov     bx,0aaaah               ;NOT 5555h
        xchg    ds:[si],bx              ;get 5555h, place aaaah in memory
        cmp     bx,5555h
        jne     mem_error1              ;jmp if 5555h was corrupted
        xchg    ds:[si],ax              ;get aaaah, and restore memory
        cmp     ax, 0aaaah
        jne     mem_error1
        add     si,2
        loop    mem_l1                  ;check all words in block
endif   ;RAM_TEST
comment &
        No stuck bits have been detected.  We will now check for wrap
        problems internal to the block.  So long as we are testing 2^n K
        blocks on 2^n K boundaries, all internal wrap problems will show up
        back at the first word of the block.  dx contains the size of the
        block in words.
&
        mov     di,2
        mov     cx,ds:[0]               ;get first word in block
        mov     ax,cx
        not     ax                      ;get ax != first word in block
mem_l2:
        xchg    ax,ds:[di]
        cmp     cx,ds:[0]               ;check if first word was altered
        xchg    ax,ds:[di]              ;restore memory and ax
        jne     mem_error1              ;jmp if first word was corrupted
        shl     di,1                    ;get ready to check next address line
        cmp     di,dx
        jb      mem_l2                  ;don't loop when di = dx, dx = words

; No wrap problems have been detected, address lines are okay, check refresh

if RAM_TEST EQ 2        ;do the fast, "write over" test
; The block has already been initialized to aaaah so all we need to do is
; check to see if it changes after a delay.  This doubles as the second part
; of the stuck bit test.
        mov     cx,dlytime
mem_l5:
        loop    mem_l5                  ;wait about 7 milliseconds
        mov     ax,0aaaah               ;alternating 1s and 0s
        xor     di,di
        mov     cx,dx
        repe    scasw
        jne     mem_error1
; If we make it this far, there are no stuck bits and refresh is working.
        xor     ax,ax
        xor     di,di
        mov     cx,dx
        rep     stosw                   ;zero the block

else    ;RAM_TEST NE 2          do the slower non destructive test
; We will calculate a checksum while encoding the memory.  After a delay,
; we will decode the memory and calculate a new checksum.  If the memory was
; corrupted during the delay, the new checksum will be corrupt.
        mov     cx,dx
        xor     di,di
        xor     si,si
        mov     bx,53A9h                ;random seed for encoding
mem_l3:
        lodsw
        xor     ax,bx                   ;encode data
        stosw
        add     bx,ax                   ;calculate new seed
        loop    mem_l3                  ;encode the entire block
;bx contains an encoded checksum, now wait a while for the RAM to forget
        mov     cx,dlytime
dly_loop:
        loop    dly_loop

;decode the block while calculating the new checksum
        mov     cx,dx
        mov     dx,bx                   ;save old checksum
        xor     di,di
        xor     si,si
        mov     bx,53A9h                ;seed for decoding
mem_l4:
        lodsw
        xor     ax,bx                   ;decode data
        stosw                           ;restore memory
        xor     ax,bx
        add     bx,ax                   ;calculate new seed
        loop    mem_l4                  ;decode the entire block
;bx now contains the newly calculated seed, dx has the old.
        cmp     bx,dx
        jne     mem_error1

endif   ;IF RAM_TEST == 2
endif   ;IF RAM_TEST == 0
;We have successfully completed the test of the memory block
        clc
        jmp     bp
mem_error1:
        stc
        jmp     bp

if SupportPostCodes
;jmp to this code with cs:si pointing to an ASCIIZ string, the string is
;dumped and the system halted.

term_dump_msg:

ifdef Con_Port                  ;dump message if Con_Port is defined
        mov     ax,cs
        mov     ds,ax
        cld
        mov     dx,Con_Port+5

lp3:    in      al,dx
        test    al,20h
        jz      lp3             ; wait for trans buffer to be empty
        lodsb                   ; get the next character
        or      al,al           ; check if done
        jz short lp4
        sub     dl,5            ; make Console_Port
        out     dx,al
        add     dl,5            ; make Console_Port + 5
        jmp     lp3             ; loop until message is dumped

else    ;if con_port is not defined, dump error simple message

Post_Print e
Post_Print r
Post_Print r
Post_Print o
Post_Print r

endif

lp4:    jmp     lp4             ; halt the system

if RAM_TEST NE 0

; mem_fail_msg is dumped out if the first 8K of RAM does not work properly
mem_fail_msg    db      ' Fatal Error, failure in first 8K of RAM test',0

endif

endif   ;SupportPostCodes

IF ReportNonSupportedCalls
; ---------------------------------
; ** TRAP unsupported BIOS calls **
; ---------------------------------
; all unused vectors point to these dummy ISRs
; so we may display "Unsupported BIOS INT" message
; and all the register values when the int happens.
;
; Works for both Hardware and Software interrupts.
;

ns_calls:
isr_00: call    unsupported_int
isr_01: call    unsupported_int
isr_02: call    unsupported_int
isr_03: call    unsupported_int
isr_04: call    unsupported_int
isr_05: call    unsupported_int
isr_06: call    unsupported_int
isr_07: call    unsupported_int
isr_08: call    unsupported_int
isr_09: call    unsupported_int
isr_0A: call    unsupported_int
isr_0B: call    unsupported_int
isr_0C: call    unsupported_int
isr_0D: call    unsupported_int
isr_0E: call    unsupported_int
isr_0F: call    unsupported_int
        ;iret   ; simple immediate iret for int 0Fh
        ;nop
        ;nop

isr_10: call    unsupported_int
isr_11: call    unsupported_int
isr_12: call    unsupported_int
isr_13: call    unsupported_int
isr_14: call    unsupported_int
isr_15: call    unsupported_int
isr_16: call    unsupported_int
isr_17: call    unsupported_int
isr_18: call    unsupported_int
isr_19: call    unsupported_int
isr_1A: call    unsupported_int
isr_1B: call    unsupported_int
isr_1C: call    unsupported_int
isr_1D: call    unsupported_int
isr_1E: call    unsupported_int
isr_1F: call    unsupported_int

isr_20: call    unsupported_int
isr_21: call    unsupported_int
isr_22: call    unsupported_int
isr_23: call    unsupported_int
isr_24: call    unsupported_int
isr_25: call    unsupported_int
isr_26: call    unsupported_int
isr_27: call    unsupported_int
isr_28: call    unsupported_int
isr_29: call    unsupported_int
isr_2A: call    unsupported_int
isr_2B: call    unsupported_int
isr_2C: call    unsupported_int
isr_2D: call    unsupported_int
isr_2E: call    unsupported_int
isr_2F: call    unsupported_int

isr_30: call    unsupported_int
isr_31: call    unsupported_int
isr_32: call    unsupported_int
isr_33: call    unsupported_int
isr_34: call    unsupported_int
isr_35: call    unsupported_int
isr_36: call    unsupported_int
isr_37: call    unsupported_int
isr_38: call    unsupported_int
isr_39: call    unsupported_int
isr_3A: call    unsupported_int
isr_3B: call    unsupported_int
isr_3C: call    unsupported_int
isr_3D: call    unsupported_int
isr_3E: call    unsupported_int
isr_3F: call    unsupported_int

isr_40: call    unsupported_int
isr_41: call    unsupported_int
isr_42: call    unsupported_int
isr_43: call    unsupported_int
isr_44: call    unsupported_int
isr_45: call    unsupported_int
isr_46: call    unsupported_int
isr_47: call    unsupported_int
isr_48: call    unsupported_int
isr_49: call    unsupported_int
isr_4A: call    unsupported_int
isr_4B: call    unsupported_int
isr_4C: call    unsupported_int
isr_4D: call    unsupported_int
isr_4E: call    unsupported_int
isr_4F: call    unsupported_int

isr_50: call    unsupported_int
isr_51: call    unsupported_int
isr_52: call    unsupported_int
isr_53: call    unsupported_int
isr_54: call    unsupported_int
isr_55: call    unsupported_int
isr_56: call    unsupported_int
isr_57: call    unsupported_int
isr_58: call    unsupported_int
isr_59: call    unsupported_int
isr_5A: call    unsupported_int
isr_5B: call    unsupported_int
isr_5C: call    unsupported_int
isr_5D: call    unsupported_int
isr_5E: call    unsupported_int
isr_5F: call    unsupported_int

isr_60: call    unsupported_int
isr_61: call    unsupported_int
isr_62: call    unsupported_int
isr_63: call    unsupported_int
isr_64: call    unsupported_int
isr_65: call    unsupported_int
isr_66: call    unsupported_int
isr_67: call    unsupported_int
isr_68: call    unsupported_int
isr_69: call    unsupported_int
isr_6A: call    unsupported_int
isr_6B: call    unsupported_int
isr_6C: call    unsupported_int
isr_6D: call    unsupported_int
isr_6E: call    unsupported_int
isr_6F: call    unsupported_int

isr_70: call    unsupported_int
isr_71: call    unsupported_int
isr_72: call    unsupported_int
isr_73: call    unsupported_int
isr_74: call    unsupported_int
isr_75: call    unsupported_int
isr_76: call    unsupported_int
isr_77: call    unsupported_int
isr_78: call    unsupported_int
isr_79: call    unsupported_int
isr_7A: call    unsupported_int
isr_7B: call    unsupported_int
isr_7C: call    unsupported_int
isr_7D: call    unsupported_int
isr_7E: call    unsupported_int
isr_7F: call    unsupported_int

isr_80: call    unsupported_int
isr_81: call    unsupported_int
isr_82: call    unsupported_int
isr_83: call    unsupported_int
isr_84: call    unsupported_int
isr_85: call    unsupported_int
isr_86: call    unsupported_int
isr_87: call    unsupported_int
isr_88: call    unsupported_int
isr_89: call    unsupported_int
isr_8A: call    unsupported_int
isr_8B: call    unsupported_int
isr_8C: call    unsupported_int
isr_8D: call    unsupported_int
isr_8E: call    unsupported_int
isr_8F: call    unsupported_int

isr_90: call    unsupported_int
isr_91: call    unsupported_int
isr_92: call    unsupported_int
isr_93: call    unsupported_int
isr_94: call    unsupported_int
isr_95: call    unsupported_int
isr_96: call    unsupported_int
isr_97: call    unsupported_int
isr_98: call    unsupported_int
isr_99: call    unsupported_int
isr_9A: call    unsupported_int
isr_9B: call    unsupported_int
isr_9C: call    unsupported_int
isr_9D: call    unsupported_int
isr_9E: call    unsupported_int
isr_9F: call    unsupported_int

isr_A0: call    unsupported_int
isr_A1: call    unsupported_int
isr_A2: call    unsupported_int
isr_A3: call    unsupported_int
isr_A4: call    unsupported_int
isr_A5: call    unsupported_int
isr_A6: call    unsupported_int
isr_A7: call    unsupported_int
isr_A8: call    unsupported_int
isr_A9: call    unsupported_int
isr_AA: call    unsupported_int
isr_AB: call    unsupported_int
isr_AC: call    unsupported_int
isr_AD: call    unsupported_int
isr_AE: call    unsupported_int
isr_AF: call    unsupported_int

isr_B0: call    unsupported_int
isr_B1: call    unsupported_int
isr_B2: call    unsupported_int
isr_B3: call    unsupported_int
isr_B4: call    unsupported_int
isr_B5: call    unsupported_int
isr_B6: call    unsupported_int
isr_B7: call    unsupported_int
isr_B8: call    unsupported_int
isr_B9: call    unsupported_int
isr_BA: call    unsupported_int
isr_BB: call    unsupported_int
isr_BC: call    unsupported_int
isr_BD: call    unsupported_int
isr_BE: call    unsupported_int
isr_BF: call    unsupported_int

isr_C0: call    unsupported_int
isr_C1: call    unsupported_int
isr_C2: call    unsupported_int
isr_C3: call    unsupported_int
isr_C4: call    unsupported_int
isr_C5: call    unsupported_int
isr_C6: call    unsupported_int
isr_C7: call    unsupported_int
isr_C8: call    unsupported_int
isr_C9: call    unsupported_int
isr_CA: call    unsupported_int
isr_CB: call    unsupported_int
isr_CC: call    unsupported_int
isr_CD: call    unsupported_int
isr_CE: call    unsupported_int
isr_CF: call    unsupported_int

isr_D0: call    unsupported_int
isr_D1: call    unsupported_int
isr_D2: call    unsupported_int
isr_D3: call    unsupported_int
isr_D4: call    unsupported_int
isr_D5: call    unsupported_int
isr_D6: call    unsupported_int
isr_D7: call    unsupported_int
isr_D8: call    unsupported_int
isr_D9: call    unsupported_int
isr_DA: call    unsupported_int
isr_DB: call    unsupported_int
isr_DC: call    unsupported_int
isr_DD: call    unsupported_int
isr_DE: call    unsupported_int
isr_DF: call    unsupported_int

isr_E0: call    unsupported_int
isr_E1: call    unsupported_int
isr_E2: call    unsupported_int
isr_E3: call    unsupported_int
isr_E4: call    unsupported_int
isr_E5: call    unsupported_int
isr_E6: call    unsupported_int
isr_E7: call    unsupported_int
isr_E8: call    unsupported_int
isr_E9: call    unsupported_int
isr_EA: call    unsupported_int
isr_EB: call    unsupported_int
isr_EC: call    unsupported_int
isr_ED: call    unsupported_int
isr_EE: call    unsupported_int
isr_EF: call    unsupported_int

isr_F0: call    unsupported_int
isr_F1: call    unsupported_int
isr_F2: call    unsupported_int
isr_F3: call    unsupported_int
isr_F4: call    unsupported_int
isr_F5: call    unsupported_int
isr_F6: call    unsupported_int
isr_F7: call    unsupported_int
isr_F8: call    unsupported_int
isr_F9: call    unsupported_int
isr_FA: call    unsupported_int
isr_FB: call    unsupported_int
isr_FC: call    unsupported_int
isr_FD: call    unsupported_int
isr_FE: call    unsupported_int
isr_FF: call    unsupported_int

;  stack after save frame
;
;       +------------+
;  BP+8 | FL of User |
;       +------------+
;  BP+6 | CS of User |
;       +------------+
;  BP+4 | IP of User |
;       +------------+
;  BP+2 | IP of Isr  |
;       +------------+
;       |     BP     |
;       +------------+
;
unsupported_int:
        ; save stack frame
        push    bp
        mov     bp, sp

        ; push all registers we will use
        ; note: do NOT change the order, we display regs in this order
        push    ax
        push    bx
        push    cx
        push    dx
        push    ds

        ; just in case we change 'em
        push    es
        push    si
        push    di

        ; get DGROUP into DS
        mov     ax, dgroup
        mov     ds, ax

        ; determine interrupt #
        mov     ax, [bp+2]
        sub     ax, offset CS:isr_00
        xor     dx, dx
        mov     cx, 3
        div     cx              ; DX:AX / CX -1 = int #
        dec     ax
        mov     un_int_num, ax  ; record unsupported int number

        ; display "unsupported int" message
        mov     ax,offset _TEXT:uint_msg1
        call    _console_puts

        ; htoa(int val, char far *str)
        push    ds
        mov     ax,GOFFSET strbuf
        push    ax
        push    word ptr un_int_num
        call    htoa            ; convert int value to ascii
        add     sp,6            ; clean stack

        ; display "strbuf"
        push    ds
        mov     ax,GOFFSET strbuf+2  ; knock off leading zeros
        push    ax
        call    _far_console_puts
        add     sp,4            ; clean stack

        ; message2
        mov     ax,offset _TEXT:uint_msg2
        call    _console_puts

        ; report register contents (counts on value in BP)
        call    disp_regs

        mov     ax,offset _TEXT:cr
        call    _console_puts

        ; now wait for a keystroke
        mov     ah,0
        int     16h

        ; we're done, restore regs and exit
        pop     di
        pop     si
        pop     es
        pop     ds
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        pop     bp
        add     sp,02   ;this cleans the stack from the call from
        iret            ; the unsupported int table


;  Called by "unsupported_int", this function assumes BP
;  points to the stack frame of the interrupt call.  See
;  "unsupported_int" for a visual picture of stack frame.
;
;  Displays | FL | CS | IP | AX | BX | CX | DX | DS |
;
;  On Stack
;    +8   +6   +4   +2   +0   -2   -4   -6   -8  -10  -12  -14
;  +----+----+----+----+----+----+----+----+----+----+----+----+
;  | FL | CS | IP | XX | BP | AX | BX | CX | DX | DS | ES | SI |
;  +----+----+----+----+----+----+----+----+----+----+----+----+
;
disp_regs:
        push    si

        ; FL begins at [BP+8], print out 3 words
        mov     si, 8           ; [BP+8]
        mov     cx, 3           ; 3 words
        call    disp_regs_2

        ; AX begins at [BP-2], print out 5 words
        mov     si, -2          ; [BP-2]
        mov     cx, 5           ; 5 words
        call    disp_regs_2
        pop     si
        ret

disp_regs_2:

        ; in case they gets trashed
        push    cx
        push    si

        ; htoa(int val, char far *str)
        push    ds
        mov     ax,GOFFSET strbuf
        push    ax
        mov     ax,[bp+si]      ; get next reg
        push    ax
        call    htoa            ; convert reg contents to ascii (0000)
        add     sp,6            ; clean stack

        ; bios_puts(char far *str)
        push    ds
        mov     ax,GOFFSET strbuf
        push    ax
        call    _far_console_puts
        add     sp,4            ; clean stack

        ; in case they was trashed (colloquial, how quaint)
        pop     si
        pop     cx
        sub     si, 2
        loop    disp_regs_2

        ret


;-----------------------------------------------------------
;>>> HEX TO ASCII CONVERSION ROUTINE CALLED BY DISP_REGS <<<
;-----------------------------------------------------------
;the address of the output string buffer is passed on the
;stack along with the hex value to be converted to ascii for
;printing
        public htoa
htoa:
        push    bp
        mov     bp,sp
        push    si
        mov     cx,word ptr [bp+4]
        xor     si,si
htoa1:
;hex number can be 5 digits, start at right most and work to the left
        mov     ax,cx
        and     ax,15
        cmp     ax,10
        jb      short htoa2
        mov     al,cl
        and     al,15
        add     al,55
        jmp     short htoa3
htoa2:
        mov     al,cl
        and     al,15
        add     al,48
htoa3:
        mov     dx,3
        sub     dx,si
        les     bx,dword ptr [bp+6]
        add     bx,dx
        mov     byte ptr es:[bx],al
   ;
   ;    divide hex number by 16 to remove right most digit
   ;
        mov     bx,16
        mov     ax,cx
        xor     dx,dx
        div     bx
        mov     cx,ax
        inc     si
        cmp     si,4
        jl      short htoa1

   ; place a space at end of string and null terminate the string
   ;
        les     bx,dword ptr [bp+6]
        mov     byte ptr es:[bx+4],32
        les     bx,dword ptr [bp+6]
        mov     byte ptr es:[bx+5],0
        pop     si
        pop     bp
        ret


ELSE
;----------------------------------------------------
; >>>            DEFAULT ISR                      <<<
; ---------------------------------------------------
;do simple iret for all unsupported interrupts if
; the report unsupported interrupt option is not enbled

dummy_isr:                      ; default isr vector used to trap
trap_uints:
        iret                    ;  any unsupported funtion calls.

ENDIF   ; end of "report unsupported bios calls" conditional

; ----------------------------------------------------------
; for target debugging using a remote load & execute utility
; assumes that code is loaded at segment 1000h
; (allows ram test to bypass an 8K area where code resides)
; ----------------------------------------------------------

IF TARGETRUN
protect:
        cmp     ax,cx                   ; test for pgm area
        jne     prxt                    ; resume ram test w/o bypass
        add     ax,dx
        mov     es,ax
        call    dispram                 ; report verified ram size
        mov     ax,es                   ;tt added to fix 'test_limit' bug
prxt:
        ret                             ; resume ram test at next 8K boundary
ENDIF


; ----------------------------------------------------------------------------
;                              DEBUG UTILITIES
; ----------------------------------------------------------------------------


; -------------------------------------------------------
; ** For testing user implemented features WITHOUT CTR **
;    (enter this loop instead of booting ROM-DOS)
; *******************************************************
IFDEF NOT_ROMDOS
        public  go_test
go_test:
        ; display a test message ...
        mov     ax,offset _TEXT: teststring
        call    _console_puts
        ; get a key ...
keywait:
        mov     al,1
dloop1: mov     cx,-1   ; get-a-key delay
dloop:  loop    dloop
        dec     al
        jnz     dloop1

        mov     ah,0
        int     16h     ; get any key
        mov     ah,0eh
        push    ax      ; save it
        int     10h     ; display it
        pop     ax
        ;
        cmp     al,'D'  ; test it
        jne     keywait
        call    dkey
        jmp     keywait
        ;
dkey:
        ; test some func
        ret

ENDIF   ; end "ifdef not_romdos" option
; -------------------------------------------------------

IF DEBUG+TARGETRUN
; user defined routines for testing added features
; with CTR KERNEL..
; this will be entered after all system initialization
; has been performed, just before the BIOS searches for
; bios-extentions to execute.

        public do_debug
do_debug:                               ; target location for debug
        mov     ax,0E07h
        int     10h                     ; ring host bell
        mov     ah,0                    ; wait for char
        int     16h
public  sf1test
sf1test:
        jmp     do_debug

ENDIF
; ** END OF DEBUG CODE **
; -------------------------------------------------------------------


; ------------------------------------------------
; >> message list for initialization reporting <<
; ------------------------------------------------

copyrt  db      7,0AH,0DH,"Datalight miniBIOS (R) ",SHORTVERSION,BIOSVERSION
        db      0AH,0DH,COPYRIGHT,0AH,0DH,0
target_name_msg db TARGET_NAME," ", BIOS_DATE, 0AH,0DH,0

if TARGET_CPU GE 386
rrBacksp        db     8,8,8,8,8,8,8,0
; extra backspaces for extended ramsize reporting message
rptram  db      0AH,0DH," Tested RAM 000000K",0
else
rrBacksp db     8,8,8,8,0       ; backspaces for ramsize reporting message
rptram  db      0AH,0DH," Tested RAM 000K",0
endif

cr      db      0ah,0dh,0
; --------- conditionally compiled messages ---------

IF ReportNonSupportedCalls
uint_msg1  db 13,10,"* Unsupported miniBIOS call, INT ",0
uint_msg2  db 13,10,"| FL | CS | IP | AX | BX | CX | DX | DS |",13,10,' ',0
ENDIF

IFDEF NOT_ROMDOS
teststring db   "**>",0DH,0AH,"TESTING THE BIOS !!!!>>>>>>>> ",0
ENDIF

CEndCode

        end reset

