//
//   $Id: RSZ.H 1.4 2002/10/15 23:55:32Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*******************************************************************

	RSZ.H  created 08/08/97  by Dennis Edwards

	Copyright (c) 1997-2002 Datalight, Inc.
	All Rights Reserved.
	Datalight Confidential and Proprietary

	This is the RSZ ZMODEM protocol driver interface.

*******************************************************************/
#if !defined(RSZ_H)
#define RSZ_H 1

// types of handshaking we support
//
#define NO_HANDSHAKING      	0
#define SOFTWARE_HANDSHAKING	1
#define HARDWARE_HANDSHAKING	2

// ZMDODEM file management options we support
//
#define SKIP_IT					0
#define RESUME_TRANSFER			1
#define DUP_IT						2
#define CLOBBER_EXISTING		3

#if 0
// Any pre-established error messages that may come from the protocol driver
// are to be displayed by invoking a function pointer. The function
// pointer is initialized to 0 and thus not called by default. The protocol
// driver supplies the subsequent function which allows the messages to be
// output via the user supplied status reporting routine which returns the
// previous pointer value.
// This function must be called before opening the port.
//
MessageFunction SetMessageFunction(MessageFunction newFunction);
#endif

// To simplify cabling, no handshaking is used by default. This will present
// a problem when the receiver has to write to slow media (floppies, flash).
// This allows the use to specify a particular hand shaking method. If the
// protocol driver cannot support the particular handshaking method then it
// must return an error. Otherwise it must return the previous method and enable
// the new handshaking scheme.
// This function must be called before opening the port.
//
int SetHandShakingType(int newMethod);

// The ZMODEM protocol allows the sender to specifier a number of ways to deal
// with file collisions, these are refered to as file management options. We
// let the user choose from among a subset of those defined by the protocol.
// The user's intent to initiate crash recovery must be separately specified
// since many implementations do not exchange ZCRC packets to determine if
// appending data to an existing file is appropriate under this guise. The
// append new data to existing file option is supported explicitly.
// This function must be called before opening the port.
//
int SetFileManagementType(int newMethod, bool crashRecovering);

// The communications port is opened by calling this routine which allows a
// file transfer to begin immediately upon return. The protocol driver must
// be able to restore the original port configuration when CommClose() is
// called just prior to terminating the program. The routine should return
// 0 on success or -1 on error. If an error occures the, message function
// (if assigned) should be called to explain the trouble to the user before
// returning to the calling routine.
//
int comm_open(long baudRate, char *parms, int portNumber, int iIrqNumber);

// This will send the specified files using the ZMODEM protocol over the
// port specified by the previous CommOpen() call. Multiple ports are not
// supported by RSZ. The number of files actually transfered should be returned
// or, if an error occured, a negative value. If an error occures the, message function
// (if assigned) should be called to explain the trouble to the user before
// returning to the calling routine. The string passed to SendZMODEM() will just
// be a list of files, separated by any of {',',';','\t',' '}. It is SendZMODEM()'s
// responsibility to resolve wildcards. zRecover, if <>0, enables crash recovery.
// Remote files should be over-written by default. Blocking must be supported
// if a handshaking method is specified.
//
int  SendZMODEM(char *pzFiles);

// This will receive files using the ZMODEM protocol over the
// port specified by the previous CommOpen() call. Multiple ports are not
// supported by RSZ. The number of files actually transfered should be returned
// or, if an error occured, a negative value. If an error occures the, message function
// (if assigned) should be called to explain the trouble to the user before
// returning to the calling routine. Crash recovery must be enabled. Full and
// relative path names must be enabled and directories must be created as
// required.
//
int  ReceiveZMODEM(void);

// This will close the port previously opened, restoring its original configuration
// and freeing any memory allocated by the protocol driver. If an error occures,
// the message function (if assigned) should be called to explain the trouble to
// the user before returning to the calling routine.
//
int  comm_close(void);

// in xyzgen.c, disables kbhits during transfer on serial console
extern bool fNoKbHit;

#endif //!defined(RSZ_H)

