//
//   $Id: RXE.H 1.6 2002/10/16 15:53:20Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 * RXE.H
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

 * This file provides several defines and other things for RXE converter
 *
 */

#include "rxe-prot.pt"

struct rxe {
	unsigned ds_dsp;
	unsigned ld_seg;
	};

extern int quit, continue_on_error, exit_status;

#define XIPSIG (((long) 'P' << 16) | ((long) 'I' << 8) | 'X' )

/*
 * The RXE_BASE structure is at the head of the assembly RXE_BASE.
 *
 * The "X" shows the fields that are initialized by RXE_BASE.ASM.
 *
 * The "R" shows the fields that are initialized by RXE_CVT.EXE
 */
struct rxe_base {
	long rxe_sig;		/* X - RXE Sig is "XIP" */
	unsigned rxe_ver;	/* X - Version of RXE_CVT  that built it */
	unsigned cd_seg;	/* X - Start of Code Block in RXE Memory */
	unsigned ld_seg;	/* R - Segment of start of RXE in memory */
	unsigned int_no;	/* R - Interrupt used for RXE support */
	unsigned cd_cs;	/* R - Segment of start code of RXE in memory */
	unsigned cd_ip;		/* R - Offset of start code of RXE in memory */
	unsigned cd_len;	/* R - Length in paragraphs of RXE code block */
	unsigned cd_sum;	/* R - Check sum of RXE code block */
	unsigned rxe_base_len;	/* R - The length in para's of the rxe Blodk */
	unsigned rxe_fixup_table[16]; /* R - Fixup table */
	char code[2];		/* X - Code of the RXE_BASE */
};

