//
//   $Id: RXECHECK.C 1.4 2002/10/16 15:53:20Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	Copyright (c) 1989-2002 Datalight, Inc.
	All Rights Reserved.
	Datalight Confidential and Proprietary
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <process.h>
#include <dos.h>
#include <io.h>
#include <assert.h>
#include <fcntl.h>
#include <sys\\stat.h>

#include "rxe.h"
#include "..\dosver.h"


#define USAGE "Usage:\n\tRXECHECK Data_Segment ExeFileName <arguments>\n\
\n\tChecks if an EXE program can be made into an RXE, it checks for\n\
\t\t1) Data or self modifying code the Code Block\n\
\t\t2) Invalid Code Block Fixups (DW DGROUP in the Code Block).\n\
\n\tUse '/L' as first argument to maintain case of segment names.\n\
Example:\n\
\tRXECHECK DATA args Arg1 Arg2 Arg3 Arg4\n\
\t\tThe above example checks the program ARGS.EXE for code block \n\
\t\tmodification.  The data block starts at segment DATA, the ARGS\n\
\t\tprogram gets the argument line \"Arg1 Arg2 Arg3 Arg4\n"

struct exec {
	unsigned env;
	void far *com_line;
	void far *fcb1;
	void far *fcb2;
	unsigned SP;
	unsigned SS;
	unsigned IP;
	unsigned CS;
};

static struct exec exe_struct;

struct {
	unsigned char dummy[10];
	void far *term_addr;
	} far *psp;

static union REGS regs;

unsigned new_psp;			/* Initial segment of new program */
unsigned load_address;

unsigned long length = 15000;

extern ret_spawn();

int _OKBIGBUF = 1;

int continue_on_error = FALSE;

int quit = FALSE;

int useLowerCase = FALSE;

int exit_status;

int DisplayWarningMessages = FALSE;  /* For RXE_ERROR.C */

int code_changed = FALSE;

#define CARRY_SET(c) (c & 1)

char exe_name[66], args[129], *not = "";
char *prog_name, *seg_name;

char *RXERootPath;

int do_write(int fd, void far *buffer, long size);

FILE *RXE_output;			// Output for RXE Error

void main(int argc, char *argv[])
{
	extern int _OKBIGBUF, errno;
	unsigned d_seg;
	int i=1, ret, sum1, sum2, fd, badFixups, rxeAble;

	printf("Datalight ROMable EXE Check Utility\nVersion  %s\n", FULLVERSION);
	printf("%s\n\n", COPYRIGHT);

	if(argc < 3){
		continue_on_error = TRUE;
		error(21);
		printf(USAGE);
		exit(1);
	}

	RXERootPath = argv[0];			// Save Root path!

	RXE_output = fopen("CON", "w");
	assert(RXE_output != NULL);

	if(argv[i][0] == '/')
	{
		switch(argv[i][1])
		{
		case 'L':
		case 'l':
			useLowerCase = TRUE; ++i;
			break;

		default:
			error(10, argv[i]);
		}
	}

	seg_name = argv[i++];

	prog_name = argv[i++];

	strcpy(exe_name, prog_name);		/* Build prog name */

	if(!isdigit(*seg_name))			/* Get memory segment */
	{
		if(!useLowerCase)
			strupr(seg_name);			/* Make the name upper case */
		d_seg = find_segment_value(exe_name, seg_name);
		if(d_seg == 0xFFFF)
		{
			char MapName[128];
			strcpy(MapName, exe_name);
			strcat(MapName, ".map");
			error(9, seg_name, exe_name, seg_name);
		}
	}
	else
		sscanf(seg_name, "%x", &d_seg);

	length = (long)d_seg << 4;

	args[0] = 1;				/* Build argment line */
	for(; i<argc; ++i){
		strcat(args, argv[i]);
		strcat(args, " ");
	}
	args[0] = strlen(args+1);

	ret = load_program(exe_name, args);	/* Try to load it */

	if(ret == -1){				/* If fails add EXE */
		strcat(exe_name, ".EXE");	/* And try again */
		ret = load_program(exe_name, args);
	}

	if(ret != 0)
	{
		error(13, prog_name);
		exit(1);
	}

	sum1 = check_sum(load_address, length);

	fd = _creat("Before.cod", 0);
	big_write(fd, MK_FP(load_address, 0), d_seg*16L);
	_close(fd);

	ret = exec_program();

	sum2 = check_sum(load_address, length);

	fd = _creat("After.cod", 0);
	big_write(fd, MK_FP(load_address, 0), d_seg*16L);
	_close(fd);

	code_changed = sum1 != sum2;

	badFixups = CheckForFixUps(prog_name, seg_name);

	rxeAble = (code_changed == 0)  && (badFixups == 0);

	printf("\n\nThe Program '%s' can %sbe made into an RXE\n",
				prog_name, rxeAble ?  "" : "NOT ");


	if(code_changed)
	{
		do_diff("before.cod", "after.cod");
		printf("\t1) The code block has been modified during execution\n");
		printf("\t\t* See file CODE.DIF for a list of Code Block\n\t\t  modifications during execution!\n");
		if(FindString("CODE.DIF", "39CD	DD9B") != 0)
			printf("\t\t* Appears to have Emulated Floating Point!\n");
	}

	if(badFixups)
	{
		printf("\t2) The program has Invalid Code Block Fixups!\n");
			printf("\t\t* See file FIX-UP.BAD for a list of\n\t\t  invalid fixups in the Code Block!\n");
	}

	exit(0);
}




int load_program(char *program, char *cmd_line)
{
	exe_struct.env = 0;
	exe_struct.com_line = MK_FP(getDS(), cmd_line);

	regs.x.ax = 0x4B01;
	regs.x.bx = (unsigned) &exe_struct;
	regs.x.dx = (unsigned) program;

	intdos(&regs, &regs);			/* Load Program */
	if(CARRY_SET(regs.x.flags))
		return -1;

	regs.x.ax = 0x5100;
	intdos(&regs, &regs);				/* Get PSP */
	new_psp = regs.x.bx;
	load_address = new_psp + 0x10;

	psp = MK_FP(new_psp, 0);			/* Make psp point to */
	psp->term_addr = MK_FP(getCS(), ret_spawn);	/* Our term address */
	return 0;					/* All OK */
}


int exec_program(void)
{
	go_asm(exe_struct.IP, exe_struct.CS, exe_struct.SP, exe_struct.SS,
		new_psp);
	regs.x.ax = 0x4D00;		/* Get the return Code */
	intdos(&regs, &regs);
	return regs.x.ax;
}




unsigned char buffer1[10000];
unsigned char buffer2[10000];
FILE *fpDiff;
/*
 * do_diff reads the BEFORE.COD file and the AFTER.COD files and
 * displays the differences between the files.  These files are the
 * exact Code Block memory image before a program ran and after!
 */
void do_diff(char *file1, char *file2)
{
	unsigned val1, val2;
	int count1, count2, i;
	int f1, f2;
	long offset = 0L;
	f1 = _open(file1, O_RDONLY);
	f2 = _open(file2, O_RDONLY);
	if(f1 == NULL){
		printf("Cannot open '%s'\n", f1);
		return;
	}
	if(f2 == NULL){
		printf("Cannot open '%s'\n", f2);
		return;
	}

	// Open a file for Differences!
	fpDiff = fopen("CODE.DIF", "w");
	if(fpDiff == NULL)
	{
		error(20, "CODE.DIF");
		exit(20);
	}

	while(1){
		count1 = _read(f1, buffer1, sizeof(buffer1));
		count2 = _read(f2, buffer2, sizeof(buffer2));
		if(count1 < 1 || count2 < 1)
			break;
		assert(count1 == count2);
		for(i=0; i<count1; ++i){
			if(buffer1[i] != buffer2[i]){
				if(buffer1[i+1] != buffer2[i+1]){
					val1 = *((unsigned *) (buffer1+i));
					val2 = *((unsigned *) (buffer2+i));
					show_diff(offset, val1, val2, 2);
					++offset;
					++i;
				}
				else {
					show_diff(offset, buffer1[i], buffer2[i], 1);
				}
			}
			++offset;
		}
	}
	close(f1);
	close(f2);
	fclose(fpDiff);
}


/*
 * show_diff displays differences between either bytes or words
 * in the Code Block before and after a canadate RXE program ran.
 */
void show_diff(long offset, unsigned val1, unsigned val2, unsigned size)
{
	static count = 0;
	if(count == 0){
		fprintf(fpDiff, "Differences found during the execution of program '%s'\n\n", prog_name);
		fprintf(fpDiff, "Offset	Before	After\n");
		fprintf(fpDiff, "---------------------\n");
	}
	++count;
	if(size == 1)
		fprintf(fpDiff, "%05lX\t%02X\t%02X\n", offset, val1, val2);
	else
		fprintf(fpDiff, "%05lX\t%04X\t%04X\n", offset, val1, val2);
}

/*
 * This is a write function that can span more than 64K bytes!
 */
void big_write(int handle, void far *buffer, long size)
{
	long count = 0L;
	unsigned tmp;
	while(count < size){
		if(size - count > 0x8000)
			tmp = 0x8000;
		else
			tmp = (unsigned) (size - count);
/*
printf("Write %u bytes from %p\n", tmp, buffer);
*/
		_write(handle, buffer, tmp);
		buffer = MK_FP(FP_SEG(buffer) + 0x800, FP_OFF(buffer));
		count += tmp;
	}
}




#define RXENAME "RXE_CVT.EXE"
#define TMP_FILE_NAME  "RXE-TMP.TMP"

int CheckForFixUps(char *fileName, char *dataseg)
{
	int ret_val;
	char *options = "/L /Q /Efix-up.bad";

	ret_val = spawnlp(0, RXENAME, "", options, fileName, dataseg, "1000", TMP_FILE_NAME, NULL);

	return (ret_val);
}


/*
 * Find a String in a given file.
 */
int FindString(char *file, char *string)
{
	char line[132];
	int occurences=0, i;
	FILE *fp;

	fp = fopen(file, "r");
	if(fp != NULL)
	{
		while(!feof(fp))
		{
			fgets(line, sizeof(line), fp);
			for(i=0; i<10; ++i)
			{
				if(strncmp(string, line+i, strlen(string)) == 0)
				{
					++occurences;
					break;
				}
			}
		}
	}
	fclose(fp);
	return (occurences);
}

