//
//   $Id: RXE_DEMO.C 1.4 2002/10/16 15:53:20Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/**********************************************************
   RXE_DEMO.C

	Copyright (c) 1990-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

**********************************************************/
#include <stdio.h>
#include <ctype.h>
#include <dos.h>

int (*func)(char *, ...) = printf;

#define MK_FP(seg,ofs)	((void far *) \
			   (((unsigned long)(seg) << 16) | (unsigned)(ofs)))

extern unsigned _psp;
void memlist();

void main(argc, argv) int argc; char *argv[];
{
	int i;
	extern unsigned _psp;
	printf("\nRXE Demo Program \n\n");
	for(i=0; i<argc; ++i){
		printf("Arg[%d] = '%s'\n", i, argv[i]);
	}
	printf("\n");
	printf("The 80x86 CS = %04X DS = %04X\n\n",  getCS(), getDS());
	printf("The PSP starts at %04X\n\n", _psp);
	printf("The DOS memory list is:\n");
	memlist();
}


struct MCB {
	unsigned char sig;
	unsigned owner;
	unsigned size;
};

void memlist()
{
	unsigned para;
	struct MCB far *mcb;

	para = get_first_mcb();
	do {
		mcb = MK_FP(para, 0);
		printf("Seg %04X Sig '%c' Owner %04X  Size %04X",
			para, mcb->sig, mcb->owner, mcb->size);
		if(para == _psp - 1)
			printf(" <-- This is the RXE_DEMO Memory Block!");
		printf("\n");
		para += (mcb->size + 1);

	}while(mcb->sig != 'Z');
}

get_first_mcb()
{
	union REGS regs;
	struct SREGS sregs;
	unsigned far *p;
	regs.h.ah = 0x52;
	intdosx( &regs, &regs, &sregs );
	p = MK_FP(sregs.es, (regs.x.bx -2));
	return (*p);
}


getCS()
{
	int far *func;
	func = main;
	return (FP_SEG(func));
}

getDS()
{
	char far *string = "This is a string";
	return (FP_SEG(string));
}


