;
;   $Id: RXE_INIT.ASM 1.5 2002/10/16 15:54:28Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
; RXE_BASE is the RXE start up code.
;
; Copyright (c) Datalight 1990-2002
; All Rights Reserved.
; Datalight Confidential and Propriority
;
; Version 6.00-H
; History
;   10/26/200 DE  Commented out seg override code in the RXE base interrupt
;		handler code.  We just can't trust it to not act wrongly
;		on spurious data at the end of the previous instruction.
;		Added "SUPPORT_SEG_OVERRIDES = FALSE" just in case we want
;		to fix or test the segment override code someday. Also
;		clarified/corrected some comments.
;   04/23/96 RLS
;	Changed RXE_base "cs_seg" to "cd_cs"  and "start_ofs" to cd_seg
;	Did not add any new variables!  This was caused by assuming
;	that the first segment of the CodeBlock was the same as the
;	starting segment of the CodeBlock! (MSC 8 Large Model uses this
;	model)
;   10/15/94 RLS
;	Modified rxe_int to handle segment overrides!
;   05/10/94 RLS
;	Changed RXE_INIT from version 2.05 to 6.00
;
FALSE	=	0
TRUE	=	NOT FALSE

; 10/26/2000  DE
; There is no way to currently know if what we think is a segment override
; is really just data at the end of the previous instruction.  If we are
; wrong in our assumption then the results could be catastrophic.  Until
; we can determine instruction alignment then don't support segment
; overrides.  RXE_BLK has been changed to warn the user of their possible
; existence in front of presumably supported fixup code.
;
SUPPORT_SEG_OVERRIDES	=	FALSE

RXE_INTERRUPT	equ	018H
VERVAL		equ	002H
DEBUG		equ	0	; 0 for non-DEBUGGING and 1 for Debugging

RXE_INTRO segment PARA PUBLIC 'RXE'

	assume CS: RXE_INTRO
	public rxe_start, rxe_fixup_table

;	long rxe_sig;		/* RXE Sig is "XIP" */
;	unsigned rxe_ver;	/* Version of RXE_CVT  that built it */
;	unsigned start_ofs;	/* IP value for RXE_BASE */
;	unsigned short ld_seg;  /* Segment of start of RXE in memory */
;	unsigned short int_no;	/* Interrupt used for RXE support */
;	unsigned short cd_seg;  /* Segment of start code of RXE in memory */
;	unsigned short cd_ip;	/* Offset of start code of RXE in memory */
;	unsigned short cd_len;  /* Length in paragraphs of RXE code block */
;	unsigned short cd_sum;  /* Check sum of RXE code */
;	unsigned short rxe_base_len;  /* Length in paras of RXE_Base */

rxe_sig:	db	'X', 'I', 'P', 0
rxe_ver:	dw	VERVAL
cd_seg:	dw	rxe_start
ld_seg:		dw	0
int_no:		dw	RXE_INTERRUPT
cd_cs:		dw	0
cd_ip:		dw	0
cd_len:		dw	0
cd_sum:		dw	0
rxe_base_len:	dw	0
rxe_fixup_table DW	16 DUP (?)

rxe_start:
	push	ax
	push	bx
	push	ds
	push	es

	push	CS
	pop	DS

if DEBUG
	jmp	NoChkSum	; Skip Check Sum so you can put
endif
				; Break Points in RXE Code in RAM
;
;	chksum(unsigned far fp, unsigned paras)
;
;	ES:DI =
;
chksum:
	mov	AX, 0			; Init sum = 0
	mov	BX, word ptr cd_len 	; BX = number of paras to chksum
	MOV	DX, word ptr cd_seg
	MOV	ES, DX

again: 					; do {
	mov	DI, 0
	mov	CX, 800H
	cmp	CX, BX			;	if(paras_left > 0x800)
	jle	a1
	mov	CX, BX			;
a1:
	push	CX			; Save it for later
	shl	CX,1
	shl	CX,1
	shl	CX,1
	shl	CX,1
a2:

	CALL	short_sum

	POP	CX			; Get # of segs chksumed
	MOV	DX, ES
	ADD	DX, CX
	MOV	ES, DX

	sub	BX, CX
					; While(paras < total_paras);
	jnz	again

	cmp	AX, word ptr cd_sum
	jnz	rxe_err

NoChkSum:

	mov	AL, byte ptr CS:int_no
	mov	AH, 035H
	int	21H
	mov	CS:word ptr old_rxe_int_0+2, ES
	mov	CS:word ptr old_rxe_int_0, BX

	mov	DX, offset rxe_int_0
	push	CS
	pop	DS
	mov	AL, byte ptr CS:int_no
	mov	AH, 25H
	int	21H			; Set RXE interrupt 0 vector

	mov	AL, byte ptr CS:int_no
	inc	al
	mov	AH, 035H
	int	21H
	mov	CS:word ptr old_rxe_int_1+2, ES
	mov	CS:word ptr old_rxe_int_1, BX

	mov	DX, offset rxe_int_1
	push	CS
	pop	DS
	mov	AL, byte ptr CS:int_no
	inc	al
	mov	AH, 25H
	int	21H			; Set RXE interrupt 0 vector

	pop	es
	pop	ds
	pop	bx
	pop	ax


	push	word ptr CS:cd_cs
	push	word ptr CS:cd_ip
	retf				; Goto to program _astart



;
; rxe_err is the routine that is called if any errors occur during RXE
; initlazition.  Terminate the program with an Exit Code of 255.
;
rxe_err:
	mov	AX, 0900H
	mov	DX, offset chk_sum_err
	int	21H

	mov	AX, 4CFFh
	int	21H

chk_sum_err: db	'Fatal Error: RXE code not in memory!', 0DH, 0AH, '$'

;
; short_sum(unsigned far fp, unsigned count)
;
;
short_sum:
	add	AX, ES:[DI]
	add	di, 2
	cmp	di, cx
	jnz	short_sum
	ret


SegOverRide: 	db	0	; Byte before instruction May be Seg Override
SS_OverRide	equ	36H	; SS Segment Over Ride Byte Value
ES_OverRide	equ	26H	; ES Segment Over Ride Byte Value

;*****************************************************************
;
;	RXE_INT handles loads the reference to a DATA segment into
;	the correct register. The segment value is calculated by
;	adding the program load address and segment value placed
;	in the RXE_segment_table.
;
;	This interrupt is placed in the program by either the
;	ROMDISK.EXE program or by the RXE standalone program.  It
;	is placed in the program where an attempt is made to load
;	a general purpose register with a relocatable segment
;	value:
;       *
;		MOV	AX, DGROUP
;
;	The execution of this interrupt will perform that
;	operation.  The byte following the interrupt is
;	interpreted by this interrupt handler to know the value
;	of the segment register and the general purpose register
;	to place the value into.  That byte is defined as:
;
;		+--------------------------+
;		|  7  6  5  4  3  2  1  0  |
;		+--------------------------+
;		 \       /  \           /
;		  ------     ----------
;		     |
;		   Register	Segment
;		   Number	Table
;				Index
;
;  The register number in B5-B7 of the above byte is the index into
;  the register file created on entry to the RXE base interrupt handler.
;  The enumeration of those registers is {AX=0,BX,CX,DX,SI,DI,BP}
;  If the upper three bits of the ID byte is 111b then it means that
;  The operation is not a direct register move and the modr/m byte
;  must be consulted to determine the move operation we must perform.
;
;*****************************************************************

BX_DISP	equ	4	; Was 6
BP_DISP	equ	14	; Was 2
SI_DISP	equ	10	; Was 12
DI_DISP	equ	12	; Was 14
DS_DISP	equ	16
ES_DISP	equ	00

	public rxe_int_0, rxe_int_1

rxe_int_0:
	push	DS
	push	BP		; Change is push order for 2.05
	push	DI
	push	SI
	push	DX
	push	CX
	push	BX
	push	AX
	push	ES
	push	CS
	pop	DS
	mov	BP,SP

	mov	ES, [BP+20]		; Get CS
	mov	SI, [BP+18]		; Get IP
	mov	DL, Byte Ptr ES:[SI-3]
	mov	Byte Ptr CS:SegOverRide, DL
	mov	DL, ES:[SI]		; Get fixup Byte
	inc	SI
	mov	[BP+18], SI		; Move IP past fixup byte

	mov	CL, DL
	and	DL, 01FH
	xor	DH, DH
	add	DX, DX			; DX = Table index

	; Make CL = register number:
	; AX=0, BX=1, CX=2, DX=3, SI=4, DI=5, BP=6
	;
	; A register number of 7 means the segment value is not going into a
	; register location but into a memory location and the modr/m byte
	; must be used to further decode the memory move operation.
	;
	; NOTE:	The code sequence "mov sp, SEG END_STACK_SEG" is not supported
	;
	shr	CL,1
	shr	CL,1
	shr	CL,1
	shr	CL,1
	shr	CL,1

	add	CL,CL
	xor	CH,CH

	mov	BX, DX
	add	BX, offset rxe_fixup_table
	mov	AX, [BX] 		; Add RXE Seg table Entry

	cmp	CX, 14 			; If REG != 7 Then
	jz	load_reg

	mov	SI,CX 		; Store value in the reg's Place on Stack
	mov	[BP+SI+2], AX	; Changed for push order (was [BP+SI+4])
	jmp	Do_Ret

load_reg:				; Else
	MOV	BX,0
	MOV	DL,ES:[SI] 		; Get Mode Byte
	MOV	DI,DX
	INC	SI

	RCL	DL,1
	JNC 	L3			; If Mode & 0x80
	MOV	BX,Word ptr ES:[SI]	; Get 2 Disp bytes
	INC	SI
	INC	SI
	RCR	DL,1
	JMP	L4

L3:
	RCL	DL,1
	JNC	L3A			; If Mode & 0x40
	MOV	BL,Byte ptr ES:[SI]	; Get 1 Disp Bytes
	PUSH	AX
	MOV	AL,BL
	CBW				; Sign Extend it
	MOV	BX,AX
	POP	AX
	INC	SI
L3A:
	RCR	DL,1
	RCR	DL,1
L4:
	MOV	[BP+18], SI		; Move IP past Disp Bytes

IF SUPPORT_SEG_OVERRIDES
	; 10/26/2000 DE
	; $ToDo: If we ever do figure out how to guarantee instruction
	; 	alignment (possibly using debug line number info in a .MAP
	;	file) then we need to fix the way we handle seg overrides
	;	which is currently horribly broken as follows:
	;	1) Neither the CS or DS overrides are supported
	;	2) The SS override actually uses ES now
	;	3) Any indirection involving the BP reg assumes SS but
	;	   any override may apply to those instructions as well.
	;
CheckForSegmentOverrides:
	CMP	Byte Ptr CS:SegOverRide, ES_OverRide
	JNZ	L4A			; If ES OverRide
	PUSH	[BP + ES_DISP]		; Set ES to Prog ES Value
	JMP	L4C

L4A:	CMP	Byte Ptr CS:SegOverRide, SS_OverRide
	JNZ	L4B			; Else If SS OverRide
	PUSH	[BP + ES_DISP]		; Set ES to Prog ES Value
	JMP	L4C
ENDIF	; SUPPORT_SEG_OVERRIDES

L4B:	PUSH	[BP + DS_DISP]		; Else
L4C:	POP	DS			; Set DS to Prog DS Value

 	AND	DL, 07H			; switch(mode & 0x7){
	CMP	DL, 0
	JNZ	L5			; case 0 [BX + SI]
	ADD	BX, [BP+BX_DISP]
	ADD	BX, [BP+SI_DISP]
	JMP	Done

L5:	CMP	DL, 1
	JNZ	L6	 	 	; case 1 [BX + DI]
	ADD	BX, [BP+BX_DISP]
	ADD	BX, [BP+DI_DISP]
	JMP	Done

L6:	CMP	DL, 2
	JNZ	L7	 		; case 2 [BP + SI]
	ADD	BX, [BP+BP_DISP]
	ADD	BX, [BP+SI_DISP]
	PUSH	SS
	POP	DS			; Set DS to Prog SS Value
	JMP	Done

L7:	CMP	DL, 3
	JNZ	L8	 	 	; case 3 [BP + DI]
	ADD	BX, [BP+BP_DISP]
	ADD	BX, [BP+DI_DISP]

	PUSH	SS
	POP	DS			; Set DS to Prog SS Value
	JMP	Done

L8:	CMP	DL, 4
	JNZ	L9	 	 	; case 4 [SI]
	ADD	BX, [BP+SI_DISP]
	JMP	Done

L9:	CMP	DL, 5
	JNZ	L10	 	 	; case 5 [DI]
	ADD	BX, [BP+DI_DISP]
	JMP	Done

L10:	CMP	DL, 6
	JNZ	L11	 	 	; case 6
	AND	DI, 0C0H
	CMP	DI, 0		 	; [Disp]
	JNZ	L10A
	MOV	BX, Word Ptr ES:[SI]
	JMP	Done
L10A:	ADD	BX, [BP+BP_DISP] 	; [BP+Disp]
	PUSH	SS
	POP	DS			; Set DS to Prog SS Value
	JMP	Done

L11:	CMP	DL, 7
	JNZ	Done	 	 	; case 7 [BX]
	ADD	BX, [BP+BX_DISP]
	JMP	Done
				; 	}
Done:
	MOV	[BX], AX
Do_Ret:
	pop	ES
	pop	AX
	pop	BX
	pop	CX
	pop	DX
	pop	SI
	pop	DI
	pop	BP		; Change in Pop Order for 2.05
	pop	DS
	iret

old_rxe_int_0:	dw 0, 0		; Save original RXE Interrupt #0


; This is the RXE interrupt handler specifically for the instruction
;
; 	push	imm16	 <==>	push	SEG something
;
; where "imm16" is identified as a fixup in the .EXE's relocation table.
;
; RXE_CVT changes the bytes: "68 00 00" to "CD xx yy" where "xx"
; is the RXE base interrupt number + 1 and "yy" is the RXE info
; byte that holds the segment number (an index into a table of
; segment fixup values). When this interrupt handler is called
; the callers FLAGS and return CS:IP are on the stack and the
; return CS:IP points to the RXE info byte (the "yy" byte). When
; this routine returns, execution continues with the the byte
; following the RXE info byte, the segment fixup value is left on
; the top of the stack, and all register values except IP and SP
; are restored.
;
rxe_int_1:
	push	bp    		; establish a stack frame
	mov	bp, sp
	push	bx		; save regs and
	push	es
	push	[bp+6]		; state of caller's flags before the int

	; The RXE info byte that specifies the SEG number exists at
	; the caller's return CS:IP, get that byte value and then skip
	; over it
	;
	les	bx, [bp+2]
	mov	bl, es:[bx]
	inc	word ptr [bp+2]

	; convert the byte value into a word offset then
	; use it to index into a table of segment fixup values
	;
	and	bx, 01Fh
	shl	bx, 1
	mov	bx, cs:rxe_fixup_table[bx]

	mov	word ptr [bp+6], bx	; over-write caller's flags with fixup

	popf			; restore callers flags
	pop	es		; and registers
	pop	bx
	pop	bp
	retf			; return to code byte following RXE info byte

old_rxe_int_1:	dw 0, 0		; Save original RXE Interrupt #1

rxe_end:

RXE_INTRO Ends

	END	rxe_start


