;
;   $Id: TEST.ASM 1.5 2002/10/16 15:54:28Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
; Copyright (c) 1989-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; Revision History
;
; 1.04	12-21-94
;		Added Test for the situation where there is a C7 four bytes
;		before the Fixup Value;  This was a bug in RXE_CVT 6.0-L!
;
; 1.03	11-1-94
;		Added Tests for the MOV SI, VALUE => C7 FE Value type
;		instructions
; 1.02	10-14-94
;		Added tests for "mov Word Ptr es:[bx+10], seg Data
;		Added tests for "mov Word Ptr ss:[bx+10], seg Data
;
; 1.01	9-18-91
;		Added "CALL DWORD PTR FAR_PRINT" so there was at least
;		one Code Block fixup in the Data Block
; 1.00	9-16-91 Initial release
;		This release has a test case for each MOV AX,DGROUP and
;		MOV	[BP-1AH], DGROUP type instruction


include ..\macros.inc

xVersion equ "1.04"

CBegCode
	ASSUME DS:DGROUP
Start:
	mov	AX, DGROUP
	mov	DS, AX
	mov	SS, AX
	mov	AX, Offset EndOfStack
	mov	SP,AX

	mov	DX, Offset Hello
	call 	dword ptr far_print

	mov	AX, Seg _BSS
	cmp	AX, GoodValue
	jz	L1
	mov	DX, Offset ErrorMsg1
	call	error

L1:	mov	BX, Seg _BSS
	cmp	BX, GoodValue
	jz	L2
	mov	DX, Offset ErrorMsg2
	call	error

L2:	mov	CX, Seg _BSS
	cmp	CX, GoodValue
	jz	L3
	mov	DX, Offset ErrorMsg3
	call	error

L3:	mov	DX, Seg _BSS
	cmp	DX, GoodValue
	jz	L4
	mov	DX, Offset ErrorMsg4
	call	error

L4:	mov	SI, Seg _BSS
	cmp	SI, GoodValue
	jz	L5
	mov	DX, Offset ErrorMsg5
	call	error

L5:	mov	DI, Seg _BSS
	cmp	DI, GoodValue
	jz	L5A
	mov	DX, Offset ErrorMsg6
	call	error

L5A:	mov	BP, Seg _BSS
	cmp	BP, GoodValue
	jz	L6
	mov	DX, Offset ErrorMsg6A
	call	error

L6:	mov	BX, offset val1
	mov	word ptr [BX], Seg _BSS
	mov	CX, val1
	cmp	CX, GoodValue
	jz	L7
	mov	DX, Offset ErrorMsg7
	call	error

L7:	mov	BX, offset xtable
	mov	word ptr [BX + 4], Seg _BSS
	mov	CX, word ptr xtable+4
	cmp	CX, GoodValue
	jz	L8
	mov	DX, Offset ErrorMsg8
	call	error

L8:	mov	BX, offset xtable
	mov	word ptr [BX + 300], Seg _BSS
	mov	CX, word ptr xtable+300
	cmp	CX, GoodValue
	jz	L9
	mov	DX, Offset ErrorMsg9
	call	error

L9:	mov	BX, offset xtable
	mov	SI, 8
	mov	word ptr [BX + SI], Seg _BSS
	mov	CX, word ptr xtable+8
	cmp	CX, GoodValue
	jz	L10
	mov	DX, Offset ErrorMsg10
	call	error

L10:	mov	BX, offset xtable
	mov	SI, 10
	mov	word ptr [BX + SI + 12], Seg _BSS
	mov	CX, word ptr xtable+10+12
	cmp	CX, GoodValue
	jz	L11
	mov	DX, Offset ErrorMsg11
	call	error

L11:	mov	BX, offset xtable
	mov	SI, 12
	mov	word ptr [BX + SI + 258], Seg _BSS
	mov	CX, word ptr xtable+12+258
	cmp	CX, GoodValue
	jz	L12
	mov	DX, Offset ErrorMsg12
	call	error

L12:	mov	BX, offset xtable
	mov	DI, 14
	mov	word ptr [BX + DI], Seg _BSS
	mov	CX, word ptr xtable+14
	cmp	CX, GoodValue
	jz	L13
	mov	DX, Offset ErrorMsg13
	call	error

L13:	mov	BX, offset xtable
	mov	DI, 16
	mov	word ptr [BX + DI + 12], Seg _BSS
	mov	CX, word ptr xtable+16+12
	cmp	CX, GoodValue
	jz	L14
	mov	DX, Offset ErrorMsg14
	call	error

L14:	mov	BX, offset xtable
	mov	DI, 18
	mov	word ptr [BX + DI + 258], Seg _BSS
	mov	CX, word ptr xtable+18+258
	cmp	CX, GoodValue
	jz	L15
	mov	DX, Offset ErrorMsg15
	call	error

L15:	mov	BP, offset xtable
	mov	SI, 20
	mov	word ptr [BP + SI], Seg _BSS
	mov	CX, word ptr xtable+20
	cmp	CX, GoodValue
	jz	L16
	mov	DX, Offset ErrorMsg16
	call	error

L16:	mov	BP, offset xtable
	mov	SI, 22
	mov	word ptr [BP + SI + 12], Seg _BSS
	mov	CX, word ptr xtable+22+12
	cmp	CX, GoodValue
	jz	L17
	mov	DX, Offset ErrorMsg17
	call	error

L17:	mov	BP, offset xtable
	mov	SI, 24
	mov	word ptr [BP + SI + 258], Seg _BSS
	mov	CX, word ptr xtable+24+258
	cmp	CX, GoodValue
	jz	L18
	mov	DX, Offset ErrorMsg18
	call	error

L18:	mov	BP, offset xtable
	mov	DI, 26
	mov	word ptr [BP + DI], Seg _BSS
	mov	CX, word ptr xtable+26
	cmp	CX, GoodValue
	jz	L19
	mov	DX, Offset ErrorMsg19
	call	error

L19:	mov	BP, offset xtable
	mov	DI, 28
	mov	word ptr [BP + DI + 12], Seg _BSS
	mov	CX, word ptr xtable+28+12
	cmp	CX, GoodValue
	jz	L20
	mov	DX, Offset ErrorMsg20
	call	error

L20:	mov	BP, offset xtable
	mov	DI, 30
	mov	word ptr [BP + DI + 258], Seg _BSS
	mov	CX, word ptr xtable+30+258
	cmp	CX, GoodValue
	jz	L21
	mov	DX, Offset ErrorMsg21
	call	error

					; SI, SI+disp, SI+disp-16
L21:	mov	SI, offset val2
	mov	word ptr [SI], Seg _BSS
	mov	CX, val2
	cmp	CX, GoodValue
	jz	L22
	mov	DX, Offset ErrorMsg22
	call	error

L22:	mov	SI, offset xtable
	mov	word ptr [SI + 4], Seg _BSS
	mov	CX, word ptr xtable+4
	cmp	CX, GoodValue
	jz	L23
	mov	DX, Offset ErrorMsg23
	call	error

L23:	mov	SI, offset xtable
	mov	word ptr [SI + 300], Seg _BSS
	mov	CX, word ptr xtable+300
	cmp	CX, GoodValue
	jz	L24
	mov	DX, Offset ErrorMsg24
	call	error


					; DI, DI+disp, DI+disp-16
L24:	mov	DI, offset val2
	mov	word ptr [DI], Seg _BSS
	mov	CX, val2
	cmp	CX, GoodValue
	jz	L25
	mov	DX, Offset ErrorMsg25
	call	error

L25:	mov	DI, offset xtable
	mov	word ptr [DI + 4], Seg _BSS
	mov	CX, word ptr xtable+4
	cmp	CX, GoodValue
	jz	L26
	mov	DX, Offset ErrorMsg26
	call	error

L26:	mov	DI, offset xtable
	mov	word ptr [DI + 300], Seg _BSS
	mov	CX, word ptr xtable+300
	cmp	CX, GoodValue
	jz	L27
	mov	DX, Offset ErrorMsg27
	call	error

					; [Direct_Address]
L27:	mov	[val5], Seg _BSS
	mov	CX, val5
	cmp	CX, GoodValue
	jz	L28
	mov	DX, Offset ErrorMsg28
	call	error

L28: 	mov	BP, offset xtable+400
	mov	word ptr [BP - 1AH], Seg _BSS
	mov	CX, GoodValue
	cmp	CX, xtable+400 - 1AH
	jz	L29
	mov	DX, Offset ErrorMsg29
	call	error

L29: 	mov	BP, offset xtable+400
	mov	word ptr [BP - 389], Seg _BSS
	mov	CX, GoodValue
	cmp	CX, xtable+400 - 389
	jz	L30
	mov	DX, Offset ErrorMsg30
	call	error

L30:
	mov	AX, DS
	mov	ES, AX
	push	DS
	add	AX, 100H
	mov	DS, AX
	mov	BX, offset xtable+500
	mov	Word Ptr ES:[BX+10], Seg _BSS
	pop	DS
	mov	CX, GoodValue
	cmp	CX, [BX+10]
	jz	L31
	mov	DX, Offset ErrorMsg31
	call	error

L31:
	mov	AX, DS
	mov	ES, AX
	push	DS
	push	ES
	add	AX, 100H
	mov	DS, AX
	mov	ES, AX
	mov	BX, offset xtable+500
	mov	Word Ptr SS:[BX+20], Seg _BSS
	pop	DS
	pop	ES
	mov	CX, GoodValue
	cmp	CX, [BX+10]
	jz	L32
	mov	DX, Offset ErrorMsg32
	call	error

L32:

	call	trash_regs
	db	0C7H, 0C0H	; EQU MOV AX, BSS  Note: See page 3-180 in 8088 book
	dw	Seg _BSS
	cmp	AX, GoodValue
	jz	L33
	mov	DX, Offset ErrorMsg33
	call	error

L33:

	call	trash_regs
	db	0C7H, 0C1H	; EQU MOV CX, BSS  Note: See page 3-180 in 8088 book
	dw	Seg _BSS
	cmp	CX, GoodValue
	jz	L34
	mov	DX, Offset ErrorMsg34
	call	error

L34:

	call	trash_regs
	db	0C7H, 0C2H	; EQU MOV DX, BSS  Note: See page 3-180 in 8088 book
	dw	Seg _BSS
	cmp	DX, GoodValue
	jz	L35
	mov	DX, Offset ErrorMsg35
	call	error

L35:

	call	trash_regs
	db	0C7H, 0C3H	; EQU MOV BX, BSS  Note: See page 3-180 in 8088 book
	dw	Seg _BSS
	cmp	BX, GoodValue
	jz	L36
	mov	BX, Offset ErrorMsg36
	call	error

L36:

	call	trash_regs
	db	0C7H, 0C5H	; EQU MOV BP, BSS  Note: See page 3-180 in 8088 book
	dw	Seg _BSS
	cmp	BP, GoodValue
	jz	L37
	mov	BP, Offset ErrorMsg37
	call	error

L37:

	call	trash_regs
	db	0C7H, 0C6H	; EQU MOV SI, BSS  Note: See page 3-180 in 8088 book
	dw	Seg _BSS
	cmp	SI, GoodValue
	jz	L38
	mov	DX, Offset ErrorMsg38
	call	error

L38:

	call	trash_regs
	db	0C7H, 0C7H	; EQU MOV DI, BSS  Note: See page 3-180 in 8088 book
	dw	Seg _BSS
	cmp	DI, GoodValue
	jz	L39
	mov	DX, Offset ErrorMsg39
	call	error

L39:

exit:
	mov	DX, offset Passed
	mov	AX, error_count
	cmp	AX, 0
	jz	E1
	mov	DX, offset Failed
E1:
	call	print
	mov	AX, 4C00H
	int	21H

error:	inc	error_count
	call	print
	ret

fprint:	call	print		; Far call test
	retf


trash_regs:
	mov	ax, 1
	mov	bx, 2
	mov	cx, 3
	mov	dx, 4
	mov	si, 5
	mov	di, 6
	mov	bp, 7
	ret;

print:	mov	AX, 0900H
	int	21H
	ret

	db 22 dup (?)



;
; Test Code for the Version 1.04 Change
;     13	000C  03 F8			     add     di,ax
;     14	000E  81 C7 0DB4		     add     di, 0db4H
;     15	0012  B8 0000s			     mov     ax, Seg Data
;     16

	add	di,ax
	add	di, 0db4H
	mov	ax, Seg _Data


CEndCode

Dummy Segment para public
Dummy Ends


CBegData

GoodValue	dw  	Seg _BSS
far_print	dd	fprint		; Code fixup in data area
error_count	dw	0

xtable		dw 800 dup (?)

val1		dw 0
val2		dw 0
val3		dw 0
val4		dw 0
val5		dw 0

Hello		db "RXE Test Routine Version ", xVERSION, 0DH, 0AH,  "...", 0Dh, 0AH, '$'
Passed		db "RXE Test Passed!!!", 0DH, 0AH, '$'
Failed		db "*   *   *  RXE Test Failed *   *   *", 0DH, 0AH, '$'
ErrorMsg1	db "Error: Mov AX,_BSS", 0DH, 0Ah, '$'
ErrorMsg2	db "Error: Mov BX,_BSS", 0DH, 0Ah, '$'
ErrorMsg3	db "Error: Mov CX,_BSS", 0DH, 0Ah, '$'
ErrorMsg4	db "Error: Mov DX,_BSS", 0DH, 0Ah, '$'
ErrorMsg5	db "Error: Mov SI,_BSS", 0DH, 0Ah, '$'
ErrorMsg6	db "Error: Mov DI,_BSS", 0DH, 0Ah, '$'
ErrorMsg6A	db "Error: Mov BP,_BSS", 0DH, 0Ah, '$'
ErrorMsg7	db "Error: Mov [BX],_BSS", 0DH, 0Ah, '$'
ErrorMsg8	db "Error: Mov [BX+4],_BSS", 0DH, 0Ah, '$'
ErrorMsg9	db "Error: Mov [BX+300],_BSS", 0DH, 0Ah, '$'
ErrorMsg10	db "Error: Mov [BX+SI],_BSS", 0DH, 0Ah, '$'
ErrorMsg11	db "Error: Mov [BX+SI+12],_BSS", 0DH, 0Ah, '$'
ErrorMsg12	db "Error: Mov [BX+SI+258],_BSS", 0DH, 0Ah, '$'
ErrorMsg13	db "Error: Mov [BX+DI],_BSS", 0DH, 0Ah, '$'
ErrorMsg14	db "Error: Mov [BX+DI+12],_BSS", 0DH, 0Ah, '$'
ErrorMsg15	db "Error: Mov [BX+DI+258],_BSS", 0DH, 0Ah, '$'
ErrorMsg16	db "Error: Mov [BP+SI],_BSS", 0DH, 0Ah, '$'
ErrorMsg17	db "Error: Mov [BP+SI+12],_BSS", 0DH, 0Ah, '$'
ErrorMsg18	db "Error: Mov [BP+SI+258],_BSS", 0DH, 0Ah, '$'
ErrorMsg19	db "Error: Mov [BP+DI],_BSS", 0DH, 0Ah, '$'
ErrorMsg20	db "Error: Mov [BP+DI+12],_BSS", 0DH, 0Ah, '$'
ErrorMsg21	db "Error: Mov [BP+DI+258],_BSS", 0DH, 0Ah, '$'
ErrorMsg22	db "Error: Mov [SI],_BSS", 0DH, 0Ah, '$'
ErrorMsg23	db "Error: Mov [SI+4],_BSS", 0DH, 0Ah, '$'
ErrorMsg24	db "Error: Mov [SI+300],_BSS", 0DH, 0Ah, '$'
ErrorMsg25	db "Error: Mov [DI],_BSS", 0DH, 0Ah, '$'
ErrorMsg26	db "Error: Mov [DI+4],_BSS", 0DH, 0Ah, '$'
ErrorMsg27	db "Error: Mov [DI+300],_BSS", 0DH, 0Ah, '$'
ErrorMsg28	db "Error: Mov [val5],_BSS", 0DH, 0Ah, '$'
ErrorMsg29	db "Error: Mov [BP-1AH], _BSS", 0DH, 0Ah, '$'
ErrorMsg30	db "Error: Mov [BP-389], _BSS", 0DH, 0Ah, '$'
ErrorMsg31	db "Error: Mov Word Ptr ES:[BX + 10], _BSS", 0DH, 0Ah, '$'
ErrorMsg32	db "Error: Mov Word Ptr SS:[BX + 20], _BSS", 0DH, 0Ah, '$'
ErrorMsg33	db "Error: (C7) Mov AX, _BSS", 0DH, 0Ah, '$'
ErrorMsg34	db "Error: (C7) Mov CX, _BSS", 0DH, 0Ah, '$'
ErrorMsg35	db "Error: (C7) Mov DX, _BSS", 0DH, 0Ah, '$'
ErrorMsg36	db "Error: (C7) Mov BX, _BSS", 0DH, 0Ah, '$'
ErrorMsg37	db "Error: (C7) Mov BP, _BSS", 0DH, 0Ah, '$'
ErrorMsg38	db "Error: (C7) Mov SI, _BSS", 0DH, 0Ah, '$'
ErrorMsg39	db "Error: (C7) Mov DI, _BSS", 0DH, 0Ah, '$'

CEndData

CBegUData


CEndUData

_Stack segment  para Stack "STACK"
	dw 800 dup (?)
EndOfStack equ	$
_Stack Ends

	ENd Start

