;
;   $Id: ABSDISK.ASM 1.4 2002/10/16 15:55:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;----------------------------------------------------------------------
;  ABSDISK.ASM   created 02/15/89  by Drew Gislason
;
;  Copyright (c) 1989-2002 Datalight, Inc.
;  Datalight Proprietary and Confidential.
;  All Rights Reserved.
;
;  This source was derived from RAMDISK
;
;  DEVICE=ABSDISK.SYS 200      ; will create a 200K ramdisk
;
;  01/15/90      Allow data to start at ABS segment address
;

.MODEL SMALL
.CODE

SRAM	EQU	1H	; If disk exists, don't reinitialize it
ABS_ON	EQU	1H	; If disk should start at absolute segment

ENTRIES	EQU	30H	; 10H entries/sector (3 sectors worth here)
BEGDISK	EQU	30H	; RAM disk starts 30H paragraphs after CS:0
ABS_SEG EQU	1000H	; RAMDISK will start at ABS_SEG:0
HEADER	EQU	0C00H/16; Size of beginning of  DISK (Boot Sec, fat, Root DIR )

	public boot,ram_serve,ram_init,ram_read,ram_write

	ASSUME	DS:NOTHING

;----------------------------------------------------------------------
;
;	DEVICE HEADER
;
	public ramx
ramx:
	dw	-1,-1
	dw	0		; IBM format-compatible block
	dw	ram_strat	; strategy routine
	dw	ram_serve	; service routine
maxdrv	db	1,0		; 1 drive


IF SRAM
vol_id	db	"ABSDISK 1.1"	; 11 character name (vol ID)
ELSE
vol_id	db	"RAMDISK 1.1"	; 11 character name (vol ID)
ENDIF

disk_start	dw	BEGDISK

boot	LABEL	WORD
	db	0EBH,24H,90H	; 00H	JMP SHORT 34H, NOP
	db	"RAMDISK "	; 03H	name
bpb	LABEL	WORD
	dw	512		; 0BH	bytes per sector
	db	2		; 0DH	sectors/cluster
	dw	1		; 0EH	reserved sectors
	db	1		; 10H	# of fats
	dw	ENTRIES		; 11H	directory entries (5 sectors worth)
sectors	LABEL	WORD
	dw	64		; 13H	total sectors
	db	0F8H		; 15H	media descriptor
	dw	2		; 16H	sectors per fat
	dw	0F000H		; 18H	sectors/track
	dw	1		; 1AH	number of heads
	dw	0		; 1CH	reserved for disk partitioning


bpb_array	LABEL	WORD
	dw	offset bpb	; pointer to the bpb

drvtbl	LABEL	WORD
	dw	ram_init	; init
	dw	media_chk	; media check
	dw	ram_bpb		; build a bpb (has none)
	dw	exit		; ioctl input (has none)
	dw	ram_read	; device read
	dw	exit		; non-destructive read (has none)
	dw	exit		; input status (has none)
	dw	exit		; input flush (has none)
	dw	ram_write	; write
	dw	ram_write	; write w/ verify

;----------------------------------------------------------------------
;
;	STRATEGY
;
ptrsav	dd	?
strat	proc	far
ram_strat:
	mov	word ptr [ptrsav],bx
	mov	word ptr [ptrsav+2],es
	ret
strat	endp

;----------------------------------------------------------------------
;
;	SERVICE ROUTINE (MAIN ENTRY)
;
; Request Header Macros
CMDLEN	=	0	; length of this command
UNIT	=	1	; sub unit specifier
CMDC	=	2	; command code
STATUS	=	3	; status
MEDIA	=	13	; media descriptor
TRANS	=	14	; transfer address
COUNT	=	18	; count of blocks
START	=	20	; first block to transfer


ram_serve:
	pushf
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es

	lds	bx,cs:[ptrsav]		; get pointer to i/o packet

	mov	cx,word ptr [bx].count	; cx = count
	mov	dx,word ptr [bx].start	; dx = start sector
	mov	al,byte ptr [bx].cmdc	; command code
	cmp	al,10
	jae	cmderr			; bad command
	cbw
	shl	ax,1			; get index into cmd table
	mov	si,offset drvtbl
	add	si,ax

	les	di,dword ptr [bx].trans	; ES:DI = transfer buffer

;	DS:BX	= i/o packet
;	CX	= count
;	DX	= start sector
;	ES:DI	= transfer area

	jmp	word ptr cs:[si]	; do the command

;----------------------------------------------------------------------
;
;		EXIT - ALL ROUTINE RETURN THROUGH HERE
;
cmderr:
	mov	al,3		; unknown cmd error
err_exit:
	mov	ah,81H		; mark error return
	jmp	short err1

exitp	PROC	FAR
exit:	mov	ah,01H
err1:	lds	bx,cs:[ptrsav]
	mov	word ptr [bx].status,ax		; mark as complete

	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	popf
	ret
exitp	ENDP

;----------------------------------------------------------------------
;
;	INIT THE DISK
;
;	*  check for a valid disk ... if not
;	*  read the command line for disk size (default in 32K)
;	*  set the packet information (describe disk to DOS)
;	*  set up an empty disk
;
;	DS:BX	= i/o packet
;
;	Returns:
;	+-------------------------+
;	| 13-Byte header          |
;	+-------------------------+
; 0D	| BYTE   Number of units  |
;	+-------------------------+
; 0E	| DWORD  End Address      |
;	+-------------------------+
; 12	| DWORD  Ptr to BPB array |
;	+-------------------------+
; 16	| BYTE   Block Device #   |
;	+-------------------------+
;
ram_init:

;	[]--------------------------------------[]
;	 |	Check for Existing RAM Disk	|
;	[]--------------------------------------[]
;
	int	3
IF ABS_ON
	PUSH	AX
	PUSH	BX
	MOV	AX,ABS_SEG
	MOV	BX,CS
	SUB	AX,BX
	JC	abs_fail
	SUB	AX, HEADER
	JC	abs_fail
	MOV	CS:disk_start,AX
	POP	BX
	POP	AX
	jmp	abs_ok
abs_fail:
	push	ds
	mov	ax, cs
	mov	ds, ax
	mov	dx, offset abs_err
	mov	ah, 9
	int	21H
	pop	ds
	pop	AX
	pop	BX
	jmp	err_exit;
abs_ok:
ENDIF
IF SRAM
	; check if boot sector looks correct
	PUSH	DS
	MOV	AX,CS
	MOV	DS,AX
	ADD	AX,disk_start
	MOV	ES,AX		; ES:0 = start of disk
	MOV	SI,OFFSET CS:boot
	XOR	DI,DI
	MOV	CX,13H		; 13H bytes should be the same
	CLD
	REPZ	CMPSB

	POP	DS
	CMP	CL,0
	JNZ	cmdline

	; get the number of sectors
sram_size:
	MOV	AX,ES:[DI]	; total sectors
	MOV	sectors,AX
	JMP	build_pac
ENDIF


;	[]----------------------------------------------[]
;	 |	Read Command Line for Disk Size		|
;	[]----------------------------------------------[]
;
cmdline:
	les	di,dword ptr [bx].count		; ES:DI = cmdline
	cld
try_again:
	mov	al,es:[di]
	cmp	al,'0'
	jb	notfound
	cmp	al,'9'		; find the first digit
	jbe	found
notfound:
	inc	di
	cmp	al,10		; LF - end of cmdline
	jne	try_again
	mov	cx,32		; 32K default
	jmp	short got_size

found:			; we've found a digit!
	xor	cx,cx
next_digit:
	mov	dl,es:[di]
	sub	dl,'0'
	cmp	dl,9
	ja	got_size
	mov	dh,0
	push	dx
	mov	ax,10	; multiply by 10
	mul	cx
	pop	dx
	add	ax,dx
	mov	cx,ax
	inc	di
	jmp	next_digit

got_size:
	cmp	cx,8			; make sure size>=8K
	jnb	size_ok
	mov	cx,8
size_ok:
	cmp	cx,600			; make sure size<=600K
	jbe	size_good
	mov	cx,600
size_good:
	SHL	CX,1
	MOV	CS:[sectors],CX		; total sectors


;	[]--------------------------------------[]
;	 |	Initialize a New Ram Disk	|
;	[]--------------------------------------[]
;
	; zero boot, fat and directory sectors
	mov	ax,cs
	add	ax,disk_start	; disk starts 200H bytes after driver
	mov	es,ax		; ES= start seg of RAMDISK
	xor	di,di		; DI= 0 = index for storing
	xor	al,al		; AL= 0 = value to store
	mov	cx,7*200H	; 7 sectors of boot, fat and dir
	cld
	rep	stosb

	; initialize fat
	mov	word ptr es:[200H],0FFFDH
	mov	byte ptr es:[202H],0FFH

	; initialize directory
	push	ds
	mov	si,offset vol_id
	mov	ax,cs
	mov	ds,ax			; DS:SI = "RAMDISK 1.1"
	mov	di,3*200H		; ES:DI = first dir entry
	mov	cx,11
	rep	movsb			; store the name
	mov	byte ptr es:[di],08H	; Volume Label attribute

	; initialize boot sector
	mov	si,offset boot	; DS:SI = boot record in device
	xor	di,di		; ES:DI = boot sector
	mov	cx,30		; 30 bytes
	cld
	rep	movsb
	pop	ds

;	[]--------------------------------------[]
;	 |	Return Init Info to DOS		|
;	[]--------------------------------------[]
;
	; build a request packet response - tell DOS
build_pac:
	mov	byte ptr [bx].media,1	; 1 and only 1 RAMDISK
	mov	word ptr [bx].count,offset bpb_array
	mov	word ptr [bx].count+2,cs

	; calculate end segment
	mov	ax,cs:[sectors]		; # of 200H byte sectors
	inc	ax
	mov	cl,5
	shl	ax,cl			; get total paragraphs
	mov	cx,cs
	add	ax,cx
	add	ax,disk_start		; end segment (AX:0 = end address)
	mov	word ptr [bx].trans+2,ax
	mov	word ptr [bx].trans,0	; end offset is always 0


;	[]------------------------------[]
;	 |	Print Sign-on Message	|
;	[]------------------------------[]
;
	mov	si,offset message
next:	mov	al,cs:[si]
	cmp	al,0
	jz	start2
	mov	ah,0EH		; use the BIOS TTY call to print chars
	mov	bh,0
	int	10H
	inc	si
	jmp	next
message db	"Installing ABSDISK.SYS v1.1",13,10,0
start2:
	jmp	exit

;----------------------------------------------------------------------
;
;	MEDIA CHECK (disk never changes)
;
media_chk:
	mov	byte ptr [bx].trans,1	; RAMDISK is never changed
	jmp	exit

;----------------------------------------------------------------------
;
;	BUILD BPB
;
ram_bpb:
	mov	word ptr [bx].count,offset bpb
	mov	word ptr [bx].count+2,cs
	jmp	exit

;----------------------------------------------------------------------
;
;	READ FROM DISK
;
;	DS:DX	= i/o packet
;	CX	= count
;	DX	= start
;	ES:DI	= buffer
;
ram_read:
	mov	ax,cx		; get # of sectors to read
	mov	cl,9		; multiply by 200H
	shl	ax,cl		; AX = # of bytes to transfer

	mov	si,dx		; starting sector #
	mov	cl,5		; multiply by 20H (# of paras)
	shl	si,cl		; starting paragraph
	mov	dx,cs
	add	si,dx		; add in CS
	add	si,disk_start	; add in start of DISK
	mov	ds,si		; RAMDISK sector
	xor	si,si		; 0 offset

	mov	cx,ax		; put byte count in CX

;	ES:DI	- destination buffer
;	DS:SI	- RAMDISK sector
;	CX	- count in bytes

	cld
	rep	movsb
	jmp	exit

;----------------------------------------------------------------------
;
;	WRITE TO DISK
;
;	DS:DX	= i/o packet
;	CX	= count
;	DX	= start
;	ES:DI	= buffer
;
ram_write:
IF 0
	CMP	DX,CS:[sectors]	; check for write past end of disk
	JB	W1
	MOV	WORD PTR [BX].COUNT,0
	MOV	AL,8
	JMP	err_exit

W1:	MOV	AX,DX
	ADD	AX,CX
	CMP	AX,CS:[sectors]
	JBE	W2
	SUB	AX,CS:[sectors]
	SUB	CX,AX
ENDIF

W2:	MOV	AX,CX		; get # of sectors to write
	MOV	CL,9		; multiply by 200H
	SHL	AX,CL		; # of bytes to transfer

	MOV	SI,DX		; starting sector #
	MOV	CL,5		; multiply by 20H (# of paras)
	SHL	SI,CL		; starting paragraph
	MOV	DX,CS
	ADD	SI,DX		; add in CS (SI = RAMDISK sector)
	ADD	SI,disk_start	; add in start of disk

	MOV	CX,AX		; count in bytes

	MOV	AX,ES		; save seg of transfer buffer
	MOV	ES,SI		; ES = RAMDISK sector (segment)
	MOV	DS,AX		; DS = buffer (segment)
	MOV	SI,DI		; SI = buffer (offset)
	XOR	DI,DI		; RAMDISK sector (offset=0)

;	ES:DI	- RAMDISK sector
;	DS:SI	- transfer buffer
;	CX	- count in bytes

	CLD
	REP	MOVSB
	JMP	exit

abs_err:db 'RAMDISK loading error, absolute segment too low!', 13, 10, '$', 0

cmdln_init:	int 20

	END cmdln_init
