//
//   $Id: SETARGV.C 1.2 2002/10/16 16:01:26Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
#include <stdio.h>
#include <string.h>
#include <dos.h>

#ifdef __TURBOC__
/*
 * Setargs
 *
 * Setargv is called before main to segup the argc, argv parameters.
 *
 */


#define BLANK		0
#define IN_ARG		1
#define IN_S_STRING	2
#define IN_D_STRING	3

extern char **_argv;
extern int _argc;
static int state;

void *malloc(unsigned);
extern unsigned _psp;
static void save_arg(char *arg)
{
	_argv[_argc] = malloc(strlen(arg) + 1);
	strcpy(_argv[_argc++], arg);
	state = BLANK;
}


void far _setargv(void)
{
	char far *args, count, local_arg[128];
	int i, local_arg_count=0;
	args = MK_FP(_psp, 0x80);
	count = *args++;

	_argv = malloc(sizeof(char *) * 32);
	_argv[0] = "Program.EXE";

	_argc = 1;				/* 1 for program name */

	for(i=0; i<count; ++i){
		switch(args[i]){
			case ' ':
				if(state == IN_ARG){
					local_arg[local_arg_count] = '\0';
					save_arg(local_arg);
					local_arg_count = 0;
				}
				else if(state != BLANK){
					local_arg[local_arg_count++] = args[i];
				}
				break;
				
			case '\'':
				if(state == IN_S_STRING){
					local_arg[local_arg_count] = '\0';
					save_arg(local_arg);
					local_arg_count = 0;
				}
				else if(state != BLANK)
					local_arg[local_arg_count++] = args[i];
				else
					state = IN_S_STRING;
				break;
				
			case '"':
				if(state == IN_D_STRING){
					local_arg[local_arg_count] = '\0';
					save_arg(local_arg);
					local_arg_count = 0;
				}
				else if(state != BLANK)
					local_arg[local_arg_count++] = args[i];
				else
					state = IN_D_STRING;
				break;
			default:
				if(state == BLANK)
					state = IN_ARG;
				local_arg[local_arg_count++] = args[i];
				break;
		}
	}

	if(state != BLANK){
		local_arg[local_arg_count] = '\0';
		save_arg(local_arg);
	}
	save_arg(NULL);
}


#endif
