;
;   $Id: TASM.INC 1.2 2002/10/16 16:01:26Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~ /*-------------------------------------------------------------
        $DOCFILE:TASM.INC

        Copyright (C) Datalight, Inc. 1997
        All Rights Reserved.
        Datalight Confidential and Proprietary.

        This include contains TASM specific Datalight standard defines
        and macros.

        This include should be included in all Datalight assembly
        language modules.  It is generally automatically included by
        DATALGHT.INC.

        $DOCHISTORY
        10/09/97 gp     Created
----------------------------------------------------------------------*/ ~


if MANUALFRAME EQ FALSE
;------------------------------------------------------------------------
;       $DOCMACRO:?TasmProcSetup
;
;	This is an internally used macro that does the proc initialization
;	for TASM when the high level constructs are used.
;------------------------------------------------------------------------
?TasmProcSetup	MACRO	ovr
local           attribs
.errnb <ovr>    ;; not TOO many parameters

  ;; build an "attribs" string appropriate for TASM
  attribs CATSTR $pLang,< >
  attribs CATSTR attribs,$pDist

  ifidni $pVis,<EXPORT>
    attribs CATSTR <WINDOWS >,attribs
  endif

  ;; declare the procedure PUBLIC if need be
  ifidni $pVis,<EXPORT>
    % PUBLIC $pName
  elseifidni $pVis,<PUBLIC>
    % PUBLIC $pName
  endif

  ;; execute the actual PROC directive
  % $pName PROC attribs

  ;; process any arguments as needed
  ifnb $pArgs
    % ARG $pArgs
  endif

  ;; process any locals as needed
  ifnb $pLocals
    % LOCAL $pLocals
  endif

  ;; save any registers as needed
  ifnb $pUses
    % USES $pUses
  endif
ENDM

endif
