//
//   $Id: RXEVERFY.H 1.4 2002/10/16 16:12:00Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  RXEVERFY.H
//
//  Copyright (c) 2000-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  06-22-2000  bt  Created
//


//  Error codes
//
#define ERR_NONE				      0
#define ERR_OPEN_EXE			      1
#define ERR_OPEN_EXEMAP		      2
#define ERR_OPEN_RXE			      3
#define ERR_READ_EXE			      4
#define ERR_READ_EXEMAP		      5
#define ERR_READ_RXE			      6
#define ERR_CLOSE_EXE		      7
#define ERR_CLOSE_EXEMAP	      8
#define ERR_CLOSE_RXE		      9
#define ERR_SEEK_EXE			      10
#define ERR_SEEK_EXEMAP		      11
#define ERR_SEEK_RXE			      12
#define ERR_BAD_EXE			      13
#define ERR_BAD_RXE			      14
#define ERR_MEM				      15
#define ERR_FREE				      16
#define ERR_EXEHDR_CORRUPT			17
#define ERR_BAD_RXE_FIXUP_LIST	18
#define ERR_RXEBASE_CORRUPT		19


//  Error codes without error strings
//
#define ERR_USAGE				200
#define ERR_READ				201
#define ERR_SEEK				202


//  Indexes into the boolean command line switches array
//
#define HIDE_SIGNON			0
#define VERBOSE_MODE			1
#define FORCE_OPTIM        2

//  Specify the maximum switches in the boolean switch array
//
#define MAX_BOOLEAN_SWITCHES		3

//  Macros for boolean command line switches
//
#define DoHideSignon()			(fSwitches[HIDE_SIGNON]      != 0)
#define VerboseMode()			(fSwitches[VERBOSE_MODE]     != 0)
#define Force_Optim()			(fSwitches[FORCE_OPTIM]      != 0)


//  Structure for fixup list entry
//
typedef struct FIXUP_ENTRY FIXUP_ENTRY;
typedef FIXUP_ENTRY * PFIXUP_ENTRY;
typedef FIXUP_ENTRY far * LPFIXUP_ENTRY;
struct FIXUP_ENTRY {
	unsigned uOffset;
	unsigned uSegment;
};


typedef struct rxehdr RXEHDR;
typedef RXEHDR * PRXEHDR;
typedef RXEHDR far * LPRXEHDR;
struct rxehdr {
  unsigned short sig;     /* MS-LINK's signature == 4D5A hex */
  unsigned short imgmod;  /* image length mod 512 (bytes) */
  unsigned short imglen;  /* image length in 512-byte pages (including hdr) */
  unsigned short nreloc;  /* Numbermseg; */
  unsigned short hdrlen;  /* Size of header in paragraphs */
  unsigned short minpar;  /* Minimum paragraphs required above loaded program */
  unsigned short maxpar;  /* Maximum paragraphs required above loaded program */
  unsigned short ssdsp;   /* Displacement of SS within module (paragraphs) */
  unsigned short spofs;   /* Offset to be put in SP when executing */
  unsigned short cksum;   /* Neg. sum of all words in file, ignoring overflow */
  unsigned short ipofs;   /* Offset to be put in IP when executing */
  unsigned short csdsp;   /* Displacement of CS within module (paragraphs) */
  unsigned short reldsp;  /* Displacement of 1st reloc item in file (bytes) */
  unsigned short ovlnum;  /* Overlay no. (0 for resident part) */
			  /* Used for RXE support only NOT part of EXE hdr */
  unsigned short ds_dsp;  /* Displacement of 1st DS value for runtime fixup */
  unsigned short ld_seg;  /* Segment of start of RXE in memory */
  unsigned short rxe_int; /* Interrupt used for RXE support */
  unsigned short cd_seg;  /* Segment of start code of RXE in memory */
  unsigned short cd_len;  /* Length in paragraphs of RXE code block */
  unsigned short cd_sum;  /* Check sum of RXE code block */
};


typedef union _XEHDR _XEHDR;
typedef _XEHDR	* P_XEHDR;
typedef _XEHDR	far * LP_XEHDR;
union _XEHDR{
	RXEHDR	RXE;
	EXEHDR	EXE;
};

#define RXE_FIXUP_TABLE_ENTRIES		16


/*
 * The RXE_BASE structure is at the head of the assembly RXE_BASE.
 *
 * The "X" shows the fields that are initialized by RXE_BASE.ASM.
 *
 * The "R" shows the fields that are initialized by RXE_CVT.EXE
 */
#define XIPSIG (((long) 'P' << 16) | ((long) 'I' << 8) | 'X' )
typedef struct rxe_base RXE_BASE;
typedef RXE_BASE * PRXE_BASE;
typedef RXE_BASE far * LPRXE_BASE;
struct rxe_base {
	long rxe_sig;		/* X - RXE Sig is "XIP" */
	unsigned rxe_ver;	/* X - Version of RXE_CVT  that built it */
	unsigned cd_seg;	/* X - Start of Code Block in RXE Memory */
	unsigned ld_seg;	/* R - Segment of start of RXE in memory */
	unsigned int_no;	/* R - Interrupt used for RXE support */
	unsigned cd_cs;	/* R - Segment of start code of RXE in memory */
	unsigned cd_ip;		/* R - Offset of start code of RXE in memory */
	unsigned cd_len;	/* R - Length in paragraphs of RXE code block */
	unsigned cd_sum;	/* R - Check sum of RXE code block */
	unsigned rxe_base_len;	/* R - The length in para's of the rxe Blodk */
	unsigned rxe_fixup_table[16]; /* R - Fixup table */
	char code[2];		/* X - Code of the RXE_BASE */
};


//  Macro for converting segmented addresses to physical offsets
//
#define PHYS(uSegment, uOffset) (((ulong)(uSegment) << 4) + (uOffset))



#define BUFFER_SIZE		4096


#define MAX_INSTRUCTION_LENGTH 6
