REM
REM   $Id: BUILDALL.BAT 1.2 2002/10/16 16:27:00Z peterb Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@if "%echo%" == "" set echo=off
@echo %echo%
cls
REM -----------------------------------------------------------------------
REM   BUILDALL.BAT ---- Build all of SOCKETS
REM
REM 02/16/01 rk Added to SOCKETS project
REM -----------------------------------------------------------------------

REM Default to pausing on errors
set paus=pause
set builderr=
set autobuild=

if "%1" == "" goto Usage
if "%1" == "?" goto Usage
if "%1" == "/?" goto Usage
if not "%1" == "/nopause" goto DoBuild
shift
set paus=
set autobuild=/auto

:DoBuild
set sockver=%1

call sockets\logwrite --------[BUILDALL: Stage 1: Deleting Old Files]----------
if exist demodos\nul    deltree /Y demodos
if exist dos\nul deltree /Y dos
if exist win\nul deltree /Y win
if exist demowin\nul deltree /Y demowin

call clean

call sdk\logwrite --------[BUILDALL: Stage 2: Copying SDK Source Files]----
md dos
md dos\clients
md dos\utils
md dos\docs
md dos\server
md dos\examples
md dos\configs

REM Copy docs appropriate for the SDK
copy docs\*.*  dos\docs\*.*

REM Build the filtered HISTORY.TXT
grep -v+ "^.\*" dos\history.txt >release\source\history.txt

%cpy% clients  release\source\comm\*.*     /s/e
%cpy% server   release\source\apps\*.*     /s/e
%cpy% utils    release\source\mouse\*.*    /s/e
%cpy% configs  release\source\common\*.*   /s/e
%cpy% examples release\source\system\*.*   /s/e
%cpy% kernel   release\source\display\*.*  /s/e

call dos\logwrite --------[BUILDALL: Stage 3: Making the Debug Version]----

md release\dos
md release\demodos

REM Prevent the RELEASE directory from being seen during the build
attrib +h release

set DBUG=1
call autoproj\makeall %autobuild%
if not "%builderr%" == "" goto BuildError

copy demodos\*.* release\demodos\*.*
del  release\demodos\socketp.exe
del  release\demodos\socketm.exe
cd   ..\..
call clean

call dos\logwrite --------[BUILDALL: Stage 4: Making the Release Version]--

if exist demodos\nul deltree /Y demo

set DBUG=0
call autoproj\makeall %autobuild%
if not "%builderr%" == "" goto BuildError

REM Unhide the RELEASE directory now that that the build is done
attrib -h release

call dos\logwrite --------[BUILDALL: Stage 5: Run WINDOC]-----------------

call autoproj\makedocs SDK

call dos\logwrite --------[BUILDALL: Stage 6: Add Supplemental Stuff]-----

cd demo
call ..\autoproj\addons /auto
cd..

call dos\logwrite --------[BUILDALL: Stage 7: Build RELEASE tree]---------

call dos\logwrite --------[BUILDALL: Stage 8: Build DEMO tree]-----------


call dos\logwrite --------[BUILDALL: Stage 9: Time-Stamping All Files]-----


call dos\logwrite --------[BUILDALL: Stage 10: BuildAll Complete!]---------

goto fini

REM --------------------------------------------
REM Error messages
REM --------------------------------------------

:BuildError
echo.
echo An error occurred when building the project!
echo.
%paus%
goto fini


REM --------------------------------------------
REM    Show usage
REM --------------------------------------------

:Usage
cls
echo.


:Fini
set sdkver=
set paus=
set autobuild=
