REM
REM   $Id: SDKPREP.BAT 1.2 2002/10/16 16:27:00Z peterb Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo %echo%

REM -------------------------------------------------------------------------
REM $DOCFILE:SDKPREP.BAT
REM
REM Create the image to be used by the web upload program to create
REM DEMO.
REM
REM $DOCHISTORY
REM 02/16/01 rk Added to SOCKETS project
REM -------------------------------------------------------------------------

REM validate Command line parameters
if "%1"=="" goto usage
if "%1"=="?" goto usage
if "%1"=="/?" goto usage

if "%3"=="" goto usage

set error=
set bldver=%1
set bldnum=%2
set dstroot=%3
set dst=%dstroot%\sockets\demodos

call t:\mks\autoproj\logwrite --------[SDKPREP: Stage 1: Initialization]---------------

timeout /pad/nh/12/d /t Beginning SDKPREP for Build %bldnum%>>%dstroot%\sockets\demodos.log

REM verify we have our archive location
if NOT exist %projroot%\nul goto no_wmap

REM verify build exists
if NOT exist %projroot%\bld_%bldnum%\*.* goto no_build

REM if not exist %dstroot%\nul goto inv_dest

REM see if working directory exists
REM if exist %dst%\nul deltree /y %dst%
deltree /y %dst%

REM create working directories
echo Creating directory %dst% tree
md %dst%
md %dst%\demodos

call t:\mks\autoproj\logwrite --------[SDKPREP: Stage 2: Copy Files]-------------------

REM Copy current build into the full source kit directory (except the
REM test suite executables).

echo Getting latest build from %projroot%\bld_%bldnum%
%cpy% %projroot%\bld_%bldnum% %dst%\demodos /s/e

REM remove read only attributes
echo Removing read-only flag from the files
attrib -r %dst%\demodos\*.* /s >nul

REM copy current release tree to the sdk directory
echo Copy SDK to %dst%\demodos
%cpy% %dst%\sockets\release %dst%\demodos /s/e

REM copy current demo tree to the SOCKETS directory
echo Copy DEMO to %dst%\demodos
%cpy% %dst%\sockets\demodos %dst%\demodos /s/e

REM
REM make appropriate changes to the WLFSK directory for copying to CDROM
REM
if exist %dst%\sockets\sandbox.pj attrib -r %dst%\sockets\sandbox.*
if exist %dst%\sockets\sandbox.pj del       %dst%\sockets\sandbox.*
deltree /y %dst%\sockets\demdos

deltree /y t:\products\sockets\alpha
md         t:\products\sockets\alpha
md         t:\products\sockets\alpha\image

%cpy% %dst% t:\products\sockets\alpha\image /s/e

rendir t:\products\sockets\alpha\image\demodos demodos
rendir t:\products\sockets\alpha\image\dos  dos
rendir t:\products\sockets\alpha\image\win  win
rendir t:\products\sockets\alpha\image\demowin  demowin

call t:\mks\autoproj\logwrite --------[SDKPREP: Stage 3: Complete]---------------------
attrib +r %dst%\*.* /s

timeout /pad/nh/12/d /t Finishing SDKPREP -- ERROR="%error%">>%dstroot%\sockets.log

:fini
set bldver=
set bldnum=
set dst=
set dstroot=
