#
#   $Id: makefile.ms 1.2 2003/05/08 17:19:16Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# MAKEFILE for Datalight's CAPI Library Routines
#
# ROM-DOS Copyright (c) 1991-2003 by Datalight, Inc.
# All Rights Reserved.
# Datalight Confidential and Proprietary
#
# This file to build libraries for the small, medium, compact and large
# memory models.
#
CC       = cl
CFLAGS   = /c /O /A$(MEM_MODEL) /D_CAPI_LIBRARY /I..\include
LIB      = LIB

# RELEASE
# -------------
release : clean capis capim capic capil copyrel

copyrel:
        @if exist ..\LIB\ms_capi?.lib del ..\lib\ms_capi?.lib  >nul
        @if not exist ..\LIB\nul md ..\lib >nul
        @copy ms_capi?.lib ..\lib >nul

capis:
	nmake /A -fmakefile.ms MEM_MODEL=S DMEM_MODEL_NAME=SMALL capilib

capim:
	nmake /A -fmakefile.ms MEM_MODEL=M DMEM_MODEL_NAME=MEDIUM capilib

capic:
	nmake /A -fmakefile.ms MEM_MODEL=C DMEM_MODEL_NAME=COMPACT capilib

capil:
	nmake /A -fmakefile.ms MEM_MODEL=L DMEM_MODEL_NAME=LARGE capilib


# Define the modules of the library.
#
OBJ1 = getsockv.obj disablea.obj enableas.obj issocket.obj getdcsoc.obj
OBJ2 = getsocke.obj getversi.obj convertd.obj eofsocke.obj flushsoc.obj
OBJ3 = releases.obj released.obj abortsoc.obj abortdcs.obj shutdown.obj
OBJ4 = getaddre.obj getpeera.obj getkerni.obj icmpping.obj getkernc.obj
OBJ5 = getnetin.obj connects.obj listenso.obj listenac.obj acceptso.obj
OBJ6 = selectso.obj readsock.obj readfrom.obj writesoc.obj writetos.obj
OBJ7 = setalarm.obj setasync.obj resolven.obj parseadd.obj setsocke.obj
OBJ8 = joingrou.obj leavegro.obj ifaceioc.obj asyncnot.obj dpmicbre.obj 
OBJ9 = arpapi.obj   _capi.obj    base.obj

MODULES = $(OBJ1) $(OBJ2) $(OBJ3) $(OBJ4) $(OBJ5) $(OBJ6) $(OBJ7) $(OBJ8) $(OBJ9)


#
# build the librarian response file
#
ms_capi.rsp : makefile
 @echo +getsockv +disablea +enableas +issocket +getdcsoc &> ms_capi.rsp
 @echo +getsocke +getversi +convertd +eofsocke +flushsoc &>> ms_capi.rsp
 @echo +releases +released +abortsoc +abortdcs +shutdown &>> ms_capi.rsp
 @echo +getaddre +getpeera +getkerni +icmpping +getkernc &>> ms_capi.rsp
 @echo +getnetin +connects +listenso +listenac +acceptso &>> ms_capi.rsp
 @echo +selectso +readsock +readfrom +writesoc +writetos &>> ms_capi.rsp
 @echo +setalarm +setasync +resolven +parseadd +setsocke &>> ms_capi.rsp
 @echo +joingrou +leavegro +ifaceioc +asyncnot +dpmicbre &>> ms_capi.rsp
 @echo +arpapi   +_capi    +base; >> ms_capi.rsp                 

#
# build the specified library
#
capilib : $(MODULES) ms_capi.rsp
	 $(LIB) ms_capi$(MEM_MODEL).lib @ms_capi.rsp
	 @del *.obj

arpapi.obj:	capi.c
	 $(CC) $(CFLAGS) -Foarpapi  /D_CAPI_ARPAPI capi.c
getsockv.obj:	capi.c
	 $(CC) $(CFLAGS) -Fogetsockv /D_CAPI_GETSOCKETSVERSION capi.c
disablea.obj:	capi.c
	$(CC) $(CFLAGS) -Fodisablea /D_CAPI_DISABLEASYNCNOTIFICATION capi.c
enableas.obj:	capi.c
	$(CC) $(CFLAGS) -Foenableas /D_CAPI_ENABLEASYNCNOTIFICATION capi.c
issocket.obj:	capi.c
	$(CC) $(CFLAGS) -Foissocket /D_CAPI_ISSOCKET capi.c
getdcsoc.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetdcsoc /D_CAPI_GETDCSOCKET capi.c
getsocke.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetsocke /D_CAPI_GETSOCKET capi.c
getversi.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetversi /D_CAPI_GETVERSION capi.c
convertd.obj:	capi.c
	$(CC) $(CFLAGS) -Foconvertd /D_CAPI_CONVERTDCSOCKET capi.c
eofsocke.obj:	capi.c
	$(CC) $(CFLAGS) -Foeofsocke /D_CAPI_EOFSOCKET capi.c
flushsoc.obj:	capi.c
	$(CC) $(CFLAGS) -Foflushsoc /D_CAPI_FLUSHSOCKET capi.c
releases.obj:	capi.c
	$(CC) $(CFLAGS) -Foreleases /D_CAPI_RELEASESOCKET capi.c
released.obj:	capi.c
	$(CC) $(CFLAGS) -Foreleased /D_CAPI_RELEASEDCSOCKETS capi.c
abortsoc.obj:	capi.c
	$(CC) $(CFLAGS) -Foabortsoc /D_CAPI_ABORTSOCKET capi.c
abortdcs.obj:	capi.c
	$(CC) $(CFLAGS) -Foabortdcs /D_CAPI_ABORTDCSOCKETS capi.c
shutdown.obj:	capi.c
	$(CC) $(CFLAGS) -Foshutdown /D_CAPI_SHUTDOWNNET capi.c
getaddre.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetaddre /D_CAPI_GETADDRESS capi.c
getpeera.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetpeera /D_CAPI_GETPEERADDRESS capi.c
getkerni.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetkerni /D_CAPI_GETKERNELINFORMATION capi.c
icmpping.obj:	capi.c
	$(CC) $(CFLAGS) -Foicmpping /D_CAPI_ICMPPING capi.c
getkernc.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetkernc /D_CAPI_GETKERNELCONFIG capi.c
getnetin.obj:	capi.c
	$(CC) $(CFLAGS) -Fogetnetin /D_CAPI_GETNETINFO capi.c
connects.obj:	capi.c
	$(CC) $(CFLAGS) -Foconnects /D_CAPI_CONNECTSOCKET capi.c
listenso.obj:	capi.c
	$(CC) $(CFLAGS) -Folistenso /D_CAPI_LISTENSOCKET capi.c
listenac.obj:	capi.c
	$(CC) $(CFLAGS) -Folistenac /D_CAPI_LISTENACCEPTSOCKET capi.c
acceptso.obj:	capi.c
	$(CC) $(CFLAGS) -Foacceptso /D_CAPI_ACCEPTSOCKET capi.c
selectso.obj:	capi.c
	$(CC) $(CFLAGS) -Foselectso /D_CAPI_SELECTSOCKET capi.c
readsock.obj:	capi.c
	$(CC) $(CFLAGS) -Foreadsock /D_CAPI_READSOCKET capi.c
readfrom.obj:	capi.c
	$(CC) $(CFLAGS) -Foreadfrom /D_CAPI_READFROMSOCKET capi.c
writesoc.obj:	capi.c
	$(CC) $(CFLAGS) -Fowritesoc /D_CAPI_WRITESOCKET capi.c
writetos.obj:	capi.c
	$(CC) $(CFLAGS) -Fowritetos /D_CAPI_WRITETOSOCKET capi.c
setalarm.obj:	capi.c
	$(CC) $(CFLAGS) -Fosetalarm /D_CAPI_SETALARM capi.c
setasync.obj:	capi.c
	$(CC) $(CFLAGS) -Fosetasync /D_CAPI_SETASYNCNOTIFICATION capi.c
resolven.obj:	capi.c
	$(CC) $(CFLAGS) -Foresolven /D_CAPI_RESOLVENAME capi.c
parseadd.obj:	capi.c
	$(CC) $(CFLAGS) -Foparseadd /D_CAPI_PARSEADDRESS capi.c
setsocke.obj:	capi.c
	$(CC) $(CFLAGS) -Fosetsocke /D_CAPI_SETSOCKETOPTION capi.c
joingrou.obj:	capi.c
	$(CC) $(CFLAGS) -Fojoingrou /D_CAPI_JOINGROUP capi.c
leavegro.obj:	capi.c
	$(CC) $(CFLAGS) -Foleavegro /D_CAPI_LEAVEGROUP capi.c
ifaceioc.obj:	capi.c
	$(CC) $(CFLAGS) -Foifaceioc /D_CAPI_IFACEIOCTL capi.c
asyncnot.obj:	capi.c
	$(CC) $(CFLAGS) -Foasyncnot /D_CAPI_ASYNCNOTIFICATIONHANDLER capi.c
dpmicbre.obj:	capi.c
	$(CC) $(CFLAGS) -Fodpmicbre /D_CAPI_DPMICBREGS capi.c
base.obj:	capi.c
	$(CC) $(CFLAGS) -Fobase /D_CAPI_BASE capi.c

_capi.obj:	_capi.c
	$(CC) $(CFLAGS) _capi.c


# HOUSEKEEPING
# -----------------
clean :
	@if exist *.obj del *.obj
	@if exist *.map del *.map
	@if exist *.lnk del *.lnk
	@if exist *.xrf del *.xrf
	@if exist *.lst del *.lst
	@if exist *.exe del *.exe
	@if exist *.pt del *.pt
	@if exist *.td del *.td
	@if exist *.tr del *.tr
	@if exist *.bak del *.bak
	@if exist *.rsp del *.rsp
	@if exist *.lib del *.lib
	@if exist x.y del x.y
	@if exist err.txt del err.txt
	@if exist status.me del status.me

cleanall : clean
	@if exist status.me del status.me
	@if exist build.log del build.log
        @if exist ..\LIB\ms_capi?.lib del ..\lib\ms_capi?.lib  >nul
