//
//   $Id: FTPCLI.C 1.9 2003/09/08 15:47:32Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Portions Copyright (c) 1993-2002 GP van Niekerk Ondernemings
//   Portions Copyright (c) 1986-1989 Phil Karn, KA9Q
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// FTPCLI.C
//
// FTP Client (interactive user) code
//
// Revision History
// 09/08/2003 jmb IR#4261
//                Gave specific return values for timeout cases of cannot connect(7)
//                and when the connection is lost(8).
// 02/14/2002 jmb IR#3931
//                added MDTM command support as supported by the imminent
//                release of a new FTP specification.
// 02/14/2002 jmb IR#3924:
//                allowed 250 to be valid to signal successful transfer
// 01/07/2002 gvn Fixed short input buffer introduced by change on 04/30/2001
//						Fixed continuous loop when doing LIST when not logged in
//						Disable Ctrl-C/Break preventiong open connections when used
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <alloc.h>
#include <stdarg.h>
#include <process.h>
#include <conio.h>
#include <dir.h>
#include <dos.h>
#include "inetdefs.h"
#include "compiler.h"
#include "api.h"
#include "apic.h"
#include "ftp.h"
#include "ftpparse.h"
#include "dirutil.h"
#include "dostruct.h"	//  DOS structures
#include "dosdef.h"
#include "datalght.h"
#include "dldosio.h" 	//  some int 21h (DOS)
#include "dllfn.h"  		//  LFN and LFN "smart" functions
#include "lfnopen.h"

#ifdef DL
#include "dosver.h"
#include "fatworld.h"
#endif

#define FK(n)	   ((unsigned)n * 256)
#define ALT_X	 FK(45)
// error codes returned
#define	PARAMETER_ERR	1
#define NO_API_			2
#define ABORTED			3
#define XFER_ABORTED	4
#define CANT_WRITE		5
#define CANT_READ		6
#define CANT_CONNECT 7
#define CONN_LOST    8
#define FTP_ERROR		10	// FTP errors starting at 400

char *ftp_state[] = {
	"COMMAND_STATE",
	"SENDING_STATE",
	"SENDING_STATE_WPOK",
	"SEND_RDY_STATE",
	"SENT_STATE",
	"LIST_STATE_WTOK",
	"LIST_STATE_WPOK",
	"LIST_STATE",
	"LIST_RDY_STATE",
	"LISTED_STATE_WTOK",
	"LISTED_STATE",
	"RECEIVING_STATE_WPOK",
	"RECEIVING_STATE",
	"RECV_RDY_STATE",
	"RECEIVED_STATE",
	"REPLY_STATE",
	"COMMAND_STATE_WTOK",
	"RCVLIST_STATE_WPOK",
	"RCVNLST_STATE_WPOK",
};

#define showstat()

DWORD tick_timer(void);
static void ftpsetup(struct ftp *ftp,int rcv);
void ftp_command(struct ftp *ftp,char *line,int len);
int sndftpmsg(struct ftp *ftp,char *fmt,...);
void ftp_delete();
int donothing(int argc,char *argv[]);
void secret(void);
void cooked(void);
int isconsole(char *name);
void ftp_line(struct ftp *ftp,char *lb);
void kbinit(void);
void check_dontwipe(void);

extern char dis_stop;			/* display stopped flag */

char nospace[] = "Not enough memory\n";
char badhost[] = "Unknown host: %s\n";
static char notsess[] = "Not an FTP session!\n";
static char cantwrite[] = "Can't write %s\n";
static char cantread[] = "Can't read %s\n";

struct ftp *current_ftp;	// nasty way of passing current ftp pointer
char window_shown;
char shown;
char no_window;

#ifndef DL
#define INET "Inet"
#define PROGRAM "IFTP"
#else
#define INET "Sockets"
#define PROGRAM "FTP"
#endif

int argcount;
char **argval;

// 2.04 00-03-03 Fix Y2k bug in ldir!

static char inbuf[] =
#ifndef DL
INET" FTP client version 2.05\n"
#endif
"Usage:\n"
PROGRAM" [<options>] <server> [<options>] [/f=<filename> [<parameters>]]\n"
"Options:\n"
"    /n        - no progress window\n"
"    /v        - verbose on\n"
"    /p=<port> - use non-standard port\n"
"<filename> is a file containing FTP commands\n"
"<parameters> are parameters for replaceable parameters in file <filename>\n"
;
#define INBUFSIZE	sizeof(inbuf)			// command buffer size

FILE *fpinput;
int error_code;
int donothing(),doftpcd(),dolist(),doget(),dols(),doput(),dotype(),doabort(),
	domkdir(),dormdir(),douser(),doverbose(),doquote(),dolcd(),doldir(),
	doquit(),doascii(),dobinary(),dopass(),dopasv(),dodel(),doshell(),
	dolstat(),dolhelp(), domdtm();

struct cmds ftpcmds[] = {
	{"noop",	donothing},
	{"abort",doabort},
	{"append",doput},
	{"ascii",doascii},
	{"binary",dobinary},
	{"bye",	doquit},
	{"cd",	doftpcd},
	{"delete",dodel},
	{"dir",	dolist},
	{"exit",	doquit},
	{"get",	doget},
	{"image",dobinary},
	{"lcd",	dolcd},
	{"ldir",	doldir},
	{"lhelp",dolhelp},
	{"list",	dolist},
	{"ls",	dols},
	{"lstat",dolstat},
   {"mdtm", domdtm},
	{"mget",	doget},
	{"mkdir",domkdir},
	{"mput",	doput},
	{"nlst",	dols},
	{"pass",	dopass},
	{"pasv",	dopasv},
	{"put",	doput},
	{"quote",doquote},
	{"rmdir",dormdir},
	{"shell",doshell},
	{"type",	dotype},
	{"user",	douser},
	{"verbose",doverbose},
	{"",		NULLFP},
};

//struct text_info ti;

int ControlBreak()
{
	return 1;		// ignore Ctrl-Break
}

/* Handle top-level FTP command */
main(int argc,char *argv[])
{
	char *inet_ntoa();
	struct ftp *ftp,*ftp_create();
	unsigned control;
	struct isocket lsocket,fsocket;
	int i,cnt,rcnt,len;
	char verbose = 0;
	char *hname = 0;
	char *line;
	char buf[100],*pb;
	char *lb;
	char ch;
   int x,y;
   
	/*
	gettextinfo(&ti);
	cprintf("window left      %2d\r\n",ti.winleft);
	cprintf("window top       %2d\r\n",ti.wintop);
	cprintf("window right     %2d\r\n",ti.winright);
	cprintf("window bottom    %2d\r\n",ti.winbottom);
	cprintf("attribute        %2d\r\n",ti.attribute);
	cprintf("normal attribute %2d\r\n",ti.normattr);
	cprintf("current mode     %2d\r\n",ti.currmode);
	cprintf("screen height    %2d\r\n",ti.screenheight);
	cprintf("screen width     %2d\r\n",ti.screenwidth);
	cprintf("current x        %2d\r\n",ti.curx);
	cprintf("current y        %2d\r\n",ti.cury);
	*/
	lsocket.dwAddress = 0;
	lsocket.wPort = 0;
	fsocket.wPort = FTP_PORT;
	for (i = 0,--argc,++argv;argc > 0;--argc,++argv) {
		if (*argv[0] == '/' || *argv[0] == '-') {
			char *parg = argv[0] + (argv[0][2] == '=' ? 3 : 2);
			switch (toupper(argv[0][1])) {
			case 'F':
				argcount = argc;
				argval = argv;
				if ((fpinput = LFNfopen(parg,"rt")) == 0) {
					printf("Unable to open '%s'\n",parg);
					exit(PARAMETER_ERR);
				}
				goto args_done;
			case 'N':
				no_window = 1;
				break;
			case 'P':
				fsocket.wPort = atoi(parg);
				break;
			case 'V':
				verbose = 1;
				break;
			default:
#ifdef DL
				printf("Datalight Sockets FTP ");
				if (dlIsFat32World())
					printf("%s ", SHORTVERSION);
				else
					printf("%s ", SHORTVERSION622);
				printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
					BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);


		
#endif
				printf(inbuf);
				return 0;
			}
		}
		else {
			switch (i) {
			case 0:
				hname = argv[0];
				++i;
				break;
			case 1:
				fsocket.wPort = atoi(argv[0]);
				++i;
				break;
			}
		}
	}
	args_done:
#ifndef DL
	check_dontwipe();
#endif
	if (init_api() < 0) {
		printf(INET" API not loaded\n");
		exit(NO_API_);
	}
	if (!i) {
		printf("Please supply server host\n");
		exit(PARAMETER_ERR);
	}
	if (!no_window) {
		x = wherex();
		y = wherey();
		window(1, 1, 80, 25);
		gotoxy(x,y);
	}
	kbinit();
	ctrlbrk(ControlBreak);
	if((fsocket.dwAddress = Resolve(hname)) == 0){
		printf(badhost,hname);
		exit(PARAMETER_ERR);
	}

	/* Allocate an FTP control block */
	if((ftp = ftp_create(0)) == NULLFTP){
		printf(nospace);
		exit(PARAMETER_ERR);
	}
	if ((ftp->linebuf = malloc(LNBFLEN)) == NULLCHAR) {
		printf(nospace);
		ftp_delete(ftp);
		exit(PARAMETER_ERR);
	}
	ftp->state = COMMAND_STATE;
	ftp->verbose = verbose;
	ftp->flags |= FF_PASV;
	/* Now open the control connection */
	control = OpenTcp(&lsocket,&fsocket,TCP_ACTIVE,0,0,0,0,0,(char *)ftp);
	ftp->control = control;
	ftp->flags |= FF_DISP;
//	sprintf(servname," %d-%.18s ",(int)(current - sessions),current->name);
//	screen_string(servname,60,24,window_col[TITLE]);
	printf("\nftp> ");
	while (1) {
		if (ftp == NULLFTP) {
			hide_window();
			error_code = CANT_CONNECT;
			printf("No FTP control block\n");
			break;
		}
		else if (ftp->control == 0) {
			hide_window();
			error_code = CANT_CONNECT;
			printf("No connection\n");
			break;
		}
		if ((len = getline(&line)) == -2 || len == -3) {
			hide_window();
			error_code = ABORTED;
			printf("aborted\n");
			break;
		}
		if (len != -1 && (len & 0xff00)) {	/* nochar or function key */
			if (len == 0x4f00)
				hide_window();
			len = -1;
		}
		if (len >= 0) {
			if (ftp->flags & FF_USERNAME) {
				for (i = 0;i < len;++i) {
					if (!line[i] || line[i] == '\r')
						break;
				}
				line[i] = 0;
				sndftpmsg(ftp,"USER %s\r\n",line);
				ftp->flags &= ~FF_USERNAME;
			}
			else if (ftp->flags & FF_PASSWORD) {
				for (i = 0;i < len;++i) {
					if (!line[i] || line[i] == '\r')
						break;
				}
				line[i] = 0;
				if (i)
					sndftpmsg(ftp,"PASS %s\r\n",line);
				ftp->flags &= ~FF_PASSWORD;
				cooked();
			}
			else
				ftp_command(ftp,line,len);
		}
		lb = ftp->linebuf;
		while ((rcnt = RecvTcp(control,buf,100,0)) > 0) {
			for (pb = buf,cnt = rcnt;cnt;--cnt) {
				ch = *pb++;
				if (ftp->lbindex < LNBFLEN)
					lb[ftp->lbindex++] = ch;
				if (ch == '\n') {
					lb[LNBFLEN - 2] = '\r';	// make sure it is terminated properly
					lb[LNBFLEN - 1] = '\n';
					shown = window_shown;
					hide_window();
					ftp_line(ftp,lb);
					if (shown)
						show_window();
					ftp->lbindex = 0;
				}
			}
		}
		if (rcnt != -WOULDBLK)
			{
			// if an error code is not set... set one now!
			if (!error_code)
				error_code = CONN_LOST;
			break;
			}
		if (ftp->data) {
			ftp->mode ? ftpdr(ftp) : ftpdt(ftp);
		}
	}
	CloseTcp(control);
	if(ftp != NULLFTP) {
		ftp_delete(ftp);
	}
	exit(error_code);
	return 0;
}

char *allocstr(char *str)
{
	char *retstr;

	if ((retstr = malloc(strlen(str) + 1)) != 0)
		strcpy(retstr,str);
	return retstr;
}

alloc_name(struct ftp *ftp,char *name)
{
	if (ftp->remotename) {
		free(ftp->remotename);
		ftp->remotename = 0;
	}
	if (name && (ftp->remotename = allocstr(name)) == 0) {
		printf(nospace);
		return 0;
	}
	return 1;
}

void ftp_command(struct ftp *ftp,char *line,int len)
{
	char copy[100],*pb;

	/* Save it now because cmdparse modifies the original */
	if (len > 99)
		len = 99;
	strncpy(copy,line,len);
	copy[len] = 0;
	current_ftp = ftp;
	pb = copy;
	if ((len = cmdparse(ftpcmds,line,0)) == -2) {
		/* echo command */
		while (*pb && isspace(*pb))
			++pb;
		while (*pb && !isspace(*pb))
			++pb;
		while (*pb && isspace(*pb))
			++pb;
		if (*pb)
			SendTcp(ftp->control,pb,strlen(pb),0);
	}
	else if (len == -1) {
		/* Send it direct - unknown local command */
		if(*pb)
			SendTcp(ftp->control,pb,strlen(pb),0);
	}
	else if (len == 1) {
		donothing(0,0);
	}
}

/* queue ftp display data */
void ftp_qdisp(struct ftp *ftp,char *buf,int len)
{
	char shown = window_shown;

	hide_window();
	if (ftp->flags & FF_DISP)
		printf("%.*s",len,buf);
	if (shown)
	    show_window();
}

/* Handle null line to avoid trapping on first command in table */
int donothing()
{
	struct ftp *ftp = current_ftp;
	int len;
	char *line;

	if (fpinput && (len = getfline(&line)) != -1) {
		ftp_command(ftp,line,len);
	}
	else {
		ftp_qdisp(ftp,"\rftp> ",6);
	}
	return 0;
}

/* Change working directory */
docd(int argc,char *argv[])
{
	char dirname[262];
	char *name,*cp;

	if (argc > 1) {
		name = argv[1];
		if (name[1] == ':') {
			setdisk(toupper(*name) - 'A');
			name += 2;
		}
		cp = name;
		while ((cp = strchr(cp,'\\')) != 0)
			*cp = '/';
		if (*name && SmartChangeDirectory(name) == 0) {
			printf("Can't change directory to '%s'\r\n",name);
			return 1;
		}
	}
	if (SmartGetCurrentDirectory(0,dirname) != 0) {
		printf("%c:\\%s\r\n",getdisk() + 'A',dirname);
	}
	else
		printf("SmartGetCurrentDirectory() failed\r\n");
	return 0;
}
/* List directory to console */
dodir(int argc,char *argv[])
{
	char *path, *cp;

	if(argc >= 2){
		cp = path = argv[1];
		while ((cp = strchr(cp,'\\')) != 0)
			*cp = '/';
	} else {
		path = "*.*";
	}
	getdir(path,1,stdout);
	return 0;
}

/* local change directory */
static int dolcd(int argc,char *argv[])
{
	docd(argc,argv);
	return donothing(argc,argv);
}

/* local directory list */
static int doldir(int argc,char *argv[])
{
	dodir(argc,argv);
	return donothing(argc,argv);
}

/* Translate 'cd' to 'cwd' for convenience */
#pragma argsused
static int doftpcd(int argc,char *argv[])
{
	return sndftpmsg(0,"CWD %s\r\n",argv[1]);
}

/* Translate 'delete' to 'dele' for Ferdi */
#pragma argsused
static int dodel(int argc,char *argv[])
{
	return sndftpmsg(0,"DELE %s\r\n",argv[1]);
}

/* Translate 'mdtm' to 'mdtm' */
#pragma argsused
static int domdtm(int argc,char *argv[])
{
	return sndftpmsg(0,"MDTM %s\r\n",argv[1]);
}

/* Translate 'mkdir' to 'xmkd' for convenience */
#pragma argsused
static int domkdir(int argc,char *argv[])
{
	return sndftpmsg(0,"XMKD %s\r\n",argv[1]);
}

/* Translate 'rmdir' to 'xrmd' for convenience */
#pragma argsused
static int dormdir(int argc,char *argv[])
{
	return sndftpmsg(0,"XRMD %s\r\n",argv[1]);
}

/* Translate 'exit' to 'quit' for convenience */
#pragma argsused
static int doquit(int argc,char *argv[])
{
	return sndftpmsg(0,"QUIT\r\n");
}

/* Handle "quote" command from user */
static int doquote()
{
	return -2;
}

static int doshell()
{
	char *argvl[2];

	if ((argvl[0] = getenv("COMSPEC")) == 0)
		argvl[0] = "\\COMMAND.COM";
	argvl[1] = 0;
	spawnvp(P_WAIT,argvl[0],argvl);
	return donothing(0,0);
}

/* Handle "type" command from user */
static int dotype(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	if(argc < 2){
		printf("Type is %s\n",
			ftp->type == ASCII_TYPE ? "ASCII" : "Binary");
		return donothing(argc,argv);
	}
	switch(*argv[1]){
	case 'i':
	case 'b':
		ftp->type = IMAGE_TYPE;
		sndftpmsg(ftp,"TYPE I\r\n");
		break;
	case 'a':
		ftp->type = ASCII_TYPE;
		sndftpmsg(ftp,"TYPE A\r\n");
		break;
	case 'l':
		ftp->type = IMAGE_TYPE;
		sndftpmsg(ftp,"TYPE L %s\r\n",argv[2]);
		break;
	default:
		printf("Invalid type %s\n",argv[1]);
		return 1;
	}
	return 0;
}

static int dolhelp(int argc,char *argv[])
{
	struct cmds *pcom;
	int i = 0;

	printf("FTP commands:\n");
	for (pcom = ftpcmds;*pcom->name;++pcom) {
		printf("%-10s%s",pcom->name,++i == 7 ? i = 0,"\n" : " ");
	}
	printf("\n");
	return donothing(argc,argv);
}

static int dolstat(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	printf("Local state = %s\n",ftp_state[ftp->state]);
	if (ftp->data)
		printf("Data connection in use\n");
	if (ftp->error) {
		if (ftp->error == -1)
			printf("Last data connection had a connection problem\n");
		else
			printf("Last data transfer error: %s\n",sys_errlist[ftp->error]);
	}
	return donothing(argc,argv);
}

static int dobinary()
{
	register struct ftp *ftp;

	ftp = current_ftp;
	ftp->type = IMAGE_TYPE;
	return sndftpmsg(ftp,"TYPE I\r\n");
}

static int doascii()
{
	register struct ftp *ftp;

	ftp = current_ftp;
	ftp->type = ASCII_TYPE;
	return sndftpmsg(ftp,"TYPE A\r\n");
}

/* Handle "user" command from user */
static int douser(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	if (argc > 1) {
		sndftpmsg(ftp,"USER %s\r\n",argv[1]);
	}
	else {
		printf("Username: ");
		ftp->flags |= FF_USERNAME;
	}
	return 0;
}

static int dopass(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	if (argc > 1) {
		sndftpmsg(ftp,"PASS %s\r\n",argv[1]);
	}
	else {
		printf("Password: ");
		ftp->flags |= FF_PASSWORD;
		secret();
	}
	return 0;
}

static int dopasv(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	if (argc > 1) {
		if (!stricmp(argv[1],"on"))
			ftp->flags |= FF_PASV;
		else
			ftp->flags &= ~FF_PASV;
	}
	printf("Passive transfer is %s\n",ftp->flags & FF_PASV ? "on" : "off");
	return donothing(argc,argv);
}

/* Handle "verbose" command from user */
static int doverbose(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	if (argc > 1) {
		if (!stricmp(argv[1],"on"))
			ftp->verbose = 1;
		else
			ftp->verbose = 0;
	}
	printf("Verbose is %s\n",ftp->verbose ? "on" : "off");
	return donothing(argc,argv);
}
#if DEMO

static near abortftpdemo(struct ftp *ftp)
{
	static char cnt;
	if (cnt++ < 2)
		return 0;
	demohelp("demo_ms2");
	ftp_command(ftp,"QUIT\r\n",6);
	return 1;
}
#endif

/* start a get operation */
startget(struct ftp *ftp,char *locname,char *rname)
{
	char name[52];
	char errmes[70];
	char *p,*lname;
	int len;

	if(ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);
	ftp->fp = NULLFILE;
	while (1) {
		if (!locname) {
			if (fgets(lname = rname = name,50,ftp->fplist) != NULL) {
				name[49] = 0;
				if ((p = strchr(name,'\r')) != NULL)
					*p = 0;
				if ((p = strchr(name,'\n')) != NULL)
					*p = 0;
			}
			else {
				fclose(ftp->fplist);
				ftp->fplist = 0;
				return 1;
			}
		}
		else
			lname = locname;
		len = sprintf(errmes,"%s - ",lname);
		ftp_qdisp(ftp,errmes,len);
		if (isconsole(lname) != 0) {
			ftp->fp = Stdout;
			ftp_qdisp(ftp,"\n",1);
			break;
		}
		else if ((ftp->fp = LFNfopen(lname,"wb")) == NULLFILE) {
			ftp_qdisp(ftp,"can't write\n",12);
			error_code = CANT_WRITE;
			if (locname)
				return 1;
		}
		else {
			write_window(1,1,"Received:          ");
			shown = 1;
			break;
		}
	}
	if (alloc_name(ftp,rname) == 0) {
		return 1;
	}
	ftp->state = RECEIVING_STATE_WPOK;
	ftpsetup(ftp,1);
	showstat();
	return 0;
}

/* Start receive transfer. Syntax: get <remote name> [<local name>] */
static int doget(int argc,char *argv[])
{
	char *remotename,*localname;
	register struct ftp *ftp;

	ftp = current_ftp;
	if(ftp == NULLFTP){
		printf(notsess);
		return 1;
	}
	if (ftp->state != COMMAND_STATE) {
		printf("Transfer in progress; use ABORT to terminate\n");
		return 1;
	}
#if	DEMO
	if (abortftpdemo(ftp) != 0)
		return 1;
#endif
	remotename = argv[1];
	if(argc < 3)
		localname = remotename;
	else
		localname = argv[2];

	if(ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);
	ftp->fp = NULLFILE;
/*  for MSDOS the EOL for text files is the same as that of FTP
	if(ftp->type == IMAGE_TYPE)
		mode = binmode[WRITE_BINARY];
	else
		mode = "w";
*/
	if (strchr(localname,'*') != NULL || strchr(localname,'?') != NULL) {
		if ((ftp->fp = tmpfile()) == NULL) {
			printf(cantwrite,"tmpfile");
			return 1;
		}
		if (alloc_name(ftp,remotename) == 0) {
			return 1;
		}
		if (ftp->type == IMAGE_TYPE) {
			sndftpmsg(ftp,"TYPE A\r\n");
			ftp->state = LIST_STATE_WTOK;
		}
		else {
			ftpsetup(ftp,1);
			ftp->state = LIST_STATE_WPOK;
		}
		return 0;
	}
	showstat();
	return startget(ftp,localname,remotename);
}

/* List remote directory. Syntax: dir <remote directory/file> [<local name>] */
static int dolist(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	if(ftp == NULLFTP){
		printf(notsess);
		return 1;
	}
	if (ftp->state != COMMAND_STATE) {
		printf("Transfer in progress; use ABORT to terminate\n");
		return 1;
	}
	if(ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);
	ftp->fp = NULLFILE;

	if(argc < 3){
		ftp->fp = Stdout;
	} else if((ftp->fp = LFNfopen(argv[2],"wb")) == NULLFILE){
		printf(cantwrite,argv[2]);
		return 1;
	}
	if (alloc_name(ftp,argc > 1 ? argv[1] : 0) == 0) {
		return 1;
	}
	ftp->state = RCVLIST_STATE_WPOK;
	ftpsetup(ftp,1);
	showstat();
	return 0;
}

/* Abbreviated (name only) list of remote directory.
 * Syntax: ls <remote directory/file> [<local name>]
 */
static int dols(int argc,char *argv[])
{
	register struct ftp *ftp;

	ftp = current_ftp;
	if(ftp == NULLFTP){
		printf(notsess);
		return 1;
	}
	if (ftp->state != COMMAND_STATE) {
		printf("Transfer in progress; use ABORT to terminate\n");
		return 1;
	}
	if(ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);
	ftp->fp = NULLFILE;

	if(argc < 3){
		ftp->fp = Stdout;
	} else if((ftp->fp = LFNfopen(argv[2],"wb")) == NULLFILE){
		printf(cantwrite,argv[2]);
		return 1;
	}
	if (alloc_name(ftp,argc > 1 ? argv[1] : 0) == 0) {
		return 1;
	}
	ftp->state = RCVNLST_STATE_WPOK;
	ftpsetup(ftp,1);
	showstat();
	return 0;
}

/* start a put operation */
startput(struct ftp *ftp,char *locname,char *rname)
{
	char name[80];
	char errmes[70];
	char *p,*lname;
	int len;

	if(ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);
	ftp->fp = NULLFILE;
	while (1) {
		if (!locname) {
			if (ftp->cd) {
				strncpy(name,ftp->cd,60);
				name[60] = 0;
			}
			else
				name[0] = 0;
			rname = name + strlen(name);
			lname = name;
			if (fgets(rname,78 + rname - name,ftp->fplist) != NULL) {
				name[79] = 0;
				if ((p = strchr(rname,'\r')) != NULL)
					*p = 0;
			}
			else {
				fclose(ftp->fplist);
				ftp->fplist = 0;
				return 1;
			}
		}
		else {
			lname = locname;
			if (!rname) {
				for (rname = lname + strlen(lname) - 1;
					rname != lname;--rname) {
					if (*rname == '\\' || *rname == '/'
							|| *rname == ':') {
						++rname;
						break;
					}
				}
			}
		}
		len = sprintf(errmes,"%s - ",lname);
		ftp_qdisp(ftp,errmes,len);
		if ((ftp->fp = LFNfopen(lname,"rb")) == NULLFILE) {
			ftp_qdisp(ftp,"can't read\n",11);
			error_code = CANT_READ;
			if (locname)
				return 1;
		}
		else {
			write_window(1,1,"Sent:              ");
			shown = 1;
			break;
		}
	}
	if (alloc_name(ftp,rname) == 0) {
		return 1;
	}
	ftp->state = SENDING_STATE_WPOK;
	ftpsetup(ftp,0);
	showstat();
	return 0;
}

/* Start transmit. Syntax: put <local name> [<remote name>] */
static int doput(int argc,char *argv[])
{
	char *remotename,*localname;
	struct ftp *ftp;
	FILE *dir();

	if((ftp = current_ftp) == NULLFTP){
		printf(notsess);
		return 1;
	}
	if (ftp->state != COMMAND_STATE) {
		printf("Transfer in progress; use ABORT to terminate\n");
		return 1;
	}
#if	DEMO
	if (abortftpdemo(ftp) != 0)
		return 1;
#endif
	localname = argv[1];
	if(argc < 3)
		remotename = 0;
	else
		remotename = argv[2];

	if(ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);

/*  for MSDOS the EOL for text files is the same as that of FTP
	if(ftp->type == IMAGE_TYPE)
		mode = binmode[READ_BINARY];
	else
		mode = "r";
*/
	ftp->flags &= ~FF_APPEND;
	if (argv[0][0] == 'a')
		ftp->flags |= FF_APPEND;
	if (strchr(localname,'*') != NULL || strchr(localname,'?') != NULL) {
		if ((ftp->fplist = dir(localname,0)) != NULL) {
			char *p;
			if (ftp->cd)
				free(ftp->cd);
			for (p = localname + strlen(localname) - 1;
							p != localname;--p) {
				ftp->cd = 0;
				if (*p == '\\' || *p == '/' || *p == ':') {
					p[1] = 0;
					ftp->cd = malloc(strlen(localname) + 1);
					if (ftp->cd)
						strcpy(ftp->cd,localname);
					else {
						printf(nospace);
						return 1;
					}
					break;
				}
			}
			localname = 0;
		}
		else {
			printf(cantread,localname);
			return 1;
		}
	}
	return startput(ftp,localname,remotename);
}

/* Abort a GET or PUT operation in progress. Note: this will leave
 * the partial file on the local or remote system
 */
#pragma argsused
doabort(int argc,char *argv[])
{
	register struct ftp *ftp;
	char wait_typeok = 0;

	ftp = current_ftp;

	if (window_shown)
		hide_window();
	shown = 0;
	/* Close the local file */
	if(ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);
	ftp->fp = NULLFILE;
	if(ftp->fplist != NULLFILE)
		fclose(ftp->fplist);
	ftp->fplist = NULLFILE;

	switch(ftp->state){
	case SENDING_STATE:
	case SEND_RDY_STATE:
		/* Send a premature EOF.
		 * Unfortunately we can't just reset the connection
		 * since the remote side might end up waiting forever
		 * for us to send something.
		 */
		CloseTcp(ftp->data);
		printf("Put aborted\n");
		break;
	case LISTED_STATE:
		if (ftp->type == IMAGE_TYPE) {
			wait_typeok = 1;
		}
		break;
	case LIST_STATE:
	case LIST_RDY_STATE:
		if (ftp->type == IMAGE_TYPE) {
			wait_typeok = 1;
		}
		/* fall through */
	case RECEIVING_STATE:
	case RECV_RDY_STATE:
	case RCVLIST_STATE_WPOK:
	case RCVNLST_STATE_WPOK:
	case RECEIVING_STATE_WPOK:
	case SENDING_STATE_WPOK:
		/* Just exterminate the data channel TCB; this will
		 * generate a RST on the next data packet which will
		 * abort the sender
		 */
		DelTcp(ftp->data);
		ftp->data = 0;
		printf("Get aborted\n");
		break;
	}
	if (!error_code)
		error_code = XFER_ABORTED;
	ftp->state = wait_typeok ? COMMAND_STATE_WTOK : COMMAND_STATE;
	showstat();
	return sndftpmsg(ftp,wait_typeok ? "TYPE I\r\n" : "ABOR\r\n");
}

/* create data port, and send PORT message */
static void ftpsetup(struct ftp *ftp,int rcv)
{
	struct isocket lsocket;
	 int cnt;
	char bp[35];

	ftp->error = 0;
	lsocket.dwAddress = GetTcb(ftp->control)->conn.sLocal.dwAddress;
	lsocket.wPort = 0;

	if (!(ftp->flags & FF_PASV)) {
		/* Post a listen on the data connection */
		ftp->data = OpenTcp(&lsocket,0,TCP_PASSIVE,0,0,0,0,0,(char *)ftp);
		/* Compose and send PORT a,a,a,a,p,p message */
		lsocket.wPort = GetTcb(ftp->data)->conn.sLocal.wPort;
		sprintf(bp,"PORT %u,%u,%u,%u,%u,%u\r\n",
			hibyte(hiword(lsocket.dwAddress)),
			lobyte(hiword(lsocket.dwAddress)),
			hibyte(loword(lsocket.dwAddress)),
			lobyte(loword(lsocket.dwAddress)),
			hibyte(lsocket.wPort),
			lobyte(lsocket.wPort));
	}
	else {
		sprintf(bp,"PASV\r\n");
	}
	ftp->mode = rcv;
	cnt = strlen(bp);
	SendTcp(ftp->control,bp,cnt,0);

	ftp->time = tick_timer();		/* start time of transfer */
	ftp->flags |= FF_WPOK;		/* waiting for port ok */
}

void ftp_line(struct ftp *ftp,char *lb)	/* handle incoming ftp line */
{
	union {
		struct isocket sock;
		char numar[6];
	} fsocket;
	struct isocket lsocket;
	int code,i,num;
	char digitseen = 0;
	char uname = 0;
	char prompt = 0;
	char port_ok = 0;
	char fdigit = lb[0];
	int len;
	char *line;
	char *pcom;

	if (isdigit(lb[0]) && isdigit(lb[1]) && isdigit(lb[2]) &&
					(lb[3] == ' ' || lb[3] == '-'))
		code = atoi(lb);
	else
		code = 0;
	if (code && lb[3] != '-' && code != 221 &&
		((fdigit == '2' && !(ftp->flags & FF_WPOK)) || fdigit >= '3'))
		prompt = 1;
	if ((ftp->flags & (FF_PASV | FF_WPOK)) == (FF_PASV | FF_WPOK) && code != 530) {
		if (fdigit == '5') {	// pasv not working!
			ftp->flags &= ~FF_PASV;
			ftpsetup(ftp,ftp->mode);
			return;
		}
		else if (code == 227) {
			ftp->flags &= ~FF_WPOK;
			port_ok = 1;
			prompt = 0;
			for (pcom = lb + 4,i = 0,num = 0;*pcom && i < 6;++pcom) {
				if (isdigit(*pcom)) {
					digitseen = 1;
					num = num * 10 + *pcom - '0';
				}
				else if (digitseen) {
					if (i < 4)
						fsocket.numar[3 - i++] = num;
					else
						fsocket.numar[9 - i++] = num;
					num = 0;
				}
			}
			lsocket.wPort = 0;
			lsocket.dwAddress = 0l;
			ftp->data = OpenTcp(&lsocket,&fsocket.sock,TCP_ACTIVE,0,0,0,0,0,
															(char *)ftp);
		}
	}
	else {
		if (code == 200)
			port_ok = 1;
		ftp->flags &= ~FF_WPOK;
	}
	if (code == 220 && fpinput == NULL) {
		prompt = 0;
		uname = 1;
		ftp_qdisp(ftp,"\r",1);	// printf("\r");
	}
	if (code != 331) {
		if (ftp->flags & FF_PASSWORD) {
			ftp->flags &= ~FF_PASSWORD;
			cooked();
		}
		if (ftp->verbose || (code != 150 && code != 200 &&
											code != 226 && code != 227)) {
			ftp_qdisp(ftp,lb,ftp->lbindex); // winwrite(lb,ftp->lbindex);
		}
	}
	else {	// 331 Enter PASS
		ftp->flags &= ~FF_USERNAME;
		if (fpinput == NULL) {
			ftp->flags |= FF_PASSWORD;
			ftp_qdisp(ftp,"Password: ",10);	// printf("Password: ");
			secret();
			prompt = 0;
		}
	}
	if (code == 230)	// 230 Logged in
		ftp->flags &= ~(FF_USERNAME | FF_PASSWORD);
	if (code >= 400)
		error_code = code - 400 + FTP_ERROR;
	if (code >= 500) {
		if (ftp->remotename) {
			free(ftp->remotename);
			ftp->remotename = 0;
		}
		if (ftp->data) {
			//dolstat(0,0);	// for debugging
			//ftp->data = 0;
			doabort(0,0);
			prompt = 0;
		}
		else
			ftp->state = COMMAND_STATE;
	}
	if (code == 226 || code == 250) {
		switch (ftp->state) {
		case SENDING_STATE:
			ftp->state = SEND_RDY_STATE;
			break;
		case SENT_STATE:
			ftp->state = COMMAND_STATE;
			if (ftp->fplist) {
				if (startput(ftp,0,0) == 0) {
					prompt = 0;
				}
			}
			break;
		case LIST_STATE:
			ftp->state = LIST_RDY_STATE;
			prompt = 0;
			break;
		case LISTED_STATE:
			if (ftp->type == IMAGE_TYPE) {
				sndftpmsg(ftp,"TYPE I\r\n");
				ftp->state = LISTED_STATE_WTOK;
				prompt = 0;
				break;
			}
		case RECEIVED_STATE:
			ftp->state = COMMAND_STATE;
			if (ftp->fplist) {
				if (startget(ftp,0,0) == 0) {
					prompt = 0;
				}
			}
			break;
		case RECEIVING_STATE:
			ftp->state = RECV_RDY_STATE;
			prompt = 0;
			break;
		}
	}
	else switch (ftp->state) {
	case LIST_STATE_WTOK:
		if (code == 200) {
			ftpsetup(ftp,1);
			ftp->state = LIST_STATE_WPOK;
			prompt = 0;
		}
		break;
	case LIST_STATE_WPOK:
		if (port_ok) {
			sndftpmsg(ftp,"NLST %s\r\n",ftp->remotename);
			ftp->state = LIST_STATE;
			prompt = 0;
			goto free_name;
		}
		break;
	case LISTED_STATE_WTOK:
		ftp->state = COMMAND_STATE;
		if (code == 200 && ftp->fplist) {
			if (startget(ftp,0,0) == 0) {
				prompt = 0;
			}
		}
		break;
	case RECEIVING_STATE_WPOK:
		pcom = "RETR";
		goto do_recv;
	case RCVLIST_STATE_WPOK:
		pcom = "LIST";
		goto do_recv;
	case RCVNLST_STATE_WPOK:
		pcom = "NLST";
		do_recv:
		if (port_ok) {
			sndftpmsg(ftp,"%s%s%s\r\n",pcom,
				ftp->remotename ? " " : "",
				ftp->remotename ? ftp->remotename : "");
			ftp->state = RECEIVING_STATE;
			prompt = 0;
			goto free_name;
		}
		break;
	case SENDING_STATE_WPOK:
		if (port_ok) {
			sndftpmsg(ftp,"%s %s\r\n",ftp->flags & FF_APPEND ?
					"APPE" : "STOR",ftp->remotename);
			ftp->state = SENDING_STATE;
			prompt = 0;
			free_name:
			if (ftp->remotename) {
				free(ftp->remotename);
				ftp->remotename = 0;
			}
		}
		break;
	case COMMAND_STATE_WTOK:
		if (code == 200) {
			ftp->state = COMMAND_STATE;
			prompt = 0;
		}
		break;
	case LIST_STATE:
	case LIST_RDY_STATE:
	case LISTED_STATE:
	case RECEIVING_STATE:
		prompt = 0;
		break;
	}
	if (uname) {
		ftp_qdisp(ftp,"\rUsername: ",11); // printf("\rUsername: ");
		ftp->flags |= FF_USERNAME;
	}
	else if (prompt) {
		if (fpinput && (len = getfline(&line)) != -1) {
				ftp_command(ftp,line,len);
		}
		else {
			ftp_qdisp(ftp,"\rftp> ",6);
		}
	}
	showstat();
}

/* Send a message on the control channel */
int sndftpmsg(struct ftp *ftp,char *fmt,...)
{
	WORD len;
	va_list ap;
	char dlin [100];

	if (!ftp)
		ftp = current_ftp;
	va_start(ap, fmt);
	len = vsprintf(dlin, fmt, ap);
	va_end(ap);
	SendTcp(ftp->control,dlin,len,0);
	return 0;
}

/* function to determine whether 'name' specifies the console */
int isconsole(char *name)
{
	char *p;
	int len;

	if (name[0] == '\\')
		++name;
	if (name[1] == ':')
		name += 2;
	if ((p = strrchr(name,'\\')) != 0)
		name = p + 1;
	if ((p = strrchr(name,'/')) != 0)
		name = p + 1;
	len = strlen(name);
	return (len == 3 || (len > 3 && (name[3] == '.' || name[3] == ':'))) &&
		!strnicmp(name,"con",3);
}

#define X	30
#define Y	12
#define W	20
#define H	2

char win_buf[(W+1) * (H+1) * 2];
char prog_buf[(W+1) * (H+1) * 2];

char window_exist;

void show_window(void)
{
	int x,y,i;

	if (no_window)
		return;
	if (!window_shown) {
		x = wherex();
		y = wherey();
		gettext(X,Y,X + W,Y + H,prog_buf);
		window_shown = 1;
		if (!window_exist) {
			window(X,Y,X + W,Y + H);
			clrscr();
			gotoxy(1,1);
			putch('');
			for (i = 1;i < W;++i)
				putch('');
			putch('');
			for (i = 2;i <= H;++i) {
				gotoxy(1,i);
				putch('');
				gotoxy(W + 1,i);
				putch('');
			}
			gotoxy(1,H + 1);
			putch('');
			for (i = 1;i < W;++i)
				putch('');
			window(1, 1, 80, 25);
			gotoxy(X + W,Y + H);
			putch('');
			gettext(X,Y,X + W,Y + H,win_buf);
			window_exist = 1;
		}
		else
			puttext(X,Y,X + W,Y + H,win_buf);
		window(1, 1, 80, 25);
		gotoxy(x,y);
	}
}

void hide_window(void)
{
	int x,y;

	if (no_window)
		return;
	if (window_shown) {
		x = wherex();
		y = wherey();
		window_shown = 0;
//		window(X,Y,X + W,Y + H);
		gettext(X,Y,X + W,Y + H,win_buf);
		puttext(X,Y,X + W,Y + H,prog_buf);
//		window(1, 1, 80, 25);
		gotoxy(x,y);
	}
}

void write_window(int xpos,int ypos,char *str)
{
	int x,y;

	if (no_window)
		return;
	x = wherex();
	y = wherey();
	if (!window_shown)
		show_window();
	gotoxy(X + xpos,Y + ypos);
	cputs(str);
	gotoxy(x,y);
}

void repargs(char *buf,int bufsiz)
{
	char *bufp = buf;
	char *prep,*pend;
	char ch;
	int i,len,room,left,gap;
	int argc = argcount;
	char **argv = argval;

	buf[bufsiz - 1] = 0;
	while ((ch = *bufp++) != 0) {
		if (ch == '%') {
			if (isdigit(ch = *bufp)) {
				++bufp;
				gap = 2;
				prep = ((i = ch - '0') <= argc) ? argv[i] : "";
				goto replace;
			}
			else if ((pend = strchr(bufp,'%')) != 0) {
				*pend = 0;
				strupr(bufp);
				if ((prep = getenv(bufp)) == 0)
					prep = "";
				gap = pend - bufp + 1;
				bufp += gap++;
				replace:
				len = strlen(prep);
				if (len <= gap) {
					strncpy(bufp - gap,prep,len);
					if (len < gap)
						strcpy(bufp - gap + len,bufp);
					bufp += (len - gap);
					continue;
				}
				room = buf - bufp + bufsiz + 1;
				if (len < room) {
					char *ps,*pd;

					room -= len;
					left = strlen(bufp);
					if (left > room)
						left = room;
					ps = bufp + left -1;
					pd = ps + len - gap;
					pd[1] = 0;
					while (left--) {
						*pd-- = *ps--;
					}
				}
				else
					len = room;
				strncpy(bufp - gap,prep,len);
				bufp += (len - gap);
			}
			else if (ch) {
				strcpy(bufp - 1,bufp);
				++bufp;
			}
		}
	}
}

int test_key(void);

getfline(char **buf)		/* get a line from input file */
{
	int len;

	if (fpinput) {
		if ((*buf = fgets(inbuf,INBUFSIZE,fpinput)) != NULL && test_key() != ALT_X) {
			len = strlen(inbuf);
			if (inbuf[len - 1] == '\n')
				len--;
			inbuf[len++] = '\r';
			inbuf[len++] = '\n';
			inbuf[len] = 0;
			repargs(inbuf,INBUFSIZE);
			return strlen(inbuf);
		}
		fclose(fpinput);
		fpinput = 0;
	}
	return -1;
}
