//
//   $Id: FTPDATA.C 1.4 2003/02/15 00:32:38Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Portions Copyright (c) 1993-2002 GP van Niekerk Ondernemings
//   Portions Copyright (c) 1986-1989 Phil Karn, KA9Q
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
ftp.c
Routines common to both the FTP server and client
*/

#include <stdio.h>
#include <alloc.h>
#include <string.h>
#include <errno.h>
#include <dos.h>
#include "inetdefs.h"
#include "compiler.h"
#include "api.h"
#include "apic.h"
#include "ftp.h"

extern FILE *fpinput;

DWORD tick_timer(void);
void ftp_qdisp(struct ftp *ftp,char *buf,int len);
startput(struct ftp *ftp,char *locname,char *rname);
startput(struct ftp *ftp,char *locname,char *rname);
void ftp_command(struct ftp *ftp,char *line,int len);
int sndftpmsg(struct ftp *ftp,char *fmt,...);
startget(struct ftp *ftp,char *locname,char *rname);
void get_timestr(char *time_buf,DWORD time);

/* FTP Data channel Receive handler */
void ftpdr(struct ftp *ftp)
{
	char buf[500];
	char *line,str[50];
	char prompt = 0;
	int cnt,len;
	char t_str[20];
	DWORD number;
	DWORD time;
	TCB far *tcb = GetTcb(ftp->data);

	if (ftp->state != RECEIVING_STATE && ftp->state != LIST_STATE &&
		ftp->state != RECV_RDY_STATE && ftp->state != LIST_RDY_STATE) {
		if (tcb->state == FINWAIT2)
			ResetTcp(ftp->data);	/* shut him up for good */
		return;
	}
	while ((cnt = RecvTcp(ftp->data,buf,500,0)) > 0) {
		sprintf(str,"%ld",tcb->rcv.nxt - tcb->irs - 1);
		write_window(11,1,str);
		if (ftp->fp == Stdout) {
			ftp_qdisp(ftp,buf,cnt);
		}
		else if (ftp->fp) {
			if (fwrite(buf,1,cnt,ftp->fp) != cnt) {
				ftp->error = errno;
				goto close_it;
			}
		}
	}
	if (cnt != - WOULDBLK && cnt != -RE_ENTER) {
		close_it:
		number = tcb->rcv.nxt - tcb->irs - 2;
		CloseTcp(ftp->data);
		ftp->data = 0;
		if (ftp->state == RECEIVING_STATE ||
						ftp->state == RECV_RDY_STATE) {
			/* End of file received on incoming file */
			if ((time = tick_timer() - ftp->time) == 0)
				time = 1;
			if (ftp->error) {
				ftp_qdisp(ftp,"Write error\n",12);
			}
			get_timestr(t_str,time);
			len = sprintf(buf,"%lu byte%s received "
					"in %s seconds, %lu bytes/second\n",
					number,number != 1 ? "s" : "",
					t_str, (number * 91) / (time * 5));
			hide_window();
			ftp_qdisp(ftp,buf,len);
			if(ftp->fp != Stdout)
				fclose(ftp->fp);
			ftp->fp = NULLFILE;
			if (ftp->state == RECV_RDY_STATE) {
				goto rcvok;
			}
			else {
				ftp->state = RECEIVED_STATE;
			}
		}
		else if (ftp->state == LIST_STATE || ftp->state == LIST_RDY_STATE) {
			rewind(ftp->fplist = ftp->fp);
			ftp->fp = NULLFILE;
			if (ftp->state == LIST_RDY_STATE) {
				if (ftp->type == IMAGE_TYPE)
					sndftpmsg(ftp,"TYPE I\r\n");
				rcvok:
				ftp->state = COMMAND_STATE;
				if (ftp->fplist) {
					if (startget(ftp,0,0) != 0) {
						prompt = 1;
					}
				}
				else {
					prompt = 1;
				}
			}
			else
				ftp->state = LISTED_STATE;
		}
		if (prompt) {
			if (fpinput && (len = getfline(&line)) != -1) {
					ftp_command(ftp,line,len);
			}
			else {
				ftp_qdisp(ftp,"\rftp> ",6);
			}
		}
	}
}

/* FTP Data channel Transmit handler */
void ftpdt(struct ftp *ftp)
{
	char eof_flag;
	char *line;
	char str[80],t_str[20];
	static char buf[2000];
	static char *pbuf;
	static int rcnt;
	TCB far *tcb = GetTcb(ftp->data);
	int cnt,len;
	char prompt = 0;
	unsigned long number;
	DWORD time;

	if (ftp->state != SENDING_STATE && ftp->state != SEND_RDY_STATE) {
		return;
	}
	if ((cnt = RecvTcp(ftp->data,0,0,0)) != 0) {
		goto tcp_error;
	}
	if (tcb->state >= LISTEN && tcb->state < ESTABLISHED)
		return;
	if ((cnt = tcb->window - tcb->sndcnt) <= 0)
		return;
	if (cnt > 2 * tcb->mss)
		cnt = 2 * tcb->mss;
	if (cnt > 2000)
		cnt = 2000;
	eof_flag = 0;
	if (!rcnt) {
		rcnt = fread(buf,1,cnt,ftp->fp);
		if (rcnt < 0)
			goto error1;
		pbuf = buf;
		if (rcnt != cnt)
			eof_flag = 1;
		if (ftp->type == ASCII_TYPE) {
			char *p;
			if ((p = memchr(buf,CTLZ,rcnt)) != 0) {
				rcnt = p - buf;
				eof_flag = 1;
			}
		}
	}
	if(rcnt) {
		cnt = SendTcp(ftp->data,pbuf,rcnt,0);
		if (cnt == -NO_SPACE || cnt == -WOULDBLK || cnt == -RE_ENTER)
			return;
		if (cnt < 0) {
			tcp_error:
			ftp->error = -1;
			goto error;
		}
		rcnt -= cnt;
		pbuf += cnt;
	}
	sprintf(str,"%ld",tcb->snd.una - tcb->iss - 1);
	write_window(7,1,str);
	if (eof_flag && !rcnt) {	/* EOF seen */
		error1:
		if (ferror(ftp->fp) != 0)
			ftp->error = errno;
		error:
		rcnt = 0;
		fclose(ftp->fp);
		ftp->fp = NULLFILE;
		if ((time = tick_timer() - ftp->time) == 0)
			time = 1;
		disable();
		number = tcb->snd.una - tcb->iss - 1 + tcb->sndcnt;
		enable();
		CloseTcp(ftp->data);
		ftp->data = 0;
		if (ftp->error) {
			len = sprintf(str,"%s error\n",
								ftp->error == -1 ? "Connection" : "Read");
			ftp_qdisp(ftp,str,len);
		}
		get_timestr(t_str,time);
		len = sprintf(str,"%lu byte%s sent in %s seconds, %lu bytes/second\n",
			number,number != 1 ? "s" : "",t_str, (number * 91) / (time * 5));
		hide_window();
//		if (ftp->session == current) {
//			screen_string("",2,24,window_col[BORDER]);
//		}
		ftp_qdisp(ftp,str,len);
		if (ftp->state == SEND_RDY_STATE) {
			ftp->state = COMMAND_STATE;
			if (ftp->fplist) {
				if (startput(ftp,0,0) != 0) {
					prompt = 1;
				}
			}
			else {
				prompt = 1;
			}
		}
		else
			ftp->state = SENT_STATE;
	}
	if (prompt) {
		if (fpinput && (len = getfline(&line)) != -1) {
			ftp_command(ftp,line,len);
		}
		else {
			ftp_qdisp(ftp,"\rftp> ",6);
		}
	}
}

/* Allocate an FTP control block */
struct ftp *ftp_create(unsigned bufsize)
{
	void ftp_delete();
	register struct ftp *ftp;

	if((ftp = (struct ftp *)calloc(1,sizeof (struct ftp))) == NULLFTP)
		return NULLFTP;
	if(bufsize != 0 && (ftp->buf = malloc(bufsize)) == NULLCHAR){
		ftp_delete(ftp);
		return NULLFTP;
	}
	ftp->state = COMMAND_STATE;
	ftp->type = ASCII_TYPE;	/* Default transfer type */
	return ftp;
}
/* Free resources, delete control block */
void ftp_delete(register struct ftp *ftp)
{
	if (ftp->fp != NULLFILE && ftp->fp != Stdout)
		fclose(ftp->fp);
	if (ftp->fplist != NULLFILE)
		fclose(ftp->fp);
	if (ftp->data != 0)
		DelTcp(ftp->data);
	if (ftp->username != NULLCHAR)
		free(ftp->username);
	if (ftp->path != NULLCHAR)
		free(ftp->path);
	if (ftp->buf != NULLCHAR)
		free(ftp->buf);
	if (ftp->cd != NULLCHAR)
		free(ftp->cd);
	if (ftp->oldname != NULLCHAR)
		free(ftp->oldname);
	if (ftp->remotename != NULLCHAR)
		free(ftp->remotename);
	if (ftp->linebuf != NULLCHAR)
		free(ftp->linebuf);
	free((char *)ftp);
}

void get_timestr(char *time_buf,DWORD time)
{
	int cnt;

	sprintf(time_buf,"%04lu",(time * 10000)/182);
	cnt = strlen(time_buf);
	time_buf[cnt] = time_buf[cnt - 1];
	time_buf[cnt - 1] = time_buf[cnt - 2];
	time_buf[cnt - 2] = time_buf[cnt - 3];
	time_buf[cnt + 1] = 0;
	time_buf[cnt - 3] = ',';
}

DWORD tick_timer(void)
{
	return *((DWORD far *)MK_FP(0x40,0x6c));
}

