#
#   $Id: HTTPGET.MAK 1.8 2003/08/21 14:08:48Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# HTTPGET.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 06/21/2001 jmb added cleanall target
# 04/30/2001 jmb added ROMDOS INCLUDE to the include search path and pathed to
#                ROMDOS libraries.
# 04/17/2001 jmb added code to delete the HTTGET.CFG file on CLEAN
# 04/09/2001 jmb Ported from a Borland C++ Generated makefile
#
.AUTODEPEND

all:    httpget httpput
	@if exist ..\httpget.exe del ..\httpget.exe >nul
	@copy httpget.exe ..\httpget.exe >nul
    @if exist ..\httpput.exe del ..\httpput.exe >nul
    @copy httpput.exe ..\httpput.exe >nul

clean:
    @echo Cleaning HTTPGET/PUT
	@if exist *.cfg del *.cfg >nul
	@if exist *.log del *.log >nul
	@if exist *.obj del *.obj >nul
	@if exist *.pt del *.pt >nul
	@if exist httpget.map del httpget.map >nul
    @if exist httpput.map del httpput.map >nul

cleanall: clean
    @if exist httpget.exe del httpget.exe >nul
    @if exist httpput.exe del httpput.exe >nul

#		*Translator Definitions*
CC = bcc
TLINK = tlink

#
# Options
#
LFLAGS = $(RD_SW_L) -c -x -P-
CFLAGS = $(RD_SW) 
STARTUP= c0s.obj
LIBS   = emu.lib+maths.lib cs.lib graphics.lib ..\..\..\lib\dls.lib

HTTPGET_OBJS =  \
  httpget.obj \
  api.obj

HTTPPUT_OBJS =  \
  httpput.obj \
  api.obj

#
# Dependency List
#
httpget : httpget.exe
httpput : httpput.exe

httpget.exe : httpget.cfg $(HTTPGET_OBJS)
  $(TLINK)  $(LFLAGS) @&&|
	$(STARTUP)+httpget.obj+api.obj
	$<
			# no map file
	$(LIBS)
|

httpput.exe : httpget.cfg $(HTTPPUT_OBJS)
  $(TLINK)  $(LFLAGS) @&&|
    $(STARTUP)+httpput.obj
	$<
			# no map file
	$(LIBS) ..\..\lib\capis.lib ..\..\lib\sockets.lib
|

#       *Individual File Dependencies*
httpget.obj: httpget.c api.pt

httpput.obj: httpput.c

api.obj: api.c

#		*Compiler Configuration File*
httpget.cfg: httpget.mak
  copy &&|
-I..\..\include;..\..\..\include 
-DDL;
-K
-C
-G
-O
-Z
-k-
#-H=HTTPGET.SYM
| httpget.cfg

#		*Implicit Rules*
.c.obj:
  $(CC) -c $(CFLAGS) @httpget.cfg {$< }

.c.pt:
  proto $*.c > $*.pt

