//
//   $Id: ILPR.C 1.7 2003/07/23 17:06:58Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//
// ilpr.c
//
// Copyright (c) 1996-2001 Datalight, Inc.
// Confidential and Proprietary
// All Rights Reserved
// Portions copyright (c) GPvNO 2001
//
// DOS LPR Client
//
// $DOCHISTORY
//  04/30/2001 jmb used ROMDOS version number and copyright info.
//  04/26/2001 jmb added header
//

#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys\stat.h>
#include <time.h>

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

#include "compiler.h"
#include "api.h"
#include "capi.h"
#include "ini.h"

//===========================================================================
// Defines
//===========================================================================
#define BLOCKSIZE       1024
#define ERROR           0
#define OK              1
#define PROGRAM_OK      0
#define PROGRAM_ERROR   1
//===========================================================================
// Global Variables
//===========================================================================
TCB     *connection_tcb;    // Connection TCB
int     PauseForUser = 1;   // Set when user must acknowledge
char    Entry[80];          // Used in GetPrivateProfileString
char    Printer[80];        // Printer to which printing is done
char    Server[80];         // Name of LPD Server
char    JobName[80];        // Jobname
char    IniFile[80];        // Ini-File location
char    LocalUser[80];      // Name of user
char    HostName[80];       // Host name
char    ClassName[80];      // Class name
char    cfn[80];            // Control file name
char    dfn[80];            // Data file name
char    BinaryData = 1;     // Set when file is binary
char    *TransmitBuffer;    // Buffer for transmitted data
unsigned int TransmitSize;  // Size of transmitbuffer
unsigned int LpdPort = 515; // Port of LPD Server
unsigned int JobNumber;     // Number of job if jobname is not given
unsigned int api_int;		// API interrupt
unsigned int api_intc;      // Compatible API interrupt
char    id[]  = "Inet";
char    id1[] = "RinetI";
union   REGS r;
struct  SREGS sr;
unsigned adrh   = 0xc40A;
unsigned adrl   = 0xE502;
TCP_OP_P op     = {0,515,0,TCP_ACTIVE,0,0,0,0,0,0};
unsigned int tcbo;
char    *FileNameArray[10]; // Array of files or usernames or jobnumbers
int     FileNameIndex = 0;  // Number of specified files, jobnumbers,users
unsigned char   ip_addr[4], is_id;

//===========================================================================
// Prototypes for functions in LPR.C
//===========================================================================
char    *err(unsigned errcode);
int     SendTheFiles(char *file);
int     SendReceiveJob(void);
int     WaitForAcknowledge(void);
int     SendControlFile(char *file);
int     SendDataFile(char *file);
int     QueryQueue(char **Files);
int     RemoveFiles(char **Files);
int     OpenConnection(void);
void    CloseConnection(void);
void    Acknowledge(void);
char*	getsw(char *str);
//===========================================================================
// Return error code string for TCP errors, etc.
//===========================================================================
char *err(unsigned errcode)
{
	static char unk[30];
	static char *errs[] = {
		"No error",
		"Connection already exists",
		"Connection does not exist",
		"Connection closing",
		"No memory for TCB or buffer creation",
		"Would block",
		"Protocol or mode not supported",
		"Invalid arguments"
	};

	if (errcode > INVALID) {
		sprintf(unk,"Unknown error %u",errcode);
		return unk;
	}
	return errs[errcode];
}

//===========================================================================
//
//===========================================================================
#pragma argsused
void repargs(char *buf,int bufsiz)
{
}

//===========================================================================
// Main Routime of LPR.C
//===========================================================================
int main(int argc, char *argv[])
{
void interrupt (*int_apiv)(void);
// 1.00 95-10-15 First release
// 1.01 95-10-17 Added jobnumber display, pause if error
// 1.12 96-01-16 Added IP to hostname field if not specified
// 1.13 96-03-14 Fixed fail if no ini or no API
// 1.14 96-03-19 change Name in control file
// 1.15 96-04-16 fix abs references to API
// 1.16 03-02-14 use api.h instead of _api.h
// Ŀ
//                                          

#ifndef DL
static char Help[] =  "\nSockets LPR Client Version 1.16(dt)\n\n"
#else
static char Help[] =  "\nDatalight Sockets LPR Client usage:\n"
#endif
				"TO PRINT FILES:    LPR [options] file(s)\n"
				"TO REQUEST STATUS: LPR /q [options] [List of user names or job numbers]\n"
				"TO REMOVE JOBS:    LPR /r [options] <agent> [List of usernames or job numbers]\n"
				"where options are:\n"
				"/l=<prt>     is the LPD server's listening port. Normally 515\n"
				"/n           is to enable batch mode without prompting\n"
				"/t           is to strip control characters. (Text mode only)\n"
				"/s=<server>  is the LPD server's IP address or host name\n"
				"/p=<printer> is the name of the printer on the LPD server\n"
				"/h=<name>    is your local host name\n"
				"/u=<name>    is your registered user name on the LPD server\n"
				"/c=<name>    is the print job's class name\n"
				"/j=<name>    is the job name. If not given, file name will substituted\n"
				"<agent>      is your local user name. Same as /u. Can also be 'root'\n"
				"\nNOTE:\nAll of these parameters are optional, except files, depending on SOCKET.INI\n"
				"You can also use - instead of / for options. /s= or -s= is valid.\n";
char far    *pid;
char        *cp, *psz, *param;
unsigned    i, ParmCounter = 0;
int         FileNumber, Query = 0, RemoveMode = 0;
int         api, size = 4;

	if((psz = getenv("SOCKETS")) == 0)
		psz = "\\dl\\sockets\dos";
	strcpy(IniFile, psz);
	strcat(IniFile, "\\socket.ini");

	OpenProfile(IniFile);
	GetPrivateProfileString("LPR", "Username", "",  LocalUser, sizeof(LocalUser), IniFile);
	GetPrivateProfileString("LPR", "Printer",  "",  Printer,   sizeof(Printer),   IniFile);
	GetPrivateProfileString("LPR", "Hostname",  "", HostName,  sizeof(HostName),  IniFile);
	GetPrivateProfileString("LPR", "Server",  "",   Server,    sizeof(Server),    IniFile);
	GetPrivateProfileString("LPR", "Class",  "",    ClassName, sizeof(ClassName), IniFile);
	GetPrivateProfileString("LPR", "Job",  "",      JobName,   sizeof(JobName),   IniFile);
	GetPrivateProfileString("LPR", "Binary",  "1",  Entry,     sizeof(Entry),     IniFile);
	BinaryData = atoi(Entry);
	GetPrivateProfileString("LPR", "Port",  "515",  Entry,     sizeof(Entry),     IniFile);
	LpdPort = atoi(Entry);
	CloseProfile();

	randomize();
	JobNumber   = random(1000);

	for(api = 0x20; api < 0x100; ++api)
	{
		int_apiv = getvect(api);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0, is_id = 1; i < 4; ++i)
			if (pid[i] != id[i])
				is_id = 0;
		if (is_id)
			api_int = api;
		pid = (char far *)int_apiv - 6;
		for (i = 0,is_id = 1;i < 6;++i)
			if (pid[i] != id1[i])
				is_id = 0;
		if (is_id)
			api_intc = api;
		if (api_int && api_intc)
			break;
	}

	if(argc <= 1)
	{
#ifdef DL
   	printf("Datalight Sockets LPR ");
	   if (dlIsFat32World())
   		printf("%s ", SHORTVERSION);
	   else
   		printf("%s ", SHORTVERSION622);
	   printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
		   BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif
		printf(Help);
		Acknowledge();
		return PROGRAM_OK;
	}

	for(argv++; argc > 1; argv++, argc--)
	{
		cp = *argv;
		if((*cp == '-') || (*cp == '/'))
		{
			param = cp+2;
			if(*param == '=')
				param++;
			switch (*(cp+1))
			{
				case '?':
					printf(Help);
					Acknowledge();
					return PROGRAM_OK;
				case 'c':   // Class name
				case 'C':
					strcpy(ClassName, param);
					break;
				case 'h':   // Host name
				case 'H':
					strcpy(HostName, param);
					break;
				case 'J':   // Job name
				case 'j':
					strcpy(JobName, param);
					break;
				case 'L':   // LPD port if 515 is not default
				case 'l':
					LpdPort = atoi(param);
					break;
				case 'N':   // Don't pause if there is errors
				case 'n':
					PauseForUser = 0;   // Don't pause
					break;
				case 'P':   // Printer name
				case 'p':
					strcpy(Printer, param);
					break;
				case 'Q':   // Set query mode mode. Overides Remove mode
				case 'q':
					RemoveMode = 0;
					Query      = 1;
					break;
				case 'R':   // Set remove mode
				case 'r':
					RemoveMode = 1;
					break;
				case 'S':   // Name of server
				case 's':
					strcpy(Server, param);
					break;
				case 'T':   // Set binary modes
				case 't':
					BinaryData = 0;
					break;
				case 'u':   // User name
				case 'U':
					strcpy(LocalUser, param);
					break;
				default:
					printf("\nInvalid parameter: %c\n", *(cp+1));
					break;
			}
		}
		else
		{
			switch(ParmCounter++)
			{
				default:
					FileNameArray[FileNameIndex] = malloc(strlen(cp)+1);
					if(FileNameArray[FileNameIndex] != NULL)
					{
						strcpy(FileNameArray[FileNameIndex], cp);   // Add filenames to some list to send here
						FileNameIndex++;
					}
					break;
			}
		}
	}

	if (api == 0x100)
	{
		printf("\nSockets API not loaded\n");
		Acknowledge();
		exit(PROGRAM_ERROR);
	}
	while(*Server == 0)
	{
		printf("LPD Server Address = ");
		getsw(Server);
	}
	while(*Printer == 0)
	{
		printf("LPD Printer Name   = ");
		getsw(Printer);
	}
	if(Query == 0)
	{
		while(*LocalUser == 0)      // For printing and remove mode
		{
			printf("LPD User Name      = ");
			getsw(LocalUser);
			if (strcmp(LocalUser,"@#$") == 0) {
				*LocalUser = 0;
				break;
			}
		}
		if(RemoveMode == 0)         // Not in remove mode. Get local host name
			while(*HostName == 0)
			{
				sr.ds  = FP_SEG(ip_addr);
				r.x.si = FP_OFF(ip_addr);
				sr.es  = FP_SEG(&size);
				r.x.di = FP_OFF(&size);
				r.h.ah = GET_KERNEL_INFO;
				r.x.bx = 0;
				r.h.dh = K_INF_IP_ADDR;
				r.h.dl = 0;
				int86x(api_intc, &r, &r, &sr);
				sprintf(HostName, "%u.%u.%u.%u",ip_addr[0],ip_addr[1],
												ip_addr[2],ip_addr[3]);
			}
	}

	if(*ClassName == 0)
		strcpy(ClassName, HostName);

	r.x.cx = FP_OFF(Server);
	r.x.bx = FP_SEG(Server);
    r.h.ah = API_GETIPADR;
    int86(api_int,&r,&r);
    if (r.x.cx == 0 && r.x.dx == 0) {
        printf("\nUnknown host: %s\n", Server);
		Acknowledge();
        exit(PROGRAM_ERROR);
    }
    adrh = r.x.cx;
    adrl = r.x.dx;
	 op.wRemPort = LpdPort;
    printf("\n%s %u.%u.%u.%u:%u\n", Query + RemoveMode ? Query ? "Requesting status from" : "Deleting jobs from" : "Printing to",
		  adrh >> 8,adrh & 0xff,adrl >> 8,adrl & 0xff,op.wRemPort);
	 op.dwRemIPAd = ((long)adrh << 16) + adrl;

    if((TransmitBuffer = (char*)calloc(BLOCKSIZE, 1)) == NULL)
    {
        printf("\rCan't execute LPR command due to insufficient memory.\n");
		Acknowledge();
        return PROGRAM_ERROR;
    }

    if(Query == 1)
    {
        if(OpenConnection() == OK)
        {
            if(QueryQueue(FileNameArray) == ERROR)
            {
                printf("\rRequesting status from LPD server failed\n");
				Acknowledge();
            }
            CloseConnection();
			Acknowledge();
        }
    }
    else if(RemoveMode == 1)
    {
        if(OpenConnection() == OK)
        {
            if(RemoveFiles(FileNameArray) == ERROR)
            {
                printf("\rRemoving print jobs from LPD server failed\n");
				Acknowledge();
            }
            CloseConnection();
			Acknowledge();
        }
    }
    else
    {
		_setcursortype(_NOCURSOR);
        for(FileNumber = 0; FileNumber < FileNameIndex; FileNumber++)
        {
            OpenConnection();
            if(SendTheFiles(FileNameArray[FileNumber]) == ERROR)
            {
                printf("\rFile %s not printed                               \n", FileNameArray[FileNumber]);
				Acknowledge();
            }
            free(FileNameArray[FileNumber]);
            CloseConnection();
        }
		Acknowledge();
    }

    if(TransmitBuffer)
    {
		  free(TransmitBuffer);
        TransmitBuffer = 0;
    }
    return PROGRAM_OK;
}

//===========================================================================
// Send the data using TCP
//===========================================================================
int TcpWrite(WORD tcbo, char *keybuf,int keycnt,int urgent)
{
int sent = 0;

    do
    {
        r.x.si = FP_OFF(keybuf+sent);
        r.x.dx = FP_SEG(keybuf+sent);
        r.x.cx = keycnt - sent;
		  r.x.bx = tcbo;
        r.h.ah = API_TCPWRITE;
        r.h.al = urgent;
        int86(api_int,&r,&r);
        if (r.x.ax != 0)
        {
            printf("\rError on TCP_WRITE: %s                            \n",err(r.x.ax));
            return ERROR;
        }
        sent += r.x.cx;

        if(kbhit())
        {
            if(getch() == 0)
                getch();
            printf("\r                                             ");
			_setcursortype(_NORMALCURSOR);
            printf("\rDo you want to abort? (Y/N) : ");
            if(toupper(getche()) == 'Y')
                return ERROR;
        }

    } while(sent != keycnt);    // Add timeout here as well
    return OK;
}

//===========================================================================
//
//===========================================================================
int WaitForAcknowledge(void)
{
unsigned int    errcode;
unsigned int    ReceiveCount;
char    ReceiveBuffer[128];

	ReceiveCount = 0;
	while(ReceiveCount == 0)    // Add timeout of some sort!!
	{
		if(kbhit())
		{
			if(getch() == 0)
				getch();
			printf("\r                                             ");
			printf("\rDo you want to abort? (Y/N) : ");
			_setcursortype(_NORMALCURSOR);
			if(toupper(getch()) == 'Y')
				return ERROR;
		}
		r.x.si = FP_OFF(ReceiveBuffer);
		r.x.dx = FP_SEG(ReceiveBuffer);
		r.x.cx = sizeof(ReceiveBuffer);
		r.x.bx = tcbo;
        r.h.ah = API_TCPREAD;
        int86(api_int,&r,&r);
        ReceiveCount = r.x.cx;
        errcode      = r.x.ax;
        if(errcode != 0)
        {
            if (errcode != WOULDBLK)
            {
                printf("\rError on TCP_READ: %s                          \n",err(errcode));
                return ERROR;
            }
            continue;
        }
        if(ReceiveCount == 0)
        {
            printf("\rReceive Error: Connection closed by remote host       \n");
            return ERROR;
        }
    }
    return(!(*ReceiveBuffer));
}

//===========================================================================
// Send receive job command
//===========================================================================
int SendReceiveJob(void)
{
    TransmitSize = sprintf(TransmitBuffer, "\x02%s\n", Printer);
	 if(TcpWrite(tcbo,TransmitBuffer,TransmitSize,0))
    {
		if(WaitForAcknowledge())    // All sent. Wait for reply
            return OK;
        else
            printf("\nLPD server didn't acknowledge 'Send Job' command\n");
    }
	 return ERROR;                   // TcpWrite timed out. Error
}

//===========================================================================
// Send control file parameters and contents
//===========================================================================
int SendControlFile(char *file)
{
char    cfp[512];   // Control File contents. Done in memory!!
int     len = 0;

	sprintf(cfn, "cfA%03u%s", ++JobNumber, HostName);
	sprintf(dfn, "dfA%03u%s",   JobNumber, HostName);

	len += sprintf(cfp+len, "H%s\n",  HostName);
	len += sprintf(cfp+len, "P%s\n",  LocalUser);
	len += sprintf(cfp+len, "J%s\n",  *JobName ? JobName : file);
	len += sprintf(cfp+len, "C%s\n",  ClassName);
	len += sprintf(cfp+len, "L%s\n",  LocalUser);
	len += sprintf(cfp+len, "N%s\n",  file);
	len += sprintf(cfp+len, "%c%s\n", BinaryData?'l':'f', dfn);
	len += sprintf(cfp+len, "U%s\n",  dfn);
//	len += sprintf(cfp+len, "N%s\n",  dfn+1);

    TransmitSize = sprintf(TransmitBuffer, "\x02%u %s\n", strlen(cfp), cfn);
	 if(TcpWrite(tcbo,TransmitBuffer, TransmitSize, 0))
    {
		if(WaitForAcknowledge())
        {
				if(TcpWrite(tcbo,cfp, len+1, 0))
				if(WaitForAcknowledge())
                    return OK;
                else
                    printf("\nLPD server didn't acknowledge the control file contents\n");
            else
                printf("\nCouldn't send control file contents to the LPD server\n");
        }
        else
            printf("\nLPD server didn't acknowledge the control file parameters\n");
    }
    else
        printf("\nCouldn't send control file parameters to the LPD server\n");
    return ERROR;
}

//===========================================================================
// Send data file parameters and contents
//===========================================================================
int SendDataFile(char *file)
{
struct  stat statbuf;
FILE    *fp;
char    progress[41] = "";
unsigned long Total = 0;

    stat(file, &statbuf);
    TransmitSize = sprintf(TransmitBuffer, "\x03%lu %s\n", statbuf.st_size, dfn);
	 TcpWrite(tcbo,TransmitBuffer, TransmitSize, 0);
	if(WaitForAcknowledge())
    {
        if((fp = fopen(file, "rb")) != NULL)
        {
            do
            {
				_setcursortype(_NOCURSOR);
                TransmitSize = fread(TransmitBuffer, 1, BLOCKSIZE, fp);
                Total += TransmitSize;
                strnset(progress, '', (size_t)((Total * 40) / statbuf.st_size));
                printf("\r%s", progress);
					 if(TcpWrite(tcbo,TransmitBuffer, TransmitSize, 0) == ERROR)
                {
                    printf("\nThere was an error sending the data file contents\n");
                    return ERROR;
                }
            } while(!feof(fp));
				TcpWrite(tcbo,"", 1, 0);
            fclose(fp);
			if(WaitForAcknowledge())
                return OK;
            else
                printf("\nLPD server didn't acknowledge the data file contents\n");
        }
        else
            printf("\nCan't open data file '%s' to send\n", file);
    }
    else
        printf("\nLPD server didn't acknowledge the data file parameters\n");
    return ERROR;
}

//===========================================================================
// Send all the files on the command line
//===========================================================================
int SendTheFiles(char *file)
{
    if(SendReceiveJob() == OK)
        if(SendControlFile(file) == OK)
            if(SendDataFile(file) == OK)
            {
                printf("\rJob %03u, File %s printed                                \n", JobNumber, file);
                clreol();
                return OK;
            }
    return ERROR;
}

//===========================================================================
// Get status information for LPD server
//===========================================================================
int QueryQueue(char **Files)
{
int Index = 0, ReceiveCount = 0;
unsigned int    errcode;
char    ReceiveBuffer[1024];

    sprintf(TransmitBuffer, "\x04%s", Printer);
    if(FileNameIndex)
    {
        for(Index = 0; Index < FileNameIndex; Index++)
        {
            strcat(TransmitBuffer, " ");
            strcat(TransmitBuffer, Files[Index]);
            free(Files[Index]);
        }
    }
    strcat(TransmitBuffer, "\n");
	 if(TcpWrite(tcbo,TransmitBuffer, strlen(TransmitBuffer), 0) == ERROR)
        return ERROR;

    while(ReceiveCount == 0)    // Add timeout of some sort!!
    {
        if(kbhit())
        {
            if(getch() == 0)
                getch();
            printf("\r                                             ");
            printf("\rDo you want to abort? (Y/N) : ");
            _setcursortype(_NORMALCURSOR);
            if(toupper(getch()) == 'Y')
                return ERROR;
        }
        r.x.si = FP_OFF(ReceiveBuffer);
        r.x.dx = FP_SEG(ReceiveBuffer);
        r.x.cx = sizeof(ReceiveBuffer);
        r.x.bx = tcbo;
        r.h.ah = API_TCPREAD;
        int86(api_int,&r,&r);
        ReceiveCount = r.x.cx;
        errcode      = r.x.ax;
        if(errcode != 0)
        {
            if (errcode != WOULDBLK)
                return ERROR;
            continue;
        }
        if(ReceiveCount == 0)
            return OK;
        else
        {
            printf("%.*s", ReceiveCount, ReceiveBuffer);
            ReceiveCount = 0;
        }
    }
    return OK;
}

//===========================================================================
// Remove files or jobs
//===========================================================================
int RemoveFiles(char **Files)
{
int Index = 0, ReceiveCount = 0;
unsigned int    errcode;
char    ReceiveBuffer[1024];

    sprintf(TransmitBuffer, "\x05%s %s", Printer, LocalUser);

    if(FileNameIndex)
    {
        for(Index = 0; Index < FileNameIndex; Index++)
        {
            strcat(TransmitBuffer, " ");
            strcat(TransmitBuffer, Files[Index]);
            free(Files[Index]);
		  }
    }
    strcat(TransmitBuffer, "\n");
	 if(TcpWrite(tcbo,TransmitBuffer, strlen(TransmitBuffer), 0) == ERROR)
        return ERROR;
    while(ReceiveCount == 0)    // Add timeout of some sort!!
    {
        if(kbhit())
        {
            if(getch() == 0)
                getch();
            printf("\r                                             ");
            printf("\rDo you want to abort? (Y/N) : ");
            _setcursortype(_NORMALCURSOR);
            if(toupper(getch()) == 'Y')
                return ERROR;
        }
        r.x.si = FP_OFF(ReceiveBuffer);
        r.x.dx = FP_SEG(ReceiveBuffer);
        r.x.cx = sizeof(ReceiveBuffer);
        r.x.bx = tcbo;
        r.h.ah = API_TCPREAD;
        int86(api_int,&r,&r);
        ReceiveCount = r.x.cx;
        errcode      = r.x.ax;
        if(errcode != 0)
        {
            if (errcode != WOULDBLK)
                return ERROR;
            continue;
        }
        if(ReceiveCount == 0)
            return OK;
        else
            printf("%.*s", ReceiveCount, ReceiveBuffer);
    }
    return OK;
}

//===========================================================================
//
//===========================================================================
int OpenConnection(void)
{
unsigned int errcode;

	r.x.cx = FP_OFF(&op);
	r.x.bx = FP_SEG(&op);
	r.h.ah = API_TCPOPEN;
	int86(api_int,&r,&r);
	errcode = r.x.ax;
	tcbo    = r.x.cx;
	if (tcbo == 0)
	{
		printf("\rCouldn't establish connection. Error on TCP_OPEN: %s\n", err(errcode));
		return PROGRAM_ERROR;
	}
	return OK;
}

//===========================================================================
//
//===========================================================================
void CloseConnection(void)
{
	r.x.bx = tcbo;
	r.h.ah = API_TCPCLOSE;
	int86(api_int,&r,&r);
	tcbo = 0;
}

//===========================================================================
//
//===========================================================================
void Acknowledge(void)
{
	if(PauseForUser == 1)
	{
		_setcursortype(_NORMALCURSOR);
		printf("\nPress any key to continue ...\n");
		while(!kbhit() && api_int && (api_int != 0x100))
		{
			 r.h.ah = API_NOOP; /* keep INET alive */
		    int86(api_int,&r,&r);
		}
		if(getch() == 0)
			getch();
	}
}

char*	getsw(char *str)
{
	int i = 0;
	int x,y;
	char ch;

	x = wherex();
	y = wherey();
	while (1) {
		while(!kbhit())
		{
		    r.h.ah = API_NOOP; /* keep INET alive */
		    int86(api_int,&r,&r);
		}
		if((ch = getch()) == 0) {
			getch();
			continue;
		}
		if (ch == '\r') {
			str[i] = 0;
			putch('\r');
			putch('\n');
			return str;
		}
		else if (ch == '\b' && i) {
			--i;
			gotoxy(--x,y);
			putch(' ');
			gotoxy(x,y);
		}
		else if (isprint(ch) && x < 79) {
			putch(ch);
			str[i++] = ch;
			++x;
		}
	}
}
