//
//   $Id: SENDMAIL.C 1.4 2002/10/16 16:32:16Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// SENDMAIL.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Program to send mail to mail server.
//
// Revision History
// 05/10/2001 jmb increased timeout to 45 seconds
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//

#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <string.h>
#include <time.h>
#include "compiler.h"
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dllfn.h"
#include "dlbiosio.h"
#include "capi.h"
#include "sendmail.h"
#include "sendmail.pt"

#ifdef DL
#include "dosver.h"
#include "fatworld.h"
#endif

#define USAGE	"SENDMAIL <server> <file>"

char	szLogFile[] = "SENDMAIL.LOG";

int main( int argc, char* argv[] )
{
	int	iSock;
	int	iMessages;
	int	i;

#ifdef DL
	printf("Datalight Sockets SENDMAIL ");
	if (dlIsFat32World())
		printf("%s ", SHORTVERSION);
	else
		printf("%s ", SHORTVERSION622);
	printf("%s\n%s\n%s\n\n",
		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif


	if( argc != 3 )
	{
		LogError( ERR_BAD_PARAMS, USAGE );
		return 1;
	}

	// connect and authorize a user
	iSock = SmtpConnect( argv[1] );
	if( iSock == -1 )
	{
		LogMessage( "999 Failed to send mail.", 1 );
		return 1;
	}

	// send the message
	if( SmtpSendFile( iSock, argv[2] ) == -1 )
	{
		// error case
		SmtpDisconnect( iSock, FALSE );
		LogMessage( "999 Failed to send mail.", 1 );
		return 1;
	}

	// stop processing, ignore return code
	SendLine( iSock, "QUIT" );
	if( SmtpCheckResponse( iSock ) == TRUE )
		SmtpDisconnect( iSock, TRUE );
	else
		SmtpDisconnect( iSock, FALSE );

	LogMessage( "000 Sent SMTP mail successfully", 1 );
	return 0;
}


/*
	SmtpConnect

	Gets a socket, connects to the passed server, and
	authorizes with the passed user and password.  If
	anything goes wrong, it logs a message and returns
	-1.
*/
int SmtpConnect( char* szServer )
{
	int	iSock;
	int	iRet;
	char	chCommand[80];

	// connect to the server

	iSock = ConnectTo( szServer, 25 );

	if( iSock == -1 )
		return -1;
	if( SmtpCheckResponse( iSock ) != TRUE )
	{
		LogError( ERR_SERVER_NOT_READY, "Server not ready" );
		goto ErrorExit;
	}

	// send greeting
	{
		DWORD	dwIP;
		char	chIP[4];

		// build IP string
		dwIP = GetAddress( iSock );
		memcpy( chIP, &dwIP, 4 );
		sprintf( chCommand, "helo %u.%u.%u.%u", chIP[0], chIP[1], chIP[2], chIP[3]);

		// send greeting string
		iRet = SendLine( iSock, chCommand );
		if( iRet == -1 )
		{
			LogNetError( "Sending greeting" );
			goto ErrorExit;
		}
		if( SmtpCheckResponse( iSock ) != TRUE )
		{
			LogError( ERR_BAD_GREETING, "Greeting rejected" );
			goto ErrorExit;
		}
	}

	// success
	return iSock;

ErrorExit:
	SmtpDisconnect( iSock, FALSE );
	return -1;
}


/*
	SmtpCheckResponse

	Reads from the socket a SMTP response code.  The server
	may send a multi-line response.

	The return value will be -1 on internal error, FALSE on
	server failure, or TRUE on server success.
*/
int SmtpCheckResponse( int iSock )
{
	char*	pszLine;
	int	iCode = 0;

	while( iCode == 0 )
	{
		// get the next line from the server
		pszLine = ReadLine( iSock );

		if( !pszLine )
			return -1;

		// the final output line will have a space character
		// at position 3, where all previous lines will have
		// a dash in that position.
		if( pszLine[3] == ' ' )
		{
			iCode = atoi( pszLine );
			if( (iCode < 100) || (iCode > 500) )
			{
				LogError( ERR_INVALID_RESPONSE, "Server returned invalid response" );
				LogError( ERR_INVALID_RESPONSE, pszLine );
				return -1;
			}
		}
		else
		{
			if( pszLine[3] != '-' )
			{
				LogError( ERR_INVALID_RESPONSE, "Server returned invalid response" );
				return -1;
			}
		}
	}

	if( iCode < 399 )
		return TRUE;
	else
		return FALSE;
}


/*
	SmtpSendFile
	pete
*/
int SmtpSendFile( int iSock, char *pszFile )
{
	int	iRet;
	int	fInData=FALSE;
	char	chBuf[LINE_SIZE+1];
	FILE*	pfMail;
	char*	pRet;
	char cTemp[255];

	// open the file to send
 	// change to short name if lfn.
 	SmartExpandPath( _FULLPATH_SHORTNAME, pszFile, cTemp );
	pszFile = cTemp;
	pfMail = fopen( pszFile, "rb" );
	if( !pfMail )
		return -1;

	// dump file to socket
	while( !feof(pfMail) )
	{
		int	iIndex, iSize;

		iIndex = 0;
		fgets( chBuf, LINE_SIZE, pfMail );
		iSize = strlen( chBuf );
		if( iSize > LINE_SIZE-1 )
		{
			LogError( ERR_LINE_TOO_LONG, "Input line too long" );
			return -1;
		}

		// send the line, looping until it's done.
		iRet = WriteSocket( iSock, chBuf+iIndex, iSize-iIndex, 0 );
		if( iRet == -1 )
		{
			LogNetError( "Sending mail contents" );
			goto ErrorExit;
		}

		// check command lines for errors
		if( (!fInData) && (SmtpCheckResponse(iSock) != TRUE) )
			LogNetError( chBuf );

		// are we entering the DATA section?
		if( strcmpi( chBuf, "DATA\r\n" ) == 0 )
			fInData = TRUE;
	}

	fclose( pfMail );
	return 1;

ErrorExit:
	fclose( pfMail );
	return -1;
}


/*
	SmtpDisconnect

	Sends QUIT, closes socket, releases socket, returns.
*/
void SmtpDisconnect( int iSock, int iGraceful )
{
	if( iGraceful )
		EofSocket( iSock );
	ReleaseSocket( iSock );
	return;
}


/*
	SendLine

	Sends passed string+CRLF to socket.  Returns the WriteSocket
	return code.
*/
int SendLine( int iSock, char* lpsz )
{
	char	chBuf[80];

	sprintf( chBuf, "%s\r\n", lpsz );
	return WriteSocket( iSock, chBuf, strlen(chBuf), 0 );
}


/*
	ReadLine

	Reads a line of text from the passed socket.  Strips trailing
	CRLF pair, and swallows all characters past the end of the
	buffer to maintain line-alignment.

	Returns a pointer to a static buffer or NULL on socket error.
*/
char* ReadLine( int iSock )
{
	static char	chThisLine[LINE_SIZE+1];
	char			chBuf[LINE_SIZE+1];
	int			iRet;
	char*			pszTemp;

	// read-ahead to see what's available
	iRet = ReadSocket( iSock, chThisLine, LINE_SIZE, 0, NET_FLG_PEEK );
	if( iRet < 1 )
		return NULL;
	chThisLine[iRet] = '\0';

	// now find EOL
	pszTemp = strchr( chThisLine, '\n' );
	if( pszTemp )
	{
		// found it!  dequeue the data from TCP and leave
		*(pszTemp-1) = '\0';
		iRet = ReadSocket( iSock, chBuf, strlen(chThisLine)+2, 0, 0 );
		if( iRet < 1 )
			return NULL;
		return chThisLine;
	}

	// dequeue the line to return
	iRet = ReadSocket( iSock, chBuf, iRet, 0, 0 );

	// line too long.  loop until we find eol
	while( !pszTemp )
	{
		// peek another chunk ahead
		iRet = ReadSocket( iSock, chBuf, LINE_SIZE, 0, NET_FLG_PEEK );
		if( iRet < 1 )
			return NULL;
		chBuf[iRet] = '\0';

		// look for CRLF
		pszTemp = strchr( chBuf, '\n' );
		if( pszTemp )
			iRet = ((WORD)pszTemp - (WORD)chBuf)+1;

		// dequeue iRet bytes
		iRet = ReadSocket( iSock, chBuf, iRet, 0, 0 );
		if( iRet < 1 )
			return NULL;
	}

	return chThisLine;
}


/*
	ConnectTo

	Open a TCP connection to the passed host and port.
*/
int ConnectTo( char* lpszHostName, int iPort )
{
	NET_ADDR sNetAddr;
	int iSock;

	memset(&sNetAddr, 0, sizeof(NET_ADDR));

	// setup the destination address
	sNetAddr.wRemotePort = iPort;
	sNetAddr.dwRemoteHost = ResolveName( lpszHostName, 0, 0 );
	if( sNetAddr.dwRemoteHost == 0 )
	{
		LogNetError( "Looking up host" );
		return -1;
	}

	// get a socket
	iSock = GetSocket();
	if( iSock < 0 )
	{
		LogNetError( "Getting client socket" );
		return -1;
	}

	// set the socket to blocking mode
	if( SetSocketOption( iSock, 0, NET_OPT_NON_BLOCKING, 0, 4 ) == -1 )
	{
		LogNetError( "Setting blocking mode" );
		ReleaseSocket( iSock );
		return -1;
	}

	// set the socket timeout to 45 seconds
	if( SetSocketOption( iSock, 0, NET_OPT_TIMEOUT, 45000, 4 ) == -1 )
	{
		LogNetError( "Setting blocking mode" );
		ReleaseSocket( iSock );
		return -1;
	}

	// connect the socket to the server
	if( ConnectSocket(iSock, STREAM, &sNetAddr) < 0 )
	{
		LogNetError( "Connecting to server" );
		ReleaseSocket( iSock );
		return -1;
	}

	return iSock;
}


/*
	LogNetError

	Transforms an integer error number into a log message and
	writes it to the log file.
*/
void LogNetError( char *pszWhence )
{
	char*	pszError;
	int	iError = iNetErrNo;
	static char rgcUnk[30];
	static char *rgszErrs[] =
	{
		"No error",
		"Connection already in use",
		"DOS error",
		"Out of memory",
		"Connection does not exist",
		"Protocol or Mode not supported",
		"Bad Packet",
		"Invalid or missing host address",
		"Can't open",
		"Network unreachable",
		"Host unreachable",
		"Protocol unreachable on host",
		"Port unreachable",
		"Timeout",
		"Host name lookup failed",
		"No servers",
		"Server error",
		"Bad parameter format",
		"Bad parameter",
		"Connection closed by peer",
		"Connection reset by peer",
		"Operation would block",
		"Socket not bound",
		"Socket not available",
		"Bad parameter in system call",
		"Can't broadcast",
		"Connection has not been established",
		"Kernel Re-entered",
	};

	if( iError == ERR_API_NOT_LOADED )
	{
		pszError = "Sockets API not loaded";
	}
	else
	{
		if( iError > ERR_RE_ENTRY )
		{
			sprintf( rgcUnk, "Unknown error 0x%04X", iError );
			pszError = rgcUnk;
		}
		else
		{
			pszError = rgszErrs[iError];
		}
	}

	// format and log the error
	{
		char	szError[255];

		sprintf( szError, "%s (%s)", pszError, pszWhence );
		LogError( 200+iError, szError );
	}
}


/*
	LogError

	Transforms an error number and message into a text line
	for the log, and outputs it.
*/
void LogError( int iError, char *lpszError )
{
	static char	chBuf[257];

	sprintf( chBuf, "%03d %s", iError, lpszError );
	LogMessage( chBuf, TRUE );
}


/*
	LogMessage

	Outputs a message to the screen, and to the log file if
	the passed flag is TRUE.
*/
void LogMessage( char* lpszMessage, int fFile )
{
	time_t	lTime;
	char*		pszTime = ctime(&lTime);
	char		szTime[25];

	// get time stamp, trim CRLF
	lTime = time(0);
	pszTime = ctime(&lTime);
	strncpy( szTime, pszTime, 24 );
	szTime[24] = '\0';

	if( fFile )
	{
		FILE*	pfLog;

		pfLog = fopen( szLogFile, "a+" );
		if( pfLog )
		{
			fprintf( pfLog, "%s, %s\n", szTime, lpszMessage );
			fclose( pfLog );
		}
		else
		{
			printf( "FAILED TO OPEN LOG!\n" );
			exit( 1 );
		}
	}

	printf( "%s, %s\n", szTime, lpszMessage );
}
