//
//   $Id: RCCLI.C 1.8 2003/08/19 16:49:30Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//
// rccli.c
//
// Copyright (c) 1996-2003 Datalight, Inc.
// Confidential and Proprietary
// All Rights Reserved
// Portions copyright (c) GPvNO 2003
//
// Remote console client
//
// $DOCHISTORY
//  07/17/2001 gvn cleaned up, changed port.
//  04/30/2001 jmb used ROMDOS version number and copyright info.
//  04/26/2001 jmb added header
//

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <time.h>
#include <ctype.h>
#include <process.h>
#include <errno.h>
#ifdef _Windows
#include <winsock2.h>
#define Errno WSAGetLastError()
#define SleepX(x) Sleep(x)
#else
#include "socket.h"
#define Errno errno
#define SleepX(x)
#endif

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

#define KEYMAX 	10
#define DISPMAX 	1500
#define ALT_X		0x2d00
#define ALT_E		0x1200
#define ALT_R		0x1300
#define ALT_S		0x1f00

// prototypes

char *GetSocketError(int iError);
void Fail(char *pszCall,int iCode);
int check_input(void);
void TcpWrite(SOCKET s,char *pcBuf,int keycnt);
int GetKey(char *pcControl);

char arcKeyBuf[KEYMAX];
char arcBuf[DISPMAX];
int dispcnt;
int count;

SOCKET s;

int iOffset;

unsigned uScreenSize = 80 * 25 * 2;

int dstate;
int tempdstate;
unsigned dpos,uPrevDpos;
int iCols = 80;
int iBlockSize;
unsigned char byte1, byte2;
char cError;
FILE *psFile;

void Reset(void)
{
	clrscr();
	dpos = iOffset = 0;
	TcpWrite(s,"r",1);
}

main(int argc,char *argv[])
{
	struct sockaddr sSockAddrLocal,sSockAddrRemote;
	struct sockaddr_in *pAddr = (struct sockaddr_in *)&sSockAddrRemote;
	char *pszHostName,*pszServiceName;
	struct servent *psService;
	struct hostent *psHost;
	unsigned ch;
	char exitf = 0,cControl = 0;
	unsigned long ulOn = 1l;
	char *argvl[2];

	printf("Datalight Sockets Remote Console Client\n");

#ifdef DL
	if (dlIsFat32World())
		printf("%s ", SHORTVERSION);
	else
		printf("%s ", SHORTVERSION622);

	printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);

#endif
	if (argc < 2) {
		printf("Usage:\nRCCLI server_ip_address [port [dump_file]]\nUse Ctrl-Alt-X to exit.\n");
		exit(1);
	}
	if (*argv[1] == '/') {
		printf("Keyboard test\nUse Ctrl-Alt-X to exit.\n"
				 "Key  VK SC Char Shift codes\n");
		cControl = 2;
		while (GetKey(&cControl) != ALT_X || !cControl) {
			cControl = 2;
			SleepX(10);
		}
		exit(0);                      
	}
#ifdef _Windows
	{
		WSADATA 	winsockdata;

		if (WSAStartup(0x0101,&winsockdata) != 0) {
			WSACleanup();
			printf("WinSock V1.1 required\n");
			exit(1);
		}
		printf("Winsock v %u.%u\n",HIBYTE(winsockdata.wHighVersion),LOBYTE(winsockdata.wHighVersion));
	}
#endif

	s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	if (s == INVALID_SOCKET)
		Fail("socket",1);
	memset(&sSockAddrLocal,0,sizeof(sSockAddrLocal));
	memset(&sSockAddrRemote,0,sizeof(sSockAddrRemote));
	sSockAddrLocal.sa_family = AF_INET;
	sSockAddrRemote.sa_family = AF_INET;
	if (bind(s,&sSockAddrLocal,sizeof(sSockAddrLocal)) == SOCKET_ERROR)
		Fail("bind",1);
	pszHostName = argv[1];
	if ((psHost = gethostbyname(pszHostName)) == 0) {
		if ((pAddr->sin_addr.s_addr = inet_addr(argv[1])) == 0)
			Fail("inet_addr",1);
	}
	else
		pAddr->sin_addr.s_addr = *(u_long *)(psHost->h_addr_list[0]);
	pAddr->sin_port = htons(81);
	if (argc > 2) {
		pszServiceName = argv[2];
		if ((pAddr->sin_port = htons((u_short)atoi(pszServiceName))) == 0) {
			if ((psService = getservbyname(pszServiceName,"tcp")) == 0) {
				Fail("getservbyname(remcon)",0);
				pAddr->sin_port = htons(81);
			}
			else
				pAddr->sin_port = psService->s_port;
		}
	}
	printf("port= %d\n",ntohs(pAddr->sin_port));
	if (connect(s,&sSockAddrRemote,sizeof(sSockAddrRemote)) == SOCKET_ERROR)
		Fail("connect",1);
	if (ioctlsocket(s,FIONBIO,&ulOn) == SOCKET_ERROR)
		Fail("ioctlsocket",1);
	if (argc > 3) {
		if ((psFile = fopen(argv[3],"wt")) == 0) {
			printf("Open error on '%s', Press a key...",argv[3]);
			getch();
		}
	}
	clrscr();
	while (!exitf) {
		if ((int)(ch = GetKey(&cControl)) != -1) {
			if (cError) {
				Reset();
				cError = 0;
			}
			if (cControl) {
				if (ch == ALT_X) {
					exitf = 1;
					continue;
				}
				else if (ch == ALT_S) {
					textattr(0x07);
					cprintf("\r\nStatus: Pos %d\r\n",dpos);
					cprintf("state %x '%c' tmpstate %x '%c' iCols %d ScreenSize %u\r\n",
						dstate, dstate, tempdstate, tempdstate, iCols, uScreenSize);
					getch();
					Reset();
					continue;
				}
				else if (ch == ALT_E) {
					textattr(0x07);
					if ((argvl[0] = getenv("COMSPEC")) == 0)
						argvl[0] = "\\COMMAND.COM";
					argvl[1] = 0;
					spawnvp(P_WAIT,argvl[0],argvl);
					Reset();
					continue;
				}
				else if (ch == ALT_R) {
					Reset();
					continue;
				}
			}
			arcKeyBuf[0] = 'k';
			arcKeyBuf[1] = (char)(ch >> 8);
			arcKeyBuf[2] = (char)ch;
			TcpWrite(s,arcKeyBuf,3);
		}
		check_input();
	}
	if (closesocket(s) == SOCKET_ERROR)
		Fail("closesocket",1);
#ifdef _Windows
	WSACleanup();
#endif
	return 0;
}

static int iDisplayCnt;
unsigned char arcDisplayBuf[16];

void HexDump(FILE *psFile,unsigned char ch)
{
	int i;

	arcDisplayBuf[iDisplayCnt++] = ch;
	if (iDisplayCnt >= 16) {
		for (i = 0;i < 16;++i)
			fprintf(psFile,"%02x ",arcDisplayBuf[i]);
		fprintf(psFile," ");
		for (i = 0;i < 16;++i)
			fprintf(psFile,"%c",isprint(arcDisplayBuf[i]) ? arcDisplayBuf[i] : '.');
		fprintf(psFile,"\n");
		iDisplayCnt = 0;
	}
}

void HexDumpEnd(FILE *psFile)
{
	int i;

	if (iDisplayCnt) {
		for (i = 0;i < iDisplayCnt;++i)
			fprintf(psFile,"%02x ",arcDisplayBuf[i]);
		for (;i < 16;++i)
			fprintf(psFile,"   ",arcDisplayBuf[i]);
		fprintf(psFile," ");
		for (i = 0;i < iDisplayCnt;++i)
			fprintf(psFile,"%c",isprint(arcDisplayBuf[i]) ? arcDisplayBuf[i] : '.');
		fprintf(psFile,"\n");
		iDisplayCnt = 0;
	}
}

#define NORMAL				0
#define BYTE1				2
#define BYTE2				3
#define DATA				'd'
#define REPEAT_DA			'p'
#define ATR_DATA			'a'
#define REPEAT_DA_E		'P'
#define ATR_DATA_E		'A'
#define SCROLL				's'
#define MOVE				'm'
#define SETCAR				'c'
#define SCRSIZE			'o'

#define TOLOWER			0x20

int check_input()		// return: 0 - none, > 0 received, < 0 closed
{
	int i,iPos,iLeft,iRight,iTop,iIndex,iCount,iLoopCount,iDestTop,iBottom;
	char arcVidBuf[160];
	signed char ch;

	if ((dispcnt = recv(s,arcBuf + iOffset,DISPMAX - iOffset,0)) == SOCKET_ERROR) {
		if (Errno != WSAEWOULDBLOCK) {
			Fail("recv",0);
			return -1;
		}
		SleepX(10);	// Give control away for a while
		return 0;	/* nothing to read */
	}
	if (dispcnt == 0) {
		textattr(0x07);
		cprintf("\r\nConnection closed by remote\r\n");
		return -1;
	}
	dispcnt += iOffset;
	iOffset = 0;
	for (iIndex = 0;iIndex < dispcnt;++iIndex) {
		while (dpos >= uScreenSize)
			dpos -= uScreenSize;
		ch = arcBuf[iIndex];
		switch (dstate) {
		case NORMAL:
			dstate = isupper(ch) ? BYTE1 : BYTE2;
			byte1 = 0;
			if (ch == SETCAR || ch == SCRSIZE)//NB inconsistency in protocol
				dstate = BYTE1;
			tempdstate = ch | TOLOWER;
			if (psFile && dpos != uPrevDpos) {
				fprintf(psFile,"Pos %d Row %d Col %d%s\n",
							dpos / 2, (dpos / 2) / iCols, (dpos /2) % iCols,
							dpos & 1 ? " Odd!" : "");
				uPrevDpos = dpos;
			}
			switch (tempdstate) {
			case DATA:				// 'd'
			case REPEAT_DA:		//	'p'
			case ATR_DATA:			// 'a'
			case SCROLL:			//	's'
			case MOVE:				// 'm'
			case SETCAR:			// 'c'
			case SCRSIZE:			// 'o'
				break;
			default:					// Invalid command
				clrscr();
				textattr(0x07);
				cprintf("Unknown state %x, '%c'\r\n",dstate,dstate);
				dstate = NORMAL;
				if (psFile) {
					fprintf(psFile,"Bad command %02x, ignored data:\n",
												(unsigned char)ch);
					for (;iIndex < dispcnt;++iIndex)
						HexDump(psFile,arcBuf[iIndex]);
					HexDumpEnd(psFile);
				}
				return dispcnt;	// ignore rest of received data
										// yea, I know about no record boundaries in TCP...
			}
			break;
		case BYTE1:
			byte1 = ch;
			dstate = BYTE2;
			break;
		case BYTE2:
			byte2 = ch;
			switch (tempdstate) {
			case MOVE:
				iCount = ((byte1 << 9) + (byte2 << 1));
				if (psFile) {
					fprintf(psFile,"Move %d\n",iCount / 2);
				}
				dpos += iCount;
				dstate = NORMAL;
				break;
			case REPEAT_DA:
				iBlockSize = (byte1 << 8) + byte2;
				dstate = BYTE1;
				tempdstate = REPEAT_DA_E;
				break;
			case REPEAT_DA_E:
				if (psFile) {
					fprintf(psFile,"Repeat %02x (%c) %02x %d times\n",
							byte1,isprint(byte1) ? byte1 : '.',byte2,iBlockSize);
				}
				iPos = dpos / 2;
				iLeft = iPos % iCols + 1;
				iTop = iPos / iCols + 1;
				arcVidBuf[0] = byte1;
				arcVidBuf[1] = byte2;
				dpos += 2 * iBlockSize;
				while (iBlockSize--) {
					puttext(iLeft,iTop,iLeft,iTop,arcVidBuf);
					if (++iLeft > iCols) {
						iLeft = 1;
						++iTop;
					}
				}
				dstate = NORMAL;
				break;
			case ATR_DATA:
				iBlockSize = (byte1 << 8) + byte2;
				dstate = BYTE2;
				tempdstate = ATR_DATA_E;
				break;
			case ATR_DATA_E:
				if (psFile) {
					fprintf(psFile,"Constant attrib %02x + Data, %d bytes:\n",
							byte2,iBlockSize);
				}
				dstate = ATR_DATA;
				break;
			case SETCAR:
				gotoxy(byte1 + 1,byte2 + 1);
				if (psFile) {
					fprintf(psFile,"Set cursor %d %d\n",
							byte2,byte1);
				}
				dstate = NORMAL;
				break;
			case SCRSIZE:
				iCols = byte1;
				uScreenSize = byte1 * byte2 * 2;
				if (psFile) {
					fprintf(psFile,"Set Screensize Cols=%d Rows=%d\n",
							byte1,byte2);
				}
				dstate = NORMAL;
				break;
			case DATA:
				iBlockSize = (byte1 << 8) + byte2;
				if (psFile) {
					fprintf(psFile,"Data, %d data/attr pairs:\n",
							iBlockSize);
				}
			default:
				iBlockSize = (byte1 << 8) + byte2;
				dstate = tempdstate;
				break;
			}
			break;
		case DATA:
			iPos = dpos / 2;
			iLeft = iPos % iCols;
			iTop = iPos / iCols + 1;
			iCount = (dispcnt - iIndex) / 2;
			if (iCount > iCols - iLeft)
				iCount = iCols - iLeft;
			if (iCount > iBlockSize)
				iCount = iBlockSize;
			iBlockSize -= iCount;
			puttext(iLeft + 1,iTop,iLeft + iCount,iTop,arcBuf + iIndex);
//int puttext(int left, int top, int right, int bottom, void *source);
			iCount *= 2;
			if (psFile) {
				for (i = iIndex, iLoopCount = iCount;iLoopCount;iLoopCount--,i++)
					HexDump(psFile,arcBuf[i]);
			}
			dpos += iCount;
			iIndex += (iCount - 1);
			if (iBlockSize == 0) {
				if (psFile)
					HexDumpEnd(psFile);
				dstate = NORMAL;
			}
			if (dispcnt - iIndex == 2) {	// only one byte left
				arcBuf[0] = arcBuf[iIndex + 1];
				iOffset = 1;
				return dispcnt;
			}
			break;
		case ATR_DATA:

			iPos = dpos / 2;
			iLeft = iPos % iCols;
			iTop = iPos / iCols + 1;
			iCount = dispcnt - iIndex;
			if (iCount > iCols - iLeft)
				iCount = iCols - iLeft;
			if (iCount > iBlockSize)
				iCount = iBlockSize;
			if (iCount > sizeof(arcVidBuf) / 2)
				iCount = sizeof(arcVidBuf) / 2;
			iBlockSize -= iCount;
			for (i = 0;i < iCount;++i) {
				arcVidBuf[i * 2] = arcBuf[iIndex + i];
				arcVidBuf[i * 2 + 1] = byte2;
			}
			puttext(iLeft + 1,iTop,iLeft + iCount,iTop,arcVidBuf);
//int puttext(int left, int top, int right, int bottom, void *source);
			if (psFile) {
				for (i = iIndex, iLoopCount = iCount;iLoopCount;iLoopCount--,i++)
					HexDump(psFile,arcBuf[i]);
			}
			dpos += 2 * iCount;
			iIndex += (iCount - 1);
			if (iBlockSize == 0) {
				if (psFile)
					HexDumpEnd(psFile);
				dstate = NORMAL;
			}
			break;
		case SCROLL:
			iPos = dpos / 2;
			iLeft = iPos % iCols + 1;
			iDestTop = iPos / iCols + 1;
			iPos += (iBlockSize - 1);
			iRight = iPos % iCols + 1;
			iBottom = iPos / iCols + 1 + ch;
			iTop = iDestTop + ch;
			while (1) {
				if (iBottom > iTop) {
					if (iLeft == 1) {
						int iBot = iBottom - (iRight == iCols ? 0 : 1);
						movetext(iLeft,iTop,iCols,iBot,iLeft,iDestTop);
						if (iBottom == iBot)
							break;
						iTop = iBottom;
						iDestTop = iTop - ch;
					}
					else {
						movetext(iLeft,iTop,iCols,iTop,iLeft,iDestTop);
						++iTop;
						++iDestTop;
						iLeft = 1;
					}
				}
				else {
					movetext(iLeft,iTop,iRight,iTop,iLeft,iDestTop);
					break;
				}
			}
			dpos += 2 * iBlockSize;
			if (psFile) {
				fprintf(psFile,"Scroll %d chars from row offset %d (pos %d)\n",
						iBlockSize,ch,iPos);
			}
			dstate = NORMAL;
			break;
		}
	}
	return dispcnt;
}

void TcpWrite(SOCKET s,char *pcBuf, int iCnt)
{
	if (send(s,pcBuf,iCnt,0) == SOCKET_ERROR)
		Fail("send",0);
}

void Fail(char *pszCall,int iCode)
{
	textattr(0x07);
	cprintf("%s() failed: %s\r\n",pszCall,GetSocketError(Errno));
	if (iCode) {
		closesocket(s);
#ifdef _Windows
		WSACleanup();
#endif
		exit(iCode);
	}
}

#ifdef _Windows
// movetext() in the Borland library uses the Win32 API ScrollConsoleScreenBuffer()
// which does not work as documented in WIN2000 :(
int movetext(int iLeft,int iTop,int iRight,int iBottom,int iDestLeft,int iDestTop)
{
	char arcBuf[8000];

	gettext(iLeft,iTop,iRight,iBottom,arcBuf);
	puttext(iDestLeft,iDestTop,iDestLeft + iRight - iLeft,iDestTop + iBottom - iTop,arcBuf);
	return 1;
}
#endif

typedef struct sErr {
	int iErr;
	char *pszErr;
} SERROR;

extern SERROR sError[];

char *GetSocketError(int iError)
{
	int i;

	for (i = 0;sError[i].iErr != 0x7fff;++i) {
		if (iError == sError[i].iErr)
			break;
	}
	return sError[i].pszErr;
}

SERROR sError[] = {
  {WSABASEERR,         	"No Error"},
  {WSAEINTR,        		"Interrupted system call"},
  {WSAEBADF,        		"Bad file number"},
  {WSAEACCES,       		"Permission denied"},
  {WSAEFAULT,       		"Bad address"},
  {WSAEINVAL,       		"Invalid argument"},
  {WSAEMFILE,    	  		"Too many open files"},
  {WSAEWOULDBLOCK,     	"Operation would block"},
  {WSAEINPROGRESS,     	"Operation now in progress"},
  {WSAEALREADY,        	"Operation already in progress"},
  {WSAENOTSOCK,        	"Socket operation on non-socket"},
  {WSAEDESTADDRREQ,    	"Destination address required"},
  {WSAEMSGSIZE,        	"Message too long"},
  {WSAEPROTOTYPE,      	"Protocol wrong type for socket"},
  {WSAENOPROTOOPT,     	"Bad protocol option"},
  {WSAEPROTONOSUPPORT, 	"Protocol not supported"},
  {WSAESOCKTNOSUPPORT, 	"Socket type not supported"},
  {WSAEOPNOTSUPP,      	"Operation not supported on socket"},
  {WSAEPFNOSUPPORT,    	"Protocol family not supported"},
  {WSAEAFNOSUPPORT,    	"Address family not supported by protocol family"},
  {WSAEADDRINUSE,      	"Address already in use"},
  {WSAEADDRNOTAVAIL,   	"Can't assign requested address"},
  {WSAENETDOWN,        	"Network is down"},
  {WSAENETUNREACH,     	"Network is unreachable"},
  {WSAENETRESET,       	"Net dropped connection or reset"},
  {WSAECONNABORTED,    	"Software caused connection abort"},
  {WSAECONNRESET,      	"Connection reset by peer"},
  {WSAENOBUFS,         	"No buffer space available"},
  {WSAEISCONN,         	"Socket is already connected"},
  {WSAENOTCONN,        	"Socket is not connected"},
  {WSAESHUTDOWN,       	"Can't send after socket shutdown"},
  {WSAETOOMANYREFS,    	"Too many references, can't splice"},
  {WSAETIMEDOUT,       	"Connection timed out"},
  {WSAECONNREFUSED,    	"Connection refused"},
  {WSAELOOP,           	"Too many levels of symbolic links"},
  {WSAENAMETOOLONG,    	"File name too long"},
  {WSAEHOSTDOWN,       	"Host is down"},
  {WSAEHOSTUNREACH,    	"No Route to Host"},
  {WSAENOTEMPTY,       	"Directory not empty"},
  {WSAEPROCLIM,        	"Too many processes"},
  {WSAEUSERS,          	"Too many users"},
  {WSAEDQUOT,          	"Disc Quota Exceeded"},
  {WSAESTALE,          	"Stale NFS file handle"},
  {WSAEREMOTE,         	"Too many levels of remote in path"},
  {WSASYSNOTREADY,     	"Network SubSystem is unavailable"},
  {WSAVERNOTSUPPORTED, 	"WINSOCK DLL Version out of range"},
  {WSANOTINITIALISED,  	"Successful WSASTARTUP not yet performed"},
  {WSAHOST_NOT_FOUND,  	"Host not found"},
  {WSATRY_AGAIN,       	"Non-Authoritative Host not found"},
  {WSANO_RECOVERY,     	"Non-Recoverable errors: FORMERR, REFUSED, NOTIMP"},
  {WSANO_DATA,         	"Valid name, no data record of requested type"},
  {0x7fff,				  	"Unkown error"}
};


