//
//   $Id: SNTPCLI.H 1.4 2002/10/16 16:34:40Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//

/******************************************************************************
   SNTPCLI.H

   Copyright (C) 2001 Datalight, Inc.
   All Rights Reserved
   Datalight Confidential and Proprietary

   set dos clock from internet using SNTP

   Revision History
   11/01/2001 jmb corrected sntp_request bit mapped field.
   10/30/2001 jmb original revision

******************************************************************************/


//
// specified time port
//
#define TIME_PORT 123


//
// Notes:
// The time returned from the server is the number of seconds since
// 00:00 (midnight) 1 January 1900 GMT, such that the time 1 is 12:00:01 am
// on 1 January 1900 GMT; this base will serve until the year 2036.
//
// For example:
//
//     2,208,988,800L corresponds to 00:00  1 Jan 1970 GMT
//
// This base time is selected as UNIX systems started counting time 0 on
// this date.
//
#define BASE_TIME 2208988800L


//
// SNTP_TIMESTAMP is defined as a 64bit field containing both seconds and a
// fraction of seconds since 00:00 (midnight) 1 January 1900 GMT.
// The first 32 bits are seconds and the second is the fraction of seconds.
//
typedef struct sntp_timestamp
{
   DWORD Seconds;
   DWORD SubSeconds;
} SNTP_TIMESTAMP;

//
// this structure is defined by RFC2030.  The first four fields are
// bitmasked into a word field.  Please see pages 9-11 for further
// information about these fields.
//
typedef struct sntp_request
{
   unsigned  Mode:3;                   // broadcast mode
   unsigned  VN:3;                     // version number 
   unsigned  LI:2;                     // warns of an added or removed leap second
   unsigned  Stratum:8;                // stratum level of local clock
   BYTE  Poll;                         // max interval between messages
   BYTE  Precision;                    // precision of the local clock
   DWORD RootDelay;                    // round trip delay to reference source
   DWORD RootDispersion;               // nominal error to reference source
   DWORD ReferenceID;                  // id for particular reference source
   SNTP_TIMESTAMP ReferenceTimestamp;  // time local clock was set or corrected
   SNTP_TIMESTAMP OriginateTimestamp;  // time client sent request to server
   SNTP_TIMESTAMP ReceiveTimestamp;    // time server received request
   SNTP_TIMESTAMP TransmitTimestamp;   // time server sent response to client
} SNTP_REQUEST;                        
                                       

//
// macros
//

#define htonl(x) \
   ((x << 24) | ((x & 0x0000FF00l) << 8) | ((x & 0x00FF0000l) >> 8) | (x >> 24))

#define htons(x) \
   ((x << 8) | (x >> 8))


#define ntohl(x) htonl(x)
#define ntohs(x) htons(x)

#define Now time(NULL)


