//
//   $Id: IPRINT.C 1.6 2003/07/23 17:08:31Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//
// iprint.c
//
// Copyright (c) 1996-2001 Datalight, Inc.
// Confidential and Proprietary
// All Rights Reserved
// Portions copyright (c) GPvNO 2001
//
// remote print client
//
// $DOCHISTORY
//  04/30/2001 jmb used ROMDOS version number and copyright info.
//  04/26/2001 jmb added header
//

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

#include "compiler.h"
#include "api.h"
#include "iprint.pt"

#define BUFSIZ 512

// printer status bits

#define TIMEOUT		1
#define LASTPRINT	2
#define IOER		8
#define SELECTED	0x10
#define PAPEROUT	0x20
#define ACKNOWLEDGED	0x40
#define READY		0x80

//#define State (tcbs == 4 ? ((TCBL far *)tcb)->state : tcb->state)
#define State tcb->state
char *err(unsigned errcode);		/* return errorcode string */
char buf[BUFSIZ];

unsigned adrh = 0xc006;
unsigned adrl = 0x0102;

TCP_OP_P op = {0,10,0,TCP_ACTIVE,0,0,0,0,0,0};

main(argc,argv)
int argc;
char *argv[];
{
	TCB far *tcb;
	void interrupt (*int_apiv)();
	unsigned tcbo,tcbs,errcode,ch,acnt;
	int bufoff,count;
	FILE *fp;
	char status = 0,mask = 0x3f,offline = 0,paperout = 0,done = 0,state;

	int_apiv = getvect(API_INT);

	if (int_apiv == 0 || FP_SEG(int_apiv) >= 0xe000) {
		printf("Sockets API not loaded\n");
		exit(1);
	}
	if (argc < 3) {
#ifdef DL
	   printf("Datalight Sockets SPRINT ");
	   if (dlIsFat32World())
	   	printf("%s ", SHORTVERSION);
   	else
		   printf("%s ", SHORTVERSION622);
	   printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
   		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif
		printf("Not enough arguments, format is:\n"
			"sprint <hostname> <filename> [<port_number>] [<mask>]\n");
		goto error;
	}
	if (argc > 1) {
		_CX = FP_OFF(argv[1]);
		_BX = FP_SEG(argv[1]);
		_AH = API_GETIPADR;
		geninterrupt(API_INT);
		if (_CX == 0 && _DX == 0) {
			printf("Unknown host: %s\n",argv[1]);
			exit(1);
		}
		adrh = _CX;
		adrl = _DX;
	}
	if ((fp = fopen(argv[2],"rb")) == 0) {
		printf("Open error on %s\n",argv[2]);
		goto error;
	}
	if (argc > 3)
		op.wRemPort = atoi(argv[3]);
	if (argc > 4)
		mask = htoi(argv[4]);
	printf("Printing %s to %u.%u.%u.%u:%u\n"
		"Press Alt-X to abort, Alt-S for status\n",argv[2],
		adrh >> 8,adrh & 0xff,adrl >> 8,adrl & 0xff,op.wRemPort);
	op.dwRemIPAd = ((long)adrh << 16) + adrl;
	_CX = FP_OFF(&op);
	_BX = FP_SEG(&op);
	_AH = API_TCPOPEN;
	geninterrupt(API_INT);
	errcode = _AX;
	tcbo = _CX;
	tcbs = _BX;
	if (tcbo == 0)
		printf("Error on TCP_OPEN: %s\n",err(errcode));
	count = 0;
	if (tcbs == 4)
		tcb = MK_FP(tcbo,tcbs);
	else
		tcb = MK_FP(tcbs,tcbo);
	//printf("TCB at %Fp\n",tcb);
	while (1) {
		if (kbhit() && (ch = getch()) == 0) {	/* function key */
			ch = getch();
			if (ch == 45) {		/* alt X */
				printf("User abort\n");
				goto close_it;
			}
			else if (ch == 31) {	/* alt S */
				status_rep(tcbs,tcbo);
			}
		}
		_SI = (unsigned)&status;
		_DX = _DS;	/* no buffer == flush input */
		_CX = 1;
		_BX = tcbo;
		_AH = API_TCPREAD;
		geninterrupt(API_INT);
		if ((errcode = _AX) != 0) {
			if (errcode == NO_CONN || errcode == INVALID) {
				printf("Status error: %s\n",err(errcode));
				goto error;
			}
		}
		if (State < ESTABLISHED)
			continue;
		if (errcode == 0 && _CX) {
			if (mask & status & TIMEOUT) {
				printf("Remote printer timeout\n");
			}
			if (status & LASTPRINT)
				printf("Remote printing finished\n");
			if (mask & status & IOER) {
				printf("Remote printer I/O error\n");
			}
			if (mask & ~status & SELECTED) {
				printf("Remote printer not selected\n");
				offline = 1;
			}
			if (offline && (mask & status & SELECTED)) {
				printf("Remote printer selected\n");
				offline = 0;
			}
			if (mask & status & PAPEROUT) {
				printf("Remote printer out of paper\n");
				paperout = 1;
			}
			if (paperout && (mask & ~status & PAPEROUT)) {
				printf("Remote printer paper OK\n");
				paperout = 0;
			}
		}
		state = State;
		if (state == TIME_WAIT || state == CLOSED)
			break;
		if (done)
			continue;
		if (!count) {
			if ((count = fread(buf,1,BUFSIZ,fp)) == 0) {
				close_it:
				done = 1;
				fclose(fp);
				_BX = tcbo;
				_AH = API_TCPCLOSE;
				geninterrupt(API_INT);
				if ((errcode = _AX) != 0) {
					printf("Error on TCP_CLOSE: %s\n",
								err(errcode));
					error:
					printf("\nType any key to exit..");
					while (!kbhit()) {
						_AH = API_NOOP;
						geninterrupt(API_INT);
					}
					getch();
					exit(1);
				}
				continue;
			}
			bufoff = 0;
		}
		_SI = FP_OFF(buf) + bufoff;
		_DX = FP_SEG(buf);
		_CX = count;
		_BX = tcbo;
		_AH = API_TCPWRITE;
		_AL = 0;
		geninterrupt(API_INT);
		errcode = _AX;
		acnt = _CX;
		if (errcode != 0) {
			printf("Error on TCP_WRITE: %s\n",err(errcode));
			goto error;
		}
		count -= acnt;
		bufoff += acnt;
	}
	//status_rep(tcbs,tcbo);
	return 0;
}

status_rep(unsigned tcbs,unsigned tcbo)
{
	int errcode;
	TCB far *tcb;
	static char *states[] = {
		"CLOSED","LISTEN","SYN_SENT","SYN_RECEIVED",
		"ESTABLISHED","FINWAIT1","FINWAIT2","CLOSE_WAIT",
		"CLOSING","LAST_ACK","TIME_WAIT","???"
	};

	if (tcbs == 4)
		tcb = MK_FP(tcbo,tcbs);
	else
		tcb = MK_FP(tcbs,tcbo);
	_SI = 0;
	_DX = 0;	/* no buffer == flush input */
	_CX = 1;
	_BX = tcbo;
	_AH = API_TCPREAD;
	geninterrupt(API_INT);
	if ((errcode = _AX) != 0) {
		if (errcode == NO_CONN || errcode == INVALID) {
			printf("Error on status: %s\n",err(errcode));
			return 0;
		}
	}
	printf("TCB at %Fp state = %s\n",tcb,states[State]);
	return 0;
}

char *err(unsigned errcode)	/* return errorcode string */
{
	static char unk[30];
	static char *errs[] = {
		"No error",
		"Connection already exists",
		"Connection does not exist",
		"Connection closing",
		"No memory for TCB or buffer creation",
		"Would block",
		"Protocol or mode not supported",
		"Invalid arguments"
	};

	if (errcode > INVALID) {
		sprintf(unk,"Unknown error %u",errcode);
		return unk;
	}
	return errs[errcode];
}

/* Convert hex-ascii to integer */
int htoi(char *s)
{
	int i = 0;
	char c;

	while((c = *s++) != '\0'){
		if(c == 'x')
			continue;	/* allow 0x notation */
		if('0' <= c && c <= '9')
			i = (i * 16) + (c - '0');
		else if('a' <= c && c <= 'f')
			i = (i * 16) + (c - 'a' + 10);
		else if('A' <= c && c <= 'F')
			i = (i * 16) + (c - 'A' + 10);
		else
			break;
	}
	return i;
}
