//
//   $Id: FTP.H 1.5 2003/02/15 02:02:58Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
FTP.H
Updated @ Date 8 March 1996, 18:47 by Gerrit van Niekerk
*/

#ifndef	__FTP_H
#define __FTP_H

#define CTLZ	26				/* EOF for CP/M systems */

extern char userfile[];			/* List of user names and permissions */

#if APL
#ifndef __TCP_H
#include "tcp.h"
#endif
#define TCPCON	TCB *
#define TIMEWORD WORD
#else
#define TCPCON	WORD
#define TIMEWORD DWORD
#endif

/* Per-session control block */
struct ftp {
	struct ftp *prev;			/* Linked list pointers */
	struct ftp *next;
	TCPCON control;			/* TCP control connection */
	char state;
#define	COMMAND_STATE			0	/* Awaiting user command */
#define	SENDING_STATE			1	/* Sending data to user */
#define	SENDING_STATE_WPOK	2	/* Wait for PORT OK before Sending */
#define	SEND_RDY_STATE			3	/* Sending, server ready */
#define	SENT_STATE				4	/* Finished sending, waiting for 226 */
#define	LIST_STATE_WTOK		5	/* Wait for TYPE OK before Listing */
#define	LIST_STATE_WPOK		6	/* Wait for PORT OK before Listing */
#define	LIST_STATE				7	/* Listing remote files to get */
#define	LIST_RDY_STATE			8	/* Listing, server ready */
#define	LISTED_STATE_WTOK		9	/* Listing done, waiting for TYPE OK */
#define	LISTED_STATE			10	/* Listing done, waiting for 226 */
#define	RECEIVING_STATE_WPOK 11	/* Wait for PORT OK before Storing */
#define	RECEIVING_STATE		12	/* Storing data from other side */
#define	RECV_RDY_STATE			13	/* Receiving, server ready */
#define	RECEIVED_STATE			14	/* Finished receiving data from user */
#define	REPLY_STATE				15	/* Waiting for reply from raw line */
#define	COMMAND_STATE_WTOK	16	/* waiting for TYPE OK */
#define	RCVLIST_STATE_WPOK	17	// wait for PORT OK before LIST
#define	RCVNLST_STATE_WPOK	18	// wait for PORT OK before NLST
	char type;							/* Transfer type */
#define	IMAGE_TYPE	0
#define	ASCII_TYPE	1

	FILE *fp;					/* File descriptor being transferred */
	struct isocket port;		/* Remote port for data connection */
	TCPCON data;				/* Data connection */
	TIMEWORD time;				/* time of transfer start */

	/* The following are used only by the server */
	char *username;			/* Arg to USER command */
	char *path;					/* Allowable path prefix */
	char perms;					/* Permission flag bits */
#define	FTP_READ			1	/* Read files */
#define	FTP_CREATE		2	/* Create new files */
#define	FTP_WRITE		4	/* Overwrite or delete existing files */
#define	FTP_DIRECTORY	8	/* access any directory or disk */

	char *buf;					/* Input command buffer */
	char cnt;					/* Length of input buffer */
	char mode;					/* normal or raw */
#define	RAW_MODE	1

	char *cd;					/* Current directory name */

	/* And this is used only by the client and a server in 'raw' mode */
	FILE *fplist;				/* listing file for multi-file xfers */
#if APL
	struct mbuf *dispbuf;	/* display buffer */
	struct session *session;
#else
	char *dispbuf;				/* buffer for assembling a line from TCP */
#endif
	char *linebuf;				/* buffer for assembling a line from TCP */
	int lbindex;				/* line buffer index */
	char verbose;				/* show commands when set */
	char flags;					/* various control flags */
#define FF_DISP		1		/* display on */
#define FF_WPOK		2		/* waiting for port ok */
#define FF_NOPATH		4		/* no path in filename */
#define FF_APPEND		8		/* append rather than store */
#define FF_USERNAME	0x10	/* expecting username */
#define FF_PASSWORD	0x20	/* expecting password */
#define FF_PASV		0x40	// using passive mode
	int error;				/* data error on read or write */
	char *oldname;			/* old name to rename from */
	char *remotename;		/* filename of remote file */
};

#if APL
void ftpccr(register struct tcb *tcb,WORD cnt);
void ftp_done(struct ftp *ftp);
char * pathname(struct ftp *ftp,char *path);
int isconsole(char *name);
void ftpdt(struct tcb *tcb,WORD cnt);
void ftpdr(struct tcb *tcb,WORD cnt);

#else

int getline(char **ppline);
int getfline(char **ppline);
void ftpdr(struct ftp *ftp);
void ftpdt(struct ftp *ftp);
void show_window(void);
void hide_window(void);
void write_window(int xpos,int ypos,char *str);
extern char window_shown;
extern FILE *fpinput;
#endif
struct ftp *ftp_create(unsigned bufsize);
void ftp_delete(struct ftp *ftp);
#define	NULLFTP	(struct ftp *)0
#define	LNBFLEN 		152	/* line buffer length */

#endif
