//
//   $Id: HTTFTPS.H 1.6 2003/05/19 19:24:34Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// HTTFTPS.H
//
// Copyright (c) 2001 Datalight, Inc.
// All Rights Reserved
// Datalight Confidential and Proprietary
// Portions copyright 2001 (c) GPvNO
//
// Revision History
// 05/19/2003 gvn state definitions cleaned up
// 07/27/2001 gvn added SetSchedule prototype
//

// HTTPD part

#define HTTP_PORT		80	//standard http port
#define RMS_PORT		81	//for remote server port
#define TIMERINT		8	//0x1c// timer interrupt to use

extern char *pszUserfile;	// filename of permissions file

//HTTP_PARAMS;
//cgi
typedef struct cgiUser {
	char *szName;
	int (far *pfFunc)(HTTP_PARAMS far *psHttpParams);
	char cInuse;
	int iFlags;
	DWORD dwUserID;

	struct cgiUser* psNext;
} CGI_USER;




/* Per-session control block */

#define LINELEN 	128

// HTTP control block

typedef struct https {
	struct https *prev;
	struct https *next;
	unsigned tcbo;			//offset of pointer to tcb structure
	unsigned	id;
	int state;				// state of connection
#define REQUEST 	0
#define HEADER		1
#define POST		2
#define NEWCGI		3
	int request;			// request type
#define RQ_NONE	0		// unknown
#define RQ_GET  	1     // get
#define RQ_POST	2		// post

	char flags;
#define HTTP_RECEIVE				1		//data available at rinet to be read
#define HTTP_SEND					2		//data available at us to be send
#define HTTP_SENDFILE			4		//we can start sending file
#define GOT_RECEIVE_UPCALL		8		//we got a receive upcall, may read data at stable time
#define GOT_TRANSMIT_UPCALL	0x10	//we got a tranmsit upcall, may send data at stable time
#define GOT_STCH_UPCALL			0x20	//we got a state change upcall, may handle at stable time
#define USE_LOCAL_COPY			0x40	// use local copy flag
#define IS_CGI						0x80	// this is a CGI request
	char buf[LINELEN];	// line buffer
	int cnt;					// count of characters in buffer
	char *rqline;			// request line for CGI
	char *pQuery;			// query string for CGI
	char **pCGIEnv;		// space for CGI environment variables
	 int countEnv;			// count of environment variables
	FILE *fp;				// file being sent (or received)
	char *szFilename;		// hold the file name for as short as possible
	char *type;				// type of file
	time_t if_modified_time;
	unsigned long if_modified_length;
	long content_len;
	unsigned tcount;		//the amount we may transmit
	int rcount;		//the amount data available
	int iNameIn;			// number to form stdin name from
	int iNameOut;			// number to form stdout name from
	char *szUser;			// username (if supplied)
	char *szPass;			// password (if supplied)

	char far* far* ppEnv;		//the environment (headers, ip address, etc)
	int iEnvSize;			//the size of the environment

	//api vars
	//char useAPI;			//indicate api user using this connection
	CGI_USER *pCgiUser;		//pointer to cgi user
	int iDataRead;			//amount of data cgi user read
	long dwSessionID;		//per-session ID

} HTTP;

// prototypes and shared variables

void SetSchedule(void);
void _loadds far http_rcv_up(WORD tcbo,WORD cnt);
void _loadds far http_snd_up(WORD tcbo,WORD cnt);
void _loadds far http_stc_up(WORD tcbo,char oldstate,char newstate);
void check_dontwipe(void);
void resinit(void);
#ifdef API
WORD resident(void);
#else
WORD resident(char *signature);
#endif
void http_delete(HTTP *ph);
void s_http(void);
void t_http(register HTTP *ph);
void r_http(register HTTP *ph);
int SendTcph(unsigned tcbo,char far *buf,int cnt);
HttpStatus(unsigned tcbs,unsigned tcbo);
void log();
int Tprintf(unsigned tcbo,char *message, ...);
void ResetTcp(unsigned tcbo);
void close_all(void);
int SendTcp(unsigned tcbo,char *buf,int cnt);
int RecvTcp(unsigned tcbo,char far *buf,int cnt,int *peof);
void CloseTcp(unsigned tcbo);
void DelTcp(unsigned tcbo);
int TcpFunction(unsigned tcbo,char function);
int tcpq_empty(HTTP *ph);		// check for tcp request queue empty
char *err(unsigned errcode);	// return errorcode string
void schedule(void);
void SetPassive(void);			//set server to passive mode
int IsPassive(void);			//check if server to passive mode
int init_RTS(int apiInt, int port);//initialise remote terminal server
void close_RTS(void);			//stop remote terminal server
void setBiosVideo(char *val);
void setAspectRatio(char *val);

#ifdef CHECK_ALLOC
// Allocation checking
void        _Cdecl free_c(void _FAR *__block);
int RemoveAlloc(char *pWhat,void *pM);
#define if_RemoveAlloc(pWhat,pM) if (RemoveAlloc(pWhat,pM))
void        _Cdecl free_c(void _FAR *__block);
void  _FAR *_Cdecl malloc_c(size_t __size);
#else
#define AddAlloc(pWhat,pM)
#define RemoveAlloc(pWhat,pM)
#define if_RemoveAlloc(pWhat,pM)
#define malloc_c(x) malloc(x)
#define free_c(x) free(x)
#endif

extern unsigned serv_tcb;
extern unsigned numcon;		// number of connections
extern unsigned tcbs;
extern char must_schedule;
extern long ip_addr;
extern long alloc_err;		// counter of memory allocation errors

extern char *httpdir;		// pointer to root http directory
extern HTTP *HTTPfirst;
extern HTTP *HTTPlast;
extern char *comspec;		// comspec env variable
extern char *path;			// path env variable
#define URLNF "HTTP/1.0 404 URL not found\r\n"//url not found

int deblog(char* buf);
int deblogf(char *format, ...);

//functions called by tcp que handlers on api module
int ApiCgi(HTTP* psHTTP, char cType, char *szReqLine, int iCount);
CGI_USER *FindCGIUser(char far *szName);
void UnloadCgiApi(void);

// FTPD part

#define CTLZ	26		/* EOF for CP/M systems */

extern char userfile[];	/* List of user names and permissions */

/* Per-session control block */
struct ftp {
	struct ftp *prev;	/* Linked list pointers */
	struct ftp *next;
	int id;
	unsigned control;	/* TCP control connection */
	char state;
#define	COMMAND_STATE			0	/* Awaiting user command */
#define	SENDING_STATE			1	/* Sending data to user */
#define	SENDING_STATE_WPOK	2	/* Wait for PORT OK before Sending */
#define	SEND_RDY_STATE			3	/* Sending, server ready */
#define	SENT_STATE				4	/* Finished sending, waiting for 226 */
#define	LIST_STATE_WTOK		5	/* Wait for TYPE OK before Listing */
#define	LIST_STATE_WPOK		6	/* Wait for PORT OK before Listing */
#define	LIST_STATE				7	/* Listing remote files to get */
#define	LIST_RDY_STATE			8	/* Listing, server ready */
#define	LISTED_STATE_WTOK		9	/* Listing done, waiting for TYPE OK */
#define	LISTED_STATE			10	/* Listing done, waiting for 226 */
#define	RECEIVING_STATE_WPOK 11	/* Wait for PORT OK before Storing */
#define	RECEIVING_STATE		12	/* Storing data from other side */
#define	RECV_RDY_STATE			13	/* Receiving, server ready */
#define	RECEIVED_STATE			14	/* Finished receiving data from user */
#define	REPLY_STATE				15	/* Waiting for reply from raw line */
#define	COMMAND_STATE_WTOK	16	/* waiting for TYPE OK */
#define	RCVLIST_STATE_WPOK	17	// wait for PORT OK before LIST
#define	RCVNLST_STATE_WPOK	18	// wait for PORT OK before NLST
	char type;		/* Transfer type */
#define	IMAGE_TYPE	0
#define	ASCII_TYPE	1

	FILE *fp;				/* File descriptor being transferred */
	struct isocket port;	/* Remote port for data connection */
	int data;				/* Data connection */
	unsigned time;			/* time of transfer start */

	/* The following are used only by the server */
	char *username;		/* Arg to USER command */
	char *path;				/* Allowable path prefix */
	char perms;				/* Permission flag bits */
#define	FTP_READ			1	/* Read files */
#define	FTP_CREATE		2	/* Create new files */
#define	FTP_WRITE		4	/* Overwrite or delete existing files */
#define	FTP_DIRECTORY	8	/* access any directory or disk */

	char *buf;				/* Input command buffer */
	int cnt;					/* Length of input buffer */
	char *dbuf;				// data buffer
	int dcnt;				// data buffer count
	char *cd;				/* Current directory name */

	int flags;					/* various control flags */
#define FF_NOPATH		1		/* no path in filename */
#define FF_APPEND		2		/* append rather than store */
#define	FF_WPOK		4		// wait for port OK
#define FF_CON_RC		8		// control channel receive
#define FF_CON_SN		0x10	// control channel send
#define FF_DAT_CL		0x20	// data channel close
#define FF_DAT_DN		0x40	// data channel done
#define FF_DAT_RS		0x80	// data channel reset
#define FF_DAT_CLSD	0x100	// data channel closed
#define FF_DAT_ST		(FF_DAT_CL|FF_DAT_DN|FF_DAT_RS|FF_DAT_CLSD)
#define FF_DAT_RC		0x200	// data channel receive
#define FF_DAT_SN		0x400	// data channel send
#define FF_PASV		0x800	// using passive mode
#define FF_CLIENT		0x1000// this is a client
#define FF_SNDEOF		0x2000// eof while sending

	int error;				/* data error on read or write */
	char *oldname;			/* old name to rename from */
	char *remotename;		/* filename of remote file */
#ifdef API
	char *dbufc;			// data buffer current pointer
	char mode;
	FILE *fplist;			/* listing file for multi-file xfers */
	char *linebuf;			/* buffer for assembling a line from TCP */
	int lbindex;			/* line buffer index */
	int status;				// status
	char status_line[100];	// status line
#endif
};

#define	NULLFTP	(struct ftp *)0

#define	LNBFLEN		260		/* line buffer length */
#define 	CBUFSZ		260		// control buffer size
#define 	DBUFSZ		500		// data buffer size
// prototypes and shared variables

void _loadds far FtpControlReceive(WORD tcbo,WORD cnt);
void _loadds far FtpControlStateChange(WORD tcbo,char oldstate,char newstate);
void _loadds far FtpDataReceive(WORD tcbo,WORD cnt);
void _loadds far FtpDataTransmit(WORD tcbo,WORD cnt);
void _loadds far FtpDataStateChange(WORD tcbo,char oldstate,char newstate);
void FtpDataStateChangeHandler(struct ftp *ftp);
void FtpDataTransmitHandler(struct ftp *ftp);
void FtpControlReceiveHandler(struct ftp *ftp);
void FtpDataReceiveHandler(struct ftp *ftp);
void FtpControlStateChangeHandler(void);
FtpStatus(unsigned tcbs,unsigned tcbo);
//int SendTcph(unsigned tcbo,char *buf,int cnt);
int SendTcp(unsigned tcbo,char *buf,int cnt);
//int RecvTcp(unsigned tcbo,char *buf,int cnt);
void CloseTcp(unsigned tcbo);
void DelTcp(unsigned tcbo);
void ResetTcp(unsigned tcbo);
void CloseAll(void);
char *err(unsigned errcode);	// return errorcode string
void schedule(void);
struct ftp *ftp_create(void);
void ftp_delete(struct ftp *ftp,int id);
unsigned OpenTcp(struct ftp *ftp,char receive);
//int Tprintf(struct ftp *ftp,char *message,...);
void resinit(void);
void SetRunning(void);
void ftp_client(struct ftp *ftp);

extern unsigned serv_tcb;
extern unsigned numcon;		// number of connections
extern unsigned tcbs;
extern struct ftp *ftps;	// start of ftp chain
extern struct ftp *ftpe;	// end of ftp chain
extern char must_schedule;
extern long ip_addr;
extern unsigned iNumcon;		// number of connections
extern unsigned iMaxNumcon;	// maximum number of connections
extern int iNoKeyboardConfirm;// don't ask confirmation for abort

int ActiveSessions(void);	// test for active sessions

// used in FTPAPI
#ifdef API
void terminate(int iNoConfirm);
void status(WORD seg, WORD off);
void resterm(void);
WORD OpenTcpC(
struct isocket *lsocket,	/* Local socket */
struct isocket *fsocket,	/* Remote socket */
int mode,					/* Active/passive/server */
WORD window,				/* Receive window (and send buffer) sizes */
void (far *r_upcall)(	/*WORD handle,WORD cnt*/),	/* Function to call when data arrives */
void (far *t_upcall)(),	/* Function to call when ok to send more data */
void (far *s_upcall)(	/*WORD control,char old,char new*/),	/* Function to call when connection state changes */
char tos,
char *user);				/* User linkage area */
int startput(struct ftp *ftp,char *locname,char *rname);
int startget(struct ftp *ftp,char *locname,char *rname);
#endif
#ifdef SHOW_DEB
void ShowValue(WORD wVal,BYTE bFlag, int iOffset);
#define ShowDeb(x,y,z) ShowValue(x,y,z)
#else
#define ShowDeb(x,y,z)
#endif

