//
//   $Id: IPX.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* ipx header file
 * Updated @ Date 11 October 1993, 10:8 by Gerrit van Niekerk
 */

#define	OPEN_SOCKET		0
#define	CLOSE_SOCKET		1
#define	GET_LOCAL_TARGET	2
#define	SEND_PACKET		3
#define	LISTEN_FOR_PACKET	4
#define	SCHEDULE_IPX_EVENT	5
#define	CANCEL_EVENT		6
#define	SCHEDULE_SPECIAL_EVENT	7
#define	GET_INTERVAL_MARKER	8
#define GET_INTERNET_ADDRESS	9
#define RELINQUISH_CONTROL	10
#define DISCONNECT_FROM_TARGET	11

typedef struct {		/* IPX address */
	char network[4];
	char node[6];
	char socket[2];
} IPXADDRESS;

typedef struct {		/* IPX header */
	char checksum[2];
	char length[2];
	char transport;
	char type;
	IPXADDRESS dest;
	IPXADDRESS source;
} IPXHEADER;

typedef struct {		/* fragment descriptor */
	void far *addr;
	unsigned size;
} FRAGMENT;

typedef struct {		/* ECB */
	void far *link;
	void far (*esrcall)();
	char inuse;
	char ccode;		/* completion code */
	char socket[2];
	char ipxwork[4];
	char driverwork[12];
	char imadr[6];		/* immediate address */
	unsigned fcount;	/* fragment count */
	FRAGMENT frag1;		/* first fragment */
} ECB;

typedef struct ipxnw {		/* network structure */
	struct ipxnw *link;	/* link to next nw */
	char network[4];	/* the actual nw */
//	char *rt_addr;		/* pointer to router address */
} IPXNW;

void far ipxfunc(void);		/* ipx function call */
