//
//   $Id: KEYS.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* ---------------------- keys.h ------------------------- *
Updated @ Date 6 March 1996, 12:58 by Gerrit van Niekerk
*/
#define FK(n)	   ((unsigned)n * 256)
#define HT 	   9
#define RUBOUT 	   8
#define BS	   8
#define CTRL_BS    0x7f
#define BELL 	   7
#define ESC 	  27
#define SHIFT_HT  FK(15)
#define CTRL_T    20
#define CTRL_B     2
#define CTRL_D     4
#define ALT_Q	 FK(16)
#define ALT_W	 FK(17)
#define ALT_E	 FK(18)
#define ALT_R	 FK(19)
#define ALT_T	 FK(20)
#define ALT_Y	 FK(21)
#define ALT_U	 FK(22)
#define ALT_I	 FK(23)
#define ALT_O	 FK(24)
#define ALT_P	 FK(25)
#define ALT_A	 FK(30)
#define ALT_S	 FK(31)
#define ALT_D    FK(32)
#define ALT_F    FK(33)
#define ALT_G	 FK(34)
#define ALT_H	 FK(35)
#define ALT_J	 FK(36)
#define ALT_K	 FK(37)
#define ALT_L	 FK(38)
#define ALT_Z	 FK(44)
#define ALT_X	 FK(45)
#define ALT_C	 FK(46)
#define ALT_V	 FK(47)
#define ALT_B	 FK(48)
#define ALT_N	 FK(49)
#define ALT_M	 FK(50)

#define ALT_0	 FK(129)
#define ALT_1	 FK(120)
#define ALT_2	 FK(121)
#define ALT_3	 FK(122)
#define ALT_4	 FK(123)
#define ALT_5	 FK(124)
#define ALT_6	 FK(125)
#define ALT_7	 FK(126)
#define ALT_8	 FK(127)
#define ALT_9	 FK(128)

#define F1  FK(59)
#define F2  FK(60)
#define F3  FK(61)
#define F4  FK(62)
#define F5  FK(63)
#define F6  FK(64)
#define F7  FK(65)
#define F8  FK(66)
#define F9  FK(67)
#define F10 FK(68)

#define HOME	FK(71)
#define UP	FK(72)
#define PGUP	FK(73)
#define BWD	FK(75)
#define FWD	FK(77)
#define END	FK(79)
#define DN	FK(80)
#define PGDN	FK(81)
#define INS	FK(82)
#define DEL	FK(83)

#define CTRL_HOME	FK(119)
#define CTRL_BWD	FK(115)
#define CTRL_FWD	FK(116)
#define CTRL_END	FK(117)
#define CTRL_UP		FK(141)
#define CTRL_DN		FK(145)
#define CTRL_PGUP	FK(132)
#define CTRL_PGDN	FK(118)

#define FUNKEY(x) (0x8000 + (x << 4))

#define ENTER	FUNKEY(0)
#define BACKARROW FUNKEY(75)
#define G_BACKARROW FUNKEY(199)
#define FORWARROW FUNKEY(77)
#define G_FORWARROW FUNKEY(200)
#define HOMEK FUNKEY(71)
#define G_HOMEK FUNKEY(196)
#define ENDK FUNKEY(79)
#define G_ENDK FUNKEY(201)
#define DELK FUNKEY(83)
#define G_DELK FUNKEY(205)
#define INSK FUNKEY(82)
#define G_INSK FUNKEY(204)
#define F2KEY FUNKEY(60)
#define F3KEY FUNKEY(61)
#define F4KEY FUNKEY(62)
#define BSKEY FUNKEY(13)
#define ESCKEY FUNKEY(8)
#define BSKEY FUNKEY(13)

int test_key(void);			/* test for freeze(alt_f) and alt_x */
int getline(char **buf);	/* get a cooked or secret line */
void wait_errack(void);			/* wait for error acknowledge */
void cooked(void);
void secret(void);
void raw(void);
int ureadkey(char *pshift,char help_flag);
get_ute_key(int wait);	/* get ute key */
void abort_read(void);
int get_char(void);
