//
//   $Id: MODEM.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* modem.h
Modem driver for INET - header file
Updated @ Date 28 November 1995, 12:23 by Gerrit van Niekerk
*/

typedef struct modempar {	/* modem parameter table */
	struct timer timer;		/* modem timer */
	int time;					/* time for hangup */
	int modem_char_time;		// time between characters in modem commands
	WORD flags;					/* various flags */
#define MF_DIAL	0x01		// always dial if no DCD
#define MF_DISX	0x02		/* display xmit */
#define MF_DISR 	0x04		/* display receive */
#define MF_INIT	0x08		/* has been initialised */
#define MF_DCDLOST 0x10		/* DCD has dropped */
#define MF_ACKSEEN 0x20		// Ack seen in XID
#define MF_DISCON  0x40		// Disconnect active
#define MF_NODOD	 0x80		// No Dial-on-demand
#define MF_DIALNOW 0x100	// Dial now, regardless of MF_NODOD
	char tmstate;			/* timer state */
#define	TM_IDLE 0			// timer is idle
#define	TM_WDCD	1			// wait for DCD
#define	TM_WTO	2			// wait for timeout
#define	TM_WRCV	3			// wait for receive
#define	TM_WXID	4			// wait for XID
#define	TM_WADD	5			// wait for IP address
#define	TM_PACE	6			// wait for modem pacing

	char state;             // modem state
#define MODEM_IDLE		0	// modem is idle
#define	MODEM_INIT		1	// initialising modem
#define	MODEM_DIAL		2	// modem is dialing
#define	MODEM_CONNECT	3	// connecting
#define	MODEM_ANSWER	4	// answering
	char com_char;		// command character
	int retry_val;		// retry value
	int retry;		// retry count
	BYTE **fdial;		// first dial number
	BYTE **dial;		/* pointer to current dial number */
	BYTE *nextptr;		// next pointer to output from
	/* the next entries must stay in order without any changes */
	BYTE *init;		// initialize string
	BYTE *dialcom;		// dial command
	BYTE *connect;		// connect command
	BYTE *answer;		// answer script
	BYTE *xchange;		// exchange id
	BYTE *dialar[1];	// array of dial numbers
} MODEMPAR;

enum {INIT,DIAL,CONNECT,ANSWER,XCHANGE,DIALAR,NUMDIAL = 10};

MODEMPAR *modem_par(char *filename);

void dial_status(MODEMPAR *pm);
