//
//   $Id: PARSER.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//parser.h

typedef struct {
	char type;
	char* string;
} STRINGS;

//Parser Strings
//html tags

#define END_TAG		0x80	//set bit if end-tag
#define TYPE_MASK	0x7f	//flag for getting only tag value
#define TA_UNKNOWN	0xff	//if unknown
#define TAG_TEXT 0
#define TAG_HTML 1
#define TAG_HEAD 2
#define TAG_BODY 3
#define TAG_TITLE 4
#define TAG_META 5
#define TAG_B 6
#define TAG_BR 7
#define TAG_HEX 8
#define WHITESPACE 9
#define TAG_FLASH 10
#define TAG_TABLE 11
#define TAG_TR	12
#define TAG_TD	13
#define TAG_TIME 14

//html attributes
#define ATR_LH		40	//Letter height
#define ATR_LW		41	//Letter width
#define ATR_CS		42	//Character set
#define ATR_HT		43	//Host timeout
#define ATR_WIDTH	44	//Panel width
#define ATR_HEIGHT	48	//Panel height
#define ATR_ALIGN	45
#define ATR_CELLSPACING	46
#define	ATR_CELLPADDING	47

//html possible values
#define VAL_LEFT	60
#define VAL_CENTER	61
#define VAL_RIGHT	62

struct htmlent {			//html entity
	unsigned char token;	//one of constants defined above
	unsigned char atrtoken;	//name of attr - type will hold parent tag
	char* sval;				//if string value to atr
	int ss;					//string size
	char endtag;			//if tag begin or end tag
};

//return the accociated token of given 0 terminated string
unsigned char getToken (char* string);

void startParsing(void);
void onByte(char c);
void setCallback(void (*func)());
//prototype of callback function:
//void (*listener)(struct htmlent *ent);
