//
//   $Id: PING.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* PING.H
   Updated @ Date 30 October 1995, 12:37 by Gerrit van Niekerk
   ICMP Echo ("ping") definitions
*/

struct ping {
	struct ping *next;	/* Linked list pointers */
	struct ping *prev;
	DWORD remote;		/* Address of remote host */
	struct timer timer;	/* Ping interval timer */
	DWORD ttotal;		/* Total round trip time (for averaging) */
	DWORD count;		/* Number of pings sent */
	DWORD echoes;		/* Number of replies received */
	WORD burst;		/* Number of pings/burst */
	WORD size;			// data size of ping
};
#define	NULLPING (struct ping *)0
#define	PMOD	7
extern struct ping *ping[];

/* ID fields for pings */
#define	ONESHOT	0
#define	REPEAT	1
#define	REMCON	2
#define	EXTRNL	3
#define	QUERY   4
#define SILENT	5

typedef struct xping {		/* external ping q */
	struct xping *next;
	DWORD remote;
	WORD seq;
} XPING;

pingem(DWORD dest,WORD seq,WORD id,WORD size);
