//
//   $Id: PPP.H 1.6 2003/08/04 19:54:34Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
#ifndef _PPP_H
#define _PPP_H

// This implementation of PPP is declared to be in the public domain.
//
//	Jan 91	Bill_Simpson@um.cc.umich.edu
//		Computer Systems Consulting Services
//
//	Acknowledgements and correction history may be found in PPP.C
/*
Revision history:
2003-08-04 gvn optionally add route to peer
*/

#ifndef	_MBUF_H
#include "mbuf.h"
#endif

#ifndef	_IFACE_H
#include "iface.h"
#endif

#ifdef _Windows
typedef void INTVOID;
#define VI_ERR
#define VI_RETURN
#else
typedef int INTVOID;
#define VI_ERR -1
#define VI_RETURN return
#endif

// PPP definitions
#define	PPP_ALLOC	128					// mbuf allocation increment


typedef struct ppp_hdr {
	BYTE addr;
#define HDLC_ALL_ADDR			0xff		// HDLC all-station
	BYTE control;
#define HDLC_UI					0x03		// HDLC Unnumbered Information
	WORD protocol;
#define PPP_IP_PROTOCOL			0x0021	// Internet Protocol
#define PPP_COMPR_PROTOCOL		0x002d	// Van Jacobson Compressed TCP/IP
#define PPP_UNCOMP_PROTOCOL	0x002f	// Van Jacobson Uncompressed TCP/IP
#define PPP_IPCP_PROTOCOL		0x8021	// Internet Protocol Control Protocol
#define PPP_CCP_PROTOCOL		0x80fd	// Commpression control protocol
#define PPP_LCP_PROTOCOL		0xc021	// Link Control Protocol
#define PPP_PAP_PROTOCOL		0xc023	// Password Authentication Protocol
#define PPP_LQR					0xc025	// Link Quality Report
#define PPP_CHAP_PROTOCOL		0xc223	// Challenge Handshake Authentication Protocol
#define PPP_SPAP_PROTOCOL		0xc027	//
#define PPP_EAP_PROTOCOL		0xc227	//
	int32	accm_o;								// The current accm value

} PPP_HDR;
#define PPP_HDR_LEN		4				// Max bytes for PPP/HDLC envelope header
#define PPP_HDR_LEN_O   8				// Output header length

// HDLC envelope constants
#define HDLC_ENVLEN	8				// Max bytes for HDLC envelope (outgoing)

#define HDLC_FLAG	0x7e				// HDLC async start/stop flag
#define HDLC_ESC_ASYNC	0x7d		// HDLC transparency escape flag for async
#define HDLC_ESC_COMPL	0x20		// HDLC transparency bit complement mask

#define HDLC_FCS_START	0xffff	// Starting bit string for FCS calculation
#define HDLC_FCS_FINAL	0xf0b8	// FCS when summed over frame and sender FCS


// In ppp.c:
void ppp_send(
MBUF *bp,		// Buffer to send
IFACE *ifp,		// Pointer to interface control block
DWORD gateway,	// Ignored (PPP is point-to-point)
char precedence,char delay,char throughput,char reliability);
INTVOID ppp_output(IFACE *iface, BYTE dest[], BYTE source[],
	WORD type, MBUF *data,BYTE *rif);

int ppp_init(IFACE *iface);
int ppp_free(IFACE *iface);
#ifdef _Windows
void ppp_proc(IFACE *iface,MBUF *pb);
#else
void ppp_proc(IFACE *iface);
#endif

// In pppcmd.c
extern int PPPtrace;			// trace flag
extern IFACE *PPPiface;		// iface for trace

void ppp_show(IFACE *ifp);

int doppp_commands(int argc,char *argv[], void *p);

int doppp_passive(int argc, char *argv[], void *p);

int doppp_close(int argc, char *argv[], void *p);
int doppp_timeout(int argc, char *argv[], void *p);
int doppp_try(int argc, char *argv[], void *p);

#ifndef	_MBUF_H
#include "mbuf.h"
#endif

#ifndef	_PROC_H
//#include "proc.h"
#endif

#ifndef	_IFACE_H
#include "iface.h"
#endif

#ifndef	_TIMER_H
#include "timer.h"
#endif

// config packet header
typedef struct config_hdr {
	BYTE code;
#define CONFIG_REQ	 	1
#define CONFIG_ACK	 	2
#define CONFIG_NAK	 	3
#define CONFIG_REJ		4
#define TERM_REQ	 		5
#define TERM_ACK	 		6
#define CODE_REJ	 		7
#define PROT_REJ	 		8
#define ECHO_REQ	 		9
#define ECHO_REPLY		10
#define DISCARD_REQ		11
#define QUALITY_REPORT	12
// Challenge Handshake Authentication Protocol
#define CHAP_CHALLENGE	1
#define CHAP_RESPONSE	2
#define CHAP_SUCCESS		3
#define CHAP_FAILURE		4
#define SEND_CHALLENGE	3	// to differentiate between CONFIG_REQ and CHALLENGE

	BYTE id;
	WORD len;
} CONFIG_HDR;
#define CONFIG_HDR_LEN	4	// Length of config packet header


// config option header
typedef struct option_hdr {
	BYTE type;					// protocol dependant types
	BYTE len;
} OPTION_HDR;
#define OPTION_HDR_LEN	2	// Length of option header


// Supported Configuration Protocol index
enum {
	Lcp,
	Ap,
	IPcp,
	fsmi_Size
};

struct fsm_s;					// forward declaration

// Protocol Constants needed by State Machine
typedef struct fsm_constant_s {
	char *name;					// Name of protocol
	WORD protocol;				// Protocol number
	WORD recognize;			// Config codes to use (bits)

	BYTE fsmi;					// Finite State Machine index
	BYTE try_req;				// # tries for request
	BYTE try_nak;				// # tries for nak substitutes
	BYTE try_terminate;		// # tries for terminate
	DWORD timeout;				// Time for timeouts (milliseconds)

	// To free structure
	void near (*free)(struct fsm_s *psFSM);

	// Set negotiation to initial values
	void near (*reset)(struct fsm_s *psFSM);
	// When leaving Closed or Listen
	void near (*starting)(struct fsm_s *psFSM);
	// When entering Opened
	void near (*opening)(struct fsm_s *psFSM);
	// When leaving Opened
	void near (*closing)(struct fsm_s *psFSM);
	// When entering Closed or Listen (after termination)
	void near (*stopping)(struct fsm_s *psFSM);

	MBUF * near (*makereq)(struct fsm_s *psFSM);

	int near (*request)(struct fsm_s *psFSM,
					struct config_hdr *hdr,
					MBUF **bpp);
	int near (*ack)(struct fsm_s *psFSM,
					struct config_hdr *hdr,
					MBUF **bpp);
	int near (*nak)(struct fsm_s *psFSM,
					struct config_hdr *hdr,
					MBUF **bpp);
	int near (*reject)(struct fsm_s *psFSM,
					struct config_hdr *hdr,
					MBUF **bpp);
} FSM_CONSTANT;

// FSM states
enum {
	fsmCLOSED,
	fsmLISTEN,
	fsmREQ_Sent,
	fsmACK_Rcvd,
	fsmACK_Sent,
	fsmOPENED,
	fsmTERM_Sent,
	fsmState_Size,
};

// State Machine Control Block
typedef struct fsm_s {
	BYTE state;					// FSM state
	BYTE lastid;				// ID of last REQ we sent

	BYTE flags;
#define PPP_ESCAPED	0x01
#define PPP_TOSS		0x02
#define FSM_PASSIVE	0x40	// opened passive
#define FSM_ACTIVE	0x80	// opened active

	BYTE retry;					// counter for timeouts
	BYTE try_req;				// # tries for request
	BYTE try_terminate;		// # tries for terminate

	BYTE retry_nak;			// counter for naks of requests
#define bChallengeRetry	retry_nak	// for AP use as Challenge retry
	BYTE try_nak;				// # tries for nak substitutes
#define bResponseRetry try_nak		// for AP use as Response retry

	struct ppp_s *psPPP;		// the ppp we belong to
	struct timer timer;
	struct fsm_constant_s *pdc;// protocol dependent constants
	void *pdv;					// protocol dependent variables
	void *pdv_out;				// pdv for outgoing modem_connections
	void *pdv_in;				// pdv for incoming modem connections
} FSM;


// Link Phases
enum {
	pppDEAD,						// Waiting for physical layer
	pppLCP,						// Link Control Phase
	pppAP,						// Authentication Phase
	pppREADY,					// Link ready for traffic
	pppTERMINATE,				// Termination Phase
	pppPhase_Size
};

// PPP control block
typedef struct ppp_s {
	IFACE *iface;					// pointer to interface block

	BYTE phase;						// phase of link initialization
	BYTE id;							// id counter for connection

	BYTE flags;
#define PPP_CBV			0x01	// callback verification
#define PPP_CBVCALL		0x02	// callback in progress
#define PPP_AP_LOCAL		0x10	// local authentication
#define PPP_AP_REMOTE	0x20	// remote authentication

	BYTE trace;						// trace flags for connection

	struct fsm_s fsm[fsmi_Size];	// finite state machines

	DWORD upsince;					// Timestamp when Link Opened
	BYTE *peername;				// Peername from remote (if any)

	DWORD OutTxOctetCount;		// # octets sent
	DWORD OutOpenFlag;			// # of open flags sent
	WORD OutNCP[fsmi_Size];		// # NCP packets sent by protocol
	WORD OutError;					// # packets with error on send
	WORD OutMemory;				// # alloc failures on send

	DWORD InRxOctetCount;		// # octets received
	DWORD InOpenFlag;				// # of open flags
	WORD InNCP[fsmi_Size];		// # NCP packets by protocol
	WORD InUnknown;				// # unknown packets received
	WORD InChecksum;				// # packets with bad checksum
	WORD InFrame;					// # packets with frame error
	WORD InError;					// # packets with other error
	WORD InMemory; 				// # alloc failures
} PPP;

extern char *fsmStates[];
extern char *fsmCodes[];

void htoncnf(CONFIG_HDR *cnf, MBUF **data);
int ntohcnf(CONFIG_HDR *cnf, MBUF **bpp);

void near fsm_no_action(FSM *psFSM);
int near fsm_no_check(FSM *psFSM,
				CONFIG_HDR *hdr,
				MBUF **bp);

void near fsm_log(FSM *psFSM, char *comment);
void near fsm_timer(FSM *psFSM);

int near fsm_send(FSM *psFSM, WORD protocol, BYTE code,
			BYTE id, MBUF **data);
int near fsm_sendreq(FSM *psFSM);

void near fsm_proc(FSM *psFSM, MBUF **bp);

void fsm_start(FSM *psFSM);
void near fsm_down(FSM *psFSM);
void fsm_close(FSM *psFSM);

void fsm_init(FSM *psFSM);
void near fsm_free(FSM *psFSM);

					// LCP option types
#define LCP_MRU				0x01
#define LCP_ACCM				0x02
#define LCP_AUTHENT			0x03
#define LCP_QUALITY			0x04
#define LCP_MAGIC				0x05
#define LCP_PFC				0x07
#define LCP_ACFC				0x08
#define LCP_OPTION_LIMIT	0x08	// highest # we can handle

#define AUTHENT_CHAP_MD5		5	// CHAP MD5 authentication algorithm

// Table for LCP configuration requests
typedef struct lcp_value_s {
	WORD negotiate;		// negotiation flags
#define LCP_N_MRU				(1 << LCP_MRU)
#define LCP_N_ACCM			(1 << LCP_ACCM)
#define LCP_N_AUTHENT		(1 << LCP_AUTHENT)
#define LCP_N_ENCRYPT		(1 << LCP_ENCRYPT)
#define LCP_N_MAGIC			(1 << LCP_MAGIC)
#define LCP_N_QUALITY		(1 << LCP_QUALITY)
#define LCP_N_PFC				(1 << LCP_PFC)
#define LCP_N_ACFC			(1 << LCP_ACFC)

	WORD mru;					// Maximum Receive Unit
	DWORD accm;					// Async Control Char Map
	WORD authentication;		// Authentication protocol
	WORD encryption;			// Encryption protocol
	DWORD magic_number;		// Magic number value
	DWORD reporting_period;	// Link Quality reporting period
} LCP_VALUE;

// Other configuration option values
#define LCP_ACCM_DEFAULT	0xffffffffL
#define LCP_MRU_DEFAULT		1500
#define LCP_MRU_HI			4096		// High MRU limit
#define LCP_MRU_LO			128		// Lower MRU limit

/*
 *	local.want:	Options to request.
 *			Contains desired value.
 *			Only non-default options need to be negotiated.
 *			Initially, all are default.
 *	local.will:	Options to accept in a NAK from remote.
 *	local.work:	Options currently being negotiated.
 *			Value is valid only when negotiate bit is set.
 *
 *	remote.want:	Options to suggest by NAK if not present in REQ.
 *			Contains desired value.
 *	remote.will:	Options to accept in a REQ from remote.
 *	remote.work:	Options currently being negotiated.
 *			Value is valid only when negotiate bit is set.
 */

typedef struct lcp_side_s {
	WORD	will_negotiate;
	struct lcp_value_s want;
	struct lcp_value_s work;
} LCP_SIDE;

// LCP control block
typedef struct lcp_s {
	struct lcp_side_s local;
	struct lcp_side_s remote;
} LCP;

#define LCP_REQ_TRY		10		// REQ attempts
#define LCP_NAK_TRY		10		// NAK attempts
#define LCP_TERM_TRY		10		// tries on TERM REQ
#define LCP_TIMEOUT		4		// Seconds to wait for response


int StartLcp(PPP *psPPP);
int doppp_lcp(int argc, char *argv[], void *p);
int doppp_lcpin(int argc, char *argv[], void *p);

void ppp_ready(struct ppp_s *psPPP);

void lcp_init(struct ppp_s *psPPP);

// AP config packet codes

// Use of AP FSM state byte:

#define AP_REQUEST_SENT		0x01		// PAP request sent
#define AP_CHALLENGE_SENT  0x02		// CHAP challenge sent
#define AP_RESPONSE_SENT	0x04		// CHAP response sent
#define AP_OPENED				0x08		// AP opened

// AP control block
typedef struct ap_s {
	char *psApUsername;			// Username for REQ
	char *psApPassword;			// Password for REQ
	char *psApMessage;			// message from last ACK/NAK
	BYTE *pcChallenge;			// chap challenge value
	BYTE *pcResponse;				// chap response value
	BYTE bChallengeId;			// last challenge ID sent
} AP;


#define PAP_REQ_TRY	100	// REQ attempts
#define PAP_FAIL_MAX	2		// # attempts from remote
#define PAP_TIMEOUT	3		// Seconds to wait for response


int near ap_local(struct ppp_s *psPPP);
int near ap_remote(struct ppp_s *psPPP,WORD protocol);
void near ap_down(FSM *psFSM);
void near ap_proc(FSM *psFSM, MBUF **bpp, WORD protocol);

int doppp_ap(int argc, char *argv[], void *p);
int doppp_apin(int argc, char *argv[], void *p);
void ap_init(struct ppp_s *psPPP);

#ifndef _SLHC_H
#include "slhc.h"
#endif

// IPCP option types
#define IPCP_ADDRESSES		0x01
#define IPCP_COMPRESS		0x02
#define IPCP_ADDRESS			0x03
#define IPCP_DNS1				0x04	// mapped from 0x81
#define IPCP_DNS2          0x05  // mapped from 0x83
#define IPCP_PRI_DNS			0x81	// real primary DNS
#define IPCP_SEC_DNS			0x83	// real secondary DNS
#define IPCP_OPTION_LIMIT	0x05	// highest # we can handle

// Table for IPCP configuration requests
typedef struct ipcp_value_s {
	WORD negotiate;					// negotiation flags
#define IPCP_N_ADDRESSES	(1 << IPCP_ADDRESSES)
#define IPCP_N_COMPRESS		(1 << IPCP_COMPRESS)
#define IPCP_N_ADDRESS		(1 << IPCP_ADDRESS)
#define IPCP_N_DNS1			(1 << IPCP_DNS1)
#define IPCP_N_DNS2			(1 << IPCP_DNS2)

	DWORD dwLocalAddress;			// address for this side
//	DWORD dwRemoteAddress;			// address for other side
	WORD compression;					// Compression protocol
	WORD slots;							// Slots (0-n)
	BYTE slot_compress;				// Slots may be compressed (flag)
	BYTE bFlags;						// Flags
#define IPCP_ADD_RT	1				// Add host route to remote
	DWORD ardwDnsAddress[2];		// Primary and secondary DNS addresses
} IPCP_VALUE;

#define IPCP_SLOT_DEFAULT	16		// Default # of slots
#define IPCP_SLOT_HI			64		// Maximum # of slots
#define IPCP_SLOT_LO 		 1		// Minimum # of slots
#define IPCP_SLOT_COMPRESS	0x01	// May compress slot id

typedef struct ipcp_side_s {
	WORD will_negotiate;
	struct ipcp_value_s want;
	struct ipcp_value_s work;
} IPCP_SIDE;

// Store address pool in otherwise unused address locations
//#define peer_min	local.want.dwRemoteAddress		// First IP address in pool
//#define peer_max	remote.want.dwRemoteAddress	// Last IP address in pool

// IPCP control block
typedef struct ipcp_s {
	struct ipcp_side_s local;
	struct ipcp_side_s remote;

	struct slcompress *slhcp;	// pointer to compression block
} IPCP;

#define IPCP_REQ_TRY		20		// REQ attempts
#define IPCP_NAK_TRY		10		// NAK attempts
#define IPCP_TERM_TRY	10		// tries on TERM REQ
#define IPCP_TIMEOUT		3		// Seconds to wait for response


int doppp_ipcp(int argc, char *argv[], void *p);
int doppp_ipcpin(int argc, char *argv[], void *p);
void ipcp_init(struct ppp_s *psPPP);
int ppp_iostatus(IFACE *ifp, int command, DWORD value);
void ppp_skipped(PPP *psPPP, MBUF **bp, int code);
#define PARAM_UP 	0				// bring interface up
#define PARAM_DOWN 	1			// bring interface down

#endif // _PPP_H
