//
//   $Id: QUESTION.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
#ifndef __SCONFIG_H_
#include "sconfig.h"
#include "sconfig.pt"
#endif


/*
	MAIN QUESTION TREE

	Chains downward from qFirst....
*/
OPTION optAbort =
{
	"Quit and return to DOS",				NULL,					FuncAbort
};

OPTION optStatic =
{
	"Static Addressing (Manual)",			NULL,					FuncStatic
};

OPTION optDHCP =
{
	"DHCP",										NULL,					FuncDHCP
};

OPTION optBOOTP =
{
	"BOOTP",										NULL,					FuncBOOTP
};


POPTION	optPacketChoices[] = { &optStatic, &optDHCP, &optBOOTP, &optAbort, NULL };
QUESTION qPacketDriver =
{
	"How will Sockets assign an IP address to the network card?\n",
	optPacketChoices
};


OPTION optPacketDriver =
{
	"Network Card (Packet Driver)",		&qPacketDriver,	NULL
};

OPTION optSerialPort =
{
	"Modem (Serial Port via PPP)",		NULL,					FuncPPP
};

POPTION optMediaChoices[] = { &optPacketDriver, &optSerialPort, &optAbort, NULL };
QUESTION qSelectMedia =
{
	"Are you using a network card or a modem?\n"
	"If Sockets will communicate through a packet driver, you must\n"
	"select Network Card.  If Sockets will communicate through a\n"
	"serial port, you must answer Modem.\n",

	optMediaChoices
};

OPTION optSelectMedia =
{
	"Continue configuration",				&qSelectMedia,		NULL
};

POPTION optFirstChoices[] = { &optSelectMedia, &optAbort, NULL };
QUESTION qFirst =
{
	"This utility will overwrite your SOCKET.CFG and MODEM.MCF files\n"
	"Are you sure you wish to continue?\n",

	optFirstChoices
};


/*
	PPP QUESTIONS

	Used to retrieve serial port and baud rate numbers
*/
OPTION optCOM1 = { "COM1", NULL, NULL };
OPTION optCOM2 = { "COM2", NULL, NULL };
OPTION optCOM3 = { "COM3", NULL, NULL };
OPTION optCOM4 = { "COM4", NULL, NULL };
OPTION optCustom = { "Custom", NULL, NULL };
POPTION optPorts[] = { &optCOM1, &optCOM2, &optCOM3, &optCOM4, &optCustom, NULL };

QUESTION qPort = 
{
	"Please select the serial port to which the device is connected:\n",

	optPorts
};

OPTION opt1200   = { "1200",   NULL, NULL };
OPTION opt2400   = { "2400",   NULL, NULL };
OPTION opt9600   = { "9600",   NULL, NULL };
OPTION opt19200  = { "19200",  NULL, NULL };
OPTION opt38400  = { "38400",  NULL, NULL };
OPTION opt57600  = { "57600",  NULL, NULL };
OPTION opt115200 = { "115200", NULL, NULL };
POPTION optSpeeds[] = { &opt1200, &opt2400, &opt9600, &opt19200, &opt38400,
		&opt57600, &opt115200, NULL };

QUESTION qSpeed = 
{
	"Please select the baud rate to use:\n",

	optSpeeds
};
