//
//   $Id: RTLDATA.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*------------------------------------------------------------------------
 * filename - rtldata.h
 *
 *      definitions for DLL instance data
 *-----------------------------------------------------------------------*/

/*[]------------------------------------------------------------[]*/
/*|                                                              |*/
/*|     C/C++ Run Time Library - Version 4.0                     |*/
/*|                                                              |*/
/*|                                                              |*/
/*|     Copyright (c) 1991 by Borland International              |*/
/*|     All Rights Reserved.                                     |*/
/*|                                                              |*/
/*[]------------------------------------------------------------[]*/

#if !defined( __RTLDATA_H )
#define __RTLDATA_H

#include <_defs.h>
#include <time.h>
#include <_printf.h>
#include <suballoc.h>
#include <stdio.h>
#include <_nfile.h>

#define _F_STDIN    (_F_READ | _F_TERM | _F_LBUF)
#define _F_STDOUT   (_F_WRIT | _F_TERM | _F_LBUF)
#define _F_STDERR   (_F_WRIT | _F_TERM)
#define _F_STDAUX   (_F_RDWR | _F_TERM | _F_BIN)
#define _F_STDPRN   (_F_WRIT | _F_TERM | _F_BIN)

typedef void (_FAR * _FARFUNC pvf)();

#define TZstrlen        3        /* Len of tz string(- null terminator) */
#define DefaultTimeZone 5L
#define YES 1
#define DefaultDaylight YES

struct _RTLData
{
    FILE _streams[_NFILE_];
    unsigned int _openfd[_NFILE_];
    unsigned int _nfile;
    int _fmode;
    int _notUmask;
    int _doserrno_;
    pvf _new_handler;
    char strbuf[94 + 2 + 64 + 1];
    char *Ss;
    char _template[L_tmpnam];
    unsigned int _tmpnum;
    char a[26];
    char _DfltZone[ TZstrlen+1 ], _DfltLight[ TZstrlen+1 ];
    long  timezone_;
    int   daylight_;
    char  *tzname_[2];
    struct tm tmX;
    int errno_;
    unsigned long _StartTime;
    char _cvtBuf[__XCVTDIG__ + 2];
    struct TSubAllocClientData subAllocData;
};

#if !defined( _RTLDLL )
#   define _QRTLDataBlock
#   define _RTLInstanceData(x) (x)
#   define _QRTLInstanceData(x) (x)
#else
#   if defined( __cplusplus )
        extern "C" struct _RTLData far * _export pascal __getRTLInstanceData();
        extern "C" struct TSubAllocClientData far * __GetSubAllocClientData();
#   else
        struct _RTLData far * _export pascal __getRTLInstanceData(void);
        struct TSubAllocClientData far * __GetSubAllocClientData(void);
#   endif
#   define _QRTLDataBlock struct _RTLData far *__rtlInstanceData = __getRTLInstanceData()
#   define _RTLInstanceData(x) (__getRTLInstanceData()->x)
#   define _QRTLInstanceData(x) (__rtlInstanceData->x)
#endif

#endif  // __RTLDATA_H
