//
//   $Id: _CAPI.H 1.8 2003/08/19 16:55:26Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// CAPI.H
// Compatible API header file
// 1.00 1999-03-18 Starting version control

// The compatibility API is called called by setting up registers
// and memory structures and issueing an Interrupt 0x61. The AH
// register holds the function code as defined below:

// Note: use a tab setting of 4 spaces for proper viewing

#ifndef __WIN_TYPES
#define __WIN_TYPES
typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef unsigned long DWORD;
#endif

#define	GetBusyFlag		0x01
#define	GetKernelInfo	0x02
#define	GetAddr			0x05
#define	NetInfo			0x06
#define	NetGlobalize	0x07
#define	NetRelease		0x08
#define	NetReleaseAll	0x09
#define	IsNetDesc		0x0d
#define	NetSelect		0x0e
#define	GetNetVersion	0x0f
#define	NetShutDown		0x10
#define	DisableAsynch	0x11
#define	EnableAsynch	0x12
#define	NetConnect		0x13
#define	GetPeer			0x16
#define	NetEof			0x18
#define	NetAbort			0x19
#define	NetWrite			0x1a
#define	NetRead			0x1b
#define	NetWriteTo		0x1c
#define	NetReadFrom		0x1d
#define	NetFlush			0x1e
#define	NetAsynch		0x1f
#define	SetOption		0x20
#define	NetGetDesc		0x22
#define	NetListen		0x23
#define	NetAbortAll		0x24
#define	NET_SWAP			0x28
#define	NetGetGlobDesc	0x29
#define 	NetGetKConf		0x2a
#define 	NetAlarm			0x2b
#define 	IcmpPing			0x30
#define	NmPrsAddr		0x50
#define	NmHTable			0x51
#define	NmResName		0x54
#define	JOIN_GROUP		0x60
#define	LEAVE_GROUP		0x61
#define	IFACE_IOCTL		0x62
#define	GET_SOCKETS_VERSION	0x63
#define	ARP_API					0x64
#define	ARP_API_ADD				0
#define 	ARP_API_DROP			1
#define 	ARP_API_GETTABLE     2
#define  NET_ACCEPT_LISTEN 	0x65
#define	NET_ACCEPT				0x66


// If an error occurs, the Carry Flag is set and an error code is
// returned in the AX register as follows:

#define	NoErr				0	// No error
#define	ErrInUse			1	// A connection already exists
#define 	ErrDOS			2	// A DOS error occured
#define	ErrNoMem			3	// No memory to perform function
#define	ErrNotNetConn	4	// Connection does not exist
#define	ErrIllegalOp	5	// Protocol or mode not supported
#define	ErrNoHost		7	// No host address specified
#define	ErrTimeOut		13	// The function timed out
#define	ErrHostUnknown	14	// Unknown host has been specified
#define	ErrBadArg		18	// Bad arguments
#define	ErrEOF			19	// The connection has been closed by peer
#define	ErrReset			20	// The connection has been reset by peer
#define	ErrWouldBlock	21	// Operation would block
#define	ErrUnbound		22	// The descriptor has not been assigned yet
#define	ErrNoDesc		23	// No descriptor is available
#define	ErrBadSysCall	24	// Bad parameter in call
#define	ErrNotEstab		26	// The connection has not been established
#define	ErrReEntry		27	// The kernel is in use, try again later
#define	ErrICMPMsg		28	// ICMP message
#define ErrTerminating	29	// Kernel unloading
#define ERR_INF_LOCKED		30	 /* Kernel info locked */
#define ERR_BAD_INTERFACE	31	 /* Bad intreface specified */
#define ErrAPINotLoaded	50	// API is not loaded

// Network address structure for NetConnect() and NetListen()

typedef struct net_addr {
	long remote_host;			// IP address of remote host
	unsigned remote_port;	// Remote port address
	unsigned local_port;		// Local port address
	unsigned char protocol;	// protocol
} NET_ADDR;

typedef struct group_addr {// Multicast group structure
	DWORD dwGroupAddr;		// group address
	DWORD dwIFAddr;			// IP address of interface to use, 0 for default
} GROUP_ADDR;

// connection types for NetConnect() and NetListen()

#define	DataGram	3
#define	Stream		4

// flags for NetRead, NetReadFrom, NetRecv, NetRecvFrom,
// NetWrite, NetWriteTo, NetSend, NetSendTo

#define	NetFlgOOB			0x0001	// out of band data
#define	NetFlgPeek			0x0002	// don't dequeue data
#define	NetFlgPush			0x0010	// disregard Nagle heuristic
#define	NetFlgNonBlocking	0x0040	// don't block
#define	NetFlgBroadCast	0x0080	// broadcast data
#define 	NET_FLG_MC_NOECHO	0x1000	// don't echo multicast

// Values used in SetOption

#define	NetOptNonBlocking	0x01	// don't block on system calls
#define	NetOptTimeOut		0x02	// timeout system calls
#define	NET_OPT_KEEPALIVE	0x06	// TCP keepalive
#define	NetOptWaitFlush	0x0C	// Honor NetFlgPush on this Desc

// values for NetAsynch routines

#define	NetAsAlarm		0x00
#define	NetAsOpen		0x01
#define	NetAsRcv			0x02
#define	NetAsXmt			0x03
#define	NetAsXmtflush	0x04
#define	NetAsFclose		0x05
#define	NetAsClose		0x06
#define	NetAsError		0x07

#define MaxAsEvent		NetAsError

// CAPI internal structures
typedef struct {		/* event */
	int (far *handler)(void);
	unsigned long hint;
} EVENT;

typedef struct {		/* network descriptor */
	int flags;
#define ND_ASSIGNED	1
#define NO_BLOCK		2
#define TCP_CON		4
#define UDP_CON		8
#define TIME_OUT		0x10
#define WRITE_NOTIFY	0x20	// write notification enabled
#define KEEP_ALIVE	0x40	// keep-alive is set
#define WAIT_FLUSH	0x80	// NET_OPT_WAITFLUSH is set
#define LISTEN_FLAG	0x100	// listen() was used
	TCB *tcb;
	EVENT event[MaxAsEvent + 1];
	unsigned long timer;	/* timer value set by set_option() */
	unsigned long ctime;	/* current timer value while timing */
	TIMER *alarm_timer;
} ND;

typedef struct {		/* UDP structure referenced in ND */
	struct socket remote_socket;
	unsigned lport;
} UCB;

// NetInfo structure

struct netinfo {
	int	class;
	int	type;
	int	number;
	DWORD ip_address;
	DWORD ip_subnet;
	int	up;
	DWORD in;
	DWORD out;			/* # of packets transmitted */
	DWORD inerr;		/* # of receiver errors */
	DWORD outerr;		/* # of transmitter errors */
	int	lanlen;			/* length of local net address */
	BYTE far *lanaddr;	/* pointer to the lan address */
};

// kernel configuration
struct kernel_conf {
	BYTE	k_max_tcp;	/* # of TCP connections allowed */
	BYTE	k_max_udp;	/* # of UDP connections allowed */
	BYTE	k_max_ip;	/* # of IP connections allowed */
	BYTE	k_max_raw;	/* # of RAW_NET connections allowed */
	BYTE	k_act_tcp;	/* # of TCP connections in use */
	BYTE	k_act_udp;	/* # of UDP connections in use */
	BYTE	k_act_ip;	/* # of IP connections in use */
	BYTE	k_act_raw;	/* # of RAW_NET connections in use */
	WORD	k_act_lcl;	/* # of active Local network descriptors */
	WORD	k_act_gbl;	/* # of active Global network descriptors */
	BYTE	k_MaxLnh;	/* Maximum header on an attached network */
	BYTE	k_MaxLnt;	/* Maximum trailer on an attached network */
	WORD	k_LBUF_SIZE;/* Size of a large packet buffer */
	WORD	k_Nnet;		/* Number of network interfaces attached */
	DWORD 	k_cticks;	/* Milliseconds since kernel started */
	DWORD	k_broadcast;/* IP broadcast address in use */
};

// Kernel info
#define K_INF_TCP_CONS      0x04
#define K_INF_HOST_TABLE    0x08
#define K_INF_DNS_SERVERS   0x09
#define K_INF_HOSTNAME      0x5a
#define K_INF_LOCAL_PORT	 0x5b	// Next available local port
#define K_INF_TCP_CB			 0x5c	// TCP Control Block
#define K_INF_MAC_ADDR      0x81 //
#define K_INF_BCAST_ADDR    0x84
#define K_INF_IP_ADDR       0x82
#define K_INF_SUBNET_MASK   0x85
#define K_INF_REMOTE_IP		 0x86	// remote IP address on PPP


