//
//   $Id: ALLOC.C 1.13 2003/09/06 00:47:52Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// ALLOC.C
// Copyright (c) 2001 Datalight, Inc.
// All Rights Reserved
// Datalight Confidential and Proprietary
// Portions Copyright (c) GPvNO 1990-2001
// Portions Copyright (c) 1986-1989 Phil Karn, KA9Q
//
// Memory allocation functions
//
// Revision History
// 12/05/2001 gvn default heapsize to run common configs without /m=
// 09/21/2001 gvn Fix /m=60000 crash
// 05/29/2001 gvn Updates...

//#define SHOWMEM

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <alloc.h>
#include <ctype.h>
#if APL
// before re-defines of allocation functions
#ifdef ALLOC_TRACE
#define _DIST_ALLOC far
#include "allocdef.h"
void *Malloc(unsigned size, unsigned id);
void *Calloc(unsigned items, unsigned size, unsigned id);
void *ReAlloc(void *block, unsigned size, unsigned id);
char *Strdup(const char *s, unsigned id);

void *malloc(unsigned size)
{
	return Malloc(size,AllocAllocLib);
}

void *calloc(unsigned items, unsigned size)
{
	return Calloc(items,size,AllocAllocLib);
}

void *realloc(void *block, unsigned size)
{
	return ReAlloc(block,size,AllocAllocLib);
}

#ifdef SERIAL
char *strdup(const char *s)
{
	return Strdup(s,AllocAllocLib);
}
#endif

#else
void *Malloc(unsigned size);
void *Calloc(unsigned items, unsigned size);
void *ReAlloc(void *block, unsigned size);
char *Strdup(const char *s);
void *malloc(unsigned size)
{
	return Malloc(size);
}

void *calloc(unsigned items, unsigned size)
{
	return Calloc(items,size);
}

void *realloc(void *block, unsigned size)
{
	return ReAlloc(block,size);
}

#ifdef SERIAL
char *strdup(const char *s)
{
	return Strdup(s);
}
#endif

#endif
#endif
#include "inetdefs.h"
#include "mbuf.h"
#include "iface.h"
#include "_api.h"

//#define ALLOC_TRACE		// keep track of malloc and free
#ifdef ALLOC_TRACE
#define TRACE_SIZE 10000
TRACEBUF far trace_buf[TRACE_SIZE];
#else
#define	trace_buf 0
#endif

unsigned get_memavail(void);

#if APL
#define DEFHEAPSIZE 		0xe000	// 56 k default
#define DEFSTKSIZE 		0x1000	// 4 k default
#else
#ifdef ASYNC
#define DEFHEAPSIZE 		0x5800	// 22 k default
#define STARTHEAPSIZE   0x2000	// at least 8k at startup
#else
#define DEFHEAPSIZE 		0x4000	// 16 k default
#define STARTHEAPSIZE   0x1000	// at least 4k at startup
#endif
#define DEFSTKSIZE 		0x800		// 2 k default
char *initfree;
char *printfree;
#endif

unsigned heapsize = DEFHEAPSIZE;
unsigned stksize = DEFSTKSIZE;
unsigned stack_bottom;		/* bottom of stack */

extern unsigned stack_pointer;
socket_exit();			/* routine in first slot of loadmap */

#ifndef	NULL
#define	NULL	(void *)0
#endif
#undef NULLCHAR
#define	NULLCHAR	(char *)NULL
union header {
	struct {
		union header *ptr;
		unsigned size;
	} s;
	long len;
};

typedef union header HEADER;
#define	NULLHDR	(HEADER *)NULL
#define HEADERSZ (sizeof(HEADER))

HEADER membase, *allocp = NULLHDR;

struct mem_stat mem_stat = {
	0,0,0,0,
	0,trace_buf,&membase,0
};

/* Allocate block of 'nb' bytes */
#ifdef ALLOC_TRACE
void *Malloc(unsigned nb, unsigned id)
#else
void *Malloc(unsigned nb)
#endif
{
	register HEADER *p, *q;
	register unsigned nu;
#if APL
	static char initflag;
	char far *pcom;
	char ch;
	unsigned *pval,val,state,len;

	if (!initflag) {
		pcom = MK_FP(_psp,0x80);
		len = *pcom++;
		for (state = 0;len;len--,pcom++) {
			ch = *pcom;
			switch (state) {
			case 0:
				if (ch == '/')
					state = 1;
				break;
			case 1:
				ch |= ('a' - 'A');
				if (ch == 'm') {
					state = 2;
					pval = &heapsize;
				}
				else if (ch == 's') {
					state = 2;
					pval = &stksize;
				}
				else
					state = 0;
				val = 0;
				break;
			case 2:
				if (ch == '=')
					break;
				if (isdigit(ch))
					val = val * 10 + ch - '0';
				else {
					state = 3;
					if (val)
						*pval = val;
				}
				break;
			case 3:
				if (isspace(ch))
					state = 0;
				break;
			}
		}
		if (state == 2 && val)
			*pval = val;
		{
			extern char *__brklvl;
			char *cp;
			register HEADER *up;
			register unsigned int size;

			/* Initialize the heap pointers */
			if (allocp == NULLHDR){
				membase.s.ptr = allocp = &membase;
				membase.s.size = 1;
			}
			/* Find out where the break is */
			cp = (char *)(((WORD)__brklvl + HEADERSZ - 1) & ~(HEADERSZ - 1));
			size = _SP - (unsigned)cp - 64;
			if ((unsigned long)stksize + (unsigned long)heapsize > size) {
				if (stksize > DEFSTKSIZE)
					stksize = DEFSTKSIZE;
				heapsize = size - stksize;
			}
			up = (HEADER *)cp;
			up->s.size = heapsize / HEADERSZ;
			up->s.ptr = up;	/* satisfy audit */
			stack_bottom = (unsigned)(up + up->s.size + 1);
			stack_pointer = stack_bottom + stksize;
			mem_stat.stack_avail = stksize;
			free((char *)(up + 1));
		}
		initflag = 1;
	}
#endif
	if ((nu = nb + 3) < nb)
		return NULLCHAR;	// overflow!
	nu = (nu >> 2) + 1;
	idisable();
	if ((q = allocp) == NULLHDR){
		membase.s.ptr = allocp = q = &membase;
		membase.s.size = 1;
	}
	for (p = q->s.ptr; ; q = p, p = p->s.ptr){
		if (p->s.size >= nu){
			if (p->s.size == nu){
				q->s.ptr = p->s.ptr;
			} else {
				p->s.size -= nu;
				p += p->s.size;
				p->s.size = nu;
			}
			allocp = q;
			p->s.ptr = p;	/* for auditing */
#ifdef ALLOC_TRACE
			{
				int i;
				for (i = 0;i < mem_stat.trace_index;++i) {
					if (trace_buf[i].adr == 0) {
						trace_buf[i].adr = (WORD)p;
						trace_buf[i].id = id;
						break;
					}
				}
				if (i == mem_stat.trace_index &&  mem_stat.trace_index < TRACE_SIZE){
					trace_buf[mem_stat.trace_index].adr = (WORD)p;
					trace_buf[mem_stat.trace_index++].id = id;
				}
				i = ((WORD *)(p))[1];
			}
#endif
			popf();
			//printf("malloc(%u) %p %x\n",nb,p+1,p->s.size);
			return 	(char *)(p + 1);
		}
		if (p == allocp){
			mem_stat.mem_fail++;
			popf();
			//printf("malloc(%u) failed\n",nb);
			return NULLCHAR;
		}
	}
}

/* Initialize memory */
void InitMemory(void)
{
#if !APL
	extern char *__brklvl;
	char *cp;
	register HEADER *up;

	int initsize;
	char *pinit;
	extern char far lastdata[];
	extern char far lastprinter[];
	unsigned long ulInit_Heap_Stack_Top = 0l;
	unsigned long ulDifference = 0l;
	unsigned uOldHeapSize, uOldStackSize;

	/* Initialize the heap pointers */
	if (allocp == NULLHDR){
		membase.s.ptr = allocp = &membase;
		membase.s.size = 1;
	}

	if (stksize == 0)
	{
		printf("\tInvalid stack size specified: using default!\n");
		stksize = DEFSTKSIZE;
	}

	if (heapsize == 0)
	{
		printf("\tInvalid memory size specified: using default!\n");
		heapsize = DEFHEAPSIZE;
	}

	/* Find out where the break is */
	cp = (char *)(((WORD)__brklvl + HEADERSZ - 1) & ~(HEADERSZ - 1));
#if 0
	size = _SP - (unsigned)cp - 64;
	if ((unsigned long)stksize + (unsigned long)heapsize > size) {
		if (stksize > DEFSTKSIZE)
			stksize = DEFSTKSIZE;
		heapsize = size - stksize;
	}
#endif
	pinit = (char *)((FP_SEG(lastdata) - FP_SEG(cp)) << 4) + HEADERSZ;
	initfree = (char *)((FP_SEG(lastprinter) - FP_SEG(cp)) << 4) + HEADERSZ;
	printfree = cp + HEADERSZ;
	initsize = pinit - initfree;

	ulInit_Heap_Stack_Top = (unsigned)((HEADER *)(pinit - HEADERSZ));
	ulInit_Heap_Stack_Top += heapsize - initsize;
	ulInit_Heap_Stack_Top += stksize;
	// did we exceed segment limits?
	if (ulInit_Heap_Stack_Top > 0xFFFFl)
	{
		printf("*** ERROR: memory limits exceeded.\n");

		// get the difference (how much did we exceed FFFFh?)
		ulDifference = ulInit_Heap_Stack_Top - 0xFFFFl;

		// can we take the difference off of the heapsize?
		if (heapsize > DEFHEAPSIZE)
		{
			uOldHeapSize = heapsize;

			// yes, set heapsize to default if greater than default
			if ((ulDifference > heapsize) || (heapsize - (unsigned)ulDifference) <= DEFHEAPSIZE)
			{
				ulDifference -= (heapsize - DEFHEAPSIZE);
				heapsize = DEFHEAPSIZE;
			}
			else
			{
				heapsize -= (unsigned)ulDifference;
				ulDifference -= uOldHeapSize - heapsize;
			}

			printf("\tReducing memory size from %u to %u.\n", uOldHeapSize, heapsize);
		}


		// can we take the difference off of the stacksize?
		if ((ulDifference > stksize) || ulDifference && stksize > DEFSTKSIZE)
		{
			uOldStackSize = stksize;

			// yes, set stksize to default if greater than default
			if ((stksize - (unsigned)ulDifference) <= DEFSTKSIZE)
			{
				ulDifference -= (stksize - DEFSTKSIZE);
				stksize = DEFSTKSIZE;
			}
			else
			{
				stksize -= (unsigned)ulDifference;
				ulDifference -= uOldStackSize - stksize;
			}
			printf("\tReducing stack size from %u to %u.\n\n", uOldStackSize, stksize);
		}

		if (ulDifference > 0)
		{
			printf("\t*** unable to reduce memory enough - exiting **\n");
			exit(1);
		}

	}

	if (heapsize < initsize + STARTHEAPSIZE)
		heapsize = initsize + STARTHEAPSIZE;	// need some heap for initialization
// printf("DS=%04x heapsize=%u stacksize=%u initsize=%d\n",_DS,heapsize,stksize,initsize);

	up = (HEADER *)cp;
	up->s.size = (initfree - printfree) / HEADERSZ;
	up->s.ptr = up;	/* satisfy audit */
//	printf("printfree %p up %p size %u 0x%x\n",printfree,up,up->s.size*HEADERSZ,up->s.size*HEADERSZ);
	up = (HEADER *)(initfree - HEADERSZ);
	up->s.size = initsize / HEADERSZ;
	up->s.ptr = up;	/* satisfy audit */
//	printf("initfree %p up %p size %u 0x%x\n",initfree,up,up->s.size*HEADERSZ,up->s.size*HEADERSZ);
	up = (HEADER *)(pinit - HEADERSZ);
	up->s.size = (heapsize - initsize - HEADERSZ) / HEADERSZ;
	up->s.ptr = up;				/* satisfy audit */
//	printf("startfree %p up %p size %u 0x%x\nheap_top %p\n",up+1,up,up->s.size*HEADERSZ,up->s.size*HEADERSZ,up + (up->s.size + 1));

	stack_bottom = (unsigned)(up + up->s.size + 1);
	stack_pointer = stack_bottom + stksize;
	mem_stat.stack_avail = stksize;
	free((char *)(up + 1));
#endif
}

/* Put memory block back on heap */
void free(void *blk)
{
	register HEADER *p, *q;
	int avail;

	if (blk == 0)
		return;		// nothing to do
	if ((avail = _SP - stack_bottom) < mem_stat.stack_avail &&
								avail > -200)
		mem_stat.stack_avail = avail;
	idisable();
	p = (HEADER *)blk - 1;
	//printf("free(%p %x)\n",p,p->s.size);
	/* Audit check */
	if(p->s.ptr != p){
		popf();
		mem_stat.mem_free_err++;
		return;
	}
#ifdef ALLOC_TRACE
	{
		int i;

		for (i = 0;i < mem_stat.trace_index;++i) {
			if (trace_buf[i].adr == (WORD)p) {
				trace_buf[i].adr = 0;
				if (i == mem_stat.trace_index - 1)
					--mem_stat.trace_index;
				break;
			}
		}
	}
#endif
	for(q = allocp; !(p > q && p < q->s.ptr); q = q->s.ptr){
		if (q >= q ->s.ptr && (p > q || p < q->s.ptr))
			break;
	}
	if(p + p->s.size == q->s.ptr){
		p->s.size += q->s.ptr->s.size;
		p->s.ptr = q->s.ptr->s.ptr;
	} else
		p->s.ptr = q->s.ptr;
	if(q + q->s.size == p){
		q->s.size += p->s.size;
		q->s.ptr = p->s.ptr;
	}
	else q->s.ptr = p;
	allocp = q;
	popf();
}

/* Move existing block to new area */
#ifdef ALLOC_TRACE
void *ReAlloc(void *area, unsigned size, unsigned id)
#else
void *ReAlloc(void *area, unsigned size)
#endif
{
	unsigned osize;
	HEADER *hp;
	char *cp;

	hp = ((HEADER *)area) - 1;
	osize = (hp->s.size -1) << 2;

	/* Make sure nobody else comes in and takes it */
	idisable();
	free(area);
	if((cp = malloc(size, id)) != NULLCHAR && cp != area)
		memcpy((char *)cp,(char *)area,size>osize? osize : size);
	popf();
	return cp;
}
/* Allocate block of cleared memory */
#ifdef ALLOC_TRACE
void *Calloc(unsigned nelem,unsigned size, unsigned id)
#else
void *Calloc(unsigned nelem,unsigned size)
#endif
{
	register unsigned i;
	register char *cp;
	i = nelem * size;
	if((cp = malloc(i,id)) != NULLCHAR)
		memset(cp,0,i);
	return cp;
}
/* Print free list map */

unsigned get_memavail()
{
	HEADER *p;
	unsigned total,uCurrent;

	total = 0;
	p = &membase;
	idisable();
	mem_stat.wLargest = 0;
	do {
		total += (uCurrent = p->s.size * HEADERSZ);
		if (uCurrent > mem_stat.wLargest)
			mem_stat.wLargest = uCurrent;
#ifdef SHOWMEM
		printf("%p %5u",p,p->s.size * HEADERSZ);
		printf("%s\t",p == allocp ? "<" : "");
#endif
		p = p->s.ptr;
	} while(p != &membase);
#ifdef SHOWMEM
		printf("\n");
#endif
	mem_stat.mem_avail = total;
	popf();
	return total;
}

#if APL
#pragma argsused
memstat(int argc,char *argv[])
{
#ifdef SHOWMEM
	if (argc > 1) {
		char *p1,*p2;
		int val = atoi(argv[1]);
		get_memavail();
		p1 = malloc(val);
		printf("malloc %u %p\n",val,p1);
		get_memavail();
		p2 = malloc(val);
		printf("malloc %u %p\n",val,p2);
		get_memavail();
		printf("free %p\n",p1);
		free(p1);
		get_memavail();
		free(p2);
		printf("free %p\n",p2);
		get_memavail();
		return 0;
	}
#endif
	printf("Memory available - Inet: %u, DOS: %lu bytes\n",
				get_memavail(),farcoreleft());
	printf("Failed requests: %u, Release errors: %u\n"
				"Largest free block: %u\n",
				mem_stat.mem_fail,mem_stat.mem_free_err,mem_stat.wLargest);
#ifdef ALLOC_TRACE
	{
		int i;
		for (i = 0;i < mem_stat.trace_index;++i) {
			if (mem_stat.pwTraceBuf[i].adr) {
				WORD wAd,wCheck;
				int iIndex;
				BYTE *pcBuf = (BYTE *)mem_stat.pwTraceBuf[i].adr;
				printf("%p %p %4u ",(wAd = mem_stat.pwTraceBuf[i].adr) + 4,
					wCheck = ((WORD *)pcBuf)[0],
					((WORD far *)pcBuf)[1] * 4);
				printf("%c %-10.10Fs",wAd == wCheck ? ' ' : '!',
						szAlloc + mem_stat.pwTraceBuf[i].id * 10);
				for (iIndex = 4;iIndex < 20;++iIndex)
					printf(" %02x",pcBuf[iIndex]);
				printf("\n");
			}
		}
		if (argc > 1)
			mem_stat.trace_index = 0;
	}
#endif
	return 0;
}
#endif

