//
//   $Id: API_INTC.C 1.16 2003/08/11 03:22:26Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// API_INTC.C
// Copyright (C) 2001 Datalight, Inc.
// All Rights Reserved
// Datalight Confidential and Proprietary
// Portions Copyright (c) GPvNO 1990-2001
//
// INET and compatible API, C portion
//
// Revision History
// 07/12/2003 gvn NET_ACCEPT peer address
// 07/02/2003 gvn Fix NET_ACCEPT, change wait_schedule()
// 12/30/2002 gvn K_INF_TCP_CB
// 12/14/2002 gvn K_INF_LOCAL_PORT, UDP stats
// 11/25/2002 gvn NET_ACCEPT_LISTEN, NET_ACCEPT
//	11/19/2002 gvn NET_SWAP
//	10/01/2002 gvn ARP API
// 09/27/2002 gvn SetAsyncNotification (NetAsynch) returns old handler
// 09/16/2002 gvn fix possible crash on IfaceIOCTL
// 08/26/2002 gvn NDESC and NGDESC values for RINET
// 06/24/2002 gvn NDESC and NGDESC values for SOCKETD
// 03/28/2002 gvn in_tcp for upcalls
// 07/25/2001 gvn ReadSocket error returns
// 07/23/2001 gvn Allocation tracing
// 06/19/2001 gvn fixed compatiblity problem in ReadSocket.  If a NULL buffer
//                is specified or both the NET_FLG_PEEK and
//                NET_FLG_NON_BLOCKING flags are specified, the number of
//                bytes on the receive queue is returned.
// 05/29/2001 gvn Updates...
//

#pragma inline

#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <process.h>
#include <alloc.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include <mem.h>
#include "inetdefs.h"
#include "iface.h"
#include "mbuf.h"
#include "timer.h"
#include "netfunc.h"
#include "tcp.h"
#include "ping.h"
#include "udp.h"
#include "_api.h"
#include "_capi.h"
#include "igmp.h"
#include "pc.h"
#include "arp.h"
#include "ppp.h"

#if APL
#include "keys.h"
#endif
#if APL && !defined(DL)
#define	NDESC		0		// number of descriptors
#define	NGDESC	0		// number of global descriptors
#else
#define	NDESC		12		// number of descriptors
#define	NGDESC	8		// number of global descriptors
#endif

#define Rcvq ((MBUF *)tcb->rcvq)

#if (__BORLANDC__ < 0x500)
#define _rtl_open _open
#define _rtl_close _close
#endif

int source_default_filter(int32 address,int operation);

char f386 = 1;					// set when /0 flag is not given
extern unsigned uVersion;		// version number defined in version.c
extern char hold_tcp;
char must_schedule;
char schedule_event;		// timer tick or card interrupt
char tcp_ext;				// set to TCP_EXT for INET API TCP open
extern int in_tcp;
extern struct ip_stats ip_stats;
extern struct mem_stat mem_stat;
extern LPCB lpcb[];
extern int32 ip_netmask,ip_hostmask;
extern unsigned long master_tick;
extern XPING *pxpfirst;	/* first entry in external ping queue */
extern XPING *pxplast;	/* last entry in external ping queue */
int ping_seq;

#ifdef METRO_DEBUG
#define MET_LISTEN	0
#define MET_CLOSE	1
#define MET_NOTIFY	2
#define MET_SIZE	50
struct metro {
	char history[MET_SIZE];
	int indx;
	unsigned events[3];
} met;
#endif

// Async notification (upcall) queue format
// It is not required to disable interrupts when accessing this queue,
// because in_tcp provides a proper semaphore (I hope!)

typedef struct saq {
	struct saq *next;
	ND *pnd;
	int nd;
	int event;
	void far *arg;
} AQ;

AQ *paqf;			// Async notification queue first
AQ *paql;			// Async notification queue last

char in_handle;	// busy handling callback

#ifdef __LARGE__
VARBLOCKL stats = {
#else
VARBLOCK stats = {
#endif
	&ip_stats,
	&tcp_stat,
	&mem_stat,
#if APL
	0,
#else
	lpcb,
#endif
	0,    	// pointer to local descriptors
	0,			// pointer to global descriptors
	NDESC,	// number of network descriptors (local)
	NGDESC,	// number of global network descriptors
#ifdef METRO_DEBUG
	(void*)&met,
#endif
	0,      // WWW (HTTP) server address
	&ifaces,// Interface chain
	&udp_stat,// UDP stats and status
};

#ifdef METRO_DEBUG
void met_mark(char event)
{
	met.events[event]++;
	met.history[met.indx] = event;
	if (++met.indx >= MET_SIZE)
		met.indx = 0;
}
#endif

typedef struct {
	unsigned es;
	unsigned dx;
	unsigned cx;
	unsigned bx;
	unsigned ax;
	unsigned di;
	unsigned si;
	unsigned ds;
	unsigned flags;
	unsigned sp;
	unsigned ss;
} API_REG;

void far api_state(struct tcb *tcb,char old,char cNew);
void far apif_state(TCB *tcb,char old,char cNew);
void far apif_t(TCB *tcb,int,int);
void far apif_r(TCB *tcb,int);
void far apiu_r(struct socket *lsocket,int rcvcnt,IFACE *ifp);
int get_kern_info(API_REG *pr);
int api_release(int nd);
int net_desc(void);
int api_connect(API_REG *pr,int mode);
int api_abort(int nd);
void get_k_config(API_REG *pr);
int api_read(API_REG *pr);
int api_write(API_REG *pr,char writeto);
void wait_schedule(void);
void smtptick(void);
get_memavail(void);
static near void handle(ND *pnd,int event,void far *arg);

extern char errmap[];		/* map to pctcp errors */
extern int net_error;		/* network error */

void alarm_timeout(ND *pnd);

int async = 1;

TCB *get_tcb(int nd,ND **ppnd);
ND *get_ndt(int nd);

/*
ADDR testadr = {0x020106c0l,21,0};
testint()
{
	_SI = FP_OFF(&testadr);
	_DX = 4;
	_BX = -1;
	_AH = 0x13;
	geninterrupt(0x61);
}
*/

api_init()		// allocate network descriptors
{
	if (stats.nndesc && (stats.ndesc = calloc(stats.nndesc,sizeof(ND),AllocApiDcSockets)) == 0)
		return -1;
	if (stats.ngdesc && (stats.gdesc = calloc(stats.ngdesc,sizeof(ND),AllocApiSockets)) == 0)
		return -1;
	return 0;
}

DWORD htonl (DWORD netlong)
{
	char tmp[4];

	tmp[3] = ((char *)&netlong)[0];
	tmp[2] = ((char *)&netlong)[1];
	tmp[1] = ((char *)&netlong)[2];
	tmp[0] = ((char *)&netlong)[3];
	return *(DWORD *)&tmp;
}

int GetGlobalDescriptor(ND **ppNd)
{
	int nd;
	ND *pnd;

	for (nd = 64,pnd = stats.gdesc;nd < 64 + stats.ngdesc;++nd,++pnd) {
		if (!pnd->flags & ND_ASSIGNED) {
			pnd->flags |= ND_ASSIGNED;
			*ppNd = pnd;
			return nd;
		}
	}
	return ErrNoDesc;
}

/*
BYTE bTimerSet;
void SetTimer(void);
*/

void api_int_c(unsigned reg_off)
{
#ifdef __LARGE__
	API_REG *pr = MK_FP(_SS,reg_off);
#else
	API_REG *pr = (API_REG *)reg_off;
#endif
	char str[80];
	char far *name;
	char far *buf;
	char ip_address[4];
	int nd,err,err1,i,n,mode,option;
	TCB *tcb,*psAcceptTcb;
	ND *pnd,*pgd,*pnd1;
	EVENT *pev;
	GROUP_ADDR far *pgaddr;
	NET_ADDR far *paddr;
	unsigned far *pif;
	unsigned far *pof;
	struct netinfo far *ni;
	unsigned mask;
	char *adra;
	TIMER *pt;
	IFACE *ifp;
	extern IFACE *ifaces;
	struct udp_cb *udp;
	UCB *ucb;
	struct socket lsocket;
	int32 dest;
	XPING *pxp;
	unsigned long ctime;
	int (far *pfOldHandler)(void);
	struct arp_tab *psArpTab;

	/*
	if (!bTimerSet) {
		SetTimer();
		bTimerSet = 1;
	} */
	pr->flags &= ~1;
	if ((in_tcp & 0xf) < 2)
		schedule();
	switch (((char *)&pr->ax)[1]) {
	case GetBusyFlag:			// 0x01
		pr->es = FP_SEG(&in_tcp);
		pr->si = FP_OFF(&in_tcp);
		break;
	case GetKernelInfo:		/* 0x02 */
		if (get_kern_info(pr) < 0)
			goto error;
		break;
	case GetAddr:			/* 0x05 */
		if ((tcb = get_tcb(pr->bx,&pnd)) == 0 || !pnd) {
			pr->ax = pnd && (pnd->flags & ND_ASSIGNED) ?
					ErrUnbound : ErrNotNetConn;
			goto error;
		}
		if ((pnd->flags & TCP_CON) && tcb->conn.local.address)
			adra = (char *)&tcb->conn.local.address;
		else
			adra = (char *)&ifaces->ip_addr;	// use IP address of first interface
		((char *)&pr->ax)[0] = adra[3];
		((char *)&pr->ax)[1] = adra[2];
		((char *)&pr->dx)[0] = adra[1];
		((char *)&pr->dx)[1] = adra[0];
		break;
	case NetInfo:			/* 0x06 */
		ifp = ifaces;
		ni = MK_FP(pr->ds,pr->si);
		_fsetmem(ni,sizeof(struct netinfo),0);
		ni->up = 1;
		ni->ip_address = htonl(ifp->ip_addr);
		ni->ip_subnet = htonl(NETMASK(ifp->netbits));
		ni->lanlen = 6;
		ni->lanaddr = (BYTE *)ifp->hwaddr;
		pr->ax = 0;
		break;
	case NetGlobalize:		/* 0x07 */
		if (pr->bx > 63)
			break;
		if ((pnd = get_ndt(pr->bx)) == 0) {
			pr->ax = ErrNotNetConn;
			goto error;
		}
		if ((pr->ax = GetGlobalDescriptor(&pgd)) == ErrNoDesc)
			goto error;
		*pgd = *pnd;
		_rtl_close(pr->bx);
		setmem(pnd,sizeof(ND),0);
		break;
	case NetRelease:		/* 0x08 */
		if ((err = api_release(pr->bx)) > 0)
			goto error1;
		break;
	case NetReleaseAll:		/* 0x09 */
		err = 0;
		for (nd = 0;nd < stats.nndesc;++nd) {
			if ((((ND *)stats.ndesc)[nd].flags & ND_ASSIGNED) &&
					(err1 = api_release(nd)) > 0)
				err = err1;
		}
		if (err)
			goto error1;
		break;
	case IsNetDesc:			/* 0x0d */
		if ((pnd = get_ndt(pr->bx)) == 0 || !(pnd->flags & ND_ASSIGNED)) {
			pr->ax = ErrNotNetConn;
			goto error;
		}
		pr->ax = 0;
		break;
	case NetSelect:		/* 0x0e */
		if (pr->bx > 31) {
			pr->ax = ErrBadArg;
			goto error;
		}
		pif = MK_FP(pr->ds,pr->dx);
		pof = MK_FP(pr->es,pr->di);
		for (n = 0,mask = 1,pnd = stats.ndesc;
					n <= pr->bx && n < 16 && n < stats.nndesc;
													++n,mask <<= 1,++pnd) {
			if ((pnd->flags & ND_ASSIGNED) && (pnd->flags & TCP_CON)) {
				if ((tcb = pnd->tcb)->rcvcnt)
					*pif |= mask;
				if ((tcb->state == ESTABLISHED ||
					tcb->state == CLOSE_WAIT) &&
					(int)(tcb->window - tcb->sndcnt) > 0)
					*pof |= mask;
			}
			else if ((pnd->flags & ND_ASSIGNED) && (pnd->flags & UDP_CON)) {
				ucb = (UCB *)pnd->tcb;
				lsocket.address = 0;
				lsocket.port = ucb->lport;
				udp = lookup_udp(&lsocket);
				if (udp != NULLUDP && udp->rcvcnt)
					*pif |= mask;
				*pof |= mask;
			}
		}
		if (n < 16)
			break;
		pif++;
		pof++;
		for (mask = 1;n <= pr->bx && n < stats.nndesc;++n,mask <<= 1,++pnd) {
			if ((pnd->flags & ND_ASSIGNED) &&
						(pnd->flags & TCP_CON)) {
				if ((tcb = pnd->tcb)->rcvcnt)
					*pif |= mask;
				if ((tcb->state == ESTABLISHED ||
					tcb->state == CLOSE_WAIT) &&
					(int)(tcb->window - tcb->sndcnt) > 0)
					*pof |= mask;
			}
			else if ((pnd->flags & ND_ASSIGNED) && (pnd->flags & UDP_CON)) {
				ucb = (UCB *)pnd->tcb;
				lsocket.address = 0;
				lsocket.port = ucb->lport;
				udp = lookup_udp(&lsocket);
				if (udp != NULLUDP && udp->rcvcnt)
					*pif |= mask;
				*pof |= mask;
			}
		}
		break;
	case GetNetVersion:		/* 0x0f */
		pr->ax = 0x214;
		pr->bx = 0;
		break;
	case NetShutDown:		/* 0x10 */
		iostop();
		break;
	case DisableAsynch:		/* 0x11 */
		pr->ax = async;
		async = 0;
		break;
	case EnableAsynch:		/* 0x12 */
		pr->ax = async;
		async = 1;
		if (paqf)
			handle(0,-1,0);	// go handle unhandled events
		break;
	case NetConnect:		/* 0x13 */
		mode = TCP_ACTIVE;
		goto connect_open;
	case GetPeer:			/* 0x16 */
		if ((tcb = get_tcb(pr->bx,&pnd)) == 0) {
			pr->ax = pnd && (pnd->flags & ND_ASSIGNED) ?
					ErrUnbound : ErrNotNetConn;
			goto error;
		}
		paddr = MK_FP(pr->ds,pr->dx);
		if (pnd->flags & TCP_CON) {
			get_address:
			paddr->remote_port = tcb->conn.remote.port;
			paddr->local_port = tcb->conn.local.port;
			paddr->protocol = 6;
			adra = (char *)&tcb->conn.remote.address;
		}
		else {
			ucb = (UCB *)tcb;
			paddr->remote_port = ucb->remote_socket.port;
			paddr->local_port = ucb->lport;
			paddr->protocol = 17;
			adra = (char *)&ucb->remote_socket.address;
		}
		((char far *)&paddr->remote_host)[0] = adra[3];
		((char far *)&paddr->remote_host)[1] = adra[2];
		((char far *)&paddr->remote_host)[2] = adra[1];
		((char far *)&paddr->remote_host)[3] = adra[0];
		break;
	case NetEof:			/* 0x18 */
		if ((tcb = get_tcb(pr->bx,&pnd)) == 0) {
			goto tcberror;
		}
		if (!(pnd->flags & TCP_CON)) {
			pr->ax = ErrIllegalOp;
			goto error;
		}
		if (tcb->state != ESTABLISHED && tcb->state != CLOSE_WAIT) {
			pr->ax = ErrNotEstab;
			goto error;
		}
		close_tcp(tcb);
		break;
	case NetAbort:			/* 0x19 */
		if ((err = api_abort(pr->bx)) > 0)
			goto error1;
		break;
	case NetWrite:			/* 0x1a */
		mode = 0;
		goto net_write;
	case NetRead:			/* 0x1b */
		if ((err = api_read(pr)) > 0) {
			goto error1;
		}
		break;
	case NetWriteTo:		/* 0x1c */
		mode = 1;
		net_write:
		if ((err = api_write(pr,mode)) > 0) {
			goto error1;
		}
		break;
	case NetReadFrom:		/* 0x1d */
		if ((err = api_read(pr)) > 0) {
			goto error1;
		}
		break;
	case NetFlush:			/* 0x1e */
		if ((tcb = get_tcb(pr->bx,&pnd)) == 0) {
			tcberror:
			pr->ax = (pnd && (pnd->flags & ND_ASSIGNED)) ?
					ErrNotEstab : ErrNotNetConn;
			goto error;
		}
		if (!(pnd->flags & TCP_CON)) {
			pr->ax = ErrIllegalOp;
			goto error;
		}
		tcp_stat.flush_flag |= FLUSH_UNCONDITIONAL;
		tcp_output(tcb);
		tcp_stat.flush_flag &= ~FLUSH_UNCONDITIONAL;
		break;
	case NetAsynch:		/* 0x1f */
		if ((pnd = get_ndt(pr->bx)) == 0) {
			pr->ax = ErrNotNetConn;
			goto error;
		}
		if (pr->cx > MaxAsEvent) {
			pr->ax = ErrBadArg;
			goto error;
		}
		pev = pnd->event + pr->cx;
		pfOldHandler = pev->handler;
		pev->handler = MK_FP(pr->ds,pr->dx);
		pev->hint = (unsigned long)MK_FP(pr->es,pr->di);
		tcb = pnd->tcb;
		if ((pnd->flags & TCP_CON) && tcb != 0) {
			if (pr->cx == NetAsOpen || pr->cx == NetAsClose ||
						pr->cx == NetAsFclose ||
						pr->cx == NetAsError) {
				tcb->s_upcall = apif_state;
			}
			else if (pr->cx == NetAsXmt)
				tcb->t_upcall = apif_t;
			else if (pr->cx == NetAsRcv)
				tcb->r_upcall = apif_r;
		}
		else if ((pnd->flags & UDP_CON) && pr->cx == NetAsRcv) {
			struct udp_cb *udp;
			struct udp_cb *lookup_udp();
			struct socket lsock;

			lsock.port = ((UCB *)tcb)->lport;
			lsock.address = 0;
			if ((udp = lookup_udp(&lsock)) != 0)
				udp->r_upcall = apiu_r;
		}
		pr->ds = FP_SEG(pfOldHandler);
		pr->dx = FP_OFF(pfOldHandler);
		break;
	case SetOption:		/* 0x20 */
		if ((pnd = get_ndt(pr->bx)) == 0 ||
						!(pnd->flags & ND_ASSIGNED)) {
			pr->ax = ErrNotNetConn;
			goto error;
		}
		switch (pr->di) {
		case NetOptNonBlocking:
			option = NO_BLOCK;
			goto set_option;
		case NetOptTimeOut:
			((unsigned *)&pnd->timer)[0] = pr->dx;
			((unsigned *)&pnd->timer)[1] = pr->ds;
			if (pnd->timer) {
				pnd->flags |= TIME_OUT;
				pnd->timer /= MSPTICK;
			}
			else
				pnd->flags &= ~TIME_OUT;
			break;
		case NET_OPT_KEEPALIVE:
			option = KEEP_ALIVE;
			goto set_option;
		case NetOptWaitFlush:
			option = WAIT_FLUSH;
			set_option:
			if (pr->ds || pr->dx)
				pnd->flags |= option;
			else
				pnd->flags &= ~option;
			break;
		}
		break;
	case NetGetDesc:		/* 0x22 */
		if ((int)(pr->ax = net_desc()) < 0) {
			pr->ax = ErrDOS;
			goto error;
		}
		break;
	case NetListen:		/* 0x23 */
		mode = TCP_PASSIVE;
		connect_open:
		if ((err = api_connect(pr,mode)) > 0) {
			error1:
			pr->ax = err;
			goto error;
		}
		break;
	case NetAbortAll:		/* 0x24 */
		err = 0;
		for (nd = 0;nd < stats.nndesc;++nd) {
			if ((((ND *)stats.ndesc)[nd].flags & ND_ASSIGNED) &&
						(err1 = api_abort(nd)) > 0)
				err = err1;
		}
		if (err)
			goto error1;
		break;
	case NET_SWAP:				// 0x28
		if ((pnd = get_ndt(pr->bx)) == 0 || (pnd1 = get_ndt(pr->cx)) == 0) {
			pr->ax = ErrNotNetConn;
			goto error;
		}
		if ((pr->bx >= 64 && pr->cx < 64) || (pr->bx < 64 && pr->cx >= 64)) {
			pr->ax = ErrIllegalOp;
			goto error;
		}
		*(ND *)str = *pnd;
		*pnd = *pnd1;
		*pnd1 = *(ND *)str;
		break;
	case NetGetGlobDesc:		/* 0x29 */
		if ((pr->ax = GetGlobalDescriptor(&pnd)) == ErrNoDesc)
			goto error;
		break;
	case NetGetKConf:		/* 0x2A */
		get_k_config(pr);
		break;
	case NetAlarm:			/* 0x2b */
		if ((pnd = get_ndt(pr->bx)) == 0 ||
						!(pnd->flags & ND_ASSIGNED)) {
			pr->ax = ErrNotNetConn;
			goto error;
		}
		if ((pt = pnd->alarm_timer) == 0 && (pt = pnd->alarm_timer =
				(TIMER *)calloc(1,sizeof(TIMER),AllocApiAlarmTimer)) == 0) {
			pr->ax = ErrNoMem;
		}
		pev = pnd->event + NetAsAlarm;
		pev->handler = MK_FP(pr->ds,pr->si);
		pev->hint = (unsigned long)MK_FP(pr->es,pr->di);
		pt->func = (void(*)(char *))alarm_timeout;
		pt->arg = (char *)pnd;
		set_timer(pt,(unsigned long)MK_FP(pr->cx,pr->dx));
		start_timer(pt);
		break;
	case IcmpPing:		// 0x30
		((unsigned char *)&dest)[0] = ((unsigned char *)&pr->dx)[1];
		((unsigned char *)&dest)[1] = ((unsigned char *)&pr->dx)[0];
		((unsigned char *)&dest)[2] = ((unsigned char *)&pr->bx)[1];
		((unsigned char *)&dest)[3] = ((unsigned char *)&pr->bx)[0];
		pingem(dest,++ping_seq,EXTRNL,pr->cx);
		ctime = master_tick + 6000 / MSPTICK;
		while (master_tick < ctime) {
			if ((pxp = pxpfirst) != 0) {
				pr->bx = pxp->seq;
				dest = pxp->remote;
				if ((pxpfirst = pxp->next) == NULL)
					pxplast = NULL;
				if (pxp->seq == ping_seq) {
					free(pxp);
					goto ping_ok;
				}
				else
					free(pxp);
			}
			wait_schedule();
		}
		pr->ax = ErrTimeOut;
		goto error;
		ping_ok:
		break;
	case NmPrsAddr:		/* 0x50 */
		name = MK_FP(pr->ds,pr->dx);
		_fstrncpy(str,name,79);
		*(long *)ip_address = aton(str);
		goto return_ipa;
	case NmHTable:			/* 0x51 */
	case NmResName:		/* 0x54 */
		name = MK_FP(pr->ds,pr->dx);
		buf = MK_FP(pr->es,pr->di);
		_fstrncpy(str,name,79);
		if ((*(long *)ip_address = resolve(str)) != 0) {
			if (buf)
				_fstrncpy(buf,name,pr->cx);
			return_ipa:
			((char *)&pr->ax)[0] = ip_address[3];
			((char *)&pr->ax)[1] = ip_address[2];
			((char *)&pr->dx)[0] = ip_address[1];
			((char *)&pr->dx)[1] = ip_address[0];
		}
		else {
			pr->ax = ErrHostUnknown;
			goto error;
		}
		break;
	case JOIN_GROUP:		// 0x60
		pgaddr = MK_FP(pr->ds,pr->si);
		if ((pr->ax = JoinGroup(
					htonl(pgaddr->dwGroupAddr),htonl(pgaddr->dwIFAddr))) != 0)
			goto error;
		break;
	case LEAVE_GROUP:		// 0x61
		pgaddr = MK_FP(pr->ds,pr->si);
		if ((pr->ax = LeaveGroup(
					htonl(pgaddr->dwGroupAddr),htonl(pgaddr->dwIFAddr))) != 0)
			goto error;
		break;
	case IFACE_IOCTL:		// 0x62
		name = MK_FP(pr->ds,pr->si);
		n = *name;
		for (ifp = ifaces, i = 0;ifp;ifp = ifp->next,++i) {
			if ((_fstrcmp(ifp->name,name) == 0 || n == i) && ifp->ioctl) {
				char ioctl[2];
				char *pioctl[1];

				ioctl[0] = 0;
				ioctl[1] = pr->ax;
				pioctl[0] = ioctl;
				if ((int)(pr->ax = (*ifp->ioctl)(ifp,1,pioctl)) < 0) {
					pr->ax = ErrIllegalOp;
					goto error;
				}
				else
					goto ok2;
			}
		}
		pr->ax = ErrBadArg;
		goto error;
		ok2:
		break;
	case GET_SOCKETS_VERSION:	// 0x63
		pr->ax = uVersion;
		break;
	case ARP_API:					// 0x64
		switch (((char *)&pr->ax)[0]) {
		//case ARP_API_ADD:		// Not yet implemented
		//	break;
		case ARP_API_DROP:
			if (pr->cx == 0 && pr->dx == 0) {
				for (i = 0;i < ARPSIZE;i++) {
					while ((psArpTab = arp_tab[i]) != 0) {
						if (psArpTab->hardware == pr->bx)
							arp_drop(psArpTab);
					}
				}
			}
			else {
				if ((psArpTab = arp_lookup(pr->bx,htonl((DWORD)MK_FP(pr->cx,pr->dx)))) == 0)
					goto arp_badarg;
				arp_drop(psArpTab);
			}
			break;
		case ARP_API_GETTABLE:
			pr->es = FP_SEG(arp_tab);
			pr->si = FP_OFF(arp_tab);
			break;
		default:
			arp_badarg:
			pr->ax = ErrBadArg;
			goto error;
		}
		break;
	case NET_ACCEPT_LISTEN: 		// 0x65
		if (pr->cx == 0)
			pr->cx = 1;
		if (pr->cx > 5)
			pr->cx = 5;
		mode = TCP_SERVER + (pr->cx << 8);
		goto connect_open;
	case NET_ACCEPT:					// 0x66
		if ((tcb = get_tcb(pr->bx,&pnd)) == 0) {
			goto tcberror;
		}
		pnd->ctime = master_tick + pnd->timer;
		while (!tcb->num_nacc || (psAcceptTcb = tcb->naccq) == 0 ||
													psAcceptTcb->state < ESTABLISHED) {
			if (pnd->flags & NO_BLOCK) {
				pr->ax = ErrWouldBlock;
				goto error;
			}
			if ((pnd->flags & TIME_OUT) && master_tick >= pnd->ctime) {
				pr->ax = ErrTimeOut;
				goto error;
			}
			wait_schedule();
		}
		if ((pr->ax = GetGlobalDescriptor(&pnd1)) == ErrNoDesc)
			goto error;
		if ((psAcceptTcb = accept_tcp(tcb)) == 0) {
			pnd1->flags &= ~ND_ASSIGNED;
			pr->ax = errmap[net_error];
			goto error;
		}
		*pnd1 = *pnd;		// accepted descriptor has same properties as listening descriptor
		pnd1->tcb = psAcceptTcb;
		psAcceptTcb->user = (char *)pnd1;
		if ((paddr = MK_FP(pr->ds,pr->si)) != 0) {
			tcb = psAcceptTcb;
			goto get_address;
		}
		break;

	default:
		pr->ax = ErrBadSysCall;
		error:
		pr->flags |= 1;		/* set carry */
		break;
	}
	while (must_schedule) {
		must_schedule = 0;
		if ((in_tcp & 0xf) < 2)
			schedule();
	}
}

int net_desc(void)
{
	int nd;
	ND *pnd;

	if ((nd = _rtl_open("NUL",O_RDONLY)) < 0 || nd >= stats.nndesc || nd > 31) {
		_rtl_close(nd);
		return -1;
	}
	pnd = (ND *)stats.ndesc + nd;
	if (pnd->flags)
		return -1;
	pnd->flags = ND_ASSIGNED;
	return nd;
}

void get_k_config(API_REG *pr)
{
	ND *pnd;
	int flags;
	char n_tcb = 0,n_udp = 0,n_desc = 0,n_gdesc = 0;
	struct kernel_conf far *pkc = MK_FP(pr->ds,pr->si);

	for (pnd = stats.ndesc;pnd < (ND *)stats.ndesc + stats.nndesc;++pnd) {
		if ((flags = pnd->flags) & ND_ASSIGNED) {
			++n_desc;
			if (flags & TCP_CON)
				++n_tcb;
			else if (flags & UDP_CON)
				++n_udp;
		}
	}
	for (pnd = stats.gdesc;pnd < (ND *)stats.gdesc + stats.ngdesc;++pnd) {
		if ((flags = pnd->flags) & ND_ASSIGNED) {
			++n_gdesc;
			if (flags & TCP_CON)
				++n_tcb;
			else if (flags & UDP_CON)
				++n_udp;
		}
	}
	pkc->k_max_tcp = stats.nndesc + stats.ngdesc;	/* # of TCP connections allowed */
	pkc->k_max_udp = stats.nndesc + stats.ngdesc;	/* # of UDP connections allowed */
	pkc->k_max_ip = 0;	/* # of IP connections allowed */
	pkc->k_max_raw = 0;	/* # of RAW_NET connections allowed */
	pkc->k_act_tcp = n_tcb;	/* # of TCP connections in use */
	pkc->k_act_udp = n_udp;	/* # of UDP connections in use */
	pkc->k_act_ip = 0;	/* # of IP connections in use */
	pkc->k_act_raw = 0;	/* # of RAW_NET connections in use */
	pkc->k_act_lcl = n_desc;/* # of active Local network descriptors */
	pkc->k_act_gbl = n_gdesc;/* # of active Global network descriptors */
	pkc->k_MaxLnh = 14;	/* Maximum header on an attached network */
	pkc->k_MaxLnt = 0;	/* Maximum trailer on an attached network */
	pkc->k_LBUF_SIZE = 1514;	/* Size of a kernel packet buffer */
	pkc->k_Nnet = 1;	/* Number of network interfaces attached */
	pkc->k_cticks = 0;	/* Milliseconds since kernel started */
	pkc->k_broadcast = 0xffffffffL;	/* IP broadcast address in use */
}

int get_dns_servers(char far *buf, int size);

static near IFACE *FindIface(int iId)
{
	IFACE *psIface;
	int i;

	for (i = 0,psIface = ifaces;iId != i && psIface;psIface = psIface->next,++i);
	return psIface;
}

#ifdef DEB1C
int aiTimer[4];						// debug int 1c
#endif

int get_kern_info(API_REG *pr)
{
	void far *data = MK_FP(pr->ds,pr->si);
	unsigned far *psize = MK_FP(pr->es,pr->di);
	unsigned size = *psize,len;
	char bc[4],str[80];
	int iDevId = pr->dx & 0xff;
	TCB *tcb;
	ND *pnd;
	IFACE *psIface;

	switch (pr->dx >> 8) {
#ifdef DEB1C
	case 0:						// debug int 1c
		_fmemcpy(data,aiTimer,sizeof(aiTimer));
		break;
#endif
	case K_INF_HOST_TABLE:
		getfilename(str,hosts,0);
		if ((len = strlen(str) + 1) > size)
			goto mem_err;
		_fstrcpy(data,str);
		*psize = len;
		break;
	case K_INF_DNS_SERVERS:
		if (size < 12)
			goto mem_err;
		*psize = get_dns_servers(data,size);
		break;
	case K_INF_TCP_CONS:
		if (size < 2) {
			mem_err:
			pr->ax = ErrNoMem;
			return -1;
		}
		*psize = 2;
		*((int far *)data) = stats.nndesc + stats.ngdesc;
		break;
	case K_INF_MAC_ADDR:			// MAC address for interface
		if (size < 6)
			goto mem_err;
		if ((psIface = FindIface(iDevId)) == 0)
			goto bad_interface;
		if (psIface->hwaddr) {
			_fmemcpy(data,psIface->hwaddr,6);
			*psize = 6;
		}
		else
			*psize = 0;
		break;
	case K_INF_BCAST_ADDR:
		*(int32 *)bc = 0xffffffffl;
		goto set_ip;
#ifdef ASYNC
	case K_INF_REMOTE_IP:
		{
			PPP *psPpp;
			IPCP *psIpcp;

			psPpp = psIface->prot_ext;
			psIpcp = psPpp->fsm[IPcp].pdv;
			if ((psIface = FindIface(iDevId)) == 0 ||
					(psPpp = psIface->prot_ext) == 0 ||
					(psIpcp = psPpp->fsm[IPcp].pdv) == 0)
				goto bad_interface;
			*(int32 *)bc = psIpcp->remote.work.dwLocalAddress;
			goto set_ip;
		}
#endif
	case K_INF_IP_ADDR:
		if ((psIface = FindIface(iDevId)) == 0)
			goto bad_interface;
		*(int32 *)bc = psIface->ip_addr;
		goto set_ip;
	case K_INF_SUBNET_MASK:
		if ((psIface = FindIface(iDevId)) == 0) {
			bad_interface:
			pr->ax = ERR_BAD_INTERFACE;
			return -1;
		}
		*(int32 *)bc = NETMASK(psIface->netbits);
		set_ip:
		*psize = 4;
		if (size < 4) {
			pr->ax = ErrNoMem;
			return -1;
		}
		((char far *)data)[3] = bc[0];
		((char far *)data)[2] = bc[1];
		((char far *)data)[1] = bc[2];
		((char far *)data)[0] = bc[3];
		break;
	case K_INF_HOSTNAME:
		if ((len = strlen((char *)hostname) + 1) > size)
			goto mem_err;
		_fstrcpy(data,(char *)hostname);
		*psize = len;
		break;
	case K_INF_LOCAL_PORT:
		if (size < 2)
			goto mem_err;
		*psize = 2;
		*((int far *)data) = getlport();
		break;
	case K_INF_TCP_CB:
		if (size < sizeof(TCB))
			goto mem_err;
		if ((tcb = get_tcb(pr->bx,&pnd)) == 0) {
			pr->ax = (pnd && (pnd->flags & ND_ASSIGNED)) ?
					ErrNotEstab : ErrNotNetConn;
			return -1;
		}
		if (!(pnd->flags & TCP_CON)) {
			pr->ax = ErrIllegalOp;
			return -1;
		}
		*psize = sizeof(TCB);
		_fmemcpy(data,tcb,sizeof(TCB));
		break;
	default:
		pr->ax = ErrBadArg;
		return -1;
	}
	pr->ax = 0;
	return 0;
}

void wait_schedule(void)
{
	extern unsigned stack_pointer;

	asm push stack_pointer;
	stack_pointer = _SP - 200;
	in_tcp &= 0xf;
#if !APL
	enable();	// Blocking, better have interrupts on!
	/* This causes it to not work in a DOS box in Win2K. Let's see if it will
		work in all cases...
	for (schedule_event = 0,must_schedule = 0;!schedule_event && !must_schedule;) {
		//static char c = '0';
		//pokeb(0xb800,0,c++);
	}
	*/
#endif
	schedule();
	asm pop stack_pointer;
	in_tcp |= 0x70;
}

int api_connect(API_REG *pr,int mode)
{
	int nd,err,retv;
	NET_ADDR far *paddr;
	struct socket lsocket,fsocket;
	TCB *tcb;
	ND *pnd;
	UCB *ucb;
	char reason;
	void (far *s_upcall)();
	void (far *t_upcall)();
	void (far *r_upcall)();

	nd = pr->bx;
	if ((int)nd == -1 && (int)(nd = net_desc()) < 0) {
		return ErrNoDesc;
	}
	pr->ax = nd;
	if ((pnd = get_ndt(nd)) == 0) {
		err = ErrNotNetConn;
		goto error;
	}
	if (pnd->tcb) {
		err = ErrInUse;
		goto error;
	}
	paddr = MK_FP(pr->ds,pr->si);
	lsocket.address = 0;
	((char *)&fsocket.address)[0] = ((char far *)&paddr->remote_host)[3];
	((char *)&fsocket.address)[1] = ((char far *)&paddr->remote_host)[2];
	((char *)&fsocket.address)[2] = ((char far *)&paddr->remote_host)[1];
	((char *)&fsocket.address)[3] = ((char far *)&paddr->remote_host)[0];
	if ((lsocket.port = paddr->local_port) == 0)
		lsocket.port = paddr->local_port = getlport();
	fsocket.port = paddr->remote_port;
	s_upcall = r_upcall = t_upcall = 0;
	if (pr->dx == Stream) {
		if (mode == TCP_ACTIVE && paddr->remote_host == 0) {
			err = ErrNoHost;
			goto error;
		}
		if (pnd->event[NetAsOpen].handler ||
			pnd->event[NetAsClose].handler ||
			pnd->event[NetAsFclose].handler||
			pnd->event[NetAsError].handler) {
			s_upcall = apif_state;
		}
		if (pnd->event[NetAsXmt].handler)
			t_upcall = apif_t;
		if (pnd->event[NetAsRcv].handler)
			r_upcall = apif_r;
#ifdef METRO_DEBUG
		if (mode == TCP_PASSIVE) {
			pnd->flags |= LISTEN_FLAG;
			met_mark(MET_LISTEN);
		}
#endif
		tcb = open_tcp(&lsocket,&fsocket,mode,0,r_upcall,t_upcall,
							s_upcall,0,(char *)pnd);
		if (tcb == 0) {
			err = errmap[net_error];
			goto error;
		}
		pnd->flags |= TCP_CON;
		pnd->tcb = tcb;
		pnd->ctime = master_tick + pnd->timer;
		if (pnd->flags & KEEP_ALIVE)
			tcb->flags1 |= F1_KEEPALIVE;	// set keep-alive
		while (tcpval(tcb) != 0) {
			if ((pnd->flags & NO_BLOCK) || (mode & 0xff00) || tcb->state >= ESTABLISHED)
				return 0;
			if ((pnd->flags & TIME_OUT)  && master_tick >= pnd->ctime) {
				err = ErrTimeOut;
				goto error;
			}
			else if (tcb->state == CLOSED) {
				reason = tcb->reason;
				if (!tcb->s_upcall)
					del_tcp(tcb);
				pnd->tcb = 0;
				err = reason == TIMEOUT ? ErrTimeOut :
								ErrReset;
				goto error;
			}
			if (!async)
				break;
			wait_schedule();
		}
		err = ErrNoMem;
	}
	else if (pr->dx == DataGram) {
		if (pnd->event[NetAsRcv].handler)
			r_upcall = apiu_r;
		if ((retv = open_udp(&lsocket,r_upcall,0)) == 0) {
			err = ErrInUse;
			goto error;
		}
		if (retv == -1 || ((ucb = calloc(1,sizeof(UCB),AllocApiUCB)) == 0)) {
			err = ErrNoMem;
			goto error;
		}
		ucb->remote_socket = fsocket;
		ucb->lport = lsocket.port;
		pnd->tcb = (TCB *)ucb;
		pnd->flags |= UDP_CON;
	}
	else {
		err = ErrBadArg;
		error:
		if (pr->bx == 0xffff) {
			api_release(nd);
		}
		return err;
	}
	return 0;
}

MBUF *read_mbuf(MBUF *bp,char far *buf,int cnt,int peek,int *ptot)
{
	volatile int n;		// volatile for optimizing bug in BC 3.0

	while (bp != NULLBUF && cnt != 0) {
		n = min(cnt,bp->cnt);
		_fmemcpy(buf,bp->data,n);
		buf += n;
		cnt -= n;
		*ptot += n;
		if (peek) {
			if (bp->cnt == n)
				bp = bp->next;
		}
		else {
			bp->data += n;
			bp->cnt -= n;
			if (bp->cnt == 0) {
				bp = free_mbuf(bp);
			}
		}
	}
	return bp;
}

int api_read(API_REG *pr)
{
	char far *buf;
	int cnt,header_cnt;
	MBUF *bp;
	TCB *tcb;
	UCB *ucb;
	unsigned long time;
	ND *pnd;
	NET_ADDR far *from;
	char *adra;
	struct socket lsocket;
	struct socket *sp;
	struct udp_cb *up;

	from = MK_FP(pr->es,pr->di);
	if ((tcb = get_tcb(pr->bx,&pnd)) == 0) {
		return (pnd && (pnd->flags & ND_ASSIGNED)) ?
					ErrNotEstab : ErrNotNetConn;
	}
	buf = MK_FP(pr->ds,pr->si);
	cnt = pr->cx;
	pr->cx = 0;
	pnd->ctime = master_tick + pnd->timer;
	if (pnd->flags & TCP_CON) {
		time = master_tick;
		if (from) {
			adra = (char *)&tcb->conn.remote.address;
			((char far *)&from->remote_host)[0] = adra[3];
			((char far *)&from->remote_host)[1] = adra[2];
			((char far *)&from->remote_host)[2] = adra[1];
			((char far *)&from->remote_host)[3] = adra[0];
			from->remote_port = tcb->conn.remote.port;
			from->local_port = tcb->conn.local.port;
			from->protocol = 6;
		}
		while (1) {
			if (tcb->rcvcnt) {
				if ((pr->dx & NetFlgPeek) &&
										(buf == 0 || (pr->dx & NetFlgNonBlocking))) {
					pr->cx = pr->ax = tcb->rcvcnt;
						return 0;
				}
				if (buf) {
					bp = read_mbuf(Rcvq,buf,cnt,
						pr->dx & NetFlgPeek,&(int)pr->cx);
					if (!(pr->dx & NetFlgPeek)) {
						Rcvq = bp;
						tcb->rcvcnt -= pr->cx;
						tcb->rcv_wndav += pr->cx;
						// RFC 1122 4.2.3.3
						// Do a window update if the difference between the available window
						// and the offered window is >= min(max_window/2,mss_rcv)
						if ((tcb->rcv_wndav - tcb->rcv.wnd) >= min(tcb->mss_rcv,tcb->window / 2) &&
												tcb->state < CLOSE_WAIT) {
							tcb->rcv.wnd = tcb->rcv_wndav;
							tcb->flags |= FORCE;
							tcp_output(tcb);
						}
					}
				}
				else
					pr->cx = tcb->rcvcnt;
				break;
			}
			else switch (tcb->state) {
			case LISTEN:
			case SYN_SENT:
			case SYN_RECEIVED:
				return ErrNotEstab;
			case CLOSED:
			case CLOSING:
			case LAST_ACK:
			case TIME_WAIT:
				return tcb->reason == NORMAL_R ? ErrEOF :
						 tcb->reason == RESET ? ErrReset :
						 tcb->reason == TIMEOUT ? ErrTimeOut : ErrICMPMsg;
			case ESTABLISHED:
			case FINWAIT1:
			case FINWAIT2:
				if ((pr->dx & NetFlgNonBlocking) ||
						(pnd->flags & NO_BLOCK)) {
					/* kludge for SYBASE bug */
					if ((pr->dx & NetFlgPeek) && !buf &&
									cnt == -1 && (master_tick - time) < 20) {
						if (async) {
							wait_schedule();
							continue;
						}
					}
					/* end of kludge */
					return ErrWouldBlock;
				}
				if (!async)
					return ErrWouldBlock;
				if ((pnd->flags & TIME_OUT) && master_tick >= pnd->ctime) {
					return ErrTimeOut;
				}
				wait_schedule();
				continue;
			case CLOSE_WAIT:
				return ErrEOF;
			}
		}
	}
	else if (pnd->flags & UDP_CON) {
		char header_buf[sizeof(struct socket)];

		ucb = (UCB *)tcb;
		lsocket.address = 0;
		lsocket.port = ucb->lport;
		while (1) {
			up = lookup_udp(&lsocket);
			if (up == NULLUDP)
				return ErrNotNetConn;
			if (!up->rcvcnt) {
				if ((pr->dx & NetFlgNonBlocking) || (pnd->flags & NO_BLOCK)) {
					return ErrWouldBlock;
				}
				if ((pnd->flags & TIME_OUT) && master_tick >= pnd->ctime) {
					return ErrTimeOut;
				}
				wait_schedule();
				continue;
			}
			bp = up->rcvq;
			if (from) {
				sp = (struct socket *)bp->data;
				adra = (char *)&sp->address;
				((char far *)&from->remote_host)[0] = adra[3];
				((char far *)&from->remote_host)[1] = adra[2];
				((char far *)&from->remote_host)[2] = adra[1];
				((char far *)&from->remote_host)[3] = adra[0];
				from->remote_port = sp->port;
				from->local_port = lsocket.port;
//				from->protocol = 17;
			}
			if (pr->dx & NetFlgPeek) {
				if (up->rcvcnt) {
					if (pr->dx & NetFlgNonBlocking) {
						pr->cx = pr->ax = up->rcvcnt;
						return 0;
					}
					else if (buf == 0) {
						pr->cx = pr->ax = len_mbuf(up->rcvq) - sizeof(struct socket);
						return 0;
					}
				}
			}
			if (!(pr->dx & NetFlgPeek)) {
				bp = dequeue(&up->rcvq);
				up->rcvcnt--;
			}
			bp = read_mbuf(bp,header_buf,sizeof(struct socket),pr->dx & NetFlgPeek,&header_cnt);
			if (buf)
				bp = read_mbuf(bp,buf,cnt,pr->dx & NetFlgPeek,&(int)pr->cx);
			while (bp && !(pr->dx & NetFlgPeek))
				bp = free_mbuf(bp);
			break;
		}
	}
	pr->ax = pr->cx;    // emulate PCTCP undocumented behaviour !
	return 0;
}

int api_write(API_REG *pr,char writeto)
{
	TCB *tcb;
	UCB *ucb;
	ND *pnd;
	int cnt,sent,n,err1;
	char far *buf;
	MBUF *bp;
	struct socket lsocket,fsocket;
	extern int32 ip_netmask,ip_hostmask;

	if ((tcb = get_tcb(pr->bx,&pnd)) == 0) {
		return (pnd && (pnd->flags & ND_ASSIGNED)) ?
					ErrNotEstab : ErrNotNetConn;
	}
	buf = MK_FP(pr->ds,pr->si);
	cnt = pr->cx;
	pnd->ctime = master_tick + pnd->timer;
	if (pnd->flags & TCP_CON) {
		if (writeto)
			return ErrIllegalOp;
		if (tcb->state != ESTABLISHED && tcb->state != CLOSE_WAIT) {
			return ErrEOF;
		}
		sent = 0;
		if (cnt) while (1) {
			n = min(tcb->window - tcb->sndcnt,cnt);
			if (n) {
				if ((bp = alloc_mbuf(n,AllocApiSndBufTc)) == 0) {
					return ErrNoMem;
				}
				_fmemcpy(bp->data,buf,bp->cnt = n);
				if ((pnd->flags & WAIT_FLUSH) &&
						!(pr->dx & NetFlgPush)) {
					tcp_stat.flush_flag |= FLUSH_DONTSEND;
				}
				err1 = send_tcp(tcb,bp,pr->dx & NetFlgOOB);
				tcp_stat.flush_flag &= ~FLUSH_DONTSEND;
				if (err1 == -1) {
					return errmap[net_error];
				}
				pnd->flags |= WRITE_NOTIFY;
				sent += err1;
				cnt -= err1;
				buf += err1;
			}
			if (!cnt || (pr->dx & NetFlgNonBlocking) ||
					(pnd->flags & NO_BLOCK) || !async) {
				if (sent != 0)
					break;
				return ErrWouldBlock;
			}
			if ((pnd->flags & TIME_OUT) && master_tick >= pnd->ctime) {
				return ErrTimeOut;
			}
			wait_schedule();
		}
		pr->ax = sent;
	}
	else if (pnd->flags & UDP_CON) {
		ucb = (UCB *)tcb;
		lsocket.address = 0;
		if (writeto) {
			NET_ADDR far *paddr = MK_FP(pr->es,pr->di);
			((char *)&fsocket.address)[0] =
						((char far *)&paddr->remote_host)[3];
			((char *)&fsocket.address)[1] =
						((char far *)&paddr->remote_host)[2];
			((char *)&fsocket.address)[2] =
						((char far *)&paddr->remote_host)[1];
			((char *)&fsocket.address)[3] =
						((char far *)&paddr->remote_host)[0];
			if ((lsocket.port = paddr->local_port) == 0)
				lsocket.port = paddr->local_port = ucb->lport;
			fsocket.port = paddr->remote_port;
		}
		else {
			fsocket = ucb->remote_socket;
			lsocket.port = ucb->lport;
		}
		if (pr->dx & NetFlgBroadCast)
			fsocket.address = 0x7ffffffful;
		if (cnt) {
			if ((bp = alloc_mbuf(cnt,AllocApiSndBufUc)) == 0) {
				return ErrNoMem;
			}
			_fmemcpy(bp->data,buf,bp->cnt = cnt);
		}
		else
			bp = 0;
		wNoMulticastEcho = pr->dx & NET_FLG_MC_NOECHO;
		send_udp(&lsocket,&fsocket,0,0,bp,cnt,0,0,0);
		wNoMulticastEcho = 0;
		pr->ax = cnt;
	}
	return 0;
}

void release_cleanup(ND *pnd,int nd)
{
	TIMER *pt;

	if ((pt = pnd->alarm_timer) != 0) {
		stop_timer(pt);
		free(pt);
	}
	if (nd < stats.nndesc)
		_rtl_close(nd);
	if (paqf) {
		// remove any queued events for this nd
		AQ *paq,*paqp = 0;

		for (paq = paqf;paq;paq = paq->next) {
			if (paq->nd == nd) {
				if (paqp == 0) {
					if ((paqf = paq->next) == 0)
						paql = 0;
				}
				else
					paqp->next = paq->next;
				free(paq);
			}
			else
				paqp = paq;
		}
	}
	setmem(pnd,sizeof(ND),0);
}

int api_release(int nd)
{
	struct socket lsocket;
	TCB *tcb;
	ND *pnd;

	if ((tcb = get_tcb(nd,&pnd)) == 0) {
		if (!pnd || !(pnd->flags & ND_ASSIGNED))
			return ErrNotNetConn;
	}
	if (tcb) {
		if (pnd->flags & TCP_CON) {
			close_tcp(tcb);
			if (pnd->tcb) {
				if (tcb->state != CLOSED) {
					tcb->s_upcall = apif_state;
				}
				else if (!tcb->s_upcall) {
					del_tcp(tcb);
				}
				else
					tcb->user = 0;
			}
		}
		else if (pnd->flags & UDP_CON) {
			lsocket.address = 0;
			lsocket.port = ((UCB *)tcb)->lport;
			del_udp(&lsocket);
			free(tcb);
		}
	}
	release_cleanup(pnd,nd);
	return 0;
}

int api_abort(int nd)
{
	TCB *tcb;
	ND *pnd;

	if ((tcb = get_tcb(nd,&pnd)) == 0) {
		if (!pnd || !(pnd->flags & ND_ASSIGNED))
			return ErrNotNetConn;
	}
	if (pnd->flags & UDP_CON)
		return api_release(nd);
	if (tcb) {
		if (tcb->state != TIME_WAIT && tcb->state != CLOSED)
			reset_tcp(tcb);
		if (pnd->tcb && !tcb->s_upcall) {
			del_tcp(tcb);
		}
		else {
			tcb->user = 0;
		}
	}
	release_cleanup(pnd,nd);
	return 0;
}

TCB *get_tcb(int nd,ND **ppnd)
{
	TCB *tcb = 0;
	ND *pnd;

	if ((pnd = get_ndt(nd)) != 0 && (tcb = pnd->tcb) != 0) {
		if ((pnd->flags & TCP_CON) && tcpval(tcb) == 0) {
			pnd->tcb = 0;
			tcb = 0;
		}
	}
	*ppnd = pnd;
	return tcb;
}

ND *get_ndt(int nd)
{
	if (nd < 0 || nd >= 64 + stats.ngdesc)
		return 0;
	if (nd < stats.nndesc)
		return (ND *)stats.ndesc + nd;
	else if (nd >= 64)
		return (ND *)stats.gdesc + (nd - 64);
	return 0;
}

static near void handle(ND *pnd,int event,void far *arg)
{
	extern unsigned stack_pointer;
	extern int in_tcp;
	int (far *handler)(void);
	EVENT *pev;
	AQ *paq;
	int nd;

	if ((nd = pnd - stats.gdesc) > stats.ngdesc || nd < 0)
		nd = pnd - stats.ndesc;
	else
		nd += 64;
	if (in_handle || !async) {
		if ((paq = malloc(sizeof(AQ),AllocApiUCQ)) == 0)
			return;		// out of memory - too bad
		paq->next = 0;
		if (paqf) {
			if (paql)
				paql->next = paq;
		}
		else
			paqf = paq;
		paql = paq;
		paq->pnd = pnd;
		paq->nd = nd;
		paq->event = event;
		paq->arg = arg;
		return;
	}
	++in_handle;
	asm push stack_pointer;
	stack_pointer = _SP - 200;
	while (1) {
		if (event != -1) {
			pev = pnd->event + event;
			handler = pev->handler;
			in_tcp &= 0xf;
#ifdef METRO_DEBUG
			if (event == NetAsOpen && (pnd->flags & LISTEN_FLAG))
				met_mark(MET_NOTIFY);
#endif
			_ES = FP_SEG((void far *)pev->hint);
			_DI = FP_OFF((void far *)pev->hint);
			_CX = event;
			_BX = nd;
			if (f386) {
#pragma warn -asm
				asm .386;
				asm pushad;
				asm pushfd;
				asm push gs;
				asm push fs;
			}
			else
				asm push si;
			asm push ds;
			_DS = FP_SEG(arg);
			_SI = FP_SEG(arg);
			_DX = FP_OFF(arg);
			asm push bp;
			if (handler)
				(*handler)();
			asm pop bp;
			asm pop ds;
			if (f386) {
				asm pop fs;
				asm pop gs;
				asm popfd;
				asm popad;
				asm .186;
			}
			else
				asm pop si;
			in_tcp |= 0x70;
		}
		if ((paq = paqf) == 0)
			break;       // nothing queued

		pnd = paq->pnd;
		nd = paq->nd;
		event = paq->event;
		arg = paq->arg;
		if ((paqf = paq->next) == 0)
			paql = 0;
		free(paq);
	}
	asm pop stack_pointer;
	in_handle = 0;
}

void far apif_state(TCB *tcb,char old,char cNew)
{
	ND *pnd;
	NET_ADDR addr;
	char *adra;
	static signed char in_apif_state;

	in_apif_state++;
	pnd = (ND *)tcb->user;
#ifdef METRO_DEBUG
	if (old == LISTEN && cNew == CLOSED) {
		met_mark(MET_CLOSE);
	}
#endif
	if (pnd && pnd->tcb != tcb && cNew != ESTABLISHED)
		pnd = 0;	// some previous user of this nd closed
	if (pnd != 0) {
		adra = (char *)&tcb->conn.remote.address;
		((char *)&addr.remote_host)[0] = adra[3];
		((char *)&addr.remote_host)[1] = adra[2];
		((char *)&addr.remote_host)[2] = adra[1];
		((char *)&addr.remote_host)[3] = adra[0];
		addr.remote_port = tcb->conn.remote.port;
		addr.local_port = tcb->conn.local.port;
		addr.protocol = 6;
		switch (cNew) {
		case ESTABLISHED:
			if (pnd->event[NetAsOpen].handler)
				handle(pnd,NetAsOpen,&addr);
			break;
		case TIME_WAIT:
			if (old != FINWAIT2)
				goto try_as_close;
		case CLOSE_WAIT:
		case CLOSING:
			if (pnd->event[NetAsFclose].handler) {
				handle(pnd,NetAsFclose,0/*&addr*/);
			}
				try_as_close:
			if (cNew == TIME_WAIT && pnd->event[NetAsClose].handler) {
				handle(pnd,NetAsClose,&addr);
			}
			break;
		case CLOSED:
			if (old == TIME_WAIT)
				break;
			if (tcb->reason == NORMAL_R &&
					 pnd->event[NetAsClose].handler) {
				handle(pnd,NetAsClose,&addr);
			}
			else if (tcb->reason != NORMAL_R &&
					 pnd->event[NetAsError].handler) {
				handle(pnd,NetAsError,
					(void far*)(tcb->reason == TIMEOUT ? ErrTimeOut :
														  ErrReset));
			}
			break;
		}
	}
	if (in_apif_state < 2 && tcb->state == CLOSED) {
		pnd = (ND *)tcb->user;
		del_tcp(tcb);
		if (pnd && pnd->tcb == tcb)
			pnd->tcb = 0;
	}
	in_apif_state--;
}

#pragma argsused
void far apif_t(TCB *tcb,int sndwnd,int sndcnt)
{
	ND *pnd;

	pnd = (ND *)tcb->user;
	if (pnd != 0 && pnd->tcb == tcb &&
				pnd->event[NetAsXmt].handler &&
				(pnd->flags & WRITE_NOTIFY)) {
//		handle(pnd,NetAsXmt,(void far *)0xf);
		handle(pnd,NetAsXmt,(void far *)sndcnt);
	}
}

#pragma argsused
void far apif_r(TCB *tcb,int cnt)
{
	ND *pnd;

	pnd = (ND *)tcb->user;
	if (pnd != 0 && pnd->tcb == tcb && pnd->event[NetAsRcv].handler) {
		handle(pnd,NetAsRcv,0);
	}
}

#pragma argsused
void far apiu_r(struct socket *lsocket,int rcvcnt,IFACE *ifp)
{
	ND *pnd;
	UCB *ucb;

	for (pnd = stats.gdesc;pnd < (ND *)stats.gdesc + stats.ngdesc;++pnd) {
		if (pnd->flags & UDP_CON) {
			ucb = (UCB *)pnd->tcb;
			if (ucb->lport == lsocket->port)
				goto found;
		}
	}
	for (pnd = stats.ndesc;pnd < (ND *)stats.ndesc + stats.nndesc;++pnd) {
		if (pnd->flags & UDP_CON) {
			ucb = (UCB *)pnd->tcb;
			if (ucb->lport == lsocket->port)
				goto found;
		}
	}
	return;
	found:
	if (pnd->event[NetAsRcv].handler) {
		handle(pnd,NetAsRcv,0);
	}
}

void alarm_timeout(ND *pnd)
{
	handle(pnd,NetAsAlarm,0);
}

#if !APL
void api_stop(void)
{
	ND *pnd;
	int nd;

	for (nd = 64,pnd = stats.gdesc;pnd && nd < 64 + stats.ngdesc;++nd,++pnd) {
		if ((pnd->flags & ND_ASSIGNED) && pnd->event[NetAsError].handler)
			handle(pnd,NetAsError,(void far *)ErrTerminating);
	}
}
#endif

char errmap[] = {		/* map to pctcp errors */
	NoErr,		/* No error */
	ErrInUse,		/* Connection already exists */
	ErrNotNetConn,	/* Connection does not exist */
	ErrNotEstab,	/* Connection closing */
	ErrNoMem,		/* No memory for TCB creation */
	ErrWouldBlock,	/* Would block */
	ErrIllegalOp,	/* Protocol or mode not supported */
	ErrBadArg,		/* Invalid arguments */
	ErrBadArg,		/* Buffer too short for data */
};

//----------------------------------------------------------------------------
// INET API
//----------------------------------------------------------------------------
#pragma options -Od

static DWORD resolve_ip(WORD seg,WORD off);
TCB *api_tcpopen(TCP_OP_P far *po);

/* INET API interrupt */
void api_inti_c(unsigned reg_off)
{
#ifdef __LARGE__
	API_REG *pr = MK_FP(_SS,reg_off);
#else
	API_REG *pr = (API_REG *)reg_off;
#endif
	struct socket lsocket,rsocket;
	UDP_WR_P far *pudpw;
	int32 dest;
	XPING *pxp;
	MBUF *bp;
	TCB *ptcb;
	TIMER *pt;
	int n,cnt,retv;
	char far *buf;
	/*
	if (!bTimerSet) {
		SetTimer();
		bTimerSet = 1;
	} */
	schedule();
	deb3(22," API %02x %d",((char *)&pr->ax)[1],pr->cx);
	switch (((char *)&pr->ax)[1]) {
	case API_SENDPING:
		((int *)&dest)[0] = pr->dx;
		((int *)&dest)[1] = pr->cx;
		pingem(dest,pr->bx,EXTRNL,0);
		break;
	case API_GETPING:
		if ((pxp = pxpfirst) != 0) {
			pr->bx = pxp->seq;
			dest = pxp->remote;
			if ((pxpfirst = pxp->next) == NULL)
				pxplast = NULL;
			free(pxp);
			goto setipadr;
		}
		else
			pr->ax = 0;
		break;
	case API_STARTMAIL:
#ifdef	SMTP
#if APL
		smtptick();
#endif
#endif
		break;
	case API_GETIPADR:
		if (pr->bx == 0 && pr->cx == 0) {	// want local IP address
			pr->bx = FP_SEG(hostname);
			pr->si = FP_OFF(hostname);
			pr->cx = FP_SEG(ifaces->ip_addr);
			pr->dx = FP_OFF(ifaces->ip_addr);
			break;
		}
		dest = resolve_ip(pr->bx,pr->cx);
		setipadr:
		pr->dx = ((int *)&dest)[0];
		pr->cx = ((int *)&dest)[1];
		break;
	case API_TCPOPEN:	/* open a TCP connection */
		if ((ptcb = api_tcpopen(MK_FP(pr->bx,pr->cx))) == 0) {
			pr->ax = net_error;
			break;
		}
#ifdef __LARGE__
		pr->bx = FP_OFF(ptcb);
		pr->cx = FP_SEG(ptcb);
#define tcb ((TCB *)MK_FP(pr->bx,4))
#else
		pr->cx = FP_OFF(ptcb);
		pr->bx = FP_SEG(ptcb);
#define tcb ((TCB *)pr->bx)
#endif
		pr->ax = 0;
		break;
	case API_TCPREAD:	/* read from a TCP connection */
		if (tcpval(tcb) == 0) {
			pr->cx = 0;
			goto invtcb;
		}
		if (pr->cx == 0) {
			pr->ax = 0;
			break;
		}
		if ((int)(pr->cx = recv_tcp(tcb,&bp,pr->cx,0)) != -1) {
			buf = MK_FP(pr->dx,pr->si);
			cnt = pr->cx;
			goto copymbuf;
		}
		else {
			pr->cx = 0;
			pr->ax = net_error;
		}
		break;
	case API_TCPWRITE:	/* write to a TCP connection */
		if (tcpval(tcb) == 0) {
			pr->cx = 0;
			goto invtcb;
		}
		n = tcb->window - tcb->sndcnt;
		pr->cx = min(n,pr->cx);
		if (pr->cx) {
			if ((bp = alloc_mbuf(pr->cx,AllocApiSndBufT)) == 0) {
				pr->cx = 0;
				pr->ax = NO_SPACE;
				break;
			}
			_fmemcpy(bp->data,MK_FP(pr->dx,pr->si),bp->cnt = pr->cx);
			if (pr->ax & 2)
				hold_tcp = 1;
			pr->cx = send_tcp(tcb,bp,pr->ax & 1);
			hold_tcp = 0;
			if ((int)(pr->cx) == -1) {
				pr->cx = 0;
				pr->ax = net_error;
				break;
			}
		}
		pr->ax = 0;
		break;
	case API_TCPCLOSE:	/* close a TCP connection */
		if (tcpval(tcb) == 0) {
			goto invtcb;
		}
		if (tcb->s_upcall == 0)
			tcb->s_upcall = api_state;
		if (close_tcp(tcb) == -1) {
			pr->ax = net_error;
			break;
		}
		pr->ax = 0;
		break;
	case API_TCPRESET:	/* reset a TCP connection */
		if (tcpval(tcb) == 0) {
			goto invtcb;
		}
		reset_tcp(tcb);
		pr->ax = 0;
		break;
	case API_TCPDELET:	/* delete TCP connection resources */
		if (tcpval(tcb) == 0) {
			invtcb:
			pr->ax = NO_CONN;
			break;
		}
		if (tcb->state == CLOSED) {
			if (del_tcp(tcb) == -1) {
				pr->ax = net_error;
				break;
			}
		}
		else {
			tcb->r_upcall = 0;tcb->t_upcall = 0;
			tcb->s_upcall = api_state;
		}
		pr->ax = 0;
		break;
#undef tcb
	case API_UDPOPEN:	/* open a udp socket to receive dg's */
		lsocket.address = 0;
		lsocket.port = pr->bx;
		if ((retv = open_udp(&lsocket,
				(void (far *)())MK_FP(pr->cx,pr->dx),1)) == 0) {
			pr->ax = CON_EXISTS;
		}
		else if (retv == -1) {
			pr->ax = net_error;
		}
		else
			pr->ax = 0;
		break;
	case API_UDPREAD:	/* read a udp datagram */
		lsocket.address = 0;
		lsocket.port = pr->bx;
		if ((cnt = recv_udp(&lsocket,&rsocket,&bp)) != -1) {
			buf = MK_FP(pr->dx,pr->si);
			if (pr->cx < cnt)
				cnt = pr->cx;
			else
				pr->cx = cnt;
			pr->bx = rsocket.port;
			pr->si = (unsigned)rsocket.address;
			pr->dx = ((unsigned *)(&rsocket.address))[1];
			copymbuf:
			while(bp != NULLBUF && cnt != 0){
				n = min(cnt,bp->cnt);
				if (buf != 0 && n != 0){
					_fmemcpy(buf,bp->data,n);
					buf += n;
				}
				cnt -= n;
				bp->data += n;
				bp->cnt -= n;
				if (bp->cnt == 0) {
					bp = free_mbuf(bp);
				}
			}
			while (bp)
				bp = free_mbuf(bp);
			pr->ax = 0;
		}
		else {
			pr->cx = 0;
			pr->ax = net_error;
		}
		break;
	case API_UDPWRITE:	/* write a udp datagram */
		pudpw = MK_FP(pr->dx,pr->si);
		lsocket.port = pr->bx;
		lsocket.address = 0;
		rsocket.port = pudpw->rem_port;
		rsocket.address = pudpw->rem_ip_ad;
		cnt = pudpw->length;
		if (cnt) {
			if ((bp = alloc_mbuf(cnt,AllocApiSndBufU)) == 0) {
				pr->cx = 0;
				pr->ax = NO_SPACE;
				break;
			}
			_fmemcpy(bp->data,pudpw->buf,bp->cnt = cnt);
			send_udp(&lsocket,&rsocket,0,ip_ttl,bp,cnt,0,0,0);
		}
		pr->ax = 0;
		break;
	case API_UDPCLOSE:	/* close a udp socket */
		lsocket.address = 0;
		lsocket.port = pr->bx;
		if (del_udp(&lsocket) != -1)
			pr->ax = 0;
		else
			pr->ax = net_error;
		break;
	case API_GETVARPTR:	/* get pointer to variables */
		get_memavail();
		pr->bx = FP_SEG(&stats);
		pr->cx = FP_OFF(&stats);
		break;
	case API_GETKEY:	/* get key from INET */
#if APL
		pr->ax = ureadkey((char *)&pr->bx,0);
#endif
		break;
	case API_FILTER:	// modify filter
		pr->ax = source_default_filter((int32)(MK_FP(pr->cx,pr->dx)),pr->bx);
		break;
	case API_TIMERCREATE:	// create a timer
		if ((pt = (TIMER *)calloc(1,sizeof(TIMER),AllocApiTimer)) == 0) {
			pr->ax = NO_SPACE;
			break;
		}
		pt->state = TIMER_EXT;
		pt->func = (void(*)(char *))MK_FP(pr->si,pr->di);
		pt->arg = (char *)pr->bx;
		set_timer(pt,(unsigned long)MK_FP(pr->cx,pr->dx));
#ifdef __LARGE__
		pr->bx = FP_OFF(pt);
		pr->cx = FP_SEG(pt);
#define timer ((TIMER *)MK_FP(pr->bx,4))
#else
		pr->cx = FP_OFF(pt);
		pr->bx = FP_SEG(pt);
#define timer ((TIMER *)pr->bx)
#endif
		start_timer(pt);
		pr->ax = 0;
		break;
	case API_TIMERSET:    	// set a timer
		set_timer(timer,(DWORD)MK_FP(pr->cx,pr->dx));
		pr->ax = 0;
		break;
	case API_TIMERSTART:  	// start a timer
		start_timer(timer);
		pr->ax = 0;
		break;
	case API_TIMERSTOP:		// stop a timer
		stop_timer(timer);
		pr->ax = 0;
		break;
	case API_TIMERDELETE:	// delete a timer
		stop_timer(timer);
		free(timer);
		pr->ax = 0;
		break;
#undef timer
	}
#if !APL
	if (must_schedule) {
		schedule();
		must_schedule = 0;
	}
#endif
	deb1(22+DE,"X");
}

/* resolve IP address, given the name */
static DWORD resolve_ip(WORD seg,WORD off)
{
	char str[80];

	_fstrncpy(str,MK_FP(seg,off),79);
	return resolve(str);
}

#pragma argsused
void far api_state(struct tcb *tcb,char old,char cNew)
{
	if (cNew == CLOSED)
		del_tcp(tcb);
}

TCB *api_tcpopen(TCP_OP_P far *po)
{
	struct socket lsocket,fsocket;

	lsocket.address = 0;
	if ((lsocket.port = po->loc_port) == 0)
		lsocket.port = po->loc_port = getlport();
	fsocket.address = po->rem_ip_ad;
	fsocket.port = po->rem_port;
	tcp_ext = TCP_EXT;
	return open_tcp(&lsocket,&fsocket,po->mode,po->window,
		po->rcv_upcall,po->snd_upcall,
		po->stc_upcall ? (void(far*)())po->stc_upcall : (void(far*)())api_state,po->tos,po->user);
}

