//
//   $Id: BOOTPCMD.C 1.4 2002/10/24 21:03:12Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*************************************************/
/* Center for Information Technology Integration */
/*           The University of Michigan          */
/*                    Ann Arbor                  */
/*                                               */
/* Dedicated to the public domain.               */
/* Send questions to info@citi.umich.edu         */
/*                                               */
/* BOOTP is documented in RFC 951 and RFC 1048   */
/*************************************************/
// BOOTPCMD.C
// BOOTP commands

#if APL==0
#pragma option -zAINETINIT
#pragma option -zFINETINIT
#endif

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include "inetdefs.h"
#include "timer.h"
#include "mbuf.h"
#include "netfunc.h"
#include "internet.h"
#include "tcp.h"
#include "cmdparse.h"
#include "ini.h"

extern BYTE SilentStartup;
extern DWORD bootp_retrans;
extern WORD bootp_maxretry;
DWORD bootp_timeout;

void bootp_set_retry(void)
{
	DWORD time = 0;

	if (!bootp_retrans)
		bootp_retrans = 1000;
	if (!bootp_timeout)
		bootp_timeout = 30000;
	for (bootp_maxretry = 1;time < bootp_timeout;++bootp_maxretry)
		time += bootp_retrans * (1 << (bootp_maxretry - 1));
}

#pragma argsused
doretrans(int argc,char *argv[],void *p)
{
	bootp_retrans = atol(argv[1]);
	return 0;
}

#pragma argsused
dotimeout(int argc,char *argv[],void *p)
{
	bootp_timeout = atol(argv[1]);
	return 0;
}

struct scmds far bootpcmds[] = {
	{"retrans",	doretrans},
	{"timeout",	dotimeout},
	{"",		NULLFP},
};

int dobootp(int argc,char *argv[])
{
	return subcmd(bootpcmds,argc,argv,0);
}

#ifdef INI_FILE
void ini_bootp(char *ini_file)	// initialise BOOTP
{
	char name[80];
	char *argv[2];

	argv[1] = name;
	GetPrivateProfileString("Bootp","Retrans","",name,80,ini_file);
	if (*name)
		doretrans(2,argv,0);
	GetPrivateProfileString("Bootp","Timeout","",name,80,ini_file);
	if (*name)
		dotimeout(2,argv,0);
}
#endif
