//
//   $Id: ECCOM.C 1.3 2002/10/16 16:42:10Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// ECCOM.C
// Ethernet/Tokenring card common functions
// Copyright (c) GP van Niekerk Ondernemings 1990-1998
// Portions Copyright (c) 1986-1989 Phil Karn, KA9Q

#include <stdio.h>
#include <alloc.h>
#include <string.h>
#include <ctype.h>
#include "inetdefs.h"
#include "mbuf.h"
#include "enet.h"
#include "iface.h"
#include "timer.h"
#include "arp.h"
#include "pc.h"

void ip_route(MBUF *bp,char rxbroadcast,IFACE *ifp);

/* Send an IP datagram on Ethernet or tokenring */
#pragma argsused
void ec_send(bp,ifp,gateway,precedence,delay,throughput,reliability)
struct mbuf *bp;		/* Buffer to send */
struct interface *ifp;		/* Pointer to interface control block */
int32 gateway;			/* IP address of next hop */
char precedence;
char delay;
char throughput;
char reliability;
{
	BYTE *egate;
	BYTE *rif;
	static BYTE broadcast_rif[2] = {0xc2,0};
	static BYTE ether_mcast[6] = {1,0,0,0,0,0};

	if ((gateway & 0xf0000000l) == 0xe0000000l) {	// multicast
		egate = ether_mcast;
		put32(ether_mcast + 2, (gateway & 0x7fffffl) + 0x5e000000l);
	}
	else if ((gateway & HOSTMASK(ifp->netbits)) == HOSTMASK(ifp->netbits)) {
		egate = ether_bdcst;
		rif = broadcast_rif;
	}
	else
		egate = res_arp(ifp,gateway,bp,&rif);
	if(egate != 0)
		(*ifp->output)(ifp,egate,ifp->hwaddr,IP_TYPE,bp,rif);
}

/* Send a packet with Ethernet or tokenring header */
void ec_output(interface,dest,source,type,bp,rif)
struct interface *interface;		/* Pointer to interface control block */
char dest[];			/* Destination Ethernet address */
char source[];			/* Source Ethernet address */
WORD type;				/* Type field */
struct mbuf *bp;		/* Data field */
BYTE *rif;
{
	struct ether ep;
	struct mbuf *hdr;

	memcpy(ep.dest,dest,EADDR_LEN);
	memcpy(ep.source,source,EADDR_LEN);
	ep.type = type;
	if (interface->flags & IEEE_FLAG)
		hdr = htoniso(&ep,len_mbuf(bp));
	else if (interface->flags & TOKEN_FLAG)
		hdr = htontoken(&ep,rif);
	else
		hdr = htonether(&ep);
	hdr->next = bp;
	(*interface->raw)(interface,hdr);
}
