//
//   $Id: FILEIO45.C 1.3 2002/10/16 16:42:10Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* FILEIO.C
Simple replacement for File I/O in library
NB - will only work on T,S or M !!!
Updated @ Date 23 November 1995, 12:58 by Gerrit van Niekerk
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <dos.h>
#include <errno.h>
#include <fcntl.h>
#pragma inline
#include <asmrules.h>

#define  __IN_CHMOD

#include <io.h>
#include <_io.h>
#include <stdarg.h>
#include "inetdefs.h"

#define	ZF	0x40	/* 8086/8 zero flag in flags word */
#define	CF	1		/* 8086/8 carry flag */

typedef struct filestr {
	int handle;
	long pos;
	char flags;
#define BINMODE	1
#define EOFSEEN 2
} FILE1;

int _sys_nerr;
FILE *fopen(const char *name,const char *mode)
{
	FILE1 *fp = 0;
	int handle;

	_DX = FP_OFF(name);
	_AX = 0x3d00;
	geninterrupt(0x21);
	handle = _AX;
	if (_FLAGS & CF)
		return 0;
	if ((fp = calloc(sizeof(FILE1),1,AllocFilIoFil)) == 0)
		return 0;
	fp->handle = handle;
	if (strchr(mode,'b') != 0)
		fp->flags |= BINMODE;
	return (FILE *)fp;
}

int read_file(char *buf,int cnt,FILE1 *stream)
{
	_DX = FP_OFF(buf);
	_CX = cnt;
	_BX = stream->handle;
	_AH = 0x3f;
	geninterrupt(0x21);
	if (_FLAGS & CF)
		return -1;
	return _AX;
}

char *fgets(char *s, int n, FILE *stream)
{
	int ch = 0;
	char *ps = s;

	if (stream->flags & EOFSEEN)
		return 0;
	while (n-- > 0) {
		if (read_file((char *)&ch,1,(FILE1 *)stream) <= 0) {
			stream->flags |= EOFSEEN;
			if (ps == s)
				return 0;
			break;
		}
		switch (ch) {
		case '\r':
			break;
		case 'Z' - '@':		// primitive CPM EOF
		case '\n':
			*ps++ = '\n';
			n = 0;
			break;
		default:
			*ps++ = ch;
			break;
		}
	}
	*ps = 0;
	return s;
}

size_t fread(void *ptr, size_t size, size_t n, FILE *stream)
{
	unsigned rsize = size * n;
	unsigned cnt;

	cnt = read_file(ptr,rsize,(FILE1 *)stream);
	if (cnt != rsize)
		stream->flags |= EOFSEEN;
	return cnt / size;
}

int fseek(FILE *stream, long offset, int whence)
{
	int retv = 0;

	if (stream) {
		_BX = ((FILE1 *)stream)->handle;
		_CX = FP_SEG((void far *)offset);
		_DX = FP_OFF((void far *)offset);
		_AL = (char)whence;
		_AH = 0x42;
		geninterrupt(0x21);
		if (_FLAGS & CF)
			retv = -1;
		((FILE1 *)stream)->pos = (long)MK_FP(_DX,_AX);
	}
	else
		retv = -1;
	return retv;
}

long ftell(FILE *stream)
{
	return ((FILE1 *)stream)->pos;
}


int fclose(FILE *stream)
{
	int retv = 0;

	if (stream) {
		_BX = ((FILE1 *)stream)->handle;
		_AH = 0x3e;
		geninterrupt(0x21);
		if (_FLAGS & CF)
			retv = -1;
		free(stream);
	}
	else
		retv = -1;
	return retv;
}

void _setupio(void)
{
}

void _abort(void)
{
	_exit(3);
}

int _RTLENTRY _FARFUNC _rtl_chmod_(const char *pathname, int func/*, int attrib */)
//const char *pathname;
//int func, attrib;
{
		pushDS_
//asm     mov     cx,attrib
asm     mov     ah,43h
asm     mov     al,func
asm     LDS_    dx, pathname
asm     int     21h
		popDS_
asm     jc      _chmodFailed
asm     xchg    ax,cx
		return(_AX);

/*
		error detected call __IOerror
*/

_chmodFailed:
		return -1;	// __IOerror (_AX);
}

int _CType _FARFUNC access(const char *filename, int amode)
{
		register int    attrib;

		attrib = _rtl_chmod_(filename, 0);
		if (attrib == -1)
				return(attrib);
		if ((amode & 0x0002) == 0 || (attrib & FA_RDONLY) == 0)
				return(0);
		errno = EACCES;
		return(-1);
}

int _CType _FARFUNC _open( const char *filename, int oflag )
{
        register int            fd;

asm             mov             al, 1
asm             mov             cx, oflag
asm             test    cx, O_WRONLY
asm             jnz             ready
asm             mov             al, 2
asm             test    cx, O_RDWR
asm             jnz             ready
asm             mov             al, 0
ready:
                pushDS_
asm             LDS_    dx, filename
asm             mov             cl, 0F0h
asm             and             cl, oflag
asm             or              al, cl
asm             mov             ah, 3Dh
asm             int             21h             /* AX = sopen (DS:DX, AL) */
                popDS_
asm             jc              _openFailed

asm             mov             fd,ax
//				_RTLInstanceData(_openfd)[fd] =
//				(oflag & ~(_O_RUNFLAGS | O_TEXT)) | O_BINARY;
				return(fd);

_openFailed:
				return -1;//__IOerror (_AX);
}

int _CType _FARFUNC _close( register int fd )
{
#if defined( _RTLDLL )
    unsigned saveBX;
#endif
asm     mov     ah, 3eh
asm     mov     bx, fd
asm     int     21h
asm     jc      _closeFailed
#if defined( _RTLDLL )
        saveBX = _BX;
		_RTLInstanceData(_openfd) [saveBX] = 0;
#else
		_openfd [_BX] = 0;
#endif
        return 0;

_closeFailed:
		return -1;//__IOerror (_AX);
}

void abort(void)
{
//    raise(SIGABRT);
	_abort();       // If handler returns then not handled so default action
}

void __ErrorMessage(const char *__message)
{
	biosprintf(__message);
}

