//
//   $Id: FILES.C 1.4 2003/07/01 19:29:58Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// FILES.C
// Definitions of file names
// Copyright (c) GP van Niekerk Ondernemings 1990-1998
// Portions Copyright (c) 1986-1989 Phil Karn, KA9Q

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include "inetdefs.h"

char *binmode[] = {
	"rb",	/* Read binary */
	"wb"	/* Write binary */
};

#include <dir.h>

#ifdef DL
#define CNAME "SOCKETS"
char startupn[] =  "socket.cfg";		/* Initialization file */
char hosts[] =	   "hosts";				/* Network host table */
#if APL
char userfile[] =  "socket.upw";		/* Authorized FTP users and passwords */
char mailspool[] = "inmail";			/* Incoming mail */
char mailqdir[] =  "outmail";			/* Outgoing mail spool */
char mailqueue[] = "outmail\\*.mid";	/* Outgoing mail work files */
char inetpath[] =  "c:\\dl\\sockets";	/* prefix to all names */
#else
char inetpath[] =  "c:\\dl\\sockets";	/* prefix to all names */
#endif
#else
#define CNAME "INET"
char startupn[] =  "inet.stu";		/* Initialization file */
char hosts[] =	   "inet.hst";		/* Network host table */
#if APL
char userfile[] =  "inet.upw";		/* Authorized FTP users and passwords */
char mailspool[] = "inmail";		/* Incoming mail */
char mailqdir[] =  "outmail";		/* Outgoing mail spool */
char mailqueue[] = "outmail\\*.mid";	/* Outgoing mail work files */
char inetpath[] =  "C:\\INET";		/* prefix to all names */
#else
char inetpath[] =  "C:\\INET";		/* prefix to all names */
char rinetpath[] = "C:\\RINET";
#define SNAME "RINET"
#endif
#endif
char *pinetpath;
#if (!APL) && !defined(DL)
char *prinetpath;
#endif

void set_disk(void)			/* set path in filenames */
{
	char *p;

	if ((pinetpath = getenv(CNAME)) == 0) {
		pinetpath = inetpath;
		inetpath[0] = getdisk() + 'A';
	}
	else while (*(p = pinetpath + strlen(pinetpath) - 1) == '\\')
		*p = 0;
#if (!APL) && !defined(DL)
	if ((prinetpath = getenv(SNAME)) == 0) {
		prinetpath = rinetpath;
		rinetpath[0] = getdisk() + 'A';
	}
	else while (*(p = prinetpath + strlen(prinetpath) - 1) == '\\')
		*p = 0;
#endif
}

#pragma argsused
char *getfilename(char *fulname,char *name,int dos)
{
#ifdef DL
	sprintf(fulname,"%s\\%s%s",pinetpath,dos ? "dos\\" : "",name);
	if (access(fulname,4) != 0) {
		if (dos) {
			sprintf(fulname,"%s\\%s",pinetpath,name);
			if (access(fulname,4) == 0)
				return fulname;
		}
		strcpy(fulname,name);
	}
#else
#if APL
	sprintf(fulname,"%s\\%s",pinetpath,name);
#else
	sprintf(fulname,"%s\\%s",dos ? prinetpath : pinetpath,name);
#endif
#endif
	return fulname;
}
