//
//   $Id: PCS.C 1.7 2003/08/11 19:55:24Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// PCS.C
// PC related functions for MSDOS
// Copyright (c) GP van Niekerk Ondernemings 1990-1998
// Portions Copyright (c) 1986-1989 Phil Karn, KA9Q

#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <alloc.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include "inetdefs.h"
#include "iface.h"
#include "pc.h"
#include "cmdparse.h"
#include "mbuf.h"
#include "log.h"
#include "_api.h"
#include "_capi.h"

#ifdef DL
#define CONFIG_EXT ".cfg"
#define PRNAME "DL Sockets"
#else
#define CONFIG_EXT ".stu"
#define PRNAME "Rinet"
#endif

#ifdef X25
#include "mbuf.h"
#include "x25if.h"
#endif

#ifndef V25
//#define TIMINT	8	// clock interrupt for PC compatible processors

#define TIMINT	0x1c	// timer interrupt for PC compatible processors
#else
#define TIMINT	0x1d	// timer interrupt for Schweers V25
#endif
#define DOSINT	0x21	/* DOS interrupt */

/* Interface list header */
//struct interface *ifaces;
extern char *initfree, *printfree, cPrintingUsed;
extern int doscurx,doscury;	/* dos cursor on entry */
extern int net_error;		/* network error */
extern WORD lport;
extern int32 ip_addr;
static WORD clkval = 0;

void (*outbuf)();		/* pointer to string output routine */
void (*inbuf)();		/* pointer to string input routine */

void outbuf8p();		/* string output, PC 8 bit mode */
void outbuf8a();		/* string output, AT 8 bit mode */
void inbuf8p();			/* string input, PC 8 bit mode */
void inbuf8a();			/* string input, AT 8 bit mode */

//extern unsigned _stklen = 0x800;
//extern unsigned _heaplen = 0x4000;

void interrupt api_int_a();
void interrupt api_inti_a();
static void interrupt (*oldtimer)();
void interrupt newtimer();

unsigned stack_pointer;
unsigned stack_segment;
int in_tcp = 0xf0;
char did_schedule;
char upper_case;		// actually unload flag!

int api_intp = 0x61;	/* Emulator API interrupt */
int api_int = API_INT;	/* Inet API interrupt */

/* Called at startup time to set up console I/O, memory heap */
void ioinit(void)
{
	unsigned grabcore();
	char *p;

	/* determine if PC or AT and set string i/o */

#if ETHDRV
	if (peekb(0xf000,0xfffe) == 0xfc) {
		outbuf = outbuf8a;
		inbuf = inbuf8a;
	}
	else {
		outbuf = outbuf8p;
		inbuf = inbuf8p;
	}
#endif
	/* Interrupts use a special stack deep in data space.
	 * Calls to sbrk() (invoked by malloc when it needs more memory
	 * from the system) at interrupt time will fail because sbrk()
	 * will think that the stack has overwritten the heap. So
	 * grab all the memory we can now for the heap so that malloc
	 * won't have to call sbrk and alloc_mbuf() won't fail unnecessarily
	 * at interrupt time.
	 */
	//grabcore();
	p = malloc(0x100,AllocPcs100);
	free(p);
	/* read the clock time */
	clkval = peek(0x40,0x6c);
}

/* Called just before exiting to restore console state */
void iostop(void)
{
	void interrupt intx25();
	void lpt_exit(void);
	void api_stop(void);

	api_stop();
	if (cPrintingUsed)
		lpt_exit();
	while(ifaces != 0){
		if(ifaces->stop != 0)
			(*ifaces->stop)(ifaces);
		ifaces = ifaces->next;
	}
	setvect(api_int,0);
	setvect(api_intp,0);
#ifdef X25
	_AH = F_UNLOAD;
    intx25();
#endif
	if (newtimer == getvect(TIMINT)) {
		setvect(TIMINT, oldtimer);
		_ES = _psp;
		_AH = 0x49;
		geninterrupt(0x21);	/* release program memory */
	}
}

/* This code is handled by newtimer.asm module
static WORD savess,savebp;

void interrupt newtimer()
{
	(*oldtimer)();
	if (!in_tcp && !did_schedule) {
		in_tcp = 0x41;
		savess = _SS;
		savebp = _SP;
		_SS = _DS;
		_SP = stack_pointer;
		_BP = stack_pointer + 6;
		enable();
		schedule();
		disable();
		_SS = savess;
		_SP = savebp;
		in_tcp = 0;
	}
	did_schedule = 0;
}
*/

static void near checkint(int vec)
{
	void interrupt (*int_apiv)();
	struct REGPACK r;

	int_apiv = getvect(vec);
	if (int_apiv != 0 && FP_SEG(int_apiv) < 0xf000) {
		if (upper_case) {
			printf(PRNAME " unloaded\n");
			r.r_ax = NetShutDown << 8;
			intr(vec,&r);
			exit(0);
		}
		else {
			printf(PRNAME " already loaded using INT %02Xh\n",vec);
			exit(2);
		}
	}
}

void checkresident()
{
//	checkint(api_int);
	checkint(api_intp);
}
/*
void SetTimer(void)
{
	void set_oldtimer(void interrupt(*)());

	oldtimer = getvect(TIMINT);
	set_oldtimer(oldtimer);		// put into code segment
	setvect(TIMINT, newtimer);
}
*/

goresident()
{
	void set_oldtimer(void interrupt(*)());

	oldtimer = getvect(TIMINT);
	set_oldtimer(oldtimer);		// put into code segment
	setvect(TIMINT, newtimer);
	setvect(api_int,api_inti_a);
	setvect(api_intp,api_int_a);
	in_tcp = 0;
	free(initfree);
	if (!cPrintingUsed)
		free(printfree);
	//printf("stack_pointer %p\n",stack_pointer);
	keep(0,(_SS + (stack_pointer / 16) - _psp + 2));
	return 0;
}

#if APL
/* delete a list of files */
dodelete(int argc,char *argv[])
{
	int i;

	for (i = 1;i < argc;++i) {
		if (unlink(argv[i]) == -1)
			return -1;
	}
	return 0;
}

static near void getval(char *pval,char *arg)
{
	unsigned int val;

	val = atoi(arg);
	if (val != 0 || *arg == '0')
		*pval = val;
}

/* date examine/set */
dodate(int argc,char *argv[])
{
	int i;
	struct date d;
	struct time t;
	extern time_t start_time;
	time_t timold;

	getdate(&d);
	gettime(&t);
	if (argc > 1) {
		for (i = 1;i < argc;++i) {
			switch (i) {
			case 1:
				d.da_year = atoi(argv[1]);
				if (d.da_year < 100)
					d.da_year += 1900;
				break;
			case 2:
				getval(&d.da_mon,argv[2]);
				break;
			case 3:
				getval(&d.da_day,argv[3]);
				break;
			case 4:
				getval(&t.ti_hour,argv[4]);
				break;
			case 5:
				getval(&t.ti_min,argv[5]);
				break;
			case 6:
				getval(&t.ti_sec,argv[6]);
				break;
			}
		}
		timold = time(0);
		setdate(&d);
		if (i > 4)
			settime(&t);
		start_time += (time(0) - timold);
		clkval = peek(0x40,0x6c);	/* set to current */
		getdate(&d);
		gettime(&t);
		log(0,"date set");
	}
	printf("Date: %u-%02u-%02u Time: %u:%02u:%02u\n",
		d.da_year,d.da_mon,d.da_day,t.ti_hour,t.ti_min,t.ti_sec);
	return 0;
}

/* rename a file */
dorename(int argc,char *argv[])
{
	if (argc == 3) {
		return rename(argv[1],argv[2]);
	}
	return -1;
}
#endif

wait(void)
{
	return 1;
}

/* wait for 'ticks' number of clock ticks */
void tick_wait(unsigned ticks)
{
	WORD time;

	while (ticks--) {
		time = peek(0x40,0x6c);
		while (time == peek(0x40,0x6c)){}
	}

}

unsigned long master_tick;

/* checks the time then ticks and updates ISS */
void
check_time()
{
	void tick(void);
	int32 iss();
	WORD ntime;

	/* Read the low order word of the BIOS tick counter directly. The
	 * INT 1Ah call isn't used because it stupidly clears the
	 * "midnight passed" flag and we'd have to update the date ourselves.
	 * (See Norton, p222).
	 *
	 */
	ntime = peek(0x40,0x6c);
	if (ntime - clkval > 0x50)
		clkval = ntime - 1;// for midnight problem
	while(ntime != clkval){	/* Handle possibility of several missed ticks */
		master_tick++;
		clkval++;
#if APL
		icmpclk();	/* Call this one before tick */
#endif
		tick();
		(void)iss();
#if APL
		timint();	/* terminal emulator timer int */
#endif
	}
}

/* Reset the CPU, reboot DOS */
void sysreset(void)
{
	void (*freset)(void);

	freset = MK_FP(0xffff,0);
	(*freset)();
}
