;
;   $Id: PKTRCV.ASM 1.2 2002/10/16 16:43:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
page 50,132
TITLE 'PKTRCV.ASM'
;
;	Assembler interface for 'receiver()' function
;	Updated @ Date 27 January 1996, 19:35 by Gerrit van Niekerk
;

PDCBLEN	equ 30		; NB This length MUST match up with PDCB in pktdrv.h

extrn	_receiver_c : far
extrn	_pstack_start : word
extrn	_pktcb : word

public	_receiver_a0,_receiver_a1,_receiver_a2,_receiver_a3,_popf

DGROUP	GROUP	_DATA

ASSUME	DS : DGROUP,	CS : _TEXT

;
;	Data Structures
;

_DATA	SEGMENT	WORD	PUBLIC	'DATA'

;
;	Area to save Stack Pointer
;
ss_save		DW	?
sp_save		DW	?
;
_DATA	ENDS

page +

;
;	Start of Code
;

_TEXT	SEGMENT	WORD	PUBLIC	'CODE'

; simulate a popf instruction for buggy 286's

_popf	proc	far
	iret
_popf	endp

_receiver_a0	proc	far
	mov	di,offset _pktcb
	jmp	short receiver
_receiver_a0	endp

_receiver_a1	proc	far
	mov	di,offset _pktcb + PDCBLEN
	jmp	short receiver
_receiver_a1	endp

_receiver_a2	proc	far
	mov	di,offset _pktcb + (PDCBLEN*2)
	jmp	short receiver
_receiver_a2	endp

_receiver_a3	proc	far
	mov	di,offset _pktcb + (PDCBLEN*3)

;
;	This routine is the 'receiver()' entry point.  It is called by the
;	Packet Driver via a far call.  Before calling the main 'receiver()'
;	routine (written in 'C'), it sets up the Data Segment, saves
;	the Packet Driver's stack, and allocates a new stack.
;	Before returning to the Packet Driver it restores its
;	stack.
;
receiver:
	pushf
	cli
	push	ds
	mov	dx, DGROUP	; Get Data Segement
	mov	ds, dx		; Set up DS

	mov	ss_save, ss	; Save Stack Pointers
	mov	sp_save, sp	;

	mov	ss, dx		; Set up Stack Segment
	mov	sp, _pstack_start	; 
	push cx			; for 1.10 spec
	call	_receiver_c	; Call 'C' 'receiver()'
	pop cx
	mov	di,ax
	mov	es,dx
	mov	ss, ss_save	; Restore Stack Pointers
	mov	sp, sp_save

	pop	ds
	call	_popf
	ret
_receiver_a3	endp

_TEXT	ENDS

	END

