#
#   $Id: socketm.mak 1.11 2002/10/24 18:40:14Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# SOCKETM.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 10/24/2002 jmb added bootpcmd.c/.obj
# 09/28/2001 jmb corrected syntax error
# 09/27/2001 jmb added RD_SW and RD_SW_L support
# 07/25/2001 gvn added KERNEL flag
# 07/10/2001 gvn improved usage
# 07/09/2001 jmb removed -k- option
# 05/04/2001 pb  Added Usage screen file.
# 03/30/2001 jmb Ported from a Borland C++ Generated makefile
#
#
.AUTODEPEND


#
# Borland C++ tools
#
CC = BCC
BCCDOS  = $(CC)
TLINK   = TLink
TASM    = Tasm

#
# Dependency List
#
socketm : BccDos.cfg SOCKETM\socketm.exe
#	@if exist ..\socketm.exe del ..\socketm.exe >nul
#	@copy socketm\socketm.exe ..\socketm.exe

#
# Options
#
LFLAGS = $(RD_SW_L) -c -Tde -m
CFLAGS = $(RD_SW) -I..\INCLUDE;..\..\include -DMSDOS;APL=0;DL;NOLIC;ASYNC;PPP_S;USR;noDEB;LPDD;KERNEL;

STARTUP = c0m.obj
LIB     = noehm.lib cm.lib ..\..\lib\dlm.lib

LAST_OBJ = last.obj

SOCKETS_OBJ = 	!a000.obj	\
		!alloc.obj	\
		!api_intc.obj	\
		!arp.obj	\
		!arpcmd.obj	\
		!bootp.obj	\
		!bootpcmd.obj	\
		!bprintf.obj	\
		!cmdparse.obj 	\
		!commands.obj	\
		!debug.obj	\
		!dns.obj	\
		!eccom.obj	\
		!enet.obj	\
		!exit.obj	\
		!fileio45.obj	\
		!files.obj	\
		!files2.obj	\
		!icmp.obj	\
		!icmpcmd.obj	\
		!iface.obj	\
		!ifunc.obj	\
		!igmp.obj	\
		!ip.obj		\
		!ipcmd.obj	\
		!lpdd.obj	\
		!main.obj	\
		!mbuf.obj	\
		!misc.obj	\
		!netfunc.obj	\
		!pcs.obj	\
		!pktdrv.obj	\
		!pktdrvi.obj	\
		!prntserv.obj	\
		!rip.obj	\
		!rs.obj 	\
		!schedule.obj	\
		!tcp.obj	\
		!tcpcmd.obj	\
		!term.obj	\
		!timer.obj	\
		!udp.obj	\
		!version.obj	\
		!api_int.obj	\
		!newtimer.obj	\
		!pcg.obj	\
		!pktrcv.obj	\
		!usage.obj \
		!z000.obj

SOCKM_OBJ  =   	!asy.obj	\
		!md5_dgst.obj	\
		!modem.obj	\
		!ppp.obj	\
		!pppcmd.obj	\
		!s_iface.obj	\
		!slhc.obj	\
		!slip.obj	\
		!slipb.obj	\
		!userpass.obj




SOCKETM.TLK : $(SOCKETS_OBJ:!=SOCKETM\) $(SOCKM_OBJ:!=SOCKETM\)
	@echo Building linker response file...
	@echo $(STARTUP)  +>SOCKETM.TLK
	@&echo $? +              >>socketm.tlk
        @echo socketm\last.obj   >>SOCKETM.TLK
        @ECHO socketm\socketm, socketm\socketm >>SOCKETM.TLK
	@echo $(LIB) $(LFLAGS);  >>SOCKETM.TLK


SOCKETM\socketm.exe : $(SOCKETS_OBJ:!=SOCKETM\) $(SOCKM_OBJ:!=SOCKETM\) $(LAST_OBJ) socketm.tlk
  @$(TLINK)  $(LFLAGS) @socketm.tlk
  @cd socketm
  @echo Compressing SOCKETM.EXE
  @..\..\BIN\lzexe socketm.exe > nul
  @cd ..
  @del socketm.tlk > nul


SOCKETM\a000.obj :  a000.c
SOCKETM\alloc.obj :  alloc.c
SOCKETM\api_intc.obj :  api_intc.c
SOCKETM\arp.obj :  arp.c
SOCKETM\arpcmd.obj :  arpcmd.c
SOCKETM\asy.obj :  asy.c
SOCKETM\bootp.obj :  bootp.c
SOCKETM\bootpcmd.obj :  bootpcmd.c
SOCKETM\bprintf.obj :  bprintf.c
SOCKETM\cmdparse.obj :  cmdparse.c
SOCKETM\commands.obj :  commands.c
SOCKETM\debug.obj :  debug.c
SOCKETM\dns.obj :  dns.c
SOCKETM\eccom.obj :  eccom.c
SOCKETM\enet.obj :  enet.c
SOCKETM\exit.obj :  exit.c
SOCKETM\fileio45.obj :  fileio45.c
SOCKETM\files.obj :  files.c
SOCKETM\files2.obj :  files2.c
SOCKETM\icmp.obj :  icmp.c
SOCKETM\icmpcmd.obj :  icmpcmd.c
SOCKETM\iface.obj :  iface.c
SOCKETM\ifunc.obj :  ifunc.c
SOCKETM\igmp.obj :  igmp.c
SOCKETM\ip.obj :  ip.c
SOCKETM\ipcmd.obj :  ipcmd.c
SOCKETM\lpdd.obj :  lpdd.c
SOCKETM\main.obj :  main.c
SOCKETM\mbuf.obj :  mbuf.c
SOCKETM\md5_dgst.obj :  md5_dgst.c
SOCKETM\misc.obj :  misc.c
SOCKETM\modem.obj :  modem.c
SOCKETM\netfunc.obj :  netfunc.c
SOCKETM\pcs.obj :  pcs.c
SOCKETM\pktdrv.obj :  pktdrv.c
SOCKETM\pktdrvi.obj :  pktdrvi.c
SOCKETM\ppp.obj :  ppp.c
SOCKETM\pppcmd.obj :  pppcmd.c
SOCKETM\prntserv.obj :  prntserv.c
SOCKETM\rip.obj :  rip.c
SOCKETM\rs.obj :  rs.c
SOCKETM\s_iface.obj :  s_iface.c
SOCKETM\schedule.obj :  schedule.c
SOCKETM\slhc.obj :  slhc.c
SOCKETM\slip.obj :  slip.c
SOCKETM\slipb.obj :  slipb.c
SOCKETM\tcp.obj :  tcp.c
SOCKETM\tcpcmd.obj :  tcpcmd.c
SOCKETM\term.obj :  term.c
SOCKETM\timer.obj :  timer.c
SOCKETM\udp.obj :  udp.c
SOCKETM\userpass.obj :  userpass.c
SOCKETM\version.obj :  version.c
SOCKETM\api_int.obj :  api_int.asm
SOCKETM\newtimer.obj :  newtimer.asm
SOCKETM\pcg.obj :  pcg.asm
SOCKETM\pktrcv.obj :  pktrcv.asm
SOCKETM\z000.obj :  z000.c
SOCKETM\usage.obj :  usage.c
SOCKETM\last.obj :  last.c

# Compiler configuration file
BccDos.cfg :
   Copy &&|
-W-
-w
#-R
#-v
-vi
-H
-H=socketp.csm
-1
-C
-O-d
-Z
-O
-O-e
-Ol
-d
-mm
-f-
-x-
-xp-
-xd-
-xc-
-xf-
-RT-
-O-b
-O-W
-O-a
-O-m
-O-p
-v-
-R-

-K-
-H-
| $@


.c.obj:
  $(CC) @BccDos.cfg -P- -c @&&|
  $(CFLAGS) -oSOCKETM\$*.obj $*.c
|

.asm.obj:
  $(TASM) /ml $*.asm ,SOCKETM\$*.obj


