//
//   $Id: CGIFORM.C 1.7 2002/10/16 16:57:00Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCFILE:CGIFORM.C

	Copyright (C) 1999-2001 Datalight, Inc.
	All Rights Reserved

	Simple "CGI" forms program for Sockets HTTP server

	WARNING: This sample has only been tested with the Borland C compiler and may
	need modification if another compiler is used.

	$DOCHISTORY:

   11/02/2001  jmb added check for additional data and to return
                   to wait for more data if data is not available.
	2001-07-14  gvn fixed resident sizes
	2001-05-11	gvn cleanup
	2001-05-02	jmb corrected back button to point to caform.htm
	2001-05-01	jmb fixed "back" button to point to cgiform.htm
	2000-05-18	jvn first version
*/

#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <process.h>
#include <stdlib.h>
#include <string.h>

#include "cgiadap.h"
int check_password(char *pname,char *ppass);

// Format of input:
// loginname=gerrit&password=van+niekerk&submit=Submit
// clear=Clear+all

// Forms demo


// Make the heap and stack smaller as not to waste memory when going resident
// _stklen should be at least 1000 + the stack required for the callback

extern unsigned _stklen = 3000;
extern unsigned _heaplen = 2000;

void GoDOS(void);
int far Callback(HTTP_PARAMS far* psParams);

void main(int iArgc, char *pArgs[])
{
	if(HttpRegister("cgiform.htm", Callback, F_OVERLAP | F_ENV, 0) != NONE) {
		printf("cannot register\n");
		HttpDeRegister("cgiform.htm");
		exit(-1);
	}

	if (iArgc > 1 && strcmp(pArgs[1], "/t") == 0)
		GoDOS();
	else {
		/*
			PLEASE NOTE: take care when calculating the amount of memory to save
				as different memory models use different memory layouts
		 */
		int iSize = _SS - _psp + (_SP - 1000) / 16 + 1;
		printf("Resident program at %04x, Callback stack at %04x:%04x\n"
				 "Size = %u bytes, 0x%x paragraphs\n",_psp,
				 GetStackSegment(),GetStackPointer(),iSize * 16, iSize);
		keep(0, iSize);//go tsr
	}

	printf("Program exiting\n");
	HttpDeRegister("cgiform.htm");
}

int far Callback(HTTP_PARAMS far* psParams)
{
	char buf[200],*p,*pname,*ppass;
	int iReadCount;
	char rgcResponse[400];
	char *pResp = rgcResponse;
	int rc;

	*buf = 0;

  //	printf("There are %d headers\n", psParams->iEnvSize);
  //	for (rc = 0; rc < psParams->iEnvSize; rc++)
  //		printf("header %d = %Fs\n", rc, psParams->ppEnv[rc]);

	iReadCount = _fstrlen(psParams->szQuery);
	if (iReadCount)
		_fmemcpy (buf,psParams->szQuery, iReadCount);
	//read 1 shot would block or buffer full and handle
   rc = HttpGetData(psParams->iHandle, buf + iReadCount, 200 - iReadCount);

   // see if an error situation occurred
   if (rc < 0)
   {
      if (rc == (-WOULDBLK))
         // get more data
         return RET_OK;
      else
         // some error occurred
         goto bad_input;
   }

	iReadCount += rc;

#if 0

11/06/2001 jmb this code could be dangerous.  If all of the data is not
               present, should we wait or give an error?  If all of the
 					data has not been delivered then the code below will catch
					erroneous data.

   if (iReadCount < psParams->lContentLen)
      // get more data
      return RET_OK;

#endif

	pResp += sprintf(pResp, "HTTP/1.0 200 OK\r\nContent-type: text/html\r\n\r\n<html><h1>");
	if (strncmp(buf,"loginname=", 10) == 0) {
		pname = buf + 10;
		if ((p = strchr(pname,'&')) == 0)
			goto bad_input;
		*p++ = 0;
		if ((ppass = strchr(p,'=')) == 0)
			goto bad_input;
		if ((p = strchr(++ppass,'&')) == 0)
			goto bad_input;
		*p = 0;
		if ((rc = check_password(pname,ppass)) < -1)
			pResp += sprintf(pResp, "Sorry %s, we have a system problem",pname);
		else if (rc < 0)
			pResp += sprintf(pResp, "Sorry %s, you entered the wrong password",pname);
		else if (rc == 0)
			pResp += sprintf(pResp, "User %s logged in",pname);
		else
			pResp += sprintf(pResp, "Welcome %s, you are now registered",pname);
	}
	else if (strncmp(buf,"clear=",6) == 0) {
		pResp += sprintf(pResp, "You asked for it!<p>All users cleared out.");
		unlink("users.dat");
	}
	else {
		int iMethod;
		bad_input:
		iMethod = psParams->iValue;
		pResp += sprintf(pResp, "Bad input<p>Method: %s<p>%s<p>",
						iMethod == RQ_GET ? "Get" :
						iMethod == RQ_POST ? "Post" : "Unkown", buf);
		/*
		for (env = environ;*env;env++) {
			printf("%s<p>\n",*env);
		}
		*/
	}
	pResp += sprintf(pResp, "<P><P><A HREF=\"/caform.htm\">Back</A>.</html>\n");
	HttpSendData(psParams->iHandle, rgcResponse, pResp - rgcResponse);
	return RET_DONE;
}

int check_password(char *pname,char *ppass)
{
	FILE *fp;
	char name[40],pass[40], *mode = "r+t";
	int rc = 1;

	if (access("users.dat",0) != 0)
		mode = "w+t";
	if ((fp = fopen("users.dat",mode)) == 0) {
		printf("Fopen error: %s\n", sys_errlist[errno]);

		return -2;
	}
	while (fgets(name,40,fp) != 0) {
		name[strlen(name) - 1] = 0;
		fgets(pass,40,fp);
		pass[strlen(pass) - 1] = 0;
		if (strcmp(pname,name) == 0) {
			rc = strcmp(ppass,pass) ? -1 : 0;
			break;
		}
	}
	if (rc == 1)
		fprintf(fp,"%s\n%s\n",pname,ppass);
	fclose(fp);
	return rc;
}


void GoDOS(void)
{
	char *argvl[2];

	if ((argvl[0] = getenv("COMSPEC")) == 0)
		argvl[0] = "\\COMMAND.COM";
	argvl[1] = 0;
	printf("Type 'exit' to unload program\n");
	spawnvp(P_WAIT,argvl[0],argvl);
}


