#
#   $Id: RC.MAK 1.3 2003/01/16 23:34:22Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#   HISTORY
#   1/16/2003 added danish specific build

JC=JAVAC
JAR=JAR

JCOPTS=-g -sourcepath source/inet -d . -deprecation
JAROPTS=vf

all: CLASSES JAR
	@if exist ..\rc*.jar del ..\rc*.jar >nul
	@copy rc.jar ..\rc.jar >nul
	@copy rc_dk.jar ..\rc_dk.jar >nul


CLASSES: RC.RSP\
	src\inet\Constants.java   src\inet\Emul.java \
	src\inet\DosConsole.java  src\inet\DataBase.java \
	src\inet\QuickDialog.java src\inet\Debug.java \
	src\inet\Od.java          src\inet\KeyMapDialog.java \
	src\inet\OpenConnectionDialog.java \        
	src\inet\DosConsoleApplet.java \
	src\inet\ASCIITableUS.java 
	@echo Making US/English RC.JAR
	@attrib -r src\inet\ASCIITableUS.java
	@copy src\inet\ASCIITableUS.java src\inet\ASCIITable.java /y
	@$(JC) $(JCOPTS) @rc.rsp
	@copy src\inet\keymap.us inet\keymap /y >nul
	@copy src\inet\specialkey.us inet\specialkey >nul


JAR: inet\Constants.class        inet\DosConsole.class \
     inet\DosConsoleApplet.class inet\Emul$$EmulCanvas.class \
     inet\Emul.class             inet\keymap \
     inet\specialkey             inet\ASCIITable.class

        #
        # US language specific JAR file
        #
	@$(JAR) c$(JAROPTS) rc.jar  inet/Constants.class
	@$(JAR) u$(JAROPTS) rc.jar  inet/DosConsole.class
	@$(JAR) u$(JAROPTS) rc.jar  inet/DosConsoleApplet.class
	@$(JAR) u$(JAROPTS) rc.jar  inet/Emul$$EmulCanvas.class
	@$(JAR) u$(JAROPTS) rc.jar  inet/Emul.class
	@$(JAR) u$(JAROPTS) rc.jar  inet/ASCIITable.class
	@$(JAR) u$(JAROPTS) rc.jar  inet/keymap
	@$(JAR) u$(JAROPTS) rc.jar  inet/specialkey

	@echo Making Danish RC_DK.JAR
        #
        # Danish specific JAR file
        #
	@copy src\inet\keymap.dk inet\keymap /y>nul
	@copy src\inet\specialkey.dk inet\specialkey >nul

        #
        # copy and compile DK specific translation table
        #
	@attrib -r src\inet\ASCIITableDK.java
	@copy src\inet\ASCIITableDK.java src\inet\ASCIITable.java /y
	@$(JC) $(JCOPTS) src/inet/ASCIITable.java

	@$(JAR) c$(JAROPTS) rc_dk.jar  inet/Constants.class
	@$(JAR) u$(JAROPTS) rc_dk.jar  inet/DosConsole.class
	@$(JAR) u$(JAROPTS) rc_dk.jar  inet/DosConsoleApplet.class
	@$(JAR) u$(JAROPTS) rc_dk.jar  inet/Emul$$EmulCanvas.class
        @$(JAR) u$(JAROPTS) rc_dk.jar  inet/Emul.class
        @$(JAR) u$(JAROPTS) rc_dk.jar  inet/ASCIITable.class
        @$(JAR) u$(JAROPTS) rc_dk.jar  inet/keymap
        @$(JAR) u$(JAROPTS) rc_dk.jar  inet/specialkey

RC.RSP:
	@if exist rc.rsp del rc.rsp
	@echo src/inet/DosConsole.java              >rc.rsp
	@echo src/inet/DataBase.java                >>rc.rsp
	@echo src/inet/Constants.java               >>rc.rsp
	@echo src/inet/ASCIITable.java              >>rc.rsp
	@echo src/inet/Emul.java                    >>rc.rsp
	@echo src/inet/QuickDialog.java             >>rc.rsp
	@echo src/inet/Debug.java                   >>rc.rsp
	@echo src/inet/Od.java                      >>rc.rsp
	@echo src/inet/KeyMapDialog.java            >>rc.rsp
	@echo src/inet/OpenConnectionDialog.java    >>rc.rsp
	@echo src/inet/DosConsoleApplet.java        >>rc.rsp


clean:
	@echo cleaning remote console
	@if exist rc.rsp del rc.rsp
	@if exist src\inet\*.class del src\inet\*.class
	@if exist inet\*.class del inet\*.class
	@if exist inet\keymap del inet\keymap
	@if exist inet\specialkey del inet\specialkey

cleanall: clean
	@if exist rc.jar del rc.jar
	@if exist ..\rc.jar del ..\rc.jar
	@if exist rc_dk.jar del rc_dk.jar
	@if exist ..\rc_dk.jar del ..\rc_dk.jar


