//
//   $Id: ASCIITableDK.java 1.2 2003/01/17 16:40:24Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//


package inet;

public class ASCIITable
{

   public static final char[] ASCII = 
   {
		    32, 0x263a, 0x263b, 0x2665, 0x2666, 0x2663, 0x2660, 0x25cf,   // 0
		0x25d8,      9, 0x25d9, 0x2642, 0x2640, 0x266a, 0x266b, 0x263c,  
		0x25ba, 0x25c4, 0x2195,   0x13,   0x14,   0x15, 0x25ac, 0x21a8,   // 16
		0x2191, 0x2193, 0x2192, 0x2190,   0x1c, 0x2194, 0x25b2, 0x25bc,  
		  0x20,   0x21,   0x22,   0x23,   0x24,   0x25,   0x26,   0x27,   // 32
		  0x28,   0x29,   0x2a,   0x2b,   0x2c,   0x2d,   0x2e,   0x2f,   
		  0x30,   0x31,   0x32,   0x33,   0x34,   0x35,   0x36,   0x37,   // 48
		  0x38,   0x39,   0x3a,   0x3b,   0x3c,   0x3d,   0x3e,   0x3f,
		  0x40,   0x41,   0x42,   0x43,   0x44,   0x45,   0x46,   0x47,   // 64
		  0x48,   0x49,   0x4a,   0x4b,   0x4c,   0x4d,   0x4e,   0x4f,
		  0x50,   0x51,   0x52,   0x53,   0x54,   0x55,   0x56,   0x57,   // 80
		  0x58,   0x59,   0x5a,   0x5b,   0x5c,   0x5d,   0x5e,   0x5f,
		  0x60,   0x61,   0x62,   0x63,   0x64,   0x65,   0x66,   0x67,   // 96
		  0x68,   0x69,   0x6a,   0x6b,   0x6c,   0x6d,   0x6e,   0x6f,
		  0x70,   0x71,   0x72,   0x73,   0x74,   0x75,   0x76,   0x77,   // 112
		  0x78,   0x79,   0x7a,   0x7b,   0x7c,   0x7d,   0x7e,   0x7f,
		  0xc7,   0xfc,   0xe9,   0xe2,   0xe4,   0xe0,   0xe5,   0xe7,   // 128
		  0xea,   0xeb,   0xe8,   0xef,   0xee,   0xec,   0xc4,   0xc5,
		  0xc9,   0xe6,   0xc6,   0xf4,   0xf6,   0xf2,   0xfb,   0xf9,   // 144
		  0xff,   0xd6,   0xdc,   0xf8,   0xa3,   0xd8,   0x9e,   0x9f,   
		  0xe1,   0xed,   0xf3,   0xfa,   0xf1,   0xd1,   0xa6,   0xa7,   // 160
		  0xa8, 0x2310,   0xac,   0xbd,   0xbc,   0x69,   0xab,   0xbb,
		0x2591, 0x2592, 0x2593, 0x2502, 0x2524, 0x2561, 0x2562, 0x2556,   // 176
	   0x2555, 0x2563, 0x2551, 0x2557, 0x255d, 0x255c, 0x255b, 0x2510,
		0x2514, 0x2534, 0x252c, 0x251c, 0x2500, 0x253c, 0x255e, 0x255f,   // 192
		0x255a, 0x2554, 0x2569, 0x2566, 0x2560, 0x2550, 0x256c,   0xa4,
		0x2568, 0x2564, 0x2565, 0x2559, 0x2558, 0x20ac, 0x2553, 0x256b,   // 208
		0x256a, 0x2518, 0x250c, 0x2588, 0x2584, 0x258c, 0x2590, 0x2580,
		0x03b1,   0xe1, 0x0393, 0x03c0, 0x03a3, 0x03c3,   0xe6, 0x03c4,   // 224
		  0xe8,   0xe9, 0x03a9, 0x03b4, 0x221e, 0x03a6, 0x03b5,   0xef,
		0x2261,   0xb1, 0x2265, 0x2264, 0x2320,   0xa7,   0xf7, 0x2248,   // 240
        0xb0, 0x2219,   0xb7, 0x221a, 0x2229,   0xb2, 0x25d8,   0x20,
   };
;
   
   ASCIITable()
   {
   }
}
