//
//   $Id: KeyMapDialog.java 1.2 2002/10/16 17:01:48Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
package inet;

import java.awt.event.*;
import java.awt.*;
import java.util.*;

class KeyMapDialog
extends QuickDialog
implements TextListener, FocusListener
{
	class BTextField extends TextField
	{
		BTextField()
		{
			super(20);
			//setEditable(false);
			this.enableEvents(AWTEvent.KEY_EVENT_MASK);
		}

		private int mi = 0;//used between calls as both carrier and keybord-state indicator
		private int keycode;
		private boolean lookForRelease = false;
		protected void processEvent(AWTEvent e)
		{
			if (e instanceof KeyEvent) {
				KeyEvent k = (KeyEvent)e;
				switch(e.getID()) {
				case KeyEvent.KEY_PRESSED:
					mi = k.getModifiers();
					keycode = Emul.getKeyCode(k);
					switch(keycode) {
					case KeyEvent.VK_ALT:
					case KeyEvent.VK_CONTROL:
					case KeyEvent.VK_META:
					case KeyEvent.VK_SHIFT:
						lookForRelease = true;
						key.setText(k.getKeyModifiersText(mi));
						break;
					default:
						lookForRelease = false;
						lookup(mi, keycode);
					}
					break;
				case KeyEvent.KEY_RELEASED:
					if (!lookForRelease)
						break;
					switch(k.getKeyCode()) {
					case KeyEvent.VK_ALT:
					case KeyEvent.VK_CONTROL:
					case KeyEvent.VK_META:
					case KeyEvent.VK_SHIFT:
						lookup(mi, 0);
						lookForRelease = false;
					}
					break;
				}//end case
				setCaretPosition(0);
				k.consume();
			}//end if
		}//end processevent

		String getCodeString()
		{
			return "" + mi + "+" + keycode;
		}
		int getMods()
		{
			return mi;
		}
		int getKey()
		{
			return keycode;
		}

	}

	private BTextField key = new BTextField();
	private java.awt.List list;
	private Button map, ok, clear;
	private TextField mapto = new TextField(30),//enter new assignment
				maptohex = new TextField(30),	//enter new ass. in hex
				current = new TextField(30),	//displays current ass.
				currenthex = new TextField(30); // above in hex
	private String smt = new String(),		//used for effectiveness and to prevent reentrance
					smth = new String();	//above
	private int[] si;	//NB, used as sequence carrier
	private DataBase keymap;
	private String undef = "undef";
	private Object focusOwner;

	KeyMapDialog(Frame ctrl, DataBase keys)
	{
		super(ctrl, keys.getS(DataBase.KeyMap_title));
		keymap = keys;
		adLabel(keys.getS(DataBase.Label_presKey));
		ad(key);
		gridcons.gridwidth = 2;
		adLabel(keys.getS(DataBase.Label_ENVal));
		gridcons.gridwidth = 1;
		gridcons.gridy = 1;
		adLabel(keys.getS(DataBase.Label_curAss));
		ad(current);
		adLabel(keys.getS(DataBase.Label_mapTo));
		ad(mapto);
		gridcons.gridy = 2;
		adLabel(keys.getS(DataBase.Label_mapToH));
		ad(currenthex);
		adLabel(keys.getS(DataBase.Label_mapToH));
		ad(maptohex);
		gridcons.gridy = 3;
		ok = adButton(keys.getS(DataBase.ok));
		clear = adButton(keys.getS(DataBase.clear));
		adLabel(keys.getS(DataBase.Label_func));
		gridcons.gridheight = 2;
		ad(list = new java.awt.List(7, false));
		gridcons.gridheight = 1;
		setgcXY(1, 4);
		map = adButton(keys.getS(DataBase.assign));
		list.addActionListener(this);
//		for (Enumeration en = keys.elements(); en.hasMoreElements(); )
//			list.add((String)en.nextElement());

		mapto.addTextListener(this);
		maptohex.addTextListener(this);
		mapto.addFocusListener(this);
		maptohex.addFocusListener(this);

		map.addActionListener(this);
		mapto.addActionListener(this);
		maptohex.addActionListener(this);
		ok.addActionListener(this);
		clear.addActionListener(this);

		setModal(true);
		current.setEditable(false);
		currenthex.setEditable(false);
		display();
	}

	public void paint(Graphics g)
	{
		super.paint(g);
		key.requestFocus();
		map.setVisible(false);
		clear.setVisible(false);
	}

	private void lookup(int mods, int code)
	{
		key.setText(Constants.getKeyStateString(mods, code));
		if (!map.isVisible() && smt != null && smt.length() > 0)
			map.setVisible(true);
		Entry e = keymap.getKeyMap(code, mods);
		setTextCurrent(e == null ? null : e.firstmap);//get from key-mapping object
	}

	public void actionPerformed(ActionEvent a)
	{
		Object o = a.getSource();
		String s;
		if (o == map || o == mapto || o == maptohex) {
			s = key.getCodeString();
			if (s.length() > 0) {
				keymap.addKey(key.getKey(), key.getMods(), maptohex.getText());
				setTextCurrent(si);
			}
			key.requestFocus();
		}
		else if (o == ok) {
			dispose();
		}
		else if (o == clear) {
			keymap.remove(key.getKey(), key.getMods());
			setTextCurrent(null);
		}
		else if (o == list) {	//insert at field's cursor position
			int[] old = si;
			int[] ins = new int[20];//NBBNBNBNB !!defSeqs.getIntArray(list.getSelectedItem());
			si = new int[old.length + ins.length];
			int br = mapto.getCaretPosition();
			System.arraycopy(old, 0, si, 0, br);
			System.arraycopy(ins, 0, si, br, ins.length);
			System.arraycopy(old, br, si, br + ins.length, old.length - br);
			setText();
		}
	}

    public synchronized void textValueChanged(TextEvent e)
	{
		Object o = e.getSource();
		if (o != focusOwner) return;
		int[] ints = null;
		String s;
		if (o == mapto) {
			if(smt.equals(s = mapto.getText())) return;
			ints = getIntsFromString(s);
		}
		else if (o == maptohex) {
			if(smt.equals(s = maptohex.getText())) return;
			ints = Constants.getIntsFromHexString(s);
		}
		if (ints != null) si = ints;
		setText();
	}

	private void setTextCurrent(int[] ints)
	{
		clear.setVisible (ints != null);
		if (ints == null) {
			current.setText("");
			currenthex.setText("");
		}
		else {
			current.setText(getStringFromInts(ints));
			currenthex.setText(Constants.getHexStringFromInts(ints));
		}
	}

	private void setText()
	{
		String s = getStringFromInts(si);
		int caret;
		if (!smt.equals(s)) {
			caret = mapto.getCaretPosition();
			mapto.setText(smt = s);
			mapto.setCaretPosition(caret);
		}
		s = Constants.getHexStringFromInts(si);
		if (!smth.equals(s)) {
			caret = maptohex.getCaretPosition();
			maptohex.setText(smth = s);
			maptohex.setCaretPosition(caret);
		}
		map.setVisible(smt.length() > 0 && key.getText().length() > 0);
	}

	private int[] getIntsFromString(String s)
	{
		try {
			char[] c = s.toCharArray();
			int[] ret = new int[c.length];
			int co = 0;
			for (int i = 0; i < c.length; i++, co++) {
				if (c[i] == '<') {
					int j = ++i;
					while (c[i] != '>') i++;
					String t = new String(c, j, i - j);
					if (t.equals(undef)) ret[co] = si[co];
					//NBelse ret[co] = getFuncInt(t);
				}
				else ret[co] = c[i];
			}
			int[] ret2 = new int[co];
			System.arraycopy(ret, 0, ret2, 0, co);
			return ret2;
		}
		catch(Exception e) {
			return null;
		}
	}

	private String getStringFromInts(int[] ints)
	{
		StringBuffer tex = new StringBuffer();
		for (int i = 0; i < ints.length; i++) {
			int it = ints[i];
//			if (it < 0x10000) //its a character
				tex.append((char)it);
//			else//its a function
//				tex.append('<').append(getFuncName(it)).append('>');
		}
		return new String(tex);
	}

	public void focusLost(FocusEvent f)
	{
		if (f.getSource() == focusOwner)
			focusOwner = null;
	}

	public void focusGained(FocusEvent f)
	{
		focusOwner = f.getSource();
	}

}
