//
//   $Id: APIINTC.C 1.6 2003/05/27 22:18:04Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* APIINTC.C

   Copyright (c) 2001 Datalight, Inc.
   All Rights Reserved
   Datalight Confidential and Proprietary
   Portions copyright (c) GPvNO 1999-2001

	FTPAPI C interface

	Revision History
	05/27/2003 jmb added function to set passive mode
	06/27/2001 gvn added check for ftp port command and to use it on
	               next ftp open session.
*/
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <alloc.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include "inetdefs.h"
#include "compiler.h"
#include "api.h"
#include "ftpapi.h"
#include "htapic.h"
#include "httftps.h"
#include "ftpfunc.h"

typedef struct {
	unsigned es;
	unsigned dx;
	unsigned cx;
	unsigned bx;
	unsigned ax;
	unsigned di;
	unsigned si;
	unsigned ds;
	unsigned flags;
	unsigned sp;
	unsigned ss;
} API_REG;

/* API interrupt */
void api_inti_c(API_REG *pr)
{
	extern int iPort;

	FTPPar far *pf = (FTPPar far *)MK_FP(pr->bx,pr->cx);
	switch (pr->ax >> 8) {
	case OpenFTPSession:
		pr->ax = OpenFTP(pf);
		break;
	case CloseFTPSession:
		pr->ax = CloseFTP(pf);
		break;
	case SendFTPCommmand:
		pr->ax = SendFTPCom(pf);
		break;
	case GetFTPFile:
		pr->ax = GetFile(pf);
		break;
	case GetFTPDirectory:
		pr->ax = GetDir(pf);
		break;
	case SendFTPFile:
		pr->ax = SendFile(pf);
		break;
	case CheckFTPStatus:
		pr->ax = CheckStatus(pf);
		break;
	case CallResident:
		xstatus(pr->ax);	// status / unload
		pr->ax = 0;
		break;
	case SetFTPType:
		pr->ax = SetType(pf);
      break;
	case SetFTPPort:
		iPort = pf->par4;
		pr->ax = 0;
		break;
	case SetPassiveMode:
		SetPASVMode(pf);
		pr->ax = 0;
		break;
	default:
		pr->ax = FERR_UNKNOWN_CALL;
		break;
	}
}
