//
//   $Id: FTPACLI.C 1.11 2003/09/02 18:25:26Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   FTPCLI.C

   Copyright (c) 2001 Datalight, Inc.
   All Rights Reserved
   Datalight Confidential and Proprietary
   Portions copyright (c) GPvNO 1999-2001

   FTP client code

   Revision History:
	04/23/2003 gvn return Receiving/Sending status
	02/14/2002 jmb IR#3924:
                  allowed 250 to be valid to signal successful transfer
   06/27/2001 gvn modified code to use FTP port variable.
Updated @ Date 27 May 1996, 10:10 by Gerrit van Niekerk
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mem.h>
#include <ctype.h>
#include <alloc.h>
#include <stdarg.h>
#include <process.h>
#include <conio.h>
#include <dos.h>
#include <time.h>
#include "inetdefs.h"
#include "compiler.h"
#include "api.h"
#include "dirutil.h"
#include "ftpapi.h"
#include "htapic.h"
#include "httftps.h"
#include "ftpfunc.h"

// error codes returned
#define	PARAMETER_ERR	1
#define NO_API_			2
#define ABORTED			3
#define XFER_ABORTED	4
#define CANT_WRITE		5
#define CANT_READ		6
#define FTP_ERROR		10	// FTP errors starting at 400

DWORD tick_timer(void);
static void ftpsetup(struct ftp *ftp,int rcv);
void ftp_command(struct ftp *ftp,char *line,int len);
void ftp_delete();
int donothing(int argc,char *argv[]);
void ftp_line(struct ftp *ftp,char *lb);
void kbinit(void);
DWORD Resolve(char *name);
int alloc_name(struct ftp *ftp,char *name);
TCB far *GetTcb(WORD handle);

extern char dis_stop;			/* display stopped flag */
extern int bPassive;
char username[22];
char password[22];

//struct ftp *current_ftp;	// nasty way of passing current ftp pointer

int argcount;
char **argval;
//static char inbuf[200];
//#define BUFSIZE	sizeof(inbuf)			// command buffer size

int error_code;
int iPort = FTP_PORT;
//struct ftp *ftp;
struct ftp *ftp_create();

int OpenFTP(FTPPar far *pf)
{
	char *inet_ntoa();
	struct isocket lsocket,fsocket;
	char buf[100];
	struct ftp *ftp;


	lsocket.dwAddress = 0;
	lsocket.wPort = 0;
	fsocket.wPort = iPort;
	_fstrncpy(buf,pf->par1,80);
	_fstrncpy(username,pf->par2,20);
	_fstrncpy(password,pf->par3,20);
	if((fsocket.dwAddress = Resolve(buf)) == 0){
		return FERR_UNKNOWN_HOST;
	}
	/* Allocate an FTP control block */
	if((ftp = ftp_create()) == NULLFTP){
		return FERR_NO_MEMORY;
	}
	if ((ftp->linebuf = malloc(LNBFLEN)) == 0) {
		ftp_delete(ftp,ftp->id);
		ftp = 0;
		return FERR_NO_MEMORY;
	}
	ftp->state = COMMAND_STATE;
	if (bPassive)
		ftp->flags |= FF_PASV | FF_CLIENT;
	else
		ftp->flags |= FF_CLIENT;
	/* Now open the control connection */
	ftp->control = OpenTcpC(&lsocket,&fsocket,TCP_ACTIVE,0,0,0,0,0,(char *)ftp);
	pf->par5 = (int)ftp;
	pf->par6 = ftp->id;
	return 0;
}

// Get ftp control block, checking for validity
struct ftp *get_ftp(FTPPar far *pf)
{
	struct ftp *ftp;
	int par5 = pf->par5;
	int par6 = pf->par6;

	for (ftp = ftps;ftp;ftp = ftp->next) {
		if (ftp == (struct ftp *)par5 && ftp->id == par6)
			break;
	}
	return ftp;
}

int CloseFTP(FTPPar far *pf)
{
	struct ftp *ftp = get_ftp(pf);
	if (!ftp)
		return FERR_SESSION_CLOSED;
	CloseTcp(ftp->control);
	ftp_delete(ftp,ftp->id);
	return 0;
}

int SendFTPCom(FTPPar far *pf)
{
	struct ftp *ftp = get_ftp(pf);
	if (!ftp)
		return FERR_SESSION_CLOSED;
	Tprintf(ftp->control,"%Fs\r\n",pf->par1);
	return 0;
}

int GetFile(FTPPar far *pf)
{
	char local[42],remote[42];
	char *remotename,*localname;
	struct ftp *ftp = get_ftp(pf);

	if (!ftp)
		return FERR_SESSION_CLOSED;
	if (ftp->state != COMMAND_STATE) {
		return FERR_TRANSFERRING;
	}
	_fstrncpy(remote,pf->par1,40);
	remotename = remote;
	if (pf->par2 && *pf->par2) {
		_fstrncpy(local,pf->par2,40);
		localname = local;
	}
	else
		localname = remote;
	if(ftp->fp != 0)
		fclose(ftp->fp);
	ftp->fp = 0;
	if (strchr(localname,'*') != NULL || strchr(localname,'?') != NULL) {
		if ((ftp->fp = tmpfile()) == NULL) {
			return FERR_CANT_CREATE;
		}
		if (alloc_name(ftp,remotename) == 0) {
			return FERR_NO_MEMORY;
		}
		if (ftp->type == IMAGE_TYPE) {
			Tprintf(ftp->control,"TYPE A\r\n");
			ftp->state = LIST_STATE_WTOK;
		}
		else {
			ftpsetup(ftp,1);
			ftp->state = LIST_STATE_WPOK;
		}
		return 0;
	}
	return startget(ftp,localname,remotename);
}

int GetDir(FTPPar far *pf)
{
	char buf[100];
	struct ftp *ftp = get_ftp(pf);

	if (!ftp)
		return FERR_SESSION_CLOSED;
	if (ftp->state != COMMAND_STATE) {
		return FERR_TRANSFERRING;
	}
	if (pf->par1 == 0 || pf->par2 == 0)
		return FERR_PARAMETER_ERROR;
	_fstrncpy(buf,pf->par1,99);
	if (alloc_name(ftp,buf) == 0) {
		return FERR_NO_MEMORY;
	}
	_fstrncpy(buf,pf->par2,99);
	if(ftp->fp != 0)
		fclose(ftp->fp);
	if((ftp->fp = fopen(buf,"w")) == 0){
		return FERR_FILE_OPEN;
	}
	ftp->state = pf->par4 ? RCVLIST_STATE_WPOK : RCVNLST_STATE_WPOK;
	ftpsetup(ftp,1);
	return 0;
}

int SendFile(FTPPar far *pf)
{
	char remote[42],local[42];
	char *remotename,*localname;
	FILE *dir();
	struct ftp *ftp = get_ftp(pf);

	if (!ftp)
		return FERR_SESSION_CLOSED;
	if (ftp->state != COMMAND_STATE) {
		return FERR_TRANSFERRING;
	}
	_fstrncpy(local,pf->par1,40);
	localname = local;
	if (pf->par2 && *pf->par2) {
		_fstrncpy(remote,pf->par2,40);
		remotename = remote;
	}
	else
		remotename = 0;
	if(ftp->fp != 0)
		fclose(ftp->fp);
	ftp->flags &= ~FF_APPEND;
	if (pf->par4)
		ftp->flags |= FF_APPEND;
	if (strchr(localname,'*') != NULL || strchr(localname,'?') != NULL) {
		if ((ftp->fplist = dir(localname,0)) != NULL) {
			char *p;
			if (ftp->cd)
				free(ftp->cd);
			for (p = localname + strlen(localname) - 1;
							p != localname;--p) {
				ftp->cd = 0;
				if (*p == '\\' || *p == '/' || *p == ':') {
					p[1] = 0;
					ftp->cd = malloc(strlen(localname) + 1);
					if (ftp->cd)
						strcpy(ftp->cd,localname);
					else {
						return FERR_NO_MEMORY;
					}
					break;
				}
			}
			localname = 0;
		}
		else {
			return FERR_DIR_LIST;
		}
	}
	return startput(ftp,localname,remotename);
}

int CheckStatus(FTPPar far *pf)
{
	int stat = 0;
	struct ftp *ftp;

	schedule();
	for (ftp = ftps;ftp;ftp = ftp->next) {
		if (ftp->state == SENDING_STATE)
			stat |= FSTAT_SENDING;
		else if (ftp->state == RECEIVING_STATE)
			stat |= FSTAT_RECEIVING;
		if (ftp->status == 0)
			continue;
		stat = ftp->status;
		ftp->status = 0;
		if ((stat == FSTAT_LINE_RECEIVED ||
			 stat == FSTAT_RX_OK ||
			 stat == FSTAT_TX_OK ||
			 stat == FSTAT_RX_ERR ||
			 stat == FSTAT_TX_ERR) && pf->par1) {
			_fstrcpy(pf->par1,ftp->status_line);
		}
		else if (stat == FERR_SESSION_CLOSED)
			ftp_delete(ftp,ftp->id);
		pf->par5 = (int)ftp;
		pf->par6 = ftp->id;
		return stat;
	}
	return stat;
}

int SetType(FTPPar far *pf)
{
	struct ftp *ftp = get_ftp(pf);

	if (!ftp)
		return FERR_SESSION_CLOSED;
	ftp->type = pf->par4 ? IMAGE_TYPE : ASCII_TYPE;
	Tprintf(ftp->control,"TYPE %c\r\n",pf->par4 ? 'I' : 'A');
	return 0;
}

int SetPASVMode(FTPPar far *pf)
{
	struct ftp *ftp = get_ftp(pf);
   
      
	if (pf->par4)
   {
		bPassive = 1;
   	if (ftp)
         ftp->flags |= FF_PASV;
   }
	else
   {
		bPassive = 0;
	   if (ftp)
         ftp->flags &= ~FF_PASV;
   }
	return 0;
}

void ftp_client(struct ftp *ftp)		// called from schedule()
{
	int cnt,rcnt,iEof;
	char *p;

	if (!ftp->lbindex || memchr(ftp->linebuf,'\n',ftp->lbindex) == 0) {
		while ((cnt = LNBFLEN - ftp->lbindex) == 0)
			ftp->lbindex = 0;		// discard too long line
		if ((rcnt = RecvTcp(ftp->control,ftp->linebuf + ftp->lbindex,cnt,&iEof)) > 0) {
			ftp->lbindex += rcnt;
		}
		else if (iEof || (rcnt && rcnt != -RE_ENTER)) {
			ftp->status = FERR_SESSION_CLOSED;
			CloseTcp(ftp->control);
			return;
		}
		else {
			return;
		}
	}
	if (ftp->lbindex && (p = memchr(ftp->linebuf,'\n',ftp->lbindex)) != 0) {
		if (*(p - 1) == '\r')
			*(p - 1) = 0;
		*p = 0;
		ftp_line(ftp,ftp->linebuf);
		ftp->lbindex -= (p + 1 - ftp->linebuf);
		memcpy(ftp->linebuf, p + 1,ftp->lbindex);
	}
}

char *allocstr(char *str)
{
	char *retstr;

	if ((retstr = malloc(strlen(str) + 1)) != 0)
		strcpy(retstr,str);
	return retstr;
}

int alloc_name(struct ftp *ftp,char *name)
{
	if (ftp->remotename) {
		free(ftp->remotename);
		ftp->remotename = 0;
	}
	if (name && (ftp->remotename = allocstr(name)) == 0) {
		return 0;
	}
	return 1;
}

/* start a get operation */
int startget(struct ftp *ftp,char *locname,char *rname)
{
	char name[52];
	char *p,*lname;

	if(ftp->fp != 0)
		fclose(ftp->fp);
	ftp->fp = 0;
	while (1) {
		if (!locname) {
			if (fgets(lname = rname = name,50,ftp->fplist) != NULL) {
				name[49] = 0;
				if ((p = strchr(name,'\r')) != NULL)
					*p = 0;
				if ((p = strchr(name,'\n')) != NULL)
					*p = 0;
			}
			else {
				fclose(ftp->fplist);
				ftp->fplist = 0;
//				return 1;
				return FERR_FILE_OPEN;
			}
		}
		else
			lname = locname;
		if ((ftp->fp = fopen(lname,"wb")) == 0) {
			error_code = CANT_WRITE;
			if (locname)
//				return 1;
				return FERR_FILE_OPEN;
		}
		else {
//			write_window(1,1,"Received:          ");
			break;
		}
	}
	if (alloc_name(ftp,rname) == 0) {
//		return 1;
		return FERR_NO_MEMORY;
	}
	ftp->state = RECEIVING_STATE_WPOK;
	ftpsetup(ftp,1);
	return 0;
}

/* start a put operation */
int startput(struct ftp *ftp,char *locname,char *rname)
{
	char name[80];
	char *p,*lname;

	if(ftp->fp != 0)
		fclose(ftp->fp);
	ftp->fp = 0;
	while (1) {
		if (!locname) {
			if (ftp->cd) {
				strncpy(name,ftp->cd,60);
				name[60] = 0;
			}
			else
				name[0] = 0;
			rname = name + strlen(name);
			lname = name;
			if (fgets(rname,78 + rname - name,ftp->fplist) != NULL) {
				name[79] = 0;
				if ((p = strchr(rname,'\r')) != NULL)
					*p = 0;
			}
			else {
				fclose(ftp->fplist);
				ftp->fplist = 0;
	 //			return 1;
				return FERR_FILE_OPEN;
			}
		}
		else {
			lname = locname;
			if (!rname) {
				for (rname = lname + strlen(lname) - 1;
					rname != lname;--rname) {
					if (*rname == '\\' || *rname == '/'
							|| *rname == ':') {
						++rname;
						break;
					}
				}
			}
		}
		if ((ftp->fp = fopen(lname,"rb")) == 0) {
			error_code = CANT_READ;
			if (locname)
//				return 1;
				return FERR_FILE_OPEN;
		}
		else {
//			write_window(1,1,"Sent:              ");
			break;
		}
	}
	if (alloc_name(ftp,rname) == 0) {
//		return 1;
		return FERR_NO_MEMORY;
	}
	ftp->state = SENDING_STATE_WPOK;
	ftpsetup(ftp,0);
	return 0;
}

/* Abort a GET or PUT operation in progress. Note: this will leave
 * the partial file on the local or remote system
 */
doabort(struct ftp *ftp)
{
	char wait_typeok = 0;

	/* Close the local file */
	if(ftp->fp != 0)
		fclose(ftp->fp);
	ftp->fp = 0;
	if(ftp->fplist != 0)
		fclose(ftp->fplist);
	ftp->fplist = 0;

	switch(ftp->state){
	case SENDING_STATE:
	case SEND_RDY_STATE:
		/* Send a premature EOF.
		 * Unfortunately we can't just reset the connection
		 * since the remote side might end up waiting forever
		 * for us to send something.
		 */
		CloseTcp(ftp->data);
		break;
	case LISTED_STATE:
		if (ftp->type == IMAGE_TYPE) {
			wait_typeok = 1;
		}
		break;
	case LIST_STATE:
	case LIST_RDY_STATE:
		if (ftp->type == IMAGE_TYPE) {
			wait_typeok = 1;
		}
		/* fall through */
	case RECEIVING_STATE:
	case RECV_RDY_STATE:
		/* Just delete the data channel TCB; this will
		 * generate a RST on the next data packet which will
		 * abort the sender
		 */
		DelTcp(ftp->data);
		ftp->data = 0;
		break;
	}
	if (!error_code)
		error_code = XFER_ABORTED;
	ftp->state = wait_typeok ? COMMAND_STATE_WTOK : COMMAND_STATE;
	return Tprintf(ftp->control,wait_typeok ? "TYPE I\r\n" : "ABOR\r\n");
}

/* create data port, and send PORT message */
static void ftpsetup(struct ftp *ftp,int rcv)
{
	struct isocket lsocket;
	int cnt;
	char bp[35];

	ftp->error = 0;
	lsocket.dwAddress = GetTcb(ftp->control)->conn.sLocal.dwAddress;
	lsocket.wPort = 0;

	ftp->flags &= ~FF_SNDEOF;
	if (!(ftp->flags & FF_PASV)) {
		/* Post a listen on the data connection */
		ftp->data = OpenTcpC(&lsocket,0,TCP_PASSIVE,0,0,0,0,0,(char *)ftp);
		/* Compose and send PORT a,a,a,a,p,p message */
		lsocket.wPort = GetTcb(ftp->data)->conn.sLocal.wPort;
		// lsocket.wPort = 0;//get_tcb(ftp->data)->conn.local.wPort;
		sprintf(bp,"PORT %u,%u,%u,%u,%u,%u\r\n",
			hibyte(hiword(lsocket.dwAddress)),
			lobyte(hiword(lsocket.dwAddress)),
			hibyte(loword(lsocket.dwAddress)),
			lobyte(loword(lsocket.dwAddress)),
			hibyte(lsocket.wPort),
			lobyte(lsocket.wPort));
	}
	else {
		sprintf(bp,"PASV\r\n");
	}
	ftp->mode = rcv;
	cnt = strlen(bp);
	SendTcp(ftp->control,bp,cnt);

	ftp->flags |= FF_WPOK;		/* waiting for port ok */
}

void ftp_line(struct ftp *ftp,char *lb)	/* handle incoming ftp line */
{
	union {
		struct isocket sock;
		char numar[6];
	} fsocket;
	struct isocket lsocket;
	int code,i,num;
	char digitseen = 0;
	char port_ok = 0;
	char fdigit = lb[0];
	char *pcom;

	ftp->status = FSTAT_LINE_RECEIVED;
	strncpy(ftp->status_line,lb,99);
	if (isdigit(lb[0]) && isdigit(lb[1]) && isdigit(lb[2]) &&
					(lb[3] == ' '/* || lb[3] == '-'*/))
		code = atoi(lb);
	else
		code = 0;
	if ((ftp->flags & (FF_PASV | FF_WPOK)) == (FF_PASV | FF_WPOK)) {
		if (fdigit == '5') {	// pasv not working!
			ftp->flags &= ~FF_PASV;
			ftpsetup(ftp,ftp->mode);
			return;
		}
		else if (code == 227) {
			ftp->flags &= ~FF_WPOK;
			port_ok = 1;
			for (pcom = lb + 4,i = 0,num = 0;*pcom && i < 6;++pcom) {
				if (isdigit(*pcom)) {
					digitseen = 1;
					num = num * 10 + *pcom - '0';
				}
				else if (digitseen) {
					if (i < 4)
						fsocket.numar[3 - i++] = num;
					else
						fsocket.numar[9 - i++] = num;
					num = 0;
				}
			}
			lsocket.wPort = 0;
			lsocket.dwAddress = 0l;
			ftp->data = OpenTcpC(&lsocket,&fsocket.sock,TCP_ACTIVE,0,0,0,0,0,
																				(char *)ftp);
		}
	}
	else {
		if (code == 200)
			port_ok = 1;
		ftp->flags &= ~FF_WPOK;
	}
	if (code == 220) {
		Tprintf(ftp->control,"USER %s\r\n",username);
	}
	if (code == 331) {
		Tprintf(ftp->control,"PASS %s\r\n",password);
	}
	if (code >= 400)
		error_code = code - 400 + FTP_ERROR;
	if (code >= 500) {
		if (ftp->remotename) {
			free(ftp->remotename);
			ftp->remotename = 0;
		}
		if (ftp->data) {
			doabort(ftp);
		}
		else
			ftp->state = COMMAND_STATE;
	}
	if (code == 226 || code == 250) {
		switch (ftp->state) {
		case SENDING_STATE:
			ftp->state = SEND_RDY_STATE;
			break;
		case SENT_STATE:
			ftp->state = COMMAND_STATE;
			if (ftp->fplist) {
				if (startput(ftp,0,0) == 0) {
				}
			}
			break;
		case LIST_STATE:
			ftp->state = LIST_RDY_STATE;
			break;
		case LISTED_STATE:
			if (ftp->type == IMAGE_TYPE) {
				Tprintf(ftp->control,"TYPE I\r\n");
				ftp->state = LISTED_STATE_WTOK;
				break;
			}
		case RECEIVED_STATE:
			ftp->state = COMMAND_STATE;
			if (ftp->fplist) {
				if (startget(ftp,0,0) == 0) {
				}
			}
			break;
		case RECEIVING_STATE:
			ftp->state = RECV_RDY_STATE;
			break;
		}
	}
	else switch (ftp->state) {
	case LIST_STATE_WTOK:
		if (code == 200) {
			ftpsetup(ftp,1);
			ftp->state = LIST_STATE_WPOK;
		}
		break;
	case LIST_STATE_WPOK:
		if (port_ok) {
			Tprintf(ftp->control,"NLST %s\r\n",ftp->remotename);
			ftp->state = LIST_STATE;
			goto free_name;
		}
		break;
	case LISTED_STATE_WTOK:
		ftp->state = COMMAND_STATE;
		if (code == 200 && ftp->fplist) {
			if (startget(ftp,0,0) == 0) {
			}
		}
		break;
	case RECEIVING_STATE_WPOK:
		pcom = "RETR";
		goto do_recv;
	case RCVLIST_STATE_WPOK:
		pcom = "LIST";
		goto do_recv;
	case RCVNLST_STATE_WPOK:
		pcom = "NLST";
		do_recv:
		if (port_ok) {
			Tprintf(ftp->control,"%s%s%s\r\n",pcom,
				ftp->remotename ? " " : "",
				ftp->remotename ? ftp->remotename : "");
			ftp->state = RECEIVING_STATE;
			goto free_name;
		}
		break;
	case SENDING_STATE_WPOK:
		if (port_ok) {
			Tprintf(ftp->control,"%s %s\r\n",ftp->flags & FF_APPEND ?
					"APPE" : "STOR",ftp->remotename);
			ftp->state = SENDING_STATE;
			free_name:
			if (ftp->remotename) {
				free(ftp->remotename);
				ftp->remotename = 0;
			}
		}
		break;
	case COMMAND_STATE_WTOK:
		if (code == 200) {
			ftp->state = COMMAND_STATE;
		}
		break;
	case LIST_STATE:
	case LIST_RDY_STATE:
	case LISTED_STATE:
	case RECEIVING_STATE:
		break;
	}
}

/* Send a message on the control channel */
int Tprintf(unsigned tcbo,char *fmt,...)
{
	WORD len;
	va_list ap;
	char dlin [100];

	va_start(ap, fmt);
	len = vsprintf(dlin, fmt, ap);
	va_end(ap);
	SendTcp(tcbo,dlin,len);
	return 0;
}

DWORD Resolve(char *name)
{
	extern int api_int;
	WORD adr[2];
	union REGS r;

	r.x.cx = FP_OFF(name);
	r.x.bx = FP_SEG(name);
	r.h.ah = API_GETIPADR;
	int86(api_int,&r,&r);
	adr[1] = r.x.cx;
	adr[0] = r.x.dx;
	return *(DWORD *)adr;
}
