//
//   $Id: FTPCOM.C 1.10 2003/09/02 18:30:32Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   Portions Copyright (c) 1993-2002 GP van Niekerk Ondernemings
//   Portions Copyright (c) 1986-1989 Phil Karn, KA9Q
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// ftpcom.c
//
// Copyright(C) 2002 Datalight, Inc.
// All Rights Reserved
// Datalight Confidential and Proprietary
// Portions Copyright (c) 1993-2002 GP van Niekerk Ondernemings
// Portions Copyright (c) 1986-1989 Phil Karn, KA9Q
//
// FTP common functions
//
// Revision History
// 04/21/2003 gvn don't let FTPAPI hog the system on data receives
// 02/06/2002 jmb IR#3887:
//                added temporary variable for "min" comparison
// 07/27/2001 gvn removed must_schedule

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <alloc.h>
#include <string.h>
#include <errno.h>
#include "compiler.h"
#include "api.h"
#include <time.h>
#include "htapic.h"
#include "httftps.h"
#ifdef API
#include "ftpapi.h"
#endif

extern char rxok[],txok[],rxerr[],txerr[],noconn[];
void UpcallC(void);

struct ftp *ftps;      // start of ftp chain
struct ftp *ftpe;      // end of ftp chain

/* FTP Data channel Receive upcall handler */
#ifndef API
#pragma argsused
void _loadds far FtpDataReceive(WORD tcbo,WORD cnt)
{
   register struct ftp *ftp;
   TCB far *tcb = (TCB far *)MK_FP(tcbs,tcbo);

   ftp = (struct ftp *)tcb->user;
   ftp->flags |= FF_DAT_RC;
   UpcallC();
}
#endif

void FtpDataReceiveHandler(struct ftp *ftp)
{
   TCB far *tcb;
   int cnt,iEof;

   if (ftp->data == 0)
      return;   // ???
   tcb = (TCB far *)MK_FP(tcbs,ftp->data);
   if (ftp->state != RECEIVING_STATE) 
   {
//      if (tcb->state == FINWAIT2)
//         reset_tcp(FP_OFF(tcb));   /* shut him up for good */
		return;
	}
	while ((cnt = RecvTcp(FP_OFF(tcb),ftp->dbuf,DBUFSZ,&iEof)) > 0)
	{
		if (ftp->fp && fwrite(ftp->dbuf,1,cnt,ftp->fp) != cnt)
		{
			ftp->error = errno;
			goto close_it;
		}
#ifdef API
		cnt = 0;
		break;		// don't hog the system
#endif
	}
	if (iEof || (cnt && cnt != -RE_ENTER))
	{
		close_it:
		CloseTcp(ftp->data);
		ftp->data = 0;
#ifdef API
		if (ftp->state == RECEIVING_STATE || ftp->state == RECV_RDY_STATE)
		{
			// End of file received on incoming file
			fclose(ftp->fp);
			ftp->fp = 0;
			if (!(ftp->flags & FF_CLIENT))
			{
				// server done
				if (tcb->reason != R_NORMAL)
					ftp->error = -1;
				if (ftp->error) {
					if (ftp->error != -1)
					{
						Tprintf(ftp->control,rxerr);
					}
					else
					{
						// Data connection was reset, complain about it
						Tprintf(ftp->control,noconn);
					}
					ftp->status = FSTAT_RX_ERR;
					ftp->error = 0;
				}
				else
				{
					Tprintf(ftp->control,rxok);
					ftp->status = FSTAT_RX_OK;
				}
				//strncpy(ftp->status_line,ftp->filename,99);
				ftp->state = COMMAND_STATE;
			}
			else if (ftp->state == RECV_RDY_STATE)
			{
				goto rcvok;
			}
			else
			{
				ftp->state = RECEIVED_STATE;
			}
		}
		else if (ftp->state == LIST_STATE || ftp->state == LIST_RDY_STATE)
		{
			rewind(ftp->fplist = ftp->fp);
			ftp->fp = 0;
			if (ftp->state == LIST_RDY_STATE)
			{
				if (ftp->type == IMAGE_TYPE)
					Tprintf(ftp->control,"TYPE I\r\n");
				rcvok:
				ftp->state = COMMAND_STATE;
				if (ftp->fplist) {
					startget(ftp,0,0);
				}
			}
			else
				ftp->state = LISTED_STATE;
		}
#endif
	}
}

#ifndef API
/* FTP Data channel Transmit upcall handler */
#pragma argsused
void _loadds far FtpDataTransmit(WORD tcbo,WORD cnt)
{
   struct ftp *ftp;
   TCB far *tcb = (TCB far *)MK_FP(tcbs,tcbo);

   ftp = (struct ftp *)tcb->user;
   ftp->flags |= FF_DAT_SN;
   UpcallC();
}

void FtpDataTransmitHandler(struct ftp *ftp)
{
   int eof_flag;
   TCB far *tcb;
   int cnt;
   int nTmpXferSize;

   if (ftp->data == 0)
      return;   // ???
   tcb = (TCB far *)MK_FP(tcbs,ftp->data);

   if (ftp->state != SENDING_STATE || ftp->fp == 0) 
   {
      return;
   }

   eof_flag = 0;
   nTmpXferSize = tcb->window - tcb->sndcnt;

   while ((cnt = min(DBUFSZ, nTmpXferSize)) != 0 && !eof_flag) 
   {
      if (cnt > DBUFSZ)
         cnt = DBUFSZ;
      ftp->dcnt = fread(ftp->dbuf,1,cnt,ftp->fp);
      if (ftp->dcnt != cnt)
         eof_flag = 1;
      if (ftp->dcnt > 0) 
      {
         if (ftp->type == ASCII_TYPE) 
         {
            char *p;
            if ((p = memchr(ftp->dbuf,CTLZ,ftp->dcnt)) != 0) 
            {
               ftp->dcnt = p - ftp->dbuf;
               eof_flag = 1;
            }
         }
         if (SendTcp(FP_OFF(tcb),ftp->dbuf,ftp->dcnt) < 0)
            // to be fixed! What if EOF and can't send ? See RFTP
            break;
      }
      nTmpXferSize = tcb->window - tcb->sndcnt;
   }
   if (eof_flag) 
   {      // EOF seen
      if (ferror(ftp->fp) != 0)
         ftp->error = errno;
      fclose(ftp->fp);
      ftp->fp = NULL;
      CloseTcp(FP_OFF(tcb));
   }
}
#else      // this part for API
/* FTP Data channel Transmit upcall handler */
void FtpDataTransmitHandler(struct ftp *ftp)
{
   TCB far *tcb;
   int cnt;
   int nTmpXferSize;

   if (ftp->data == 0)
      return;   // ???
   tcb = (TCB far *)MK_FP(tcbs,ftp->data);

   if ((ftp->state != SENDING_STATE && ftp->state != SEND_RDY_STATE) || ftp->fp == 0) {
      return;
   }
   if ((cnt = RecvTcp(ftp->data,0,0,0)) != 0) {
      goto tcp_error;
   }
   if (tcb->state >= LISTEN && tcb->state < ESTABLISHED)
      return;
   if (!ftp->dcnt && !(ftp->flags & FF_SNDEOF)) 
   {
      nTmpXferSize = tcb->window - tcb->sndcnt;
      if ((cnt = min(DBUFSZ,nTmpXferSize)) != 0) 
      {
         if (cnt > DBUFSZ)
         {
            printf("***** cnt(%d) exceeds DBUFSZ (%d)\n", cnt, DBUFSZ);
            cnt = DBUFSZ;
         }
         ftp->dcnt = fread(ftp->dbuf,1,cnt,ftp->fp);
         ftp->dbufc = ftp->dbuf;
         if (ftp->dcnt != cnt)
            ftp->flags |= FF_SNDEOF;
         if (ftp->dcnt > 0) 
         {
            if (ftp->type == ASCII_TYPE) 
            {
               char *p;
               if ((p = memchr(ftp->dbuf,CTLZ,ftp->dcnt)) != 0) 
               {
                  ftp->dcnt = p - ftp->dbuf;
                  ftp->flags |= FF_SNDEOF;
               }
            }
         }
      }
   }
   while (ftp->dcnt) 
   {
      if ((cnt = SendTcp(FP_OFF(tcb),ftp->dbufc,ftp->dcnt)) < 0) 
      {
         if (cnt == -NO_SPACE || cnt == -WOULDBLK || cnt == -RE_ENTER)
            return;      // try again later
         tcp_error:
         ftp->error = -1;
         goto close;
      }
      ftp->dcnt -= cnt;
      ftp->dbufc += cnt;
   }
   if (ftp->flags & FF_SNDEOF) 
   {      // EOF seen
      if (ferror(ftp->fp) != 0)
         ftp->error = errno;
      close:
      fclose(ftp->fp);
      ftp->fp = NULL;
      CloseTcp(FP_OFF(tcb));
      ftp->data = 0;
      if (!(ftp->flags & FF_CLIENT)) 
      {
         // server done
         if (ftp->error) 
         {
            if (ftp->error != -1) 
            {
               Tprintf(ftp->control,txerr);
            }
            else if (tcb->reason != R_NORMAL) 
            {
               // Data connection was reset, complain about it
               Tprintf(ftp->control,noconn);
            }
            ftp->status = FSTAT_TX_ERR;
            ftp->error = 0;
         }
         else 
         {
            Tprintf(ftp->control,txok);
            ftp->status = FSTAT_TX_OK;
         }
         //strncpy(ftp->status_line,ftp->filename,99);
         ftp->state = COMMAND_STATE;
      }
      else 
      {
         ftp->state = SENT_STATE;
      }
   }
}
#endif

/* Allocate an FTP control block */
struct ftp *ftp_create()
{
   register struct ftp *ftp;
   static int id;

   if((ftp = (struct ftp *)calloc(1,sizeof (struct ftp))) == NULLFTP)
      return NULLFTP;
   if ((ftp->buf = malloc(CBUFSZ)) == 0) 
   {
      free(ftp);
      return NULLFTP;
   }
   if ((ftp->dbuf = malloc(DBUFSZ)) == 0) 
   {
      free(ftp->buf);
      free(ftp);
      return NULLFTP;
   }
   if (ftpe) 
   {
      ftp->prev = ftpe;
      ftpe->next = ftp;
      ftpe = ftp;
   }
   else
      ftpe = ftps = ftp;
   ftp->state = COMMAND_STATE;
   ftp->id = ++id;
   ftp->type = ASCII_TYPE;   /* Default transfer type */
   return ftp;
}

/* Free resources, delete control block */
void ftp_delete(register struct ftp *ftp,int id)
{
   struct ftp *ftp1;

   for (ftp1 = ftps;ftp1;ftp1 = ftp1->next) 
   {
      if (ftp == ftp1 && ftp->id == id)
         goto found;
   }
   return;      // does not exist!
   found:
   CloseTcp(ftp->control);
   DelTcp(ftp->control);
   if (ftp->fp != NULL)
      fclose(ftp->fp);
   if (ftp->data != 0) 
   {
      CloseTcp(ftp->data);
      DelTcp(ftp->data);
   }
   if (ftp->username != NULL)
      free(ftp->username);
   if (ftp->path != NULL)
      free(ftp->path);
   if (ftp->buf != NULL)
      free(ftp->buf);
   if (ftp->dbuf != NULL)
      free(ftp->dbuf);
   if (ftp->cd != NULL)
      free(ftp->cd);
   if (ftp->oldname != NULL)
      free(ftp->oldname);
   if (ftp->remotename != NULL)
      free(ftp->remotename);
#ifdef API
   if (ftp->linebuf != NULL)
      free(ftp->linebuf);
#endif
   if (ftp->next)
      ftp->next->prev = ftp->prev;
   else
      ftpe = ftp->prev;
   if (ftp->prev)
      ftp->prev->next = ftp->next;
   else
      ftps = ftp->next;
   free((char *)ftp);
}
