//
//   $Id: HTAPIC.C 1.5 2003/05/19 17:54:28Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   HTAPIC.C

   Copyright (C) 2001 Datalight, Inc.
   All Rights Reserved
   Datalight Confidential and Proprietary
   Portions Copyright (c) GP van Niekerk Ondernemings 1990-2000

   HTTPD API functions

   Revision History
   07/20/2001 gvn corrected typo's
*/
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <alloc.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <sys\stat.h>
#include <share.h>
#include "dostruct.h"	//  DOS structures
#include "dosdef.h"
#include "datalght.h"
#include "dldosio.h" 	//  some int 21h (DOS)
#include "dllfn.h"  		//  LFN and LFN "smart" functions
#include "compiler.h"
#include "api.h"
#include <time.h>
#include "htapic.h"
#include "httftps.h"

typedef struct {
	unsigned es;
	unsigned dx;
	unsigned cx;
	unsigned bx;
	unsigned ax;
	unsigned di;
	unsigned si;
	unsigned ds;
	unsigned flags;
	unsigned sp;
	unsigned ss;
} API_REG;


static CGI_USER *psCgiList;	//first entry in LL of registered users

//find a cgi user based on szName. Return 0 if not found
CGI_USER *FindCGIUser(char far *szName)
{
	CGI_USER *psUser = psCgiList;
	while (psUser) {
		if (!_fstricmp(szName, psUser->szName))
			return psUser;//this one already exists
		psUser = psUser->psNext;
	}
	return 0;
}

/*
 * register a user for handling a cgi routine
 * arguments:
 * szName -The name on which to react. eg. if the URI is
 *  "www.server.com/cgi-bin/pageGenerator.exe?name=gv"
 * 	then the name is "pageGenerator.exe\0"
 * pfCallback -The function to call when named cgi request is encountered

 * return: error code
 * 	0 	all OK
 * 	-1	no memory
 * 	-2	name already exists
 */
static int RegisterCgiUser(API_REG *pr)
//char* szName, void (far *pfCallback)(unsigned, char*))
{
	char far *szName = MK_FP(pr->ds, pr->si);
	int (far *pfCallback)(HTTP_PARAMS far*) = MK_FP(pr->es, pr->di);
	CGI_USER *psUser;
	int iLength = _fstrlen(szName);

	//see if a callback with this name already exists
	if (FindCGIUser(szName))
		return -ERR_DUPL;//this one already exists

	__asm pushf;
	disable();
	if ((psUser = calloc(1, sizeof(CGI_USER))) != 0) {
		if ((psUser->szName = malloc(iLength + 1)) == 0)
			free(psUser);
	}
	__asm popf;
	if (!psUser)
		return -NO_SPACE;	//no memory

	//fill structure
	_fstrcpy(psUser->szName, szName);
	psUser->pfFunc = pfCallback;
	psUser->dwUserID = (DWORD)MK_FP(pr->cx, pr->dx);
	psUser->iFlags = pr->bx;
	psUser->cInuse = 0;

	//add this one to beginning of list (doesnt matter, just easier)
	psUser->psNext = psCgiList;
	psCgiList = psUser;

	return 0;
		/*
		Assembler level:
		AH = 0
		szName: 	DS:SI
		pfCallback: 	ES:DI
		iFlags:		BX
		dwUserID:	CX:DX

		Return in AX register.
		return values:
		0 - not done
		1 - done, ok
		-1 - done, error

		*/
}

/*Assembler level:
	deregister
	AH = 1
	pszPath: 	DS:SI
	Return in AX register.
	return:	0 - ok
		2 - not registered
*/
static int DeRegister(API_REG *pr)
{
	CGI_USER *psUser = psCgiList;
	CGI_USER *psPrev = 0;
	char far *szName = MK_FP(pr->ds, pr->si);
	while (psUser) {
		if (!_fstricmp(szName, psUser->szName))
			break;
		psPrev = psUser;
		psUser = psUser->psNext;
	}
	if (!psUser)
		return -NO_USER;

	__asm pushf;
	disable();

	if (!psPrev)//first in list
		psCgiList = psUser->psNext;
	else
		psPrev->psNext = psUser->psNext;

	free(psUser->szName);
	free(psUser);
	__asm popf;
	return 0;
}

//verify if this one is in list and valid
// return 1 if valid, 0 if not valid
static int VerifyHTTP(HTTP* psHTTP)
{
	HTTP *psFind;
	//check for validity
	for(psFind = HTTPfirst; psFind; psFind = psFind->next) {
		if (psFind == psHTTP) //found
			break;
	}
	if (!psFind || psFind->id != psHTTP->id)//error
		return 0;
	return 1;
}
/* Get data for this socket
 *
 *		Assembler level:
 *		AH = 2
 *		iHandle:		BX
 *		pcBuf: 		DS:SI
 *		iCount:		CX
 *
 *		Return in AX register.
 *		return: 	>=0 bytes received
 *			-1 error; peer closed connection
 *			-2 error; connection does not exist
 *			-3 network error
 */
static int GetData(API_REG *pr)
{
	int iEof = 0;
	int iRet = 0;
	int iRcvd = 0;
	HTTP *psHTTP = (HTTP *)pr->bx;
	char far *pBuf = MK_FP(pr->ds, pr->si);
	unsigned iSize = pr->cx;

	if (!VerifyHTTP(psHTTP))//check for validity
		return -INVALID;

	//check if buffered data available
	if (psHTTP->cnt) {
		if(iSize <= psHTTP->cnt) {//only copy data (dont read)
			_fmemcpy(pBuf, psHTTP->buf, iSize);
			psHTTP->cnt -= iSize;
			memmove(psHTTP->buf, psHTTP->buf + iSize, iSize);
			psHTTP->iDataRead += iSize;
			return iSize;
		}
		//else copy whole buffer
		_fmemcpy(pBuf, psHTTP->buf, psHTTP->cnt);
		iRcvd = psHTTP->cnt;
		psHTTP->cnt = 0;
		iSize -= iRcvd;
		pBuf += iRcvd;
	}
	//direct calls - if errors: tough luck, return error message
	iRet = RecvTcp(psHTTP->tcbo, pBuf, iSize, &iEof);
	//NB use iEof
	if (iRet >= 0) {
		iRet += iRcvd;
		psHTTP->iDataRead += iRet;
	}
	if (iRet == 0 && !iEof) {
		//dont call user again
		psHTTP->iDataRead = 0;
		return -WOULDBLK;
	}
	return iRet;
}

/*
 * Send data
 *
 *		Assembler level:
 *		AH = 3
 *		iHandle:		BX
 *		pcBuf: 		DS:SI
 *		iCount:		CX
 *
 *		Return in AX register.
 *		return: 	>= 0 number of bytes actually sent
 *			-1 error
 *			-2 con doesnt exist
 */
static int SendData(API_REG *pr)
{
	HTTP *psHTTP = (HTTP *)pr->bx;
	if (!VerifyHTTP(psHTTP))//check for validity
		return -INVALID;
	return SendTcph(psHTTP->tcbo, MK_FP(pr->ds, pr->si), pr->cx);
}

/*
 * Send a file on a connection
 * NOTE: DOS MUST be stable, no tests are performed to verify stability
 *
 * Assembler level:
 * AH = 4
 * iHandle:		BX
 * pszFileName: 	DS:SI
 *
 * Return in AX register.
 * return:  	0 	ok
 * 	-1 	error
 */
static int SendFile(API_REG *pr)
{
	char szFilename[260];//shouldnt be longer
	char szShortPath[260], *pszShortPath;
	HTTP *psHTTP = (HTTP *)pr->bx;

	if (!VerifyHTTP(psHTTP))//check for validity
		return -INVALID;
	//printf("Http trying to open %s\n",szFilename);
	_fstrcpy(szFilename, MK_FP(pr->ds, pr->si));
	if (SmartExpandPath(FULLPATH_SHORTNAME, szFilename, szShortPath))
		pszShortPath = szShortPath;
	else
		pszShortPath = szFilename;
	if ((psHTTP->fp = _fsopen(pszShortPath,"rb",SH_DENYWR)) == NULL)
		return -BADFILENAME;//cant open file
	return 0;
}

int GetVersion(void)
{
	extern int hVersion;

	return hVersion;
}

int GetConnections(void)
{
	static int iCalled = 0;
	int iXferStat;
	void resident_psp(void);
	void interrupted_psp(void);
	HTTP *ph;

	if (iCalled > 0)//do not reenter
		return -1;
	iCalled++;
	if (IsPassive()) { //running passive mode
		resident_psp();			/* swap psps                   */
		schedule();
		interrupted_psp();		/* reset interrupted psp       */
	}
	iCalled--;

	iXferStat = 0;
	disable();			// don't get interrupted
	for (ph = HTTPfirst;ph;ph = ph->next)
	{
		if (ph->fp)
			iXferStat |= (ph->request == RQ_GET) ?
								RETS_SENDING : RETS_RECEIVING;
	}
	enable();

	return iNumcon | iXferStat;
}


/* API interrupt */
void api_inti_c(API_REG *pr)
{
	switch (pr->ax >> 8) {
	case APIF_REGISTER:
		pr->ax = RegisterCgiUser(pr);
		break;
	case APIF_DEREGISTER:
		pr->ax = DeRegister(pr);
		break;
	case APIF_GETDATA:
		pr->ax = GetData(pr);
		break;
	case APIF_SENDDATA:
		pr->ax = SendData(pr);
		break;
	case APIF_SENDFILE:
		pr->ax = SendFile(pr);
		break;
	case APIF_GETVERSION:
		pr->ax = GetVersion();
		break;
	case APIF_GETSTATUS:
		pr->ax = GetConnections();
		break;
	default:
		pr->ax = -NO_API;
	}
}

/*
 * Function called by http server when cgi event occurs. DOS is stable,
 * interrupts is on
 *
 * psHTTP - the connection
 * cType - one of R_NEWREQ, R_INDATA, R_OUTDATA, R_ENDDATA, R_CLOSED
 * szReqLine - the request line if cType is R_NEWREQ
 * iCount - number of bytes when cType either R_INDATA or R_OUTDATA
 *
 *	return: -1 if psHTTP deleted, 0 otherwise
 *
 */
int ApiCgi(HTTP* psHTTP, char cType, char *szReqLine, int iCount)
{
	//int iRet;
	HTTP_PARAMS sHP;
	CGI_USER *psUser;
	CGI_USER *psFind;
	extern unsigned apistk;
	unsigned iSaveApistk;
	int iRet;
	//int iRet;

	//printf("HTTP Got cgi call\n");
	//already assigned
	psUser = psHTTP->pCgiUser;
	if(!psUser)//some kind of internal server error
		return 0;

	//printf("About to verify\n");
	//verify user (may have been deregistered recently)
	for (psFind = psCgiList; psFind; psFind = psFind->psNext) {
		if (psFind == psUser)
			break;
	}
	if (!psFind) {
		Tprintf(psHTTP->tcbo,"HTTP/1.0 503 Service Unavailable\r\n\r\n"
			"<HTML><H1>This service recently became unavailable</H1></HTML>");
		http_delete(psHTTP);
		return -1;
	}
	//printf("Found user\n");

	if (cType == R_NEWREQ && (psUser->iFlags & F_OVERLAP) == 0) {
		if (psUser->cInuse) {
			//give server busy
			Tprintf(psHTTP->tcbo,"HTTP/1.0 503 Service Unavailable\r\n\r\n"
				"<HTML><H1>This service is currently in use - please try again later</H1></HTML>");
			http_delete(psHTTP);
			return -1;
		}
		psUser->cInuse = 1;
	}

	if (cType == R_INDATA) {
		if (psHTTP->cnt > 0)
			iCount += psHTTP->cnt;
		psHTTP->iDataRead = 0;
	}
	//fill in everything and call function
again:
	sHP.iReason = cType;
	sHP.iHandle = (int)psHTTP;
	sHP.dwUserID = psUser->dwUserID;
	sHP.lContentLen = psHTTP->content_len;
	sHP.szQuery = szReqLine;
	sHP.dwSessionID = psHTTP->dwSessionID;
	sHP.iValue = cType == R_NEWREQ ? psHTTP->request : iCount;
	sHP.ppEnv = psHTTP->ppEnv;		//the environment (headers, ip address, etc)
	sHP.iEnvSize = psHTTP->iEnvSize;     //number of entries in environment


	//call application
	iSaveApistk = apistk;
	apistk = _SP - 0x100;
	iRet = (*psUser->pfFunc)(&sHP);
	apistk = iSaveApistk;
	switch(iRet) {
	case RET_ERR://error
		Tprintf(psHTTP->tcbo,"HTTP/1.0 500 CGI Error\r\n\r\n"
			"<HTML><H1>A CGI error occurred while processing your request</H1></HTML>");
		//fall thru
	case RET_DONE://done
		psUser->cInuse = 0;
		http_delete(psHTTP);
		return -1;
	case RET_OK:
		psHTTP->dwSessionID = sHP.dwSessionID;
		if (cType == R_INDATA && psHTTP->iDataRead > 0
		 && psHTTP->iDataRead < iCount) {
			//keep on giving read upcalls until all data read
			iCount -= psHTTP->iDataRead;
			goto again;
		}
		break;
	}
	return 0;
}

/*
 * Go thru list and deregister all users.
 */
void UnloadCgiApi(void)
{
	CGI_USER *next;
	while(psCgiList) {
		free (psCgiList->szName);
		next = psCgiList->psNext;
		free (psCgiList);
		psCgiList = next;
	}
}
