#
#   $Id: FTPAPI.MAK 1.4 2002/10/16 21:28:34Z peterb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# FTPAPI.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 07/10/2001 jmb changed library order
# 06/21/2001 jmb added cleanall target
# 04/10/2001 jmb Ported from a Borland C++ Generated makefile
#
.AUTODEPEND


#
# Borland C++ tools
#
CC    = Bcc
TLINK = TLink
TASM  = Tasm

all : ftpapi
	@if exist ..\ftpapi.exe del ..\ftpapi.exe >nul
	@copy ftpapi.exe ..\ftpapi.exe >nul

clean:
	@echo Cleaning FTPAPI
	@if exist *.cfg del *.cfg >nul
	@if exist *.map del *.map >nul
	@if exist *.obj del *.obj >nul

cleanall: clean
	@if exist *.exe del *.exe >nul


#
# Options
#
LFLAGS = $(RD_SW_L) -s -c -Tde
CFLAGS = $(RD_SW) -I..\..\include;..\..\..\include -DPRODUCT=P_FtpServer;DL;API;
STARTUP = c0s.obj
LIBS    = noehs.lib+cs.lib+..\..\..\lib\dls.lib

#
# Dependency List
#
ftpapi : ftpapi.cfg ftpapi.exe

FTPAPI_OBJS = \
   ftpapi.obj\
   ftpacli.obj\
   ftpss.obj\
   ftpcom.obj\
   apiintc.obj\
   apiint.obj\
   pathname.obj\
   dirutil.obj\
   ftpres.obj\
   getch.obj\
   lfnopen.obj\

ftpapi.exe : $(FTPAPI_OBJS)
  $(TLINK)   $(LFLAGS) @&&|
	$(STARTUP)+
	ftpapi.obj+
	ftpacli.obj+
	ftpss.obj+
	ftpcom.obj+
	apiintc.obj+
	apiint.obj+
	pathname.obj+
	dirutil.obj+
	ftpres.obj+
	getch.obj+
	lfnopen.obj
	$<,$*
	$(LIBS)
|



#
# Implicit Rules
#
.c.obj:
	$(CC) -P- -c @ftpapi.cfg @&&|
		$(CFLAGS) $*.c
|

.asm.obj:
	$(TASM) /ml $<, $@

ftpapi.obj   :  ftpapi.c
ftpacli.obj  :  ..\..\server\source\ftpacli.c
ftpss.obj    :  ..\..\server\source\ftpss.c
ftpcom.obj   :  ..\..\server\source\ftpcom.c
apiintc.obj  :  ..\..\server\source\apiintc.c
apiint.obj   :  ..\..\server\source\apiint.asm
pathname.obj :  ..\..\server\source\pathname.c
dirutil.obj  :  ..\..\server\source\dirutil.c
ftpres.obj   :  ..\..\server\source\ftpres.c
getch.obj    :  ..\..\server\source\getch.c
lfnopen.obj  :  ..\..\server\source\lfnopen.c

# Compiler configuration file
ftpapi.cfg :
	Copy &&|
-W-
-w
-vi
-H
-H=ftpapi.csm
-R-
-K
-C
-i32
-O
-Og
-Oe
-Om
-Ov
-Ol
-Ob
-Op
-Oi
-Z
-k-
-vi-
-ms
-f-
-x-
-xp-
-xd-
-xc-
-xf-
-RT-
-1-
-H-
| $@


