//
//   $Id: SCONFIG.C 1.6 2003/07/23 17:11:55Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// SCONFIG.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Sockets Configuration Utility.
//
// Revision History
// 12/18/2001 pb  added a portion to allow the user to
//                configure SOCKETS as a print server.
// 04/30/2001 jmb displayed Datalight copyright message.
// 04/30/2001 jmb created header
//
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include "sconfig.h"
#include "question.h"
#include "sconfig.pt"

#define BANNER	"Sockets/DOS Configuration Utility 1.0(dt)\n"


void main( void )
{
	PQUESTION	pQuestion = &qFirst;
	POPTION		pSelection;

	fprintf( stderr, BANNER );
	printf("Copyright (C) 1999-2001 Datalight, Inc.\nAll Rights Reserved\n"
	       "Portions copyright (c) GPvNO 2003\n\n");

	// ask questions until we're at a terminal selection
	while( pQuestion )
	{
		// ask this question
		pSelection = Ask( pQuestion );
		if( pSelection == NULL )
			ErrorExit( "Invalid response" );

		// get the next question
		pQuestion = pSelection->pqNext;
	}
	if( !pSelection->pvfHandler )
		ErrorExit( "Invalid terminal option" );

	// okay, we've reached a terminal option, call the
	// appropriate configuration function
	pSelection->pvfHandler();

	// Ask the user about print server usage
	//
	AskPrintServer();

	// print success message
	printf( "\n\nSuccessfully created Sockets/DOS configuration file(s)\n" );

	return;
}

void ErrorExit( char* pszMessage )
{
	fprintf( stderr, "ABORT: %s\n", pszMessage );
	exit( 1 );
}

POPTION Ask( PQUESTION pQuestion )
{
	POPTION*	ppOptions = pQuestion->ppOptions;
	int		nMax, nSelection=0;

	// loop until the user "gets it"
	while( nSelection == 0 )
	{
		// clear the screen
		clrscr();

		// first ask the question
		printf( "%s\n", pQuestion->szText );

		// now present the options
		for( nMax = 0; ppOptions[nMax] != NULL; nMax++ )
			printf( " [%d] %s\n", nMax+1, ppOptions[nMax]->szText );

		printf( "\nPlease make a selection from 1 to %d: ", nMax );
		scanf( "%d", &nSelection );

		// validate the option
		if( (nSelection < 1) || (nSelection > nMax) )
			nSelection = 0;
	}

	// return the option selected
	return ppOptions[nSelection-1];
}


void FuncAbort( void )
{
	// just exit nicely
	return;
}

void FuncPPP( void )
{
	char		chPhone[80], chUser[80], chPassword[80];
	char		chDNS1[20], chDNS2[20];
	char		chInitString[200];
	long		lSpeed;
	int		iPort, iIRQ;
	POPTION	poptPort, poptSpeed;
	FILE*	fp;

	poptPort = Ask( &qPort );
	if( !poptPort )
		ErrorExit( "Invalid response for PPP port" );
	switch( poptPort->szText[3] )
	{
		case '1':
			iPort = 0x03f8;
			iIRQ = 4;
			break;
		case '2':
			iPort = 0x02f8;
			iIRQ = 3;
			break;
		case '3':
			iPort = 0x03e8;
			iIRQ = 4;
			break;
		case '4':
			iPort = 0x02e8;
			iIRQ = 3;
			break;
		case 't':
			printf( "\nEnter serial port base address (hex digits): " );
			scanf( "%x", &iPort );
			printf( "\nEnter serial port IRQ (decimal digits): " );
			scanf( "%d", &iIRQ );
			break;
		default:
			ErrorExit( "Invalid port for PPP" );
	}

	poptSpeed = Ask( &qSpeed );
	if( !poptSpeed )
		ErrorExit( "Invalid response for PPP speed" );
	lSpeed = atol( poptSpeed->szText );

	// get user name, password and phone number
	printf( "\nEnter modem initialization string: " );
	scanf( "%s", chInitString );
	printf( "Enter phone number to dial: " );
	scanf( "%s", chPhone );
	printf( "Enter PPP user name: " );
	scanf( "%s", chUser );
	printf( "Enter PPP password: " );
	scanf( "%s", chPassword );
	printf( "Please enter the primary DNS address, or 0 to skip: " );
	scanf( "%s", chDNS1 );
	printf( "Please enter the secondary DNS address, or 0 to skip: " );
	scanf( "%s", chDNS2 );

	// got everything, dump the config file!
	fp = fopen( "socket.cfg", "wt" );
	if( !fp )
		ErrorExit( "Error opening SOCKET.CFG for write" );

	// main PPP section
	fprintf( fp, "# Configure PPP for %s at %s baud\n",
			poptPort->szText, poptSpeed->szText );
	fprintf( fp, "interface asy p0 ppp 1500 30 0x%x %d %ld modem.mcf\n",
			iPort, iIRQ, lSpeed );
	fprintf( fp, "route add default p0\n" );
	if( atoi( chDNS1 ))
		fprintf( fp, "domain server %s\n", chDNS1 );
	if( atoi( chDNS2 ))
		fprintf( fp, "domain server %s\n", chDNS2 );

	// TCP options
	fprintf( fp, "\n# The following lines set TCP parameters\n" );
	fprintf( fp, "ip ttl 64\n" );
	fprintf( fp, "tcp mss 1460\n" );
	fprintf( fp, "tcp window 2920\n\n" );

	// PPP options
	fprintf( fp, "# PPP parameters\n" );
	fprintf( fp, "par p0 ipcp local compress tcp 16 1\n" );
	fprintf( fp, "par p0 ipcp local address 0.0.0.0\n" );
	fprintf( fp, "par p0 lcp local accm 0\n" );
	fprintf( fp, "par p0 lcp local acfc on\n" );
	fprintf( fp, "par p0 lcp local pfc on\n" );
	fprintf( fp, "par p0 lcp local magic on\n\n" );

	// login options
	fprintf( fp, "# PPP login \"%s\" with password \"%s\"\n", chUser, chPassword );
	fprintf( fp, "par p0 pap user %s %s\n", chUser, chPassword  );
	fprintf( fp, "par p0 ipcp open\n" );
	fprintf( fp, "par p0 lcp open\n" );

	fclose( fp );

	fp = fopen( "modem.mcf", "wt" );
	if( !fp )
		ErrorExit( "Error opening MODEM.MCF for write" );

	fprintf( fp, "# Init Modem\n" );
	fprintf( fp, "i A@w100%s^M^J@w100\n\n", chInitString );
	fprintf( fp, "# Dial String\n" );
	fprintf( fp, "d ^M^J@w2000ATDT@n^M^J@d40000\n\n" );
	fprintf( fp, "# Number to dial\n" );
	fprintf( fp, "n %s\n\n", chPhone );
	fprintf( fp, "# Number of retries\n" );
	fprintf( fp, "r 3\n\n" );
	fprintf( fp, "# Debugging (remove next # to enable)\n" );
	fprintf( fp, "#p rx\n" );

	fclose( fp );
}

void FuncNIC( char* pszIP, char* pszDNS1, char* pszDNS2, char* pszRouter )
{
	FILE* fp;
	int	iIRQ, iVector=0;

	printf( "Please enter the interrupt vector of the packet driver (in hex): " );
	scanf( "%x", &iVector );
	while( iVector <= 0x2f )
	{
		printf( "Error: packet driver must be above 2Fh, please reenter (in hex): ");
		scanf( "%x", &iVector );
	}

	printf( "To improve performance, enter the network card's IRQ, or 0 to skip: " );
	scanf( "%d", &iIRQ );
	if( (iIRQ < 2) || (iIRQ > 15) )
		iIRQ = 0;

	fp = fopen( "socket.cfg", "wt" );
	if( !fp )
		ErrorExit( "Error opening SOCKET.CFG for write" );

	fprintf( fp, "# Packet driver settings\n" );
	fprintf( fp, "ip address %s\n", pszIP );
	fprintf( fp, "interface pdr if0 dix 1500 10 0x%x", iVector );
	if( iIRQ )
		fprintf( fp, " %d", iIRQ );
	fprintf( fp, "\n" );
	if( pszRouter )
		fprintf( fp, "route add default if0 %s\n", pszRouter );
	if( pszDNS1 && atoi(pszDNS1) )
		fprintf( fp, "domain server %s\n", pszDNS1 );
	if( pszDNS2 && atoi(pszDNS2) )
		fprintf( fp, "domain server %s\n", pszDNS2 );
	fprintf( fp, "\n" );
	fprintf( fp, "# The following will cause SOCKETS to display IP status\n" );
	fprintf( fp, "ip address\n\n" );
	fprintf( fp, "# The following lines set TCP parameters\n" );
	fprintf( fp, "ip ttl 64\n" );
	fprintf( fp, "tcp mss 1460\n" );
	fprintf( fp, "tcp window 2920\n" );

	fclose( fp );

	unlink( "modem.mcf" );
}

void FuncDHCP( void )
{
	FuncNIC( "0.0.0.1", NULL, NULL, NULL );
}

void FuncBOOTP( void )
{
	FuncNIC( "0.0.0.0", NULL, NULL, NULL );
}

void FuncStatic( void )
{
	char	chIP[20], chRouter[20], chDNS1[20], chDNS2[20];

	printf( "\nPlease enter the IP address with optional netmask.\n(e.g. 192.168.1.32/24): " );
	scanf( "%s", chIP );
	printf( "Please enter the default gateway address: " );
	scanf( "%s", chRouter );
	printf( "Please enter the primary DNS address, or 0 to skip: " );
	scanf( "%s", chDNS1 );
	printf( "Please enter the secondary DNS address, or 0 to skip: " );
	scanf( "%s", chDNS2 );

	FuncNIC( chIP, chDNS1, chDNS2, chRouter );
}

void AskPrintServer( void )
{
	FILE * fp;
	int iTcpPort;
	int iPrinterNumber;
	char cUsersAnswer;


	//  Clear the screen
	//
	clrscr();


	//  Describe what this option is about.
	//
	printf( "The following questions pertain to configuring SOCKETS\n");
	printf( "to work as a print server.\n");

 	printf( "\n\nWould you like SOCKETS to be a print server? (Y/N) :");
   cUsersAnswer = toupper(getch());
   while ((cUsersAnswer != 'Y') && (cUsersAnswer != 'N'))
   {
		sound(100);
		delay(1000);
		nosound();
		cUsersAnswer = toupper(getch());
   }
   printf("%c\n", cUsersAnswer);

	//  Check the users response to determine if we should continue to
	//  the next question.
	if (cUsersAnswer == 'Y')
	{
		//  The user wants SOCKETS to be a print server so open the
		//  SOCKET.CFG file
		//
		fp = fopen( "socket.cfg", "a" );
		if( !fp )
		{
			ErrorExit( "Error opening SOCKET.CFG for write" );
		}

		//  Ask about the TCP port number
		//
		printf("\n\nEnter the TCP port number in hex or 0 to skip:");
		scanf( "%x", &iTcpPort );
		printf("\nEnter the printer number,\n");
		printf("(0=LPT1, 1=LPT2, 2=LPT3):");
		scanf( "%d", &iPrinterNumber );
		while( iPrinterNumber > 2 )
		{
			printf("\nInvalid printer number!\n");
			printf("Please enter another printer number:");
			scanf( "%d", &iPrinterNumber );
		}

		fprintf( fp, "\n\n# The following lines are for the print server\n");
		fprintf( fp, "# configuration.\n");

		if( iTcpPort == 0 )
		{
			fprintf( fp, "start prntserv 10 %d\n", iPrinterNumber );
		}
		else
		{
			fprintf( fp, "start prntserv %x %d\n", iTcpPort, iPrinterNumber );
		}

		fclose( fp );

		printf("\n\nIf you would like to use the advanced print server\n");
		printf("options, please refer to the SOCKETS Developer's Guide\n");
		printf("Chapter 6.\n");
	}

	return;
}
