//
//   $Id: SETHOST.C 1.5 2003/07/23 17:11:55Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// SETHOST.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Packet driver set environment variable according to ethernet address
//
// Revision History
// 05/25/2001 gvn Added "/t" to truncate macname...
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//


#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "ipx.h"

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

#pragma inline

#define DRIVER_INFO			1
#define ACCESS_TYPE			2
#define RELEASE_TYPE			3
#define SEND_PKT				4
#define TERMINATE				5
#define GET_ADDRESS			6
#define RESET_INTERFACE 	7
#define GET_PARAMETERS  	10	/* high-performance */
#define AS_SEND_PKT			11	/* high-performance */
#define SET_RCV_MODE			20	/* extended */
#define GET_RCV_MODE			21	/* extended */
#define SET_MULTICAST_LIST	22	/* extended */
#define GET_MULTICAST_LIST	23	/* extended */
#define GET_STATISTICS     24	/* extended */
#define SET_ADDRESS			25	/* extended */

/* Error codes */

#define BAD_HANDLE      	1	/* Invalid handle number */
#define NO_CLASS				2	/* No interfaces of specified class found */
#define NO_TYPE				3	/* No interfaces of specified type found */
#define NO_NUMBER				4	/* No interfaces of specified number found */
#define BAD_TYPE				5	/* Bad packet type specified */
#define NO_MULTICAST			6	/* This interface does not support multicast */
#define CANT_TERMINATE		7	/* This packet driver cannot terminate */
#define BAD_MODE				8	/* An invalid receiver mode was specified */
#define NO_SPACE				9	/* Failed because of insufficient space */
#define TYPE_INUSE      	10	/* The type had previously been accessed */
#define BAD_COMMAND			11	/* The command was out of range */
#define CANT_SEND				12	/* The packet couldn't be sent */
#define CANT_SET				13	/* Hardware address couldn't be changed */
#define BAD_ADDRESS			14	/* Hardware address has bad length or format */
#define CANT_RESET      	15	/* Couldn't reset interface */

typedef struct pdpar {			/* Packet Driver parameters */
	unsigned char	major_rev;	/* Revision of Packet Driver spec */
	unsigned char	minor_rev;	/*  this driver conforms to. */
	unsigned char	length;     /* Length of structure in bytes */
	unsigned char	addr_len;	/* Length of a MAC-layer address */
	unsigned short	mtu;			/* MTU, including MAC headers */
	unsigned short	multicast_aval; /* Buffer size for multicast addr */
	unsigned short	rcv_bufs;	/* (# of back-to-back MTU rcvs) - 1 */
	unsigned short	xmt_bufs;	/* (# of successive xmits) - 1 */
	unsigned short	int_num;		/* Interrupt # to hook for post-EOI
											processing, 0 == none */
} PDPAR;

typedef struct pdstat {
	unsigned long	packets_in;	/* Totals across all handles */
	unsigned long	packets_out;
	unsigned long	bytes_in;	/* Including MAC headers */
	unsigned long	bytes_out;
	unsigned long	errors_in;	/* Totals across all error types */
	unsigned long	errors_out;
	unsigned long	packets_lost;/* No buffer from receiver(), card */
										/*  out of resources, etc. */
} PDSTAT;

typedef char far * fptr;

char access;
int handle;
char preserve_case;
char debug;

char *test(int drint);
char *findmacname(int *pnum);
check_error(int drint,union REGS regs,char operation);
removemh(char *pb);
int help(void);
readmachost(char *name,int must_exist);
int getmachost(char **pmacname,char **phostname);
int settheenv(char * symbol, char * val);

FILE *fp;
char *mapbuf;
char *pmb;
char *pme;
char *vname = "HOSTNAME";
char *fname = "MACHOST.MF";
char take_first;	/* set to take first env block  */
#define MAPBUFSIZE 60000u

main(int argc, char *argv[])
{
	char *macname,*pmacname,*phostname,*pb;
	int num = 0x2f;
	char *hname = 0;
	char help_flag = 0;
	char map_changed = 0,found;
	char truncate = 0;

	while (argc-- > 1) {
		if (argv[1][0] == '?')
			help_flag = 1;
		if (argv[1][0] == '/') {
			if (argv[1][1] == '?')
				help_flag = 1;
			else if (argv[1][2] == '=') {
				switch(tolower(argv[1][1])) {
				case 'c':
					preserve_case = 1;
					break;
				case 'd':
					debug = 1;
					break;
				case 'm':
					fname = argv[1] + 3;
					break;
				case 'f':
					take_first = argv[1][3] - '0';
					break;
				case 'n':
					hname = argv[1] + 3;
					break;
				case 'v':
					vname = argv[1] + 3;
					break;
				case 't':
					truncate = 1;
					break;
				default:
					help_flag = 1;
					break;
				}
			}
			else
				hname = argv[1] + 1;
		}
		else
			vname = argv[1];
		++argv;
	}
	if (help_flag)
		help();
	if (!*fname) {
		if ((macname = findmacname(&num)) != 0) {
			if (truncate)
				macname += 4;
			printf("%s\n",macname);
			if (settheenv(vname,macname) != 0) {
				printf("Failed to set '%s' to '%s'\n",
								vname,phostname);
				exit(2);
			}
			return 0;
		}
		else {
			printf("No MAC address found\n");
			exit(1);
		}
	}
	readmachost(fname,hname == 0);
	if (hname) {
		pmb = mapbuf;
		while (getmachost(&pmacname,&phostname) > 0) {
			if (stricmp(phostname,hname) == 0) {
				printf("%s %s removed\n",pmacname,
					phostname);
				removemh(pmacname);
				map_changed = 1;
			}
		}
	}
	while ((macname = findmacname(&num)) != 0) {
		if (!hname) {	/* just set variable */
			pmb = mapbuf;
			while (getmachost(&pmacname,&phostname) > 0) {
				if (stricmp(pmacname,macname) == 0) {
					printf("%s %s\n",pmacname,phostname);
					if (settheenv(vname,phostname) != 0) {
						printf("Failed to set '%s' to '%s'\n",
							vname,phostname);
						exit(2);
					}
					exit(0);
				}
			}
		}
		else {
			pmb = mapbuf;
			found = 0;
			while (getmachost(&pmacname,&phostname) > 0) {
				if (stricmp(pmacname,macname) == 0) {
					if (stricmp(phostname,hname) == 0 && !found) {
						found = 1;
						continue;
					}
					printf("%s %s removed\n",pmacname,
								phostname);
					removemh(pmacname);
				}
			}
			if (!found) {
				if (pme - mapbuf < MAPBUFSIZE - 160) {
					printf("%s %s added\n",macname,hname);
					map_changed = 1;
					strcpy(pme,macname);
					pme += (strlen(macname) + 1);
					strcpy(pme,hname);
					pme += (strlen(hname) + 1);
					*pme = 0;
				}
				else {
					printf("Too many entries in %s\n",fname);
					exit(4);
				}
			}
		}
	}
	if (map_changed) {
		if ((fp = fopen(fname,"wt")) == 0) {
			printf("Unable to open '%s'\n",fname);
			exit(4);
		}
		for (pb = mapbuf;*pb;) {
			fprintf(fp,"%s ",pb);
			pb += (strlen(pb) + 1);
			fprintf(fp,"%s\n",pb);
			pb += (strlen(pb) + 1);
		}
		fclose(fp);
	}
	else {
		printf("No matching MAC address found\n");
		exit(1);
	}
	return 0;
}

char *findmacname(int *pnum)
{
	int i;
	char far *id;
	static char pid[] = "PKT DRVR";
	char *retv;
	void far (*ipxcall)(void);		/* IPX call vector */
	unsigned char adr[10];
	static char s_addr[50];

	for (++*pnum;*pnum <= 0xff;++*pnum) {
		id = *(fptr far *)MK_FP(0,4 * *pnum);
		for (i = 0;i < 9;++i) {
			if (id[i + 3] != pid[i])
				goto notfound;
		}
		if ((retv = test(*pnum)) != 0)
			return retv;
		notfound:;
	}
	/* No packet driver, try IPX */
	if ((*pnum)++ > 0x100)
		return 0;
	_AX = 0x7a00;
	geninterrupt(0x2f);
	if (_AL != 0xff) {
		return 0;
	}
	ipxcall = MK_FP(_ES,_DI);
	_ES = FP_SEG(adr);
	_SI = FP_OFF(adr);
	_BX = GET_INTERNET_ADDRESS;
	asm push bp;
	(*ipxcall)();
	asm pop bp;
	for (i = 0;i < 6;++i) {
		sprintf(s_addr + 2 * i,"%02x",adr[i + 4]);
		retv = s_addr;
	}
	return s_addr;
}

int getmachost(char **pmacname,char **phostname)
{
	if (*pmb == 0)
		return 0;	/* no more entries */
	*pmacname = pmb;
	pmb += (strlen(pmb) + 1);
	if (*pmb == 0)
		return 0;	/* something wrong! */
	*phostname = pmb;
	pmb += (strlen(pmb) + 1);
	return 1;
}

removemh(char *pb)
{
	char *ps,*pd;

	for (pd = pb,ps = pmb;ps < pme;++ps,++pd) {
		*pd = *ps;
	}
	pme = pd;
	*pme = 0;
	pmb = pb;
	return 0;
}

readmachost(char *name,int must_exist)
{
	char *pb,*ps,*pbo;
	int state;

	if ((pme = pmb = mapbuf = calloc(1,MAPBUFSIZE)) == 0) {
		printf("Not enough memory to run\n");
		exit(3);
	}
	if ((fp = fopen(name,"rt")) == 0) {
		if (must_exist) {
			printf("Unable to open '%s'\n",name);
			exit(2);
		}
		return 0;
	}
	pb = mapbuf;
	while (pb < mapbuf + MAPBUFSIZE - 160 && fgets(pb,160,fp) != 0) {
		if (*pb == ';' || *pb == '#' || isspace(*pb))
			continue;
		pbo = pb;
		for (ps = pb,state = 0;*ps;++ps) {
			if (isspace(*ps)) {
				switch(state) {
				case 0:
					pb = ps + 1;
					state = 1;
					*ps = 0;
					break;
				case 1:
					state = 2;	/* more than 1 space */
					break;
				case 3:
				case 4:
					*pb++ = 0;
					goto line_done;
				}
			}
			else {
				switch(state) {
				case 1:
					state = 3;
				case 3:
					pb = ps + 1;
					break;
				case 2:
					state = 4;
				case 4:
					*pb++ = *ps;
					break;
				}
			}
		}
		pb = pbo;	/* somthing wrong - ignore line */
		line_done:;
	}
	fclose(fp);
	*pb = 0;
	pme = pb;
	return 1;
}

#pragma argsused
void interrupt receiver(
	unsigned bp,
	unsigned di,unsigned si,
	unsigned ds,unsigned es,
	unsigned dx,unsigned cx,
	unsigned bx,unsigned ax)

{
	es = di = 0;		/* drop all packets */
}

char *test(int drint)
{
	union REGS regs;
	struct SREGS segregs;
	char functionality,class;
	int i,addrlen = 6;
	unsigned char addr[20];
	static char s_addr[50];
	PDPAR far *ppdp;
	char dum_type[2] = {0xff,0xfe};
	char *retv = 0;

	regs.x.ax = (DRIVER_INFO << 8) + 0xff;
	int86x(drint,&regs,&regs,&segregs);
	if (check_error(drint,regs,DRIVER_INFO) < 0)
		return retv;
	functionality = regs.h.al;
	class = regs.h.ch;
	regs.x.ax = ACCESS_TYPE << 8;
	regs.h.al = regs.h.ch;
	regs.x.bx = regs.x.dx;
	regs.h.dl = regs.h.cl;
	regs.x.cx = 2;			/* typelen */
	regs.x.si = FP_OFF(dum_type);
	segregs.ds = FP_SEG(dum_type);
	segregs.es = FP_SEG(receiver);
	regs.x.di = FP_OFF(receiver);
	int86x(drint,&regs,&regs,&segregs);
	if (check_error(drint,regs,ACCESS_TYPE) < 0)
		return retv;
	access = 1;
	handle = regs.x.ax;
	if (functionality == 5 || functionality == 6) {	/* high performance */
		regs.x.ax = GET_PARAMETERS << 8;
		int86x(drint,&regs,&regs,&segregs);
		if (check_error(drint,regs,GET_PARAMETERS) < 0)
			return retv;
		ppdp = MK_FP(segregs.es,regs.x.di);
		addrlen = ppdp->addr_len;
		if (addrlen > 20)
			addrlen = 20;
	}
	for (i = 0;i < addrlen;++i)
		addr[i] = 0;
	if (class != 6) {
		regs.x.ax = GET_ADDRESS << 8;
		regs.x.bx = handle;
		regs.x.cx = addrlen;
		segregs.es = FP_SEG(addr);
		regs.x.di = FP_OFF(addr);
		int86x(drint,&regs,&regs,&segregs);
		if (check_error(drint,regs,GET_ADDRESS) < 0)
			return retv;
		for (i = 0;i < addrlen;++i) {
			sprintf(s_addr + 2 * i,"%02x",addr[i]);
			retv = s_addr;
		}
	}
	regs.h.ah = RELEASE_TYPE;
	regs.x.bx = handle;
	int86(drint,&regs,&regs);
	access = 0;
	check_error(drint,regs,RELEASE_TYPE);
	return retv;
}

check_error(int drint,union REGS regs,char operation)
{
	if (regs.x.flags & 1) {
		printf("Error on %x call: %x\n",operation,regs.h.dh);
		if (access) {
			regs.h.ah = RELEASE_TYPE;
			regs.x.bx = handle;
			int86(drint,&regs,&regs);
		}
		return -1;
	}
	return 0;
}

int help(void)
{
#ifndef DL
	printf("SetHost ver 1.7\n");
#else
	printf("Datalight Sockets SetHost ");
	if (dlIsFat32World())
		printf("%s ", SHORTVERSION);
	else
		printf("%s ", SHORTVERSION622);
	printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif
	printf(
"Usage:\n"
" SETHOST [<options>] [<variable>]\n"
"to set an evironment variable (default %s) to the\n"
"name contained in the file %s according to the MAC address\n"
"found by searching for packet driver TSRs or IPX.\n\n"
"Use\n"
" SETHOST [<options>] /<name>\n"
"to add a name to or modify an existing name entry in the\n"
"file %s.\n\n"
"The following options can be used:\n"
"/c=           Preserve the case of the environment variable\n"
"/d=           Set debug on\n"
"/f=<n>        Use environment block <n> (Sometimes required for Netware)\n"
"              Try values of 1 or 2\n"
"/m=<mapfile>  Use <mapfile> instead of default\n"
"/n=<name>     Add <name> to mapping file\n"
"/v=<variable> Use <variable> instead of default\n"
,vname,fname,fname);
	exit(0);
	return 0;
}

/* subroutine to put a value string into an environment symbol.
   Uses the controling command.com environment, not the programs.
   This means that the env variable is set so other routines in
   a .BAT file may use it.

   call:  settheenv (char * symbol, char * val);
   symbol is an asciiz string containing the env variable name,
   val    is an asciiz string containing the value to assign to this vbl.

   returns: 0 = OK,
		1 = failure.
   failure is not unlikely.  The env block may be full.  Or on some
   systems the env block might not be found
*/


typedef struct {
	char fill1[0x0A];
	int *prev_term_handler;
	int *prev_ctrl_c;
	int *prev_crit_error;
	char fill2[0x16];
	int  envir_seg;
} psp;

typedef struct {
	char  type;
	int   psp_segment;
	int   num_segments;
		char  fill[11];
		char  arena_data;
} arena;

static arena * get_first_arena (void);
static arena * get_arena_of_environment(void);

#define NORMAL_ATYPE 0x4D
#define LAST_ATYPE   0x5A


static arena * get_next_arena (arena * ap)
{
	return( MK_FP( FP_SEG(ap)+1+ap->num_segments, 0) );
}

/* returns 0 if passed pointer is to an arena, else returns 1 */
int is_valid_arena (arena * ap)
{
	arena * ap1;

	if (ap->type == NORMAL_ATYPE  &&
		(ap1=get_next_arena(ap))->type == NORMAL_ATYPE  &&
		( (ap1=get_next_arena(ap1))->type == NORMAL_ATYPE  ||
		ap1->type == LAST_ATYPE) )
			return(0);
	return (1);
}


static arena * get_first_arena ()
{
/* return pointer to the first arena.
 * scan memory for a 0x4D on a segment start,
 * see if this points to another two levels of arena
 */
	arena * ap;
	int segment;

	for (segment=0; segment<_CS;  segment++) {
		ap = MK_FP(segment, 0);
		if ( is_valid_arena (ap) == 0)  return (ap);
	}
	return(NULL);
} /* end get_first_arena */


static int is_valid_env (char * ad, int num_segs)
{
	char * base_ad;
	base_ad = ad;
	while ( (*ad) && (((ad-base_ad)>>4) < num_segs) ) {
		if (strnicmp(ad, "COMSPEC=", 8)==0) {
			if (debug)
				printf("Valid env %p\n",base_ad);
			return(0);
		}
		ad += strlen(ad) + 1;
	}
	return (1);
}


static arena * get_arena_of_environment()
{
/* to get the arena of first environment block:
   First get segment of COMMAND.COM from segment of previous critical err code.
   Then scan all the arenas for an environment block with a matching PSP
   segment */

	arena * ap;
	psp   * pspp, * pspc;
	unsigned int i, ccseg;

    if (debug)
        printf("First = %d\n",take_first);
	if (take_first) {
        --take_first;
		goto L3;
    }
	/* set pspp to psp of this program */
	pspp = MK_FP(_psp,0);

	if (debug)
		printf("prog psp=%p\n",pspp);

	/* set pspc to psp of COMMAND.COM, back up a bit to get it if needed */
	ccseg = FP_SEG (pspp->prev_crit_error);
    if (debug)
       printf("Seg of critical error handler = %04x\n",ccseg);
	/*if ( (i=ccseg-32) < 60)*/  i=60;

	while (ccseg>i) {
		pspc = MK_FP (ccseg, 0);
		if ( is_valid_arena((arena *) pspc) == 0)  goto L1;
		ccseg--;
	}
	return (NULL);

	L1: pspc = MK_FP (++ccseg, 0);
	if (debug)
		printf("command.com=%p\n",pspc);

	/* first see if env seg in command.com points to valid env block
	   if env seg is in a valid arena, then arena must point to this command.com
	   else assume env block is fabricated like for 4DOS, use 128 bytes */

	ap = MK_FP (pspc->envir_seg-1, 0);
	i  = ap->num_segments;

	if (is_valid_arena (ap) == 0) {
		if (ap->psp_segment != FP_SEG(pspc))  goto L2;
	} else {
		i = 9;
	}

	if ( is_valid_env (&ap->arena_data, i) == 0 )
		return (ap);

	/* command.com did not so point, search thru all env blocks */

	L2:
	if ((ap=get_first_arena()) != NULL) {
		while (ap->type != LAST_ATYPE) {
			if (debug)
				printf("%p\n",ap);
			if (ap->psp_segment == FP_SEG(pspc) &&
				is_valid_env (&ap->arena_data, ap->num_segments)==0 )
				return (ap);

			ap = get_next_arena(ap);
		}
	}
	L3:
	/* just take the first env block we find */
	if ( (ap=get_first_arena()) != NULL ) {
		while (ap->type != LAST_ATYPE) {
			if (debug)
				printf("%p\n",ap);
			if (is_valid_env(&ap->arena_data,ap->num_segments) == 0 &&
                                                               !take_first--)
				return (ap);

			ap = get_next_arena(ap);
		}
	}
	return(NULL);
}  /* end get_arena_of_environment */

/*****************************************************************************/

int settheenv(char * symbol, char * val)
{
	int total_size,
	needed_size=0,
	strlength;
	char * sp, *op, *envir;
	char symb_len=strlen(symbol);
	char found=0;
	arena * ap;

	if (!preserve_case)
		strupr(symbol);

	/* first, can COMMAND.COM's envir block be found ? */
	if ( (ap=get_arena_of_environment()) == NULL) {
		printf("COMMAND.COM environment block not found\n");
		return(1);
	}

	/* search to end of the envir block, get sizes */
	total_size = 16 * ap->num_segments;
	envir = &ap->arena_data;
	op=sp=envir;
	while (*sp) {
		strlength = strlen(sp)+1;
		if ( *(sp+symb_len)=='='  &&
			 strnicmp(sp,symbol,symb_len)==0 )
			found=1;
		else {
			needed_size += strlength;
			if (found) strcpy(op,sp);
			op = &op[strlength];
		}
		sp += strlength;
	}
	*op=0;
	if (strlen(val) > 0) {
		unsigned current_size = needed_size;
		needed_size += 3 + strlen(symbol) + strlen(val);
		if (needed_size > total_size) {
			printf("Out of environment space\n"
					"Total %u bytes, used %u bytes, needed %u bytes more\n",
						total_size,current_size,needed_size - current_size);
			return(1);  /* could mess with environment expansion here */
		}
		if (debug)
			printf("Total environment %u bytes, used %u bytes, needed %u bytes more\n",
						total_size,current_size,needed_size - current_size);
		strcpy(op, symbol); strcat(op, "="); strcat(op, val);
		op += strlen(op)+1;
		*op = 0;
	}
	return(0);
} /* end setheenv subroutine */

