//
//   $Id: tcp.c 1.6 2003/07/23 17:11:55Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// TCP.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Revision History
// 02/12/2002 gvn AckOnPush
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
// 3.01 99-05-03 Fix truncation of long dotted decimal addresses
// 3.02 00-06-09 make direct screen writes optional, VT support
//
//

char version[] = "3.04";

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <dos.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include "inetdefs.h"
#undef printf
#include "timer.h"
#include "mbuf.h"
#include "netfunc.h"
#include "tcp.h"
#include "cmdparse.h"
#include "_capi.h"
#include "_api.h"

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

#ifndef DL
#define VARNAME		"INET"
#define HOSTFILE	"inet.hst"
#define DEFDIR		"\\inet"
#else
#define VARNAME		"SOCKETS"
#define HOSTFILE	"hosts"
#define DEFDIR		"\\dl\\sockets"
#endif

char *err(unsigned errcode);		/* return errorcode string */
static void state_tcp1(struct tcb far *tcb,int num,int iDetail);
char *psocket1(SOCKET far *s,int width);
static int tstat(unsigned cnt,char refresh,unsigned ticks);
dohelp(int argc,char *argv[],void *p);

int	(*pPrintf)( const char *pszFormat, ... );
void  (*pGotoXY)( int iX, int iY );
void  (*pClrEol)( void );
void  (*pClrScr)( void );
void  (*pTextAttr)( int iNewAttr );

#define NAMELEN 10		// Length of IP name
#define NUM_IP 100		// Max number of IP addresses in table
int num_ip;					// number of IP addresses in table
char out_of_mem;        // out of memory flag
char was_out_of_mem;
int linger_ticks = 2;	// number of scans to keep deleted conns
char timesort = 2;		// unsorted
int numflag;				// what to do with a number
int numnew;					// number of newest connections to highlight
int numdisp;				// number of display multiples
int dispnum;
char frozen;				// set for display not to change
int format = 1;
int time = 18;				// time in ticks for scan
int iNumLines = 25;		// number of lines in display

#define DELETED (TIME_WAIT + 1)
#define EXPIRED (TIME_WAIT + 2)

typedef struct {
	unsigned long ip_adr;
	char name[NAMELEN];
} IP_TAB;

IP_TAB ip_tab[NUM_IP];

typedef struct tcb_tabs {		// tcb table
	struct tcb_tabs *next;		// unsorted next
	struct tcb_tabs *prev;		// unsorted previous
	struct tcb_tabs *tnext;		// time sorted next
	struct tcb_tabs *tprev;		// time sorted previous
	struct tcb_tabs *hnext;		// host sorted next
	struct tcb_tabs *hprev;		// host sorted previous
	unsigned tcbo;				// offset to RINET tcb
	struct connection conn;
	char state;					// last state of tcb
	char flags;					// Control flags
	WORD rcvcnt;
	WORD sndcnt;
	char r_upcall;
	char t_upcall;
	char s_upcall;
	int linger;					// number of scans to keep deleted conns
	IP_TAB *pipl;				// pointer to IP table for local
	IP_TAB *pipr;				// pointer to IP table for remote
} TCB_TAB;

TCB_TAB *ftt,*ltt;				// first and last table entries
TCB_TAB *fttm;					// first table entry time sorted
TCB_TAB *fth;					// first table entry host sorted
int num_tt;

char *psocket2(IP_TAB *pip,SOCKET *s,int width);
IP_TAB *getipname(DWORD a);

/* TCP connection states */
char *tcpstates[] = {
	"Closed      ",
	"Listen   ",
	"SYN sent    ",
	"SYN received",
	"Established ",
	"FIN wait 1  ",
	"FIN wait 2  ",
	"Close wait  ",
	"Closing     ",
	"Last ACK    ",
	"Time wait   ",
	"Deleted     "
};

char *tcpst[] = {
	"Cd",
	"Li",
	"SS",
	"SR",
	"Es",
	"F1",
	"F2",
	"CW",
	"Cg",
	"LA",
	"TW",
	"De"
};

/* TCP closing reasons */
char *reasons[] = {
	"Normal",
	"Reset",
	"Timeout",
	"ICMP"
};

/* TCP subcommand table */
int domss(),doirtt(),dortt(),doretry(),dotcpstat(),dowindow(),
	doclose(),doreset(),dolport(),dotcptos(),dohelp(),AckOnPush();
struct scmds far tcpcmds[] = {
	{"ackonpush",AckOnPush},
	{"close",	doclose},
	{"help",		dohelp},
	{"irtt",		doirtt},
	{"mss",		domss},
	{"reset",	doreset},
	{"retry",	doretry},
	{"status",	dotcpstat},
	{"tos",		dotcptos},
	{"window",	dowindow},
	{"",		0},
};

struct tcp_stat far *ptcp;
unsigned api_int;
char id[] = "Inet";
unsigned iseg;
char poll;

union REGS r;

void  (GotoxyVt)( int iX, int iY )
{
	printf("\x1b[%u;%uH",iY,iX);
}

void  (ClrEolVt)( void )
{
	printf("\x1b[K");
}

void  (ClrScrVt)( void )
{
	printf("\x1b[2J\x1bH");
}

void  (TextAttrVt)( int iNewAttr )
{
	printf("\x1b[%um",iNewAttr >= 0x10 ? 7 : 0);
}

void ClrScrSt(void)
{
	printf("\n");
}

void	None0(void)
{
}

#pragma argsused
void None1(int iArg)
{
}

#pragma argsused
void GotoXySt(int iX, int iY)
{
	if (iX == 1 && iY == 1)
		printf("\n");
}

void SetVidStandard(void)
{
	pPrintf = printf;
	pGotoXY = GotoXySt;
	pClrEol = None0;
	pClrScr = ClrScrSt;
	pTextAttr = None1;
}

void SetVidDirect(void)
{
	pPrintf = cprintf;
	pGotoXY = gotoxy;
	pClrEol = clreol;
	pClrScr = clrscr;
	pTextAttr = textattr;
}

ND far *psLocalDesc, far *psGlobalDesc;
VARBLOCK far *pstat;

main(int argc,char *argv[])
{
	void interrupt (*int_apiv)();
	char far *pid;
	int i;

	SetVidStandard();
	for (api_int = 0x20;api_int < 0x100;++api_int) {
		int_apiv = getvect(api_int);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0;i < 4;++i) {
			if (pid[i] != id[i])
				break;
		}
		if (i == 4)
			goto ok;;
	}
	printf(VARNAME " API not loaded\n");
	exit(1);
	ok:
	r.h.ah = API_GETVARPTR;
	int86(api_int,&r,&r);
	iseg = r.x.bx;
	pstat = MK_FP(iseg,r.x.cx);
	ptcp = MK_FP(iseg,pstat->tcpstat);
	psLocalDesc = MK_FP(iseg,pstat->ndesc);
	psGlobalDesc = MK_FP(iseg,pstat->gdesc);
	subcmd(tcpcmds,argc,argv,0);
	return 0;
}

/* print tcp default values */
void near tcp_defaults(void);
void near tcp_defaults()
{
	printf("TCP: IRTT %u ms Retry %u MSS %u Window %u\n",
		ptcp->tcp_irtt,ptcp->tcp_retry,ptcp->tcp_mss,
		ptcp->tcp_window);
}

/* Set initial round trip time for new connections */
static int
doirtt(argc,argv)
int argc;
char *argv[];
{
	if(argc < 2)
		tcp_defaults();
	else ptcp->tcp_irtt = atoi(argv[1]) * (strchr(argv[1],'m') ?
								1 : 1000);
	return 0;
}

/* Show/set AckOnPush flag */
static int
AckOnPush(int argc,char *argv[])
{
	if(argc < 2)
		printf("AckOnPush = %d\n",ptcp->cAckOnPush);
	else
		ptcp->cAckOnPush = atoi(argv[1]);
	return 0;
}

/* Set tcp retry count */
static int
doretry(argc,argv)
int argc;
char *argv[];
{
	if(argc < 2)
		tcp_defaults();
	else
		ptcp->tcp_retry = atoi(argv[1]);
	return 0;
}

/* Set/examine TOS used by Telnet */
static int
dotcptos(argc,argv)
int argc;
char *argv[];
{
	extern WORD lport;

	if(argc < 2)
		printf("Telnet TOS = %u\n",ptcp->tel_tos);
	else
		ptcp->tel_tos = atoi(argv[1]);
	return 0;
}

/* Set default maximum segment size */
static int
domss(argc,argv)
int argc;
char *argv[];
{
	if(argc < 2)
		tcp_defaults();
	else
		ptcp->tcp_mss = atoi(argv[1]);
	return 0;
}

/* Set default window size */
static int
dowindow(argc,argv)
int argc;
char *argv[];
{
	if(argc < 2)
		tcp_defaults();
	else
		ptcp->tcp_window = atoi(argv[1]);
	return 0;
}

TCB far *get_tcb(int n)
{
	TCB far *tcb;
	int i,num;

	for (i = num = 0;i < NTCB;i++) {
		for (tcb = MK_FP(iseg,ptcp->tcbs[i]);FP_OFF(tcb) != 0;
						tcb = MK_FP(iseg,tcb->next)) {
			if (num++ == n) {
				return tcb;
			}
		}
	}
	return 0;
}

/* Display status of TCBs */
static int
dotcpstat(argc,argv)
int argc;
char *argv[];
{
	TCB far *tcb;
	int n;
	FILE *fp;
	unsigned ip[4];
	char buf[86];
	char *pstr,*p;

	if ((p = getenv(VARNAME)) == 0)
		p = DEFDIR;
	sprintf(buf,"%s\\%s",p,HOSTFILE);
	strcpy(buf + 80,"0 ?\n");
	if ((fp = fopen(buf,"rt")) != NULL) {
		while (fgets(buf,80,fp)) {
			buf[81] = ' ';
			buf[82] = '\n';
			sscanf(buf,"%u.%u.%u.%u",ip,ip + 1,ip + 2,ip + 3);
			for (pstr = buf;!isspace(*pstr);pstr++);
			for (;isspace(*pstr);pstr++);
			for (p = pstr;*p && *p != '\n' && !isspace(*p);p++);
			*p = 0;
			if (num_ip < NUM_IP) {
				ip_tab[num_ip].ip_adr = ((long)ip[0] << 24) +
							((long)ip[1] << 16) +
							(ip[2] << 8) + ip[3];
				strncpy(ip_tab[num_ip++].name,pstr,NAMELEN);
			}
			else break;
		}
		fclose(fp);
	}
	if (argc < 2) {
		tstat(1,0,0);
	} else if (argv[1][0] == '/') {
		SetVidDirect();
		while (argc > 1 && argv[1][0] == '/') {
			char *parg = argv[1] + (argv[1][2] == '=' ? 3 : 2);
			int val = atoi(parg);
			switch(tolower(argv[1][1])) {
			case 'd':
				numdisp = val;
				break;
			case 'f':
				frozen = val;
				break;
			case 'n':
				numnew = val;
				break;
			case 'l':
				linger_ticks = val;
				break;
			case 'p':
				poll = val;
				break;
			case 's':
				timesort = val;
				break;
			case 't':
				time = val;
				break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
				format = argv[1][1] - '0';
				break;
			case 'v':
				if (val == 0) {
					SetVidDirect();
				}
				else if (val == 1) {		// VT100 sequences
					pPrintf = printf;
					pGotoXY = GotoxyVt;
					pClrEol = ClrEolVt;
					pClrScr = ClrScrVt;
					pTextAttr = TextAttrVt;
					iNumLines = 24;
				}
				else if (val == 2) {	// stdout
					SetVidStandard();
				}
			}
			--argc;
			++argv;
		}
		if (argc > 1)
			time = atoi(argv[1]) * 18;
		tstat(format,1,time);
	} else {
		n = atoi(argv[1]);
		if ((tcb = get_tcb(n)) != 0) {
			state_tcp1(tcb,n,argc > 2 ? atoi(argv[2]) : 0);
			return 0;
		}
		printf("TCP connection #%u does not exist\n",n);
	}
	return 0;
}

doclose(int argc,char *argv[])
{
	TCB far *tcb;
	int n,errcode;

	if (argc < 2) {
		dohelp(0,0,0);
	} else {
		n = atoi(argv[1]);
		if ((tcb = get_tcb(n)) != 0) {
			_BX = FP_OFF(tcb);
			_AH = API_TCPCLOSE;
			geninterrupt(API_INT);
			if ((errcode = _AX) != 0)
				printf("Error on TCP_CLOSE: %s\n",
								err(errcode));
			return 0;
		}
		printf("TCP connection #%u does not exist\n",n);
	}
	return 0;
}

doreset(int argc,char *argv[])
{
	TCB far *tcb;
	int n,errcode;

	if (argc < 2) {
		dohelp(0,0,0);
	} else {
		n = atoi(argv[1]);
		if ((tcb = get_tcb(n)) != 0) {
			_BX = FP_OFF(tcb);
			_AH = API_TCPRESET;
			geninterrupt(API_INT);
			if ((errcode = _AX) != 0)
				printf("Error on TCP_RESET: %s\n",
								err(errcode));
			return 0;
		}
		printf("TCP connection #%u does not exist\n",n);
	}
	return 0;
}

/* Dump TCP stats and summary of all TCBs, build TCB index
 * Con# Rcv-Q Snd-Q  Local socket           Remote socket          State
 *   1      0     0  xxx.xxx.xxx.xxx:xxxxx  xxx.xxx.xxx.xxx:xxxxx  Established
 */

int lines;

void (*print_tcb)(int num,TCB_TAB *pt,int last);

int states[DELETED + 1];
int num_cons;

void set_time_attr(TCB_TAB *pt)
{
	TCB_TAB *ptm;
	int i;

	for (ptm = fttm,i = numnew;i && ptm;--i,ptm = ptm->tnext) {
		if (ptm == pt) {
			(*pTextAttr)(0x70);
			break;
		}
	}
}

void print_tcb0(int num,TCB_TAB *pt,int last)
{
	int i;

	if (last) {
		(*pPrintf)("Number of connections: %u\r\n",num_cons);
		++lines;
		for (i = 0;i <= DELETED;++i) {
			if (states[i]) {
				(*pPrintf)("%-15s%2u\r\n",tcpstates[i],states[i]);
				++lines;
			}
		}
		return;
	}
	if (num == 0) {
		lines = 1;
		num_cons = 0;
		for (i = 0;i <= DELETED;++i)
			states[i] = 0;
	}
	if ((i = pt->state) <= DELETED)
		++states[i];
	++num_cons;
}

void print_tcb1(int num,TCB_TAB *pt,int last)
{
	if (num == 0) {
		(*pTextAttr)(0x70);
		(*pPrintf)("Con# Rcv-Q  Snd-Q  Local socket          "
			"Remote socket         State        UpC\r\n");
		(*pTextAttr)(0x7);
		lines = 1;
	}
	if (last == 2)
		return;
	++lines;
	set_time_attr(pt);
#ifdef DEBUG
	(*pPrintf)("%p %p %p %p ",pt,pt->next,pt->prev,pt->tcbo);
	(*pPrintf)("%3u %6u %6u  ",num,pt->rcvcnt,pt->sndcnt);
	(*pPrintf)("%-14s",psocket2(pt->pipl,&pt->conn.local,14));
	(*pPrintf)("%-14s",psocket2(pt->pipr,&pt->conn.remote,14));
	(*pPrintf)("%-s",tcpstates[pt->state]);
#else
	(*pPrintf)("%3u %6u %6u  ",num,pt->rcvcnt,pt->sndcnt);
	(*pPrintf)("%-22s",psocket2(pt->pipl,&pt->conn.local,22));
	(*pPrintf)("%-22s",psocket2(pt->pipr,&pt->conn.remote,22));
	(*pPrintf)("%-s",tcpstates[pt->state]);
	if(pt->state == LISTEN)
		(*pPrintf)((pt->flags & CLONE) ? "(S)" : "   ");
	(*pPrintf)(" %s%s%s",pt->r_upcall ? "R" : " ",pt->t_upcall ? "T" : " ",
					  pt->s_upcall ? "S" : " ");
#endif
	//(*pPrintf)("\r\nTCB = %Fp, user = %p",tcb,tcb->user);++lines;
	(*pPrintf)("\r\n");
}

void print_tcb2(int num,TCB_TAB *pt,int last)
{
	if (num == 0) {
		(*pTextAttr)(0x70);
		(*pPrintf)("Con Local socket    "
			"Remote socket   St"
			"Con Local socket    "
			"Remote socket   St\r\n");
		(*pTextAttr)(0x7);
		lines = 1;
	}
	if (last) {
		if (num & 1) {
			(*pClrEol)();
			(*pPrintf)("\r\n");
			++lines;
		}
		return;
	}
	else if (num == 0)
		++lines;
	(*pPrintf)("%3u ",num);
	set_time_attr(pt);
	(*pPrintf)("%-16s",psocket2(pt->pipl,&pt->conn.local,16));
	(*pPrintf)("%-16s",psocket2(pt->pipr,&pt->conn.remote,16));
	(*pPrintf)("%-s",tcpst[pt->state]);
	(*pPrintf)(num & 1 ? ++lines,"\r\n" : "");
}

void print_tcb3(int num,TCB_TAB *pt,int last)
{
	if (num == 0) {
		(*pTextAttr)(0x70);
		(*pPrintf)("ConRemote Socket   LPort StRemote Socket   LPort St"
			"Remote Socket   LPort St\r\n");
		(*pTextAttr)(0x7);
		lines = 1;
	}
	if (last) {
		switch (num % 3) {
		case 1:
			(*pPrintf)("                        ");
		case 2:
			(*pClrEol)();
			(*pPrintf)("\r\n");
			++lines;
			break;
		}
		return;
	}
	else if (num == 0)
		++lines;
	if ((num % 3) == 0)
		(*pPrintf)("%3u",num);
	set_time_attr(pt);
	(*pPrintf)("%-15s %5u",psocket2(pt->pipr,&pt->conn.remote,15),pt->conn.local.port);
	(*pPrintf)(" %-s",tcpst[pt->state]);
	(*pPrintf)(num % 3 == 2 ? ++lines,"\r\n" : "");
}

void print_tcb4(int num,TCB_TAB *pt,int last)
{
	char str[10], *prem;
	int len,lenp;

	if (num == 0) {
		(*pTextAttr)(0x70);
		(*pPrintf)("C#Rem Sockt LPort StRem Sockt LPort St"
			"Rem Sockt LPort StRem Sockt LPort St\r\n");
		(*pTextAttr)(0x7);
		lines = 1;
	}
	if (last) {
		switch (num & 3) {
		case 1:
			(*pPrintf)("                  ");
		case 2:
			(*pPrintf)("                  ");
		case 3:
			(*pClrEol)();
			(*pPrintf)("\r\n");
			++lines;
			break;
		}
		return;
	}
	else if (num == 0)
		++lines;
	if ((num & 3) == 0)
		(*pPrintf)("%2u",num);
	set_time_attr(pt);
	prem = psocket2(pt->pipr,&pt->conn.remote,12);
	if ((len = strlen(prem)) < 10) {	// local port will fit
		(*pPrintf)("%-9s %5u",prem,pt->conn.local.port);
	}
	else {
		lenp = sprintf(str,"%u",pt->conn.local.port);
		if (len + lenp < 15) {
			strcat(prem,"               ");
			strcpy(prem + 15 - lenp,str);
			(*pPrintf)("%s",prem);
		}
		else {
			str[len + lenp - 15] = '<';
			(*pPrintf)("%s%s",prem,str + len + lenp - 15);
		}
	}
	(*pPrintf)(" %-s",tcpst[pt->state]);
	(*pPrintf)((num & 3) == 3 ? ++lines,"\r\n" : "");
}

#ifdef DEBUG
FILE *fp;

void cq(char *mes)
{
	TCB_TAB *pt;
	int cnt = 0,tcnt = 0,hcnt = 0;

	fprintf(fp,"%s\nQI: ",mes);
	for (pt = ftt;pt;pt = pt->next) {
		fprintf(fp,"%04x<%04x-%x ",pt,pt->prev,pt->state);
		++cnt;
	}
	fprintf(fp,"\nQT: ");
	for (pt = fttm;pt;pt = pt->tnext) {
		fprintf(fp,"%04x<%04x-%x ",pt,pt->tprev,pt->state);
		++tcnt;
	}
	fprintf(fp,"\nQH: ");
	for (pt = fth;pt;pt = pt->hnext) {
		fprintf(fp,"%04x<%04x-%x ",pt,pt->hprev,pt->state);
		++hcnt;
	}
	fprintf(fp,"\n");
	if (cnt != hcnt || cnt != tcnt) {
		printf("\nQ bad at %s - cnt = %u, tcnt = %u, hcnt = %u\n",mes,cnt,tcnt,hcnt);
		if (getch() == '\x1b') {
			fclose(fp);
			exit(1);
		}
	}
}
#endif

int same(TCB_TAB *pt,TCB far *tcb)
{
	if (pt->state == DELETED || pt->tcbo != FP_OFF(tcb))
		return 0;
	if (pt->state == LISTEN)
		return pt->conn.local.port == tcb->conn.local.port;
	else
		return _fmemcmp(&pt->conn,&tcb->conn,sizeof(struct connection)) == 0;
}

void hinsert(TCB_TAB *pt)
{
	TCB_TAB *ptc,*ptp;

	pt->pipl = getipname(pt->conn.local.address);
	pt->pipr = getipname(pt->conn.remote.address);
	if (!fth) {
		fth = pt;
		return;
	}
	for (ptc = fth;ptc;ptc = ptc->hnext) {
		if (pt->pipr <= ptc->pipr) {
			if (ptc->hprev) {
				ptc->hprev->hnext = pt;
				pt->hprev = ptc->hprev;
			}
			else {
				fth = pt;
			}
			pt->hnext = ptc;
			ptc->hprev = pt;
			return;
		}
		ptp = ptc;
	}
	ptp->hnext = pt;
	pt->hprev = ptp;
}

void hunlink(TCB_TAB *pt)
{
	TCB_TAB *ptp = pt->hprev;

	if (ptp) {
		ptp->hnext = pt->hnext;
		if (pt->hnext)
			pt->hnext->hprev = ptp;
	}
	else {
		fth = pt->hnext;
		if (fth)
			fth->hprev = 0;
	}
}

TCB_TAB *create_tt(TCB far *tcb)
{
	TCB_TAB *ptn;

	if ((ptn = calloc(sizeof(TCB_TAB),1)) != 0) {
		ptn->conn = tcb->conn;
		ptn->flags = tcb->flags;
		ptn->rcvcnt = tcb->rcvcnt;
		ptn->sndcnt = tcb->sndcnt;
		ptn->r_upcall = tcb->r_upcall != 0;
		ptn->t_upcall = tcb->t_upcall != 0;
		ptn->s_upcall = tcb->s_upcall != 0;
		ptn->tcbo = FP_OFF(tcb);
		ptn->state = tcb->state;
		if (fttm) {
			ptn->tnext = fttm;
			fttm->tprev = ptn;
			fttm = ptn;
		}
		else
			fttm = ptn;
		hinsert(ptn);
	}
	return ptn;
}

void delete_tt(TCB_TAB *pt)
{
	if (pt->state == DELETED) {
		if (--pt->linger <= 0) {
			pt->state = EXPIRED;
		}
	}
	else {
		pt->linger = linger_ticks;
		pt->state = DELETED;
	}
}

static int tstat(unsigned cnt,char refresh,unsigned ticks)
{
	register int i;
	int previous_lines = 0;
	struct tcb far *tcb;
	int num,ch;
	unsigned lclock;
	static char rcnt;
	TCB_TAB *pt,*ptc,*ptn,*ptp;

#ifdef DEBUG
	fp = fopen("log","wt");
#endif
	restart:
	switch (cnt) {
	case 0:
		print_tcb = print_tcb0;
		break;
	case 2:
		print_tcb = print_tcb2;
		break;
	case 3:
		print_tcb = print_tcb3;
		break;
	case 4:
		print_tcb = print_tcb4;
		break;
	default:
		print_tcb = print_tcb1;
		break;
	}
	(*pClrScr)();
	while (1) {
		lclock = peek(0x40,0x6c);
		ptc = ftt;
		disable();
		for (i = 0,num = 0;i < NTCB;i++) {
			for (tcb = MK_FP(iseg,ptcp->tcbs[i]);FP_OFF(tcb) != 0;
						tcb = MK_FP(iseg,tcb->next)) {
				if (ptc != 0) {
					if (same(ptc,tcb) == 0) {
						for (pt = ptc->next;pt;pt = pt->next) {
							if (same(pt,tcb) != 0)
								break;
						}
						if (pt) {
							while(ptc != pt) {
								delete_tt(ptc);
								ptc = ptc->next;
							}
							ptc = ptc->next;
						}
						else {	// insert an entry
							if ((ptn = create_tt(tcb)) != 0) {
								if ((ptp = ptc->prev) != 0) {
									ptc->prev = ptn;
									ptp->next = ptn;
								}
								else {
									ptc->prev = ftt = ptn;
								}
								ptn->next = ptc;
								ptn->prev = ptp;
							}
							else {
								out_of_mem = 1;
							}
						}
					}
					else {
						if (_fmemcmp(&ptc->conn,&tcb->conn,
									sizeof(struct connection)) != 0) {
							hunlink(ptc);
							ptc->hnext = ptc->hprev = 0;
							ptc->conn = tcb->conn;
							hinsert(ptc);
						}
						ptc->flags = tcb->flags;
						ptc->rcvcnt = tcb->rcvcnt;
						ptc->sndcnt = tcb->sndcnt;
						ptc->state = tcb->state;
						ptc->r_upcall = tcb->r_upcall != 0;
						ptc->t_upcall = tcb->t_upcall != 0;
						ptc->s_upcall = tcb->s_upcall != 0;
						ptc = ptc->next;
					}
				}
				else {
					if ((ptn = create_tt(tcb)) != 0) {
						if (ftt) {
							ltt->next = ptn;
							ptn->prev = ltt;
							ltt = ptn;
						}
						else {
							ftt = ltt = ptn;
						}
					}
					else {
						out_of_mem = 1;
					}
				}
			}
		}
		enable();
#ifdef DEBUG
		cq("tstat1");
#endif
		while(ptc) {
			delete_tt(ptc);
			ptc = ptc->next;
		}
		look_again:
#ifdef DEBUG
		cq("tstat2");
#endif
		for (pt = ftt;pt;pt = pt->next) {
			if (pt->state == EXPIRED) {
				ptp = pt->prev;
				if (ptp) {
					ptp->next = pt->next;
					if (pt->next)
						pt->next->prev = ptp;
				}
				else {
					ftt = pt->next;
					if (ftt)
						ftt->prev = 0;
				}
				if (pt == ltt)
					ltt = ptp;
				ptp = pt->tprev;
				if (ptp) {
					ptp->tnext = pt->tnext;
					if (pt->tnext)
						pt->tnext->tprev = ptp;
				}
				else {
					fttm = pt->tnext;
					if (fttm)
						fttm->tprev = 0;
				}
				hunlink(pt);
#ifdef DEBUG
				fprintf(fp,"Free %04x\n",pt);
#endif
				free(pt);
				goto look_again;
			}
		}
#ifdef DEBUG
		cq("tstat3");
#endif
		if (!frozen && --dispnum < 0) {
			dispnum = numdisp;
			_setcursortype(_NOCURSOR);
			(*pPrintf)("ConOut %u ConIn %u ResetOut %u Runt %u "
				   "ChksumErr %u Bdcsts %u\r\n",
				ptcp->conout,ptcp->conin,ptcp->resets,ptcp->runt,
				ptcp->checksum,ptcp->bdcsts);
			(*pClrEol)();
			for (pt = timesort == 0 ? fth : timesort == 1 ? fttm : ftt;pt;
					pt = timesort == 0 ? pt->hnext :
					timesort == 1 ? pt->tnext : pt->next) {
				(*print_tcb)(num++,pt,0);
				(*pTextAttr)(0x07);
				if (!refresh && kbhit()) {
					getch();
					(*pTextAttr)(0x70);
					(*pPrintf)("Press any key to continue..");
					(*pTextAttr)(0x7);
					if (getch() == '\x1b') {
						_setcursortype(_NORMALCURSOR);
						return 0;
					}
					(*pPrintf)("\r");
					(*pClrEol)();
				}
				if (refresh && lines >= iNumLines - 1) {
					(*pTextAttr)(0x70);
					(*pPrintf)("Too many connections for display.");
					goto wait;
				}
			}
			if (!refresh)
				break;
			(*print_tcb)(num,pt,2);
			while (lines < previous_lines) {
				(*pClrEol)();
				(*pPrintf)("\r\n");
				--previous_lines;
			}
			previous_lines = lines;
		}
		wait:
		if (out_of_mem) {
			(*pGotoXY)(40,iNumLines);
			was_out_of_mem = 1;
			(*pTextAttr)(0x70);
			(*pPrintf)("Out of memory!");
		}
		else if (was_out_of_mem) {
			(*pGotoXY)(40,iNumLines);
			(*pPrintf)("              ");
			was_out_of_mem = 0;
		}
		(*pGotoXY)(64,iNumLines);
		(*pTextAttr)(0x70);
		(*pPrintf)("S:%c N:%c D:%c %c %c",
						timesort == 0 ? 'H' : timesort == 1 ? 'T' : 'I',
						numflag == 1 ? '?' : numnew + '0',
						numflag == 2 ? '?' : numdisp + '0',
						frozen ? 'F' : ' ',
						rcnt++ & 1 ? '.' : 249);
		(*pTextAttr)(7);
		_setcursortype(_NORMALCURSOR);
		while (1) {
			if ((unsigned)peek(0x40,0x6c) - lclock > ticks)
				break;
			if (poll) {
				r.h.ah = API_NOOP;
				int86(api_int,&r,&r);
			}
			if (kbhit()) {
				int numflag1 = numflag;
				ch = getch();
				numflag = 0;
				dispnum = 0;
				switch (ch) {
				case '\x1b':
					goto exit;
				default:
					if (ch >= '0' && ch <= '9') {
						ch -= '0';
						switch (numflag1) {
						case 0:					// display
							if (ch < 5) {
								cnt = ch;
								goto restart;
							}
							(*pClrScr)();
							goto refresh;
						case 1:         		// new lines
							numnew = ch;
							goto refresh;
						case 2:         		// new lines
							numdisp = ch;
							goto refresh;
						}
					}
					else
						goto refresh;
				case 'd':
				case 'D':
					numflag = 2;
					goto refresh;
				case 'f':
				case 'F':
					frozen = !frozen;
					goto refresh;
				case 'M' - '@':		// for debugging
					out_of_mem = !out_of_mem;
					goto refresh;
				case 'n':
				case 'N':
					numflag = 1;
					goto refresh;
				case 's':
				case 'S':
					if (++timesort >= 3)
						timesort = 0;
					goto refresh;
				}
			}
		}
		refresh:
		(*pGotoXY)(1,1);
	}
	exit:
	if (kbhit())
		getch();
	_setcursortype(_NORMALCURSOR);
	return 0;
}

char *arszFlags[] = {
	"FORCE",		//		1		// We owe the other end an ACK or window update
	"CLONE",		//		2		// Server-type TCB, cloned on incoming SYN
	"RETRAN",	//		4		// A retransmission has occurred
	"TCP_RCV",	//		8		// Set on data arrival, reset by user
	"TCP_XMT",	//		0x10	// Set when ok to send more, reset by user
	"TCP_STC",	//		0x20	// Set on state change, reset by user
	"SEND_URG",	//		0x40	// Set when sending urgent data
	"TCP_EXT"	//		0x80	// External connection (via API)
};

char *arszFlags1[] = {
	"LISTEN0",	//		1		// was listening on 0.0.0.0:0
	"KEEPALIVE",//		2		// keep alive is active
	"KATIMING",	//		4		// keep alive timer running
	"MUSTACK",	//		8 		// Ack is outstanding
	"MAXSEGRCVD",//	0x10	// Max segment has been received
	0,
	0,
	0
};

void PrintFlags(char *szName,char cFlags,char *arszFlags[])
{
	int i,iMask;
	char *psz;

	printf("%s",szName);

	for (i = 0,iMask = 1;i < 8 && ((psz = arszFlags[i]) != 0);++i,iMask <<= 1) {
		if (cFlags & iMask)
			printf(" %s",psz);
	}
	printf("\n");
}

/* Dump a TCP control block in detail */
static void state_tcp1(struct tcb far *tcb,int num,int iDetail)
{
	int32 sent,recvd;

	if(tcb == 0)
		return;
	/* Compute total data sent and received; take out SYN and FIN */
	sent = tcb->snd.una - tcb->iss;	/* Acknowledged data only */
	recvd = tcb->rcv.nxt - tcb->irs;
	switch(tcb->state){
	case LISTEN:
	case SYN_SENT:		/* Nothing received or acked yet */
		sent = recvd = 0;
		break;
	case SYN_RECEIVED:
		recvd--;	/* Got SYN, no data acked yet */
		sent = 0;
		break;
	case ESTABLISHED:	/* Got and sent SYN */
	case FINWAIT1:		/* FIN not acked yet */
		sent--;
		recvd--;
		break;
	case FINWAIT2:		/* Our SYN and FIN both acked */
		sent -= 2;
		recvd--;
		break;
	case CLOSE_WAIT:	/* Got SYN and FIN, our FIN not yet acked */
	case CLOSING:
	case LAST_ACK:
		sent--;
		recvd -= 2;
		break;
	case TIME_WAIT:		/* Sent and received SYN/FIN, all acked */
		sent -= 2;
		recvd -= 2;
		break;
	}
	printf("TCP con# %u:\nLocal: %s",num,psocket1(&tcb->conn.local,22));
	printf(" Remote: %s",psocket1(&tcb->conn.remote,22));
	printf(" State: %s\n",tcpstates[tcb->state]);
	printf("   Init seq      Unack       Next Resent CWind Thrsh  Wind  MSS Queue     Total\n");
	printf("S%10lu",tcb->iss);
	printf("%11lu",tcb->snd.una);
	printf("%11lu",tcb->snd.nxt);
	printf("%7lu",tcb->resent);
	printf("%6u",tcb->cwind);
	printf("%6u",tcb->ssthresh);
	printf("%6u",tcb->snd.wnd);
	printf("%5u",tcb->mss);
	printf("%6u",tcb->sndcnt);
	printf("%10lu\n",sent);

	printf("R%10lu",tcb->irs);
	printf("           ");
	printf("%11lu",tcb->rcv.nxt);
	printf("%7lu",tcb->rerecv);
	printf("      ");
	printf("      ");
	printf("%6u",tcb->rcv.wnd);
	printf("     ");
	printf("%6u",tcb->rcvcnt);
	printf("%10lu\n",recvd);

	if(tcb->reseq != (struct reseq *)NULL){
		struct reseq far *rp;

		printf("Reassembly queue:\n");
		for(rp = MK_FP(iseg,tcb->reseq);FP_OFF(rp);
						rp = MK_FP(iseg,rp->next)) {
			printf("  seq %lu %u bytes\n",rp->seg.seq,rp->length);
		}
	}
	if(tcb->backoff > 0 || tcb->retry > 0)
		printf("Backoff %u %u ",tcb->backoff,tcb->retry);
	if(tcb->flags & RETRAN)
		printf("Retrying ");
	switch(tcb->timer.state){
	case TIMER_STOP:
		printf("Timer stopped ");
		break;
	case TIMER_RUN:
		printf("Timer running (%ld/%ld ms) ",
		 (long)MSPTICK * (tcb->timer.start - tcb->timer.count),
		 (long)MSPTICK * tcb->timer.start);
		break;
	case TIMER_EXPIRE:
		printf("Timer expired ");
	}
	printf("SRTT %ld ms Mean dev %ld ms\n",tcb->srtt,tcb->mdev);
	if (iDetail) {
		ND far *psDesc;
		int iNd;

		for (iNd = 0,psDesc = psLocalDesc;iNd < pstat->nndesc;++iNd,psDesc++) {
			if ((psDesc->flags & ND_ASSIGNED) && (psDesc->flags & TCP_CON) &&
						(int)psDesc->tcb == FP_OFF(tcb))
				goto found;
		}
		for (iNd = 64,psDesc = psGlobalDesc;iNd < 64 + pstat->ngdesc;++iNd,psDesc++) {
			if ((psDesc->flags & ND_ASSIGNED) && (psDesc->flags & TCP_CON) &&
						(int)psDesc->tcb == FP_OFF(tcb)) {
				found:
				printf("TCB %Fp Socket %d\n",tcb,iNd);
				goto been_found;
			}
		}
		printf("TCB %Fp\n",tcb);
		been_found:
		printf("Upcalls: State %Fp Receive %Fp Transmit %Fp\n",
			tcb->s_upcall,tcb->r_upcall,tcb->t_upcall);
		PrintFlags("Flags: ",tcb->flags,arszFlags);
		PrintFlags("Flags1:",tcb->flags1,arszFlags1);
		printf("Not accepted %u Max not accepted %u\n",tcb->num_nacc,tcb->max_nacc);
		if (tcb->num_nacc) {
			int i = tcb->max_nacc;
			printf("NAQueue:");
			while (tcb->naccq && i--) {
				printf(" %04x",tcb->naccq);
				tcb = MK_FP(iseg,tcb->naccq);
			}
			printf("\n");
		}
	}
}

dohelp()
{
#ifndef DL
	printf("TCP version %s\n", version);
#else
	printf("Datalight Sockets TCP ");
	if (dlIsFat32World())
		printf("%s ", SHORTVERSION);
	else
		printf("%s ", SHORTVERSION622);
	printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif

	printf("Usage:\n"

"tcp ackonpush [<n>] Set or display ACK on PSH flag\n"
"tcp close  <n>   Close connection\n"
"tcp help         This message\n"
"tcp irtt   [<n>] Set or display the Initial Round Trip Time\n"
"tcp mss    [<n>] Set or display the Maximum Segment Size\n"
"tcp reset  <n>   Reset connection\n"
"tcp retry  [<n>] Set or display the retry count\n"
"tcp status [/v=<video>] [/<columns> [/d=<display_multiple> [/f=<frozen>\n"
"           [/l=<linger>] [/n=<new> [/s=<sort> [/t=<refresh_ticks>\n"
"           [<refresh_time>]]]]]]]]\n"
"           <video>: 0 - VGA screen, 1 - VT100 sequences, 2 - stdout\n"
"                 Display summary status of all connections\n"
"tcp status <n>   Display detailed status for connection <n>\n"
"tcp window [<n>] Set or display Window size\n");
	return 0;
}

/* CMDPARSE.C
*/

/* Call a subcommand based on the first token in an already-parsed line */
int subcmd(struct scmds far *tab,int argc,char *argv[],void *p)
{
	int rslt;
	struct scmds far *cmdp;

	/* Strip off first token and pass rest of line to subcommand */
	if (argc < 2) {
		goto print_options;
	}
	argc--;
	argv++;
	for(cmdp = tab;cmdp->name[0] != 0;cmdp++){
		if(fstrcmp(argv[0],cmdp->name) == 0){
			rslt = (*cmdp->func)(argc,argv,0);
			if (rslt < 0)
				printf("Command failed: %s\n",argv[0],p);
			return(rslt);
		}
	}
	print_options:
	dohelp(0,0,0);
	return -1;
}

int fstrcmp(char *str1,char far *str2)
{
	char ch1,ch2;

	while ((ch1 = *str1++) != 0 && (ch2 = *str2++) != 0) {
		if (ch1 != ch2)
			return 1;
	}
	return 0;
}

/* Convert an internet address (in host byte order) to a dotted decimal ascii
 * string, e.g., 255.255.255.255\0
 */
char *inet_ntoa(DWORD a)
{
	static char buf[16];
	IP_TAB *pip;

	for (pip = ip_tab;pip < ip_tab + num_ip;++pip) {
		if (a == pip->ip_adr) {
			return pip->name;
		}
	}
	sprintf(buf,"%u.%u.%u.%u",
		hibyte(hiword(a)),
		lobyte(hiword(a)),
		hibyte(loword(a)),
		lobyte(loword(a)) );
	return buf;
}

char *inet_ntoa2(IP_TAB *pip,int32 a)
{
	static char buf[16];

	if (pip)
		sprintf(buf,"%.*s",NAMELEN,pip->name);
	else
		sprintf(buf,"%u.%u.%u.%u",hibyte(hiword(a)),lobyte(hiword(a)),
								  hibyte(loword(a)),lobyte(loword(a)));
	return buf;
}

IP_TAB *getipname(DWORD a)
{
	IP_TAB *pip;

	for (pip = ip_tab;pip < ip_tab + num_ip;++pip) {
		if (a == pip->ip_adr) {
			return pip;
		}
	}
	return 0;
}

/* Convert a socket (address + port) to an ascii string of the form
 * aaa.aaa.aaa.aaa:ppppp
 */
char *psocket1(SOCKET far *s,int width)
{
	static char buf[30];
	int len;

	len = sprintf(buf,"%.*s:%u",NAMELEN,inet_ntoa(s->address),s->port);
	if (len > width)
		strcpy(buf + width - 1,">");
	return buf;
}

char *psocket2(IP_TAB *pip,SOCKET *s,int width)
{
	static char buf[60];
	int len;

	len = sprintf(buf,"%s:%u",inet_ntoa2(pip,s->address),s->port);
	if (len > width)
		strcpy(buf + width - 1,">");
	return buf;
}

char *err(unsigned errcode)	/* return errorcode string */
{
	static char unk[30];
	static char *errs[] = {
		"No error",
		"Connection already exists",
		"Connection does not exist",
		"Connection closing",
		"No memory for TCB or buffer creation",
		"Would block",
		"Protocol or mode not supported",
		"Invalid arguments"
	};

	if (errcode > INVALID) {
		sprintf(unk,"Unknown error %u",errcode);
		return unk;
	}
	return errs[errcode];
}

// Functions to write to correct output device
