//
//   $Id: attrib.c 1.10 2002/10/16 21:38:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   ATTRIB.C

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
	Datalight Confidential and Proprietary

	This program displays and sets file attributes.

   HISTORY:

	11-21-2001  pb  Fixed the /s functionality.
	06-29-2000  td  Created using snippets of old source

**********************************************************/

#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dllfn.h"
#include "stdc.h"
#include "dosver.h"
#include "dlpath.h"
#include "fatworld.h"

#define ATTRIB 1
#include "dosmsg.c"

#include "attrib.h"
#include "attrib.pt"

char signon[] = "ATTRIB %s %s\n%s\n\n";
bool fIsFat32World;
bool fSuccess = FALSE;
bool ContainsWildcards = FALSE;
bool do_sub_dirs = FALSE, modify = FALSE;
int Quiet = FALSE;
bool ResetHidden = FALSE, ResetSystem = FALSE;
bool NoErrorMsg = TRUE;

unsigned add_attr = 0, sub_attr = -1;
unsigned uAttributes;
int FFAttrib = (A_ANYFILE | A_SUBDIR);
unsigned count;

char LongFileName[LFN_MAX_PATH];
char ShortFileName[LFN_MAX_PATH];
char ShortNamePath[LFN_MAX_PATH];

int iInitialDrive;
static char szInitialDirectory[LFN_MAX_PATH];

int main( int argc, char *argv[] )
{
	unsigned uIndex;
	char plus,c;
   static char szFullMask[LFN_MAX_PATH];      	// first path found in args
   static char ParseNamePath[LFN_MAX_PATH];
	bool fNameSet = FALSE;
	char * szTemp;
	bool fSuccessful;
	int iError;


	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();


	//  save the current drive and directory
	//
   dlGetCurrentDrive( &iInitialDrive );
	szInitialDirectory[0] = iInitialDrive + 'A';
	szInitialDirectory[1] = ':';
	szInitialDirectory[2] = '\\';
	szInitialDirectory[3] = 0;
   SmartGetCurrentDirectory( iInitialDrive+1, &(szInitialDirectory[3]) );


   // walk the arglist, picking up switches, plusses and minuses
   //
	for(uIndex=1; uIndex<argc; uIndex++)
	{
      LFNStripArgQuotes( argv[uIndex] );

		plus = argv[uIndex][0];
		c = toupper( argv[uIndex][1] );

		if( plus == '/' )                // switch condition
		{
         switch( c )
         {
            case '?':
            case 'H':
                     do_help();
         				break;
            case '[':
         				Quiet = TRUE;
         				break;
            case 'S':
         				do_sub_dirs = TRUE;
         				break;
            default :
         				error( ERR_INVALID_SWITCH, argv[uIndex] );
         				break;
         }
		}
		else if( plus == '+' )           // set attribute
		{
			modify = TRUE;
         switch( c )
			{
				case 'A':	add_attr |= A_ARCHIVE; break;
				case 'C':	sub_attr  = 0; break;
				case 'H':	add_attr |= A_HIDDEN;  ResetHidden = TRUE;  break;
				case 'S':	add_attr |= A_SYSTEM;  ResetSystem = TRUE;  break;
				case 'R':	add_attr |= A_READONLY; break;

				default:
					error( ERR_PARM_FORMAT, argv[uIndex] );
			}
		}
		else if( plus == '-' )           // clear attribute
		{
			modify = TRUE;
         switch( c )
			{
				case 'A':	sub_attr ^= A_ARCHIVE; break;
				case 'C':	sub_attr  = 0; break;
				case 'H':	sub_attr ^= A_HIDDEN;  ResetHidden = TRUE;  break;
				case 'S':	sub_attr ^= A_SYSTEM;  ResetSystem = TRUE;  break;
				case 'R':	sub_attr ^= A_READONLY; break;

				default:
					error( ERR_PARM_FORMAT, argv[uIndex] );
			}
		}
		else if(   ( plus == '"' )           // Parameter value not allowed
              || ( plus == ';' )
              || ( plus == '[' )
              || ( plus == ']' ) )
      {
			error( ERR_PARM_NOT_ALLOWED, argv[uIndex] );
      }
		else if( plus == '=' )              // Parameter value not allowed
      {
			error( ERR_INVALID_KEYWORD, argv[uIndex] );
      }
      else
      {
         // Per MS compatibility, use only the first of multiple paths
         //
         if ( !fNameSet )
         {
            strcpy( szFullMask, argv[uIndex] );
				fNameSet = TRUE;
         }
      }
	}

   // If we have some modify commands but they logically cancel, error
   //
   if( modify )
   {
      if( add_attr == ~sub_attr )
      {
			error( ERR_PARM_FORMAT, " " );
      }
   }


	DisplaySignOnMessage();


	//  Determine if the drive was valid
	//
	if( szFullMask[1] == ':' )
	{
      // Save first char, restore if we have an error
      //
      c = szFullMask[0];

      // tack on a *.* if needed, for output compatibility
      //
      if( !szFullMask[2] )
      {
         strcat( szFullMask, "*.*" );
      }

      if( c == '`' )
      {
			error( ERR_BAD_PATH, szFullMask );
      }
      else if( c == '@' )
      {
			error( ERR_FILE_NOT_FOUND, szFullMask );
      }

		szFullMask[0] = toupper( szFullMask[0] );
		if( (szFullMask[0] >= 'A') && (szFullMask[0] <= 'Z') )
		{
			if( !IsValidDrive(szFullMask[0] - 'A') )
			{
            szFullMask[0] = c;
				error( ERR_INVALID_DRIVE, szFullMask );
			}
		}
		else
		{
         szFullMask[0] = c;
			error( ERR_INVALID_DRIVE, szFullMask );
		}
	}


	// count keeps track of how many files we modified, and zero files
   // generates an error.  So initialize it!
   //
   count = 0;

	szTemp = szFullMask;
	if( szTemp[1] == ':' )
	{
		szTemp += 2;
	}


	// MS peculiarity -- no path param is an assumption of "*.*"
   // If that is the case, no reason to re-walk the arglist
   //
	if( *szTemp == 0 )
   {
		strcat( szFullMask, "*.*" );
   }


	//  Change to the appropriate drive
	//
	if( szFullMask[1] == ':' )
	{
		dlSetCurrentDrive( szFullMask[0] - 'A' );
	}


	if( strchr( szFullMask, '\\' ) )
   {
		strcpy( ShortNamePath, szFullMask );
      CopyNamePart( ParseNamePath, ShortNamePath );
      RemoveName( ShortNamePath );
		if( *ShortNamePath == 0 )
		{
			strcat( ShortNamePath, "\\" );
		}
      fSuccessful = SmartChangeDirectory( ShortNamePath );
		if( !fSuccessful )
		{
			error( ERR_BAD_PATH, szFullMask );
		}
   }
   else
   {
      CopyNamePart( ParseNamePath, szFullMask );
   }


	ParseAttribFiles( ParseNamePath );

	//  No error if we managed to get at least one hit
   //
 	iError = dlCheckDOSError();
   if( (!count) && (iError) )
   {
		if( iError == ERR_NOTFOUND )
  		{
  			error( ERR_FILE_NOT_FOUND, ParseNamePath );
  		}
  		else if( iError == ERR_LASTFILE )
  		{
  			error( ERR_FILE_NOT_FOUND, ParseNamePath );
  		}
  		else
  		{
  			error( ERR_BAD_PATH, ParseNamePath );
  		}
   }

	//  Restore the starting drive and directory
	//
	dlSetCurrentDrive( iInitialDrive );
   SmartChangeDirectory( szInitialDirectory );

   return(0);
}

// This function is highly recursive, so we don't pass much on the stack
// and we use primarily global variables.
// The local struct ffblk is a necessary evil to allow depth parsing
//
void ParseAttribFiles( char * szNameMask )
{
   FIND ff;
	unsigned uIndex;


   // Initialize those global variables for local use
   //
   FFAttrib = ( A_ANYFILE | A_SUBDIR );
   fSuccess = FALSE;
   ContainsWildcards = IsWild( szNameMask );

   // Depth first search for MS compatibility
   //
   if ( do_sub_dirs )
   {
      fSuccess = SmartFindFirst( A_SUBDIR, "*.*", &ff );
      while ( fSuccess )
      {
         if ( ff.attr & A_SUBDIR )
         {
            if ( ff.name[0] != '.' )
            {
               SmartChangeDirectory ( ff.name );
               ParseAttribFiles( szNameMask );
               SmartChangeDirectory ( ".." );
            }
         }
         fSuccess = SmartFindNext( &ff );
      }
      SmartFindClose( &ff );

      // When doing sub directories ("/S")
      // we never change the attribute on a subdirectory name
      // so adjust our search attribute to do only files
      //
      FFAttrib = A_ANYFILE;
   }


	fSuccess = SmartFindFirst( FFAttrib, szNameMask, &ff );
   while ( fSuccess )
   {
      count++;
      SmartGetFileAttributes( ff.name, &uAttributes );

      if ( ff.name[0] != '.' )
      {
         if( SmartExpandPath( FULLPATH_LONGNAME, ff.name, ShortNamePath ) )
         {
            CopyNamePart( LongFileName, ShortNamePath );
            SmartExpandPath( FULLPATH_SHORTNAME, ff.name, ShortNamePath );
            CopyNamePart( ShortFileName, ShortNamePath );
            RemoveName( ShortNamePath );
   			uIndex = strlen( ShortNamePath );
   			if( (uIndex) && (ShortNamePath[uIndex-1] == '\\') )
   			{
   				ShortNamePath[uIndex-1] = 0;
   			}

            if ( modify )
            {
               NoErrorMsg = TRUE;

               // Display warning messages and skip modify if appropriate
               //
               if( uAttributes & A_SYSTEM )
               {
                  if( !ResetSystem )
                  {
                     msg( ERR_NOT_RESETTING_SYS, ShortNamePath, LongFileName );
                     NoErrorMsg = FALSE;
                  }
               }
               else if( uAttributes & A_HIDDEN )
               {
                  if( !ResetHidden )
                  {
                     msg( ERR_NOT_RESETTING_HID, ShortNamePath, LongFileName );
                     NoErrorMsg = FALSE;
                  }
               }

               if (NoErrorMsg)
               {
                  uAttributes &= A_ANYFILE;     // clear A_SUBDIR and A_VOLUME flags
               	uAttributes |= add_attr;      // set user specified flags
            	   uAttributes &= sub_attr;      // clear user specified flags
                  SmartSetFileAttributes( ff.name, uAttributes );
               }
            }
            else
            {
               // per MS compatibility, whenever there are wildcards don't
               // display subdirectory name attributes
               //
               if (   !ContainsWildcards
                   || !(ff.attr & A_SUBDIR) )
               {
                  DisplayFileAttributes( uAttributes, ShortFileName, ShortNamePath,
                        LongFileName );
               }
            }
         }
         else
         {
            SmartFindClose( &ff );
            error( ERR_CANNOT_OPEN, szNameMask );
         }
      }

      fSuccess = SmartFindNext( &ff );
   }
   SmartFindClose( &ff );
}

// Naturally, different versions of DOS display differently.
//
// The initial portion (the attributes) is the same.  Following that,
// MS 6.22 displays the complete path and filename.
//
//   A   H      C:\TEST\SUBDIR\1.TXT
//
// MS 7.1 displays the short filename, then the complete path and filename
//  *note* the path is a "shortname" path!!!
//
//   A   H      THISIS~1.TXT  C:\TEST\SUBDIR~1\ThisisaLongFilename.TXT
//
void DisplayFileAttributes( unsigned uAttributes, char * ShortFileName,
      char * ShortNamePath, char * LongFileName )
{
	static char szPadding[] = "              ";
	unsigned uPaddingIndex;

  	show_attr( uAttributes );

	if( fIsFat32World)
   {
		memset( szPadding, ' ', sizeof(szPadding) );
		uPaddingIndex = strlen( ShortFileName );
   	szPadding[( 14 - uPaddingIndex )] = 0;
   	printf( "%s%s%s\\%s\n", ShortFileName, szPadding, ShortNamePath,
   	      LongFileName );
   }
   else
	{
	   printf( "%s\\%s\n", ShortNamePath, ShortFileName );
   }
}

void show_attr( unsigned attr )
{
	/* some space at the beginning */
	printf("  %c  %c%c%c     ",
		(attr & A_ARCHIVE)  ? 'A' : ' ',		/* Archive */
		(attr & A_SYSTEM)   ? 'S' : ' ',		/* System */
		(attr & A_HIDDEN)   ? 'H' : ' ',		/* Hidden */
		(attr & A_READONLY) ? 'R' : ' '		/* Read-only */
		);
}

void DisplaySignOnMessage( void )
{
	if( !Quiet )
	{
		if( fIsFat32World )
		{
			printf( signon, SHORTVERSION, BUILDVERSION, COPYRIGHT );
		}
		else
		{
			printf( signon, SHORTVERSION622, BUILDVERSION, COPYRIGHT );
		}
	}
}

void do_help( void )
{
	DisplaySignOnMessage();
	printf( USAGE );
	exit( 1 );
}

void error( int msg, ... )
{
	extern char *msgs[];

	va_list arg_ptr;
	va_start( arg_ptr, msg );
	vfprintf( STDERR, msgs[msg], arg_ptr );
	fprintf( STDERR, "\n" );

	dlSetCurrentDrive( iInitialDrive );
   SmartChangeDirectory( szInitialDirectory );

	exit( 1 );
}

void msg( int msg, ... )
{
	extern char *msgs[];

	va_list arg_ptr;
	va_start( arg_ptr, msg );
	vfprintf( STDOUT, msgs[msg], arg_ptr );
	fprintf( STDOUT, "\n" );
}
