;
;   $Id: ABSRDWR.ASM 1.2 2002/10/16 21:39:42Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  ABSRDWR.ASM
;
;  Copyright (c) 2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  History:
;
;  01-25-2001  bt  Created
;



.model small


.data?


    extrn _fInCache:word

	public _fABSRDWRIsRead
    _fABSRDWRIsRead	dw	?

    fInt25Patched	dw	?
    fInt26Patched	dw	?

.data

    extrn _Dispatcher:word
    extrn _fInFDHD:word


    ;  For easy reference, save a local pointer to our INT 25h handler
    ;
	public _lpInt25Handler
    _lpInt25Handler	label	dword
    LocalInt25Offset	dw	_Int25Handler
    LocalInt25Segment	dw	@Code


    ;  pointer to the previous INT 25h handler
    ;
	public _lpOldInt25Handler
    _lpOldInt25Handler	label	dword
    OldInt25Offset	dw	_Int25Handler
    OldInt25Segment	dw	@Code


    ;  For easy reference, save a local pointer to our INT 26h handler
    ;
	public _lpInt26Handler
    _lpInt26Handler	label	dword
    LocalInt26Offset	dw	_Int26Handler
    LocalInt26Segment	dw	@Code


    ;  pointer to the previous INT 26h handler
    ;
	public _lpOldInt26Handler
    _lpOldInt26Handler	label	dword
    OldInt26Offset	dw	_Int26Handler
    OldInt26Segment	dw	@Code


    ;  pointer to the previous int ?? handler (changes for different ints)
    ;
    extrn _lpOldHandler:dword


.code

	ASSUME	CS:@Code,DS:NOTHING

	extrn	_ABSRDWRDispatch:proc
	extrn	DoServiceCall:proc


.186


;  _INT26Handler
;
;  This handler gets called everytime that there is an INT 26h
;
comment ~
void INT26Handler( void )
{}
~
    public _INT26Handler
_INT26Handler:


	;  Tell the dispatcher to use the ABSRDWR dispatcher
	;
DoInt26:
	push	ax
	mov	ax, offset _ABSRDWRDispatch
	mov	cs:_Dispatcher, ax
	mov	ax, word ptr cs:_lpOldInt26Handler
	mov	word ptr cs:_lpOldHandler, ax
	mov	ax, word ptr cs:_lpOldInt26Handler+2
	mov	word ptr cs:_lpOldHandler+2, ax
	pop	ax


	;  Jump to the dispatcher
	;
	mov	cs:_fABSRDWRIsRead, 0
	jmp	DoServiceCall



;  _INT25Handler
;
;  This handler gets called everytime that there is an INT 25h
;
comment ~
void INT25Handler( void )
{}
~
    public _INT25Handler
_INT25Handler:


	;  Tell the dispatcher to use the ABSRDWR dispatcher
	;
DoInt25:
	push	ax
	mov	ax, offset _ABSRDWRDispatch
	mov	cs:_Dispatcher, ax
	mov	ax, word ptr cs:_lpOldInt25Handler
	mov	word ptr cs:_lpOldHandler, ax
	mov	ax, word ptr cs:_lpOldInt25Handler+2
	mov	word ptr cs:_lpOldHandler+2, ax
	pop	ax


	;  Jump to the dispatcher
	;
	mov	cs:_fABSRDWRIsRead, 1
	jmp	DoServiceCall



;  InstallInt25Vector
;
;  Save the current int 25h vector and set the int 25h vector to
;  our handler
;
comment ~
void InstallInt25Vector( void )
{}
~
	ASSUME	DS:@Data
    public	_InstallInt25Vector
_InstallInt25Vector:


IF 0
	;  Set ES:BX to the int 25h vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 25h * 4


	;  Save the current int 25h vector
	;
	pushf
	cli
	mov	ax, es:[bx]
	mov	OldInt25Offset, ax
	mov	ax, es:[bx+2]
	mov	OldInt25Segment, ax


	;  Set our int 25h vector
	;
	mov	ax, LocalInt25Offset
	mov	es:[bx], ax
	mov	ax, LocalInt25Segment
	mov	es:[bx+2], ax
	popf
ELSE
	push	bx
	mov	ah, 35h
	mov	al, 25h
	int	21h
	mov	OldInt25Offset, bx
	mov	ds:OldInt25Segment, es
	pop	bx
	push	ds
	pushf
	cli
	mov	ah, 25h
	mov	al, 25h
	lds	dx, _lpInt25Handler
	int	21h
	popf
	pop	ds
ENDIF

	;  Set the flag indicating that the INT 25h interface
	;  has been patched
	;
	mov	fInt25Patched, 1


	;  All done, return
	;
	ret


;  InstallInt26Vector
;
;  Save the current int 26h vector and set the int 26h vector to
;  our handler
;
comment ~
void InstallInt26Vector( void )
{}
~
	ASSUME	DS:@Data
    public	_InstallInt26Vector
_InstallInt26Vector:


IF 0
	;  Set ES:BX to the int 26h vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 26h * 4


	;  Save the current int 26h vector
	;
	pushf
	cli
	mov	ax, es:[bx]
	mov	OldInt26Offset, ax
	mov	ax, es:[bx+2]
	mov	OldInt26Segment, ax


	;  Set our int 26h vector
	;
	mov	ax, LocalInt26Offset
	mov	es:[bx], ax
	mov	ax, LocalInt26Segment
	mov	es:[bx+2], ax
	popf
ELSE
	push	bx
	mov	ah, 35h
	mov	al, 26h
	int	21h
	mov	OldInt26Offset, bx
	mov	ds:OldInt26Segment, es
	pop	bx
	push	ds
	pushf
	cli
	mov	ah, 25h
	mov	al, 26h
	lds	dx, _lpInt26Handler
	int	21h
	popf
	pop	ds
ENDIF


	;  Set the flag indicating that the INT 26h interface
	;  has been patched
	;
	mov	fInt26Patched, 1


	;  All done, return
	;
	ret


	END
