//
//   $Id: CACHINIT.C 1.18 2003/02/18 17:40:18Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  CACHINIT.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  06-28-2001  bt  Created
//


//  Borland libraries
//
#include <stdio.h>
#include <mem.h>
#include <string.h>


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dllfn.h"
#include "dlapp.h"
#include "dlxms.h"
#include "windows.h"
#include "fatworld.h"
#include "dosver.h"
#include "bldver.h"

#include "cache.h"


#if COMM_PORT_LOGGING
#include "dl8250.h"
#endif


//  Prototypes
//
#include "cachinit.pt"
#include "cachres.pt"
#include "sdreq.pt"
#include "i2f15.pt"
void ServiceFDHD( void );
void StrategyFDHD( void );
void ServiceCDEX( void );
void StrategyCDEX( void );
void PASCAL InstallCtrlAltDelHandler(void);
void PASCAL TrapCtrlAltDel(void);

void exit(int);
char toupper(char c);
long atol(char *);


//  Program strings
//
#define DISK_CACHE		1
#include "dosmsg.c"


//
//
#include "cachinit.h"


#if COMM_PORT_LOGGING
uchar TXBuffer[200];
#endif


bool fIsFat32World;
bool fInWindows;
bool fSwitches[MAX_BOOLEAN_SWITCHES];


extern ulong ulElementSize;
extern ulong ulBufferSize;
extern ulong ulInitCacheSizeKB;
extern ulong ulWinCacheSizeKB;
extern INT13_DRIVE_INFO Int13DriveInfo[26];
extern uchar ucDriveInfoEntries;
extern uchar ucFirstCDROMEntry;
extern bool fDontWriteBeforeCommand;
extern ulong ulCacheHits;
extern ulong ulCacheMisses;


//  Start of CACHE
//
uchar main( int argc, char * argv[] )
{
	uchar ucExitCode = ERR_NONE;
	extern LPLOL lpLOL;
	extern unsigned far * lpCurrentPSPSegment;
#if COMM_PORT_LOGGING
	bool fSuccessful;
#endif


	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();


	//  Determine if we are in Windows
	//
	fInWindows = dlInWindows();
	if( fInWindows )
	{
		printf( szWindowsIsRunning );
		exit(ERR_WINDOWS);
	}


	//  Create a pointer to the current PSP in the DOS data segment
	//
	dlGetLOLPointer( &lpLOL );
	lpCurrentPSPSegment = MK_FP( FP_SEG(lpLOL), 0x330 );


	//  Parse the command line
	//
	DoParseCommandLine( argc-1, &argv[1] );


	//  Determine if we should display the signon message and if
	//  so display it
	//
	DisplaySignonMessage();


	//  Display the cache status message
	//
	DisplayStatusMessage();


	//  Install the control alt delete handler
	//
	InstallCtrlAltDelHandler();
	TrapCtrlAltDel();


#if COMM_PORT_LOGGING

	//  Initialize the comm port
	//
	fSuccessful = comm_open( 115, DEFPARMS, DEFPORT, DEFIRQ,
			sizeof(TXBuffer), TXBuffer );

#endif


	//  Terminate but stay resident
	//
	GoResident();


	//  Set the return code and exit
	//
	return ucExitCode;
}


//  Terminate but stay resident
//
void PASCAL GoResident( void )
{
	extern unsigned _psp;
	LPPSP lpPSP;
	LPMCB lpMCB;
	unsigned uAllocatedPara;


	//  Get the address of the PSP
	//
	lpPSP = MK_FP( _psp, 0 );


	//  Get the address of our MCB
	//
	lpMCB = MK_FP( _psp - 1, 0 );


	//  Free the environment
	//
	dlFreeMem( lpPSP->env_seg );


	//  Get the number of paragraphs currently
	//  allocated to us
	//
	uAllocatedPara = lpMCB->para_cnt;


	//  Terminate our program preserving all of
	//  memory that we are currently using
	//
	asm	mov	ax, 3100h
	asm	mov	dx, uAllocatedPara
	asm	int	21h
}


//  Display the cache status message
//
void PASCAL DisplayStatusMessage( void )
{
	ulong ulTemp;
	uchar ucIndex;
	unsigned uElementSize = 0;
	unsigned uNumberOfElements = 0;
	uchar ucStatusByte;
	unsigned uStatusWord;
#if COUNT_READS_AND_WRITES
	ulong ulCDReadRequests;
	ulong ulCDWriteRequests;
	ulong ulHDReadRequests;
	ulong ulHDWriteRequests;
#endif


	if( DoDisplayStatus() )
	{
		//  Get the cache size information
		//
		CacheGetSize( &uNumberOfElements, &uElementSize );
		ulElementSize = uElementSize;

#if COUNT_READS_AND_WRITES
		if( GetHDRequestCounts( &ulHDReadRequests, &ulHDWriteRequests ) )
		{
			printf("HD read requests:  %lu\n", ulHDReadRequests );
			printf("HD write requests: %lu\n", ulHDWriteRequests );
		}
		if( GetCDRequestCounts( &ulCDReadRequests, &ulCDWriteRequests ) )
		{
			printf("CD read requests:  %lu\n", ulCDReadRequests );
			printf("CD write requests: %lu\n", ulCDWriteRequests );
		}
#endif

		if( DoDisplayMoreStatus() )
		{
			printf( szExtraStatus, uNumberOfElements, uElementSize,
					ulCacheHits, ulCacheMisses );
		}


		ulTemp = (ulong)ulElementSize * uNumberOfElements;
		printf( szCachSize, ulTemp );
		printf("\n");
		printf( szStatusHeader );
		for( ucIndex = 0; ucIndex < 26; ucIndex++ )
		{
			ucStatusByte = 0xff;
			CacheGetSetStatus( ucIndex, ACTION_GET_STATUS, &ucStatusByte );
			if( ucStatusByte != 0xff )
			{
				if( ((ucStatusByte & 0x80) == 0) ||
						((ucStatusByte & 0x40) == 0) )
				{
					printf( szStatusEntry, 'A' + ucIndex,
							GetYesNoString( ((ucStatusByte & 0x80) == 0) ),
							GetYesNoString( ((ucStatusByte & 0x40) == 0) ),
							szNo );
				}
			}
		}
		CacheGetCommandFlushFlag( &uStatusWord );
		if( uStatusWord & 0x0100 )
		{
			printf(szCommitBeforeCommand, "");
		}
		else
		{
			printf(szCommitBeforeCommand, szNot );
		}
		printf("\n\n");
		printf( szForHelp );
	}
}


//  Parse the command line
//
void PASCAL DoParseCommandLine( int argc, char *argv[] )
{
	bool fResidentAlready;
	bool fDisableReadCache;
	bool fEnableWriteCache;
	bool fSuccessful;
	unsigned uIndex;
	char * szArgs;
	uchar ucDOSDriveNumber;
	char cDrive;
	uchar ucStatusByte;
	bool fDontShowStatus;
	static ARGDEF CacheOpts[] =
	{
		{ BOOL_SWITCH, &fSwitches[HIDE_SIGNON],            '[', 0 }, //  0
		{ BOOL_SWITCH, &fSwitches[NO_CD_CACHE],            'U', 0 }, //  1
		{ BOOL_SWITCH, &fSwitches[DO_FLUSH],               'C', 0 }, //  2
		{ BOOL_SWITCH, &fSwitches[DO_INVALIDATE],          'R', 0 }, //  3
		{ BOOL_SWITCH, &fSwitches[WRITE_BEFORE_RETURN],    'F', 0 }, //  4
		{ BOOL_SWITCH, &fSwitches[NO_WRITE_BEFORE_RETURN], 'N', 0 }, //  5
		{ BOOL_SWITCH, &fSwitches[DISPLAY_STATUS],         'V', 0 }, //  6
		{ BOOL_SWITCH, &fSwitches[DISPLAY_MORE_STATUS],    'S', 0 }, //  7
		{ BOOL_SWITCH, &fSwitches[DONT_DISPLAY_STATUS],    'Q', 0 }, //  8
		{ BOOL_SWITCH, &fSwitches[DONT_LOAD_HIGH],         'L', 0 }, //  9
		{ BOOL_SWITCH, &fSwitches[NO_WRITE_CACHING],       'X', 0 }, //  10
//
//  These switches disabled if resident.  When Inserting switches
//  you must change the code below that disables them when resident
//
		{ LONG_SWITCH, &ulElementSize,                     'E', 0 }, //  11
		{ LONG_SWITCH, &ulBufferSize,                      'B', 0 }, //  12
		{ 0 }
	};


	//  Determine if the program is already loaded
	//
	fResidentAlready = CacheInstallCheckAndStats( &ulCacheHits,
			&ulCacheMisses );


	//  Process all the boolean switches in the command line
	//
	if( fResidentAlready )
	{
		CacheOpts[11].type = 0;
	}
	SetParseFlags(PARSEF_NOARGSOK | PARSEF_MULTIPASS);
	argc = ParseCmdline(argc, &argv[0], CacheOpts);


	//  Check for conflicting switches
	//
	if( DoWriteBeforeCommand() && NoWriteBeforeCommand() )
	{
		printf(szConflictingSwitches);
		exit(ERR_CONFLICTING_SWITCHES);
	}
	if( DoDisplayStatus() && DontDisplayStatus() )
	{
		printf(szConflictingSwitches);
		exit(ERR_CONFLICTING_SWITCHES);
	}


 	//  Determine if we are not loaded
	//
	if( !fResidentAlready )
	{
		//  Determine if we are not loaded and want to display more
		//  status information
		//
		if( DoDisplayMoreStatus() )
		{
			Usage();
		}


		//  Set the init cache size from the command line
		//
		ProcessInitCacheSize( argc, argv );


		//  Determine the total size of the cache, the buffer size, and the
		//  element size
		//
		DetermineCacheSize();


      //  Initialize the cache module
      //
      fSuccessful = InitializeDiskCache(
               (unsigned) ((ulInitCacheSizeKB * 1024)/ulElementSize),
               (unsigned) ulElementSize,
               (unsigned) ulBufferSize );
		if( !fSuccessful )
		{
			printf(szNotEnoughXMS);
			exit(ERR_LOW_XMS);
		}


		//  Initialize the int 13 drive info list
		//
		InitInt13DriveList();


		//  Determine if the CD caching module is being loaded
		//
		if( DoCDCache() )
		{
			//  Add the CDROMs to the drive list
			//
			InitCDROMList();
		}


		//  Initialize the Int 2fh interface
		//
		InstallInt2fVector();


		//  Enable the int 28h idle handler
		//
		InstallInt28Vector();


		//  Enable the int 13h disk access handler
		//
		InstallInt13Vector();


		//  Enable the int 25h and int 26h abs read/write handler
		//
		InstallInt25Vector();
		InstallInt26Vector();


		//  Enable the int 21h filter
		//
		InstallInt21Vector();
	}


	//  Process the drive letter switches
	//
	for( uIndex = 0; uIndex < argc; uIndex++ )
	{
		szArgs = LFNSkipWhite( argv[uIndex] );
		while( *szArgs )
		{
			szArgs = LFNSkipWhite( szArgs );
			cDrive = toupper(szArgs[0]);
			if( (cDrive >= 'A') && (cDrive <= 'Z') )
			{
				ucDOSDriveNumber = cDrive - 'A';
				szArgs++;

				fDisableReadCache = FALSE;
				fEnableWriteCache = FALSE;

				if( szArgs[0] == '+' )
				{
					fEnableWriteCache = TRUE;
					szArgs++;
				}
				else if( szArgs[0] == '-' )
				{
					fDisableReadCache = TRUE;
					szArgs++;
				}

				fSuccessful = CacheDriveCacheable(ucDOSDriveNumber);
				if( fSuccessful )
				{
					CacheGetSetStatus( ucDOSDriveNumber,
							ACTION_GET_STATUS, &ucStatusByte );
					fSuccessful = (ucStatusByte != 0xff);
				}


				if( fSuccessful )
				{
					if( fDisableReadCache )
					{
						CacheGetSetStatus( ucDOSDriveNumber,
								ACTION_DISABLE_WRITE_CACHE, &ucStatusByte );
						CacheGetSetStatus( ucDOSDriveNumber,
								ACTION_DISABLE_READ_CACHE, &ucStatusByte );
					}
					else
					{
						CacheGetSetStatus( ucDOSDriveNumber,
								ACTION_ENABLE_READ_CACHE, &ucStatusByte );
						CacheGetSetStatus( ucDOSDriveNumber,
								ACTION_DISABLE_WRITE_CACHE, &ucStatusByte );

						if( fEnableWriteCache )
						{
							CacheGetSetStatus( ucDOSDriveNumber,
									ACTION_ENABLE_WRITE_CACHE, &ucStatusByte );
						}
					}
				}
				else
				{
					printf(szBadDrive);
				}
			}
			else
			{
				OptError( szArgs );
			}
		}
	}


	//  Determine if the user wants to disable write caching on all
	//  drives
	//
	if( DisableAllWriteCaching() )
	{
		for( uIndex = 0; uIndex < 26; uIndex++ )
		{
			CacheGetSetStatus( (uchar)uIndex,
					ACTION_DISABLE_WRITE_CACHE, &ucStatusByte );
		}
	}


	//  If we are already resident, process some of the allowed
	//  switches ignoring what is not recognized and show the
	//  status
	//
	if( fResidentAlready )
	{
		//  Determine if we should display the signon message and if
		//  so display it
		//
		DisplaySignonMessage();
		fDontShowStatus = FALSE;


		//  Determine if the user wanted to flush the cache
		//
		if( DoFlushCache() )
		{
			CacheCommit();
			fDontShowStatus = TRUE;
		}


		//  Determine if the user wanted to invalidate the cache
		//
		if( DoInvalidateCache() )
		{
			CacheRestart();
			fDontShowStatus = TRUE;
		}


		//  Detemine if the user wants to change the command flush
		//  settings
		//
		if( DoWriteBeforeCommand() )
		{
			CacheSetCommandFlushFlag( 0x01 );
		}
		else if( NoWriteBeforeCommand() )
		{
			CacheSetCommandFlushFlag( 0x00 );
		}


		//  Display the cache status
		//
		if( (!DontDisplayStatus()) && (!fDontShowStatus) )
		{
			fSwitches[DISPLAY_STATUS] = 1;
		}
		DisplayStatusMessage();


		exit(ERR_STATUS);
	}
   else
   {
      //  Detemine if the user wants to change the command flush
      //  settings
      //
      if( DoWriteBeforeCommand() )
      {
         fDontWriteBeforeCommand = FALSE;
      }
      else if( NoWriteBeforeCommand() )
      {
         fDontWriteBeforeCommand = TRUE;
      }
   }
}


//  Parse the command line
//
void PASCAL ProcessInitCacheSize( int argc, char *argv[] )
{
	unsigned uIndex;
	char * szArgs;
	char cDrive;
	char * szInitBufferSize;
	bool fSetInitCacheSize = FALSE;
	char cTemp;


	//  Process the drive letter switches
	//
	for( uIndex = 0; uIndex < argc; uIndex++ )
	{
		szArgs = LFNSkipWhite( argv[uIndex] );
		while( *szArgs )
		{
			szArgs = LFNSkipWhite( szArgs );
			cDrive = toupper(szArgs[0]);
			if( (cDrive >= 'A') && (cDrive <= 'Z') )
			{
				szArgs++;
				if( szArgs[0] == '+' )
				{
					szArgs++;
				}
				else if( szArgs[0] == '-' )
				{
					szArgs++;
				}
			}
			else
			{
				//  Process the init buffer size
				//
				if( (szArgs[0] >= '0') && (szArgs[0] <= '9') )
				{
					if( fSetInitCacheSize )
					{
						OptError( szArgs );
					}

					szInitBufferSize = szArgs;
					while( (szArgs[0] >= '0') && (szArgs[0] <= '9') )
					{
						szArgs++;
					}
					if( (szArgs[0] != 0) && (szArgs[0] != ' ') )
					{
						OptError( szArgs );
					}
					cTemp = szArgs[0];
					szArgs[0] = 0;
					ulInitCacheSizeKB = (ulong)(atol( szInitBufferSize ));
					fSetInitCacheSize = TRUE;
					szArgs[0] = cTemp;
					while( szInitBufferSize != szArgs )
					{
						szInitBufferSize[0] = ' ';
						szInitBufferSize++;
					}
				}
				else
				{
					OptError( szArgs );
				}
			}
		}
	}
}


//  Determine the total size of the cache, the buffer size, and the
//  element size
//
void PASCAL DetermineCacheSize( void )
{
	int iErrorCode;
	unsigned uIndex;
	unsigned uNumberOfElements;
	unsigned uXMSLargestFreeK;
	unsigned uXMSTotalFreeK;
	static unsigned uValidElementSizes[] = {
		1024, 2048, 4096, 8192,
	};


	//  Determine if the element size is a valid value.  If not, round
	//  up to the nearest valid value
	//
	for( uIndex = 0; uIndex < (ARRAY_ENTRIES(uValidElementSizes) - 1); uIndex++ )
	{
		if( ulElementSize <= (ulong)(uValidElementSizes[uIndex]) )
		{
			break;
		}
	}
	ulElementSize = uValidElementSizes[uIndex];


	//  Determine if the buffer size is a valid value.  If it is not
	//  a multiple of the element size, then round down.
	//
	ulBufferSize  = (ulBufferSize / ulElementSize);
	if( ulBufferSize == 0 )
	{
		ulBufferSize++;
	}
	ulBufferSize *= ulElementSize;


	//  Determine the amount of XMS in KB
	//
	iErrorCode = CheckXMMInstalled();
	if( iErrorCode == XMS_SUCCESS )
	{
		iErrorCode = GetXMSFree( &uXMSLargestFreeK, &uXMSTotalFreeK );
		if( uXMSLargestFreeK == MIN_XMS_KB )
		{
			printf( szNotEnoughXMS );
			exit(ERR_LOW_XMS);
		}
	}
	if( iErrorCode != XMS_SUCCESS )
	{
		printf( szNoXMS );
		exit(ERR_NO_XMS);
	}


	//  Compute the number of elements that will be in the cache
	//
	//  Note:  We are using the same type of logic as MS to figure out
	//         what size the cache should be.  It seems a bit convoluted
	//         until you realize that they don't change the element
	//         size from 8K to what the user specified on the command line
	//         until after the number of elements is calculated.
	//
	if( ulInitCacheSizeKB == 0 )
	{
		if( uXMSLargestFreeK > (6 * 1024) )
		{
			ulInitCacheSizeKB = 2 * 1024;
		}
		else if( uXMSLargestFreeK > (4 * 1024) )
		{
			ulInitCacheSizeKB = 2 * 1024;
		}
		else if( uXMSLargestFreeK > (2 * 1024) )
		{
			ulInitCacheSizeKB = 1024;
		}
		else if( uXMSLargestFreeK > 1024 )
		{
			ulInitCacheSizeKB = 1024;
		}
		else
		{
			ulInitCacheSizeKB = 2 * 1024;
		}
	}
	else
	{
		if( ulInitCacheSizeKB < MIN_XMS_KB )
		{
			ulInitCacheSizeKB = MIN_XMS_KB;
		}
	}
	uNumberOfElements = (unsigned)(ulInitCacheSizeKB / ELEMENT_SIZE_DEFAULT);


	//  Compute the size of the cache
	//
	ulInitCacheSizeKB  = uNumberOfElements;
	ulInitCacheSizeKB *= (ulElementSize / 1024);
}


//
//
void PASCAL InitInt13DriveList( void )
{
	LPDDT lpDDT;
	LPDDT622 lpDDT622;
	LPDPB lpDPB;
	bool fSuccessful;
	ulong ulSize;
	ulong ulHidden;
	ulong ulTemp;
	extern LPLOL lpLOL;
	extern LPDEV_HDR lpFDHDHDR;
	extern void far * lpOldStrategyFDHD;
	extern void far * lpOldServiceFDHD;
	unsigned uSectorsPerElement;


	//  Determine the number of 512 byte sectors that are in an element
	//
	uSectorsPerElement = (unsigned)(ulElementSize/512);


	//  Copy the FDHD device header and insert ours in the chain
	//
	dlGetDPBForDrive( 0, &lpDPB );
	_fmemcpy( lpFDHDHDR, lpDPB->device, sizeof(DEV_HDR) );
	lpFDHDHDR->next = lpLOL->first_dev.next;
	lpLOL->first_dev.next = lpFDHDHDR;
	lpFDHDHDR->strategy = (unsigned)(StrategyFDHD);
	lpFDHDHDR->service = (unsigned)(ServiceFDHD);
	lpOldStrategyFDHD =
			MK_FP( FP_SEG(lpDPB->device), lpDPB->device->strategy );
	lpOldServiceFDHD =
			MK_FP( FP_SEG(lpDPB->device), lpDPB->device->service );


	//  Get the address of the first DDT
	//
	dlGetFirstDDT( &lpDDT );


	//  Determine the number of drives using the INT 13 interface while
	//  updating the drive info list fields
	//
	ucDriveInfoEntries = 0;
	while( (unsigned)(lpDDT) != 0xffff )
	{
		lpDDT622 = (LPDDT622)(lpDDT);

		fSuccessful = dlGetDPBForDrive( lpDDT->dos_drive, &lpDPB );
		if( fSuccessful )
		{
			Int13DriveInfo[ucDriveInfoEntries].ucBIOSDriveNumber =
					lpDDT->bdrive;
			Int13DriveInfo[ucDriveInfoEntries].ucDOSDriveNumber  =
					lpDDT->dos_drive;
			Int13DriveInfo[ucDriveInfoEntries].lpOriginalDevice =
					lpDPB->device;
			lpDPB->device = lpFDHDHDR;
			Int13DriveInfo[ucDriveInfoEntries].ucUnitNumber =
					lpDPB->unit;
			Int13DriveInfo[ucDriveInfoEntries].uSectorSize =
					lpDPB->bytes_per_sec;
			{
				//  Compute the hidden sectors
				//
				ulHidden = lpDDT->bpb.hidden;
				if( lpDDT->bdrive & 0x80 )
				{
					if( fIsFat32World )
					{
						ulTemp = lpDDT->ddt_info.ps.strak;
					}
					else
					{
						ulTemp = lpDDT622->ddt_info.ps.strak;
					}
					ulTemp *= lpDDT->bpb.sec_per_trak;
					ulTemp *= lpDDT->bpb.sides;
					ulHidden += ulTemp;
				}
			}
			ulSize = lpDDT->bpb.num_sec;
			if( ulSize == 0 )
			{
				ulSize = lpDDT->bpb.lnumsec;
			}
			Int13DriveInfo[ucDriveInfoEntries].ulStart = ulHidden;


			//  Determine if this is a FAT32 drive
			//
			if( IsFat32Drive(lpDPB) )
			{
				Int13DriveInfo[ucDriveInfoEntries].ulDataStart =
						ulHidden + lpDPB->ulFirstDataSector;

				Int13DriveInfo[ucDriveInfoEntries].ulSkipSectors =
						uSectorsPerElement - (lpDPB->ulFirstDataSector %
						uSectorsPerElement);
			}
			else
			{
				Int13DriveInfo[ucDriveInfoEntries].ulDataStart =
						ulHidden + lpDPB->data_start;

				Int13DriveInfo[ucDriveInfoEntries].ulSkipSectors =
						uSectorsPerElement - (lpDPB->data_start %
						uSectorsPerElement);
			}


			Int13DriveInfo[ucDriveInfoEntries].ulEnd = ulSize;
			if( lpDDT->bdrive & 0x80 )
			{
				Int13DriveInfo[ucDriveInfoEntries].fIsWriteCached = TRUE;
				Int13DriveInfo[ucDriveInfoEntries].fIsRemovable = FALSE;
			}
			else
			{
				Int13DriveInfo[ucDriveInfoEntries].fIsWriteCached = FALSE;
				Int13DriveInfo[ucDriveInfoEntries].fIsRemovable = TRUE;
			}
			Int13DriveInfo[ucDriveInfoEntries].fIsCached = TRUE;


			//
			//
			if( fIsFat32World )
			{
				Int13DriveInfo[ucDriveInfoEntries].lpMaxBPB = &lpDDT->defbpb;
			}
			else
			{
				Int13DriveInfo[ucDriveInfoEntries].lpMaxBPB =
						(LPBPB)( &(((char far *)lpDDT)[0x27]) );
			}


			//  Now that the drive has been added to the list of
			//  drives that we can cache, determine if someone
			//  does not want this drive cached
			//
			if( !CacheDriveCacheable(
					Int13DriveInfo[ucDriveInfoEntries].ucDOSDriveNumber ) )
			{
				Int13DriveInfo[ucDriveInfoEntries].fIsCached = FALSE;
				Int13DriveInfo[ucDriveInfoEntries].fIsWriteCached = FALSE;
			}


			//  Register this drive in the cache
			//
			RegisterDiskInformation( ucDriveInfoEntries,
					Int13DriveInfo[ucDriveInfoEntries].uSectorSize, 0);


			//  Go to the next entry in the list
			//
			ucDriveInfoEntries++;
		}


		//  Go to the next DDT
		//
		lpDDT = lpDDT->nextptr;
	}


	//
	//
	ucFirstCDROMEntry = ucDriveInfoEntries;
}


//  Add the CDROMs to the drive list
//
void PASCAL InitCDROMList( void )
{
	uchar ucCDEXDOSDriveNumbers[26];
	unsigned uNumberOfDrives;
	unsigned uFirstDriveNumber;
	struct DRIVERMAP
	{
		uchar ucUnitNumber;
		LPDEV_HDR lpDevice;
	};
	struct DRIVERMAP DriverMap[26];
	extern LPDEV_HDR lpCDEXHDR;
	extern void far * lpOldStrategyCDEX;
	extern void far * lpOldServiceCDEX;
	unsigned uIndex;
	LPDEV_HDR lpFirstDevice;



	//  Determine if MSCDEX is loaded.  Then get the number of drives
	//  serviced by MSCDEX and the the first drive
	//
	CDEXInstallationCheck( &uNumberOfDrives, &uFirstDriveNumber );


	if( uNumberOfDrives == 0 )
	{
		//  CDEX has no drives
		//
		return;
	}


	//  Get the drive letters used by CDEX
	//
	CDEXGetDriveLetters( ucCDEXDOSDriveNumbers );


	//  Get the driver list
	//
	CDEXDDeviceMap( &DriverMap );


	//  Save the address of the first atapi driver
	//
	_fmemcpy( lpCDEXHDR, DriverMap[0].lpDevice, sizeof(DEV_HDR) );
	lpCDEXHDR->strategy = (unsigned)(StrategyCDEX);
	lpCDEXHDR->service = (unsigned)(ServiceCDEX);
	lpOldStrategyCDEX = MK_FP( FP_SEG( DriverMap[0].lpDevice),
			DriverMap[0].lpDevice->strategy );
	lpOldServiceCDEX = MK_FP( FP_SEG(DriverMap[0].lpDevice),
			DriverMap[0].lpDevice->service );


	//  Add the drives that have the same device driver
	//  as the first drive
	//
	lpFirstDevice = DriverMap[0].lpDevice;
	for( uIndex = 0; uIndex < uNumberOfDrives; uIndex++ )
	{
		//  We only patch the first ATAPI driver.  Determine if this
		//  is the first ATAPI driver
		//
		if( lpFirstDevice == DriverMap[0].lpDevice )
		{
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].ucBIOSDriveNumber = 0xff;
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].ucDOSDriveNumber =
					ucCDEXDOSDriveNumbers[uIndex];
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].ucUnitNumber =
					DriverMap[uIndex].ucUnitNumber;
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].lpOriginalDevice =
					DriverMap[uIndex].lpDevice;
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].fIsCached = TRUE;
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].fIsWriteCached = FALSE;
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].uSectorSize = 2048;
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].ulEnd = 0xffffffffL;
			Int13DriveInfo[uIndex+ucFirstCDROMEntry].ulSkipSectors = 0;


			//  Register this drive in the cache
			//
			RegisterDiskInformation( ucDriveInfoEntries,
					Int13DriveInfo[uIndex+ucFirstCDROMEntry].uSectorSize, 0);


			ucDriveInfoEntries++;
		}
	}


	//  Tell our MSCDEX to use this cache device instead
	//
	CDEXChangeDevice( DriverMap[0].lpDevice, lpCDEXHDR );


#if PATCH_MS_CDEX
	//  Patch the MS version(s) of CDEX
	//
	{
		extern LPLOL lpLOL;
		LPMCB lpMCB;
		unsigned uMCBSegment;
		LPDEV_HDR far * lpATAPIDevice;


		//  Walk the MCB chain looking for CDEX
		//
		uMCBSegment = lpLOL->first_mcb;
		while( TRUE )
		{
			//  Get the address of the next MCB in the chain
			//
			lpMCB = MK_FP( uMCBSegment, 0 );
//			printf("MCB %x:%x\n", FP_SEG(lpMCB), FP_OFF(lpMCB) );
			if( _fstrcmp( lpMCB->name, "MSCDEX" ) == 0 )
			{
				//  Determine if this is MS 6.22 cdex
				//
				lpATAPIDevice = MK_FP( uMCBSegment+0x11, 0x5ad4 );
				if( *lpATAPIDevice == DriverMap[0].lpDevice )
				{
					//  Change the driver
					//
					*lpATAPIDevice = lpCDEXHDR;
					lpATAPIDevice++;
					*lpATAPIDevice = MK_FP( FP_SEG(lpCDEXHDR),
							lpCDEXHDR->strategy );
					lpATAPIDevice++;
					*lpATAPIDevice = MK_FP( FP_SEG(lpCDEXHDR),
							lpCDEXHDR->service );
					printf("MS-DOS 6.22 CDEX patched\n");
					break;
				}
//  BT 4-4-02
//
//  Unsuccessful at patching MS DOS 7.1 MSCDEX and making it work
//
#if PATCH_MS71_CDEX
				else
				{
					//  Determine if this is MS 7.1 cdex
					//
					lpATAPIDevice = MK_FP( uMCBSegment+0x11, 0x5b26 );
					if( *lpATAPIDevice == DriverMap[0].lpDevice )
					{
						//  Change the driver
						//
//  BT 4-4-02
//
//  MS DOS 7.1 SMARTDRV does not overwrite this field
//
//						*lpATAPIDevice = lpCDEXHDR;
						lpATAPIDevice++;
						*lpATAPIDevice = MK_FP( FP_SEG(lpCDEXHDR),
								lpCDEXHDR->strategy );
						lpATAPIDevice++;
						*lpATAPIDevice = MK_FP( FP_SEG(lpCDEXHDR),
								lpCDEXHDR->service );
						printf("MS-DOS 7.1 CDEX patched\n");
						break;
					}
				}
#endif // #if PATCH_MS71_CDEX
			}


			//  Determine if this is the end of the MCB chain
			//
			if( lpMCB->id == 'Z' )
			{
				break;
			}


			//  Determine the segment of the next MCB
			//
			uMCBSegment = uMCBSegment + 1 + lpMCB->para_cnt;
		}
	}
#endif // #if PATCH_MS_CDEX

}


//  Determine if we should display the signon message and if
//  so display it
//
void PASCAL DisplaySignonMessage( void )
{
	extern char szSignOnMessage[];
	extern char szShortVersion[];
	extern char szShortVersion622[];
	extern char szBuildVersion[];
	extern char szCopyright[];


	if( !DoHideSignon() )
	{
		if( fIsFat32World )
		{
			printf(szSignOnMessage,szShortVersion,szBuildVersion,szCopyright);
		}
		else
		{
			printf(szSignOnMessage,szShortVersion622,szBuildVersion,szCopyright);
		}
	}
}


//  Display the usage screen
//
void Usage( void )
{
	extern char szUsage[];


	fSwitches[HIDE_SIGNON] = 0;
	DisplaySignonMessage();
	printf( szUsage );
	exit(ERR_USAGE);
}


//  Show the usage for a bad command line parameter
//
void OptError(char * szMsg)
{
	unsigned uIndex = 0;
	extern char szInvalidSwitch[];


	while( (szMsg[uIndex] != ' ') && (szMsg[uIndex] != 0) )
	{
		if( szMsg[uIndex] == '/' )
		{
			uIndex++;
			if( szMsg[uIndex] != 0 )
			{
				uIndex++;
			}
			break;
		}
		uIndex++;
	}
	szMsg[uIndex] = 0;

	printf( szInvalidSwitch, szMsg );
	exit(ERR_USAGE);
}


//  Return a the address of the "yes" or "no" string based on
//  the value of the boolean
//
char * PASCAL GetYesNoString( bool fIsYes )
{
	if( fIsYes )
	{
		return szYes;
	}
	return szNo;
}
