;
;   $Id: INT21.ASM 1.6 2003/01/31 18:37:02Z thomd Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT21.ASM
;
;  Copyright (c) 2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  History:
;
;  01-25-2001  bt  Created
;


include dostruct.inc


.model small


.data?


    extrn _fInCache:word

    fInt21Patched	dw	?


    ;  Used by many functions
    ;
	public _lpLOL
    _lpLOL			dd	?


    ;  Variables to assist in optimizing the cache by knowing more
    ;  information about the read request at the DOS level
    ;
	public _lpCurrentPSPSegment
    _lpCurrentPSPSegment	dd	?
	public _fIsFileRead
    _fIsFileRead		dw	?
	public _uFileReadSize
    _uFileReadSize		dw	?
	public _uSFTIndex
    _uSFTIndex			dw	?


.data

	extrn	_lpLocalStack:dword
	extrn _lpCallersStack:dword


    ;  For easy reference, save a local pointer to our INT 21h handler
    ;
	public _lpInt21Handler
    _lpInt21Handler	label	dword
    LocalInt21Offset	dw	_Int21Handler
    LocalInt21Segment	dw	@Code


    ;  pointer to the previous INT 21h handler
    ;
	public _lpOldInt21Handler
    _lpOldInt21Handler	label	dword
    OldInt21Offset	dw	_Int21Handler
    OldInt21Segment	dw	@Code

    CallersDS      dw   ?

    ;  pointer to the previous int ?? handler (changes for different ints)
    ;
    extrn _lpOldHandler:dword


.code

	ASSUME	CS:@Code,DS:NOTHING

	extrn	FlushAllBuffers:proc

.186


;  _INT21Handler
;
;  This handler gets called everytime that there is an INT 21h
;
comment ~
void INT21Handler( void )
{}
~
    public _INT21Handler
_INT21Handler:

	pushf
	cmp	ah, 3fh
	je	TrapFunction3f
	cmp	ah, 0dh
   je    PostI21Flush
	cmp	ah, 68h
	cmp	ax, 2513h
	cmp	ax, 2522h

DoOldHandler:
	popf
	jmp	dword ptr cs:[_lpOldInt21Handler]

PostI21Target:
   ; int 21 has done it's thing, now we need to flush all buffers
   ;  Set our environment the way we like it
   ;
   mov   word ptr cs:_lpCallersStack+2, ss
   mov   word ptr cs:_lpCallersStack, sp
   mov   cs:CallersDS, ds

   mov   ax, DGROUP
   mov   ds, ax
   mov   ss, word ptr ds:_lpLocalStack+2
   mov   sp, word ptr ds:_lpLocalStack          ; lpLocalStack

   mov   cs:_fInCache, 1    ; fInCache
   call    FlushAllBuffers
   mov   cs:_fInCache, 0

   ;  now restore the caller's environment
   ;
   mov   ds, cs:CallersDS
   mov   ss, word ptr cs:_lpCallersStack+2
   mov   sp, word ptr cs:_lpCallersStack

   iret

PostI21Flush:
   push  CS
   push  offset PostI21Target
   pushf
   jmp short DoOldHandler

;  Get some information about the read function
;
TrapFunction3f:


	;  Set the flag which indicates that we are in a file
	;  read call
	;
	inc	word ptr cs:[_fIsFileRead]


	;  Save the size of the read
	;
	mov	cs:[_uFileReadSize], cx


	;  Preserve the DS and BX registers
	;
	push	ds
	push	si


	;  Get the address of the of the current PSP
	;
	lds	si, cs:[_lpCurrentPSPSegment]
	mov	ds, ds:[si]


	;  Get the SFT index number of this file handle
	;
	xor	si, si
	lds	si, dword ptr [si+PSP_htbl_addr] ; Note: assembler don't like immediate here hence the [si+immediate]
	mov	si, word ptr [si+bx]
	and	si, 0ffh


	;  Save the SFT index for this call
	;
	mov	cs:[_uSFTIndex], si


	;  Restore the DS and BX registers
	;
	pop	si
	pop	ds


	;  Let DOS service the call (flags are already on the stack)
	;
	call	dword ptr cs:[_lpOldInt21Handler]
	pushf ; Flags are now back on the stack


	;  Clear the flag which indicates that we are in a file
	;  read call
	;
	dec	word ptr cs:[_fIsFileRead]


	;  Return to the caller
	;
	popf
	retf	2


;  InstallInt21Vector
;
;  Save the current int 21h vector and set the int 21h vector to
;  our handler
;
comment ~
void InstallInt21Vector( void )
{}
~
	ASSUME	DS:@Data
    public	_InstallInt21Vector
_InstallInt21Vector:


IF 0
	;  Set ES:BX to the int 21h vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 21h * 4


	;  Save the current int 21h vector
	;
	pushf
	cli
	mov	ax, es:[bx]
	mov	OldInt21Offset, ax
	mov	ax, es:[bx+2]
	mov	OldInt21Segment, ax


	;  Set our int 21h vector
	;
	mov	ax, LocalInt21Offset
	mov	es:[bx], ax
	mov	ax, LocalInt21Segment
	mov	es:[bx+2], ax
	popf
ELSE
	push	bx
	mov	ah, 35h
	mov	al, 21h
	int	21h
	mov	OldInt21Offset, bx
	mov	ds:OldInt21Segment, es
	pop	bx
	push	ds
	pushf
	cli
	mov	ah, 25h
	mov	al, 21h
	lds	dx, _lpInt21Handler
	int	21h
	popf
	pop	ds
ENDIF

	;  Set the flag indicating that the INT 21h interface
	;  has been patched
	;
	mov	fInt21Patched, 1


	;  All done, return
	;
	ret


	END
