//
//   $Id: LRUCACHE.H 1.4 2002/10/16 21:38:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*

	LRUCACHE.H
	Created 06-28-2001  by Keith Garvin

	Provides public APIs and types to the LRU cache.

	Copyright (c) 2001-2002 Datalight, Inc.
	All rights reserved.
	Confidential and Proprietary

*/

/*
	The cache type is typedef'd so we could use a structure
	or virtually any type the deemed necessary.  Given that
	our LRU cache will simply store indices into another
	relatively small cache, keep this at a 16 bit value for
	now.  (06-29-2001 PKG)
*/
typedef unsigned LRU_ENTRY;

/* Proto types */
bool PASCAL InitializeLruCache(unsigned uNumberOfCacheEntries);
void PASCAL DeinitializeLruCache(void);
bool PASCAL GetLruEntry(unsigned uLruIndex, LRU_ENTRY * plruEntry);
bool PASCAL GetLeastRecentLruCacheEntry(LRU_ENTRY * pCacheEntry);
bool PASCAL GetMostRecentLruCacheEntry(LRU_ENTRY * pCacheEntry);
bool PASCAL UpdateCacheEntryToMru(LRU_ENTRY cacheEntry);

#if TESTING
bool PASCAL TestLruCache(void);
#endif
