//
//   $Id: MISERY.H 1.5 2002/10/16 21:38:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//



#define READ		TRUE
#define WRITE		FALSE


//  This is used to control how many drives are being tested
//
//  NOTE:  Must have at least two to validate the test program
//
#define MAX_DRIVES				6
#define MAX_SECTORS				0x4000


//  This is the maximum read/write size being tested
//
//#define MAX_RW_SEC_COUNT		10
#define MAX_RW_SEC_COUNT		0x80L


//  This is the maximum sector size being tested
//
#define MIN_SECTOR_SIZE			HD_SECTOR_SIZE
#define MAX_SECTOR_SIZE			HD_SECTOR_SIZE


//  Sector size constants
//
#define HD_SECTOR_SIZE			512
#define CD_SECTOR_SIZE			2048


//  This is a seed for random byte data.  It it repeatedly added
//  to itself for the next byte value
//
#define PRIME_VALUE				7


//  An array of these structures are used to track information
//  about each drive
//
typedef struct DiskInfo DISKINFO;
typedef DISKINFO * PDISKINFO;
typedef DISKINFO far * LPDISKINFO;
struct DiskInfo
{
	unsigned uSectorSize;
	bool fIsWriteCached;
};


//  This structure is used to track sector information.  It
//  is written in every sector.
//
//  NOTE: The ul32BitCRC field must be he last entry in this
//        structure since this structure is written at the very
//        end of a sector and the 32 bit CRC is for the sector
//        size minus the size of ul32BitCRC
//
typedef struct SectorInfo SECTORINFO;
typedef SECTORINFO * PSECTORINFO;
typedef SECTORINFO far * LPSECTORINFO;
struct SectorInfo
{
	uchar ucDrive;
	ulong ulSectorNumber;
	unsigned uWriteCount;
	ulong ul32BitCRC;
};


#define MIN_XMS_KB					16
#define ELEMENT_SIZE_DEFAULT		8
#define ARRAY_ENTRIES(array) (sizeof(array)/sizeof(array[0]))



//  This structure is used to track the "write count" for each
//  sector that is written to the cache
//
typedef struct WRITE_COUNTS WRITE_COUNTS;
typedef WRITE_COUNTS * PWRITE_COUNTS;
typedef WRITE_COUNTS far * LPWRITE_COUNTS;
struct WRITE_COUNTS
{
	uchar ucDrive;
	ulong ulSectorNumber;
	unsigned uWriteCount;
	bool fCommitted;
};
