//
//   $Id: cachinit.h 1.9 2002/10/16 21:38:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  CACHE.H
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  06-28-2001  bt  Created
//


//  Internal testing use only.  This flag determines
//  whether we cache MS-DOS 6.22 cdex
//
#define PATCH_MS_CDEX					TRUE
#define PATCH_MS71_CDEX					FALSE	 // Leave disabled, don't work yet.


//
//
#define DEBUG_BAD_DRIVES				FALSE
#define DEBUG_BAD_ERROR_CODES			FALSE
#define DEBUG_BAD_DATA					FALSE
#define DEBUG_WRITE_PROTECT			FALSE
#define DEBUG_CHECK_SECTOR_NUMBERS	FALSE


//
//
#define ERR_NONE							0
#define ERR_STATUS						0
#define ERR_CONFLICTING_SWITCHES		251
#define ERR_LOW_XMS						252
#define ERR_NO_XMS						253
#define ERR_WINDOWS						254
#define ERR_USAGE							255


//  This is the minimum amount of XMS that will be used and that must
//  be available.  Do not change this value or the cache will not be
//  compatible with MS
//
#define MIN_XMS_KB					16
#define ELEMENT_SIZE_DEFAULT		8


//  Indexes into the boolean command line switches array
//
#define HIDE_SIGNON					0
#define NO_CD_CACHE					1
#define DO_FLUSH                 2
#define DO_INVALIDATE            3
#define WRITE_BEFORE_RETURN      4
#define NO_WRITE_BEFORE_RETURN   5
#define DISPLAY_STATUS				6
#define DISPLAY_MORE_STATUS		7
#define DONT_DISPLAY_STATUS		8
#define DONT_LOAD_HIGH				9
#define NO_WRITE_CACHING			10
#define MAX_BOOLEAN_SWITCHES		11


//  Macros for boolean command line switches
//
#define DoHideSignon()			   (fSwitches[HIDE_SIGNON]            != 0)
#define DoCDCache()              (fSwitches[NO_CD_CACHE]            == 0)
#define DoFlushCache()           (fSwitches[DO_FLUSH]               != 0)
#define DoInvalidateCache()      (fSwitches[DO_INVALIDATE]          != 0)
#define DoWriteBeforeCommand()   (fSwitches[WRITE_BEFORE_RETURN]    != 0)
#define NoWriteBeforeCommand()   (fSwitches[NO_WRITE_BEFORE_RETURN] != 0)
#define DoDisplayStatus()        (fSwitches[DISPLAY_STATUS]         != 0)
#define DoDisplayMoreStatus()    (fSwitches[DISPLAY_MORE_STATUS]    != 0)
#define DontDisplayStatus()      (fSwitches[DONT_DISPLAY_STATUS]    != 0)
#define DontLoadHigh()           (fSwitches[DONT_LOAD_HIGH]         != 0)
#define DisableAllWriteCaching() (fSwitches[NO_WRITE_CACHING]       != 0)


#define ARRAY_ENTRIES(array) (sizeof(array)/sizeof(array[0]))


typedef struct Int13DriveInfo INT13_DRIVE_INFO;
typedef INT13_DRIVE_INFO * PINT13_DRIVE_INFO;
typedef INT13_DRIVE_INFO far * LPINT13_DRIVE_INFO;
struct Int13DriveInfo
{
	uchar ucBIOSDriveNumber;			// 00
	uchar ucDOSDriveNumber;          // 01
	uchar ucUnitNumber;              // 02
	LPDEV_HDR lpOriginalDevice;      // 03
	bool  fIsCached;                 // 07
	bool  fIsWriteCached;            // 09
	ulong ulStart;                   // 0b
	ulong ulDataStart;               // 0f
	ulong ulEnd;                     // 13
	LPBPB lpMaxBPB;                  // 17
	unsigned uSectorSize;            // 1b
	bool	fIsRemovable;					// 1d
	ulong ulSkipSectors;					// 1e (used to get cluster alignment)
};


//  These are the actions for the CacheGetSetStatus() function
//
#define ACTION_GET_STATUS					0x00
#define ACTION_ENABLE_READ_CACHE			0x01
#define ACTION_DISABLE_READ_CACHE		0x02
#define ACTION_ENABLE_WRITE_CACHE		0x03
#define ACTION_DISABLE_WRITE_CACHE		0x04


//  The bit for the carry flag when the flags are in a word register
//
#define FLAG_CARRY		0x0001



//  Structure of registers saved on int 2fh call
//
typedef struct CallersRegisters CALLREG;
typedef CALLREG * PCALLREG;
typedef CALLREG far * LPCALLREG;
struct CallersRegisters
{
    unsigned	ax;
    unsigned	bx;
    unsigned	cx;
    unsigned	dx;
    unsigned	si;
    unsigned	di;
    unsigned	bp;
    unsigned 	ds;
    unsigned 	es;
    unsigned 	sp;
    unsigned 	ss;
    unsigned 	ip;
    unsigned 	cs;
    unsigned 	flags;
};


//  For word access to dwords
//
#define LOWWORD(ulValue)   ((unsigned)(ulValue))
#define HIGHWORD(ulValue)  ((unsigned)(FP_SEG((void far *)(ulValue))))


//  For byte access to words
//
#define LOWBYTE(uValue)   ((uchar)(uValue))
#define HIGHBYTE(uValue)  ((uchar)(uValue >> 8))


//  Structure for LBA read and writes
//
typedef struct LBATransferPacket LBAPACKET;
typedef LBAPACKET * PLBAPACKET;
typedef LBAPACKET far * LPLBAPACKET;
struct LBATransferPacket
{
	uchar ucPacketSize;
	uchar ucReserved1;
	unsigned uNumberOfSectors;
	uchar far * lpucData;
	ulong ulSectorLowDWORD;
	ulong ulSectorHighDWORD;
};
