;
;   $Id: int28.asm 1.5 2002/10/16 21:39:42Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT28.ASM
;
;  Copyright (c) 2001-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  History:
;
;  06-29-2001  bt  Created
;



.model small


.data

    extrn _Dispatcher:word

    ;  For easy reference, save a local pointer to our INT 28h handler
    ;
	public _lpInt28Handler
    _lpInt28Handler	label	dword
    LocalInt28Offset	dw	_Int28Handler
    LocalInt28Segment	dw	@Code


    ;  pointer to the previous INT 28h handler
    ;
	public _lpOldInt28Handler
    _lpOldInt28Handler	label	dword
    OldInt28Offset	dw	_Int28Handler
    OldInt28Segment	dw	@Code


    ;  pointer to the previous int ?? handler (changes for different ints)
    ;
    extrn _lpOldHandler:dword


    fInt28Patched	dw	?


.code

	ASSUME	CS:@Code,DS:NOTHING

	extrn	_Int28Dispatch:proc
	extrn	DoServiceCall:proc


.186


;  _INT28Handler
;
;  This handler gets called everytime that there is an INT 28h
;
comment ~
void INT28Handler( void )
{}
~
    public _INT28Handler
_INT28Handler:


	;  Tell the dispatcher to use the int 28h dispatcher
	;
	push	ax
	mov	ax, offset _Int28Dispatch
	mov	cs:_Dispatcher, ax
	mov	ax, word ptr cs:_lpOldInt28Handler
	mov	word ptr cs:_lpOldHandler, ax
	mov	ax, word ptr cs:_lpOldInt28Handler+2
	mov	word ptr cs:_lpOldHandler+2, ax
	pop	ax


	;  Jump to the dispatcher
	;
	jmp	DoServiceCall


;  InstallInt28Vector
;
;  Save the current int 28h vector and set the int 28h vector to
;  our handler
;
comment ~
void InstallInt28Vector( void )
{}
~
	ASSUME	DS:@Data
    public	_InstallInt28Vector
_InstallInt28Vector:


	;  Set ES:BX to the int 28h vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 28h * 4


	;  Save the current int 28h vector
	;
	pushf
	cli
	mov	ax, es:[bx]
	mov	OldInt28Offset, ax
	mov	ax, es:[bx+2]
	mov	OldInt28Segment, ax


	;  Set our int 28h vector
	;
	mov	ax, LocalInt28Offset
	mov	es:[bx], ax
	mov	ax, LocalInt28Segment
	mov	es:[bx+2], ax
	popf


	;  Set the flag indicating that the INT 28h interface
	;  has been patched
	;
	mov	fInt28Patched, 1


	;  All done, return
	;
	ret


	END
