;
;   $Id: int2f.asm 1.10 2002/11/12 18:33:26Z thomd Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT2f.ASM
;
;  Copyright (c) 2001-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  History:
;
;  06-29-2001  bt  Created
;



.model small


.data?


    ;  This is the stack that the handler switches to
    ;  to perform an int 2fh processing
    ;
    I2fStack		dw	2048 dup(?)
	public	_I2fStackTop
    _I2fStackTop	label   word


    extrn _abortingBecause:word
    extrn _fInCache:word


	public _fLeaveFlagsOnStack
    _fLeaveFlagsOnStack	dw	?


.data

    ;  For easy reference, save a local pointer to our stack
    ;
	public	_lpLocalStack
    _lpLocalStack	label	dword
    LocalStackSP	dw	_I2fStackTop - 2
    LocalStackSS	dw	@Data


    ;  For easy reference, save a local pointer to our INT 2fh handler
    ;
	public	_lpInt2fHandler
    _lpInt2fHandler	label	dword
    LocalInt2fOffset	dw	_INT2fHandler
    LocalInt2fSegment	dw	@Code


    ;  pointer to the previous INT 2fh handler
    ;
	public	_lpOldInt2fHandler
    _lpOldInt2fHandler	label	dword
    OldInt2fOffset	dw	_INT2fHandler
    OldInt2fSegment	dw	@Code


    ;  pointer to the previous int ?? handler (changes for different ints)
    ;
	public	_lpOldHandler
    _lpOldHandler	label	dword
    OldOffset		dw	?
    OldSegment		dw	?


    ;  pointer to the active dispatcher
    ;
	public	_Dispatcher
    _Dispatcher		dw	?


    ;  Callers registers
    ;
	public	_Int2fRegisters
    _Int2fRegisters	label	byte

    CallersAX		dw	?
    CallersBX		dw	?
    CallersCX		dw	?
    CallersDX		dw	?
    CallersSI		dw	?
    CallersDI		dw	?
    CallersBP		dw	?
    CallersDS		dw	?
    CallersES		dw	?

   public   _lpCallersStack
    _lpCallersStack	label	dword
    CallersSP		dw	?
    CallersSS		dw	?

    _lpCallersCSIP	label	dword
    CallersIP		dw	?
    CallersCS		dw	?

    CallersFlags	dw	?


    	public _fHandledCall
    _fHandledCall	dw	?


    fInt2fPatched	dw	?


    extrn _fInDevice:word

.code

	ASSUME	CS:@Code,DS:NOTHING

	extrn	_Int2fDispatch:proc
	extrn	__FlushAndReboot:proc

.186


;  _INT2fHandler
;
;  This handler gets called everytime that there is an INT 2fh
;
comment ~
void INT2fHandler( void )
{}
~
    public _INT2fHandler
_INT2fHandler:

	;  Determine if this is an our call
	;
	cmp	ax, 4a10h		; Smartdrv APIs
	je	_DoServiceCall
	cmp	ax, 1122h		; Process termination hook
	je	_DoServiceCall
	jmp	dword ptr cs:_lpOldInt2fHandler


_DoServiceCall:

	;  Tell the dispatcher to use the int 2fh dispatcher
	;
	push	ax
	mov	ax, offset _Int2fDispatch
	mov	cs:_Dispatcher, ax
	mov	ax, word ptr cs:_lpOldInt2fHandler
	mov	word ptr cs:_lpOldHandler, ax
	mov	ax, word ptr cs:_lpOldInt2fHandler+2
	mov	word ptr cs:_lpOldHandler+2, ax
	pop	ax


	public	DoServiceCall
DoServiceCall:


	;  Set a flag indicating that we are in the cache
	;
	mov	cs:_fInCache, 1
	mov	cs:_fLeaveFlagsOnStack, 0


	;  Save the stack
	;
	mov	cs:CallersSS, ss
	mov	cs:CallersSP, sp


	;  Set our stack
	;
	mov	ss, word ptr cs:_lpLocalStack+2
	mov	sp, word ptr cs:_lpLocalStack


	;  Save DS
	;
	mov	cs:CallersDS, ds


	;  Set our DS
	;
	push	ss
	pop	ds
	ASSUME	DS:@Data


	;  Save the rest of the registers
	;
	mov	CallersAX, ax
	mov	CallersBX, bx
	mov	CallersCX, cx
	mov	CallersDX, dx
	mov	CallersSI, si
	mov	CallersDI, di
	mov	CallersBP, bp
	mov	ds:CallersES, es


	;  Save the CS:IP
	;
	les	bx, _lpCallersStack
	mov	ax, es:[bx]
	mov	CallersIP, ax
	mov	ax, es:[bx+2]
	mov	CallersCS, ax


	;  Save the flags
	;
	mov	ax, es:[bx+4]
	mov	cs:CallersFlags, ax


	;  Clear the flag indicating that the call was handled
	;
	mov	_fHandledCall, 0


	;  Re-enter our program
	;
	call	[_Dispatcher]


	;
	;  Fall through to return function
	;


;  _INT2fReturn
;
;  This is where control is passed on to the previous int 2fh handler
;  or returned to the caller depending on whether the call was handled
;
comment ~
void INT2fReturn( void )
{}
~
    public	_INT2fReturn
_INT2fReturn:


	;  Set the flags
	;
	les	bx, _lpCallersStack
	mov	ax, CallersFlags
	mov	es:[bx+4], ax


	;  Set all the registers
	;
	mov	ax, CallersAX
	mov	bx, CallersBX
	mov	cx, CallersCX
	mov	dx, CallersDX
	mov	si, CallersSI
	mov	di, CallersDI
	mov	bp, CallersBP
	mov	es, ds:CallersES


	;  Set DS
	;
	mov	ds, CallersDS
	ASSUME	DS:NOTHING


	;  Set the stack
	;
	mov	ss, word ptr cs:_lpCallersStack+2
	mov	sp, word ptr cs:_lpCallersStack


	;  Clear the flag indicating that we are in the cache
	;
	mov	cs:_fInCache, 0


	;
	;
	pushf
	cmp	cs:_abortingBecause, 0
	jnz	DoReboot


	cmp	cs:_fHandledCall, 0
	jz	QuickOut2


	popf


	cmp	cs:_fLeaveFlagsOnStack, 0
	jnz	DoRetf


	;  Return
	;
	iret


	;  Return leaving the flags on the stack for Int 25h and Int 26h
	;
DoRetf:
	retf


	;  Pass on the call to the previous INT 2fh
	;

QuickOut2:
	popf
QuickOut:
	jmp     dword ptr cs:_lpOldHandler


DoReboot:

	;  Flush and reboot
	;
	jmp	__FlushAndReboot


;  InstallInt2fVector
;
;  Save the current int 2fh vector and set the int 2fh vector to
;  our handler
;
comment ~
void InstallInt2fVector( void )
{}
~
	ASSUME	DS:@Data
    public	_InstallInt2fVector
_InstallInt2fVector:


	;  Set ES:BX to the int 2fh vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 2fh * 4


	;  Save the current int 2fh vector
	;
	pushf
	cli
	mov	ax, es:[bx]
	mov	OldInt2fOffset, ax
	mov	ax, es:[bx+2]
	mov	OldInt2fSegment, ax


	;  Set our int 2fh vector
	;
	mov	ax, LocalInt2fOffset
	mov	es:[bx], ax
	mov	ax, LocalInt2fSegment
	mov	es:[bx+2], ax
	popf


	;  Set the flag indicating that the INT 2fh interface
	;  has been patched
	;
	mov	fInt2fPatched, 1


	;  All done, return
	;
	ret


	END
