//
//   $Id: INLIB.C 1.8 2003/01/17 15:18:42Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  INLIB.C
//
//  Copyright (c) 2000-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  03-15-2000  bt  Created (Started over from scratch)
//  03-23-1989  Drew Gislason (created old chkdsk)
//


#define __FILENUMBER__		5


//  Borland libraries
//
#include "dir.h"
#include "stdio.h"
#include "stdlib.h"
#include "ctype.h"
#include "mem.h"
#include "string.h"


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"



//  Chkdsk header files
//
#include "chkdsk.h"
#include "chkasert.h"


//  Prototypes
//
#include "chkdsk.pt"


//  Convert the time into a DOS file time format
//
void DOSTimeToDOSFileTime( DOSTime * pDOSTime, DOSFileTime * pFileTime )
{
	pFileTime->second = pDOSTime->second;
	pFileTime->minute = pDOSTime->minute;
	pFileTime->hour   = pDOSTime->hour;
}


//  Convert the date into a DOS file date format
//
void DOSDateToDOSFileDate( DOSDate * pDOSDate, DOSFileDate * pFileDate )
{
	pFileDate->day   = pDOSDate->day;
	pFileDate->month = pDOSDate->month;
	pFileDate->year  = pDOSDate->year - 1980;
}


//  Get the current date and time
//
void GetDateAndTime( unsigned * puFileDate, unsigned * puFileTime )
{
	static DOSDate DOSDate;
	static DOSTime DOSTime;
	unsigned uStartFileDate;


	//  We need to make sure that when we get the date and time that
	//  a midnight roll-over does not occure.  Get the date, then the
	//  time, and then get the date again.  Repeat until the dates
	//  match.
	do{
		//  Get the current date
		//
		dlGetDOSDate( &DOSDate );


		//  Convert the date into a DOS file date format
		//
		DOSDateToDOSFileDate( &DOSDate,
				(struct DOSFileDate *)(&uStartFileDate) );


		//  Get the current time
		//
		dlGetDOSTime( &DOSTime );


		//  Get the current date again
		//
		dlGetDOSDate( &DOSDate );


		//  Convert the date into a DOS file date format
		//
		DOSDateToDOSFileDate( &DOSDate, (struct DOSFileDate *)puFileDate );


	}while( uStartFileDate != *puFileDate );


	//  Convert the time into a DOS file time format
	//
	DOSTimeToDOSFileTime( &DOSTime, (struct DOSFileTime *)puFileTime );
}


/*
	Returns TRUE if yes, FALSE if no.  (Microsoft style)
*/
bool getyesno( char * szMessage, char cDefault )
{
   uchar s[4];          // used by dlGetLine to store result
   bool retval;

   if( DoConfirm() )
   {
      retval = (cDefault == DEFAULT_YES);

      ConOutput( szMessage );
      s[0] = 2;
      s[1] = 0;
      dlGetLine(s);
      printf("\n");

      if(s[1])
      {
         if(toupper(s[2]) == 'Y')
         {
            retval = TRUE;
         }
         else if(toupper(s[2]) == 'N')
         {
            retval = FALSE;
         }
      }
   }
   else
   {
      // if the "do not confirm" option (/C) is set, we always return TRUE
      //
      retval = TRUE;
   }

   return retval;
}


//  Con output (bypass redirection)
//
void ConOutput( char * szMessage )
{
	unsigned uLength;
	unsigned uAction = ACT_EXIST_OPEN;
	int iHandle;


	uLength = strlen( szMessage );
	if( dlOpenOrCreateFile( O_WRONLY, A_NORMAL, &uAction, "CON", &iHandle ) )
	{
		dlWriteFile( iHandle, &uLength, szMessage );
		dlCloseFile( iHandle );
	}
	else
	{
		//  ???
		//
		printf("Con open failed!\n");
	}
}


//  Convert the file name in ENAME form into a ASCIIZ string
//
void EnameToDot( char far * lpEname, char * szFileName )
{
	uchar ucCount;


	//  Copy the non-space characters into the string
	//
	for( ucCount = 0; ucCount < 11; ucCount++ )
	{
		if( (ucCount == 8) && (lpEname[8] != 0x20) )
		{
			*szFileName = '.';
			szFileName++;
		}

		if( lpEname[ucCount] != 0x20 )
		{
			*szFileName = lpEname[ucCount];
			szFileName++;
		}
	}


	//  Terminate the the file name string
	//
	*szFileName = 0;
}


/*
	$DOCAPI:SmartGetFreeSpace

	This is a 'smart' version of get free space. This function will check first
	to see if the disk is a FAT32 disk, and if so, will call the FAT32 get disk
	free space, otherwise this function will build the FAT12/16 free space info
	into the FAT32 structure so that only one structure is used to retrieve the
	free space for a drive. This function returns TRUE upon success and FALSE
	upon failure.

	iDrive = (0=default,1=A,2=B,...)!!!!

*/
//  Note:  Library free space won't work on windows because the DPB didn't
//         get updated
//
bool PASCAL SmartGetFreeSpace( int iDrive, PGDF32 pDiskSpace )
{
	bool		fResult;
	char * szDriveString = "A:\\";
	unsigned	uFreeClusters;			// Used to calculate FAT16 disk values
	unsigned	uTotalClusters;		// Used to calculate FAT16 disk values
	unsigned	uBytesPerSector;		// Used to calculate FAT16 disk values
	unsigned	uSectorsPerCluster;	// Used to calculate FAT16 disk values


	ASSERT(pDiskSpace);

	if(iDrive == 0)
	{
		dlGetCurrentDrive(&iDrive);
	}
	else
	{
		iDrive--;
	}

	// if we are in a DOS 7.1 enviornment then we can use the get
	// extended free space function
	//
	if( fIsFat32World )
	{
		// The FAT32 Get Free Space function requires a drive string
		// instead of a number, so we must first convert this drive number
		//
		*szDriveString = iDrive + 'A';

		// This member must specifically be initialized to ZERO always
		//
		pDiskSpace->uLevel = 0;

		// Get the drive space structure filled out
		//
		fResult = dlGetDriveFreeSpace32(szDriveString, pDiskSpace);
	}
	else
	{
		// Get some info on this drive so we can calculate
		fResult = __dlGetFreeSpaceOnDrive(iDrive+1, &uSectorsPerCluster, &uFreeClusters,
						&uBytesPerSector, &uTotalClusters);

		if(fResult)
		{
			// Initialize as many elements of this structure as possible
			pDiskSpace->uLevel                     = 0;
			pDiskSpace->uSize                      = sizeof(GDF32);
			pDiskSpace->ulSectorsPerCluster        = (ulong) uSectorsPerCluster;
			pDiskSpace->ulBytesPerSector           = (ulong) uBytesPerSector;

			pDiskSpace->ulAvailableClusters        = (ulong) uFreeClusters;
			pDiskSpace->ulAvailableAllocationUnits = (ulong) uFreeClusters;
			pDiskSpace->ulTotalClusters            = (ulong) uTotalClusters;
			pDiskSpace->ulTotalAllocationUnits     = (ulong) uTotalClusters;

			pDiskSpace->ulAvailablePhysicalSectors = (ulong) uFreeClusters *
					uSectorsPerCluster;
			pDiskSpace->ulTotalPhysicalSectors     = (ulong) uTotalClusters *
					uSectorsPerCluster;
		}
	}
	return fResult;
}


//  Convert a physical memory address into a segmented address
//
void far * PhysicalToSegmentedAddress( ulong ulPhysicalAddress )
{
	return MK_FP( (unsigned)(ulPhysicalAddress >> 4),
			(unsigned)ulPhysicalAddress & 0xf );
}


//  Convert a segmented address into a physical memory address
//
ulong SegmentedAddressToPhysical( void far * lpSegmentedAddress )
{
	return ((ulong)(FP_SEG(lpSegmentedAddress)) << 4) +
			((unsigned)(FP_OFF(lpSegmentedAddress)));
}
