//
//   $Id: CLIAPI.H 1.8 2002/10/16 21:42:08Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  I2FAPI.H
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  This file contains all the API functions that an int 2fh IFS
//  interface is expected to perform.
//
//  History:
//
//  04-01-2001  bt  Created
//



//  ========================================================================
//
//  This are constants used for version and program type
//
//  ========================================================================




//  This is a byte value that represents the program
//
#define CLI_TOKEN		 0x11


//  This is the version byte of the program
//
#define CLI_VERSION	 0x20




//  ========================================================================
//
//  The following functions are required APIs for the INT 2fh interface.
//
//  ========================================================================




//  Declare the distance for the strings and data being passed in
//  to the functions.  This can be unique to the implementation.
//
//  NOTE: Only near and far are valid values
//
#ifndef SERVER_APP
#define _D_		far
#else // #ifndef SERVER_APP
#define _D_
#endif // #ifndef SERVER_APP


//  InitInt2fInterface
//
//
//  Initialize the INT 2fh interface
//
//
//  On entry:
//
//    argc = The number of options in the argv array
//    argv = Array of pointers to command line options
//
//  On exit:
//
//  on success,
//
//  	function returns TRUE
//
//  on error,
//
//		function returns FALSE
//
//
bool InitInt2fInterface( int argc, char *argv[] );


//  GetRemoteDriveInfo  INT 2fh fn 110ch
//
//
//  Get some information about the remote drive such as the
//  total drive space and free space.  Because of the limitation
//  in the size of the variables, the values returned from this
//  function may have been adjusted to fit the size of the
//  variables but still reflect the amount of space on the remote
//  drive.
//
//
//  On entry:
//
//  	ucRemoteDriveLetter	= Drive letter of drive on remote machine
//  	pucSectorsPerCluster = Variable for sectors per cluster
//  	pucMediaIdByte			= Variable for media id byte
//  	puTotalClusters		= Variable for total clusters
//  	puBytesPerSector		= Variable for bytes per sector
//  	puAvailableClusters	= Variable for available clusters
//
//  On exit:
//
//  on success,
//
//  	pucSectorsPerCluster	= is updated
//  	ucMediaIdByte			= is updated
//  	puTotalClusters		= is updated
//  	puBytesPerSector 		= is updated
//  	puAvailableClusters	= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL GetRemoteDriveInfo( uchar ucRemoteDriveLetter,
		uchar * pucSectorsPerCluster, uchar * pucMediaIdByte,
		unsigned * puTotalClusters, unsigned * puBytesPerSector,
		unsigned * puAvailableClusters );


//  RemoteFindFirst  INT 2fh fn 111bh
//
//
//  Find the first entry that matches the mask given in the RemoteFindFirst
//  call on a remote machine
//
//  NOTE: pFIND must be filled out before pDIR.  When MS hands down the
//        call to this function, the DIR structure overlaps the FIND
//        structure.
//
//
//  On entry:
//
//		szCWD	 				= Current working directory on the remote machine
//		szMask				= name or mask including path to search for
//		uSearchAttributes	= Attributes to search for on remote machine
//		pFIND 				= Address of the find first data block (in the DTA)
//
//  On exit:
//
//  on success,
//
//		pFIND 			= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteFindFirst(  uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szMask, unsigned uSearchAttributes,
		FIND _D_ * pFIND, DIR _D_ * pDIR );


//  RemoteFindNext  INT 2fh fn 111ch
//
//
//  Find the next entry that matches the mask given in the RemoteFindFirst
//  call on a remote machine
//
//  NOTE: pFIND must be filled out before pDIR.  When MS hands down the
//        call to this function, the DIR structure overlaps the FIND
//        structure.
//
//
//  On entry:
//
//		szCWD	= Current working directory on the remote machine
//		pFIND	= Address of the find first data block (in the DTA)
//
//  On exit:
//
//  on success,
//
//		pFIND 			= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteFindNext( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, FIND _D_ * pFIND, DIR _D_ * pDIR );


//  GetRemoteFileAttributesAndSize  INT 2fh fn 110fh
//
//
//  Retrieve the attributes and size of a file on a remote machine
//
//
//  On entry:
//
//		szCWD	 			= Current working directory on the remote machine
//		szPath 			= Path for the directory on the remote machine
//		puAttributes	= Variable for file attributes of the remote file
//		pulSize			= Variable for file size of the remote file
//
//  On exit:
//
//  on success,
//
//		puAttributes	= is updated
//		pulSize			= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL GetRemoteFileAttributesAndSize( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned * puAttributes,
		ulong * pulSize );


//  SetRemoteFileAttributes  INT 2fh fn 110eh
//
//
//  Set the attributes for a file on a remote machine
//
//
//  On entry:
//
//		szCWD	 			= Current working directory on the remote machine
//		szPath 			= Path for the directory on the remote machine
//		uAttributes		= Desired attributes for the remote file
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL SetRemoteFileAttributes( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uAttributes );


//  CreateRemoteDirectory  INT 2fh fn 1103h
//
//
//  Create a directory on a remote machine
//
//
//  On entry:
//
//		szCWD	 = Current working directory on the remote machine
//		szPath = Path for the directory on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL CreateRemoteDirectory( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath );


//  RemoveRemoteDirectory  INT 2fh fn 1101h
//
//
//  Remove a directory on a remote machine
//
//
//  On entry:
//
//		szCWD	 = Current working directory on the remote machine
//		szPath = Path for the directory on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoveRemoteDirectory( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath );


//  ChangeRemoteDirectory  INT 2fh fn 1105h
//
//
//  Change the current directory on a remote machine
//
//
//  On entry:
//
//		szCWD	 = Current working directory on the remote machine
//		szPath = Path for the directory on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL ChangeRemoteDirectory( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath );


//  DeleteRemoteFile  INT 2fh fn 1113h
//
//
//  Delete a file on the remote machine
//
//
//  On entry:
//
//		szCWD		= Current working directory on the remote machine
//		szPath	= Path for the file on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL DeleteRemoteFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath );


//  RenameRemoteFile  INT 2fh fn 1111h
//
//
//  Rename a file on the remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szCurrentName	= Current name of the file on the remote machine
//		szNewName		= Desired name of the file on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RenameRemoteFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szCurrentName, char _D_ * szNewName );


//  RemoteExtendedOpenCreateFile INT 2fh fn 112eh
//
//
//  Open, create, or truncate a file on a remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szPath			= Path for the directory on the remote machine
//		uOpenMode		= Desired action (open, create, or truncate)
//		uAttributes    = File attributes for the file
//    uProcessID     = Process ID on remote machine
//		puAction       = Variable for the action performed (open, create, etc)
//		puRemoteHandle	= Variable for file handle on remote machine
//    puTime         = Variable for file time in DOS packed form
//    puDate         = Variable for file date in DOS packed form
//		pulSize        = Variable for the file size
//		puAttributes   = Variable for the file attributes
//
//  On exit:
//
//  on success,
//
//		puAction       = is updated
//		puRemoteHandle	= is updated
//    puTime         = Time in DOS packed form
//    puDate         = Date in DOS packed form
//		pulSize        = is updated
//		puAttributes   = is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteExtendedOpenCreateFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uOpenMode,
		unsigned uAttributes, unsigned uProcessID, unsigned * puAction,
		unsigned * puRemoteHandle, unsigned * puTime, unsigned * puDate,
		ulong * pulSize, unsigned * puAttributes );


//  RemoteOpenFile INT 2fh fn 1116h
//
//
//  Open a file on a remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szPath			= Path for the directory on the remote machine
//		uOpenMode		= Desired action (open, create, or truncate)
//    uProcessID     = Process ID on remote machine
//		puRemoteHandle	= Variable for file handle on remote machine
//    puTime         = Variable for file time in DOS packed form
//    puDate         = Variable for file date in DOS packed form
//		pulSize        = Variable for the file size
//		puAttributes   = Variable for the file attributes
//
//  On exit:
//
//  on success,
//
//		puRemoteHandle	= is updated
//    puTime         = Time in DOS packed form
//    puDate         = Date in DOS packed form
//		pulSize        = is updated
//		puAttributes   = is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteOpenFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uOpenMode,
		unsigned uProcessID, unsigned * puRemoteHandle,	unsigned * puTime,
		unsigned * puDate, ulong * pulSize, unsigned * puAttributes );


//  RemoteCreateFile INT 2fh fn 1117h
//
//
//  Create or truncate a file on a remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szPath			= Path for the directory on the remote machine
//		uAttributes    = File attributes for the file
//    uProcessID     = Process ID on remote machine
//		puRemoteHandle	= Variable for file handle on remote machine
//    puTime         = Variable for file time in DOS packed form
//    puDate         = Variable for file date in DOS packed form
//		pulSize        = Variable for the file size
//		puAttributes   = Variable for the file attributes
//
//  On exit:
//
//  on success,
//
//		puRemoteHandle	= is updated
//    puTime         = Time in DOS packed form
//    puDate         = Date in DOS packed form
//		pulSize        = is updated
//		puAttributes   = is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteCreateFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uAttributes,
		bool fCreateNew, unsigned uProcessID, unsigned * puRemoteHandle,
		unsigned * puTime, unsigned * puDate, ulong * pulSize,
		unsigned * puAttributes );


//  SetRemoteFilePosition  INT 2fh fn 1121h
//
//
//  Set the position of a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle 			= File handle on remote machine
//		ulPositionFromEnd		= Desired position in file from the end
//		pulResultingPosition	= Variable for the file position after the call
//
//  On exit:
//
//  on success,
//
//		pulResultingPosition	= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL SetRemoteFilePosition( unsigned uRemoteHandle,
		ulong ulPositionFromEnd, ulong * pulResultingPosition );


//  ReadRemoteFile  INT 2fh fn 1108h
//
//
//  Read from a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle	= File handle on remote machine
//		uNumberOfBytes	= Number of bytes to read
//    ulFilePosition = Position in the file to begin reading
//		pBuffer			= Address of buffer
//		puByteRead		= Variable for the number of bytes actually read
//
//  On exit:
//
//  on success,
//
//		puByteRead	= is updated
//		pBuffer		= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL ReadRemoteFile( unsigned uRemoteHandle, ulong ulFilePosition,
		unsigned uNumberOfBytes, void _D_ * pBuffer, unsigned * puBytesRead );


//  WriteRemoteFile  INT 2fh fn 1109h
//
//
//  Write to a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle	= File handle on remote machine
//		uNumberOfBytes	= Number of bytes to write
//    ulFilePosition = Position in the file to begin writing
//		pBuffer			= Address of buffer
//		puBytesWritten	= Variable for the number of bytes actually written
//
//  On exit:
//
//  on success,
//
//		puBytesWritten	= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL WriteRemoteFile( unsigned uRemoteHandle,
		ulong ulFilePosition, unsigned uNumberOfBytes, void _D_ * pBuffer,
		unsigned * puBytesWritten );


//  CommitRemoteFile  INT 2fh fn 1107h
//
//
//  Commit a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle   = File handle on remote machine
//    fUpdateDateTime = Boolean for whether to update the date and time
//    uTime           = Time in DOS packed form
//    uDate           = Date in DOS packed form
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL CommitRemoteFile( unsigned uRemoteHandle,
		bool fUpdateDateTime, unsigned uTime, unsigned uDate );


//  CloseRemoteFile  INT 2fh fn 1106h
//
//
//  Close a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle   = File handle on remote machine
//    fUpdateDateTime = Boolean for whether to update the date and time
//    uTime           = Time in DOS packed form
//    uDate           = Date in DOS packed form
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL CloseRemoteFile( unsigned uRemoteHandle,
		bool fUpdateDateTime, unsigned uTime, unsigned uDate,
		bool fDuplicateHandleAndClose );



//  CloseAllRemoteFiles  INT 2fh fn 111dh
//
//
//  Close all files on a remote machine for local process termination
//
//
//  On entry:
//
//		uProcessID = The identifier process that is terminating
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned CloseAllRemoteFiles( unsigned uProcessID );




//  ========================================================================
//
//  The remainder of this file is specific to the implementation.
//
//  ========================================================================




//  This is the structure information returned for each remote drive
//
typedef struct RemoteDriveList REMOTELIST;
typedef REMOTELIST * PREMOTELIST;
struct RemoteDriveList
{
	uchar ucRemoteDriveLetter;
	bool  fIsRemovable;
	bool  fIsRemote;
};


//  This is the maximum size of a read or write requested in one
//  server request.  This value inevidably controls the size of
//  a global server request data space
//
#define MAX_RW_SIZE		16*1024


//  INT 2fh fn 110Ch
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn110C REQ110C;
typedef REQ110C * PREQ110C;
struct ReqFn110C
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
};


//  INT 2fh fn 110ch
//
//  Structure for returning the results of the operation
//
typedef struct ServFn110C SERV110C;
typedef SERV110C * PSERV110C;
struct ServFn110C
{
	unsigned uFunction;
	bool	   fService;
	unsigned uErrorCode;
	uchar    ucMediaIdByte;
	unsigned uBytesPerSector;
	uchar    ucSectorsPerCluster;
	unsigned uTotalClusters;
	unsigned uAvailableClusters;
};


//  INT 2fh fn 110Fh
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn110F REQ110F;
typedef REQ110F * PREQ110F;
struct ReqFn110F
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szPath[128];
};


//  INT 2fh fn 110Fh
//
//  Structure for returning the results of the operation
//
typedef struct ServFn110F SERV110F;
typedef SERV110F * PSERV110F;
struct ServFn110F
{
	unsigned uFunction;
	bool	   fService;
	unsigned uErrorCode;
	unsigned uAttributes;
	ulong    ulSize;
};


//  INT 2fh fn 110Eh
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn110E REQ110E;
typedef REQ110E * PREQ110E;
struct ReqFn110E
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szPath[128];
	unsigned uAttributes;
};


//  INT 2fh fn 110Eh
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV110E;
typedef SERV110E * PSERV110E;


//  INT 2fh fn 1113h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1113 REQ1113;
typedef REQ1113 * PREQ1113;
struct ReqFn1113
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szPath[128];
};


//  INT 2fh fn 1113h
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV1113;
typedef SERV1113 * PSERV1113;


//  INT 2fh fn 1111h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1111 REQ1111;
typedef REQ1111 * PREQ1111;
struct ReqFn1111
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szCurrentName[128];
	char szNewName[128];
};


//  INT 2fh fn 1111h
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV1111;
typedef SERV1111 * PSERV1111;


//  INT 2fh fn 112Eh
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn112E REQ112E;
typedef REQ112E * PREQ112E;
struct ReqFn112E
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szPath[128];
	unsigned uOpenMode;
	unsigned uAttributes;
	unsigned uAction;
	unsigned uProcessID;
};


//  INT 2fh fn 112Eh
//
//  Structure for returning the results of the operation
//
typedef struct ServFn112E SERV112E;
typedef SERV112E * PSERV112E;
struct ServFn112E
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	unsigned uRemoteHandle;
	unsigned uRemoteAction;
	unsigned uFileTime;
	unsigned uFileDate;
	ulong ulSize;
	unsigned uAttributes;
};


//  INT 2fh fn 1116h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1116 REQ1116;
typedef REQ1116 * PREQ1116;
struct ReqFn1116
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szPath[128];
	unsigned uOpenMode;
	unsigned uProcessID;
};


//  INT 2fh fn 1116h
//
//  Structure for returning the results of the operation
//
typedef struct ServFn1116 SERV1116;
typedef SERV1116 * PSERV1116;
struct ServFn1116
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	unsigned uRemoteHandle;
	unsigned uFileTime;
	unsigned uFileDate;
	ulong ulSize;
	unsigned uAttributes;
};


//  INT 2fh fn 1117h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1117 REQ1117;
typedef REQ1117 * PREQ1117;
struct ReqFn1117
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szPath[128];
	unsigned uAttributes;
	bool fCreateNew;
	unsigned uProcessID;
};


//  INT 2fh fn 1117h
//
//  Structure for returning the results of the operation
//
typedef struct ServFn1117 SERV1117;
typedef SERV1117 * PSERV1117;
struct ServFn1117
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	unsigned uRemoteHandle;
	unsigned uFileTime;
	unsigned uFileDate;
	ulong ulSize;
	unsigned uAttributes;
};


//  INT 2fh fn 1121h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1121 REQ1121;
typedef REQ1121 * PREQ1121;
struct ReqFn1121
{
	unsigned uFunction;
	bool	fService;
	unsigned uRemoteHandle;
	ulong ulPositionFromEnd;
};


//  INT 2fh fn 1121h
//
//  Structure for returning the results of the operation
//
typedef struct ServFn1121 SERV1121;
typedef SERV1121 * PSERV1121;
struct ServFn1121
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	ulong ulResultingPosition;
};


//  INT 2fh fn 1108h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1108 REQ1108;
typedef REQ1108 * PREQ1108;
struct ReqFn1108
{
	unsigned uFunction;
	bool	fService;
	unsigned uRemoteHandle;
	ulong ulFilePosition;
	unsigned uNumberOfBytes;
};


//  INT 2fh fn 1108h
//
//  Structure for returning the results of the operation
//
typedef struct ServFn1108 SERV1108;
typedef SERV1108 * PSERV1108;
struct ServFn1108
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	unsigned uBytesRead;
	uchar ucData[MAX_RW_SIZE];
};


//  INT 2fh fn 1109h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1109 REQ1109;
typedef REQ1109 * PREQ1109;
struct ReqFn1109
{
	unsigned uFunction;
	bool	fService;
	unsigned uRemoteHandle;
	ulong ulFilePosition;
	unsigned uNumberOfBytes;
	uchar ucData[MAX_RW_SIZE];
};


//  INT 2fh fn 1109h
//
//  Structure for returning the results of the operation
//
typedef struct ServFn1109 SERV1109;
typedef SERV1109 * PSERV1109;
struct ServFn1109
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	unsigned uBytesWritten;
};


//  INT 2fh fn 1106h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1106 REQ1106;
typedef REQ1106 * PREQ1106;
struct ReqFn1106
{
	unsigned uFunction;
	bool	   fService;
	unsigned uRemoteHandle;
	bool		fUpdateDateTime;
	unsigned uFileTime;
	unsigned uFileDate;
	bool     fDuplicateHandleAndClose;
};


//  INT 2fh fn 1106h
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV1106;
typedef SERV1106 * PSERV1106;


//  INT 2fh fn 111Dh
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn111D REQ111D;
typedef REQ111D * PREQ111D;
struct ReqFn111D
{
	unsigned uFunction;
	bool	   fService;
	unsigned uProcessID;
};


//  INT 2fh fn 111Dh
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV111D;
typedef SERV111D * PSERV111D;


//  INT 2fh fn 1107h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1106 REQ1107;
typedef REQ1107 * PREQ1107;


//  INT 2fh fn 1107h
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV1107;
typedef SERV1107 * PSERV1107;


//  INT 2fh fn 1101h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1105 REQ1101;
typedef REQ1101 * PREQ1101;


//  INT 2fh fn 1101h
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV1101;
typedef SERV1101 * PSERV1101;


//  INT 2fh fn 1103h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1105 REQ1103;
typedef REQ1103 * PREQ1103;


//  INT 2fh fn 1103h
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV1103;
typedef SERV1103 * PSERV1103;


//  INT 2fh fn 1105h
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn1105 REQ1105;
typedef REQ1105 * PREQ1105;
struct ReqFn1105
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szPath[128];
};


//  INT 2fh fn 1105h
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERV1105;
typedef SERV1105 * PSERV1105;


//  INT 2fh fn 111bh
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn111b REQ111B;
typedef REQ111B * PREQ111B;
struct ReqFn111b
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	char szMask[128];
	unsigned uSearchAttr;
};


//  INT 2fh fn 111bh
//
//  Structure for returning the results of the operation
//
typedef struct ServFn111b SERV111B;
typedef SERV111B * PSERV111B;
struct ServFn111b
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	FIND Find;
	DIR  Dir;
};


//  INT 2fh fn 111ch
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqFn111C REQ111C;
typedef REQ111C * PREQ111C;
struct ReqFn111C
{
	unsigned uFunction;
	bool	fService;
	uchar ucDriveLetter;
	char szCWD[67];
	FIND Find;
};


//  INT 2fh fn 111ch
//
//  Structure for returning the results of the operation
//
typedef struct ServFn111C SERV111C;
typedef SERV111C * PSERV111C;
struct ServFn111C
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	char cReserved[66];	// Used only to align the FIND structure with REQ111C
	FIND Find;
	DIR  Dir;
};


//  INT 2fh fn 11xxh
//  Invalid INT 2fh functions
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqShort REQSHORT;
typedef REQSHORT * PREQSHORT;
struct ReqShort
{
	unsigned uFunction;
	bool	fService;
};


//  INT 2fh fn 11xxh
//  Invalid INT 2fh functions
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERVSHORT;
typedef SERVSHORT * PSERVSHORT;
struct ServShort
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
};


//  INT 2fh fn 11xxh
//  Invalid INT 2fh functions
//
//  Structure for requesting an operation be performed by the server
//
typedef struct ReqPeek REQPEEK;
typedef REQPEEK * PREQPEEK;
struct ReqPeek
{
	unsigned uFunction;
	bool	fService;
	unsigned uIP;
	unsigned uCS;
	unsigned uAX;
	unsigned uBX;
	unsigned uCX;
	unsigned uDX;
	unsigned uSI;
	unsigned uDI;
	unsigned uDS;
	unsigned uES;
};


//  INT 2fh fn 11xxh
//  Invalid INT 2fh functions
//
//  Structure for returning the results of the operation
//
typedef struct ServShort SERVPEEK;
typedef SERVPEEK * PSERVPEEK;


//  Structure for requesting the list of mappable drives on
//  the remote system.
//
typedef struct ReqShort REQMAP;
typedef REQMAP * PREQMAP;


//  Structure for returning the list of mappable drives on
//  the remote system.
//
typedef struct ServMap SERVMAP;
typedef SERVMAP * PSERVMAP;
struct ServMap
{
	unsigned uFunction;
	bool	fService;
	unsigned uErrorCode;
	REMOTELIST DriveList[26];
};


//  This MUST be set to the maximum request/service packet size plus
//  the size of a TX RX packet
//
#define REQ_PACKET_SIZE 	(sizeof(REQ1109) + sizeof(TXRXPKT))


//  GetGlobalRequestPacketAddress
//
//
//  Return the address of the data space used to form packets
//
//
//  Note:  This data space must be able to hold the maximum
//         possible packet size
//
//
//  On entry:
//
//    Nothing
//
//  On exit:
//
//  	function returns = The address of the data space for a packet
//
//
void * GetGlobalRequestPacketAddress( void );


//  GetDriveMapList
//
//
//  Return the address of the remote drive list array
//
//
//  On entry:
//
//    ppRemoteList = Address of a variable that will contain the
//                   address of the remote list array
//
//  On exit:
//
//		function returns the DOS error code describing the error
//
//
unsigned GetDriveMapList( PREMOTELIST * ppRemoteList );


//  UnloadClient
//
//
//  Invalidate all the drives that were mapped.  Unhook the int 2fh
//  vector.  Then terminate the TSR while returning to the int 2fh caller.
//
//
//  On entry:
//
//    nothing
//
//
//  On exit:
//
//    nothing
//
//
void UnloadClient( void );
