//
//   $Id: CLIENT.C 1.8 2002/10/16 21:42:08Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  CLIENT.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  History:
//
//  04-01-2001  bt  Created
//


//  Borland libraries
//
#include <process.h>
#include <stdio.h>
#include <mem.h>
#include <string.h>


//  Local libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "fatworld.h"
#include "windows.h"
#include "dosver.h"
#include "bldver.h"
char far * GetEnvEntry( const char * szName );


//  Local includes
//
#include "client.h"
#include "cliapi.h"


//  Prototypes
//
#include "client.pt"


bool fIsFat32World;
bool fInWindows;
LPLOL lpLOL;
bool fSwitches[MAX_BOOLEAN_SWITCHES];


//  Start of program
//
uchar main( int argc, char *argv[] )
{
	bool fSuccessful;
	struct MCB far * lpMCB;
	unsigned uProgramPara;
	char far * lpszOSString;
	bool fIsWinNT;


	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();


	//  Determine if this is Windows NT
	//
	lpszOSString = GetEnvEntry("OS");
	fIsWinNT = ( _fstrcmp( lpszOSString, "Windows_NT" ) == 0 );
	if( fIsWinNT )
	{
		printf("This program cannot be run under Window NT.\n");
		return 2;
	}


	//  Determine if we are in windows
	//
	fInWindows = dlInWindows();


	//  Get the DOS List of Lists
	//
	dlGetLOLPointer( &lpLOL );


	//
	//
	fSuccessful = InitInt2fInterface( argc-1, &argv[1] );
	if( fSuccessful )
	{
		//  Terminate and stay resident
		//
		lpMCB = MK_FP( _psp - 1, 0 );
		uProgramPara = lpMCB->para_cnt;


		asm	mov	dx, uProgramPara
		asm	mov	ax, 3100h
		asm	int	21h
	}


	return 1;
}


//  GetKey
//
//
//  Retrieve the user key if one is available
//
//
//  On entry:
//
//		pucKey = Variable to return the key pressed by the user
//
//  On exit:
//
//  	If function returns TRUE,
//
//			pucKey = Is updated with the key the user pressed
//
//		If function returns FALSE,
//
//			No key has been pressed
//
//
bool GetKey( uchar * pucKey )
{
	bool fKeyAvailable = FALSE;
	uchar ucTemp;


	asm	mov	ah, 0bh
	asm	int	21h
	asm	mov	ucTemp, al
	if( ucTemp != 0 )
	{
		fKeyAvailable = TRUE;
		asm	mov	ah, 08h
		asm	int	21h
		asm	mov	ucTemp, al
		*pucKey = ucTemp;
		if( ucTemp == 0 )
		{
			asm	mov	ah, 08h
			asm	int	21h
			asm	mov	ucTemp, al
		}
	}


	return fKeyAvailable;
}


//  Show the usage for a bad command line parameter
//
void OptError(char * szMsg)
{
	unsigned uIndex = 0;

	while( (szMsg[uIndex] != ' ') && (szMsg[uIndex] != 0) )
	{
		if( szMsg[uIndex] == '/' )
		{
			uIndex++;
			if( szMsg[uIndex] != 0 )
			{
				uIndex++;
			}
			break;
		}
		uIndex++;
	}
	szMsg[uIndex] = 0;

	printf("Invalid Switch - %s\n", szMsg );
	exit(255);
}


//  Determine if we should display the signon message and if
//  so display it
//
void DisplaySignonMessage( void )
{
	char * szSignOnMessage = "SERLINK %s %s\n%s\n\n";

	if( !DoHideSignon() )
	{
		if( fIsFat32World )
		{
			printf(szSignOnMessage,SHORTVERSION,BUILDVERSION,COPYRIGHT);
		}
		else
		{
			printf(szSignOnMessage,SHORTVERSION622,BUILDVERSION,COPYRIGHT);
		}
	}
}


//  Display the usage screen and exit
//
void Usage( void )
{
	static char szUsage[] = ""
	"SERLINK [/R][/N][/O<list>][/D<list>][/C#][/I#][/B#][/W#]\n"
	"SERLINK /U\n"
	"\n"
	"/U  Disable and unload the program\n"
	"/R  Don't map removable drives\n"
	"/N  Don't map network drives\n"
	"/O<list> Only map in drives from this list of drive letters\n"
	"/D<list> Don't map in drives from this list of drive letters\n"
	"/C# Comport numbers 1-4 are valid.  Default:COM1\n"
	"/I# IRQ number which can be used to overide the default IRQ for COM1-COM4\n"
	"/B# Baud rate which can be 115200,57600,38400,19200,9600,4800,2400,1200,\n"
   "    and 300. Default:115200\n"
	"/W# Number of seconds to wait before timing out.  MAX:60 Default:10\n"
	"";

	DisplaySignonMessage();
	printf( szUsage );
	exit(1);
}
