//
//   $Id: NETAPI.H 1.6 2002/10/16 21:42:08Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  NETAPI.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  This file contains all the API function prototypes and constants
//  that the int 2fh IFS interface uses
//
//  History:
//
//  04-01-2001  bt  Created
//




//  ========================================================================
//
//  The following constants are required for the API
//
//  ========================================================================




//  These are the error codes returned by the API
//
#define NET_TIMESHARE_TIMEOUT		COMM_TIMESHARE_TIMEOUT
#define NET_TIMEOUT					COMM_TIMEOUT
#define NET_SEND_FAILED				COMM_SEND_FAILED
#define NET_READY_FAILED			COMM_READY_FAILED
#define NET_SERVICED					COMM_SERVICED




//  ========================================================================
//
//  The following functions are required for the API
//
//  ========================================================================




//  NetworkTXRXInit
//
//
//  Initialize the "network" interface
//
//
//  On entry:
//
//    argc = The number of options in the argv array
//    argv = Array of pointers to command line options
//
//  On exit:
//
//  on success,
//
//  	function returns TRUE
//
//  on error,
//
//  	function returns FALSE
//
//
bool NetworkTXRXInit( int argc, char *argv[] );




//  NetworkTXRXDeInit
//
//
//  Uninitialize the "network" interface
//
//
//  On entry:
//
//    nothing
//
//  On exit:
//
//  on success,
//
//  	function returns TRUE
//
//  on error,
//
//  	function returns FALSE
//
//
bool NetworkTXRXDeInit( void );




//  NetworkTX
//
//
//  Transmit a packet over the network
//
//
//  On entry:
//
//    pPacket     = The address of the packet (data)
//    uPacketSize = The size of the packet to transmit
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns an error code defined in NETAPI.H
//
//
unsigned NetworkTX( void * pPacket, unsigned uPacketSize );


//  NetworkRX
//
//
//  Receive a packet from the network
//
//
//  Note:  This function must be able to receive the maximum
//         possible packet size
//
//
//  On entry:
//
//    pPacket = The address of the packet (data)
//
//  On exit:
//
//  on success,
//
//    *pPacket = Updated with the packet (data)
//
//  	function returns 0
//
//  on error,
//
//		function returns an error code defined in NETAPI.H
//
//
unsigned NetworkRX( void * pPacket );




//  ========================================================================
//
//  The remainder of this file is specific to the implementation.
//
//  ========================================================================




//  ServiceRequest
//
//
//  Transmit a packet and wait to receive a packet
//
//
//  Note:  This function must be able to receive the maximum
//         possible packet size
//
//
//  On entry:
//
//    pPacket = The address of the packet (data)
//
//  On exit:
//
//  on success,
//
//    *pPacket = Updated with the packet (data)
//
//  	function returns 0
//
//  on error,
//
//		function returns an error code defined in NETAPI.H
//
//
unsigned ServiceRequest( void * pRequestPacket, unsigned uPacketSize );



//  GetNetworkTypeDetailsWord
//
//
unsigned GetNetworkTypeDetailsWord( void );



//  GetNetworkTypeWord
//
//
unsigned GetNetworkTypeWord( void );
