;
;   $Id: DISP2.ASM 1.4 2002/10/16 21:43:10Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;   disp.asm   Fri Aug  7 1987
;
;   Copyright (c) 1989-2002 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary

; Fast screen display package

include ..\include\datalght.inc
InitModel %MEMMODEL
.Code

IF @CodeSize
	P	= 6
ELSE
	P	= 4
ENDIF
IF @DataSize
	SIZEPTR = 4
ELSE
	SIZEPTR = 2
ENDIF
SPTR	= 1


video_io macro
	int	10h
	endm

;ASCII values
DEL	equ	07Fh		;DEL character

	extrn	_pformat:proc


.data
	public	_disp_numrows,_disp_numcols
_disp_numrows	dw	25	;# of rows in display
_disp_numcols	dw	0	;# of columns in display

scrnrowcol	label	word	;row,col of actual screen cursor
scrncol	db	?
scrnrow	db	?

	public	_disp_cursorrow,_disp_cursorcol
_disp_cursorrow	dw	?	;row,col of where we want the cursor to be
_disp_cursorcol	dw	?

	public	_att
normatt	equ	07h	;white chars on black background
stndatt	equ	070h	;inverse video
_att	db	normatt	;current attribute

	public	_disp_mono,_disp_base,_disp_snowycga,_disp_mode,_disp_inited
	public	_disp_ega
_disp_mono	db	1	;0 for color, 1 for monochrome
_disp_snowycga	db	1	;if 1, then the display is an IBM snowy CGA
_disp_mode	db	?	;what is the current display mode?
_disp_inited	db	0	;1 if display package is opened
_disp_ega	db	0	;1 if IBM EGA
_disp_base	dw	0B000h	;segment of base of video screen
				; (default is mono)
				;if 0, then not available (use BIOS)

cursortype	dw	?	;where we save the cursor type

	 ifdef I8086P
ptoputc	dw	offset _disp_putc
	dw	seg _disp_putc
	 endif

.Code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Printf directly to the screen.
;	_disp_printf(format,args)

comment ~
void disp_printf(char *fmt, ...)
~
	public	_disp_printf
_disp_printf proc
	push	BP
	mov	BP,SP
	 if @DataSize
	push	SS			;segment of args
	 endif
	lea	AX,P+SIZEPTR[BP]	;AX = offset of args
	push	AX
	 if @DataSize
	push	P+2[BP]			;segment of format
	 endif
	push	P[BP]			;offset of format
    if @CodeSize
	mov	AX, SEG _disp_putc
	push	ax
    endif
	mov	AX,offset _disp_putc
	push	AX
	call	_pformat		;_pformat(&_disp_putc,format,&args);
	mov	SP,BP
	pop	BP
    Q4: ret
_disp_printf endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Flush output.
; What this does is set the hardware cursor (scrnxxx) to be where
; the software cursor (_disp_cursorxxx) is. This is only done when
; _disp_flush() is called because it is a relatively slow operation.

comment ~
void disp_flush(void)
~
	public	_disp_flush
_disp_flush proc
	push	BP
	mov	DH,byte ptr _disp_cursorrow
	mov	DL,byte ptr _disp_cursorcol
F2:	mov	scrnrow,DH
	mov	scrncol,DL
	xor	BX,BX		;page 0
	mov	AH,2		;set cursor proction
	video_io
F1:	pop	BP
	ret
_disp_flush endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set things up. That is, determine what display we've got.

comment ~
void disp_open(void)
~
	public	_disp_open
_disp_open proc
	cmp	_disp_inited, 0
	jne	Q4		;if already initialized
	mov	_disp_inited,1
	push	BP
	push	DI
	push	ES

	;Determine number of rows, also if we have an EGA
	xor	DX,DX		;default value
	xor	BH,BH
	mov	AX,01130h	;inquire info from EGA BIOS
	video_io
	or	DL,DL		;Check if DL is still zero
	jz	L3		;if so, no EGA
	mov	_disp_ega,1	;flag that we have an EGA
	mov	_disp_snowycga,0	;EGAs don't snow
	inc	DL
	mov	_disp_numrows,DX	;number of rows
L3:

	mov	AH,15
	video_io
	mov	byte ptr _disp_numcols,AH	;set number of columns
	mov	_disp_mode,AL		;save display mode
	cmp	AL, 7
	jne	Q2			;if not mono mode
	mov	_disp_snowycga,0		;mono displays don't snow

	;Do an equipment check to see if this is really a mono card.
	;Note that the COMPAQ can be in mode 7, but still be a color card!
	int	11h			;Equipment Determination BIOS call
	and	AX,  00110000b		;isolate initial video mode bits
	cmp	AX, 00110000b
	je	L1			;yes, it is a real mono card
	mov	AL,7			;mode 7
	jmp	L51

Q2:	cmp	AL, 15
	je	L51			;if EGA monochrome graphics mode
	mov	_disp_mono,0		;else color display
L51:	mov	_disp_base,0B800h	;base of color adapter
	cmp	AL, 3
	jbe	L1			;if color text mode
	cmp	AL, 7
	je	L1			; or mono text mode
	mov	_disp_base,0		;use BIOS instead of direct access to video ram
					; for all graphics and other unrecognized modes
	jmp	L50
L1:
	;Find out if we are running under DESQview.
	;This section provided by Erik Lindberg.
	mov	AX,2B01h	; Get DESQview version (set date)
	mov	CX,'DE'		;     if CX,DX = 'DESQ', is invalid
	mov	DX,'SQ'		;     setdate call.
	int	21h		; DOS interrupt.
	cmp	AL,0FFh		; check for invalid return.
	jz	L2		;   then DESQview is not running.
	mov	ES,_disp_base	; get pre-determined buffer address (_disp_base:0)
	xor	DI,DI		;   into ES:DI
	mov	AH,0FEh		; load proction code into AH
	video_io		; to request alternate buffer address.
	mov	_disp_base,ES	; and save it.
L2:

	;determine where cursor is
L50:	mov	AH,3
	video_io
	mov	cursortype,CX	;save original cursor type
	mov	scrnrow,DH
	mov	scrncol,DL
	mov	AL,DH
	cbw
	mov	_disp_cursorrow,AX
	xor	DH,DH
	mov	_disp_cursorcol,DX

	pop	ES
	pop	DI
	pop	BP
	ret
_disp_open endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Close things up

comment ~
void disp_close(void)
~
	public	_disp_close
_disp_close proc
	cmp	_disp_inited, 0
	je	Q3		;quit if never opened
	push	BP
	call	_disp_flush	;flush all output
	mov	AH,1
	mov	CX,cursortype	;restore original cursor type
	video_io
	mov	_disp_inited,0
	pop	BP
Q3:	ret
_disp_close endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Be BIOS compatible, instead of poking directly into the screen
; memory.

	public	_disp_usebios
_disp_usebios proc
	mov	_disp_base,0
	ret
_disp_usebios endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set cursor type.
; Use:
;	_disp_setcursortype(startline*256 + endline);

comment ~
void disp_setcursortype(int cursorType)
~
	public	_disp_setcursortype
_disp_setcursortype proc
	push	BP
	mov	BP,SP
	mov	CX,P[BP]
	mov	AH,1
	video_io
	pop	BP
	ret
_disp_setcursortype endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Put a character into the display

comment ~
void disp_putc(char c)
~
	public	_disp_putc
_disp_putc proc
	push	BP
	mov	BP,SP
	mov	AL,P[BP]		;char
	cmp	AL, ' '
	jb	docntl			;control char
	cmp	AL, DEL
	je	zip1			;ignore rubouts
doout:	call	near ptr outchr		;display character
	mov	AX,_disp_cursorcol
	inc	AX			;next column
	cmp	AX, _disp_numcols
	jb	L19			;if not past right edge
	xor	AX,AX
	mov	BX,_disp_cursorrow	;get row and column
	inc	BX			;start of next row
	cmp	BX, _disp_numrows
	jb	L18			;if not past bottom
;	call	near ptr scrollup	;scroll up 1 line
;	xor	AX,AX
;	mov	BX,_disp_numrows		;lower left corner
;	dec	BX
	xor	BX,BX
L18:	mov	_disp_cursorrow,BX
L19:	mov	_disp_cursorcol,AX
zip1:	pop	BP
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Handle control characters

docntl:	xor	AH,AH
	mov	BX,AX
	add	BX,AX
	jmp	CS:word ptr (offset cntltab)[BX]

cntltab:
	dw	7 dup (offset doout)
	dw	offset beep,offset dobs	;BEL,BS
	dw	offset dotab,offset donl	;TAB,LF
	dw	offset donl,offset donl	;VT,FF
	dw	offset docr			;CR
	dw	offset doout,offset doout
	dw	offset doout,offset doout		;P,XON,R,XOFF
	dw	7 dup (offset doout)
	dw	offset doout				;escape
	dw	6 dup (offset doout)

;;;;;;;;;;;;;;;;;;;;;;
; Bell

beep:	mov	DL,7
	mov	ah, 2
	int	21h			;send a bell to DOS
	pop	BP
	ret

;;;;;;;;;;;;;;;;;;;;
; Backspace (non-destructive)

dobs:	mov	AX,_disp_cursorcol
	dec	AX			;backup 1 column
	js	L140			;oops! already in column 0
	mov	_disp_cursorcol,AX
L140:	pop	BP
	ret

;;;;;;;;;;;;;;;;;;;;
; Carriage return

docr:	mov	_disp_cursorcol,0		;reset column
	pop	BP
	ret

;;;;;;;;;;;;;;;;;;;
; Line feed

donl:	mov	_disp_cursorcol,0		;reset column to start of line

dolf:	mov	DX,_disp_cursorrow
	inc	DX
	cmp	DX, _disp_numrows
	jb	L101
;	call	near ptr scrollup
	mov	_disp_cursorrow,0
	pop	BP
	ret

L101:	mov	_disp_cursorrow,DX
	pop	BP
	ret

;;;;;;;;;;;;;;;;;;;
; Tab (non-destructive)

dotab:
	mov	AX,_disp_cursorcol
	or	AX,7
	inc	AX		;advance to next tab stop
	cmp	AX, _disp_numcols
	jb	D1
	mov	AX,_disp_numcols
	dec	AX
D1:	mov	_disp_cursorcol,AX
	pop	BP
	ret

_disp_putc endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Scroll a region of the display.
;	void disp_scroll(lines,ulrow,ulcol,lrrow,lrcol,att);
;	lines > 0:	scroll up
;	lines == 0:	blank window
;	lines < 0:	scroll down

comment ~
void disp_scroll(int lines, int ulRow, int ulCol, int lrRow, int lrCol, int attr)
~
	public	_disp_scroll
_disp_scroll proc
	push	BP
	mov	BP,SP
	mov	AL,P[BP]
	mov	CH,P+2[BP]
	mov	CL,P+4[BP]
	mov	DH,P+6[BP]
	mov	DL,P+8[BP]
	mov	BH,P+10[BP]
	mov	AH,6
	or	AL,AL
	jns	scroll1
	neg	AL
	inc	AH
scroll1:
	video_io
	pop	BP
	ret
_disp_scroll endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Poke att/char into display at row,column.
;	void disp_pokew(row,col,attchr);

comment ~
void disp_pokew(int row, int col, int charAttr)
~
	public	_disp_pokew
_disp_pokew proc
	push	BP
	mov	BP,SP

	mov	CX,P+4[BP]	;save att/char
	mov	DH,P[BP]	;row
	mov	DL,P+2[BP]	;column
	cmp	_disp_base, 0
	jne	W7
	mov	scrnrow,DH
	mov	scrncol,DL
	xor	BH,BH		;page number
	mov	AH,2
	video_io		;set cursor position (BP is destroyed)
	mov	AL,CL		;char
	mov	BL,CH		;attribute to use
	mov	AH,9		;write att/char at current cursor position
	mov	CX,1		;write one character
	video_io
	pop	BP
	ret

W7:
	 if SPTR
	push	ES
	 endif
	mov	AX,_disp_numcols
	mul	DH
	xor	DH,DH
	add	AX,DX		;add in column
	shl	AX,1		;compute offset into screen
	mov	BX,AX
	mov	ES,_disp_base
	cmp	_disp_snowycga, 0
	je	W1	;if skip snow check

	mov	DX,03DAh		;color card status port

W5:	in	AL,DX			;wait for retrace low
	test	AL,1
	jnz	W5
	cli				;turn off interrupts
W6:	in	AL,DX			;wait for retrace high
	test	AL,1
	jz	W6

	mov	ES:[BX],CX		;poke it
	sti				;enable interrupts
	jmp	W2

W1:	mov	ES:[BX],CX		;poke it

W2:
	 if SPTR
	pop	ES
	 endif
	pop	BP
	ret
_disp_pokew endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Read att/char from display at row,column.
;	unsigned _disp_peekw(row,col);

comment ~
unsigned _disp_peekw(int row, int col)
~
	public	_disp_peekw
_disp_peekw proc
	push	BP
	mov	BP,SP

	mov	DH,P[BP]	;row
	mov	DL,P+2[BP]	;column
	mov	scrnrowcol,DX
	xor	BH,BH		;page number
	mov	AH,2
	video_io		;set cursor position (BP is destroyed)
	mov	AH,8		;read att/char at current cursor position
	video_io
	pop	BP
	ret
_disp_peekw endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Display character in AL.

outchr	proc	near
	cmp	_disp_base, 0
	jne	P7
	push	AX
	call	_disp_flush	;bring cursor up to date
	pop	AX
	mov	AH,9		;write att/char at current cursor position
	xor	BH,BH		;page number
	mov	BL, [_att]	;attribute to use
	mov	CX,1		;write one character
	video_io
	ret

P7:
    if SPTR
	push	ES
    endif
	mov	CL, AL
	mov	CH, [_att]	;attribute to use
	mov	AX,_disp_numcols
	mul	_disp_cursorrow
	add	AX,_disp_cursorcol
	shl	AX,1		;compute offset into screen
	mov	BX,AX
	mov	ES,_disp_base
	cmp	_disp_snowycga, 0
	je	P1		;if skip snow check

	mov	DX,03DAh		;color card status port

P5:	in	AL,DX			;wait for retrace low
	test	AL,1
	jnz	P5
	cli				;turn off interrupts
P6:	in	AL,DX			;wait for retrace high
	test	AL,1
	jz	P6

	mov	ES:[BX],CX		;poke it
	sti				;enable interrupts
	jmp	P2

P1:	mov	ES:[BX],CX		;poke it

P2:
    if SPTR
	pop	ES
    endif
	ret
outchr	endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set cursor position

comment ~
void disp_move(int row, int col)
~
	public	_disp_move
_disp_move proc
	push	BP
	mov	BP,SP
	mov	AX,P[BP]
	mov	_disp_cursorrow,AX
	mov	AX,P+2[BP]
	mov	_disp_cursorcol,AX
	pop	BP
	ret
_disp_move endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Delete to end of line (including cursor position)

comment ~
void disp_eeol(void)
~
	public	_disp_eeol
_disp_eeol proc
	mov	CX,_disp_numcols
	sub	CX,_disp_cursorcol	;CX = # of spaces left in line
	mov	AX,_disp_numcols
	mul	_disp_cursorrow
	add	AX,_disp_cursorcol
	jmp	clear1
_disp_eeol endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Delete to end of screen (including cursor position)

comment ~
void disp_eeop(void)
~
	public	_disp_eeop
_disp_eeop proc
	mov	AX,_disp_numcols
	mul	_disp_numrows
	mov	CX,AX		;CX = # of chars on screen
	mov	AX,_disp_numcols
	mul	_disp_cursorrow
	add	AX,_disp_cursorcol
	sub	CX,AX
clear1:
	push	DI
	shl	AX,1
	mov	DI,AX
;	jmp	clear
_disp_eeop endp

;;;;;;;;;;;;;;;;;;;;;;;;
; Send CX spaces to screen starting at DI.

clear proc
	cmp	_disp_base, 0
	jne	C7
	call	_disp_flush	;bring cursor up to date
	mov	AX,9*256+' '	;write att/char at current cursor position
	xor	BH,BH		;page number
	mov	BL, [_att]	;attribute to use
	video_io
	pop	DI
	ret

C7:
    if SPTR
	push	ES
    endif
	mov	ES,_disp_base
	cld
	mov	AH, [_att]
	mov	AL,' '
	cmp	_disp_snowycga, 0
	jne	C1
	rep	stosw
	jmp	C2

C1:	mov	DX,03DAh		;color card status port
	mov	BX,AX

C5:	in	AL,DX			;wait for retrace low
	test	AL,1
	jnz	C5
	cli				;turn off interrupts
C6:	in	AL,DX			;wait for retrace high
	test	AL,1
	jz	C6

	mov	AX,BX
	stosw				;poke it
	sti				;enable interrupts
	loop	C5

C2:
    if SPTR
	pop	ES
    endif
	pop	DI
	ret
clear	endp

;;;;;;;;;;;;;;;;;;;;;;;;
; Start/end standout mode.
; Set attribute for subsequent writes.

	public	_disp_startstand,_disp_endstand,_disp_setattr

_disp_startstand proc
	mov	[_att], stndatt
	ret
_disp_startstand endp

_disp_endstand proc
	mov	[_att], normatt
	ret
_disp_endstand endp

comment ~
/* returns old attribute */
int disp_setattr(int attr)
~
_disp_setattr proc
	push	BP
	mov	BP,SP
	mov	AL,P[BP]
	xchg	[_att], AL
	pop	BP
	ret
_disp_setattr endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Scroll up 1 line (monochrome only)

scrollup proc	near
	cmp	_disp_snowycga, 0
	jne	biosway				;give up and use bios
	cmp	_disp_base, 0
	je	biosway
	push	DS
	 if SPTR
	push	ES
	 endif
	push	SI
	push	DI
	mov	AX,_disp_numcols
	mov	SI,AX
	mov	BX,AX
	mul	_disp_numrows
	sub	AX,SI
	mov	CX,AX			;CX = # of words to scroll
	shl	SI,1			;source is 1 row in
	xor	DI,DI
	mov	ES,_disp_base		;point to video segment
	mov	DS,_disp_base
	cld				;increment
	rep movsw			;do the scroll
	mov	AX,(normatt * 256) + ' '	;att/char for blank row
	mov	CX,BX				;# of words in bottom row
	rep stosw			;blank bottom row
	pop	DI
	pop	SI
	 if SPTR
	pop	ES
	 endif
	pop	DS
	ret

biosway:
	xor	CX,CX			;row,col of upper left corner
	mov	DX,_disp_numcols		;col of lower right corner
	dec	DX
	mov	DH,24
	mov	BH,normatt		;att for blank
	mov	AX,0601h		;scroll up 1 line
	video_io
	ret
scrollup endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Get and return the current video mode.

comment ~
int disp_getmode(void)
~
	public	_disp_getmode
_disp_getmode proc
	push	BP
	mov	BP,SP
	mov	AH,15
	video_io
	xor	AH,AH
	pop	BP
	ret
_disp_getmode endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set the video mode.
; Do not use while disp package is open.

comment ~
void disp_setmode(int mode)
~
	public	_disp_setmode
_disp_setmode proc
	push	BP
	mov	BP,SP
	xor	AH, AH
	mov	AL,P[BP]
	video_io
	xor	AH,AH
	pop	BP
	ret
_disp_setmode endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set into 43 line mode.
; Do not use while disp package is open.

	public	_disp_set43
_disp_set43 proc
	cmp	_disp_ega, 1
	jne	S1
	cmp	_disp_numrows, 25
	jne	S1
	push	BP
	mov	AX,0003h	;set color mode, 80x43
	cmp	_disp_mono, 0
	je	S2
	mov	AX,0007h	;set monochrome mode, 80x43
S2:	mov	_disp_mode,AL		;save display mode
	video_io
	mov	AX,01112h	;character generator BIOS routine
	mov	BL,0		;8x8 double dot character font
	video_io
	mov	AX,01200h	;alternate screen routine
	mov	BL,020h		;alternate print screen routine
	video_io
	;Must set cursor to be a block else it will disappear
	mov	AX,0100h
	mov	CX,0007h	;block cursor
	video_io		;set cursor type

S3:	mov	AX,01130h	;inquire info from EGA BIOS
	video_io
	inc	DL
	xor	DH,DH
	mov	_disp_numrows,DX	;set new # of rows
	pop	BP
	mov ax,1
	 ret
S1: mov ax,0
	 ret
_disp_set43 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Switch from 43 line mode back to 25 line mode.

	public	_disp_reset43
_disp_reset43 proc
	cmp	_disp_ega,1
	jne	S1
	cmp	_disp_numrows, 25
	jbe	S1
	push	BP
	mov	AX,0003		;color, 80x25
	cmp	_disp_mono, 0
	je	R2
	mov	AX,0007		;mono, 80x25
R2:	mov	_disp_mode,AL	;save display mode
	video_io
	mov	AX,01101h	;character generator BIOS routine
	mov	BL,0
	video_io
	mov	AX,01200h
	mov	BL,020h
	video_io
	jmp	S3		;determine # of rows
_disp_reset43 endp

	end
