//
//   $Id: DEFMSG.C 1.4 2002/10/16 21:45:08Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// DEFMSG.C
// Message module for the Datalight disk DEFRAGmentation utility.
// Created 03-13-97 Dennis Edwards
//
// Copyright (c) 1989-2002 Datalight, Inc.
// All Rights Reserved.
// Datalight Confidential and Proprietary
//
#define DEFRAG 1
#include "defmsg.h"

//
// This may eventually need to be included in DOSMSG.C
//


char signon_msg[]= "DEFRAG -- Disk defragmentation utility.\n%s %s\n%s\n";
char usage_msg[] =
"Usage:\tDEFRAG  [drive:] [[/D | /F | /U] [/S[:]order] [/B]]\n"\
"/D         Optimize directories only\n"\
"/U         Optimize directories and defragment files \(default\)\n"\
"/B         Reboot when DEFRAG is finished\n"\
"/S:order   Sort directories in the specified order:\n"\
"           N = Sort by name\n"\
"           E = Sort by extension\n"\
"           D = Sort by date and time\n"\
"           S = Sort by size\n"\
"           - = Reverse previous sort order\n"\
"/H or /?   Display this message.\n"\
"/C         Do NOT prompt for confirmation at command line.\n"\
"Examples:  DEFRAG c: /s:n-e- /b\n"\
"           DEFRAG /u /ss\n"\
"\n"\
"The first example will defragment drive C: and reboot the computer\n"\
"when done. Files will appear in reverse alphabetical order. The second\n"\
"example will defragment files on the default drive, optimizing directories\n"\
"and sorting them in order of increasing file size. DEFRAG will not prompt\n"\
"for confirmation when run from a .BAT file.\n";

// "/F         Optimize directories then defragment files and compact the disk\n"\

char drive_compacted_msg[]= "Drive is compacted.\n";


char	bad_opt_msg[]=  	"Invalid option: %c\n";

char fatal_msg[]=       "DEFRAG Fatal Error: ";
char feinvalid_msg[]=   "Drive is invalid.\n\r";
char fecannot_msg[]=    "Cannot defragment drive.\n\r";
char fenodisk_msg[]=    "Not enough free clusters on drive.\n\r";
char fenomem_msg[]=     "Not enough free memory.\n\r";
char fediskrd_msg[]=    "Reading from disk.\n\r";
char fediskwr_msg[]=    "Writing to disk.\n\r";
char feaborted_msg[]=   "DEFRAG aborted by user.\n\r";

char febadcpu_msg[]=	   "DEFRAG requires a '386 or better CPU.\n\r";

char felongfilenames_msg[]= "Long file names not supported.\n\r";

char fetoomanynodes_msg[]=  "Sub-directory tree has too many nodes.\n\r";

char fewindozed_msg[]=  "Windows detected. Quit Windows and rerun DEFRAG.\n\r";

char feopenfiles_msg[]= "Open files detected. Close all files and rerun DEFRAG.\n\r";

#if DEBUG
char warning[]=           "DEFRAG Warning: the ";
char file_msg[]=          "file ";
char dir_msg[]=           " directory tree is too big to optimize.\n\r";
char toobig_msg[]=        " is too big to defragment.\n\r";
char root_name_msg[]=     "ROOT";
#endif

char criterr_msg[]=       "Error ";
char critrd_msg[]=        "reading";
char critwr_msg[]=        "writing";
char critdrv_msg[]=       " drive ";
char criterr_prompt[]=    "Abort, Retry, Fail or Ignore? ";
char criterr_responses[]= "ARFI";

char chk_invalid_msg[]=   "File has invalid cluster\n";
char chk_dir2file_msg[]=  "First directory cluster is invalid\n";
char chk_baddir_msg[]=	  "Invalid subdirectory\n";
char chk_alloc_msg[]=     "Allocation error\n";

char lost_clusters[]=  "%,u lost clusters found in %,u chains\n";
char cross_linked[]=   "%s cross linked on cluster %u\n";
char chk_nofix[]=      "\aErrors found on disk.\n"\
					       "Run CHKDSK to repair the disk then run DEFRAG again.\n";

/* yes or no questions */
char ask_yesno_msg[]=  "     %s %s? ";
char yesno_str[]=      "[Y/N]";
char yesno_responses[]= "YN";

char percentfragmented_msg[]= "Drive is %d%% fragmented.\n";
char defrag_anyway_msg[]=          "Run DEFRAG anyway";

/* statistics */
char chk_vol_str[]=	      "Volume %-11s created ";
char chk_totaldisk_str[]=	"bytes total disk space";
char chk_hidden_str[]=     "bytes in %,u hidden files";
char chk_dir_str[]=        "bytes in %,u directories";
char chk_user_str[]=       "bytes in %,u user files";
char chk_bad_str[]=        "bytes in bad sectors";
char chk_lost_str[]=       "bytes in lost clusters";
char chk_freedisk_str[]=   "bytes available on disk\n";
char chk_totalmem_str[]=   "bytes total memory";
char chk_freemem_str[]=    "bytes free\n";

char chk_bpc_str[]=            "bytes in each allocation unit";
char chk_totalclusters_str[]=  "total allocation units on disk";
char chk_freeclusters_str[]=   "available allocation units on disk";


char ctrlbrk_msg[]=    "\r<Ctrl><Break> keystroke detected. Press:\n\r";
char ctrlaltdel_msg[]= "\r<Ctrl><Alt><Del> keystroke detected. Press:\n\r"\
							  "      <Ctrl><Alt><Del> again to reboot the machine.\n\r";
char tocontinue_msg[]= "      <Space> to continue DEFRAG.\n\r";
char toexitnow_msg[]=  "      <Enter> to exit DEFRAG.\n\r";

char dirsoptimum_msg[]=    "Directories are optimized.\n";
char filesdefragged_msg[]= "Defragmentation complete.\n";

