//
//   $Id: DEFRAG.H 1.4 2002/10/16 21:45:08Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// DEFRAG.H  Created 03-13-97 Dennis Edwards
//
// Copyright (c) 1989-2002 Datalight, Inc.
// All Rights Reserved.
// Datalight Confidential and Proprietary
//
// Common include module for Datalight disk DEFRAGmentation utility.
//
#if !defined(DEFRAG_H_INCLUDED)
#define      DEFRAG_H_INCLUDED 1

#include "datalght.h"


#if defined(__BORLANDC__)
	#if(__BORLANDC__ < 0x300)
		#undef	 BC2
		#define   BC2   1
	#endif
#else
	#error Not BCC
#endif


#define MAX_NODES_IN_SUBDIR   1024
#define MIN_DEFRAG_PERCENT    20
#define MAXPATH   				80
#define MAX_DEFRAG_ALLOCS     (16+MAX_NODES_IN_SUBDIR)


#if BC2
#define  PASCAL   pascal
#define  _USERENTRY
#define  __seg
#define  __far  far
#define  __near near
#else
#define  PASCAL   __pascal
#endif


#define  MAX(a,b)             (((a) > (b)) ? (a) : (b))
#define  MIN(a,b)             (((a) < (b)) ? (a) : (b))


// Common FAT entries, we will ALWAYS *write* these
//
#define  FREE_CLUSTER         0
#define  BAD_CLUSTER          0xFFF7
#define  FAT_EOF              0xFFFF

//  any of {{0xFF8,0xFF9,..,0xFFF},{0xFFF8,0xFFF9,...,0xFFFF}} can
//  be considered an end of FAT allocation chain marker (see MSDOS
//  Programmer's Ref pg33). When reading a 12-bit FAT, our
//  ReadFATInRAM(clusterIndex) routine sets all bits in the upper
//  nybble of the returned word if the FAT entry values is > 0xFF6.
//
#define  IS_FAT_EOF(x)        ((x) > 0xFFF7)

// maximum value in a DPB.hiclus field for a 12-BIT FAT.
//
#define HICLUS_OF_12_BIT_FAT		0x0FF6

// file/directory attributes (in a DIR)
//
#define A_NORMAL     0x00           // OK for OpenOrCreatFile()
#define A_READONLY   0x01           // OK for OpenOrCreatFile()
#define A_HIDDEN     0x02           // OK for OpenOrCreatFile()
#define A_SYSTEM     0x04           // OK for OpenOrCreatFile()
#define A_VOLUME     0x08
#define A_LONGNAME   0x0F           // a long filename
#define A_SUBDIR     0x10
#define A_ARCHIVE    0x20           // OK for OpenOrCreatFile()
#define A_DEVICE     0x40

// openMode values for OpenOrCreatFile()
//
#define O_RDONLY     0x0000
#define O_WRONLY     0x0001
#define O_RDWR       0x0002
#define O_RESERVED   0x0008   /* must not be used - reserved */
#define O_DENYOPEN   0x0010
#define O_DENYWRITE  0x0020
#define O_DENYREAD   0x0030
#define O_DENYNONE   0x0040
#define O_SHARE      0x0070   /* share bits */
#define O_SHARESHFT  4
#define O_NOCHILD    0x0080
#define O_NO24       0x2000
#define O_WRITENOW   0x4000

//  action values for OpenOrCreatFile()
//
#define ACT_EXIST_OPEN     0x0001
#define ACT_EXIST_REPLACE  0x0002
#define ACT_NEXIST_CREATE  0x0010

// action values returned by OpenOrCreatFile()
//
#define ACTION_OPENED      1
#define ACTION_CREATED     2
#define ACTION_TRUNCATED   3

//  Location codes for SeekFile
//
#define SEEK_CUR    1
#define SEEK_END    2
#define SEEK_SET    0

#if !defined(ushort)
typedef  unsigned short ushort;
#endif

// CDS status bits
#define  CDS_NETWORK    0x8000
#define  CDS_VALID      0x4000
#define  CDS_JOIN       0x2000
#define  CDS_SUBST      0x1000
#define  CDS_ISREMOTE   0x0100   // ???
#define  CDS_CDROM      0x0080

// SFT attr bits
#define  SFT_DEVICE		0x0080


#define  HARDMEDIA      0xF8

// if a dir entry is deleted, its name starts with this
#define DELETED      0xE5
#define DELETED2     0x05

// used to determine if a directory entry is deleted or free
#define IS_DELETED(c) ((c)==DELETED || (c)==DELETED2)
#define IS_END_OF_DIR_LIST(lpDir) (*(lpDir)->name==0 && (lpDir)->attr==0)

// shift values used with DIR entries (see DOSTRUCT.H)
//
#define DIREntriesToBytes   5 // shift count dir entry <-> bytes

// the directory absread structure, this keeps track
// of where we are in the FAT when sequentially reading a directory.
//
struct ReadDirStruct
{
   ushort   startingCluster,  // starting cluster of the (sub)dir
            currentCluster,   // current cluster to read
            clustersToRead;   // count of clusters to read
   short    discontinuities;  // discontinuities in this dir
   ulong    sectorsToRead,    // total number of sectors in a FAT chain
            sectorsRead,      // number of sectors successfully read
            currentSector;    // count of sectors to read
};

//
// The following error codes are the same as MS-DOS v6.22 DEFRAG
//

// 0   The defragmentation was successful.
//
#define  EL_SUCCESS  0

// 1   An internal error occurred.
//
#define  EL_INTERNAL_ERR   80

// 2   The disk contained no free clusters. To operate, DEFRAG needs 1 free
//     cluster.
//
#define  EL_ENODISK  2

// 3   The user pressed CTRL+C to stop the process.
//
#define  EL_USER_ABORT  3

// 4   A general error occurred.
//
#define  EL_GENERAL 4

// 5   DEFRAG encountered an error while reading a cluster.
//
#define  EL_DISK_READ_ERR 5

// 6   DEFRAG encountered an error while writing a cluster.
//
#define  EL_DISK_WRITE_ERR 6

// 7   An allocation error occurred. To correct the error, use the <SCANDISK>
//     command.
//
#define  EL_BAD_DISK 7

// errors passed by the CHKDSK code
//
#define 	ERR_INVALID		100	// invalid FAT entry, file/dir truncated
#define 	ERR_DIR2FILE	101	// convert a directory into a file
#define 	ERR_BADDIR		102	// bad subdir, convert to file?
#define 	ERR_ALLOC		103	// allocation error

// 8   A memory error occurred.
//
#define  EL_MEM_ERR  8

// 9   There was insufficient memory to defragment the disk.
//
#define  EL_ENOMEM   9

//
// The error codes below are specific to Datalight's DEFRAG
//

// 10  The use pressed <Ctrl><Alt><Del> we may exit as a result
//     (see DEFERR.C.)
//
#define  EL_CTRL_ALT_DEL 10

// 11  Long file names encountered.
//
#define  EL_LONG_NAMES  11

// 12  Too many nodes in a sub-dir
//
#define  EL_TOO_MANY_NODES 12

// 13  Need at least a '386 CPU
//
#define  EL_BAD_CPU	13

// 14  If windows is running, we won't
//
#define  EL_WINDOWS_RUNNING 14

// 15  Open files detected
//
#define  EL_OPEN_FILES 15



#endif   // #if !defined(DEFRAG_H_INCLUDED)
