//
//   $Id: diskcomn.h 1.3 2002/10/16 21:47:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  DISKCOMN.H
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  05-01-2001  aj  Created
//

#define ERR_DISKREAD			7

#define MS_ERR_INVALID_DRIVE        1
#define MS_ERR_UNSUPORTED_DRIVE		2
#define MS_ERR_CTRL_BREAK				3
#define MS_ERR_FATAL_ERROR 			4
#define MS_ERR_NO_PROCEED				5

#define ARRAY_ENTRIES(array) (sizeof(array) / sizeof(array[0]))

#define MAX_SPT				0x3f
#define BYTES_PER_SECTOR	0x200
#define IOCTL_VERIFY			0x62
#define IOCTL_WRITE			0x41
#define IOCTL_READ			0x61
#define IOCTL_GETINFO		0x66
#define IOCTL_SENSEMEDIA	0x68
#define SWAP_DEST				1
#define SWAP_SRC				2

struct TRACK_TABLE{
	unsigned uNumber;
	unsigned uSize;
};

typedef struct DRIVE_PARMS DRIVE_PARMS;
typedef DRIVE_PARMS * PDRIVE_PARMS;
typedef DRIVE_PARMS far * LPDRIV_PARMS;
struct DRIVE_PARMS{
	struct DEVICE_PARMS Parms;
	uchar  ucReserved[32];
	unsigned uSectorsInTrack;
	struct TRACK_TABLE TrackInfo[MAX_SPT];
};

#define DEFAULT_CATEGORY_CODE						0x08

typedef struct IOCTL_ReadWrite IOCTL_READWRITE;
typedef IOCTL_READWRITE * PIOCTL_READWRITE;
typedef IOCTL_READWRITE far * LPIOCTL_READWRITE;
struct IOCTL_ReadWrite
{
	uchar ucSpecialFunction;
	unsigned uHead;
	unsigned uTrack;
	unsigned uSector;
	unsigned uNumberOfSectors;
	void far * lpBuffer;
};


#define IS_READ	FALSE
#define IS_WRITE	TRUE
