;
;   $Id: TRAP14.ASM 1.5 2002/10/16 21:55:48Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------

   TRAP14.ASM  created  03/03/92  by Drew Gislason

   Copyright (c) 1992-2002 Datalight, Inc.
   all Rights Reserved.
   Datalight Confidential and Proprietary

   The resident part of MODE.

   01/25/2002 jmb added support for printer redirection to COM ports.

----------------------------------------------------------- ~
include macros.inc


;  These are the external variables
;
EXTRN _ucInt14Retries:byte
EXTRN _uResidentCodeSegment:word
EXTRN __psp:word

EXTRN _gRedirectedLpt:word
EXTRN _gRedirectedCom:word


;  This is an offset into the PSP
;
ENV_SEG	EQU	2ch	; psp.env_seg

;
; LPT status bit settings
;
LPT_NOT_BUSY    EQU     80h     ; not busy
LPT_ACK         EQU     40h     ; acknowledge
LPT_PAPER_OUT   EQU     20h     ; out of paper
LPT_SELECTED    EQU     10h     ; selected
LPT_IO_ERROR    EQU     08h     ; I/O error
LPT_TIMEOUT     EQU     01h     ; timeout

;
; COM line status bit settings
;
COM_TIMEOUT     EQU     80h     ; timeout
COM_TXS_REG_EMPTY EQU   40h     ; transmit shift register empty
COM_TXH_REG_EMPTY EQU   20h     ; transmit holding register empty
COM_BREAK_DET   EQU     10h     ; break detected
COM_FRAME_ERR   EQU     08h     ; framing error
COM_PARITY_ERR  EQU     04h     ; parity error
COM_OVERRUN_ERR EQU     02h     ; overrun error
COM_RDR         EQU     01h     ; receive data ready

;
; COM modem status bit settings
;
COM_MDM_CD      EQU     80h     ; carrier detect
COM_MDM_RI      EQU     40h     ; ring indicator
COM_MDM_DSR     EQU     20h     ; data set ready
COM_MDM_CTS     EQU     10h     ; clear to send
COM_MDM_DCD     EQU     08h     ; delta carrier detect
COM_MDM_TE_RI   EQU     04h     ; trailing edge of ring indicator
COM_MDM_DDSR    EQU     02h     ; delta data set ready
COM_MDM_DCTS    EQU     01h     ; delta clear to send

;
; INT 17h functions
;
LPT_WRITE_CHAR  EQU     0
LPT_INIT_PORT   EQU     1

;
; INT 14h functions
;
COM_WRITE_CHAR  EQU     1
COM_GET_STATUS  EQU     3




;  These are the addresses into the interrupt vector
;  table for the interrupts
;
INT14	EQU	4*14H
INT17	EQU	4*17H
INT2F	EQU	4*2FH


ADDR_INT14_START  EQU 0
ADDR_INT14_END    EQU ADDR_INT14_START + ( INT14_END - INT14_START )
ADDR_INT17_START  EQU ADDR_INT14_END
ADDR_INT17_END    EQU ADDR_INT17_START + ( INT17_END - INT17_START )
ADDR_INT2F_START  EQU ADDR_INT17_END
ADDR_INT2F_END    EQU ADDR_INT2F_START + ( INT2F_END - INT2F_START )
ADDR_RESIDENT_END EQU ADDR_INT2F_END


cBegCode


public RESIDENT_PART_START
RESIDENT_PART_START:


;  This is the interrupt 14h handler.  This function intercepts INT 14h
;  function 00h calls.  This is the write character to communications
;  port function.  All other functions go to the old interrupt handler.
;
PUBLIC INT14_START
INT14_START:

		; only intercept the write character function of INT 14H
		;
		cmp	ah, 1
		jz	INT14_INTERCEPT

	INT14_PASS_THROUGH:

		; far jmp to the old handler
		;
		db	0eah
	OLD_14:	dw	0, 0	; Address of the old INT-14 handler

		; These are the variables for the INT-14 handler
		;
	RETRIES:
		db 	?	; how many times do we retry?
	LOOPVAL:
		db	?	; loop counter
	COMMAND:
		dw	?	; COMMAND and character (AX)
        REDIRECTED_COM:
                db      4 dup (-1)

	INT14_INTERCEPT:

                ;
                ; check to see if this belongs to the port we are
                ; intercepting...
                ;
                push    bx
                push    dx
                mov     bx, offset REDIRECTED_COM
                add     bx, dx
                cmp     byte ptr cs:[bx], -1
                pop     dx
                pop     bx
                jz      INT14_PASS_THROUGH

		; save the COMMAND(ah) and character(al)
		;
		mov	word ptr cs:[COMMAND], ax
		mov	byte ptr cs:[LOOPVAL], 0

	TRY_AGAIN:

		; loop around trying to send the character
		;
		pushf
		call	dword ptr cs:[OLD_14]
		test	ah, 80H
		jnz	INCR_LOOP
		iret

	INCR_LOOP:
		inc	byte ptr cs:LOOPVAL
		push	cx
		mov	cl, byte ptr cs:[RETRIES]
		cmp	cl, byte ptr cs:[LOOPVAL]
		jna	GIVE_UP
		pop	cx

		; get COMMAND(ah) and character(al) back
		;
		mov	ax, word ptr cs:[COMMAND]
		jmp	short TRY_AGAIN

	GIVE_UP:
		pop	cx
		iret

INT14_END:


;  This is the interrupt 17h handler.  Presently we are not
;  patching INT-17 but it was noticed that msdos is patching
;  INT-17.  This is here so that it can be added with minimal
;  effort.
;
PUBLIC INT17_START
INT17_START:

                cmp     ah, 2                   ; valid function?
                ja      INT17_PASS_THROUGH      ; no, pass to old hander

                ;
                ; check to see if this belongs to the port we are
                ; intercepting...
                ;
                push    bx
                push    dx
                mov     bx, offset REDIRECTED_LPT
                add     bx, dx
                cmp     byte ptr cs:[bx], -1
                pop     dx
                pop     bx
                jnz     INT17_INTERCEPT

	INT17_PASS_THROUGH:
		; far jmp to the old handler
		;
		db	0eah
	OLD_17:	dw	0, 0	; Address of the old INT-17 handler

        REDIRECTED_LPT:
                db      3 dup (-1)


	INT17_INTERCEPT:
                cmp     ah, LPT_INIT_PORT
                jnz     CHECK_WRITE_CHAR

                mov     ah, LPT_NOT_BUSY
                jmp     INT17_IRET

        CHECK_WRITE_CHAR:
                cmp     ah, LPT_WRITE_CHAR
                jnz     CHECK_STATUS

                push    bx
                push    ax
                push    dx

                mov     bx, offset REDIRECTED_LPT
                add     bx, dx
                mov     dl, byte ptr cs:[bx]

                ;
                ; write character in AL to port in DX
                ;
                mov     ah, COM_WRITE_CHAR
                int     14h
                test    ah, COM_TIMEOUT
                mov     ah, (LPT_NOT_BUSY OR LPT_SELECTED)
                jz      INT17_CLEANUP
                mov     ah, (LPT_IO_ERROR OR LPT_TIMEOUT)
                jmp     INT17_CLEANUP

        CHECK_STATUS:
                push    bx
                push    ax
                push    dx

                mov     bx, offset REDIRECTED_LPT
                add     bx, dx
                mov     dl, byte ptr cs:[bx]

                ;
                ; get status of port in DX
                ;
                mov     ah, COM_GET_STATUS
                int     14h
                mov     ah, LPT_SELECTED
                test    al, (COM_MDM_DSR OR COM_MDM_CTS)
                jz      INT17_CLEANUP
                mov     ah, (LPT_NOT_BUSY OR LPT_SELECTED)

        INT17_CLEANUP:
                pop     dx
                pop     bx              ; get AX value from stack
                mov     al, bl          ; restore only AL
                pop     bx

        INT17_IRET:
                iret

INT17_END:


;  This is the interrupt 2Fh handler.  This function acts as
;  a filter only responding to INT-2f function 49.  It returns
;  FFh in al and the segment of the resident part in BX.  all
;  the other INT-2f calls are passed through to the old
;  INT-2f handler.
;
PUBLIC INT2F_START
INT2F_START:

		cmp	ax, 4900h
		jz	INT2F_INTERCEPT

	INT2F_PASS_THROUGH:

		; far jmp to the old handler
		;
		db	0eah
	OLD_2F:	dw	0, 0	; Address of the old INT-2F handler

	INT2F_INTERCEPT:
		xor	ah, ah
		dec	ah	; mov ah, 0ffh
		mov	bx, cs
		iret

INT2F_END:


public RESIDENT_PART_END
RESIDENT_PART_END:


; void InstallIntHandlers( void )
;
;  This function saves the old interrupt vectors, moves the
;  resident part of the code to the start of the code segment,
;  sets the new interrupt vectors, and then terminates (TSR)
;
c_func	InstallIntHandlers

	push	bp
	mov	bp, sp


	; set RETRIES in the int 14h handler
	;
	mov	al, _ucInt14RETRIES
	mov	byte ptr cs:RETRIES, al

        ;
        ; set lpt and com redirects
        ;
        mov     ax, _gRedirectedLpt
        mov     dx, _gRedirectedCom
        lea     bx, cs:REDIRECTED_COM
        add     bx, dx
        mov     byte ptr cs:[bx], al

        mov     ax, _gRedirectedCom
        mov     dx, _gRedirectedLpt
        lea     bx, cs:REDIRECTED_LPT
        add     bx, dx
        mov     byte ptr cs:[bx], al



	; save address to old INT 14H handler
	;
	xor	ax, ax
	mov	ES, ax
	mov	ax, word ptr ES:[INT14]
	mov	word ptr cs:OLD_14, ax
	mov	ax, word ptr ES:[INT14+2]
	mov	word ptr cs:OLD_14+2, ax


	; save address to old INT 17H handler
	;
	mov	ax, word ptr ES:[INT17]
	mov	word ptr cs:OLD_17, ax
	mov	ax, word ptr ES:[INT17+2]
	mov	word ptr cs:OLD_17+2, ax


	; save address to old INT 2FH handler
	;
	mov	ax, word ptr ES:[INT2F]
	mov	word ptr cs:OLD_2F, ax
	mov	ax, word ptr ES:[INT2F+2]
	mov	word ptr cs:OLD_2F+2, ax


	; point INT 14H to our new handler
	;
	mov	ax, cs
	mov	ds, ax
	mov	dx, ADDR_INT14_START
	mov	ax, 2514H
	int	21H		; set interrupt vector


	; point INT 17H to our new handler
	;
	mov	ax, cs
	mov	ds, ax
	mov	dx, ADDR_INT17_START
	mov	ax, 2517H
	int	21H		; set interrupt vector


	; point INT 2FH to our new handler
	;
	mov	ax, cs
	mov	ds, ax
	mov	dx, ADDR_INT2F_START
	mov	ax, 252FH
	int	21H		; set interrupt vector


	; release the memory used by the enviornment segment
	;
	mov	ah, 62h
	int	21h		; get psp segment
	mov	es, bx
	mov	bx, ENV_SEG
	mov	ax, es:[bx]
	mov	es, ax
	mov	ah, 49h
	int	21h		; release memory


	; terminate and stay resident
	;
	mov	dx, offset cs:RESIDENT_PART_END
	sub	dx, offset cs:RESIDENT_PART_START
	mov	cl, 4
	shr	dx, cl
	inc	dx
	add	dx, 10H
	mov	ax, 3100H
	int	21H		; terminate and stay resident

	ret

c_ENDp	InstallIntHandlers


; void SetRetries( void )
;
;  This function saves the new retry value in the resident part of
;  of the MODE interrupt handlers.
;
c_func	SetRetries

	;  Get the code segment of the resident part of mode
	;
	mov	bx, _uResidentCodeSegment


	;  Get the new retry value
	;
	mov	al, _ucInt14Retries


	;  Save the current data segment
	;
	push	ds


	;  Set the retry value in the variable location
	;  inside the code segment of the resident part
	;  of int 14.
	;
	mov	ds, bx
	mov	bx, offset RETRIES
	mov	[bx], al


	;  Restore the data segment
	;
	pop	ds


	;  Return
	;
	ret

c_ENDp	SetRetries

;
; void SetRedirect(int lpt, int com)
;
; sets the redirected com port value into the lpt array
; and sets the lpt port value into the com array
;
c_func	SetRedirect
        push    bp
        mov     bp, sp

        push    ds

	;  Get the code segment of the resident part of mode
	;
	mov	bx, _uResidentCodeSegment
        mov     ds, bx

        ;
        ; put lpt port in com port array
        ;
        mov     ax, P[bp]       ; get lpt port number
        mov     dx, P+2[bp]     ; get com port number
        mov     bx, offset REDIRECTED_COM
        add     bx, dx          ; add in com port number
        mov     [bx], al        ; store lpt port in COM array


        ;
        ; put com port in lpt port array
        ;
        mov     bx, offset REDIRECTED_LPT
        add     bx, ax          ; add in lpt port number
        mov     [bx], dl        ; store com port in LPT array

        pop     ds
        pop     bp
        ret
c_ENDp  SetRedirect

cEndCode

	END
