//
//   $Id: DLRESPON.C 1.4 2002/10/16 21:55:48Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// DLRESPON.C Created 5-6-97 Dennis Edwards
// Simple keyboard input validation routine for the
// Datalight C utility libarary.
//
// Copyright (c) 1989-2002 Datalight, Inc.
// All Rights Reserved.
// Datalight Confidential and Proprietary
//
#define __FILENUM__  555

#include <ctype.h>
#include <string.h>
#include <stdio.h>

#include "datalght.h"
#include "dlrespon.h"

#if USE_BIOS_KBD
GetKeyFunction GetKey = BIOSGetKey;
#else
GetKeyFunction GetKey = DOSGetKey;
#endif

GetKeyFunction PASCAL SetGetKeyFunction(GetKeyFunction func)
{ GetKeyFunction  oldFunc;

	oldFunc = GetKey;
	GetKey = func;
	return oldFunc;
}

// Displays a question and its specifics then waits for the
// user to enter one of the allowed options. The comparison
// between the input and the allowed options is case insensitive.
//
// ->:	question	- 	a format string for the prompt
//							(eg "Delete file %s [%s]? ")
//  		specifics - (possibly empty) string to augment the prompt
//							(eg the name of the file in the above case)
//			allowed -	the list of allowed user responses
//							(eg "YNA")
// <-:	index of the matching char in the allowed string
//			or -1 on error (empty allowed string).
//
int PASCAL ValidateResponse(char *question, char *specifics, char *allowed)
{ int response, len, i;

	ASSERT(question);
	ASSERT(specifics);
	ASSERT(allowed);

	len = strlen(allowed);
	if(!len)
		return(-1);

	printf(question,specifics,allowed);
	while(1)
	{
		response = toupper(GetKey() & 0xFF);
		for(i = 0; i < len; i++)
		{
			if((char)(response) == toupper(allowed[i]))
			{
				printf("%c\n",response);
				return i;
			}
		}
		printf("\a");
	}
}

