;
;   $Id: POWER.INC 1.4 2002/10/16 21:57:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
; Datalight Power Management Software
; Assembly  Include Module
;
; Copyright(c) 1993-2002 Datalight Inc.
; All Rights Reserved
; Datalight Confidential and Propritary
;


; Power State Definitions
; Standby mode will typically respond to IRQs. Suspend mode will typically
; require an NMI (from an RTC, for example) to wake the system. Off is off.
;
READY			=	0 	; everything up and on line
STANDBY			=	1	; waiting for IRQ
SUSPEND			=	2	; waiting for NMI
OFF			=	3	; maybe... off?
APM_REQUEST_IN_PROGRESS	=	4	; say "Waiting for Go/NoGo from apps"
APM_REQUEST_REJECTED    =     	5	; say "App rejected last request"


; Device Definitions
; E000h-EFFFh define OEM devices, all other values reserved.
;
APM_DEV_SYSTEM		=	0000h  	; v1.0 devices
APM_DEV_ALL		=	0001h
APM_DEV_DISPLAY		=	0100h
APM_DEV_DISK		=	0200h
APM_DEV_PRINTER		=	0300h
APM_DEV_SERIAL		=	0400h
APM_DEV_NETWORK		=	0500h	; v1.1 device
APM_DEV_PCMCIA		=	0600H	; v1.1 device

APM_DEV_COUNT		= 	7

; Datalight's device info struc
;
; LastUsed field contains the Ticks value when the device was
; last used. InactiveCount field contains the # of ticks required
; to put the device into StandbyState.
; Status = Ready, Standby, Syspend, Off
;
DEVICE struc
	LastUsed	dw	?
	InactiveCount	dw	?
	Status		dw	?
DEVICE ends

; The APM standard devices numbers are defined above and, in most
; cases, are used in the same order to index into an array of the
; above device strucs.
;
DEV_SYSTEM		=       0000h
DEV_DISPLAY		=       0001h
DEV_DISK		=       0002h
DEV_PRINTER		=       0003h
DEV_SERIAL		=       0004h
DEV_KEYBOARD		=       0005h

; APM BIOS Functions
; subfn 08h enables/disables cooperative services POWER<->APM while
; subfn 0Fh enables/disables the automatic functions of the BIOS
;
APM_INSTALLATION_CHECK		=	5300h	; ask "anybody home?"
APM_REAL_MODE_CONNECT         	=	5301h	; say "talk to me in real mode"
APM_16BIT_PM_CONNECT          	=	5302h	; protected mode interface
APM_32BIT_PM_CONNECT          	=	5303h	; protected mode interface
APM_INTERFACE_DISCONNECT      	=	5304h	; say "go away"
APM_CPU_IDLE                  	=	5305h	; say "the system is idle"
APM_CPU_BUSY                  	=	5306h	; say "more powaw!"
APM_SET_POWER_STATE           	=	5307h	; say "..."
APM_ENABLE_PWR_MGMT         	=	5308h	; cx=0: disable, cx=1: enable
APM_RESTORE_DEFAULTS          	=	5309h	; to power on values
APM_GET_PWR_STATUS            	=	530Ah	; of AC line and battery
APM_GET_PWR_MGMT_EVENT        	=	530Bh	; ask "what should I do next"
APM_GET_PWR_MGMT_STATE	      	=	530Ch	; ask "what is on-line now"
APM_SET_DEV_PWR_MGMT_FUNC     	=	530Dh	; cx=0: disable, cx=1: enable
APM_GET_DRIVER_VERSION	        =	530Eh   ; call w/BCD in cx, returns AX
APM_ENGAGE_PWR_MGMT		=     	530Fh	; cx=0: disengage,cx=1: engage


; The APM installation check function returns a set of flags in CX
; to indicate the state and capabilities of the APM BIOS implementation.
;
APM_16_BIT_MODE_SUPPORT		=     000001b	; has protected mode ifc
APM_32_BIT_MODE_SUPPORT		=     000010b	; has protected mode ifc
APM_SLOWS_CPU_CLOCK		=     000100b	; in response to APM_CPU_IDLE
APM_BIOS_DISABLED		=     001000b
APM_BIOS_DISENGAGED		=     010000b


; An app can call this int 2Fh function to signal that it is idle.
;
APM_APP_IDLE_SIGNAL     	=	1680h


; APM BIOS events
; In addition to the events below, a number of reserverd events are
; defined. Each of these events must be broadcast to APM aware applications
; but POWER has no other responsibility for handling them. These events are
;
; 000Ch - 00FFh	Reserved system events
; 0100h - 01FFh  Reserved device events
; 0200h - 02FFh  Reserved OEM events
;
; All other event numbers (0300h - FFFFh) are reserved.
;
SYSTEM_STANDBY_REQUEST 		=	0001h
SYSTEM_SUSPEND_REQUEST		=	0002h
END_NORMAL_SUSPEND_NOTICE       =	0003h
END_CRITICAL_SUSPEND_NOTICE     =	0004h
BATTERY_LOW_NOTICE              =	0005h
POWER_STATUS_CHANGE_NOTICE      =	0006h
UPDATE_TIME_NOTICE              =	0007h
CRITICAL_SUSPEND_NOTICE         =	0008h
USER_STANDBY_REQUEST            =	0009h
USER_SUSPEND_REQUEST            =	000Ah
END_NORMAL_STANDBY_NOTICE       =	000Bh


; An APM aware app can listen for this signal off of int 2Fh to be
; informed of APM events. Any of the APM events defined below may
; be identified in the BL (BX) register. An app may reject any of
; the "request" events by setting the sign bit in BX (set BH=80h).
;
APM_APP_EVENT_BROADCAST		=	530Bh

CARRY_FLAG			=	1
