//
//   $Id: POWPRINT.C 1.4 2002/10/16 21:57:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 * Datalight Power Management Software
 * Print Module
 *
 * Copyright(c) 1993-2002 Datalight Inc.
 * All Rights Reserved
 * Datalight Confidential and Proprietary
 */

#include <dos.h>

#include "datalght.h"

#include "power.h"
#include "proto.h"

void interrupt( far * getvect( int __interruptno ))( );
void setvect( int __interruptno, void interrupt( far *__isr )( ));
#define prt_putc bputc
#define prt_puts bputs

void bputs(char *s);
void bputc(char c);
void putc(char c);
void puts(char *s);

char *itoa(int numb, char *buffer, int radix);

void printf(char *fmt,...)
{
	unsigned far *args;
	static char buffer[25];

	args = (unsigned far *) &fmt;
	++args;

	while(*fmt){
		if(*fmt != '%')
			prt_putc(*fmt);
		else{
			++fmt;
			switch(*fmt){

				case 'c':
					prt_putc(*args);
					++args;
					break;

				case 'd':
					itoa(*args, buffer, 10);
					prt_puts(buffer);
					++args;
					break;

				case 'x':
					itoa(*args, buffer, 16);
					prt_puts(buffer);
					++args;
					break;

				case 's':
					prt_puts((char *) *args);
					++args;
					break;

				default:
					prt_putc(*fmt);
			}
		}
		++fmt;
	}
}


#if 0
void puts(char *s)
{
	while(*s)
		putc(*s++);
}

void putc(char c)
{

	if(c == '\n')
		bputc('\r');
	bdos(2, c, c);
}
#endif


void bputs(char *s)
{
	while(*s)
		bputc(*s++);
}

void bputc(char c)
{
	static unsigned col;

	if(c == '\r')
		col = 0;
	if(c == '\n')
		bputc('\r');
	if(c == '\t')
	{
		do {
			bputc(' ');
		} while(col%8);
		return;
	}
asm	mov	ah, 0xE
asm	mov	al, c
asm	mov	bx,0
asm	int	0x10
	if(c >= ' ')
		++col;
}



/*
 * DOS Terminate and Stay Resident function
 */
void keep(unsigned char stat, unsigned paras)
{
asm	mov	AH, 0x31
asm	mov	AL, stat
asm	mov	DX, paras
asm	int	21H
}


/*
 * Build a char string for a given number for any radix
 */
char *itoa(int numb, char *buffer, int radix)

{
	static char *hex = "0123456789ABCDEF", local[5];
	unsigned remainder, i=0;

	do{
		remainder = numb % radix;
		numb /= radix;
		local[i++] = hex[remainder];
	}while(numb);

	while(i)
		*buffer++ = local[--i];
	*buffer = '\0';

	return (buffer);
}


