//
//   $Id: rdbldnum.C 1.6 2002/10/16 21:58:28Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  RDBLDNUM.C
//
//  Copyright (c) 2000-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  08-02-2000  bt  Created
//


#define __FILENUMBER__		1


//  Borland libraries
//
#include "dir.h"
#include "stdio.h"
#include "stdlib.h"
#include "ctype.h"
#include "mem.h"
#include "string.h"


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dllfn.h"
#include "fatworld.h"
#include "bldver.h"
#include "dlapp.h"
#include "fatlib.h"
#include "dlpath.h"
#include "dlmath.h"
#include "dosver.h"


//  RDBLDNUM header files
//
#include "RDBLDNUM.h"


//  Prototypes
//
#include "RDBLDNUM.pt"



//
//  Variables
//

bool fIsFat32World  = FALSE;
bool fLFNsSupported = FALSE;
char * szCommandLinePath = 0;


//  Array of boolean command line switches.  Accessed through macros.
//
bool fSwitches[SWITCH_COUNT];


//  Error message strings
//
char * szErrorMsg[] = {
	"",											// 0
	"",											// 1
	"",											// 2
};


//  usage screen text
//
char szUsage[] =
	"This utility displays the ROMDOS Test Suite build number.\n"
	"\n"
	"RDBLDNUM [/?] [/[]\n"
   "\n"
	"/[\tHide program signon message\n"
   "/?\tShow this help screen\n";


//  Start of RDBLDNUM
//
uchar main( int argc, char *argv[] )
{
	//  Determine if this is DOS 7.1
	//
	fIsFat32World = dlIsFat32World();


	//  Parse the command line
	//
	DoParseCommandLine( argc-1, &argv[1] );


	//  Display the signon message
	//
	DisplaySignOnMessage();


	//  Display the Test Suite build number
	//
	printf("             ROMDOS Build Number: %5s", BUILD_NUMBER );
	printf("  (built on %s)\n", BUILDDATE );


	return ERR_NONE;
}


//  Process all the command line arguments
//
void DoParseCommandLine( int argc, char *argv[] )
{
	uchar ucArgIndex;
	static ARGDEF RDBLDNUMOpts[] =
	{
		{ BOOL_SWITCH, &fSwitches[HIDE_SIGNON],      '[', 0 },
		{ 0 }
	};


	//  Remove the quotes from any LFN arguments
	//
	for(ucArgIndex=0; ucArgIndex < argc; ucArgIndex++)
	{
		LFNStripArgQuotes( argv[ucArgIndex] );
		if( strlen(argv[ucArgIndex]) >= LFN_MAX_PATH )
		{
			printf("Error: Path too long.\n");
			exit(255);
		}
	}


	//  This is for the command line parsing library function.  It
	//  indicates that no command line options are ok
	//
	SetParseFlags( PARSEF_NOARGSOK );


	//  Process all the boolean switches in the command line
	//
	argc = ParseCmdline(argc, &argv[0], RDBLDNUMOpts);


	//  If there is anything, it should only be a drive or
	//  path/name combination.
	//
	if(argc != 0)
		Usage();
}


//  Display the usage screen and exit.  Called by the command line
//  parsing routines if an error is encountered
//
void Usage( void )
{
	DisplaySignOnMessage();
	printf( szUsage );
	exit( ERR_USAGE );
}


//  Display a message stating that there was an internal error
//  at the specified line number
//
void RDBLDNUMInternalError( unsigned uFileNumber, unsigned uLineNumber )
{
	printf( "\nRDBLDNUM Internal Error! (%u:%u)", uFileNumber, uLineNumber );
	exit(ERR_INTERNAL);
}


//  Display the program name, version, and copyright information
//
void DisplaySignOnMessage( void )
{
	char *szSignon = "RDBLDNUM version %s.%s\n%s\n\n";


	if( !DoHideSignon() )
	{
		printf(szSignon,MAJORVER,BUILD_NUMBER,COPYRIGHT);
	}
}
