//
//   $Id: CLIAPI.C 1.9 2002/10/16 21:59:16Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  CLIAPI.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  This file contains all the API functions that an int 2fh IFS
//  interface is expected to perform.
//
//  History:
//
//  04-01-2001  bt  Created
//


//  Borland libraries
//
#include <string.h>
#include <mem.h>
#include <stdio.h>
#include <ctype.h>


//  Local libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dlapp.h"


#define	SERVER_APP	1


//  Local definitions
//
#include "cliapi.h"
#include "netapi.h"
#include "commapi.h"
#include "cliint.h"
#include "server.h"


//  Prototypes
//
#include "cliapi.pt"



//  Enable debug code
//
#define ENABLE_DEBUG_PARM		FALSE
#define ENABLE_DEBUG_ERR		FALSE

#if ENABLE_DEBUG_PARM

#define DEBUG_PARM_1100			TRUE
#define DEBUG_PARM_1101			TRUE
#define DEBUG_PARM_1103			TRUE
#define DEBUG_PARM_1105			TRUE
#define DEBUG_PARM_1106			TRUE
#define DEBUG_PARM_1108			TRUE
#define DEBUG_PARM_1109			TRUE
#define DEBUG_PARM_110E			TRUE
#define DEBUG_PARM_110F			TRUE
#define DEBUG_PARM_1111			TRUE
#define DEBUG_PARM_1113			TRUE
#define DEBUG_PARM_1116			TRUE
#define DEBUG_PARM_1117			TRUE
#define DEBUG_PARM_111B			TRUE
#define DEBUG_PARM_111C			TRUE
#define DEBUG_PARM_112E			TRUE

#endif

#if ENABLE_DEBUG_ERR

#define DEBUG_ERR_1100			TRUE
#define DEBUG_ERR_1101			TRUE
#define DEBUG_ERR_1103			TRUE
#define DEBUG_ERR_1105			TRUE
#define DEBUG_ERR_1106			TRUE
#define DEBUG_ERR_1108			TRUE
#define DEBUG_ERR_1109			TRUE
#define DEBUG_ERR_110E			TRUE
#define DEBUG_ERR_110F			TRUE
#define DEBUG_ERR_1111			TRUE
#define DEBUG_ERR_1113			TRUE
#define DEBUG_ERR_1116			TRUE
#define DEBUG_ERR_1117			TRUE
#define DEBUG_ERR_111B			TRUE
#define DEBUG_ERR_111C			TRUE
#define DEBUG_ERR_112E			TRUE

#endif

//  Externs
//
extern bool fIsFat32World;
extern bool fInWindows;
extern bool fIsWinNT;
extern unsigned uMaxHandles;
extern uchar ucHandleTable[];
extern unsigned HandleTrack[];


//  Globals
//
char szDontMapList[26];
char szOnlyMapList[26];



//  ========================================================================
//
//  The following functions are required APIs for the INT 2fh interface.
//
//  ========================================================================




//  InitInt2fInterface
//
//
//  Initialize the INT 2fh interface
//
//
//  On entry:
//
//    nothing
//
//  On exit:
//
//  on success,
//
//  	function returns TRUE
//
//  on error,
//
//		function returns FALSE
//
//
#pragma argsused
bool InitInt2fInterface( int argc, char *argv[] )
{
	bool fSuccessful;
	static ARGDEF ServerOpts1[] =
	{
		{ BOOL_SWITCH, &fSwitches[SW_HIDE_SIGNON],      '[', 0 },
		{ BOOL_SWITCH, &fSwitches[SW_REMOVABLE],    		'R', 0 },
		{ BOOL_SWITCH, &fSwitches[SW_NETWORK],    		'N', 0 },
		{ STRING_SWITCH, szDontMapList,                 'D', 26 },
		{ STRING_SWITCH, szOnlyMapList,                 'O', 26 },
		{ 0 }
	};


	//  Process some of the boolean switches in the command line
	//
	SetParseFlags(PARSEF_MULTIPASS | PARSEF_NOARGSOK);
	argc = ParseCmdline(argc, &argv[0], ServerOpts1);


	//  Uppercase any drive letters the user may have supplied
	//
	strupr( szDontMapList );
	strupr( szOnlyMapList );


	//  Process the remaining part of the command line and
	//  initialize the transport layer
	//
	fSuccessful = NetworkTXRXInit( argc, &argv[0] );
	if( !fSuccessful )
	{
		return FALSE;
	}


	//  Return that initialization was successful
	//
	return TRUE;
}


//  GetRemoteDriveInfo  INT 2fh fn 110ch
//
//
//  Get some information about the remote drive such as the
//  total drive space and free space.  Because of the limitation
//  in the size of the variables, the values returned from this
//  function may have been adjusted to fit the size of the
//  variables but still reflect the amount of space on the remote
//  drive.
//
//
//  On entry:
//
//  	ucRemoteDriveLetter	= Drive letter of drive on remote machine
//  	pucSectorsPerCluster = Variable for sectors per cluster
//  	pucMediaIdByte			= Variable for media id byte
//  	puTotalClusters		= Variable for total clusters
//  	puBytesPerSector		= Variable for bytes per sector
//  	puAvailableClusters	= Variable for available clusters
//
//  On exit:
//
//  on success,
//
//  	pucSectorsPerCluster	= is updated
//  	ucMediaIdByte			= is updated
//  	puTotalClusters		= is updated
//  	puBytesPerSector 		= is updated
//  	puAvailableClusters	= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL GetRemoteDriveInfo( uchar ucRemoteDriveLetter,
		uchar * pucSectorsPerCluster, uchar * pucMediaIdByte,
		unsigned * puTotalClusters, unsigned * puBytesPerSector,
		unsigned * puAvailableClusters )
{
	bool fSuccessful;
	unsigned uErrorCode;
	bool fIsRemovable;
	uchar ucDOSDriveNumber;
	unsigned uSPC;


	//  Get the drive free space
	//
	ucDOSDriveNumber = toupper(ucRemoteDriveLetter) - 'A';
	fSuccessful = __dlGetFreeSpaceOnDrive(	ucDOSDriveNumber + 1, &uSPC,
			puAvailableClusters, puBytesPerSector, puTotalClusters );
	if( fSuccessful )
	{
		//
		//
		*pucSectorsPerCluster = (uchar)uSPC;

		//  Set the media ID byte by determining if the drive is removable
		//
		*pucMediaIdByte = 0xf8;
		dlIsDriveRemote( ucDOSDriveNumber + 1, &fIsRemovable );
		{
			*pucMediaIdByte = 0xf0;
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_110C
	printf("110c uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  RemoteFindFirst  INT 2fh fn 111bh
//
//
//  Find the first entry that matches the mask given in the RemoteFindFirst
//  call on a remote machine
//
//  NOTE: pFIND must be filled out before pDIR.  When MS hands down the
//        call to this function, the DIR structure overlaps the FIND
//        structure.
//
//
//  On entry:
//
//		szCWD	 				= Current working directory on the remote machine
//		szMask				= name or mask including path to search for
//		uSearchAttributes	= Attributes to search for on remote machine
//		pFIND 				= Address of the find first data block (in the DTA)
//
//  On exit:
//
//  on success,
//
//		pFIND 			= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteFindFirst( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szMask, unsigned uSearchAttributes,
		FIND _D_ * pFIND, DIR _D_ * pDIR )
{
	bool fSuccessful;
	unsigned uErrorCode;
	static char szMaskTemp[128];
	char * szName;


#if DEBUG_PARM_111B
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif

	strcpy( szMaskTemp, szMask );


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
		//  Set the DTA to the address of the find first
		//  structure in the request packet
		//
		dlSetDTA( pFIND );


#if DEBUG_PARM_111B
		printf("szMask: %s\n", szMask );
		printf("uSearchAttributes: %xh\n", uSearchAttributes );
#endif


		//
		//
		szName = strrchr( szMaskTemp, '\\' );
		if( szName )
		{
			szName++;
#if 0
			if( strcmp(szName, "*") == 0 )
			{
				strcat( szMaskTemp, ".*" );
			}
#endif
		}
		else
		{
			szName = szMaskTemp;
		}


		//  Perform the find first
		//
		fSuccessful = dlFindFirstFile( uSearchAttributes, szMaskTemp );
		if( fSuccessful )
		{
			if( fIsWinNT )
			{
				pFIND->srchattr = pFIND->drive;
				memcpy( &(pFIND->dirnum), pFIND->emask, 8 );
			}

#if DEBUG_PARM_111B
			printf("Successful\n");
			printf("pFIND->drive: %x\n", (unsigned)(pFIND->drive) );
			printf("pFIND->emask: %s\n", pFIND->emask );
			{
				unsigned uIndex;
				for( uIndex = 0; uIndex < sizeof(pFIND->emask); uIndex++ )
				{
					printf("%02x ", (uchar)(pFIND->emask[uIndex]) );
				}
				printf("\n");
			}
			printf("pFIND->srchattr: %x\n", (unsigned)(pFIND->srchattr) );
			printf("pFIND->dirnum: %x\n", pFIND->dirnum );
			printf("pFIND->ulStartingCluster: %lu\n", pFIND->ulStartingCluster );
			printf("pFIND->res[0]: %x\n",  (unsigned)(pFIND->res[0]) );
			printf("pFIND->res[1]: %x\n",  (unsigned)(pFIND->res[1]) );
			printf("pFIND->attr: %x\n", pFIND->attr );
			printf("pFIND->time: %x\n", pFIND->time );
			printf("pFIND->date: %x\n", pFIND->date );
			printf("pFIND->size: %x\n", pFIND->size );
			printf("pFIND->name: %s\n",  pFIND->name );
#endif
			GetDirEntry( pFIND, pDIR );
		}
	}


	if( szName )
	{
		DotToENAME( szName, pFIND->emask );
	}
	else
	{
		DotToENAME( "", pFIND->emask );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_111B
	printf("111b uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  RemoteFindNext  INT 2fh fn 111ch
//
//
//  Find the next entry that matches the mask given in the RemoteFindFirst
//  call on a remote machine
//
//  NOTE: pFIND must be filled out before pDIR.  When MS hands down the
//        call to this function, the DIR structure overlaps the FIND
//        structure.
//
//
//  On entry:
//
//		szCWD	= Current working directory on the remote machine
//		pFIND	= Address of the find first data block (in the DTA)
//
//  On exit:
//
//  on success,
//
//		pFIND 			= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteFindNext( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, FIND _D_ * pFIND, DIR _D_ * pDIR )
{
	bool fSuccessful;
	unsigned uErrorCode;


#if DEBUG_PARM_111C
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
		//  Set the DTA to the address of the find first
		//  structure in the request packet
		//
		dlSetDTA( pFIND );


		//  Set the drive letter to that of an IFS drive if
		//  in windows because all drives are an IFS in
		//  windows.  However, MS-DOS 6.22 and 7.1 will fail
		//  the call if the drive letter is set for an IFS when
		//  it is not really an IFS drive.
		//
		if( fIsWinNT )
		{
			pFIND->drive = pFIND->srchattr;
			memcpy( pFIND->emask, &(pFIND->dirnum), 8 );
		}
		else if( fInWindows )
		{
			pFIND->drive |= 0x80;
		}
		else
		{
			pFIND->drive &= 0x7f;
		}


#if DEBUG_PARM_111C
		printf("pFIND->drive: %x\n", (unsigned)(pFIND->drive) );
		printf("pFIND->emask: %s\n", pFIND->emask );
		{
			unsigned uIndex;
			for( uIndex = 0; uIndex < sizeof(pFIND->emask); uIndex++ )
			{
				printf("%02x ", (uchar)(pFIND->emask[uIndex]) );
			}
			printf("\n");
		}
		printf("pFIND->srchattr: %x\n", (unsigned)(pFIND->srchattr) );
		printf("pFIND->dirnum: %x\n", pFIND->dirnum );
		printf("pFIND->ulStartingCluster: %lu\n", pFIND->ulStartingCluster );
		printf("pFIND->res[0]: %x\n",  (unsigned)(pFIND->res[0]) );
		printf("pFIND->res[1]: %x\n",  (unsigned)(pFIND->res[1]) );
		printf("pFIND->attr: %x\n", pFIND->attr );
		printf("pFIND->time: %x\n", pFIND->time );
		printf("pFIND->date: %x\n", pFIND->date );
		printf("pFIND->size: %x\n", pFIND->size );
		printf("pFIND->name: %s\n",  pFIND->name );
#endif


		//  Perform the find first
		//
		fSuccessful = dlFindNextFile();
		if( fSuccessful )
		{
#if DEBUG_PARM_111C
			printf("Successful\n");
			printf("pFIND->drive: %x\n", (unsigned)(pFIND->drive) );
			printf("pFIND->emask: %s\n", pFIND->emask );
			{
				unsigned uIndex;
				for( uIndex = 0; uIndex < sizeof(pFIND->emask); uIndex++ )
				{
					printf("%02x ", (uchar)(pFIND->emask[uIndex]) );
				}
				printf("\n");
			}
			printf("pFIND->srchattr: %x\n", (unsigned)(pFIND->srchattr) );
			printf("pFIND->dirnum: %x\n", pFIND->dirnum );
			printf("pFIND->ulStartingCluster: %lu\n", pFIND->ulStartingCluster );
			printf("pFIND->res[0]: %x\n",  (unsigned)(pFIND->res[0]) );
			printf("pFIND->res[1]: %x\n",  (unsigned)(pFIND->res[1]) );
			printf("pFIND->attr: %x\n", pFIND->attr );
			printf("pFIND->time: %x\n", pFIND->time );
			printf("pFIND->date: %x\n", pFIND->date );
			printf("pFIND->size: %x\n", pFIND->size );
			printf("pFIND->name: %s\n",  pFIND->name );
#endif
			GetDirEntry( pFIND, pDIR );
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_111C
	printf("111c uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  GetRemoteFileAttributesAndSize  INT 2fh fn 110fh
//
//
//  Retrieve the attributes and size of a file on a remote machine
//
//
//  On entry:
//
//		szCWD	 			= Current working directory on the remote machine
//		szPath 			= Path for the directory on the remote machine
//		puAttributes	= Variable for file attributes of the remote file
//		pulSize			= Variable for file size of the remote file
//
//  On exit:
//
//  on success,
//
//		puAttributes	= is updated
//		pulSize			= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL GetRemoteFileAttributesAndSize( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned * puAttributes,
		ulong * pulSize )
{
	static FIND FIND;
	unsigned uAttributes;
	bool fSuccessful;
	unsigned uErrorCode;
	unsigned uSearchAttributes =
			A_NORMAL | A_HIDDEN | A_READONLY | A_SYSTEM | A_SUBDIR;


#if DEBUG_PARM_110F
		printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
		printf("szCWD: %s\n", szCWD );
#endif

	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
		//  Set the DTA to the address of the find first
		//  structure in the request packet
		//
		dlSetDTA( &FIND );


#if DEBUG_PARM_110F
		printf("szPath: %s\n", szPath );
#endif

		//  Perform the find first
		//
		fSuccessful = dlFindFirstFile( uSearchAttributes, szPath );
		if( fSuccessful )
		{
			*puAttributes = FIND.attr;
			*pulSize      = FIND.size;

#if DEBUG_PARM_110F
			printf("FIND.name: %s\n", FIND.name );
			printf("FIND.attr: %x\n", FIND.attr );
			printf("FIND.size: %x\n", FIND.size );
			printf("FIND.time: %x\n", FIND.time );
			printf("FIND.date: %x\n", FIND.date );
#endif
		}
		else
		{
			fSuccessful = dlGetFileAttributes( szPath, &uAttributes );
			if( fSuccessful )
			{
				*puAttributes = uAttributes;
				*pulSize      = 0;
			}
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
		if( uErrorCode == ERR_LASTFILE )
		{
			uErrorCode = ERR_NOTFOUND;
		}
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_110F
	printf("110f uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  SetRemoteFileAttributes  INT 2fh fn 110eh
//
//
//  Set the attributes for a file on a remote machine
//
//
//  On entry:
//
//		szCWD	 			= Current working directory on the remote machine
//		szPath 			= Path for the directory on the remote machine
//		uAttributes		= Desired attributes for the remote file
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL SetRemoteFileAttributes( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uAttributes )
{
	bool fSuccessful;
	unsigned uErrorCode;


#if DEBUG_PARM_110E
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
#if DEBUG_PARM_110E
		printf("szPath: %s\n", szPath );
		printf("uAttributes: %x\n", uAttributes );
#endif

		//  Perform the set file attributes
		//
		fSuccessful = dlSetFileAttributes( uAttributes, szPath );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_110E
	printf("110e uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  CreateRemoteDirectory  INT 2fh fn 1103h
//
//
//  Create a directory on a remote machine
//
//
//  On entry:
//
//		szCWD	 = Current working directory on the remote machine
//		szPath = Path for the directory on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL CreateRemoteDirectory( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath )
{
	bool fSuccessful;
	unsigned uErrorCode;


#if DEBUG_PARM_1103
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
#if DEBUG_PARM_1103
		printf("szPath: %s\n", szPath );
#endif


		//  Perform the create directory
		//
		fSuccessful = dlMakeDirectory( szPath );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1103
	printf("1103 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  RemoveRemoteDirectory  INT 2fh fn 1101h
//
//
//  Remove a directory on a remote machine
//
//
//  On entry:
//
//		szCWD	 = Current working directory on the remote machine
//		szPath = Path for the directory on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoveRemoteDirectory( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath )
{
	bool fSuccessful;
	unsigned uErrorCode;


#if DEBUG_PARM_1101
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
#if DEBUG_PARM_1101
		printf("szPath: %s\n", szPath );
#endif


		//  Perform the remove directory
		//
		fSuccessful = dlRemoveDirectory( szPath );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1101
	printf("1101 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  ChangeRemoteDirectory  INT 2fh fn 1105h
//
//
//  Change the current directory on a remote machine
//
//
//  On entry:
//
//		szCWD	 = Current working directory on the remote machine
//		szPath = Path for the directory on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL ChangeRemoteDirectory( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath )
{
	bool fSuccessful;
	unsigned uErrorCode;


#if DEBUG_PARM_1105
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
#if DEBUG_PARM_1105
		printf("szPath: %s\n", szPath );
#endif


		//  Perform the change directory
		//
		fSuccessful = dlSetCurrentDirectory( szPath );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1105
	printf("1105 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  DeleteRemoteFile  INT 2fh fn 1113h
//
//
//  Delete a file on the remote machine
//
//
//  On entry:
//
//		szCWD		= Current working directory on the remote machine
//		szPath	= Path for the file on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL DeleteRemoteFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath )
{
	bool fSuccessful;
	unsigned uErrorCode;
	static FIND FIND;
	static char szTempPath[MAXNAMELEN];


#if DEBUG_PARM_1113
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
#if DEBUG_PARM_1113
		printf("szPath: %s\n", szPath );
#endif

		//  Perform the delete file
		//
		fSuccessful = dlWildcardDelete( szPath, &FIND, szTempPath );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
		if( uErrorCode == ERR_LASTFILE )
		{
			uErrorCode = ERR_NOTFOUND;
		}
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1113
	printf("1113 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  RenameRemoteFile  INT 2fh fn 1111h
//
//
//  Rename a file on the remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szCurrentName	= Current name of the file on the remote machine
//		szNewName		= Desired name of the file on the remote machine
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RenameRemoteFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szCurrentName, char _D_ * szNewName )
{
	bool fSuccessful;
	unsigned uErrorCode;


#if DEBUG_PARM_1111
	printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
	printf("szCWD: %s\n", szCWD );
#endif


	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{
#if DEBUG_PARM_1111
		printf("szCurrentName: %s\n", szCurrentName );
		printf("szNewName: %s\n", szNewName );
#endif

		//  Perform the file or directory rename
		//
		fSuccessful = dlRenameFileOrDirectory( szCurrentName, szNewName );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1111
	printf("1111 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  RemoteExtendedOpenCreateFile INT 2fh fn 112Eh
//
//
//  Open, create, or truncate a file on a remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szPath			= Path for the directory on the remote machine
//		uOpenMode		= Desired action (open, create, or truncate)
//		uAttributes    = File attributes for the file
//    uProcessID     = Process ID on remote machine
//		puAction       = Variable for the action performed (open, create, etc)
//		puRemoteHandle	= Variable for file handle on remote machine
//    puTime         = Variable for file time in DOS packed form
//    puDate         = Variable for file date in DOS packed form
//		pulSize        = Variable for the file size
//		puAttributes   = Variable for the file attributes
//
//  On exit:
//
//  on success,
//
//		puAction       = is updated
//		puRemoteHandle	= is updated
//    puTime         = Time in DOS packed form
//    puDate         = Date in DOS packed form
//		pulSize        = is updated
//		puAttributes   = is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteExtendedOpenCreateFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uOpenMode,
		unsigned uAttributes, unsigned uProcessID, unsigned * puAction,
		unsigned * puRemoteHandle, unsigned * puTime, unsigned * puDate,
		ulong * pulSize, unsigned * puAttributes )
{
	bool fSuccessful;
	unsigned uErrorCode;
	long lPosition;


#if DEBUG_PARM_112E
		printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
		printf("szCWD: %s\n", szCWD );
#endif

	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{

#if DEBUG_PARM_112E
		printf("uOpenMode: %x\n", uOpenMode );
		printf("uAttributes: %x\n", uAttributes );
		printf("uAction: %x\n", *puAction );
#endif

#if DEBUG_PARM_112E
		printf("szPath: %s\n", szPath );
#endif

		//  Perform the open/create file
		//
		fSuccessful = dlOpenOrCreateFile( uOpenMode, uAttributes, puAction,
				szPath, (int *)(puRemoteHandle) );

		if( fSuccessful )
		{
#if DEBUG_PARM_112E
			printf("Open successful - handle %x action %x\n", *puRemoteHandle,
					*puAction );
#endif

			//  Track the use of handles for process termination
			//
			HandleTrack[*puRemoteHandle] = uProcessID;


			//  Get the file date and time
			//
			dlGetFileDateAndTime( *puRemoteHandle, (DOSFileTime *)(puTime),
					(DOSFileDate *)(puDate) );


			//  Determine the file size and return the file position back
			//  to the start of the file
			//
			lPosition = 0;
			dlSeekFile( SEEK_END, *puRemoteHandle, &lPosition );
			*pulSize = (ulong)lPosition;
			lPosition = 0;
			dlSeekFile( SEEK_SET, *puRemoteHandle, &lPosition );


			//  Get the file attributes
			//
			dlGetFileAttributes( szPath, puAttributes );


#if DEBUG_PARM_112E
			printf("pulSize: %lx\n", *pulSize );
			printf("puAttributes: %x\n", *puAttributes );
			printf("puTime: %x\n", *puTime );
			printf("puDate: %x\n", *puDate );
#endif
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_112E
	printf("112e uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  RemoteOpenFile INT 2fh fn 1116h
//
//
//  Open a file on a remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szPath			= Path for the directory on the remote machine
//		uOpenMode		= Desired action (open, create, or truncate)
//    uProcessID     = Process ID on remote machine
//		puRemoteHandle	= Variable for file handle on remote machine
//    puTime         = Variable for file time in DOS packed form
//    puDate         = Variable for file date in DOS packed form
//		pulSize        = Variable for the file size
//		puAttributes   = Variable for the file attributes
//
//  On exit:
//
//  on success,
//
//		puRemoteHandle	= is updated
//    puTime         = Time in DOS packed form
//    puDate         = Date in DOS packed form
//		pulSize        = is updated
//		puAttributes   = is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteOpenFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uOpenMode,
		unsigned uProcessID, unsigned * puRemoteHandle,	unsigned * puTime,
		unsigned * puDate, ulong * pulSize, unsigned * puAttributes )
{
	bool fSuccessful;
	unsigned uErrorCode;
	long lPosition;


#if DEBUG_PARM_1116
		printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
		printf("szCWD: %s\n", szCWD );
#endif

	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{

#if DEBUG_PARM_1116
		printf("uOpenMode: %x\n", uOpenMode );
#endif

#if DEBUG_PARM_1116
		printf("szPath: %s\n", szPath );
#endif

		//  Perform the open file
		//
		fSuccessful = dlOpenFile( szPath, (uchar)uOpenMode,
				(int *)(puRemoteHandle) );

		if( fSuccessful )
		{
#if DEBUG_PARM_1116
			printf("Open successful - handle %x\n", *puRemoteHandle );
#endif


			//  Track the use of handles for process termination
			//
			HandleTrack[*puRemoteHandle] = uProcessID;


			//  Get the file date and time
			//
			dlGetFileDateAndTime( *puRemoteHandle, (DOSFileTime *)(puTime),
					(DOSFileDate *)(puDate) );


			//  Determine the file size and return the file position back
			//  to the start of the file
			//
			lPosition = 0;
			dlSeekFile( SEEK_END, *puRemoteHandle, &lPosition );
			*pulSize = (ulong)lPosition;
			lPosition = 0;
			dlSeekFile( SEEK_SET, *puRemoteHandle, &lPosition );


			//  Get the file attributes
			//
			dlGetFileAttributes( szPath, puAttributes );

#if DEBUG_PARM_1116
			printf("pulSize: %lx\n", *pulSize );
			printf("puAttributes: %x\n", *puAttributes );
			printf("puTime: %x\n", *puTime );
			printf("puDate: %x\n", *puDate );
#endif
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1116
	printf("1116 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  RemoteCreateFile INT 2fh fn 1117h
//
//
//  Create or truncate a file on a remote machine
//
//
//  On entry:
//
//		szCWD				= Current working directory on the remote machine
//		szPath			= Path for the directory on the remote machine
//		uAttributes    = File attributes for the file
//    uProcessID     = Process ID on remote machine
//		puRemoteHandle	= Variable for file handle on remote machine
//    puTime         = Variable for file time in DOS packed form
//    puDate         = Variable for file date in DOS packed form
//		pulSize        = Variable for the file size
//		puAttributes   = Variable for the file attributes
//
//  On exit:
//
//  on success,
//
//		puRemoteHandle	= is updated
//    puTime         = Time in DOS packed form
//    puDate         = Date in DOS packed form
//		pulSize        = is updated
//		puAttributes   = is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL RemoteCreateFile( uchar ucRemoteDriveLetter,
		char _D_ * szCWD, char _D_ * szPath, unsigned uAttributes,
		bool fCreateNew, unsigned uProcessID, unsigned * puRemoteHandle,
		unsigned * puTime, unsigned * puDate, ulong * pulSize,
		unsigned * puAttributes )
{
	bool fSuccessful;
	unsigned uErrorCode;
	long lPosition;


#if DEBUG_PARM_1117
		printf("ucRemoteDriveLetter: %c\n", ucRemoteDriveLetter );
		printf("szCWD: %s\n", szCWD );
#endif

	//  Set the drive and CWD
	//
	fSuccessful = SmartDriveSetup( ucRemoteDriveLetter, szCWD );
	if( fSuccessful )
	{

#if DEBUG_PARM_1117
		printf("uAttributes: %x\n", uAttributes );
		printf("fCreateNew: %04x\n", fCreateNew );
#endif

#if DEBUG_PARM_1117
		printf("szPath: %s\n", szPath );
#endif

		if( fCreateNew )
		{
			//  Perform the create new file
			//
			fSuccessful = dlCreateNewFile( uAttributes, szPath,
					(int *)(puRemoteHandle) );
		}
		else
		{
			//  Perform the open/create file
			//
			fSuccessful = dlCreateFile( uAttributes, szPath,
					(int *)(puRemoteHandle) );
		}

		if( fSuccessful )
		{
#if DEBUG_PARM_1117
			printf("Create successful - handle %x\n", *puRemoteHandle );
#endif


			//  Track the use of handles for process termination
			//
			HandleTrack[*puRemoteHandle] = uProcessID;


			//  Get the file date and time
			//
			dlGetFileDateAndTime( *puRemoteHandle, (DOSFileTime *)(puTime),
					(DOSFileDate *)(puDate) );


			//  Determine the file size and return the file position back
			//  to the start of the file
			//
			lPosition = 0;
			dlSeekFile( SEEK_END, *puRemoteHandle, &lPosition );
			*pulSize = (ulong)lPosition;
			lPosition = 0;
			dlSeekFile( SEEK_SET, *puRemoteHandle, &lPosition );


			//  Get the file attributes
			//
			dlGetFileAttributes( szPath, puAttributes );


#if DEBUG_PARM_1117
			printf("pulSize: %lx\n", *pulSize );
			printf("puAttributes: %x\n", *puAttributes );
			printf("puTime: %x\n", *puTime );
			printf("puDate: %x\n", *puDate );
#endif
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1117
	printf("1117 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  SetRemoteFilePosition  INT 2fh fn 1121h
//
//
//  Set the position of a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle 			= File handle on remote machine
//		ulPositionFromEnd		= Desired position in file from the end
//		pulResultingPosition	= Variable for the file position after the call
//
//  On exit:
//
//  on success,
//
//		pulResultingPosition	= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL SetRemoteFilePosition( unsigned uRemoteHandle,
		ulong ulPositionFromEnd, ulong * pulResultingPosition )
{
	bool fSuccessful;
	unsigned uErrorCode;
	long lPosition;


	//  Perform the file seek
	//
	lPosition = (long)ulPositionFromEnd;

#if DEBUG_PARM_1121
	printf("uRemoteHandle: %x\n", uRemoteHandle );
	printf("set position from end - lPosition: %lx\n", lPosition );
#endif

	fSuccessful = dlSeekFile( SEEK_END, uRemoteHandle, &lPosition );
	if( fSuccessful )
	{

#if DEBUG_PARM_1121
		printf("Successful\n");
		printf("lPosition: %lx\n", lPosition );
#endif
		*pulResultingPosition = (ulong)lPosition;
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1121
	printf("1121 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  ReadRemoteFile  INT 2fh fn 1108h
//
//
//  Write to a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle	= File handle on remote machine
//		uNumberOfBytes	= Number of bytes to read
//    ulFilePosition = Position in the file to begin reading
//		pBuffer			= Address of buffer
//		puByteRead		= Variable for the number of bytes actually read
//
//  On exit:
//
//  on success,
//
//		puByteRead	= is updated
//		pBuffer		= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL ReadRemoteFile( unsigned uRemoteHandle, ulong ulFilePosition,
		unsigned uNumberOfBytes, void _D_ * pBuffer, unsigned * puBytesRead )
{
	bool fSuccessful;
	unsigned uErrorCode;
	unsigned uByteCount;
	long lPosition;


	//  Perform the file read
	//
	uByteCount = uNumberOfBytes;

#if DEBUG_PARM_1108
	printf("uRemoteHandle: %x\n", uRemoteHandle );
	printf("uByteCount: %x\n", uByteCount );
	printf("ulPosition: %lx\n", ulFilePosition );
#endif

	lPosition = (long)(ulFilePosition);
	fSuccessful = dlSeekFile( SEEK_SET, uRemoteHandle, &lPosition );
	if( fSuccessful )
	{
		fSuccessful = dlReadFile( (int)uRemoteHandle, &uByteCount, pBuffer );
		if( fSuccessful )
		{
#if DEBUG_PARM_1108
			printf("Successful\n");
			printf("uByteCount: %x\n", uByteCount );
#endif
			*puBytesRead = uByteCount;
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1108
	printf("1108 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  WriteRemoteFile  INT 2fh fn 1109h
//
//
//  Write to a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle	= File handle on remote machine
//		uNumberOfBytes	= Number of bytes to write
//    ulFilePosition = Position in the file to begin writing
//		pBuffer			= Address of buffer
//		puBytesWritten	= Variable for the number of bytes actually written
//
//  On exit:
//
//  on success,
//
//		puBytesWritten	= is updated
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL WriteRemoteFile( unsigned uRemoteHandle,
		ulong ulFilePosition, unsigned uNumberOfBytes, void _D_ * pBuffer,
		unsigned * puBytesWritten )
{
	bool fSuccessful;
	unsigned uErrorCode;
	unsigned uByteCount;
	long lPosition;


	//  Perform the file write
	//
	uByteCount = uNumberOfBytes;

#if DEBUG_PARM_1109
	printf("uRemoteHandle: %x\n", uRemoteHandle );
	printf("uByteCount: %x\n", uByteCount );
	printf("ulPosition: %lx\n", ulFilePosition );
#endif

	lPosition = (long)(ulFilePosition);
	fSuccessful = dlSeekFile( SEEK_SET, uRemoteHandle, &lPosition );
	if( fSuccessful )
	{
		fSuccessful = dlWriteFile( (int)uRemoteHandle, &uByteCount, pBuffer );
		if( fSuccessful )
		{
#if DEBUG_PARM_1109
			printf("Successful\n");
			printf("uByteCount: %x\n", uByteCount );
#endif
			*puBytesWritten = uByteCount;
		}
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1109
	printf("1109 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  CommitRemoteFile  INT 2fh fn 1107h
//
//
//  Commit a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle = File handle on remote machine
//    fUpdateDateTime = Boolean for whether to update the date and time
//    uTime           = Time in DOS packed form
//    uDate           = Date in DOS packed form
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL CommitRemoteFile( unsigned uRemoteHandle,
		bool fUpdateDateTime, unsigned uTime, unsigned uDate )
{
	bool fSuccessful;
	unsigned uErrorCode;


#if DEBUG_PARM_1107
	printf("uRemoteHandle: %04x\n", uRemoteHandle );
	printf("fUpdateDateTime: %x\n", fUpdateDateTime );
	printf("uTime: %04x\n", uTime );
	printf("uDate: %04x\n", uDate );
#endif


	//  Update the file's date and time
	//
	if( fUpdateDateTime )
	{
		dlSetFileDateAndTime( uRemoteHandle, (DOSFileTime *)(&uTime),
				(DOSFileDate *)(&uDate) );
	}


	//  Perform the commit file
	//
	fSuccessful = dlCommitFile( uRemoteHandle );


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1107
	printf("1107 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  CloseRemoteFile  INT 2fh fn 1106h
//
//
//  Close a file on a remote machine
//
//
//  On entry:
//
//		uRemoteHandle = File handle on remote machine
//    fUpdateDateTime = Boolean for whether to update the date and time
//    uTime           = Time in DOS packed form
//    uDate           = Date in DOS packed form
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned PASCAL CloseRemoteFile( unsigned uRemoteHandle,
		bool fUpdateDateTime, unsigned uTime, unsigned uDate,
		bool fDuplicateHandleAndClose )
{
	bool fSuccessful;
	unsigned uErrorCode;
	unsigned uDuplicateHandle;


#if DEBUG_PARM_1106
	printf("uRemoteHandle: %04x\n", uRemoteHandle );
	printf("fUpdateDateTime: %x\n", fUpdateDateTime );
	printf("uTime: %04x\n", uTime );
	printf("uDate: %04x\n", uDate );
	printf("fDuplicateHandleAndClose: %x\n", fDuplicateHandleAndClose );
#endif


	//  Update the file's date and time
	//
	if( fUpdateDateTime )
	{
		dlSetFileDateAndTime( uRemoteHandle, (DOSFileTime *)(&uTime),
				(DOSFileDate *)(&uDate) );
	}


	if( fDuplicateHandleAndClose )
	{
		//  Duplicate the handle
		//
		asm	mov	ah, 45h
		asm	mov	bx, uRemoteHandle
		asm   int	21h
		asm	mov	uDuplicateHandle, ax

		//  Perform the close file
		//
		fSuccessful = dlCloseFile( uDuplicateHandle );
	}
	else
	{
		//  Perform the close file
		//
		fSuccessful = dlCloseFile( uRemoteHandle );
	}


	//  Determine if there was error
	//
	if( !fSuccessful )
	{
		//  Set the DOS error code
		//
		uErrorCode = dlCheckDOSError();
	}
	else
	{
		uErrorCode = 0;
	}


#if DEBUG_ERR_1106
	printf("1106 uErrorCode = %04x\n\n", uErrorCode );
#endif

	return uErrorCode;
}


//  CloseAllRemoteFiles  INT 2fh fn 111dh
//
//
//  Close all files on a remote machine for local process termination
//
//
//  On entry:
//
//		uProcessID = The identifier process that is terminating
//
//  On exit:
//
//  on success,
//
//  	function returns 0
//
//  on error,
//
//		function returns the DOS error code describing the error
//
//
unsigned CloseAllRemoteFiles( unsigned uProcessID )
{
	unsigned uIndex;


	for( uIndex = 0; uIndex < uMaxHandles; uIndex++ )
	{
		if( HandleTrack[uIndex] == uProcessID )
		{
			dlCloseFile( uIndex );
			HandleTrack[uIndex] = 0;
		}
	}

	return 0;
}


//  ========================================================================
//
//  The remainder of this file is specific to the implementation.
//
//  ========================================================================




//  GetGlobalRequestPacketAddress
//
//
//  Return the address of the data space used to form packets
//
//
//  Note:  This data space must be able to hold the maximum
//         possible packet size
//
//
//  On entry:
//
//    Nothing
//
//  On exit:
//
//  	function returns = The address of the data space for a packet
//
//
void * GetGlobalRequestPacketAddress( void )
{
	static uchar ucPacket[REQ_PACKET_SIZE];
	return ucPacket;
}



//  SmartDriveSetup
//
//
//  Change to the specified drive and directory
//
//
//  On Entry:
//
//    ucRemoteDriveLetter = Drive letter to change to
//    szCWD               = Directory to change to
//
//
//  On Exit:
//
//    On success,
//
//       Function returns FALSE
//
//
//    On failure,
//
//       Function returns FALSE
//
//
bool SmartDriveSetup( uchar ucRemoteDriveLetter, char _D_ * szCWD )
{
	bool fSuccessful;


	//  Change the drive to the one being service on
	//
	fSuccessful = dlSetCurrentDrive(
			toupper(ucRemoteDriveLetter) - 'A' );
	if( fSuccessful )
	{
		//  Change the directory to what the CWD is on the
		//  client machine
		//
		fSuccessful = dlSetCurrentDirectory( szCWD );
	}


	//  Return whether the drive setup was successful
	//
	return fSuccessful;
}



//  GetDirEntry
//
//
//  Retrieve the directory entry that the find structure references
//
//
//  On Entry:
//
//    pFind = FIND structure containing the results of a find first/next
//    pDir  = Variable to store the directory entry
//
//
//  On Exit:
//
//    pDir = Is updated with the directory entry
//
//
void GetDirEntry( PFIND pFind, PDIR pDir )
{
	memset( pDir, 0, sizeof(DIR) );

	pDir->attr = pFind->attr;
	pDir->time = pFind->time;
	pDir->date = pFind->date;
	pDir->size = pFind->size;
	pDir->uStartingClusterLo = (unsigned)(pFind->ulStartingCluster);
	pDir->uStartingClusterHi = (unsigned)(pFind->ulStartingCluster >> 16);

	DotToENAME( &pFind->name[0], &pDir->name[0] );

//	pDir->reserved = pFind->;
//	pDir->bCentiSeconds = pFind->;
//	pDir->uCreationTime = pFind->;
//	pDir->uCreationDate = pFind->;
//	pDir->uLastAccessDate = pFind->;
}


//
//
void DotToENAME( char * szDotName, char * szENAME )
{
	unsigned uENAMEIndex = 0;
	unsigned uDotNameIndex = 0;
	char cTemp;
	unsigned uCount;


	for( uCount = 0; uCount < 2; uCount++ )
	{
		cTemp = szDotName[uDotNameIndex];
		if( cTemp == '.' )
		{
			szENAME[uENAMEIndex] = cTemp;
			uDotNameIndex++;
			uENAMEIndex++;
		}
		else
		{
			break;
		}
	}


	while( uENAMEIndex < 8 )
	{
		cTemp = szDotName[uDotNameIndex];
		if( (cTemp == '.') || (cTemp == 0) )
		{
			szENAME[uENAMEIndex] = ' ';
		}
		else
		{
			szENAME[uENAMEIndex] = cTemp;
			uDotNameIndex++;
		}

		uENAMEIndex++;
	}


	if( szDotName[uDotNameIndex] == '.' )
	{
		uDotNameIndex++;
	}


	while( uENAMEIndex < 11 )
	{
		cTemp = szDotName[uDotNameIndex];
		if( cTemp == 0 )
		{
			szENAME[uENAMEIndex] = ' ';
		}
		else
		{
			szENAME[uENAMEIndex] = cTemp;
			uDotNameIndex++;
		}

		uENAMEIndex++;
	}
}


//  Create a DPB so that we have all of the drive areas calculated
//
void CreateDPBFromBPB( uchar ucDosDriveNumber, PBPB pBPB, PDPB pDPB )
{
	unsigned bps;
	unsigned res;
	ulong    dirstart;
	ulong    datastart;
	ulong    ulFreeClusters = 0;
	ulong		ulNextFreeCluster = 0;
	ulong    ulMaxCluster;
	unsigned entries;
	ulong    sectors;
	uchar    spc;
	uchar    num_fats;
	uchar    shift;


	//  Save the dos drive number in the DPB
	//
	pDPB->drive = ucDosDriveNumber;

	//  Make local copies of some of the variables in the BPB
	//
	bps      = pBPB->sec_size;
	res      = pBPB->res_sec;
	spc      = pBPB->sec_per_clus;
	entries  = pBPB->uDirEntries;
	num_fats = pBPB->num_fats;

	//  Determine the shift factor for the cluster
	//
	spc = spc >> 1;
	for(shift=0; spc; ++shift)
	{
		spc >>= 1;
	}

	//
	//  These calculations are the same for both FAT16 and FAT32 drives
	//

	sectors      	= (pBPB->num_sec ? (long)pBPB->num_sec : pBPB->lnumsec);
	ulFreeClusters	= 0xFFFFFFFFL;

	// FAT32 disk? then set the fields up for FAT32
	if( !pBPB->uFatSectors )
	{
		datastart    = res + (pBPB->ulSectorsPerFat * num_fats);
		ulMaxCluster = ((sectors - datastart) >> shift) + 1;

		//  These fields are assigned zero for a FAT32 DPB
		//
		pDPB->dir_ent   = 0;
		pDPB->fat_len   = 0;
		pDPB->hiclus    = 0;

		//  This field is not used for FAT32 drives and should be
		//  assigned -1
		//
		pDPB->dir_start	= Negative1;

		//  Set the FAT32 fields of the DPB
		//
		pDPB->uExtendedFlags        = pBPB->uExtendedFlags;
		pDPB->uFSInfoSector         = pBPB->uFSInfoSector;
		pDPB->uBackUpBootSector     = pBPB->uBackUpBootSector;
		pDPB->ulSectorsPerFAT       = pBPB->ulSectorsPerFat;
		pDPB->ulRootDirStartCluster = pBPB->ulRootDirStartCluster;
		pDPB->ulFirstDataSector     = datastart;
		pDPB->ulMaxCluster          = ulMaxCluster;
	}
	else
	{
		dirstart     = res + (pBPB->uFatSectors * num_fats);
		datastart    = dirstart + ((entries + ((bps>>5) - 1)) << 5) / bps;
		ulMaxCluster = ((sectors - datastart) >> shift) + 1;

		pDPB->dir_ent	 = entries;
		pDPB->dir_start = LOWORD(dirstart);
		pDPB->hiclus    = LOWORD(ulMaxCluster);
		pDPB->fat_len   = pBPB->uFatSectors;
	   pDPB->newclus   = 0;
	}

	//
	//  These fields get set the same for FAT32 or FAT16
	//

	pDPB->bytes_per_sec	= bps;
	pDPB->ms_spc			= pBPB->sec_per_clus - 1;
	pDPB->fat_start		= res;
	pDPB->num_fats			= num_fats;
	pDPB->media				= pBPB->media;
	pDPB->shift          = shift;

	//  This field gets set with with the low word of the same variable
	//  for both FAT32 and FAT16 drives.  See the notes in the DPB
	//  structure before changing these assignments.
	//
	pDPB->data_start  = LOWORD(datastart);

	//  For a FAT32 drive we need to retrieve the number of free clusters
	//  and the next available cluster number from the disk.  The DPB needs
	//  to be fully initilized and the sda_dpbptr needs to point to the
	//  dpb.  For romdos init this is done in dev_init.
	//
	if( !pBPB->uFatSectors )
	{
		// determine freespace and next free cluster
		//
		pDPB->uFreeClustersHigh = HIWORD(ulFreeClusters);
		pDPB->ulNextFreeCluster = ulNextFreeCluster;
		pDPB->newclus           = LOWORD(ulNextFreeCluster);
	}
	else
	{
		pDPB->rebuild = 0xFF;
	}

	//  This field gets set with with the low word of the same variable
	//  for both FAT32 and FAT16 drives.  See the notes in the DPB
	//  structure before changing these assignments.
	//
	pDPB->freeclus = LOWORD(ulFreeClusters);
}


//  UpdateDriveMapList
//
//
//  Return the remote drive list array
//
//
//  On entry:
//
//    pRemoteList = Address that will contain the remote list array
//
//  On exit:
//
//		function returns the DOS error code describing the error
//
//
unsigned UpdateDriveMapList( PREMOTELIST pRemoteList )
{
	uchar ucDOSDriveNumber;
	bool fSuccessful;
	bool fIsRemovable;
	bool fIsRemote;
	bool fIsSubsted;
	uchar ucMappedDriveNumber;
	unsigned uIndex;


	//  Retrieve the information about each drive
	//
	for( ucDOSDriveNumber = 0; ucDOSDriveNumber < 26; ucDOSDriveNumber++ )
	{
		//  Determine if this is a valid drive and if it is substed
		//
		fSuccessful = dlIsDriveSubst( ucDOSDriveNumber + 1, &fIsSubsted );
		if( (fSuccessful) && (!fIsSubsted) )
		{
			//  Determine if this drive is in the "don't map these drives list"
			//
			uIndex = 0;
			while( szDontMapList[uIndex] )
			{
				if( szDontMapList[uIndex] == (ucDOSDriveNumber + 'A') )
				{
					continue;
				}
				uIndex++;
			}


			//  Determine if this drive is in the "only map these drives list"
			//
			uIndex = 0;
			while( szOnlyMapList[uIndex] )
			{
				if( szOnlyMapList[uIndex] == (ucDOSDriveNumber + 'A') )
				{
					break;
				}
				uIndex++;
			}
			if( szOnlyMapList[0] != 0 )
			{
				if( szOnlyMapList[uIndex] != (ucDOSDriveNumber + 'A') )
				{
					continue;
				}
			}


			//  Set whether the drive is local or remote in the drive list
			//
			dlIsDriveRemote( ucDOSDriveNumber + 1, &fIsRemote );
			if( (fIsRemote) && (DontMapNetworkDrives()) )
			{
				continue;
			}
			pRemoteList->fIsRemote = fIsRemote;


			//  Set whether the drive is removable in the drive list
			//
			dlIsDriveRemovable( ucDOSDriveNumber + 1, &fIsRemovable );
			if( (fIsRemovable) && (DontMapRemovableDrives()) )
			{
				continue;
			}
			pRemoteList->fIsRemovable = fIsRemovable;


			fSuccessful = dlGetLogicalDriveMap( ucDOSDriveNumber + 1,
					&ucMappedDriveNumber );
			if( fSuccessful )
			{
				if( (ucMappedDriveNumber != 0) &&
						(ucMappedDriveNumber == ucDOSDriveNumber) )
				{
					//  Don't map logical drives;
					//
					continue;
				}
			}


			//  Set the remote (local in this case) drive letter in
			//  the drive list
			//
			pRemoteList->ucRemoteDriveLetter = ucDOSDriveNumber + 'A';


			//  Go to the next entry in the drive list
			//
			pRemoteList++;
		}
	}


	//  Set an indicator that this is the end of the list
	//
	if( ucDOSDriveNumber < 26 )
	{
		pRemoteList->ucRemoteDriveLetter = 0;
	}


	//  Return that the function was successful
	//
	return 0;
}
