//
//   $Id: SERVER.C 1.9 2002/10/16 22:01:36Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  SERVER.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  This file initializes the IFS service interface then begins
//  servicing remote requests
//
//  History:
//
//  04-01-2001  bt  Created
//


#define SWIRL 		FALSE


//  Borland libaries
//
#include <stdio.h>
#include <dir.h>
#include <ctype.h>
#include <mem.h>
#include <string.h>
#include <process.h>


//  Local libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dllfn.h"
#include "dl8250.h"
#include "crc32.h"
#include "fatworld.h"
#include "windows.h"
#include "dosver.h"
#include "bldver.h"
char far * GetEnvEntry( const char * szName );


//  Local definitions
//
#include "commapi.h"
#include "netapi.h"
#include "cliapi.h"
#include "server.h"


//  Prototypes
//
#include "server.pt"
unsigned Service( void );


bool fIsFat32World;
bool fInWindows;
bool fIsWinNT;
bool fSwitches[MAX_BOOLEAN_SWITCHES];


unsigned uMaxHandles = MAX_HANDLES;
uchar ucHandleTable[MAX_HANDLES];

unsigned HandleTrack[MAX_HANDLES];


uchar main( int argc, char *argv[] )
{
	uchar ucTemp;
	unsigned uErrorCode = 0xffff;
	static int iDrive;
	static char szCWD[67];
	bool fQuit = FALSE;
	LPPSP lpPSP;
	bool fSuccessful;
	char far * lpszOSString;
	extern unsigned _psp;
#if SWIRL
	char szSwirl[] = "-\\|/";
	uchar ucSwirlIndex = 0;
#endif

	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();


	//  Determine if this is Windows NT
	//
	lpszOSString = GetEnvEntry("OS");
	fIsWinNT = ( _fstrcmp( lpszOSString, "Windows_NT" ) == 0 );


	//  Determine if we are in windows
	//
	fInWindows = dlInWindows();


	//  Install a critical error handler so that we can abort cleanly
	//
	InstallInt24Handler();


	//  Save the starting drive and current directory
	//
	dlGetCurrentDrive( &iDrive );
	dlGetCurrentDirectory( iDrive+1, szCWD );


	//  Increase the number of handle that are available to this process
	//
	lpPSP = MK_FP( _psp, 0 );
	memset( ucHandleTable, 0xff, uMaxHandles );
	_fmemcpy( ucHandleTable, lpPSP->htbl_addr, lpPSP->hcount );
	lpPSP->htbl_addr = (uchar far *)ucHandleTable;
	lpPSP->hcount = uMaxHandles;


	//
	//
	fSuccessful = InitInt2fInterface( argc-1, &argv[1] );
	if( fSuccessful )
	{
		//  Display the waiting message
		//
		printf("Servicing requests...\n");
		printf("Press Q to terminate.\n");
#if SWIRL
		printf( "%c", szSwirl[ucSwirlIndex] );
		ucSwirlIndex++;
#endif

		//  Process user requests until the user wants to quit
		//
		while( !fQuit )
		{
			//  Determine if the user wants to quit
			//
			while( TRUE )
			{
				asm	mov	ah, 0bh
				asm	int	21h
				asm	mov	ucTemp, al
				if( ucTemp != 0 )
				{
					asm	mov	ah, 08h
					asm	int	21h
					asm	mov	ucTemp, al
					if( ucTemp == 0 )
					{
						asm	mov	ah, 08h
						asm	int	21h
						asm	mov	ucTemp, al
					}
					else if( toupper(ucTemp) == 'Q' )
					{
						fQuit = TRUE;
					}

				}
				else
				{
					break;
				}
			}


			if( uErrorCode != NET_TIMESHARE_TIMEOUT )
			{
				//
				//  Do nothing
				//
			}
			else
			{
#if SWIRL
				//  Something to let the user know that the the
				//  program is not hung
				//
				printf( "\x08%c", szSwirl[ucSwirlIndex] );
				ucSwirlIndex++;
				if( ucSwirlIndex > 3 )
				{
					ucSwirlIndex = 0;
				}
#endif // #if SWIRL
			}


			//  Process any network requests
			//
			uErrorCode = Service();
		}
#if SWIRL
		printf( "\x08 " );
#endif


		//  Uninitialize the "network"
		//
		NetworkTXRXDeInit();
	}


	//  Restore the starting drive and current directory
	//
	dlSetCurrentDrive( iDrive );
	dlSetCurrentDirectory( "\\" );
	dlSetCurrentDirectory( szCWD );


	//  Uninstall the critical error handler
	//
	UninstallInt24Handler();


	return 0;
}


//  Int 24 handler
//
#pragma argsused
 void interrupt far Int24Handler(BP, DI, SI, DS, ES, DX, CX, BX, AX,
		IP, CS, FLAGS)
{
	//  Fail all critical errors
	//
	(uchar)AX = 3;
}


//  Install a critical error handler so that we can abort cleanly
//
void InstallInt24Handler( void )
{
	void far * far * lplpOldCritHandler;


	lplpOldCritHandler = MK_FP( 0, 0x24*4 );
	SaveOldCritHandler( *lplpOldCritHandler );
	*lplpOldCritHandler = (void far *)Int24Handler;
}


//  Uninstall the critical error handler
//
void UninstallInt24Handler( void )
{
	void far * far * lplpOldCritHandler;

	lplpOldCritHandler = MK_FP( 0, 0x24*4 );
	*lplpOldCritHandler = GetOldCritHandler();
}


//  Return the address of the old critical error handler
//
void far * GetOldCritHandler( void )
{
	void far * * plpOldCritHandler;

	plpOldCritHandler = GetOldCritHandlerAddress();
	return *plpOldCritHandler;
}


//  Save the address of the old critical error handler
//
void SaveOldCritHandler( void far * lpOldCritHandler )
{
	void far * * plpOldCritHandler;

	plpOldCritHandler = GetOldCritHandlerAddress();
	*plpOldCritHandler = lpOldCritHandler;
}


//  Return the address of the variable which contain the old critical
//  error handler
//
void far * * GetOldCritHandlerAddress( void )
{
	static void far * lpOldCritHandler;

	return &lpOldCritHandler;
}


//  Show the usage for a bad command line parameter
//
void OptError(char * szMsg)
{
	unsigned uIndex = 0;

	while( (szMsg[uIndex] != ' ') && (szMsg[uIndex] != 0) )
	{
		if( szMsg[uIndex] == '/' )
		{
			uIndex++;
			if( szMsg[uIndex] != 0 )
			{
				uIndex++;
			}
			break;
		}
		uIndex++;
	}
	szMsg[uIndex] = 0;

	printf("Invalid Switch - %s\n", szMsg );
	exit(255);
}


//  Determine if we should display the signon message and if
//  so display it
//
void DisplaySignonMessage( void )
{
	char * szSignOnMessage = "SERSERV %s %s\n%s\n\n";

	if( !DoHideSignon() )
	{
		if( fIsFat32World )
		{
			printf(szSignOnMessage,SHORTVERSION,BUILDVERSION,COPYRIGHT);
		}
		else
		{
			printf(szSignOnMessage,SHORTVERSION622,BUILDVERSION,COPYRIGHT);
		}
	}
}


//  Display the usage screen and exit
//
void Usage( void )
{
	static char szUsage[] = ""
	"SERSERV [/R][/N][/O<list>][/D<list>][/C#][/I#][/B#][/W#]\n"
	"\n"
	"/R  Don't map removable drives\n"
	"/N  Don't map network drives\n"
	"/O<list> Only map in drives from this list of drive letters\n"
	"/D<list> Don't map in drives from this list of drive letters\n"
	"/C# Comport numbers 1-4 are valid.  Default:COM1\n"
	"/I# IRQ number which can be used to overide the default IRQ for COM1-COM4\n"
	"/B# Baud rate which can be 115200,57600,38400,19200,9600,4800,2400,1200,\n"
   "    and 300. Default:115200\n"
	"/W# Number of seconds to wait before timing out.  MAX:60 Default:10\n"
	"";

	DisplaySignonMessage();
	printf( szUsage );
	exit(1);
}
