;
;   $Id: BOOT32.ASM 1.6 2002/10/16 22:01:36Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;
;   BOOT32.ASM
;
;   Copyright (c) 1989-2002 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary
;
;   History
;
;   01/27/99 bt  Original
;
;   The BS(Boot Sector) which is used to load romdos on a
;   FAT32 partition.  This boot sector can be used for hard
;   drives whos partition reside above the 8Gb boundary and
;   for FAT32 floppy devices.
;
;
;   Operation
;   -------------
;   1)
;   2)
;   3)
;
;   FORMAT and SYS responsibilities
;   ---------------------------------------------------
;   1)
;   2)
;   3)
;
;


;
;
; [ CONSTANTS ]
;

;
; All constants are in this file
;

include BOOT32.INC


;
;
; [ MACROS ]
;

;
; All macros are in thess files
;

include boot.mac


;
;
;
;

_DATA	SEGMENT BYTE PUBLIC 'DATA'
		ASSUME	cs:_DATA, ds:_DATA, es:_DATA, ss:_DATA

		;
		; The boot program will take up 1536 bytes (3 sectors) of
		; space.  We want to make sure that any extra space is
		; filled with zeros.
		;

		org	0000h
		db	1536 dup(0)
		org	0000h


;
;
; Program entry point - skip over BPB info
;


	;
	;  This label is used by SYS.COM and FORMAT.COM to locate
	;  the start of the boot sector for a FAT32 drive.
	;

	public	_rgucBootSector32

	_rgucBootSector32:
	BOOT_SECTOR_START:

		jmp	short REAL_START		; offset 00h
		nop					; offset 02h


;
;
; System name and BPB
;

	SYSTEM_NAME:

    		FileSystemOEMName		db	'DLDOS710'	; 03

;  FAT32 BPB
;                                            OFFSETS:  BPB        ACTUAL

    BPB_BytesPerSector       	DW    0200h	      ; 00	  (0B)
    BPB_SectorsPerCluster    	DB    08h             ; 02	  (0D)
    BPB_ReservedSectors      	DW    0020h           ; 03	  (0E)
    BPB_NumberOfFATs         	DB    02h	      ; 05	  (10)
    BPB_RootEntries          	DW    0000h           ; 06	  (11)
    BPB_TotalSectors         	DW    0000h           ; 08	  (13)
    BPB_MediaDescriptor      	DB    0F8h            ; 0A	  (15)
    BPB_SectorsPerFAT        	DW    0000h           ; 0B	  (16)
    BPB_SectorsPerTrack      	DW    003Fh           ; 0D	  (18)
    BPB_Heads                	DW    00FFh           ; 0F	  (1A)
    BPB_HiddenSectors        	DW    003Fh           ; 11	  (1C)
    BPB_HiddenSectorsHigh    	DW    0000h           ; 13	  (1E)
    BPB_BigTotalSectors      	DW    0080h           ; 15	  (20)
    BPB_BigTotalSectorsHigh  	DW    0B18Eh          ; 17	  (22)
    BPB_BigSectorsPerFat     	DW    201Dh           ; 19	  (24)
    BPB_BigSectorsPerFatHi   	DW    0000h           ; 1B	  (26)
    BPB_ExtFlags             	DW    0000h           ; 1D	  (28)
    BPB_FS_Version           	DW    0000h           ; 1F	  (2A)
    BPB_RootDirStrtClus      	DW    0002h           ; 21	  (2C)
    BPB_RootDirStrtClusHi    	DW    0000h           ; 23	  (2E)
    BPB_FSInfoSec            	DW    0001h           ; 25	  (30)
    BPB_BkUpBootSec          	DW    0006h           ; 27	  (32)
    BPB_Reserved             	DW    0000h           ; 29	  (34)
				DW    0000h           ; 2A	  (36)
				DW    0000h           ; 2C	  (38)
				DW    0000h           ; 2E	  (3A)
				DW    0000h           ; 30	  (3C)
				DW    0000h           ; 32	  (3E)
    BPB_DriveNumber		DB    80h             ; 34        (40)
    BPB_unknown1		DB    00h             ; 35        (41)
    BPB_SystemID		DB    29h             ; 36        (42)
    BPB_SerialNumber		DD    00000000h	      ; 37        (43)
    BPB_VolumeLabel		DB    'NO NAME    '   ; 3b        (47)
    BPB_FileID			DB    'FAT32   '      ; 46        (52)


;
;
; Variables
;

		;
		; This is a variable is the minimum value of a
		; marker indicating the end of a cluster chain.
		;

								 ; offset 5ah

		EndOfClusterChainMarker		dd	0ffffff8h

		;
		; This is the number of cluster entries in a 32-bit
		;

								 ; offset 5eh

		FATClustersNumbersInASector 	dd 	80h

		;
		; This is the address which romdos will be loaded
		;

	LOAD_ADDR label dword

		;
		; Offset to load ROM-DOS
		;

		LOAD_OFF  		dw	0		; offset 62h

		;
		; Segment to load ROM-DOS
		;

		LOAD_SEG  		dw	DEF_LOADADDR	; offset 64h

		;
		; This is the absolute sector number of the the fat
		; which is currently loaded in the fat buffer
		;

		CURRENT_FAT_SECTOR	dd	0		; offset 66h


;
;
; Set up the stack
;

		;
		; Actual program start point
		;

	REAL_START:

		;
		; Setup the stack
		;

		xor	cx, cx
		mov	ss, cx
		mov	sp, PROGRAM_OFFSET

		;
		; Set the base pointer for all the variables
		;

		mov	bp, sp


;
;
; Fixup the BPB heads and sectors per track
;

		; MSDOS fixes up the BPB at device initialization.
		; They do not update the heads and sectors per
		; track in the boot sector.  Because of this there
		; are some situations where MSDOS will not boot.
		;
		; We want to be able to boot all the time so we
		; fixup the heads and sectors per track using the
		; BIOS function 08h call but not for floppies.
		;

		PatchHeadsAndSectorsPerTrack


;
;
; Set up the DBT (Disk Base Table)
;

		;
		; Set up the segment registers
		;

		mov	es, cx

		;
		; Save the address of the old DBT.  Copy the DBT to
		; a new location.  Change the new DBTs sectors per
		; track to the value for this disk.  Change the new
		; DBTs idle time to a default value.
		;
		; ON ENTRY
		;
		; CX	= 0
		; SP	= Offset of the boot sector
		; SP	= Segment of the boot sector
		; ES    = 0
		;
		; ON EXIT
		;
		; AX   	= Preserved
		; BX    = DESTROYED
		; CX    = Preserved
		; DX    = Preserved
		; SI	= DESTROYED
		; DI	= DESTROYED
		; BP	= Offset of the boot sector
		; SP	= Preserved
	 	; SS	= Preserved
		; DS	= 0
		; ES	= Preserved
		;

		SetNewDBT


;
;
; Determine if this is a FAT32 drive
;

		;
		; Check if the sectors per FAT field that was used
		; for FAT12 and FAT16 boot sectors is being used.
		;

	CHECK_IF_FAT32_BPB:

		cmp [bp + OFFSET_SPF], cx

		;
		; Jump if this field is not being used.
		;
		; A floppy device does not have a MBR so we don't need to
		; do the next couple of steps to determine the type of
		; INT-13 function calls to use.  We will assume that the
		; INT-13 functions 2 and 3 will be used.  No we should
		; continue loading up the remaining boot sectors and
		; continue like any other FAT32 partition.
		;

		jnz	DISPLAY_NO_SYS_ON_DISK


;
;
; Save a modified version of the partition ID
;
; Note: This still could be a valid FAT32 file system even if it is
;       a a floppy device.
;

		;
		; Load the partition table (MBR), locate the partition which
		; this boot sector was loaded from, 'AND' off some bits from
		; the partition ID, then save the modified partition ID in
		; a variable.
		;
		; ON ENTRY
		;
		; CX    = 0
		; DS    = Segment of boot sector
		; BP	= Offset of boot sector
		;
		; ON EXIT
		;
		; SI	= High word of the number of hidden sectors
		; DI	= Low word of the number of hidden sectors
		; AX	= DESTROYED
		; BX    = DESTROYED
		; CX    = Preserved
		; DX	= Preserved
		; BP	= Preserved
		; DS	= Preserved
		; ES	= Preserved
		;

		SaveModifiedPartitionID


;
;
; Load up the the rest of the boot sectors
;

		;
		; Set the address of the rest of the boot
		; sectors.
		;
		; DX:AX was set above to be the number of
		; hidden sectors which is equal to the
		; first sector of the partition.  The first
		; sector was already loaded so set the
		; physical sector number to the next sector
		;
		; SI = word ptr [bp + (OFFSET_HID + 0)]
		; DI = word ptr [bp + (OFFSET_HID + 2)]

	LOAD_REMAINING_BOOT_SECTORS:

		mov	ax, si
		mov	dx, di
		inc	ax
		adc	dx, 0

		;
		; Set the remaining number of sectors to read
		;

		mov	cl, 2

		;
		; Set the address to read the sectors into
		;

		mov	bx, REMAINING_BOOT_SECTORS_BUFFER

		;
		; Read the rest of the boot sectors
		;

		call	ReadSector

		;
		; Begin execution in the second boot sector code
		;

		jmp	CALCULATE_FAT_AND_DATA_AREA


;
;
; Display no system on disk error message and reboot
;

		;
		; Display an non system disk error message
		;

	DISPLAY_NO_SYS_ON_DISK:

		mov	si, PROGRAM_OFFSET + ( offset MSG_NO_SYS_ON_DISK - offset BOOT_SECTOR_START )
		call	DisplayString

		;
		; Get a keypress, restore the DBT vector and
		; warmboot the computer.
		;
		; ON ENTRY
		;
		; BP    = Offset of the boot sector
		; SS    = Segment of the boot sector
		;
		; ON EXIT
		;
		; does not return
		;

		Restart


;
;
; Display string function
;
; Display a zero terminated string one character at a
; time using BIOS display character functions.
;
; ON ENTRY
;
; DS:SI = Pointer to a zero terminated string
; DS    = Segment of boot sector
; BP	= Offset of boot sector
;
; ON EXIT
;
; AX	= DESTROYED
; BX    = DESTROYED
; CX    = Preserved
; DX	= Preserved
; SI	= DESTROYED
; DI	= DESTROYED
; BP	= Preserved
; DS	= Preserved
; ES	= Preserved
;

DisplayString	proc	near

		; Display a zero terminated string being pointed to by
		; DS:SI by successivly calling BIOS display character
		; functions.
		;
		; ON ENTRY
		;
		; DS:SI = Pointer to an ASCIIZ string
		; DS    = Segment of boot sector
		; BP	= Offset of boot sector
		;
		; ON EXIT
		;
		; AX	= DESTROYED
		; BX    = DESTROYED
		; CX    = Preserved
		; DX	= Preserved
		; SI	= DESTROYED
		; DI	= DESTROYED
		; BP	= Preserved
		; DS	= Preserved
		; ES	= Preserved
		;

		DisplayAsciizString

		;
		; We are done
		;

		ret

DisplayString	ENDP


;
;
; Read a number of sectors
;
; Read a number of sectors, one sector at a time, into
; a buffer.  This function does properly increment a
; segmented buffer address so that more than 64K worth
; of data can be loaded.
;
; ON ENTRY
;
; DX:AX = Starting physical sector number
; CX	= Number of sectors to read
; ES:BX = Buffer address
; DS    = Segment of boot sector
; BP	= Offset of boot sector
;
; ON EXIT
;
; DX:AX	= Starting physical sector number + CX
; ES:BX = Buffer address + (CX + 512)
; CX    = 0
; SI	= Preserved
; DI	= Preserved
; BP	= Preserved
; DS	= Preserved
;

ReadSector	PROC	NEAR

		; Read a number of sectors, one sector at a time, into
		; a buffer.  This function does properly increment a
		; segmented buffer address so that more than 64K worth
		; of data can be loaded.
		;
		; ON ENTRY
		;
		; DX:AX = Starting physical sector number
		; CX	= Number of sectors to read
		; ES:BX = Buffer address
		; DS    = Segment of boot sector
		; BP	= Offset of boot sector
		;
		; ON EXIT
		;
		; DX:AX	= Starting physical sector number + CX
		; ES:BX = Buffer address + (CX + 512)
		; CX    = 0
		; SI	= Preserved
		; DI	= Preserved
		; BP	= Preserved
		; DS	= Preserved
		;

		ReadXNumberOfSectors

ReadSector	ENDP


;
;
; Display no LBA mode message and halt
;

	DISPLAY_NO_LBA_MODE:

		;
		; Set the pointer to the no LBA mode message
		;

		mov	si, PROGRAM_OFFSET + ( offset MSG_NO_LBA_MODE - offset BOOT_SECTOR_START )

		;
		; Display the string
		;

		call	DisplayString

		;
		; Endless loop
		;

	ENDLESS_LOOP:

		jmp	short ENDLESS_LOOP


;
;
; Error strings
;

	MSG_NO_LBA_MODE:

		db	0Dh, 0Ah
		db	'No LBA modes present'
		db	0

	MSG_NO_SYS_ON_DISK:

		db	0Dh, 0Ah
		db	'Non-system disk or disk error'
		db	0Dh, 0Ah
		db	'Press a key to reboot'
		db	0Dh, 0Ah
		db	0

;
;
; System file names
;

		;
		; Romdos startup code filename
		;

	ROMDOS_FILENAME:

		db	'IBMBIO  COM',0ffh

;
;
; Boot sector marker
;

		org	01feh

		; Boot sector marker
		;

		dw	0aa55h


;
;
; FAT32 FSINFO_STRUCTURE
;

		org	0200h

		db	510 dup(0)

		org	0200h

		db	"RRaA"

		org	03e4h

		db	"rrAa"
		dd	0ffffffffh
		dd	2

		org	03feh

		; Boot sector marker
		;

		dw	0aa55h

;
;
; Calculate start of FAT and DATA area on the disk
;

	       	org	0400h

		;
		; Set the number of reserved sectors in DX:AX
		;

	CALCULATE_FAT_AND_DATA_AREA:

		mov	ax, word ptr [bp + OFFSET_RES]
		cwd

		;
		; Add in the number of hidden sectors
		;
		; SI = word ptr [bp + (OFFSET_HID + 0)]
		; DI = word ptr [bp + (OFFSET_HID + 2)]
		;

		add	ax, si
		adc	dx, di

		;
		; Save the physical sector address for the
		; start of the FATs
		;

		mov	word ptr [bp + (FAT_START + 0)], ax
		mov	word ptr [bp + (FAT_START + 2)], dx

		;
		; Add the number of sectors used by the FATs.
		;

		mov	cl, byte ptr [bp + OFFSET_NOF]
	ADD_IN_NUMBER_OF_FAT_SECTORS:
		add	ax, word ptr [bp + (OFFSET_SPF32 + 0)]
		adc	dx, word ptr [bp + (OFFSET_SPF32 + 2)]
		loop	ADD_IN_NUMBER_OF_FAT_SECTORS

		;
		; Save the physical sector address for the
		; start of the data area on the disk.
		;

		mov	word ptr [bp + (DATA_START + 0)], ax
		mov	word ptr [bp + (DATA_START + 2)], dx


;
;
; Search for the romdos files in the root directory
;

		;
		; Get the cluster number for the start of
		; the root directory
		;

		mov	ax, word ptr [bp + (OFFSET_ROOTSTARTCLUSTER + 0)]
		mov	dx, word ptr [bp + (OFFSET_ROOTSTARTCLUSTER + 2)]

		;
		; Reset the function which reads sectors of
		; a fat chain
		;

		mov	byte ptr [bp + SECTORS_LEFT_IN_CLUSTER], 0ffh

		;
		; Set the address to read a sector of the
		; root directory into
		;

	READ_NEXT_SECTOR_OF_ROOT:

		mov	bx, ROOT_DIR_BUFFER_OFFSET

		;
		; Save the address of the buffer
		;

		push	bx

		;
		; Read sector of cluster chain
		;

		call	ReadSectorOfChain32

		;
		; Check if we have loaded all the sectors
		; in the cluster chain
		;

		jc	DISPLAY_NO_SYS_ON_DISK_JUMP_POINT

		;
		; Search the sector of the root directory
		; for the ROMDOS file
		;

		;
		; Set the buffer address for the search
		;

		pop	si

		;
		; Set the number of root directory entries to search
		;

		mov	bx, 16

		;
		; Set the size of the search
		;

	REPEAT_SEARCH:

		add	si, cx
		mov	cl, 20h

		;
		; Set the buffer address as the other search string
		;

		mov	di, PROGRAM_OFFSET + (offset ROMDOS_FILENAME - offset BOOT_SECTOR_START )

		;
		; Perform the search
		;

		rep	cmpsb

		;
		; Check if we found the string
		;

		cmp	cl, 14h

		;
		; Jump if we found the string
		;

		jbe	LOAD_ROMDOS

		;
		; Decrement the search counter
		;

		dec	bx

		;
		; Jump if we are not done searching
		;

		jnz	REPEAT_SEARCH

		;
		; Zero the "sectors to read" value, then
		; Load the next sector of the root directory
		;

      xor   cx, cx
		jmp	short READ_NEXT_SECTOR_OF_ROOT

		;
		; This is a jump to an error code that is to far
		; away for a near (conditional) jump.
		;

	DISPLAY_NO_SYS_ON_DISK_JUMP_POINT:

		jmp	DISPLAY_NO_SYS_ON_DISK

;
;
; Place the ROMDOS file in memory
;

		;
		; Get the starting cluster of the file from
		; the directory entry
		;

	LOAD_ROMDOS:

		mov	ax, word ptr [si + 0eh]
		mov	dx, word ptr [si + 08h]


		;
		; Restore the CX register back to zero.  We
		; try and keep this register zero so we can
		; compare agaist cl and cx in place of a zero
		; and so we can use the inc instruction to
		; perform an equivilent of mov cx, 1.
		;

		xor	cx, cx

		;
		; Set the address to place romdos at
		;

		les	bx, dword ptr [bp + OFFSET_LOAD_ADDR]

		;
		; Reset the function which reads sectors of
		; a fat chain
		;

		mov	byte ptr [bp + SECTORS_LEFT_IN_CLUSTER], 0ffh

		;
		; Read in a sector of the romdos file
		;

	READ_NEXT_SECTOR_OF_ROMDOS:

		call	ReadSectorOfChain32

		;
		; If we are not done then read in the next
		; sector of the file.
		;

		jnc	READ_NEXT_SECTOR_OF_ROMDOS


;
;
; Transfer control to ROMDOS
;

		;
		; Save the boot drive letter for romdos
		;
		; When ROM-DOS sees an FFFFH in the "segment" part
		; of INT 21H, it knows the boot drive is in the
		; "offset" part.
		;
		; Alternatly, romdos startup code could look directly
		; at the boot sector which is still at 0000:7c00 for
		; the bpb drive letter.
		;

		mov	dl, byte ptr [bp + OFFSET_DRV]
		mov	bx, INT21_VECTOR
		mov	word ptr [bx + 0], dx
		mov	word ptr [bx + 2], 0ffffh

		;
		; Load the old DBT pointer
		;

		mov	di, word ptr [bp + (OLD_DBT_ADDRESS + 0)]
		mov	es, word ptr [bp + (OLD_DBT_ADDRESS + 2)]

		;
		; Set the DBT vector with the old DBT pointer
		;

		mov	bx, DBT_VECTOR
		mov	word ptr [bx + 0], di
		mov	word ptr [bx + 2], es

		;
		; This is a far jump to the location ROMDOS was loaded
		;

	TRANSFER_CONTROL:

		jmp	dword ptr [bp + OFFSET_LOAD_ADDR]


;
;
; Load one sector of a cluster chain.
;
; This function calculates the physical sector number for a cluster.  It
; loads the first sector of the cluster and updates an internal counter
; for the number of sectors in a cluster.  Repeaded calls to this function
; yeilds the remaining sectors in the cluster.  When the function has read
; in all the sectors for a particular cluster, it loads the first sector in
; the next cluster in the cluster chain.  The function will return with the
; carry flag set if there are no more sectors to read.  The physical sector
; number is not stored internally.  This function expects that the physical
; sector number from the last call to be in the DX:AX registers.
;

ReadSectorOfChain32	proc	near

		;
		; Check if we are already reading in sectors
		; of a cluster chain
		;

		cmp	byte ptr [bp + SECTORS_LEFT_IN_CLUSTER], 0ffh
		jne	READ_NEXT_CLUSTER_IN_CHAIN

		;
		; Set the number of sectors per cluster in
		; the internal sector counter
		;

	RESET_INTERNAL_VARIABLES:

		push	cx
		mov	cl, byte ptr [bp + OFFSET_SPC]
		mov	byte ptr [bp + SECTORS_LEFT_IN_CLUSTER], cl
		pop	cx

		;
		; Save the cluster number
		;

		mov	word ptr [bp + (READING_CLUSTER + 0)], ax
		mov	word ptr [bp + (READING_CLUSTER + 2)], dx

		;
		; Convert the cluster number to a physical
		; address
		;

		call	ClusterToPhysicalSector32

		;
		; Check if we have read in all the sectors
		; this cluster
		;

	READ_NEXT_CLUSTER_IN_CHAIN:

		cmp	byte ptr [bp + SECTORS_LEFT_IN_CLUSTER], cl
		jne	READ_SECTOR_OF_CLUSTER

		;
		; Restore the cluster number
		;

		mov	ax, word ptr [bp + (READING_CLUSTER + 0)]
		mov	dx, word ptr [bp + (READING_CLUSTER + 2)]

		;
		; Get next cluster in the chain
		;

		call	LookUpNextCluster32

		;
		; Check if we are at the end of a chain
		;

		cmp	dx, word ptr [bp + (OFFSET_END_CLUSTER_CHAIN + 2)]
		jne	RESET_INTERNAL_VARIABLES
		cmp	ax, word ptr [bp + (OFFSET_END_CLUSTER_CHAIN + 0)]
		jb	RESET_INTERNAL_VARIABLES

		;
		; We are done reading all the sectors in the cluster
		; chain.  Let the caller no we are done reading and
		; return
		;

		stc
		ret

		;
		; Decreament the number of sectors remaining
		; in this cluster counter
		;

	READ_SECTOR_OF_CLUSTER:

		sub	byte ptr [bp + SECTORS_LEFT_IN_CLUSTER], 1

		;
		; Set the number of sectors to read
		;

		inc	cx

		;
		; Read the sector
		;

		call	ReadSector

		;
		; Check for an overflow in the buffer offset
		;

		or	bx, bx

		;
		; Jump if there is not an overflow in the buffer offset
		;

		jnz	NO_BUFFER_OFFSET_OVERFLOW

		;
		; Adjust the segment register to account for the new
		; offset.
		;

		mov	si, es
		add	si, 1000h
		mov	es, si

	NO_BUFFER_OFFSET_OVERFLOW:

		;
		; Set the return status and return
		;

		clc
		ret

ReadSectorOfChain32	endp


;
;
; Convert a cluster number into a physical sector address
;

ClusterToPhysicalSector32	proc	near

		;
		; Convert this to an offset into the data area
		;

		sub	ax, 2
		sbb	dx, 0
		mov	cl, byte ptr [bp + OFFSET_SPC]
		dec	cx
	CONTINUE_SHIFTING:
		shl	ax, 1
		rcl	dx, 1
		shr	cx, 1
		jnz	CONTINUE_SHIFTING

		;
		; Add in the physical sector address for the start
		; of the data area.
		;

		add	ax, word ptr [bp + (DATA_START + 0)]
		adc	dx, word ptr [bp + (DATA_START + 2)]

		;
		; We are done
		;

		ret

ClusterToPhysicalSector32	endp


;
;
; Lookup the next cluster value in a cluster chain
;

LookupNextCluster32	proc	near

		;
		; Save the current buffer(ES:BX) address
		;

		push	es
		push	bx

		;
		; Determine the sector of the FAT that contains
		; this cluster number
		;

		div	word ptr [bp + FAT_ENTRIES_PER_SECTOR]

		;
		; Save the index into this sector
		;

		mov	si, dx
		xor	dx, dx

		;
		; Add in the the physical sector number of the
		; start of the FAT
		;

		add	ax, word ptr [bp + (FAT_START + 0)]
		adc	dx, word ptr [bp + (FAT_START + 2)]

		;
		; Set the address of the FAT buffer
		;

		mov	bx, FAT_BUFFER_OFFSET
		push	ds
		pop	es

		;
		; Check if we already have this sector loaded
		;

		cmp	word ptr [bp + (OFFSET_CURRENT_FAT_SECTOR + 0)], ax
		jne	READ_FAT_SECTOR
		cmp	word ptr [bp + (OFFSET_CURRENT_FAT_SECTOR + 2)], dx
		je	LOOKUP_INDEXED_ENTRY

		;
		; Save this sector number
		;

	READ_FAT_SECTOR:

		mov	word ptr [bp + (OFFSET_CURRENT_FAT_SECTOR + 0)], ax
		mov	word ptr [bp + (OFFSET_CURRENT_FAT_SECTOR + 2)], dx

		;
		; Set the number of sectors to read
		;

		inc	cx

		;
		; Read in the FAT sector
		;

		call	ReadSector
		sub	bh, 2

		;
		; Lookup the next cluster using the index
		; into this sector
		;

	LOOKUP_INDEXED_ENTRY:

		shl	si, 2
		mov	ax, word ptr [bx + (si + 0)]
		mov	dx, word ptr [bx + (si + 2)]

		;
		; Restore the original buffer (ES:BX) address
		;

		pop	bx
	       	pop	es

		;
		; The cluster number is being returned in EAX
		;

		ret

LookupNextCluster32	endp


;
;
; Boot sector marker
;

		org	05feh

		; Boot sector marker
		;

		dw	0aa55h


;
;
; End of the boot program
;

	;
	;  This label is used by SYS.COM and FORMAT.COM to locate
	;  the end of the boot sector.
	;

	public	_rgucBootSector32End
	_rgucBootSector32End:


_DATA	ENDS

		END
