//
//   $Id: TREE.H 1.4 2002/10/16 22:04:26Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  TREE.H
//
//  Copyright (c) 2000-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  05-05-2000  bt  Created
//


//
//
#define ERR_NONE					0
#define ERR_NO_FILES				1
#define ERR_INVALID_PATH		2
#define ERR_USAGE					3
#define ERR_INVALID_SWITCH		4


//  Indexes into the boolean command line switches array
//
#define HIDE_SIGNON			0
#define ASCII_OUTPUT			1
#define SHOW_FILES			2
#define MAX_BOOLEAN_SWITCHES		3


//  Macros for boolean command line switches
//
#define DoHideSignon()			(fSwitches[HIDE_SIGNON]      != 0)
#define DoAsciiOutput()			(fSwitches[ASCII_OUTPUT]     != 0)
#define DoShowFiles()			(fSwitches[SHOW_FILES]       != 0)


//  Indexes into the (local) graphics character set
//
#define LINE_UD		0
#define LINE_UDR		1
#define LINE_LR		2
#define LINE_UR		3
#define LINE_WHITE	4
#define LINE_TERM		5
#define LINE_COUNT	6


//  Spacing between directories in the graphics display
//
#define LINE_INDENT	4


//  This structure is passed to DOS to retrieve the
//  serial number and other disk information
//
typedef struct DiskInfo DISK_INFO;
typedef DISK_INFO * pDISK_INFO;
typedef DISK_INFO far * lpDISK_INFO;
struct DiskInfo{
	unsigned uInfoLevel;
	ulong    ulSerialNumber;
	char		cVolumeLabel[11];
	char		cFatTypeString[8];
};
