//
//   $Id: UTILERR.C 1.11 2002/12/10 16:41:44Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/**********************************************************

	Error message and display for all ROM-DOS utilities.

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
	Datalight Confidential and Proprietary

**********************************************************/

//#include <stdio.h>
//#include <stdarg.h>
//#include <stdlib.h>
#include "datalght.h"
#include "stdc.h"

#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"

#include "xcopy.h"


extern unsigned uFileCount;

void error(int msg,...)
{
	extern char *msgs[];
   extern int iOriginalDriveNumber;

	uchar ucExitCode = 4;
	extern char file_count_str[];
	extern bool fIsLFNWorld;
	va_list arg_ptr;
	unsigned uDevice;


	if( fIsLFNWorld )
	{
		uDevice = STDOUT;
		if( msg == ERR_ACCESSDENIED )
		{
			msg = ERR_LFNACCESSDENIED;
			ucExitCode = 5;
		}
		else if( msg == ERR_INVALIDSWITCH )
		{
			msg = ERR_LFNINVALIDSWITCH;
		}
	}
	else
	{
		uDevice = STDERR;
	}

	va_start(arg_ptr, msg);
	vfprintf(uDevice, msgs[msg], arg_ptr);
	fprintf(uDevice, "\n");
	fprintf(STDOUT, file_count_str, uFileCount );

   // Only reset the current drive if the value was initialized.
   //
   if( iOriginalDriveNumber != 0xFF )
   {
      dlSetCurrentDrive( iOriginalDriveNumber );
   }

	exit(ucExitCode);
}


void ErrorMsg(int msg, int errCode)
{
	extern char *msgs[];

	printf(msgs[msg]);
   printf("\n");
	exit(errCode);
}


void msg(int msg,...)
{
	extern char *msgs[];

	va_list arg_ptr;
	va_start(arg_ptr, msg);
	vfprintf(STDOUT, msgs[msg], arg_ptr);
	fprintf(STDOUT, "\n");
}
