//
//   $Id: XCOPY.H 1.12 2002/12/17 16:08:40Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*--------------------------------------------------------

   XCOPY.H  created 03/04/99  by John Burnham

	Copyright (c) 1999-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This module contains defines and structures for XCOPY

---------------------------------------------------------*/

#define ENABLE_DIRECT_MEMSTO_COPIES			TRUE

#define CHANGE_DIRECTORY_TO_COPY          FALSE

#define CVT_PARA( bytes ) ((bytes+0xf) / 0x10)

#define FP_DIST(lpszEnd,lpszStart) (FP_OFF(lpszEnd) - FP_OFF(lpszStart))

typedef struct FileRecord FILERECORD;
struct FileRecord
{
	ulong		next;							// 00h next FileRecord on this volume
	unsigned	sig;							// 04h signature
	uchar		attr;							// 06h file attr
	unsigned	date;							// 07h date file was last modified
	unsigned	time;							// 09h time file was last modified
	ulong		size;							// 0bh total size of file
	ulong		startOffset;				// 0fh starting offset in file
	unsigned	uSrcNameSize;				// 13h size of filename after header
	unsigned	uDstNameSize;				// 15h size of filename after header
	uchar		reserved[3];				// 17h
};


// amount of memory required for disk I/O storage
#if !ENABLE_DIRECT_MEMSTO_COPIES
#define DISKIO_BUFFSIZE ((unsigned)32*1024)
#else
#define DISKIO_BUFFSIZE ((unsigned)(65536L - 512))
#endif

#define MAXDEEP 25
#define FILE_RECORD_SIG		0xBABA	// BABA ROM-DOS!
#define MIN_OUT_SIZE		512
#define MIN_RECORD_SIZE		(sizeof(FILERECORD) + (2 * LFN_MAX_PATH) + MIN_OUT_SIZE)
#define MORE_DATA			0x11

// Error messages - defined in "..\..\include\dosmsg.c"

#define ERR_FILENOTFOUND         1
#define ERR_CANNOTCREATE         2
#define ERR_IOERROR              3
#define ERR_INVALIDSOURCE        4
#define ERR_INVALIDDESTINATION   5
#define ERR_CYCLICCOPY           6
#define ERR_DISKSPACE            7
#define ERR_ACCESSDENIED         8
#define ERR_LFNACCESSDENIED      9
#define ERR_ERRORREADINGFILE     10
#define ERR_INSUFFICENTMEMORY    11
#define ERR_TORESERVEDDEVICE     12
#define ERR_FROMRESERVEDDEVICE   13
#define ERR_INVALIDPARAMETERS    14
#define ERR_PATHTOODEEP          15
#define ERR_INVALIDSWITCH        16
#define ERR_LFNINVALIDSWITCH     17
#define ERR_INTERNALERROR        18
#define ERR_COPIEDTOITSELF			19
#define ERR_INVALIDDATE				20
#define ERR_INVALIDDRIVE			21
