;
;   $Id: NETBIOS.ASM 1.7 2003/07/23 17:08:31Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
; NETBIOS.ASM
; Copyright (c) 2001 Datalight, Inc.
; Portions copyright (c) GPvNO 2001
; All Rights Reserved
; Datalight Confidential and Proprietary
;
; Revision History
; 07/13/2001 gvn Fix /option=, broadcast file
; 05/14/2001 gvn Add /q for no startup messages
; 04/30/2001 jmb used Datalight copyright info.
; 04/30/2001 jmb created header
;
;

;TRACE_DUMP		equ	1	; comment out for no trace
;LOAD_HIGH		equ	1	; comment out for no hiload
;CONFIG_PRINT	equ	1	; comment out for no print
;TEST				equ	1	; comment out for test version

ifndef	TEST
NBVEC			equ	05ch
else
NBVEC			equ	05dh
endif

ncb				struc
ncb_command		db	?		; 0
ncb_retcode		db	?		; 1
ncb_lsn			db	?		; 2
ncb_num			db	?		; 3
ncb_buffer		dd	?		; 4
ncb_length		dw	?		; 8
ncb_callname 	db	16d dup (?)	; a
ncb_name			db	16d dup (?)	; 1a
ncb_rto			db	?		; 2a
ncb_sto			db	?		; 2b
ncb_post			dd	?		; 2c
ncb_lana_num	db	?		; 30
ncb_cmd_cplt	db	?		; 31
ncb_reserve		db	14d dup (?)	; 32
					ends
ncb_length2		equ	ncb_callname   	; a
ncb_buffer2		equ	ncb_length2 + 2   ; c

cb					struc			; control block structure
cb_next			dw	?		; 0 pointer to next cb
cb_prev			dw	?		; 2 pointer to previous cb
cb_ncb_seg0		dw	?		; 4 ncb segment
cb_resvd1		dw	?		; 6
cb_func_ptr		dw	?		; 8 pointer to function table
cb_ncb_off		dw	?		; a ncb offset
cb_ncb_seg		dw	?		; c ncb segment
cb_id				dw	?		; e cb id
cb_comstat		db	?		; 10 command/status
cb_ptr			dw	?		; 11 session/cache pointer
cb_timer			db	?		; 13 timer count
cb_retry			db	?		; 14 retry counter
cb_stat			db	?		; 15 status
					ends
;cb_stat bits
C_TIMING 		equ	01h		;
C1					equ	02h
C2					equ	04h
C3					equ	08h
C4					equ	10h
C_NAMEWAIT		equ	20h
C6					equ	40h		;not used?
C_GROUPNAME		equ	80h

que_element		struc			; general queue element structure
next				dw	?
prev				dw	?
					ends

cache_struc		struc			; cache buffer structure
c_name		db	16d dup (?)	;00 name
c_type		db	?				;10 type
c_ipad		db 4 dup (?)	;11 IP address
c_age			dw ?				;15 age: 0 unused, ffff permanent
					ends

name_struc		struc			; name buffer structure
nm_name		db	16d dup (?)	;name
nm_type1		db	?				;10 type
nm_type2		db	?				;11 type
nm_12			db	?				;12
nm_13			dw	?				;13
nm_15			dw	?				;15
nm_17			dw	?				;17
nm_19			dw	?				;19
nm_1bq		dw	?				;1b Q ptr
nm_1d			dw	?				;1d
nm_1fq		dw	?				;1f Q ptr
nm_21       dw	?				;21
									;size = 23h
					ends

session_struc	struc			; session buffer structure
s_00		      dw	?			;00
s_02				dw	?			;02
s_ncbseg			dw	?			;04
s_cb				dw	?			;06 cb pointer
s_state			dw	? 			;08 session state
s_nd				dw ?  		;0a network descriptor
s_rto				db	?			;0c receive timeout
s_sto				db	?			;0d send timeout
s_rcvq			dw ?			;0e receive Q ptr
s_10				dw	?			;10
s_12				dw	?			;12
s_14				db	?			;14
s_15				dw	?			;15
s_listenq		dw	?			;17 listen Q ptr
s_19				dw	?			;19
s_1b				db	?			;1b
s_1c				db	?			;1c
s_1d				dw	?			;1d
s_sendq			dw	?			;1f send Q ptr
s_21				db	?			;21
s_22				db	?        ;22
s_23				dw	?			;23
s_25				db 6 dup (?);25
s_retry			db	?			;2b retry counter
s_2c				db 4 dup (?);2c
s_rnmptr			dw	?			;30 remote name ptr
									;size = 32h
					ends
;s_state bits

B0					equ	0001h
B1					equ	0002h
S_WR1				equ	0004h
S_WR2				equ	0008h
B4					equ	0010h
S_CLOSED			equ	0020h	;session closed
S_RCVD			equ	0040h	;session data has been received
B7					equ	0080h	;unused?
B8					equ	0100h
B9					equ	0200h
B10				equ	0400h
B11				equ	0800h
B12				equ	1000h	;unused?
S_HUP				equ	2000h	;hangup pending
S_SENT			equ	4000h	;session data has been sent
S_FREE			equ	8000h	;session is free (unused)

psp_savint24	equ	00012h 		; saved int 24 vector
psp_envir		equ	0002ch 		; environment segmnt-DOS2.0

;RFC1002 constants

NAME_SRVC_UDP_P	equ	137d
DGM_SRVC_UDP_P		equ	138d
SSN_SRVC_TCP_P		equ	139d

;API error codes

NO_ERR					equ	0	; No error
ERR_IN_USE				equ	1	; A connection already exists
ERR_DOS					equ	2	; A DOS error occured
ERR_NO_MEM				equ	3	; No memory to perform function
ERR_NOT_NET_CONN		equ	4	; Connection does not exist
ERR_ILLEGAL_OP			equ	5	; Protocol or mode not supported
ERR_NO_HOST				equ	7	; No host address specified
ERR_TIMEOUT				equ	13d	; The function timed out
ERR_HOST_UNKNOWN		equ	14d	; Unknown host has been specified
ERR_BAD_ARG				equ	18d	; Bad arguments
ERR_EOF					equ	19d	; The connection has been closed by peer
ERR_RESET				equ	20d	; The connection has been reset by peer
ERR_WOULD_BLOCK		equ	21d	; Operation would block
ERR_UNBOUND				equ	22d	; The descriptor has not been assigned yet
ERR_NO_SOCKET			equ	23d	; No descriptor is available
ERR_BAD_SYS_CALL		equ	24d	; Bad parameter in call
ERR_NOT_ESTAB			equ	26d	; The connection has not been established
ERR_RE_ENTRY			equ	27d	; The kernel is in use, try again later
ERR_TERMINATING		equ	29d	; Kernel unloading

TAB			equ	9
CR				equ	0dh
LF				equ	0ah

J	macro	where
		dw		(where - $ - 2) and 0ffh
		endm

F	equ	dw	offset
W	equ	dw	0

public		nbmain

.radix 16
cseg		segment BYTE PUBLIC
		assume cs:cseg,ds:cseg,es:cseg,ss:cseg
		org	100h
nbmain		proc near
		mov	sp,offset InitStack
		retn
nbmain		endp

;-------------------------------------
TraceFlag		db	00
CBQue				dw	00
					dw	offset CBQue

CBCompletion	dw	00
					dw	offset CBCompletion

FreeCBs			dw	00
					dw	offset FreeCBs

RcvBcDgQue		dw	00
					dw	offset RcvBcDgQue

RcvDgQue			dw	00
					dw	offset RcvDgQue

RcvAnyQue		dw	00
					dw	offset RcvAnyQue

NBNamesSize	dw	00
NCB_Buf		dw	00
SesBuf1		dw	00
SesBuf		dw	00
StackBot1	dw	00
DataSegm		dw	00
lana			db	00
NetIOBuf		dw	offset IndirectOff
CacheBuf		dw	00
BCNameBuf1	dw	00
NbCache		dw	0a
Count2		db	02
Cnt2			db	02
NameRetries	db	02
NameNd		dw	00
Scope			dw	00,00,00,00
				dw	00,00,00,00
				dw	00,00
				db	00
ScopeLen		db	01
DomName		db	24d dup (00h)
DomNameLen	db	00
BCNameBuf2	dw	00
NCBsBuf1		dw	00
BCNameCount	dw	00
NbNCBs		dw	18
NbNCBs1		dw	18
NumSes1		dw	10
TimeOut		db	0ff
DgramNd		dw	00
Count4		db	04
Retry2		db	02
Count30		db	1e
;-----------------------------------------------------
KernelAPI	proc near
VecNum		equ	$+01h
				int	61h
				retn
KernelAPI	endp
InetAPI		proc near
VecNum1		equ	$+01h
				int	7fh
				retn
InetAPI		endp
;-----------------------------------------------------
ReleaseCB	proc near
		push	di
		push	cx
		push	es
		push	ds
		pop	es
		mov	di,si
		add	di,04
		mov	cx,0012h
		xor	ax,ax
		cld
		rep	stosb
		cmp	si,word ptr cs:NCB_Buf
		jb		CorruptedNCB
		cmp	di,word ptr cs:SesBuf1
		jna	NCBinRange
CorruptedNCB:
		mov	cl,02
		call	near ptr HaltSystem
NCBinRange:
		mov	bp,offset FreeCBs
		call	near ptr MoveToQue
		inc	word ptr cs:FreeCBCount
		pop	es
		pop	cx
		pop	di
		retn
;-----------------------------------------------------
CBID		dw	00
;-----------------------------------------------------
ReleaseCB	endp

GetFreeCB	proc near		; get a control block in SI
		mov	bp,offset FreeCBs
		call	near ptr DeQue
		jne	HaveCB
		push	si
		mov	si,offset NoFreeCBs
		call	near ptr StringOut
		pop	si
		stc
		jmp	short GetCBExit
HaveCB:
		inc	word ptr cs:CBID
		je		HaveCB
		dec	word ptr cs:FreeCBCount
		mov	ax,word ptr cs:CBID
		mov	word ptr [si].cb_id,ax
		clc
GetCBExit:
		retn
GetFreeCB	endp

;-----------------------------------------------------
NoFreeCBs	db	0a,0dh
				db	'NETBIOS - Out of resources!'
				db	00
;-----------------------------------------------------

SendDgrmA:
		call	near ptr CheckBuf
		jb		SendDgrmAExit
		xor	cx,cx
		or		cl,byte ptr ds:ScopeLen
		shl	cx,1
		add	cx,50h
		add	ax,cx
		cmp	word ptr ds:NetReadLen,ax
SendDgrmAExit:
		retn
;-----------------------------------------------------
RcvDgrmB:
		mov	bp,offset RcvDgQue
		cmp	byte ptr es:[bx].ncb_num,0ffh
		je		RcvDgrmB2
		call	near ptr GetNamePtr
		jb		RcvDgrmBExit
		lea	bp,word ptr [di+1bh]
		mov	ax,1719h
		mov	cx,1800h
		and	cx,word ptr [di+10h]
		je		RcvDgrmB2
		test	ch,08
		jne	RcvDgrmB1
		xchg	ah,al
RcvDgrmB1:
		mov	byte ptr [si].cb_comstat,al
		stc
		jmp	short RcvDgrmBExit
RcvBcDgmB:
		mov	bp,offset RcvBcDgQue
		cmp	byte ptr es:[bx].ncb_num,0ffh
		je		RcvDgrmB2
		call	near ptr GetNamePtr
		jb		RcvDgrmBExit
RcvDgrmB2:
		call	near ptr MoveToQue
		xor	ax,ax
RcvDgrmBExit:	retn
;-----------------------------------------------------
Template1	db	00,02
				db	2d dup (00h)
IPAdd1		db	00,00,00,00,00,00
				db	00,00,00,00
Star1			db	'*'
;-----------------------------------------------------
SendBcDgmD:
		mov	al,12h
		or		byte ptr [si].cb_stat,C_GROUPNAME
		call	near ptr BuildHdrWName
		mov	si,offset Star1
		jmp	short SendBcDgm2
SendBcDgmA:
		mov	ax,1110h
		test	byte ptr [si].cb_stat,C_GROUPNAME
		je		SendBcDgm1
		xchg	ah,al
SendBcDgm1:
		call	near ptr BuildHdrWName
		lds	si,dword ptr [bp+0ah]
		add	si,0ah
SendBcDgm2:
		call	near ptr ExpandName
		lds	si,dword ptr [bp+0ah]
		mov	cx,word ptr [si].s_state
		lds	si,dword ptr [si+04]
		rep	movsb
		push	cs
		pop	ds
		mov	cx,word ptr ds:NetIOBuf
		sub	di,cx
		xchg	cx,di
		mov	ax,0fff2h
		add	ax,cx
		xchg	ah,al
		mov	word ptr [di+0ah],ax
		mov	si,bp
		mov	ax,word ptr ds:DgramNd
		mov	word ptr [si].cb_ptr,ax
		mov	di,offset AddrStrFSock
		mov	ax,DGM_SRVC_UDP_P
		stosw
		stosw
		mov	byte ptr [si].cb_comstat,00
		test	byte ptr [si].cb_stat,C_GROUPNAME
		jne	SendBcDgm3
		jmp	near ptr NetWriteto
SendBcDgm3:
		push	cx
		call	near ptr NetWritetoBC
		pop	cx
		push	si
		call	near ptr GetFreeCB
		jb		SendBcDgmExit
		mov	word ptr [si].cb_ptr,bx
		mov	bp,word ptr ds:NetIOBuf
		call	near ptr DgrmRcv0
		call	near ptr ReleaseCB
SendBcDgmExit:
		pop	si
		retn

BuildHdrWName	proc near
		mov	bp,offset Template1
		mov	byte ptr [bp+00],al
		mov	ax,word ptr [si+0eh]
		xchg	ah,al
		mov	word ptr [bp+02],ax
		mov	di,word ptr ds:NetIOBuf
		push	cs
		pop	es
		xchg	bp,si
		mov	cx,000eh
		rep	movsb
		mov	si,bx
		jmp	near ptr ExpandName
BuildHdrWName	endp

DgrmRcv		proc near
		call	near ptr NetRead
		jb	DgrmRcv1

DgrmRcv0:
		mov	dx,cx
		test	byte ptr [bp+01],02
		je		DgrmRcv
		push	si
		mov	al,byte ptr [bp+00]
		or		al,80h
		mov	byte ptr [si].cb_comstat,al
		xor	ax,ax
		mov	word ptr [si].cb_func_ptr,ax
		call	near ptr Execute
		pop	si
		jmp	short DgrmRcv
DgrmRcv1:
		xor	ax,ax
		mov	word ptr ds:DgrmRcvData,ax
		mov	word ptr [si+0eh],ax
		retn
DgrmRcv		endp

CheckReceivedName		proc near
		push	si
		push	bx
		mov	di,word ptr ds:NetIOBuf
		mov	ax,word ptr [di+0ah]
		xchg	ah,al
		mov	word ptr [di+0ah],ax
		mov	di,bx
		call	near ptr ExtractName4
		pop	di
		xor	ax,ax
		cmp	byte ptr [di],'*'
		mov	bp,offset RcvBcDgQue
		je		CheckReceivedName2
		call	near ptr GetNameNumA
		jb		CheckReceivedName6
		add	bp,1bh
CheckReceivedName1:
		call	near ptr DeQue
		jne	CheckReceivedName3
		mov	bp,offset RcvDgQue
CheckReceivedName2:
		call	near ptr DeQue
		jne	CheckReceivedName3
		jmp	near ptr CheckReceivedName7
CheckReceivedName3:
		push	ax
		push	bp
		mov	bp,bx
		les	bx,dword ptr [si].cb_ncb_off
		mov	byte ptr es:[bx].ncb_num,al
		push	dx
		push	si
		mov	al,00
		mov	si,word ptr ds:NetIOBuf
		mov	cx,dx
		sub	cx,0eh
		cmp	cx,word ptr [si+0ah]
		jnb	CheckReceivedName4
		mov	al,06
CheckReceivedName4:
		mov	cx,bp
		sub	cx,si
		sub	dx,cx
		push	dx
		add	si,0eh
		mov	cx,0010h
		lea	di,word ptr [bx].ncb_callname
		rep	movsb
		mov	si,bp
		pop	cx
		mov	di,word ptr es:[bx].ncb_length
		cmp	cx,di
		jna	CheckReceivedName5
		mov	al,06
		mov	cx,di
CheckReceivedName5:
		mov	word ptr es:[bx].ncb_length,cx
		les	di,dword ptr es:[bx].ncb_buffer
		rep	movsb
		pop	si
		mov	byte ptr [si].cb_comstat,al
		push	bp
		xor	ax,ax
		call	near ptr Execute
		pop	bx
		pop	dx
		pop	bp
		pop	ax
		cmp	bp,offset RcvBcDgQue
		je		CheckReceivedName2
		jmp	short CheckReceivedName1
CheckReceivedName6:
		push	cs
		pop	es
		mov	si,word ptr ds:NetIOBuf
		cmp	byte ptr [si],10h
		jne	CheckReceivedName7
		push	si
		mov	ax,8213h
		mov	byte ptr [si],al
		add	si,04
		mov	di,offset AddrStrFAddr
		movsw
		movsw
		movsw
		mov	di,si
		xchg	ah,al
		stosb
		pop	cx
		xchg	cx,di
		sub	cx,di
		pop	si
		jmp	near ptr NetWriteto
CheckReceivedName7:
		pop	si
		retn
CheckReceivedName		endp

DgramListen	proc near
		mov	cx,DGM_SRVC_UDP_P
		mov	word ptr ds:AddrStrLSock,cx
		mov	di,004ah
		push	cx
		call	near ptr UDPListen
		pop	cx
		jb		DgrLisExit
		mov	word ptr ds:DgramNd,bx
		mov	si,offset IPAddress
		mov	di,offset IPAdd1
		movsw
		movsw
		mov	ax,cx
		xchg	ah,al
		stosw
DgrLisExit:	retn
;-----------------------------------------------------
		db	00
;-----------------------------------------------------
DgramListen	endp

SesStatFill	proc near
		les	bx,dword ptr [si].cb_ncb_off
		mov	byte ptr [si].cb_comstat,15h
		lea	di,word ptr [bx].ncb_name
		mov	ax,00ffh
		xor	bp,bp
		cmp	byte ptr es:[di],'*'
		je		SesStatFillAll
		call	near ptr GetNameNumA
		jnb	SesStatFill1
		jmp	near ptr SesStatFillExit
SesStatFill1:
		xor	ah,ah
SesStatFillAll:
		push	si
		mov	dx,word ptr es:[bx].ncb_length
		les	di,dword ptr es:[bx].ncb_buffer
		mov	byte ptr [si].cb_comstat,ah
		mov	bx,di
		stosb				;NameNumber being reported (ff for all)
		mov	al,ah
		stosb      		;number of sessions with this name
		push	bp
		mov	cx,offset GetQlen
		mov	bp,offset RcvBcDgQue
		call	cx
		xchg	ah,al
		mov	bp,offset RcvDgQue
		call	cx
		add	al,ah
		stosb       	;number of RcvDgm and RcvBCDgm calls outstanding
		mov	bp,offset RcvAnyQue
		call	cx
		stosb				;number of RcvAny calls outstanding
		mov	si,offset NamesBuf
SesStatFillL1:
		lea	bp,word ptr [si].nm_1bq
		call	cx
		xchg	ah,al
		lea	bp,word ptr [si].s_sendq
		call	cx
		add	byte ptr es:[bx].ncb_num,al
		add	byte ptr es:[bx].ncb_lsn,ah
		lea	si,word ptr [si+23h]
		cmp	si,word ptr ds:CacheBuf
		jb		SesStatFillL1
		pop	bp
		sub	dx,04
		mov	si,word ptr ds:SesBuf
SesStatFillL2:
		test	word ptr [si].s_state,S_FREE	;8000h
		jne	SesStatFill10
		push	dx
		push	bx
		push	bp
		xchg	di,si
		call	near ptr GetSesName
		xchg	si,di
		pop	bp
		or		bp,bp
		je		SesStatFill7
		cmp	bx,bp
		je		SesStatFill7
		pop	bx
		pop	dx
		jmp	short SesStatFill10
SesStatFill7:
		pop	dx
		xchg	bx,dx
		inc	byte ptr es:[bx].ncb_retcode
		xchg	ax,dx
		pop	dx
		sub	dx,24h
		jl		SesStatFill10
		push	cx
		push	si
		xchg	ax,si
		mov	cl,32h
		sub	ax,word ptr ds:SesBuf
		div	cl
		inc	al
		stosb					;local session number
		pop	ax
		xchg	ax,si
		push	ax
		call	near ptr GetSesState
		stosb					;session state
		pop	ax
		xchg	ax,si
		mov	cx,0010h
		push	cx
		rep	movsb			;local name
		pop	cx
		xor	si,si
		xchg	ax,si
		or		ax,word ptr [si].s_rnmptr
		je		SesStatFill8
		xchg	ax,si
		rep	movsb			;remote name
		xchg	ax,si
		jmp	short SesStatFill9
SesStatFill8:
		rep	stosb			;remote name empty
SesStatFill9:
		pop	cx
		push	bp
		lea	bp,word ptr [si].s_rcvq
		call	cx
		stosb          	;receive commands outstanding
		lea	bp,word ptr [si].s_sendq
		call	cx
		stosb					;send commands outstanding
		pop	bp
SesStatFill10:
		lea	si,word ptr [si+32h]
		cmp	si,word ptr ds:StackBot1
		jb		SesStatFillL2
		pop	si
		sub	di,bx
		les	bx,dword ptr [si].cb_ncb_off
		mov	word ptr es:[bx].ncb_length,di
		or		dx,dx
		jge	SesStatFillExit
		mov	byte ptr [si].cb_comstat,06
SesStatFillExit:
		retn
SesStatFill	endp

; Q length in AL
GetQlen		proc near
		push	bp
		xor	al,al
GetQlen1:
		mov	bp,word ptr [bp].next
		or		bp,bp
		je		GetQlenExit
		inc	al
		jmp	short GetQlen1
GetQlenExit:
		pop	bp
		retn
GetQlen		endp

GetSesState:						;si has session pointer, return in al
		mov	ax,0203h
		mov	cx,S_HUP+B8+S_CLOSED+B4	;2130h
		and	cx,word ptr [si].s_state
		jz		GetSesStateExit	;session established (active) - 3
		xchg	al,ah
		test	cl,S_CLOSED		;20h
		jnz	GetSesStateHangUp	;hangup/ended abnormally - 4,5,6
		test	byte ptr [si].s_state,B0+B1	;03h
		jz		GetSesStateExit	;call pending - 2
		mov	al,01					;listen pending - 1
		jmp	short GetSesStateExit
GetSesStateHangUp:
		mov	ax,0004h
		test	cx,S_HUP	;2000h
		jnz	GetSesStateExit	;hangup pending - 4
		mov	ax,0605h
		or		ch,ch
		jz		GetSesStateExit	;hangup complete - 5
		cmp	byte ptr [si].s_rto,0ah
		je		GetSesStateExit	;hangup complete - 5
		xchg	ah,al					;aborted - 6
GetSesStateExit:
		retn
;-----------------------------------------------------
CopyLocalAdapStatus:
		mov	dx,word ptr es:[bx].ncb_length
		les	di,dword ptr es:[bx].ncb_buffer
		mov	byte ptr [si].cb_comstat,06
		push	si
		mov	cx,60d
		sub	dx,cx
		mov	si,offset AdaptorStatus
		push	di
		rep	movsb
		pop	si
		mov	ax,word ptr ds:NbNCBs
		mov	word ptr es:[si+2ah],ax
		mov	ax,word ptr ds:NumSes1
		mov	word ptr es:[si+34h],ax
		dec	word ptr es:[si+32h]
		mov	bx,word ptr ds:NumNBNames
		dec	bx
		xchg	cx,bx
		mov	si,offset LocalNamesBuf
CopyLocalName:
		xchg	bx,cx
		test	word ptr [si+10h],0400h
		je		CopyLocalSkip
		mov	cx,0011h
		dec	dx			;18 bytes per name
		sub	dx,cx
		jb		CopyLocalDone
		push	si
		rep	movsb
		lodsb
		call	near ptr SetNameFlags
		stosb
		pop	si
CopyLocalSkip:
		lea	si,word ptr [si+23h]
		xchg	bx,cx
		loop	CopyLocalName
CopyLocalDone:
		pop	si
		jb		CopyLocalExit
		les	bx,dword ptr [si].cb_ncb_off
		sub	word ptr es:[bx].ncb_length,dx
		mov	byte ptr [si].cb_comstat,00
		xor	ax,ax
CopyLocalExit:
		retn
;-----------------------------------------------------
NameFE:
		mov	bp,si
		and	byte ptr [si].cb_stat,not C_NAMEWAIT
		cmp	byte ptr [si].cb_comstat,00
		stc
		je		NameFE1
		jmp	near ptr NameFE13
NameFE1:
		les	bx,dword ptr [si].cb_ncb_off
		mov	si,word ptr ds:NetIOBuf
		mov	cx,si
		add	si,0ch
		xor	ax,ax
NameFE2:
		lodsb
		or		al,al
		je		NameFE3
		add	si,ax
		cmp	si,offset IPAddress
		jb		NameFE2
NameFE3:
		add	si,08
		lodsw
		xchg	ah,al
		sub	cx,si
		add	cx,dx
		xor	dl,dl
		cmp	cx,ax
		jnb	NameFE4
		mov	dl,06
NameFE4:
		mov	ax,word ptr es:[bx].ncb_length
		add	cx,0dh
		cmp	ax,cx
		jnb	NameFE5
		xchg	ax,cx
		mov	dl,06
NameFE5:
		mov	word ptr es:[bx].ncb_length,cx
		les	di,dword ptr es:[bx].ncb_buffer
		lodsb
		mov	ah,12h
		mul	ah
		push	di
		push	si
		push	ax
		add	si,ax
		cmp	si,offset K1
		jna	NameFE6
		mov	dl,40h
		stc
		jmp	short NameFE7
NameFE6:
		sub	cx,3ch
		push	cx
		mov	cx,0020h
		rep	movsb
		add	di,08
		mov	cl,06
		rep	movsb
		add	di,04
		mov	cl,08
		rep	movsb
		pop	cx
NameFE7:
		pop	ax
		pop	si
		jb	NameFE11
		dec	si
		inc	ax
		cmp	ax,cx
		jnb	NameFE8
		xchg	ax,cx
NameFE8:
		xor	ax,ax
		stosb
		lodsb
		stosb
		xchg	ax,cx
NameFE9:
		sub	ax,12h
		jb	NameFE10
		push	ax
		push	cx
		mov	cl,10h
		rep	movsb
		lodsw
		call	near ptr SetNameFlags
		xchg	ah,al
		stosw
		pop	cx
		pop	ax
		loop	NameFE9
NameFE10:
		clc
NameFE11:
		pop	di
		jb		NameFE12
		mov	si,offset Table1
		push	dx
		call	near ptr CopyA
		pop	dx
NameFE12:
		mov	byte ptr [bp+10h],dl
NameFE13:
		mov	si,bp
		retn

SetNameFlags		proc near
		test	al,10h
		jz		SetNameFlags_1
		or		al,01
SetNameFlags_1:
		test	al,08
		jz		SetNameFlagsExit
		or		al,02
SetNameFlagsExit:
		and	al,87h
		retn
;-----------------------------------------------------
CheckAdapStatBuf:
		mov	ax,60d
		jmp	short CheckSesStatBuf1
CheckSesStatBuf:
		mov	ax,0004h
CheckSesStatBuf1:
		les	bx,dword ptr [si].cb_ncb_off
		mov	byte ptr [si].cb_comstat,01
		mov	dx,word ptr es:[bx].ncb_length
		cmp	dx,ax
		jb		CheckSesStatBufExit
		les	di,dword ptr es:[bx].ncb_buffer
		mov	ax,es
		or		ax,ax
		stc
		je		CheckSesStatBufExit
		mov	ax,di
		add	ax,dx
CheckSesStatBufExit:
		retn
;-----------------------------------------------------
Table1		dw	3e70,0ffe0,00
Table2		dw	0ff,0ffe0,00
;-----------------------------------------------------
SetNameFlags		endp

CopyA		proc near
		lodsw
		push	ax
		lodsw
		push	ax
		lodsw
		mov	dx,ax
		push	di
		shr	cx,1
		push	cx
		shr	cx,1
		mov	si,di
		push	es
		pop	ds
CopyA_1:
		lodsw
		shr	dx,1
		jnb	CopyA_2
		xchg	ax,word ptr [si]
CopyA_2:
		stosw
		lodsw
		mov	di,si
		loop	CopyA_1
		pop	cx
		pop	di
		pop	dx
		mov	si,di
		sub	cl,10h
		push	cx
		mov	cl,10h
		call	near ptr CopyB
		pop	cx
		pop	dx
CopyA		endp

CopyB:
		push	es
		pop	ds
CopyB_1:
		lodsw
		shr	dx,1
		jnb	CopyB_2
		xchg	ah,al
CopyB_2:
		stosw
		loop	CopyB_1
		push	cs
		pop	ds
		retn
;-----------------------------------------------------
SendNamePacketA:
		call	near ptr SendNamePacket0
		push	si
		lea	di,word ptr [di-10h]
		mov	word ptr [di],2100h
		lea	di,word ptr [di+08]
		push	di
		mov	ax,002fh
		stosw
		add	ax,di
		sub	ax,word ptr ds:NetIOBuf
		mov	dx,word ptr ds:NetReadLen
		sub	dx,ax
		xor	ax,ax
		mov	bx,di
		stosb
		mov	si,offset LocalNamesBuf
		mov	cx,word ptr ds:NumNBNames
		jmp	short SendNamePacketA2
SendNamePacketA1:
		test	word ptr [si+10h],0400h
		je		SendNamePacketA2
		sub	dx,12h
		jb		SendNamePacketA3
		push	si
		push	cx
		mov	cl,10h
		rep	movsb
		lodsb
		lodsb
		stosw
		pop	cx
		pop	si
		inc	byte ptr [bx]
		lea	si,word ptr [si+23h]
SendNamePacketA2:
		loop	SendNamePacketA1
SendNamePacketA3:
		mov	si,offset AdaptorStatus
		push	di
		mov	cx,0020h
		rep	movsb
		add	si,08
		movsw
		lodsw
		mov	ax,word ptr ds:NbNCBs
		stosw
		movsw
		add	si,04
		lodsw
		dec	ax
		stosw
		lodsw
		mov	ax,word ptr ds:NumSes1
		stosw
		movsw
		movsw
		mov	bx,di
		pop	di
		mov	si,offset Table2
		mov	cl,2eh
		call	near ptr CopyA
		pop	di
		mov	si,di
		lodsw
		mov	ax,bx
		sub	ax,si
		xchg	ah,al
		stosw
		xchg	di,bx
		pop	si
		jmp	near ptr SndNmPacket2
;-----------------------------------------------------
InvCom		db	30,36,31,20,22,34
				db	32,35,10
;-----------------------------------------------------
CancelA:
		mov	byte ptr [si].cb_comstat,24h
		les	bx,dword ptr [si].cb_ncb_off
		les	bx,dword ptr es:[bx].ncb_buffer
		cmp	byte ptr es:[bx].ncb_cmd_cplt,0ffh
		jne	CancelAExit
		mov	byte ptr [si].cb_comstat,26h
		mov	al,byte ptr es:[bx].ncb_command
		and	al,7fh
		push	es
		push	cs
		pop	es
		mov	di,offset InvCom
		mov	cx,0009h
		repnz	scasb			;Flags = AL - ES:[DI]
		pop	dx
		je		CancelAExit
		push	si
		mov	si,word ptr ds:NCB_Buf
		mov	cx,word ptr ds:NumNCBs
		xor	ax,ax
CancelA1:
		cmp	word ptr [si].cb_id,ax
		je		CancelA2
		cmp	word ptr [si].cb_ncb_off,bx
		jne	CancelA2
		cmp	word ptr [si].cb_ncb_seg,dx
		je		CancelA4
CancelA2:
		add	si,16h
		loop	CancelA1
CancelA3:
		pop	si
		jmp	short CancelAExit
CancelA4:
		test	byte ptr [si].cb_stat,C4
		jne	CancelA3
		mov	byte ptr [si].cb_comstat,0bh
		stc
		call	near ptr Execute
		pop	si
		mov	byte ptr [si].cb_comstat,00
CancelAExit:
		retn
;-----------------------------------------------------
ResetA:
		or		byte ptr [si].cb_stat,C2
		les	bx,dword ptr [si].cb_ncb_off
		xor	ax,ax
		mov	al,byte ptr es:[bx].ncb_num
		mov	cx,word ptr ds:NbNCBs1
		cmp	cx,ax
		jnb	C32_a1
		xchg	ax,cx
C32_a1:
		mov	word ptr ds:NbNCBs,ax
		mov	al,byte ptr es:[bx].ncb_lsn
		mov	cx,word ptr ds:NumSes
		cmp	cx,ax
		jnb	C32_a2
		xchg	ax,cx
C32_a2:
		mov	word ptr ds:NumSes1,ax
		clc
		retn

; si=Ptr
Unlink		proc near
		pushf
		cli
		push	di
		mov	di,word ptr [si].prev
		or		di,di
		je		UnlinkNoPrev
		push	bp
		mov	bp,word ptr [si].next
		mov	word ptr [di].next,bp
		or		bp,bp
		jne	UnlinkHasNext
		push	di
Unlink1:
		cmp	word ptr [di].prev,si
		je		Unlink2
		mov	di,word ptr [di].prev
		jmp	short Unlink1
Unlink2:
		pop	word ptr [di].prev
		jmp	short Unlink3
UnlinkHasNext:
		mov	word ptr cs:[bp].prev,di
Unlink3:
		xor	di,di
		mov	word ptr [si].prev,di
		pop	bp
UnlinkNoPrev:
		pop	di
		popf
		retn
Unlink		endp

DeQueAdd:
		add	bp,di

; Return Ptr in SI
DeQue:
		pushf
		cli
		mov	si,word ptr cs:[bp].next
		or		si,si
		je		QueEmpty
		push	di
		mov	di,word ptr [si].next
		mov	word ptr cs:[bp].next,di
		or		di,di
		jne	DeQue1
		mov	word ptr cs:[bp].prev,bp
		jmp	short DeQue2
DeQue1:
		mov	word ptr [di].prev,bp
DeQue2:
		xor	di,di
		mov	word ptr [si].prev,di
		pop	di
QueEmpty:
		popf
		or		si,si
		retn
;-----------------------------------------------------
		add	bp,di

MoveToQue	proc near
		pushf
		cli
		call	near ptr Unlink
		push	di
		mov	di,word ptr cs:[bp].prev
		mov	word ptr cs:[bp].prev,si
		mov	word ptr [si].prev,di
		mov	word ptr [di].next,si
		xor	di,di
		mov	word ptr [si].next,di
		pop	di
		popf
		retn
MoveToQue	endp

Execute		proc near
		rcl	ch,1			;save Carry in ch
		mov	di,word ptr [si].cb_func_ptr	;get function pointer
		or		di,di
		jnz	ExecNext
		push	ax			;get new function pointer
		push	cx
		call	near ptr NBGetFunc
		pop	cx
		pop	ax
		jb		ExecErr
ExecNext:
		test	word ptr [si].cb_id,0ffffh;check CB ID
		jz		ExecRelCB	;release CB and exit
		rcr	ch,1			;restore Carry
		jc		ExecDone		;done on error (carry is set)
		xchg	ax,cx
ExecLoop:
		mov	ax,word ptr [di]	;get function
		inc	di
		inc	di
		mov	word ptr [si].cb_func_ptr,di	;update function pointer
		or		ax,ax
		jz		ExecExit		;exit if 0
		or		ah,ah
		jne	ExecFunct	;Execute a function
		or		cx,cx       ;Conditional jump in function table
		jz		ExecLoop
		cbw
		add	di,ax			;Take jump (previous return != 0)
		jmp	short ExecLoop

ExecFunct:
		push	di
		call	ax				;Call function, return error in carry, value in AX
		pop	di
		rcl	ch,1			;Save carry
		or		si,si			;CB pointer still valid?
		jne	ExecNext		;carry on
		retn

ExecErr:
		mov	al,03
		mov	byte ptr [si].cb_comstat,al
ExecDone:
		call	near ptr FinishUp
		or		si,si
		je		ExecExit
		test	word ptr [si].cb_id,0ffffh
		jne	ExecExit
ExecRelCB:
		call	near ptr ReleaseCB
ExecExit:
		retn
Execute		endp

NBGetFunc	proc near
		push	bx
ifdef TRACE_DUMP
		call	near ptr TraceDump
endif
		push	cs
		pop	es
		mov	di,offset NetbiosCodes
		mov	bx,di
		mov	al,byte ptr [si].cb_comstat
		mov	cx,002ch
		cld
		repnz	scasb			;Flags = AL - ES:[DI]
NBGetFunc1:	stc
		jne	NBGetFuncExit
		dec	di
		cmp	word ptr [si].cb_ncb_seg,00	;NCB Seg (ES)
		je		NBGetFunc2
		cmp	di,offset RealNBCodes
		jb		NBGetFuncExit
		cmp	di,offset UnsupNBCodes
		ja		NBGetFunc1
NBGetFunc2:
		sub	di,bx
		shl	di,1
		mov	di,word ptr cs:NetbiosFuncPtr[di]
		mov	word ptr [si].cb_func_ptr,di
		mov	byte ptr [si].cb_comstat,00
		clc
NBGetFuncExit:	pop	bx
		retn
NBGetFunc	endp

ifdef TRACE_DUMP
;-----------------------------------------------------
NBePMes		db	'CB:'
NBePCB		db	'0000,cmd:'
NBePcmd		db	'00'
NBePMes1	db	'w NCB:'
NBePNCB		db	'0000:'
NBePNCBO	db	'0000 cmd:'
NBePcmd1	db	'00 ret:'
NBePret		db	'00 cplt:'
NBePcplt	db	'00 '
NBePMes5	db	'p '
NBePp		db	'0000'
		db	0dh,0a,00
;-----------------------------------------------------

TraceDump	proc near
		mov	al,20h
		jmp	short TraceDump1
TraceDump	endp

TraceDump_e	proc near
		mov	al,65h
		jmp	short TraceDumpXX
TraceDump_e	endp

TraceDump_p	proc near
		mov	al,70h
TraceDump1:	cmp	byte ptr ds:TraceFlag,0ffh
		jne	TraceDump2
		cmp	byte ptr [si].cb_comstat,48h
		je		TraceDumpXX
TraceDump2:	cmp	byte ptr ds:TraceFlag,00
		jne	TraceDump4
TraceDumpXX:
		jmp	near ptr TraceDumpX
TraceDump4:
		mov	byte ptr ds:NBePMes5,al
		les	bx,dword ptr [si].cb_ncb_off
		mov	ax,es
		or		ax,bx
		je		TraceDump5
		mov	al,byte ptr es:[bx].ncb_command
		and	al,7fh
		cmp	al,21h		;Receive datagram
		je		TraceDumpXX
		cmp	al,20h
		je		TraceDumpXX
TraceDump5:
		cmp	byte ptr [si].cb_comstat,49h
		je		TraceDumpXX
		cmp	byte ptr [si].cb_comstat,4ah
		je		TraceDumpXX
		cmp	byte ptr [si].cb_comstat,80h
		jnb	TraceDumpXX
		push	si
		push	cs
		pop	es
		mov	di,offset NBePp
		mov	bx,word ptr ds:Ticks
		xor	al,al
		call	near ptr NumToString
		mov	di,offset NBePCB
		mov	bx,si
		xor	al,al
		call	near ptr NumToString
		mov	di,offset NBePcmd
		mov	bh,byte ptr [si].cb_comstat
		mov	al,01
		call	near ptr NumToString
		les	bx,dword ptr [si].cb_ncb_off
		or		bx,bx
		jne	TraceDump6
		test	byte ptr ds:TraceFlag,80h
		je		TraceDumpX1
		jmp	short TraceDump7
TraceDump6:
		mov	byte ptr ds:NBePMes1,20h
		test	byte ptr es:[bx],80h
		jne	TraceDump7
		mov	byte ptr ds:NBePMes1,77h ;'w'
TraceDump7:
		push	bx
		push	es
		push	cs
		pop	es
		mov	di,offset NBePNCBO
		xor	al,al
		call	near ptr NumToString
		mov	di,offset NBePNCB
		pop	bx
		push	bx
		xor	al,al
		call	near ptr NumToString
		pop	es
		pop	bx
		or		bx,bx
		jne	TraceDump8
		push	bx
		push	bx
		jmp	short TraceDump9
TraceDump8:
		mov	ah,byte ptr es:[bx].ncb_cmd_cplt
		push	ax
		mov	ah,byte ptr es:[bx].ncb_retcode
		push	ax
		mov	bh,byte ptr es:[bx]
		mov	ax,0001h
TraceDump9:
		push	cs
		pop	es
		mov	di,offset NBePcmd1
		call	near ptr NumToString
		mov	al,01
		mov	di,offset NBePret
		pop	bx
		call	near ptr NumToString
		mov	al,01
		mov	di,offset NBePcplt
		pop	bx
		call	near ptr NumToString
		mov	si,offset NBePMes
		call	near ptr TracePrint
TraceDumpX1:
		pop	si
TraceDumpX:
		retn
TraceDump_p	endp

endif

;-----------------------------------------------------
		db	00
StackBot2	dw	00
NetbiosSP	dw	00
StackFlag	db	00
				db	00
SaveSS		dw	00
SaveSP		dw	00
;-----------------------------------------------------

HandleQue	proc near
		pushf
		cli
		neg	byte ptr ds:StackFlag
		jne	HandleQue3
		not	byte ptr ds:StackFlag
		mov	word ptr ds:SaveSS,ss
		mov	word ptr ds:SaveSP,sp
		push	cs
		pop	ss
		mov	sp,word ptr ds:NetbiosSP
		sti
		mov	bp,offset CBQue
HandleQue1:
		call	near ptr DeQue
		je		HandleQue2
		push	bp
		xor	ax,ax
		call	near ptr Execute
		pop	bp
		mov	di,word ptr ds:StackBot2
		cmp	word ptr [di],0cccch
		je		HandleQue1
		xor	cl,cl
		call	near ptr HaltSystem
HandleQue2:
		cli
		mov	ss,word ptr ds:SaveSS
		mov	sp,word ptr ds:SaveSP
		mov	byte ptr ds:StackFlag,00
HandleQue3:
		popf
		jmp	near ptr HandleCompltn
;-----------------------------------------------------
NBePFatalMes	db	0a,0dh,07
		db	'NETBIOS Fatal Error:'
SysHaltedMes	db	'0.',0
;-----------------------------------------------------
HandleQue	endp

HaltSystem	proc near
		add	byte ptr ds:SysHaltedMes,cl
		push	si
		mov	si,offset NBePFatalMes
HaltSys1:
		lodsb
		cmp	al,0
HaltSys2:
		je		HaltSys2
		mov	ah,0eh
		int	10h			;CRT:0e-wr Teletype mode,AL-
		jmp	short HaltSys1
;-----------------------------------------------------
Ticks		dw	00
SecondTick	db	14
StartFlag	db	00
InAlarm		db	00
TimeHi		db	00,0cbh
;-----------------------------------------------------
Int1c:		jmp	short Int1c_c
;-----------------------------------------------------
OldInt1c	dd	00h
		db	'RB',00,0eeh,44h
		db	7d dup (00h)
;-----------------------------------------------------
HaltSystem	endp

Int1c_c		proc near
		pushf
		call	dword ptr cs:OldInt1c
		inc	word ptr cs:Ticks
		dec	byte ptr cs:SecondTick
		jne	Int1cExit
		mov	byte ptr cs:SecondTick,14h
		inc	byte ptr cs:TimeHi
		cmp	byte ptr cs:TimeHi,04
		jne	Int1cExit
		call	near ptr QueTick
Int1cExit:
		iret
Int1c_c		endp

AlarmHandler	proc near
		push	cs
		pop	ds
		call	near ptr QueAlarm
		retf
AlarmHandler	endp

QueTick		proc near
		call	near ptr SaveAll
QueTick		endp

QueAlarm	proc near
		cli
		inc	byte ptr ds:InAlarm
		neg	byte ptr ds:StartFlag
		jne	QueAlarm1
		call	near ptr GetFreeCB
		jb	QueAlarm1
		not	byte ptr ds:StartFlag
		mov	byte ptr [si].cb_comstat,48h
		mov	bp,offset CBQue
		call	near ptr MoveToQue
QueAlarm1:
		call	near ptr HandleQue
		retn
;-----------------------------------------------------
Count8		db	08
Count109	db	109d	; to give close to 1 minute
;-----------------------------------------------------
HandleTick:
		xor	ax,ax
		mov	word ptr [si].cb_id,ax
		push	si
HandleTick1:
		mov	si,word ptr ds:NCB_Buf
		mov	cx,word ptr ds:NumNCBs
HandleTick2:
		xor	ax,ax
		cmp	ax,word ptr [si].cb_id
		je		HandleTick3
		test	byte ptr [si].cb_stat,C_TIMING
		je		HandleTick3
		dec	byte ptr [si].cb_timer
		jne	HandleTick3
		and	byte ptr [si].cb_stat,not C_TIMING
		or		byte ptr [si].cb_stat,C1
		call	near ptr Unlink
		push	cx
		push	si
		mov	byte ptr [si].cb_comstat,05
		nop
		call	near ptr Execute
		pop	si
		pop	cx
HandleTick3:
		add	si,16h
		loop	HandleTick2
		mov	di,word ptr ds:SesBuf
		mov	cx,word ptr ds:NumSes
HandleTick4:
		test	word ptr [di].s_state,S_FREE+B4
		jne	HandleTick7
		mov	bx,S_WR1		;0004h
		test	bx,word ptr [di].s_state
		je		HandleTick6
		mov	si,offset NetWrite
		cmp	byte ptr [di].s_retry,00
		je		HandleTick5
		dec	byte ptr [di].s_retry
		jne	HandleTick5
		mov	bx,0080h
		mov	dx,0006h
		mov	si,offset AsCloseHandler
HandleTick5:
		call	near ptr SessionCall
HandleTick6:
		xor	bx,bx
		test	word ptr [di].s_state,S_FREE+S_HUP+B8+S_CLOSED+B4
		jne	HandleTick7
		mov	si,offset NetReadA
		call	near ptr SessionCall
HandleTick7:
		add	di,32h
		loop	HandleTick4
		dec	byte ptr ds:Count8
		dec 	byte ptr ds:Count109
		dec	byte ptr ds:InAlarm
		jle	HandleTick8
		jmp	near ptr HandleTick1
HandleTick8:
		cmp	byte ptr ds:Count8,cl
		jg  	HandleTick9
		mov	byte ptr ds:Count8,08
		mov	bx,word ptr ds:NameNd
		mov	di,0049h
		nop
		push	cs
		call	near ptr AsDGRcvHandler
		mov	bx,word ptr ds:DgramNd
		mov	di,004ah
		nop
		push	cs
		call	near ptr AsDGRcvHandler
HandleTick9:
		cmp	byte ptr ds:Count109,0
		jg  	HandleTick10
		mov	byte ptr ds:Count109,109d
		inc	word ptr ds:wRunTime
HandleTick10:
		call	near ptr SetNetAlarm
		pop	si
		xor	ax,ax
		mov	byte ptr ds:StartFlag,al
		retn
QueAlarm	endp

SetNetAlarm	proc near
		xor	cx,cx
		mov	byte ptr ds:TimeHi,cl
		mov	dx,0258h
		mov	si,offset AlarmHandler
		mov	bx,word ptr ds:NameNd
		mov	ah,2bh			;net_alarm
		call	near ptr KernelAPI
		push	cs
		pop	ds
		retn
SetNetAlarm	endp

SessionCall	proc near
		push	cx
		push	di
		push	si
		or		word ptr [di].s_state,bx
		mov	bx,word ptr [di].s_nd
		mov	cl,dl
		mov	ax,0ffffh
		push	ax
		push	cs
		call	si
SessionCall1:
		pop	ax
		cmp	ax,-01
		jne	SessionCall1
		pop	si
		pop	di
		pop	cx
		retn
;-----------------------------------------------------
		db	00
;-----------------------------------------------------
ResetB:
		push	si
		mov	di,si
		mov	si,word ptr ds:NCB_Buf
		mov	cx,word ptr ds:NumNCBs
ResetB1:
		cmp	si,di
		je		ResetB2
		test	word ptr [si].cb_id,0ffffh
		jz		ResetB2
		mov	byte ptr [si].cb_comstat,0bh
		push	di
		call	near ptr FinishUp
		call	near ptr ReleaseCB
		pop	di
ResetB2:
		add	si,16h
		loop	ResetB1
		mov	di,word ptr ds:SesBuf
		mov	cx,word ptr ds:NumSes
ResetB3:
		call	near ptr NetAbort
		add	di,32h
		loop	ResetB3
		pop	si
		mov	byte ptr [si].cb_comstat,00
		retn
;-----------------------------------------------------
		db	00
TraceBuf	dw	00
		dw	offset UnloadNB
		db	0cbh
;-----------------------------------------------------
Int5c:		jmp	short Int5c_c
;-----------------------------------------------------
OldInt5cOff	dw	00
OldInt5cSeg	dw	00
		db	'RB',00,0eeh,44h
		db	7d dup (00h)
;-----------------------------------------------------
Int5c_c:
		push	ax
		mov	ah,byte ptr cs:lana
		mov	al,23h
		cmp	byte ptr es:[bx].ncb_lana_num,ah ;NCB_LANA_NUM
		jne	NotUs
		mov	al,03
		cmp	byte ptr es:[bx].ncb_command,04	;NCB_COMMAND
		jb	NotUs
		pop	ax
		call	near ptr Netbios
		xor	ax,ax
		or		ah,byte ptr es:[bx].ncb_retcode
		js		Int5c_2
		cmp	ah,40h
		je		Int5c_1
		cmp	ah,09
		je		Int5c_1
		test	byte ptr es:[bx].ncb_command,80h
		jne	Int5c_2
Int5c_1:
		xchg	ah,al
Int5c_2:
		xor	ah,ah
		iret
;-----------------------------------------------------
NotUs:
		push	ax
		mov	ax,word ptr cs:OldInt5cSeg
		cmp	ah,0f0h
		je		NotUs1
		or		ah,al
NotUs1:
		pop	ax
		jne	NotUs2
		add	sp,02
		mov	byte ptr es:[bx].ncb_cmd_cplt,al ;NCB_CMD_CPLT
		mov	byte ptr es:[bx].ncb_retcode,al	;NCB_RETCODE
		jmp	short Int5c_2
NotUs2:
		pop	ax
		jmp	dword ptr cs:OldInt5cOff
SessionCall	endp

Netbios		proc near
		call	near ptr SaveAll
		mov	dx,es
		mov	cl,byte ptr es:[bx]
		cmp	cl,0ffh
		jne	NotFF
		mov	cl,7fh
		mov	byte ptr es:[bx],cl
NotFF:
		test	cl,80h
		jne	NoWait
		mov	ax,0021h		;Interface busy
		neg	byte ptr ds:StackFlag
		jne	NetbiosErr
		push	es
		push	bx
		mov	ax,offset WaitC
		push	ax
NoWait:
		and	cl,7fh
		call	near ptr GetFreeCB
		mov	ax,0022h		;Too many commands
		jb		NetbiosErr
		mov	byte ptr [si].cb_comstat,cl
		mov	word ptr [si].cb_ncb_seg0,dx
		mov	word ptr [si].cb_ncb_off,bx
		mov	word ptr [si].cb_ncb_seg,es
		mov	ax,00ffh
		mov	byte ptr es:[bx].ncb_cmd_cplt,al ;NCB_CMD_CPLT
		mov	byte ptr es:[bx].ncb_retcode,al	;NCB_RETCODE
		mov	bp,offset CBQue
		call	near ptr MoveToQue
		push	si
		call	near ptr HandleQue
		pop	si
		jmp	short NetbiosExit
NetbiosErr:
		mov	byte ptr es:[bx].ncb_cmd_cplt,al ;NCB_CMD_CPLT
		mov	byte ptr es:[bx].ncb_retcode,al	;NCB_RETCODE
NetbiosExit:
		retn
;-----------------------------------------------------
		retf
;-----------------------------------------------------
Int2a:
		jmp	short Int2a_c
;-----------------------------------------------------
OldInt2a	dd	00
		db	'RB',00,0eeh,44h
		db	7d dup (00h)
;-----------------------------------------------------
Int2a_c:
		jmp	dword ptr cs:OldInt2a

WaitC:
		neg	byte ptr ds:Int2aFlag
		je		Wait2
		pop	bx
		pop	es
		mov	byte ptr [si].cb_comstat,21h
		stc
		call	near ptr Execute
		jmp	short WaitExit
Wait2:
		mov	ax,9080h
		int	15h			;GEN:90-device busy loop
		sti				;Turn ON Interrupts
Wait3:
		pop	bx
		pop	es
		cmp	byte ptr es:[bx].ncb_cmd_cplt,0ffh
		jne	Wait4
		push	es
		push	bx
		call	near ptr HandleQue
		jmp	short Wait3
Wait4:
		mov	ax,9180h
		int	15h			;GEN:91-timeout int 15,AL=type
WaitExit:
		retn

;-----------------------------------------------------
InNetbios	db	00
;-----------------------------------------------------
Netbios		endp

SaveAll		proc near
		push	bp
		mov	bp,sp
		xchg	cx,word ptr [bp+02]
		push	ax
		push	bx
		push	dx
		push	si
		push	di
		push	ds
		push	es
		push	cs
		pop	ds
		inc	byte ptr ds:InNetbios
		call	cx
		pop	es
		pop	ds
		pop	di
		pop	si
		pop	dx
		pop	bx
		pop	ax
		pop	bp
		pop	cx
		dec	byte ptr cs:InNetbios
		retn
;-----------------------------------------------------
		db	00
;-----------------------------------------------------
SaveAll		endp

LookupCache	proc near	;es:di pointer to name, return cache ptr in bp
		call	near ptr LookCache16
		jb		LookupCache0
		jmp	near ptr LookupCacheExit
LookupCache0:
		push	ax
		push	si
		push	cx
		push	dx
		push	di
		push	es
		call	near ptr LookCache15	; try a 15 byte match
		jb		LookupCache1
		mov	dl,es:[di+0fh];		; get differing byte
		push	bp			; pointer to 15 byte match
		mov	bp,1000d
		mov	si,word ptr ds:CacheBuf
		mov	cx,word ptr ds:NbCache
		jmp	short LookupC2
LookupC1:
		cmp	word ptr [si].c_age,ax
		jnb	LookupC3
LookupC2:
		mov	di,si
		mov	ax,word ptr [di].c_age
LookupC3:
		add	si,17h
		loop	LookupC1
		pop	si
		cmp	bp,ax
		jb	LookupCacheRL
		push	di
		push	ds
		pop	es
		mov	cx,0015h
		rep	movsb
		mov	byte ptr [di-06],dl;		; fix changed byte
		mov	byte ptr [di-05],04		; fix status
		mov	word ptr [di],bp		; age
		pop	bp
LookupCacheRL:
		jmp	near ptr LookupCacheR
LookupCache1:
		xor	ax,ax
		or		al,byte ptr ds:DomNameLen
		stc
		je		LookupCacheR
		push	ax
		mov	si,word ptr ds:NetIOBuf
		push	si
		xchg	si,di
		push	ds
		push	es
		pop	ds
		pop	es
		call	near ptr ExpandName
		pop	si
		pop	cx
		push	si
		lodsb
		cbw
		add	ax,si
		xchg	ax,di
		mov	dx,si			;dx=*name
		mov	si,offset DomName
		rep	movsb
		mov	di,cx			;es,di=*cname
		mov	es,cx			;cx=cname_len
		mov	ah,52h		;nm_domain
		call	near ptr KernelAPI
		pop	si
		jnb	LookupCache2
		push	si
		mov	di,si
		push	ds
		pop	es
		call	near ptr CompressName
		dec	di
		std				;Backwards String Ops
		mov	cx,0010h
		mov	al,20h
		repz	scasb
		cld				;Forward String Opers
		inc	di
		inc	di
		mov	cl,byte ptr ds:DomNameLen
		rep	movsb
		pop	dx
		mov	di,cx
		mov	es,cx
		mov	ah,52h		;nm_domain
		call	near ptr KernelAPI
LookupCache2:
		pop	es
		pop	di
		jb	LookupCache3
		push	di
		push	es
		mov	si,word ptr ds:NetIOBuf
		push	si
		xchg	si,di
		push	ds
		push	es
		pop	ds
		pop	es
		mov	cx,0010h
		rep	movsb
		push	cs
		pop	ds
		mov	bx,di
		mov	bp,1000d
		lea	di,word ptr [bx].ncb_callname
		xchg	ax,cx
		or		al,04
		stosw
		xchg	ax,cx
		stosw
		xchg	ax,dx
		stosw
		pop	di
		call	near ptr PutCache
LookupCacheR:
		pop	es
		pop	di
LookupCache3:
		pop	dx
		pop	cx
		pop	si
		pop	ax
LookupCacheExit:
		retn
LookupCache	endp

LookCache0:
		push	ax
		xor	ax,ax
		jmp	short LookCache1

LookCache16:
		push	ax	;es:di pointer to name, return cache ptr in bp
		push	bx
		xor	ax,ax
		mov	bx,01000h	; look at 16 bytes
		jmp	short LookCache2

LookCache15:
		push	ax	;es:di pointer to name, return cache ptr in bp
		push	bx
		xor	ax,ax
		mov	bx,0f00h	; look at 15 bytes
		jmp	short LookCache2

LookCache:
		push	ax		;age in bp
		mov	ax,bp
LookCache1:
		push	bx
		mov	bx,01004h	; look at 16 bytes
LookCache2:
		push	si
		push	cx
		push	dx
		mov	bp,word ptr ds:CacheBuf
		mov	cx,word ptr ds:NbCache
		xor	dx,dx
LCNext:
		test	word ptr [bp].c_age,0ffffh
		jz	LCTryNext
		test	bl,bl		; test for any
		jz	LCAny
		test	bl,byte ptr [bp].c_type
		jz	LCTryNext
LCAny:
		push	cx
		xor	cx,cx
		mov	cl,bh		; get byte count
		mov	si,bp
		push	di
		repz	cmpsb
		pop	di
		pop	cx
		jne	LCNoMatch
		cmp	bp,ax		; match found
		jna	LCTryNext
		or		dx,dx
		jne	LCTryNext
		mov	dx,bp
		cmp	word ptr [bp].c_age,-02
		jnb	LCTryNext
		inc	word ptr [bp].c_age
		jmp	short LCTryNext
LCNoMatch:
		cmp	word ptr [bp].c_age,-01
		je		LCTryNext
		dec	word ptr [bp].c_age
LCTryNext:
		add	bp,17h
		loop	LCNext
		mov	bp,dx
		or		dx,dx
		jne	LookCacheExit
LCNotFound:
		stc
LookCacheExit:
		pop	dx
		pop	cx
		pop	si
		pop	bx
		pop	ax
		retn

PutCache	proc near
		;pointer to name in DI, pointer to structure containing IP add in BX
		push	si
		push	di
		mov	si,word ptr ds:CacheBuf
		mov	cx,word ptr ds:NbCache
		jmp	short PutCache2
PutCache1:
		cmp	word ptr [si].c_age,ax
		jnb	PutCache3
PutCache2:
		mov	di,si
		mov	ax,word ptr [di].c_age
PutCache3:
		add	si,17h
		loop	PutCache1
		pop	si
		push	si
		push	di
; The next two code lines may result in a loop when all cache entries
; are used. Commented out, results in bad session status reports when
; all entries are used
;		cmp	bp,ax
;		jb		PutCache4
		mov	cx,0010h
		rep	movsb
		lea	si,word ptr [bx+0ah]
		movsb				;type
		inc	si
		movsw				;IP address
		movsw				;IP address
		mov	ax,1000d ;default age
		stosw
		clc				;always successful
PutCache4:
		pop	bp
PutCacheExit:
		pop	di
		pop	si
		retn
PutCache	endp

AddCache	proc near
		push	si
		or		byte ptr [bx+0ah],04
		js		AddCache1
		xchg	ax,bp
		call	near ptr LookCache0
		jnb	AddCache2
		xchg	ax,bp
AddCache1:
		call	near ptr PutCache
		jmp	short AddCacheExit
AddCache2:
		xchg	bp,di
		push	di
		lea	di,word ptr [di+10h]
		lea	si,word ptr [bx+0ah]
		lodsw
		stosb
		movsw
		movsw
		pop	di
		xchg	bp,di
AddCacheExit:
		pop	si
		retn
AddCache	endp

;-----------------------------------------------------
VecTable	dw	NBVEC,2a,1c
			dw	offset Int5c
			dw	offset Int2a
			dw	offset Int1c
;-----------------------------------------------------

SetVecs		proc near
		mov	si,offset VecTable
		mov	cx,0003h
SetVecs1:
		mov	ax,word ptr [si]
		mov	ah,35h
		int	21h			;DOS:35-get int vector in ES:BX
		mov	di,word ptr [si+06]
		mov	word ptr cs:[di+02],bx
		mov	word ptr cs:[di+04],es
		cld
		lodsw
		mov	dx,di
		mov	ah,25h
		int	21h			;DOS:25-set int vect,DS:DX=-
		loop	SetVecs1
		retn
SetVecs		endp

CallNBC_clc	proc near
		mov	di,offset Func_clc
		jmp	short CallNBCopiesJ
CallNBC_clc	endp

CallNBC_ResVec	proc near
		mov	di,offset RestoreVec
CallNBCopiesJ:
		call	near ptr CallNBCopies
		retn
;-----------------------------------------------------
RestoreVec:
		push	ds
		lds	dx,dword ptr es:[bx+02]
		jb	RestoreVector1
		mov	al,byte ptr cs:[si-02]
		mov	ah,25h
		int	21h			;DOS:25-set int vect,DS:DX=handl
		jmp	short RestoreVector2
RestoreVector1:
		xchg	dx,bp
		lds	dx,dword ptr cs:[bp+02]
		cli
		mov	word ptr es:[bx+02],dx
		mov	word ptr es:[bx+04],ds
		sti
RestoreVector2:
		pop	ds
Func_clc:
		clc
		retn
CallNBC_ResVec	endp

CallNBCopies	proc near
		mov	si,offset VecTable
		mov	cx,0003h
TryNextVec1:
		cld
		lodsw
		mov	ah,35h
		int	21h			;DOS:35-get int vector in ES:BX
TryNext1:
		mov	bp,es
		mov	ax,cs
		xor	bp,ax
		je		CallIt
		cmp	word ptr es:[bx+06],'BR'
		jne	CNBCExit
		cmp	word ptr es:[bx],10ebh
		jne	CNBCExit
		cmp	byte ptr es:[bx+09],0eeh
		jne	CNBCExit
		xor	ax,word ptr es:[bx+04]
		stc
		je		CallIt
		les	bx,dword ptr es:[bx+02]
		jmp	short TryNext1
CallIt:
		call	di
		loop	TryNextVec1
		retn
;-----------------------------------------------------
CNBCExit:
		stc
		retn
CallNBCopies	endp

IsNameRemote:
		les	bx,dword ptr [si].cb_ncb_off
		mov	ax,es
		or		ax,bx
		jne	IsNameRemote1
		mov	byte ptr [si].cb_comstat,06
		stc
		jmp	short IsNameRemoteExit
IsNameRemote1:
		xor	ax,ax
		cmp	byte ptr es:[bx].ncb_callname,'*'
		je		IsNameRemoteExit
		inc	ax
IsNameRemoteExit:
		retn
;-----------------------------------------------------
InvalidName:
		mov	byte ptr [si].cb_comstat,15h
		stc
		retn
;-----------------------------------------------------
SetCommand26:
		mov	byte ptr [si].cb_comstat,26h
		stc
		retn
;-----------------------------------------------------
ClrCommand:
		mov	byte ptr [si].cb_comstat,00
		retn
;-----------------------------------------------------
SetGrpName:
		or		byte ptr [si].cb_stat,C_GROUPNAME
		retn

FindCallingName:
		mov	di,ncb_name		; 001ah
		jmp	short FindCName
FindCalledName:
		mov	di,ncb_callname		; 000ah
FindCName:
		les	bx,dword ptr [si].cb_ncb_off
		add	di,bx
		call	near ptr GetNameNumA
		jnb	FindCNameExit
		call	near ptr LookCache0
		jnb	FindCNameExit
		mov	al,byte ptr ds:NameRetries
		mov	byte ptr [si].cb_retry,al
		xor	ax,ax
FindCNameExit:
		mov	word ptr [si].cb_ptr,bp
		retn
;-----------------------------------------------------
ValidateName:
		les	bx,dword ptr [si].cb_ncb_off
		lea	di,word ptr [bx].ncb_name
		mov	ax,0015h		;Invalid name
		or		ah,byte ptr es:[di]
		je		ValidateNameErr
		cmp	ah,'*'
		je		ValidateNameErr
		call	near ptr GetNameNumA
		mov	ax,0d16h			;local duplicate name / remote in use
		mov	ch,byte ptr [si].cb_stat
		jb		ValidateName1
		xor	ch,byte ptr [bp+11h]
		js		ValidateNameErr
		xchg	ah,al
		jmp	short ValidateNameErr
ValidateName1:
		call	near ptr LookCache0
		jb		ValidateNameOK
		and	ch,byte ptr [bp+10h]
		js		ValidateNameOK
ValidateNameErr:
		mov	byte ptr [si].cb_comstat,al
		stc
		jmp	short ValidateNameExit
ValidateNameOK:
		mov	al,byte ptr ds:NameRetries
		mov	byte ptr [si].cb_retry,al
		clc
ValidateNameExit:
		retn
;-----------------------------------------------------
CreateLocalName:
		mov	di,offset NamesBuf
		mov	cx,word ptr ds:NumNBNames
		mov	ax,cx
		mov	byte ptr [si].cb_comstat,0eh
CreateLocalName1:
		test	word ptr [di+10h],1c00h
		je		CreateLocalName2
		add	di,23h
		loop	CreateLocalName1
		jmp	short CreateLocalNameErr
CreateLocalName2:
		sub	ax,cx
		inc	al
		mov	byte ptr es:[bx].ncb_num,al
		or		ax,8000h
		and	ah,byte ptr [si].cb_stat
		or		ax,1400h
		mov	word ptr [di+10h],ax
		mov	cx,0010h
		push	es
		push	ds
		pop	es
		pop	ds
		push	di
		push	si
		mov	si,bx
		add	si,1ah
		rep	movsb
		pop	si
		pop	di
		push	es
		push	ds
		pop	es
		pop	ds
		mov	ax,word ptr ds:NameNd
		mov	word ptr [si].cb_ptr,ax
		xor	ax,ax
		inc	word ptr ds:UDPup
		jmp	short CreateLocalNameExit
CreateLocalNameErr:
		stc
CreateLocalNameExit:
		retn
;-----------------------------------------------------
NmPkTemplate	db	00,00,00,00,00,01
		db	6d dup (00h)
NmPktTemplate	db	00,20,00,01,0c0,0c
QuestionType	db	00,20,00,01,0ff,0ff
		db	0ff,0ff,00,06
QuestionType1	db	6d dup (00h)
;-----------------------------------------------------
SendRegisterRD:
		mov	dx,2910h
		jmp	short SendRelease1
SendRelease:
		mov	dx,3010h
SendRelease1:
		mov	al,20h
		jmp	short SendRelease2
SendRegister:
		xor	ax,ax
		mov	dx,2810h
SendRelease2:
		or		byte ptr [si].cb_stat,al
		mov	ax,0100h
		mov	cx,001ah
		call	near ptr BuildNmPacket
		push	si
		mov	ax,0080h
		test	byte ptr [si].cb_stat,C_GROUPNAME
		jne	SendRelease3
		xor	ax,ax
SendRelease3:
		mov	word ptr ds:QuestionType1,ax
		mov	si,offset NmPktTemplate
		mov	cx,0012h
		rep	movsb
		mov	si,offset IPAddress
		movsw
		movsw
		pop	si
		jmp	near ptr SndNmP1

SendNameQuery:
		mov	dx,0110h
		mov	bp,2000h
		jmp	short SendNameQuery1
SendAdapterRequest:
		mov	dx,0010h
		mov	bp,2100h
SendNameQuery1:
		or		byte ptr [si].cb_stat,C_NAMEWAIT
		xor	ax,ax
		mov	cx,000ah
		call	near ptr BuildNmPacket
		mov	ax,bp
		stosw
		mov	ax,0100h
		stosw
		cmp	bp,2100h
		jne	SendNameQuery2
		jmp	near ptr SndNmP0
SendNameQuery2:
		jmp	near ptr SndNmP1

IsName1000:		mov	cx,1000h
		jmp	short IsName3

IsName0:
		xor	cx,cx
IsName3:
		and	byte ptr [si].cb_stat,not C_NAMEWAIT
		les	bx,dword ptr [si].cb_ncb_off
		call	near ptr GetNamePtr
		jb		IsNameExit
		test	byte ptr [si].cb_stat,C1
		je		IsName4
		and	byte ptr [si].cb_stat,not C1
		xor	ax,ax
		mov	al,byte ptr [si].cb_retry
		dec	al
		mov	byte ptr [si].cb_retry,al
		jne	IsNameExit
		mov	byte ptr [si].cb_comstat,al
		not	cx
		and	word ptr [di+10h],cx
		mov	dx,di
		jmp	short IsNameExit
IsName4:
		or		cx,cx
		je		IsNameExit
		mov	byte ptr [si].cb_comstat,16h
		xor	ax,ax
		mov	word ptr [di+10h],ax
		dec	word ptr ds:UDPup
		stc
IsNameExit:
		retn
;-----------------------------------------------------
HandleNameResp:
		xor	ax,ax
		and	byte ptr [si].cb_stat,not C_NAMEWAIT
		test	byte ptr [si].cb_stat,C1
		jne	HandleNRFailed
		call	near ptr ExtractName1
		mov	byte ptr [si].cb_comstat,al
		mov	bp,1000d
		mov	di,word ptr ds:NetIOBuf
		mov	bx,di
		add	bx,dx
		sub	bx,10h
		add	di,0ch
		call	near ptr AddCache
		jb	HandleNRFailed
		mov	word ptr [si].cb_ptr,bp
		xor	ax,ax
		jmp	short HandleNRExit
HandleNRFailed:
		and	byte ptr [si].cb_stat,not C1
		mov	al,byte ptr [si].cb_retry
		dec	al
		mov	byte ptr [si].cb_retry,al
HandleNRExit:
		retn
;-----------------------------------------------------
GetRemoteName:
		cmp	byte ptr [si].cb_comstat,05
		je		GetRemoteName1
		mov	al,byte ptr ds:Cnt2
		mov	byte ptr [si].cb_timer,al
		or		byte ptr [si].cb_stat,C_NAMEWAIT+C_TIMING
		xor	ax,ax
		jmp	short GetRemoteName4
GetRemoteName1:
		les	bx,dword ptr [si].cb_ncb_off
		lea	di,word ptr [bx].ncb_callname
		call	near ptr LookupCache
		mov	word ptr [si].cb_ptr,bp
		jb		GetRemoteName2
		or		byte ptr [si].cb_stat,C1
		mov	bp,offset CBQue
		jmp	near ptr MoveToQue
GetRemoteName2:
		mov	al,byte ptr es:[bx].ncb_command
		and	al,7fh
		cmp	al,33h		;adapter status
		je		GetRemoteName3
		mov	byte ptr [si].cb_comstat,00
		cmp	al,20h		;send datagram
		je		GetRemoteName3
		mov	byte ptr [si].cb_comstat,14h
GetRemoteName3:
		stc
GetRemoteName4:
		retn

RemoteIPAddress:
		mov	cx,offset FindCallingName
		jmp	short RemoteIPAddress1
RemoteIPAddressNop:
		mov	cx,offset RetIns
		jmp	short RemoteIPAddress1
RemoteIPAddressNCB_NUM:
		mov	cx,offset NameFromNCB_NUM
RemoteIPAddress1:
		push	si
		mov	dx,word ptr [si].cb_ptr
		les	bx,dword ptr [si].cb_ncb_off
		call	cx
		mov	bx,bp
		push	ds
		pop	es
		mov	di,offset AddrStrFAddr
		mov	si,dx
		mov	al,80h
		cmp	si,word ptr ds:CacheBuf
		jb		RemoteIPAddress2
		and	al,byte ptr [si+10h]
		add	si,11h
		jmp	short RemoteIPAddress3
RemoteIPAddress2:
		and	al,byte ptr [si+11h]
		mov	si,offset IPAddress
RemoteIPAddress3:
		movsw
		movsw
		pop	si
		or		byte ptr [si].cb_stat,al
		mov	byte ptr [si].cb_comstat,00
RetIns:
		retn
;-----------------------------------------------------
DelNameA:
		les	bx,dword ptr [si].cb_ncb_off
		lea	di,word ptr [bx].ncb_name
		mov	byte ptr [si].cb_comstat,15h
		call	near ptr GetNameNum
		jb		DelNameExit
		test	word ptr [bp+10h],1200h
		stc
		jne	DelNameExit
		mov	byte ptr es:[bx].ncb_num,al
		or		word ptr [bp+10h],1000h
		mov	al,byte ptr ds:NameRetries
		mov	byte ptr [si].cb_retry,al
DelNameExit:
		retn
;-----------------------------------------------------
NameFromNCB_NUM:
		les	bx,dword ptr [si].cb_ncb_off
		call	near ptr GetNamePtr	;get name pointer fron ncb_num in di
		jb		NameFromNCB_NUMExit
		test	word ptr [di].nm_type1,1800h
		stc
		jne	NameFromNCB_NUMExit
		mov	word ptr [si].cb_ptr,di
		mov	bp,di
		clc
NameFromNCB_NUMExit:
		retn
;-----------------------------------------------------
DeQueExecA:
		mov	byte ptr [si].cb_comstat,0fh
		mov	bp,dx
		xor	ax,ax
		or		ax,word ptr [bp+13h]
		jne	DeQueExecBExit
		mov	byte ptr [si].cb_comstat,al

DeQueExecB:
		mov	al,17h
		xor	di,di
		push	bp
		add	bp,17h
		call	near ptr DeQueExecAll
		add	bp,04
		call	near ptr DeQueExecAll
		add	bp,04
		call	near ptr DeQueExecAll
		pop	bp
		mov	word ptr [bp+10h],di
		dec	word ptr ds:UDPup
DeQueExecBExit:
		retn

NameX		proc near
		xor	ax,ax
		and	byte ptr [si].cb_stat,not C_NAMEWAIT
		test	byte ptr [si].cb_stat,C1
		jne	NameXExit
		call	near ptr ExtractName1
		mov	di,word ptr ds:NetIOBuf
		push	di
		add	di,0ch
		call	near ptr LookCache0
		pop	di
		jb		NameX2
		mov	bx,di
		add	bx,dx
		sub	bx,10h
		mov	al,byte ptr [bp+10h]
		and	al,byte ptr [bx+0ah]
		js		NameX1
		mov	byte ptr [si].cb_comstat,19h
		mov	di,word ptr [si].cb_ptr
		mov	word ptr [di+15h],ax
		call	near ptr SendNamePacket7
		stc
		jmp	short NameXExit
NameX1:
		mov	bp,1000d
		shr	bp,1
		add	di,0ch
		call	near ptr AddCache
NameX2:
		or		al,01
NameXExit:
		retn
NameX		endp

NmSvRcv:
		call	near ptr NetRead
		jb		NmSvRcvDone
		mov	dx,cx
		push	si
		lea	di,word ptr [bp+0ch]
		xor	ax,ax
NmSvRcv1:
		mov	al,byte ptr [di]
		inc	di
		test	al,al
		jz		NmSvRcv2
		add	di,ax
		jmp	short NmSvRcv1
NmSvRcv2:
		mov	ax,word ptr [bp+02]
		xchg	ah,al
		test	ax,S_FREE	;8000h
		jne	NmSvRcv3
		cmp	word ptr [di],2100h
		jne	NmSvRcv7
		mov	al,0dh
		jmp	short NmSvRcv8
NmSvRcv3:
		cmp	ax,8587h
		jne	NmSvRcv4
		mov	al,0eh
		jmp	short NmSvRcv8
NmSvRcv4:
		mov	si,word ptr ds:NCB_Buf
		mov	cx,word ptr ds:NumNCBs
		mov	ax,word ptr [bp+00]
		xchg	ah,al
NmSvRcv5:
		cmp	word ptr [si].cb_id,ax
		je		NmSvRcv6
		add	si,16h
		loop	NmSvRcv5
		jmp	short NmSvRcvNext
NmSvRcv6:
		test	byte ptr [si].cb_stat,C_NAMEWAIT
		jnz	NmSvRcv9
		jmp	short NmSvRcvNext

NmSvRcv7:
		mov	cl,0bh
		shr	ax,cl
NmSvRcv8:
		or		al,0f0h
		mov	byte ptr [si].cb_comstat,al
		xor	ax,ax
		mov	word ptr [si].cb_func_ptr,ax
NmSvRcv9:
		call	near ptr Execute
NmSvRcvNext:
		pop	si
		jmp	short NmSvRcv
NmSvRcvDone:
		xor	ax,ax
		mov	word ptr ds:NmRcvData,ax
		mov	word ptr [si].cb_id,ax
		retn

;---------------------------------
NameFA		proc near
		mov	di,word ptr ds:NetIOBuf
		mov	bx,di
		add	bx,dx
		sub	bx,10h
		mov	ax,word ptr [di+02]
		xchg	ah,al
		add	di,0ch
		test	ax,0100h
		je		NameFA1
		call	near ptr GetNameNumA
		jb		NameFA2
		mov	ax,word ptr [bx+0ah]
		xchg	ah,al
		and	ax,word ptr [bp+10h]
		js		NameFA2
		mov	word ptr [si+04],bp
		xor	ax,ax
		jmp	short NameFAExit
NameFA1:
		xor	bp,bp
		call	near ptr AddCache
NameFA2:
		not	ax
NameFAExit:
		clc
		retn
NameFA		endp

NameFB		proc near
		mov	di,word ptr ds:NetIOBuf
		add	di,0ch
		call	near ptr GetNameNumA
		jb		NameFB1
		or		word ptr [bp+10h],0800h
NameFB1:
		xor	ax,ax
		retn
NameFB		endp

NameFC		proc near
		mov	di,word ptr ds:NetIOBuf
		add	di,0ch
		call	near ptr LookCache0
		jb		NameFCExit
		push	si
		mov	si,offset psp_savint24
		add	si,bx
		xor	ax,ax
NameFC1:
		push	di
		mov	di,0011h
		add	di,bp
		push	si
		cmpsw				;Flgs=DS:[SI]-ES:[DI]
		jne	NameFC2
		cmpsw
		jne	NameFC2
		mov	word ptr [bp+15h],ax
NameFC2:
		pop	si
		pop	di
		call	near ptr LookCache
		jnb	NameFC1
		pop	si
NameFCExit:
		clc
		retn
NameFC		endp

NameFD		proc near
		mov	di,word ptr ds:NetIOBuf
		add	di,0ch
		call	near ptr GetNameNumA
		jb		NameFD1
		mov	word ptr [si+04],bp
		xor	ax,ax
NameFD1:
		clc
		retn
NameFD		endp

ExtractName1:
		mov	di,000ch
		jmp	short ExtractName3
ExtractName2:
		mov	di,000eh
ExtractName3:
		push	ds
		pop	es
		add	di,word ptr ds:NetIOBuf

ExtractName4:
		push	si
		mov	si,di
		call	near ptr CompressName
		mov	cl,byte ptr ds:ScopeLen
		mov	di,offset Scope
		repz	cmpsb			;Flgs=DS:[SI]-ES:[DI]
		mov	ax,cx
		mov	bx,si
		clc
		pop	si
		retn

SendNamePacket6 proc near
		mov	ax,8486h
		jmp	short SndNmPacket1
SendNamePacket6 endp

SendNamePacket7 proc near
		mov	ax,8487h
		jmp	short SndNmPacket1
SendNamePacket7 endp

SendNamePacket0 proc near
		not	dx
SendNamePacktC:
		mov	ax,8400h
SndNmPacket1:
		mov	di,word ptr ds:NetIOBuf
		add	di,02
		cld
		or		ah,byte ptr [di]
		xchg	ah,al
		stosw
		push	word ptr [di]
		xor	ax,ax
		stosw
		pop	ax
		stosw
		xor	ax,ax
		stosw
		stosw
		push	si
		mov	si,word ptr [si+04]
		mov	bx,word ptr [si+10h]
		and	bx,S_FREE	;8000h
		xchg	bl,bh
		call	near ptr ExpandName
		mov	si,offset QuestionType
		mov	word ptr [si+0ah],bx
		mov	cx,000ch
		rep	movsb
		mov	si,offset IPAddress
		movsw
		movsw
		pop	si
		or		dx,dx
		js		SndNmPacktExit
SndNmPacket2:
		mov	cx,di
		sub	cx,word ptr ds:NetIOBuf
		call	near ptr NetWriteto
		xor	ax,ax
SndNmPacktExit:
		 retn
SendNamePacket0 endp

BuildNmPacket	proc near
		xchg	dh,dl
		mov	di,offset NmPkTemplate
		push	ds
		pop	es
		mov	word ptr [di+02],dx
		mov	word ptr [di+0ah],ax
		mov	ax,word ptr [si].cb_id
		xchg	al,ah
		mov	word ptr [di],ax
		push	cx
		mov	cx,000ch
		push	si
		mov	si,word ptr ds:NetIOBuf
		xchg	si,di
		rep	movsb
		pop	si
		pop	cx
		push	si
		lds	si,dword ptr [si].cb_ncb_off
		add	si,cx
		call	near ptr ExpandName
		push	cs
		pop	ds
		pop	si
		retn
BuildNmPacket	endp

SndNmP1		proc near
		mov	bx,offset NetWritetoBC
		jmp	short SndNmPack0
SndNmP0:
		mov	bx,offset NetWriteto
SndNmPack0:
		mov	ax,word ptr ds:NameNd
		mov	word ptr [si].cb_ptr,ax
		sub	di,word ptr ds:NetIOBuf
		mov	cx,di
		mov	ax,NAME_SRVC_UDP_P
		mov	di,offset AddrStrFSock
		stosw
		stosw
		call	bx
		mov	al,byte ptr ds:Count2
		mov	byte ptr [si].cb_timer,al
		or		byte ptr [si].cb_stat,C_TIMING
		xor	ax,ax
		retn
SndNmP1		endp

ExpandName	proc near
		mov	cx,0010h
		mov	ax,cx
		shl	ax,1
		cld
		stosb
ExpandName1:
		lodsb
		mov	ah,al
		shr	al,1
		shr	al,1
		shr	al,1
		shr	al,1
		and	ax,0f0fh
		add	ax,4141h
		stosw
		loop	ExpandName1
		push	cs
		pop	ds
		mov	si,offset Scope
		mov	cl,byte ptr ds:ScopeLen
		rep	movsb
		retn
ExpandName	endp

CompressName	proc near
		cld
		lodsb
		shr	al,1
		cbw
		mov	cx,ax
CompressName1:
		lodsw
		sub	ax,4141h
		shl	al,1
		shl	al,1
		shl	al,1
		shl	al,1
		or		al,ah
		stosb
		loop	CompressName1
		retn
CompressName	endp

GetNamePtr	proc near	; return name pointer from ncb_num in di
		xor	ax,ax
		mov	al,byte ptr es:[bx].ncb_num
		dec	al
		mov	byte ptr [si].cb_comstat,13h	;invalid NameNumber
		cmp	word ptr ds:NumNBNames,ax
		jna	GetNamePtrExit
		mov	ah,23h
		mul	ah
		mov	di,offset NamesBuf
		add	di,ax
		test	word ptr [di].nm_type1,0400h
		jne	GetNamePtrExit
		stc
GetNamePtrExit:
		 retn
GetNamePtr	endp

GetNameNumA:		;es:di points to name, return NameNum in al
		mov	ax,1800h
		jmp	short GetNameNum1

GetNameNum:
		xor	ax,ax
GetNameNum1:
		push	si
		push	cx
		mov	bp,offset NamesBuf
		mov	cx,word ptr ds:NumNBNames
		mov	al,cl
GetNameNum2:
		test	word ptr [bp+10h],0400h
		je		GetNameNum3
		test	ah,byte ptr [bp+11h]
		jne	GetNameNum3
		push	cx
		mov	cx,0010h
		mov	si,bp
		push	di
		repz	cmpsb			;Flgs=DS:[SI]-ES:[DI]
		pop	di
		pop	cx
		je		GetNameNum4
GetNameNum3:
		add	bp,23h
		loop	GetNameNum2
		stc
		jmp	short GetNameNum5
GetNameNum4:
		sub	al,cl
		inc	al
GetNameNum5:
		pop	cx
		pop	si
		retn

NameSrvcListen	proc near
		mov	word ptr ds:AddrStrLSock,NAME_SRVC_UDP_P
		mov	di,0049h
		call	near ptr UDPListen
		jb	NameSrvcExit
		mov	word ptr ds:NameNd,bx
		call	near ptr SetNetAlarm
		jb	NameSrvcExit
		mov	ah,05			;get_addr
		call	near ptr KernelAPI
		push	cs
		pop	es
		mov	di,offset IPAddress
		stosw
		xchg	ax,dx
		stosw
NameSrvcExit:
		retn
;-----------------------------------------------------
NmRcvData	dw	00
DgrmRcvData	dw	00
;-----------------------------------------------------
NameSrvcListen	endp

AsDGRcvHandler	proc near
		push	cs
		pop	ds
		cmp	di,49h
		jne	AsDgmRcv1
		cmp	word ptr ds:NmRcvData,bx
		je		AsDgmRcvExit
		mov	word ptr ds:NmRcvData,bx
		jmp	short AsDgmRcv2
AsDgmRcv1:
		cmp	word ptr ds:DgrmRcvData,bx
		je		AsDgmRcvExit
		mov	word ptr ds:DgrmRcvData,bx
AsDgmRcv2:
		call	near ptr GetFreeCB
		jnb	AsDgmRcv3
		inc	word ptr ds:wNoBufErrs
		jmp	short AsDgmRcvExit
AsDgmRcv3:
		mov	word ptr [si].cb_ptr,bx
		xchg	ax,di
		mov	byte ptr [si].cb_comstat,al
		mov	bp,offset CBQue
		call	near ptr MoveToQue
		call	near ptr HandleQue
AsDgmRcvExit:
		retf
AsDGRcvHandler	endp

AsDGCloseHandlr proc near
		nop
		cmp	dx,1dh		;NET_ERR_TERMINATING
		jne	AsDGClHndExit
		nop
		push	cs
		call	near ptr UnloadNB
AsDGClHndExit:
		retf
AsDGCloseHandlr endp

NetRead		proc near
		mov	bx,word ptr [si].cb_ptr
		push	ds
		pop	es
		mov	di,offset AddrStrFAddr
		mov	cx,word ptr ds:NetReadLen
		mov	dx,0040h
		mov	bp,word ptr ds:NetIOBuf
		xchg	bp,si
		xor	ax,ax
		mov	ah,1bh			;net_read
		call	near ptr KernelAPI
		xchg	bp,si
		jb		NetReadExit
		inc	word ptr ds:NumReadsLo
		jne	NetReadExit
		inc	word ptr ds:NumReadsHi
NetReadExit:
		retn
NetRead		endp

UDPListen	proc near
		push	si
		mov	ah,29h			;net_getglobdesc
		call	near ptr KernelAPI
		jb		DGLExit
		mov	bx,ax
		mov	cx,0002h		;NET_AS_RCV
		mov	dx,offset AsDGRcvHandler
		mov	ah,1fh			;net_asynch
		call	near ptr KernelAPI
		mov	bp,ds
		push	cs
		pop	ds
		jb		DGLAbort
		mov	cx,0007h		;NET_AS_CLOSE
		mov	dx,offset AsDGCloseHandlr
		mov	ah,1fh			;net_asynch
		call	near ptr KernelAPI
		mov	bp,ds
		push	cs
		pop	ds
		jb		DGLAbort
		mov	dx,0003h		;DGRAM
		mov	si,offset AddrStrFAddr
		mov	ah,23h			;net_listen
		call	near ptr KernelAPI
		jb		DGLAbort
		jmp	short DGLExit
DGLAbort:
		mov	ah,19h			;net_abort
		call	near ptr KernelAPI
		stc
DGLExit:
		pop	si
		retn
UDPListen	endp

NetWriteto	proc near
		xor	dx,dx
		jmp	short NetWriteto3
NetWriteto	endp

NetWritetoBC	proc near
		push	bp
		mov	bp,word ptr ds:BCNameCount
		xchg	bp,cx
		jcxz	NetWriteto2
		push	si
		mov	bx,word ptr [si].cb_ptr
		mov	si,word ptr ds:BCNameBuf2
		mov	di,offset AddrStrFAddr
		xor	dx,dx
NetWriteto1:
		push	di
		movsw
		movsw
		pop	di
		push	si
		mov	si,word ptr ds:NetIOBuf
		xchg	bp,cx
		mov	ah,1ch			;net_writeto
		call	near ptr KernelAPI
		xchg	bp,cx
		pop	si
		loop	NetWriteto1
		pop	si
NetWriteto2:
		xchg	bp,cx
		pop	bp
		mov	dx,0080h
		xor	ax,ax
		mov	di,offset AddrStrFAddr
		stosw
		stosw
NetWriteto3:
		mov	di,offset AddrStrFAddr
		push	bp
		push	si
		mov	bx,word ptr [si].cb_ptr
		mov	si,word ptr ds:NetIOBuf
		mov	ah,1ch			;net_writeto
		call	near ptr KernelAPI
		jnb	NetWriteto4
		inc	word ptr ds:wAbortTran
		jmp	short NetWriteto5
NetWriteto4:
		inc	word ptr ds:wGoodTranLo
		jne	NetWriteto5
		inc	word ptr ds:wGoodTranHi
NetWriteto5:
		clc
		pop	si
		pop	bp
		retn
NetWritetoBC	endp
;-----------------------------------------------------
AddrStrFAddr	db	00,00,00,00
AddrStrFSock	dw	00
AddrStrLSock	dw	00
		db	00
;-----------------------------------------------------

AsOpenHandler	proc near
		nop
		push	cs
		pop	ds
		mov	si,word ptr [di+23h]
		or		si,si
		je		AsOpenHandExit
		xor	word ptr [di+23h],si
		mov	byte ptr [si].cb_comstat,ch
		cmp	cl,07
		jne	AsOpenHand1
		mov	byte ptr [si].cb_comstat,dl
AsOpenHand1:
		mov	bp,offset CBQue
		call	near ptr MoveToQue
		call	near ptr HandleQue
AsOpenHandExit:
		retf
AsOpenHandler	endp

AsCloseHandler	proc near
		nop
		push	cs
		pop	ds
		test	word ptr [di].s_state,S_FREE	;8000h
		jne	AsCloseHand3
		cmp	cl,07
		jne	AsCloseHand1
		cmp	dl,14h
		jne	AsCloseHand3
AsCloseHand1:
		call	near ptr GetFreeCB
		jnb	AsCloseHand2
		inc	word ptr ds:wNoBufErrs
		jmp	short AsCloseHand3
AsCloseHand2:
		mov	byte ptr [si].cb_comstat,cl
		mov	word ptr [si].cb_ptr,di
		mov	bp,offset CBQue
		call	near ptr MoveToQue
		xor	si,si
		xchg	si,word ptr [di].s_cb
		test	si,si
		je		AsCloseHand3
		and	byte ptr [si].cb_stat,not C_TIMING
		call	near ptr MoveToQue
AsCloseHand3:
		call	near ptr HandleQue
		retf
AsCloseHandler	endp

AsRXHandler	proc near
		push	cs
		pop	ds
		cli
		mov	ax,S_SENT	;4000h
		mov	dl,4dh
		cmp	cl,03		;NET_AS_XMT
		je		AsRXHand1
		mov	ax,S_RCVD	;0040h
		mov	dl,4eh
		cmp	cl,02		;NET_AS_RCV
		jne	AsRXHandExit
AsRXHand1:
		test	ax,word ptr [di].s_state
		jnz	AsRXHandExit
		push	ax
		call	near ptr GetFreeCB
		pop	ax
		jb		AsRXHandExit
		or		word ptr [di].s_state,ax
		mov	byte ptr [si].cb_comstat,dl
		mov	word ptr [si].cb_ptr,di
		mov	bp,offset CBQue
		mov	ax,si
		xchg	ax,word ptr cs:[bp+00]
		mov	word ptr [si],ax
		mov	word ptr [si+02],bp
		test	ax,ax
		jne	AsRXHand2
		mov	word ptr cs:[bp+02],si
AsRXHand2:
		call	near ptr HandleQue
AsRXHandExit:
		sti
		retf
AsRXHandler	endp

TCPXmt		proc near
		mov	di,word ptr [si].cb_ptr
		mov	bx,word ptr [di+0ah]
		and	word ptr [di].s_state,not S_SENT	;0bfffh
		call	near ptr NetWrite
		mov	word ptr [si+0eh],0000h
		retn
TCPXmt		endp

NetWrite	proc near
		push	si
NetWrite1:
		test	word ptr [di].s_state,S_FREE+B9	;8200h
		jne	NetWriteExit
		test	word ptr [di].s_state,S_WR1		;0004h
		jne	NetWrite3
		mov	bp,001fh
		call	near ptr DeQueAdd
		je		NetWrite5
		mov	ax,0000h
		or		byte ptr [si].cb_stat,C4
		mov	word ptr [di+23h],si
		mov	cl,byte ptr [di+0dh]
		mov	byte ptr [di+2bh],cl
		les	bx,dword ptr [si].cb_ncb_off
		mov	cx,word ptr es:[bx].ncb_length
		test	byte ptr [si].cb_stat,C3
		je		NetWrite2
		add	cx,word ptr es:[bx].ncb_callname
		adc	ah,ah
NetWrite2:
		xchg	ch,cl
		mov	word ptr [di+2eh],cx
		mov	word ptr [di+2ch],ax
		mov	word ptr [di+29h],0004h
		lea	bx,word ptr [di+2ch]
		mov	word ptr [di+25h],bx
		mov	word ptr [di+27h],ds
		mov	bx,word ptr [di+0ah]
		or		word ptr [di].s_state,S_WR2+S_WR1	;0ch
NetWrite3:
		mov	cx,word ptr [di+29h]
		lds	si,dword ptr [di+25h]
NetWrite4:
		mov	dx,0040h
		mov	ah,1ah			;net_write
		call	near ptr KernelAPI
		jnb	NetWrite6
		mov	bp,ds
		push	cs
		pop	ds
		call	near ptr CheckAPIerr
		jne	NetWrite7
		mov	word ptr [di+25h],si
		mov	word ptr [di+27h],bp
		mov	word ptr [di+29h],cx
NetWrite5:
		mov	bx,word ptr [di+0ah]
		mov	ah,1eh			;net_flush
		call	near ptr KernelAPI
NetWriteExit:
		pop	si
		retn
;-----------------------------------------------------
NetWrite6:
		add	si,ax
		sub	cx,ax
		jne	NetWrite4
		push	cs
		pop	ds
		xor	ax,ax
		test	word ptr [di].s_state,B10	;0400h
NetWrite7:
		jne	NetWrite10
		mov	si,word ptr [di+23h]
		les	bx,dword ptr [si].cb_ncb_off	;??
		test	word ptr [di].s_state,S_WR2	;0008h
		je		NetWrite9
		and	word ptr [di].s_state,not S_WR2	;fff7h
		or		cx,word ptr es:[bx].ncb_length	;??
		je		NetWrite9
		lds	dx,dword ptr es:[bx].ncb_buffer	;??
NetWrite8:
		mov	word ptr cs:[di+27h],ds
		push	cs
		pop	ds
		mov	word ptr [di+25h],dx
		mov	word ptr [di+29h],cx
		mov	bx,word ptr [di+0ah]
		jmp	short NetWrite3
NetWrite9:
		test	byte ptr [si].cb_stat,C3
		je		NetWrite10
		or		word ptr [di].s_state,B10	;0400h
		or		cx,word ptr es:[bx].ncb_length2
		je		NetWrite10
		lds	dx,dword ptr es:[bx].ncb_buffer2
		jmp	short NetWrite8
NetWrite10:
		mov	si,word ptr [di+23h]
		mov	byte ptr [si].cb_comstat,al
		or		al,al
		jne	NetWrite12
		inc	word ptr ds:wGoodTranLo
		jne	NetWrite11
		inc	word ptr ds:wGoodTranHi
NetWrite11:
		jmp	short NetWrite13
NetWrite12:
		inc	word ptr ds:wAbortTran
NetWrite13:
		and	word ptr [di].s_state,not (B10+S_WR2+S_WR1)	;0fbf3h
		and	byte ptr [si].cb_stat,not C4
		mov	bp,offset CBQue
		call	near ptr MoveToQue
		test	word ptr [di].s_state,S_CLOSED	;0020h
		je		NetWrite14
		xor	si,si
		xchg	si,word ptr [di].s_cb
		test	si,si
		je		NetWrite14
		and	byte ptr [si].cb_stat,not C_TIMING
		call	near ptr MoveToQue
		jmp	near ptr NetWriteExit
NetWrite14:
		jmp	near ptr NetWrite1
NetWrite	endp

TCPRcv		proc near
		mov	di,word ptr [si].cb_ptr
		mov	bx,word ptr [di+0ah]
		and	word ptr [di].s_state,not S_RCVD	;ffbfh
		call	near ptr NetReadA
		mov	word ptr [si+0eh],0000h
		retn
TCPRcv		endp

NetReadA	proc near
		push	si
NetReadA1:
		test	word ptr [di].s_state,S_FREE+B9	;8200h
		jne	NetReadA6
		test	word ptr [di].s_state,B11+B1	;0802h
		jne	NetReadA3
		test	word ptr [di].s_state,B0		;0001h
		jne	NetReadA8
NetReadA2:
		mov	word ptr [di+18h],0004h
		lea	bx,word ptr [di+1ah]
		mov	word ptr [di+14h],bx
		mov	word ptr [di+16h],ds
		mov	bx,word ptr [di+0ah]
		or		word ptr [di].s_state,B1+B0	;03
NetReadA3:
		mov	cx,word ptr [di+18h]
		lds	si,dword ptr [di+14h]
NetReadA4:
		xor	ax,ax
		push	es
		push	di
		mov	es,ax
		mov	di,ax
		push	cx
		mov	dx,0040h
		mov	ah,1bh			;net_read
		call	near ptr KernelAPI
		pop	cx
		pop	di
		pop	es
		jnb	NetReadA7
		mov	bp,ds
		push	cs
		pop	ds
		call	near ptr CheckAPIerr
		je		NetReadA5
		test	word ptr [di].s_state,B11	;0800h
		je		NetReadA5
		jmp	near ptr NetReadA13
NetReadA5:
		mov	word ptr [di+14h],si
		mov	word ptr [di+16h],bp
		mov	word ptr [di+18h],cx
NetReadA6:
		pop	si
		retn
;-----------------------------------------------------
NetReadA7:
		add	si,ax
		sub	cx,ax
		jne	NetReadA4
		push	cs
		pop	ds
		xor	ax,ax
		test	word ptr [di].s_state,B1	;0002h
		je		NetReadA11
		mov	ax,word ptr [di+1ah]
		or		al,al
		jne	NetReadA2
		and	word ptr [di].s_state,not B1	;fffdh
		mov	dx,word ptr [di+1ch]
		xchg	dh,dl
		mov	word ptr [di+1ch],dx
NetReadA8:
		mov	bp,000eh
		call	near ptr DeQueAdd
		jne	NetReadA9
		call	near ptr GetSesName
		lea	bp,word ptr [bx+1fh]
		call	near ptr DeQue
		jne	NetReadA9
		mov	bp,offset RcvAnyQue
		call	near ptr DeQue
		je		NetReadA6
NetReadA9:
		mov	word ptr [si].cb_ptr,di
		or		byte ptr [si].cb_stat,C4
		and	byte ptr [si].cb_stat,not C_TIMING
		mov	word ptr [di+12h],si
		or		word ptr [di].s_state,B11	;0800h
		les	bx,dword ptr [si].cb_ncb_off
		mov	cx,word ptr es:[bx].ncb_length
		xor	ax,ax
		cmp	al,byte ptr [di+1bh]
		jne	NetReadA10
		mov	dx,word ptr [di+1ch]
		cmp	cx,dx
		jb		NetReadA10
		xchg	cx,dx
NetReadA10:
		sub	word ptr [di+1ch],cx
		sbb	byte ptr [di+1bh],al
		mov	word ptr es:[bx].ncb_length,cx
		jcxz	NetReadA11
		lds	dx,dword ptr es:[bx].ncb_buffer
		mov	ax,ds
		push	cs
		pop	ds
		or		ax,ax
		je		NetReadA11
		mov	word ptr [di+16h],ax
		mov	word ptr [di+14h],dx
		mov	word ptr [di+18h],cx
		mov	bx,word ptr [di+0ah]
		jmp	near ptr NetReadA3
NetReadA11:
		or		al,byte ptr [di+1bh]
		jne	NetReadA12
		or		ax,word ptr [di+1ch]
		je		NetReadA13
NetReadA12:
		mov	al,06
		jmp	short NetReadA14
NetReadA13:
		and	word ptr [di].s_state,not (B1+B0)	;fffc
NetReadA14:
		test	word ptr [di].s_state,B11	;0800h
		je		NetReadA18
		and	word ptr [di].s_state,not B11;	0f7ffh
		mov	si,word ptr [di+12h]
		les	bx,dword ptr [si].cb_ncb_off
		sub	word ptr es:[bx].ncb_length,cx
		mov	byte ptr [si].cb_comstat,al
		or		al,al
		jne	NetReadA16
		inc	word ptr ds:NumReadsLo
		jne	NetReadA15
		inc	word ptr ds:NumReadsHi
NetReadA15:
		jmp	short NetReadA17
NetReadA16:
		cmp	al,06
		je		NetReadA17
		inc	word ptr ds:wAbortTran
NetReadA17:
		and	byte ptr [si].cb_stat,not C4
		mov	bp,offset CBQue
		call	near ptr MoveToQue
NetReadA18:
		jmp	near ptr NetReadA1
NetReadA	endp

CheckAPIerr:
		cmp	al,ERR_WOULD_BLOCK	;15h
		je		CheckAPIerrExit
		cmp	al,ERR_NO_MEM			;03h
		je		CheckAPIerrExit
		cmp	al,24h
		je		CheckAPIerrExit
		cmp	al,1ch
		je		CheckAPIerrExit
		cmp	al,ERR_RE_ENTRY	;1bh
		je		CheckAPIerrExit
		cmp	al,ERR_TIMEOUT		;0dh
		je		CheckAPIerrExit
		mov	al,40h
CheckAPIerrExit:
		retn
;-----------------------------------------------------
		db	24d dup (00h)
StackMarker	dw	0cccc
		db	1024d dup (00h)
StackPointer1	dw	0cccc
SaveC_SS	dw	00
SaveC_SP	dw	00
Int2aFlag	db	00
;-----------------------------------------------------

HandleCompltn	proc near
		pushf
		cli
		neg	byte ptr ds:Int2aFlag
		jne	HandleCompl4
		not	byte ptr ds:Int2aFlag
		mov	word ptr ds:SaveC_SS,ss
		mov	word ptr ds:SaveC_SP,sp
		push	cs
		pop	ss
		mov	sp,offset StackPointer1
		sti
HandleComp1:
		mov	bp,offset CBCompletion
		call	near ptr DeQue
		je		HandleCompl3
		push	si
ifdef TRACE_DUMP
		call	near ptr TraceDump_p
endif
		les	bx,dword ptr [si].cb_ncb_off
		call	near ptr ReleaseCB
		mov	ax,0ffffh
		push	ax
		mov	al,byte ptr es:[bx].ncb_retcode
		mov	ah,al
		pushf
		call	dword ptr es:[bx].ncb_post
HandleCompl2:
		pop	ax
		cmp	ax,-01
		jne	HandleCompl2
		push	cs
		pop	ds
		pop	si
ifdef TRACE_DUMP
		call	near ptr TraceDump_e
endif
		cmp	word ptr ds:StackMarker,0cccch
		je	HandleComp1
		mov	cl,01
		call	near ptr HaltSystem
HandleCompl3:
		cli
		mov	ss,word ptr ds:SaveC_SS
		mov	sp,word ptr ds:SaveC_SP
		mov	byte ptr ds:Int2aFlag,00
HandleCompl4:
		popf
		retn
HandleCompltn	endp

FinishUp	proc near
		and	byte ptr [si].cb_stat,not C_TIMING
		les	bx,dword ptr [si].cb_ncb_off
		mov	ax,es
		neg	ax
		je		FinishUp1
		mov	al,byte ptr [si].cb_comstat
		mov	byte ptr es:[bx].ncb_retcode,al
		mov	byte ptr es:[bx].ncb_cmd_cplt,al
		test	byte ptr es:[bx],80h
		je		FinishUp1
		mov	ax,word ptr es:[bx].ncb_post
		or		ax,word ptr es:[bx].ncb_post+2
		je		FinishUp1
		mov	bp,offset CBCompletion
		call	near ptr MoveToQue
		xor	si,si
		jmp	short FinishUpExit
FinishUp1:
ifdef TRACE_DUMP
		call	near ptr TraceDump
endif
		xor	ax,ax
		mov	word ptr [si].cb_id,ax
FinishUpExit:
		retn
FinishUp	endp

GetSession	proc near
		mov	byte ptr [si].cb_comstat,11h
		call	near ptr GetFreeSession
		jb		GetSessionExit
		mov	word ptr [di+30h],dx
		mov	bp,bx
		xchg	si,di
		add	bp,13h
		call	near ptr MoveToQue
		xchg	si,di
GetSessionExit:
		mov	bx,di
		retn
GetSession	endp

SetRetry	proc near
		mov	al,byte ptr ds:Retry2
		mov	byte ptr [si].cb_retry,al
		retn
SetRetry		endp

ChainSendC	proc near
		or		byte ptr [si].cb_stat,C3
		retn
ChainSendC	endp

SetSessSrvc	proc near
		mov	word ptr ds:AddrStrFSock,SSN_SRVC_TCP_P
		clc
		retn
SetSessSrvc	endp

SetOpen		proc near
		mov	cx,sp
		jmp	short SetOpen1
SetOpen0:
		xor	cx,cx
SetOpen1:
		push	si
		xchg	bx,di
		push	di
		mov	byte ptr [si].cb_comstat,09
		mov	ah,29h			;net_getglobdesc
		call	near ptr KernelAPI
		jb		SetOpen3
		mov	word ptr [di+0ah],ax
		mov	bx,ax
		push	ds
		pop	es
		mov	byte ptr [si].cb_comstat,40h
		or		cx,cx
		je		SetOpen2
		mov	cx,0001h		;NET_AS_OPEN
		mov	dx,offset AsOpenHandler
		mov	ah,1fh			;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		jb		SetOpen3
SetOpen2:
		mov	cx,0007h		;NET_AS_ERROR
		mov	dx,offset AsOpenHandler
		mov	ah,1fh			;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		jb		SetOpen3
		mov	cx,0002h		;NET_AS_RCV
		mov	dx,offset AsOpenHandler
		mov	ah,1fh			;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		jb		SetOpen3
		pop	dx
		push	dx
		xor	cx,cx
		xor	si,si
		mov	di,0001h
		mov	ah,20h			;set_option
		call	near ptr KernelAPI
		jb		SetOpen3
		pop	dx
		pop	si
		mov	byte ptr [si].cb_comstat,00
		jmp	short SetOpenExit
SetOpen3:
		pop	dx
		pop	si
SetOpenExit:
		clc
		retn
SetOpen		endp

NetConnect	proc near
		push	si
		mov	di,dx
		mov	word ptr [di+23h],si
		mov	al,byte ptr ds:Count4
		mov	byte ptr [si].cb_timer,al
		mov	byte ptr [si].cb_stat,C_TIMING
		mov	dx,0004h
		push	di
		lea	di,word ptr [di+25h]
		push	di
		mov	si,offset AddrStrFAddr
		push	cs
		pop	es
		movsw
		movsw
		movsw
		xor	ax,ax
		stosw
		pop	si
		pop	di
		mov	bx,word ptr [di+0ah]
		mov	ah,13h			;net_connect
		call	near ptr KernelAPI
		pop	si
		clc
		retn
NetConnect	endp

NetAbortA	proc near
		xor	ax,ax
		mov	di,word ptr [si].cb_ptr
		or		al,byte ptr [si].cb_comstat
		je		NetAbortAExit
		mov	bp,word ptr [di+30h]
		call	near ptr NetAbort
HandleNegResp82:
		mov	al,14h
		mov	byte ptr [si].cb_comstat,al
HandleNegResp:
		mov	cx,S_FREE	;8000h
		cmp	bp,word ptr ds:CacheBuf
		jb		NetAbortA3
		test	ch,byte ptr [bp+10h]
		je		NetAbortA2
		mov	di,bp
		call	near ptr LookCache
		jmp	short NetAbortA5
NetAbortA2:
		inc	cx
NetAbortA3:
		xor	ax,ax
		mov	al,byte ptr [si].cb_retry
		dec	al
		mov	byte ptr [si].cb_retry,al
		jne	NetAbortA5
		dec	cx
		jns	NetAbortA4
		cmp	word ptr [bp].c_age,0ffffh
		nop
		je		NetAbortA4
		mov	word ptr [bp].c_age,ax
NetAbortA4:
		stc
NetAbortA5:
		mov	word ptr [si].cb_ptr,bp
NetAbortAExit:
		retn
NetAbortA	endp

NetReadC	proc near
		push	si
		xor	ax,ax
		mov	bp,word ptr [si].cb_ptr
		or		al,byte ptr [si].cb_comstat
		jne	NetReadC5
		test	word ptr [bp].s_state,B1+B0	;0003h
		je		NetReadC5
		mov	word ptr [bp+23h],si
		inc	byte ptr [si].cb_timer
		or		byte ptr [si].cb_stat,C_TIMING
		test	word ptr [bp].s_state,B1	;0002h
		je		NetReadC2
		mov	cx,0004h
		lea	si,word ptr [bp+1ah]
NetReadC1:
		call	near ptr NetReadB
		mov	ax,sp
		jb		NetReadCExit
		cmp	byte ptr [bp+1ah],85h
		je		NetReadC1
		and	word ptr [bp].s_state,not B1	;fffd
NetReadC2:
		mov	cx,word ptr [bp+1ch]
		xchg	cl,ch
		or		cx,cx
		je		NetReadC4
		cmp	cx,word ptr ds:NetReadLen
		jb		NetReadC3
		mov	cx,word ptr ds:NetReadLen
NetReadC3:
		mov	si,word ptr ds:NetIOBuf
		call	near ptr NetReadB
		mov	ax,sp
		jb		NetReadCExit
NetReadC4:
		and	word ptr [bp].s_state,not B0	;fffeh
NetReadC5:
		xor	ax,ax
		mov	word ptr [bp+23h],ax
NetReadCExit:
		pop	si
		clc
		retn
NetReadC	endp

NetWriteC		proc near
		push	si
		mov	bp,word ptr [si].cb_ptr
		or		word ptr [bp].s_state,B1+B0	;03
		mov	word ptr [bp+23h],si
		mov	al,byte ptr ds:Count4
		mov	byte ptr [si].cb_timer,al
		mov	byte ptr [si].cb_stat,C_TIMING
		mov	di,word ptr ds:NetIOBuf
		xor	ax,ax
		mov	byte ptr [di],81h
		mov	byte ptr [di+01],al
		push	di
		add	di,04
		push	si
		mov	si,word ptr [bp+30h]
		push	cs
		pop	es
		call	near ptr ExpandName
		pop	si
		lds	si,dword ptr [si].cb_ncb_off
		add	si,ncb_name		;1ah
		call	near ptr ExpandName
		pop	si
		mov	bx,word ptr [bp+0ah]
		call	near ptr NetWriteB
		xor	ax,ax
		pop	si
		retn
NetWriteC		endp

NetAbortB	proc near
		push	si
		mov	di,word ptr [si].cb_ptr
		mov	cl,byte ptr [di+1ah]
		xor	ax,ax
		mov	byte ptr [si].cb_comstat,al
		cmp	cl,82h		;test for pos session response
		je		NetAbortBExit	;positive response
		mov	byte ptr [si].cb_comstat,12h
		mov	dx,word ptr [di+30h]
		call	near ptr NetAbort
		cmp	cl,83h		;test for negative response
		jne	NetAbortB2	;not negative
		mov	bp,word ptr ds:NetIOBuf	;negative response
		cmp	byte ptr [bp+00],83h;test for out of resources
		jne	TestFor82
		mov	byte ptr [si].cb_retry,1	;no retry
		mov	byte ptr [si].cb_comstat,9h	;out of resources error
TestFor82:
		mov	ax,offset HandleNegResp
		cmp	byte ptr [bp+00],82h
		jne	NetAbortB1
		mov	ax,offset HandleNegResp82;called name not present
NetAbortB1:
		mov	bp,dx
		call	ax
		neg	ax
		stc
		je		NetAbortBExit
		call	near ptr RemoteIPAddress
		not	ax
		jmp	short NetAbortBExit
NetAbortB2:
		call	near ptr FindCallingName
		mov	bx,bp
		push	ds
		pop	es
		mov	di,offset AddrStrFAddr
		mov	si,word ptr ds:NetIOBuf
		movsw
		movsw
		lodsw
		xchg	al,ah
		stosw
NetAbortBExit:
		pop	si
		retn
NetAbortB	endp

SetUpOpen	proc near
		push	si
		mov	di,word ptr [si].cb_ptr
		mov	ax,word ptr [si].cb_ncb_seg0
		mov	word ptr [di].s_ncbseg,ax
		les	bx,dword ptr [si].cb_ncb_off
		mov	ax,di
		sub	ax,word ptr ds:SesBuf
		mov	cl,32h
		div	cl
		inc	al
		mov	byte ptr es:[bx].ncb_lsn,al
		mov	ah,byte ptr ds:TimeOut
		mov	al,byte ptr es:[bx].ncb_rto
		call	near ptr GetTimeOut
		mov	byte ptr [di].s_rto,al
		mov	al,byte ptr es:[bx].ncb_sto
		call	near ptr GetTimeOut
		mov	byte ptr [di].s_sto,al
		push	di
		xor	bp,bp			;clear error counter
		mov	bx,word ptr [di].s_nd
		push	ds
		pop	es
		mov	cx,0006h		;NET_AS_CLOSE
		mov	dx,offset AsCloseHandler
		mov	ah,1fh		;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		adc	bp,bp			;mark error if any
		mov	cx,0005h		;NET_AS_FCLOSE
		mov	dx,offset AsCloseHandler
		mov	ah,1fh		;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		adc	bp,bp
		mov	cx,0007h		;NET_AS_ERROR
		mov	dx,offset AsCloseHandler
		mov	ah,1fh		;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		adc	bp,bp
		mov	cx,0002h		;NET_AS_RCV
		mov	dx,offset AsRXHandler
		mov	ah,1fh			;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		adc	bp,bp
		mov	cx,0003h		;NET_AS_XMT
		mov	dx,offset AsRXHandler
		mov	ah,1fh			;net_asynch
		call	near ptr KernelAPI
		mov	dx,ds
		push	cs
		pop	ds
		adc	bp,bp
		mov	dx,sp
		xor	cx,cx
		xor	si,si
		mov	di,0006h
		mov	ah,20h			;set_option
		call	near ptr KernelAPI
		adc	bp,bp
		mov	di,000ch
		mov	ah,20h			;set_option
		call	near ptr KernelAPI
		adc	bp,bp
		pop	di
		pop	si
		and	word ptr [di].s_state,not (B4+B1+B0)	;ffech
		mov	byte ptr [si].cb_comstat,00
		or		bp,bp
		jne	SetUpOpenError
		mov	bp,word ptr [di].s_rnmptr
		cmp	word ptr ds:CacheBuf,bp
		ja		SetUpOpenExit
		or		word ptr [bp].c_age,0f000h
		jmp	short SetUpOpenExit
SetUpOpenError:
		mov	byte ptr [si].cb_comstat,40h
		call	near ptr NetAbort
		stc
SetUpOpenExit:
		retn
SetUpOpen	endp

GetTimeOut:
		cmp	al,01
		jne	GetTimeOut1
		inc	al
GetTimeOut1:
		test	al,al
		je		GetTimeOutExit
		cmp	ah,0ffh
		je		GetTimeOutExit
		mov	al,ah
GetTimeOutExit:
		retn

GetSesNameFrNCB:
		les	bx,dword ptr [si].cb_ncb_off
		mov	ah,08
		mov	al,byte ptr es:[bx].ncb_lsn
		dec	al
		push	ds
		pop	es
		cmp	byte ptr ds:NumSes,al
		jna	ErrRetAH
		mov	di,word ptr ds:SesBuf
		mov	ah,32h
		mul	ah
		add	di,ax
		mov	word ptr [si].cb_ptr,di
		test	word ptr [di].s_state,B8	;0100h
		je		GetSesNameFrCB
		call	near ptr NetAbortC
		mov	ah,byte ptr [di+0ch]
		jmp	short ErrRetAH

GetSesNameFrCB:
		mov	di,word ptr [si].cb_ptr
		mov	ah,08
		test	word ptr [di].s_state,S_FREE	;8000h
		jne	ErrRetAH

GetSesName: 					; session pointer in DI, return in BX
		mov	bx,word ptr [di].s_02
GetSesNameLoop:
		or		bx,bx
		jne	GetSesName2
		mov	cl,03
		call	near ptr HaltSystem
GetSesName2:
		mov	bp,word ptr [bx+02]
		xor	ax,ax
		or		ax,word ptr cs:[bp+00]
		jz		GetSesName3
		mov	bx,bp
		jmp	short GetSesNameLoop
GetSesName3:
		sub	bx,13h
		jmp	short GetSesNameExit
ErrRetAH:
		mov	byte ptr [si].cb_comstat,ah
		stc
GetSesNameExit:
		retn

HangupStatus:
		mov	di,word ptr [si].cb_ptr
		mov	al,byte ptr ds:Count30
		test	word ptr [di].s_state,S_FREE	;8000h
		jnz	HangupStatusExit
		or		word ptr [di].s_state,S_HUP+S_CLOSED	;2020h
		test	word ptr [di].s_state,S_WR1	;0004h
		jz		HangupStatusExit
		mov	byte ptr [si].cb_timer,al
		or		byte ptr [si].cb_stat,C_TIMING
		mov	word ptr [di].s_cb,si
		xor	ax,ax
HangupStatusExit:
		retn

EofErr18:
		mov	al,18h
		jmp	short EofErr
EofErr0A:
		mov	al,0ah
EofErr:
		mov	di,word ptr [si].cb_ptr
		test	word ptr [di].s_state,S_FREE	;8000h
		jne	EofErrExit
		mov	word ptr [di].s_cb,0000h
		test	word ptr [di].s_state,S_CLOSED		;0020h
		jnz	EofNoDeque
		or		word ptr [di].s_state,B8+S_CLOSED	;0120h
		lea	bp,word ptr [bx+1fh]
		call	near ptr DeQueExecOne
		call	near ptr ExecD
EofNoDeque:
		mov	bx,word ptr [di].s_nd
		mov	ah,18h			;net_eof
		call	near ptr KernelAPI
		clc
EofErrExit:
		retn

StartRcvAny		proc near
		les	bx,dword ptr [si].cb_ncb_off
		mov	dx,offset NetReadA
		mov	cx,word ptr ds:NumSes
		call	near ptr GetNamePtr	;return pointer to name in di
		jb		StartRcvAny3
		mov	bx,di
		lea	di,word ptr [bx+13h]
StartRcvAny1:
		mov	di,word ptr [di]
		test	di,di
		je		StartRcvAny2
		call	near ptr CheckSession
		jnb	StartRcvAny1
		jmp	near ptr ReceiveCExit
StartRcvAny2:
		lea	bp,word ptr [bx+1fh]
		mov	di,word ptr ds:SesBuf
		jmp	short ReceiveC5
StartRcvAny3:
		cmp	byte ptr es:[bx].ncb_num,0ffh
		jb		ReceiveCExit
		mov	di,word ptr ds:SesBuf	;receive from all names
StartRcvAny4:
		call	near ptr CheckSession
		jb		ReceiveCExit
		add	di,32h
		loop	StartRcvAny4
		mov	di,word ptr ds:SesBuf
		mov	cx,word ptr ds:NumSes
		mov	bp,offset RcvAnyQue
		jmp	short ReceiveC6
SendC:
		mov	dx,offset NetWrite
		mov	bp,001fh
		jmp	short ReceiveC2
ReceiveC:
		mov	di,word ptr [si].cb_ptr
		mov	al,byte ptr [di+0ch]
		mov	byte ptr [si].cb_timer,al
		test	al,al
		je		ReceiveC1
		or		byte ptr [si].cb_stat,C_TIMING
ReceiveC1:
		mov	bp,000eh
		mov	dx,offset NetReadA
ReceiveC2:
		mov	cx,0001h
		mov	di,word ptr [si].cb_ptr
		mov	byte ptr [si].cb_comstat,0ah
		test	word ptr [di].s_state,S_FREE+S_CLOSED	;8020h
		je		ReceiveC4
ReceiveC3:
		stc
		retn
;-----------------------------------------------------
ReceiveC4:
		add	bp,di
ReceiveC5:
		mov	byte ptr [si].cb_comstat,17h
		test	word ptr [bx+10h],1800h
		jne	ReceiveC3
ReceiveC6:
		call	near ptr MoveToQue
		push	si
		mov	si,dx
ReceiveC7:
		test	word ptr [di].s_state,S_FREE+S_HUP+B8+S_CLOSED+B4	;0a130h
		jnz	ReceiveC8
		xor	bx,bx
		mov	ax,sp
		or		dx,dx
		je		ReceiveC9
		call	near ptr SessionCall
ReceiveC8:
		add	di,32h
		loop	ReceiveC7
ReceiveC9:
		pop	si
		clc
ReceiveCExit:
		retn
StartRcvAny		endp

CheckSession		proc near
		test	word ptr [di].s_state,B8	;0100h
		jz		CheckSessionExit
		mov	word ptr [si].cb_ptr,di
		call	near ptr NetAbortC
		mov	ah,byte ptr [di+0ch]
		mov	byte ptr [si].cb_comstat,ah
		mov	ax,di
		sub	ax,word ptr ds:SesBuf
		mov	bl,32h
		div	bl
		les	bx,dword ptr [si].cb_ncb_off
		mov	byte ptr es:[bx].ncb_lsn,al
		stc
CheckSessionExit:
		retn
CheckSession		endp

RcvAnyC		proc near
		mov	di,word ptr [si].cb_ptr
		mov	ax,di
		sub	ax,word ptr ds:SesBuf
		mov	cl,32h
		div	cl
		push	ax
		mov	di,word ptr [si].cb_ptr
		call	near ptr GetSesName
		mov	al,23h
		sub	bx,offset NamesBuf
		xchg	ax,bx
		div	bl
		les	bx,dword ptr [si].cb_ncb_off
		inc	al
		mov	byte ptr es:[bx].ncb_num,al
		pop	ax
		inc	al
		mov	byte ptr es:[bx].ncb_lsn,al
		retn
RcvAnyC		endp

ExecD		proc near
		mov	di,word ptr [si].cb_ptr
		test	word ptr [di].s_state,S_FREE	;8000h
		js		ExecD3
		or		word ptr [di].s_state,B9	;0200h
		push	si
		test	word ptr [di].s_state,S_WR1	;0004h
		je		ExecD1
		mov	si,word ptr [di+23h]
		call	near ptr ExecOne
ExecD1:
		test	word ptr [di].s_state,B11	;0800h
		je		ExecD2
		mov	si,word ptr [di].s_12
		call	near ptr ExecOne
ExecD2:
		pop	si
		mov	bp,s_sendq
		add	bp,di
		call	near ptr DeQueExecAll
		add	bp,s_rcvq-s_sendq
		call	near ptr DeQueExecAll
		mov	byte ptr [di].s_rto,al
ExecD3:
		xor	ax,ax
		retn
ExecD		endp

Listen		proc near
		push	si
		xor	ax,ax
		mov	byte ptr [si].cb_stat,al
		cmp	al,byte ptr [si].cb_comstat
		jb		Listn1
		mov	di,dx
		mov	word ptr [di+23h],si
		or		word ptr [di].s_state,B1+B0	;03
		mov	dx,0004h
		mov	bx,word ptr [di+0ah]
		push	di
		lea	di,word ptr [di+25h]
		push	cs
		pop	es
		push	di
		stosw
		stosw
		stosw
		mov	al,8bh
		stosw
		pop	si
		mov	ah,23h			;net_listen
		call	near ptr KernelAPI
		pop	di
		pop	si
		push	si
		jnb	Listen2
Listn1:
		mov	byte ptr [si].cb_timer,02
		mov	byte ptr [si].cb_stat,C_TIMING
Listen2:
		pop	si
		clc
		retn
Listen		endp

QueListen		proc near
		mov	bp,word ptr [si].cb_ptr
		add	bp,17h
		call	near ptr MoveToQue
		retn
QueListen		endp

ChainCheckBuf:
		clc
		jmp	short CheckBuf1

CheckBuf:
		stc
CheckBuf1:
		mov	byte ptr [si].cb_comstat,01
		les	bx,dword ptr [si].cb_ncb_off
		mov	ax,word ptr es:[bx].ncb_length
		mov	dx,word ptr es:[bx].ncb_buffer
		jb		CheckBuf2
		mov	cx,word ptr es:[bx].ncb_buffer2
		add	cx,word ptr es:[bx].ncb_length2
		jnb	CheckBuf2
		jne	CheckBufExit
CheckBuf2:
		add	dx,ax
		jnb	CheckBufExit
		jne	CheckBufExit
		clc
CheckBufExit:
		retn

SetStateB8:
		mov	di,word ptr [si].cb_ptr
		xchg	ax,dx
		or		ax,ax
		je		SetStateB8Exit
		or		word ptr [di].s_state,B8	;0100h
SetStateB8Exit:
		retn

Close		proc near
		push	si
		mov	di,word ptr [si].cb_ptr
		mov	bx,word ptr [di+0ah]
		xor	ax,ax
		or		al,byte ptr [si].cb_comstat
		jne	Close1
		cmp	byte ptr [di+1ah],81h
		je		Close2
Close1:
		jmp	near ptr Close9
Close2:
		mov	dx,di
		mov	si,word ptr ds:NetIOBuf
		mov	di,si
		push	di
		push	cs
		pop	es
		call	near ptr CompressName
		pop	di
		call	near ptr GetNameNumA
		mov	byte ptr [di+04],82h
		jb		Close8
		xor	ax,ax
Close3:
		lodsb
		or		al,al
		je		Close5
		add	si,ax
		cmp	si,offset IPAddress
		jb		Close3
Close4:
		mov	byte ptr [di+04],8fh
		jmp	short Close8
Close5:
		cmp	si,offset K2
		jnb	Close4
		mov	byte ptr [di+04],81h
		cmp	word ptr [bp+17h],ax
		je		Close8
		push	di
		mov	di,si
		push	si
		call	near ptr CompressName
		pop	si
		call	near ptr NBStartB
		pop	di
		jb		Close8
		xchg	si,di
		mov	bx,dx
		xor	ax,ax
		mov	word ptr [bx+30h],ax
		call	near ptr GetNameNumA
		jnb	Close6
		lea	bx,word ptr [bx+19h]
		mov	bp,S_FREE	;8000h
		call	near ptr AddCache
		jb		Close7
		or		word ptr [bp+15h],0f000h
Close6:
		mov	bx,dx
		mov	word ptr [bx+30h],bp
Close7:
		mov	di,si
		mov	ax,0082h
		add	di,04
		call	near ptr SetStat
		xor	ax,ax
		jmp	short Close10
Close8:
		mov	si,di
		mov	ax,0083h
		add	di,05
		call	near ptr SetStat
Close9:
		mov	ah,18h			;net_eof
		call	near ptr KernelAPI
		mov	ah,19h			;net_abort
		call	near ptr KernelAPI
		mov	ax,sp
Close10:
		pop	si
		mov	bx,word ptr [si].cb_ptr
		retn
Close		endp
;-----------------------------------------------------
Star		db	'*'
;-----------------------------------------------------

NBStartB	proc near
		push	bp
		push	si
		mov	bx,si
		mov	cx,0010h
		add	bp,17h
		call	near ptr NBStartA
		jnb	NBStartB1
		mov	cl,01
		mov	si,offset Star
		call	near ptr NBStartA
NBStartB1:
		push	ds
		pop	es
		pop	si
		pop	bp
		retn
NBStartB	endp

NBStartA	proc near
		push	bp
NBStartA1:
		mov	bp,word ptr [bp+00]
		or		bp,bp
		stc
		je		NBStartAExit
		les	di,dword ptr [bp+0ah]
		add	di,0ah
		push	di
		push	cx
		repz	cmpsb			;Flgs=DS:[SI]-ES:[DI]
		pop	cx
		pop	di
		jne	NBStartA1
		mov	si,bx
		mov	bx,word ptr ds:NetIOBuf
		mov	byte ptr [bx+04],83h
		call	near ptr NBStart
		jb		NBStartAExit
		mov	cx,0010h
		rep	movsb
		mov	si,bp
		mov	word ptr [si].cb_ptr,dx
		pop	bp
		push	bp
		add	bp,-04
		xchg	dx,si
		call	near ptr MoveToQue
		xchg	dx,si
		call	near ptr Unlink
		push	dx
		xor	ax,ax
		call	near ptr Execute
		pop	dx
		clc
NBStartAExit:
		pop	bp
		retn
NBStartA	endp

DeQueExecAll:
		xor	ah,ah
		jmp	short DeQueExec1

ExecOne:
		push	si
		mov	ah,01
		jmp	short DeQueExec3

DeQueExecOne:			;bp has address of queue pointer
		mov	ah,01
DeQueExec1:
		push	si
DeQueExecLoop:
		call	near ptr DeQue
		je		DeQueExecOneExit
DeQueExec3:
		mov	byte ptr [si].cb_comstat,al
		mov	word ptr [si].cb_ptr,di
		test	di,di
		jz		DeQueExec4
		and	word ptr [di].s_state,not B8	;0feffh
DeQueExec4:
		push	ax
		push	di
		push	bp
		cmp	di,si
		call	near ptr Execute
		pop	bp
		pop	di
		pop	ax
		or		ah,ah
		jz		DeQueExecLoop
DeQueExecOneExit:
		pop	si
		retn

NetReadB	proc near
		mov	bx,word ptr [bp+0ah]
		lea	di,word ptr [bp+25h]
		push	cs
		pop	es
		mov	dx,0002h
		push	cx
		mov	ah,1bh			;net_read
		call	near ptr KernelAPI
		jb		NetReadBExit
		pop	ax
		cmp	cx,ax
		jb		NetReadBExit
		xor	dx,dx
		mov	ah,1bh			;net_read
		call	near ptr KernelAPI
		inc	word ptr ds:NumReadsLo
		jne	NetReadBExit
		inc	word ptr ds:NumReadsHi
NetReadBExit:
		retn
NetReadB	endp

SetStat		proc near
		mov	byte ptr [si],al
		mov	byte ptr [si+01],ah
		mov	bp,dx
		mov	bx,word ptr [bp+0ah]
SetStat		endp

NetWriteB	proc near
		mov	cx,di
		sub	cx,si
		mov	ax,cx
		sub	ax,04
		xchg	ah,al
		mov	word ptr [si+02],ax
		xor	dx,dx
		mov	ah,1ah			;net_write
		call	near ptr KernelAPI
		jnb	NetWriteB1
		inc	word ptr ds:wAbortTran
		jmp	short NetWriteBExit
NetWriteB1:
		add	si,ax
		sub	ax,cx
		jb		NetWriteBExit
		mov	ah,1eh			;net_flush
		call	near ptr KernelAPI
		inc	word ptr ds:wGoodTranLo
		jne	NetWriteBExit
		inc	word ptr ds:wGoodTranHi
NetWriteBExit:
		retn
NetWriteB	endp

GetFreeSession	proc near
		mov	di,word ptr ds:SesBuf
		mov	cx,word ptr ds:NumSes
GFSession1:
		test	word ptr [di].s_state,S_FREE	;8000h
		jne	FreeSesFound
		add	di,32h
		loop	GFSession1
		stc
		jmp	short GFSessionExit
FreeSesFound:
		mov	word ptr [di].s_state,B4	;0010h
		mov	ax,word ptr [si].cb_ncb_seg0
		mov	word ptr [di].s_ncbseg,ax
		mov	word ptr [si].cb_ptr,di
		inc	word ptr ds:SessionsUsed
GFSessionExit:
		retn
GetFreeSession	endp

NetAbortD:
		mov	di,word ptr [si].cb_ptr
		test	word ptr [di].s_state,S_HUP	;2000h
		jnz	NetAbortC
		test	word ptr [di].s_state,B8	;0100h
		jnz	NetAbortCExit

NetAbortC:
		call	near ptr GetSesNameFrCB
		push	bx
		call	near ptr NetAbort
		pop	bx
		test	word ptr [bx+10h],1000h
		je		NetAbortCExit
		or		ax,word ptr [bx+13h]
		jne	NetAbortCExit
		mov	bp,bx
		call	near ptr DeQueExecB
NetAbortCExit:
		retn

NetAbort	proc near
		test	word ptr [di].s_state,S_FREE	;8000h
		jne	NetAbortExit
		mov	bx,word ptr [di+0ah]
		mov	ah,19h			;net_abort
		call	near ptr KernelAPI
		xchg	si,di
		call	near ptr Unlink
		xchg	si,di
		xor	ax,ax
		mov	word ptr [di].s_cb,ax
		mov	word ptr [di].s_ncbseg,ax
		mov	word ptr [di].s_12,ax
		mov	word ptr [di].s_23,ax
		mov	word ptr [di].s_state,S_FREE	;8000h
		dec	word ptr ds:SessionsUsed
NetAbortExit:
		retn
NetAbort	endp

NBStart		proc near
		call	near ptr SaveAll
		call	near ptr GetFreeCB
		jb		NBStartExit
		mov	bx,offset NamesBuf
		xor	dx,dx
		call	near ptr GetSession
		jb		NBStart1
		mov	byte ptr [si].cb_comstat,4ch
		call	near ptr Execute
		clc
		jmp	short NBStartExit
NBStart1:
		call	near ptr ReleaseCB
		stc
NBStartExit:
		retn
;-----------------------------------------------------
pTraceBuf	dw	00
;-----------------------------------------------------
NBStart		endp

TracePrint	proc near
		push	cs
		pop	es
		test	word ptr ds:TraceBuf,0ffffh
		jne	TracePrint1
		jmp	near ptr StringOut
TracePrint1:
		mov	di,word ptr ds:pTraceBuf
		mov	bx,word ptr ds:TraceBuf
		add	bx,2710h
TracePrintNext:
		cmp	di,bx
		jb		TracePrint3
		mov	di,word ptr ds:TraceBuf
TracePrint3:
		lodsb
		test	al,al
		je		TracePrintExit
		stosb
		jmp	short TracePrintNext
TracePrintExit:
		mov	word ptr ds:pTraceBuf,di
		retn
;-----------------------------------------------------
Config10:
		call	near ptr StartListens
		call	near ptr SetVecs
		pop	dx
		pop	ax
		int	21h			;DOS:
;-----------------------------------------------------
TopAddress	db	00,00,00,00
;-----------------------------------------------------
TracePrint	endp

StartListens	proc near
		push	si
		cli
		xor	ax,ax
		mov	byte ptr ds:StartFlag,al
		mov	di,offset NamesBuf
		mov	cx,word ptr ds:NumNBNames
		jmp	short StartLis1
ClrNmFlags:
		and	word ptr [di+10h],63ffh
StartLis1:
		add	di,23h
		loop	ClrNmFlags
		sti
		cmp	word ptr ds:NameNd,00
		jne	NameSrvRunning
		call	near ptr NameSrvcListen
NameSrvRunning:
		cmp	word ptr ds:DgramNd,00
		jne	DGsrvRunning
		call	near ptr DgramListen
DGsrvRunning:
		call	near ptr NBStart
		mov	ah,12h			;enable_asynch
		call	near ptr KernelAPI
		xor	ax,ax
		pop	si
		retn
StartListens	endp

NetAbortND	proc near
		xor	bx,bx
		xchg	bx,word ptr ds:NameNd
		test	bx,bx
		je		NetAbortND1
		mov	ah,19h			;net_abort
		call	near ptr KernelAPI
NetAbortND1:
		xor	bx,bx
		xchg	bx,word ptr ds:DgramNd
		test	bx,bx
		je		NetAbortND2
		mov	ah,19h			;net_abort
		call	near ptr KernelAPI
NetAbortND2:
		xor	ax,ax
		mov	word ptr ds:UDPup,ax
		retn
NetAbortND	endp

UnloadNB	proc near
		push	ds
		push	cs
		pop	ds
		call	near ptr CallNBC_clc
		jb		UnloadNBExit
		mov	byte ptr ds:lana,0ffh
		mov	ah,11h			;disable_asynch
		call	near ptr KernelAPI
UnloadNB1:
		call	near ptr HandleQue
		call	near ptr GetFreeCB
		jb		UnloadNB1
		mov	byte ptr [si].cb_comstat,47h
		mov	bp,offset CBQue
		call	near ptr MoveToQue
		call	near ptr HandleQue
		call	near ptr NetAbortND
		call	near ptr CallNBC_ResVec
		push	cs
		pop	es
		mov	ah,49h
		int	21h			;DOS:49-release mem,ES=block seg
		mov	ah,12h			;enable_asynch
		call	near ptr KernelAPI
UnloadNBExit:
		pop	ds
		retf
UnloadNB	endp

NumToString	proc near
		push	cx
		mov	cx,0004h
		or		al,al
		je		NumToString1
		shr	cx,1
NumToString1:
		push	cx
		mov	cx,0004h
		rol	bx,cl			;LO]<--[HI..LO]<--[HI
		pop	cx
		mov	ax,000fh
		and	ax,bx
		cmp	al,0ah
		jb		NumToString2
		sub	al,09
		add	al,40h
		jmp	short NumToString3
NumToString2:
		add	al,30h
NumToString3:
		stosb
		loop	NumToString1
		pop	cx
		retn
NumToString	endp

StringOut	proc near
		push	dx
StringOutNext:
		lodsb
		or		al,al
		je		StringOutExit
		mov	ah,0eh
		int	10h		;CRT:0e-wr Teletype mode,AL=char
		jmp	short StringOutNext
StringOutExit:
		pop	dx
		retn
StringOut	endp
;-----------------------------------------------------
NetbiosCodes	db	49,0f0,0f5,0f6,0fe,0fdh
					db	0f7,0f8,4a,90,91,92
					db	93,94,95,96,4c,05
					db	06,07,48,4dh,4e
RealNBCodes		db	12,14,15,16,17,20
					db	22,21,23,10,11,30
					db	36,78,31,34,35,33
					db	32
UnsupNBCodes	db	70,47,00,00

NetbiosFuncPtr	F	NBF49NmSvRcv
					F	NBFf0
					F	NBFf5
					F	NBFf6
					F	NBFfe
					F	NBFfd
					F	NBFf7    ; f7
					F	NBFf7		; f8
					F	NBF4aDgrmRcv
					F	NBF90    ; 90
					F	NBF90   	; 91
					F	NBF90    ; 92
					F	NBFf7    ; 93
					F	NBFf7    ; 94
					F	NBFf7    ; 95
					F	NBFf7    ; 96
					F	NBF4c
					F	NBF05AsFclose
					F	NBF06AsClose
					F	NBF07AsError
					F	NBF48Tick
					F	NBF4dTCPXmt
					F	NBF4eTCPRcv
					F	NBF12HangUp
					F	NBF14Send
					F	NBF15Receive
					F	NBF16RcvAny
					F	NBF17ChainSend
					F	NBF20SendDgrm
					F	NBF22SendBcDgm
					F	NBF21RcvDgrm
					F	NBF23RcvBcDgm
					F	NBF10Call
					F	NBF11Listen
					F	NBF30AddName
					F	NBF36AddGrName
					F	NBF78
					F	NBF31DelName
					F	NBF34SessnStat
					F	NBF35Cancel
					F	NBF33AdapStat
					F	NBF32Reset
					F	NBF70Unlink
					F	NBF47TermNB

NBF49NmSvRcv	F	NmSvRcv
					W
NBFf0				F	ExtractName1
					J	NBFf0_1		;dw 06
					F	NameFD
					J	NBFf0_1		;dw	02
					F	SendNamePacktC
NBFf0_1			W
NBFf5				F	ExtractName1
					J	NBFf5_1		;dw 06
					F	NameFA
					J	NBFf5_1		;dw 02
					F	SendNamePacket6
NBFf5_1			W
NBFf6				F	ExtractName1
					J	NBFf6_1		;dw 02
					F	NameFC
NBFf6_1			W
NBFfe				F	ExtractName1
					J	NBFfe_1		;dw 02
					F	NameFB
NBFfe_1			W
NBFfd				F	ExtractName1
					J	NBFfd_1		;dw	06
					F	NameFD
					J	NBFfd_1		;dw	02
					F	SendNamePacketA
NBFfd_1			W
NBFf7				W
NBF4aDgrmRcv	F	DgrmRcv
					W
NBF90				F	ExtractName2
					J	NBF90_1		;dw	02
					F	CheckReceivedName
NBF90_1			W
NBF4c				F	SetOpen0
					F	Listen
NBF4c_1			W
					F	NetReadC
					J	NBF4c_1		;dw	0fa
					F	Close
					J	NBF4c		;dw	0f2
					F	FinishUp
					W
NBF05AsFclose	F	GetSesNameFrCB
					F	EofErr0A
					F	FinishUp
					W
NBF06AsClose	F	NetAbortD
					F	FinishUp
					W
NBF07AsError	F	GetSesNameFrCB
					F	EofErr18
					F	NetAbortD
					F	FinishUp
					W
NBF48Tick		F	HandleTick
					F	FinishUp
					W
NBF4dTCPXmt		F	TCPXmt
					F	FinishUp
					W
NBF4eTCPRcv		F	TCPRcv
					F	FinishUp
					W
NBF12HangUp		F	GetSesNameFrNCB
					F	HangupStatus
					J	Hangup1		;dw	04
					W
					F	GetSesNameFrCB
Hangup1			F	EofErr0A
					F	FinishUp
					W
NBF14Send		F	CheckBuf
					F	GetSesNameFrNCB
					F	SendC
					W
					F	FinishUp
					W
NBF15Receive	F	CheckBuf
					F	GetSesNameFrNCB
					F	ReceiveC
					W
					F	FinishUp
					W
NBF16RcvAny		F	CheckBuf
					F	StartRcvAny
					W
					F	RcvAnyC
					F	FinishUp
					W
NBF17ChainSend	F	ChainCheckBuf
					F	GetSesNameFrNCB
					F	ChainSendC
					F	SendC
					W
					F	FinishUp
					W
NBF20SendDgrm	F	SendDgrmA
					F	NameFromNCB_NUM
					F	FindCalledName
					J	SendDgrm3	;dw	10
SendDgrm1		F	SendNameQuery
					W
					F	HandleNameResp
					J	SendDgrm1	;dw	0f8
					F	GetRemoteName
SendDgrm2		W
					F	NameX
					J	SendDgrm2	;dw	0fa
SendDgrm3		F	RemoteIPAddressNCB_NUM
					F	SendBcDgmA
					F	FinishUp
					W
NBF22SendBcDgm	F	SendDgrmA
					F	NameFromNCB_NUM
					F	RemoteIPAddressNCB_NUM
					F	SendBcDgmD
					F	FinishUp
					W
NBF21RcvDgrm	F	CheckBuf
					F	RcvDgrmB
					W
					F	FinishUp
					W
NBF23RcvBcDgm	F	CheckBuf
					F	RcvBcDgmB
					W
					F	FinishUp
					W
NBF10Call		F	FindCallingName
					J	Call1		;dw	02
					F	InvalidName
Call1				F	FindCalledName
					J	Call4		;dw	10
Call2				F	SendNameQuery
					W
					F	HandleNameResp
					J	Call2		;dw	0f8
					F	GetRemoteName
Call3				W
					F	NameX
					J	Call3		;dw	0fa
Call4				F	SetRetry
Call5				F	RemoteIPAddress
					F	SetSessSrvc
Call6				F	GetSession
					F	SetOpen
					F	NetConnect
					W
					F	NetAbortA
					J	Call5		;dw	0f0
					F	NetWriteC
Call7				W
					F	NetAbortA
					J	Call5		;dw	0e8
					F	NetReadC
					J	Call7		;dw	0f6
					F	NetAbortB
					J	Call6		;dw	0e4
					F	SetUpOpen
					F	FinishUp
					W
NBF11Listen		F	FindCallingName
					J	Listen1		;dw	02
					F	InvalidName
Listen1			F	QueListen
					W
					F	SetUpOpen
					F	FinishUp
					W
NBF30AddName	F	ValidateName
					F	CreateLocalName
AddName1			F	SendRegisterRD
					W
					F	IsName1000
					J	AddName1		;dw	0f8
					F	SendRegister
					F	FinishUp
					W
NBF36AddGrName F	SetGrpName
					J	NBF30AddName	;dw	0ea
NBF78				F	InvalidName
					J	AddGrpName3		;dw	0c
					F	CreateLocalName
AddGrpName2		F	SendRegisterRD
					W
					F	IsName1000
					J	AddGrpName2		;dw	0f8
					F	SendRegister
AddGrpName3		F	FinishUp
					W
NBF31DelName	F	DelNameA
DelName1			F	SendRelease
					W
					F	IsName0
					J	DelName1		;dw	0f8
					F	DeQueExecA
					F	FinishUp
					W
NBF34SessnStat	F	CheckSesStatBuf
					F	SesStatFill
					F	FinishUp
					W
NBF35Cancel		F	CancelA
					F	FinishUp
					W
NBF33AdapStat	F	CheckAdapStatBuf
					F	IsNameRemote
					J	AdapStat1
					F	CopyLocalAdapStatus
					F	FinishUp
					W
AdapStat1		F	FindCalledName
					J	AdapStat4
AdapStat2		F	SendNameQuery
					W
					F	HandleNameResp
					J	AdapStat2	;dw	0f8
					F	GetRemoteName
AdapStat3		W
					F	NameX
					J	AdapStat3	;dw	0fa
AdapStat4		F	RemoteIPAddressNop
					F	SendAdapterRequest
					W
					F	NameFE
					F	FinishUp
					W
NBF32Reset		F	ResetA
					F	ResetB
					F	NetAbortND
					F	StartListens
					F	FinishUp
					W
NBF70Unlink		F	ClrCommand
					F	FinishUp
					W
NBF47TermNB		F	ResetB
					F	FinishUp
					W
IndirectOff		dw	00
IndirectSeg		dw	00
T_SR				dw	3100
TopSegment		dw	00
;-----------------------------------------------------
Config9:
		call	near ptr NBInit
		push	word ptr ds:T_SR
		push	word ptr ds:TopSegment
		jmp	near ptr Config10

NumToStringC	proc near
		jmp	near ptr NumToString
		jmp	near ptr NetAbortND
;-----------------------------------------------------
BCNamePtr	db	00,00
BCNamePtrSeg	dw	00
NameFilePtr	dw	00
NameFilePtrSeg	dw	00
NameFileCount	dw	00
;-----------------------------------------------------
NumToStringC	endp

NBInit		proc near
		mov	di,offset NamesBuf
		push	cs
		pop	es
		cld
		xor	ax,ax
		lea	di,word ptr [di+23h]
		mov	cx,word ptr ds:NBNamesSize
		sub	cx,23h
		rep	stosb
		mov	di,word ptr ds:CacheBuf
		mov	al,17h
		mul	word ptr ds:NameFileCount
		xchg	ax,cx
		jcxz	NBInit1
		lds	si,dword ptr ds:NameFilePtr
		rep	movsb
		push	cs
		pop	ds
NBInit1:
		mov	al,17h
		mov	dx,word ptr ds:NbCache
		sub	dx,word ptr ds:NameFileCount
		mul	dx
		xchg	ax,cx
		rep	stosb
		mov	di,word ptr ds:BCNameBuf2
		mov	al,04
		mul	word ptr ds:BCNameCount
		xchg	ax,cx
		jcxz	NBInit2
		lds	si,dword ptr ds:BCNamePtr
		rep	movsb
		push	cs
		pop	ds
NBInit2:
		mov	ax,word ptr ds:NameFilePtrSeg
		or		ax,ax
		je		NBInit3
		mov	es,ax
		mov	ah,49h
		int	21h			;DOS:49-release mem,ES=bloc-
		push	cs
		pop	es
		xor	ax,ax
NBInit3:
		mov	cx,word ptr ds:TopAddress
		sub	cx,di
		rep	stosb
		mov	si,word ptr ds:StackBot2
		mov	word ptr [si],0cccch
		mov	di,offset Buffer1
		mov	cx,0006h
		mov	si,offset AdaptorStatus
		rep	movsb
		mov	bp,offset FreeCBs
		mov	cx,word ptr ds:NumNCBs
		mov	si,word ptr ds:NCB_Buf
NBInit4:
		call	near ptr ReleaseCB
		add	si,16h
		loop	NBInit4
		mov	di,offset NamesBuf
		mov	cx,word ptr ds:NumNBNames
NBInit5:
		mov	ax,di
		add	ax,13h
		mov	word ptr [di].nm_15,ax
		add	ax,04
		mov	word ptr [di].nm_19,ax
		add	ax,04
		mov	word ptr [di].nm_1d,ax
		add	ax,04
		mov	word ptr [di].nm_21,ax
		add	di,23h
		loop	NBInit5
		mov	di,word ptr ds:SesBuf
		mov	cx,word ptr ds:NumSes
		mov	word ptr ds:SessionsUsed,0000h
NBInit6:
		mov	ax,di
		add	ax,0eh
		mov	word ptr [di].s_10,ax
		add	ax,11h
		mov	word ptr [di].s_21,ax
		xor	ax,ax
		mov	word ptr [di].s_rcvq,ax
		mov	word ptr [di].s_sendq,ax
		mov	word ptr [di].s_cb,ax
		mov	word ptr [di].s_ncbseg,ax
		mov	word ptr [di].s_12,ax
		mov	word ptr [di].s_23,ax
		mov	word ptr [di].s_state,S_FREE	;8000h
		add	di,32h
		loop	NBInit6
		retn
;-----------------------------------------------------
		db	700d dup (00h)
K1		db	00,00,00,00,00,00
		db	00,00,00,00,00,00
		db	00
K2		db	00,00,00,00,00,00
		db	00,00,00,00,00,00
		db	00,00,00,00,00,00
		db	00,00,00,00,00,00
		db	00,00,00,00,00,00
		db	00
InitStack	dw	offset begin
IPAddress		db	00,00,00,00
AdaptorStatus	db	00,00,00,00,00,00	;Also initial SP/unitID
				db	00,00
bVersionMajor	db	02
bVersionMinor	db	03
wRunTime		dw	00		; run-time in minutes
			db	6d dup (00h)
wAbortTran		dw	00
wGoodTranLo		dw	00
wGoodTranHi		dw	00
NumReadsLo		dw	00
NumReadsHi		dw	00
					dw	00
wNoBufErrs		dw	00
					db	8d dup (00h)
FreeCBCount		dw	00
NumNCBs			db	20,00,0ff
					db	5d dup (00h)
SessionsUsed	dw	00
NumSes			dw	10,0ff
NetReadLen		dw	200
UDPup				dw	00
NumNBNames		dw	11
NamesBuf		db	10d dup (00h)
Buffer1			db	00,00,00,00,00,00
					db	00
					db	06
					db	17d dup (00h)
LocalNamesBuf	dw	04
TCP_cons			dw	00
GKISize2			dw	02
Options			dw	00
;-----------------------------------------------------
NBInit		endp

;Option definitions

O_NUMNAMES	equ	0001h
O_NUMCBS		equ	0002h
O_LANA		equ	0004h
O_NUMSES		equ	0008h
O_UNLOAD		equ	0010h
O_LOADHIGH	equ	0020h
O_NAMEFILE	equ	0040h
O_SCOPE		equ	0080h
O_NUMCACHE	equ	0100h
O_BCFILE		equ	0200h
O_DOMAIN		equ	0400h
O_TRACE		equ	0800h
O_DUMP		equ	1000h
O_TIMEOUT	equ	2000h
O_QUIET		equ	4000h

O_NUM1		equ	O_NUMNAMES or O_NUMCBS or O_LANA
O_NUM2		equ	O_NUMSES or O_NUMCACHE or O_TIMEOUT
O_NUM			equ	O_NUM1 or O_NUM2
O_NAME		equ	O_NAMEFILE or O_BCFILE or O_DOMAIN or O_SCOPE
O_ARGVAL		equ	O_NUM or O_NAME

begin		proc near
		call	near ptr ParseArgs
		jb		UsageErr
		test	word ptr ds:Options,O_QUIET ;'q'
		je		OutputCopyright
		mov	al,0c3h
		mov	byte ptr StringOut,al
OutputCopyright:
		mov	si,offset CopyRightMes
		call	near ptr StringOut
		call	near ptr GetNBVec	;ES|BX
		jb		IsLoaded
		jmp	short NotLoaded
IsLoaded:
		test	word ptr ds:Options,O_UNLOAD ;'u'
		jne	Unload
		test	word ptr ds:Options,O_DUMP ;'d'
		jne	DumpTrace
		jmp	short AlreadyErr
Unload:
		mov	ax,word ptr es:[bx-03]
		mov	word ptr ds:IndirectOff,ax
		mov	word ptr ds:IndirectSeg,es
		call	dword ptr ds:IndirectOff
		jmp	near ptr ExitWithMessage
Exit2:
		jmp	near ptr Exit1
AlreadyErr:
		mov	si,offset AlreadyMessage
		jmp	short MesExitJump
UsageErr:
		mov	si,offset CopyRightMes
		call	near ptr StringOut
		mov	si,offset UsageMessage
		jmp	short MesExitJump
DumpFileErr:
		mov	si,offset DumpFileMes
		jmp	short MesExitJump
NotLoadedErr:
		mov	si,offset NotLoadedMes
		jmp	short MesExitJump
TraceErr:
		mov	si,offset TraceMes
		jmp	short MesExitJump
DumpTrace:
		mov	di,word ptr es:[bx-05]
		test	di,di
		je		TraceErr
		mov	ah,3ch
		xor	cx,cx
		mov	dx,offset DumpName
		int	21h			;DOS:3c-create file, DS:DX name
		jb		DumpFileErr
		mov	bx,ax
		mov	dx,di
		push	es
		pop	ds
		mov	ah,40h
		mov	cx,2710h
		int	21h			;DOS:40-write file, BX=handle
		push	cs
		pop	ds
		jb		DumpFileErr
		mov	si,offset TraceCreateMes
MesExitJump:
		jmp	near ptr MessageExit
KernelErr:
		mov	si,offset KernelMes
		jmp	short MesExitJump
MemoryErr:
		mov	si,offset MemoryMes
		jmp	short MesExitJump
NotLoaded:
		test	word ptr ds:Options,O_TRACE ;'t'
		je		NotTraceOption
		mov	word ptr ds:TraceBuf,0ffffh
NotTraceOption:
		test	word ptr ds:Options,O_UNLOAD or O_DUMP ;'u' or 'd'
		jne	NotLoadedErr
		call	near ptr FindKernelVec
		jb		KernelErr
		call	near ptr DoFileConfig
		mov	bx,cs
		mov	ds,bx
		mov	es,bx
		mov	word ptr ds:DataSegm,bx
		mov	dx,0400h		;TCB_CONS
		mov	si,offset TCP_cons
		mov	di,offset GKISize2
		mov	ah,02			;get_kernel_info
		call	near ptr KernelAPI
		jnb	Config1
		jmp	near ptr KernelIsBad
Config1:
		mov	bx,word ptr ds:TCP_cons
		cmp	bx,word ptr ds:NumSes
		jnb	NumSesOK
		mov	word ptr ds:NumSes,bx
		mov	word ptr ds:NumSes1,bx
		mov	di,offset NumSesns
		mov	ax,0101h
		call	near ptr DecimalToStr
		mov	si,offset SesReducedMes
		call	near ptr StringOut
NumSesOK:
		mov	word ptr ds:NetReadLen,0400h
		mov	ax,0023h
		mul	word ptr ds:NumNBNames
		jb		MemoryErr
		mov	word ptr ds:NBNamesSize,ax
		add	ax,offset NamesBuf
MemoryErrC:
		jb		MemoryErr
		mov	word ptr ds:CacheBuf,ax
		xchg	ax,cx
		mov	ax,0017h
		mul	word ptr ds:NbCache
		jb		MemoryErrC
		add	ax,cx
		jb		MemoryErrC
		mov	word ptr ds:BCNameBuf1,ax
		mov	word ptr ds:BCNameBuf2,ax
		xchg	ax,cx
		mov	ax,0004h
		mul	word ptr ds:BCNameCount
		add	ax,cx
		mov	word ptr ds:NCBsBuf1,ax
		mov	word ptr ds:NCB_Buf,ax
		xchg	ax,cx
		mov	ax,0016h
		mul	word ptr ds:NumNCBs
		jb		MemoryErrC
		add	ax,cx
		jb		MemoryErrC
		mov	word ptr ds:SesBuf1,ax
		mov	word ptr ds:SesBuf,ax
		xchg	ax,cx
		mov	ax,0032h
		mul	word ptr ds:NumSes
		jb		MemoryErrC
		add	ax,cx
		jb		MemoryErrC
		mov	word ptr ds:StackBot1,ax
		mov	word ptr ds:StackBot2,ax
		add	ax,0200h
		jb		MemErr1C
		test	al,01
		je		AddressIsEven
		inc	ax
AddressIsEven:
		mov	word ptr ds:NetbiosSP,ax
		test	word ptr ds:TraceBuf,0ffffh
		je		Config4
		mov	byte ptr ds:TraceFlag,0ffh
		inc	ax
		inc	ax
		mov	word ptr ds:TraceBuf,ax
		mov	word ptr ds:pTraceBuf,ax
		add	ax,2710h
		jb		MemErr1C
Config4:
		mov	word ptr ds:TopAddress,ax
		mov	bx,ax
		add	bx,0fh
		mov	cl,04
		shr	bx,cl
		mov	word ptr ds:TopSegment,bx
		cmp	ax,offset ProgEnd
		jb		FitIn
		push	cs
		pop	es
		mov	ah,4ah
		int	21h			;DOS:4a-set mem block,BX=pargphs
		jnb	FitIn
MemErr1C:
		jmp	MemErr1
FitIn:
		mov	ax,word ptr cs:psp_envir
		mov	es,ax
		mov	ah,49h
		int	21h			;DOS:49-release mem,ES=block seg
		mov	ah,11h			;disable_asynch
		call	near ptr KernelAPI
		xor	bx,bx
		mov	word ptr ds:UDPup,bx
		mov	dx,8200h		;get IP address
		mov	si,offset IPAddress
		mov	di,offset LocalNamesBuf	; contains 4 at this stage
		push	cs
		pop	es
		mov	ah,02			;get_kernel_info
		call	near ptr KernelAPI
		jb		KernelIsBad
		dec	dh				;get MAC address
		mov	word ptr[di],6
		mov	si,offset AdaptorStatus
		mov	ah,02			;get_kernel_info
		call	near ptr KernelAPI
		jb		KernelIsBad
		; reverse MAC address
		mov	ax,word ptr [si]
		mov	bx,word ptr [si+4]
		xchg	ah,al
		xchg	bh,bl
		mov	[si],bx
		mov	[si+4],ax
		or		bx,bx
		jnz	HaveMac1
		mov	bx,ax
HaveMac1:
		mov	ax,[si+2]
		xchg	ah,al
		mov	[si+2],ax
		or		ax,ax
		jnz	HaveMac
		or		bx,bx
		jnz	HaveMac
		; use IP address
		mov	di,offset IPAddress
		mov	ax,[di]
		mov	[si],ax
		mov	ax,[di+2]
		mov	[si+2],ax
HaveMac:
ifdef	LOAD_HIGH
		test	word ptr ds:Options,O_LOADHIGH
		je		KeepItLow
		call	near ptr LoadHigh
endif
KeepItLow:
		mov	ax,offset Config8
		mov	word ptr ds:IndirectOff,ax
		mov	word ptr ds:IndirectSeg,ds
		push	ds
		push	cs
		pop	ds
		call	near ptr PrintConfig
		pop	ds
		jmp	dword ptr ds:IndirectOff
Config8:
		jmp	near ptr Config9
MemErr1:
		mov	si,offset MemNotEnoughMes
		jmp	short MessageExit
ExitWithMessage:
		mov	si,offset SuccessMes
		jnb	MessageExit
		mov	si,offset NotUnloadMes
		jmp	short MessageExit
KernelIsBad:
		mov	ah,12h
		call	near ptr KernelAPI
		mov	si,offset KernelBadMes
MessageExit:
		call	near ptr StringOut
Exit1:
		mov	ax,4c01h
		int	21h		;DOS:4c-term. prog., AL=ret code
begin		endp
;-----------------------------------------------------

ArgOptions	db	'aclnsu'
ifdef		TRACE_DUMP
		db	'td'
endif
ifdef		LOAD_HIGH
		db	'o'
endif
		db	'pebmiq'

OptionFlags	dw	O_NUMNAMES
		dw	O_NUMCBS
		dw	O_LANA
		dw	O_NAMEFILE
		dw	O_NUMSES
		dw	O_UNLOAD
ifdef		TRACE_DUMP
		dw	O_TRACE
		dw	O_DUMP
endif
ifdef		LOAD_HIGH
		dw	O_LOADHIGH
endif
		dw	O_SCOPE
		dw	O_NUMCACHE
		dw	O_BCFILE
		dw	O_DOMAIN
		dw	O_TIMEOUT
		dw      O_QUIET
;-----------------------------------------------------

ParseArgs	proc near
		push	ds
		pop	es
		mov	si,0080h
		xor	cx,cx
		or		cl,byte ptr [si]
		je		ParseArgsExit
		inc	si
ParseArgs1:
		lodsb
		cmp	al,' '
		je		ParseArgs2
		cmp	al,TAB
		je		ParseArgs2
		cmp	al,'/'
		stc
		jne	ParseArgsExit
		dec	cx
		je		ParseArgsExit
		lodsb
		test	al,40h
		jz		PArgNotAlpha
		or		al,'a'-'A'	;convert to lower case
PArgNotAlpha:
		push	cx
		mov	di,offset ArgOptions
		mov	cl,offset OptionFlags - offset ArgOptions
		repnz	scasb
		pop	cx
		stc
		jne	ParseArgsExit
		dec	di
		sub	di,offset ArgOptions
		shl	di,1
		mov	dx,word ptr ds:OptionFlags[di]
		or		word ptr ds:Options,dx
		test	dx,O_ARGVAL
		jz		ParseArgs2
		xor	bx,bx		;no argument yet
ParseArgsNext:
		mov	al,[si]
		cmp	al,' '
		je		ParseArgsSp
		cmp	al,TAB
		jne	ParseArgsNoSp
ParseArgsSp:
		cmp	bx,0
		je		ParseArgsNS
		call	HandleArg
		jb		ParseArgsExit
		jmp	short ParseArgs2
ParseArgsNoSp:
		cmp	bx,0
		jne	ParseArgsNS
		mov	bx,si		;start of argument
ParseArgsNS:
		inc	si
		loop	ParseArgsNext
		dec	si		;for CR at end
		call	HandleArg
		jmp	short ParseArgsExit
ParseArgs2:
		loop	ParseArgs1
ParseArgs3:
		clc
ParseArgsExit:
		retn
ParseArgs	endp

HandleArg	proc	near	;dx=flag,bx=start,si=end
		cmp	bx,0
		stc
		je		HandleArgExit
		push	si
		xchg	bx,si
		cmp		byte ptr [si],'='
		jne		ArgNotEq
		inc		si
ArgNotEq:
		sub	bx,si
		stc
		jz		HandleArgExPop
		xchg	bx,cx
		mov	bp,dx
		test	dx,O_NUM
		jz		HandleArgStr
		xor	dx,dx
HandleArg1:
		lodsb
		cmp	al,'0'
		jb		HandleArgExPop
		cmp	al,':'
		cmc
		jb		HandleArgExPop
		sub	al,30h
		push	ax
		mov	ax,10d
		xchg	ax,dx
		mul	dx
		xchg	ax,dx
		pop	ax
		cbw
		add	dx,ax
		jb		HandleArgExPop
		loop	HandleArg1
		call	SetNumArg
		jmp	short HandleArgExEx
HandleArgStr:
		cmp	bp,O_NAMEFILE
		jne	HandleBCFile
		mov	di,offset NameFile
		jmp	short HandleFile
HandleBCFile:
		cmp	bp,O_BCFILE
		jne	HandleScope
		mov	di,offset BCastNames
HandleFile:
		cmp	cx,40h
		ja		HandleOK
		rep	movsb
		jmp	short HandleOK
HandleScope:
		cmp	bp,O_SCOPE
		jne	HandleDomain
HandleDomain:
		cmp	bp,O_DOMAIN
		jne	HandleOK
HandleOK:
		clc
HandleArgExEx:
		xchg	bx,cx
HandleArgExPop:
		pop	si
HandleArgExit:
		retn
HandleArg	endp

SetNumArg	proc	near		;bp=flags,dx=num
		mov	ax,dx
		or		ah,ah
		jnz	SetNumErr	;all must be single byte
		cmp	bp,O_NUMNAMES
		jne	SetNumCBS
		or		ax,ax
		jle	SetNumCBS
		inc	ax
		cmp	ax,00ffh
		jnb	SetNumCBS
		mov	word ptr ds:NumNBNames,ax
SetNumCBS:
		cmp	bp,O_NUMCBS
		jne	SetNumSES
		cmp	al,08
		jb		SetNumSES
		mov	word ptr ds:NbNCBs,ax
		mov	word ptr ds:NbNCBs1,ax
		mov	cx,ax
		inc	ax
		shr	ax,1
		add	ax,cx
		cmp	ax,14h
		jnb	SetNumCBS1
		mov	ax,0014h
SetNumCBS1:
		mov	word ptr ds:NumNCBs,ax
SetNumSES:
		cmp	bp,O_NUMSES
		jne	SetNumCACHE
		cmp	al,02
		jb		SetNumCACHE
		mov	word ptr ds:NumSes,ax
		mov	word ptr ds:NumSes1,ax
SetNumCACHE:
		cmp	bp,O_NUMCACHE
		jne	SetNumLANA
		mov	word ptr ds:NbCache,ax
SetNumLANA:
		cmp	bp,O_LANA
		jne	SetNumTIMEOUT
		cmp	al,08
		jnb	SetNumErr
		mov	byte ptr ds:lana,al
SetNumTIMEOUT:
		cmp	bp,O_TIMEOUT
		jne	SetNumExit
		cmp	al,0ffh
		jne	SetNumTO
		dec	al
SetNumTO:
		mov	byte ptr ds:TimeOut,al
SetNumExit:
		clc
		retn
SetNumErr:
		stc
		retn
SetNumArg	endp

;-----------------------------------------------------
;Revision history
; 0.0		First release
; 1.0		941023	Fix error return for Out of Resources
; 1.01	941122	Allow null in namefile, broadcast file, 15 byte matches
;						in name file
; 2.00	000203	Change to NETBIOS
; 2.01  	000304  	Change run-time
; 2.02	000323   Fix ReceiveAny, Adapter Status
; 2.03	000403	Fix hang on cache full
; 2.04	000706	Use MAC address as permanent ID if available, else IP address
; 2.05	010514	/q switch to suppress output

CopyRightMes	db	'Sockets NETBIOS Version 2.06(dt)',CR,LF
               db 'Copyright (C) 1999-2001 Datalight, Inc.', CR, LF
               db 'All Rights Reserved', CR, LF
               db 'Portions copyright (c) GPvNO 2003', CR, LF, CR, LF, 0
UsageMessage	db	'Usage:  netbios  [option1] [option2] [...]',CR,LF
		db	'Options:',CR,LF
		db	'/a=<num>  set number of names',CR,LF
		db	'/b=<name> set broadcast file name',CR,LF
		db	'/c=<num>  set number of NCB''s',CR,LF
		db	'/e=<num>  set number of cached names',CR,LF
		db	'/l=<num>  set Lan Adapter number',CR,LF
		db	'/n=<name> set name file name',CR,LF
		db	'/q        do not display sign-on message',CR,LF
		db	'/s=<num>  set number of sessions',CR,LF
ifdef		LOAD_HIGH
		db	'/o        load NETBIOS high',CR,LF
endif
ifdef		TRACE_DUMP
		db	'/d        dump trace buffer',CR,LF
		db	'/t        enable trace',CR,LF
endif
		db	'/u        unload NETBIOS',CR,LF,0
DumpFileMes	db	'NETBIOS - cannot create dump file.',CR,LF,0
AlreadyMessage	db	'NETBIOS already resident',CR,LF,0
NotLoadedMes	db	'NETBIOS not resident',CR,LF,0
DumpName	db	'netbios.trc',0
TraceMes	db	'NETBIOS - trace not enabled.',CR,LF,0
TraceCreateMes	db	'NETBIOS - trace file netbios.trc created.',CR,LF,0
MemNotEnoughMes db	'NETBIOS - not enough memory to load.',CR,LF,0
MemoryMes		db	'NETBIOS - too much memory required',CR,LF,0
SuccessMes		db	'NETBIOS unloaded.',CR,LF,0
NotUnloadMes	db	'NETBIOS cannot be unloaded now.',CR,LF,0
KernelMes		db	'NETBIOS - Sockets not loaded.',CR,LF,0
KernelBadMes	db	'NETBIOS - Sockets not responding',CR,LF,0
SesReducedMes	db	'Warning: Number of sessions reduced to '
NumSesns			db	'   ',CR,LF,0
SuccessLoadMes	db	'NETBIOS now resident.',CR,LF
ifdef	CONFIG_PRINT
					db	'Memory used: '
MemOccupied		db	'00000 bytes, Lana number: '
AdapNum			db	'0',CR,LF
					db	'Local names: '
LocNamesNum		db	'000, Sessions: '
SessionNum		db	'000, CBs: '
CBsNum			db	'000, Name cache size:'
					db	' '
NameCacheNum	db	'000  names.',CR,LF
					db	'NETBIOS  name  scope '
					db	'"'
NameScope		db	'                     '
					db	'         '
NameFileNum		db	'000 names  from  name'
					db	' file',CR,LF
					db	'NETBIOS domain scope '
					db	'"'
Name1				db	'                     '
					db	'         '
BCFileNum		db	'000 addr-s from bcast file',CR,LF
					db	'Kernel v'
VersionNum		db	'0    Patch lvl('
PatchLevNum		db	'00000), found at vector: 0x'
PCTCPVecNum		db	'00',CR,LF
					db	'Local Node address: '
IPATemplate		db	'000.000.000.000',CR,LF
endif
		db	00
;-----------------------------------------------------

PrintConfig	proc near

ifdef	CONFIG_PRINT

		push	cs
		pop	es
		mov	di,offset MemOccupied
		mov	bx,word ptr ds:TopAddress
		add	bx,1fh
		and	bx,-10h
		xor	ax,ax
		call	near ptr DecimalToStr
		mov	di,offset BCFileNum
		mov	bx,word ptr ds:BCNameCount
		mov	ax,0001h
		call	near ptr DecimalToStr
		mov	di,offset NameFileNum
		mov	bx,word ptr ds:NameFileCount
		mov	ax,0001h
		call	near ptr DecimalToStr
		mov	di,offset LocNamesNum
		mov	bx,word ptr ds:NumNBNames
		dec	bx
		mov	ax,0001h
		call	near ptr DecimalToStr
		mov	di,offset SessionNum
		mov	bx,word ptr ds:NumSes
		mov	ax,0001h
		call	near ptr DecimalToStr
		mov	di,offset CBsNum
		mov	bx,word ptr ds:NumNCBs
		mov	ax,0001h
		call	near ptr DecimalToStr
		mov	al,byte ptr ds:lana
		add	byte ptr ds:AdapNum,al
		mov	di,offset NameCacheNum
		mov	bx,word ptr ds:NbCache
		mov	ax,0001h
		call	near ptr DecimalToStr
		mov	ax,0001h
		mov	bh,byte ptr ds:VecNum
		mov	di,offset PCTCPVecNum
		call	near ptr NumToStringC
		mov	ah,0fh			;get_netversion
		call	near ptr KernelAPI
		push	ax
		xor	ax,ax
		mov	di,offset PatchLevNum
		call	near ptr DecimalToStr
		pop	bx
		xchg	bh,bl
		push	bx
		xor	bh,bh
		mov	ax,0100h
		mov	di,offset VersionNum
		call	near ptr DecimalToStr
		mov	al,2eh
		stosb
		pop	bx
		xchg	bh,bl
		xor	bh,bh
		mov	ax,0100h
		call	near ptr DecimalToStr
		mov	di,offset IPATemplate
		mov	cx,0004h
		mov	si,offset IPAddress
		cld				;Forward String Opers
		jmp	short PrintConfig2
PrintConfig1:
		mov	al,2eh
		stosb
PrintConfig2:
		xor	ax,ax
		lodsb
		xchg	ax,bx
		mov	ax,0001h
		call	near ptr DecimalToStr
		loop	PrintConfig1
		mov	si,offset Scope
		mov	di,offset NameScope
PrintConfig3:
		xor	ax,ax
		lodsb
		or		al,al
		je		PrintConfig4
		mov	cx,ax
		mov	al,2eh
		stosb
		rep	movsb
		jmp	short PrintConfig3
PrintConfig4:
		mov	al,22h
		stosb
		mov	si,offset DomName
		mov	di,offset Name1
		xor	cx,cx
		mov	cl,byte ptr ds:DomNameLen
		jcxz	PrintConfig5
		dec	cx
		rep	movsb
PrintConfig5:
		mov	al,22h
		stosb
endif
		mov	si,offset SuccessLoadMes
		call	near ptr StringOut
		retn
PrintConfig	endp

DecimalToStr	proc near
		push	cx
		push	dx
		push	si
		push	bp
		mov	si,2710h
		mov	cx,0005h
		or		al,al
		je		DTS1
		mov	si,0064h
		mov	cx,0003h
DTS1:
		mov	al,ah
		mov	bp,ax
		cld				;Forward String Opers
DTS2:
		xor	dx,dx
		mov	ax,bx
		div	si
		or		ax,ax
		jne	DTS3
		cmp	cx,01
		je		DTS3
		or		bp,bp
		jne	DTS4
DTS3:
		xor	bp,bp
		add	al,30h
		stosb
DTS4:
		mov	bx,dx
		xor	dx,dx
		mov	ax,000ah
		xchg	ax,si
		div	si
		xchg	ax,si
		loop	DTS2
		pop	bp
		pop	si
		pop	dx
		pop	cx
		retn
DecimalToStr	endp

GetNBVec	proc near
		mov	ax,355ch
		int	21h			;DOS:35-get int vector in ES:BX
GetNBVec1:
		mov	ax,es
		or		ax,ax
		jz		NoNB
		cmp	ax,0f000h
		je		NoNB
		cmp	word ptr es:[bx+06],'BR'
		clc
		jne	NoNB
		mov	di,bx
		add	di,12h
		mov	si,offset Int5c_c
		mov	cx,001bh
		repz	cmpsw			;Flgs=DS:[SI]-ES:[DI]
		je		GetNBVec2
		les	bx,dword ptr [bx+02]
		jmp	short GetNBVec1
GetNBVec2:
		stc
NoNB:
		retn
;-----------------------------------------------------
KernelSignature 	db	'RinetI'
KernelSig1 			db	'Inet'
;-----------------------------------------------------
GetNBVec	endp

FindKernelVec	proc near
		mov	cx,00eah
		mov	ax,002ah
		sub	cx,ax
		mov	ah,35h
TryNextVec:
		int	21h			; DOS:35-get int vector in ES:BX
		mov	si,offset KernelSignature
		push	cx
		mov	cx,0006h
		mov	di,bx
		sub	di,06
		repz	cmpsb			;Flgs=DS:[SI]-ES:[DI]
		pop	cx
		je		FoundVec
		inc	al
		loop	TryNextVec
		stc
		jmp	short NoVec
FoundVec:
		mov	byte ptr ds:VecNum,al
		mov	cx,00eah
		mov	ax,002ah
		sub	cx,ax
		mov	ah,35h
TryNextVecI:
		int	21h			; DOS:35-get int vector in ES:BX
		mov	si,offset KernelSig1
		push	cx
		mov	cx,0004h
		mov	di,bx
		sub	di,04
		repz	cmpsb			;Flgs=DS:[SI]-ES:[DI]
		pop	cx
		je		FoundVecI
		inc	al
		loop	TryNextVecI
		stc
		jmp	short NoVec
FoundVecI:
		mov	byte ptr ds:VecNum1,al
NoVec:
		retn
FindKernelVec	endp
;-----------------------------------------------------
BCastNames		db	65d dup (00h)
NameFile			db	65d dup (00h)
Buffer			db	80d dup (00h)
SaveSP1			dw	00
MaxNameFiles	dw	100
MaxBCNames		dw	100
;-----------------------------------------------------

DoFileConfig	proc near
		mov	word ptr ds:SaveSP1,sp
		push	cs
		pop	es
		mov	bx,0ffeh
		mov	ah,4ah
		int	21h		;DOS:4a-set mem block,BX=paragraphs
		jnb	MemOk1
		cmp	al,08
		jne	NotEnoughMemC
MemOk1:
		mov	bx,01b1h
		mov	ah,48h
		int	21h		;DOS:48-allocate mem,BX=paragraphs
		jnb	DoNameFile
NotEnoughMemC:
		jmp	near ptr DoConfigExit1
DoNameFile:
		mov	es,ax
		mov	word ptr ds:NameFilePtrSeg,ax
		mov	word ptr ds:BCNamePtrSeg,ax
		cmp	byte ptr ds:NameFile,00
		je		NoNameFile
		mov	dx,offset NameFile
		call	near ptr OpenFile
		or		ax,ax
		jne	NoNameFile
		les	di,dword ptr ds:NameFilePtr
		push	es
		push	di
		mov	ax,0050h
		push	ax
		push	cs
		mov	ax,offset Buffer
		push	ax
		mov	bp,sp
NameFileNext:
		nop
		call	near ptr ReadLine
		les	di,dword ptr [bp+06]
		or		ax,ax
		je		NameFileNext
		jns	NameFile2
		cmp	al,0feh
		je		NameFileNext
		jmp	short NameFileEnd
NameFile2:
		call	near ptr CopyNBName
		jb		NameFileNext
		mov	byte ptr es:[di],00
		inc	di
		mov	dx,si
		xor	cx,cx
		mov	ah,54h			;nm_res_name
		call	near ptr KernelAPI
		jb		NameFileNext
		stosw
		xchg	ax,dx
		stosw
		mov	ax,0ffffh
		stosw
		mov	word ptr [bp+06],di
		inc	word ptr ds:NameFileCount
		dec	word ptr ds:MaxNameFiles
		jne	NameFileNext
NameFileEnd:
		les	di,dword ptr [bp+06]
		mov	word ptr ds:BCNamePtr,di
		mov	ax,word ptr ds:NameFileCount
		add	word ptr ds:NbCache,ax
		mov	sp,word ptr ds:SaveSP1
		call	near ptr CloseFile
NoNameFile:
		cmp	byte ptr ds:BCastNames,00
		je		DoConfigExit1
		mov	dx,offset BCastNames
		call	near ptr OpenFile
		or		ax,ax
		jne	DoConfigExit1
		mov	sp,word ptr ds:SaveSP1
		les	di,dword ptr ds:BCNamePtr
		push	es
		push	di
		mov	ax,0050h
		push	ax
		push	cs
		mov	ax,offset Buffer
		push	ax
		mov	bp,sp
NextBCName:
		nop
		call	near ptr ReadLine
		les	di,dword ptr [bp+06]		; 2001-07-12 changed from [bp+04]
		or		ax,ax
		je		NextBCName
		jns	BCName2
		cmp	al,0feh
		je		NextBCName
		jmp	short BCName3
BCName2:
		mov	dx,offset Buffer
		xor	cx,cx
		mov	ah,54h			;nm_res_name
		call	near ptr KernelAPI
		jb		NextBCName
		stosw
		xchg	ax,dx
		stosw
		mov	word ptr [bp+06],di
		inc	word ptr ds:BCNameCount
		dec	word ptr ds:MaxBCNames
		jne	NextBCName
BCName3:
		les	di,dword ptr [bp+06]
DoConfigExit1:
		mov	sp,word ptr ds:SaveSP1
		call	near ptr CloseFile
DoConfigExit:
		retn
DoFileConfig	endp

CopyNBName	proc near
		mov	si,offset Buffer
		mov	cx,0010h
		xor	ax,ax
		cmp	byte ptr [si],22h	;(")
		je		Quote
		cmp	byte ptr [si],27h	;(')
		jne	NextCharacter
Quote:
		mov	ah,byte ptr [si]
		inc	si
NextCharacter:
		lodsb
;		or		al,al	;Allow null in name 941115 gvn
;		je		End1
		or		ah,ah
		je		NotQuoted
		cmp	al,ah
		je		EndQuote
		jne	PutIt
NotQuoted:
		cmp	al,20h ;( )
		je		EndQuote
		cmp	al,09
		je		EndQuote
PutIt:
		stosb
		loop	NextCharacter
		lodsb
		or		al,al
		je		End1
		or		ah,ah
		je		NotQuoted1
		cmp	al,ah
		jne	End1
		lodsb
NotQuoted1:
		cmp	al,20h ;( )
		je		IsaSpace
		cmp	al,09
		je		IsaSpace
End1:
		stc
		jmp	short Exit
EndQuote:
		mov	al,20h
		rep	stosb
IsaSpace:
		mov	al,byte ptr [si]
		or		al,al
		je		Exit
		cmp	al,20h ;( )
		je		IsaSpace1
		cmp	al,09
		jne	Exit
IsaSpace1:
		inc	si
		jmp	short IsaSpace
Exit:
		retn
CopyNBName	endp

ifdef	LOAD_HIGH

;-----------------------------------------------------
LoadHighMes	db	'NETBIOS has been loaded high.',CR,LF
;-----------------------------------------------------

LoadHigh	proc near
		mov	cx,word ptr ds:TopSegment
		cmp	cx,1000h
		ja		LoadHiExit
		call	near ptr GetHiMem
		jb		LoadHiExit
		mov	word ptr ds:T_SR,4c01h
		mov	word ptr ds:DataSegm,ax
		mov	cx,word ptr ds:TopSegment
		shl	cx,1
		shl	cx,1
		shl	cx,1
		push	cs
		pop	ds
		xor	si,si
		mov	es,ax
		xor	di,di
		cld
		rep	movsw
		push	ax
		mov	si,offset LoadHighMes
		call	near ptr StringOut
		pop	ax
		mov	ds,ax
		mov	ss,ax
LoadHiExit:
		retn
LoadHigh	endp

;-----------------------------------------------------
					db	00
MemRequired		dw	00
AllocStrategy	dw	00
UMBlinked		db	00
;-----------------------------------------------------

GetHiMem	proc near
		push	es
		push	si
		push	di
		push	cx
		mov	ax,cx
		mov	word ptr ds:MemRequired,ax
		call	near ptr SetMemAllocStrategy
		jb		NoUMB
		mov	bx,0041h
		call	near ptr UseUMB
		jnb	GetHiMemOK
NoUMB:
		mov	ax,word ptr ds:MemRequired
		call	near ptr MuxInt_ax
		or		ax,ax
		je		GetHiMemFailed
GetHiMemOK:
		clc
GetHiMemExit:
		pop	cx
		pop	di
		pop	si
		pop	es
		retn
;-----------------------------------------------------
GetHiMemFailed:
		 stc
		jmp	short GetHiMemExit
GetHiMem	endp

MuxFunc10	proc near
		mov	ah,10h
MuxFunc10	endp

MuxFunc		proc near
MuxOff		equ	$+01h
MuxSeg		equ	$+03h
		db	9a,00,00,00,00 ; call far ptr 0000h
		cmp	ax,01
		retn
MuxFunc		endp

MuxInt		proc near
		push	es
		mov	ax,352fh
		int	21h			;DOS:35-get int vector in
		mov	ax,es
		or		ax,bx
		je		MuxIntFail
		mov	ax,4300h
		int	2fh
		cmp	al,80h
		jne	MuxIntFail
		mov	ax,4310h
		int	2fh
		mov	word ptr ds:MuxOff,bx
		mov	word ptr ds:MuxSeg,es
		pop	es
		clc
		retn
MuxInt		endp
;-----------------------------------------------------
MuxIntFail:
		pop	es
		stc
		retn

MuxInt_ax	proc near
		mov	dx,ax
		call	near ptr MuxInt
		jnb	MuxIntOk
		xor	ax,ax
		retn
MuxInt_ax	endp

MuxIntOk	proc near
		push	si
		push	di
		mov	si,dx
		mov	dx,0ffffh
		call	near ptr MuxFunc10
		je		ExitZero
		cmp	dx,si
		jb		ExitZero
		call	near ptr MuxFunc10
		jne	ExitZero
		mov	di,bx
		mov	dx,si
		call	near ptr MuxIntOk
		or		ax,ax
		jne	MuxFunc1
		mov	ah,11h
		mov	dx,di
		call	near ptr MuxFunc
		mov	dx,si
		call	near ptr MuxFunc10
		jne	ExitZero
		mov	ax,bx
		jmp	short ExitNonZero
MuxFunc1:
		push	ax
		mov	ah,11h
		mov	dx,di
		call	near ptr MuxFunc
		pop	ax
		jmp	short ExitNonZero
ExitZero:
		xor	ax,ax
ExitNonZero:
		pop	di
		pop	si
		retn
MuxIntOk	endp

SetMemAllocStrategy proc near
		mov	ax,5800h
		int	21h			;DOS:58-Get mem alloc strategy
		mov	word ptr ds:AllocStrategy,ax
		mov	ax,5802h
		int	21h			;DOS:58-Get UMB link status
		mov	byte ptr ds:UMBlinked,al
		mov	ax,3000h
		int	21h			;DOS:30-get MSDOS version,AL.AH
		cmp	al,05
		jb		StrategyExit
		cmp	al,0ah
		jnb	StrategyExit
		mov	ax,2b01h
		mov	cx,4445h
		mov	dx,5351h
		int	21h			;DOS:2b-set date, DH / DL / CX
		cmp	al,0ffh
		jne	StrategyExit
		mov	ax,5803h
		mov	bx,0001h
		int	21h			;DOS:58-Set UMB link status
		mov	ax,5802h
		int	21h			;DOS:58-Get/Set mem alloc
		cmp	al,01
		jne	StrategyExit
		clc
		retn
StrategyExit:
		stc
		retn
SetMemAllocStrategy endp

UseUMB		proc near
		mov	ax,5801h
		int	21h			;DOS:58-Get/Set mem alloc
		mov	ah,48h
		mov	bx,word ptr ds:MemRequired
		int	21h			;DOS:48-allocate mem,BX=par-
		pushf				;Push flags on Stack
		jb		UseUMB1
		push	ax
		dec	ax
		mov	es,ax
		inc	ax
		mov	word ptr es:one,ax
		mov	ah,51h
		int	21h
		dec	bx
		push	ds
		mov	ds,bx
		push	si
		push	di
		mov	si,0008h
		mov	di,si
		cld
		movsw
		movsw
		movsw
		movsw
		pop	di
		pop	si
		pop	ds
		pop	ax
UseUMB1:
		popf
		pushf
		push	ax
		mov	ax,5801h
		mov	bx,word ptr ss:AllocStrategy
		int	21h			;DOS:58-Get/Set mem alloc
		mov	ax,5803h
		mov	bh,00
		mov	bl,byte ptr ss:UMBlinked
		int	21h			;DOS:58-Get/Set mem alloc
		pop	ax
		popf
		retn
UseUMB		endp

endif

;-----------------------------------------------------
					db	00
OpenFlag			dw	00
StringBuffer	db	4098d dup (00h)
String			dw	00
StringLen		dw	00
FileHandle		dw	00
FilePointerLo	dw	00
FilePointerHi	db	2d dup (00h)
					db	00
;-----------------------------------------------------

OpenFile	proc near
OpenFile5:
		mov	ax,3d00h
		int	21h			;DOS:3d-open file, DS:DX=name
		jb		OpenFileExit
		push	cs
		pop	ds
		mov	word ptr ds:FileHandle,ax
		mov	word ptr ds:OpenFlag,0001h
		mov	ax,offset StringBuffer
		mov	word ptr ds:String,ax
		xor	ax,ax
		mov	word ptr ds:StringLen,ax
OpenFileExit:
		retn
OpenFile	endp

ReadLine	proc near
		push	bp
		mov	bp,sp
		lea	bp,word ptr [bp+04]
		push	si
		push	di
		push	ds
		push	cs
		pop	ds
		mov	di,word ptr ds:String
		mov	cx,word ptr ds:StringLen
		test	word ptr ds:OpenFlag,0008h
		jne	ReadLine1
		or		word ptr ds:OpenFlag,08
		call	near ptr ReadFile
		jb		ReadLine5
ReadLine1:
		or		cx,cx
		jne	ReadLine2
		test	word ptr ds:OpenFlag,0002h
		jne	ReadLine7
ReadLine2:
		push	cs
		pop	ds
		push	cs
		pop	es
		mov	si,di
		mov	al,CR
		mov	dx,cx
		repnz	scasb			;Flags = AL - ES:[DI]
		je		ReadLine4
		test	word ptr ds:OpenFlag,0002h
		jne	ReadLine3
		mov	di,si
		call	near ptr ReadFile
		jnb	ReadLine1
		jmp	short ReadLine5
ReadLine3:
		inc	cx
		inc	dx
		inc	dx
ReadLine4:
		inc	di
		dec	cx
		mov	word ptr ds:String,di
		mov	word ptr ds:StringLen,cx
		sub	dx,cx
		mov	ax,dx
		dec	ax
		dec	ax
		cmp	ax,word ptr [bp+02]
		ja		ReadLine6
		mov	cx,ax
		push	ds
		pop	es
		mov	di,si
		call	near ptr SkipSpace
		mov	si,di
		add	di,cx
		dec	di
		call	near ptr SkipSpaceReverse
		mov	ax,cx
		les	di,dword ptr [bp+00]
		rep	movsb
		mov	byte ptr es:[di],00
ReadLine5:
		pop	ds
		pop	di
		pop	si
		pop	bp
		retn
ReadLine6:
		mov	ax,0fffeh
		jmp	short ReadLine5
ReadLine7:
		mov	ax,0fffdh
		jmp	short ReadLine5
ReadLine	endp

CloseFile	proc near
		mov	bx,word ptr cs:FileHandle
		test	bx,bx
		je		CloseFileX
		mov	ah,3eh
		int	21h			;DOS:3e-close file, BX=hand-
		jb		CloseFileX
		xor	ax,ax
		mov	word ptr cs:FileHandle,ax
		mov	word ptr cs:OpenFlag,ax
CloseFileX:
		retn
CloseFile	endp

SkipSpace	proc near
		push	ax
		jcxz	IsNotSpace
SkipAnother:
		mov	al,byte ptr es:[di]
		cmp	al,' '
		je		IsSpace
		cmp	al,TAB
		jne	IsNotSpace
IsSpace:
		inc	di
		loop	SkipAnother
IsNotSpace:
		pop	ax
		retn
SkipSpace	endp

SkipSpaceReverse proc near
		push	ax
		jcxz	IsNotSpace1
SkipAnother1:
		mov	al,byte ptr es:[di]
		cmp	al,' '
		je		IsSpace1
		cmp	al,TAB
		jne	IsNotSpace1
IsSpace1:
		dec	di
		loop	SkipAnother1
IsNotSpace1:
		pop	ax
		retn
SkipSpaceReverse endp

ReadFile	proc near
		push	bx
		cmp	word ptr ds:FileHandle,00
		jne	RFHandleOK
		jmp	near ptr RFNotOpen
RFHandleOK:
		test	word ptr ds:OpenFlag,0001h
		jne	RFResetPointer
		test	word ptr ds:OpenFlag,0002h
		je		RFEOFNotSeen
		test	word ptr ds:OpenFlag,0004h
		je		ReadFile2
		jmp	near ptr ReadFile11
ReadFile2:
		or		word ptr ds:OpenFlag,04
RFResetPointer:
		xor	ax,ax
		and	word ptr ds:OpenFlag,-04
		mov	word ptr ds:FilePointerLo,ax
		mov	word ptr ds:FilePointerHi,ax
		jmp	short RFReadIt
RFEOFNotSeen:
		mov	ax,offset StringBuffer
		add	ax,word ptr ds:StringLen
		sub	ax,di
		cmp	ax,word ptr ds:StringLen
		jnb	ReadFile10
		sub	word ptr ds:FilePointerLo,ax
		sbb	word ptr ds:FilePointerHi,00
RFReadIt:
		mov	cx,word ptr ds:FilePointerHi
		mov	dx,word ptr ds:FilePointerLo
		mov	bx,word ptr ds:FileHandle
		mov	ax,4200h
		int	21h			;DOS:42-move file pointr,BX-
		jb		RFNotOpen
		mov	dx,offset StringBuffer
		mov	word ptr ds:String,dx
		mov	bx,word ptr ds:FileHandle
		mov	cx,1000h
		mov	ah,3fh
		int	21h			;DOS:3f-read file, BX=handl-
		jb		RFNotOpen
		add	word ptr ds:FilePointerLo,ax
		adc	word ptr ds:FilePointerHi,00
		mov	word ptr ds:StringLen,ax
		mov	cx,ax
		mov	di,word ptr ds:String
		jcxz	ReadFile8
ReadFile6:
		cmp	byte ptr [di],3bh	;Semi-colon
		je		ReadFile7
		inc	di
		loop	ReadFile6
		jmp	short ReadFile8
ReadFile7:
		cmp	byte ptr [di],0dh
		je		ReadFile6
		mov	byte ptr [di],20h
		inc	di
		loop	ReadFile7
ReadFile8:
		mov	cx,ax
		mov	di,word ptr ds:String
		cmp	ax,1000h
		je		ReadFileExit
		or		word ptr ds:OpenFlag,02
		jmp	short ReadFileExit
RFNotOpen:
		mov	ax,0ffffh
		jmp	short RFSetFlag
ReadFile10:
		mov	ax,0fffeh
		jmp	short RFSetFlag
ReadFile11:
		mov	ax,0fffdh
RFSetFlag:
		or		word ptr ds:OpenFlag,01
		stc
ReadFileExit:
		pop	bx
		retn
ReadFile	endp

ProgEnd:

cseg		ends

one		equ	00001h

public	Int5c
public	nbmain
public	KernelAPI
public	InetAPI
public	ReleaseCB
public	GetFreeCB
public	BuildHdrWName
public	DgrmRcv
public	CheckReceivedName
public	DgramListen
public	SesStatFill
public	GetQlen
public	GetSesState
public	SetNameFlags
public	CopyA
public	CopyB
public	Unlink
public	DeQueAdd
public	DeQue
public	MoveToQue
public	Execute
public	NBGetFunc
public	HandleQue
public	HaltSystem
public	Int1c_c
public	AlarmHandler
public	QueTick
public	QueAlarm
public	SetNetAlarm
public	SessionCall
public	Netbios
public	SaveAll
public	LookupCache
public	LookCache0
public	LookCache16
public	LookCache
public	PutCache
public	AddCache
public	SetVecs
public	CallNBC_clc
public	CallNBC_ResVec
public	CallNBCopies
public	IsNameRemote
public	FindCallingName
public	RemoteIPAddress
public	DeQueExecB
public	NameX
public	NmSvRcv
public	NameFA
public	NameFB
public	NameFC
public	NameFD
public	ExtractName1
public	ExtractName4
public	SendNamePacket6
public	SendNamePacket7
public	SendNamePacket0
public	BuildNmPacket
public	SndNmP1
public	ExpandName
public	CompressName
public	GetNamePtr
public	GetNameNumA
public	GetNameNum
public	NameSrvcListen
public	AsDGRcvHandler
public	AsDGCloseHandlr
public	NetRead
public	UDPListen
public	NetWriteto
public	NetWritetoBC
public	AsOpenHandler
public	AsCloseHandler
public	AsRXHandler
public	TCPXmt
public	NetWrite
public	TCPRcv
public	NetReadA
public	CheckAPIerr
public	HandleCompltn
public	FinishUp
public	GetSession
public	SetRetry
public	ChainSendC
public	SetSessSrvc
public	SetOpen
public	NetConnect
public	NetAbortA
public	NetReadC
public	NetWriteC
public	NetAbortB
public	SetUpOpen
public	GetTimeOut
public	GetSesNameFrNCB
public	GetSesNameFrCB
public	GetSesName
public	HangupStatus
public	EofErr18
public	StartRcvAny
public	CheckSession
public	RcvAnyC
public	ExecD
public	Listen
public	QueListen
public	ChainCheckBuf
public	CheckBuf
public	SetStateB8
public	Close
public	NBStartB
public	NBStartA
public	DeQueExecAll
public	ExecOne
public	DeQueExecOne
public	NetReadB
public	SetStat
public	NetWriteB
public	GetFreeSession
public	NetAbortD
public	NetAbortC
public	NetAbort
public	NBStart
public	TracePrint
public	StartListens
public	NetAbortND
public	UnloadNB
public	NumToString
public	StringOut
public	NumToStringC
public	NBInit
public	begin
public	ParseArgs
public	HandleArg
public	SetNumArg
public	PrintConfig
public	DecimalToStr
public	GetNBVec
public	FindKernelVec
public	DoFileConfig
public	CopyNBName
public	OpenFile
public	ReadLine
public	CloseFile
public	SkipSpace
public	SkipSpaceReverse
public	ReadFile
public	TraceFlag
public	CBQue
public	CBCompletion
public	FreeCBs
public	RcvBcDgQue
public	RcvDgQue
public	RcvAnyQue
public	NBNamesSize
public	NCB_Buf
public	SesBuf1
public	SesBuf
public	StackBot1
public	DataSegm
public	lana
public	NetIOBuf
public	CacheBuf
public	BCNameBuf1
public	NbCache
public	Count2
public	Cnt2
public	NameRetries
public	NameNd
public	Scope
public	ScopeLen
public	DomName
public	DomNameLen
public	BCNameBuf2
public	NCBsBuf1
public	BCNameCount
public	NbNCBs
public	NbNCBs1
public	NumSes1
public	TimeOut
public	DgramNd
public	Count4
public	Retry2
public	Count30
public	Template1
public	IPAdd1
public	Star1
public	StackBot2
public	NetbiosSP
public	StackFlag
public	SaveSS
public	SaveSP
public	Ticks
public	SecondTick
public	StartFlag
public	InAlarm
public	TimeHi
public	InNetbios
public	NmPkTemplate
public	NmPktTemplate
public	QuestionType
public	QuestionType1
public	AddrStrFAddr
public	AddrStrFSock
public	AddrStrLSock
public	StackMarker
public	StackPointer1
public	SaveC_SS
public	SaveC_SP
public	Int2aFlag
public	NetbiosCodes
public	RealNBCodes
public	UnsupNBCodes
public	NetbiosFuncPtr
public	NBF49NmSvRcv
public	NBFf0
public	NBFf5
public	NBFf6
public	NBFfe
public	NBFfd
public	NBFf7
public	NBF4aDgrmRcv
public	NBF90
public	NBF4c
public	NBF05AsFclose
public	NBF06AsClose
public	NBF07AsError
public	NBF48Tick
public	NBF4dTCPXmt
public	NBF4eTCPRcv
public	NBF12HangUp
public	NBF14Send
public	NBF15Receive
public	NBF16RcvAny
public	NBF17ChainSend
public	NBF20SendDgrm
public	NBF22SendBcDgm
public	NBF21RcvDgrm
public	NBF23RcvBcDgm
public	NBF10Call
public	NBF11Listen
public	NBF30AddName
public	NBF36AddGrName
public	NBF78
public	NBF31DelName
public	NBF34SessnStat
public	NBF35Cancel
public	NBF33AdapStat
public	NBF32Reset
public	NBF70Unlink
public	NBF47TermNB
public	IndirectOff
public	IndirectSeg
public	T_SR
public	TopSegment
public	BCNamePtr
public	BCNamePtrSeg
public	NameFilePtr
public	NameFilePtrSeg
public	NameFileCount
public	K1
public	K2
public	InitStack
public	AdaptorStatus
public	wRunTime
public	wAbortTran
public	wGoodTranLo
public	wGoodTranHi
public	NumReadsLo
public	NumReadsHi
public	wNoBufErrs
public	FreeCBCount
public	NumNCBs
public	SessionsUsed
public	NumSes
public	NetReadLen
public	UDPup
public	NumNBNames
public	NamesBuf
public	Buffer1
public	LocalNamesBuf
public	TCP_cons
public	GKISize2
public	Options

		end	nbmain

